#define HAVE_LONG_LONG 1
/* * This file was generated by SLIRP, the (Sl)ang (I)nte(r)face (P)ackage,
 * a S-Lang module code generator for C, C++, and FORTRAN.
 *
 * Copyright (C) 2003-2009 Massachusetts Institute of Technology 
 * Copyright (C) 2002 Michael S. Noble <mnoble@space.mit.edu>
 *
 * SLIRP is free software, and may be used under the conditions stipulated
 * in the COPYRIGHT agreement bundled within the SLIRP distribution.
 */
#include <stdlib.h>		/* SLIRP common {{{ */
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <slang.h>

#define SAFE_DEREF_OPAQUE(po)		(po == NULL ? NULL : po->instance)
#define SAFE_DEREF_ARRAY(pa)		(pa == NULL ? NULL : pa->data)
#define SLang_pop_array(x)		SLang_pop_array(x, 1)
#define SLang_pop_string(x)             ( (SLang_peek_at_stack() == SLANG_NULL_TYPE && (SLdo_pop() || 1)) ? ((*x = NULL) || 1): SLang_pop_slstring(x))
#define SLang_push_size_t		SLang_push_ulong
#define SLang_push_ptrdiff_t		SLang_push_long

#define pop_defaultable(argno, kind, type, obj, value) \
   (SLang_Num_Function_Args >= argno ? SLang_pop_##kind ( (type*)&obj) : ((obj = value) || ( (void*)&obj > (void*)0) ) )

#ifdef __cplusplus
#define LINKAGE "C"
#else
#define LINKAGE
#endif

#define USAGE(msg) \
    {SLang_verror(SL_USAGE_ERROR, (char*)"Usage: %s", msg); return;}

static void Slirp_usage(int i, int j, int flags);

static int slang_abi_mismatch(void)
{
   long module_abi = SLANG_VERSION / 10000;
   long app_abi    = SLang_Version / 10000;

   if (module_abi != app_abi) {
	SLang_verror(SL_APPLICATION_ERROR, (char*)
		"S-Lang library abi mismatch\nmodule: %s, application: %s",
		SLANG_VERSION_STRING, SLang_Version_String);
	return 1;
   }
			        
   return 0;
} /* }}} */

static char *slns;  /* slang namespace active at time of module load */
#define BEGIN_DECLS
#define END_DECLS
#define SLIRP_EXTERN
BEGIN_DECLS				/* Opaque handling code {{{ */

#define SLIRP_ABI_VERSION			10500

typedef void            (*FINALIZER)            (void*);
typedef void            (*INITIALIZER)          (void*);

typedef struct _Slirp_Type {
   SLang_Class_Type	*slclass;	/* SLang type class for this type */
   struct _Slirp_Type	*parent;	/* NULL if type has no ancestors  */
   FINALIZER		finalizer;
   INITIALIZER		initializer;
} Slirp_Type;

typedef struct _Slirp_Opaque {
   Slirp_Type *type;
   SLang_MMT_Type *mmt;
   void* instance;
   int deletion_in_progress;
   int free_me_too;		       /* if non-zero, free MMT, then struct */
   int owns_ref;		       /* if non-zero, do not free instance */
} Slirp_Opaque;

static void SLang_free_opaque (Slirp_Opaque *o)
{
   SLang_MMT_Type *mmt;

   if ((o == NULL)
       || (o->deletion_in_progress))
     return;

   mmt = o->mmt;
   if (mmt == NULL)
     return;

   o->mmt = NULL;
   o->deletion_in_progress = 1;
   SLang_free_mmt (mmt);
   o->deletion_in_progress = 0;
   if (o->free_me_too)
     SLfree ((char *) o);
}


static int opaque_typecast (SLtype from_type, VOID_STAR from_p,
			unsigned int num, SLtype to_type, VOID_STAR to_p)
{
   unsigned int i;
   SLang_MMT_Type **from = (SLang_MMT_Type**)from_p;
   SLang_MMT_Type **to   = (SLang_MMT_Type**)to_p;

   (void) from_type; (void) to_type; 

   for (i=0; i < num; i++) {
	to[i] = from[i];	/* FIXME: typeof() still reports prev type */
	if (from[i] != NULL)
	   SLang_inc_mmt(from[i]);
   }

   return 1;
}

static int opaque_search(const void* key, const void *elem)
{
   return *(SLtype*)key - SLclass_get_class_id((*(Slirp_Type**)elem)->slclass);
}

static void destroy_opaque(SLtype type, VOID_STAR w)
{
   Slirp_Opaque *ot = (Slirp_Opaque*)w;

   (void) type;

   if ((ot->type != NULL)
       && (ot->type->finalizer != NULL)
       && (ot->instance != NULL))
     {
	if (ot->owns_ref == 0)
	  (*ot->type->finalizer) (ot->instance);
	ot->instance = NULL;
     }

   if (ot->deletion_in_progress)
     {
	/* Evidently, the MMT container is being destroyed from SLang_free_mmt.
	 * Let it perform the final free.
	 */
	ot->free_me_too = 1;
	return;
     }
   SLfree( (char*)ot );
}
END_DECLS

SLIRP_EXTERN SLtype void_ptr_Type;	/* These opaque pointer types must */
SLIRP_EXTERN SLtype string_ptr_Type;	/* be kept in sync with opaques.c  */
SLIRP_EXTERN SLtype uchar_ptr_Type;
SLIRP_EXTERN SLtype short_ptr_Type;
SLIRP_EXTERN SLtype ushort_ptr_Type;
SLIRP_EXTERN SLtype int_ptr_Type;
SLIRP_EXTERN SLtype uint_ptr_Type;
SLIRP_EXTERN SLtype long_ptr_Type;
SLIRP_EXTERN SLtype ulong_ptr_Type;
SLIRP_EXTERN SLtype float_ptr_Type;
SLIRP_EXTERN SLtype double_ptr_Type;
SLIRP_EXTERN SLtype opaque_ptr_Type;
SLIRP_EXTERN SLtype file_ptr_Type;

typedef struct _Reserved_Opaque_Type {
   char	  *name;
   SLtype *type;		/* SLtype of opaque pointer defined by this */
   SLtype masked_type;		/* SLtype of datum to which this points */
} Reserved_Opaque_Type;

SLIRP_EXTERN Slirp_Type	**Slirp_Opaque_Types;
SLIRP_EXTERN SLtype 	Slirp_Num_Opaque_Types;
SLIRP_EXTERN SLtype	First_Opaque_Type;
SLIRP_EXTERN SLtype	Last_Reserved_Opaque_Type;

static Reserved_Opaque_Type Reserved_Opaque_Types[] = {

   { (char*)"void_ptr",		&void_ptr_Type,		SLANG_ANY_TYPE,    },
   { (char*)"int_ptr",		&int_ptr_Type,		SLANG_INT_TYPE,    },
   { (char*)"double_ptr",	&double_ptr_Type,	SLANG_DOUBLE_TYPE, },
   { (char*)"opaque_ptr",	&opaque_ptr_Type,	SLANG_ANY_TYPE,	   },
   { (char*)"file_ptr",		&file_ptr_Type,		SLANG_FILE_PTR_TYPE,},
   { (char*)"float_ptr",	&float_ptr_Type,	SLANG_FLOAT_TYPE,  },
   { (char*)"long_ptr",		&long_ptr_Type,		SLANG_LONG_TYPE,   },
   { (char*)"string_ptr",	&string_ptr_Type,	SLANG_STRING_TYPE, },
   { (char*)"uint_ptr",		&uint_ptr_Type,		SLANG_UINT_TYPE,   },
   { (char*)"short_ptr",	&short_ptr_Type,	SLANG_SHORT_TYPE,  },
   { (char*)"ulong_ptr",	&ulong_ptr_Type,	SLANG_ULONG_TYPE,  },
   { (char*)"ushort_ptr",	&ushort_ptr_Type,	SLANG_USHORT_TYPE, },
   { (char*)"uchar_ptr",	&uchar_ptr_Type,	SLANG_UCHAR_TYPE,  },
   { NULL, NULL, 0, }
};

#define NUM_RESERVED_OPAQUES \
	sizeof(Reserved_Opaque_Types) / sizeof(Reserved_Opaque_Type) - 1

static Slirp_Type* sltype_to_slirp_type(SLtype sltype)
{
   Slirp_Type **ot = (Slirp_Type**) bsearch( (const void*) &sltype,
	 		(const void*) Slirp_Opaque_Types,
			(size_t) Slirp_Num_Opaque_Types,
			sizeof(Slirp_Type*), opaque_search);

   if (ot != NULL) return *ot;
   return NULL;
}

static SLang_MMT_Type*
create_opaque_mmt(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt = NULL;
   Slirp_Opaque *ot = (Slirp_Opaque*) SLcalloc(1, sizeof(Slirp_Opaque));

   if (ot != NULL) {

	ot->instance = instance;
	ot->owns_ref = owns_ref;
	ot->mmt      = NULL;

	if ( (ot->type = sltype_to_slirp_type(type)) != NULL) {

	   if (ot->type->initializer != NULL)
		(*ot->type->initializer) (ot->instance);

	   mmt = SLang_create_mmt (type, (VOID_STAR) ot);
	}

	if (mmt == NULL)
	   SLfree((char*)ot);
   }

   return mmt;
}

static int SLang_push_opaque(SLtype type, void *instance, unsigned int owns_ref)
{
   SLang_MMT_Type *mmt;

   if (instance == NULL)
      return SLang_push_null();

   mmt = create_opaque_mmt(type, instance, owns_ref);
   if (NULL == mmt)
      return -1;

   if (-1 == SLang_push_mmt (mmt))
     {
	SLang_free_mmt (mmt);
	return -1;
     }
   return 0;
}

static int SLang_pop_opaque (SLtype type, void **instance, Slirp_Opaque **o)
{
   Slirp_Opaque *ot;
   SLang_MMT_Type *mmt = NULL;

   if (instance != NULL) *instance = NULL;
   *o = NULL;

   if ((type == file_ptr_Type)
       && (SLang_peek_at_stack() == SLANG_FILE_PTR_TYPE))
     {
	FILE *fp;
	if (-1 == SLang_pop_fileptr(&mmt, &fp))
	  return -1;

	ot = (Slirp_Opaque*) SLcalloc(1, sizeof(Slirp_Opaque));
	if (ot == NULL)
	  {
	     SLang_free_mmt(mmt);
	     return -1;
	  }
	ot->mmt = mmt;
	ot->free_me_too = 1;
	*instance = (void*)fp;
	*o = ot;
	return 0;
   }

   if (NULL == (mmt = SLang_pop_mmt (type)))
     return -1;

   if (NULL == (ot = (Slirp_Opaque*) SLang_object_from_mmt (mmt))
       || (ot->instance == NULL))
     {
	SLang_verror (SL_INVALID_PARM, "%s", "slirp: pop_opaque: instance=NULL");
	SLang_free_mmt (mmt);
	return -1;
     }

   /* This creates a circular reference:
    *    mmt->ot->mmt
    */
   ot->mmt = mmt;
   if (instance != NULL)
     *instance = ot->instance;
   *o = ot;
   return 0;
}

static unsigned int
allocate_opaque(char *name, FINALIZER fzer, INITIALIZER izer, SLtype parent_id,
		int (*sget)(SLtype, char *), int (*sput)(SLtype, char *))
{
   /* Returning from here with anything but a positive id is fatal */
   SLtype new_type, ancestor_type;
   Slirp_Type *type , *parent = NULL;
   SLang_Class_Type *new_class = SLclass_allocate_class (name);

   if (new_class == NULL) return SLANG_UNDEFINED_TYPE;

   (void) SLclass_set_destroy_function (new_class, destroy_opaque);
   if (-1 == SLclass_register_class (new_class, SLANG_VOID_TYPE,
				     sizeof(Slirp_Opaque),
				     SLANG_CLASS_TYPE_MMT))
	return SLANG_UNDEFINED_TYPE;

   new_type = SLclass_get_class_id(new_class);
   if (parent_id) {

	type = parent = sltype_to_slirp_type(parent_id);

	while (type) {

	   ancestor_type = SLclass_get_class_id(type->slclass);

	   /* Support downcasting ancestor types to this type */
	   if (-1 == SLclass_add_typecast (ancestor_type, new_type,
		    					opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   /* Support upcasting this type to each ancestor type */
	   if (-1 == SLclass_add_typecast (new_type, ancestor_type,
							opaque_typecast, 1))
		return SLANG_UNDEFINED_TYPE;

	   type = type->parent;
	}
   }

   if ( (sget != NULL && SLclass_set_sget_function(new_class, sget) == -1) ||
	(sput != NULL && SLclass_set_sput_function(new_class, sput) == -1))
	return SLANG_UNDEFINED_TYPE;
	
   if ( (type = (Slirp_Type*) SLmalloc(sizeof(Slirp_Type))) == NULL)
	return SLANG_UNDEFINED_TYPE;

   type->slclass = new_class;
   type->parent = parent;
   type->finalizer = fzer;
   type->initializer = izer;
   Slirp_Opaque_Types[ Slirp_Num_Opaque_Types++ ] = type;

   return new_type;
}

static int allocate_reserved_opaque_types(void)
{
   Reserved_Opaque_Type *pt;
   long abi_version = -1;

   if ( SLang_is_defined((char*)"_slirp_initialized")) {

	if ( SLang_is_defined((char*)"_slirp_abi_version") == 0  ||
		SLang_load_string((char*)"_slirp_abi_version;") == -1 ||
		SLang_pop_long(&abi_version) == -1 ||
		abi_version != SLIRP_ABI_VERSION)
	{
	   SLang_verror(SL_APPLICATION_ERROR,
		(char*) "SLIRP abi mismatch: want version %ld, have %ld\n",
		(long)SLIRP_ABI_VERSION, abi_version);
	   return -1;
	}

	return 0;
   }

   (void)SLang_load_string((char*)"public variable _slirp_initialized=1;");
   (void)SLang_push_int(SLIRP_ABI_VERSION);
   (void)SLang_load_string((char*)"public variable _slirp_abi_version=();");

   Slirp_Num_Opaque_Types = 0;

   if ( NULL == (Slirp_Opaque_Types = (Slirp_Type**) SLmalloc
			( sizeof(Slirp_Type*) * (NUM_RESERVED_OPAQUES + 1))))
      return -1;

   Slirp_Opaque_Types[0] = NULL;

   pt = Reserved_Opaque_Types;
   while (pt->name != NULL) {
	if ((*pt->type = allocate_opaque(pt->name, NULL,NULL,0,NULL,NULL)) ==
	      						SLANG_UNDEFINED_TYPE)
		return -1;
	   pt++;
	}

   /* Loop again, to enable casts to/from generic pointer type */
   pt = Reserved_Opaque_Types + 1;
   while (pt->name != NULL) {

	if (-1 == SLclass_add_typecast (*pt->type, void_ptr_Type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	if (-1 == SLclass_add_typecast (void_ptr_Type, *pt->type,
							opaque_typecast, 1))
	   return SLANG_UNDEFINED_TYPE;

	pt++;
   }

   First_Opaque_Type = *Reserved_Opaque_Types[0].type;
   Last_Reserved_Opaque_Type = First_Opaque_Type + NUM_RESERVED_OPAQUES - 1;

   return 0;
} /* }}} */
static int pop_nullable(SLtype type, void **obj, void **meta)
{
   if (SLANG_NULL_TYPE == SLang_peek_at_stack ()) { 
	*obj = NULL;
	if (type && meta != NULL)
	   *meta = NULL;
	return SLang_pop_null ();
   }

   switch(type) {

	case 0:
	   return SLang_pop_cstruct(*obj, (SLang_CStruct_Field_Type *)meta);

	case SLANG_ANY_TYPE:
	   return SLang_pop_anytype((SLang_Any_Type**)obj);

	case SLANG_REF_TYPE:
	   return SLang_pop_ref((SLang_Ref_Type**)obj);

	case SLANG_STRING_TYPE:
	   return SLang_pop_slstring ((char**)obj);

	default:
	   /* This will fail, as intended, for non-opaque types */
	   return SLang_pop_opaque(type, meta, (Slirp_Opaque**)obj);
   }
}
#define pop_string_or_null(s)  pop_nullable(SLANG_STRING_TYPE,(void**)s,NULL)
#define pop_ref_or_null(r)  pop_nullable(SLANG_REF_TYPE,(void**)&r->ref,r->data)
#define pop_anytype_or_null(a) pop_nullable(SLANG_ANY_TYPE,(void**)a,NULL)

SLtype Cairo_Type = 0;
SLtype GtkOpaque_Type = 0;
SLtype GBookmarkFile_Type = 0;
SLtype GBytes_Type = 0;
SLtype GChecksum_Type = 0;
SLtype GDate_Type = 0;
SLtype GDateTime_Type = 0;
SLtype GDir_Type = 0;
SLtype GHmac_Type = 0;
SLtype GIOChannel_Type = 0;
SLtype GKeyFile_Type = 0;
SLtype GMainContext_Type = 0;
SLtype GMainLoop_Type = 0;
SLtype GMatchInfo_Type = 0;
SLtype GRegex_Type = 0;
SLtype GSource_Type = 0;
SLtype GMappedFile_Type = 0;
SLtype GRand_Type = 0;
SLtype GTimer_Type = 0;
SLtype GTimeZone_Type = 0;
SLtype GVariant_Type = 0;
SLtype GVariantBuilder_Type = 0;
SLtype GVariantType_Type = 0;
SLtype GObject_Type = 0;
SLtype GdkPixbuf_Type = 0;
SLtype GdkDevice_Type = 0;
SLtype GtkWidget_Type = 0;
SLtype GdkEvent_Type = 0;
SLtype GdkFrameTimings_Type = 0;
SLtype GtkPaperSize_Type = 0;
SLtype GtkSelectionData_Type = 0;
SLtype GtkTargetList_Type = 0;
SLtype GtkTextAttributes_Type = 0;
SLtype GtkTextIter_Type = 0;
SLtype GtkTreeIter_Type = 0;
SLtype GtkTreePath_Type = 0;
SLtype GtkTreeRowReference_Type = 0;
SLtype GtkWidgetPath_Type = 0;
SLtype PangoAttrList_Type = 0;
SLtype PangoCoverage_Type = 0;
SLtype PangoFontMetrics_Type = 0;
SLtype PangoGlyphString_Type = 0;
SLtype PangoItem_Type = 0;
SLtype PangoLayoutIter_Type = 0;
SLtype PangoLayoutLine_Type = 0;
SLtype PangoScriptIter_Type = 0;
SLtype PangoTabArray_Type = 0;
SLtype GtkIconSize_ptr_Type = 0;
SLtype GtkPolicyType_ptr_Type = 0;
SLtype gchar_ptr_ptr_ptr_Type = 0;
SLtype PangoFontFace_ptr_ptr_ptr_Type = 0;
SLtype int_ptr_ptr_Type = 0;
SLtype PangoFontFamily_ptr_ptr_ptr_Type = 0;
SLtype PangoTabAlign_ptr_ptr_Type = 0;
SLtype gint_ptr_ptr_Type = 0;
SLtype GdkKeymapKey_ptr_ptr_Type = 0;
SLtype guchar_ptr_ptr_Type = 0;
SLtype GdkVisualType_ptr_ptr_Type = 0;
SLtype GdkAtom_ptr_ptr_Type = 0;
SLtype char_ptr_ptr_ptr_Type = 0;

static int allocate_gtk3_opaque_types(void) /* {{{ */
{
   if (Cairo_Type) return 0;

   Slirp_Opaque_Types = (Slirp_Type**) SLrealloc((char*)Slirp_Opaque_Types,
		(1 + Slirp_Num_Opaque_Types + 60) * sizeof(Slirp_Type*));

   if (Slirp_Opaque_Types == NULL) return -1;

   Cairo_Type = allocate_opaque((char*)"Cairo_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (Cairo_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkOpaque_Type = allocate_opaque((char*)"GtkOpaque_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) Cairo_Type, NULL, NULL);
   if (GtkOpaque_Type == SLANG_UNDEFINED_TYPE) return -1;

   GBookmarkFile_Type = allocate_opaque((char*)"GBookmarkFile_Type",
		(FINALIZER) g_bookmark_file_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GBookmarkFile_Type == SLANG_UNDEFINED_TYPE) return -1;

   GBytes_Type = allocate_opaque((char*)"GBytes_Type",
		(FINALIZER) g_bytes_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GBytes_Type == SLANG_UNDEFINED_TYPE) return -1;

   GChecksum_Type = allocate_opaque((char*)"GChecksum_Type",
		(FINALIZER) g_checksum_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GChecksum_Type == SLANG_UNDEFINED_TYPE) return -1;

   GDate_Type = allocate_opaque((char*)"GDate_Type",
		(FINALIZER) g_date_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GDate_Type == SLANG_UNDEFINED_TYPE) return -1;

   GDateTime_Type = allocate_opaque((char*)"GDateTime_Type",
		(FINALIZER) g_date_time_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GDateTime_Type == SLANG_UNDEFINED_TYPE) return -1;

   GDir_Type = allocate_opaque((char*)"GDir_Type",
		(FINALIZER) g_dir_close, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GDir_Type == SLANG_UNDEFINED_TYPE) return -1;

   GHmac_Type = allocate_opaque((char*)"GHmac_Type",
		(FINALIZER) g_hmac_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GHmac_Type == SLANG_UNDEFINED_TYPE) return -1;

   GIOChannel_Type = allocate_opaque((char*)"GIOChannel_Type",
		(FINALIZER) g_io_channel_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GIOChannel_Type == SLANG_UNDEFINED_TYPE) return -1;

   GKeyFile_Type = allocate_opaque((char*)"GKeyFile_Type",
		(FINALIZER) g_key_file_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GKeyFile_Type == SLANG_UNDEFINED_TYPE) return -1;

   GMainContext_Type = allocate_opaque((char*)"GMainContext_Type",
		(FINALIZER) g_main_context_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GMainContext_Type == SLANG_UNDEFINED_TYPE) return -1;

   GMainLoop_Type = allocate_opaque((char*)"GMainLoop_Type",
		(FINALIZER) g_main_loop_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GMainLoop_Type == SLANG_UNDEFINED_TYPE) return -1;

   GMatchInfo_Type = allocate_opaque((char*)"GMatchInfo_Type",
		(FINALIZER) g_match_info_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GMatchInfo_Type == SLANG_UNDEFINED_TYPE) return -1;

   GRegex_Type = allocate_opaque((char*)"GRegex_Type",
		(FINALIZER) g_regex_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GRegex_Type == SLANG_UNDEFINED_TYPE) return -1;

   GSource_Type = allocate_opaque((char*)"GSource_Type",
		(FINALIZER) g_source_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GSource_Type == SLANG_UNDEFINED_TYPE) return -1;

   GMappedFile_Type = allocate_opaque((char*)"GMappedFile_Type",
		(FINALIZER) g_mapped_file_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GMappedFile_Type == SLANG_UNDEFINED_TYPE) return -1;

   GRand_Type = allocate_opaque((char*)"GRand_Type",
		(FINALIZER) g_rand_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GRand_Type == SLANG_UNDEFINED_TYPE) return -1;

   GTimer_Type = allocate_opaque((char*)"GTimer_Type",
		(FINALIZER) g_timer_destroy, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GTimer_Type == SLANG_UNDEFINED_TYPE) return -1;

   GTimeZone_Type = allocate_opaque((char*)"GTimeZone_Type",
		(FINALIZER) g_time_zone_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GTimeZone_Type == SLANG_UNDEFINED_TYPE) return -1;

   GVariant_Type = allocate_opaque((char*)"GVariant_Type",
		(FINALIZER) g_variant_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GVariant_Type == SLANG_UNDEFINED_TYPE) return -1;

   GVariantBuilder_Type = allocate_opaque((char*)"GVariantBuilder_Type",
		(FINALIZER) g_variant_builder_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GVariantBuilder_Type == SLANG_UNDEFINED_TYPE) return -1;

   GVariantType_Type = allocate_opaque((char*)"GVariantType_Type",
		(FINALIZER) g_variant_type_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GVariantType_Type == SLANG_UNDEFINED_TYPE) return -1;

   GObject_Type = allocate_opaque((char*)"GObject_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GObject_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkPixbuf_Type = allocate_opaque((char*)"GdkPixbuf_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GObject_Type, NULL, NULL);
   if (GdkPixbuf_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkDevice_Type = allocate_opaque((char*)"GdkDevice_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GObject_Type, NULL, NULL);
   if (GdkDevice_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkWidget_Type = allocate_opaque((char*)"GtkWidget_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GObject_Type, NULL, NULL);
   if (GtkWidget_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkEvent_Type = allocate_opaque((char*)"GdkEvent_Type",
		(FINALIZER) gdk_event_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GdkEvent_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkFrameTimings_Type = allocate_opaque((char*)"GdkFrameTimings_Type",
		(FINALIZER) gdk_frame_timings_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GdkFrameTimings_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkPaperSize_Type = allocate_opaque((char*)"GtkPaperSize_Type",
		(FINALIZER) gtk_paper_size_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkPaperSize_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkSelectionData_Type = allocate_opaque((char*)"GtkSelectionData_Type",
		(FINALIZER) gtk_selection_data_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkSelectionData_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTargetList_Type = allocate_opaque((char*)"GtkTargetList_Type",
		(FINALIZER) gtk_target_list_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTargetList_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTextAttributes_Type = allocate_opaque((char*)"GtkTextAttributes_Type",
		(FINALIZER) gtk_text_attributes_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTextAttributes_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTextIter_Type = allocate_opaque((char*)"GtkTextIter_Type",
		(FINALIZER) gtk_text_iter_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTextIter_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTreeIter_Type = allocate_opaque((char*)"GtkTreeIter_Type",
		(FINALIZER) gtk_tree_iter_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTreeIter_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTreePath_Type = allocate_opaque((char*)"GtkTreePath_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTreePath_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkTreeRowReference_Type = allocate_opaque((char*)"GtkTreeRowReference_Type",
		(FINALIZER) gtk_tree_row_reference_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkTreeRowReference_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkWidgetPath_Type = allocate_opaque((char*)"GtkWidgetPath_Type",
		(FINALIZER) gtk_widget_path_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (GtkWidgetPath_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoAttrList_Type = allocate_opaque((char*)"PangoAttrList_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoAttrList_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoCoverage_Type = allocate_opaque((char*)"PangoCoverage_Type",
		(FINALIZER) pango_coverage_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoCoverage_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoFontMetrics_Type = allocate_opaque((char*)"PangoFontMetrics_Type",
		(FINALIZER) pango_font_metrics_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoFontMetrics_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoGlyphString_Type = allocate_opaque((char*)"PangoGlyphString_Type",
		(FINALIZER) pango_glyph_string_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoGlyphString_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoItem_Type = allocate_opaque((char*)"PangoItem_Type",
		(FINALIZER) pango_item_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoItem_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoLayoutIter_Type = allocate_opaque((char*)"PangoLayoutIter_Type",
		(FINALIZER) pango_layout_iter_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoLayoutIter_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoLayoutLine_Type = allocate_opaque((char*)"PangoLayoutLine_Type",
		(FINALIZER) pango_layout_line_unref, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoLayoutLine_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoScriptIter_Type = allocate_opaque((char*)"PangoScriptIter_Type",
		(FINALIZER) pango_script_iter_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoScriptIter_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoTabArray_Type = allocate_opaque((char*)"PangoTabArray_Type",
		(FINALIZER) pango_tab_array_free, 
		(INITIALIZER) NULL,
		(SLtype) GtkOpaque_Type, NULL, NULL);
   if (PangoTabArray_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkIconSize_ptr_Type = allocate_opaque((char*)"GtkIconSize_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (GtkIconSize_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   GtkPolicyType_ptr_Type = allocate_opaque((char*)"GtkPolicyType_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (GtkPolicyType_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   gchar_ptr_ptr_ptr_Type = allocate_opaque((char*)"gchar_ptr_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (gchar_ptr_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoFontFace_ptr_ptr_ptr_Type = allocate_opaque((char*)"PangoFontFace_ptr_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (PangoFontFace_ptr_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   int_ptr_ptr_Type = allocate_opaque((char*)"int_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (int_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoFontFamily_ptr_ptr_ptr_Type = allocate_opaque((char*)"PangoFontFamily_ptr_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (PangoFontFamily_ptr_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   PangoTabAlign_ptr_ptr_Type = allocate_opaque((char*)"PangoTabAlign_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (PangoTabAlign_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   gint_ptr_ptr_Type = allocate_opaque((char*)"gint_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (gint_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkKeymapKey_ptr_ptr_Type = allocate_opaque((char*)"GdkKeymapKey_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (GdkKeymapKey_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   guchar_ptr_ptr_Type = allocate_opaque((char*)"guchar_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (guchar_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkVisualType_ptr_ptr_Type = allocate_opaque((char*)"GdkVisualType_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (GdkVisualType_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   GdkAtom_ptr_ptr_Type = allocate_opaque((char*)"GdkAtom_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (GdkAtom_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   char_ptr_ptr_ptr_Type = allocate_opaque((char*)"char_ptr_ptr_ptr_Type",
		(FINALIZER) NULL, 
		(INITIALIZER) NULL,
		(SLtype) void_ptr_Type, NULL, NULL);
   if (char_ptr_ptr_ptr_Type == SLANG_UNDEFINED_TYPE) return -1;

   return 0;
} /* }}} */
static unsigned char map_scalars_to_refs = 0;

typedef struct _Slirp_Ref {			/* Ref handling code {{{ */
#define	REF_FLAG_FREE_DATA			0x01
#define	REF_FLAG_IS_OPAQUE			0x02
#define	REF_FLAG_COLUMN_MAJOR			0x04
#define	REF_FLAG_ARRAY_EXPECTED			0x08
   unsigned int		flags;		/* Slirp_Ref encapsulates S-Lang    */
   SLtype		sltype;		/* array, ref, and MMT types, the   */
   size_t		sizeof_type;	/* latter two of which are seen as  */
   void			**data;		/* pointing to a single object      */
   unsigned int		vstride;	/* how to find "next" vectored elem */
   SLang_Array_Type	*array;
   SLang_Ref_Type	*ref;
   SLang_MMT_Type	*mmt;		/* mmt supports passing around C    */
} Slirp_Ref;				/* ptr arrays of indeterminate size */

static Slirp_Ref* ref_new(SLtype t,size_t typesize, void *d,unsigned int flags)
{
   Slirp_Ref *ref;
   if ((ref = (Slirp_Ref*)SLcalloc( sizeof(Slirp_Ref), 1)) != NULL) {
	ref->sltype = t;
	ref->sizeof_type = typesize;
	ref->flags = flags;
	ref->data = (void**)d;
	*ref->data = NULL;
   }
   return ref;
}

static int ref_finalize(Slirp_Ref *r) /* {{{ */
{
   int status = 0;
   if (r == NULL) return 0;

   if (r->ref) {

        void *ref_value = NULL; SLtype ref_type = 0; double dc[2];

	if (r->flags & REF_FLAG_IS_OPAQUE) { 	/* wrap aggregates/opaques  */
#ifdef NUM_RESERVED_OPAQUES			/* in mmt before ref assign */
	   void *opaqval = *r->data;		/* the mmt w/be freed when  */
	   if (opaqval == NULL) {		/* the S-Lang object goes   */
		ref_value = NULL;		/* out of scope		    */
		ref_type = SLANG_NULL_TYPE;
	   }
	   else {
		SLang_MMT_Type *mmt = create_opaque_mmt(r->sltype, opaqval, 0);
		ref_value = &mmt;
		ref_type = r->sltype;
	   }
#endif
	}
	else {
	   ref_type = r->sltype;
	   if (ref_type == SLANG_COMPLEX_TYPE && r->sizeof_type < sizeof(dc)) {
		float *fc = (float*) r->data;
		dc[0] = fc[0];
		dc[1] = fc[1];
		ref_value = dc;
	   }
	   else
		ref_value = r->data;
	}

	status = SLang_assign_to_ref (r->ref, ref_type, ref_value);
	SLang_free_ref(r->ref);
   }
   else if (r->array) {
#ifdef HAVE_FORTRAN_CODE
	if ((r->flags & REF_FLAG_COLUMN_MAJOR) && TRANSPOSE(1,r->array) == -1)
		return -1;
#endif
	SLang_free_array(r->array);
   }
   else if (r->mmt)
	SLang_free_mmt(r->mmt);

   if (r->flags & REF_FLAG_FREE_DATA)
	SLfree( (char*) r->data );

   SLfree((char*)r);
   return status;
} /* }}} */

static void finalize_refs(unsigned int nargs, ...) /* {{{ */
{
   va_list ap;
   va_start(ap, nargs);
   while (nargs--) ref_finalize(va_arg(ap, Slirp_Ref *));
   va_end(ap);
} /* }}} */

static unsigned int ref_get_size(Slirp_Ref *r, int which_dimension) /* {{{ */
{
   if (r->array) {
	if (which_dimension == 0)
	   return (unsigned int)r->array->num_elements;
	else if (which_dimension < 0)
	   return r->array->num_dims;
	else {
	   which_dimension--;
	   if ((unsigned int)which_dimension < r->array->num_dims)
		return (unsigned int)r->array->dims[which_dimension];
	   else
		return 0;
	}
   }

   return 1;
} /* }}} */

extern LINKAGE int _SLang_get_class_type (SLtype t);	/* quasi-public  */

#ifdef NUM_RESERVED_OPAQUES
static SLtype sltype_to_opaque_ptr_type(SLtype sltype) /*{{{*/
{
   Reserved_Opaque_Type *pt;

   if (sltype > Last_Reserved_Opaque_Type) return opaque_ptr_Type;
   if (sltype == void_ptr_Type) return void_ptr_Type;

   pt = Reserved_Opaque_Types;		/* sequential search, but s/b < O(n) */
   while (pt->name) {			/* since list is ordered by expected */
	if (pt->masked_type == sltype)	/* frequency of use for each SLtype  */
	   return *pt->type;		
	pt++;
   }
   return 0;
} /*}}}*/
#endif

static int try_pop_mmt(SLtype type, SLang_MMT_Type **mmt) /*{{{*/
{
   static SLang_Name_Type *cl_type_func;	/* SLang_pop_mmt doesn't */
   int classtype;				/* validate that type is */
						/* an MMT, so we do here */
   *mmt = NULL;					/* FIXME: remove v2.0.7  */

   if (cl_type_func == NULL)
	cl_type_func = SLang_get_function( (char*) "__class_type");

   if (cl_type_func == NULL)
      return 0;

   if (-1 == SLang_push_datatype(type) ||		/* do the hard way, */
	-1 == SLexecute_function(cl_type_func) ||	/* as C api lacks   */
	-1 == SLang_pop_int(&classtype))		/* get_class_type() */
	return -1;

   if (classtype == SLANG_CLASS_TYPE_MMT) {
	*mmt = SLang_pop_mmt(type);
	return 1;
   }
   return 0;
} /*}}}*/

#define POP_FLAG_NULLABLE	0x1
#define POP_FLAG_VECTORIZE	0x2
static int pop_array_or_ref(Slirp_Ref *r, int flags, int defaultable) /*{{{*/
{
   SLtype type;
   unsigned int i, objtype;
#ifdef NUM_RESERVED_OPAQUES
   unsigned int is_opaque;
#endif

   if (r == NULL) {
	SLang_verror(SL_INTRINSIC_ERROR, (char*)"Attempted NULL reference (out of memory?)");
	return -1;
   }

   if (defaultable && SLang_Num_Function_Args < defaultable) {
	r->ref   = NULL;	/* observe that only NULL can be */
	*r->data = NULL;	/* assigned as the default value */
	return 0;
   }
   
   objtype = SLang_peek_at_stack();

   if ((flags & POP_FLAG_NULLABLE) && objtype == SLANG_NULL_TYPE) {
	r->ref   = NULL;		/* nullable flag: a pointer arg for */
	*r->data = NULL;		/* which NULL is a legitimate value */
	return SLang_pop_null ();
   }

   type = r->sltype;

#ifdef NUM_RESERVED_OPAQUES
   is_opaque =(type >= First_Opaque_Type && sltype_to_slirp_type(type) != NULL);
   if (is_opaque) r->flags |= REF_FLAG_IS_OPAQUE;
#endif

   switch(objtype) {

	case SLANG_ARRAY_TYPE:

	   if (SLang_pop_array_of_type(&r->array, type) == -1)
		return -1;

#ifdef HAVE_FORTRAN_CODE
	   if (r->flags & REF_FLAG_COLUMN_MAJOR) {
		if (flags & POP_FLAG_VECTORIZE)		/* vectorizable arrs*/
		   r->flags ^= REF_FLAG_COLUMN_MAJOR;   /* r not transposed */
		else if (TRANSPOSE(0,r->array) == -1)
		   return -1;
	   }
#endif

	   i = r->array->num_elements;
#ifdef NUM_RESERVED_OPAQUES
	   if (is_opaque) {
	      	Slirp_Opaque *ot;
		SLang_MMT_Type** mmts = (SLang_MMT_Type**)r->array->data;
		void **arr = (void**)SLmalloc(i * sizeof(void*) );
		if (arr == NULL) return -1;

		while (i--) {
		   ot = (Slirp_Opaque*) SLang_object_from_mmt (mmts[i]);
		   if (ot == NULL) {
			SLfree((char*)arr);
			return -1;
		   }
		   arr[i] = ot->instance;
		}

		*r->data = (void*)arr; r->data = (void**)arr;
		r->flags |= REF_FLAG_FREE_DATA;
	   }
	   else
#endif
	   if (type == SLANG_COMPLEX_TYPE &&
		 		r->sizeof_type < r->array->sizeof_type) {
		double *dc = (double*) r->array->data;
		float  *fc = (float *) SLmalloc(i * r->sizeof_type);
		if (fc == NULL) return -1;
		*r->data = fc; r->data = (void**)fc;
		while (i--) { *fc++ = (float) *dc++; *fc++ = (float) *dc++; }
		r->flags |= REF_FLAG_FREE_DATA;
	   }
	   else {
		*r->data = r->array->data;
		r->data = (void**)*r->data;
	   }

	   break;

	case SLANG_REF_TYPE:

	   /* Refs can only send values one-way (C to S-Lang, not reverse) */
	   if (SLang_pop_ref(&r->ref) == -1)
		return -1;

	   /* Ref is assumed to point to a scalar instance of the  */
	   /* refd type, so declare enough space to hold one such. */
	   *r->data = (void*)SLmalloc(r->sizeof_type);
	   if (*r->data == NULL) return -1;
	   memset(*r->data, 0, r->sizeof_type);
	   r->flags |= REF_FLAG_FREE_DATA;
	   r->data = (void**)*r->data;
	   break;

	/* Allow scalars to used as if they were 1-element arrays */
	case SLANG_CHAR_TYPE: case SLANG_UCHAR_TYPE:
	case SLANG_SHORT_TYPE: case SLANG_USHORT_TYPE:
	case SLANG_INT_TYPE: case SLANG_UINT_TYPE:
	case SLANG_LONG_TYPE: case SLANG_ULONG_TYPE:
	case SLANG_FLOAT_TYPE: case SLANG_DOUBLE_TYPE:
	case SLANG_COMPLEX_TYPE: case SLANG_STRING_TYPE:

	   /* Accomodate FORTRAN-style pass by reference semantics */
	   if (map_scalars_to_refs &&
		 	SLang_pop_array_of_type(&r->array,type) == 0) {

		*r->data = (void*)SLmalloc(r->sizeof_type);
		if (*r->data == NULL) return -1;

		if (r->sizeof_type == r->array->sizeof_type)
		   memcpy(*r->data, r->array->data, r->sizeof_type);
		else if (type == SLANG_COMPLEX_TYPE) {
		   double *dc = (double*) r->array->data;
		   float  *fc = (float*) *r->data;
		   fc[0] = (float)dc[0];
		   fc[1] = (float)dc[1];
		}
		else  {
		   SLang_verror(SL_TYPE_MISMATCH, (char*)
			"mismatched type sizes, when popping scalar as ref");
		   SLang_free_array(r->array);
		   return -1;
		}

		r->data = (void**)*r->data;
		r->flags |= REF_FLAG_FREE_DATA;
		/* Nullify to distinguish between vectored/non-vectored args */
		SLang_free_array(r->array); r->array = NULL;
		break;
	   }				/* intentional fallthrough */

	default:

#ifdef NUM_RESERVED_OPAQUES
	   if (objtype >= First_Opaque_Type && 
		 		sltype_to_slirp_type(objtype) != NULL) {

		if (!(flags & POP_FLAG_VECTORIZE))
		   type = sltype_to_opaque_ptr_type(type);

		if (type) {

		   Slirp_Opaque *otp;
		   if (SLang_pop_opaque(type, NULL, &otp) == -1)
			return -1;
		
		   if (flags & POP_FLAG_VECTORIZE) {
			void **arr = (void**) SLmalloc(sizeof(void*));
			if (arr == NULL) return -1;
			arr[0] = otp->instance;
			*r->data = arr;
			r->flags |= REF_FLAG_FREE_DATA;
		   }
		   else
			*r->data = otp->instance;

		   r->data = (void**)*r->data;
		   r->mmt = otp->mmt;
		   return 0;
		}
	   }
	   else
#endif
	   if ( try_pop_mmt(objtype, &r->mmt) == 1 &&
		(*r->data = SLang_object_from_mmt (r->mmt)) != NULL) {
		   r->data = (void**)*r->data;	 /* not flagged for freeing */
		   return 0;
	   }

	   SLang_verror(SL_TYPE_MISMATCH, (char*)
			"context requires array, ref, or opaque pointer");
	   return -1;
   }
   return 0;
} /*}}}*/
/* }}} */
static void push_null_term_str_array(char **arr, char *funcname, int free_arr)
{
   int i;
   char **copy = arr;
   SLang_Array_Type *sarr;

   while (*copy++) ;
   i = copy - arr - 1;

   sarr = SLang_create_array (SLANG_STRING_TYPE, 0, NULL, &i, 1);
   if (sarr != NULL) {
	   
	char **slstr = (char**)sarr->data;
	while (i--)
	   if ( NULL == (slstr[i] = SLang_create_slstring (arr[i]))) {
		SLang_free_array(sarr);
		sarr = NULL;
		break;
	   }

   }
   if (sarr == NULL) {
	if (funcname == NULL) funcname = "unknown function";
	SLang_verror(SL_INTRINSIC_ERROR, "creating string array in %s", funcname);
   }
   else
	SLang_push_array(sarr, 1);

   if (free_arr) {
	i = copy - arr;
	while (i--)
	   SLfree(arr[i]);
	SLfree((char*)arr);
   }
}

/* Wrapper functions */ /* {{{ */
static void sl_gtk_accel_label_set_accel_closure (void)
{
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GClosure* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_accel_label_set_accel_closure(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (0, 0, 0);
}

static void sl_gtk_editable_cut_clipboard (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_cut_clipboard(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1, 1, 0);
}

static void sl_gtk_tree_selection_iter_is_selected (void)
{
   gboolean retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_selection_iter_is_selected(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2, 2, 0);
}

static void sl_gtk_scrollable_get_vscroll_policy (void)
{
   GtkScrollablePolicy retval;
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollable_get_vscroll_policy(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3, 3, 0);
}

static void sl_gdk_window_set_decorations (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWMDecoration arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_decorations(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4, 4, 0);
}

static void sl_gtk_cell_editable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_editable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5, 5, 0);
}

static void sl_g_value_get_pointer (void)
{
   gpointer retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_pointer(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (6, 6, 0);
}

static void sl_gtk_progress_bar_set_fraction (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_set_fraction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (7, 7, 0);
}

static void sl_g_vfs_parse_name (void)
{
   GFile* retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_vfs_parse_name(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (8, 8, 0);
}

static void sl_gtk_target_list_add_rich_text_targets (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gboolean arg3;
   GtkTextBuffer* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   gtk_target_list_add_rich_text_targets(arg1,  arg2,  arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (9, 9, 0);
}

static void sl_gdk_cairo_get_drawing_context (void)
{
   GdkDrawingContext* retval;
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cairo_get_drawing_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (10, 10, 0);
}

static void sl_gtk_tree_model_sort_convert_iter_to_child_iter (void)
{
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_sort_convert_iter_to_child_iter(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (11, 11, 0);
}

static void sl_g_keyfile_settings_backend_new (void)
{
   GSettingsBackend* retval;
   gchar* arg1;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_keyfile_settings_backend_new(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (12, 12, 0);
}

static void sl_gtk_flow_box_get_max_children_per_line (void)
{
   guint retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_max_children_per_line(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (13, 13, 0);
}

static void sl_gtk_container_check_resize (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_check_resize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (14, 14, 0);
}

static void sl_gtk_menu_item_set_use_underline (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_set_use_underline(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (15, 15, 0);
}

static void sl_gtk_tree_selection_unselect_range (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_unselect_range(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (16, 16, 0);
}

static void sl_g_ascii_strncasecmp (void)
{
   gint retval;
   gchar* arg1;
   gchar* arg2;
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_ascii_strncasecmp(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (17, 17, 0);
}

static void sl_gtk_cell_area_get_cell_at_position (void)
{
   GtkCellRenderer* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   gint arg5;
   gint arg6;
   GdkRectangle* arg7 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_get_cell_at_position(arg1, arg2, arg3, arg4,  arg5,  arg6, arg7);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   (void) SLang_push_cstruct ((VOID_STAR) arg7, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (18, 18, 0);
}

static void sl_g_drive_is_removable (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_is_removable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (19, 19, 0);
}

static void sl_gtk_cell_area_get_preferred_width (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_get_preferred_width(arg1, arg2, arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (20, 20, 0);
}

static void sl_g_hmac_update (void)
{
   GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gssize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_hmac_update(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (21, 21, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_flow_box_set_hadjustment (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_flow_box_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (22, 22, 0);
}

static void sl_gdk_event_get_button (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_button(arg1, &arg2);
   if (retval)
      (void)SLang_push_uint(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (23, 23, 0);
}

static void sl_gtk_scrolled_window_unset_placement (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_unset_placement(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (24, 24, 0);
}

static void sl_gtk_message_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_message_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (25, 25, 0);
}

static void sl_gdk_window_get_group (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (26, 26, 0);
}

static void sl_g_value_set_variant (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_variant(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (27, 27, 0);
}

static void sl_gtk_tree_store_swap (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_store_swap(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (28, 28, 0);
}

static void sl_g_time_zone_new_offset (void)
{
   GTimeZone* retval;
   gint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_new_offset( arg1);
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (29, 29, 0);
}

static void sl_gtk_recent_chooser_select_all (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (30, 30, 0);
}

static void sl_gtk_selection_clear_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_selection_clear_targets(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (31, 31, 0);
}

static void sl_gtk_button_set_image_position (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPositionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_image_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (32, 32, 0);
}

static void sl_gtk_print_settings_get_number_up_layout (void)
{
   GtkNumberUpLayout retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_number_up_layout(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (33, 33, 0);
}

static void sl_g_file_set_display_name_finish (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_set_display_name_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (34, 34, 0);
}

static void sl_gdk_window_move_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_move_region(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (35, 35, 0);
}

static void sl_g_cancellable_is_cancelled (void)
{
   gboolean retval;
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_is_cancelled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (36, 36, 0);
}

static void sl_g_settings_schema_source_new_from_directory (void)
{
   GSettingsSchemaSource* retval;
   gchar* arg1;
   GSettingsSchemaSource* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_settings_schema_source_new_from_directory(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (37, 37, 0);
}

static void sl_gtk_entry_set_inner_border (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBorder* arg2 = (GtkBorder*) alloca(sizeof(GtkBorder));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GtkBorder_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_inner_border(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GtkBorder_Layout);
usage_label:
   if (issue_usage) Slirp_usage (38, 38, 0);
}

static void sl_gtk_widget_can_activate_accel (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_can_activate_accel(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (39, 39, 0);
}

static void sl_gtk_button_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_new_with_label(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (40, 40, 0);
}

static void sl_g_app_info_get_all_for_type (void)
{
   GList* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_all_for_type(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (41, 41, 0);
}

static void sl_gtk_flow_box_get_child_at_index (void)
{
   GtkFlowBoxChild* retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_child_at_index(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (42, 42, 0);
}

static void sl_g_file_info_set_modification_date_time (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateTime* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_modification_date_time(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (43, 43, 0);
}

static void sl_g_variant_get_double (void)
{
   gdouble retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_double(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (44, 44, 0);
}

static void sl_g_value_set_long (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   glong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_long(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (45, 45, 0);
}

static void sl_gdk_test_simulate_key (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   guint arg4;
   GdkModifierType arg5;
   GdkEventType arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_test_simulate_key(arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (46, 46, 0);
}

static void sl_gtk_menu_button_set_use_popover (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_button_set_use_popover(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (47, 47, 0);
}

static void sl_gtk_spin_button_get_digits (void)
{
   guint retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_digits(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (48, 48, 0);
}

static void sl_gtk_notebook_set_tab_label (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_tab_label(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (49, 49, 0);
}

static void sl_gdk_display_get_monitor (void)
{
   GdkMonitor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_monitor(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (50, 50, 0);
}

static void sl_gtk_window_set_has_user_ref_count (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_has_user_ref_count(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (51, 51, 0);
}

static void sl_gtk_file_filter_add_pattern (void)
{
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_filter_add_pattern(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (52, 52, 0);
}

static void sl_pango_attr_list_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_list_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (53, 53, 0);
}

static void sl_gtk_entry_get_invisible_char (void)
{
   gunichar retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_invisible_char(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (54, 54, 0);
}

static void sl_gtk_file_chooser_set_local_only (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_local_only(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (55, 55, 0);
}

static void sl_gtk_link_button_get_visited (void)
{
   gboolean retval;
   GtkLinkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_link_button_get_visited(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (56, 56, 0);
}

static void sl_gtk_entry_get_placeholder_text (void)
{
   const gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_placeholder_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (57, 57, 0);
}

static void sl_gdk_window_coords_from_parent (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_coords_from_parent(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (58, 58, 0);
}

static void sl_g_content_type_get_symbolic_icon (void)
{
   GIcon* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_symbolic_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (59, 59, 0);
}

static void sl_g_variant_new_uint16 (void)
{
   GVariant* retval;
   guint16 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_uint16( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (60, 60, 0);
}

static void sl_gtk_notebook_popup_enable (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_popup_enable(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (61, 61, 0);
}

static void sl_gtk_mount_operation_get_screen (void)
{
   GdkScreen* retval;
   GtkMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_mount_operation_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (62, 62, 0);
}

static void sl_gtk_widget_intersect (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_intersect(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (63, 63, 0);
}

static void sl_gtk_tool_item_group_set_ellipsize (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoEllipsizeMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_group_set_ellipsize(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (64, 64, 0);
}

static void sl_gtk_color_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (65, 65, 0);
}

static void sl_gtk_expander_set_label_fill (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_label_fill(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (66, 66, 0);
}

static void sl_g_app_info_get_icon (void)
{
   GIcon* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (67, 67, 0);
}

static void sl_gtk_application_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (68, 68, 0);
}

static void sl_pango_font_description_set_style (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_style(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (69, 69, 0);
}

static void sl_g_inet_address_get_is_mc_node_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_mc_node_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (70, 70, 0);
}

static void sl_gtk_cell_renderer_spinner_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_spinner_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (71, 71, 0);
}

static void sl_gtk_widget_freeze_child_notify (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_freeze_child_notify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (72, 72, 0);
}

static void sl_pango_attr_size_new_absolute (void)
{
   PangoAttribute* retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_size_new_absolute( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (73, 73, 0);
}

static void sl_gtk_combo_box_new_with_entry (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new_with_entry();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (74, 74, 0);
}

static void sl_gtk_print_operation_get_support_selection (void)
{
   gboolean retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_support_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (75, 75, 0);
}

static void sl_gtk_cell_renderer_pixbuf_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_pixbuf_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (76, 76, 0);
}

static void sl_g_value_get_flags (void)
{
   guint retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_flags(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (77, 77, 0);
}

static void sl_gtk_builder_get_type_from_name (void)
{
   GType retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_builder_get_type_from_name(arg1, arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (78, 78, 0);
}

static void sl_gtk_combo_box_popdown (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_popdown(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (79, 79, 0);
}

static void sl_g_settings_set_strv (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_strv(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (80, 80, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_tree_view_get_reorderable (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_reorderable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (81, 81, 0);
}

static void sl_pango_script_iter_free (void)
{
   PangoScriptIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoScriptIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_script_iter_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (82, 82, 0);
}

static void sl_gtk_button_get_alignment (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_get_alignment(arg1, &arg2, &arg3);
   (void)SLang_push_float(arg2);
   (void)SLang_push_float(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (83, 83, 0);
}

static void sl_gtk_window_get_attached_to (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_attached_to(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (84, 84, 0);
}

static void sl_gtk_style_context_set_parent (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_set_parent(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (85, 85, 0);
}

static void sl_g_menu_link_iter_get_next (void)
{
   gboolean retval;
   GMenuLinkIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GMenuModel** arg3;
   Slirp_Ref *arg3_r = ref_new(GObject_Type,sizeof(GMenuModel*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_link_iter_get_next(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (86, 86, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_pango_context_get_round_glyph_positions (void)
{
   gboolean retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_round_glyph_positions(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (87, 87, 0);
}

static void sl_gtk_radio_button_join_group (void)
{
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRadioButton* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_radio_button_join_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (88, 88, 0);
}

static void sl_gtk_page_setup_get_paper_size (void)
{
   GtkPaperSize* retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_paper_size(arg1);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (89, 89, 0);
}

static void sl_g_app_info_get_id (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_id(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (90, 90, 0);
}

static void sl_gtk_toolbar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (91, 91, 0);
}

static void sl_g_clear_signal_handler (void)
{
   gulong* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_ULONG_TYPE,sizeof(gulong),&arg1,0x0);
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   g_clear_signal_handler(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (92, 92, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_icon_view_set_activate_on_single_click (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_activate_on_single_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (93, 93, 0);
}

static void sl_gtk_tree_view_insert_column (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumn* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_insert_column(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (94, 94, 0);
}

static void sl_g_bookmark_file_get_applications (void)
{
   gchar** retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   arg4 = NULL;
   retval = g_bookmark_file_get_applications(arg1, arg2, &arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   push_null_term_str_array (retval, "g_bookmark_file_get_applications", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (95, 95, 0);
}

static void sl_g_value_get_string (void)
{
   const gchar* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (96, 96, 0);
}

static void sl_gtk_widget_set_hexpand (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_hexpand(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (97, 97, 0);
}

static void sl_g_param_spec_pool_insert (void)
{
   GParamSpecPool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_param_spec_pool_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (98, 98, 0);
}

static void sl_gtk_text_buffer_get_start_iter (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_start_iter(arg1, arg2);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (99, 99, 0);
}

static void sl_gtk_tree_view_set_search_column (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_search_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (100, 100, 0);
}

static void sl_gdk_pixbuf_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (101, 101, 0);
}

static void sl_gtk_drag_set_icon_name (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_name(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (102, 102, 0);
}

static void sl_gtk_tree_path_down (void)
{
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_path_down(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (103, 103, 0);
}

static void sl_gtk_recent_filter_add_application (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_filter_add_application(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (104, 104, 0);
}

static void sl_pango_font_description_copy_static (void)
{
   PangoFontDescription* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_copy_static(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (105, 105, 0);
}

static void sl_gtk_calendar_unmark_day (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_unmark_day(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (106, 106, 0);
}

static void sl_g_type_class_get_instance_private_offset (void)
{
   gint retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_class_get_instance_private_offset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (107, 107, 0);
}

static void sl_gtk_tree_view_get_level_indentation (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_level_indentation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (108, 108, 0);
}

static void sl_gtk_text_iter_forward_to_tag_toggle (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_forward_to_tag_toggle(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (109, 109, 0);
}

static void sl_gdk_window_hints_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_hints_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (110, 110, 0);
}

static void sl_gtk_text_child_anchor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_child_anchor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (111, 111, 0);
}

static void sl_gtk_font_chooser_dialog_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_font_chooser_dialog_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (112, 112, 0);
}

static void sl_gtk_text_iter_begins_tag (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_begins_tag(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (113, 113, 0);
}

static void sl_g_key_file_load_from_data_dirs (void)
{
   gboolean retval;
   GKeyFile* arg1;
   gchar* arg2;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GKeyFileFlags arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   issue_usage = 0;

   arg1 = g_key_file_new ();
   arg5 = NULL;
   retval = g_key_file_load_from_data_dirs(arg1, arg2, arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   if (retval == TRUE)
      (void) SLang_push_opaque (GKeyFile_Type, (void*) retval, 0);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (114, 114, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_text_buffer_remove_tag (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_remove_tag(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (115, 115, 0);
}

static void sl_gtk_widget_list_mnemonic_labels (void)
{
   GList* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_list_mnemonic_labels(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (116, 116, 0);
}

static void sl_g_variant_new_double (void)
{
   GVariant* retval;
   gdouble arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_double( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (117, 117, 0);
}

static void sl_g_file_info_set_attribute (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileAttributeType arg3;
   gpointer arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute(arg1, arg2,  arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (118, 118, 0);
}

static void sl_gtk_grab_add (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grab_add(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (119, 119, 0);
}

static void sl_gdk_set_double_click_time (void)
{
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_set_double_click_time( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (120, 120, 0);
}

static void sl_gtk_text_buffer_get_bounds (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   GtkTextIter* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   if ((arg3 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_bounds(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   (void) SLang_push_opaque (GtkTextIter_Type, arg3, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (121, 121, 0);
}

static void sl_gtk_tree_model_sort_convert_child_path_to_path (void)
{
   GtkTreePath* retval;
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_sort_convert_child_path_to_path(arg1, arg2);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (122, 122, 0);
}

static void sl_gdk_frame_timings_get_predicted_presentation_time (void)
{
   gint64 retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_predicted_presentation_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (123, 123, 0);
}

static void sl_gtk_widget_get_request_mode (void)
{
   GtkSizeRequestMode retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_request_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (124, 124, 0);
}

static void sl_pango_layout_iter_get_line_yrange (void)
{
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_iter_get_line_yrange(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (125, 125, 0);
}

static void sl_g_type_register_dynamic (void)
{
   GType retval;
   GType arg1;
   gchar* arg2;
   GTypePlugin* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GTypeFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_type_register_dynamic( arg1, arg2, arg3,  arg4);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (126, 126, 0);
}

static void sl_gtk_menu_bar_get_child_pack_direction (void)
{
   GtkPackDirection retval;
   GtkMenuBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_bar_get_child_pack_direction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (127, 127, 0);
}

static void sl_g_variant_new_object_path (void)
{
   GVariant* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_object_path(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (128, 128, 0);
}

static void sl_gtk_grid_attach (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_grid_attach(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (129, 129, 0);
}

static void sl_gdk_frame_clock_end_updating (void)
{
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_frame_clock_end_updating(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (130, 130, 0);
}

static void sl_g_settings_get_flags (void)
{
   guint retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_flags(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (131, 131, 0);
}

static void sl_g_drive_poll_for_media_finish (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_drive_poll_for_media_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (132, 132, 0);
}

static void sl_gtk_paned_add2 (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_paned_add2(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (133, 133, 0);
}

static void sl_gtk_file_chooser_set_preview_widget_active (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_preview_widget_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (134, 134, 0);
}

static void sl_gtk_menu_item_get_reserve_indicator (void)
{
   gboolean retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_reserve_indicator(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (135, 135, 0);
}

static void sl_gtk_app_chooser_button_get_show_default_item (void)
{
   gboolean retval;
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_button_get_show_default_item(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (136, 136, 0);
}

static void sl_gtk_tool_button_get_icon_name (void)
{
   const gchar* retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_icon_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (137, 137, 0);
}

static void sl_gtk_expander_get_use_underline (void)
{
   gboolean retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_use_underline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (138, 138, 0);
}

static void sl_g_menu_model_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_model_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (139, 139, 0);
}

static void sl_gtk_text_iter_ends_line (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_ends_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (140, 140, 0);
}

static void sl_gtk_accel_group_disconnect (void)
{
   gboolean retval;
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GClosure* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_accel_group_disconnect(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (141, 141, 0);
}

static void sl_g_strnfill (void)
{
   gchar* retval;
   gsize arg1;
   gchar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strnfill( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (142, 142, 0);
}

static void sl_g_key_file_set_integer_list (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   gsize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = (gsize) ref_get_size(arg4_r, 0);
   g_key_file_set_integer_list(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (143, 143, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_tool_button_get_icon_widget (void)
{
   GtkWidget* retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_icon_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (144, 144, 0);
}

static void sl_g_ascii_formatd (void)
{
   gchar* retval;
   gchar* arg1;
   gint arg2;
   gchar* arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_ascii_formatd(arg1,  arg2, arg3,  arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (145, 145, 0);
}

static void sl_g_bookmark_file_add_group (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_add_group(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (146, 146, 0);
}

static void sl_g_inet_address_get_is_mc_site_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_mc_site_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (147, 147, 0);
}

static void sl_gtk_popover_new (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (148, 148, 0);
}

static void sl_gtk_tree_view_set_cursor (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_cursor(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (149, 149, 0);
}

static void sl_gtk_style_context_reset_widgets (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_reset_widgets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (150, 150, 0);
}

static void sl_gtk_text_iter_inside_sentence (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_inside_sentence(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (151, 151, 0);
}

static void sl_gtk_level_bar_add_offset_value (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_level_bar_add_offset_value(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (152, 152, 0);
}

static void sl_gtk_accel_map_save (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_save(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (153, 153, 0);
}

static void sl_gtk_editable_paste_clipboard (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_paste_clipboard(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (154, 154, 0);
}

static void sl_gtk_list_box_get_row_at_index (void)
{
   GtkListBoxRow* retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_row_at_index(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (155, 155, 0);
}

static void sl_gtk_print_settings_set_print_pages (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintPages arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_print_pages(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (156, 156, 0);
}

static void sl_pango_cairo_show_error_underline (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   double arg3;
   double arg4;
   double arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_cairo_show_error_underline(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (157, 157, 0);
}

static void sl_gtk_get_current_event_time (void)
{
   guint32 retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_current_event_time();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (158, 158, 0);
}

static void sl_gtk_entry_completion_set_popup_set_width (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_popup_set_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (159, 159, 0);
}

static void sl_g_timeout_source_new (void)
{
   GSource* retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_timeout_source_new( arg1);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (160, 160, 0);
}

static void sl_g_app_info_should_show (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_should_show(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (161, 161, 0);
}

static void sl_gdk_pixbuf_animation_new_from_stream (void)
{
   GdkPixbufAnimation* retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gdk_pixbuf_animation_new_from_stream(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (162, 162, 0);
}

static void sl_gtk_file_chooser_set_current_folder_uri (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_set_current_folder_uri(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (163, 163, 0);
}

static void sl_gtk_text_tag_get_priority (void)
{
   gint retval;
   GtkTextTag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_get_priority(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (164, 164, 0);
}

static void sl_gtk_cell_area_context_push_preferred_width (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_push_preferred_width(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (165, 165, 0);
}

static void sl_gtk_entry_completion_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (166, 166, 0);
}

static void sl_gtk_widget_get_device_events (void)
{
   GdkEventMask retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_get_device_events(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (167, 167, 0);
}

static void sl_gtk_icon_info_load_icon (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_icon_info_load_icon(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (168, 168, 0);
}

static void sl_gtk_widget_get_preferred_height (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_height(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (169, 169, 0);
}

static void sl_gtk_window_close (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_close(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (170, 170, 0);
}

static void sl_gtk_cell_area_context_reset (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_reset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (171, 171, 0);
}

static void sl_gtk_button_set_image (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_button_set_image(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (172, 172, 0);
}

static void sl_pango_attr_list_unref (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_attr_list_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (173, 173, 0);
}

static void sl_g_drive_get_start_stop_type (void)
{
   GDriveStartStopType retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_start_stop_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (174, 174, 0);
}

static void sl_pango_layout_get_line_count (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_line_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (175, 175, 0);
}

static void sl_gtk_entry_get_text_area (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_get_text_area(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (176, 176, 0);
}

static void sl_gtk_widget_queue_resize (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_resize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (177, 177, 0);
}

static void sl_gtk_style_context_has_class (void)
{
   gboolean retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_style_context_has_class(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (178, 178, 0);
}

static void sl_gtk_image_set_from_animation (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbufAnimation* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_animation(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (179, 179, 0);
}

static void sl_gtk_entry_set_tabs (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoTabArray* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_tabs(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (180, 180, 0);
}

static void sl_g_notification_set_title (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (181, 181, 0);
}

static void sl_g_file_open_readwrite (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_open_readwrite(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (182, 182, 0);
}

static void sl_gtk_window_set_role (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_role(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (183, 183, 0);
}

static void sl_pango_font_metrics_get_ascent (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_ascent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (184, 184, 0);
}

static void sl_gtk_container_add (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_add(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (185, 185, 0);
}

static void sl_gtk_event_box_set_visible_window (void)
{
   GtkEventBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_event_box_set_visible_window(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (186, 186, 0);
}

static void sl_g_settings_schema_key_get_name (void)
{
   const gchar* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (187, 187, 0);
}

static void sl_g_mount_operation_get_pim (void)
{
   guint retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_pim(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (188, 188, 0);
}

static void sl_g_value_get_variant (void)
{
   GVariant* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_variant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (189, 189, 0);
}

static void sl_gtk_builder_get_translation_domain (void)
{
   const gchar* retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_get_translation_domain(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (190, 190, 0);
}

static void sl_gtk_window_get_default_size (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_get_default_size(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (191, 191, 0);
}

static void sl_g_signal_handler_unblock (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_signal_handler_unblock(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (192, 192, 0);
}

static void sl_gtk_window_set_type_hint (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindowTypeHint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_type_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (193, 193, 0);
}

static void sl_gtk_notebook_set_group_name (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_group_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (194, 194, 0);
}

static void sl_gtk_page_setup_set_paper_size (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPaperSize* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_page_setup_set_paper_size(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (195, 195, 0);
}

static void sl_gtk_expander_set_use_markup (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_use_markup(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (196, 196, 0);
}

static void sl_gdk_device_get_axis_use (void)
{
   GdkAxisUse retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_axis_use(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (197, 197, 0);
}

static void sl_gtk_widget_translate_coordinates (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_translate_coordinates(arg1, arg2,  arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (198, 198, 0);
}

static void sl_g_file_dup (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_dup(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (199, 199, 0);
}

static void sl_gtk_print_job_get_collate (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_collate(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (200, 200, 0);
}

static void sl_g_variant_new_array (void)
{
   GVariant* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariant** arg2;
   Slirp_Ref *arg2_r = ref_new(GVariant_Type,sizeof(GVariant*),&arg2,0x0);
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_array(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (201, 201, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_query_visual_types (void)
{
   GdkVisualType** arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkVisualType_ptr_ptr_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_query_visual_types(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (202, 202, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_adjustment_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (203, 203, 0);
}

static void sl_gtk_scrolled_window_set_hadjustment (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scrolled_window_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (204, 204, 0);
}

static void sl_gtk_print_operation_cancel (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_cancel(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (205, 205, 0);
}

static void sl_gtk_tree_store_insert_before (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkTreeIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_store_insert_before(arg1, arg2, arg3, arg4);
   (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
free_and_return_3:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (206, 206, 0);
}

static void sl_gtk_range_set_slider_size_fixed (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_slider_size_fixed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (207, 207, 0);
}

static void sl_g_strsignal (void)
{
   const gchar* retval;
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strsignal( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (208, 208, 0);
}

static void sl_gdk_window_unfullscreen (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_unfullscreen(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (209, 209, 0);
}

static void sl_gtk_menu_button_set_popup (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_button_set_popup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (210, 210, 0);
}

static void sl_gtk_accelerator_name (void)
{
   gchar* retval;
   guint arg1;
   GdkModifierType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_name( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (211, 211, 0);
}

static void sl_gtk_tool_item_set_visible_vertical (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_visible_vertical(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (212, 212, 0);
}

static void sl_gtk_tool_item_retrieve_proxy_menu_item (void)
{
   GtkWidget* retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_retrieve_proxy_menu_item(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (213, 213, 0);
}

static void sl_gtk_widget_child_notify (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_child_notify(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (214, 214, 0);
}

static void sl_gtk_file_chooser_button_get_title (void)
{
   const gchar* retval;
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (215, 215, 0);
}

static void sl_gtk_window_is_active (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_is_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (216, 216, 0);
}

static void sl_gtk_print_settings_get_output_bin (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_output_bin(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (217, 217, 0);
}

static void sl_gdk_screen_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (218, 218, 0);
}

static void sl_g_themed_icon_new_from_names (void)
{
   GIcon* retval;
   char** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg1,0x0);
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_themed_icon_new_from_names(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (219, 219, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_pango_cairo_font_map_get_font_type (void)
{
   cairo_font_type_t retval;
   PangoCairoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_get_font_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (220, 220, 0);
}

static void sl_gdk_event_get_window (void)
{
   GdkWindow* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (221, 221, 0);
}

static void sl_gtk_cell_view_get_size_of_row (void)
{
   gboolean retval;
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkRequisition* arg3 = (GtkRequisition*) alloca(sizeof(GtkRequisition));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GtkRequisition_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_view_get_size_of_row(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GtkRequisition_Layout);
usage_label:
   if (issue_usage) Slirp_usage (222, 222, 0);
}

static void sl_gtk_recent_info_has_group (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_info_has_group(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (223, 223, 0);
}

static void sl_pango_cairo_show_layout (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayout* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_show_layout(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (224, 224, 0);
}

static void sl_gdk_pixbuf_get_height (void)
{
   int retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (225, 225, 0);
}

static void sl_gtk_icon_theme_list_contexts (void)
{
   GList* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_list_contexts(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (226, 226, 0);
}

static void sl_gtk_text_view_get_pixels_below_lines (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_pixels_below_lines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (227, 227, 0);
}

static void sl_g_file_attribute_matcher_enumerate_next (void)
{
   const char* retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_matcher_enumerate_next(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (228, 228, 0);
}

static void sl_gtk_popover_get_transitions_enabled (void)
{
   gboolean retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_transitions_enabled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (229, 229, 0);
}

static void sl_gtk_entry_buffer_insert_text (void)
{
   guint retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = (gint) strlen (arg3);
   retval = gtk_entry_buffer_insert_text(arg1,  arg2, arg3,  arg4);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (230, 230, 0);
}

static void sl_gtk_popover_get_default_widget (void)
{
   GtkWidget* retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_default_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (231, 231, 0);
}

static void sl_gtk_container_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (232, 232, 0);
}

static void sl_gtk_range_set_flippable (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_flippable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (233, 233, 0);
}

static void sl_gtk_cell_view_get_model (void)
{
   GtkTreeModel* retval;
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (234, 234, 0);
}

static void sl_gtk_gesture_set_sequence_state (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventSequence* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkEventSequenceState arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_set_sequence_state(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (235, 235, 0);
}

static void sl_gtk_cell_renderer_spin_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_spin_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (236, 236, 0);
}

static void sl_gtk_entry_buffer_get_bytes (void)
{
   gsize retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_get_bytes(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (237, 237, 0);
}

static void sl_gtk_places_sidebar_set_show_other_locations (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_other_locations(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (238, 238, 0);
}

static void sl_gtk_range_set_value (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (239, 239, 0);
}

static void sl_gtk_selection_data_targets_include_text (void)
{
   gboolean retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_targets_include_text(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (240, 240, 0);
}

static void sl_g_themed_icon_append_name (void)
{
   GThemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_themed_icon_append_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (241, 241, 0);
}

static void sl_g_key_file_to_data (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   arg3 = NULL;
   retval = g_key_file_to_data(arg1, &arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (242, 242, 0);
}

static void sl_gtk_combo_box_text_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_text_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (243, 243, 0);
}

static void sl_g_date_time_get_year (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_year(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (244, 244, 0);
}

static void sl_g_regex_match_full (void)
{
   gboolean retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   gint arg4;
   GRegexMatchFlags arg5;
   GMatchInfo** arg6;
   Slirp_Ref *arg6_r = ref_new(GMatchInfo_Type,sizeof(GMatchInfo*),&arg6,0x0);
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_regex_match_full(arg1, arg2,  arg3,  arg4,  arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (245, 245, 0);
   finalize_refs(1,arg6_r); 
}

static void sl_gtk_text_iter_ends_word (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_ends_word(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (246, 246, 0);
}

static void sl_gtk_font_chooser_widget_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_widget_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (247, 247, 0);
}

static void sl_gtk_color_button_get_color (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_button_get_color(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkColor_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (248, 248, 0);
}

static void sl_g_app_info_get_fallback_for_type (void)
{
   GList* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_fallback_for_type(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (249, 249, 0);
}

static void sl_gdk_window_get_clip_region (void)
{
   cairo_region_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_clip_region(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (250, 250, 0);
}

static void sl_pango_cairo_show_layout_line (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayoutLine* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_show_layout_line(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (251, 251, 0);
}

static void sl_gtk_menu_tool_button_set_arrow_tooltip_text (void)
{
   GtkMenuToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_tool_button_set_arrow_tooltip_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (252, 252, 0);
}

static void sl_gtk_entry_get_input_purpose (void)
{
   GtkInputPurpose retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_input_purpose(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (253, 253, 0);
}

static void sl_gdk_drag_motion (void)
{
   gboolean retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDragProtocol arg3;
   gint arg4;
   gint arg5;
   GdkDragAction arg6;
   GdkDragAction arg7;
   guint32 arg8;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_drag_motion(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (254, 254, 0);
}

static void sl_gtk_tool_item_group_set_label (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_group_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (255, 255, 0);
}

static void sl_gtk_text_buffer_get_tag_table (void)
{
   GtkTextTagTable* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_tag_table(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (256, 256, 0);
}

static void sl_g_file_has_uri_scheme (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_has_uri_scheme(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (257, 257, 0);
}

static void sl_gtk_mount_operation_new (void)
{
   GMountOperation* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_mount_operation_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (258, 258, 0);
}

static void sl_gtk_text_view_get_window_type (void)
{
   GtkTextWindowType retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_get_window_type(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (259, 259, 0);
}

static void sl_gtk_page_setup_load_key_file (void)
{
   gboolean retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GKeyFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_page_setup_load_key_file(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (260, 260, 0);
}

static void sl_gtk_grid_insert_column (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_insert_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (261, 261, 0);
}

static void sl_g_bookmark_file_has_application (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_has_application(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (262, 262, 0);
}

static void sl_gtk_label_get_yalign (void)
{
   gfloat retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_yalign(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (263, 263, 0);
}

static void sl_gtk_window_set_focus (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_focus(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (264, 264, 0);
}

static void sl_gtk_entry_get_icon_tooltip_text (void)
{
   gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_tooltip_text(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (265, 265, 0);
}

static void sl_gtk_range_get_value (void)
{
   gdouble retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (266, 266, 0);
}

static void sl_g_io_create_watch (void)
{
   GSource* retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOCondition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_create_watch(arg1,  arg2);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (267, 267, 0);
}

static void sl_gtk_text_view_get_input_purpose (void)
{
   GtkInputPurpose retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_input_purpose(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (268, 268, 0);
}

static void sl_gtk_widget_get_device_enabled (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_get_device_enabled(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (269, 269, 0);
}

static void sl_gdk_screen_height (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_height();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (270, 270, 0);
}

static void sl_gtk_get_current_event_device (void)
{
   GdkDevice* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_current_event_device();
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (271, 271, 0);
}

static void sl_g_socket_get_socket_type (void)
{
   GSocketType retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_socket_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (272, 272, 0);
}

static void sl_pango_renderer_get_alpha (void)
{
   guint16 retval;
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_renderer_get_alpha(arg1,  arg2);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (273, 273, 0);
}

static void sl_gtk_tool_item_set_proxy_menu_item (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_set_proxy_menu_item(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (274, 274, 0);
}

static void sl_gtk_tree_view_column_get_button (void)
{
   GtkWidget* retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_button(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (275, 275, 0);
}

static void sl_gtk_spinner_start (void)
{
   GtkSpinner* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spinner_start(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (276, 276, 0);
}

static void sl_gdk_event_sequence_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_sequence_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (277, 277, 0);
}

static void sl_g_mount_operation_set_is_tcrypt_hidden_volume (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_is_tcrypt_hidden_volume(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (278, 278, 0);
}

static void sl_gtk_container_resize_children (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_resize_children(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (279, 279, 0);
}

static void sl_gtk_adjustment_value_changed (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_value_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (280, 280, 0);
}

static void sl_g_resolver_lookup_by_name (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_resolver_lookup_by_name(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (281, 281, 0);
}

static void sl_g_canonicalize_filename (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_canonicalize_filename(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (282, 282, 0);
}

static void sl_gtk_icon_theme_set_screen (void)
{
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_theme_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (283, 283, 0);
}

static void sl_gtk_tree_view_set_show_expanders (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_show_expanders(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (284, 284, 0);
}

static void sl_gdk_window_get_state (void)
{
   GdkWindowState retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (285, 285, 0);
}

static void sl_gtk_printer_new (void)
{
   GtkPrinter* retval;
   gchar* arg1;
   GtkPrintBackend* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_printer_new(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (286, 286, 0);
}

static void sl_pango_font_metrics_get_approximate_digit_width (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_approximate_digit_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (287, 287, 0);
}

static void sl_gtk_paned_pack2 (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_paned_pack2(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (288, 288, 0);
}

static void sl_gtk_print_context_get_cairo_context (void)
{
   cairo_t* retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_cairo_context(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (289, 289, 0);
}

static void sl_gtk_text_view_add_child_in_window (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextWindowType arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_add_child_in_window(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (290, 290, 0);
}

static void sl_gtk_widget_get_focus_on_click (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_focus_on_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (291, 291, 0);
}

static void sl_gtk_paper_size_new_from_ppd (void)
{
   GtkPaperSize* retval;
   gchar* arg1;
   gchar* arg2;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_paper_size_new_from_ppd(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (292, 292, 0);
}

static void sl_gdk_gl_context_get_use_es (void)
{
   gboolean retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_use_es(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (293, 293, 0);
}

static void sl_gtk_window_get_hide_titlebar_when_maximized (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_hide_titlebar_when_maximized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (294, 294, 0);
}

static void sl_g_file_make_directory_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_make_directory_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (295, 295, 0);
}

static void sl_gtk_tool_palette_set_icon_size (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_palette_set_icon_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (296, 296, 0);
}

static void sl_gtk_file_chooser_unselect_uri (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_unselect_uri(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (297, 297, 0);
}

static void sl_gtk_icon_theme_lookup_icon_for_scale (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint arg4;
   GtkIconLookupFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_lookup_icon_for_scale(arg1, arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (298, 298, 0);
}

static void sl_g_themed_icon_new_with_default_fallbacks (void)
{
   GIcon* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_themed_icon_new_with_default_fallbacks(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (299, 299, 0);
}

static void sl_gtk_paned_get_handle_window (void)
{
   GdkWindow* retval;
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_handle_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (300, 300, 0);
}

static void sl_g_mount_operation_get_domain (void)
{
   const char* retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_domain(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (301, 301, 0);
}

static void sl_gtk_recent_chooser_set_current_uri (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_recent_chooser_set_current_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (302, 302, 0);
}

static void sl_g_content_type_get_description (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_description(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (303, 303, 0);
}

static void sl_gtk_combo_box_set_model (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_set_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (304, 304, 0);
}

static void sl_gtk_recent_info_get_mime_type (void)
{
   const gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_mime_type(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (305, 305, 0);
}

static void sl_gtk_cell_renderer_get_preferred_height (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_preferred_height(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (306, 306, 0);
}

static void sl_g_checksum_get_string (void)
{
   const gchar* retval;
   GChecksum* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GChecksum_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_checksum_get_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (307, 307, 0);
}

static void sl_g_inet_address_mask_get_family (void)
{
   GSocketFamily retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_mask_get_family(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (308, 308, 0);
}

static void sl_g_variant_new_maybe (void)
{
   GVariant* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_new_maybe(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (309, 309, 0);
}

static void sl_gtk_widget_path_iter_get_object_type (void)
{
   GType retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_object_type(arg1,  arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (310, 310, 0);
}

static void sl_gdk_window_create_similar_image_surface (void)
{
   cairo_surface_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_format_t arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_create_similar_image_surface(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (311, 311, 0);
}

static void sl_g_param_spec_get_default_value (void)
{
   const GValue* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_default_value(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (312, 312, 0);
}

static void sl_gdk_display_open_default_libgtk_only (void)
{
   GdkDisplay* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_open_default_libgtk_only();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (313, 313, 0);
}

static void sl_gtk_text_iter_backward_visible_cursor_positions (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_cursor_positions(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (314, 314, 0);
}

static void sl_gtk_combo_box_get_popup_fixed_width (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_popup_fixed_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (315, 315, 0);
}

static void sl_gtk_font_button_set_show_size (void)
{
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_button_set_show_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (316, 316, 0);
}

static void sl_gtk_event_controller_get_propagation_phase (void)
{
   GtkPropagationPhase retval;
   GtkEventController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_get_propagation_phase(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (317, 317, 0);
}

static void sl_gtk_paper_size_get_ppd_name (void)
{
   const gchar* retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_ppd_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (318, 318, 0);
}

static void sl_gtk_target_list_add_image_targets (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_list_add_image_targets(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (319, 319, 0);
}

static void sl_gtk_level_bar_set_value (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_level_bar_set_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (320, 320, 0);
}

static void sl_gtk_widget_get_size_request (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_size_request(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (321, 321, 0);
}

static void sl_gtk_accel_map_change_entry (void)
{
   gboolean retval;
   gchar* arg1;
   guint arg2;
   GdkModifierType arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_map_change_entry(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (322, 322, 0);
}

static void sl_gtk_print_run_page_setup_dialog (void)
{
   GtkPageSetup* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSetup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkPrintSettings* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_run_page_setup_dialog(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (323, 323, 0);
}

static void sl_gtk_icon_theme_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (324, 324, 0);
}

static void sl_gtk_render_background_get_clip (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   GdkRectangle* arg6 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_render_background_get_clip(arg1,  arg2,  arg3,  arg4,  arg5, arg6);
   (void) SLang_push_cstruct ((VOID_STAR) arg6, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (325, 325, 0);
}

static void sl_gtk_application_uninhibit (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_application_uninhibit(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (326, 326, 0);
}

static void sl_gtk_window_has_toplevel_focus (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_has_toplevel_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (327, 327, 0);
}

static void sl_gtk_printer_get_location (void)
{
   const gchar* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_location(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (328, 328, 0);
}

static void sl_gtk_tree_view_column_get_widget (void)
{
   GtkWidget* retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (329, 329, 0);
}

static void sl_gtk_widget_get_margin_bottom (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_bottom(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (330, 330, 0);
}

static void sl_gtk_combo_box_get_model (void)
{
   GtkTreeModel* retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (331, 331, 0);
}

static void sl_gtk_switch_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_switch_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (332, 332, 0);
}

static void sl_gdk_device_get_key (void)
{
   gboolean retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_key(arg1,  arg2, &arg3, &arg4);
   if (retval)
      (void)SLang_push_uint(arg3);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_int(arg4);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (333, 333, 0);
}

static void sl_gtk_check_menu_item_set_draw_as_radio (void)
{
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_check_menu_item_set_draw_as_radio(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (334, 334, 0);
}

static void sl_gtk_print_context_create_pango_context (void)
{
   PangoContext* retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_create_pango_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (335, 335, 0);
}

static void sl_gdk_pixbuf_format_get_license (void)
{
   gchar* retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_license(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (336, 336, 0);
}

static void sl_pango_cairo_font_map_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (337, 337, 0);
}

static void sl_g_utf8_strncpy (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_utf8_strncpy(arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (338, 338, 0);
}

static void sl_gtk_font_chooser_get_font_face (void)
{
   PangoFontFace* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_face(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (339, 339, 0);
}

static void sl_gtk_dialog_set_default_response (void)
{
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_dialog_set_default_response(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (340, 340, 0);
}

static void sl_gtk_layout_move (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_layout_move(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (341, 341, 0);
}

static void sl_gtk_shortcuts_section_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcuts_section_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (342, 342, 0);
}

static void sl_gtk_get_current_event (void)
{
   GdkEvent* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_current_event();
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (343, 343, 0);
}

static void sl_pango_font_map_list_families (void)
{
   PangoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontFamily*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontFamily_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_map_list_families(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (344, 344, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_size_allocate (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GtkAllocation_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_size_allocate(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GtkAllocation_Layout);
usage_label:
   if (issue_usage) Slirp_usage (345, 345, 0);
}

static void sl_gtk_page_setup_new_from_key_file (void)
{
   GtkPageSetup* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_page_setup_new_from_key_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (346, 346, 0);
}

static void sl_g_file_info_get_icon (void)
{
   GIcon* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (347, 347, 0);
}

static void sl_gtk_flow_box_set_activate_on_single_click (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_activate_on_single_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (348, 348, 0);
}

static void sl_gtk_tree_store_remove (void)
{
   gboolean retval;
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_store_remove(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (349, 349, 0);
}

static void sl_gdk_disable_multidevice (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_disable_multidevice();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (350, 350, 0);
}

static void sl_gtk_drag_set_icon_pixbuf (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_pixbuf(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (351, 351, 0);
}

static void sl_gtk_box_reorder_child (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_reorder_child(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (352, 352, 0);
}

static void sl_gtk_entry_completion_get_popup_single_match (void)
{
   gboolean retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_popup_single_match(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (353, 353, 0);
}

static void sl_gtk_printer_is_virtual (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_is_virtual(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (354, 354, 0);
}

static void sl_gtk_flow_box_get_min_children_per_line (void)
{
   guint retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_min_children_per_line(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (355, 355, 0);
}

static void sl_gtk_label_set_attributes (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttrList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_attributes(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (356, 356, 0);
}

static void sl_gtk_adjustment_new (void)
{
   GtkAdjustment* retval;
   gdouble arg1;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_new( arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (357, 357, 0);
}

static void sl_gtk_widget_remove_tick_callback (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_remove_tick_callback(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (358, 358, 0);
}

static void sl_g_socket_receive (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_receive(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (359, 359, 0);
}

static void sl_gtk_text_iter_set_visible_line_index (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_visible_line_index(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (360, 360, 0);
}

static void sl_gdk_frame_timings_get_presentation_time (void)
{
   gint64 retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_presentation_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (361, 361, 0);
}

static void sl_g_mkdtemp_full (void)
{
   gchar* retval;
   gchar* arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_mkdtemp_full(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (362, 362, 0);
}

static void sl_gtk_app_chooser_widget_set_show_default (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_widget_set_show_default(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (363, 363, 0);
}

static void sl_g_settings_new_full (void)
{
   GSettings* retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSettingsBackend* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_new_full(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (364, 364, 0);
}

static void sl_pango_layout_set_single_paragraph_mode (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_single_paragraph_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (365, 365, 0);
}

static void sl_gdk_device_list_slave_devices (void)
{
   GList* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_list_slave_devices(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (366, 366, 0);
}

static void sl_gtk_style_context_get_border (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GtkBorder* arg3 = (GtkBorder*) alloca(sizeof(GtkBorder));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_border(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GtkBorder_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (367, 367, 0);
}

static void sl_gtk_clipboard_wait_is_text_available (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_is_text_available(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (368, 368, 0);
}

static void sl_g_variant_new_uint64 (void)
{
   GVariant* retval;
   guint64 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_uint64( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (369, 369, 0);
}

static void sl_gtk_print_settings_set_paper_width (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_paper_width(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (370, 370, 0);
}

static void sl_pango_coverage_ref (void)
{
   PangoCoverage* retval;
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_ref(arg1);
   (void)SLang_push_opaque(PangoCoverage_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (371, 371, 0);
}

static void sl_gtk_widget_set_events (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_events(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (372, 372, 0);
}

static void sl_gtk_text_iter_forward_sentence_ends (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_sentence_ends(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (373, 373, 0);
}

static void sl_gtk_box_set_homogeneous (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_box_set_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (374, 374, 0);
}

static void sl_g_signal_stop_emission (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GQuark arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_signal_stop_emission(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (375, 375, 0);
}

static void sl_gtk_assistant_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_assistant_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (376, 376, 0);
}

static void sl_g_settings_get_value (void)
{
   GVariant* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_value(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (377, 377, 0);
}

static void sl_gtk_application_get_windows (void)
{
   GList* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_windows(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (378, 378, 0);
}

static void sl_gtk_tree_view_column_add_attribute (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_add_attribute(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (379, 379, 0);
}

static void sl_gtk_calendar_clear_marks (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_clear_marks(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (380, 380, 0);
}

static void sl_g_intern_string (void)
{
   const gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_intern_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (381, 381, 0);
}

static void sl_gdk_device_get_n_keys (void)
{
   gint retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_n_keys(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (382, 382, 0);
}

static void sl_gtk_actionable_set_action_target_value (void)
{
   GtkActionable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_actionable_set_action_target_value(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (383, 383, 0);
}

static void sl_gtk_window_set_has_resize_grip (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_has_resize_grip(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (384, 384, 0);
}

static void sl_gtk_entry_get_text_length (void)
{
   guint16 retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_text_length(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (385, 385, 0);
}

static void sl_g_drive_get_symbolic_icon (void)
{
   GIcon* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_symbolic_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (386, 386, 0);
}

static void sl_gtk_stack_set_visible_child (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_set_visible_child(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (387, 387, 0);
}

static void sl_gdk_cursor_new (void)
{
   GdkCursor* retval;
   GdkCursorType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_new( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (388, 388, 0);
}

static void sl_gtk_radio_menu_item_set_group (void)
{
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_radio_menu_item_set_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (389, 389, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_widget_get_opacity (void)
{
   double retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_opacity(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (390, 390, 0);
}

static void sl_gtk_print_unix_dialog_get_page_setup (void)
{
   GtkPageSetup* retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_page_setup(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (391, 391, 0);
}

static void sl_gtk_widget_set_tooltip_markup (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_tooltip_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (392, 392, 0);
}

static void sl_gtk_level_bar_set_mode (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkLevelBarMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_level_bar_set_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (393, 393, 0);
}

static void sl_gdk_window_get_screen (void)
{
   GdkScreen* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (394, 394, 0);
}

static void sl_gtk_file_chooser_set_filename (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_set_filename(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (395, 395, 0);
}

static void sl_gtk_target_list_ref (void)
{
   GtkTargetList* retval;
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_list_ref(arg1);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (396, 396, 0);
}

static void sl_gtk_gl_area_get_has_alpha (void)
{
   gboolean retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_has_alpha(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (397, 397, 0);
}

static void sl_g_resolver_free_addresses (void)
{
   GList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_resolver_free_addresses(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (398, 398, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_drag_source_set_icon_stock (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_source_set_icon_stock(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (399, 399, 0);
}

static void sl_gtk_file_chooser_set_extra_widget (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_set_extra_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (400, 400, 0);
}

static void sl_pango_context_get_gravity_hint (void)
{
   PangoGravityHint retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_gravity_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (401, 401, 0);
}

static void sl_g_menu_item_get_link (void)
{
   GMenuModel* retval;
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_menu_item_get_link(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (402, 402, 0);
}

static void sl_g_settings_list_keys (void)
{
   gchar** retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_list_keys(arg1);
   push_null_term_str_array (retval, "g_settings_list_keys", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (403, 403, 0);
}

static void sl_pango_attr_list_copy (void)
{
   PangoAttrList* retval;
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_list_copy(arg1);
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (404, 404, 0);
}

static void sl_gtk_recent_manager_move_item (void)
{
   gboolean retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_recent_manager_move_item(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (405, 405, 0);
}

static void sl_pango_attr_background_alpha_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_background_alpha_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (406, 406, 0);
}

static void sl_gtk_print_operation_new (void)
{
   GtkPrintOperation* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (407, 407, 0);
}

static void sl_g_utf8_substring (void)
{
   gchar* retval;
   gchar* arg1;
   glong arg2;
   glong arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_substring(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (408, 408, 0);
}

static void sl_gtk_expander_get_label_fill (void)
{
   gboolean retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_label_fill(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (409, 409, 0);
}

static void sl_gtk_progress_bar_get_pulse_step (void)
{
   gdouble retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_pulse_step(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (410, 410, 0);
}

static void sl_gdk_pixbuf_animation_new_from_stream_finish (void)
{
   GdkPixbufAnimation* retval;
   GAsyncResult* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_animation_new_from_stream_finish(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (411, 411, 0);
}

static void sl_gtk_color_button_new_with_color (void)
{
   GtkWidget* retval;
   GdkColor* arg1 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkColor_Layout)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_new_with_color(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (412, 412, 0);
}

static void sl_gtk_places_sidebar_set_location (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_places_sidebar_set_location(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (413, 413, 0);
}

static void sl_gtk_widget_path_prepend_type (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_prepend_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (414, 414, 0);
}

static void sl_gtk_entry_buffer_set_text (void)
{
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (gint) strlen (arg2);
   gtk_entry_buffer_set_text(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (415, 415, 0);
}

static void sl_gtk_popover_get_position (void)
{
   GtkPositionType retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (416, 416, 0);
}

static void sl_gtk_image_new_from_file (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_file(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (417, 417, 0);
}

static void sl_gtk_accel_group_from_accel_closure (void)
{
   GtkAccelGroup* retval;
   GClosure* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_from_accel_closure(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (418, 418, 0);
}

static void sl_gtk_statusbar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_statusbar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (419, 419, 0);
}

static void sl_gtk_tree_model_row_has_child_toggled (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_row_has_child_toggled(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (420, 420, 0);
}

static void sl_g_utf8_find_next_char (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_utf8_find_next_char(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (421, 421, 0);
}

static void sl_g_settings_schema_key_get_description (void)
{
   const gchar* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_description(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (422, 422, 0);
}

static void sl_gtk_tree_model_iter_parent (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_parent(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (423, 423, 0);
}

static void sl_g_volume_monitor_get_volumes (void)
{
   GList* retval;
   GVolumeMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_monitor_get_volumes(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (424, 424, 0);
}

static void sl_g_hmac_new (void)
{
   GHmac* retval;
   GChecksumType arg1;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hmac_new( arg1, arg2,  arg3);
   (void)SLang_push_opaque(GHmac_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (425, 425, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_object_get_qdata (void)
{
   gpointer retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GQuark arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_get_qdata(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (426, 426, 0);
}

static void sl_pango_units_from_double (void)
{
   int retval;
   double arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_units_from_double( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (427, 427, 0);
}

static void sl_g_file_info_set_size (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   goffset arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_set_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (428, 428, 0);
}

static void sl_gdk_window_set_fullscreen_mode (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkFullscreenMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_fullscreen_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (429, 429, 0);
}

static void sl_g_mount_remount_finish (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mount_remount_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (430, 430, 0);
}

static void sl_gtk_widget_set_visible (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (431, 431, 0);
}

static void sl_gtk_viewport_new (void)
{
   GtkWidget* retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_viewport_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (432, 432, 0);
}

static void sl_g_date_time_to_utc (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_to_utc(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (433, 433, 0);
}

static void sl_gtk_menu_shell_get_selected_item (void)
{
   GtkWidget* retval;
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_shell_get_selected_item(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (434, 434, 0);
}

static void sl_g_main_context_new (void)
{
   GMainContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_new();
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (435, 435, 0);
}

static void sl_gtk_orientable_set_orientation (void)
{
   GtkOrientable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_orientable_set_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (436, 436, 0);
}

static void sl_gtk_toolbar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (437, 437, 0);
}

static void sl_gtk_drag_set_icon_surface (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_surface_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_surface(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (438, 438, 0);
}

static void sl_g_date_new_dmy (void)
{
   GDate* retval;
   GDateDay arg1;
   GDateMonth arg2;
   GDateYear arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_new_dmy( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GDate_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (439, 439, 0);
}

static void sl_gtk_widget_path_iter_has_class (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_class(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (440, 440, 0);
}

static void sl_gdk_pixbuf_composite (void)
{
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   double arg7;
   double arg8;
   double arg9;
   double arg10;
   GdkInterpType arg11;
   int arg12;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 12) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg12)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg11)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg10)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg9)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_pixbuf_composite(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8,  arg9,  arg10,  arg11,  arg12);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (441, 441, 0);
}

static void sl_g_date_set_month (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateMonth arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_month(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (442, 442, 0);
}

static void sl_g_io_channel_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (443, 443, 0);
}

static void sl_gtk_cell_area_get_focus_siblings (void)
{
   const GList* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_get_focus_siblings(arg1, arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (444, 444, 0);
}

static void sl_gtk_entry_completion_set_popup_single_match (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_popup_single_match(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (445, 445, 0);
}

static void sl_gtk_popover_menu_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_menu_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (446, 446, 0);
}

static void sl_gtk_window_set_opacity (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_opacity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (447, 447, 0);
}

static void sl_gtk_tree_model_get_n_columns (void)
{
   gint retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_get_n_columns(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (448, 448, 0);
}

static void sl_gtk_targets_include_rich_text (void)
{
   gboolean retval;
   GdkAtom* arg1;
   Slirp_Ref *arg1_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg1,0x0);
   gint arg2;
   GtkTextBuffer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_targets_include_rich_text(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (449, 449, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_text_buffer_select_range (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_select_range(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (450, 450, 0);
}

static void sl_gdk_gl_context_get_version (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg2,0x0);
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_get_version(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (451, 451, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_tool_shell_get_text_alignment (void)
{
   gfloat retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_text_alignment(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (452, 452, 0);
}

static void sl_gtk_paper_size_copy (void)
{
   GtkPaperSize* retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_copy(arg1);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (453, 453, 0);
}

static void sl_gtk_notebook_get_tab_hborder (void)
{
   guint16 retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_hborder(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (454, 454, 0);
}

static void sl_gtk_window_set_keep_above (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_keep_above(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (455, 455, 0);
}

static void sl_gtk_color_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (456, 456, 0);
}

static void sl_gtk_message_dialog_new_with_markup (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gchar* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg5, NULL)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_5;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_5;
   issue_usage = 0;

   retval = gtk_message_dialog_new_with_markup(arg1,  arg2,  arg3,  arg4, arg5);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_5:
   SLang_free_slstring(arg5);
usage_label:
   if (issue_usage) Slirp_usage (457, 457, 0);
}

static void sl_gtk_gesture_pan_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_pan_new(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (458, 458, 0);
}

static void sl_g_date_valid_dmy (void)
{
   gboolean retval;
   GDateDay arg1;
   GDateMonth arg2;
   GDateYear arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_dmy( arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (459, 459, 0);
}

static void sl_gtk_tree_store_is_ancestor (void)
{
   gboolean retval;
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_store_is_ancestor(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (460, 460, 0);
}

static void sl_gdk_selection_convert (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint32 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_selection_convert(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (461, 461, 0);
}

static void sl_gtk_tree_view_column_get_fixed_width (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_fixed_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (462, 462, 0);
}

static void sl_gtk_tooltip_set_icon (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (463, 463, 0);
}

static void sl_gdk_drag_begin_for_device (void)
{
   GdkDragContext* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GList* arg3;
   Slirp_Ref *arg3_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_drag_begin_for_device(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (464, 464, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_combo_box_text_remove (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_text_remove(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (465, 465, 0);
}

static void sl_gtk_stack_sidebar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_sidebar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (466, 466, 0);
}

static void sl_g_key_file_get_double (void)
{
   gdouble retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_double(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (467, 467, 0);
}

static void sl_gtk_menu_item_set_label (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_item_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (468, 468, 0);
}

static void sl_g_variant_get_variant (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_variant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (469, 469, 0);
}

static void sl_gtk_icon_view_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (470, 470, 0);
}

static void sl_g_socket_close (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_close(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (471, 471, 0);
}

static void sl_gtk_notebook_append_page (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_append_page(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (472, 472, 0);
}

static void sl_g_file_info_clear_status (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_clear_status(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (473, 473, 0);
}

static void sl_g_socket_set_blocking (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_blocking(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (474, 474, 0);
}

static void sl_gtk_entry_set_icon_activatable (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_icon_activatable(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (475, 475, 0);
}

static void sl_g_ascii_strtoll (void)
{
   gint64 retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_strtoll(arg1, arg2,  arg3);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (476, 476, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_widget_path_iter_get_object_name (void)
{
   const char* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_object_name(arg1,  arg2);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (477, 477, 0);
}

static void sl_gtk_label_set_text (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (478, 478, 0);
}

static void sl_pango_cairo_error_underline_path (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   double arg3;
   double arg4;
   double arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_cairo_error_underline_path(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (479, 479, 0);
}

static void sl_g_date_time_to_local (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_to_local(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (480, 480, 0);
}

static void sl_g_file_make_directory_with_parents (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_make_directory_with_parents(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (481, 481, 0);
}

static void sl_gtk_font_chooser_set_show_preview_entry (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_chooser_set_show_preview_entry(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (482, 482, 0);
}

static void sl_gtk_entry_completion_get_model (void)
{
   GtkTreeModel* retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (483, 483, 0);
}

static void sl_g_file_get_uri (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_uri(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (484, 484, 0);
}

static void sl_g_bookmark_file_get_title (void)
{
   gchar* retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_title(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (485, 485, 0);
}

static void sl_gtk_size_group_remove_widget (void)
{
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_size_group_remove_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (486, 486, 0);
}

static void sl_g_variant_get_bytestring_array (void)
{
   const gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_get_bytestring_array(arg1, &arg2);
   (void)SLang_push_opaque(string_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (487, 487, 0);
}

static void sl_gtk_tool_palette_set_exclusive (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_palette_set_exclusive(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (488, 488, 0);
}

static void sl_gtk_widget_get_preferred_width (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_width(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (489, 489, 0);
}

static void sl_pango_font_metrics_get_descent (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_descent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (490, 490, 0);
}

static void sl_gtk_cell_area_context_push_preferred_height (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_push_preferred_height(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (491, 491, 0);
}

static void sl_gdk_drag_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (492, 492, 0);
}

static void sl_gtk_pad_controller_new (void)
{
   GtkPadController* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GActionGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDevice* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_pad_controller_new(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (493, 493, 0);
}

static void sl_g_resolver_get_default (void)
{
   GResolver* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_resolver_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (494, 494, 0);
}

static void sl_g_menu_link_iter_get_value (void)
{
   GMenuModel* retval;
   GMenuLinkIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_link_iter_get_value(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (495, 495, 0);
}

static void sl_gtk_lock_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_lock_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (496, 496, 0);
}

static void sl_gtk_drag_set_icon_default (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_set_icon_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (497, 497, 0);
}

static void sl_gtk_recent_chooser_get_show_private (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_show_private(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (498, 498, 0);
}

static void sl_g_settings_schema_get_key (void)
{
   GSettingsSchemaKey* retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_schema_get_key(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (499, 499, 0);
}

static void sl_g_regex_match_all_full (void)
{
   gboolean retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   gint arg4;
   GRegexMatchFlags arg5;
   GMatchInfo** arg6;
   Slirp_Ref *arg6_r = ref_new(GMatchInfo_Type,sizeof(GMatchInfo*),&arg6,0x0);
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_regex_match_all_full(arg1, arg2,  arg3,  arg4,  arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (500, 500, 0);
   finalize_refs(1,arg6_r); 
}

static void sl_gtk_image_set_pixel_size (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_set_pixel_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (501, 501, 0);
}

static void sl_gtk_frame_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_frame_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (502, 502, 0);
}

static void sl_pango_attr_list_update (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_attr_list_update(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (503, 503, 0);
}

static void sl_gtk_box_get_baseline_position (void)
{
   GtkBaselinePosition retval;
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_get_baseline_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (504, 504, 0);
}

static void sl_gtk_label_get_layout (void)
{
   PangoLayout* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (505, 505, 0);
}

static void sl_gdk_selection_owner_get_for_display (void)
{
   GdkWindow* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_selection_owner_get_for_display(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (506, 506, 0);
}

static void sl_gtk_entry_set_icon_drag_source (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   GtkTargetList* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkDragAction arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_drag_source(arg1,  arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (507, 507, 0);
}

static void sl_gtk_stack_get_transition_running (void)
{
   gboolean retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_transition_running(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (508, 508, 0);
}

static void sl_g_key_file_get_locale_string_list (void)
{
   gchar** retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   gsize arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg4, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   arg6 = NULL;
   retval = g_key_file_get_locale_string_list(arg1, arg2, arg3, arg4, &arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   push_null_term_str_array (retval, "g_key_file_get_locale_string_list", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (509, 509, 0);
}

static void sl_gtk_file_chooser_select_file (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_select_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (510, 510, 0);
}

static void sl_g_file_copy_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_copy_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (511, 511, 0);
}

static void sl_g_variant_get_boolean (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_boolean(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (512, 512, 0);
}

static void sl_gtk_actionable_get_action_name (void)
{
   const gchar* retval;
   GtkActionable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_actionable_get_action_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (513, 513, 0);
}

static void sl_gtk_tool_item_get_text_size_group (void)
{
   GtkSizeGroup* retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_text_size_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (514, 514, 0);
}

static void sl_gtk_invisible_new_for_screen (void)
{
   GtkWidget* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_invisible_new_for_screen(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (515, 515, 0);
}

static void sl_g_settings_schema_key_get_summary (void)
{
   const gchar* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_summary(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (516, 516, 0);
}

static void sl_gtk_recent_chooser_menu_get_show_numbers (void)
{
   gboolean retval;
   GtkRecentChooserMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_menu_get_show_numbers(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (517, 517, 0);
}

static void sl_gdk_window_scroll (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_scroll(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (518, 518, 0);
}

static void sl_gdk_visual_get_bits_per_rgb (void)
{
   gint retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_bits_per_rgb(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (519, 519, 0);
}

static void sl_g_file_replace_readwrite_finish (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_replace_readwrite_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (520, 520, 0);
}

static void sl_g_drive_can_eject (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_can_eject(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (521, 521, 0);
}

static void sl_g_variant_new_int32 (void)
{
   GVariant* retval;
   gint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_int32( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (522, 522, 0);
}

static void sl_gdk_window_thaw_toplevel_updates_libgtk_only (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_thaw_toplevel_updates_libgtk_only(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (523, 523, 0);
}

static void sl_gdk_pixbuf_new_from_file_at_scale (void)
{
   GdkPixbuf* retval;
   char* arg1;
   int arg2;
   int arg3;
   gboolean arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg5 = NULL;
   retval = gdk_pixbuf_new_from_file_at_scale(arg1,  arg2,  arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (524, 524, 0);
}

static void sl_g_param_spec_ref (void)
{
   GParamSpec* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (525, 525, 0);
}

static void sl_g_key_file_has_key (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_has_key(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (526, 526, 0);
}

static void sl_gtk_app_chooser_dialog_new_for_content_type (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDialogFlags arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_app_chooser_dialog_new_for_content_type(arg1,  arg2, arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (527, 527, 0);
}

static void sl_g_source_get_can_recurse (void)
{
   gboolean retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_can_recurse(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (528, 528, 0);
}

static void sl_gtk_entry_get_progress_pulse_step (void)
{
   gdouble retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_progress_pulse_step(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (529, 529, 0);
}

static void sl_gtk_menu_item_set_reserve_indicator (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_set_reserve_indicator(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (530, 530, 0);
}

static void sl_g_variant_parser_get_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_variant_parser_get_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (531, 531, 0);
}

static void sl_g_match_info_fetch_all (void)
{
   gchar** retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_fetch_all(arg1);
   push_null_term_str_array (retval, "g_match_info_fetch_all", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (532, 532, 0);
}

static void sl_gtk_link_button_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_link_button_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (533, 533, 0);
}

static void sl_g_strndup (void)
{
   gchar* retval;
   gchar* arg1;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strndup(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (534, 534, 0);
}

static void sl_gtk_expander_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (535, 535, 0);
}

static void sl_gtk_combo_box_popup (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_popup(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (536, 536, 0);
}

static void sl_g_cancellable_new (void)
{
   GCancellable* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (537, 537, 0);
}

static void sl_gtk_tree_selection_select_all (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_selection_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (538, 538, 0);
}

static void sl_gtk_gesture_pan_set_orientation (void)
{
   GtkGesturePan* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gesture_pan_set_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (539, 539, 0);
}

static void sl_gtk_icon_view_get_selection_mode (void)
{
   GtkSelectionMode retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_selection_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (540, 540, 0);
}

static void sl_g_network_service_new (void)
{
   GSocketConnectable* retval;
   gchar* arg1;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_network_service_new(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (541, 541, 0);
}

static void sl_pango_font_description_from_string (void)
{
   PangoFontDescription* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_from_string(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (542, 542, 0);
}

static void sl_gtk_tree_view_set_search_entry (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntry* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_search_entry(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (543, 543, 0);
}

static void sl_gtk_dialog_add_action_widget (void)
{
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_dialog_add_action_widget(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (544, 544, 0);
}

static void sl_gtk_editable_copy_clipboard (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_copy_clipboard(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (545, 545, 0);
}

static void sl_g_menu_attribute_iter_get_next (void)
{
   gboolean retval;
   GMenuAttributeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GVariant** arg3;
   Slirp_Ref *arg3_r = ref_new(GVariant_Type,sizeof(GVariant*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_attribute_iter_get_next(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (546, 546, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gdk_screen_get_n_monitors (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_n_monitors(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (547, 547, 0);
}

static void sl_g_menu_model_iterate_item_links (void)
{
   GMenuLinkIter* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_model_iterate_item_links(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (548, 548, 0);
}

static void sl_gtk_builder_new_from_string (void)
{
   GtkBuilder* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_new_from_string(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (549, 549, 0);
}

static void sl_gtk_print_settings_unset (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_unset(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (550, 550, 0);
}

static void sl_pango_font_description_get_set_fields (void)
{
   PangoFontMask retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_set_fields(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (551, 551, 0);
}

static void sl_gtk_statusbar_push (void)
{
   guint retval;
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_statusbar_push(arg1,  arg2, arg3);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (552, 552, 0);
}

static void sl_gtk_box_pack_end (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   guint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_pack_end(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (553, 553, 0);
}

static void sl_gtk_style_context_set_state (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_set_state(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (554, 554, 0);
}

static void sl_gtk_menu_item_get_right_justified (void)
{
   gboolean retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_right_justified(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (555, 555, 0);
}

static void sl_gtk_window_set_focus_visible (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_focus_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (556, 556, 0);
}

static void sl_gtk_tool_palette_get_expand (void)
{
   gboolean retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_palette_get_expand(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (557, 557, 0);
}

static void sl_g_file_get_relative_path (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_get_relative_path(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (558, 558, 0);
}

static void sl_gtk_toggle_tool_button_get_active (void)
{
   gboolean retval;
   GtkToggleToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_tool_button_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (559, 559, 0);
}

static void sl_gtk_clipboard_get_owner (void)
{
   GObject* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get_owner(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (560, 560, 0);
}

static void sl_gtk_menu_button_set_align_widget (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_button_set_align_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (561, 561, 0);
}

static void sl_gtk_tree_view_get_hover_selection (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_hover_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (562, 562, 0);
}

static void sl_gtk_text_iter_forward_visible_cursor_position (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_cursor_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (563, 563, 0);
}

static void sl_gtk_search_entry_handle_event (void)
{
   gboolean retval;
   GtkSearchEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_search_entry_handle_event(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (564, 564, 0);
}

static void sl_pango_context_get_font_description (void)
{
   PangoFontDescription* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_font_description(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (565, 565, 0);
}

static void sl_gtk_widget_get_toplevel (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_toplevel(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (566, 566, 0);
}

static void sl_gtk_adjustment_get_value (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (567, 567, 0);
}

static void sl_gtk_dialog_get_response_for_widget (void)
{
   gint retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_dialog_get_response_for_widget(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (568, 568, 0);
}

static void sl_gtk_text_buffer_get_selection_bound (void)
{
   GtkTextMark* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_selection_bound(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (569, 569, 0);
}

static void sl_gtk_print_unix_dialog_add_custom_tab (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_unix_dialog_add_custom_tab(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (570, 570, 0);
}

static void sl_pango_layout_set_text (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (int) strlen (arg2);
   pango_layout_set_text(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (571, 571, 0);
}

static void sl_gtk_list_store_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_store_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (572, 572, 0);
}

static void sl_gtk_size_group_get_mode (void)
{
   GtkSizeGroupMode retval;
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_size_group_get_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (573, 573, 0);
}

static void sl_gtk_native_dialog_hide (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_native_dialog_hide(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (574, 574, 0);
}

static void sl_gtk_image_get_storage_type (void)
{
   GtkImageType retval;
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_get_storage_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (575, 575, 0);
}

static void sl_gtk_drag_cancel (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_cancel(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (576, 576, 0);
}

static void sl_gdk_window_show_unraised (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_show_unraised(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (577, 577, 0);
}

static void sl_gdk_pixbuf_new_from_resource (void)
{
   GdkPixbuf* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_new_from_resource(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (578, 578, 0);
}

static void sl_gtk_print_settings_set_finishings (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_finishings(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (579, 579, 0);
}

static void sl_gtk_radio_tool_button_new_from_stock (void)
{
   GtkToolItem* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_tool_button_new_from_stock(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (580, 580, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_offscreen_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_offscreen_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (581, 581, 0);
}

static void sl_g_filename_display_name (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_filename_display_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (582, 582, 0);
}

static void sl_gtk_gl_area_set_required_version (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_required_version(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (583, 583, 0);
}

static void sl_gtk_accessible_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accessible_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (584, 584, 0);
}

static void sl_g_flags_to_string (void)
{
   gchar* retval;
   GType arg1;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_flags_to_string( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (585, 585, 0);
}

static void sl_g_bytes_icon_get_bytes (void)
{
   GBytes* retval;
   GBytesIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_bytes_icon_get_bytes(arg1);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (586, 586, 0);
}

static void sl_gtk_gesture_drag_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_drag_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (587, 587, 0);
}

static void sl_gtk_icon_view_get_path_at_pos (void)
{
   GtkTreePath* retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_path_at_pos(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (588, 588, 0);
}

static void sl_gtk_tree_view_set_tooltip_row (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTooltip* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_tooltip_row(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (589, 589, 0);
}

static void sl_gtk_overlay_reorder_overlay (void)
{
   GtkOverlay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_overlay_reorder_overlay(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (590, 590, 0);
}

static void sl_g_strdup_value_contents (void)
{
   gchar* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_strdup_value_contents(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (591, 591, 0);
}

static void sl_gtk_print_settings_get_double (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_double(arg1, arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (592, 592, 0);
}

static void sl_gtk_label_set_markup_with_mnemonic (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_markup_with_mnemonic(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (593, 593, 0);
}

static void sl_gtk_menu_item_set_right_justified (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_set_right_justified(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (594, 594, 0);
}

static void sl_gtk_combo_box_get_row_span_column (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_row_span_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (595, 595, 0);
}

static void sl_gtk_widget_path_iter_remove_region (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_remove_region(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (596, 596, 0);
}

static void sl_g_menu_item_set_label (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (597, 597, 0);
}

static void sl_pango_context_changed (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_context_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (598, 598, 0);
}

static void sl_g_file_set_contents (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   gssize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_set_contents(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (599, 599, 0);
}

static void sl_gtk_separator_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (600, 600, 0);
}

static void sl_g_utf8_strdown (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strdown(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (601, 601, 0);
}

static void sl_gtk_tree_view_convert_bin_window_to_widget_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_bin_window_to_widget_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (602, 602, 0);
}

static void sl_gdk_pixbuf_loader_new (void)
{
   GdkPixbufLoader* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_loader_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (603, 603, 0);
}

static void sl_gtk_text_buffer_insert_interactive_at_cursor (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (gint) strlen (arg2);
   retval = gtk_text_buffer_insert_interactive_at_cursor(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (604, 604, 0);
}

static void sl_gtk_tool_palette_set_group_position (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_palette_set_group_position(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (605, 605, 0);
}

static void sl_g_type_check_instance (void)
{
   gboolean retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_instance(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (606, 606, 0);
}

static void sl_g_variant_type_element (void)
{
   const GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_element(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (607, 607, 0);
}

static void sl_g_inet_address_get_native_size (void)
{
   gsize retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_native_size(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (608, 608, 0);
}

static void sl_g_variant_get_string (void)
{
   const gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_get_string(arg1, &arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (609, 609, 0);
}

static void sl_gtk_volume_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_volume_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (610, 610, 0);
}

static void sl_gtk_entry_get_buffer (void)
{
   GtkEntryBuffer* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_buffer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (611, 611, 0);
}

static void sl_gtk_print_job_get_settings (void)
{
   GtkPrintSettings* retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_settings(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (612, 612, 0);
}

static void sl_gtk_combo_box_get_active_iter (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   retval = gtk_combo_box_get_active_iter(arg1, arg2);
   if (retval)
      (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   else
      {
         SLfree ((char *) arg2);
         (void) SLang_push_null ();
      }
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (613, 613, 0);
}

static void sl_gtk_widget_get_app_paintable (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_app_paintable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (614, 614, 0);
}

static void sl_gtk_button_box_set_layout (void)
{
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkButtonBoxStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_box_set_layout(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (615, 615, 0);
}

static void sl_gtk_widget_path_length (void)
{
   gint retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_length(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (616, 616, 0);
}

static void sl_gtk_app_chooser_widget_set_show_recommended (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_widget_set_show_recommended(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (617, 617, 0);
}

static void sl_gtk_text_iter_backward_char (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_char(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (618, 618, 0);
}

static void sl_g_proxy_address_get_protocol (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_protocol(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (619, 619, 0);
}

static void sl_gtk_font_chooser_set_font_desc (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_chooser_set_font_desc(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (620, 620, 0);
}

static void sl_gtk_gesture_group (void)
{
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkGesture* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_gesture_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (621, 621, 0);
}

static void sl_gtk_accelerator_set_default_mod_mask (void)
{
   GdkModifierType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accelerator_set_default_mod_mask( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (622, 622, 0);
}

static void sl_gdk_window_get_children (void)
{
   GList* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_children(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (623, 623, 0);
}

static void sl_gtk_text_buffer_cut_clipboard (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkClipboard* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_cut_clipboard(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (624, 624, 0);
}

static void sl_gtk_statusbar_get_message_area (void)
{
   GtkWidget* retval;
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_statusbar_get_message_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (625, 625, 0);
}

static void sl_gtk_fixed_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_fixed_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (626, 626, 0);
}

static void sl_gdk_window_attributes_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_attributes_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (627, 627, 0);
}

static void sl_g_proxy_address_get_username (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_username(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (628, 628, 0);
}

static void sl_gtk_text_buffer_apply_tag (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_apply_tag(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (629, 629, 0);
}

static void sl_gtk_widget_has_screen (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_has_screen(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (630, 630, 0);
}

static void sl_gdk_window_set_user_data (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_user_data(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (631, 631, 0);
}

static void sl_gtk_accel_label_set_accel_widget (void)
{
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_accel_label_set_accel_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (632, 632, 0);
}

static void sl_pango_layout_get_unknown_glyphs_count (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_unknown_glyphs_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (633, 633, 0);
}

static void sl_gdk_screen_get_root_window (void)
{
   GdkWindow* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_root_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (634, 634, 0);
}

static void sl_gdk_screen_get_height_mm (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_height_mm(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (635, 635, 0);
}

static void sl_g_get_user_data_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_data_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (636, 636, 0);
}

static void sl_gtk_scrolled_window_get_placement (void)
{
   GtkCornerType retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_placement(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (637, 637, 0);
}

static void sl_gtk_tree_row_reference_inserted (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_row_reference_inserted(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (638, 638, 0);
}

static void sl_gtk_text_view_set_monospace (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_monospace(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (639, 639, 0);
}

static void sl_g_inet_address_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (640, 640, 0);
}

static void sl_g_file_info_get_sort_order (void)
{
   gint32 retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_sort_order(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (641, 641, 0);
}

static void sl_g_variant_ref (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_ref(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (642, 642, 0);
}

static void sl_gtk_combo_box_get_has_entry (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_has_entry(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (643, 643, 0);
}

static void sl_gtk_popover_set_modal (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_set_modal(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (644, 644, 0);
}

static void sl_gtk_tree_view_convert_tree_to_bin_window_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_tree_to_bin_window_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (645, 645, 0);
}

static void sl_gtk_font_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (646, 646, 0);
}

static void sl_gtk_tool_item_group_get_label (void)
{
   const gchar* retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (647, 647, 0);
}

static void sl_gtk_widget_set_direction (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextDirection arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_direction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (648, 648, 0);
}

static void sl_gtk_tree_view_column_set_spacing (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (649, 649, 0);
}

static void sl_gtk_combo_box_text_insert_text (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_combo_box_text_insert_text(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (650, 650, 0);
}

static void sl_gtk_accelerator_name_with_keycode (void)
{
   gchar* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   GdkModifierType arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_name_with_keycode(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (651, 651, 0);
}

static void sl_pango_layout_iter_copy (void)
{
   PangoLayoutIter* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_copy(arg1);
   (void)SLang_push_opaque(PangoLayoutIter_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (652, 652, 0);
}

static void sl_gtk_widget_set_can_focus (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_can_focus(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (653, 653, 0);
}

static void sl_g_dir_make_tmp (void)
{
   gchar* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_dir_make_tmp(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (654, 654, 0);
}

static void sl_gdk_screen_get_font_options (void)
{
   const cairo_font_options_t* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_font_options(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (655, 655, 0);
}

static void sl_gtk_menu_get_accel_group (void)
{
   GtkAccelGroup* retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_accel_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (656, 656, 0);
}

static void sl_gtk_entry_grab_focus_without_selecting (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_grab_focus_without_selecting(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (657, 657, 0);
}

static void sl_g_socket_get_timeout (void)
{
   guint retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_timeout(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (658, 658, 0);
}

static void sl_g_regex_match (void)
{
   gboolean retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GRegexMatchFlags arg3;
   GMatchInfo** arg4;
   Slirp_Ref *arg4_r = ref_new(GMatchInfo_Type,sizeof(GMatchInfo*),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_match(arg1, arg2,  arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (659, 659, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gdk_pango_context_get (void)
{
   PangoContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pango_context_get();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (660, 660, 0);
}

static void sl_gtk_layout_put (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_layout_put(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (661, 661, 0);
}

static void sl_gtk_icon_info_load_surface (void)
{
   cairo_surface_t* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_icon_info_load_surface(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (662, 662, 0);
}

static void sl_g_file_info_get_attribute_stringv (void)
{
   char** retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_stringv(arg1, arg2);
   push_null_term_str_array (retval, "g_file_info_get_attribute_stringv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (663, 663, 0);
}

static void sl_gtk_scrolled_window_new (void)
{
   GtkWidget* retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_scrolled_window_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (664, 664, 0);
}

static void sl_gdk_rgba_copy (void)
{
   GdkRGBA* retval;
   GdkRGBA* arg1 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkRGBA_Layout)) goto usage_label;
   issue_usage = 0;

   retval = gdk_rgba_copy(arg1);
   (void)SLang_push_struct(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (665, 665, 0);
}

static void sl_g_file_make_symbolic_link (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_make_symbolic_link(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (666, 666, 0);
}

static void sl_gtk_entry_text_index_to_layout_index (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_text_index_to_layout_index(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (667, 667, 0);
}

static void sl_gtk_buildable_get_name (void)
{
   const gchar* retval;
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_buildable_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (668, 668, 0);
}

static void sl_g_app_launch_context_setenv (void)
{
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_app_launch_context_setenv(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (669, 669, 0);
}

static void sl_gtk_tree_view_column_get_max_width (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_max_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (670, 670, 0);
}

static void sl_gtk_render_icon_surface (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   cairo_surface_t* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_icon_surface(arg1, arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (671, 671, 0);
}

static void sl_g_menu_item_set_detailed_action (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_detailed_action(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (672, 672, 0);
}

static void sl_gtk_menu_place_on_monitor (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkMonitor* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_place_on_monitor(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (673, 673, 0);
}

static void sl_gtk_tree_view_column_new_with_area (void)
{
   GtkTreeViewColumn* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_new_with_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (674, 674, 0);
}

static void sl_gtk_widget_get_allocated_size (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_allocated_size(arg1, arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GtkAllocation_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (675, 675, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_drag_check_threshold (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_drag_check_threshold(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (676, 676, 0);
}

static void sl_gtk_tool_item_set_visible_horizontal (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_visible_horizontal(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (677, 677, 0);
}

static void sl_pango_layout_set_font_description (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_layout_set_font_description(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (678, 678, 0);
}

static void sl_gtk_fixed_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_fixed_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (679, 679, 0);
}

static void sl_g_date_time_get_ymd (void)
{
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_time_get_ymd(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (680, 680, 0);
   finalize_refs(3,arg2_r,arg3_r,arg4_r); 
}

static void sl_g_type_check_class_is_a (void)
{
   gboolean retval;
   GTypeClass* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_class_is_a(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (681, 681, 0);
}

static void sl_gdk_pango_context_get_for_display (void)
{
   PangoContext* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pango_context_get_for_display(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (682, 682, 0);
}

static void sl_pango_attr_weight_new (void)
{
   PangoAttribute* retval;
   PangoWeight arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_weight_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (683, 683, 0);
}

static void sl_gtk_tree_view_column_queue_resize (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_queue_resize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (684, 684, 0);
}

static void sl_gtk_menu_detach (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_detach(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (685, 685, 0);
}

static void sl_gtk_text_iter_set_offset (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_offset(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (686, 686, 0);
}

static void sl_gtk_tool_item_group_set_label_widget (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_group_set_label_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (687, 687, 0);
}

static void sl_g_proxy_address_new (void)
{
   GSocketAddress* retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint16 arg2;
   gchar* arg3;
   gchar* arg4;
   guint16 arg5;
   gchar* arg6;
   gchar* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg7)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg6)) goto free_and_return_7;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_6;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_proxy_address_new(arg1,  arg2, arg3, arg4,  arg5, arg6, arg7);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_6:
   SLang_free_slstring(arg6);
free_and_return_7:
   SLang_free_slstring(arg7);
usage_label:
   if (issue_usage) Slirp_usage (688, 688, 0);
}

static void sl_gdk_seat_get_keyboard (void)
{
   GdkDevice* retval;
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_keyboard(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (689, 689, 0);
}

static void sl_gtk_calendar_select_month (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_select_month(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (690, 690, 0);
}

static void sl_gtk_list_box_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (691, 691, 0);
}

static void sl_gdk_events_pending (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_events_pending();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (692, 692, 0);
}

static void sl_gdk_visual_get_best_type (void)
{
   GdkVisualType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best_type();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (693, 693, 0);
}

static void sl_gtk_spin_button_set_value (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (694, 694, 0);
}

static void sl_g_gtype_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_gtype_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (695, 695, 0);
}

static void sl_g_variant_type_is_array (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_array(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (696, 696, 0);
}

static void sl_gtk_popover_bind_model (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_popover_bind_model(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (697, 697, 0);
}

static void sl_g_cancellable_get_fd (void)
{
   int retval;
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_get_fd(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (698, 698, 0);
}

static void sl_g_file_replace_contents_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_replace_contents_finish(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (699, 699, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_pango_layout_iter_get_line (void)
{
   PangoLayoutLine* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_line(arg1);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (700, 700, 0);
}

static void sl_gtk_progress_bar_set_text (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_progress_bar_set_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (701, 701, 0);
}

static void sl_gtk_cell_renderer_set_sensitive (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_set_sensitive(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (702, 702, 0);
}

static void sl_gdk_screen_get_monitor_width_mm (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_width_mm(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (703, 703, 0);
}

static void sl_gtk_adjustment_set_value (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (704, 704, 0);
}

static void sl_g_inet_address_mask_matches (void)
{
   gboolean retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_inet_address_mask_matches(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (705, 705, 0);
}

static void sl_gtk_tree_view_convert_tree_to_widget_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_tree_to_widget_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (706, 706, 0);
}

static void sl_gtk_cell_renderer_toggle_get_radio (void)
{
   gboolean retval;
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_toggle_get_radio(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (707, 707, 0);
}

static void sl_gtk_recent_info_create_app_info (void)
{
   GAppInfo* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_recent_info_create_app_info(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (708, 708, 0);
}

static void sl_gtk_tree_view_column_get_visible (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (709, 709, 0);
}

static void sl_gtk_flow_box_child_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_child_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (710, 710, 0);
}

static void sl_g_filename_completer_get_completion_suffix (void)
{
   char* retval;
   GFilenameCompleter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_filename_completer_get_completion_suffix(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (711, 711, 0);
}

static void sl_gtk_target_table_free (void)
{
   GtkTargetEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_table_free(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (712, 712, 0);
}

static void sl_gdk_event_mask_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_mask_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (713, 713, 0);
}

static void sl_g_source_unref (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_source_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (714, 714, 0);
}

static void sl_gdk_window_set_opaque_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_opaque_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (715, 715, 0);
}

static void sl_gtk_editable_set_editable (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_set_editable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (716, 716, 0);
}

static void sl_g_type_free_instance (void)
{
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_type_free_instance(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (717, 717, 0);
}

static void sl_g_strdelimit (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gchar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strdelimit(arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (718, 718, 0);
}

static void sl_gdk_window_freeze_updates (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_freeze_updates(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (719, 719, 0);
}

static void sl_gtk_info_bar_set_default_response (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_set_default_response(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (720, 720, 0);
}

static void sl_gtk_icon_view_get_margin (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_margin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (721, 721, 0);
}

static void sl_gdk_device_pad_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (722, 722, 0);
}

static void sl_g_proxy_address_get_destination_protocol (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_destination_protocol(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (723, 723, 0);
}

static void sl_gtk_app_chooser_button_set_show_default_item (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_button_set_show_default_item(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (724, 724, 0);
}

static void sl_g_variant_new_bytestring (void)
{
   GVariant* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_bytestring(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (725, 725, 0);
}

static void sl_gtk_calendar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (726, 726, 0);
}

static void sl_gdk_window_maximize (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_maximize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (727, 727, 0);
}

static void sl_gtk_text_iter_equal (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (728, 728, 0);
}

static void sl_g_file_get_parent (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_parent(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (729, 729, 0);
}

static void sl_gtk_recent_manager_new (void)
{
   GtkRecentManager* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_manager_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (730, 730, 0);
}

static void sl_gtk_toolbar_get_show_arrow (void)
{
   gboolean retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_show_arrow(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (731, 731, 0);
}

static void sl_pango_attr_list_change (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttribute* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_attr_list_change(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (732, 732, 0);
}

static void sl_gdk_drag_abort (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drag_abort(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (733, 733, 0);
}

static void sl_gtk_tree_view_set_tooltip_column (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_tooltip_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (734, 734, 0);
}

static void sl_gtk_notebook_get_nth_page (void)
{
   GtkWidget* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_nth_page(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (735, 735, 0);
}

static void sl_g_file_info_set_attribute_stringv (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_stringv(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (736, 736, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_expander_get_expanded (void)
{
   gboolean retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_expanded(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (737, 737, 0);
}

static void sl_gtk_paper_size_set_size (void)
{
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   GtkUnit arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_paper_size_set_size(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (738, 738, 0);
}

static void sl_gtk_target_list_add (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_target_list_add(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (739, 739, 0);
}

static void sl_gtk_css_section_get_start_line (void)
{
   guint retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_start_line(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (740, 740, 0);
}

static void sl_pango_font_has_char (void)
{
   gboolean retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gunichar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_has_char(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (741, 741, 0);
}

static void sl_gtk_recent_info_match (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRecentInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_info_match(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (742, 742, 0);
}

static void sl_g_variant_builder_unref (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_variant_builder_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (743, 743, 0);
}

static void sl_pango_attr_variant_new (void)
{
   PangoAttribute* retval;
   PangoVariant arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_variant_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (744, 744, 0);
}

static void sl_gtk_label_set_xalign (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_xalign(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (745, 745, 0);
}

static void sl_g_utf8_to_ucs4_fast (void)
{
   gunichar* retval;
   gchar* arg1;
   glong arg2;
   glong arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_utf8_to_ucs4_fast(arg1,  arg2, &arg3);
   (void)SLang_push_opaque(uint_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (746, 746, 0);
}

static void sl_gtk_widget_path_iter_list_regions (void)
{
   GSList* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_list_regions(arg1,  arg2);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (747, 747, 0);
}

static void sl_gtk_text_buffer_set_modified (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_buffer_set_modified(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (748, 748, 0);
}

static void sl_gtk_window_unmaximize (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_unmaximize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (749, 749, 0);
}

static void sl_gdk_gl_error_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_error_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (750, 750, 0);
}

static void sl_gtk_tool_palette_get_icon_size (void)
{
   GtkIconSize retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_icon_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (751, 751, 0);
}

static void sl_gdk_keyval_to_unicode (void)
{
   guint32 retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_to_unicode( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (752, 752, 0);
}

static void sl_gtk_flow_box_set_homogeneous (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (753, 753, 0);
}

static void sl_g_socket_bind (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSocketAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_socket_bind(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (754, 754, 0);
}

static void sl_g_mount_operation_new (void)
{
   GMountOperation* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (755, 755, 0);
}

static void sl_gtk_page_setup_new (void)
{
   GtkPageSetup* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (756, 756, 0);
}

static void sl_pango_font_description_set_family_static (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_set_family_static(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (757, 757, 0);
}

static void sl_gdk_keymap_get_default (void)
{
   GdkKeymap* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_default();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (758, 758, 0);
}

static void sl_g_timer_elapsed (void)
{
   gdouble retval;
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_timer_elapsed(arg1, &arg2);
   (void)SLang_push_double(retval);
   (void)SLang_push_ulong(arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (759, 759, 0);
}

static void sl_gtk_native_dialog_get_visible (void)
{
   gboolean retval;
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_native_dialog_get_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (760, 760, 0);
}

static void sl_gtk_menu_shell_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_shell_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (761, 761, 0);
}

static void sl_g_resource_ref (void)
{
   GResource* retval;
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_resource_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (762, 762, 0);
}

static void sl_g_file_start_mountable_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_start_mountable_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (763, 763, 0);
}

static void sl_g_menu_insert_section (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   GMenuModel* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_menu_insert_section(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (764, 764, 0);
}

static void sl_gtk_gesture_is_active (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_is_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (765, 765, 0);
}

static void sl_gtk_printer_is_accepting_jobs (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_is_accepting_jobs(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (766, 766, 0);
}

static void sl_gtk_widget_get_margin_top (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_top(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (767, 767, 0);
}

static void sl_gtk_font_button_set_use_font (void)
{
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_button_set_use_font(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (768, 768, 0);
}

static void sl_gdk_window_set_support_multidevice (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_support_multidevice(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (769, 769, 0);
}

static void sl_g_date_add_years (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_add_years(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (770, 770, 0);
}

static void sl_g_notification_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_notification_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (771, 771, 0);
}

static void sl_gtk_paper_size_get_default_left_margin (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_default_left_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (772, 772, 0);
}

static void sl_gdk_visual_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (773, 773, 0);
}

static void sl_gtk_tree_iter_free (void)
{
   GtkTreeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_iter_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (774, 774, 0);
}

static void sl_g_param_spec_internal (void)
{
   gpointer retval;
   GType arg1;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   GParamFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_spec_internal( arg1, arg2, arg3, arg4,  arg5);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (775, 775, 0);
}

static void sl_gdk_pango_context_get_for_screen (void)
{
   PangoContext* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pango_context_get_for_screen(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (776, 776, 0);
}

static void sl_gdk_pixbuf_loader_get_animation (void)
{
   GdkPixbufAnimation* retval;
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_loader_get_animation(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (777, 777, 0);
}

static void sl_g_param_spec_pool_list_owned (void)
{
   GList* retval;
   GParamSpecPool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_pool_list_owned(arg1,  arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (778, 778, 0);
}

static void sl_pango_language_matches (void)
{
   gboolean retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_language_matches(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (779, 779, 0);
}

static void sl_gdk_get_program_class (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_get_program_class();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (780, 780, 0);
}

static void sl_g_bookmark_file_set_icon (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_icon(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (781, 781, 0);
}

static void sl_gtk_notebook_set_menu_label_text (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_menu_label_text(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (782, 782, 0);
}

static void sl_gtk_print_settings_to_gvariant (void)
{
   GVariant* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_to_gvariant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (783, 783, 0);
}

static void sl_gtk_tree_view_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (784, 784, 0);
}

static void sl_g_io_channel_get_buffered (void)
{
   gboolean retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_buffered(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (785, 785, 0);
}

static void sl_gtk_scrolled_window_get_vscrollbar (void)
{
   GtkWidget* retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_vscrollbar(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (786, 786, 0);
}

static void sl_gtk_label_get_layout_offsets (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_get_layout_offsets(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (787, 787, 0);
}

static void sl_gtk_print_settings_get_quality (void)
{
   GtkPrintQuality retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_quality(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (788, 788, 0);
}

static void sl_gtk_text_iter_backward_to_tag_toggle (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_backward_to_tag_toggle(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (789, 789, 0);
}

static void sl_gtk_css_provider_load_from_path (void)
{
   gboolean retval;
   GtkCssProvider* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_css_provider_load_from_path(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (790, 790, 0);
}

static void sl_gtk_app_chooser_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (791, 791, 0);
}

static void sl_gdk_device_get_associated_device (void)
{
   GdkDevice* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_associated_device(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (792, 792, 0);
}

static void sl_gdk_event_get_scancode (void)
{
   int retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_scancode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (793, 793, 0);
}

static void sl_gtk_combo_box_get_active (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (794, 794, 0);
}

static void sl_g_rand_double_range (void)
{
   gdouble retval;
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_double_range(arg1,  arg2,  arg3);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (795, 795, 0);
}

static void sl_gtk_container_get_border_width (void)
{
   guint retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_border_width(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (796, 796, 0);
}

static void sl_gtk_flow_box_get_selected_children (void)
{
   GList* retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_selected_children(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (797, 797, 0);
}

static void sl_gtk_printer_is_paused (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_is_paused(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (798, 798, 0);
}

static void sl_gtk_text_iter_get_visible_text (void)
{
   gchar* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_get_visible_text(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (799, 799, 0);
}

static void sl_gdk_window_begin_paint_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_begin_paint_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (800, 800, 0);
}

static void sl_gtk_print_unix_dialog_get_embed_page_setup (void)
{
   gboolean retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_embed_page_setup(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (801, 801, 0);
}

static void sl_g_date_time_new_now_utc (void)
{
   GDateTime* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_now_utc();
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (802, 802, 0);
}

static void sl_g_emblem_new (void)
{
   GEmblem* retval;
   GIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblem_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (803, 803, 0);
}

static void sl_gtk_scale_get_draw_value (void)
{
   gboolean retval;
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_draw_value(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (804, 804, 0);
}

static void sl_g_type_interface_get_plugin (void)
{
   GTypePlugin* retval;
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_interface_get_plugin( arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (805, 805, 0);
}

static void sl_g_variant_dup_objv (void)
{
   gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_dup_objv(arg1, &arg2);
   push_null_term_str_array (retval, "g_variant_dup_objv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (806, 806, 0);
}

static void sl_gtk_tool_item_set_homogeneous (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (807, 807, 0);
}

static void sl_gtk_cell_renderer_get_preferred_width_for_height (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_preferred_width_for_height(arg1, arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (808, 808, 0);
}

static void sl_gtk_target_list_remove (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_target_list_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (809, 809, 0);
}

static void sl_gtk_font_chooser_get_level (void)
{
   GtkFontChooserLevel retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_level(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (810, 810, 0);
}

static void sl_gtk_widget_set_accel_path (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkAccelGroup* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_accel_path(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (811, 811, 0);
}

static void sl_gtk_print_settings_set_page_set (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSet arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_page_set(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (812, 812, 0);
}

static void sl_gtk_widget_override_color (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg3, (void**)GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_override_color(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (813, 813, 0);
}

static void sl_gdk_window_get_origin (void)
{
   gint retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_origin(arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (814, 814, 0);
}

static void sl_gtk_menu_get_for_attach_widget (void)
{
   const GList* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_for_attach_widget(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (815, 815, 0);
}

static void sl_gtk_menu_reposition (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_reposition(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (816, 816, 0);
}

static void sl_gdk_pixbuf_save_to_streamv (void)
{
   gboolean retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GOutputStream* arg2;
   Slirp_Opaque* arg2_o = NULL;
   char* arg3;
   char** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg4,0x0);
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   GCancellable* arg6;
   Slirp_Opaque* arg6_o = NULL;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg6, &arg6_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto free_and_return_6;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto free_and_return_6;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = gdk_pixbuf_save_to_streamv(arg1, arg2, arg3, arg4, arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_6:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (817, 817, 0);
   finalize_refs(2,arg4_r,arg5_r); 
}

static void sl_g_environ_getenv (void)
{
   const gchar* retval;
   gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_environ_getenv(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (818, 818, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_get_system_config_dirs (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_system_config_dirs();
   push_null_term_str_array ((char **) retval, "g_get_system_config_dirs", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (819, 819, 0);
}

static void sl_gtk_file_chooser_button_set_width_chars (void)
{
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_button_set_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (820, 820, 0);
}

static void sl_gtk_native_dialog_destroy (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_native_dialog_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (821, 821, 0);
}

static void sl_pango_attr_underline_new (void)
{
   PangoAttribute* retval;
   PangoUnderline arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_underline_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (822, 822, 0);
}

static void sl_gtk_menu_set_active (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (823, 823, 0);
}

static void sl_gtk_text_tag_table_lookup (void)
{
   GtkTextTag* retval;
   GtkTextTagTable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_tag_table_lookup(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (824, 824, 0);
}

static void sl_gtk_file_chooser_select_all (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (825, 825, 0);
}

static void sl_gtk_font_chooser_get_font_size (void)
{
   gint retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (826, 826, 0);
}

static void sl_gtk_scale_get_value_pos (void)
{
   GtkPositionType retval;
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_value_pos(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (827, 827, 0);
}

static void sl_gtk_menu_attach (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   guint arg4;
   guint arg5;
   guint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_attach(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (828, 828, 0);
}

static void sl_g_resources_get_info (void)
{
   gboolean retval;
   char* arg1;
   GResourceLookupFlags arg2;
   gsize arg3;
   guint32 arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_resources_get_info(arg1,  arg2, &arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   (void)SLang_push_ulong(arg3);
   (void)SLang_push_uint(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (829, 829, 0);
}

static void sl_gtk_list_box_prepend (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_prepend(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (830, 830, 0);
}

static void sl_g_socket_send (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_send(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (831, 831, 0);
}

static void sl_gtk_file_chooser_button_get_focus_on_click (void)
{
   gboolean retval;
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_get_focus_on_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (832, 832, 0);
}

static void sl_gtk_tree_sortable_has_default_sort_func (void)
{
   gboolean retval;
   GtkTreeSortable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_sortable_has_default_sort_func(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (833, 833, 0);
}

static void sl_g_settings_set_int (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_int(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (834, 834, 0);
}

static void sl_gtk_assistant_add_action_widget (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_add_action_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (835, 835, 0);
}

static void sl_gtk_tooltip_set_text (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (836, 836, 0);
}

static void sl_gtk_print_settings_get_reverse (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_reverse(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (837, 837, 0);
}

static void sl_g_volume_should_automount (void)
{
   gboolean retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_should_automount(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (838, 838, 0);
}

static void sl_gtk_text_iter_ends_sentence (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_ends_sentence(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (839, 839, 0);
}

static void sl_gtk_text_buffer_move_mark_by_name (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_move_mark_by_name(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (840, 840, 0);
}

static void sl_gtk_file_chooser_get_current_folder_uri (void)
{
   gchar* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_current_folder_uri(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (841, 841, 0);
}

static void sl_g_charset_converter_set_use_fallback (void)
{
   GCharsetConverter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_charset_converter_set_use_fallback(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (842, 842, 0);
}

static void sl_gtk_shortcut_label_set_disabled_text (void)
{
   GtkShortcutLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_shortcut_label_set_disabled_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (843, 843, 0);
}

static void sl_g_action_map_lookup_action (void)
{
   GAction* retval;
   GActionMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_action_map_lookup_action(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (844, 844, 0);
}

static void sl_gtk_widget_set_margin_end (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_end(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (845, 845, 0);
}

static void sl_gtk_print_settings_get_use_color (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_use_color(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (846, 846, 0);
}

static void sl_g_key_file_remove_comment (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg3, NULL)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_remove_comment(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (847, 847, 0);
}

static void sl_gtk_events_pending (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_events_pending();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (848, 848, 0);
}

static void sl_gtk_image_new_from_gicon (void)
{
   GtkWidget* retval;
   GIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_gicon(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (849, 849, 0);
}

static void sl_pango_tab_array_new (void)
{
   PangoTabArray* retval;
   gint arg1;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_tab_array_new( arg1,  arg2);
   (void)SLang_push_opaque(PangoTabArray_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (850, 850, 0);
}

static void sl_gtk_print_unix_dialog_get_page_setup_set (void)
{
   gboolean retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_page_setup_set(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (851, 851, 0);
}

static void sl_gtk_tree_path_new (void)
{
   GtkTreePath* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_new();
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (852, 852, 0);
}

static void sl_gtk_print_job_get_track_print_status (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_track_print_status(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (853, 853, 0);
}

static void sl_g_variant_type_n_items (void)
{
   gsize retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_n_items(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (854, 854, 0);
}

static void sl_gtk_list_box_select_all (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (855, 855, 0);
}

static void sl_gtk_adjustment_get_lower (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_lower(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (856, 856, 0);
}

static void sl_gtk_tree_view_set_enable_search (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_enable_search(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (857, 857, 0);
}

static void sl_g_type_from_name (void)
{
   GType retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_from_name(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (858, 858, 0);
}

static void sl_gtk_print_context_get_height (void)
{
   gdouble retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_height(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (859, 859, 0);
}

static void sl_gtk_recent_filter_filter (void)
{
   gboolean retval;
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkRecentFilterInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_filter_filter(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (860, 860, 0);
}

static void sl_g_variant_get_handle (void)
{
   gint32 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_handle(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (861, 861, 0);
}

static void sl_g_utf8_strup (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strup(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (862, 862, 0);
}

static void sl_gtk_overlay_add_overlay (void)
{
   GtkOverlay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_overlay_add_overlay(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (863, 863, 0);
}

static void sl_g_io_channel_get_encoding (void)
{
   const gchar* retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_encoding(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (864, 864, 0);
}

static void sl_gtk_printer_list_papers (void)
{
   GList* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_list_papers(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (865, 865, 0);
}

static void sl_gtk_list_box_unselect_row (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkListBoxRow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_unselect_row(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (866, 866, 0);
}

static void sl_g_network_monitor_get_network_available (void)
{
   gboolean retval;
   GNetworkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_monitor_get_network_available(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (867, 867, 0);
}

static void sl_g_emblemed_icon_get_icon (void)
{
   GIcon* retval;
   GEmblemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblemed_icon_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (868, 868, 0);
}

static void sl_gtk_text_mark_set_visible (void)
{
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_mark_set_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (869, 869, 0);
}

static void sl_gtk_entry_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (870, 870, 0);
}

static void sl_g_menu_link_iter_next (void)
{
   gboolean retval;
   GMenuLinkIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_link_iter_next(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (871, 871, 0);
}

static void sl_g_variant_type_dup_string (void)
{
   gchar* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_dup_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (872, 872, 0);
}

static void sl_gtk_window_group_add_window (void)
{
   GtkWindowGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_group_add_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (873, 873, 0);
}

static void sl_gtk_cell_view_get_fit_model (void)
{
   gboolean retval;
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_get_fit_model(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (874, 874, 0);
}

static void sl_gdk_set_program_class (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_set_program_class(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (875, 875, 0);
}

static void sl_gtk_box_set_spacing (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_box_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (876, 876, 0);
}

static void sl_g_mapped_file_unref (void)
{
   GMappedFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMappedFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mapped_file_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (877, 877, 0);
}

static void sl_gdk_window_get_display (void)
{
   GdkDisplay* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (878, 878, 0);
}

static void sl_g_strjoinv (void)
{
   gchar* retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strjoinv(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (879, 879, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_frame_clock_phase_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_phase_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (880, 880, 0);
}

static void sl_gtk_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (881, 881, 0);
}

static void sl_g_settings_new_with_path (void)
{
   GSettings* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_new_with_path(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (882, 882, 0);
}

static void sl_pango_context_new (void)
{
   PangoContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_context_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (883, 883, 0);
}

static void sl_gtk_radio_menu_item_new (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (884, 884, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_pango_context_get_metrics (void)
{
   PangoFontMetrics* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   PangoLanguage* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg2_o, (void**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_context_get_metrics(arg1, arg2, arg3);
   (void)SLang_push_opaque(PangoFontMetrics_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (885, 885, 0);
}

static void sl_gdk_display_open (void)
{
   GdkDisplay* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_open(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (886, 886, 0);
}

static void sl_gtk_tool_item_group_get_nth_item (void)
{
   GtkToolItem* retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_nth_item(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (887, 887, 0);
}

static void sl_gtk_about_dialog_set_artists (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_about_dialog_set_artists(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (888, 888, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_paned_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (889, 889, 0);
}

static void sl_gdk_drag_action_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_action_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (890, 890, 0);
}

static void sl_gtk_page_setup_get_left_margin (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_left_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (891, 891, 0);
}

static void sl_gtk_print_operation_set_print_settings (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintSettings* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_operation_set_print_settings(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (892, 892, 0);
}

static void sl_gtk_text_iter_get_offset (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_offset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (893, 893, 0);
}

static void sl_g_unichar_iswide (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_iswide( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (894, 894, 0);
}

static void sl_gtk_label_set_selectable (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_selectable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (895, 895, 0);
}

static void sl_gdk_window_resize (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_resize(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (896, 896, 0);
}

static void sl_gtk_tree_view_column_set_min_width (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_min_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (897, 897, 0);
}

static void sl_gtk_image_new_from_pixbuf (void)
{
   GtkWidget* retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GdkPixbuf_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_pixbuf(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (898, 898, 0);
}

static void sl_gtk_popover_menu_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_menu_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (899, 899, 0);
}

static void sl_g_main_context_acquire (void)
{
   gboolean retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_acquire(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (900, 900, 0);
}

static void sl_gtk_cell_renderer_set_visible (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_set_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (901, 901, 0);
}

static void sl_gtk_widget_path_iter_has_qname (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GQuark arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_qname(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (902, 902, 0);
}

static void sl_gtk_font_button_set_use_size (void)
{
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_button_set_use_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (903, 903, 0);
}

static void sl_g_ascii_string_to_signed (void)
{
   gboolean retval;
   gchar* arg1;
   guint arg2;
   gint64 arg3;
   gint64 arg4;
   gint64* arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_LONG_TYPE,sizeof(gint64),&arg5,0x0);
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_ascii_string_to_signed(arg1,  arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (904, 904, 0);
   finalize_refs(1,arg5_r); 
}

static void sl_g_drive_start_finish (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_drive_start_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (905, 905, 0);
}

static void sl_gtk_gl_area_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (906, 906, 0);
}

static void sl_gdk_pixbuf_get_option (void)
{
   const gchar* retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_get_option(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (907, 907, 0);
}

static void sl_gtk_window_set_default_icon_name (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_default_icon_name(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (908, 908, 0);
}

static void sl_gtk_file_chooser_get_do_overwrite_confirmation (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_do_overwrite_confirmation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (909, 909, 0);
}

static void sl_g_date_time_equal (void)
{
   gboolean retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (910, 910, 0);
}

static void sl_gtk_notebook_set_tab_reorderable (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_tab_reorderable(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (911, 911, 0);
}

static void sl_gtk_app_chooser_widget_get_show_recommended (void)
{
   gboolean retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_show_recommended(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (912, 912, 0);
}

static void sl_gtk_accel_groups_from_object (void)
{
   GSList* retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_groups_from_object(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (913, 913, 0);
}

static void sl_gdk_window_constrain_size (void)
{
   GdkGeometry* arg1 = (GdkGeometry*) alloca(sizeof(GdkGeometry));
   GdkWindowHints arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkGeometry_Layout)) goto usage_label;
   issue_usage = 0;

   gdk_window_constrain_size(arg1,  arg2,  arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkGeometry_Layout);
usage_label:
   if (issue_usage) Slirp_usage (914, 914, 0);
}

static void sl_gtk_label_get_mnemonic_keyval (void)
{
   guint retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_mnemonic_keyval(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (915, 915, 0);
}

static void sl_gtk_file_chooser_button_new_with_dialog (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_new_with_dialog(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (916, 916, 0);
}

static void sl_gtk_page_setup_to_key_file (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GKeyFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_page_setup_to_key_file(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (917, 917, 0);
}

static void sl_gtk_page_setup_get_paper_width (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_paper_width(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (918, 918, 0);
}

static void sl_gdk_drag_context_list_targets (void)
{
   GList* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_list_targets(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (919, 919, 0);
}

static void sl_gtk_text_buffer_insert_child_anchor (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextChildAnchor* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_insert_child_anchor(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (920, 920, 0);
}

static void sl_gdk_offscreen_window_get_embedder (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_offscreen_window_get_embedder(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (921, 921, 0);
}

static void sl_g_signal_remove_emission_hook (void)
{
   guint arg1;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_signal_remove_emission_hook( arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (922, 922, 0);
}

static void sl_gtk_print_job_set_page_set (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSet arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_page_set(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (923, 923, 0);
}

static void sl_gtk_combo_box_set_focus_on_click (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_focus_on_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (924, 924, 0);
}

static void sl_gtk_entry_completion_get_completion_prefix (void)
{
   const gchar* retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_completion_prefix(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (925, 925, 0);
}

static void sl_gtk_assistant_get_page_type (void)
{
   GtkAssistantPageType retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_type(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (926, 926, 0);
}

static void sl_gtk_print_settings_set_length (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   GtkUnit arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_length(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (927, 927, 0);
}

static void sl_g_date_valid_julian (void)
{
   gboolean retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_julian( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (928, 928, 0);
}

static void sl_gtk_widget_destroyed (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget** arg2;
   Slirp_Ref *arg2_r = ref_new(GtkWidget_Type,sizeof(GtkWidget*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_destroyed(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (929, 929, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_pango_attr_style_new (void)
{
   PangoAttribute* retval;
   PangoStyle arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_style_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (930, 930, 0);
}

static void sl_gtk_button_set_always_show_image (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_always_show_image(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (931, 931, 0);
}

static void sl_gtk_spin_button_set_update_policy (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSpinButtonUpdatePolicy arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_update_policy(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (932, 932, 0);
}

static void sl_gtk_accel_group_get_is_locked (void)
{
   gboolean retval;
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_get_is_locked(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (933, 933, 0);
}

static void sl_gdk_frame_timings_get_complete (void)
{
   gboolean retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_complete(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (934, 934, 0);
}

static void sl_g_file_attribute_matcher_matches (void)
{
   gboolean retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_attribute_matcher_matches(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (935, 935, 0);
}

static void sl_gdk_frame_timings_ref (void)
{
   GdkFrameTimings* retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_ref(arg1);
   (void)SLang_push_opaque(GdkFrameTimings_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (936, 936, 0);
}

static void sl_gtk_gesture_get_group (void)
{
   GList* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_group(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (937, 937, 0);
}

static void sl_gtk_selection_data_get_pixbuf (void)
{
   GdkPixbuf* retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (938, 938, 0);
}

static void sl_gdk_event_get_device_tool (void)
{
   GdkDeviceTool* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_device_tool(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (939, 939, 0);
}

static void sl_pango_font_metrics_get_strikethrough_position (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_strikethrough_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (940, 940, 0);
}

static void sl_gtk_style_context_set_path (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidgetPath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_set_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (941, 941, 0);
}

static void sl_g_socket_condition_check (void)
{
   GIOCondition retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOCondition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_condition_check(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (942, 942, 0);
}

static void sl_gtk_drag_source_set_icon_pixbuf (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_source_set_icon_pixbuf(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (943, 943, 0);
}

static void sl_g_variant_get_uint32 (void)
{
   guint32 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_uint32(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (944, 944, 0);
}

static void sl_gtk_container_get_resize_mode (void)
{
   GtkResizeMode retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_resize_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (945, 945, 0);
}

static void sl_gdk_pixbuf_copy_area (void)
{
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int arg5;
   GdkPixbuf* arg6;
   Slirp_Opaque* arg6_o = NULL;
   int arg7;
   int arg8;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg6, &arg6_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_6;
   issue_usage = 0;

   gdk_pixbuf_copy_area(arg1,  arg2,  arg3,  arg4,  arg5, arg6,  arg7,  arg8);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_6:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (946, 946, 0);
}

static void sl_gtk_text_iter_forward_chars (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_chars(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (947, 947, 0);
}

static void sl_gtk_drag_source_add_uri_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_source_add_uri_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (948, 948, 0);
}

static void sl_gtk_font_chooser_get_font_desc (void)
{
   PangoFontDescription* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_desc(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (949, 949, 0);
}

static void sl_g_spaced_primes_closest (void)
{
   guint retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_spaced_primes_closest( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (950, 950, 0);
}

static void sl_gdk_device_pad_feature_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_feature_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (951, 951, 0);
}

static void sl_gtk_shortcut_label_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcut_label_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (952, 952, 0);
}

static void sl_g_source_get_id (void)
{
   guint retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_id(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (953, 953, 0);
}

static void sl_gtk_printer_get_state_message (void)
{
   const gchar* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_state_message(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (954, 954, 0);
}

static void sl_gtk_tool_button_get_stock_id (void)
{
   const gchar* retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_stock_id(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (955, 955, 0);
}

static void sl_gtk_revealer_set_transition_duration (void)
{
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_revealer_set_transition_duration(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (956, 956, 0);
}

static void sl_g_date_subtract_years (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_subtract_years(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (957, 957, 0);
}

static void sl_gtk_printer_compare (void)
{
   gint retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrinter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_printer_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (958, 958, 0);
}

static void sl_gdk_window_get_frame_extents (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_frame_extents(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (959, 959, 0);
}

static void sl_gtk_radio_menu_item_new_with_mnemonic_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new_with_mnemonic_from_widget(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (960, 960, 0);
}

static void sl_pango_layout_set_wrap (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoWrapMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_wrap(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (961, 961, 0);
}

static void sl_g_type_instance_get_private (void)
{
   gpointer retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_instance_get_private(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (962, 962, 0);
}

static void sl_g_file_new_for_path (void)
{
   GFile* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_new_for_path(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (963, 963, 0);
}

static void sl_pango_layout_get_baseline (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_baseline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (964, 964, 0);
}

static void sl_gtk_image_new_from_stock (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_stock(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (965, 965, 0);
}

static void sl_gtk_spin_button_new (void)
{
   GtkWidget* retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_new(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (966, 966, 0);
}

static void sl_gtk_icon_view_get_row_spacing (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_row_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (967, 967, 0);
}

static void sl_g_param_spec_get_redirect_target (void)
{
   GParamSpec* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_redirect_target(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (968, 968, 0);
}

static void sl_g_type_qname (void)
{
   GQuark retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_qname( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (969, 969, 0);
}

static void sl_gtk_layout_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_layout_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (970, 970, 0);
}

static void sl_gtk_window_get_skip_pager_hint (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_skip_pager_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (971, 971, 0);
}

static void sl_g_find_program_in_path (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_find_program_in_path(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (972, 972, 0);
}

static void sl_gtk_label_get_attributes (void)
{
   PangoAttrList* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_attributes(arg1);
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (973, 973, 0);
}

static void sl_gtk_print_settings_set (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (974, 974, 0);
}

static void sl_g_object_interface_list_properties (void)
{
   GParamSpec** retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UINT_TYPE,sizeof(guint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_interface_list_properties(arg1, arg2);
   (void)SLang_push_opaque(opaque_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (975, 975, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_tool_item_new (void)
{
   GtkToolItem* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (976, 976, 0);
}

static void sl_gtk_radio_tool_button_new_with_stock_from_widget (void)
{
   GtkToolItem* retval;
   GtkRadioToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_tool_button_new_with_stock_from_widget(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (977, 977, 0);
}

static void sl_gtk_widget_set_tooltip_text (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_tooltip_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (978, 978, 0);
}

static void sl_gtk_text_iter_order (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_iter_order(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (979, 979, 0);
}

static void sl_gtk_text_view_move_mark_onscreen (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_move_mark_onscreen(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (980, 980, 0);
}

static void sl_gdk_keymap_get_scroll_lock_state (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_scroll_lock_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (981, 981, 0);
}

static void sl_gtk_button_box_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_box_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (982, 982, 0);
}

static void sl_gtk_places_sidebar_set_show_trash (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_trash(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (983, 983, 0);
}

static void sl_gtk_tree_view_column_set_visible (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (984, 984, 0);
}

static void sl_g_type_name_from_instance (void)
{
   const gchar* retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_name_from_instance(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (985, 985, 0);
}

static void sl_gdk_display_manager_set_default_display (void)
{
   GdkDisplayManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDisplay* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_display_manager_set_default_display(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (986, 986, 0);
}

static void sl_gtk_print_operation_set_has_selection (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_has_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (987, 987, 0);
}

static void sl_gtk_menu_button_get_popover (void)
{
   GtkPopover* retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_popover(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (988, 988, 0);
}

static void sl_gtk_widget_get_support_multidevice (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_support_multidevice(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (989, 989, 0);
}

static void sl_gtk_window_get_opacity (void)
{
   gdouble retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_opacity(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (990, 990, 0);
}

static void sl_gdk_display_get_name (void)
{
   const gchar* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (991, 991, 0);
}

static void sl_gtk_drag_begin (void)
{
   GdkDragContext* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTargetList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDragAction arg3;
   gint arg4;
   GdkEvent* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg2, &arg2_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_drag_begin(arg1, arg2,  arg3,  arg4, arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (992, 992, 0);
}

static void sl_gtk_print_settings_set_printer (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_printer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (993, 993, 0);
}

static void sl_gdk_window_begin_draw_frame (void)
{
   GdkDrawingContext* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_begin_draw_frame(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (994, 994, 0);
}

static void sl_pango_font_metrics_unref (void)
{
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_metrics_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (995, 995, 0);
}

static void sl_gtk_scrolled_window_set_propagate_natural_height (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_propagate_natural_height(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (996, 996, 0);
}

static void sl_gtk_icon_theme_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (997, 997, 0);
}

static void sl_gtk_text_buffer_get_slice (void)
{
   gchar* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_get_slice(arg1, arg2, arg3,  arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (998, 998, 0);
}

static void sl_gtk_entry_get_attributes (void)
{
   PangoAttrList* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_attributes(arg1);
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (999, 999, 0);
}

static void sl_g_hostname_is_ascii_encoded (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hostname_is_ascii_encoded(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1000, 1000, 0);
}

static void sl_gtk_widget_set_child_visible (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_child_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1001, 1001, 0);
}

static void sl_gtk_tool_item_get_visible_horizontal (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_visible_horizontal(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1002, 1002, 0);
}

static void sl_g_rand_int_range (void)
{
   gint32 retval;
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint32 arg2;
   gint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_int_range(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1003, 1003, 0);
}

static void sl_gtk_page_setup_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1004, 1004, 0);
}

static void sl_gtk_text_view_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1005, 1005, 0);
}

static void sl_g_simple_action_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_simple_action_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1006, 1006, 0);
}

static void sl_gtk_tree_row_reference_get_path (void)
{
   GtkTreePath* retval;
   GtkTreeRowReference* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeRowReference_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_row_reference_get_path(arg1);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1007, 1007, 0);
}

static void sl_gtk_print_unix_dialog_set_settings (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintSettings* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_unix_dialog_set_settings(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1008, 1008, 0);
}

static void sl_gtk_mount_operation_set_screen (void)
{
   GtkMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_mount_operation_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1009, 1009, 0);
}

static void sl_gtk_recent_chooser_unselect_uri (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_chooser_unselect_uri(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1010, 1010, 0);
}

static void sl_g_bookmark_file_to_data (void)
{
   gchar* retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   arg3 = NULL;
   retval = g_bookmark_file_to_data(arg1, &arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1011, 1011, 0);
}

static void sl_gtk_builder_add_from_file (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_builder_add_from_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1012, 1012, 0);
}

static void sl_g_settings_backend_writable_changed (void)
{
   GSettingsBackend* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_backend_writable_changed(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1013, 1013, 0);
}

static void sl_pango_layout_get_attributes (void)
{
   PangoAttrList* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_attributes(arg1);
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1014, 1014, 0);
}

static void sl_g_rand_set_seed_array (void)
{
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const guint32* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UINT_TYPE,sizeof(guint32),&arg2,0x0);
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_rand_set_seed_array(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1015, 1015, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_resolver_free_targets (void)
{
   GList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_resolver_free_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1016, 1016, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_pixbuf_copy (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_copy(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1017, 1017, 0);
}

static void sl_g_volume_enumerate_identifiers (void)
{
   char** retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_enumerate_identifiers(arg1);
   push_null_term_str_array (retval, "g_volume_enumerate_identifiers", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1018, 1018, 0);
}

static void sl_pango_layout_move_cursor_visually (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   int arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_move_cursor_visually(arg1,  arg2,  arg3,  arg4,  arg5, &arg6, &arg7);
   (void)SLang_push_int(arg6);
   (void)SLang_push_int(arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1019, 1019, 0);
}

static void sl_gdk_window_begin_move_drag (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   guint32 arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_begin_move_drag(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1020, 1020, 0);
}

static void sl_gtk_notebook_popup_disable (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_popup_disable(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1021, 1021, 0);
}

static void sl_gtk_icon_view_set_selection_mode (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSelectionMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_selection_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1022, 1022, 0);
}

static void sl_gtk_tool_shell_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1023, 1023, 0);
}

static void sl_gtk_entry_completion_get_popup_set_width (void)
{
   gboolean retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_popup_set_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1024, 1024, 0);
}

static void sl_g_unichar_isdefined (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isdefined( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1025, 1025, 0);
}

static void sl_gtk_search_bar_set_show_close_button (void)
{
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_search_bar_set_show_close_button(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1026, 1026, 0);
}

static void sl_gtk_menu_shell_deactivate (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_shell_deactivate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1027, 1027, 0);
}

static void sl_gdk_window_end_paint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_end_paint(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1028, 1028, 0);
}

static void sl_gtk_window_get_type_hint (void)
{
   GdkWindowTypeHint retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_type_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1029, 1029, 0);
}

static void sl_gtk_selection_data_get_display (void)
{
   GdkDisplay* retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1030, 1030, 0);
}

static void sl_g_param_value_set_default (void)
{
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_param_value_set_default(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1031, 1031, 0);
}

static void sl_gdk_display_get_n_monitors (void)
{
   int retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_n_monitors(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1032, 1032, 0);
}

static void sl_pango_font_face_list_sizes (void)
{
   PangoFontFace* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(int_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_face_list_sizes(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1033, 1033, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_date_time_new_now_local (void)
{
   GDateTime* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_now_local();
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1034, 1034, 0);
}

static void sl_gdk_rgba_equal (void)
{
   gboolean retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_rgba_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1035, 1035, 0);
}

static void sl_gtk_text_iter_forward_char (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_char(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1036, 1036, 0);
}

static void sl_gtk_level_bar_remove_offset_value (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_level_bar_remove_offset_value(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1037, 1037, 0);
}

static void sl_gtk_list_box_insert (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1038, 1038, 0);
}

static void sl_gtk_app_chooser_refresh (void)
{
   GtkAppChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_refresh(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1039, 1039, 0);
}

static void sl_g_match_info_fetch_pos (void)
{
   gboolean retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_fetch_pos(arg1,  arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1040, 1040, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_gtk_text_buffer_get_iter_at_line_index (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_line_index(arg1, arg2,  arg3,  arg4);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1041, 1041, 0);
}

static void sl_gtk_level_bar_get_mode (void)
{
   GtkLevelBarMode retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1042, 1042, 0);
}

static void sl_gtk_assistant_get_page_header_image (void)
{
   GdkPixbuf* retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_header_image(arg1, arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1043, 1043, 0);
}

static void sl_gtk_header_bar_set_title (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1044, 1044, 0);
}

static void sl_gtk_widget_path_append_with_siblings (void)
{
   gint retval;
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidgetPath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_path_append_with_siblings(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1045, 1045, 0);
}

static void sl_g_type_class_adjust_private_offset (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_type_class_adjust_private_offset(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1046, 1046, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_display_manager_list_displays (void)
{
   GSList* retval;
   GdkDisplayManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_manager_list_displays(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1047, 1047, 0);
}

static void sl_pango_layout_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1048, 1048, 0);
}

static void sl_gtk_cell_view_set_model (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_view_set_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1049, 1049, 0);
}

static void sl_gdk_window_shape_combine_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_shape_combine_region(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1050, 1050, 0);
}

static void sl_gtk_render_arrow (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_arrow(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1051, 1051, 0);
}

static void sl_gtk_window_fullscreen_on_monitor (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_fullscreen_on_monitor(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1052, 1052, 0);
}

static void sl_g_app_info_get_all (void)
{
   GList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_all();
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1053, 1053, 0);
}

static void sl_gdk_keymap_have_bidi_layouts (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_have_bidi_layouts(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1054, 1054, 0);
}

static void sl_gtk_gl_area_get_auto_render (void)
{
   gboolean retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_auto_render(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1055, 1055, 0);
}

static void sl_gtk_widget_set_receives_default (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_receives_default(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1056, 1056, 0);
}

static void sl_gtk_size_group_add_widget (void)
{
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_size_group_add_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1057, 1057, 0);
}

static void sl_gtk_flow_box_unselect_all (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1058, 1058, 0);
}

static void sl_gtk_text_view_set_left_margin (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_left_margin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1059, 1059, 0);
}

static void sl_g_variant_get_byte (void)
{
   guint8 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_byte(arg1);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1060, 1060, 0);
}

static void sl_gtk_notebook_prepend_page_menu (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkWidget* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_prepend_page_menu(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1061, 1061, 0);
}

static void sl_gtk_text_view_reset_cursor_blink (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_reset_cursor_blink(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1062, 1062, 0);
}

static void sl_gtk_tree_view_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1063, 1063, 0);
}

static void sl_g_file_get_path (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_path(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1064, 1064, 0);
}

static void sl_gtk_scrolled_window_get_hscrollbar (void)
{
   GtkWidget* retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_hscrollbar(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1065, 1065, 0);
}

static void sl_gtk_container_get_focus_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_focus_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1066, 1066, 0);
}

static void sl_gtk_recent_filter_new (void)
{
   GtkRecentFilter* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_filter_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1067, 1067, 0);
}

static void sl_gtk_entry_get_activates_default (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_activates_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1068, 1068, 0);
}

static void sl_pango_script_iter_next (void)
{
   gboolean retval;
   PangoScriptIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoScriptIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_script_iter_next(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1069, 1069, 0);
}

static void sl_g_socket_set_broadcast (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_broadcast(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1070, 1070, 0);
}

static void sl_pango_cairo_font_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1071, 1071, 0);
}

static void sl_g_type_check_instance_is_a (void)
{
   gboolean retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_instance_is_a(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1072, 1072, 0);
}

static void sl_gtk_print_job_set_rotate (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_rotate(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1073, 1073, 0);
}

static void sl_gtk_get_micro_version (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_micro_version();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1074, 1074, 0);
}

static void sl_g_variant_dup_bytestring (void)
{
   gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_dup_bytestring(arg1, &arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1075, 1075, 0);
}

static void sl_gdk_event_get_coords (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_coords(arg1, &arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg2);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1076, 1076, 0);
}

static void sl_gtk_entry_completion_new_with_area (void)
{
   GtkEntryCompletion* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_new_with_area(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1077, 1077, 0);
}

static void sl_g_path_get_basename (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_path_get_basename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1078, 1078, 0);
}

static void sl_gtk_window_get_focus (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_focus(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1079, 1079, 0);
}

static void sl_gtk_gl_area_get_context (void)
{
   GdkGLContext* retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1080, 1080, 0);
}

static void sl_gtk_scrolled_window_set_min_content_height (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_min_content_height(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1081, 1081, 0);
}

static void sl_gdk_gl_context_set_use_es (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_set_use_es(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1082, 1082, 0);
}

static void sl_g_cancellable_source_new (void)
{
   GSource* retval;
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_source_new(arg1);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1083, 1083, 0);
}

static void sl_g_settings_get_user_value (void)
{
   GVariant* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_user_value(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1084, 1084, 0);
}

static void sl_gdk_device_pad_get_feature_group (void)
{
   gint retval;
   GdkDevicePad* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevicePadFeature arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_get_feature_group(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1085, 1085, 0);
}

static void sl_g_variant_new_tuple (void)
{
   GVariant* retval;
   const GVariant** arg1;
   Slirp_Ref *arg1_r = ref_new(GVariant_Type,sizeof(GVariant*),&arg1,0x0);
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_tuple(arg1,  arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1086, 1086, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_icon_view_get_text_column (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_text_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1087, 1087, 0);
}

static void sl_g_date_time_unref (void)
{
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_time_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1088, 1088, 0);
}

static void sl_g_file_icon_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_icon_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1089, 1089, 0);
}

static void sl_gtk_tree_store_set_column_types (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GType* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_ULONG_TYPE,sizeof(GType),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = (gint) ref_get_size(arg3_r, 0);
   gtk_tree_store_set_column_types(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1090, 1090, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_expander_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1091, 1091, 0);
}

static void sl_g_variant_is_object_path (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_is_object_path(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1092, 1092, 0);
}

static void sl_gtk_text_iter_forward_visible_word_ends (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_word_ends(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1093, 1093, 0);
}

static void sl_gtk_widget_keynav_failed (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDirectionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_keynav_failed(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1094, 1094, 0);
}

static void sl_gtk_popover_set_default_widget (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_popover_set_default_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1095, 1095, 0);
}

static void sl_pango_coverage_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1096, 1096, 0);
}

static void sl_gtk_tree_model_filter_convert_child_iter_to_iter (void)
{
   gboolean retval;
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   retval = gtk_tree_model_filter_convert_child_iter_to_iter(arg1, arg2, arg3);
   if (retval)
      (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   else
      {
         SLfree ((char *) arg2);
         (void) SLang_push_null ();
      }
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1097, 1097, 0);
}

static void sl_gtk_print_job_set_track_print_status (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_track_print_status(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1098, 1098, 0);
}

static void sl_gdk_window_coords_to_parent (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_coords_to_parent(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1099, 1099, 0);
}

static void sl_gdk_pixbuf_get_file_info (void)
{
   GdkPixbufFormat* retval;
   gchar* arg1;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_file_info(arg1, &arg2, &arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1100, 1100, 0);
}

static void sl_gtk_dialog_get_content_area (void)
{
   GtkWidget* retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_get_content_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1101, 1101, 0);
}

static void sl_g_main_context_prepare (void)
{
   gboolean retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_prepare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1102, 1102, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_get_show_events (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_get_show_events();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1103, 1103, 0);
}

static void sl_g_resource_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_resource_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1104, 1104, 0);
}

static void sl_gtk_header_bar_set_subtitle (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_set_subtitle(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1105, 1105, 0);
}

static void sl_gtk_notebook_insert_page (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_insert_page(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1106, 1106, 0);
}

static void sl_gdk_window_set_override_redirect (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_override_redirect(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1107, 1107, 0);
}

static void sl_gtk_tree_view_convert_widget_to_tree_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_widget_to_tree_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1108, 1108, 0);
}

static void sl_g_variant_type_new_array (void)
{
   GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_new_array(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1109, 1109, 0);
}

static void sl_gtk_print_job_get_page_set (void)
{
   GtkPageSet retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_page_set(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1110, 1110, 0);
}

static void sl_g_credentials_is_same_user (void)
{
   gboolean retval;
   GCredentials* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCredentials* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_credentials_is_same_user(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1111, 1111, 0);
}

static void sl_gtk_button_get_relief (void)
{
   GtkReliefStyle retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_relief(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1112, 1112, 0);
}

static void sl_g_file_set_attribute_string (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_string(arg1, arg2, arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1113, 1113, 0);
}

static void sl_gtk_file_chooser_get_uris (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_uris(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1114, 1114, 0);
}

static void sl_g_key_file_set_locale_string (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   gchar* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_locale_string(arg1, arg2, arg3, arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_5:
   SLang_free_slstring(arg5);
usage_label:
   if (issue_usage) Slirp_usage (1115, 1115, 0);
}

static void sl_g_type_name (void)
{
   const gchar* retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_name( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1116, 1116, 0);
}

static void sl_g_settings_set_uint (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_uint(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1117, 1117, 0);
}

static void sl_gtk_cell_area_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1118, 1118, 0);
}

static void sl_gtk_gl_area_make_current (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_make_current(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1119, 1119, 0);
}

static void sl_gtk_accel_label_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_label_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1120, 1120, 0);
}

static void sl_gdk_device_get_axis (void)
{
   gboolean retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GdkAxisUse arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_axis(arg1, &arg2,  arg3, &arg4);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1121, 1121, 0);
}

static void sl_gtk_widget_get_preferred_size (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRequisition* arg2 = (GtkRequisition*) alloca(sizeof(GtkRequisition));
   GtkRequisition* arg3 = (GtkRequisition*) alloca(sizeof(GtkRequisition));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_size(arg1, arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GtkRequisition_Layout);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GtkRequisition_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1122, 1122, 0);
}

static void sl_gdk_get_default_root_window (void)
{
   GdkWindow* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_get_default_root_window();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1123, 1123, 0);
}

static void sl_gdk_window_get_device_events (void)
{
   GdkEventMask retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_get_device_events(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1124, 1124, 0);
}

static void sl_g_signal_handler_is_connected (void)
{
   gboolean retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_signal_handler_is_connected(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1125, 1125, 0);
}

static void sl_gdk_window_focus (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_focus(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1126, 1126, 0);
}

static void sl_g_input_stream_skip (void)
{
   gssize retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_input_stream_skip(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1127, 1127, 0);
}

static void sl_gdk_events_get_angle (void)
{
   gboolean retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_events_get_angle(arg1, arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1128, 1128, 0);
}

static void sl_g_action_get_name (void)
{
   const gchar* retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1129, 1129, 0);
}

static void sl_gdk_window_peek_children (void)
{
   GList* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_peek_children(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1130, 1130, 0);
}

static void sl_g_date_free (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1131, 1131, 0);
}

static void sl_g_unichar_combining_class (void)
{
   gint retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_combining_class( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1132, 1132, 0);
}

static void sl_gtk_places_sidebar_set_show_connect_to_server (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_connect_to_server(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1133, 1133, 0);
}

static void sl_g_binding_get_target_property (void)
{
   const gchar* retval;
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_target_property(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1134, 1134, 0);
}

static void sl_gtk_widget_get_visual (void)
{
   GdkVisual* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_visual(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1135, 1135, 0);
}

static void sl_pango_layout_get_text (void)
{
   const char* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_text(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1136, 1136, 0);
}

static void sl_gdk_device_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1137, 1137, 0);
}

static void sl_gtk_selection_convert (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint32 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_convert(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1138, 1138, 0);
}

static void sl_g_param_spec_pool_lookup (void)
{
   GParamSpec* retval;
   GParamSpecPool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GType arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_spec_pool_lookup(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1139, 1139, 0);
}

static void sl_gtk_gl_area_set_auto_render (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_auto_render(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1140, 1140, 0);
}

static void sl_g_type_parent (void)
{
   GType retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_parent( arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1141, 1141, 0);
}

static void sl_gtk_cell_layout_get_cells (void)
{
   GList* retval;
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_layout_get_cells(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1142, 1142, 0);
}

static void sl_gtk_tool_item_group_set_item_position (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_group_set_item_position(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1143, 1143, 0);
}

static void sl_pango_layout_get_spacing (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1144, 1144, 0);
}

static void sl_gtk_text_view_move_child (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_move_child(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1145, 1145, 0);
}

static void sl_gtk_text_iter_forward_cursor_position (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_cursor_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1146, 1146, 0);
}

static void sl_gtk_file_chooser_set_choice (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_set_choice(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1147, 1147, 0);
}

static void sl_gdk_display_get_default_screen (void)
{
   GdkScreen* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_default_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1148, 1148, 0);
}

static void sl_gdk_device_ungrab (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_device_ungrab(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1149, 1149, 0);
}

static void sl_g_settings_create_action (void)
{
   GAction* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_create_action(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1150, 1150, 0);
}

static void sl_gtk_clipboard_get_default (void)
{
   GtkClipboard* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get_default(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1151, 1151, 0);
}

static void sl_gtk_tree_view_set_reorderable (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_reorderable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1152, 1152, 0);
}

static void sl_gtk_print_unix_dialog_set_has_selection (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_unix_dialog_set_has_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1153, 1153, 0);
}

static void sl_gtk_builder_set_translation_domain (void)
{
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_builder_set_translation_domain(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1154, 1154, 0);
}

static void sl_pango_font_description_to_filename (void)
{
   char* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_to_filename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1155, 1155, 0);
}

static void sl_gtk_scrollable_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollable_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1156, 1156, 0);
}

static void sl_gtk_tree_view_column_get_expand (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_expand(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1157, 1157, 0);
}

static void sl_gtk_entry_completion_set_popup_completion (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_popup_completion(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1158, 1158, 0);
}

static void sl_gtk_tree_view_column_set_sort_order (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSortType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_sort_order(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1159, 1159, 0);
}

static void sl_g_variant_type_is_container (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_container(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1160, 1160, 0);
}

static void sl_gtk_text_buffer_copy_clipboard (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkClipboard* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_copy_clipboard(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1161, 1161, 0);
}

static void sl_gtk_file_chooser_widget_new (void)
{
   GtkWidget* retval;
   GtkFileChooserAction arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_widget_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1162, 1162, 0);
}

static void sl_g_inet_address_get_is_mc_global (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_mc_global(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1163, 1163, 0);
}

static void sl_glib_check_version (void)
{
   const gchar* retval;
   guint arg1;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = glib_check_version( arg1,  arg2,  arg3);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1164, 1164, 0);
}

static void sl_gdk_cursor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1165, 1165, 0);
}

static void sl_g_date_get_day (void)
{
   GDateDay retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_day(arg1);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1166, 1166, 0);
}

static void sl_gtk_print_settings_get_number_up (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_number_up(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1167, 1167, 0);
}

static void sl_gtk_radio_menu_item_get_group (void)
{
   GSList* retval;
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_menu_item_get_group(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1168, 1168, 0);
}

static void sl_gtk_assistant_commit (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_commit(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1169, 1169, 0);
}

static void sl_g_utf8_validate (void)
{
   gboolean retval;
   gchar* arg1;
   gssize arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_validate(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1170, 1170, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_set_valign (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAlign arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_valign(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1171, 1171, 0);
}

static void sl_gtk_list_store_remove (void)
{
   gboolean retval;
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_list_store_remove(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1172, 1172, 0);
}

static void sl_gtk_tree_view_column_get_spacing (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1173, 1173, 0);
}

static void sl_gtk_icon_view_get_column_spacing (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_column_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1174, 1174, 0);
}

static void sl_gtk_text_buffer_get_iter_at_mark (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   GtkTextMark* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_mark(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1175, 1175, 0);
}

static void sl_gtk_window_add_mnemonic (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_window_add_mnemonic(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1176, 1176, 0);
}

static void sl_gtk_info_bar_set_response_sensitive (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_set_response_sensitive(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1177, 1177, 0);
}

static void sl_g_object_getv (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GValue* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   g_object_getv(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1178, 1178, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_text_attributes_ref (void)
{
   GtkTextAttributes* retval;
   GtkTextAttributes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_attributes_ref(arg1);
   (void)SLang_push_opaque(GtkTextAttributes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1179, 1179, 0);
}

static void sl_gtk_font_button_get_use_font (void)
{
   gboolean retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_use_font(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1180, 1180, 0);
}

static void sl_gtk_style_context_get_state (void)
{
   GtkStateFlags retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1181, 1181, 0);
}

static void sl_g_variant_is_signature (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_is_signature(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1182, 1182, 0);
}

static void sl_gtk_targets_include_uri (void)
{
   gboolean retval;
   GdkAtom* arg1;
   Slirp_Ref *arg1_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg1,0x0);
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_targets_include_uri(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1183, 1183, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_window_begin_move_drag_for_device (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   gint arg5;
   guint32 arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_begin_move_drag_for_device(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1184, 1184, 0);
}

static void sl_gtk_text_iter_get_char (void)
{
   gunichar retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_char(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1185, 1185, 0);
}

static void sl_gtk_range_set_upper_stepper_sensitivity (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSensitivityType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_upper_stepper_sensitivity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1186, 1186, 0);
}

static void sl_g_regex_unref (void)
{
   GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_regex_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1187, 1187, 0);
}

static void sl_g_date_time_add_weeks (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_weeks(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1188, 1188, 0);
}

static void sl_gdk_screen_get_width (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1189, 1189, 0);
}

static void sl_g_date_time_get_minute (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_minute(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1190, 1190, 0);
}

static void sl_g_inet_address_new_from_bytes (void)
{
   GInetAddress* retval;
   const guint8* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guint8),&arg1,0x0);
   GSocketFamily arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_new_from_bytes(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1191, 1191, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_search_bar_connect_entry (void)
{
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntry* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_search_bar_connect_entry(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1192, 1192, 0);
}

static void sl_gtk_file_chooser_get_select_multiple (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_select_multiple(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1193, 1193, 0);
}

static void sl_g_charset_converter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_charset_converter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1194, 1194, 0);
}

static void sl_gtk_render_layout (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   PangoLayout* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_double((double*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_layout(arg1, arg2,  arg3,  arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1195, 1195, 0);
}

static void sl_gtk_widget_set_redraw_on_allocate (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_redraw_on_allocate(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1196, 1196, 0);
}

static void sl_pango_font_get_coverage (void)
{
   PangoCoverage* retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLanguage* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_font_get_coverage(arg1, arg2);
   (void)SLang_push_opaque(PangoCoverage_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1197, 1197, 0);
}

static void sl_gtk_style_context_set_screen (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1198, 1198, 0);
}

static void sl_g_date_time_add_months (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_months(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1199, 1199, 0);
}

static void sl_pango_attr_stretch_new (void)
{
   PangoAttribute* retval;
   PangoStretch arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_stretch_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1200, 1200, 0);
}

static void sl_g_volume_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1201, 1201, 0);
}

static void sl_g_date_get_sunday_weeks_in_year (void)
{
   guint8 retval;
   GDateYear arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_sunday_weeks_in_year( arg1);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1202, 1202, 0);
}

static void sl_gtk_icon_view_get_item_column (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_view_get_item_column(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1203, 1203, 0);
}

static void sl_gdk_seat_ungrab (void)
{
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_seat_ungrab(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1204, 1204, 0);
}

static void sl_gtk_get_default_language (void)
{
   PangoLanguage* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_default_language();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1205, 1205, 0);
}

static void sl_gtk_entry_completion_get_popup_completion (void)
{
   gboolean retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_popup_completion(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1206, 1206, 0);
}

static void sl_g_key_file_get_string (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_string(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1207, 1207, 0);
}

static void sl_g_settings_schema_source_list_schemas (void)
{
   GSettingsSchemaSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   gchar*** arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar*** arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_settings_schema_source_list_schemas(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1208, 1208, 0);
}

static void sl_gtk_gl_area_get_has_depth_buffer (void)
{
   gboolean retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_has_depth_buffer(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1209, 1209, 0);
}

static void sl_gtk_widget_thaw_child_notify (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_thaw_child_notify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1210, 1210, 0);
}

static void sl_pango_layout_is_ellipsized (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_is_ellipsized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1211, 1211, 0);
}

static void sl_g_strdupv (void)
{
   gchar** retval;
   gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_strdupv(arg1);
   push_null_term_str_array (retval, "g_strdupv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1212, 1212, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_drag_context_get_drag_window (void)
{
   GdkWindow* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_drag_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1213, 1213, 0);
}

static void sl_gtk_list_box_row_is_selected (void)
{
   gboolean retval;
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_is_selected(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1214, 1214, 0);
}

static void sl_gtk_expander_set_expanded (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_expanded(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1215, 1215, 0);
}

static void sl_gtk_cell_view_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1216, 1216, 0);
}

static void sl_g_app_info_get_description (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_description(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1217, 1217, 0);
}

static void sl_g_app_info_get_name (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1218, 1218, 0);
}

static void sl_gdk_window_set_background_rgba (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_background_rgba(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1219, 1219, 0);
}

static void sl_gtk_combo_box_get_title (void)
{
   const gchar* retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1220, 1220, 0);
}

static void sl_gtk_accel_map_add_entry (void)
{
   gchar* arg1;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_add_entry(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1221, 1221, 0);
}

static void sl_g_param_spec_get_blurb (void)
{
   const gchar* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_blurb(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1222, 1222, 0);
}

static void sl_gtk_file_chooser_get_preview_uri (void)
{
   char* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_preview_uri(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1223, 1223, 0);
}

static void sl_gtk_gesture_set_window (void)
{
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_gesture_set_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1224, 1224, 0);
}

static void sl_gtk_file_chooser_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1225, 1225, 0);
}

static void sl_gtk_tree_view_convert_bin_window_to_tree_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_bin_window_to_tree_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1226, 1226, 0);
}

static void sl_gtk_file_chooser_set_uri (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_set_uri(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1227, 1227, 0);
}

static void sl_gtk_label_set_justify (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkJustification arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_justify(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1228, 1228, 0);
}

static void sl_g_bookmark_file_get_uris (void)
{
   gchar** retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_bookmark_file_get_uris(arg1, &arg2);
   push_null_term_str_array (retval, "g_bookmark_file_get_uris", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1229, 1229, 0);
}

static void sl_gtk_widget_has_default (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_has_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1230, 1230, 0);
}

static void sl_gdk_selection_property_get (void)
{
   gint retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guchar** arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom* arg3;
   Slirp_Ref *arg3_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg3,0x0);
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(guchar_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_selection_property_get(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1231, 1231, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_g_str_has_prefix (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_str_has_prefix(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1232, 1232, 0);
}

static void sl_g_utf8_pointer_to_offset (void)
{
   glong retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_utf8_pointer_to_offset(arg1, arg2);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1233, 1233, 0);
}

static void sl_g_settings_range_check (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_range_check(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1234, 1234, 0);
}

static void sl_gtk_widget_set_can_default (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_can_default(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1235, 1235, 0);
}

static void sl_gtk_assistant_insert_page (void)
{
   gint retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_insert_page(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1236, 1236, 0);
}

static void sl_pango_cairo_update_context (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_update_context(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1237, 1237, 0);
}

static void sl_g_get_language_names (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_language_names();
   push_null_term_str_array ((char **) retval, "g_get_language_names", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1238, 1238, 0);
}

static void sl_gtk_clipboard_store (void)
{
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_clipboard_store(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1239, 1239, 0);
}

static void sl_pango_attr_font_desc_new (void)
{
   PangoAttribute* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_font_desc_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1240, 1240, 0);
}

static void sl_gtk_header_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1241, 1241, 0);
}

static void sl_g_file_info_set_attribute_mask (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileAttributeMatcher* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_mask(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1242, 1242, 0);
}

static void sl_pango_font_description_merge (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_merge(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1243, 1243, 0);
}

static void sl_gtk_style_context_get_border_color (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_border_color(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1244, 1244, 0);
}

static void sl_g_variant_new_strv (void)
{
   GVariant* retval;
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_strv(arg1,  arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1245, 1245, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_pango_layout_set_tabs (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoTabArray* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_layout_set_tabs(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1246, 1246, 0);
}

static void sl_gdk_set_show_events (void)
{
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_set_show_events( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1247, 1247, 0);
}

static void sl_gtk_notebook_get_tab_reorderable (void)
{
   gboolean retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_reorderable(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1248, 1248, 0);
}

static void sl_gdk_window_thaw_updates (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_thaw_updates(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1249, 1249, 0);
}

static void sl_gtk_icon_view_set_column_spacing (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_column_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1250, 1250, 0);
}

static void sl_g_settings_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1251, 1251, 0);
}

static void sl_g_menu_attribute_iter_next (void)
{
   gboolean retval;
   GMenuAttributeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_attribute_iter_next(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1252, 1252, 0);
}

static void sl_gtk_event_controller_scroll_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_scroll_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1253, 1253, 0);
}

static void sl_g_app_launch_context_get_environment (void)
{
   char** retval;
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_launch_context_get_environment(arg1);
   push_null_term_str_array (retval, "g_app_launch_context_get_environment", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1254, 1254, 0);
}

static void sl_gdk_window_set_modal_hint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_modal_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1255, 1255, 0);
}

static void sl_gtk_scale_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1256, 1256, 0);
}

static void sl_gtk_range_get_slider_range (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_get_slider_range(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1257, 1257, 0);
}

static void sl_gtk_button_set_alignment (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_alignment(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1258, 1258, 0);
}

static void sl_gtk_icon_view_get_pixbuf_column (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_pixbuf_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1259, 1259, 0);
}

static void sl_g_app_info_reset_type_associations (void)
{
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   g_app_info_reset_type_associations(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1260, 1260, 0);
}

static void sl_gtk_notebook_get_n_pages (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_n_pages(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1261, 1261, 0);
}

static void sl_g_mount_get_root (void)
{
   GFile* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_root(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1262, 1262, 0);
}

static void sl_gtk_event_controller_set_propagation_phase (void)
{
   GtkEventController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPropagationPhase arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_event_controller_set_propagation_phase(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1263, 1263, 0);
}

static void sl_gtk_image_get_stock (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_get_stock(arg1, arg2, &arg3);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1264, 1264, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_scrollable_set_vscroll_policy (void)
{
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkScrollablePolicy arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrollable_set_vscroll_policy(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1265, 1265, 0);
}

static void sl_gtk_application_add_accelerator (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GVariant* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(GVariant_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_add_accelerator(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1266, 1266, 0);
}

static void sl_g_match_info_unref (void)
{
   GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_match_info_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1267, 1267, 0);
}

static void sl_gtk_list_box_row_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1268, 1268, 0);
}

static void sl_gtk_menu_item_get_submenu (void)
{
   GtkWidget* retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_submenu(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1269, 1269, 0);
}

static void sl_g_file_info_copy_into (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_copy_into(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1270, 1270, 0);
}

static void sl_gtk_search_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1271, 1271, 0);
}

static void sl_gtk_tree_model_ref_node (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_ref_node(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1272, 1272, 0);
}

static void sl_gtk_toggle_button_set_mode (void)
{
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toggle_button_set_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1273, 1273, 0);
}

static void sl_g_key_file_get_integer (void)
{
   gint retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_integer(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1274, 1274, 0);
}

static void sl_g_settings_schema_key_get_default_value (void)
{
   GVariant* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_default_value(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1275, 1275, 0);
}

static void sl_gdk_rectangle_equal (void)
{
   gboolean retval;
   GdkRectangle* arg1 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkRectangle_Layout)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_rectangle_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkRectangle_Layout);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1276, 1276, 0);
}

static void sl_gtk_alternative_dialog_button_order (void)
{
   gboolean retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_alternative_dialog_button_order(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1277, 1277, 0);
}

static void sl_gdk_keymap_add_virtual_modifiers (void)
{
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierType* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(GdkModifierType),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_keymap_add_virtual_modifiers(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1278, 1278, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_container_propagate_draw (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   cairo_t* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_propagate_draw(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1279, 1279, 0);
}

static void sl_gtk_level_bar_set_inverted (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_level_bar_set_inverted(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1280, 1280, 0);
}

static void sl_gtk_stack_set_vhomogeneous (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_vhomogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1281, 1281, 0);
}

static void sl_gtk_gesture_single_get_current_sequence (void)
{
   GdkEventSequence* retval;
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_current_sequence(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1282, 1282, 0);
}

static void sl_gtk_entry_get_alignment (void)
{
   gfloat retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_alignment(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1283, 1283, 0);
}

static void sl_g_str_match_string (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_str_match_string(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1284, 1284, 0);
}

static void sl_g_uuid_string_is_valid (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_uuid_string_is_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1285, 1285, 0);
}

static void sl_g_variant_get_int32 (void)
{
   gint32 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_int32(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1286, 1286, 0);
}

static void sl_g_variant_get_strv (void)
{
   const gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_get_strv(arg1, &arg2);
   (void)SLang_push_opaque(string_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1287, 1287, 0);
}

static void sl_gtk_widget_get_allocated_height (void)
{
   int retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_allocated_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1288, 1288, 0);
}

static void sl_gtk_cell_renderer_toggle_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_toggle_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1289, 1289, 0);
}

static void sl_pango_font_description_set_size (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1290, 1290, 0);
}

static void sl_pango_layout_get_width (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1291, 1291, 0);
}

static void sl_gtk_accel_group_lock (void)
{
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_accel_group_lock(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1292, 1292, 0);
}

static void sl_gtk_text_iter_get_slice (void)
{
   gchar* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_get_slice(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1293, 1293, 0);
}

static void sl_gtk_button_get_focus_on_click (void)
{
   gboolean retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_focus_on_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1294, 1294, 0);
}

static void sl_gtk_tree_view_set_grid_lines (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewGridLines arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_grid_lines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1295, 1295, 0);
}

static void sl_gtk_menu_button_set_direction (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkArrowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_button_set_direction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1296, 1296, 0);
}

static void sl_gtk_menu_item_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1297, 1297, 0);
}

static void sl_g_socket_set_multicast_ttl (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_multicast_ttl(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1298, 1298, 0);
}

static void sl_gtk_entry_buffer_emit_deleted_text (void)
{
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_buffer_emit_deleted_text(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1299, 1299, 0);
}

static void sl_gtk_print_settings_set_use_color (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_use_color(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1300, 1300, 0);
}

static void sl_gtk_scrolled_window_get_policy (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPolicyType arg2;
   GtkPolicyType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_get_policy(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1301, 1301, 0);
}

static void sl_gtk_recent_chooser_set_local_only (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_local_only(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1302, 1302, 0);
}

static void sl_gtk_text_buffer_delete_mark_by_name (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_delete_mark_by_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1303, 1303, 0);
}

static void sl_gdk_display_supports_cursor_alpha (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_cursor_alpha(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1304, 1304, 0);
}

static void sl_gtk_entry_get_icon_name (void)
{
   const gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_name(arg1,  arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1305, 1305, 0);
}

static void sl_g_file_info_get_file_type (void)
{
   GFileType retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_file_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1306, 1306, 0);
}

static void sl_g_simple_proxy_resolver_set_uri_proxy (void)
{
   GSimpleProxyResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_proxy_resolver_set_uri_proxy(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1307, 1307, 0);
}

static void sl_gtk_text_iter_set_visible_line_offset (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_visible_line_offset(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1308, 1308, 0);
}

static void sl_g_variant_new_uint32 (void)
{
   GVariant* retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_uint32( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1309, 1309, 0);
}

static void sl_gtk_render_handle (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_handle(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1310, 1310, 0);
}

static void sl_gtk_entry_set_attributes (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttrList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_attributes(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1311, 1311, 0);
}

static void sl_pango_renderer_get_color (void)
{
   PangoColor* retval;
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_renderer_get_color(arg1,  arg2);
   (void) SLang_push_cstruct ((VOID_STAR) retval, PangoColor_Layout);
;
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1312, 1312, 0);
}

static void sl_gtk_widget_get_vexpand (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_vexpand(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1313, 1313, 0);
}

static void sl_gtk_window_get_resize_grip_area (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_resize_grip_area(arg1, arg2);
   (void)SLang_push_int(retval);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1314, 1314, 0);
}

static void sl_gdk_window_end_draw_frame (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDrawingContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_end_draw_frame(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1315, 1315, 0);
}

static void sl_gtk_editable_get_selection_bounds (void)
{
   gboolean retval;
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_editable_get_selection_bounds(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1316, 1316, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_window_get_urgency_hint (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_urgency_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1317, 1317, 0);
}

static void sl_gtk_text_buffer_deserialize_get_can_create_tags (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_deserialize_get_can_create_tags(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1318, 1318, 0);
}

static void sl_gdk_display_get_monitor_at_point (void)
{
   GdkMonitor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_monitor_at_point(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1319, 1319, 0);
}

static void sl_gdk_cairo_set_source_window (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_set_source_window(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1320, 1320, 0);
}

static void sl_pango_font_get_metrics (void)
{
   PangoFontMetrics* retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLanguage* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_font_get_metrics(arg1, arg2);
   (void)SLang_push_opaque(PangoFontMetrics_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1321, 1321, 0);
}

static void sl_gtk_popover_get_modal (void)
{
   gboolean retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_modal(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1322, 1322, 0);
}

static void sl_gtk_tree_model_row_deleted (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_row_deleted(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1323, 1323, 0);
}

static void sl_gdk_drag_context_get_dest_window (void)
{
   GdkWindow* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_dest_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1324, 1324, 0);
}

static void sl_g_file_info_remove_attribute (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_remove_attribute(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1325, 1325, 0);
}

static void sl_gtk_cell_area_activate_cell (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRenderer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkEvent* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_activate_cell(arg1, arg2, arg3, arg4, arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1326, 1326, 0);
}

static void sl_gtk_application_get_window_by_id (void)
{
   GtkWindow* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_window_by_id(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1327, 1327, 0);
}

static void sl_gtk_assistant_previous_page (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_previous_page(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1328, 1328, 0);
}

static void sl_gtk_tree_store_iter_is_valid (void)
{
   gboolean retval;
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_store_iter_is_valid(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1329, 1329, 0);
}

static void sl_gdk_window_set_cursor (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkCursor* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_cursor(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1330, 1330, 0);
}

static void sl_gtk_combo_box_get_id_column (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_id_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1331, 1331, 0);
}

static void sl_gtk_builder_add_from_resource (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_builder_add_from_resource(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1332, 1332, 0);
}

static void sl_gdk_cursor_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1333, 1333, 0);
}

static void sl_gtk_target_entry_new (void)
{
   GtkTargetEntry* retval;
   gchar* arg1;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_entry_new(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1334, 1334, 0);
}

static void sl_gtk_color_button_set_title (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_color_button_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1335, 1335, 0);
}

static void sl_gtk_file_chooser_get_extra_widget (void)
{
   GtkWidget* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_extra_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1336, 1336, 0);
}

static void sl_gdk_device_warp (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_device_warp(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1337, 1337, 0);
}

static void sl_gdk_pixbuf_new_from_bytes (void)
{
   GdkPixbuf* retval;
   GBytes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColorspace arg2;
   gboolean arg3;
   int arg4;
   int arg5;
   int arg6;
   int arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_new_from_bytes(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1338, 1338, 0);
}

static void sl_gdk_window_set_device_events (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkEventMask arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_device_events(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1339, 1339, 0);
}

static void sl_g_settings_backend_path_changed (void)
{
   GSettingsBackend* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_backend_path_changed(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1340, 1340, 0);
}

static void sl_g_strv_length (void)
{
   guint retval;
   gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_strv_length(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1341, 1341, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_mount_get_default_location (void)
{
   GFile* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_default_location(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1342, 1342, 0);
}

static void sl_gtk_text_iter_get_child_anchor (void)
{
   GtkTextChildAnchor* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_child_anchor(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1343, 1343, 0);
}

static void sl_gtk_about_dialog_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1344, 1344, 0);
}

static void sl_gtk_gesture_multi_press_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_multi_press_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1345, 1345, 0);
}

static void sl_gtk_tool_button_set_icon_name (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_button_set_icon_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1346, 1346, 0);
}

static void sl_gtk_entry_set_text (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1347, 1347, 0);
}

static void sl_gtk_places_sidebar_set_open_flags (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPlacesOpenFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_open_flags(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1348, 1348, 0);
}

static void sl_gtk_info_bar_response (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_response(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1349, 1349, 0);
}

static void sl_g_file_info_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1350, 1350, 0);
}

static void sl_pango_layout_get_auto_dir (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_auto_dir(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1351, 1351, 0);
}

static void sl_gtk_font_chooser_get_font_features (void)
{
   char* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_features(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1352, 1352, 0);
}

static void sl_gtk_icon_info_is_symbolic (void)
{
   gboolean retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_is_symbolic(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1353, 1353, 0);
}

static void sl_gtk_separator_tool_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_tool_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1354, 1354, 0);
}

static void sl_gtk_combo_box_new_with_model_and_entry (void)
{
   GtkWidget* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new_with_model_and_entry(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1355, 1355, 0);
}

static void sl_gtk_widget_add_device_events (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkEventMask arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_add_device_events(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1356, 1356, 0);
}

static void sl_gtk_tree_model_get_iter_from_string (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   retval = gtk_tree_model_get_iter_from_string(arg1, arg2, arg3);
   if (retval)
      (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   else
      {
         SLfree ((char *) arg2);
         (void) SLang_push_null ();
      }
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1357, 1357, 0);
}

static void sl_gtk_combo_box_text_insert (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg3, NULL)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_combo_box_text_insert(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1358, 1358, 0);
}

static void sl_g_path_is_absolute (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_path_is_absolute(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1359, 1359, 0);
}

static void sl_gdk_cairo_draw_from_gl (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   int arg7;
   int arg8;
   int arg9;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 9) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg9)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_draw_from_gl(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8,  arg9);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1360, 1360, 0);
}

static void sl_gtk_range_get_lower_stepper_sensitivity (void)
{
   GtkSensitivityType retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_lower_stepper_sensitivity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1361, 1361, 0);
}

static void sl_gtk_check_menu_item_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_new_with_label(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1362, 1362, 0);
}

static void sl_gtk_level_bar_get_max_value (void)
{
   gdouble retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_max_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1363, 1363, 0);
}

static void sl_g_rand_new (void)
{
   GRand* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_rand_new();
   (void)SLang_push_opaque(GRand_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1364, 1364, 0);
}

static void sl_g_value_set_string (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_string(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1365, 1365, 0);
}

static void sl_g_app_info_get_commandline (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_commandline(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1366, 1366, 0);
}

static void sl_gdk_window_get_scale_factor (void)
{
   gint retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_scale_factor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1367, 1367, 0);
}

static void sl_g_key_file_set_uint64 (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   guint64 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_uint64(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1368, 1368, 0);
}

static void sl_pango_font_metrics_get_approximate_char_width (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_approximate_char_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1369, 1369, 0);
}

static void sl_gtk_text_view_get_cursor_locations (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_get_cursor_locations(arg1, arg2, arg3, arg4);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   (void) SLang_push_cstruct ((VOID_STAR) arg4, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1370, 1370, 0);
}

static void sl_gtk_file_chooser_get_current_folder_file (void)
{
   GFile* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_current_folder_file(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1371, 1371, 0);
}

static void sl_g_socket_new (void)
{
   GSocket* retval;
   GSocketFamily arg1;
   GSocketType arg2;
   GSocketProtocol arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_socket_new( arg1,  arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1372, 1372, 0);
}

static void sl_gtk_list_box_row_get_header (void)
{
   GtkWidget* retval;
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_get_header(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1373, 1373, 0);
}

static void sl_g_date_time_add_minutes (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_minutes(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1374, 1374, 0);
}

static void sl_g_variant_get_type_string (void)
{
   const gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_type_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1375, 1375, 0);
}

static void sl_gtk_widget_add_mnemonic_label (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_add_mnemonic_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1376, 1376, 0);
}

static void sl_gtk_tree_model_sort_clear_cache (void)
{
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_model_sort_clear_cache(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1377, 1377, 0);
}

static void sl_g_mount_unshadow (void)
{
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_unshadow(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1378, 1378, 0);
}

static void sl_gtk_cell_area_context_get_preferred_width_for_height (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_get_preferred_width_for_height(arg1,  arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1379, 1379, 0);
}

static void sl_gtk_application_get_menubar (void)
{
   GMenuModel* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_menubar(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1380, 1380, 0);
}

static void sl_g_mount_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1381, 1381, 0);
}

static void sl_gdk_display_get_primary_monitor (void)
{
   GdkMonitor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_primary_monitor(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1382, 1382, 0);
}

static void sl_g_key_file_set_boolean_list (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gboolean* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg4,0x0);
   gsize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = (gsize) ref_get_size(arg4_r, 0);
   g_key_file_set_boolean_list(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1383, 1383, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_g_variant_type_is_basic (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_basic(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1384, 1384, 0);
}

static void sl_gtk_stack_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1385, 1385, 0);
}

static void sl_gtk_print_settings_new (void)
{
   GtkPrintSettings* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1386, 1386, 0);
}

static void sl_gtk_entry_get_tabs (void)
{
   PangoTabArray* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_tabs(arg1);
   (void)SLang_push_opaque(PangoTabArray_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1387, 1387, 0);
}

static void sl_gtk_text_view_set_bottom_margin (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_bottom_margin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1388, 1388, 0);
}

static void sl_gtk_toggle_tool_button_new_from_stock (void)
{
   GtkToolItem* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_tool_button_new_from_stock(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1389, 1389, 0);
}

static void sl_g_variant_compare (void)
{
   gint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1390, 1390, 0);
}

static void sl_gtk_recent_chooser_widget_new_for_manager (void)
{
   GtkWidget* retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_widget_new_for_manager(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1391, 1391, 0);
}

static void sl_gdk_gl_context_realize (void)
{
   gboolean retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_gl_context_realize(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1392, 1392, 0);
}

static void sl_gtk_drag_begin_with_coordinates (void)
{
   GdkDragContext* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTargetList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDragAction arg3;
   gint arg4;
   GdkEvent* arg5;
   Slirp_Opaque* arg5_o = NULL;
   gint arg6;
   gint arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg2, &arg2_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_drag_begin_with_coordinates(arg1, arg2,  arg3,  arg4, arg5,  arg6,  arg7);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1393, 1393, 0);
}

static void sl_g_socket_check_connect_result (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_check_connect_result(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1394, 1394, 0);
}

static void sl_gtk_widget_set_font_options (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_font_options_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_font_options(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1395, 1395, 0);
}

static void sl_g_date_get_julian (void)
{
   guint32 retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_julian(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1396, 1396, 0);
}

static void sl_gtk_notebook_get_scrollable (void)
{
   gboolean retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_scrollable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1397, 1397, 0);
}

static void sl_gtk_gesture_single_get_button (void)
{
   guint retval;
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_button(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1398, 1398, 0);
}

static void sl_g_value_set_int64 (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint64 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_int64(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1399, 1399, 0);
}

static void sl_g_key_file_remove_key (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_remove_key(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1400, 1400, 0);
}

static void sl_gtk_show_uri_on_window (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   guint32 arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_show_uri_on_window(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1401, 1401, 0);
}

static void sl_g_time_zone_is_dst (void)
{
   gboolean retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_is_dst(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1402, 1402, 0);
}

static void sl_gtk_scrolled_window_get_kinetic_scrolling (void)
{
   gboolean retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_kinetic_scrolling(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1403, 1403, 0);
}

static void sl_gtk_native_dialog_get_title (void)
{
   const char* retval;
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_native_dialog_get_title(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1404, 1404, 0);
}

static void sl_gtk_icon_view_scroll_to_path (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gfloat arg4;
   gfloat arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_scroll_to_path(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1405, 1405, 0);
}

static void sl_gtk_spin_button_get_value_as_int (void)
{
   gint retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_value_as_int(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1406, 1406, 0);
}

static void sl_gtk_tree_view_column_clear_attributes (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_clear_attributes(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1407, 1407, 0);
}

static void sl_g_file_mount_enclosing_volume_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_mount_enclosing_volume_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1408, 1408, 0);
}

static void sl_gtk_text_buffer_get_paste_target_list (void)
{
   GtkTargetList* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_paste_target_list(arg1);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1409, 1409, 0);
}

static void sl_g_app_info_monitor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_monitor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1410, 1410, 0);
}

static void sl_gtk_link_button_set_visited (void)
{
   GtkLinkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_link_button_set_visited(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1411, 1411, 0);
}

static void sl_gdk_window_set_startup_id (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_startup_id(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1412, 1412, 0);
}

static void sl_gtk_tool_item_get_expand (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_expand(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1413, 1413, 0);
}

static void sl_gtk_combo_box_text_remove_all (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_text_remove_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1414, 1414, 0);
}

static void sl_gtk_recent_chooser_get_show_icons (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_show_icons(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1415, 1415, 0);
}

static void sl_g_main_context_add_poll (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPollFD* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_main_context_add_poll(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1416, 1416, 0);
}

static void sl_gdk_display_manager_get (void)
{
   GdkDisplayManager* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_manager_get();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1417, 1417, 0);
}

static void sl_gtk_menu_item_activate (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_activate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1418, 1418, 0);
}

static void sl_pango_font_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1419, 1419, 0);
}

static void sl_gtk_scale_get_has_origin (void)
{
   gboolean retval;
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_has_origin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1420, 1420, 0);
}

static void sl_gtk_assistant_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_assistant_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1421, 1421, 0);
}

static void sl_g_app_info_monitor_get (void)
{
   GAppInfoMonitor* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_monitor_get();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1422, 1422, 0);
}

static void sl_gtk_tree_model_filter_get_model (void)
{
   GtkTreeModel* retval;
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_filter_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1423, 1423, 0);
}

static void sl_g_bookmark_file_move_item (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_move_item(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1424, 1424, 0);
}

static void sl_g_unichar_istitle (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_istitle( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1425, 1425, 0);
}

static void sl_gdk_selection_send_notify (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkAtom arg4;
   Slirp_Opaque* arg4_o = NULL;
   guint32 arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_selection_send_notify(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1426, 1426, 0);
}

static void sl_gtk_link_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_link_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1427, 1427, 0);
}

static void sl_gtk_about_dialog_set_authors (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_about_dialog_set_authors(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1428, 1428, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_menu_tool_button_new_from_stock (void)
{
   GtkToolItem* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_tool_button_new_from_stock(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1429, 1429, 0);
}

static void sl_gdk_wm_function_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_wm_function_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1430, 1430, 0);
}

static void sl_g_file_get_parse_name (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_parse_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1431, 1431, 0);
}

static void sl_gtk_file_chooser_remove_shortcut_folder (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_remove_shortcut_folder(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1432, 1432, 0);
}

static void sl_pango_layout_get_iter (void)
{
   PangoLayoutIter* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_iter(arg1);
   (void)SLang_push_opaque(PangoLayoutIter_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1433, 1433, 0);
}

static void sl_gtk_printer_get_capabilities (void)
{
   GtkPrintCapabilities retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_capabilities(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1434, 1434, 0);
}

static void sl_gtk_builder_get_application (void)
{
   GtkApplication* retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_get_application(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1435, 1435, 0);
}

static void sl_g_file_query_info_finish (void)
{
   GFileInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_info_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1436, 1436, 0);
}

static void sl_gtk_flow_box_get_selection_mode (void)
{
   GtkSelectionMode retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_selection_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1437, 1437, 0);
}

static void sl_gtk_tree_selection_get_selected_rows (void)
{
   GList* retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel** arg2;
   Slirp_Ref *arg2_r = ref_new(GObject_Type,sizeof(GtkTreeModel*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_get_selected_rows(arg1, arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1438, 1438, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_pango_layout_get_tabs (void)
{
   PangoTabArray* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_tabs(arg1);
   (void)SLang_push_opaque(PangoTabArray_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1439, 1439, 0);
}

static void sl_gtk_text_view_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1440, 1440, 0);
}

static void sl_gtk_recent_filter_get_needed (void)
{
   GtkRecentFilterFlags retval;
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_filter_get_needed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1441, 1441, 0);
}

static void sl_g_date_add_months (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_add_months(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1442, 1442, 0);
}

static void sl_gtk_icon_theme_lookup_by_gicon_for_scale (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   GtkIconLookupFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_lookup_by_gicon_for_scale(arg1, arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1443, 1443, 0);
}

static void sl_gtk_entry_completion_complete (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_complete(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1444, 1444, 0);
}

static void sl_gtk_editable_delete_selection (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_delete_selection(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1445, 1445, 0);
}

static void sl_g_settings_schema_source_unref (void)
{
   GSettingsSchemaSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_schema_source_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1446, 1446, 0);
}

static void sl_gtk_file_chooser_get_action (void)
{
   GtkFileChooserAction retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_action(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1447, 1447, 0);
}

static void sl_gtk_notebook_prepend_page (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_prepend_page(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1448, 1448, 0);
}

static void sl_g_value_set_double (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_double(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1449, 1449, 0);
}

static void sl_gtk_tool_item_set_tooltip_text (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_set_tooltip_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1450, 1450, 0);
}

static void sl_gdk_pixbuf_init_modules (void)
{
   gboolean retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_init_modules(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1451, 1451, 0);
}

static void sl_gtk_icon_theme_append_search_path (void)
{
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_theme_append_search_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1452, 1452, 0);
}

static void sl_gdk_display_device_is_grabbed (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_display_device_is_grabbed(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1453, 1453, 0);
}

static void sl_gtk_tool_palette_get_drag_target_item (void)
{
   const GtkTargetEntry* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_drag_target_item();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1454, 1454, 0);
}

static void sl_gtk_widget_set_margin_right (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_right(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1455, 1455, 0);
}

static void sl_g_app_launch_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_launch_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1456, 1456, 0);
}

static void sl_gtk_native_dialog_run (void)
{
   gint retval;
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_native_dialog_run(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1457, 1457, 0);
}

static void sl_gdk_keymap_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1458, 1458, 0);
}

static void sl_gtk_list_store_iter_is_valid (void)
{
   gboolean retval;
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_list_store_iter_is_valid(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1459, 1459, 0);
}

static void sl_gtk_grid_set_row_homogeneous (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_row_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1460, 1460, 0);
}

static void sl_gdk_device_get_axes (void)
{
   GdkAxisFlags retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_axes(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1461, 1461, 0);
}

static void sl_g_notification_set_default_action (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_set_default_action(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1462, 1462, 0);
}

static void sl_gtk_scale_button_get_plus_button (void)
{
   GtkWidget* retval;
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_plus_button(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1463, 1463, 0);
}

static void sl_gtk_cell_area_add_focus_sibling (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRenderer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_add_focus_sibling(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1464, 1464, 0);
}

static void sl_g_value_get_schar (void)
{
   gint8 retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_schar(arg1);
   (void)SLang_push_char(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1465, 1465, 0);
}

static void sl_g_inet_address_get_is_site_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_site_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1466, 1466, 0);
}

static void sl_gtk_about_dialog_get_license_type (void)
{
   GtkLicense retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_license_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1467, 1467, 0);
}

static void sl_gtk_box_get_center_widget (void)
{
   GtkWidget* retval;
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_get_center_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1468, 1468, 0);
}

static void sl_g_value_get_param (void)
{
   GParamSpec* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_param(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1469, 1469, 0);
}

static void sl_gtk_menu_shell_get_parent_shell (void)
{
   GtkWidget* retval;
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_shell_get_parent_shell(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1470, 1470, 0);
}

static void sl_gdk_event_get_keycode (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_keycode(arg1, &arg2);
   if (retval)
      (void)SLang_push_ushort(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1471, 1471, 0);
}

static void sl_g_resources_lookup_data (void)
{
   GBytes* retval;
   char* arg1;
   GResourceLookupFlags arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resources_lookup_data(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1472, 1472, 0);
}

static void sl_pango_tab_array_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_tab_array_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1473, 1473, 0);
}

static void sl_gdk_event_set_device (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_event_set_device(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1474, 1474, 0);
}

static void sl_g_variant_get_child_value (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_child_value(arg1,  arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1475, 1475, 0);
}

static void sl_gtk_tree_view_column_get_sort_indicator (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_sort_indicator(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1476, 1476, 0);
}

static void sl_gtk_widget_path_iter_get_siblings (void)
{
   const GtkWidgetPath* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_siblings(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1477, 1477, 0);
}

static void sl_gtk_print_settings_get_paper_size (void)
{
   GtkPaperSize* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_paper_size(arg1);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1478, 1478, 0);
}

static void sl_gtk_container_set_focus_vadjustment (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_set_focus_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1479, 1479, 0);
}

static void sl_gtk_text_iter_is_cursor_position (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_is_cursor_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1480, 1480, 0);
}

static void sl_gdk_device_tool_get_hardware_id (void)
{
   guint64 retval;
   GdkDeviceTool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_tool_get_hardware_id(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1481, 1481, 0);
}

static void sl_g_cancellable_push_current (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_push_current(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1482, 1482, 0);
}

static void sl_gdk_get_display_arg_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_get_display_arg_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1483, 1483, 0);
}

static void sl_gdk_event_get (void)
{
   GdkEvent* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get();
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1484, 1484, 0);
}

static void sl_g_get_user_special_dir (void)
{
   const gchar* retval;
   GUserDirectory arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_special_dir( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1485, 1485, 0);
}

static void sl_g_resolver_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_resolver_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1486, 1486, 0);
}

static void sl_gtk_print_job_get_printer (void)
{
   GtkPrinter* retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_printer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1487, 1487, 0);
}

static void sl_gtk_tree_view_column_get_sort_column_id (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_sort_column_id(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1488, 1488, 0);
}

static void sl_gtk_frame_get_label_widget (void)
{
   GtkWidget* retval;
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_frame_get_label_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1489, 1489, 0);
}

static void sl_g_app_launch_context_launch_failed (void)
{
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_app_launch_context_launch_failed(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1490, 1490, 0);
}

static void sl_g_settings_schema_key_range_check (void)
{
   gboolean retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_schema_key_range_check(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1491, 1491, 0);
}

static void sl_gtk_grid_get_row_homogeneous (void)
{
   gboolean retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_row_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1492, 1492, 0);
}

static void sl_g_key_file_set_boolean (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_boolean(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1493, 1493, 0);
}

static void sl_g_strdup (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strdup(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1494, 1494, 0);
}

static void sl_gtk_file_filter_new (void)
{
   GtkFileFilter* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1495, 1495, 0);
}

static void sl_g_file_icon_get_file (void)
{
   GFile* retval;
   GFileIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_icon_get_file(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1496, 1496, 0);
}

static void sl_gdk_window_is_destroyed (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_is_destroyed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1497, 1497, 0);
}

static void sl_gtk_tree_view_get_selection (void)
{
   GtkTreeSelection* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_selection(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1498, 1498, 0);
}

static void sl_gdk_device_manager_list_devices (void)
{
   GList* retval;
   GdkDeviceManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDeviceType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_manager_list_devices(arg1,  arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1499, 1499, 0);
}

static void sl_gtk_recent_chooser_get_local_only (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_local_only(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1500, 1500, 0);
}

static void sl_g_file_get_child (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_get_child(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1501, 1501, 0);
}

static void sl_gdk_frame_clock_get_history_start (void)
{
   gint64 retval;
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_history_start(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1502, 1502, 0);
}

static void sl_gtk_file_filter_new_from_gvariant (void)
{
   GtkFileFilter* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_new_from_gvariant(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1503, 1503, 0);
}

static void sl_g_bookmark_file_new (void)
{
   GBookmarkFile* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_bookmark_file_new();
   (void)SLang_push_opaque(GBookmarkFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1504, 1504, 0);
}

static void sl_g_variant_new_bytestring_array (void)
{
   GVariant* retval;
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_bytestring_array(arg1,  arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1505, 1505, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_visual_get_depth (void)
{
   gint retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_depth(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1506, 1506, 0);
}

static void sl_g_file_attribute_info_list_ref (void)
{
   GFileAttributeInfoList* retval;
   GFileAttributeInfoList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_info_list_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1507, 1507, 0);
}

static void sl_gtk_page_setup_to_file (void)
{
   gboolean retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_page_setup_to_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1508, 1508, 0);
}

static void sl_gtk_button_set_relief (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkReliefStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_relief(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1509, 1509, 0);
}

static void sl_gtk_stack_get_vhomogeneous (void)
{
   gboolean retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_vhomogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1510, 1510, 0);
}

static void sl_gtk_notebook_get_menu_label (void)
{
   GtkWidget* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_menu_label(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1511, 1511, 0);
}

static void sl_gtk_widget_get_mapped (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_mapped(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1512, 1512, 0);
}

static void sl_gtk_header_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1513, 1513, 0);
}

static void sl_gtk_print_settings_new_from_gvariant (void)
{
   GtkPrintSettings* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_new_from_gvariant(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1514, 1514, 0);
}

static void sl_gtk_list_box_get_selected_row (void)
{
   GtkListBoxRow* retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_selected_row(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1515, 1515, 0);
}

static void sl_g_mount_unmount_with_operation_finish (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mount_unmount_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1516, 1516, 0);
}

static void sl_gtk_widget_set_tooltip_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_tooltip_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1517, 1517, 0);
}

static void sl_gdk_window_get_height (void)
{
   int retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1518, 1518, 0);
}

static void sl_gtk_window_remove_accel_group (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAccelGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_remove_accel_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1519, 1519, 0);
}

static void sl_gtk_entry_set_input_hints (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkInputHints arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_input_hints(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1520, 1520, 0);
}

static void sl_gtk_app_chooser_button_get_show_dialog_item (void)
{
   gboolean retval;
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_button_get_show_dialog_item(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1521, 1521, 0);
}

static void sl_gtk_print_operation_set_default_page_setup (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSetup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_operation_set_default_page_setup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1522, 1522, 0);
}

static void sl_g_file_info_set_attribute_uint64 (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   guint64 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_uint64(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1523, 1523, 0);
}

static void sl_gtk_font_chooser_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1524, 1524, 0);
}

static void sl_gtk_stack_switcher_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_switcher_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1525, 1525, 0);
}

static void sl_gtk_recent_chooser_set_select_multiple (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_select_multiple(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1526, 1526, 0);
}

static void sl_g_mkdtemp (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_mkdtemp(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1527, 1527, 0);
}

static void sl_g_regex_get_has_cr_or_lf (void)
{
   gboolean retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_has_cr_or_lf(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1528, 1528, 0);
}

static void sl_g_settings_get_uint64 (void)
{
   guint64 retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_uint64(arg1, arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1529, 1529, 0);
}

static void sl_g_menu_item_set_section (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_section(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1530, 1530, 0);
}

static void sl_gdk_drop_finish (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drop_finish(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1531, 1531, 0);
}

static void sl_gtk_app_chooser_widget_get_show_all (void)
{
   gboolean retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_show_all(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1532, 1532, 0);
}

static void sl_gtk_widget_set_clip (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GtkAllocation_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_clip(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GtkAllocation_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1533, 1533, 0);
}

static void sl_gtk_text_iter_forward_to_end (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_forward_to_end(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1534, 1534, 0);
}

static void sl_pango_layout_iter_get_run_readonly (void)
{
   PangoLayoutRun* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_run_readonly(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1535, 1535, 0);
}

static void sl_gtk_offscreen_window_get_surface (void)
{
   cairo_surface_t* retval;
   GtkOffscreenWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_offscreen_window_get_surface(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1536, 1536, 0);
}

static void sl_g_key_file_get_value (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_value(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1537, 1537, 0);
}

static void sl_gtk_text_view_scroll_mark_onscreen (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_scroll_mark_onscreen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1538, 1538, 0);
}

static void sl_gtk_page_setup_get_bottom_margin (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_bottom_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1539, 1539, 0);
}

static void sl_gtk_scrolled_window_set_kinetic_scrolling (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_kinetic_scrolling(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1540, 1540, 0);
}

static void sl_gtk_notebook_reorder_child (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_reorder_child(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1541, 1541, 0);
}

static void sl_gdk_screen_get_monitor_scale_factor (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_scale_factor(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1542, 1542, 0);
}

static void sl_gtk_cell_renderer_set_padding (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_set_padding(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1543, 1543, 0);
}

static void sl_pango_attribute_copy (void)
{
   PangoAttribute* retval;
   const PangoAttribute* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attribute_copy(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1544, 1544, 0);
}

static void sl_g_random_double (void)
{
   gdouble retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_random_double();
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1545, 1545, 0);
}

static void sl_gtk_tool_item_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1546, 1546, 0);
}

static void sl_g_file_set_attributes_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GFileInfo** arg3;
   Slirp_Ref *arg3_r = ref_new(GObject_Type,sizeof(GFileInfo*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_set_attributes_finish(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1547, 1547, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_tool_button_set_label (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_button_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1548, 1548, 0);
}

static void sl_gtk_print_operation_set_support_selection (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_support_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1549, 1549, 0);
}

static void sl_g_timer_reset (void)
{
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_timer_reset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1550, 1550, 0);
}

static void sl_gtk_mount_operation_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_mount_operation_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1551, 1551, 0);
}

static void sl_gtk_layout_get_bin_window (void)
{
   GdkWindow* retval;
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_layout_get_bin_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1552, 1552, 0);
}

static void sl_g_type_check_instance_is_fundamentally_a (void)
{
   gboolean retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_instance_is_fundamentally_a(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1553, 1553, 0);
}

static void sl_gtk_drag_source_set_icon_gicon (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_source_set_icon_gicon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1554, 1554, 0);
}

static void sl_gtk_menu_tool_button_set_arrow_tooltip_markup (void)
{
   GtkMenuToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_tool_button_set_arrow_tooltip_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1555, 1555, 0);
}

static void sl_gtk_icon_view_unset_model_drag_dest (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_unset_model_drag_dest(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1556, 1556, 0);
}

static void sl_g_io_channel_flush (void)
{
   GIOStatus retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_io_channel_flush(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1557, 1557, 0);
}

static void sl_gtk_tree_view_columns_autosize (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_columns_autosize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1558, 1558, 0);
}

static void sl_gtk_cell_renderer_get_alignment (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_get_alignment(arg1, &arg2, &arg3);
   (void)SLang_push_float(arg2);
   (void)SLang_push_float(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1559, 1559, 0);
}

static void sl_gtk_application_get_active_window (void)
{
   GtkWindow* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_active_window(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1560, 1560, 0);
}

static void sl_g_date_time_new_from_timeval_utc (void)
{
   GDateTime* retval;
   GTimeVal* arg1 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GTimeVal_Layout)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_from_timeval_utc(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1561, 1561, 0);
}

static void sl_gdk_owner_change_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_owner_change_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1562, 1562, 0);
}

static void sl_g_regex_match_simple (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   GRegexCompileFlags arg3;
   GRegexMatchFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_match_simple(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1563, 1563, 0);
}

static void sl_gtk_buildable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_buildable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1564, 1564, 0);
}

static void sl_gtk_combo_box_set_active (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1565, 1565, 0);
}

static void sl_gtk_text_buffer_get_line_count (void)
{
   gint retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_line_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1566, 1566, 0);
}

static void sl_g_value_dup_variant (void)
{
   GVariant* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_dup_variant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1567, 1567, 0);
}

static void sl_gtk_print_settings_get_printer (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_printer(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1568, 1568, 0);
}

static void sl_g_socket_get_broadcast (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_broadcast(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1569, 1569, 0);
}

static void sl_gdk_seat_get_pointer (void)
{
   GdkDevice* retval;
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_pointer(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1570, 1570, 0);
}

static void sl_g_socket_join_multicast_group (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_join_multicast_group(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1571, 1571, 0);
}

static void sl_g_unichar_compose (void)
{
   gboolean retval;
   gunichar arg1;
   gunichar arg2;
   gunichar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_compose( arg1,  arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_uint(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1572, 1572, 0);
}

static void sl_gtk_button_box_get_layout (void)
{
   GtkButtonBoxStyle retval;
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_box_get_layout(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1573, 1573, 0);
}

static void sl_gtk_file_chooser_list_shortcut_folder_uris (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_list_shortcut_folder_uris(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1574, 1574, 0);
}

static void sl_gtk_notebook_set_scrollable (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_set_scrollable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1575, 1575, 0);
}

static void sl_pango_font_description_equal (void)
{
   gboolean retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_font_description_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1576, 1576, 0);
}

static void sl_gtk_toolbar_unset_style (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toolbar_unset_style(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1577, 1577, 0);
}

static void sl_gtk_cell_renderer_toggle_set_radio (void)
{
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_toggle_set_radio(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1578, 1578, 0);
}

static void sl_g_app_launch_context_get_display (void)
{
   char* retval;
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAppInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GList* arg3;
   Slirp_Ref *arg3_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_app_launch_context_get_display(arg1, arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1579, 1579, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_mkstemp_full (void)
{
   gint retval;
   gchar* arg1;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_mkstemp_full(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1580, 1580, 0);
}

static void sl_gtk_notebook_get_action_widget (void)
{
   GtkWidget* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPackType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_action_widget(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1581, 1581, 0);
}

static void sl_gtk_gl_area_get_error (void)
{
   GError* retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_error(arg1);
   (void) SLang_push_cstruct ((VOID_STAR) retval, GError_Layout);
;
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1582, 1582, 0);
}

static void sl_g_menu_prepend_submenu (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GMenuModel* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_prepend_submenu(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1583, 1583, 0);
}

static void sl_gtk_places_sidebar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1584, 1584, 0);
}

static void sl_g_mount_can_unmount (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_can_unmount(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1585, 1585, 0);
}

static void sl_gdk_window_get_children_with_user_data (void)
{
   GList* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_get_children_with_user_data(arg1, arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1586, 1586, 0);
}

static void sl_g_main_context_iteration (void)
{
   gboolean retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_iteration(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1587, 1587, 0);
}

static void sl_gtk_tree_path_up (void)
{
   gboolean retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_up(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1588, 1588, 0);
}

static void sl_gtk_tree_view_get_enable_tree_lines (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_enable_tree_lines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1589, 1589, 0);
}

static void sl_gtk_label_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1590, 1590, 0);
}

static void sl_gdk_window_set_composited (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_composited(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1591, 1591, 0);
}

static void sl_g_source_destroy (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_source_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1592, 1592, 0);
}

static void sl_gdk_pixbuf_get_formats (void)
{
   GSList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_formats();
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1593, 1593, 0);
}

static void sl_gtk_assistant_remove_page (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_remove_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1594, 1594, 0);
}

static void sl_gtk_container_set_focus_child (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_set_focus_child(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1595, 1595, 0);
}

static void sl_gtk_widget_insert_action_group (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GActionGroup* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_insert_action_group(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1596, 1596, 0);
}

static void sl_gtk_page_setup_new_from_file (void)
{
   GtkPageSetup* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_page_setup_new_from_file(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1597, 1597, 0);
}

static void sl_gtk_text_attributes_copy (void)
{
   GtkTextAttributes* retval;
   GtkTextAttributes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_attributes_copy(arg1);
   (void)SLang_push_opaque(GtkTextAttributes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1598, 1598, 0);
}

static void sl_g_file_set_attribute_uint32 (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   guint32 arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_uint32(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1599, 1599, 0);
}

static void sl_g_rand_free (void)
{
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_rand_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1600, 1600, 0);
}

static void sl_gtk_app_chooser_button_set_heading (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_app_chooser_button_set_heading(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1601, 1601, 0);
}

static void sl_gtk_stack_sidebar_set_stack (void)
{
   GtkStackSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStack* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_sidebar_set_stack(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1602, 1602, 0);
}

static void sl_g_value_take_param (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_take_param(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1603, 1603, 0);
}

static void sl_pango_layout_set_auto_dir (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_auto_dir(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1604, 1604, 0);
}

static void sl_gtk_overlay_get_overlay_pass_through (void)
{
   gboolean retval;
   GtkOverlay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_overlay_get_overlay_pass_through(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1605, 1605, 0);
}

static void sl_gtk_render_frame_gap (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   GtkPositionType arg7;
   gdouble arg8;
   gdouble arg9;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 9) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg9)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_frame_gap(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8,  arg9);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1606, 1606, 0);
}

static void sl_gtk_cell_renderer_text_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_text_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1607, 1607, 0);
}

static void sl_gtk_icon_view_unselect_all (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1608, 1608, 0);
}

static void sl_gdk_init_check (void)
{
   gboolean retval;
   gint* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg1,0x0);
   gchar*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_init_check(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1609, 1609, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_resource_unref (void)
{
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_resource_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1610, 1610, 0);
}

static void sl_gtk_text_view_get_monospace (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_monospace(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1611, 1611, 0);
}

static void sl_g_app_info_get_default_for_type (void)
{
   GAppInfo* retval;
   char* arg1;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_default_for_type(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1612, 1612, 0);
}

static void sl_gdk_window_set_type_hint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindowTypeHint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_type_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1613, 1613, 0);
}

static void sl_gtk_buildable_construct_child (void)
{
   GObject* retval;
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBuilder* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_buildable_construct_child(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1614, 1614, 0);
}

static void sl_gtk_calendar_set_display_options (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCalendarDisplayOptions arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_set_display_options(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1615, 1615, 0);
}

static void sl_gtk_tree_view_set_expander_column (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumn* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_expander_column(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1616, 1616, 0);
}

static void sl_gtk_progress_bar_set_show_text (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_set_show_text(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1617, 1617, 0);
}

static void sl_gtk_widget_path_iter_add_class (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_add_class(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1618, 1618, 0);
}

static void sl_gtk_entry_get_icon_sensitive (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_sensitive(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1619, 1619, 0);
}

static void sl_g_hmac_unref (void)
{
   GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_hmac_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1620, 1620, 0);
}

static void sl_gtk_accel_map_load (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_load(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1621, 1621, 0);
}

static void sl_gtk_icon_theme_lookup_icon (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   GtkIconLookupFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_lookup_icon(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1622, 1622, 0);
}

static void sl_g_source_get_context (void)
{
   GMainContext* retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_context(arg1);
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1623, 1623, 0);
}

static void sl_gtk_tool_button_get_label (void)
{
   const gchar* retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1624, 1624, 0);
}

static void sl_gtk_combo_box_new_with_model (void)
{
   GtkWidget* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new_with_model(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1625, 1625, 0);
}

static void sl_g_mount_operation_get_password_save (void)
{
   GPasswordSave retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_password_save(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1626, 1626, 0);
}

static void sl_gtk_style_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1627, 1627, 0);
}

static void sl_g_bookmark_file_set_app_info (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   gint arg5;
   time_t arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_bookmark_file_set_app_info(arg1, arg2, arg3, arg4,  arg5,  arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1628, 1628, 0);
}

static void sl_gtk_icon_view_new_with_model (void)
{
   GtkWidget* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_new_with_model(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1629, 1629, 0);
}

static void sl_gtk_selection_remove_all (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_selection_remove_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1630, 1630, 0);
}

static void sl_g_quark_from_static_string (void)
{
   GQuark retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_quark_from_static_string(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1631, 1631, 0);
}

static void sl_g_main_depth (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_depth();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1632, 1632, 0);
}

static void sl_gtk_combo_box_text_append_text (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_text_append_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1633, 1633, 0);
}

static void sl_gtk_paper_size_to_gvariant (void)
{
   GVariant* retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_to_gvariant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1634, 1634, 0);
}

static void sl_gdk_drag_status (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDragAction arg2;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drag_status(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1635, 1635, 0);
}

static void sl_gtk_size_group_new (void)
{
   GtkSizeGroup* retval;
   GtkSizeGroupMode arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_size_group_new( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1636, 1636, 0);
}

static void sl_g_settings_set_value (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_value(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1637, 1637, 0);
}

static void sl_gtk_accel_map_get (void)
{
   GtkAccelMap* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_map_get();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1638, 1638, 0);
}

static void sl_gtk_window_maximize (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_maximize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1639, 1639, 0);
}

static void sl_gtk_window_propagate_key_event (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventKey* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_window_propagate_key_event(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1640, 1640, 0);
}

static void sl_gtk_text_view_backward_display_line (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_backward_display_line(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1641, 1641, 0);
}

static void sl_gtk_mount_operation_get_parent (void)
{
   GtkWindow* retval;
   GtkMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_mount_operation_get_parent(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1642, 1642, 0);
}

static void sl_gdk_drag_begin_from_point (void)
{
   GdkDragContext* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GList* arg3;
   Slirp_Ref *arg3_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg3,0x0);
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_drag_begin_from_point(arg1, arg2, arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1643, 1643, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_scrollable_set_vadjustment (void)
{
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scrollable_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1644, 1644, 0);
}

static void sl_gtk_menu_shell_deselect (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_shell_deselect(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1645, 1645, 0);
}

static void sl_gtk_tree_row_reference_deleted (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_row_reference_deleted(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1646, 1646, 0);
}

static void sl_gtk_widget_set_parent (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_parent(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1647, 1647, 0);
}

static void sl_pango_language_get_scripts (void)
{
   const PangoScript* retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_language_get_scripts(arg1, arg2);
   (void)SLang_push_opaque(int_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1648, 1648, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_recent_info_get_description (void)
{
   const gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_description(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1649, 1649, 0);
}

static void sl_gtk_cell_view_new_with_pixbuf (void)
{
   GtkWidget* retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_new_with_pixbuf(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1650, 1650, 0);
}

static void sl_gtk_widget_get_margin_left (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_left(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1651, 1651, 0);
}

static void sl_pango_font_family_is_monospace (void)
{
   gboolean retval;
   PangoFontFamily* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_family_is_monospace(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1652, 1652, 0);
}

static void sl_g_file_info_set_icon (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1653, 1653, 0);
}

static void sl_gdk_keyboard_ungrab (void)
{
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_keyboard_ungrab( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1654, 1654, 0);
}

static void sl_g_menu_insert (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_menu_insert(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1655, 1655, 0);
}

static void sl_gtk_file_chooser_get_local_only (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_local_only(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1656, 1656, 0);
}

static void sl_gtk_target_list_unref (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_list_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1657, 1657, 0);
}

static void sl_pango_layout_copy (void)
{
   PangoLayout* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_copy(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1658, 1658, 0);
}

static void sl_gdk_window_invalidate_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_invalidate_region(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1659, 1659, 0);
}

static void sl_gtk_check_menu_item_set_inconsistent (void)
{
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_check_menu_item_set_inconsistent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1660, 1660, 0);
}

static void sl_gtk_tree_path_prepend_index (void)
{
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_path_prepend_index(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1661, 1661, 0);
}

static void sl_g_settings_bind_writable (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_bind_writable(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1662, 1662, 0);
}

static void sl_pango_layout_set_height (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_height(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1663, 1663, 0);
}

static void sl_gtk_viewport_get_bin_window (void)
{
   GdkWindow* retval;
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_bin_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1664, 1664, 0);
}

static void sl_gdk_keyboard_grab (void)
{
   GdkGrabStatus retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyboard_grab(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1665, 1665, 0);
}

static void sl_gdk_display_keyboard_ungrab (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_keyboard_ungrab(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1666, 1666, 0);
}

static void sl_gtk_menu_shell_insert (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1667, 1667, 0);
}

static void sl_g_drive_get_identifier (void)
{
   char* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_drive_get_identifier(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1668, 1668, 0);
}

static void sl_gtk_entry_get_icon_gicon (void)
{
   GIcon* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_gicon(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1669, 1669, 0);
}

static void sl_gtk_editable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_editable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1670, 1670, 0);
}

static void sl_g_inet_address_to_string (void)
{
   gchar* retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1671, 1671, 0);
}

static void sl_g_hostname_to_ascii (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hostname_to_ascii(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1672, 1672, 0);
}

static void sl_gtk_cell_area_get_current_path_string (void)
{
   const gchar* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_current_path_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1673, 1673, 0);
}

static void sl_pango_language_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_language_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1674, 1674, 0);
}

static void sl_gtk_style_context_lookup_icon_set (void)
{
   GtkIconSet* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_style_context_lookup_icon_set(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1675, 1675, 0);
}

static void sl_gtk_print_operation_set_defer_drawing (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_defer_drawing(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1676, 1676, 0);
}

static void sl_gtk_icon_view_set_cursor (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRenderer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_set_cursor(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1677, 1677, 0);
}

static void sl_gtk_notebook_next_page (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_next_page(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1678, 1678, 0);
}

static void sl_g_file_info_set_display_name (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_display_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1679, 1679, 0);
}

static void sl_gtk_tool_button_set_label_widget (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_button_set_label_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1680, 1680, 0);
}

static void sl_gtk_text_mark_get_visible (void)
{
   gboolean retval;
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1681, 1681, 0);
}

static void sl_gtk_spin_button_spin (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSpinType arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_spin(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1682, 1682, 0);
}

static void sl_gtk_page_setup_unix_dialog_set_page_setup (void)
{
   GtkPageSetupUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSetup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_page_setup_unix_dialog_set_page_setup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1683, 1683, 0);
}

static void sl_gtk_tool_item_get_toolbar_style (void)
{
   GtkToolbarStyle retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_toolbar_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1684, 1684, 0);
}

static void sl_g_inet_address_mask_get_address (void)
{
   GInetAddress* retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_mask_get_address(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1685, 1685, 0);
}

static void sl_gtk_application_remove_window (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_remove_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1686, 1686, 0);
}

static void sl_gdk_gl_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1687, 1687, 0);
}

static void sl_gtk_file_chooser_get_file (void)
{
   GFile* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_file(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1688, 1688, 0);
}

static void sl_g_file_info_get_modification_date_time (void)
{
   GDateTime* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_modification_date_time(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1689, 1689, 0);
}

static void sl_gtk_window_get_screen (void)
{
   GdkScreen* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1690, 1690, 0);
}

static void sl_pango_layout_iter_get_baseline (void)
{
   int retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_baseline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1691, 1691, 0);
}

static void sl_g_file_info_set_attribute_int32 (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_int32(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1692, 1692, 0);
}

static void sl_g_date_get_day_of_year (void)
{
   guint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_day_of_year(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1693, 1693, 0);
}

static void sl_g_dpgettext (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_dpgettext(arg1, arg2,  arg3);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1694, 1694, 0);
}

static void sl_gtk_stack_set_visible_child_name (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_set_visible_child_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1695, 1695, 0);
}

static void sl_g_value_get_long (void)
{
   glong retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_long(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1696, 1696, 0);
}

static void sl_gtk_stack_get_visible_child (void)
{
   GtkWidget* retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_visible_child(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1697, 1697, 0);
}

static void sl_gtk_drag_source_get_target_list (void)
{
   GtkTargetList* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_drag_source_get_target_list(arg1);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1698, 1698, 0);
}

static void sl_gdk_pixbuf_get_colorspace (void)
{
   GdkColorspace retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_colorspace(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1699, 1699, 0);
}

static void sl_gdk_window_hide (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_hide(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1700, 1700, 0);
}

static void sl_gtk_popover_set_constrain_to (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPopoverConstraint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_set_constrain_to(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1701, 1701, 0);
}

static void sl_g_variant_builder_init (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_variant_builder_init(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1702, 1702, 0);
}

static void sl_gdk_visual_get_best_with_depth (void)
{
   GdkVisual* retval;
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best_with_depth( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1703, 1703, 0);
}

static void sl_g_emblem_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_emblem_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1704, 1704, 0);
}

static void sl_gtk_print_job_set_scale (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_scale(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1705, 1705, 0);
}

static void sl_gtk_list_box_row_set_selectable (void)
{
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_row_set_selectable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1706, 1706, 0);
}

static void sl_gdk_device_set_mode (void)
{
   gboolean retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkInputMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_set_mode(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1707, 1707, 0);
}

static void sl_g_file_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1708, 1708, 0);
}

static void sl_gtk_toggle_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1709, 1709, 0);
}

static void sl_gtk_tree_view_column_set_alignment (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_alignment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1710, 1710, 0);
}

static void sl_gtk_cell_area_get_focus_cell (void)
{
   GtkCellRenderer* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_focus_cell(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1711, 1711, 0);
}

static void sl_gtk_icon_theme_choose_icon_for_scale (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   gint arg3;
   gint arg4;
   GtkIconLookupFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_choose_icon_for_scale(arg1, arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1712, 1712, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_file_set_attribute (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileAttributeType arg3;
   gpointer arg4;
   Slirp_Opaque* arg4_o = NULL;
   GFileQueryInfoFlags arg5;
   GCancellable* arg6;
   Slirp_Opaque* arg6_o = NULL;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg6, &arg6_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_file_set_attribute(arg1, arg2,  arg3, arg4,  arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_6:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (1713, 1713, 0);
}

static void sl_gdk_gl_context_set_debug_enabled (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_set_debug_enabled(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1714, 1714, 0);
}

static void sl_gtk_widget_get_has_tooltip (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_has_tooltip(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1715, 1715, 0);
}

static void sl_gtk_page_setup_set_bottom_margin (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_page_setup_set_bottom_margin(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1716, 1716, 0);
}

static void sl_g_match_info_get_match_count (void)
{
   gint retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_get_match_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1717, 1717, 0);
}

static void sl_g_settings_get_range (void)
{
   GVariant* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_range(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1718, 1718, 0);
}

static void sl_g_action_map_remove_action (void)
{
   GActionMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_action_map_remove_action(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1719, 1719, 0);
}

static void sl_gtk_label_get_selection_bounds (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_selection_bounds(arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1720, 1720, 0);
}

static void sl_g_bookmark_file_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_bookmark_file_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1721, 1721, 0);
}

static void sl_g_inet_socket_address_new (void)
{
   GSocketAddress* retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_new(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1722, 1722, 0);
}

static void sl_gtk_tree_selection_unselect_path (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_unselect_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1723, 1723, 0);
}

static void sl_g_utf8_make_valid (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_make_valid(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1724, 1724, 0);
}

static void sl_pango_attr_fallback_new (void)
{
   PangoAttribute* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_fallback_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1725, 1725, 0);
}

static void sl_g_settings_schema_key_get_value_type (void)
{
   const GVariantType* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_value_type(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1726, 1726, 0);
}

static void sl_g_variant_type_is_maybe (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_maybe(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1727, 1727, 0);
}

static void sl_gtk_event_controller_motion_new (void)
{
   GtkEventController* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_motion_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1728, 1728, 0);
}

static void sl_gtk_application_remove_accelerator (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GVariant_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_remove_accelerator(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1729, 1729, 0);
}

static void sl_gtk_tree_view_column_cell_get_size (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_cell_get_size(arg1, arg2, &arg3, &arg4, &arg5, &arg6);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1730, 1730, 0);
}

static void sl_gtk_entry_get_progress_fraction (void)
{
   gdouble retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_progress_fraction(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1731, 1731, 0);
}

static void sl_g_type_class_get_private (void)
{
   gpointer retval;
   GTypeClass* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_class_get_private(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1732, 1732, 0);
}

static void sl_gtk_tree_path_new_from_string (void)
{
   GtkTreePath* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_new_from_string(arg1);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1733, 1733, 0);
}

static void sl_g_utf8_casefold (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_casefold(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1734, 1734, 0);
}

static void sl_g_settings_backend_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_backend_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1735, 1735, 0);
}

static void sl_g_mount_operation_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1736, 1736, 0);
}

static void sl_g_type_depth (void)
{
   guint retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_depth( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1737, 1737, 0);
}

static void sl_pango_attr_gravity_new (void)
{
   PangoAttribute* retval;
   PangoGravity arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_gravity_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1738, 1738, 0);
}

static void sl_gtk_image_set_from_resource (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_resource(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1739, 1739, 0);
}

static void sl_gtk_calendar_mark_day (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_mark_day(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1740, 1740, 0);
}

static void sl_gtk_offscreen_window_get_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkOffscreenWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_offscreen_window_get_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1741, 1741, 0);
}

static void sl_gtk_gesture_long_press_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_long_press_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1742, 1742, 0);
}

static void sl_g_menu_item_set_icon (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1743, 1743, 0);
}

static void sl_g_app_info_launch_uris (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg2,0x0);
   GAppLaunchContext* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_app_info_launch_uris(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1744, 1744, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_pango_cairo_font_map_set_resolution (void)
{
   PangoCairoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_cairo_font_map_set_resolution(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1745, 1745, 0);
}

static void sl_gtk_menu_button_get_menu_model (void)
{
   GMenuModel* retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_menu_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1746, 1746, 0);
}

static void sl_gdk_window_begin_resize_drag_for_device (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindowEdge arg2;
   GdkDevice* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   gint arg6;
   guint32 arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gdk_window_begin_resize_drag_for_device(arg1,  arg2, arg3,  arg4,  arg5,  arg6,  arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1747, 1747, 0);
}

static void sl_gtk_widget_send_focus_change (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_send_focus_change(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1748, 1748, 0);
}

static void sl_gdk_window_get_visual (void)
{
   GdkVisual* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_visual(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1749, 1749, 0);
}

static void sl_gdk_byte_order_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_byte_order_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1750, 1750, 0);
}

static void sl_gtk_widget_get_allocated_width (void)
{
   int retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_allocated_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1751, 1751, 0);
}

static void sl_gdk_device_pad_get_group_n_modes (void)
{
   gint retval;
   GdkDevicePad* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_get_group_n_modes(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1752, 1752, 0);
}

static void sl_gtk_app_chooser_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1753, 1753, 0);
}

static void sl_gtk_text_attributes_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_attributes_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1754, 1754, 0);
}

static void sl_gtk_accel_map_unlock_path (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_unlock_path(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1755, 1755, 0);
}

static void sl_g_socket_set_ttl (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_ttl(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1756, 1756, 0);
}

static void sl_gdk_display_flush (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_flush(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1757, 1757, 0);
}

static void sl_gtk_expander_set_label (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_expander_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1758, 1758, 0);
}

static void sl_pango_font_description_set_weight (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoWeight arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_weight(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1759, 1759, 0);
}

static void sl_gtk_file_chooser_get_preview_widget (void)
{
   GtkWidget* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_preview_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1760, 1760, 0);
}

static void sl_gtk_print_settings_get_double_with_default (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_double_with_default(arg1, arg2,  arg3);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1761, 1761, 0);
}

static void sl_pango_renderer_draw_glyph (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFont* arg2;
   Slirp_Opaque* arg2_o = NULL;
   PangoGlyph arg3;
   double arg4;
   double arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_renderer_draw_glyph(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1762, 1762, 0);
}

static void sl_pango_attr_letter_spacing_new (void)
{
   PangoAttribute* retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_letter_spacing_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1763, 1763, 0);
}

static void sl_g_variant_new_objv (void)
{
   GVariant* retval;
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_objv(arg1,  arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1764, 1764, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_text_view_get_cursor_visible (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_cursor_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1765, 1765, 0);
}

static void sl_gdk_grab_ownership_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_grab_ownership_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1766, 1766, 0);
}

static void sl_gtk_action_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_action_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1767, 1767, 0);
}

static void sl_pango_coverage_copy (void)
{
   PangoCoverage* retval;
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_copy(arg1);
   (void)SLang_push_opaque(PangoCoverage_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1768, 1768, 0);
}

static void sl_gdk_display_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1769, 1769, 0);
}

static void sl_g_file_new_for_uri (void)
{
   GFile* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_new_for_uri(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1770, 1770, 0);
}

static void sl_gtk_toolbar_set_style (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolbarStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toolbar_set_style(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1771, 1771, 0);
}

static void sl_gtk_text_view_get_indent (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_indent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1772, 1772, 0);
}

static void sl_gtk_text_view_buffer_to_window_coords (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextWindowType arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_buffer_to_window_coords(arg1,  arg2,  arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1773, 1773, 0);
}

static void sl_g_app_info_get_recommended_for_type (void)
{
   GList* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_recommended_for_type(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1774, 1774, 0);
}

static void sl_pango_attr_foreground_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   guint16 arg2;
   guint16 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_foreground_new( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1775, 1775, 0);
}

static void sl_g_main_context_push_thread_default (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_push_thread_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1776, 1776, 0);
}

static void sl_gtk_file_chooser_get_choice (void)
{
   const char* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_get_choice(arg1, arg2);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1777, 1777, 0);
}

static void sl_g_mount_operation_get_anonymous (void)
{
   gboolean retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_anonymous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1778, 1778, 0);
}

static void sl_gtk_flow_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1779, 1779, 0);
}

static void sl_gtk_assistant_next_page (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_next_page(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1780, 1780, 0);
}

static void sl_gtk_combo_box_text_new_with_entry (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_text_new_with_entry();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1781, 1781, 0);
}

static void sl_g_iconv (void)
{
   gsize retval;
   GIConv arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   gsize* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_ULONG_TYPE,sizeof(gsize),&arg3,0x0);
   gchar** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg4,0x0);
   gsize* arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_ULONG_TYPE,sizeof(gsize),&arg5,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_iconv(arg1, arg2, arg3, arg4, arg5);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1782, 1782, 0);
   finalize_refs(4,arg2_r,arg3_r,arg4_r,arg5_r); 
}

static void sl_gtk_icon_info_load_symbolic (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   GdkRGBA* arg4 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   GdkRGBA* arg5 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   gboolean* arg6;
   Slirp_Ref *arg6_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg6,0x0);
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, GdkRGBA_Layout)) goto free_and_return_5;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GdkRGBA_Layout)) goto free_and_return_4;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = gtk_icon_info_load_symbolic(arg1, arg2, arg3, arg4, arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRGBA_Layout);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, GdkRGBA_Layout);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1783, 1783, 0);
   finalize_refs(1,arg6_r); 
}

static void sl_gtk_widget_render_icon_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_render_icon_pixbuf(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1784, 1784, 0);
}

static void sl_gtk_entry_completion_get_entry (void)
{
   GtkWidget* retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_entry(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1785, 1785, 0);
}

static void sl_gtk_button_new_from_icon_name (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_new_from_icon_name(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1786, 1786, 0);
}

static void sl_g_checksum_new (void)
{
   GChecksum* retval;
   GChecksumType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_checksum_new( arg1);
   (void)SLang_push_opaque(GChecksum_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1787, 1787, 0);
}

static void sl_g_inet_address_equal (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_inet_address_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1788, 1788, 0);
}

static void sl_gtk_tree_view_get_expander_column (void)
{
   GtkTreeViewColumn* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_expander_column(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1789, 1789, 0);
}

static void sl_gtk_drag_get_data (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDragContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint32 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_get_data(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1790, 1790, 0);
}

static void sl_gdk_window_withdraw (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_withdraw(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1791, 1791, 0);
}

static void sl_gtk_app_chooser_button_set_active_custom_item (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_app_chooser_button_set_active_custom_item(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1792, 1792, 0);
}

static void sl_gtk_viewport_get_view_window (void)
{
   GdkWindow* retval;
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_view_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1793, 1793, 0);
}

static void sl_gtk_paned_get_child2 (void)
{
   GtkWidget* retval;
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_child2(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1794, 1794, 0);
}

static void sl_gtk_level_bar_set_min_value (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_level_bar_set_min_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1795, 1795, 0);
}

static void sl_gtk_entry_unset_invisible_char (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_unset_invisible_char(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1796, 1796, 0);
}

static void sl_gtk_cell_area_activate (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg5;
   gboolean arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_activate(arg1, arg2, arg3, arg4,  arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1797, 1797, 0);
}

static void sl_g_drive_can_start_degraded (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_can_start_degraded(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1798, 1798, 0);
}

static void sl_gtk_print_operation_set_custom_tab_label (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_operation_set_custom_tab_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1799, 1799, 0);
}

static void sl_gtk_widget_get_events (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_events(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1800, 1800, 0);
}

static void sl_g_value_get_uint (void)
{
   guint retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_uint(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1801, 1801, 0);
}

static void sl_gtk_tree_view_set_tooltip_cell (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTooltip* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkTreeViewColumn* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GtkCellRenderer* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_tooltip_cell(arg1, arg2, arg3, arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1802, 1802, 0);
}

static void sl_gtk_app_chooser_button_append_custom_item (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GIcon* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_app_chooser_button_append_custom_item(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1803, 1803, 0);
}

static void sl_g_action_map_add_action (void)
{
   GActionMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAction* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_action_map_add_action(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1804, 1804, 0);
}

static void sl_g_io_channel_unref (void)
{
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_io_channel_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1805, 1805, 0);
}

static void sl_gtk_clipboard_get_display (void)
{
   GdkDisplay* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1806, 1806, 0);
}

static void sl_gdk_pixbuf_new (void)
{
   GdkPixbuf* retval;
   GdkColorspace arg1;
   gboolean arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_new( arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1807, 1807, 0);
}

static void sl_gtk_text_iter_compare (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1808, 1808, 0);
}

static void sl_gtk_editable_insert_text (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_editable_insert_text(arg1, arg2,  arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1809, 1809, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_scale_set_digits (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_set_digits(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1810, 1810, 0);
}

static void sl_g_bookmark_file_set_is_private (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_is_private(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1811, 1811, 0);
}

static void sl_gtk_widget_path_iter_remove_class (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_remove_class(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1812, 1812, 0);
}

static void sl_gtk_get_locale_direction (void)
{
   GtkTextDirection retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_locale_direction();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1813, 1813, 0);
}

static void sl_gtk_text_attributes_copy_values (void)
{
   GtkTextAttributes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextAttributes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_attributes_copy_values(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1814, 1814, 0);
}

static void sl_gtk_accel_group_new (void)
{
   GtkAccelGroup* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1815, 1815, 0);
}

static void sl_gtk_icon_view_set_columns (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_columns(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1816, 1816, 0);
}

static void sl_gtk_menu_item_toggle_size_allocate (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_toggle_size_allocate(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1817, 1817, 0);
}

static void sl_gtk_recent_chooser_set_show_not_found (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_show_not_found(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1818, 1818, 0);
}

static void sl_gtk_drawing_area_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_drawing_area_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1819, 1819, 0);
}

static void sl_gtk_get_event_widget (void)
{
   GtkWidget* retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_event_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1820, 1820, 0);
}

static void sl_gtk_drag_set_icon_widget (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_widget(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1821, 1821, 0);
}

static void sl_gtk_drag_source_add_image_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_source_add_image_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1822, 1822, 0);
}

static void sl_gtk_label_get_text (void)
{
   const gchar* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1823, 1823, 0);
}

static void sl_gtk_about_dialog_set_wrap_license (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_about_dialog_set_wrap_license(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1824, 1824, 0);
}

static void sl_gtk_application_window_get_id (void)
{
   guint retval;
   GtkApplicationWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_window_get_id(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1825, 1825, 0);
}

static void sl_gtk_widget_path_copy (void)
{
   GtkWidgetPath* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_copy(arg1);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1826, 1826, 0);
}

static void sl_gtk_tree_model_iter_next (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_next(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1827, 1827, 0);
}

static void sl_g_zlib_decompressor_get_file_info (void)
{
   GFileInfo* retval;
   GZlibDecompressor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_zlib_decompressor_get_file_info(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1828, 1828, 0);
}

static void sl_gdk_window_set_event_compression (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_event_compression(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1829, 1829, 0);
}

static void sl_g_time_zone_get_abbreviation (void)
{
   const gchar* retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_get_abbreviation(arg1,  arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1830, 1830, 0);
}

static void sl_gtk_print_operation_set_export_filename (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_operation_set_export_filename(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1831, 1831, 0);
}

static void sl_gtk_text_iter_get_attributes (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextAttributes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_get_attributes(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1832, 1832, 0);
}

static void sl_gdk_device_get_has_cursor (void)
{
   gboolean retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_has_cursor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1833, 1833, 0);
}

static void sl_g_reload_user_special_dirs_cache (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   g_reload_user_special_dirs_cache();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1834, 1834, 0);
}

static void sl_g_date_get_year (void)
{
   GDateYear retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_year(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1835, 1835, 0);
}

static void sl_g_socket_join_multicast_group_ssm (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GInetAddress* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_join_multicast_group_ssm(arg1, arg2, arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (1836, 1836, 0);
}

static void sl_pango_attr_list_get_attributes (void)
{
   GSList* retval;
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_list_get_attributes(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1837, 1837, 0);
}

static void sl_g_value_init_from_instance (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_init_from_instance(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1838, 1838, 0);
}

static void sl_gtk_icon_view_get_tooltip_column (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_tooltip_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1839, 1839, 0);
}

static void sl_gdk_pixbuf_new_from_file_at_size (void)
{
   GdkPixbuf* retval;
   char* arg1;
   int arg2;
   int arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = gdk_pixbuf_new_from_file_at_size(arg1,  arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1840, 1840, 0);
}

static void sl_gtk_cell_renderer_get_request_mode (void)
{
   GtkSizeRequestMode retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_get_request_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1841, 1841, 0);
}

static void sl_gdk_gl_context_get_display (void)
{
   GdkDisplay* retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1842, 1842, 0);
}

static void sl_gtk_separator_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1843, 1843, 0);
}

static void sl_g_type_ensure (void)
{
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_type_ensure( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1844, 1844, 0);
}

static void sl_gdk_monitor_get_manufacturer (void)
{
   const char* retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_manufacturer(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1845, 1845, 0);
}

static void sl_g_date_time_get_timezone_abbreviation (void)
{
   const gchar* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_timezone_abbreviation(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1846, 1846, 0);
}

static void sl_gtk_spin_button_set_numeric (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_numeric(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1847, 1847, 0);
}

static void sl_gdk_drag_cancel_reason_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_cancel_reason_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1848, 1848, 0);
}

static void sl_g_mapped_file_ref (void)
{
   GMappedFile* retval;
   GMappedFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMappedFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mapped_file_ref(arg1);
   (void)SLang_push_opaque(GMappedFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1849, 1849, 0);
}

static void sl_g_file_attribute_matcher_enumerate_namespace (void)
{
   gboolean retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_attribute_matcher_enumerate_namespace(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1850, 1850, 0);
}

static void sl_gdk_window_get_cursor (void)
{
   GdkCursor* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_cursor(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1851, 1851, 0);
}

static void sl_g_value_peek_pointer (void)
{
   gpointer retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_peek_pointer(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1852, 1852, 0);
}

static void sl_gtk_actionable_set_action_name (void)
{
   GtkActionable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_actionable_set_action_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1853, 1853, 0);
}

static void sl_gdk_screen_get_active_window (void)
{
   GdkWindow* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_active_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1854, 1854, 0);
}

static void sl_gtk_tree_view_column_set_sort_column_id (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_sort_column_id(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1855, 1855, 0);
}

static void sl_gtk_native_dialog_set_transient_for (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_native_dialog_set_transient_for(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1856, 1856, 0);
}

static void sl_g_inet_socket_address_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1857, 1857, 0);
}

static void sl_gdk_event_free (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_event_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1858, 1858, 0);
}

static void sl_gtk_tree_view_column_set_expand (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_expand(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1859, 1859, 0);
}

static void sl_gdk_window_get_device_position_double (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   GdkModifierType arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_get_device_position_double(arg1, arg2, &arg3, &arg4, &arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   (void)SLang_push_double(arg3);
   (void)SLang_push_double(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1860, 1860, 0);
}

static void sl_pango_layout_line_index_to_x (void)
{
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   gboolean arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_line_index_to_x(arg1,  arg2,  arg3, &arg4);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1861, 1861, 0);
}

static void sl_g_app_info_get_supported_types (void)
{
   const char** retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_supported_types(arg1);
   (void)SLang_push_opaque(string_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1862, 1862, 0);
}

static void sl_gtk_gl_area_queue_render (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_queue_render(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1863, 1863, 0);
}

static void sl_gtk_paper_size_get_name (void)
{
   const gchar* retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1864, 1864, 0);
}

static void sl_gtk_level_bar_get_offset_value (void)
{
   gboolean retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_level_bar_get_offset_value(arg1, arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1865, 1865, 0);
}

static void sl_gdk_pixbuf_loader_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_loader_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1866, 1866, 0);
}

static void sl_pango_layout_iter_get_line_readonly (void)
{
   PangoLayoutLine* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_line_readonly(arg1);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1867, 1867, 0);
}

static void sl_gdk_rgba_hash (void)
{
   guint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_rgba_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1868, 1868, 0);
}

static void sl_gtk_icon_theme_add_builtin_icon (void)
{
   gchar* arg1;
   gint arg2;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   gtk_icon_theme_add_builtin_icon(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1869, 1869, 0);
}

static void sl_gtk_tree_store_move_after (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_store_move_after(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1870, 1870, 0);
}

static void sl_gtk_combo_box_get_column_span_column (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_column_span_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1871, 1871, 0);
}

static void sl_gtk_text_view_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1872, 1872, 0);
}

static void sl_gtk_text_iter_backward_sentence_starts (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_sentence_starts(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1873, 1873, 0);
}

static void sl_gtk_paper_size_new_from_gvariant (void)
{
   GtkPaperSize* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_new_from_gvariant(arg1);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1874, 1874, 0);
}

static void sl_gtk_print_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1875, 1875, 0);
}

static void sl_gtk_render_icon (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_icon(arg1, arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1876, 1876, 0);
}

static void sl_g_unicode_script_to_iso15924 (void)
{
   guint32 retval;
   GUnicodeScript arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unicode_script_to_iso15924( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1877, 1877, 0);
}

static void sl_gtk_text_tag_table_get_size (void)
{
   gint retval;
   GtkTextTagTable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_table_get_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1878, 1878, 0);
}

static void sl_g_poll (void)
{
   gint retval;
   GPollFD* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_poll(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1879, 1879, 0);
}

static void sl_g_volume_can_eject (void)
{
   gboolean retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_can_eject(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1880, 1880, 0);
}

static void sl_gdk_events_get_center (void)
{
   gboolean retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_events_get_center(arg1, arg2, &arg3, &arg4);
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_double(arg4);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1881, 1881, 0);
}

static void sl_gtk_target_entry_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_entry_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1882, 1882, 0);
}

static void sl_gtk_page_setup_get_page_height (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_page_height(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1883, 1883, 0);
}

static void sl_g_value_type_transformable (void)
{
   gboolean retval;
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_value_type_transformable( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1884, 1884, 0);
}

static void sl_gtk_text_buffer_new (void)
{
   GtkTextBuffer* retval;
   GtkTextTagTable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1885, 1885, 0);
}

static void sl_g_simple_action_new_stateful (void)
{
   GSimpleAction* retval;
   gchar* arg1;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GVariant_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == pop_nullable(GVariantType_Type, (void**)&arg2_o, (void**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_simple_action_new_stateful(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1886, 1886, 0);
}

static void sl_g_value_get_uint64 (void)
{
   guint64 retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_uint64(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1887, 1887, 0);
}

static void sl_gtk_check_version (void)
{
   const gchar* retval;
   guint arg1;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_version( arg1,  arg2,  arg3);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1888, 1888, 0);
}

static void sl_gtk_notebook_get_tab_label (void)
{
   GtkWidget* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_label(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1889, 1889, 0);
}

static void sl_gtk_places_sidebar_set_show_desktop (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_desktop(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1890, 1890, 0);
}

static void sl_g_key_file_has_group (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_key_file_has_group(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1891, 1891, 0);
}

static void sl_gtk_gesture_swipe_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_swipe_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1892, 1892, 0);
}

static void sl_gtk_accelerator_valid (void)
{
   gboolean retval;
   guint arg1;
   GdkModifierType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_valid( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1893, 1893, 0);
}

static void sl_g_date_is_leap_year (void)
{
   gboolean retval;
   GDateYear arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_is_leap_year( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1894, 1894, 0);
}

static void sl_g_date_time_format_iso8601 (void)
{
   gchar* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_format_iso8601(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1895, 1895, 0);
}

static void sl_gtk_button_set_use_stock (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_use_stock(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1896, 1896, 0);
}

static void sl_g_file_info_get_attribute_object (void)
{
   GObject* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_object(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1897, 1897, 0);
}

static void sl_gtk_header_bar_get_show_close_button (void)
{
   gboolean retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_show_close_button(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1898, 1898, 0);
}

static void sl_gtk_tree_view_unset_rows_drag_dest (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_unset_rows_drag_dest(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1899, 1899, 0);
}

static void sl_gdk_pixbuf_animation_is_static_image (void)
{
   gboolean retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_is_static_image(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1900, 1900, 0);
}

static void sl_pango_cairo_create_layout (void)
{
   PangoLayout* retval;
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_create_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1901, 1901, 0);
}

static void sl_gtk_tree_view_enable_model_drag_source (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierType arg2;
   const GtkTargetEntry* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   GdkDragAction arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_tree_view_enable_model_drag_source(arg1,  arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1902, 1902, 0);
}

static void sl_gtk_widget_get_hexpand (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_hexpand(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1903, 1903, 0);
}

static void sl_g_file_info_set_attribute_status (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileAttributeStatus arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_set_attribute_status(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1904, 1904, 0);
}

static void sl_g_enum_to_string (void)
{
   gchar* retval;
   GType arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_enum_to_string( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1905, 1905, 0);
}

static void sl_gtk_widget_get_realized (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_realized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1906, 1906, 0);
}

static void sl_g_bytes_icon_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_bytes_icon_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1907, 1907, 0);
}

static void sl_g_ascii_strdown (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_strdown(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1908, 1908, 0);
}

static void sl_gtk_popover_new_from_model (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_popover_new_from_model(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1909, 1909, 0);
}

static void sl_g_main_current_source (void)
{
   GSource* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_current_source();
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1910, 1910, 0);
}

static void sl_gtk_places_sidebar_list_shortcuts (void)
{
   GSList* retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_list_shortcuts(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1911, 1911, 0);
}

static void sl_gtk_cell_layout_clear (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_layout_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1912, 1912, 0);
}

static void sl_gtk_app_chooser_dialog_get_heading (void)
{
   const gchar* retval;
   GtkAppChooserDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_dialog_get_heading(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1913, 1913, 0);
}

static void sl_g_type_class_add_private (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_type_class_add_private(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1914, 1914, 0);
}

static void sl_pango_gravity_to_rotation (void)
{
   double retval;
   PangoGravity arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_gravity_to_rotation( arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1915, 1915, 0);
}

static void sl_gtk_widget_get_vexpand_set (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_vexpand_set(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1916, 1916, 0);
}

static void sl_gtk_event_controller_handle_event (void)
{
   gboolean retval;
   GtkEventController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_event_controller_handle_event(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1917, 1917, 0);
}

static void sl_gtk_print_operation_set_n_pages (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_n_pages(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1918, 1918, 0);
}

static void sl_gtk_about_dialog_add_credit_section (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_add_credit_section(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1919, 1919, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_cell_renderer_activate (void)
{
   gboolean retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg6 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg6, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto free_and_return_6;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_renderer_activate(arg1, arg2, arg3, arg4, arg5, arg6,  arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
free_and_return_6:
   SLang_free_cstruct((VOID_STAR)arg6, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1920, 1920, 0);
}

static void sl_g_rand_new_with_seed (void)
{
   GRand* retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_new_with_seed( arg1);
   (void)SLang_push_opaque(GRand_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1921, 1921, 0);
}

static void sl_gtk_toggle_tool_button_set_active (void)
{
   GtkToggleToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toggle_tool_button_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1922, 1922, 0);
}

static void sl_gtk_print_context_get_pango_fontmap (void)
{
   PangoFontMap* retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_pango_fontmap(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1923, 1923, 0);
}

static void sl_gtk_widget_get_preferred_width_for_height (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_width_for_height(arg1,  arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1924, 1924, 0);
}

static void sl_gtk_statusbar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_statusbar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1925, 1925, 0);
}

static void sl_gtk_print_unix_dialog_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1926, 1926, 0);
}

static void sl_gtk_widget_get_clipboard (void)
{
   GtkClipboard* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_get_clipboard(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1927, 1927, 0);
}

static void sl_g_value_dup_param (void)
{
   GParamSpec* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_dup_param(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1928, 1928, 0);
}

static void sl_gtk_cell_area_box_get_spacing (void)
{
   gint retval;
   GtkCellAreaBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_box_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1929, 1929, 0);
}

static void sl_gdk_monitor_get_width_mm (void)
{
   int retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_width_mm(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1930, 1930, 0);
}

static void sl_gtk_combo_box_get_entry_text_column (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_entry_text_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1931, 1931, 0);
}

static void sl_gtk_widget_get_font_options (void)
{
   const cairo_font_options_t* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_font_options(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1932, 1932, 0);
}

static void sl_gdk_window_set_background (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_background(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1933, 1933, 0);
}

static void sl_g_bookmark_file_has_group (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_has_group(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1934, 1934, 0);
}

static void sl_gtk_scale_get_layout (void)
{
   PangoLayout* retval;
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1935, 1935, 0);
}

static void sl_gtk_label_set_single_line_mode (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_single_line_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1936, 1936, 0);
}

static void sl_g_signal_stop_emission_by_name (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_signal_stop_emission_by_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1937, 1937, 0);
}

static void sl_gdk_pixbuf_animation_iter_on_currently_loading_frame (void)
{
   gboolean retval;
   GdkPixbufAnimationIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_iter_on_currently_loading_frame(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1938, 1938, 0);
}

static void sl_g_source_get_priority (void)
{
   gint retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_priority(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1939, 1939, 0);
}

static void sl_gdk_pixbuf_simple_anim_add_frame (void)
{
   GdkPixbufSimpleAnim* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_pixbuf_simple_anim_add_frame(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1940, 1940, 0);
}

static void sl_gtk_css_section_get_end_position (void)
{
   guint retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_end_position(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1941, 1941, 0);
}

static void sl_g_bookmark_file_remove_application (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_remove_application(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1942, 1942, 0);
}

static void sl_g_bookmark_file_load_from_data (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_load_from_data(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1943, 1943, 0);
}

static void sl_gtk_icon_set_render_icon_surface (void)
{
   cairo_surface_t* retval;
   GtkIconSet* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int arg4;
   GdkWindow* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_set_render_icon_surface(arg1, arg2,  arg3,  arg4, arg5);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (1944, 1944, 0);
}

static void sl_gtk_text_iter_can_insert (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_can_insert(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1945, 1945, 0);
}

static void sl_gtk_window_set_keep_below (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_keep_below(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1946, 1946, 0);
}

static void sl_gtk_widget_set_no_show_all (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_no_show_all(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1947, 1947, 0);
}

static void sl_gtk_toolbar_get_relief_style (void)
{
   GtkReliefStyle retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_relief_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1948, 1948, 0);
}

static void sl_gtk_notebook_set_menu_label (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_menu_label(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (1949, 1949, 0);
}

static void sl_g_socket_get_protocol (void)
{
   GSocketProtocol retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_protocol(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1950, 1950, 0);
}

static void sl_gtk_recent_chooser_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1951, 1951, 0);
}

static void sl_g_content_type_is_a (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_content_type_is_a(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1952, 1952, 0);
}

static void sl_pango_cairo_font_map_set_default (void)
{
   PangoCairoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_cairo_font_map_set_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1953, 1953, 0);
}

static void sl_gtk_window_new (void)
{
   GtkWidget* retval;
   GtkWindowType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_new( arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1954, 1954, 0);
}

static void sl_gtk_clipboard_wait_for_contents (void)
{
   GtkSelectionData* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_clipboard_wait_for_contents(arg1, arg2);
   (void)SLang_push_opaque(GtkSelectionData_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1955, 1955, 0);
}

static void sl_pango_context_set_gravity_hint (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoGravityHint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_context_set_gravity_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1956, 1956, 0);
}

static void sl_gtk_color_button_set_use_alpha (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_button_set_use_alpha(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1957, 1957, 0);
}

static void sl_g_date_time_ref (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_ref(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1958, 1958, 0);
}

static void sl_g_socket_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1959, 1959, 0);
}

static void sl_gtk_text_view_scroll_to_mark (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gboolean arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_scroll_to_mark(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1960, 1960, 0);
}

static void sl_gtk_window_begin_move_drag (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   guint32 arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_begin_move_drag(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1961, 1961, 0);
}

static void sl_gtk_page_setup_get_page_width (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_page_width(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1962, 1962, 0);
}

static void sl_gtk_color_button_new_with_rgba (void)
{
   GtkWidget* retval;
   GdkRGBA* arg1 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkRGBA_Layout)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_new_with_rgba(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (1963, 1963, 0);
}

static void sl_pango_layout_get_size (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_get_size(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1964, 1964, 0);
}

static void sl_gtk_gl_area_set_use_es (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_use_es(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1965, 1965, 0);
}

static void sl_gtk_widget_trigger_tooltip_query (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_trigger_tooltip_query(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1966, 1966, 0);
}

static void sl_g_param_spec_pool_remove (void)
{
   GParamSpecPool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_param_spec_pool_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1967, 1967, 0);
}

static void sl_gtk_range_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1968, 1968, 0);
}

static void sl_gtk_printer_get_job_count (void)
{
   gint retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_job_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1969, 1969, 0);
}

static void sl_g_io_channel_get_flags (void)
{
   GIOFlags retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1970, 1970, 0);
}

static void sl_g_get_real_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_real_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1971, 1971, 0);
}

static void sl_g_key_file_load_from_data (void)
{
   gboolean retval;
   GKeyFile* arg1;
   gchar* arg2;
   gsize arg3;
   GKeyFileFlags arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   issue_usage = 0;

   arg1 = g_key_file_new ();
   arg5 = NULL;
   retval = g_key_file_load_from_data(arg1, arg2,  arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   if (retval == TRUE)
      (void) SLang_push_opaque (GKeyFile_Type, (void*) retval, 0);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1972, 1972, 0);
}

static void sl_gtk_tool_palette_unset_style (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_palette_unset_style(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1973, 1973, 0);
}

static void sl_gtk_tree_view_set_hover_selection (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_hover_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1974, 1974, 0);
}

static void sl_gtk_style_context_get_parent (void)
{
   GtkStyleContext* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_parent(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1975, 1975, 0);
}

static void sl_pango_font_metrics_get_underline_thickness (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_underline_thickness(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1976, 1976, 0);
}

static void sl_gtk_container_set_resize_mode (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkResizeMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_set_resize_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1977, 1977, 0);
}

static void sl_gtk_text_mark_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1978, 1978, 0);
}

static void sl_g_key_file_get_int64 (void)
{
   gint64 retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_int64(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1979, 1979, 0);
}

static void sl_gtk_text_iter_is_start (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_is_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1980, 1980, 0);
}

static void sl_g_settings_backend_keys_changed (void)
{
   GSettingsBackend* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   gpointer arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_backend_keys_changed(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (1981, 1981, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_draw (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_draw(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (1982, 1982, 0);
}

static void sl_gtk_scrolled_window_set_overlay_scrolling (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_overlay_scrolling(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1983, 1983, 0);
}

static void sl_gtk_recent_chooser_set_show_tips (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_show_tips(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1984, 1984, 0);
}

static void sl_g_menu_append (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_append(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1985, 1985, 0);
}

static void sl_g_path_get_dirname (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_path_get_dirname(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1986, 1986, 0);
}

static void sl_gdk_gl_context_get_forward_compatible (void)
{
   gboolean retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_forward_compatible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1987, 1987, 0);
}

static void sl_gtk_spin_button_get_wrap (void)
{
   gboolean retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_wrap(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1988, 1988, 0);
}

static void sl_gdk_screen_get_height (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1989, 1989, 0);
}

static void sl_g_mkstemp (void)
{
   gint retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_mkstemp(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1990, 1990, 0);
}

static void sl_gtk_window_set_default_icon_from_file (void)
{
   gboolean retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_window_set_default_icon_from_file(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (1991, 1991, 0);
}

static void sl_pango_font_description_get_size_is_absolute (void)
{
   gboolean retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_size_is_absolute(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1992, 1992, 0);
}

static void sl_g_dir_close (void)
{
   GDir* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDir_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_dir_close(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1993, 1993, 0);
}

static void sl_gtk_print_settings_get_int (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_int(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1994, 1994, 0);
}

static void sl_g_convert_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_convert_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (1995, 1995, 0);
}

static void sl_gtk_print_job_get_rotate (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_rotate(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1996, 1996, 0);
}

static void sl_g_file_info_set_name (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (1997, 1997, 0);
}

static void sl_g_dpgettext2 (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_dpgettext2(arg1, arg2, arg3);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (1998, 1998, 0);
}

static void sl_gdk_display_supports_cursor_color (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_cursor_color(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (1999, 1999, 0);
}

static void sl_gtk_style_context_list_regions (void)
{
   GList* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_list_regions(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2000, 2000, 0);
}

static void sl_g_app_info_get_display_name (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_display_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2001, 2001, 0);
}

static void sl_gtk_cell_editable_editing_done (void)
{
   GtkCellEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_editable_editing_done(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2002, 2002, 0);
}

static void sl_g_object_setv (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   const GValue* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   g_object_setv(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2003, 2003, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_adjustment_changed (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2004, 2004, 0);
}

static void sl_g_simple_action_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_simple_action_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2005, 2005, 0);
}

static void sl_gtk_cell_area_box_pack_end (void)
{
   GtkCellAreaBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_box_pack_end(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2006, 2006, 0);
}

static void sl_pango_layout_iter_next_run (void)
{
   gboolean retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_next_run(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2007, 2007, 0);
}

static void sl_gtk_paper_size_get_default_top_margin (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_default_top_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2008, 2008, 0);
}

static void sl_g_date_time_new (void)
{
   GDateTime* retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   gdouble arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2009, 2009, 0);
}

static void sl_gtk_entry_layout_index_to_text_index (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_layout_index_to_text_index(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2010, 2010, 0);
}

static void sl_g_variant_new_int64 (void)
{
   GVariant* retval;
   gint64 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_int64( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2011, 2011, 0);
}

static void sl_gtk_tree_view_scroll_to_cell (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   gfloat arg5;
   gfloat arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_scroll_to_cell(arg1, arg2, arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2012, 2012, 0);
}

static void sl_gtk_size_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_size_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2013, 2013, 0);
}

static void sl_g_variant_lookup_value (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GVariantType* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_lookup_value(arg1, arg2, arg3);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2014, 2014, 0);
}

static void sl_pango_layout_set_markup_with_accel (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int arg3;
   gunichar arg4;
   gunichar* arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_UINT_TYPE,sizeof(gunichar),&arg5,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_layout_set_markup_with_accel(arg1, arg2,  arg3,  arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2015, 2015, 0);
   finalize_refs(1,arg5_r); 
}

static void sl_gtk_widget_path_iter_clear_classes (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_iter_clear_classes(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2016, 2016, 0);
}

static void sl_gtk_tree_view_move_column_after (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumn* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_move_column_after(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2017, 2017, 0);
}

static void sl_gtk_tree_view_set_hadjustment (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2018, 2018, 0);
}

static void sl_g_variant_is_normal_form (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_is_normal_form(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2019, 2019, 0);
}

static void sl_g_type_interface_add_prerequisite (void)
{
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_type_interface_add_prerequisite( arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2020, 2020, 0);
}

static void sl_gtk_cell_editable_remove_widget (void)
{
   GtkCellEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_editable_remove_widget(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2021, 2021, 0);
}

static void sl_gtk_toggle_button_toggled (void)
{
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toggle_button_toggled(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2022, 2022, 0);
}

static void sl_gtk_font_chooser_set_preview_text (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_chooser_set_preview_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2023, 2023, 0);
}

static void sl_g_mount_operation_get_password (void)
{
   const char* retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_password(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2024, 2024, 0);
}

static void sl_gdk_subpixel_layout_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_subpixel_layout_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2025, 2025, 0);
}

static void sl_pango_renderer_draw_layout_line (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayoutLine* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_renderer_draw_layout_line(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2026, 2026, 0);
}

static void sl_gtk_entry_completion_insert_prefix (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_insert_prefix(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2027, 2027, 0);
}

static void sl_g_set_application_name (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   g_set_application_name(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2028, 2028, 0);
}

static void sl_gtk_file_chooser_get_filter (void)
{
   GtkFileFilter* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_filter(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2029, 2029, 0);
}

static void sl_gtk_toolbar_insert (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_toolbar_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2030, 2030, 0);
}

static void sl_g_themed_icon_prepend_name (void)
{
   GThemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_themed_icon_prepend_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2031, 2031, 0);
}

static void sl_g_date_time_get_week_of_year (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_week_of_year(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2032, 2032, 0);
}

static void sl_g_object_add_weak_pointer (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(gpointer),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_object_add_weak_pointer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2033, 2033, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_css_provider_load_from_resource (void)
{
   GtkCssProvider* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_css_provider_load_from_resource(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2034, 2034, 0);
}

static void sl_gdk_keyval_is_lower (void)
{
   gboolean retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_is_lower( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2035, 2035, 0);
}

static void sl_gtk_radio_tool_button_set_group (void)
{
   GtkRadioToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_radio_tool_button_set_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2036, 2036, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_icon_view_get_columns (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_columns(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2037, 2037, 0);
}

static void sl_g_file_replace_finish (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_replace_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2038, 2038, 0);
}

static void sl_g_compute_hmac_for_data (void)
{
   gchar* retval;
   GChecksumType arg1;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gsize arg3;
   const guchar* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg4,0x0);
   gsize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg5)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_compute_hmac_for_data( arg1, arg2,  arg3, arg4,  arg5);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2039, 2039, 0);
   finalize_refs(2,arg2_r,arg4_r); 
}

static void sl_gtk_text_buffer_get_iter_at_line (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_line(arg1, arg2,  arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2040, 2040, 0);
}

static void sl_g_object_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_object_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2041, 2041, 0);
}

static void sl_gtk_widget_region_intersect (void)
{
   cairo_region_t* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_region_intersect(arg1, arg2);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2042, 2042, 0);
}

static void sl_gdk_window_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2043, 2043, 0);
}

static void sl_gtk_cell_view_get_draw_sensitive (void)
{
   gboolean retval;
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_get_draw_sensitive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2044, 2044, 0);
}

static void sl_g_settings_schema_list_keys (void)
{
   gchar** retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_list_keys(arg1);
   push_null_term_str_array (retval, "g_settings_schema_list_keys", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2045, 2045, 0);
}

static void sl_g_variant_type_checked_ (void)
{
   const GVariantType* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_checked_(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2046, 2046, 0);
}

static void sl_gtk_accel_group_get_modifier_mask (void)
{
   GdkModifierType retval;
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_get_modifier_mask(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2047, 2047, 0);
}

static void sl_g_date_valid_day (void)
{
   gboolean retval;
   GDateDay arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_day( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2048, 2048, 0);
}

static void sl_gtk_widget_queue_draw_region (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_queue_draw_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2049, 2049, 0);
}

static void sl_g_compute_hmac_for_string (void)
{
   gchar* retval;
   GChecksumType arg1;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gsize arg3;
   gchar* arg4;
   gssize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_4;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_4;
   issue_usage = 0;

   retval = g_compute_hmac_for_string( arg1, arg2,  arg3, arg4,  arg5);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (2050, 2050, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_volume_can_mount (void)
{
   gboolean retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_can_mount(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2051, 2051, 0);
}

static void sl_gtk_list_box_row_get_activatable (void)
{
   gboolean retval;
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_get_activatable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2052, 2052, 0);
}

static void sl_gtk_gesture_rotate_get_angle_delta (void)
{
   gdouble retval;
   GtkGestureRotate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_rotate_get_angle_delta(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2053, 2053, 0);
}

static void sl_g_file_supports_thread_contexts (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_supports_thread_contexts(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2054, 2054, 0);
}

static void sl_gtk_app_chooser_dialog_get_widget (void)
{
   GtkWidget* retval;
   GtkAppChooserDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_dialog_get_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2055, 2055, 0);
}

static void sl_g_file_equal (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2056, 2056, 0);
}

static void sl_gtk_cell_view_new_with_context (void)
{
   GtkWidget* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_view_new_with_context(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2057, 2057, 0);
}

static void sl_gdk_window_raise (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_raise(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2058, 2058, 0);
}

static void sl_gdk_window_get_type_hint (void)
{
   GdkWindowTypeHint retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_type_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2059, 2059, 0);
}

static void sl_gdk_display_sync (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_sync(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2060, 2060, 0);
}

static void sl_g_signal_name (void)
{
   const gchar* retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_signal_name( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2061, 2061, 0);
}

static void sl_pango_attribute_destroy (void)
{
   PangoAttribute* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_attribute_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2062, 2062, 0);
}

static void sl_gtk_menu_shell_prepend (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_prepend(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2063, 2063, 0);
}

static void sl_gtk_toolbar_get_n_items (void)
{
   gint retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_n_items(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2064, 2064, 0);
}

static void sl_g_file_info_set_attribute_byte_string (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_byte_string(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2065, 2065, 0);
}

static void sl_gtk_builder_expose_object (void)
{
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GObject* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_builder_expose_object(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2066, 2066, 0);
}

static void sl_g_input_stream_clear_pending (void)
{
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_input_stream_clear_pending(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2067, 2067, 0);
}

static void sl_gtk_clipboard_wait_is_image_available (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_is_image_available(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2068, 2068, 0);
}

static void sl_gtk_recent_info_exists (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_exists(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2069, 2069, 0);
}

static void sl_gtk_check_menu_item_toggled (void)
{
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_check_menu_item_toggled(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2070, 2070, 0);
}

static void sl_g_mount_operation_set_choice (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_choice(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2071, 2071, 0);
}

static void sl_g_dir_open (void)
{
   GDir* retval;
   gchar* arg1;
   guint arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_dir_open(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GDir_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2072, 2072, 0);
}

static void sl_gtk_tree_selection_unselect_iter (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_unselect_iter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2073, 2073, 0);
}

static void sl_gtk_icon_theme_get_default (void)
{
   GtkIconTheme* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_get_default();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2074, 2074, 0);
}

static void sl_gtk_print_operation_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2075, 2075, 0);
}

static void sl_gtk_bin_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_bin_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2076, 2076, 0);
}

static void sl_gtk_app_chooser_widget_get_default_text (void)
{
   const gchar* retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_default_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2077, 2077, 0);
}

static void sl_gtk_tree_view_row_activated (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_row_activated(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2078, 2078, 0);
}

static void sl_gdk_pixbuf_format_is_writable (void)
{
   gboolean retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_is_writable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2079, 2079, 0);
}

static void sl_gtk_scale_set_draw_value (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_set_draw_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2080, 2080, 0);
}

static void sl_gtk_shortcuts_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcuts_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2081, 2081, 0);
}

static void sl_gtk_menu_popdown (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_popdown(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2082, 2082, 0);
}

static void sl_g_param_values_cmp (void)
{
   gint retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GValue* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_values_cmp(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2083, 2083, 0);
}

static void sl_g_rand_double (void)
{
   gdouble retval;
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_double(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2084, 2084, 0);
}

static void sl_gtk_widget_override_background_color (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg3, (void**)GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_override_background_color(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2085, 2085, 0);
}

static void sl_gdk_window_deiconify (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_deiconify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2086, 2086, 0);
}

static void sl_g_socket_get_ttl (void)
{
   guint retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_ttl(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2087, 2087, 0);
}

static void sl_gdk_status_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_status_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2088, 2088, 0);
}

static void sl_g_menu_prepend_section (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GMenuModel* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_prepend_section(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2089, 2089, 0);
}

static void sl_gdk_pixbuf_new_from_resource_at_scale (void)
{
   GdkPixbuf* retval;
   char* arg1;
   int arg2;
   int arg3;
   gboolean arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg5 = NULL;
   retval = gdk_pixbuf_new_from_resource_at_scale(arg1,  arg2,  arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2090, 2090, 0);
}

static void sl_gtk_widget_get_no_show_all (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_no_show_all(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2091, 2091, 0);
}

static void sl_g_key_file_get_locale_for_key (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg4, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_key_file_get_locale_for_key(arg1, arg2, arg3, arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (2092, 2092, 0);
}

static void sl_g_strsplit_set (void)
{
   gchar** retval;
   gchar* arg1;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strsplit_set(arg1, arg2,  arg3);
   push_null_term_str_array (retval, "g_strsplit_set", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2093, 2093, 0);
}

static void sl_g_variant_builder_close (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_variant_builder_close(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2094, 2094, 0);
}

static void sl_gtk_tree_view_column_pack_start (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_pack_start(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2095, 2095, 0);
}

static void sl_gtk_places_sidebar_get_show_starred_location (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_starred_location(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2096, 2096, 0);
}

static void sl_gtk_recent_info_get_modified (void)
{
   time_t retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_modified(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2097, 2097, 0);
}

static void sl_gtk_expander_set_label_widget (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_expander_set_label_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2098, 2098, 0);
}

static void sl_gtk_message_dialog_get_message_area (void)
{
   GtkWidget* retval;
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_message_dialog_get_message_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2099, 2099, 0);
}

static void sl_g_io_channel_get_close_on_unref (void)
{
   gboolean retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_close_on_unref(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2100, 2100, 0);
}

static void sl_gtk_tool_item_get_proxy_menu_item (void)
{
   GtkWidget* retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_item_get_proxy_menu_item(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2101, 2101, 0);
}

static void sl_gtk_menu_get_tearoff_state (void)
{
   gboolean retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_tearoff_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2102, 2102, 0);
}

static void sl_gdk_window_get_device_cursor (void)
{
   GdkCursor* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_get_device_cursor(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2103, 2103, 0);
}

static void sl_g_strerror (void)
{
   const gchar* retval;
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strerror( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2104, 2104, 0);
}

static void sl_g_settings_new_with_backend_and_path (void)
{
   GSettings* retval;
   gchar* arg1;
   GSettingsBackend* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_new_with_backend_and_path(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2105, 2105, 0);
}

static void sl_gdk_window_get_effective_toplevel (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_effective_toplevel(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2106, 2106, 0);
}

static void sl_g_settings_schema_get_id (void)
{
   const gchar* retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_get_id(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2107, 2107, 0);
}

static void sl_gtk_tree_view_column_set_max_width (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_max_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2108, 2108, 0);
}

static void sl_gtk_font_chooser_get_show_preview_entry (void)
{
   gboolean retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_show_preview_entry(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2109, 2109, 0);
}

static void sl_gtk_frame_get_label_align (void)
{
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_frame_get_label_align(arg1, &arg2, &arg3);
   (void)SLang_push_float(arg2);
   (void)SLang_push_float(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2110, 2110, 0);
}

static void sl_gtk_print_settings_get_finishings (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_finishings(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2111, 2111, 0);
}

static void sl_gtk_accel_group_activate (void)
{
   gboolean retval;
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GQuark arg2;
   GObject* arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint arg4;
   GdkModifierType arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_accel_group_activate(arg1,  arg2, arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2112, 2112, 0);
}

static void sl_gtk_widget_register_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_register_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2113, 2113, 0);
}

static void sl_gtk_switch_set_state (void)
{
   GtkSwitch* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_switch_set_state(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2114, 2114, 0);
}

static void sl_g_file_info_get_attribute_type (void)
{
   GFileAttributeType retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_type(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2115, 2115, 0);
}

static void sl_g_object_freeze_notify (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_object_freeze_notify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2116, 2116, 0);
}

static void sl_gtk_text_view_get_pixels_inside_wrap (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_pixels_inside_wrap(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2117, 2117, 0);
}

static void sl_gtk_tree_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2118, 2118, 0);
}

static void sl_gtk_tree_view_column_focus_cell (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_focus_cell(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2119, 2119, 0);
}

static void sl_pango_attr_insert_hyphens_new (void)
{
   PangoAttribute* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_insert_hyphens_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2120, 2120, 0);
}

static void sl_g_bookmark_file_set_mime_type (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_mime_type(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2121, 2121, 0);
}

static void sl_gtk_file_chooser_get_show_hidden (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_show_hidden(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2122, 2122, 0);
}

static void sl_g_strlcat (void)
{
   gsize retval;
   gchar* arg1;
   gchar* arg2;
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strlcat(arg1, arg2,  arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2123, 2123, 0);
}

static void sl_gtk_accel_map_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_map_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2124, 2124, 0);
}

static void sl_g_inet_address_new_loopback (void)
{
   GInetAddress* retval;
   GSocketFamily arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_new_loopback( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2125, 2125, 0);
}

static void sl_gdk_frame_timings_get_refresh_interval (void)
{
   gint64 retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_refresh_interval(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2126, 2126, 0);
}

static void sl_gtk_widget_event (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_event(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2127, 2127, 0);
}

static void sl_gtk_font_chooser_get_language (void)
{
   char* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_language(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2128, 2128, 0);
}

static void sl_pango_font_description_new (void)
{
   PangoFontDescription* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2129, 2129, 0);
}

static void sl_gtk_entry_set_progress_pulse_step (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_progress_pulse_step(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2130, 2130, 0);
}

static void sl_gtk_scale_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_scale_new( arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2131, 2131, 0);
}

static void sl_gdk_drag_get_selection (void)
{
   GdkAtom retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_get_selection(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2132, 2132, 0);
}

static void sl_gtk_native_dialog_show (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_native_dialog_show(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2133, 2133, 0);
}

static void sl_gdk_drop_reply (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drop_reply(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2134, 2134, 0);
}

static void sl_gtk_text_buffer_insert_range_interactive (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_insert_range_interactive(arg1, arg2, arg3, arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2135, 2135, 0);
}

static void sl_g_main_loop_ref (void)
{
   GMainLoop* retval;
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_loop_ref(arg1);
   (void)SLang_push_opaque(GMainLoop_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2136, 2136, 0);
}

static void sl_gtk_about_dialog_get_wrap_license (void)
{
   gboolean retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_wrap_license(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2137, 2137, 0);
}

static void sl_gtk_widget_get_can_focus (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_can_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2138, 2138, 0);
}

static void sl_gtk_stack_set_transition_type (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStackTransitionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_transition_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2139, 2139, 0);
}

static void sl_g_object_new_with_properties (void)
{
   GObject* retval;
   GType arg1;
   guint arg2;
   const char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   const GValue* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto free_and_return_4;
   issue_usage = 0;

   retval = g_object_new_with_properties( arg1,  arg2, arg3, arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2140, 2140, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_drive_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2141, 2141, 0);
}

static void sl_g_unichar_isxdigit (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isxdigit( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2142, 2142, 0);
}

static void sl_g_action_activate (void)
{
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_action_activate(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2143, 2143, 0);
}

static void sl_g_unichar_iswide_cjk (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_iswide_cjk( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2144, 2144, 0);
}

static void sl_g_simple_action_group_new (void)
{
   GSimpleActionGroup* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_simple_action_group_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2145, 2145, 0);
}

static void sl_gtk_layout_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_layout_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2146, 2146, 0);
}

static void sl_gtk_text_view_get_tabs (void)
{
   PangoTabArray* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_tabs(arg1);
   (void)SLang_push_opaque(PangoTabArray_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2147, 2147, 0);
}

static void sl_g_file_eject_mountable_with_operation_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_eject_mountable_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2148, 2148, 0);
}

static void sl_gtk_entry_set_completion (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryCompletion* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_completion(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2149, 2149, 0);
}

static void sl_gtk_application_window_get_show_menubar (void)
{
   gboolean retval;
   GtkApplicationWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_window_get_show_menubar(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2150, 2150, 0);
}

static void sl_gtk_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2151, 2151, 0);
}

static void sl_g_main_context_wakeup (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_wakeup(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2152, 2152, 0);
}

static void sl_g_main_context_get_thread_default (void)
{
   GMainContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_get_thread_default();
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2153, 2153, 0);
}

static void sl_g_variant_new_take_string (void)
{
   GVariant* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_take_string(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2154, 2154, 0);
}

static void sl_g_inet_socket_address_new_from_string (void)
{
   GSocketAddress* retval;
   char* arg1;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_new_from_string(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2155, 2155, 0);
}

static void sl_gtk_shortcuts_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcuts_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2156, 2156, 0);
}

static void sl_gtk_radio_button_new_with_label_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_button_new_with_label_from_widget(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2157, 2157, 0);
}

static void sl_g_date_time_new_local (void)
{
   GDateTime* retval;
   gint arg1;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_local( arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2158, 2158, 0);
}

static void sl_gtk_accelerator_get_default_mod_mask (void)
{
   GdkModifierType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_get_default_mod_mask();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2159, 2159, 0);
}

static void sl_gtk_menu_shell_select_first (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_shell_select_first(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2160, 2160, 0);
}

static void sl_g_strv_contains (void)
{
   gboolean retval;
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strv_contains(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2161, 2161, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_pango_font_description_set_variations (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_set_variations(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2162, 2162, 0);
}

static void sl_gtk_native_dialog_get_modal (void)
{
   gboolean retval;
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_native_dialog_get_modal(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2163, 2163, 0);
}

static void sl_gdk_window_set_keep_below (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_keep_below(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2164, 2164, 0);
}

static void sl_g_inet_address_mask_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_mask_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2165, 2165, 0);
}

static void sl_gtk_text_buffer_get_has_selection (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_has_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2166, 2166, 0);
}

static void sl_gtk_flow_box_set_min_children_per_line (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_min_children_per_line(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2167, 2167, 0);
}

static void sl_g_drive_can_start (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_can_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2168, 2168, 0);
}

static void sl_gdk_monitor_get_refresh_rate (void)
{
   int retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_refresh_rate(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2169, 2169, 0);
}

static void sl_g_volume_mount_finish (void)
{
   gboolean retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_volume_mount_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2170, 2170, 0);
}

static void sl_gdk_gl_context_get_debug_enabled (void)
{
   gboolean retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_debug_enabled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2171, 2171, 0);
}

static void sl_g_variant_type_peek_string (void)
{
   const gchar* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_peek_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2172, 2172, 0);
}

static void sl_gtk_recent_info_get_short_name (void)
{
   gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_short_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2173, 2173, 0);
}

static void sl_g_utf8_offset_to_pointer (void)
{
   gchar* retval;
   gchar* arg1;
   glong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_offset_to_pointer(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2174, 2174, 0);
}

static void sl_g_file_trash (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_trash(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2175, 2175, 0);
}

static void sl_gtk_widget_is_visible (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_is_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2176, 2176, 0);
}

static void sl_gdk_pixbuf_format_get_description (void)
{
   gchar* retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_description(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2177, 2177, 0);
}

static void sl_gtk_icon_info_set_raw_coordinates (void)
{
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_info_set_raw_coordinates(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2178, 2178, 0);
}

static void sl_gtk_range_set_round_digits (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_round_digits(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2179, 2179, 0);
}

static void sl_gtk_range_get_flippable (void)
{
   gboolean retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_flippable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2180, 2180, 0);
}

static void sl_g_match_info_matches (void)
{
   gboolean retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_matches(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2181, 2181, 0);
}

static void sl_gdk_pixbuf_loader_get_pixbuf (void)
{
   GdkPixbuf* retval;
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_loader_get_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2182, 2182, 0);
}

static void sl_gtk_paper_size_get_default_bottom_margin (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_default_bottom_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2183, 2183, 0);
}

static void sl_gtk_scale_button_get_value (void)
{
   gdouble retval;
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2184, 2184, 0);
}

static void sl_gtk_gesture_stylus_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_stylus_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2185, 2185, 0);
}

static void sl_gtk_window_get_default_icon_list (void)
{
   GList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_default_icon_list();
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2186, 2186, 0);
}

static void sl_gtk_entry_set_activates_default (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_activates_default(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2187, 2187, 0);
}

static void sl_g_utf8_prev_char (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_prev_char(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2188, 2188, 0);
}

static void sl_gtk_print_settings_get_length (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_length(arg1, arg2,  arg3);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2189, 2189, 0);
}

static void sl_gtk_drag_dest_add_uri_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_dest_add_uri_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2190, 2190, 0);
}

static void sl_gtk_assistant_update_buttons_state (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_update_buttons_state(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2191, 2191, 0);
}

static void sl_gdk_window_set_role (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_role(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2192, 2192, 0);
}

static void sl_gtk_css_provider_load_from_file (void)
{
   gboolean retval;
   GtkCssProvider* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_css_provider_load_from_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2193, 2193, 0);
}

static void sl_g_app_info_supports_uris (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_supports_uris(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2194, 2194, 0);
}

static void sl_gtk_text_tag_set_priority (void)
{
   GtkTextTag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_tag_set_priority(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2195, 2195, 0);
}

static void sl_pango_font_map_get_serial (void)
{
   guint retval;
   PangoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_map_get_serial(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2196, 2196, 0);
}

static void sl_gtk_list_store_new (void)
{
   GtkListStore* retval;
   gint arg1;
   GType* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_ULONG_TYPE,sizeof(GType),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   arg1 = (gint) ref_get_size(arg2_r, 0);
   retval = gtk_list_store_newv( arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2197, 2197, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_window_get_title (void)
{
   const gchar* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2198, 2198, 0);
}

static void sl_gtk_places_sidebar_set_show_recent (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_recent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2199, 2199, 0);
}

static void sl_pango_font_face_describe (void)
{
   PangoFontDescription* retval;
   PangoFontFace* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_face_describe(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2200, 2200, 0);
}

static void sl_g_value_set_pointer (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_pointer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2201, 2201, 0);
}

static void sl_g_match_info_get_string (void)
{
   const gchar* retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_get_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2202, 2202, 0);
}

static void sl_g_action_get_state_type (void)
{
   const GVariantType* retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_state_type(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2203, 2203, 0);
}

static void sl_gtk_recent_chooser_select_uri (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_recent_chooser_select_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2204, 2204, 0);
}

static void sl_pango_font_description_unset_fields (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontMask arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_unset_fields(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2205, 2205, 0);
}

static void sl_gtk_printer_request_details (void)
{
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_printer_request_details(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2206, 2206, 0);
}

static void sl_gtk_range_get_min_slider_size (void)
{
   gint retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_min_slider_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2207, 2207, 0);
}

static void sl_g_volume_monitor_get_mount_for_uuid (void)
{
   GMount* retval;
   GVolumeMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_volume_monitor_get_mount_for_uuid(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2208, 2208, 0);
}

static void sl_gtk_gesture_ungroup (void)
{
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gesture_ungroup(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2209, 2209, 0);
}

static void sl_gtk_about_dialog_get_artists (void)
{
   const gchar** retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_artists(arg1);
   push_null_term_str_array ((char **) retval, "gtk_about_dialog_get_artists", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2210, 2210, 0);
}

static void sl_g_file_delete (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_delete(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2211, 2211, 0);
}

static void sl_gtk_range_get_slider_size_fixed (void)
{
   gboolean retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_slider_size_fixed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2212, 2212, 0);
}

static void sl_g_type_check_instance_cast (void)
{
   GTypeInstance* retval;
   GTypeInstance* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_instance_cast(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2213, 2213, 0);
}

static void sl_gtk_entry_get_icon_tooltip_markup (void)
{
   gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_tooltip_markup(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2214, 2214, 0);
}

static void sl_gdk_pixbuf_new_from_file (void)
{
   GdkPixbuf* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_new_from_file(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2215, 2215, 0);
}

static void sl_g_file_info_unset_attribute_mask (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_unset_attribute_mask(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2216, 2216, 0);
}

static void sl_gtk_app_chooser_get_content_type (void)
{
   gchar* retval;
   GtkAppChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_get_content_type(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2217, 2217, 0);
}

static void sl_gtk_gesture_multi_press_set_area (void)
{
   GtkGestureMultiPress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_gesture_multi_press_set_area(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2218, 2218, 0);
}

static void sl_gdk_visual_get_blue_pixel_details (void)
{
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_visual_get_blue_pixel_details(arg1, &arg2, &arg3, &arg4);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2219, 2219, 0);
}

static void sl_gtk_accel_map_add_filter (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_add_filter(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2220, 2220, 0);
}

static void sl_g_file_query_writable_namespaces (void)
{
   GFileAttributeInfoList* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_writable_namespaces(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2221, 2221, 0);
}

static void sl_gtk_window_move (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_move(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2222, 2222, 0);
}

static void sl_gtk_window_set_modal (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_modal(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2223, 2223, 0);
}

static void sl_g_mount_guess_content_type_finish (void)
{
   gchar** retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mount_guess_content_type_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   push_null_term_str_array (retval, "g_mount_guess_content_type_finish", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2224, 2224, 0);
}

static void sl_gtk_text_view_get_left_margin (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_left_margin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2225, 2225, 0);
}

static void sl_gdk_window_input_shape_combine_region (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_input_shape_combine_region(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2226, 2226, 0);
}

static void sl_gtk_text_view_get_justification (void)
{
   GtkJustification retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_justification(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2227, 2227, 0);
}

static void sl_gtk_print_settings_set_output_bin (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_output_bin(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2228, 2228, 0);
}

static void sl_g_menu_item_new_submenu (void)
{
   GMenuItem* retval;
   gchar* arg1;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_menu_item_new_submenu(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2229, 2229, 0);
}

static void sl_gtk_size_group_set_mode (void)
{
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSizeGroupMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_size_group_set_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2230, 2230, 0);
}

static void sl_gtk_print_unix_dialog_get_selected_printer (void)
{
   GtkPrinter* retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_selected_printer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2231, 2231, 0);
}

static void sl_gtk_tree_view_get_search_entry (void)
{
   GtkEntry* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_search_entry(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2232, 2232, 0);
}

static void sl_gtk_gesture_get_bounding_box_center (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_bounding_box_center(arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2233, 2233, 0);
}

static void sl_gtk_image_set_from_pixbuf (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_pixbuf(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2234, 2234, 0);
}

static void sl_gtk_menu_item_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_new_with_label(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2235, 2235, 0);
}

static void sl_gtk_widget_get_state_flags (void)
{
   GtkStateFlags retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_state_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2236, 2236, 0);
}

static void sl_gtk_text_view_set_justification (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkJustification arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_justification(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2237, 2237, 0);
}

static void sl_g_app_info_launch_default_for_uri_finish (void)
{
   gboolean retval;
   GAsyncResult* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_app_info_launch_default_for_uri_finish(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2238, 2238, 0);
}

static void sl_g_variant_type_copy (void)
{
   GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_copy(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2239, 2239, 0);
}

static void sl_gtk_tool_item_get_homogeneous (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2240, 2240, 0);
}

static void sl_gtk_icon_theme_add_resource_path (void)
{
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_theme_add_resource_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2241, 2241, 0);
}

static void sl_g_socket_receive_with_blocking (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   gboolean arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_socket_receive_with_blocking(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (2242, 2242, 0);
}

static void sl_gtk_label_set_line_wrap (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_line_wrap(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2243, 2243, 0);
}

static void sl_g_bookmark_file_get_modified (void)
{
   time_t retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_modified(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2244, 2244, 0);
}

static void sl_gdk_pixbuf_animation_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2245, 2245, 0);
}

static void sl_gtk_text_view_set_border_window_size (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextWindowType arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_border_window_size(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2246, 2246, 0);
}

static void sl_g_credentials_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_credentials_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2247, 2247, 0);
}

static void sl_gtk_file_filter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2248, 2248, 0);
}

static void sl_gtk_label_set_max_width_chars (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_max_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2249, 2249, 0);
}

static void sl_g_file_read_link (void)
{
   gchar* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_file_read_link(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2250, 2250, 0);
}

static void sl_g_menu_append_item (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_append_item(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2251, 2251, 0);
}

static void sl_gtk_layout_get_size (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_layout_get_size(arg1, &arg2, &arg3);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_uint(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2252, 2252, 0);
}

static void sl_gtk_paned_add1 (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_paned_add1(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2253, 2253, 0);
}

static void sl_g_file_info_get_is_symlink (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_is_symlink(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2254, 2254, 0);
}

static void sl_gtk_window_set_startup_id (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_startup_id(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2255, 2255, 0);
}

static void sl_gdk_frame_clock_request_phase (void)
{
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkFrameClockPhase arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_frame_clock_request_phase(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2256, 2256, 0);
}

static void sl_gtk_window_get_deletable (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_deletable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2257, 2257, 0);
}

static void sl_g_file_get_child_for_display_name (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_get_child_for_display_name(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2258, 2258, 0);
}

static void sl_g_app_launch_context_new (void)
{
   GAppLaunchContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_launch_context_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2259, 2259, 0);
}

static void sl_pango_ft2_font_map_new (void)
{
   PangoFontMap* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_ft2_font_map_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2260, 2260, 0);
}

static void sl_gtk_clipboard_set_image (void)
{
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_clipboard_set_image(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2261, 2261, 0);
}

static void sl_gtk_icon_view_set_tooltip_column (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_tooltip_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2262, 2262, 0);
}

static void sl_g_file_attribute_matcher_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_matcher_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2263, 2263, 0);
}

static void sl_gtk_window_group_list_windows (void)
{
   GList* retval;
   GtkWindowGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_group_list_windows(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2264, 2264, 0);
}

static void sl_g_io_channel_init (void)
{
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_io_channel_init(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2265, 2265, 0);
}

static void sl_pango_attr_type_register (void)
{
   PangoAttrType retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_type_register(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2266, 2266, 0);
}

static void sl_g_file_append_to (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileCreateFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_append_to(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2267, 2267, 0);
}

static void sl_gtk_style_context_get_section (void)
{
   GtkCssSection* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_style_context_get_section(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2268, 2268, 0);
}

static void sl_gdk_window_move (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_move(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2269, 2269, 0);
}

static void sl_gtk_file_chooser_native_set_cancel_label (void)
{
   GtkFileChooserNative* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_native_set_cancel_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2270, 2270, 0);
}

static void sl_gtk_combo_box_get_focus_on_click (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_focus_on_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2271, 2271, 0);
}

static void sl_g_param_value_defaults (void)
{
   gboolean retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_value_defaults(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2272, 2272, 0);
}

static void sl_gtk_cell_renderer_stop_editing (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_stop_editing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2273, 2273, 0);
}

static void sl_gtk_print_settings_set_paper_size (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPaperSize* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_paper_size(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2274, 2274, 0);
}

static void sl_gtk_cell_area_is_focus_sibling (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRenderer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_is_focus_sibling(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2275, 2275, 0);
}

static void sl_g_simple_proxy_resolver_new (void)
{
   GProxyResolver* retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_simple_proxy_resolver_new(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2276, 2276, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_entry_set_visibility (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_visibility(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2277, 2277, 0);
}

static void sl_gtk_list_box_row_get_index (void)
{
   gint retval;
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_get_index(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2278, 2278, 0);
}

static void sl_gtk_widget_get_can_default (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_can_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2279, 2279, 0);
}

static void sl_gdk_window_set_pass_through (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_pass_through(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2280, 2280, 0);
}

static void sl_g_charset_converter_get_num_fallbacks (void)
{
   guint retval;
   GCharsetConverter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_charset_converter_get_num_fallbacks(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2281, 2281, 0);
}

static void sl_gtk_print_job_set_collate (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_collate(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2282, 2282, 0);
}

static void sl_gtk_combo_box_set_title (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2283, 2283, 0);
}

static void sl_g_network_address_parse (void)
{
   GSocketConnectable* retval;
   gchar* arg1;
   guint16 arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_network_address_parse(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2284, 2284, 0);
}

static void sl_g_settings_is_writable (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_is_writable(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2285, 2285, 0);
}

static void sl_gtk_print_job_get_surface (void)
{
   cairo_surface_t* retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_print_job_get_surface(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2286, 2286, 0);
}

static void sl_gtk_drawing_area_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_drawing_area_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2287, 2287, 0);
}

static void sl_gtk_widget_get_preferred_height_for_width (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_height_for_width(arg1,  arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2288, 2288, 0);
}

static void sl_g_get_console_charset (void)
{
   gboolean retval;
   const char** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_get_console_charset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2289, 2289, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_widget_path_has_parent (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_has_parent(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2290, 2290, 0);
}

static void sl_gtk_tree_view_unset_rows_drag_source (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_unset_rows_drag_source(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2291, 2291, 0);
}

static void sl_g_variant_is_floating (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_is_floating(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2292, 2292, 0);
}

static void sl_gtk_adjustment_configure (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   gdouble arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_configure(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2293, 2293, 0);
}

static void sl_gtk_print_settings_get_duplex (void)
{
   GtkPrintDuplex retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_duplex(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2294, 2294, 0);
}

static void sl_gdk_window_reparent (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_reparent(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2295, 2295, 0);
}

static void sl_gtk_cell_renderer_spin_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_spin_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2296, 2296, 0);
}

static void sl_g_object_ref_sink (void)
{
   gpointer retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_ref_sink(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2297, 2297, 0);
}

static void sl_gtk_menu_item_get_use_underline (void)
{
   gboolean retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_use_underline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2298, 2298, 0);
}

static void sl_gtk_tree_path_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2299, 2299, 0);
}

static void sl_gtk_label_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2300, 2300, 0);
}

static void sl_g_inet_address_mask_equal (void)
{
   gboolean retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddressMask* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_inet_address_mask_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2301, 2301, 0);
}

static void sl_gtk_cell_area_get_focus_from_sibling (void)
{
   GtkCellRenderer* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_get_focus_from_sibling(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2302, 2302, 0);
}

static void sl_gtk_separator_tool_item_get_draw (void)
{
   gboolean retval;
   GtkSeparatorToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_tool_item_get_draw(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2303, 2303, 0);
}

static void sl_gtk_widget_get_window (void)
{
   GdkWindow* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2304, 2304, 0);
}

static void sl_gtk_color_button_get_title (void)
{
   const gchar* retval;
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2305, 2305, 0);
}

static void sl_gtk_gesture_long_press_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_long_press_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2306, 2306, 0);
}

static void sl_gtk_popover_get_pointing_to (void)
{
   gboolean retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_pointing_to(arg1, arg2);
   (void)SLang_push_int(retval);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2307, 2307, 0);
}

static void sl_gtk_scale_button_get_minus_button (void)
{
   GtkWidget* retval;
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_minus_button(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2308, 2308, 0);
}

static void sl_gtk_radio_menu_item_join_group (void)
{
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRadioMenuItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_radio_menu_item_join_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2309, 2309, 0);
}

static void sl_gtk_print_settings_get_resolution (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_resolution(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2310, 2310, 0);
}

static void sl_g_stpcpy (void)
{
   gchar* retval;
   gchar* arg1;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_stpcpy(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2311, 2311, 0);
}

static void sl_gtk_entry_buffer_emit_inserted_text (void)
{
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gchar* arg3;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_buffer_emit_inserted_text(arg1,  arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2312, 2312, 0);
}

static void sl_g_settings_schema_key_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2313, 2313, 0);
}

static void sl_g_utf8_strlen (void)
{
   glong retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strlen(arg1,  arg2);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2314, 2314, 0);
}

static void sl_gtk_grid_insert_next_to (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkPositionType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_grid_insert_next_to(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2315, 2315, 0);
}

static void sl_g_value_set_instance (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_instance(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2316, 2316, 0);
}

static void sl_pango_attr_list_splice (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttrList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_attr_list_splice(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2317, 2317, 0);
}

static void sl_gtk_image_set_from_gicon (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_gicon(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2318, 2318, 0);
}

static void sl_gtk_recent_info_get_icon (void)
{
   GdkPixbuf* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_icon(arg1,  arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2319, 2319, 0);
}

static void sl_gtk_message_dialog_set_image (void)
{
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_message_dialog_set_image(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2320, 2320, 0);
}

static void sl_gdk_event_set_screen (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_event_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2321, 2321, 0);
}

static void sl_g_settings_set_double (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_double(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2322, 2322, 0);
}

static void sl_g_date_get_monday_weeks_in_year (void)
{
   guint8 retval;
   GDateYear arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_monday_weeks_in_year( arg1);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2323, 2323, 0);
}

static void sl_gtk_button_new_from_stock (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_new_from_stock(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2324, 2324, 0);
}

static void sl_gtk_print_operation_preview_is_selected (void)
{
   gboolean retval;
   GtkPrintOperationPreview* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_preview_is_selected(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2325, 2325, 0);
}

static void sl_gtk_widget_path_iter_set_state (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GtkStateFlags arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_iter_set_state(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2326, 2326, 0);
}

static void sl_gtk_size_group_set_ignore_hidden (void)
{
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_size_group_set_ignore_hidden(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2327, 2327, 0);
}

static void sl_gtk_builder_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2328, 2328, 0);
}

static void sl_gtk_cell_renderer_accel_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_accel_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2329, 2329, 0);
}

static void sl_gtk_file_chooser_list_shortcut_folders (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_list_shortcut_folders(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2330, 2330, 0);
}

static void sl_gtk_check_menu_item_get_inconsistent (void)
{
   gboolean retval;
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_get_inconsistent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2331, 2331, 0);
}

static void sl_gtk_page_setup_unix_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_unix_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2332, 2332, 0);
}

static void sl_gtk_text_buffer_create_child_anchor (void)
{
   GtkTextChildAnchor* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_create_child_anchor(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2333, 2333, 0);
}

static void sl_gtk_icon_view_get_item_width (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_item_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2334, 2334, 0);
}

static void sl_g_settings_schema_has_key (void)
{
   gboolean retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_schema_has_key(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2335, 2335, 0);
}

static void sl_gtk_text_iter_get_chars_in_line (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_chars_in_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2336, 2336, 0);
}

static void sl_g_variant_new_signature (void)
{
   GVariant* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_signature(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2337, 2337, 0);
}

static void sl_gtk_layout_set_hadjustment (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_layout_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2338, 2338, 0);
}

static void sl_gtk_builder_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2339, 2339, 0);
}

static void sl_g_filename_completer_new (void)
{
   GFilenameCompleter* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_filename_completer_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2340, 2340, 0);
}

static void sl_g_strreverse (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strreverse(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2341, 2341, 0);
}

static void sl_gtk_window_set_transient_for (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_transient_for(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2342, 2342, 0);
}

static void sl_g_drive_is_media_removable (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_is_media_removable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2343, 2343, 0);
}

static void sl_g_drive_get_sort_key (void)
{
   const gchar* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_sort_key(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2344, 2344, 0);
}

static void sl_gtk_widget_is_focus (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_is_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2345, 2345, 0);
}

static void sl_gtk_window_get_resizable (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_resizable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2346, 2346, 0);
}

static void sl_gdk_wm_decoration_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_wm_decoration_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2347, 2347, 0);
}

static void sl_gtk_tree_path_next (void)
{
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_path_next(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2348, 2348, 0);
}

static void sl_g_socket_get_family (void)
{
   GSocketFamily retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_family(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2349, 2349, 0);
}

static void sl_gtk_icon_info_load_symbolic_for_context (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_icon_info_load_symbolic_for_context(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2350, 2350, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_uri_escape_string (void)
{
   char* retval;
   char* arg1;
   char* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_uri_escape_string(arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2351, 2351, 0);
}

static void sl_gtk_header_bar_set_has_subtitle (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_header_bar_set_has_subtitle(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2352, 2352, 0);
}

static void sl_gtk_level_bar_get_min_value (void)
{
   gdouble retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_min_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2353, 2353, 0);
}

static void sl_g_settings_get_boolean (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_boolean(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2354, 2354, 0);
}

static void sl_gtk_drag_dest_set_track_motion (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_dest_set_track_motion(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2355, 2355, 0);
}

static void sl_gtk_file_chooser_get_preview_widget_active (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_preview_widget_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2356, 2356, 0);
}

static void sl_gtk_tool_item_group_get_item_position (void)
{
   gint retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_item_position(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2357, 2357, 0);
}

static void sl_g_settings_schema_get_path (void)
{
   const gchar* retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_get_path(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2358, 2358, 0);
}

static void sl_gtk_combo_box_text_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_text_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2359, 2359, 0);
}

static void sl_gtk_widget_is_drawable (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_is_drawable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2360, 2360, 0);
}

static void sl_g_settings_list_children (void)
{
   gchar** retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_list_children(arg1);
   push_null_term_str_array (retval, "g_settings_list_children", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2361, 2361, 0);
}

static void sl_gtk_gesture_pan_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_pan_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2362, 2362, 0);
}

static void sl_gtk_lock_button_new (void)
{
   GtkWidget* retval;
   GPermission* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_lock_button_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2363, 2363, 0);
}

static void sl_gtk_icon_view_get_model (void)
{
   GtkTreeModel* retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2364, 2364, 0);
}

static void sl_gtk_font_button_set_show_style (void)
{
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_button_set_show_style(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2365, 2365, 0);
}

static void sl_gtk_style_context_get_path (void)
{
   const GtkWidgetPath* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_path(arg1);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2366, 2366, 0);
}

static void sl_g_variant_new_string (void)
{
   GVariant* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_string(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2367, 2367, 0);
}

static void sl_gtk_combo_box_set_active_id (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_combo_box_set_active_id(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2368, 2368, 0);
}

static void sl_g_app_info_get_default_for_uri_scheme (void)
{
   GAppInfo* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_default_for_uri_scheme(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2369, 2369, 0);
}

static void sl_gtk_menu_set_tearoff_state (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_set_tearoff_state(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2370, 2370, 0);
}

static void sl_gtk_print_job_set_n_up (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_n_up(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2371, 2371, 0);
}

static void sl_gtk_window_get_transient_for (void)
{
   GtkWindow* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_transient_for(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2372, 2372, 0);
}

static void sl_g_date_set_year (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateYear arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_year(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2373, 2373, 0);
}

static void sl_g_networking_init (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   g_networking_init();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2374, 2374, 0);
}

static void sl_g_mount_operation_get_username (void)
{
   const char* retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_username(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2375, 2375, 0);
}

static void sl_gtk_font_button_set_title (void)
{
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_button_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2376, 2376, 0);
}

static void sl_g_param_value_convert (void)
{
   gboolean retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GValue* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_value_convert(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2377, 2377, 0);
}

static void sl_gtk_tree_view_set_level_indentation (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_level_indentation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2378, 2378, 0);
}

static void sl_g_file_info_get_attribute_data (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileAttributeType* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(GFileAttributeType),&arg3,0x0);
   gpointer* arg4;
   Slirp_Ref *arg4_r = ref_new(GtkOpaque_Type,sizeof(gpointer),&arg4,0x0);
   GFileAttributeStatus* arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_INT_TYPE,sizeof(GFileAttributeStatus),&arg5,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_data(arg1, arg2, arg3, arg4, arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2379, 2379, 0);
   finalize_refs(3,arg3_r,arg4_r,arg5_r); 
}

static void sl_gtk_icon_theme_get_example_icon_name (void)
{
   char* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_get_example_icon_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2380, 2380, 0);
}

static void sl_gtk_target_entry_copy (void)
{
   GtkTargetEntry* retval;
   GtkTargetEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_entry_copy(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2381, 2381, 0);
}

static void sl_gdk_event_is_scroll_stop_event (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_is_scroll_stop_event(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2382, 2382, 0);
}

static void sl_g_type_init (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   g_type_init();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2383, 2383, 0);
}

static void sl_g_settings_schema_list_children (void)
{
   gchar** retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_list_children(arg1);
   push_null_term_str_array (retval, "g_settings_schema_list_children", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2384, 2384, 0);
}

static void sl_gtk_menu_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2385, 2385, 0);
}

static void sl_gtk_cell_renderer_get_aligned_area (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRendererState arg3;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_aligned_area(arg1, arg2,  arg3, arg4, arg5);
   (void) SLang_push_cstruct ((VOID_STAR) arg5, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2386, 2386, 0);
}

static void sl_gtk_fixed_put (void)
{
   GtkFixed* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_fixed_put(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2387, 2387, 0);
}

static void sl_gtk_text_iter_editable (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_editable(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2388, 2388, 0);
}

static void sl_g_main_context_is_owner (void)
{
   gboolean retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_is_owner(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2389, 2389, 0);
}

static void sl_gtk_clipboard_get_for_display (void)
{
   GtkClipboard* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_clipboard_get_for_display(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2390, 2390, 0);
}

static void sl_gtk_text_buffer_begin_user_action (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_buffer_begin_user_action(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2391, 2391, 0);
}

static void sl_pango_font_metrics_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2392, 2392, 0);
}

static void sl_g_drive_get_name (void)
{
   char* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2393, 2393, 0);
}

static void sl_g_network_monitor_can_reach (void)
{
   gboolean retval;
   GNetworkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSocketConnectable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_network_monitor_can_reach(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2394, 2394, 0);
}

static void sl_gtk_check_menu_item_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2395, 2395, 0);
}

static void sl_gtk_grid_set_row_spacing (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_row_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2396, 2396, 0);
}

static void sl_gtk_spin_button_update (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_update(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2397, 2397, 0);
}

static void sl_gtk_button_get_image_position (void)
{
   GtkPositionType retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_image_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2398, 2398, 0);
}

static void sl_g_variant_type_is_definite (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_definite(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2399, 2399, 0);
}

static void sl_gdk_flush (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_flush();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2400, 2400, 0);
}

static void sl_gdk_screen_get_resolution (void)
{
   gdouble retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_resolution(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2401, 2401, 0);
}

static void sl_pango_layout_set_attributes (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttrList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_layout_set_attributes(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2402, 2402, 0);
}

static void sl_gtk_cell_view_new_with_text (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_new_with_text(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2403, 2403, 0);
}

static void sl_gtk_widget_input_shape_combine_region (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_input_shape_combine_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2404, 2404, 0);
}

static void sl_gtk_calendar_get_date (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_get_date(arg1, &arg2, &arg3, &arg4);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_uint(arg3);
   (void)SLang_push_uint(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2405, 2405, 0);
}

static void sl_gtk_image_clear (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2406, 2406, 0);
}

static void sl_g_date_set_parse (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_date_set_parse(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2407, 2407, 0);
}

static void sl_gtk_overlay_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_overlay_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2408, 2408, 0);
}

static void sl_pango_layout_line_unref (void)
{
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_line_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2409, 2409, 0);
}

static void sl_g_app_info_create_from_commandline (void)
{
   GAppInfo* retval;
   char* arg1;
   char* arg2;
   GAppInfoCreateFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_app_info_create_from_commandline(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2410, 2410, 0);
}

static void sl_gtk_font_button_set_font_name (void)
{
   gboolean retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_font_button_set_font_name(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2411, 2411, 0);
}

static void sl_gdk_visual_get_red_pixel_details (void)
{
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_visual_get_red_pixel_details(arg1, &arg2, &arg3, &arg4);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2412, 2412, 0);
}

static void sl_gtk_tree_model_filter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_filter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2413, 2413, 0);
}

static void sl_gtk_entry_set_placeholder_text (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_placeholder_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2414, 2414, 0);
}

static void sl_g_socket_send_to (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSocketAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gsize arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_socket_send_to(arg1, arg2, arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (2415, 2415, 0);
}

static void sl_gtk_popover_set_position (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPositionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_set_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2416, 2416, 0);
}

static void sl_gdk_anchor_hints_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_anchor_hints_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2417, 2417, 0);
}

static void sl_gtk_entry_get_current_icon_drag_source (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_current_icon_drag_source(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2418, 2418, 0);
}

static void sl_gdk_window_fullscreen_on_monitor (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_fullscreen_on_monitor(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2419, 2419, 0);
}

static void sl_gtk_check_button_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_button_new_with_label(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2420, 2420, 0);
}

static void sl_gdk_pixbuf_simple_anim_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_simple_anim_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2421, 2421, 0);
}

static void sl_gdk_display_get_device_manager (void)
{
   GdkDeviceManager* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_device_manager(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2422, 2422, 0);
}

static void sl_g_simple_action_group_remove (void)
{
   GSimpleActionGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_action_group_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2423, 2423, 0);
}

static void sl_gtk_gesture_drag_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_drag_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2424, 2424, 0);
}

static void sl_gtk_flow_box_child_is_selected (void)
{
   gboolean retval;
   GtkFlowBoxChild* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_child_is_selected(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2425, 2425, 0);
}

static void sl_gtk_tree_iter_copy (void)
{
   GtkTreeIter* retval;
   GtkTreeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_iter_copy(arg1);
   (void)SLang_push_opaque(GtkTreeIter_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2426, 2426, 0);
}

static void sl_gtk_recent_chooser_set_limit (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_limit(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2427, 2427, 0);
}

static void sl_gtk_gl_area_get_use_es (void)
{
   gboolean retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_use_es(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2428, 2428, 0);
}

static void sl_gtk_flow_box_select_child (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFlowBoxChild* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_flow_box_select_child(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2429, 2429, 0);
}

static void sl_gtk_text_view_get_visible_rect (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_get_visible_rect(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2430, 2430, 0);
}

static void sl_g_source_add_child_source (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSource* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_source_add_child_source(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2431, 2431, 0);
}

static void sl_g_filename_completer_set_dirs_only (void)
{
   GFilenameCompleter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_filename_completer_set_dirs_only(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2432, 2432, 0);
}

static void sl_gtk_recent_chooser_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2433, 2433, 0);
}

static void sl_gdk_pixbuf_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2434, 2434, 0);
}

static void sl_gtk_print_operation_get_default_page_setup (void)
{
   GtkPageSetup* retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_default_page_setup(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2435, 2435, 0);
}

static void sl_g_simple_action_group_insert (void)
{
   GSimpleActionGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAction* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_action_group_insert(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2436, 2436, 0);
}

static void sl_gdk_selection_send_notify_for_display (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkAtom arg4;
   Slirp_Opaque* arg4_o = NULL;
   GdkAtom arg5;
   Slirp_Opaque* arg5_o = NULL;
   guint32 arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_selection_send_notify_for_display(arg1, arg2, arg3, arg4, arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (2437, 2437, 0);
}

static void sl_gtk_window_set_focus_on_map (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_focus_on_map(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2438, 2438, 0);
}

static void sl_g_checksum_type_get_length (void)
{
   gssize retval;
   GChecksumType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_checksum_type_get_length( arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2439, 2439, 0);
}

static void sl_gtk_native_dialog_get_transient_for (void)
{
   GtkWindow* retval;
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_native_dialog_get_transient_for(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2440, 2440, 0);
}

static void sl_g_variant_equal (void)
{
   gboolean retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2441, 2441, 0);
}

static void sl_gtk_tool_palette_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2442, 2442, 0);
}

static void sl_gtk_print_settings_get_paper_width (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_paper_width(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2443, 2443, 0);
}

static void sl_gtk_notebook_remove_page (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_remove_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2444, 2444, 0);
}

static void sl_g_source_remove_poll (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPollFD* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_source_remove_poll(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2445, 2445, 0);
}

static void sl_gtk_print_unix_dialog_set_manual_capabilities (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintCapabilities arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_unix_dialog_set_manual_capabilities(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2446, 2446, 0);
}

static void sl_gtk_drag_highlight (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_highlight(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2447, 2447, 0);
}

static void sl_gtk_spin_button_set_snap_to_ticks (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_snap_to_ticks(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2448, 2448, 0);
}

static void sl_g_variant_builder_new (void)
{
   GVariantBuilder* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_builder_new(arg1);
   (void)SLang_push_opaque(GVariantBuilder_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2449, 2449, 0);
}

static void sl_gdk_keymap_get_caps_lock_state (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_caps_lock_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2450, 2450, 0);
}

static void sl_g_unichar_fully_decompose (void)
{
   gsize retval;
   gunichar arg1;
   gboolean arg2;
   gunichar arg3;
   gsize arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_fully_decompose( arg1,  arg2, &arg3,  arg4);
   (void)SLang_push_ulong(retval);
   (void)SLang_push_uint(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2451, 2451, 0);
}

static void sl_gtk_label_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2452, 2452, 0);
}

static void sl_g_variant_type_new (void)
{
   GVariantType* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_new(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2453, 2453, 0);
}

static void sl_gdk_pixbuf_get_from_surface (void)
{
   GdkPixbuf* retval;
   cairo_surface_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_from_surface(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2454, 2454, 0);
}

static void sl_pango_layout_iter_next_char (void)
{
   gboolean retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_next_char(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2455, 2455, 0);
}

static void sl_gdk_drag_context_manage_dnd (void)
{
   gboolean retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDragAction arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_drag_context_manage_dnd(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2456, 2456, 0);
}

static void sl_gdk_pixbuf_set_option (void)
{
   gboolean retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_set_option(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2457, 2457, 0);
}

static void sl_gtk_paper_size_new_custom (void)
{
   GtkPaperSize* retval;
   gchar* arg1;
   gchar* arg2;
   gdouble arg3;
   gdouble arg4;
   GtkUnit arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_paper_size_new_custom(arg1, arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2458, 2458, 0);
}

static void sl_g_variant_builder_end (void)
{
   GVariant* retval;
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_builder_end(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2459, 2459, 0);
}

static void sl_gtk_widget_path_iter_has_qregion (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GQuark arg3;
   GtkRegionFlags* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(GtkRegionFlags),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_qregion(arg1,  arg2,  arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2460, 2460, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_g_variant_get_uint16 (void)
{
   guint16 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_uint16(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2461, 2461, 0);
}

static void sl_g_source_set_ready_time (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint64 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_source_set_ready_time(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2462, 2462, 0);
}

static void sl_gtk_file_chooser_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2463, 2463, 0);
}

static void sl_g_object_watch_closure (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GClosure* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_object_watch_closure(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2464, 2464, 0);
}

static void sl_pango_parse_markup (void)
{
   gboolean retval;
   char* arg1;
   int arg2;
   gunichar arg3;
   PangoAttrList** arg4;
   Slirp_Ref *arg4_r = ref_new(PangoAttrList_Type,sizeof(PangoAttrList*),&arg4,0x0);
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   gunichar* arg6;
   Slirp_Ref *arg6_r = ref_new(SLANG_UINT_TYPE,sizeof(gunichar),&arg6,0x0);
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x1, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x1, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg7 = NULL;
   retval = pango_parse_markup(arg1,  arg2,  arg3, arg4, arg5, arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2465, 2465, 0);
   finalize_refs(3,arg4_r,arg5_r,arg6_r); 
}

static void sl_g_io_channel_unix_get_fd (void)
{
   gint retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_unix_get_fd(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2466, 2466, 0);
}

static void sl_gtk_draw_insertion_cursor (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   gboolean arg4;
   GtkTextDirection arg5;
   gboolean arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_draw_insertion_cursor(arg1, arg2, arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2467, 2467, 0);
}

static void sl_gtk_print_unix_dialog_set_current_page (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_unix_dialog_set_current_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2468, 2468, 0);
}

static void sl_gdk_event_get_state (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_state(arg1, &arg2);
   if (retval)
      (void)SLang_push_int(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2469, 2469, 0);
}

static void sl_gtk_text_buffer_remove_selection_clipboard (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkClipboard* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_remove_selection_clipboard(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2470, 2470, 0);
}

static void sl_gtk_scrolled_window_set_max_content_height (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_max_content_height(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2471, 2471, 0);
}

static void sl_g_object_is_floating (void)
{
   gboolean retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_is_floating(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2472, 2472, 0);
}

static void sl_gdk_pixbuf_simple_anim_set_loop (void)
{
   GdkPixbufSimpleAnim* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_pixbuf_simple_anim_set_loop(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2473, 2473, 0);
}

static void sl_gtk_message_dialog_format_secondary_markup (void)
{
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_message_dialog_format_secondary_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2474, 2474, 0);
}

static void sl_gtk_window_get_icon (void)
{
   GdkPixbuf* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_icon(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2475, 2475, 0);
}

static void sl_gtk_label_set_use_underline (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_use_underline(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2476, 2476, 0);
}

static void sl_pango_renderer_draw_glyphs (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFont* arg2;
   Slirp_Opaque* arg2_o = NULL;
   PangoGlyphString* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoGlyphString_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_renderer_draw_glyphs(arg1, arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2477, 2477, 0);
}

static void sl_gtk_list_box_set_adjustment (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_set_adjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2478, 2478, 0);
}

static void sl_gtk_recent_chooser_menu_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_menu_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2479, 2479, 0);
}

static void sl_gtk_about_dialog_set_logo (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GdkPixbuf_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_logo(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2480, 2480, 0);
}

static void sl_g_date_time_get_utc_offset (void)
{
   GTimeSpan retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_utc_offset(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2481, 2481, 0);
}

static void sl_gtk_entry_completion_delete_action (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_delete_action(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2482, 2482, 0);
}

static void sl_g_notification_set_icon (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_set_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2483, 2483, 0);
}

static void sl_gtk_notebook_get_show_tabs (void)
{
   gboolean retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_show_tabs(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2484, 2484, 0);
}

static void sl_gtk_cell_view_set_displayed_row (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreePath_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_view_set_displayed_row(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2485, 2485, 0);
}

static void sl_gdk_display_request_selection_notification (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_display_request_selection_notification(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2486, 2486, 0);
}

static void sl_g_date_compare (void)
{
   gint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GDate* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2487, 2487, 0);
}

static void sl_g_type_check_value_holds (void)
{
   gboolean retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_value_holds(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2488, 2488, 0);
}

static void sl_g_file_info_set_file_type (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_set_file_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2489, 2489, 0);
}

static void sl_gdk_display_set_double_click_time (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_set_double_click_time(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2490, 2490, 0);
}

static void sl_gdk_pixbuf_fill (void)
{
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_pixbuf_fill(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2491, 2491, 0);
}

static void sl_g_file_info_get_deletion_date (void)
{
   GDateTime* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_deletion_date(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2492, 2492, 0);
}

static void sl_gtk_app_chooser_dialog_set_heading (void)
{
   GtkAppChooserDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_app_chooser_dialog_set_heading(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2493, 2493, 0);
}

static void sl_gtk_css_provider_load_from_data (void)
{
   gboolean retval;
   GtkCssProvider* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_css_provider_load_from_data(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2494, 2494, 0);
}

static void sl_gdk_offscreen_window_set_embedder (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_offscreen_window_set_embedder(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2495, 2495, 0);
}

static void sl_gdk_keyval_name (void)
{
   gchar* retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_name( arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2496, 2496, 0);
}

static void sl_gtk_text_buffer_create_mark (void)
{
   GtkTextMark* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_create_mark(arg1, arg2, arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2497, 2497, 0);
}

static void sl_gtk_stack_get_transition_type (void)
{
   GtkStackTransitionType retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_transition_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2498, 2498, 0);
}

static void sl_gtk_flow_box_set_vadjustment (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_flow_box_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2499, 2499, 0);
}

static void sl_g_credentials_set_native (void)
{
   GCredentials* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCredentialsType arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_credentials_set_native(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2500, 2500, 0);
}

static void sl_gtk_print_operation_preview_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_preview_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2501, 2501, 0);
}

static void sl_gtk_gesture_set_state (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEventSequenceState arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_set_state(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2502, 2502, 0);
}

static void sl_g_file_set_attributes_from_info (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GFileQueryInfoFlags arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_file_set_attributes_from_info(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2503, 2503, 0);
}

static void sl_gtk_menu_item_set_submenu (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_item_set_submenu(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2504, 2504, 0);
}

static void sl_gtk_text_buffer_insert_range (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_insert_range(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2505, 2505, 0);
}

static void sl_g_socket_set_keepalive (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_keepalive(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2506, 2506, 0);
}

static void sl_gtk_font_chooser_set_font_map (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontMap* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_chooser_set_font_map(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2507, 2507, 0);
}

static void sl_gtk_tree_selection_get_tree_view (void)
{
   GtkTreeView* retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_get_tree_view(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2508, 2508, 0);
}

static void sl_gtk_window_get_titlebar (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_titlebar(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2509, 2509, 0);
}

static void sl_g_menu_item_set_link (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GMenuModel* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_link(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2510, 2510, 0);
}

static void sl_gtk_selection_data_get_selection (void)
{
   GdkAtom retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_selection(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2511, 2511, 0);
}

static void sl_gtk_notebook_get_tab_detachable (void)
{
   gboolean retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_detachable(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2512, 2512, 0);
}

static void sl_gtk_tree_path_new_first (void)
{
   GtkTreePath* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_new_first();
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2513, 2513, 0);
}

static void sl_g_menu_remove_all (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_menu_remove_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2514, 2514, 0);
}

static void sl_gtk_tree_store_clear (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_store_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2515, 2515, 0);
}

static void sl_gtk_text_view_set_overwrite (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_overwrite(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2516, 2516, 0);
}

static void sl_gtk_builder_add_objects_from_resource (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_builder_add_objects_from_resource(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2517, 2517, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_unrealize (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_unrealize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2518, 2518, 0);
}

static void sl_gtk_combo_box_get_popup_accessible (void)
{
   AtkObject* retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_popup_accessible(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2519, 2519, 0);
}

static void sl_gtk_editable_select_region (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_select_region(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2520, 2520, 0);
}

static void sl_g_source_ref (void)
{
   GSource* retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_ref(arg1);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2521, 2521, 0);
}

static void sl_g_settings_revert (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_revert(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2522, 2522, 0);
}

static void sl_gdk_display_supports_input_shapes (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_input_shapes(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2523, 2523, 0);
}

static void sl_gtk_image_new_from_animation (void)
{
   GtkWidget* retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_animation(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2524, 2524, 0);
}

static void sl_gtk_gesture_get_bounding_box (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_bounding_box(arg1, arg2);
   (void)SLang_push_int(retval);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2525, 2525, 0);
}

static void sl_pango_renderer_draw_layout (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayout* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_renderer_draw_layout(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2526, 2526, 0);
}

static void sl_gdk_pixbuf_animation_get_static_image (void)
{
   GdkPixbuf* retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_get_static_image(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2527, 2527, 0);
}

static void sl_g_file_set_attribute_int64 (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gint64 arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_long((long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_int64(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (2528, 2528, 0);
}

static void sl_gtk_recent_manager_get_default (void)
{
   GtkRecentManager* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_manager_get_default();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2529, 2529, 0);
}

static void sl_gtk_widget_path_iter_set_object_type (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_iter_set_object_type(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2530, 2530, 0);
}

static void sl_g_match_info_fetch_named (void)
{
   gchar* retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_match_info_fetch_named(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2531, 2531, 0);
}

static void sl_gtk_tree_path_free (void)
{
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_path_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2532, 2532, 0);
}

static void sl_g_type_get_plugin (void)
{
   GTypePlugin* retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_get_plugin( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2533, 2533, 0);
}

static void sl_gtk_label_get_track_visited_links (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_track_visited_links(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2534, 2534, 0);
}

static void sl_gdk_gl_context_set_required_version (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_set_required_version(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2535, 2535, 0);
}

static void sl_gtk_adjustment_get_page_increment (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_page_increment(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2536, 2536, 0);
}

static void sl_g_file_open_readwrite_finish (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_open_readwrite_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2537, 2537, 0);
}

static void sl_gtk_entry_set_buffer (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryBuffer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_buffer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2538, 2538, 0);
}

static void sl_gdk_window_get_composited (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_composited(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2539, 2539, 0);
}

static void sl_gtk_widget_path_to_string (void)
{
   char* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2540, 2540, 0);
}

static void sl_g_unichar_get_mirror_char (void)
{
   gboolean retval;
   gunichar arg1;
   gunichar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_get_mirror_char( arg1, &arg2);
   (void)SLang_push_int(retval);
   (void)SLang_push_uint(arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2541, 2541, 0);
}

static void sl_gtk_drag_set_icon_gicon (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_gicon(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2542, 2542, 0);
}

static void sl_g_network_address_new (void)
{
   GSocketConnectable* retval;
   gchar* arg1;
   guint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_new(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2543, 2543, 0);
}

static void sl_gtk_tree_view_column_get_clickable (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_clickable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2544, 2544, 0);
}

static void sl_gtk_entry_get_icon_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_pixbuf(arg1,  arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2545, 2545, 0);
}

static void sl_gdk_event_get_event_type (void)
{
   GdkEventType retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_event_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2546, 2546, 0);
}

static void sl_gtk_tree_view_get_hover_expand (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_hover_expand(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2547, 2547, 0);
}

static void sl_gdk_pixbuf_copy_options (void)
{
   gboolean retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_copy_options(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2548, 2548, 0);
}

static void sl_gdk_keyval_is_upper (void)
{
   gboolean retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_is_upper( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2549, 2549, 0);
}

static void sl_gdk_pixbuf_get_byte_length (void)
{
   gsize retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_byte_length(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2550, 2550, 0);
}

static void sl_gtk_clipboard_wait_is_target_available (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_clipboard_wait_is_target_available(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2551, 2551, 0);
}

static void sl_g_themed_icon_get_names (void)
{
   const gchar** retval;
   GThemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_themed_icon_get_names(arg1);
   push_null_term_str_array ((char **) retval, "g_themed_icon_get_names", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2552, 2552, 0);
}

static void sl_gdk_grab_status_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_grab_status_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2553, 2553, 0);
}

static void sl_g_get_current_dir (void)
{
   gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_current_dir();
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2554, 2554, 0);
}

static void sl_gtk_text_view_get_iter_at_location (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   retval = gtk_text_view_get_iter_at_location(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2555, 2555, 0);
}

static void sl_gtk_stack_get_interpolate_size (void)
{
   gboolean retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_interpolate_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2556, 2556, 0);
}

static void sl_g_utf8_to_ucs4 (void)
{
   gunichar* retval;
   gchar* arg1;
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_utf8_to_ucs4(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(uint_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2557, 2557, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_child_focus (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDirectionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_child_focus(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2558, 2558, 0);
}

static void sl_gtk_cell_area_get_edited_cell (void)
{
   GtkCellRenderer* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_edited_cell(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2559, 2559, 0);
}

static void sl_gdk_frame_timings_unref (void)
{
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_frame_timings_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2560, 2560, 0);
}

static void sl_gtk_revealer_get_reveal_child (void)
{
   gboolean retval;
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_get_reveal_child(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2561, 2561, 0);
}

static void sl_gtk_print_unix_dialog_get_current_page (void)
{
   gint retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_current_page(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2562, 2562, 0);
}

static void sl_gtk_expander_get_resize_toplevel (void)
{
   gboolean retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_resize_toplevel(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2563, 2563, 0);
}

static void sl_gtk_text_view_set_right_margin (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_right_margin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2564, 2564, 0);
}

static void sl_gtk_tree_view_column_pack_end (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_pack_end(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2565, 2565, 0);
}

static void sl_gtk_print_job_set_n_up_layout (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkNumberUpLayout arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_n_up_layout(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2566, 2566, 0);
}

static void sl_gtk_widget_get_display (void)
{
   GdkDisplay* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2567, 2567, 0);
}

static void sl_gtk_drag_source_unset (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_source_unset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2568, 2568, 0);
}

static void sl_gtk_parse_args (void)
{
   gboolean retval;
   int* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg1,0x0);
   char*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(char_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_parse_args(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2569, 2569, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_drag_drop_done (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drag_drop_done(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2570, 2570, 0);
}

static void sl_gtk_style_context_remove_class (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_remove_class(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2571, 2571, 0);
}

static void sl_g_resolver_set_default (void)
{
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_resolver_set_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2572, 2572, 0);
}

static void sl_g_type_next_base (void)
{
   GType retval;
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_next_base( arg1,  arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2573, 2573, 0);
}

static void sl_gtk_tooltip_set_markup (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2574, 2574, 0);
}

static void sl_gdk_visual_get_best_with_type (void)
{
   GdkVisual* retval;
   GdkVisualType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best_with_type( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2575, 2575, 0);
}

static void sl_g_binding_get_target (void)
{
   GObject* retval;
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_target(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2576, 2576, 0);
}

static void sl_gtk_accel_group_connect_by_path (void)
{
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GClosure* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_accel_group_connect_by_path(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2577, 2577, 0);
}

static void sl_gtk_widget_path_iter_set_object_name (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_set_object_name(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2578, 2578, 0);
}

static void sl_gtk_window_parse_geometry (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_window_parse_geometry(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2579, 2579, 0);
}

static void sl_gtk_list_box_unselect_all (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2580, 2580, 0);
}

static void sl_gtk_tree_view_get_background_area (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_get_background_area(arg1, arg2, arg3, arg4);
   (void) SLang_push_cstruct ((VOID_STAR) arg4, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2581, 2581, 0);
}

static void sl_pango_attr_list_new (void)
{
   PangoAttrList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_list_new();
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2582, 2582, 0);
}

static void sl_gdk_cairo_rectangle (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_rectangle(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2583, 2583, 0);
}

static void sl_gtk_window_get_destroy_with_parent (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_destroy_with_parent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2584, 2584, 0);
}

static void sl_gtk_combo_box_set_add_tearoffs (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_add_tearoffs(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2585, 2585, 0);
}

static void sl_gtk_entry_set_has_frame (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_has_frame(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2586, 2586, 0);
}

static void sl_gtk_tree_view_column_set_fixed_width (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_fixed_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2587, 2587, 0);
}

static void sl_g_bookmark_file_add_application (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_add_application(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (2588, 2588, 0);
}

static void sl_gtk_paper_size_to_key_file (void)
{
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GKeyFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_paper_size_to_key_file(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2589, 2589, 0);
}

static void sl_gtk_recent_info_get_uri_display (void)
{
   gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_uri_display(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2590, 2590, 0);
}

static void sl_gtk_clipboard_get (void)
{
   GtkClipboard* retval;
   GdkAtom arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2591, 2591, 0);
}

static void sl_gtk_entry_completion_get_text_column (void)
{
   gint retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_text_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2592, 2592, 0);
}

static void sl_gdk_window_set_accept_focus (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_accept_focus(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2593, 2593, 0);
}

static void sl_gtk_page_setup_unix_dialog_get_page_setup (void)
{
   GtkPageSetup* retval;
   GtkPageSetupUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_unix_dialog_get_page_setup(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2594, 2594, 0);
}

static void sl_gtk_range_set_min_slider_size (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_min_slider_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2595, 2595, 0);
}

static void sl_gtk_image_set_from_stock (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_stock(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2596, 2596, 0);
}

static void sl_gtk_about_dialog_get_program_name (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_program_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2597, 2597, 0);
}

static void sl_gtk_print_operation_is_finished (void)
{
   gboolean retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_is_finished(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2598, 2598, 0);
}

static void sl_gtk_accel_map_lock_path (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_lock_path(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2599, 2599, 0);
}

static void sl_gtk_editable_delete_text (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_delete_text(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2600, 2600, 0);
}

static void sl_g_mount_operation_get_is_tcrypt_system_volume (void)
{
   gboolean retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_is_tcrypt_system_volume(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2601, 2601, 0);
}

static void sl_g_menu_insert_item (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GMenuItem* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_menu_insert_item(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2602, 2602, 0);
}

static void sl_gtk_print_operation_set_use_full_page (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_use_full_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2603, 2603, 0);
}

static void sl_gtk_combo_box_popup_for_device (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_popup_for_device(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2604, 2604, 0);
}

static void sl_gtk_gesture_get_sequence_state (void)
{
   GtkEventSequenceState retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventSequence* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_get_sequence_state(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2605, 2605, 0);
}

static void sl_g_hmac_copy (void)
{
   GHmac* retval;
   const GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_hmac_copy(arg1);
   (void)SLang_push_opaque(GHmac_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2606, 2606, 0);
}

static void sl_gtk_app_chooser_dialog_new (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDialogFlags arg2;
   GFile* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_app_chooser_dialog_new(arg1,  arg2, arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2607, 2607, 0);
}

static void sl_g_ascii_tolower (void)
{
   gchar retval;
   gchar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_tolower( arg1);
   (void)SLang_push_char(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2608, 2608, 0);
}

static void sl_gtk_progress_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2609, 2609, 0);
}

static void sl_g_bookmark_file_get_groups (void)
{
   gchar** retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   arg4 = NULL;
   retval = g_bookmark_file_get_groups(arg1, arg2, &arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   push_null_term_str_array (retval, "g_bookmark_file_get_groups", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2610, 2610, 0);
}

static void sl_gdk_event_get_screen (void)
{
   GdkScreen* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2611, 2611, 0);
}

static void sl_gtk_style_provider_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_provider_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2612, 2612, 0);
}

static void sl_gtk_check_menu_item_set_active (void)
{
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_check_menu_item_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2613, 2613, 0);
}

static void sl_g_inet_address_new_from_string (void)
{
   GInetAddress* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_new_from_string(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2614, 2614, 0);
}

static void sl_g_resource_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_resource_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2615, 2615, 0);
}

static void sl_gtk_cell_area_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2616, 2616, 0);
}

static void sl_g_regex_new (void)
{
   GRegex* retval;
   gchar* arg1;
   GRegexCompileFlags arg2;
   GRegexMatchFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_regex_new(arg1,  arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GRegex_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2617, 2617, 0);
}

static void sl_gtk_event_controller_key_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_key_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2618, 2618, 0);
}

static void sl_gtk_radio_menu_item_new_with_label_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new_with_label_from_widget(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2619, 2619, 0);
}

static void sl_gtk_widget_create_pango_context (void)
{
   PangoContext* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_create_pango_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2620, 2620, 0);
}

static void sl_gtk_selection_data_get_length (void)
{
   gint retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_length(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2621, 2621, 0);
}

static void sl_pango_renderer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_renderer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2622, 2622, 0);
}

static void sl_gtk_list_box_get_selected_rows (void)
{
   GList* retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_selected_rows(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2623, 2623, 0);
}

static void sl_gdk_screen_get_default (void)
{
   GdkScreen* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_default();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2624, 2624, 0);
}

static void sl_gtk_cell_renderer_get_fixed_size (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_get_fixed_size(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2625, 2625, 0);
}

static void sl_gtk_icon_view_set_item_width (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_item_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2626, 2626, 0);
}

static void sl_g_unichar_isgraph (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isgraph( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2627, 2627, 0);
}

static void sl_gtk_tool_palette_add_drag_dest (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkDestDefaults arg3;
   GtkToolPaletteDragTargets arg4;
   GdkDragAction arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_palette_add_drag_dest(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2628, 2628, 0);
}

static void sl_gtk_render_extension (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   GtkPositionType arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_extension(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2629, 2629, 0);
}

static void sl_gtk_event_box_get_above_child (void)
{
   gboolean retval;
   GtkEventBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_box_get_above_child(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2630, 2630, 0);
}

static void sl_g_variant_new_dict_entry (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_new_dict_entry(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2631, 2631, 0);
}

static void sl_g_variant_type_first (void)
{
   const GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_first(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2632, 2632, 0);
}

static void sl_gtk_print_unix_dialog_get_manual_capabilities (void)
{
   GtkPrintCapabilities retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_manual_capabilities(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2633, 2633, 0);
}

static void sl_pango_layout_get_height (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2634, 2634, 0);
}

static void sl_g_unichar_ispunct (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_ispunct( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2635, 2635, 0);
}

static void sl_gtk_link_button_set_uri (void)
{
   GtkLinkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_link_button_set_uri(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2636, 2636, 0);
}

static void sl_gtk_cell_area_add (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_add(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2637, 2637, 0);
}

static void sl_g_main_context_ref (void)
{
   GMainContext* retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_ref(arg1);
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2638, 2638, 0);
}

static void sl_gtk_print_settings_get_bool (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_bool(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2639, 2639, 0);
}

static void sl_gtk_tree_view_set_activate_on_single_click (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_activate_on_single_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2640, 2640, 0);
}

static void sl_gtk_icon_view_get_reorderable (void)
{
   gboolean retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_reorderable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2641, 2641, 0);
}

static void sl_gtk_widget_has_focus (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_has_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2642, 2642, 0);
}

static void sl_gdk_window_show_window_menu (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_show_window_menu(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2643, 2643, 0);
}

static void sl_gtk_widget_set_visual (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkVisual* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_visual(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2644, 2644, 0);
}

static void sl_gtk_stack_get_transition_duration (void)
{
   guint retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_transition_duration(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2645, 2645, 0);
}

static void sl_gtk_scrolled_window_get_capture_button_press (void)
{
   gboolean retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_capture_button_press(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2646, 2646, 0);
}

static void sl_g_simple_proxy_resolver_set_default_proxy (void)
{
   GSimpleProxyResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_proxy_resolver_set_default_proxy(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2647, 2647, 0);
}

static void sl_gtk_tree_view_get_headers_clickable (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_headers_clickable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2648, 2648, 0);
}

static void sl_gtk_tree_view_get_tooltip_column (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_tooltip_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2649, 2649, 0);
}

static void sl_g_value_get_float (void)
{
   gfloat retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_float(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2650, 2650, 0);
}

static void sl_gtk_menu_new_from_model (void)
{
   GtkWidget* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_new_from_model(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2651, 2651, 0);
}

static void sl_gtk_menu_get_monitor (void)
{
   gint retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_monitor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2652, 2652, 0);
}

static void sl_gtk_entry_get_icon_stock (void)
{
   const gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_stock(arg1,  arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2653, 2653, 0);
}

static void sl_pango_attr_strikethrough_new (void)
{
   PangoAttribute* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_strikethrough_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2654, 2654, 0);
}

static void sl_gdk_pixbuf_apply_embedded_orientation (void)
{
   GdkPixbuf* retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_apply_embedded_orientation(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2655, 2655, 0);
}

static void sl_gtk_combo_box_set_row_span_column (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_row_span_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2656, 2656, 0);
}

static void sl_gtk_tree_selection_get_user_data (void)
{
   gpointer retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_get_user_data(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2657, 2657, 0);
}

static void sl_gtk_event_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2658, 2658, 0);
}

static void sl_gdk_get_display (void)
{
   gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_get_display();
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2659, 2659, 0);
}

static void sl_gtk_widget_hide (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_hide(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2660, 2660, 0);
}

static void sl_gtk_layout_new (void)
{
   GtkWidget* retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_layout_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2661, 2661, 0);
}

static void sl_gtk_drag_dest_find_target (void)
{
   GdkAtom retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDragContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTargetList* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_drag_dest_find_target(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2662, 2662, 0);
}

static void sl_gtk_recent_info_get_age (void)
{
   gint retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_age(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2663, 2663, 0);
}

static void sl_gdk_window_get_visible_region (void)
{
   cairo_region_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_visible_region(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2664, 2664, 0);
}

static void sl_g_variant_type_get_string_length (void)
{
   gsize retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_get_string_length(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2665, 2665, 0);
}

static void sl_gtk_recent_info_get_private_hint (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_private_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2666, 2666, 0);
}

static void sl_gtk_tree_selection_unselect_all (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_selection_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2667, 2667, 0);
}

static void sl_g_utf8_to_utf16 (void)
{
   gunichar2* retval;
   gchar* arg1;
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_utf8_to_utf16(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(ushort_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2668, 2668, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_pango_context_set_base_gravity (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoGravity arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_context_set_base_gravity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2669, 2669, 0);
}

static void sl_g_network_service_get_protocol (void)
{
   const gchar* retval;
   GNetworkService* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_service_get_protocol(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2670, 2670, 0);
}

static void sl_g_key_file_get_string_list (void)
{
   gchar** retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gsize arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_key_file_get_string_list(arg1, arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   push_null_term_str_array (retval, "g_key_file_get_string_list", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2671, 2671, 0);
}

static void sl_g_value_set_gtype (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_gtype(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2672, 2672, 0);
}

static void sl_gtk_app_chooser_widget_set_show_all (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_widget_set_show_all(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2673, 2673, 0);
}

static void sl_gdk_gl_context_set_forward_compatible (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_set_forward_compatible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2674, 2674, 0);
}

static void sl_g_socket_get_local_address (void)
{
   GSocketAddress* retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_get_local_address(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2675, 2675, 0);
}

static void sl_pango_font_description_get_gravity (void)
{
   PangoGravity retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_gravity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2676, 2676, 0);
}

static void sl_g_get_home_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_home_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2677, 2677, 0);
}

static void sl_gtk_builder_extend_with_template (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GType arg3;
   gchar* arg4;
   gsize arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = gtk_builder_extend_with_template(arg1, arg2,  arg3, arg4,  arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (2678, 2678, 0);
}

static void sl_g_source_set_name_by_id (void)
{
   guint arg1;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   g_source_set_name_by_id( arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2679, 2679, 0);
}

static void sl_gtk_cell_area_context_get_preferred_height (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_get_preferred_height(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2680, 2680, 0);
}

static void sl_g_object_notify_by_pspec (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_object_notify_by_pspec(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2681, 2681, 0);
}

static void sl_gtk_css_provider_get_named (void)
{
   GtkCssProvider* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_css_provider_get_named(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2682, 2682, 0);
}

static void sl_g_bookmark_file_get_description (void)
{
   gchar* retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_description(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2683, 2683, 0);
}

static void sl_gtk_scrolled_window_get_max_content_height (void)
{
   gint retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_max_content_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2684, 2684, 0);
}

static void sl_gtk_widget_set_font_map (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontMap* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_font_map(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2685, 2685, 0);
}

static void sl_pango_layout_iter_next_cluster (void)
{
   gboolean retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_next_cluster(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2686, 2686, 0);
}

static void sl_g_resource_get_info (void)
{
   gboolean retval;
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GResourceLookupFlags arg3;
   gsize arg4;
   guint32 arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_resource_get_info(arg1, arg2,  arg3, &arg4, &arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   (void)SLang_push_ulong(arg4);
   (void)SLang_push_uint(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2687, 2687, 0);
}

static void sl_gtk_notebook_get_group_name (void)
{
   const gchar* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_group_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2688, 2688, 0);
}

static void sl_gtk_aspect_frame_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_aspect_frame_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2689, 2689, 0);
}

static void sl_gtk_icon_view_set_item_padding (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_item_padding(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2690, 2690, 0);
}

static void sl_gtk_tree_selection_select_path (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_select_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2691, 2691, 0);
}

static void sl_gtk_window_set_mnemonic_modifier (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_mnemonic_modifier(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2692, 2692, 0);
}

static void sl_gtk_tool_palette_set_style (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolbarStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_palette_set_style(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2693, 2693, 0);
}

static void sl_g_file_query_settable_attributes (void)
{
   GFileAttributeInfoList* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_settable_attributes(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2694, 2694, 0);
}

static void sl_gdk_axis_use_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_axis_use_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2695, 2695, 0);
}

static void sl_gtk_style_context_remove_provider_for_screen (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleProvider* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_remove_provider_for_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2696, 2696, 0);
}

static void sl_gtk_text_buffer_insert_at_cursor (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (gint) strlen (arg2);
   gtk_text_buffer_insert_at_cursor(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2697, 2697, 0);
}

static void sl_gdk_drag_begin (void)
{
   GdkDragContext* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_begin(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2698, 2698, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_settings_get_int64 (void)
{
   gint64 retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_int64(arg1, arg2);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2699, 2699, 0);
}

static void sl_gtk_cell_renderer_toggle_get_activatable (void)
{
   gboolean retval;
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_toggle_get_activatable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2700, 2700, 0);
}

static void sl_gtk_menu_get_accel_path (void)
{
   const gchar* retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_accel_path(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2701, 2701, 0);
}

static void sl_gtk_grid_get_baseline_row (void)
{
   gint retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_baseline_row(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2702, 2702, 0);
}

static void sl_gtk_widget_get_allocation (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_allocation(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GtkAllocation_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2703, 2703, 0);
}

static void sl_gtk_font_button_get_show_style (void)
{
   gboolean retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_show_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2704, 2704, 0);
}

static void sl_gtk_style_context_get_screen (void)
{
   GdkScreen* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2705, 2705, 0);
}

static void sl_gtk_entry_completion_set_model (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_completion_set_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2706, 2706, 0);
}

static void sl_gtk_flow_box_invalidate_sort (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_invalidate_sort(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2707, 2707, 0);
}

static void sl_g_source_add_poll (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPollFD* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_source_add_poll(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2708, 2708, 0);
}

static void sl_gdk_window_freeze_toplevel_updates_libgtk_only (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_freeze_toplevel_updates_libgtk_only(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2709, 2709, 0);
}

static void sl_gtk_style_context_remove_provider (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleProvider* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_remove_provider(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2710, 2710, 0);
}

static void sl_g_dir_read_name (void)
{
   gchar* retval;
   GDir* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDir_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_dir_read_name(arg1);
   (void) SLang_push_malloced_string (g_strdup (retval));
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2711, 2711, 0);
}

static void sl_gtk_window_get_application (void)
{
   GtkApplication* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_application(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2712, 2712, 0);
}

static void sl_g_match_info_next (void)
{
   gboolean retval;
   GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_match_info_next(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2713, 2713, 0);
}

static void sl_gtk_target_list_add_table (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTargetEntry* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_target_list_add_table(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2714, 2714, 0);
}

static void sl_gtk_tree_sortable_sort_column_changed (void)
{
   GtkTreeSortable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_sortable_sort_column_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2715, 2715, 0);
}

static void sl_g_content_type_set_mime_dirs (void)
{
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_content_type_set_mime_dirs(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2716, 2716, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_editable_set_position (void)
{
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_editable_set_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2717, 2717, 0);
}

static void sl_gtk_window_fullscreen (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_fullscreen(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2718, 2718, 0);
}

static void sl_g_app_launch_context_unsetenv (void)
{
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_app_launch_context_unsetenv(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2719, 2719, 0);
}

static void sl_gtk_window_resize_to_geometry (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_resize_to_geometry(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2720, 2720, 0);
}

static void sl_gtk_assistant_get_page_complete (void)
{
   gboolean retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_complete(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2721, 2721, 0);
}

static void sl_gtk_statusbar_remove (void)
{
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_statusbar_remove(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2722, 2722, 0);
}

static void sl_gtk_application_inhibit (void)
{
   guint retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkApplicationInhibitFlags arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg4, NULL)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_application_inhibit(arg1, arg2,  arg3, arg4);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (2723, 2723, 0);
}

static void sl_gdk_cursor_new_from_pixbuf (void)
{
   GdkCursor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_cursor_new_from_pixbuf(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2724, 2724, 0);
}

static void sl_pango_font_face_is_synthesized (void)
{
   gboolean retval;
   PangoFontFace* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_face_is_synthesized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2725, 2725, 0);
}

static void sl_pango_font_describe (void)
{
   PangoFontDescription* retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_describe(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2726, 2726, 0);
}

static void sl_gtk_info_bar_get_action_area (void)
{
   GtkWidget* retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_action_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2727, 2727, 0);
}

static void sl_gtk_label_get_use_markup (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_use_markup(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2728, 2728, 0);
}

static void sl_pango_context_list_families (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontFamily*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontFamily_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_context_list_families(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2729, 2729, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_notification_set_urgent (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_notification_set_urgent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2730, 2730, 0);
}

static void sl_gtk_file_chooser_get_preview_filename (void)
{
   char* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_preview_filename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2731, 2731, 0);
}

static void sl_gtk_scrollable_set_hscroll_policy (void)
{
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkScrollablePolicy arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrollable_set_hscroll_policy(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2732, 2732, 0);
}

static void sl_gdk_monitor_get_geometry (void)
{
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_monitor_get_geometry(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2733, 2733, 0);
}

static void sl_gtk_paper_size_get_paper_sizes (void)
{
   GList* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_paper_sizes( arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2734, 2734, 0);
}

static void sl_gtk_search_bar_get_show_close_button (void)
{
   gboolean retval;
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_bar_get_show_close_button(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2735, 2735, 0);
}

static void sl_gdk_window_window_class_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_window_class_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2736, 2736, 0);
}

static void sl_g_app_info_get_executable (void)
{
   const char* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_executable(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2737, 2737, 0);
}

static void sl_g_match_info_fetch (void)
{
   gchar* retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_fetch(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2738, 2738, 0);
}

static void sl_gtk_window_group_get_current_device_grab (void)
{
   GtkWidget* retval;
   GtkWindowGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_window_group_get_current_device_grab(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2739, 2739, 0);
}

static void sl_gtk_grid_insert_row (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_insert_row(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2740, 2740, 0);
}

static void sl_g_mkdir_with_parents (void)
{
   gint retval;
   gchar* arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_mkdir_with_parents(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2741, 2741, 0);
}

static void sl_gdk_device_get_mode (void)
{
   GdkInputMode retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2742, 2742, 0);
}

static void sl_gtk_recent_chooser_get_show_tips (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_show_tips(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2743, 2743, 0);
}

static void sl_g_main_context_remove_poll (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPollFD* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_main_context_remove_poll(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2744, 2744, 0);
}

static void sl_g_date_subtract_days (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_subtract_days(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2745, 2745, 0);
}

static void sl_g_io_channel_get_buffer_size (void)
{
   gsize retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_buffer_size(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2746, 2746, 0);
}

static void sl_gtk_text_buffer_register_deserialize_tagset (void)
{
   GdkAtom retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_register_deserialize_tagset(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2747, 2747, 0);
}

static void sl_gtk_scale_button_get_adjustment (void)
{
   GtkAdjustment* retval;
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_adjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2748, 2748, 0);
}

static void sl_gtk_paper_size_get_display_name (void)
{
   const gchar* retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_display_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2749, 2749, 0);
}

static void sl_gtk_flow_box_invalidate_filter (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_invalidate_filter(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2750, 2750, 0);
}

static void sl_gtk_print_operation_set_show_progress (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_show_progress(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2751, 2751, 0);
}

static void sl_gtk_text_view_set_input_purpose (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkInputPurpose arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_input_purpose(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2752, 2752, 0);
}

static void sl_gtk_main_iteration (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_main_iteration();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2753, 2753, 0);
}

static void sl_pango_font_face_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_face_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2754, 2754, 0);
}

static void sl_gtk_tree_row_reference_new_proxy (void)
{
   GtkTreeRowReference* retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_row_reference_new_proxy(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkTreeRowReference_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2755, 2755, 0);
}

static void sl_gtk_icon_theme_rescan_if_needed (void)
{
   gboolean retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_rescan_if_needed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2756, 2756, 0);
}

static void sl_gtk_file_chooser_get_filename (void)
{
   gchar* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_filename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2757, 2757, 0);
}

static void sl_gtk_accelerator_parse (void)
{
   gchar* arg1;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accelerator_parse(arg1, &arg2, &arg3);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2758, 2758, 0);
}

static void sl_g_network_monitor_get_connectivity (void)
{
   GNetworkConnectivity retval;
   GNetworkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_monitor_get_connectivity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2759, 2759, 0);
}

static void sl_gtk_text_iter_get_line_offset (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_line_offset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2760, 2760, 0);
}

static void sl_gtk_get_current_event_state (void)
{
   gboolean retval;
   GdkModifierType* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_INT_TYPE,sizeof(GdkModifierType),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_current_event_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2761, 2761, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_pango_renderer_part_changed (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_part_changed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2762, 2762, 0);
}

static void sl_g_date_time_get_month (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_month(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2763, 2763, 0);
}

static void sl_gdk_monitor_get_workarea (void)
{
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_monitor_get_workarea(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2764, 2764, 0);
}

static void sl_gtk_spin_button_set_digits (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_digits(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2765, 2765, 0);
}

static void sl_gtk_set_debug_flags (void)
{
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_set_debug_flags( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2766, 2766, 0);
}

static void sl_g_key_file_set_list_separator (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_key_file_set_list_separator(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2767, 2767, 0);
}

static void sl_gtk_scrolled_window_set_capture_button_press (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_capture_button_press(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2768, 2768, 0);
}

static void sl_gtk_frame_get_label (void)
{
   const gchar* retval;
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_frame_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2769, 2769, 0);
}

static void sl_gdk_seat_get_slaves (void)
{
   GList* retval;
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkSeatCapabilities arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_slaves(arg1,  arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2770, 2770, 0);
}

static void sl_g_file_info_set_content_type (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_content_type(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2771, 2771, 0);
}

static void sl_gtk_tree_view_set_rules_hint (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_rules_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2772, 2772, 0);
}

static void sl_gtk_print_settings_get_media_type (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_media_type(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2773, 2773, 0);
}

static void sl_gtk_radio_menu_item_new_with_mnemonic (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new_with_mnemonic(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2774, 2774, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_tree_view_column_get_tree_view (void)
{
   GtkWidget* retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_tree_view(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2775, 2775, 0);
}

static void sl_g_unichar_xdigit_value (void)
{
   gint retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_xdigit_value( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2776, 2776, 0);
}

static void sl_g_main_loop_run (void)
{
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_loop_run(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2777, 2777, 0);
}

static void sl_gtk_spinner_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_spinner_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2778, 2778, 0);
}

static void sl_g_ascii_strtoull (void)
{
   guint64 retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_strtoull(arg1, arg2,  arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2779, 2779, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_page_setup_unix_dialog_set_print_settings (void)
{
   GtkPageSetupUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintSettings* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_page_setup_unix_dialog_set_print_settings(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2780, 2780, 0);
}

static void sl_gdk_pixbuf_get_from_window (void)
{
   GdkPixbuf* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_from_window(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2781, 2781, 0);
}

static void sl_gtk_window_get_has_resize_grip (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_has_resize_grip(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2782, 2782, 0);
}

static void sl_g_credentials_to_string (void)
{
   gchar* retval;
   GCredentials* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_credentials_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2783, 2783, 0);
}

static void sl_g_value_get_object (void)
{
   gpointer retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_object(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2784, 2784, 0);
}

static void sl_gtk_print_context_get_page_setup (void)
{
   GtkPageSetup* retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_page_setup(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2785, 2785, 0);
}

static void sl_g_value_take_variant (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_take_variant(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2786, 2786, 0);
}

static void sl_gtk_tree_selection_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2787, 2787, 0);
}

static void sl_gtk_builder_add_objects_from_file (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_builder_add_objects_from_file(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2788, 2788, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_widget_set_has_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_has_window(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2789, 2789, 0);
}

static void sl_gdk_visibility_state_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visibility_state_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2790, 2790, 0);
}

static void sl_g_mount_operation_set_username (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_mount_operation_set_username(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2791, 2791, 0);
}

static void sl_gtk_widget_list_action_prefixes (void)
{
   const gchar** retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_list_action_prefixes(arg1);
   (void)SLang_push_opaque(string_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2792, 2792, 0);
}

static void sl_gtk_file_chooser_unselect_all (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2793, 2793, 0);
}

static void sl_gtk_cell_area_request_renderer (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkOrientation arg3;
   GtkWidget* arg4;
   Slirp_Opaque* arg4_o = NULL;
   gint arg5;
   gint arg6;
   gint arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_request_renderer(arg1, arg2,  arg3, arg4,  arg5, &arg6, &arg7);
   (void)SLang_push_int(arg6);
   (void)SLang_push_int(arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (2794, 2794, 0);
}

static void sl_g_bookmark_file_set_groups (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   gsize arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_groups(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2795, 2795, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_memdup (void)
{
   gpointer retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_memdup(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2796, 2796, 0);
}

static void sl_gdk_cairo_set_source_rgba (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_set_source_rgba(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2797, 2797, 0);
}

static void sl_gtk_entry_get_width_chars (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2798, 2798, 0);
}

static void sl_gtk_target_list_add_text_targets (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_list_add_text_targets(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2799, 2799, 0);
}

static void sl_gtk_combo_box_text_prepend (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_text_prepend(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2800, 2800, 0);
}

static void sl_gtk_text_mark_get_buffer (void)
{
   GtkTextBuffer* retval;
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_buffer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2801, 2801, 0);
}

static void sl_gtk_widget_set_state_flags (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_state_flags(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2802, 2802, 0);
}

static void sl_gdk_window_is_viewable (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_is_viewable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2803, 2803, 0);
}

static void sl_gtk_targets_include_image (void)
{
   gboolean retval;
   GdkAtom* arg1;
   Slirp_Ref *arg1_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg1,0x0);
   gint arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_targets_include_image(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2804, 2804, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_network_monitor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_network_monitor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2805, 2805, 0);
}

static void sl_g_bookmark_file_remove_item (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_remove_item(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2806, 2806, 0);
}

static void sl_pango_tab_array_get_tab (void)
{
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   PangoTabAlign* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(PangoTabAlign),&arg3,0x0);
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_tab_array_get_tab(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2807, 2807, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_g_volume_get_identifier (void)
{
   char* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_volume_get_identifier(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2808, 2808, 0);
}

static void sl_gtk_combo_box_set_button_sensitivity (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSensitivityType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_button_sensitivity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2809, 2809, 0);
}

static void sl_g_variant_check_format_string (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_check_format_string(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2810, 2810, 0);
}

static void sl_g_signal_lookup (void)
{
   guint retval;
   gchar* arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_signal_lookup(arg1,  arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2811, 2811, 0);
}

static void sl_gtk_tree_store_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_store_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2812, 2812, 0);
}

static void sl_g_socket_get_multicast_loopback (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_multicast_loopback(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2813, 2813, 0);
}

static void sl_gtk_label_get_line_wrap (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_line_wrap(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2814, 2814, 0);
}

static void sl_gtk_tree_view_column_get_resizable (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_resizable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2815, 2815, 0);
}

static void sl_g_settings_schema_key_get_range (void)
{
   GVariant* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_get_range(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2816, 2816, 0);
}

static void sl_g_settings_set_flags (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_flags(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2817, 2817, 0);
}

static void sl_g_settings_list_schemas (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_list_schemas();
   push_null_term_str_array ((char **) retval, "g_settings_list_schemas", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2818, 2818, 0);
}

static void sl_gtk_file_chooser_set_preview_widget (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_set_preview_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2819, 2819, 0);
}

static void sl_gdk_drag_drop_succeeded (void)
{
   gboolean retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_drop_succeeded(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2820, 2820, 0);
}

static void sl_gtk_accel_label_refetch (void)
{
   gboolean retval;
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_label_refetch(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2821, 2821, 0);
}

static void sl_gtk_text_buffer_get_selection_bounds (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   GtkTextIter* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   if ((arg3 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_selection_bounds(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   (void) SLang_push_opaque (GtkTextIter_Type, arg3, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2822, 2822, 0);
}

static void sl_g_menu_model_get_item_link (void)
{
   GMenuModel* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_menu_model_get_item_link(arg1,  arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2823, 2823, 0);
}

static void sl_gtk_info_bar_get_message_type (void)
{
   GtkMessageType retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_message_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2824, 2824, 0);
}

static void sl_g_settings_schema_ref (void)
{
   GSettingsSchema* retval;
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2825, 2825, 0);
}

static void sl_g_unichar_isspace (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isspace( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2826, 2826, 0);
}

static void sl_gtk_window_set_icon (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2827, 2827, 0);
}

static void sl_g_compute_hmac_for_bytes (void)
{
   gchar* retval;
   GChecksumType arg1;
   GBytes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GBytes* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_compute_hmac_for_bytes( arg1, arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2828, 2828, 0);
}

static void sl_g_action_get_state (void)
{
   GVariant* retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_state(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2829, 2829, 0);
}

static void sl_gtk_recent_manager_lookup_item (void)
{
   GtkRecentInfo* retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_recent_manager_lookup_item(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2830, 2830, 0);
}

static void sl_gdk_display_get_app_launch_context (void)
{
   GdkAppLaunchContext* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_app_launch_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2831, 2831, 0);
}

static void sl_gtk_color_button_get_alpha (void)
{
   guint16 retval;
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_get_alpha(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2832, 2832, 0);
}

static void sl_gtk_gesture_drag_get_offset (void)
{
   gboolean retval;
   GtkGestureDrag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_drag_get_offset(arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2833, 2833, 0);
}

static void sl_g_input_stream_has_pending (void)
{
   gboolean retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_input_stream_has_pending(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2834, 2834, 0);
}

static void sl_gdk_device_get_device_type (void)
{
   GdkDeviceType retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_device_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2835, 2835, 0);
}

static void sl_pango_context_set_round_glyph_positions (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_context_set_round_glyph_positions(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2836, 2836, 0);
}

static void sl_gtk_icon_view_set_model (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_set_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2837, 2837, 0);
}

static void sl_gtk_window_unstick (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_unstick(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2838, 2838, 0);
}

static void sl_gtk_menu_shell_select_item (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_select_item(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2839, 2839, 0);
}

static void sl_g_strchomp (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strchomp(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2840, 2840, 0);
}

static void sl_gtk_text_iter_get_bytes_in_line (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_bytes_in_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2841, 2841, 0);
}

static void sl_gtk_widget_device_is_shadowed (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_device_is_shadowed(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2842, 2842, 0);
}

static void sl_gtk_text_iter_forward_word_ends (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_word_ends(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2843, 2843, 0);
}

static void sl_g_variant_builder_ref (void)
{
   GVariantBuilder* retval;
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_builder_ref(arg1);
   (void)SLang_push_opaque(GVariantBuilder_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2844, 2844, 0);
}

static void sl_gtk_viewport_set_vadjustment (void)
{
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_viewport_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2845, 2845, 0);
}

static void sl_gtk_entry_set_max_length (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_max_length(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2846, 2846, 0);
}

static void sl_g_file_create_readwrite (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileCreateFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_create_readwrite(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2847, 2847, 0);
}

static void sl_gtk_paper_size_get_default_right_margin (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_default_right_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2848, 2848, 0);
}

static void sl_gdk_keymap_get_modifier_state (void)
{
   guint retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_modifier_state(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2849, 2849, 0);
}

static void sl_g_random_int (void)
{
   guint32 retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_random_int();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2850, 2850, 0);
}

static void sl_gtk_tool_item_get_visible_vertical (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_visible_vertical(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2851, 2851, 0);
}

static void sl_gtk_scrolled_window_get_max_content_width (void)
{
   gint retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_max_content_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2852, 2852, 0);
}

static void sl_g_value_set_param (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_param(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2853, 2853, 0);
}

static void sl_gtk_text_iter_get_line_index (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_line_index(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2854, 2854, 0);
}

static void sl_g_file_hash (void)
{
   guint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2855, 2855, 0);
}

static void sl_gtk_expander_get_label_widget (void)
{
   GtkWidget* retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_label_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2856, 2856, 0);
}

static void sl_gdk_monitor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2857, 2857, 0);
}

static void sl_gtk_list_box_invalidate_filter (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_invalidate_filter(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2858, 2858, 0);
}

static void sl_gdk_pixbuf_rotate_simple (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbufRotation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_rotate_simple(arg1,  arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2859, 2859, 0);
}

static void sl_gtk_tree_path_is_ancestor (void)
{
   gboolean retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_path_is_ancestor(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2860, 2860, 0);
}

static void sl_gtk_about_dialog_set_website (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_website(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2861, 2861, 0);
}

static void sl_g_mount_eject_with_operation_finish (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mount_eject_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2862, 2862, 0);
}

static void sl_gtk_widget_path_iter_add_region (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   GtkRegionFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_add_region(arg1,  arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2863, 2863, 0);
}

static void sl_gdk_window_set_icon_name (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_icon_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2864, 2864, 0);
}

static void sl_pango_cairo_layout_line_path (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayoutLine* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_layout_line_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2865, 2865, 0);
}

static void sl_gtk_entry_get_icon_at_pos (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_at_pos(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2866, 2866, 0);
}

static void sl_gtk_tree_view_set_hover_expand (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_hover_expand(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2867, 2867, 0);
}

static void sl_g_date_time_new_from_iso8601 (void)
{
   GDateTime* retval;
   gchar* arg1;
   GTimeZone* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_new_from_iso8601(arg1, arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2868, 2868, 0);
}

static void sl_pango_font_description_to_string (void)
{
   char* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2869, 2869, 0);
}

static void sl_gtk_text_iter_forward_to_line_end (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_to_line_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2870, 2870, 0);
}

static void sl_gtk_box_get_homogeneous (void)
{
   gboolean retval;
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_get_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2871, 2871, 0);
}

static void sl_g_str_is_ascii (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_str_is_ascii(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2872, 2872, 0);
}

static void sl_g_date_time_to_unix (void)
{
   gint64 retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_to_unix(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2873, 2873, 0);
}

static void sl_gtk_actionable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_actionable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2874, 2874, 0);
}

static void sl_gdk_window_get_event_compression (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_event_compression(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2875, 2875, 0);
}

static void sl_gdk_beep (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_beep();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2876, 2876, 0);
}

static void sl_gtk_entry_set_progress_fraction (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_progress_fraction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2877, 2877, 0);
}

static void sl_pango_attr_allow_breaks_new (void)
{
   PangoAttribute* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_allow_breaks_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2878, 2878, 0);
}

static void sl_gtk_text_view_get_top_margin (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_top_margin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2879, 2879, 0);
}

static void sl_gdk_pixbuf_animation_get_iter (void)
{
   GdkPixbufAnimationIter* retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg2, (void**)GTimeVal_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_get_iter(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2880, 2880, 0);
}

static void sl_gtk_dialog_get_widget_for_response (void)
{
   GtkWidget* retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_get_widget_for_response(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2881, 2881, 0);
}

static void sl_pango_language_get_default (void)
{
   PangoLanguage* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_language_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2882, 2882, 0);
}

static void sl_gtk_window_begin_resize_drag (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindowEdge arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   guint32 arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_begin_resize_drag(arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2883, 2883, 0);
}

static void sl_gtk_window_set_icon_name (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_icon_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2884, 2884, 0);
}

static void sl_g_value_set_static_string (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_set_static_string(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2885, 2885, 0);
}

static void sl_gtk_selection_owner_set (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_owner_set(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2886, 2886, 0);
}

static void sl_gtk_list_store_clear (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_store_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2887, 2887, 0);
}

static void sl_gtk_actionable_set_detailed_action_name (void)
{
   GtkActionable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_actionable_set_detailed_action_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2888, 2888, 0);
}

static void sl_gtk_cell_renderer_pixbuf_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_pixbuf_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2889, 2889, 0);
}

static void sl_gtk_menu_popup_at_pointer (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GdkEvent_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_popup_at_pointer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2890, 2890, 0);
}

static void sl_gtk_cell_renderer_combo_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_combo_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2891, 2891, 0);
}

static void sl_g_menu_append_section (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GMenuModel* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_append_section(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2892, 2892, 0);
}

static void sl_gtk_text_iter_set_line (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_line(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2893, 2893, 0);
}

static void sl_g_socket_shutdown (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   gboolean arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_socket_shutdown(arg1,  arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2894, 2894, 0);
}

static void sl_gtk_widget_is_sensitive (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_is_sensitive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2895, 2895, 0);
}

static void sl_gtk_button_set_label (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_button_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2896, 2896, 0);
}

static void sl_g_uri_unescape_segment (void)
{
   char* retval;
   char* arg1;
   char* arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg3, NULL)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_uri_unescape_segment(arg1, arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (2897, 2897, 0);
}

static void sl_pango_cairo_create_context (void)
{
   PangoContext* retval;
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_create_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2898, 2898, 0);
}

static void sl_g_simple_proxy_resolver_set_ignore_hosts (void)
{
   GSimpleProxyResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_simple_proxy_resolver_set_ignore_hosts(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2899, 2899, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_settings_get_default_value (void)
{
   GVariant* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_default_value(arg1, arg2);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2900, 2900, 0);
}

static void sl_gtk_popover_set_pointing_to (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_popover_set_pointing_to(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2901, 2901, 0);
}

static void sl_g_vfs_get_local (void)
{
   GVfs* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_vfs_get_local();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2902, 2902, 0);
}

static void sl_gdk_display_supports_selection_notification (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_selection_notification(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2903, 2903, 0);
}

static void sl_gtk_print_context_get_dpi_x (void)
{
   gdouble retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_dpi_x(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2904, 2904, 0);
}

static void sl_gtk_calendar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2905, 2905, 0);
}

static void sl_gtk_places_sidebar_add_shortcut (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_places_sidebar_add_shortcut(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2906, 2906, 0);
}

static void sl_pango_layout_get_character_count (void)
{
   gint retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_character_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2907, 2907, 0);
}

static void sl_gtk_radio_tool_button_new_from_widget (void)
{
   GtkToolItem* retval;
   GtkRadioToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_tool_button_new_from_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2908, 2908, 0);
}

static void sl_gtk_grid_get_row_baseline_position (void)
{
   GtkBaselinePosition retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_row_baseline_position(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2909, 2909, 0);
}

static void sl_gtk_container_get_focus_child (void)
{
   GtkWidget* retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_focus_child(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2910, 2910, 0);
}

static void sl_gtk_text_view_get_line_yrange (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_get_line_yrange(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2911, 2911, 0);
}

static void sl_gtk_cell_area_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2912, 2912, 0);
}

static void sl_pango_font_metrics_get_strikethrough_thickness (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_strikethrough_thickness(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2913, 2913, 0);
}

static void sl_gtk_window_get_icon_list (void)
{
   GList* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_icon_list(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2914, 2914, 0);
}

static void sl_g_variant_new_variant (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_variant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2915, 2915, 0);
}

static void sl_gtk_places_sidebar_get_show_other_locations (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_other_locations(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2916, 2916, 0);
}

static void sl_gtk_file_chooser_get_current_folder (void)
{
   gchar* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_current_folder(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2917, 2917, 0);
}

static void sl_gtk_tree_view_column_get_min_width (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_min_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2918, 2918, 0);
}

static void sl_gtk_print_operation_set_current_page (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_current_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2919, 2919, 0);
}

static void sl_gdk_window_set_urgency_hint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_urgency_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2920, 2920, 0);
}

static void sl_g_settings_get_string (void)
{
   gchar* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_string(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2921, 2921, 0);
}

static void sl_gtk_selection_add_target (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_selection_add_target(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2922, 2922, 0);
}

static void sl_gdk_window_invalidate_rect (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_invalidate_rect(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2923, 2923, 0);
}

static void sl_gtk_cell_area_has_renderer (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_has_renderer(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2924, 2924, 0);
}

static void sl_g_app_info_equal (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAppInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_app_info_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2925, 2925, 0);
}

static void sl_g_settings_get_child (void)
{
   GSettings* retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_child(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2926, 2926, 0);
}

static void sl_g_type_fundamental (void)
{
   GType retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_fundamental( arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2927, 2927, 0);
}

static void sl_gdk_display_beep (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_beep(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2928, 2928, 0);
}

static void sl_g_time_zone_new (void)
{
   GTimeZone* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_new(arg1);
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2929, 2929, 0);
}

static void sl_gtk_model_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_model_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2930, 2930, 0);
}

static void sl_gtk_print_job_get_n_up (void)
{
   guint retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_n_up(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2931, 2931, 0);
}

static void sl_g_proxy_address_get_password (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_password(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2932, 2932, 0);
}

static void sl_gtk_viewport_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2933, 2933, 0);
}

static void sl_g_filename_display_basename (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_filename_display_basename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2934, 2934, 0);
}

static void sl_gtk_statusbar_pop (void)
{
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_statusbar_pop(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2935, 2935, 0);
}

static void sl_gtk_stack_set_transition_duration (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_transition_duration(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2936, 2936, 0);
}

static void sl_gtk_cell_area_copy_context (void)
{
   GtkCellAreaContext* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_copy_context(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2937, 2937, 0);
}

static void sl_g_file_info_get_attribute_int32 (void)
{
   gint32 retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_int32(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2938, 2938, 0);
}

static void sl_gtk_scrolled_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2939, 2939, 0);
}

static void sl_gtk_cell_renderer_progress_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_progress_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2940, 2940, 0);
}

static void sl_gtk_widget_path_get_object_type (void)
{
   GType retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_get_object_type(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2941, 2941, 0);
}

static void sl_pango_layout_set_spacing (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2942, 2942, 0);
}

static void sl_gtk_places_sidebar_set_show_enter_location (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_enter_location(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2943, 2943, 0);
}

static void sl_gtk_entry_get_input_hints (void)
{
   GtkInputHints retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_input_hints(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2944, 2944, 0);
}

static void sl_gtk_menu_button_get_use_popover (void)
{
   gboolean retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_use_popover(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2945, 2945, 0);
}

static void sl_gdk_event_set_source_device (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_event_set_source_device(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2946, 2946, 0);
}

static void sl_gtk_tree_view_collapse_all (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_collapse_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2947, 2947, 0);
}

static void sl_g_settings_schema_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2948, 2948, 0);
}

static void sl_g_param_spec_get_name (void)
{
   const gchar* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2949, 2949, 0);
}

static void sl_gtk_font_chooser_set_level (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFontChooserLevel arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_font_chooser_set_level(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2950, 2950, 0);
}

static void sl_gtk_render_icon_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkIconSource* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_render_icon_pixbuf(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2951, 2951, 0);
}

static void sl_gtk_recent_filter_add_pattern (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_filter_add_pattern(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2952, 2952, 0);
}

static void sl_g_file_query_filesystem_info (void)
{
   GFileInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_query_filesystem_info(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2953, 2953, 0);
}

static void sl_g_random_double_range (void)
{
   gdouble retval;
   gdouble arg1;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_random_double_range( arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2954, 2954, 0);
}

static void sl_g_timer_new (void)
{
   GTimer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_timer_new();
   (void)SLang_push_opaque(GTimer_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2955, 2955, 0);
}

static void sl_gdk_display_supports_shapes (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_shapes(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2956, 2956, 0);
}

static void sl_gtk_image_get_pixel_size (void)
{
   gint retval;
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_get_pixel_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2957, 2957, 0);
}

static void sl_g_filename_from_uri (void)
{
   gchar* retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_filename_from_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (2958, 2958, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_window_get_position (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_position(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2959, 2959, 0);
}

static void sl_gtk_font_button_get_title (void)
{
   const gchar* retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2960, 2960, 0);
}

static void sl_gtk_tool_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2961, 2961, 0);
}

static void sl_gtk_paper_size_get_height (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_height(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2962, 2962, 0);
}

static void sl_g_rand_new_with_seed_array (void)
{
   GRand* retval;
   const guint32* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UINT_TYPE,sizeof(guint32),&arg1,0x0);
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_new_with_seed_array(arg1,  arg2);
   (void)SLang_push_opaque(GRand_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2963, 2963, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_accel_map_save_fd (void)
{
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_save_fd( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2964, 2964, 0);
}

static void sl_g_socket_is_closed (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_is_closed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2965, 2965, 0);
}

static void sl_gtk_separator_menu_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_menu_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2966, 2966, 0);
}

static void sl_g_main_loop_is_running (void)
{
   gboolean retval;
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_loop_is_running(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2967, 2967, 0);
}

static void sl_gtk_application_get_menu_by_id (void)
{
   GMenu* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_application_get_menu_by_id(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2968, 2968, 0);
}

static void sl_gtk_event_box_get_visible_window (void)
{
   gboolean retval;
   GtkEventBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_box_get_visible_window(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2969, 2969, 0);
}

static void sl_g_key_file_ref (void)
{
   GKeyFile* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_key_file_ref(arg1);
   (void)SLang_push_opaque(GKeyFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2970, 2970, 0);
}

static void sl_gtk_widget_set_focus_on_click (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_focus_on_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2971, 2971, 0);
}

static void sl_g_proxy_address_get_destination_port (void)
{
   guint16 retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_destination_port(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2972, 2972, 0);
}

static void sl_gtk_radio_button_set_group (void)
{
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_radio_button_set_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2973, 2973, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_volume_get_icon (void)
{
   GIcon* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2974, 2974, 0);
}

static void sl_gtk_adjustment_get_page_size (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_page_size(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2975, 2975, 0);
}

static void sl_gtk_file_chooser_native_get_accept_label (void)
{
   const char* retval;
   GtkFileChooserNative* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_native_get_accept_label(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2976, 2976, 0);
}

static void sl_gtk_tree_path_is_descendant (void)
{
   gboolean retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_path_is_descendant(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2977, 2977, 0);
}

static void sl_gtk_file_chooser_native_set_accept_label (void)
{
   GtkFileChooserNative* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_native_set_accept_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2978, 2978, 0);
}

static void sl_gtk_style_context_list_classes (void)
{
   GList* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_list_classes(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2979, 2979, 0);
}

static void sl_gtk_window_has_group (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_has_group(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2980, 2980, 0);
}

static void sl_gdk_pango_layout_get_clip_region (void)
{
   cairo_region_t* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   const gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pango_layout_get_clip_region(arg1,  arg2,  arg3, arg4,  arg5);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2981, 2981, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_widget_override_symbolic_color (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg3, (void**)GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_override_symbolic_color(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (2982, 2982, 0);
}

static void sl_gtk_target_list_find (void)
{
   gboolean retval;
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_UINT_TYPE,sizeof(guint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_target_list_find(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (2983, 2983, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_application_window_get_help_overlay (void)
{
   GtkShortcutsWindow* retval;
   GtkApplicationWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_window_get_help_overlay(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2984, 2984, 0);
}

static void sl_g_socket_create_source (void)
{
   GSource* retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOCondition arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_socket_create_source(arg1,  arg2, arg3);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (2985, 2985, 0);
}

static void sl_gdk_visual_get_byte_order (void)
{
   GdkByteOrder retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_byte_order(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2986, 2986, 0);
}

static void sl_g_ascii_digit_value (void)
{
   gint retval;
   gchar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_digit_value( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2987, 2987, 0);
}

static void sl_gtk_about_dialog_set_logo_icon_name (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_logo_icon_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2988, 2988, 0);
}

static void sl_gtk_tree_view_get_n_columns (void)
{
   guint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_n_columns(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2989, 2989, 0);
}

static void sl_pango_layout_get_pixel_size (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_get_pixel_size(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2990, 2990, 0);
}

static void sl_gtk_page_setup_set_top_margin (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_page_setup_set_top_margin(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2991, 2991, 0);
}

static void sl_pango_context_get_gravity (void)
{
   PangoGravity retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_gravity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2992, 2992, 0);
}

static void sl_gtk_widget_path_new (void)
{
   GtkWidgetPath* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_new();
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2993, 2993, 0);
}

static void sl_gtk_label_set_width_chars (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2994, 2994, 0);
}

static void sl_gtk_gesture_single_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (2995, 2995, 0);
}

static void sl_gtk_print_settings_get_default_source (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_default_source(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2996, 2996, 0);
}

static void sl_gtk_recent_info_get_groups (void)
{
   gchar** retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_recent_info_get_groups(arg1, &arg2);
   push_null_term_str_array (retval, "gtk_recent_info_get_groups", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2997, 2997, 0);
}

static void sl_gtk_radio_button_new_with_mnemonic (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_button_new_with_mnemonic(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (2998, 2998, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_date_set_julian (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_julian(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (2999, 2999, 0);
}

static void sl_pango_script_get_sample_language (void)
{
   PangoLanguage* retval;
   PangoScript arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_script_get_sample_language( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3000, 3000, 0);
}

static void sl_gtk_viewport_set_hadjustment (void)
{
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_viewport_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3001, 3001, 0);
}

static void sl_gtk_scale_add_mark (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkPositionType arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_double((double*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   gtk_scale_add_mark(arg1,  arg2,  arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (3002, 3002, 0);
}

static void sl_gtk_window_set_auto_startup_notification (void)
{
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_auto_startup_notification( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3003, 3003, 0);
}

static void sl_gtk_icon_view_set_tooltip_item (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTooltip* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_set_tooltip_item(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3004, 3004, 0);
}

static void sl_gtk_button_get_image (void)
{
   GtkWidget* retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_image(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3005, 3005, 0);
}

static void sl_gdk_window_set_functions (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWMFunction arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_functions(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3006, 3006, 0);
}

static void sl_g_settings_get_int (void)
{
   gint retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_int(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3007, 3007, 0);
}

static void sl_g_signal_handler_block (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_signal_handler_block(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3008, 3008, 0);
}

static void sl_gtk_grid_get_child_at (void)
{
   GtkWidget* retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_child_at(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3009, 3009, 0);
}

static void sl_gtk_text_iter_forward_visible_word_end (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_word_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3010, 3010, 0);
}

static void sl_g_type_default_interface_ref (void)
{
   gpointer retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_default_interface_ref( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3011, 3011, 0);
}

static void sl_gtk_gl_area_set_error (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2 = (GError*) alloca(sizeof(GError));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GError_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_gl_area_set_error(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GError_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3012, 3012, 0);
}

static void sl_gtk_tree_path_get_depth (void)
{
   gint retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_get_depth(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3013, 3013, 0);
}

static void sl_gtk_recent_manager_add_item (void)
{
   gboolean retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_manager_add_item(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3014, 3014, 0);
}

static void sl_gtk_scale_new_with_range (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_new_with_range( arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3015, 3015, 0);
}

static void sl_g_notification_add_button (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_add_button(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3016, 3016, 0);
}

static void sl_g_content_type_equals (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_content_type_equals(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3017, 3017, 0);
}

static void sl_gtk_flow_box_get_row_spacing (void)
{
   guint retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_row_spacing(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3018, 3018, 0);
}

static void sl_g_variant_parse (void)
{
   GVariant* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   const gchar** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg4,0x0);
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_variant_parse(arg1, arg2, arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3019, 3019, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_gesture_zoom_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_zoom_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3020, 3020, 0);
}

static void sl_g_volume_get_symbolic_icon (void)
{
   GIcon* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_symbolic_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3021, 3021, 0);
}

static void sl_gdk_display_supports_composite (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_composite(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3022, 3022, 0);
}

static void sl_gtk_drag_dest_add_image_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_dest_add_image_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3023, 3023, 0);
}

static void sl_gtk_info_bar_get_content_area (void)
{
   GtkWidget* retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_content_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3024, 3024, 0);
}

static void sl_g_file_resolve_relative_path (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_resolve_relative_path(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3025, 3025, 0);
}

static void sl_pango_layout_iter_get_run (void)
{
   PangoLayoutRun* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_run(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3026, 3026, 0);
}

static void sl_g_type_check_value (void)
{
   gboolean retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_value(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3027, 3027, 0);
}

static void sl_g_action_get_parameter_type (void)
{
   const GVariantType* retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_parameter_type(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3028, 3028, 0);
}

static void sl_gtk_stack_add_named (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_add_named(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3029, 3029, 0);
}

static void sl_gdk_window_create_similar_surface (void)
{
   cairo_surface_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_content_t arg2;
   int arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_create_similar_surface(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3030, 3030, 0);
}

static void sl_gtk_selection_data_get_target (void)
{
   GdkAtom retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_target(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3031, 3031, 0);
}

static void sl_g_variant_get_type (void)
{
   const GVariantType* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_type(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3032, 3032, 0);
}

static void sl_gtk_tree_model_filter_convert_child_path_to_path (void)
{
   GtkTreePath* retval;
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_filter_convert_child_path_to_path(arg1, arg2);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3033, 3033, 0);
}

static void sl_gtk_paper_size_free (void)
{
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_paper_size_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3034, 3034, 0);
}

static void sl_gtk_widget_path_free (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3035, 3035, 0);
}

static void sl_gtk_entry_set_icon_tooltip_markup (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_tooltip_markup(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3036, 3036, 0);
}

static void sl_gtk_app_chooser_widget_set_default_text (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_app_chooser_widget_set_default_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3037, 3037, 0);
}

static void sl_g_source_get_name (void)
{
   const char* retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3038, 3038, 0);
}

static void sl_gtk_tool_palette_get_style (void)
{
   GtkToolbarStyle retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3039, 3039, 0);
}

static void sl_g_variant_type_value (void)
{
   const GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_value(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3040, 3040, 0);
}

static void sl_pango_tab_array_resize (void)
{
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_tab_array_resize(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3041, 3041, 0);
}

static void sl_g_key_file_new (void)
{
   GKeyFile* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_key_file_new();
   (void)SLang_push_opaque(GKeyFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3042, 3042, 0);
}

static void sl_gtk_print_settings_set_printer_lpi (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_printer_lpi(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3043, 3043, 0);
}

static void sl_gtk_tree_model_row_changed (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_row_changed(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3044, 3044, 0);
}

static void sl_gtk_image_get_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_get_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3045, 3045, 0);
}

static void sl_pango_units_to_double (void)
{
   double retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_units_to_double( arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3046, 3046, 0);
}

static void sl_gdk_pixbuf_loader_new_with_type (void)
{
   GdkPixbufLoader* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_loader_new_with_type(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3047, 3047, 0);
}

static void sl_gtk_icon_view_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3048, 3048, 0);
}

static void sl_gtk_window_set_default_icon_list (void)
{
   GList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_default_icon_list(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3049, 3049, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_key_file_get_start_group (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_key_file_get_start_group(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3050, 3050, 0);
}

static void sl_gtk_text_iter_get_buffer (void)
{
   GtkTextBuffer* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_buffer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3051, 3051, 0);
}

static void sl_gtk_tree_model_unref_node (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_unref_node(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3052, 3052, 0);
}

static void sl_gtk_places_sidebar_remove_shortcut (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_places_sidebar_remove_shortcut(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3053, 3053, 0);
}

static void sl_g_date_valid_weekday (void)
{
   gboolean retval;
   GDateWeekday arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_weekday( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3054, 3054, 0);
}

static void sl_gtk_page_setup_new_from_gvariant (void)
{
   GtkPageSetup* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_new_from_gvariant(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3055, 3055, 0);
}

static void sl_gtk_notebook_set_tab_pos (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPositionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_set_tab_pos(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3056, 3056, 0);
}

static void sl_g_date_time_add_days (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_days(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3057, 3057, 0);
}

static void sl_g_value_get_int64 (void)
{
   gint64 retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_int64(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3058, 3058, 0);
}

static void sl_gtk_entry_buffer_set_max_length (void)
{
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_buffer_set_max_length(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3059, 3059, 0);
}

static void sl_gtk_print_settings_set_default_source (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_default_source(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3060, 3060, 0);
}

static void sl_g_cancellable_disconnect (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_disconnect(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3061, 3061, 0);
}

static void sl_g_date_set_dmy (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateDay arg2;
   GDateMonth arg3;
   GDateYear arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_dmy(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3062, 3062, 0);
}

static void sl_g_action_get_enabled (void)
{
   gboolean retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_enabled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3063, 3063, 0);
}

static void sl_pango_cairo_context_get_font_options (void)
{
   const cairo_font_options_t* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_context_get_font_options(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3064, 3064, 0);
}

static void sl_g_value_set_flags (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_flags(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3065, 3065, 0);
}

static void sl_g_memory_settings_backend_new (void)
{
   GSettingsBackend* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_memory_settings_backend_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3066, 3066, 0);
}

static void sl_gdk_window_fullscreen (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_fullscreen(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3067, 3067, 0);
}

static void sl_gtk_tree_row_reference_get_model (void)
{
   GtkTreeModel* retval;
   GtkTreeRowReference* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeRowReference_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_row_reference_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3068, 3068, 0);
}

static void sl_gdk_frame_timings_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3069, 3069, 0);
}

static void sl_g_network_service_set_scheme (void)
{
   GNetworkService* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_network_service_set_scheme(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3070, 3070, 0);
}

static void sl_gtk_tool_shell_get_relief_style (void)
{
   GtkReliefStyle retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_relief_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3071, 3071, 0);
}

static void sl_gtk_print_operation_get_status (void)
{
   GtkPrintStatus retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_status(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3072, 3072, 0);
}

static void sl_gdk_window_get_update_area (void)
{
   cairo_region_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_update_area(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3073, 3073, 0);
}

static void sl_gdk_cursor_new_from_surface (void)
{
   GdkCursor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_surface_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_cursor_new_from_surface(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3074, 3074, 0);
}

static void sl_gdk_event_put (void)
{
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_event_put(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3075, 3075, 0);
}

static void sl_gdk_pixbuf_format_get_name (void)
{
   gchar* retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3076, 3076, 0);
}

static void sl_gtk_window_group_remove_window (void)
{
   GtkWindowGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_group_remove_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3077, 3077, 0);
}

static void sl_gtk_cell_editable_start_editing (void)
{
   GtkCellEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GdkEvent_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_editable_start_editing(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3078, 3078, 0);
}

static void sl_gtk_clipboard_wait_for_rich_text (void)
{
   guint8* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextBuffer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom* arg3;
   Slirp_Ref *arg3_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg3,0x0);
   gsize arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_clipboard_wait_for_rich_text(arg1, arg2, arg3, &arg4);
   (void)SLang_push_opaque(uchar_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3079, 3079, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_mount_is_shadowed (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_is_shadowed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3080, 3080, 0);
}

static void sl_gtk_menu_set_screen (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3081, 3081, 0);
}

static void sl_pango_font_description_set_variant (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoVariant arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_variant(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3082, 3082, 0);
}

static void sl_gdk_pixbuf_scale (void)
{
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   double arg7;
   double arg8;
   double arg9;
   double arg10;
   GdkInterpType arg11;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 11) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg11)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg10)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg9)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_pixbuf_scale(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8,  arg9,  arg10,  arg11);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3083, 3083, 0);
}

static void sl_g_menu_link_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_link_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3084, 3084, 0);
}

static void sl_g_zlib_decompressor_new (void)
{
   GZlibDecompressor* retval;
   GZlibCompressorFormat arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_zlib_decompressor_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3085, 3085, 0);
}

static void sl_g_match_info_get_regex (void)
{
   GRegex* retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_get_regex(arg1);
   (void)SLang_push_opaque(GRegex_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3086, 3086, 0);
}

static void sl_gtk_text_iter_get_pixbuf (void)
{
   GdkPixbuf* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3087, 3087, 0);
}

static void sl_g_variant_builder_clear (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_variant_builder_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3088, 3088, 0);
}

static void sl_gtk_calendar_get_day_is_marked (void)
{
   gboolean retval;
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_get_day_is_marked(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3089, 3089, 0);
}

static void sl_pango_font_description_hash (void)
{
   guint retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3090, 3090, 0);
}

static void sl_g_resolver_lookup_by_address (void)
{
   gchar* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_resolver_lookup_by_address(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3091, 3091, 0);
}

static void sl_gtk_tool_palette_get_drag_item (void)
{
   GtkWidget* retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkSelectionData* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_palette_get_drag_item(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3092, 3092, 0);
}

static void sl_gtk_text_tag_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3093, 3093, 0);
}

static void sl_gdk_device_get_n_axes (void)
{
   gint retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_n_axes(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3094, 3094, 0);
}

static void sl_gtk_gesture_single_set_touch_only (void)
{
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gesture_single_set_touch_only(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3095, 3095, 0);
}

static void sl_g_inet_socket_address_get_port (void)
{
   guint16 retval;
   GInetSocketAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_get_port(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3096, 3096, 0);
}

static void sl_gdk_display_get_default_seat (void)
{
   GdkSeat* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_default_seat(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3097, 3097, 0);
}

static void sl_gtk_window_mnemonic_activate (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_mnemonic_activate(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3098, 3098, 0);
}

static void sl_gtk_text_view_get_default_attributes (void)
{
   GtkTextAttributes* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_default_attributes(arg1);
   (void)SLang_push_opaque(GtkTextAttributes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3099, 3099, 0);
}

static void sl_pango_layout_line_ref (void)
{
   PangoLayoutLine* retval;
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_line_ref(arg1);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3100, 3100, 0);
}

static void sl_g_bookmark_file_set_modified (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   time_t arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_modified(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3101, 3101, 0);
}

static void sl_gdk_modifier_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_modifier_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3102, 3102, 0);
}

static void sl_gtk_tree_selection_select_iter (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_select_iter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3103, 3103, 0);
}

static void sl_gtk_page_setup_get_top_margin (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_top_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3104, 3104, 0);
}

static void sl_gdk_event_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3105, 3105, 0);
}

static void sl_gtk_gesture_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3106, 3106, 0);
}

static void sl_g_value_get_gtype (void)
{
   GType retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_gtype(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3107, 3107, 0);
}

static void sl_g_type_add_instance_private (void)
{
   gint retval;
   GType arg1;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_add_instance_private( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3108, 3108, 0);
}

static void sl_gtk_label_get_mnemonic_widget (void)
{
   GtkWidget* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_mnemonic_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3109, 3109, 0);
}

static void sl_gdk_setting_action_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_setting_action_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3110, 3110, 0);
}

static void sl_gtk_accel_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3111, 3111, 0);
}

static void sl_gtk_scrolled_window_get_propagate_natural_width (void)
{
   gboolean retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_propagate_natural_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3112, 3112, 0);
}

static void sl_gtk_text_iter_set_line_index (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_line_index(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3113, 3113, 0);
}

static void sl_gtk_orientable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_orientable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3114, 3114, 0);
}

static void sl_gtk_icon_theme_load_surface (void)
{
   cairo_surface_t* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint arg4;
   GdkWindow* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GtkIconLookupFlags arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = gtk_icon_theme_load_surface(arg1, arg2,  arg3,  arg4, arg5,  arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (3115, 3115, 0);
}

static void sl_g_source_is_destroyed (void)
{
   gboolean retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_is_destroyed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3116, 3116, 0);
}

static void sl_gtk_flow_box_insert (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_flow_box_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3117, 3117, 0);
}

static void sl_gdk_device_get_position_double (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen** arg2;
   Slirp_Ref *arg2_r = ref_new(GObject_Type,sizeof(GdkScreen*),&arg2,0x0);
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_device_get_position_double(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_double(arg3);
   (void)SLang_push_double(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3118, 3118, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_widget_get_tooltip_window (void)
{
   GtkWindow* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_tooltip_window(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3119, 3119, 0);
}

static void sl_gtk_tree_selection_path_is_selected (void)
{
   gboolean retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_selection_path_is_selected(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3120, 3120, 0);
}

static void sl_gtk_print_settings_set_orientation (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3121, 3121, 0);
}

static void sl_pango_layout_xy_to_index (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_xy_to_index(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3122, 3122, 0);
}

static void sl_g_value_set_uint (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_uint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3123, 3123, 0);
}

static void sl_gtk_layout_set_size (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_layout_set_size(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3124, 3124, 0);
}

static void sl_g_unichar_totitle (void)
{
   gunichar retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_totitle( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3125, 3125, 0);
}

static void sl_g_variant_get_objv (void)
{
   const gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_get_objv(arg1, &arg2);
   (void)SLang_push_opaque(string_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3126, 3126, 0);
}

static void sl_gtk_info_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3127, 3127, 0);
}

static void sl_pango_language_from_string (void)
{
   PangoLanguage* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_language_from_string(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3128, 3128, 0);
}

static void sl_gtk_flow_box_unselect_child (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFlowBoxChild* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_flow_box_unselect_child(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3129, 3129, 0);
}

static void sl_pango_attr_scale_new (void)
{
   PangoAttribute* retval;
   double arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_scale_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3130, 3130, 0);
}

static void sl_g_drive_enumerate_identifiers (void)
{
   char** retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_enumerate_identifiers(arg1);
   push_null_term_str_array (retval, "g_drive_enumerate_identifiers", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3131, 3131, 0);
}

static void sl_gtk_box_pack_start (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   guint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_pack_start(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3132, 3132, 0);
}

static void sl_gtk_tree_view_set_headers_clickable (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_headers_clickable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3133, 3133, 0);
}

static void sl_g_inet_socket_address_get_flowinfo (void)
{
   guint32 retval;
   GInetSocketAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_get_flowinfo(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3134, 3134, 0);
}

static void sl_g_file_replace (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gboolean arg3;
   GFileCreateFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_replace(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (3135, 3135, 0);
}

static void sl_g_binding_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3136, 3136, 0);
}

static void sl_gtk_recent_filter_add_mime_type (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_filter_add_mime_type(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3137, 3137, 0);
}

static void sl_gdk_frame_timings_get_frame_time (void)
{
   gint64 retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_frame_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3138, 3138, 0);
}

static void sl_gtk_widget_get_valign_with_baseline (void)
{
   GtkAlign retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_valign_with_baseline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3139, 3139, 0);
}

static void sl_gtk_offscreen_window_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_offscreen_window_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3140, 3140, 0);
}

static void sl_pango_tab_array_set_tab (void)
{
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   PangoTabAlign arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_tab_array_set_tab(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3141, 3141, 0);
}

static void sl_gtk_text_iter_copy (void)
{
   GtkTextIter* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_copy(arg1);
   (void)SLang_push_opaque(GtkTextIter_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3142, 3142, 0);
}

static void sl_gtk_text_view_get_bottom_margin (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_bottom_margin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3143, 3143, 0);
}

static void sl_gtk_recent_manager_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_manager_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3144, 3144, 0);
}

static void sl_gtk_gesture_single_get_current_button (void)
{
   guint retval;
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_current_button(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3145, 3145, 0);
}

static void sl_gtk_style_context_add_provider_for_screen (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleProvider* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_add_provider_for_screen(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3146, 3146, 0);
}

static void sl_gtk_text_buffer_get_end_iter (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_end_iter(arg1, arg2);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3147, 3147, 0);
}

static void sl_pango_script_iter_new (void)
{
   PangoScriptIter* retval;
   char* arg1;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_script_iter_new(arg1,  arg2);
   (void)SLang_push_opaque(PangoScriptIter_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3148, 3148, 0);
}

static void sl_g_network_service_get_service (void)
{
   const gchar* retval;
   GNetworkService* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_service_get_service(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3149, 3149, 0);
}

static void sl_gtk_cell_view_set_draw_sensitive (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_view_set_draw_sensitive(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3150, 3150, 0);
}

static void sl_gdk_drag_find_window_for_screen (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkScreen* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   GdkWindow** arg6;
   Slirp_Ref *arg6_r = ref_new(GObject_Type,sizeof(GdkWindow*),&arg6,0x0);
   GdkDragProtocol* arg7;
   Slirp_Ref *arg7_r = ref_new(SLANG_INT_TYPE,sizeof(GdkDragProtocol),&arg7,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == pop_array_or_ref( arg7_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_drag_find_window_for_screen(arg1, arg2, arg3,  arg4,  arg5, arg6, arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3151, 3151, 0);
   finalize_refs(2,arg6_r,arg7_r); 
}

static void sl_g_value_copy (void)
{
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_copy(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3152, 3152, 0);
}

static void sl_gtk_spin_button_set_adjustment (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_spin_button_set_adjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3153, 3153, 0);
}

static void sl_g_file_monitor_directory (void)
{
   GFileMonitor* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileMonitorFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_monitor_directory(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3154, 3154, 0);
}

static void sl_gtk_tree_view_scroll_to_point (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_scroll_to_point(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3155, 3155, 0);
}

static void sl_gdk_window_begin_resize_drag (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindowEdge arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   guint32 arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_begin_resize_drag(arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3156, 3156, 0);
}

static void sl_gtk_shortcut_label_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcut_label_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3157, 3157, 0);
}

static void sl_gtk_statusbar_remove_all (void)
{
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_statusbar_remove_all(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3158, 3158, 0);
}

static void sl_gtk_info_bar_add_button (void)
{
   GtkWidget* retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_info_bar_add_button(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3159, 3159, 0);
}

static void sl_g_strsplit (void)
{
   gchar** retval;
   gchar* arg1;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strsplit(arg1, arg2,  arg3);
   push_null_term_str_array (retval, "g_strsplit", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3160, 3160, 0);
}

static void sl_gdk_display_get_window_at_pointer (void)
{
   GdkWindow* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_window_at_pointer(arg1, &arg2, &arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3161, 3161, 0);
}

static void sl_gdk_monitor_get_height_mm (void)
{
   int retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_height_mm(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3162, 3162, 0);
}

static void sl_g_content_type_from_mime_type (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_from_mime_type(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3163, 3163, 0);
}

static void sl_gtk_style_context_get_padding (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GtkBorder* arg3 = (GtkBorder*) alloca(sizeof(GtkBorder));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_padding(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GtkBorder_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3164, 3164, 0);
}

static void sl_g_settings_list_relocatable_schemas (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_list_relocatable_schemas();
   push_null_term_str_array ((char **) retval, "g_settings_list_relocatable_schemas", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3165, 3165, 0);
}

static void sl_gtk_menu_get_title (void)
{
   const gchar* retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3166, 3166, 0);
}

static void sl_g_value_set_uchar (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guchar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_uchar(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3167, 3167, 0);
}

static void sl_gtk_tool_shell_get_text_size_group (void)
{
   GtkSizeGroup* retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_text_size_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3168, 3168, 0);
}

static void sl_gtk_search_entry_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_entry_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3169, 3169, 0);
}

static void sl_g_key_file_load_from_bytes (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GBytes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GKeyFileFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_load_from_bytes(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3170, 3170, 0);
}

static void sl_pango_font_family_get_name (void)
{
   const char* retval;
   PangoFontFamily* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_family_get_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3171, 3171, 0);
}

static void sl_gtk_layout_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_layout_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3172, 3172, 0);
}

static void sl_g_emblemed_icon_new (void)
{
   GIcon* retval;
   GIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GEmblem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_emblemed_icon_new(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3173, 3173, 0);
}

static void sl_gtk_tree_view_get_show_expanders (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_show_expanders(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3174, 3174, 0);
}

static void sl_g_date_time_add_hours (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_hours(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3175, 3175, 0);
}

static void sl_gdk_list_visuals (void)
{
   GList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_list_visuals();
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3176, 3176, 0);
}

static void sl_pango_layout_set_indent (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_indent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3177, 3177, 0);
}

static void sl_g_settings_unbind (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_unbind(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3178, 3178, 0);
}

static void sl_g_file_info_get_etag (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_etag(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3179, 3179, 0);
}

static void sl_gtk_about_dialog_set_translator_credits (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_translator_credits(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3180, 3180, 0);
}

static void sl_g_socket_new_from_fd (void)
{
   GSocket* retval;
   gint arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_new_from_fd( arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3181, 3181, 0);
}

static void sl_gtk_printer_accepts_pdf (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_accepts_pdf(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3182, 3182, 0);
}

static void sl_gdk_cursor_get_display (void)
{
   GdkDisplay* retval;
   GdkCursor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3183, 3183, 0);
}

static void sl_g_value_get_enum (void)
{
   gint retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_enum(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3184, 3184, 0);
}

static void sl_g_simple_proxy_resolver_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_simple_proxy_resolver_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3185, 3185, 0);
}

static void sl_gtk_menu_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3186, 3186, 0);
}

static void sl_g_menu_attribute_iter_get_value (void)
{
   GVariant* retval;
   GMenuAttributeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_attribute_iter_get_value(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3187, 3187, 0);
}

static void sl_g_regex_get_max_backref (void)
{
   gint retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_max_backref(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3188, 3188, 0);
}

static void sl_gdk_pixbuf_animation_iter_advance (void)
{
   gboolean retval;
   GdkPixbufAnimationIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg2, (void**)GTimeVal_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_iter_advance(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3189, 3189, 0);
}

static void sl_gtk_text_view_new_with_buffer (void)
{
   GtkWidget* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_new_with_buffer(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3190, 3190, 0);
}

static void sl_gdk_window_get_modal_hint (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_modal_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3191, 3191, 0);
}

static void sl_gtk_native_dialog_set_modal (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_native_dialog_set_modal(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3192, 3192, 0);
}

static void sl_gtk_entry_set_input_purpose (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkInputPurpose arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_input_purpose(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3193, 3193, 0);
}

static void sl_gtk_recent_chooser_get_items (void)
{
   GList* retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_items(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3194, 3194, 0);
}

static void sl_g_child_watch_source_new (void)
{
   GSource* retval;
   GPid arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_child_watch_source_new( arg1);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3195, 3195, 0);
}

static void sl_g_date_time_add_full (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   gdouble arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_full(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3196, 3196, 0);
}

static void sl_gdk_pixbuf_animation_get_width (void)
{
   int retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3197, 3197, 0);
}

static void sl_g_date_time_add_years (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_years(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3198, 3198, 0);
}

static void sl_g_network_address_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3199, 3199, 0);
}

static void sl_pango_layout_set_line_spacing (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   float arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_line_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3200, 3200, 0);
}

static void sl_gtk_file_chooser_set_create_folders (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_create_folders(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3201, 3201, 0);
}

static void sl_g_main_context_dispatch (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_dispatch(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3202, 3202, 0);
}

static void sl_gtk_window_get_position (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_get_position(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3203, 3203, 0);
}

static void sl_g_volume_monitor_get_connected_drives (void)
{
   GList* retval;
   GVolumeMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_monitor_get_connected_drives(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3204, 3204, 0);
}

static void sl_g_settings_get_has_unapplied (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_get_has_unapplied(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3205, 3205, 0);
}

static void sl_g_file_info_get_symbolic_icon (void)
{
   GIcon* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_symbolic_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3206, 3206, 0);
}

static void sl_pango_script_iter_get_range (void)
{
   PangoScriptIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const char** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg2,0x0);
   const char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   PangoScript* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(PangoScript),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoScriptIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_script_iter_get_range(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3207, 3207, 0);
   finalize_refs(3,arg2_r,arg3_r,arg4_r); 
}

static void sl_gdk_pixbuf_scale_simple (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   GdkInterpType arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_scale_simple(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3208, 3208, 0);
}

static void sl_gdk_pixbuf_format_free (void)
{
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_pixbuf_format_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3209, 3209, 0);
}

static void sl_gtk_widget_get_valign (void)
{
   GtkAlign retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_valign(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3210, 3210, 0);
}

static void sl_g_quark_from_string (void)
{
   GQuark retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_quark_from_string(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3211, 3211, 0);
}

static void sl_g_mount_can_eject (void)
{
   gboolean retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_can_eject(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3212, 3212, 0);
}

static void sl_gtk_gesture_get_device (void)
{
   GdkDevice* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_device(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3213, 3213, 0);
}

static void sl_g_simple_action_set_state (void)
{
   GSimpleAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_action_set_state(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3214, 3214, 0);
}

static void sl_g_socket_get_fd (void)
{
   int retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_fd(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3215, 3215, 0);
}

static void sl_pango_attr_underline_color_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   guint16 arg2;
   guint16 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_underline_color_new( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3216, 3216, 0);
}

static void sl_gdk_touchpad_gesture_phase_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_touchpad_gesture_phase_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3217, 3217, 0);
}

static void sl_gtk_widget_path_iter_set_name (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_widget_path_iter_set_name(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3218, 3218, 0);
}

static void sl_gtk_print_settings_copy (void)
{
   GtkPrintSettings* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_copy(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3219, 3219, 0);
}

static void sl_g_set_prgname (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   g_set_prgname(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3220, 3220, 0);
}

static void sl_g_menu_append_submenu (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GMenuModel* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_append_submenu(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3221, 3221, 0);
}

static void sl_gtk_radio_button_new_with_mnemonic_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_button_new_with_mnemonic_from_widget(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3222, 3222, 0);
}

static void sl_gtk_text_view_get_accepts_tab (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_accepts_tab(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3223, 3223, 0);
}

static void sl_gtk_widget_show (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_show(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3224, 3224, 0);
}

static void sl_g_io_channel_ref (void)
{
   GIOChannel* retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_ref(arg1);
   (void)SLang_push_opaque(GIOChannel_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3225, 3225, 0);
}

static void sl_gtk_page_setup_set_left_margin (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_page_setup_set_left_margin(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3226, 3226, 0);
}

static void sl_g_variant_get_normal_form (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_normal_form(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3227, 3227, 0);
}

static void sl_gtk_css_section_ref (void)
{
   GtkCssSection* retval;
   GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3228, 3228, 0);
}

static void sl_gtk_tool_palette_set_drag_source (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolPaletteDragTargets arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_palette_set_drag_source(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3229, 3229, 0);
}

static void sl_gtk_entry_set_overwrite_mode (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_overwrite_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3230, 3230, 0);
}

static void sl_gtk_icon_view_set_reorderable (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_reorderable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3231, 3231, 0);
}

static void sl_gtk_notebook_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3232, 3232, 0);
}

static void sl_gtk_menu_set_accel_path (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_set_accel_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3233, 3233, 0);
}

static void sl_gtk_menu_tool_button_new (void)
{
   GtkToolItem* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_menu_tool_button_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3234, 3234, 0);
}

static void sl_g_unsetenv (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   g_unsetenv(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3235, 3235, 0);
}

static void sl_g_utf8_get_char (void)
{
   gunichar retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_get_char(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3236, 3236, 0);
}

static void sl_gtk_level_bar_new_for_interval (void)
{
   GtkWidget* retval;
   gdouble arg1;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_new_for_interval( arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3237, 3237, 0);
}

static void sl_g_file_monitor_is_cancelled (void)
{
   gboolean retval;
   GFileMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_monitor_is_cancelled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3238, 3238, 0);
}

static void sl_g_file_query_filesystem_info_finish (void)
{
   GFileInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_filesystem_info_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3239, 3239, 0);
}

static void sl_gtk_tree_view_expand_row (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_expand_row(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3240, 3240, 0);
}

static void sl_g_mount_operation_set_password (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_mount_operation_set_password(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3241, 3241, 0);
}

static void sl_gtk_widget_queue_draw (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_draw(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3242, 3242, 0);
}

static void sl_g_get_language_names_with_category (void)
{
   const gchar** retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_get_language_names_with_category(arg1);
   push_null_term_str_array ((char **) retval, "g_get_language_names_with_category", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3243, 3243, 0);
}

static void sl_g_uuid_string_random (void)
{
   gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_uuid_string_random();
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3244, 3244, 0);
}

static void sl_gdk_gl_context_get_current (void)
{
   GdkGLContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_current();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3245, 3245, 0);
}

static void sl_gtk_widget_pop_composite_child (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gtk_widget_pop_composite_child();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3246, 3246, 0);
}

static void sl_g_mapped_file_get_length (void)
{
   gsize retval;
   GMappedFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMappedFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mapped_file_get_length(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3247, 3247, 0);
}

static void sl_gtk_application_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3248, 3248, 0);
}

static void sl_gtk_tool_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3249, 3249, 0);
}

static void sl_gtk_tool_item_get_text_orientation (void)
{
   GtkOrientation retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_text_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3250, 3250, 0);
}

static void sl_pango_script_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_script_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3251, 3251, 0);
}

static void sl_gtk_tree_model_sort_convert_path_to_child_path (void)
{
   GtkTreePath* retval;
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_sort_convert_path_to_child_path(arg1, arg2);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3252, 3252, 0);
}

static void sl_gtk_text_view_im_context_filter_keypress (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventKey* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_im_context_filter_keypress(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3253, 3253, 0);
}

static void sl_gtk_container_child_notify (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_child_notify(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3254, 3254, 0);
}

static void sl_pango_color_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_color_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3255, 3255, 0);
}

static void sl_g_file_set_attribute_uint64 (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   guint64 arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_uint64(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (3256, 3256, 0);
}

static void sl_g_app_info_launch_uris_finish (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_launch_uris_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3257, 3257, 0);
}

static void sl_gtk_get_major_version (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_major_version();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3258, 3258, 0);
}

static void sl_gtk_text_buffer_get_iter_at_line_offset (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_line_offset(arg1, arg2,  arg3,  arg4);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3259, 3259, 0);
}

static void sl_pango_layout_get_single_paragraph_mode (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_single_paragraph_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3260, 3260, 0);
}

static void sl_gtk_print_job_get_title (void)
{
   const gchar* retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3261, 3261, 0);
}

static void sl_g_file_measure_disk_usage_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint64 arg3;
   guint64 arg4;
   guint64 arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_measure_disk_usage_finish(arg1, arg2, &arg3, &arg4, &arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   if (retval)
      (void)SLang_push_ulong(arg3);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_ulong(arg4);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_ulong(arg5);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3262, 3262, 0);
}

static void sl_gtk_label_set_text_with_mnemonic (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_text_with_mnemonic(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3263, 3263, 0);
}

static void sl_gtk_search_bar_get_search_mode (void)
{
   gboolean retval;
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_bar_get_search_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3264, 3264, 0);
}

static void sl_gtk_popover_set_relative_to (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_popover_set_relative_to(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3265, 3265, 0);
}

static void sl_g_settings_schema_source_get_default (void)
{
   GSettingsSchemaSource* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_source_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3266, 3266, 0);
}

static void sl_gtk_adjustment_get_step_increment (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_step_increment(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3267, 3267, 0);
}

static void sl_gdk_screen_width_mm (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_width_mm();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3268, 3268, 0);
}

static void sl_gtk_scrolled_window_get_shadow_type (void)
{
   GtkShadowType retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_shadow_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3269, 3269, 0);
}

static void sl_gtk_text_view_scroll_to_iter (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gboolean arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_scroll_to_iter(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3270, 3270, 0);
}

static void sl_gtk_text_tag_changed (void)
{
   GtkTextTag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_tag_changed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3271, 3271, 0);
}

static void sl_gtk_tree_view_column_get_sort_order (void)
{
   GtkSortType retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_sort_order(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3272, 3272, 0);
}

static void sl_gtk_print_unix_dialog_get_settings (void)
{
   GtkPrintSettings* retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_settings(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3273, 3273, 0);
}

static void sl_g_number_parser_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_number_parser_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3274, 3274, 0);
}

static void sl_g_app_info_launch (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg2,0x0);
   GAppLaunchContext* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_app_info_launch(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3275, 3275, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_pointer_type_register_static (void)
{
   GType retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_pointer_type_register_static(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3276, 3276, 0);
}

static void sl_gdk_event_get_scroll_direction (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_scroll_direction(arg1, &arg2);
   if (retval)
      (void)SLang_push_int(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3277, 3277, 0);
}

static void sl_gtk_tool_item_set_use_drag_window (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_use_drag_window(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3278, 3278, 0);
}

static void sl_gtk_gesture_handles_sequence (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventSequence* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_handles_sequence(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3279, 3279, 0);
}

static void sl_gtk_text_view_get_pixels_above_lines (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_pixels_above_lines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3280, 3280, 0);
}

static void sl_gdk_event_get_pointer_emulated (void)
{
   gboolean retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_pointer_emulated(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3281, 3281, 0);
}

static void sl_g_source_remove (void)
{
   gboolean retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_source_remove( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3282, 3282, 0);
}

static void sl_gtk_label_get_xalign (void)
{
   gfloat retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_xalign(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3283, 3283, 0);
}

static void sl_gtk_scrolled_window_set_policy (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPolicyType arg2;
   GtkPolicyType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_policy(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3284, 3284, 0);
}

static void sl_gdk_window_get_decorations (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWMDecoration* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(GdkWMDecoration),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_decorations(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3285, 3285, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_file_find_enclosing_mount (void)
{
   GMount* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_find_enclosing_mount(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3286, 3286, 0);
}

static void sl_g_date_get_month (void)
{
   GDateMonth retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_month(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3287, 3287, 0);
}

static void sl_pango_context_load_font (void)
{
   PangoFont* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_context_load_font(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3288, 3288, 0);
}

static void sl_gtk_render_check (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_check(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3289, 3289, 0);
}

static void sl_g_utf16_to_utf8 (void)
{
   gchar* retval;
   const gunichar2* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_USHORT_TYPE,sizeof(gunichar2),&arg1,0x0);
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_utf16_to_utf8(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3290, 3290, 0);
   finalize_refs(2,arg1_r,arg3_r); 
}

static void sl_gtk_cell_area_get_edit_widget (void)
{
   GtkCellEditable* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_edit_widget(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3291, 3291, 0);
}

static void sl_g_date_valid_year (void)
{
   gboolean retval;
   GDateYear arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_year( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3292, 3292, 0);
}

static void sl_pango_context_get_base_gravity (void)
{
   PangoGravity retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_base_gravity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3293, 3293, 0);
}

static void sl_gtk_css_section_get_start_position (void)
{
   guint retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_start_position(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3294, 3294, 0);
}

static void sl_gdk_screen_set_font_options (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_font_options_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_screen_set_font_options(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3295, 3295, 0);
}

static void sl_gtk_tree_view_column_set_sizing (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumnSizing arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_sizing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3296, 3296, 0);
}

static void sl_g_file_get_basename (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_basename(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3297, 3297, 0);
}

static void sl_gdk_keyval_to_lower (void)
{
   guint retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_to_lower( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3298, 3298, 0);
}

static void sl_gtk_text_view_set_top_margin (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_top_margin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3299, 3299, 0);
}

static void sl_pango_renderer_activate (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_activate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3300, 3300, 0);
}

static void sl_gtk_print_operation_preview_render_page (void)
{
   GtkPrintOperationPreview* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_preview_render_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3301, 3301, 0);
}

static void sl_pango_coverage_unref (void)
{
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_coverage_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3302, 3302, 0);
}

static void sl_gtk_text_iter_get_visible_line_offset (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_visible_line_offset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3303, 3303, 0);
}

static void sl_gtk_application_set_menubar (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_set_menubar(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3304, 3304, 0);
}

static void sl_g_resource_open_stream (void)
{
   GInputStream* retval;
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GResourceLookupFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_resource_open_stream(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3305, 3305, 0);
}

static void sl_gtk_stack_add_titled (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_add_titled(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (3306, 3306, 0);
}

static void sl_g_zlib_decompressor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_zlib_decompressor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3307, 3307, 0);
}

static void sl_gtk_assistant_get_page_title (void)
{
   const gchar* retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_title(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3308, 3308, 0);
}

static void sl_gdk_event_peek (void)
{
   GdkEvent* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_peek();
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3309, 3309, 0);
}

static void sl_g_vfs_unregister_uri_scheme (void)
{
   gboolean retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_vfs_unregister_uri_scheme(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3310, 3310, 0);
}

static void sl_g_vfs_is_active (void)
{
   gboolean retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_vfs_is_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3311, 3311, 0);
}

static void sl_g_main_loop_quit (void)
{
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_loop_quit(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3312, 3312, 0);
}

static void sl_gdk_init (void)
{
   gint* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg1,0x0);
   gchar*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   gdk_init(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3313, 3313, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_text_iter_starts_line (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_starts_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3314, 3314, 0);
}

static void sl_g_date_set_day (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateDay arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_day(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3315, 3315, 0);
}

static void sl_gtk_combo_box_new_with_area (void)
{
   GtkWidget* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new_with_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3316, 3316, 0);
}

static void sl_gtk_list_box_set_selection_mode (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSelectionMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_set_selection_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3317, 3317, 0);
}

static void sl_g_mount_operation_set_pim (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_pim(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3318, 3318, 0);
}

static void sl_gtk_propagate_event (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_propagate_event(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3319, 3319, 0);
}

static void sl_gtk_scale_clear_marks (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_clear_marks(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3320, 3320, 0);
}

static void sl_gtk_recent_manager_remove_item (void)
{
   gboolean retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_recent_manager_remove_item(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3321, 3321, 0);
}

static void sl_g_socket_is_connected (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_is_connected(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3322, 3322, 0);
}

static void sl_gdk_selection_owner_set (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint32 arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_selection_owner_set(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3323, 3323, 0);
}

static void sl_gtk_adjustment_set_page_size (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_page_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3324, 3324, 0);
}

static void sl_g_object_unref (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_object_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3325, 3325, 0);
}

static void sl_gtk_size_group_get_ignore_hidden (void)
{
   gboolean retval;
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_size_group_get_ignore_hidden(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3326, 3326, 0);
}

static void sl_gtk_radio_tool_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_tool_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3327, 3327, 0);
}

static void sl_g_unichar_isprint (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isprint( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3328, 3328, 0);
}

static void sl_g_regex_get_compile_flags (void)
{
   GRegexCompileFlags retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_compile_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3329, 3329, 0);
}

static void sl_gtk_cairo_transform_to_window (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkWindow* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cairo_transform_to_window(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3330, 3330, 0);
}

static void sl_g_signal_connect_closure_by_id (void)
{
   gulong retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GQuark arg3;
   GClosure* arg4;
   Slirp_Opaque* arg4_o = NULL;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   retval = g_signal_connect_closure_by_id(arg1,  arg2,  arg3, arg4,  arg5);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (3331, 3331, 0);
}

static void sl_gtk_css_section_get_end_line (void)
{
   guint retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_end_line(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3332, 3332, 0);
}

static void sl_g_date_clear (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_clear(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3333, 3333, 0);
}

static void sl_gtk_scale_get_layout_offsets (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_get_layout_offsets(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3334, 3334, 0);
}

static void sl_gtk_print_settings_set_collate (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_collate(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3335, 3335, 0);
}

static void sl_gtk_recent_manager_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_manager_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3336, 3336, 0);
}

static void sl_gtk_window_activate_default (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_activate_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3337, 3337, 0);
}

static void sl_gtk_tool_item_group_insert (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_group_insert(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3338, 3338, 0);
}

static void sl_gtk_font_chooser_get_font (void)
{
   gchar* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3339, 3339, 0);
}

static void sl_gdk_gl_context_get_window (void)
{
   GdkWindow* retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3340, 3340, 0);
}

static void sl_gtk_icon_view_get_activate_on_single_click (void)
{
   gboolean retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_activate_on_single_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3341, 3341, 0);
}

static void sl_g_time_zone_get_offset (void)
{
   gint32 retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_get_offset(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3342, 3342, 0);
}

static void sl_g_menu_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3343, 3343, 0);
}

static void sl_gtk_cell_renderer_toggle_set_active (void)
{
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_toggle_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3344, 3344, 0);
}

static void sl_gtk_widget_set_default_direction (void)
{
   GtkTextDirection arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_default_direction( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3345, 3345, 0);
}

static void sl_gtk_container_set_border_width (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_set_border_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3346, 3346, 0);
}

static void sl_g_object_notify (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_object_notify(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3347, 3347, 0);
}

static void sl_g_file_info_get_attribute_status (void)
{
   GFileAttributeStatus retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_status(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3348, 3348, 0);
}

static void sl_g_type_check_is_value_type (void)
{
   gboolean retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_is_value_type( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3349, 3349, 0);
}

static void sl_g_variant_type_string_scan (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_type_string_scan(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3350, 3350, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_time_zone_new_utc (void)
{
   GTimeZone* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_new_utc();
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3351, 3351, 0);
}

static void sl_g_date_get_days_in_month (void)
{
   guint8 retval;
   GDateMonth arg1;
   GDateYear arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_days_in_month( arg1,  arg2);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3352, 3352, 0);
}

static void sl_gdk_cursor_get_surface (void)
{
   cairo_surface_t* retval;
   GdkCursor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_get_surface(arg1, &arg2, &arg3);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3353, 3353, 0);
}

static void sl_gdk_display_list_devices (void)
{
   const GList* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_list_devices(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3354, 3354, 0);
}

static void sl_g_settings_set_int64 (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint64 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_int64(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3355, 3355, 0);
}

static void sl_gdk_device_tool_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_tool_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3356, 3356, 0);
}

static void sl_g_value_type_compatible (void)
{
   gboolean retval;
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_value_type_compatible( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3357, 3357, 0);
}

static void sl_g_file_attribute_info_list_unref (void)
{
   GFileAttributeInfoList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_attribute_info_list_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3358, 3358, 0);
}

static void sl_pango_attr_type_get_name (void)
{
   const char* retval;
   PangoAttrType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_type_get_name( arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3359, 3359, 0);
}

static void sl_gtk_color_button_set_color (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_color_button_set_color(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3360, 3360, 0);
}

static void sl_gtk_tree_model_iter_has_child (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_has_child(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3361, 3361, 0);
}

static void sl_gtk_print_unix_dialog_set_support_selection (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_unix_dialog_set_support_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3362, 3362, 0);
}

static void sl_gtk_icon_view_set_markup_column (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_markup_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3363, 3363, 0);
}

static void sl_gtk_event_controller_scroll_new (void)
{
   GtkEventController* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEventControllerScrollFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_scroll_new(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3364, 3364, 0);
}

static void sl_gdk_drawing_context_is_valid (void)
{
   gboolean retval;
   GdkDrawingContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drawing_context_is_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3365, 3365, 0);
}

static void sl_gtk_notebook_get_show_border (void)
{
   gboolean retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_show_border(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3366, 3366, 0);
}

static void sl_gtk_list_store_move_before (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_store_move_before(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3367, 3367, 0);
}

static void sl_gtk_window_get_group (void)
{
   GtkWindowGroup* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3368, 3368, 0);
}

static void sl_gtk_drag_unhighlight (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_unhighlight(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3369, 3369, 0);
}

static void sl_g_file_create_finish (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_create_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3370, 3370, 0);
}

static void sl_g_str_to_ascii (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_str_to_ascii(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3371, 3371, 0);
}

static void sl_gtk_popover_set_transitions_enabled (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_set_transitions_enabled(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3372, 3372, 0);
}

static void sl_g_value_get_uchar (void)
{
   guchar retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_uchar(arg1);
   (void)SLang_push_uchar(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3373, 3373, 0);
}

static void sl_gtk_list_box_set_activate_on_single_click (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_set_activate_on_single_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3374, 3374, 0);
}

static void sl_gtk_file_chooser_get_create_folders (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_create_folders(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3375, 3375, 0);
}

static void sl_gtk_cell_renderer_toggle_set_activatable (void)
{
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_toggle_set_activatable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3376, 3376, 0);
}

static void sl_g_date_clamp (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GDate* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GDate* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_date_clamp(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3377, 3377, 0);
}

static void sl_g_dngettext (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gchar* arg3;
   gulong arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_dngettext(arg1, arg2, arg3,  arg4);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3378, 3378, 0);
}

static void sl_gtk_text_iter_forward_search (void)
{
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   GtkTextIter* arg4;
   GtkTextIter* arg5;
   const GtkTextIter* arg6;
   Slirp_Opaque* arg6_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTextIter_Type, (void**)&arg6_o, (void**)&arg6)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg4 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   if ((arg5 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_iter_forward_search(arg1, arg2,  arg3, arg4, arg5, arg6);
   (void) SLang_push_opaque (GtkTextIter_Type, arg4, 1);
   (void) SLang_push_opaque (GtkTextIter_Type, arg5, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (3379, 3379, 0);
}

static void sl_g_inet_address_mask_new_from_string (void)
{
   GInetAddressMask* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_inet_address_mask_new_from_string(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3380, 3380, 0);
}

static void sl_gtk_style_context_get_margin (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GtkBorder* arg3 = (GtkBorder*) alloca(sizeof(GtkBorder));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_margin(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GtkBorder_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3381, 3381, 0);
}

static void sl_g_source_set_priority (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_source_set_priority(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3382, 3382, 0);
}

static void sl_gtk_expander_get_label (void)
{
   const gchar* retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3383, 3383, 0);
}

static void sl_gtk_text_iter_backward_cursor_positions (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_cursor_positions(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3384, 3384, 0);
}

static void sl_g_settings_apply (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_apply(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3385, 3385, 0);
}

static void sl_pango_is_zero_width (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_is_zero_width( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3386, 3386, 0);
}

static void sl_gdk_pixbuf_remove_option (void)
{
   gboolean retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_remove_option(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3387, 3387, 0);
}

static void sl_g_menu_item_new (void)
{
   GMenuItem* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_menu_item_new(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3388, 3388, 0);
}

static void sl_g_socket_send_with_blocking (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   gboolean arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_socket_send_with_blocking(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (3389, 3389, 0);
}

static void sl_gdk_window_set_source_events (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkInputSource arg2;
   GdkEventMask arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_source_events(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3390, 3390, 0);
}

static void sl_gtk_combo_box_get_wrap_width (void)
{
   gint retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_wrap_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3391, 3391, 0);
}

static void sl_g_type_default_interface_unref (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_type_default_interface_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3392, 3392, 0);
}

static void sl_g_value_get_double (void)
{
   gdouble retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_double(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3393, 3393, 0);
}

static void sl_gtk_window_present_with_time (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_present_with_time(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3394, 3394, 0);
}

static void sl_gdk_display_has_pending (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_has_pending(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3395, 3395, 0);
}

static void sl_gtk_tree_view_get_grid_lines (void)
{
   GtkTreeViewGridLines retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_grid_lines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3396, 3396, 0);
}

static void sl_g_file_query_info (void)
{
   GFileInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileQueryInfoFlags arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_file_query_info(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (3397, 3397, 0);
}

static void sl_g_unichar_isalpha (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isalpha( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3398, 3398, 0);
}

static void sl_gtk_about_dialog_get_translator_credits (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_translator_credits(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3399, 3399, 0);
}

static void sl_gtk_tree_sortable_set_sort_column_id (void)
{
   GtkTreeSortable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GtkSortType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_sortable_set_sort_column_id(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3400, 3400, 0);
}

static void sl_gtk_cell_area_box_set_spacing (void)
{
   GtkCellAreaBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_box_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3401, 3401, 0);
}

static void sl_gtk_label_get_line_wrap_mode (void)
{
   PangoWrapMode retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_line_wrap_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3402, 3402, 0);
}

static void sl_g_file_load_partial_contents_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   gsize arg4;
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   arg6 = NULL;
   retval = g_file_load_partial_contents_finish(arg1, arg2, arg3, &arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3403, 3403, 0);
   finalize_refs(2,arg3_r,arg5_r); 
}

static void sl_gtk_text_attributes_new (void)
{
   GtkTextAttributes* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_attributes_new();
   (void)SLang_push_opaque(GtkTextAttributes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3404, 3404, 0);
}

static void sl_g_app_info_launch_default_for_uri (void)
{
   gboolean retval;
   char* arg1;
   GAppLaunchContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_launch_default_for_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3405, 3405, 0);
}

static void sl_gtk_text_attributes_unref (void)
{
   GtkTextAttributes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextAttributes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_attributes_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3406, 3406, 0);
}

static void sl_gtk_window_set_wmclass (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_wmclass(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3407, 3407, 0);
}

static void sl_gtk_widget_get_modifier_mask (void)
{
   GdkModifierType retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierIntent arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_modifier_mask(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3408, 3408, 0);
}

static void sl_gtk_print_settings_get_page_set (void)
{
   GtkPageSet retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_page_set(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3409, 3409, 0);
}

static void sl_g_volume_eject_with_operation_finish (void)
{
   gboolean retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_volume_eject_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3410, 3410, 0);
}

static void sl_gdk_display_manager_get_default_display (void)
{
   GdkDisplay* retval;
   GdkDisplayManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_manager_get_default_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3411, 3411, 0);
}

static void sl_g_variant_new_byte (void)
{
   GVariant* retval;
   guint8 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_byte( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3412, 3412, 0);
}

static void sl_gtk_gesture_single_get_touch_only (void)
{
   gboolean retval;
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_touch_only(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3413, 3413, 0);
}

static void sl_gtk_widget_get_hexpand_set (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_hexpand_set(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3414, 3414, 0);
}

static void sl_gtk_expander_set_resize_toplevel (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_resize_toplevel(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3415, 3415, 0);
}

static void sl_gtk_grid_get_column_homogeneous (void)
{
   gboolean retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_column_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3416, 3416, 0);
}

static void sl_g_file_attribute_matcher_new (void)
{
   GFileAttributeMatcher* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_matcher_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3417, 3417, 0);
}

static void sl_g_checksum_free (void)
{
   GChecksum* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GChecksum_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_checksum_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3418, 3418, 0);
}

static void sl_gtk_event_box_set_above_child (void)
{
   GtkEventBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_event_box_set_above_child(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3419, 3419, 0);
}

static void sl_gtk_false (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_false();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3420, 3420, 0);
}

static void sl_pango_attr_list_insert (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttribute* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_attr_list_insert(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3421, 3421, 0);
}

static void sl_gtk_entry_completion_set_inline_completion (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_inline_completion(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3422, 3422, 0);
}

static void sl_gtk_aspect_frame_set (void)
{
   GtkAspectFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   gfloat arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_aspect_frame_set(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3423, 3423, 0);
}

static void sl_g_content_type_guess_for_tree (void)
{
   gchar** retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_guess_for_tree(arg1);
   push_null_term_str_array (retval, "g_content_type_guess_for_tree", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3424, 3424, 0);
}

static void sl_g_file_info_set_attribute_boolean (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_boolean(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3425, 3425, 0);
}

static void sl_gdk_screen_get_monitor_height_mm (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_height_mm(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3426, 3426, 0);
}

static void sl_pango_layout_set_ellipsize (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoEllipsizeMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_ellipsize(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3427, 3427, 0);
}

static void sl_gtk_actionable_get_action_target_value (void)
{
   GVariant* retval;
   GtkActionable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_actionable_get_action_target_value(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3428, 3428, 0);
}

static void sl_g_file_monitor_file (void)
{
   GFileMonitor* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileMonitorFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_monitor_file(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3429, 3429, 0);
}

static void sl_gtk_menu_set_title (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3430, 3430, 0);
}

static void sl_gtk_file_chooser_add_shortcut_folder (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_add_shortcut_folder(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3431, 3431, 0);
}

static void sl_g_key_file_unref (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_key_file_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3432, 3432, 0);
}

static void sl_gdk_notify_startup_complete (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_notify_startup_complete();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3433, 3433, 0);
}

static void sl_gtk_text_buffer_get_iter_at_child_anchor (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   GtkTextChildAnchor* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_child_anchor(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3434, 3434, 0);
}

static void sl_gtk_popover_get_constrain_to (void)
{
   GtkPopoverConstraint retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_constrain_to(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3435, 3435, 0);
}

static void sl_gtk_accessible_get_widget (void)
{
   GtkWidget* retval;
   GtkAccessible* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accessible_get_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3436, 3436, 0);
}

static void sl_gtk_tree_view_get_columns (void)
{
   GList* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_columns(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3437, 3437, 0);
}

static void sl_gtk_file_chooser_get_filenames (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_filenames(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3438, 3438, 0);
}

static void sl_g_date_time_add (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeSpan arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3439, 3439, 0);
}

static void sl_gtk_widget_set_device_enabled (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_device_enabled(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3440, 3440, 0);
}

static void sl_g_settings_set_enum (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_enum(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3441, 3441, 0);
}

static void sl_g_socket_accept (void)
{
   GSocket* retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_socket_accept(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3442, 3442, 0);
}

static void sl_g_type_fundamental_next (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_type_fundamental_next();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3443, 3443, 0);
}

static void sl_gdk_event_get_seat (void)
{
   GdkSeat* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_seat(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3444, 3444, 0);
}

static void sl_gtk_statusbar_get_context_id (void)
{
   guint retval;
   GtkStatusbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_statusbar_get_context_id(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3445, 3445, 0);
}

static void sl_gtk_widget_get_child_visible (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_child_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3446, 3446, 0);
}

static void sl_gtk_dialog_get_action_area (void)
{
   GtkWidget* retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_get_action_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3447, 3447, 0);
}

static void sl_gtk_button_set_focus_on_click (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_focus_on_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3448, 3448, 0);
}

static void sl_g_file_trash_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_trash_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3449, 3449, 0);
}

static void sl_gtk_progress_bar_set_ellipsize (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoEllipsizeMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_set_ellipsize(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3450, 3450, 0);
}

static void sl_g_resolver_lookup_records (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GResolverRecordType arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_resolver_lookup_records(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (3451, 3451, 0);
}

static void sl_gdk_window_move_resize (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_move_resize(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3452, 3452, 0);
}

static void sl_gtk_recent_chooser_set_filter (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRecentFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_chooser_set_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3453, 3453, 0);
}

static void sl_g_bookmark_file_set_title (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_title(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3454, 3454, 0);
}

static void sl_pango_version_check (void)
{
   const char* retval;
   int arg1;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_version_check( arg1,  arg2,  arg3);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3455, 3455, 0);
}

static void sl_gtk_entry_completion_set_text_column (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_text_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3456, 3456, 0);
}

static void sl_gtk_text_iter_forward_visible_lines (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_lines(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3457, 3457, 0);
}

static void sl_gtk_viewport_set_shadow_type (void)
{
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShadowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_viewport_set_shadow_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3458, 3458, 0);
}

static void sl_gtk_info_bar_set_revealed (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_set_revealed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3459, 3459, 0);
}

static void sl_pango_attribute_equal (void)
{
   gboolean retval;
   const PangoAttribute* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoAttribute* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_attribute_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3460, 3460, 0);
}

static void sl_gtk_tool_item_group_get_label_widget (void)
{
   GtkWidget* retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_label_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3461, 3461, 0);
}

static void sl_gdk_window_get_fullscreen_mode (void)
{
   GdkFullscreenMode retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_fullscreen_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3462, 3462, 0);
}

static void sl_gtk_gesture_multi_press_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_multi_press_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3463, 3463, 0);
}

static void sl_g_mount_guess_content_type_sync (void)
{
   gchar** retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_mount_guess_content_type_sync(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   push_null_term_str_array (retval, "g_mount_guess_content_type_sync", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3464, 3464, 0);
}

static void sl_gtk_text_tag_table_new (void)
{
   GtkTextTagTable* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_table_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3465, 3465, 0);
}

static void sl_gtk_widget_set_margin_left (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_left(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3466, 3466, 0);
}

static void sl_g_file_delete_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_delete_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3467, 3467, 0);
}

static void sl_pango_renderer_get_layout_line (void)
{
   PangoLayoutLine* retval;
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_renderer_get_layout_line(arg1);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3468, 3468, 0);
}

static void sl_gdk_frame_clock_get_timings (void)
{
   GdkFrameTimings* retval;
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint64 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_timings(arg1,  arg2);
   (void)SLang_push_opaque(GdkFrameTimings_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3469, 3469, 0);
}

static void sl_gdk_pixbuf_get_has_alpha (void)
{
   gboolean retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_has_alpha(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3470, 3470, 0);
}

static void sl_g_resolver_lookup_by_name_with_flags (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GResolverNameLookupFlags arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_resolver_lookup_by_name_with_flags(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (3471, 3471, 0);
}

static void sl_g_file_monitor_set_rate_limit (void)
{
   GFileMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_monitor_set_rate_limit(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3472, 3472, 0);
}

static void sl_g_utf8_strreverse (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strreverse(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3473, 3473, 0);
}

static void sl_gtk_text_iter_get_marks (void)
{
   GSList* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_marks(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3474, 3474, 0);
}

static void sl_pango_renderer_deactivate (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_deactivate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3475, 3475, 0);
}

static void sl_gtk_box_set_child_packing (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   guint arg5;
   GtkPackType arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_set_child_packing(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3476, 3476, 0);
}

static void sl_gtk_progress_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3477, 3477, 0);
}

static void sl_gtk_flow_box_child_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_child_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3478, 3478, 0);
}

static void sl_gtk_text_buffer_delete (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_delete(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3479, 3479, 0);
}

static void sl_gtk_expander_get_spacing (void)
{
   gint retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3480, 3480, 0);
}

static void sl_gtk_printer_is_default (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_is_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3481, 3481, 0);
}

static void sl_g_type_create_instance (void)
{
   GTypeInstance* retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_create_instance( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3482, 3482, 0);
}

static void sl_gtk_file_chooser_get_use_preview_label (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_use_preview_label(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3483, 3483, 0);
}

static void sl_gdk_device_get_name (void)
{
   const gchar* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3484, 3484, 0);
}

static void sl_g_file_new_tmp (void)
{
   GFile* retval;
   char* arg1;
   GFileIOStream** arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GFileIOStream*),&arg2,0x0);
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_new_tmp(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3485, 3485, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_file_info_get_attribute_string (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_string(arg1, arg2);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3486, 3486, 0);
}

static void sl_gtk_recent_info_is_local (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_is_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3487, 3487, 0);
}

static void sl_g_type_add_interface_dynamic (void)
{
   GType arg1;
   GType arg2;
   GTypePlugin* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   g_type_add_interface_dynamic( arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3488, 3488, 0);
}

static void sl_gtk_dialog_set_alternative_button_order_from_array (void)
{
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_dialog_set_alternative_button_order_from_array(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3489, 3489, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_date_time_is_daylight_savings (void)
{
   gboolean retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_is_daylight_savings(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3490, 3490, 0);
}

static void sl_gtk_widget_get_margin_right (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_right(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3491, 3491, 0);
}

static void sl_gtk_text_buffer_set_text (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (gint) strlen (arg2);
   gtk_text_buffer_set_text(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3492, 3492, 0);
}

static void sl_gtk_box_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_new( arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3493, 3493, 0);
}

static void sl_g_credentials_new (void)
{
   GCredentials* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_credentials_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3494, 3494, 0);
}

static void sl_g_unichar_tolower (void)
{
   gunichar retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_tolower( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3495, 3495, 0);
}

static void sl_pango_layout_line_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_line_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3496, 3496, 0);
}

static void sl_gtk_text_child_anchor_get_widgets (void)
{
   GList* retval;
   GtkTextChildAnchor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_child_anchor_get_widgets(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3497, 3497, 0);
}

static void sl_gtk_tree_view_get_rules_hint (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_rules_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3498, 3498, 0);
}

static void sl_g_date_time_get_day_of_week (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_day_of_week(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3499, 3499, 0);
}

static void sl_gtk_print_context_get_width (void)
{
   gdouble retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_width(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3500, 3500, 0);
}

static void sl_gtk_style_context_get_font (void)
{
   const PangoFontDescription* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_font(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3501, 3501, 0);
}

static void sl_gtk_scrolled_window_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3502, 3502, 0);
}

static void sl_gtk_about_dialog_get_website_label (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_website_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3503, 3503, 0);
}

static void sl_gdk_event_get_root_coords (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_root_coords(arg1, &arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg2);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3504, 3504, 0);
}

static void sl_gdk_pixbuf_savev (void)
{
   gboolean retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   char** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg4,0x0);
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = gdk_pixbuf_savev(arg1, arg2, arg3, arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3505, 3505, 0);
   finalize_refs(2,arg4_r,arg5_r); 
}

static void sl_gtk_widget_path_iter_get_name (void)
{
   const gchar* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_name(arg1,  arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3506, 3506, 0);
}

static void sl_gtk_window_get_role (void)
{
   const gchar* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_role(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3507, 3507, 0);
}

static void sl_gtk_print_job_set_pages (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintPages arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_pages(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3508, 3508, 0);
}

static void sl_gtk_file_chooser_remove_filter (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFileFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_remove_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3509, 3509, 0);
}

static void sl_gtk_entry_reset_im_context (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_reset_im_context(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3510, 3510, 0);
}

static void sl_gtk_print_settings_new_from_key_file (void)
{
   GtkPrintSettings* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_print_settings_new_from_key_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3511, 3511, 0);
}

static void sl_gtk_window_list_toplevels (void)
{
   GList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_list_toplevels();
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3512, 3512, 0);
}

static void sl_gtk_scale_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3513, 3513, 0);
}

static void sl_g_rand_int (void)
{
   guint32 retval;
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_int(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3514, 3514, 0);
}

static void sl_g_bookmark_file_set_description (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_description(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3515, 3515, 0);
}

static void sl_gtk_tree_selection_get_mode (void)
{
   GtkSelectionMode retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_get_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3516, 3516, 0);
}

static void sl_g_file_info_get_attribute_int64 (void)
{
   gint64 retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_int64(arg1, arg2);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3517, 3517, 0);
}

static void sl_gtk_selection_owner_set_for_display (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint32 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_owner_set_for_display(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3518, 3518, 0);
}

static void sl_gtk_combo_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3519, 3519, 0);
}

static void sl_gtk_menu_shell_set_take_focus (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_shell_set_take_focus(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3520, 3520, 0);
}

static void sl_gtk_window_set_attached_to (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_attached_to(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3521, 3521, 0);
}

static void sl_g_action_map_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_action_map_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3522, 3522, 0);
}

static void sl_gtk_cell_area_set_focus_cell (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_set_focus_cell(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3523, 3523, 0);
}

static void sl_gtk_menu_shell_append (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_append(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3524, 3524, 0);
}

static void sl_gtk_print_settings_set_paper_height (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_paper_height(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3525, 3525, 0);
}

static void sl_gtk_popover_get_relative_to (void)
{
   GtkWidget* retval;
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_relative_to(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3526, 3526, 0);
}

static void sl_g_variant_type_equal (void)
{
   gboolean retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_type_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3527, 3527, 0);
}

static void sl_gtk_image_get_icon_name (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_get_icon_name(arg1, &arg2, &arg3);
   (void)SLang_push_string(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3528, 3528, 0);
}

static void sl_gdk_pixbuf_loader_new_with_mime_type (void)
{
   GdkPixbufLoader* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_loader_new_with_mime_type(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3529, 3529, 0);
}

static void sl_gdk_visual_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3530, 3530, 0);
}

static void sl_gtk_cell_renderer_render (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, GdkRectangle_Layout)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_render(arg1, arg2, arg3, arg4, arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, GdkRectangle_Layout);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3531, 3531, 0);
}

static void sl_gtk_tool_item_group_set_header_relief (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkReliefStyle arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_group_set_header_relief(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3532, 3532, 0);
}

static void sl_gtk_css_provider_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_provider_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3533, 3533, 0);
}

static void sl_g_object_set_qdata (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GQuark arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_object_set_qdata(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3534, 3534, 0);
}

static void sl_pango_tab_array_get_tabs (void)
{
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoTabAlign** arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint** arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(gint_ptr_ptr_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabAlign_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_tab_array_get_tabs(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3535, 3535, 0);
}

static void sl_gtk_shortcut_label_get_disabled_text (void)
{
   const gchar* retval;
   GtkShortcutLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcut_label_get_disabled_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3536, 3536, 0);
}

static void sl_gtk_window_group_new (void)
{
   GtkWindowGroup* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_group_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3537, 3537, 0);
}

static void sl_pango_layout_iter_free (void)
{
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_iter_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3538, 3538, 0);
}

static void sl_gtk_clipboard_set_text (void)
{
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_clipboard_set_text(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3539, 3539, 0);
}

static void sl_gtk_stack_sidebar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_sidebar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3540, 3540, 0);
}

static void sl_g_utf8_collate (void)
{
   gint retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_utf8_collate(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3541, 3541, 0);
}

static void sl_gdk_screen_get_monitor_at_point (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_at_point(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3542, 3542, 0);
}

static void sl_gtk_gesture_get_last_event (void)
{
   const GdkEvent* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventSequence* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_get_last_event(arg1, arg2);
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3543, 3543, 0);
}

static void sl_gtk_button_clicked (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_clicked(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3544, 3544, 0);
}

static void sl_gtk_font_chooser_set_language (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_chooser_set_language(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3545, 3545, 0);
}

static void sl_gtk_selection_data_set (void)
{
   GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   const guchar* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg4,0x0);
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_selection_data_set(arg1, arg2,  arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3546, 3546, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_file_chooser_get_current_name (void)
{
   gchar* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_current_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3547, 3547, 0);
}

static void sl_g_regex_get_match_flags (void)
{
   GRegexMatchFlags retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_match_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3548, 3548, 0);
}

static void sl_g_date_time_new_now (void)
{
   GDateTime* retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_now(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3549, 3549, 0);
}

static void sl_g_socket_set_multicast_loopback (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_multicast_loopback(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3550, 3550, 0);
}

static void sl_pango_cairo_context_set_resolution (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_cairo_context_set_resolution(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3551, 3551, 0);
}

static void sl_gtk_text_iter_backward_visible_word_starts (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_word_starts(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3552, 3552, 0);
}

static void sl_gtk_widget_path_ref (void)
{
   GtkWidgetPath* retval;
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_ref(arg1);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3553, 3553, 0);
}

static void sl_gtk_cell_layout_add_attribute (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_layout_add_attribute(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3554, 3554, 0);
}

static void sl_gtk_stack_get_hhomogeneous (void)
{
   gboolean retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_hhomogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3555, 3555, 0);
}

static void sl_gtk_widget_set_sensitive (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_sensitive(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3556, 3556, 0);
}

static void sl_gtk_spin_button_set_wrap (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_wrap(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3557, 3557, 0);
}

static void sl_gtk_recent_chooser_set_show_private (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_show_private(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3558, 3558, 0);
}

static void sl_gdk_pixbuf_format_get_extensions (void)
{
   gchar** retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_extensions(arg1);
   push_null_term_str_array (retval, "gdk_pixbuf_format_get_extensions", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3559, 3559, 0);
}

static void sl_gdk_display_get_event (void)
{
   GdkEvent* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_event(arg1);
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3560, 3560, 0);
}

static void sl_gtk_text_view_set_tabs (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoTabArray* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_set_tabs(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3561, 3561, 0);
}

static void sl_gtk_cell_layout_reorder (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_layout_reorder(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3562, 3562, 0);
}

static void sl_gtk_menu_button_get_align_widget (void)
{
   GtkWidget* retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_align_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3563, 3563, 0);
}

static void sl_gtk_tool_palette_set_expand (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_palette_set_expand(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3564, 3564, 0);
}

static void sl_gtk_icon_info_get_builtin_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_builtin_pixbuf(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3565, 3565, 0);
}

static void sl_gtk_text_buffer_backspace (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_backspace(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3566, 3566, 0);
}

static void sl_gtk_combo_box_get_active_id (void)
{
   const gchar* retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_active_id(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3567, 3567, 0);
}

static void sl_gtk_orientable_get_orientation (void)
{
   GtkOrientation retval;
   GtkOrientable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_orientable_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3568, 3568, 0);
}

static void sl_gtk_entry_set_width_chars (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3569, 3569, 0);
}

static void sl_gtk_header_bar_set_custom_title (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_set_custom_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3570, 3570, 0);
}

static void sl_gtk_paned_get_wide_handle (void)
{
   gboolean retval;
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_wide_handle(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3571, 3571, 0);
}

static void sl_g_type_add_class_private (void)
{
   GType arg1;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_type_add_class_private( arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3572, 3572, 0);
}

static void sl_gtk_widget_path_unref (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3573, 3573, 0);
}

static void sl_gtk_progress_bar_get_text (void)
{
   const gchar* retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3574, 3574, 0);
}

static void sl_gtk_layout_set_vadjustment (void)
{
   GtkLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_layout_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3575, 3575, 0);
}

static void sl_g_simple_action_set_state_hint (void)
{
   GSimpleAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_action_set_state_hint(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3576, 3576, 0);
}

static void sl_gtk_mount_operation_is_showing (void)
{
   gboolean retval;
   GtkMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_mount_operation_is_showing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3577, 3577, 0);
}

static void sl_g_value_dup_string (void)
{
   gchar* retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_dup_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3578, 3578, 0);
}

static void sl_gtk_window_set_skip_taskbar_hint (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_skip_taskbar_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3579, 3579, 0);
}

static void sl_gtk_print_settings_set_scale (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_scale(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3580, 3580, 0);
}

static void sl_g_mount_get_symbolic_icon (void)
{
   GIcon* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_symbolic_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3581, 3581, 0);
}

static void sl_gtk_widget_get_frame_clock (void)
{
   GdkFrameClock* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_frame_clock(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3582, 3582, 0);
}

static void sl_g_value_set_ulong (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_ulong(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3583, 3583, 0);
}

static void sl_g_network_address_get_hostname (void)
{
   const gchar* retval;
   GNetworkAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_get_hostname(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3584, 3584, 0);
}

static void sl_gtk_widget_queue_draw_area (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_draw_area(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3585, 3585, 0);
}

static void sl_g_file_query_default_handler_finish (void)
{
   GAppInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_default_handler_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3586, 3586, 0);
}

static void sl_gtk_widget_shape_combine_region (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_shape_combine_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3587, 3587, 0);
}

static void sl_pango_tab_array_copy (void)
{
   PangoTabArray* retval;
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_tab_array_copy(arg1);
   (void)SLang_push_opaque(PangoTabArray_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3588, 3588, 0);
}

static void sl_gtk_widget_get_screen (void)
{
   GdkScreen* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3589, 3589, 0);
}

static void sl_g_action_change_state (void)
{
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_action_change_state(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3590, 3590, 0);
}

static void sl_gtk_menu_popup_at_widget (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkGravity arg3;
   GdkGravity arg4;
   const GdkEvent* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_nullable(GdkEvent_Type, (void**)&arg5_o, (void**)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_popup_at_widget(arg1, arg2,  arg3,  arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (3591, 3591, 0);
}

static void sl_g_input_stream_set_pending (void)
{
   gboolean retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_input_stream_set_pending(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3592, 3592, 0);
}

static void sl_gtk_entry_progress_pulse (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_progress_pulse(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3593, 3593, 0);
}

static void sl_gtk_gesture_get_window (void)
{
   GdkWindow* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3594, 3594, 0);
}

static void sl_gtk_selection_data_set_uris (void)
{
   gboolean retval;
   GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_set_uris(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3595, 3595, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_flow_box_get_activate_on_single_click (void)
{
   gboolean retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_activate_on_single_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3596, 3596, 0);
}

static void sl_g_hostname_to_unicode (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hostname_to_unicode(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3597, 3597, 0);
}

static void sl_g_file_icon_new (void)
{
   GIcon* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_icon_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3598, 3598, 0);
}

static void sl_gtk_scale_get_digits (void)
{
   gint retval;
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_get_digits(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3599, 3599, 0);
}

static void sl_g_time_zone_unref (void)
{
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_time_zone_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3600, 3600, 0);
}

static void sl_gtk_color_chooser_set_rgba (void)
{
   GtkColorChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_color_chooser_set_rgba(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3601, 3601, 0);
}

static void sl_gdk_drawing_context_get_clip (void)
{
   cairo_region_t* retval;
   GdkDrawingContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drawing_context_get_clip(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3602, 3602, 0);
}

static void sl_gdk_prop_mode_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_prop_mode_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3603, 3603, 0);
}

static void sl_gtk_drag_dest_unset (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_dest_unset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3604, 3604, 0);
}

static void sl_g_main_loop_unref (void)
{
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_loop_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3605, 3605, 0);
}

static void sl_g_file_make_directory (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_make_directory(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3606, 3606, 0);
}

static void sl_gtk_window_set_titlebar (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_titlebar(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3607, 3607, 0);
}

static void sl_g_match_info_is_partial_match (void)
{
   gboolean retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_is_partial_match(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3608, 3608, 0);
}

static void sl_gdk_display_get_default_cursor_size (void)
{
   guint retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_default_cursor_size(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3609, 3609, 0);
}

static void sl_gtk_about_dialog_get_copyright (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_copyright(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3610, 3610, 0);
}

static void sl_g_resources_enumerate_children (void)
{
   char** retval;
   char* arg1;
   GResourceLookupFlags arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resources_enumerate_children(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   push_null_term_str_array (retval, "g_resources_enumerate_children", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3611, 3611, 0);
}

static void sl_gtk_widget_path_is_type (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_is_type(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3612, 3612, 0);
}

static void sl_g_usleep (void)
{
   gulong arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_usleep( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3613, 3613, 0);
}

static void sl_g_cancellable_make_pollfd (void)
{
   gboolean retval;
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPollFD* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_cancellable_make_pollfd(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3614, 3614, 0);
}

static void sl_gtk_text_buffer_add_mark (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_add_mark(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3615, 3615, 0);
}

static void sl_g_volume_monitor_get (void)
{
   GVolumeMonitor* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_volume_monitor_get();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3616, 3616, 0);
}

static void sl_gtk_tool_item_set_expand (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_expand(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3617, 3617, 0);
}

static void sl_gtk_color_chooser_get_rgba (void)
{
   GtkColorChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_chooser_get_rgba(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3618, 3618, 0);
}

static void sl_g_filename_completer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_filename_completer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3619, 3619, 0);
}

static void sl_gtk_cell_area_context_get_preferred_height_for_width (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_get_preferred_height_for_width(arg1,  arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3620, 3620, 0);
}

static void sl_g_emblem_get_origin (void)
{
   GEmblemOrigin retval;
   GEmblem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblem_get_origin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3621, 3621, 0);
}

static void sl_gtk_scrolled_window_add_with_viewport (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scrolled_window_add_with_viewport(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3622, 3622, 0);
}

static void sl_g_key_file_get_keys (void)
{
   gchar** retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   arg4 = NULL;
   retval = g_key_file_get_keys(arg1, arg2, &arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   push_null_term_str_array (retval, "g_key_file_get_keys", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3623, 3623, 0);
}

static void sl_gtk_key_snooper_remove (void)
{
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_key_snooper_remove( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3624, 3624, 0);
}

static void sl_gtk_tree_selection_select_range (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_selection_select_range(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3625, 3625, 0);
}

static void sl_gtk_scrollable_set_hadjustment (void)
{
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scrollable_set_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3626, 3626, 0);
}

static void sl_gdk_gl_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3627, 3627, 0);
}

static void sl_pango_font_family_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_family_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3628, 3628, 0);
}

static void sl_gtk_widget_set_mapped (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_mapped(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3629, 3629, 0);
}

static void sl_gtk_window_get_size (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_get_size(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3630, 3630, 0);
}

static void sl_gdk_input_source_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_input_source_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3631, 3631, 0);
}

static void sl_gtk_spin_button_get_numeric (void)
{
   gboolean retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_numeric(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3632, 3632, 0);
}

static void sl_gtk_label_get_use_underline (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_use_underline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3633, 3633, 0);
}

static void sl_gtk_main_level (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_main_level();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3634, 3634, 0);
}

static void sl_gtk_widget_get_template_child (void)
{
   GObject* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_widget_get_template_child(arg1,  arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3635, 3635, 0);
}

static void sl_g_timer_destroy (void)
{
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_timer_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3636, 3636, 0);
}

static void sl_gtk_check_menu_item_get_draw_as_radio (void)
{
   gboolean retval;
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_get_draw_as_radio(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3637, 3637, 0);
}

static void sl_gtk_text_iter_get_line (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3638, 3638, 0);
}

static void sl_gtk_file_chooser_remove_shortcut_folder_uri (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_remove_shortcut_folder_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3639, 3639, 0);
}

static void sl_g_unichar_iscntrl (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_iscntrl( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3640, 3640, 0);
}

static void sl_gdk_notify_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_notify_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3641, 3641, 0);
}

static void sl_gdk_window_get_width (void)
{
   int retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3642, 3642, 0);
}

static void sl_g_charset_converter_new (void)
{
   GCharsetConverter* retval;
   gchar* arg1;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_charset_converter_new(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3643, 3643, 0);
}

static void sl_g_get_environ (void)
{
   gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_environ();
   push_null_term_str_array (retval, "g_get_environ", 1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3644, 3644, 0);
}

static void sl_g_file_load_bytes_finish (void)
{
   GBytes* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_load_bytes_finish(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3645, 3645, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_text_buffer_delete_mark (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_delete_mark(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3646, 3646, 0);
}

static void sl_gtk_expander_get_use_markup (void)
{
   gboolean retval;
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_get_use_markup(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3647, 3647, 0);
}

static void sl_gtk_menu_button_set_popover (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_button_set_popover(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3648, 3648, 0);
}

static void sl_gdk_test_simulate_button (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   guint arg4;
   GdkModifierType arg5;
   GdkEventType arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_test_simulate_button(arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3649, 3649, 0);
}

static void sl_g_get_host_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_host_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3650, 3650, 0);
}

static void sl_gtk_style_context_get_background_color (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_background_color(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3651, 3651, 0);
}

static void sl_gtk_notebook_set_current_page (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_set_current_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3652, 3652, 0);
}

static void sl_gdk_drawing_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_drawing_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3653, 3653, 0);
}

static void sl_gtk_spin_button_get_adjustment (void)
{
   GtkAdjustment* retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_adjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3654, 3654, 0);
}

static void sl_g_checksum_update (void)
{
   GChecksum* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gssize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GChecksum_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_checksum_update(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3655, 3655, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_window_set_destroy_with_parent (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_destroy_with_parent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3656, 3656, 0);
}

static void sl_gtk_text_iter_forward_line (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3657, 3657, 0);
}

static void sl_g_input_stream_is_closed (void)
{
   gboolean retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_input_stream_is_closed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3658, 3658, 0);
}

static void sl_gtk_icon_view_new_with_area (void)
{
   GtkWidget* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_new_with_area(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3659, 3659, 0);
}

static void sl_gdk_pixbuf_get_file_info_finish (void)
{
   GdkPixbufFormat* retval;
   GAsyncResult* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = gdk_pixbuf_get_file_info_finish(arg1, &arg2, &arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3660, 3660, 0);
}

static void sl_gtk_text_iter_backward_cursor_position (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_cursor_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3661, 3661, 0);
}

static void sl_gtk_level_bar_get_value (void)
{
   gdouble retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3662, 3662, 0);
}

static void sl_g_themed_icon_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_themed_icon_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3663, 3663, 0);
}

static void sl_gtk_color_button_get_use_alpha (void)
{
   gboolean retval;
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_button_get_use_alpha(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3664, 3664, 0);
}

static void sl_gtk_paned_get_position (void)
{
   gint retval;
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3665, 3665, 0);
}

static void sl_pango_font_description_get_family (void)
{
   const char* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_family(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3666, 3666, 0);
}

static void sl_gtk_image_get_animation (void)
{
   GdkPixbufAnimation* retval;
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_get_animation(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3667, 3667, 0);
}

static void sl_gtk_color_button_get_rgba (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_button_get_rgba(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3668, 3668, 0);
}

static void sl_gtk_widget_path_iter_get_sibling_index (void)
{
   guint retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_sibling_index(arg1,  arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3669, 3669, 0);
}

static void sl_g_file_info_get_name (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3670, 3670, 0);
}

static void sl_pango_font_description_get_size (void)
{
   gint retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3671, 3671, 0);
}

static void sl_gtk_print_settings_get_resolution_y (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_resolution_y(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3672, 3672, 0);
}

static void sl_gdk_window_create_gl_context (void)
{
   GdkGLContext* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_window_create_gl_context(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3673, 3673, 0);
}

static void sl_gtk_entry_completion_get_minimum_key_length (void)
{
   gint retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_minimum_key_length(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3674, 3674, 0);
}

static void sl_gdk_screen_get_monitor_plug_name (void)
{
   gchar* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_plug_name(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3675, 3675, 0);
}

static void sl_gdk_event_get_time (void)
{
   guint32 retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_time(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3676, 3676, 0);
}

static void sl_g_date_is_last_of_month (void)
{
   gboolean retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_is_last_of_month(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3677, 3677, 0);
}

static void sl_g_bookmark_file_to_file (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_to_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3678, 3678, 0);
}

static void sl_gtk_scale_button_set_value (void)
{
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_button_set_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3679, 3679, 0);
}

static void sl_gtk_icon_theme_lookup_by_gicon (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   GtkIconLookupFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_lookup_by_gicon(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3680, 3680, 0);
}

static void sl_g_menu_freeze (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_menu_freeze(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3681, 3681, 0);
}

static void sl_gdk_drag_context_get_selected_action (void)
{
   GdkDragAction retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_selected_action(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3682, 3682, 0);
}

static void sl_gdk_event_triggers_context_menu (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_triggers_context_menu(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3683, 3683, 0);
}

static void sl_gtk_menu_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3684, 3684, 0);
}

static void sl_gtk_print_operation_set_unit (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_unit(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3685, 3685, 0);
}

static void sl_pango_attr_font_features_new (void)
{
   PangoAttribute* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_font_features_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3686, 3686, 0);
}

static void sl_pango_layout_get_line_spacing (void)
{
   float retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_line_spacing(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3687, 3687, 0);
}

static void sl_gdk_visual_get_visual_type (void)
{
   GdkVisualType retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_visual_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3688, 3688, 0);
}

static void sl_pango_font_map_create_context (void)
{
   PangoContext* retval;
   PangoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_map_create_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3689, 3689, 0);
}

static void sl_gtk_page_setup_unix_dialog_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_page_setup_unix_dialog_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3690, 3690, 0);
}

static void sl_g_drive_get_volumes (void)
{
   GList* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_volumes(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3691, 3691, 0);
}

static void sl_gtk_tree_view_column_get_reorderable (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_reorderable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3692, 3692, 0);
}

static void sl_gdk_window_is_shaped (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_is_shaped(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3693, 3693, 0);
}

static void sl_gtk_window_get_focus_on_map (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_focus_on_map(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3694, 3694, 0);
}

static void sl_gtk_stack_get_visible_child_name (void)
{
   const gchar* retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_visible_child_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3695, 3695, 0);
}

static void sl_g_unicode_canonical_decomposition (void)
{
   gunichar* retval;
   gunichar arg1;
   gsize* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_ULONG_TYPE,sizeof(gsize),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unicode_canonical_decomposition( arg1, arg2);
   (void)SLang_push_opaque(uint_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3696, 3696, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_assistant_append_page (void)
{
   gint retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_append_page(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3697, 3697, 0);
}

static void sl_gtk_widget_set_margin_bottom (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_bottom(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3698, 3698, 0);
}

static void sl_gdk_pixbuf_format_is_disabled (void)
{
   gboolean retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_is_disabled(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3699, 3699, 0);
}

static void sl_gtk_tool_item_set_is_important (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_set_is_important(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3700, 3700, 0);
}

static void sl_gtk_list_store_insert_after (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   gtk_list_store_insert_after(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3701, 3701, 0);
}

static void sl_g_str_has_suffix (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_str_has_suffix(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3702, 3702, 0);
}

static void sl_gtk_widget_get_parent_window (void)
{
   GdkWindow* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_parent_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3703, 3703, 0);
}

static void sl_pango_font_description_get_style (void)
{
   PangoStyle retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3704, 3704, 0);
}

static void sl_g_inet_address_get_is_mc_link_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_mc_link_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3705, 3705, 0);
}

static void sl_gtk_label_select_region (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_select_region(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3706, 3706, 0);
}

static void sl_g_date_copy (void)
{
   GDate* retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_copy(arg1);
   (void)SLang_push_opaque(GDate_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3707, 3707, 0);
}

static void sl_g_object_steal_data (void)
{
   gpointer retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_object_steal_data(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3708, 3708, 0);
}

static void sl_gdk_window_type_hint_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_type_hint_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3709, 3709, 0);
}

static void sl_gtk_color_chooser_widget_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_chooser_widget_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3710, 3710, 0);
}

static void sl_gtk_font_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3711, 3711, 0);
}

static void sl_g_file_info_has_attribute (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_has_attribute(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3712, 3712, 0);
}

static void sl_gtk_widget_get_action_group (void)
{
   GActionGroup* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_get_action_group(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3713, 3713, 0);
}

static void sl_gtk_page_setup_get_right_margin (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_right_margin(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3714, 3714, 0);
}

static void sl_gdk_device_manager_get_display (void)
{
   GdkDisplay* retval;
   GdkDeviceManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_manager_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3715, 3715, 0);
}

static void sl_gtk_widget_queue_allocate (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_allocate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3716, 3716, 0);
}

static void sl_gdk_filter_return_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_filter_return_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3717, 3717, 0);
}

static void sl_gtk_print_operation_get_has_selection (void)
{
   gboolean retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_has_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3718, 3718, 0);
}

static void sl_gtk_widget_get_style_context (void)
{
   GtkStyleContext* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_style_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3719, 3719, 0);
}

static void sl_gtk_style_context_save (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_save(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3720, 3720, 0);
}

static void sl_gtk_text_iter_has_tag (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_has_tag(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3721, 3721, 0);
}

static void sl_gtk_font_chooser_get_preview_text (void)
{
   gchar* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_preview_text(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3722, 3722, 0);
}

static void sl_g_date_add_days (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_add_days(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3723, 3723, 0);
}

static void sl_g_network_service_get_domain (void)
{
   const gchar* retval;
   GNetworkService* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_service_get_domain(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3724, 3724, 0);
}

static void sl_gtk_widget_get_scale_factor (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_scale_factor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3725, 3725, 0);
}

static void sl_g_variant_get_data_as_bytes (void)
{
   GBytes* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_data_as_bytes(arg1);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3726, 3726, 0);
}

static void sl_gtk_text_view_get_input_hints (void)
{
   GtkInputHints retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_input_hints(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3727, 3727, 0);
}

static void sl_gdk_gl_context_get_shared_context (void)
{
   GdkGLContext* retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_get_shared_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3728, 3728, 0);
}

static void sl_g_quark_try_string (void)
{
   GQuark retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_quark_try_string(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3729, 3729, 0);
}

static void sl_gtk_text_iter_inside_word (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_inside_word(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3730, 3730, 0);
}

static void sl_gtk_about_dialog_get_license (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_license(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3731, 3731, 0);
}

static void sl_gdk_device_get_product_id (void)
{
   const gchar* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_product_id(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3732, 3732, 0);
}

static void sl_g_inet_socket_address_get_scope_id (void)
{
   guint32 retval;
   GInetSocketAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_get_scope_id(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3733, 3733, 0);
}

static void sl_gtk_tool_button_new_from_stock (void)
{
   GtkToolItem* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_new_from_stock(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3734, 3734, 0);
}

static void sl_gtk_tool_palette_get_drop_group (void)
{
   GtkToolItemGroup* retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_drop_group(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3735, 3735, 0);
}

static void sl_g_hmac_get_string (void)
{
   const gchar* retval;
   GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_hmac_get_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3736, 3736, 0);
}

static void sl_g_io_channel_set_encoding (void)
{
   GIOStatus retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_io_channel_set_encoding(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3737, 3737, 0);
}

static void sl_gtk_targets_include_text (void)
{
   gboolean retval;
   GdkAtom* arg1;
   Slirp_Ref *arg1_r = ref_new(GObject_Type,sizeof(GdkAtom),&arg1,0x0);
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_targets_include_text(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3738, 3738, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_mount_get_volume (void)
{
   GVolume* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_volume(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3739, 3739, 0);
}

static void sl_gtk_accel_group_unlock (void)
{
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_accel_group_unlock(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3740, 3740, 0);
}

static void sl_g_file_monitor (void)
{
   GFileMonitor* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileMonitorFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_monitor(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3741, 3741, 0);
}

static void sl_gtk_widget_is_toplevel (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_is_toplevel(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3742, 3742, 0);
}

static void sl_g_variant_dup_bytestring_array (void)
{
   gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_dup_bytestring_array(arg1, &arg2);
   push_null_term_str_array (retval, "g_variant_dup_bytestring_array", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3743, 3743, 0);
}

static void sl_gtk_icon_theme_prepend_search_path (void)
{
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_theme_prepend_search_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3744, 3744, 0);
}

static void sl_gtk_widget_get_parent (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_parent(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3745, 3745, 0);
}

static void sl_gtk_print_settings_set_number_up (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_number_up(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3746, 3746, 0);
}

static void sl_gdk_cairo_set_source_pixbuf (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_set_source_pixbuf(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3747, 3747, 0);
}

static void sl_gtk_window_get_window_type (void)
{
   GtkWindowType retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_window_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3748, 3748, 0);
}

static void sl_gdk_window_set_events (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventMask arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_events(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3749, 3749, 0);
}

static void sl_gtk_container_get_children (void)
{
   GList* retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_children(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3750, 3750, 0);
}

static void sl_gdk_device_get_position (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen** arg2;
   Slirp_Ref *arg2_r = ref_new(GObject_Type,sizeof(GdkScreen*),&arg2,0x0);
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_device_get_position(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3751, 3751, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_menu_shell_get_take_focus (void)
{
   gboolean retval;
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_shell_get_take_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3752, 3752, 0);
}

static void sl_gdk_window_set_skip_taskbar_hint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_skip_taskbar_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3753, 3753, 0);
}

static void sl_gtk_entry_get_completion (void)
{
   GtkEntryCompletion* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_completion(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3754, 3754, 0);
}

static void sl_g_timer_start (void)
{
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_timer_start(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3755, 3755, 0);
}

static void sl_g_file_load_contents_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   gsize arg4;
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   arg6 = NULL;
   retval = g_file_load_contents_finish(arg1, arg2, arg3, &arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3756, 3756, 0);
   finalize_refs(2,arg3_r,arg5_r); 
}

static void sl_gtk_about_dialog_set_copyright (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_copyright(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3757, 3757, 0);
}

static void sl_g_date_order (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDate* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_date_order(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3758, 3758, 0);
}

static void sl_gtk_range_get_range_rect (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_get_range_rect(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3759, 3759, 0);
}

static void sl_gtk_tool_item_get_relief_style (void)
{
   GtkReliefStyle retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_relief_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3760, 3760, 0);
}

static void sl_gtk_icon_view_set_pixbuf_column (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_pixbuf_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3761, 3761, 0);
}

static void sl_pango_ft2_font_map_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_ft2_font_map_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3762, 3762, 0);
}

static void sl_gtk_text_iter_starts_sentence (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_starts_sentence(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3763, 3763, 0);
}

static void sl_gtk_text_iter_backward_visible_line (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3764, 3764, 0);
}

static void sl_gtk_print_operation_get_print_settings (void)
{
   GtkPrintSettings* retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_print_settings(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3765, 3765, 0);
}

static void sl_gtk_text_buffer_insert_interactive (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_insert_interactive(arg1, arg2, arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3766, 3766, 0);
}

static void sl_gtk_recent_chooser_set_show_icons (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_show_icons(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3767, 3767, 0);
}

static void sl_gtk_text_view_get_wrap_mode (void)
{
   GtkWrapMode retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_wrap_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3768, 3768, 0);
}

static void sl_gdk_screen_get_width_mm (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_width_mm(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3769, 3769, 0);
}

static void sl_gtk_paper_size_get_width (void)
{
   gdouble retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_width(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3770, 3770, 0);
}

static void sl_gdk_device_manager_get_client_pointer (void)
{
   GdkDevice* retval;
   GdkDeviceManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_manager_get_client_pointer(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3771, 3771, 0);
}

static void sl_pango_attr_background_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   guint16 arg2;
   guint16 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_background_new( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3772, 3772, 0);
}

static void sl_gtk_menu_shell_cancel (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_shell_cancel(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3773, 3773, 0);
}

static void sl_gtk_main (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gtk_main();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3774, 3774, 0);
}

static void sl_gtk_pad_controller_set_action (void)
{
   GtkPadController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPadActionType arg2;
   gint arg3;
   gint arg4;
   gchar* arg5;
   gchar* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg6)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_5;
   issue_usage = 0;

   gtk_pad_controller_set_action(arg1,  arg2,  arg3,  arg4, arg5, arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_5:
   SLang_free_slstring(arg5);
free_and_return_6:
   SLang_free_slstring(arg6);
usage_label:
   if (issue_usage) Slirp_usage (3775, 3775, 0);
}

static void sl_gtk_stack_switcher_get_stack (void)
{
   GtkStack* retval;
   GtkStackSwitcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_switcher_get_stack(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3776, 3776, 0);
}

static void sl_gtk_widget_init_template (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_init_template(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3777, 3777, 0);
}

static void sl_gtk_menu_bar_set_pack_direction (void)
{
   GtkMenuBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPackDirection arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_bar_set_pack_direction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3778, 3778, 0);
}

static void sl_gtk_level_bar_get_inverted (void)
{
   gboolean retval;
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_inverted(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3779, 3779, 0);
}

static void sl_gtk_style_context_add_provider (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleProvider* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_add_provider(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3780, 3780, 0);
}

static void sl_gtk_window_get_default_icon_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_default_icon_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3781, 3781, 0);
}

static void sl_gdk_drag_drop (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drag_drop(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3782, 3782, 0);
}

static void sl_gtk_recent_chooser_get_filter (void)
{
   GtkRecentFilter* retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_filter(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3783, 3783, 0);
}

static void sl_gtk_entry_buffer_get_length (void)
{
   guint retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_get_length(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3784, 3784, 0);
}

static void sl_pango_font_describe_with_absolute_size (void)
{
   PangoFontDescription* retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_describe_with_absolute_size(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3785, 3785, 0);
}

static void sl_gtk_text_view_set_buffer (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextBuffer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_set_buffer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3786, 3786, 0);
}

static void sl_gtk_text_buffer_get_text (void)
{
   gchar* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_get_text(arg1, arg2, arg3,  arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3787, 3787, 0);
}

static void sl_g_drive_has_volumes (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_has_volumes(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3788, 3788, 0);
}

static void sl_g_utf8_find_prev_char (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_utf8_find_prev_char(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3789, 3789, 0);
}

static void sl_gtk_widget_set_hexpand_set (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_hexpand_set(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3790, 3790, 0);
}

static void sl_gtk_window_set_hide_titlebar_when_maximized (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_hide_titlebar_when_maximized(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3791, 3791, 0);
}

static void sl_gtk_text_child_anchor_get_deleted (void)
{
   gboolean retval;
   GtkTextChildAnchor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_child_anchor_get_deleted(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3792, 3792, 0);
}

static void sl_g_unichar_get_script (void)
{
   GUnicodeScript retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_get_script( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3793, 3793, 0);
}

static void sl_gtk_tree_view_get_headers_visible (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_headers_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3794, 3794, 0);
}

static void sl_gtk_grid_remove_row (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_remove_row(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3795, 3795, 0);
}

static void sl_gtk_text_buffer_get_iter_at_offset (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_buffer_get_iter_at_offset(arg1, arg2,  arg3);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3796, 3796, 0);
}

static void sl_gtk_tool_item_set_tooltip_markup (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_item_set_tooltip_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3797, 3797, 0);
}

static void sl_gtk_widget_has_grab (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_has_grab(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3798, 3798, 0);
}

static void sl_gtk_text_buffer_unregister_serialize_format (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_unregister_serialize_format(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3799, 3799, 0);
}

static void sl_gtk_recent_chooser_add_filter (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRecentFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_chooser_add_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3800, 3800, 0);
}

static void sl_gtk_about_dialog_get_documenters (void)
{
   const gchar** retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_documenters(arg1);
   push_null_term_str_array ((char **) retval, "gtk_about_dialog_get_documenters", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3801, 3801, 0);
}

static void sl_gtk_container_remove (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3802, 3802, 0);
}

static void sl_gtk_toggle_tool_button_new (void)
{
   GtkToolItem* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_tool_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3803, 3803, 0);
}

static void sl_gtk_widget_remove_accelerator (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAccelGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   guint arg3;
   GdkModifierType arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_remove_accelerator(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3804, 3804, 0);
}

static void sl_gtk_cell_layout_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_layout_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3805, 3805, 0);
}

static void sl_gdk_pixbuf_simple_anim_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_simple_anim_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3806, 3806, 0);
}

static void sl_gtk_tool_item_group_get_header_relief (void)
{
   GtkReliefStyle retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_header_relief(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3807, 3807, 0);
}

static void sl_g_get_prgname (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_prgname();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3808, 3808, 0);
}

static void sl_gtk_flow_box_child_changed (void)
{
   GtkFlowBoxChild* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_child_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3809, 3809, 0);
}

static void sl_gdk_pixbuf_new_subpixbuf (void)
{
   GdkPixbuf* retval;
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_new_subpixbuf(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3810, 3810, 0);
}

static void sl_gdk_window_show (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_show(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3811, 3811, 0);
}

static void sl_g_notification_set_priority (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GNotificationPriority arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_notification_set_priority(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3812, 3812, 0);
}

static void sl_g_binding_get_source (void)
{
   GObject* retval;
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_source(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3813, 3813, 0);
}

static void sl_gtk_invisible_get_screen (void)
{
   GdkScreen* retval;
   GtkInvisible* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_invisible_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3814, 3814, 0);
}

static void sl_gtk_tooltip_set_custom (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_custom(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3815, 3815, 0);
}

static void sl_gtk_tree_view_column_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3816, 3816, 0);
}

static void sl_g_date_valid (void)
{
   gboolean retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3817, 3817, 0);
}

static void sl_gdk_pre_parse_libgtk_only (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_pre_parse_libgtk_only();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3818, 3818, 0);
}

static void sl_g_key_file_get_groups (void)
{
   gchar** retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_key_file_get_groups(arg1, &arg2);
   push_null_term_str_array (retval, "g_key_file_get_groups", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3819, 3819, 0);
}

static void sl_gdk_event_get_scroll_deltas (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_scroll_deltas(arg1, &arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg2);
   else
      (void) SLang_push_null ();
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3820, 3820, 0);
}

static void sl_g_drive_has_media (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_has_media(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3821, 3821, 0);
}

static void sl_gtk_editable_get_position (void)
{
   gint retval;
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_editable_get_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3822, 3822, 0);
}

static void sl_g_file_info_dup (void)
{
   GFileInfo* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_dup(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3823, 3823, 0);
}

static void sl_g_timeout_source_new_seconds (void)
{
   GSource* retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_timeout_source_new_seconds( arg1);
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3824, 3824, 0);
}

static void sl_gtk_tool_palette_get_group_position (void)
{
   gint retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_palette_get_group_position(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3825, 3825, 0);
}

static void sl_pango_font_description_copy (void)
{
   PangoFontDescription* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_copy(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3826, 3826, 0);
}

static void sl_g_utf8_validate_len (void)
{
   gboolean retval;
   gchar* arg1;
   gsize arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_validate_len(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3827, 3827, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_text_iter_forward_lines (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_lines(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3828, 3828, 0);
}

static void sl_gtk_scrolled_window_get_overlay_scrolling (void)
{
   gboolean retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_overlay_scrolling(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3829, 3829, 0);
}

static void sl_g_bookmark_file_load_from_file (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_load_from_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3830, 3830, 0);
}

static void sl_gtk_about_dialog_get_comments (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_comments(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3831, 3831, 0);
}

static void sl_g_file_replace_contents (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gsize arg3;
   char* arg4;
   gboolean arg5;
   GFileCreateFlags arg6;
   char** arg7;
   Slirp_Ref *arg7_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg7,0x0);
   GCancellable* arg8;
   Slirp_Opaque* arg8_o = NULL;
   GError* arg9;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg8, &arg8_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg7_r, 0x0, 0)) goto free_and_return_8;
   if (-1 == SLang_pop_int((int*)&arg6)) goto free_and_return_8;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_8;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_8;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg9 = NULL;
   retval = g_file_replace_contents(arg1, arg2,  arg3, arg4,  arg5,  arg6, arg7, arg8, &arg9);
   if (arg9 != NULL)
     throw_gerror(arg9);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_8:
   SLang_free_opaque(arg8_o);
usage_label:
   if (issue_usage) Slirp_usage (3832, 3832, 0);
   finalize_refs(1,arg7_r); 
}

static void sl_gdk_error_trap_pop_ignored (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_error_trap_pop_ignored();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3833, 3833, 0);
}

static void sl_gtk_tree_model_iter_n_children (void)
{
   gint retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_n_children(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3834, 3834, 0);
}

static void sl_gtk_action_bar_get_center_widget (void)
{
   GtkWidget* retval;
   GtkActionBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_action_bar_get_center_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3835, 3835, 0);
}

static void sl_g_date_subtract_months (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_subtract_months(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3836, 3836, 0);
}

static void sl_gtk_file_filter_add_mime_type (void)
{
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_filter_add_mime_type(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3837, 3837, 0);
}

static void sl_gtk_stack_get_homogeneous (void)
{
   gboolean retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_get_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3838, 3838, 0);
}

static void sl_gdk_pixbuf_read_pixels (void)
{
   const guint8* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_read_pixels(arg1);
   (void)SLang_push_opaque(uchar_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3839, 3839, 0);
}

static void sl_gtk_widget_unset_state_flags (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_unset_state_flags(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3840, 3840, 0);
}

static void sl_gtk_range_get_inverted (void)
{
   gboolean retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_inverted(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3841, 3841, 0);
}

static void sl_gdk_selection_owner_get (void)
{
   GdkWindow* retval;
   GdkAtom arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_selection_owner_get(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3842, 3842, 0);
}

static void sl_gdk_pixbuf_simple_anim_get_loop (void)
{
   gboolean retval;
   GdkPixbufSimpleAnim* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_simple_anim_get_loop(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3843, 3843, 0);
}

static void sl_g_simple_action_set_enabled (void)
{
   GSimpleAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_simple_action_set_enabled(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3844, 3844, 0);
}

static void sl_g_bookmark_file_get_is_private (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_is_private(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3845, 3845, 0);
}

static void sl_gdk_window_get_device_position (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   GdkModifierType arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_window_get_device_position(arg1, arg2, &arg3, &arg4, &arg5);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3846, 3846, 0);
}

static void sl_gtk_tree_model_filter_convert_path_to_child_path (void)
{
   GtkTreePath* retval;
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_filter_convert_path_to_child_path(arg1, arg2);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3847, 3847, 0);
}

static void sl_gtk_file_filter_set_name (void)
{
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_filter_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3848, 3848, 0);
}

static void sl_g_settings_reset (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_reset(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3849, 3849, 0);
}

static void sl_g_key_file_load_from_file (void)
{
   gboolean retval;
   GKeyFile* arg1;
   gchar* arg2;
   GKeyFileFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   issue_usage = 0;

   arg1 = g_key_file_new ();
   arg4 = NULL;
   retval = g_key_file_load_from_file(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   if (retval == TRUE)
      (void) SLang_push_opaque (GKeyFile_Type, (void*) retval, 0);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3850, 3850, 0);
}

static void sl_gtk_info_bar_set_show_close_button (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_set_show_close_button(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3851, 3851, 0);
}

static void sl_g_drive_is_media_check_automatic (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_is_media_check_automatic(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3852, 3852, 0);
}

static void sl_gtk_menu_button_set_menu_model (void)
{
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_button_set_menu_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3853, 3853, 0);
}

static void sl_gtk_entry_get_visibility (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_visibility(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3854, 3854, 0);
}

static void sl_gtk_widget_get_state (void)
{
   GtkStateType retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3855, 3855, 0);
}

static void sl_gtk_adjustment_get_upper (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_upper(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3856, 3856, 0);
}

static void sl_gdk_offscreen_window_get_surface (void)
{
   cairo_surface_t* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_offscreen_window_get_surface(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3857, 3857, 0);
}

static void sl_g_io_channel_set_buffered (void)
{
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_io_channel_set_buffered(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3858, 3858, 0);
}

static void sl_gtk_recent_filter_add_age (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_filter_add_age(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3859, 3859, 0);
}

static void sl_gdk_monitor_get_subpixel_layout (void)
{
   GdkSubpixelLayout retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_subpixel_layout(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3860, 3860, 0);
}

static void sl_g_file_get_contents (void)
{
   gboolean retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   arg4 = NULL;
   retval = g_file_get_contents(arg1, arg2, &arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3861, 3861, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_window_add_accel_group (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAccelGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_add_accel_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3862, 3862, 0);
}

static void sl_gtk_revealer_get_child_revealed (void)
{
   gboolean retval;
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_get_child_revealed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3863, 3863, 0);
}

static void sl_gtk_button_box_get_child_non_homogeneous (void)
{
   gboolean retval;
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_button_box_get_child_non_homogeneous(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3864, 3864, 0);
}

static void sl_gtk_notebook_get_tab_pos (void)
{
   GtkPositionType retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_pos(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3865, 3865, 0);
}

static void sl_g_drive_eject_with_operation_finish (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_drive_eject_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3866, 3866, 0);
}

static void sl_gtk_color_chooser_set_use_alpha (void)
{
   GtkColorChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_chooser_set_use_alpha(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3867, 3867, 0);
}

static void sl_g_socket_connect (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSocketAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_socket_connect(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3868, 3868, 0);
}

static void sl_g_variant_new_int16 (void)
{
   GVariant* retval;
   gint16 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_short((short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_int16( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3869, 3869, 0);
}

static void sl_gtk_css_provider_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_provider_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3870, 3870, 0);
}

static void sl_pango_renderer_set_color (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   PangoColor* arg3 = (PangoColor*) alloca(sizeof(PangoColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, PangoColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   pango_renderer_set_color(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, PangoColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3871, 3871, 0);
}

static void sl_g_menu_prepend_item (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_prepend_item(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3872, 3872, 0);
}

static void sl_g_date_get_weekday (void)
{
   GDateWeekday retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_weekday(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3873, 3873, 0);
}

static void sl_gtk_window_set_default (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_default(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3874, 3874, 0);
}

static void sl_g_key_file_get_uint64 (void)
{
   guint64 retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_uint64(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3875, 3875, 0);
}

static void sl_g_param_spec_ref_sink (void)
{
   GParamSpec* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_ref_sink(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3876, 3876, 0);
}

static void sl_pango_bidi_type_for_unichar (void)
{
   PangoBidiType retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_bidi_type_for_unichar( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3877, 3877, 0);
}

static void sl_gtk_icon_info_copy (void)
{
   GtkIconInfo* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_copy(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3878, 3878, 0);
}

static void sl_gtk_builder_add_objects_from_string (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   gchar** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg4,0x0);
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = gtk_builder_add_objects_from_string(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3879, 3879, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_recent_chooser_get_show_not_found (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_show_not_found(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3880, 3880, 0);
}

static void sl_gtk_radio_button_new (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_button_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3881, 3881, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_text_view_get_right_margin (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_right_margin(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3882, 3882, 0);
}

static void sl_gdk_display_put_event (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_display_put_event(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3883, 3883, 0);
}

static void sl_gtk_progress_bar_set_pulse_step (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_set_pulse_step(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3884, 3884, 0);
}

static void sl_g_value_fits_pointer (void)
{
   gboolean retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_fits_pointer(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3885, 3885, 0);
}

static void sl_gtk_range_get_adjustment (void)
{
   GtkAdjustment* retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_adjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3886, 3886, 0);
}

static void sl_gtk_print_operation_get_status_string (void)
{
   const gchar* retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_status_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3887, 3887, 0);
}

static void sl_gdk_rgba_to_string (void)
{
   gchar* retval;
   GdkRGBA* arg1 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GdkRGBA_Layout)) goto usage_label;
   issue_usage = 0;

   retval = gdk_rgba_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (3888, 3888, 0);
}

static void sl_gtk_hsv_to_rgb (void)
{
   gdouble arg1;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_hsv_to_rgb( arg1,  arg2,  arg3, &arg4, &arg5, &arg6);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   (void)SLang_push_double(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3889, 3889, 0);
}

static void sl_gtk_widget_hide_on_delete (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_hide_on_delete(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3890, 3890, 0);
}

static void sl_gtk_window_unfullscreen (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_unfullscreen(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3891, 3891, 0);
}

static void sl_g_file_info_get_symlink_target (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_symlink_target(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3892, 3892, 0);
}

static void sl_g_ascii_string_to_unsigned (void)
{
   gboolean retval;
   gchar* arg1;
   guint arg2;
   guint64 arg3;
   guint64 arg4;
   guint64 arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_ascii_string_to_unsigned(arg1,  arg2,  arg3,  arg4, &arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   (void)SLang_push_ulong(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3893, 3893, 0);
}

static void sl_g_regex_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_regex_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3894, 3894, 0);
}

static void sl_g_mount_operation_set_domain (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_mount_operation_set_domain(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3895, 3895, 0);
}

static void sl_g_unichar_isdigit (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isdigit( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3896, 3896, 0);
}

static void sl_gtk_file_chooser_select_uri (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_select_uri(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3897, 3897, 0);
}

static void sl_g_io_channel_get_buffer_condition (void)
{
   GIOCondition retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_get_buffer_condition(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3898, 3898, 0);
}

static void sl_g_variant_builder_add_value (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_variant_builder_add_value(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3899, 3899, 0);
}

static void sl_gtk_recent_manager_has_item (void)
{
   gboolean retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_manager_has_item(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3900, 3900, 0);
}

static void sl_g_source_remove_child_source (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSource* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_source_remove_child_source(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3901, 3901, 0);
}

static void sl_gtk_print_job_set_reverse (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_reverse(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3902, 3902, 0);
}

static void sl_gtk_text_view_get_iter_at_position (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   retval = gtk_text_view_get_iter_at_position(arg1, arg2, &arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   (void) SLang_push_opaque (GtkTextIter_Type, arg2, 1);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3903, 3903, 0);
}

static void sl_gtk_print_settings_set_number_up_layout (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkNumberUpLayout arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_number_up_layout(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3904, 3904, 0);
}

static void sl_gtk_list_box_row_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3905, 3905, 0);
}

static void sl_gtk_grid_set_column_homogeneous (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_column_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3906, 3906, 0);
}

static void sl_g_file_info_set_is_symlink (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_set_is_symlink(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3907, 3907, 0);
}

static void sl_gtk_event_controller_reset (void)
{
   GtkEventController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_event_controller_reset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3908, 3908, 0);
}

static void sl_gtk_print_operation_set_embed_page_setup (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_embed_page_setup(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3909, 3909, 0);
}

static void sl_gtk_application_get_app_menu (void)
{
   GMenuModel* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_get_app_menu(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3910, 3910, 0);
}

static void sl_g_bookmark_file_has_item (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_bookmark_file_has_item(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3911, 3911, 0);
}

static void sl_gtk_cell_renderer_get_preferred_width (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_preferred_width(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3912, 3912, 0);
}

static void sl_gtk_message_dialog_format_secondary_text (void)
{
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_message_dialog_format_secondary_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3913, 3913, 0);
}

static void sl_gtk_places_sidebar_get_show_desktop (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_desktop(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3914, 3914, 0);
}

static void sl_gtk_cell_renderer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3915, 3915, 0);
}

static void sl_gdk_screen_get_monitor_workarea (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_screen_get_monitor_workarea(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3916, 3916, 0);
}

static void sl_g_notification_add_button_with_target_value (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GVariant* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_add_button_with_target_value(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (3917, 3917, 0);
}

static void sl_gtk_frame_set_label_align (void)
{
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_frame_set_label_align(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3918, 3918, 0);
}

static void sl_gtk_page_setup_set_paper_size_and_default_margins (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPaperSize* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_page_setup_set_paper_size_and_default_margins(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3919, 3919, 0);
}

static void sl_g_settings_new_with_backend (void)
{
   GSettings* retval;
   gchar* arg1;
   GSettingsBackend* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_new_with_backend(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3920, 3920, 0);
}

static void sl_gtk_box_set_baseline_position (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBaselinePosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_box_set_baseline_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3921, 3921, 0);
}

static void sl_gtk_range_set_adjustment (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_range_set_adjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3922, 3922, 0);
}

static void sl_gtk_print_operation_run (void)
{
   GtkPrintOperationResult retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintOperationAction arg2;
   GtkWindow* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_print_operation_run(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3923, 3923, 0);
}

static void sl_g_dgettext (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_dgettext(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3924, 3924, 0);
}

static void sl_gtk_text_buffer_get_copy_target_list (void)
{
   GtkTargetList* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_copy_target_list(arg1);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3925, 3925, 0);
}

static void sl_g_file_get_uri_scheme (void)
{
   char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_uri_scheme(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3926, 3926, 0);
}

static void sl_gtk_cell_area_attribute_connect (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_attribute_connect(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3927, 3927, 0);
}

static void sl_gtk_tree_model_filter_new (void)
{
   GtkTreeModel* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreePath_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_filter_new(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3928, 3928, 0);
}

static void sl_gtk_list_box_row_set_header (void)
{
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_row_set_header(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3929, 3929, 0);
}

static void sl_gtk_list_box_row_get_selectable (void)
{
   gboolean retval;
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_row_get_selectable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3930, 3930, 0);
}

static void sl_gtk_fixed_move (void)
{
   GtkFixed* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_fixed_move(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3931, 3931, 0);
}

static void sl_gdk_window_edge_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_edge_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3932, 3932, 0);
}

static void sl_gtk_icon_view_get_markup_column (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_markup_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3933, 3933, 0);
}

static void sl_gtk_image_get_icon_set (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSet** arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GtkIconSet*),&arg2,0x0);
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_get_icon_set(arg1, arg2, &arg3);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3934, 3934, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_entry_completion_get_inline_completion (void)
{
   gboolean retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_inline_completion(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3935, 3935, 0);
}

static void sl_gtk_print_job_get_pages (void)
{
   GtkPrintPages retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_pages(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3936, 3936, 0);
}

static void sl_gtk_tree_row_reference_new (void)
{
   GtkTreeRowReference* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_row_reference_new(arg1, arg2);
   (void)SLang_push_opaque(GtkTreeRowReference_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3937, 3937, 0);
}

static void sl_g_simple_action_new (void)
{
   GSimpleAction* retval;
   gchar* arg1;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GVariantType_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_simple_action_new(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3938, 3938, 0);
}

static void sl_gdk_display_pointer_is_grabbed (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_pointer_is_grabbed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3939, 3939, 0);
}

static void sl_gtk_spin_button_get_update_policy (void)
{
   GtkSpinButtonUpdatePolicy retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_update_policy(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3940, 3940, 0);
}

static void sl_gtk_range_set_lower_stepper_sensitivity (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSensitivityType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_lower_stepper_sensitivity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3941, 3941, 0);
}

static void sl_g_resource_lookup_data (void)
{
   GBytes* retval;
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GResourceLookupFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_resource_lookup_data(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3942, 3942, 0);
}

static void sl_gtk_cell_area_context_get_allocation (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_get_allocation(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3943, 3943, 0);
}

static void sl_gtk_notebook_get_menu_label_text (void)
{
   const gchar* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_menu_label_text(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3944, 3944, 0);
}

static void sl_g_key_file_set_string_list (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   const gchar** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg4,0x0);
   gsize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = (gsize) ref_get_size(arg4_r, 0);
   g_key_file_set_string_list(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3945, 3945, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_recent_chooser_menu_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_menu_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3946, 3946, 0);
}

static void sl_g_file_info_set_attribute_object (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GObject* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_object(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (3947, 3947, 0);
}

static void sl_gtk_stack_switcher_set_stack (void)
{
   GtkStackSwitcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStack* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_switcher_set_stack(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3948, 3948, 0);
}

static void sl_gtk_text_view_set_pixels_above_lines (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_pixels_above_lines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3949, 3949, 0);
}

static void sl_g_listenv (void)
{
   gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_listenv();
   push_null_term_str_array (retval, "g_listenv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3950, 3950, 0);
}

static void sl_g_variant_dup_strv (void)
{
   gchar** retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_dup_strv(arg1, &arg2);
   push_null_term_str_array (retval, "g_variant_dup_strv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3951, 3951, 0);
}

static void sl_gtk_print_capabilities_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_capabilities_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3952, 3952, 0);
}

static void sl_g_io_channel_set_flags (void)
{
   GIOStatus retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOFlags arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_io_channel_set_flags(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3953, 3953, 0);
}

static void sl_gdk_modifier_intent_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_modifier_intent_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3954, 3954, 0);
}

static void sl_g_socket_set_option (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_set_option(arg1,  arg2,  arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3955, 3955, 0);
}

static void sl_g_menu_new (void)
{
   GMenu* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3956, 3956, 0);
}

static void sl_gdk_drag_context_get_suggested_action (void)
{
   GdkDragAction retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_suggested_action(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3957, 3957, 0);
}

static void sl_g_file_monitor_cancel (void)
{
   gboolean retval;
   GFileMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_monitor_cancel(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3958, 3958, 0);
}

static void sl_gtk_file_chooser_set_action (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFileChooserAction arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_action(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3959, 3959, 0);
}

static void sl_gtk_widget_path_iter_clear_regions (void)
{
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_path_iter_clear_regions(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3960, 3960, 0);
}

static void sl_g_regex_split (void)
{
   gchar** retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GRegexMatchFlags arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_split(arg1, arg2,  arg3);
   push_null_term_str_array (retval, "g_regex_split", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3961, 3961, 0);
}

static void sl_gtk_print_context_get_hard_margins (void)
{
   gboolean retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_hard_margins(arg1, &arg2, &arg3, &arg4, &arg5);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3962, 3962, 0);
}

static void sl_g_value_transform (void)
{
   gboolean retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_value_transform(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3963, 3963, 0);
}

static void sl_gdk_gl_context_is_legacy (void)
{
   gboolean retval;
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_gl_context_is_legacy(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3964, 3964, 0);
}

static void sl_gtk_tree_view_column_get_x_offset (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_x_offset(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3965, 3965, 0);
}

static void sl_gtk_tooltip_set_icon_from_gicon (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_icon_from_gicon(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3966, 3966, 0);
}

static void sl_gdk_keymap_map_virtual_modifiers (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierType* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(GdkModifierType),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_map_virtual_modifiers(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3967, 3967, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_switch_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_switch_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3968, 3968, 0);
}

static void sl_g_key_file_get_comment (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg3, NULL)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_comment(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (3969, 3969, 0);
}

static void sl_gtk_drag_dest_get_track_motion (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_drag_dest_get_track_motion(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3970, 3970, 0);
}

static void sl_gtk_combo_box_new_with_area_and_entry (void)
{
   GtkWidget* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new_with_area_and_entry(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3971, 3971, 0);
}

static void sl_gtk_tree_view_get_visible_rect (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_get_visible_rect(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3972, 3972, 0);
}

static void sl_gtk_widget_get_tooltip_markup (void)
{
   gchar* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_tooltip_markup(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3973, 3973, 0);
}

static void sl_g_io_channel_new_file (void)
{
   GIOChannel* retval;
   gchar* arg1;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_io_channel_new_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GIOChannel_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3974, 3974, 0);
}

static void sl_g_variant_get_int64 (void)
{
   gint64 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_int64(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3975, 3975, 0);
}

static void sl_g_variant_type_string_get_depth_ (void)
{
   gsize retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_string_get_depth_(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3976, 3976, 0);
}

static void sl_g_socket_get_multicast_ttl (void)
{
   guint retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_multicast_ttl(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3977, 3977, 0);
}

static void sl_gtk_adjustment_set_lower (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_lower(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3978, 3978, 0);
}

static void sl_gdk_pixbuf_get_n_channels (void)
{
   int retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_n_channels(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3979, 3979, 0);
}

static void sl_g_variant_ref_sink (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_ref_sink(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3980, 3980, 0);
}

static void sl_g_regex_escape_string (void)
{
   gchar* retval;
   gchar* arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_escape_string(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3981, 3981, 0);
}

static void sl_gtk_scrolled_window_set_placement (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCornerType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_placement(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3982, 3982, 0);
}

static void sl_gdk_window_merge_child_input_shapes (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_merge_child_input_shapes(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3983, 3983, 0);
}

static void sl_gtk_buildable_parser_finished (void)
{
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBuilder* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_buildable_parser_finished(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (3984, 3984, 0);
}

static void sl_gtk_gl_area_get_has_stencil_buffer (void)
{
   gboolean retval;
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_has_stencil_buffer(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3985, 3985, 0);
}

static void sl_gdk_window_register_dnd (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_register_dnd(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3986, 3986, 0);
}

static void sl_gtk_radio_tool_button_get_group (void)
{
   GSList* retval;
   GtkRadioToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_tool_button_get_group(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3987, 3987, 0);
}

static void sl_gdk_monitor_get_scale_factor (void)
{
   int retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_scale_factor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3988, 3988, 0);
}

static void sl_gtk_clipboard_wait_for_uris (void)
{
   gchar** retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_for_uris(arg1);
   push_null_term_str_array (retval, "gtk_clipboard_wait_for_uris", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3989, 3989, 0);
}

static void sl_g_bookmark_file_get_mime_type (void)
{
   gchar* retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_mime_type(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (3990, 3990, 0);
}

static void sl_gtk_image_new_from_resource (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_resource(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (3991, 3991, 0);
}

static void sl_gtk_list_store_set_column_types (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GType* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_ULONG_TYPE,sizeof(GType),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = (gint) ref_get_size(arg3_r, 0);
   gtk_list_store_set_column_types(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3992, 3992, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_notebook_set_show_border (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_set_show_border(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3993, 3993, 0);
}

static void sl_gtk_recent_filter_get_name (void)
{
   const gchar* retval;
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_filter_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3994, 3994, 0);
}

static void sl_gtk_text_iter_get_tags (void)
{
   GSList* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_tags(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3995, 3995, 0);
}

static void sl_gdk_keymap_get_for_display (void)
{
   GdkKeymap* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_for_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3996, 3996, 0);
}

static void sl_gtk_tool_item_group_get_ellipsize (void)
{
   PangoEllipsizeMode retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_ellipsize(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3997, 3997, 0);
}

static void sl_g_ascii_toupper (void)
{
   gchar retval;
   gchar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_toupper( arg1);
   (void)SLang_push_char(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (3998, 3998, 0);
}

static void sl_g_date_set_time_t (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   time_t arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_set_time_t(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (3999, 3999, 0);
}

static void sl_gdk_keymap_get_modifier_mask (void)
{
   GdkModifierType retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkModifierIntent arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_modifier_mask(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4000, 4000, 0);
}

static void sl_gtk_drag_source_set_icon_name (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_source_set_icon_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4001, 4001, 0);
}

static void sl_gtk_cell_area_context_get_area (void)
{
   GtkCellArea* retval;
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_context_get_area(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4002, 4002, 0);
}

static void sl_gtk_icon_info_get_base_scale (void)
{
   gint retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_base_scale(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4003, 4003, 0);
}

static void sl_gtk_places_sidebar_get_open_flags (void)
{
   GtkPlacesOpenFlags retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_open_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4004, 4004, 0);
}

static void sl_gtk_combo_box_get_button_sensitivity (void)
{
   GtkSensitivityType retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_button_sensitivity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4005, 4005, 0);
}

static void sl_gtk_widget_get_has_window (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_has_window(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4006, 4006, 0);
}

static void sl_gtk_paper_size_new_from_key_file (void)
{
   GtkPaperSize* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_paper_size_new_from_key_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4007, 4007, 0);
}

static void sl_gtk_app_chooser_widget_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4008, 4008, 0);
}

static void sl_g_unichar_islower (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_islower( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4009, 4009, 0);
}

static void sl_gtk_container_set_focus_hadjustment (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_set_focus_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4010, 4010, 0);
}

static void sl_g_menu_item_get_attribute_value (void)
{
   GVariant* retval;
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GVariantType* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_menu_item_get_attribute_value(arg1, arg2, arg3);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4011, 4011, 0);
}

static void sl_gtk_expander_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_expander_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4012, 4012, 0);
}

static void sl_g_file_load_bytes (void)
{
   GBytes* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_load_bytes(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4013, 4013, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_invisible_set_screen (void)
{
   GtkInvisible* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_invisible_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4014, 4014, 0);
}

static void sl_gtk_style_context_get_frame_clock (void)
{
   GdkFrameClock* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_frame_clock(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4015, 4015, 0);
}

static void sl_gdk_event_set_device_tool (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDeviceTool* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_event_set_device_tool(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4016, 4016, 0);
}

static void sl_gdk_window_enable_synchronized_configure (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_enable_synchronized_configure(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4017, 4017, 0);
}

static void sl_gtk_tree_view_column_cell_get_position (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_column_cell_get_position(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4018, 4018, 0);
}

static void sl_g_main_context_pending (void)
{
   gboolean retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_pending(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4019, 4019, 0);
}

static void sl_gtk_widget_get_ancestor (void)
{
   GtkWidget* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_ancestor(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4020, 4020, 0);
}

static void sl_g_settings_backend_get_default (void)
{
   GSettingsBackend* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_backend_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4021, 4021, 0);
}

static void sl_gdk_parse_args (void)
{
   gint* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg1,0x0);
   gchar*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto free_and_return_2;
   issue_usage = 0;

   gdk_parse_args(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4022, 4022, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_menu_tool_button_set_menu (void)
{
   GtkMenuToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_tool_button_set_menu(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4023, 4023, 0);
}

static void sl_gtk_widget_map (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_map(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4024, 4024, 0);
}

static void sl_gtk_file_chooser_add_filter (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFileFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_add_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4025, 4025, 0);
}

static void sl_gtk_tool_shell_get_text_orientation (void)
{
   GtkOrientation retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_text_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4026, 4026, 0);
}

static void sl_gtk_tree_view_set_vadjustment (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4027, 4027, 0);
}

static void sl_gtk_icon_view_set_row_spacing (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_row_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4028, 4028, 0);
}

static void sl_gtk_scrolled_window_set_propagate_natural_width (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_propagate_natural_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4029, 4029, 0);
}

static void sl_g_variant_get_data (void)
{
   gconstpointer retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_data(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4030, 4030, 0);
}

static void sl_gtk_target_entry_free (void)
{
   GtkTargetEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_entry_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4031, 4031, 0);
}

static void sl_gtk_tree_model_iter_nth_child (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_nth_child(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4032, 4032, 0);
}

static void sl_gtk_window_get_gravity (void)
{
   GdkGravity retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_gravity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4033, 4033, 0);
}

static void sl_gdk_screen_is_composited (void)
{
   gboolean retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_is_composited(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4034, 4034, 0);
}

static void sl_g_emblemed_icon_get_emblems (void)
{
   GList* retval;
   GEmblemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblemed_icon_get_emblems(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4035, 4035, 0);
}

static void sl_gtk_assistant_get_n_pages (void)
{
   gint retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_assistant_get_n_pages(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4036, 4036, 0);
}

static void sl_gtk_text_iter_forward_word_end (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_word_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4037, 4037, 0);
}

static void sl_gtk_get_minor_version (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_minor_version();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4038, 4038, 0);
}

static void sl_gtk_widget_add_accelerator (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkAccelGroup* arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint arg4;
   GdkModifierType arg5;
   GtkAccelFlags arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_add_accelerator(arg1, arg2, arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4039, 4039, 0);
}

static void sl_gtk_window_set_mnemonics_visible (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_mnemonics_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4040, 4040, 0);
}

static void sl_g_key_file_set_value (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_value(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (4041, 4041, 0);
}

static void sl_gdk_window_set_shadow_width (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_shadow_width(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4042, 4042, 0);
}

static void sl_gtk_tree_view_expand_all (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_expand_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4043, 4043, 0);
}

static void sl_gtk_tree_store_move_before (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_store_move_before(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4044, 4044, 0);
}

static void sl_g_app_info_supports_files (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_supports_files(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4045, 4045, 0);
}

static void sl_gtk_menu_get_active (void)
{
   GtkWidget* retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_active(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4046, 4046, 0);
}

static void sl_gtk_widget_set_device_events (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkEventMask arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_device_events(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4047, 4047, 0);
}

static void sl_gtk_file_chooser_set_use_preview_label (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_use_preview_label(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4048, 4048, 0);
}

static void sl_gtk_printer_get_description (void)
{
   const gchar* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_description(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4049, 4049, 0);
}

static void sl_g_vfs_get_file_for_path (void)
{
   GFile* retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_vfs_get_file_for_path(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4050, 4050, 0);
}

static void sl_g_unicode_canonical_ordering (void)
{
   gunichar* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UINT_TYPE,sizeof(gunichar),&arg1,0x0);
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_unicode_canonical_ordering(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4051, 4051, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_print_job_get_status (void)
{
   GtkPrintStatus retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_status(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4052, 4052, 0);
}

static void sl_gtk_icon_info_load_symbolic_for_style (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyle* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkStateType arg3;
   gboolean* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg4,0x0);
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = gtk_icon_info_load_symbolic_for_style(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4053, 4053, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_widget_set_allocation (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GtkAllocation_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_allocation(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GtkAllocation_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4054, 4054, 0);
}

static void sl_gtk_about_dialog_get_logo_icon_name (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_logo_icon_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4055, 4055, 0);
}

static void sl_gtk_flow_box_set_selection_mode (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSelectionMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_selection_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4056, 4056, 0);
}

static void sl_pango_context_get_language (void)
{
   PangoLanguage* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_language(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4057, 4057, 0);
}

static void sl_g_mount_operation_get_is_tcrypt_hidden_volume (void)
{
   gboolean retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_is_tcrypt_hidden_volume(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4058, 4058, 0);
}

static void sl_gtk_volume_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_volume_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4059, 4059, 0);
}

static void sl_gtk_print_settings_new_from_file (void)
{
   GtkPrintSettings* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_print_settings_new_from_file(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4060, 4060, 0);
}

static void sl_g_variant_is_container (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_is_container(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4061, 4061, 0);
}

static void sl_g_settings_set_string (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_string(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4062, 4062, 0);
}

static void sl_gtk_combo_box_text_prepend_text (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_text_prepend_text(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4063, 4063, 0);
}

static void sl_g_charset_converter_get_use_fallback (void)
{
   gboolean retval;
   GCharsetConverter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_charset_converter_get_use_fallback(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4064, 4064, 0);
}

static void sl_gtk_tree_view_get_column (void)
{
   GtkTreeViewColumn* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_column(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4065, 4065, 0);
}

static void sl_gtk_revealer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4066, 4066, 0);
}

static void sl_g_settings_get_strv (void)
{
   gchar** retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_strv(arg1, arg2);
   push_null_term_str_array (retval, "g_settings_get_strv", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4067, 4067, 0);
}

static void sl_gtk_recent_chooser_get_current_uri (void)
{
   gchar* retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_current_uri(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4068, 4068, 0);
}

static void sl_gtk_widget_set_support_multidevice (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_support_multidevice(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4069, 4069, 0);
}

static void sl_g_value_dup_object (void)
{
   gpointer retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_dup_object(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4070, 4070, 0);
}

static void sl_gtk_icon_view_unselect_path (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_unselect_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4071, 4071, 0);
}

static void sl_gtk_tree_view_set_fixed_height_mode (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_fixed_height_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4072, 4072, 0);
}

static void sl_gdk_display_get_default (void)
{
   GdkDisplay* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_default();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4073, 4073, 0);
}

static void sl_gtk_buildable_add_child (void)
{
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBuilder* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GObject* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg4, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_buildable_add_child(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (4074, 4074, 0);
}

static void sl_gtk_printer_get_default_page_size (void)
{
   GtkPageSetup* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_default_page_size(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4075, 4075, 0);
}

static void sl_gtk_printer_is_active (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_is_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4076, 4076, 0);
}

static void sl_gdk_device_grab (void)
{
   GdkGrabStatus retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkGrabOwnership arg3;
   gboolean arg4;
   GdkEventMask arg5;
   GdkCursor* arg6;
   Slirp_Opaque* arg6_o = NULL;
   guint32 arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg6, &arg6_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_device_grab(arg1, arg2,  arg3,  arg4,  arg5, arg6,  arg7);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_6:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (4077, 4077, 0);
}

static void sl_gdk_pixbuf_loader_get_format (void)
{
   GdkPixbufFormat* retval;
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_loader_get_format(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4078, 4078, 0);
}

static void sl_gtk_box_get_spacing (void)
{
   gint retval;
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4079, 4079, 0);
}

static void sl_pango_layout_context_changed (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_context_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4080, 4080, 0);
}

static void sl_g_ascii_dtostr (void)
{
   gchar* retval;
   gchar* arg1;
   gint arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_dtostr(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4081, 4081, 0);
}

static void sl_g_date_time_difference (void)
{
   GTimeSpan retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GDateTime* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_difference(arg1, arg2);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4082, 4082, 0);
}

static void sl_gtk_box_query_child_packing (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   guint arg5;
   GtkPackType* arg6;
   Slirp_Ref *arg6_r = ref_new(SLANG_INT_TYPE,sizeof(GtkPackType),&arg6,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_query_child_packing(arg1, arg2, &arg3, &arg4, &arg5, arg6);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   (void)SLang_push_uint(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4083, 4083, 0);
   finalize_refs(1,arg6_r); 
}

static void sl_gtk_selection_data_get_uris (void)
{
   gchar** retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_uris(arg1);
   push_null_term_str_array (retval, "gtk_selection_data_get_uris", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4084, 4084, 0);
}

static void sl_g_menu_model_is_mutable (void)
{
   gboolean retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_model_is_mutable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4085, 4085, 0);
}

static void sl_gtk_tool_button_set_use_underline (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_button_set_use_underline(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4086, 4086, 0);
}

static void sl_gtk_radio_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4087, 4087, 0);
}

static void sl_gtk_print_settings_set_resolution (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_resolution(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4088, 4088, 0);
}

static void sl_gtk_widget_get_direction (void)
{
   GtkTextDirection retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_direction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4089, 4089, 0);
}

static void sl_gtk_clipboard_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4090, 4090, 0);
}

static void sl_gtk_widget_queue_compute_expand (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_compute_expand(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4091, 4091, 0);
}

static void sl_pango_gravity_get_for_script_and_width (void)
{
   PangoGravity retval;
   PangoScript arg1;
   gboolean arg2;
   PangoGravity arg3;
   PangoGravityHint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_gravity_get_for_script_and_width( arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4092, 4092, 0);
}

static void sl_g_date_time_compare (void)
{
   gint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4093, 4093, 0);
}

static void sl_gtk_tree_selection_count_selected_rows (void)
{
   gint retval;
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_selection_count_selected_rows(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4094, 4094, 0);
}

static void sl_gtk_list_store_insert_before (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   gtk_list_store_insert_before(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4095, 4095, 0);
}

static void sl_gtk_info_bar_add_action_widget (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_info_bar_add_action_widget(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4096, 4096, 0);
}

static void sl_g_content_type_is_mime_type (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_content_type_is_mime_type(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4097, 4097, 0);
}

static void sl_g_cancellable_release_fd (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_release_fd(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4098, 4098, 0);
}

static void sl_gdk_drag_context_get_device (void)
{
   GdkDevice* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_device(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4099, 4099, 0);
}

static void sl_g_compute_checksum_for_data (void)
{
   gchar* retval;
   GChecksumType arg1;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_compute_checksum_for_data( arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4100, 4100, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_gl_area_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gl_area_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4101, 4101, 0);
}

static void sl_gtk_grid_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4102, 4102, 0);
}

static void sl_gtk_assistant_get_page_has_padding (void)
{
   gboolean retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_has_padding(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4103, 4103, 0);
}

static void sl_gtk_action_bar_pack_end (void)
{
   GtkActionBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_action_bar_pack_end(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4104, 4104, 0);
}

static void sl_g_date_time_to_timeval (void)
{
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_date_time_to_timeval(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GTimeVal_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4105, 4105, 0);
}

static void sl_g_file_attribute_matcher_to_string (void)
{
   char* retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_matcher_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4106, 4106, 0);
}

static void sl_gtk_text_iter_backward_visible_word_start (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_word_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4107, 4107, 0);
}

static void sl_gtk_cairo_should_draw_window (void)
{
   gboolean retval;
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cairo_should_draw_window(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4108, 4108, 0);
}

static void sl_gtk_widget_unmap (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_unmap(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4109, 4109, 0);
}

static void sl_gtk_printer_has_details (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_has_details(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4110, 4110, 0);
}

static void sl_gtk_recent_chooser_widget_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_widget_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4111, 4111, 0);
}

static void sl_g_file_monitor_emit_event (void)
{
   GFileMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GFile* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GFileMonitorEvent arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_monitor_emit_event(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4112, 4112, 0);
}

static void sl_gtk_link_button_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_link_button_new_with_label(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4113, 4113, 0);
}

static void sl_gdk_window_set_focus_on_map (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_focus_on_map(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4114, 4114, 0);
}

static void sl_gtk_gesture_drag_get_start_point (void)
{
   gboolean retval;
   GtkGestureDrag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_drag_get_start_point(arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4115, 4115, 0);
}

static void sl_gtk_about_dialog_get_authors (void)
{
   const gchar** retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_authors(arg1);
   push_null_term_str_array ((char **) retval, "gtk_about_dialog_get_authors", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4116, 4116, 0);
}

static void sl_g_variant_type_is_variant (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_variant(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4117, 4117, 0);
}

static void sl_gtk_revealer_set_transition_type (void)
{
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRevealerTransitionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_revealer_set_transition_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4118, 4118, 0);
}

static void sl_gtk_text_buffer_remove_tag_by_name (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_remove_tag_by_name(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4119, 4119, 0);
}

static void sl_g_file_load_contents (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   char** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg3,0x0);
   gsize arg4;
   char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   arg6 = NULL;
   retval = g_file_load_contents(arg1, arg2, arg3, &arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4120, 4120, 0);
   finalize_refs(2,arg3_r,arg5_r); 
}

static void sl_g_date_time_new_from_unix_local (void)
{
   GDateTime* retval;
   gint64 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_from_unix_local( arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4121, 4121, 0);
}

static void sl_gdk_visual_get_best_with_both (void)
{
   GdkVisual* retval;
   gint arg1;
   GdkVisualType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best_with_both( arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4122, 4122, 0);
}

static void sl_gtk_check_menu_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4123, 4123, 0);
}

static void sl_gdk_window_set_child_shapes (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_child_shapes(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4124, 4124, 0);
}

static void sl_gtk_main_iteration_do (void)
{
   gboolean retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_main_iteration_do( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4125, 4125, 0);
}

static void sl_gtk_text_view_get_iter_location (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_get_iter_location(arg1, arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4126, 4126, 0);
}

static void sl_gtk_icon_view_get_item_padding (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_item_padding(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4127, 4127, 0);
}

static void sl_g_settings_schema_key_unref (void)
{
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_schema_key_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4128, 4128, 0);
}

static void sl_gtk_disable_setlocale (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gtk_disable_setlocale();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4129, 4129, 0);
}

static void sl_g_dcgettext (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_dcgettext(arg1, arg2,  arg3);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4130, 4130, 0);
}

static void sl_gtk_page_setup_get_orientation (void)
{
   GtkPageOrientation retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4131, 4131, 0);
}

static void sl_g_cancellable_reset (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_reset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4132, 4132, 0);
}

static void sl_gtk_icon_view_item_activated (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_item_activated(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4133, 4133, 0);
}

static void sl_gdk_screen_get_monitor_at_window (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_screen_get_monitor_at_window(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4134, 4134, 0);
}

static void sl_gtk_print_settings_get (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4135, 4135, 0);
}

static void sl_gtk_text_view_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4136, 4136, 0);
}

static void sl_g_variant_type_new_dict_entry (void)
{
   GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_type_new_dict_entry(arg1, arg2);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4137, 4137, 0);
}

static void sl_g_strrstr (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strrstr(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4138, 4138, 0);
}

static void sl_gtk_print_unix_dialog_get_support_selection (void)
{
   gboolean retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_support_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4139, 4139, 0);
}

static void sl_gtk_list_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4140, 4140, 0);
}

static void sl_g_time_val_to_iso8601 (void)
{
   gchar* retval;
   GTimeVal* arg1 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GTimeVal_Layout)) goto usage_label;
   issue_usage = 0;

   retval = g_time_val_to_iso8601(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4141, 4141, 0);
}

static void sl_g_unichar_ismark (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_ismark( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4142, 4142, 0);
}

static void sl_g_key_file_load_from_dirs (void)
{
   gboolean retval;
   GKeyFile* arg1;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   gchar** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg4,0x0);
   GKeyFileFlags arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   issue_usage = 0;

   arg1 = g_key_file_new ();
   arg6 = NULL;
   retval = g_key_file_load_from_dirs(arg1, arg2, arg3, arg4,  arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   if (retval == TRUE)
      (void) SLang_push_opaque (GKeyFile_Type, (void*) retval, 0);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4143, 4143, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_gtk_text_buffer_unregister_deserialize_format (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_unregister_deserialize_format(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4144, 4144, 0);
}

static void sl_gtk_about_dialog_set_documenters (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_about_dialog_set_documenters(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4145, 4145, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_param_spec_get_name_quark (void)
{
   GQuark retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_name_quark(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4146, 4146, 0);
}

static void sl_g_volume_get_mount (void)
{
   GMount* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_mount(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4147, 4147, 0);
}

static void sl_gdk_event_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4148, 4148, 0);
}

static void sl_g_rand_set_seed (void)
{
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_rand_set_seed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4149, 4149, 0);
}

static void sl_g_settings_schema_key_ref (void)
{
   GSettingsSchemaKey* retval;
   GSettingsSchemaKey* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_key_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4150, 4150, 0);
}

static void sl_gdk_screen_get_number (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_number(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4151, 4151, 0);
}

static void sl_gdk_event_new (void)
{
   GdkEvent* retval;
   GdkEventType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_new( arg1);
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4152, 4152, 0);
}

static void sl_gdk_drag_context_set_hotspot (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_drag_context_set_hotspot(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4153, 4153, 0);
}

static void sl_gtk_drag_dest_set_proxy (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkDragProtocol arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_dest_set_proxy(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4154, 4154, 0);
}

static void sl_gtk_text_view_starts_display_line (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_starts_display_line(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4155, 4155, 0);
}

static void sl_gtk_print_settings_load_file (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_print_settings_load_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4156, 4156, 0);
}

static void sl_g_unichar_digit_value (void)
{
   gint retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_digit_value( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4157, 4157, 0);
}

static void sl_gtk_menu_bar_get_pack_direction (void)
{
   GtkPackDirection retval;
   GtkMenuBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_bar_get_pack_direction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4158, 4158, 0);
}

static void sl_gtk_recent_chooser_menu_new_for_manager (void)
{
   GtkWidget* retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_menu_new_for_manager(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4159, 4159, 0);
}

static void sl_gtk_paned_pack1 (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_paned_pack1(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4160, 4160, 0);
}

static void sl_gtk_progress_bar_get_ellipsize (void)
{
   PangoEllipsizeMode retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_ellipsize(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4161, 4161, 0);
}

static void sl_gdk_scroll_direction_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_scroll_direction_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4162, 4162, 0);
}

static void sl_gtk_progress_bar_get_show_text (void)
{
   gboolean retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_show_text(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4163, 4163, 0);
}

static void sl_gdk_pixbuf_read_pixel_bytes (void)
{
   GBytes* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_read_pixel_bytes(arg1);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4164, 4164, 0);
}

static void sl_g_emblemed_icon_add_emblem (void)
{
   GEmblemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GEmblem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_emblemed_icon_add_emblem(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4165, 4165, 0);
}

static void sl_g_variant_unref (void)
{
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_variant_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4166, 4166, 0);
}

static void sl_gtk_revealer_set_reveal_child (void)
{
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_revealer_set_reveal_child(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4167, 4167, 0);
}

static void sl_gdk_visual_get_screen (void)
{
   GdkScreen* retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4168, 4168, 0);
}

static void sl_gdk_window_is_input_only (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_is_input_only(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4169, 4169, 0);
}

static void sl_gtk_font_button_get_use_size (void)
{
   gboolean retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_use_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4170, 4170, 0);
}

static void sl_g_emblem_new_with_origin (void)
{
   GEmblem* retval;
   GIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GEmblemOrigin arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblem_new_with_origin(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4171, 4171, 0);
}

static void sl_g_cancellable_cancel (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_cancel(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4172, 4172, 0);
}

static void sl_g_key_file_set_integer (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_integer(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4173, 4173, 0);
}

static void sl_gtk_event_box_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_box_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4174, 4174, 0);
}

static void sl_pango_coverage_set (void)
{
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   PangoCoverageLevel arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_coverage_set(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4175, 4175, 0);
}

static void sl_gtk_recent_info_get_applications (void)
{
   gchar** retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_recent_info_get_applications(arg1, &arg2);
   push_null_term_str_array (retval, "gtk_recent_info_get_applications", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4176, 4176, 0);
}

static void sl_g_credentials_get_native (void)
{
   gpointer retval;
   GCredentials* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCredentialsType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_credentials_get_native(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4177, 4177, 0);
}

static void sl_g_proxy_address_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4178, 4178, 0);
}

static void sl_gdk_frame_clock_get_frame_time (void)
{
   gint64 retval;
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_frame_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4179, 4179, 0);
}

static void sl_gtk_cell_area_focus (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkDirectionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_focus(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4180, 4180, 0);
}

static void sl_gtk_recent_chooser_remove_filter (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRecentFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_chooser_remove_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4181, 4181, 0);
}

static void sl_g_inet_socket_address_get_address (void)
{
   GInetAddress* retval;
   GInetSocketAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_socket_address_get_address(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4182, 4182, 0);
}

static void sl_gtk_file_chooser_get_files (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_files(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4183, 4183, 0);
}

static void sl_g_regex_get_capture_count (void)
{
   gint retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_capture_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4184, 4184, 0);
}

static void sl_gdk_keyval_to_upper (void)
{
   guint retval;
   guint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_to_upper( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4185, 4185, 0);
}

static void sl_g_unicode_script_from_iso15924 (void)
{
   GUnicodeScript retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unicode_script_from_iso15924( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4186, 4186, 0);
}

static void sl_gtk_icon_view_unset_model_drag_source (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_unset_model_drag_source(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4187, 4187, 0);
}

static void sl_g_key_file_set_locale_string_list (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   const gchar** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg5,0x0);
   gsize arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = (gsize) ref_get_size(arg5_r, 0);
   g_key_file_set_locale_string_list(arg1, arg2, arg3, arg4, arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (4188, 4188, 0);
   finalize_refs(1,arg5_r); 
}

static void sl_g_mount_operation_get_choice (void)
{
   int retval;
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_operation_get_choice(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4189, 4189, 0);
}

static void sl_g_io_channel_seek_position (void)
{
   GIOStatus retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint64 arg2;
   GSeekType arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_io_channel_seek_position(arg1,  arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4190, 4190, 0);
}

static void sl_pango_version_string (void)
{
   const char* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_version_string();
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4191, 4191, 0);
}

static void sl_pango_layout_get_context (void)
{
   PangoContext* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4192, 4192, 0);
}

static void sl_g_variant_get_bytestring (void)
{
   const gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_bytestring(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4193, 4193, 0);
}

static void sl_gtk_flow_box_get_homogeneous (void)
{
   gboolean retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_homogeneous(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4194, 4194, 0);
}

static void sl_gtk_window_get_mnemonics_visible (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_mnemonics_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4195, 4195, 0);
}

static void sl_gdk_cursor_get_image (void)
{
   GdkPixbuf* retval;
   GdkCursor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_get_image(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4196, 4196, 0);
}

static void sl_gtk_recent_filter_set_name (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_filter_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4197, 4197, 0);
}

static void sl_g_value_set_int (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_int(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4198, 4198, 0);
}

static void sl_g_object_ref (void)
{
   gpointer retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4199, 4199, 0);
}

static void sl_g_regex_get_string_number (void)
{
   gint retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_get_string_number(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4200, 4200, 0);
}

static void sl_gdk_event_get_axis (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAxisUse arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_axis(arg1,  arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4201, 4201, 0);
}

static void sl_gtk_message_dialog_get_image (void)
{
   GtkWidget* retval;
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_message_dialog_get_image(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4202, 4202, 0);
}

static void sl_gtk_cell_renderer_accel_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_accel_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4203, 4203, 0);
}

static void sl_gtk_paper_size_get_default (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_default();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4204, 4204, 0);
}

static void sl_g_get_user_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4205, 4205, 0);
}

static void sl_gtk_buildable_set_name (void)
{
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_buildable_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4206, 4206, 0);
}

static void sl_g_variant_store (void)
{
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_variant_store(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4207, 4207, 0);
}

static void sl_gtk_range_set_fill_level (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_fill_level(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4208, 4208, 0);
}

static void sl_gdk_window_get_root_origin (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_root_origin(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4209, 4209, 0);
}

static void sl_pango_cairo_font_map_get_resolution (void)
{
   double retval;
   PangoCairoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_get_resolution(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4210, 4210, 0);
}

static void sl_pango_attr_shape_new (void)
{
   PangoAttribute* retval;
   PangoRectangle* arg1 = (PangoRectangle*) alloca(sizeof(PangoRectangle));
   PangoRectangle* arg2 = (PangoRectangle*) alloca(sizeof(PangoRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, PangoRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, PangoRectangle_Layout)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_attr_shape_new(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, PangoRectangle_Layout);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, PangoRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4211, 4211, 0);
}

static void sl_gtk_stack_get_child_by_name (void)
{
   GtkWidget* retval;
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_stack_get_child_by_name(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4212, 4212, 0);
}

static void sl_g_date_is_first_of_month (void)
{
   gboolean retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_is_first_of_month(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4213, 4213, 0);
}

static void sl_gtk_assistant_get_current_page (void)
{
   gint retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_assistant_get_current_page(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4214, 4214, 0);
}

static void sl_gtk_widget_is_ancestor (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_is_ancestor(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4215, 4215, 0);
}

static void sl_gtk_text_buffer_apply_tag_by_name (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_apply_tag_by_name(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4216, 4216, 0);
}

static void sl_g_themed_icon_new (void)
{
   GIcon* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_themed_icon_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4217, 4217, 0);
}

static void sl_gdk_display_get_default_group (void)
{
   GdkWindow* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_default_group(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4218, 4218, 0);
}

static void sl_gtk_icon_theme_list_icons (void)
{
   GList* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_list_icons(arg1, arg2);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
      g_free (list->data);
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4219, 4219, 0);
}

static void sl_gdk_cursor_get_cursor_type (void)
{
   GdkCursorType retval;
   GdkCursor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_get_cursor_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4220, 4220, 0);
}

static void sl_gtk_places_sidebar_set_local_only (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_local_only(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4221, 4221, 0);
}

static void sl_gtk_tree_model_sort_new_with_model (void)
{
   GtkTreeModel* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_sort_new_with_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4222, 4222, 0);
}

static void sl_gtk_widget_mnemonic_activate (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_mnemonic_activate(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4223, 4223, 0);
}

static void sl_gtk_get_debug_flags (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_debug_flags();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4224, 4224, 0);
}

static void sl_g_network_address_get_port (void)
{
   guint16 retval;
   GNetworkAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_get_port(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4225, 4225, 0);
}

static void sl_gtk_paned_get_child1 (void)
{
   GtkWidget* retval;
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_child1(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4226, 4226, 0);
}

static void sl_gdk_drag_context_set_device (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_drag_context_set_device(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4227, 4227, 0);
}

static void sl_gdk_display_peek_event (void)
{
   GdkEvent* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_peek_event(arg1);
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4228, 4228, 0);
}

static void sl_gtk_widget_create_pango_layout (void)
{
   PangoLayout* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_create_pango_layout(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4229, 4229, 0);
}

static void sl_gtk_gl_area_set_has_alpha (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_has_alpha(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4230, 4230, 0);
}

static void sl_gtk_style_context_get_junction_sides (void)
{
   GtkJunctionSides retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_junction_sides(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4231, 4231, 0);
}

static void sl_gtk_text_view_move_visually (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_move_visually(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4232, 4232, 0);
}

static void sl_gtk_text_view_set_wrap_mode (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWrapMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_wrap_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4233, 4233, 0);
}

static void sl_gtk_icon_view_get_selected_items (void)
{
   GList* retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_selected_items(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4234, 4234, 0);
}

static void sl_pango_attr_rise_new (void)
{
   PangoAttribute* retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_rise_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4235, 4235, 0);
}

static void sl_gtk_builder_add_from_string (void)
{
   guint retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gsize arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_builder_add_from_string(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4236, 4236, 0);
}

static void sl_g_regex_split_full (void)
{
   gchar** retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   gint arg4;
   GRegexMatchFlags arg5;
   gint arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_regex_split_full(arg1, arg2,  arg3,  arg4,  arg5,  arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   push_null_term_str_array (retval, "g_regex_split_full", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4237, 4237, 0);
}

static void sl_gtk_grid_set_baseline_row (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_baseline_row(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4238, 4238, 0);
}

static void sl_gdk_keymap_get_num_lock_state (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keymap_get_num_lock_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4239, 4239, 0);
}

static void sl_g_app_info_add_supports_type (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_add_supports_type(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4240, 4240, 0);
}

static void sl_g_variant_is_of_type (void)
{
   gboolean retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_is_of_type(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4241, 4241, 0);
}

static void sl_g_source_set_can_recurse (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_source_set_can_recurse(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4242, 4242, 0);
}

static void sl_g_file_attribute_matcher_matches_only (void)
{
   gboolean retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_attribute_matcher_matches_only(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4243, 4243, 0);
}

static void sl_gtk_menu_item_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4244, 4244, 0);
}

static void sl_gtk_print_operation_draw_page_finish (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_draw_page_finish(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4245, 4245, 0);
}

static void sl_gtk_tree_model_row_inserted (void)
{
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_model_row_inserted(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4246, 4246, 0);
}

static void sl_gtk_label_get_current_uri (void)
{
   const gchar* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_current_uri(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4247, 4247, 0);
}

static void sl_gtk_text_buffer_delete_interactive (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_delete_interactive(arg1, arg2, arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4248, 4248, 0);
}

static void sl_gtk_range_get_upper_stepper_sensitivity (void)
{
   GtkSensitivityType retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_upper_stepper_sensitivity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4249, 4249, 0);
}

static void sl_gtk_separator_menu_item_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_menu_item_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4250, 4250, 0);
}

static void sl_gdk_window_beep (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_beep(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4251, 4251, 0);
}

static void sl_gtk_toolbar_set_icon_size (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toolbar_set_icon_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4252, 4252, 0);
}

static void sl_gtk_icon_info_get_base_size (void)
{
   gint retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_base_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4253, 4253, 0);
}

static void sl_gtk_icon_theme_has_icon (void)
{
   gboolean retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_theme_has_icon(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4254, 4254, 0);
}

static void sl_gdk_pixbuf_format_is_save_option_supported (void)
{
   gboolean retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_pixbuf_format_is_save_option_supported(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4255, 4255, 0);
}

static void sl_gtk_print_operation_set_job_name (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_operation_set_job_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4256, 4256, 0);
}

static void sl_gdk_display_get_maximal_cursor_size (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_get_maximal_cursor_size(arg1, &arg2, &arg3);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_uint(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4257, 4257, 0);
}

static void sl_g_get_user_runtime_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_runtime_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4258, 4258, 0);
}

static void sl_gdk_device_grab_info_libgtk_only (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkWindow** arg3;
   Slirp_Ref *arg3_r = ref_new(GObject_Type,sizeof(GdkWindow*),&arg3,0x0);
   gboolean* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_device_grab_info_libgtk_only(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4259, 4259, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_g_menu_model_get_item_attribute_value (void)
{
   GVariant* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   const GVariantType* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_menu_model_get_item_attribute_value(arg1,  arg2, arg3, arg4);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4260, 4260, 0);
}

static void sl_g_resolver_lookup_service_finish (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resolver_lookup_service_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4261, 4261, 0);
}

static void sl_g_file_error_from_errno (void)
{
   GFileError retval;
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_error_from_errno( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4262, 4262, 0);
}

static void sl_gtk_window_set_screen (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_screen(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4263, 4263, 0);
}

static void sl_g_main_loop_new (void)
{
   GMainLoop* retval;
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GMainContext_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_main_loop_new(arg1,  arg2);
   (void)SLang_push_opaque(GMainLoop_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4264, 4264, 0);
}

static void sl_pango_language_includes_script (void)
{
   gboolean retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoScript arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_language_includes_script(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4265, 4265, 0);
}

static void sl_gtk_accel_label_get_accel_width (void)
{
   guint retval;
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_label_get_accel_width(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4266, 4266, 0);
}

static void sl_gtk_print_settings_get_printer_lpi (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_printer_lpi(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4267, 4267, 0);
}

static void sl_g_file_info_set_attribute_int64 (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gint64 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_int64(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4268, 4268, 0);
}

static void sl_gtk_widget_get_allocated_baseline (void)
{
   int retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_allocated_baseline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4269, 4269, 0);
}

static void sl_g_file_parse_name (void)
{
   GFile* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_parse_name(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4270, 4270, 0);
}

static void sl_g_unichar_decompose (void)
{
   gboolean retval;
   gunichar arg1;
   gunichar arg2;
   gunichar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_decompose( arg1, &arg2, &arg3);
   (void)SLang_push_int(retval);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_uint(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4271, 4271, 0);
}

static void sl_g_socket_get_remote_address (void)
{
   GSocketAddress* retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_get_remote_address(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4272, 4272, 0);
}

static void sl_g_volume_get_name (void)
{
   char* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4273, 4273, 0);
}

static void sl_gtk_icon_view_select_path (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_select_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4274, 4274, 0);
}

static void sl_gtk_flow_box_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4275, 4275, 0);
}

static void sl_g_regex_get_max_lookbehind (void)
{
   gint retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_max_lookbehind(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4276, 4276, 0);
}

static void sl_gtk_level_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4277, 4277, 0);
}

static void sl_gtk_icon_view_get_item_orientation (void)
{
   GtkOrientation retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_item_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4278, 4278, 0);
}

static void sl_gtk_header_bar_get_custom_title (void)
{
   GtkWidget* retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_custom_title(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4279, 4279, 0);
}

static void sl_gtk_selection_data_copy (void)
{
   GtkSelectionData* retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_copy(arg1);
   (void)SLang_push_opaque(GtkSelectionData_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4280, 4280, 0);
}

static void sl_g_file_info_set_symlink_target (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_symlink_target(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4281, 4281, 0);
}

static void sl_gtk_text_iter_forward_visible_line (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4282, 4282, 0);
}

static void sl_g_volume_monitor_get_volume_for_uuid (void)
{
   GVolume* retval;
   GVolumeMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_volume_monitor_get_volume_for_uuid(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4283, 4283, 0);
}

static void sl_gtk_scrolled_window_get_propagate_natural_height (void)
{
   gboolean retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_propagate_natural_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4284, 4284, 0);
}

static void sl_gtk_about_dialog_set_version (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_version(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4285, 4285, 0);
}

static void sl_g_date_time_add_seconds (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_add_seconds(arg1,  arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4286, 4286, 0);
}

static void sl_gtk_invisible_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_invisible_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4287, 4287, 0);
}

static void sl_g_file_attribute_info_list_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_info_list_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4288, 4288, 0);
}

static void sl_gdk_frame_clock_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4289, 4289, 0);
}

static void sl_gtk_overlay_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_overlay_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4290, 4290, 0);
}

static void sl_gtk_widget_get_settings (void)
{
   GtkSettings* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_settings(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4291, 4291, 0);
}

static void sl_g_variant_type_free (void)
{
   GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_variant_type_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4292, 4292, 0);
}

static void sl_pango_layout_get_serial (void)
{
   guint retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_serial(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4293, 4293, 0);
}

static void sl_g_action_parse_detailed_name (void)
{
   gboolean retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GVariant** arg3;
   Slirp_Ref *arg3_r = ref_new(GVariant_Type,sizeof(GVariant*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_action_parse_detailed_name(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4294, 4294, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_pango_font_metrics_get_height (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4295, 4295, 0);
}

static void sl_g_main_context_pop_thread_default (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_pop_thread_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4296, 4296, 0);
}

static void sl_g_action_print_detailed_name (void)
{
   gchar* retval;
   gchar* arg1;
   GVariant* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_action_print_detailed_name(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4297, 4297, 0);
}

static void sl_gtk_icon_theme_set_custom_theme (void)
{
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_theme_set_custom_theme(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4298, 4298, 0);
}

static void sl_gtk_tool_palette_get_exclusive (void)
{
   gboolean retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItemGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_palette_get_exclusive(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4299, 4299, 0);
}

static void sl_gdk_frame_clock_get_frame_counter (void)
{
   gint64 retval;
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_frame_counter(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4300, 4300, 0);
}

static void sl_gtk_viewport_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4301, 4301, 0);
}

static void sl_gtk_paned_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_paned_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4302, 4302, 0);
}

static void sl_g_source_attach (void)
{
   guint retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMainContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_source_attach(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4303, 4303, 0);
}

static void sl_gdk_gravity_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_gravity_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4304, 4304, 0);
}

static void sl_gdk_screen_make_display_name (void)
{
   gchar* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_make_display_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4305, 4305, 0);
}

static void sl_gtk_menu_item_set_accel_path (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_item_set_accel_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4306, 4306, 0);
}

static void sl_gdk_window_get_accept_focus (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_accept_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4307, 4307, 0);
}

static void sl_gtk_tree_row_reference_free (void)
{
   GtkTreeRowReference* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeRowReference_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_row_reference_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4308, 4308, 0);
}

static void sl_gtk_tree_selection_set_mode (void)
{
   GtkTreeSelection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkSelectionMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_selection_set_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4309, 4309, 0);
}

static void sl_g_date_time_get_hour (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_hour(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4310, 4310, 0);
}

static void sl_g_file_info_get_size (void)
{
   goffset retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_size(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4311, 4311, 0);
}

static void sl_gtk_cell_renderer_get_preferred_size (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkRequisition* arg3 = (GtkRequisition*) alloca(sizeof(GtkRequisition));
   GtkRequisition* arg4 = (GtkRequisition*) alloca(sizeof(GtkRequisition));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_preferred_size(arg1, arg2, arg3, arg4);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GtkRequisition_Layout);
   (void) SLang_push_cstruct ((VOID_STAR) arg4, GtkRequisition_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4312, 4312, 0);
}

static void sl_gdk_visual_get_green_pixel_details (void)
{
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint32 arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_visual_get_green_pixel_details(arg1, &arg2, &arg3, &arg4);
   (void)SLang_push_uint(arg2);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4313, 4313, 0);
}

static void sl_gtk_app_chooser_widget_set_show_fallback (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_widget_set_show_fallback(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4314, 4314, 0);
}

static void sl_g_drive_can_stop (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_can_stop(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4315, 4315, 0);
}

static void sl_g_resource_enumerate_children (void)
{
   char** retval;
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GResourceLookupFlags arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_resource_enumerate_children(arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   push_null_term_str_array (retval, "g_resource_enumerate_children", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4316, 4316, 0);
}

static void sl_g_key_file_free (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_key_file_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4317, 4317, 0);
}

static void sl_pango_version (void)
{
   int retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_version();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4318, 4318, 0);
}

static void sl_g_resolver_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_resolver_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4319, 4319, 0);
}

static void sl_gtk_widget_get_path (void)
{
   GtkWidgetPath* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_path(arg1);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4320, 4320, 0);
}

static void sl_gtk_window_set_decorated (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_decorated(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4321, 4321, 0);
}

static void sl_gdk_pixbuf_format_get_mime_types (void)
{
   gchar** retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_mime_types(arg1);
   push_null_term_str_array (retval, "gdk_pixbuf_format_get_mime_types", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4322, 4322, 0);
}

static void sl_gdk_pixbuf_animation_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4323, 4323, 0);
}

static void sl_pango_layout_set_markup (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_layout_set_markup(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4324, 4324, 0);
}

static void sl_gtk_widget_error_bell (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_error_bell(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4325, 4325, 0);
}

static void sl_g_hmac_get_digest (void)
{
   GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint8* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guint8),&arg2,0x0);
   gsize* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_ULONG_TYPE,sizeof(gsize),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_hmac_get_digest(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4326, 4326, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_app_chooser_widget_get_show_default (void)
{
   gboolean retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_show_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4327, 4327, 0);
}

static void sl_g_file_info_get_edit_name (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_edit_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4328, 4328, 0);
}

static void sl_gdk_keymap_lookup_key (void)
{
   guint retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkKeymapKey* arg2 = (GdkKeymapKey*) alloca(sizeof(GdkKeymapKey));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkKeymapKey_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_keymap_lookup_key(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkKeymapKey_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4329, 4329, 0);
}

static void sl_gtk_render_option (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_option(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4330, 4330, 0);
}

static void sl_gdk_window_get_toplevel (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_toplevel(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4331, 4331, 0);
}

static void sl_pango_layout_get_wrap (void)
{
   PangoWrapMode retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_wrap(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4332, 4332, 0);
}

static void sl_gtk_notebook_get_tab_vborder (void)
{
   guint16 retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_vborder(arg1);
   (void)SLang_push_ushort(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4333, 4333, 0);
}

static void sl_gtk_file_chooser_remove_choice (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_remove_choice(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4334, 4334, 0);
}

static void sl_gtk_header_bar_set_decoration_layout (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_set_decoration_layout(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4335, 4335, 0);
}

static void sl_gtk_window_group_get_current_grab (void)
{
   GtkWidget* retval;
   GtkWindowGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_group_get_current_grab(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4336, 4336, 0);
}

static void sl_g_source_set_name (void)
{
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_source_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4337, 4337, 0);
}

static void sl_pango_font_map_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_map_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4338, 4338, 0);
}

static void sl_gtk_css_provider_to_string (void)
{
   char* retval;
   GtkCssProvider* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_provider_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4339, 4339, 0);
}

static void sl_gdk_window_get_parent (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_parent(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4340, 4340, 0);
}

static void sl_gdk_event_get_source_device (void)
{
   GdkDevice* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_source_device(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4341, 4341, 0);
}

static void sl_gtk_print_settings_get_print_pages (void)
{
   GtkPrintPages retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_print_pages(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4342, 4342, 0);
}

static void sl_gtk_print_settings_has_key (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_has_key(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4343, 4343, 0);
}

static void sl_gtk_text_tag_table_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_table_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4344, 4344, 0);
}

static void sl_gtk_recent_info_ref (void)
{
   GtkRecentInfo* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_ref(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4345, 4345, 0);
}

static void sl_gtk_cell_renderer_is_activatable (void)
{
   gboolean retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_is_activatable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4346, 4346, 0);
}

static void sl_gtk_print_settings_get_orientation (void)
{
   GtkPageOrientation retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4347, 4347, 0);
}

static void sl_gtk_adjustment_get_minimum_increment (void)
{
   gdouble retval;
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_adjustment_get_minimum_increment(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4348, 4348, 0);
}

static void sl_gtk_text_iter_get_text (void)
{
   gchar* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_get_text(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4349, 4349, 0);
}

static void sl_gtk_print_operation_get_error (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   gtk_print_operation_get_error(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4350, 4350, 0);
}

static void sl_gtk_label_get_selectable (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_selectable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4351, 4351, 0);
}

static void sl_gtk_clipboard_wait_for_image (void)
{
   GdkPixbuf* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_for_image(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4352, 4352, 0);
}

static void sl_g_bookmark_file_get_added (void)
{
   time_t retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_added(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4353, 4353, 0);
}

static void sl_gtk_text_iter_toggles_tag (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_toggles_tag(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4354, 4354, 0);
}

static void sl_gtk_widget_grab_focus (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_grab_focus(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4355, 4355, 0);
}

static void sl_gtk_text_buffer_insert_markup (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_insert_markup(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4356, 4356, 0);
}

static void sl_gdk_window_process_all_updates (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_window_process_all_updates();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4357, 4357, 0);
}

static void sl_g_utf16_to_ucs4 (void)
{
   gunichar* retval;
   const gunichar2* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_USHORT_TYPE,sizeof(gunichar2),&arg1,0x0);
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_utf16_to_ucs4(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(uint_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4358, 4358, 0);
   finalize_refs(2,arg1_r,arg3_r); 
}

static void sl_g_match_info_fetch_named_pos (void)
{
   gboolean retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_match_info_fetch_named_pos(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4359, 4359, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_gtk_window_set_title (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4360, 4360, 0);
}

static void sl_gtk_entry_get_max_length (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_max_length(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4361, 4361, 0);
}

static void sl_g_socket_set_timeout (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_timeout(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4362, 4362, 0);
}

static void sl_gtk_combo_box_get_add_tearoffs (void)
{
   gboolean retval;
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_get_add_tearoffs(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4363, 4363, 0);
}

static void sl_gdk_display_get_screen (void)
{
   GdkScreen* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_screen(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4364, 4364, 0);
}

static void sl_gtk_cell_area_apply_attributes (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_apply_attributes(arg1, arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4365, 4365, 0);
}

static void sl_gtk_selection_data_get_targets (void)
{
   gboolean retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom** arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkAtom_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_data_get_targets(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4366, 4366, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_frame_get_shadow_type (void)
{
   GtkShadowType retval;
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_frame_get_shadow_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4367, 4367, 0);
}

static void sl_g_dir_rewind (void)
{
   GDir* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDir_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_dir_rewind(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4368, 4368, 0);
}

static void sl_gdk_display_get_monitor_at_window (void)
{
   GdkMonitor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_display_get_monitor_at_window(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4369, 4369, 0);
}

static void sl_g_date_set_time_val (void)
{
   GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GTimeVal_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_date_set_time_val(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4370, 4370, 0);
}

static void sl_g_variant_builder_open (void)
{
   GVariantBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantBuilder_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_variant_builder_open(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4371, 4371, 0);
}

static void sl_g_strcompress (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strcompress(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4372, 4372, 0);
}

static void sl_g_match_info_free (void)
{
   GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_match_info_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4373, 4373, 0);
}

static void sl_gdk_frame_clock_get_refresh_info (void)
{
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint64 arg2;
   gint64* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(gint64),&arg3,0x0);
   gint64* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_LONG_TYPE,sizeof(gint64),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_frame_clock_get_refresh_info(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4374, 4374, 0);
   finalize_refs(2,arg3_r,arg4_r); 
}

static void sl_gtk_selection_add_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTargetEntry* arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_selection_add_targets(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4375, 4375, 0);
}

static void sl_gtk_cell_area_get_cell_allocation (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkCellRenderer* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg6 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_get_cell_allocation(arg1, arg2, arg3, arg4, arg5, arg6);
   (void) SLang_push_cstruct ((VOID_STAR) arg6, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4376, 4376, 0);
}

static void sl_pango_tab_array_get_positions_in_pixels (void)
{
   gboolean retval;
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_tab_array_get_positions_in_pixels(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4377, 4377, 0);
}

static void sl_pango_language_to_string (void)
{
   const char* retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_language_to_string(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4378, 4378, 0);
}

static void sl_gtk_assistant_set_page_type (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkAssistantPageType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_type(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4379, 4379, 0);
}

static void sl_g_settings_backend_changed (void)
{
   GSettingsBackend* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_backend_changed(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4380, 4380, 0);
}

static void sl_gtk_text_iter_backward_search (void)
{
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   GtkTextIter* arg4;
   GtkTextIter* arg5;
   const GtkTextIter* arg6;
   Slirp_Opaque* arg6_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTextIter_Type, (void**)&arg6_o, (void**)&arg6)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg4 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   if ((arg5 = (GtkTextIter *) SLmalloc (sizeof (GtkTextIter))) == NULL)
      goto free_and_return;
   gtk_text_iter_backward_search(arg1, arg2,  arg3, arg4, arg5, arg6);
   (void) SLang_push_opaque (GtkTextIter_Type, arg4, 1);
   (void) SLang_push_opaque (GtkTextIter_Type, arg5, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (4381, 4381, 0);
}

static void sl_gtk_app_chooser_button_append_separator (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_button_append_separator(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4382, 4382, 0);
}

static void sl_g_signal_has_handler_pending (void)
{
   gboolean retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GQuark arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_signal_has_handler_pending(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4383, 4383, 0);
}

static void sl_gtk_text_view_set_indent (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_indent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4384, 4384, 0);
}

static void sl_gtk_menu_button_get_popup (void)
{
   GtkMenu* retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_popup(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4385, 4385, 0);
}

static void sl_gtk_print_context_create_pango_layout (void)
{
   PangoLayout* retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_create_pango_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4386, 4386, 0);
}

static void sl_gtk_tree_view_column_get_title (void)
{
   const gchar* retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4387, 4387, 0);
}

static void sl_gdk_display_supports_clipboard_persistence (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_supports_clipboard_persistence(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4388, 4388, 0);
}

static void sl_gtk_cell_renderer_get_preferred_height_for_width (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_renderer_get_preferred_height_for_width(arg1, arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4389, 4389, 0);
}

static void sl_gtk_text_iter_assign (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_iter_assign(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4390, 4390, 0);
}

static void sl_g_resolver_lookup_by_name_finish (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resolver_lookup_by_name_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4391, 4391, 0);
}

static void sl_gtk_text_view_set_accepts_tab (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_accepts_tab(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4392, 4392, 0);
}

static void sl_g_file_info_get_attribute_boolean (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_boolean(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4393, 4393, 0);
}

static void sl_gtk_window_stick (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_stick(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4394, 4394, 0);
}

static void sl_g_mount_operation_set_is_tcrypt_system_volume (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_is_tcrypt_system_volume(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4395, 4395, 0);
}

static void sl_gtk_button_box_get_child_secondary (void)
{
   gboolean retval;
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_button_box_get_child_secondary(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4396, 4396, 0);
}

static void sl_g_content_type_can_be_executable (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_can_be_executable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4397, 4397, 0);
}

static void sl_g_settings_schema_source_lookup (void)
{
   GSettingsSchema* retval;
   GSettingsSchemaSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_schema_source_lookup(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4398, 4398, 0);
}

static void sl_g_variant_type_string_is_valid (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_string_is_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4399, 4399, 0);
}

static void sl_gtk_tool_button_new (void)
{
   GtkToolItem* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tool_button_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4400, 4400, 0);
}

static void sl_gtk_text_view_get_window (void)
{
   GdkWindow* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextWindowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_window(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4401, 4401, 0);
}

static void sl_pango_layout_iter_get_index (void)
{
   int retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_index(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4402, 4402, 0);
}

static void sl_gdk_window_restack (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_restack(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4403, 4403, 0);
}

static void sl_gtk_tool_button_get_label_widget (void)
{
   GtkWidget* retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_label_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4404, 4404, 0);
}

static void sl_g_strstr_len (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_strstr_len(arg1,  arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4405, 4405, 0);
}

static void sl_gtk_toolbar_get_style (void)
{
   GtkToolbarStyle retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4406, 4406, 0);
}

static void sl_gtk_tooltip_set_tip_area (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_tip_area(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4407, 4407, 0);
}

static void sl_gtk_label_set_label (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4408, 4408, 0);
}

static void sl_gtk_recent_manager_get_items (void)
{
   GList* retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_manager_get_items(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4409, 4409, 0);
}

static void sl_gtk_assistant_set_page_complete (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_complete(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4410, 4410, 0);
}

static void sl_gdk_gl_context_make_current (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_make_current(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4411, 4411, 0);
}

static void sl_g_variant_classify (void)
{
   GVariantClass retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_classify(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4412, 4412, 0);
}

static void sl_gtk_cell_area_box_pack_start (void)
{
   GtkCellAreaBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gboolean arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_box_pack_start(arg1, arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4413, 4413, 0);
}

static void sl_gdk_fullscreen_mode_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_fullscreen_mode_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4414, 4414, 0);
}

static void sl_g_file_create (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileCreateFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_create(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4415, 4415, 0);
}

static void sl_gtk_toggle_button_set_active (void)
{
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toggle_button_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4416, 4416, 0);
}

static void sl_gtk_calendar_select_day (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_select_day(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4417, 4417, 0);
}

static void sl_gtk_recent_manager_purge_items (void)
{
   gint retval;
   GtkRecentManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gtk_recent_manager_purge_items(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4418, 4418, 0);
}

static void sl_gtk_tool_item_get_use_drag_window (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_use_drag_window(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4419, 4419, 0);
}

static void sl_gtk_about_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4420, 4420, 0);
}

static void sl_pango_gravity_get_for_script (void)
{
   PangoGravity retval;
   PangoScript arg1;
   PangoGravity arg2;
   PangoGravityHint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_gravity_get_for_script( arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4421, 4421, 0);
}

static void sl_gtk_clipboard_wait_for_text (void)
{
   gchar* retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_for_text(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4422, 4422, 0);
}

static void sl_gtk_tool_button_set_icon_widget (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_button_set_icon_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4423, 4423, 0);
}

static void sl_g_signal_handlers_destroy (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_signal_handlers_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4424, 4424, 0);
}

static void sl_gtk_accessible_connect_widget_destroyed (void)
{
   GtkAccessible* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_accessible_connect_widget_destroyed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4425, 4425, 0);
}

static void sl_g_clear_object (void)
{
   GObject** arg1;
   Slirp_Ref *arg1_r = ref_new(GObject_Type,sizeof(GObject*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_clear_object(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4426, 4426, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gdk_unicode_to_keyval (void)
{
   guint retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_unicode_to_keyval( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4427, 4427, 0);
}

static void sl_gtk_event_controller_key_new (void)
{
   GtkEventController* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_key_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4428, 4428, 0);
}

static void sl_gdk_cairo_set_source_color (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_set_source_color(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4429, 4429, 0);
}

static void sl_gtk_radio_button_get_group (void)
{
   const GSList* retval;
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_button_get_group(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4430, 4430, 0);
}

static void sl_g_bookmark_file_set_visited (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   time_t arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_visited(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4431, 4431, 0);
}

static void sl_gtk_cell_view_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4432, 4432, 0);
}

static void sl_gtk_tool_item_group_set_collapsed (void)
{
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_group_set_collapsed(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4433, 4433, 0);
}

static void sl_g_strescape (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strescape(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4434, 4434, 0);
}

static void sl_g_variant_take_ref (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_take_ref(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4435, 4435, 0);
}

static void sl_g_value_unset (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_unset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4436, 4436, 0);
}

static void sl_gtk_text_mark_get_deleted (void)
{
   gboolean retval;
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_deleted(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4437, 4437, 0);
}

static void sl_gtk_accel_groups_activate (void)
{
   gboolean retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_groups_activate(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4438, 4438, 0);
}

static void sl_g_settings_backend_path_writable_changed (void)
{
   GSettingsBackend* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_backend_path_writable_changed(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4439, 4439, 0);
}

static void sl_g_file_attribute_info_list_new (void)
{
   GFileAttributeInfoList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_info_list_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4440, 4440, 0);
}

static void sl_gtk_print_job_set_num_copies (void)
{
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_job_set_num_copies(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4441, 4441, 0);
}

static void sl_g_inet_address_new_any (void)
{
   GInetAddress* retval;
   GSocketFamily arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_new_any( arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4442, 4442, 0);
}

static void sl_gtk_recent_info_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4443, 4443, 0);
}

static void sl_gtk_cell_area_attribute_get_column (void)
{
   gint retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_attribute_get_column(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4444, 4444, 0);
}

static void sl_g_file_is_native (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_is_native(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4445, 4445, 0);
}

static void sl_g_unichar_isalnum (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isalnum( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4446, 4446, 0);
}

static void sl_gtk_cell_layout_pack_start (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_layout_pack_start(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4447, 4447, 0);
}

static void sl_g_value_set_uint64 (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint64 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_uint64(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4448, 4448, 0);
}

static void sl_gtk_print_context_get_dpi_y (void)
{
   gdouble retval;
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_context_get_dpi_y(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4449, 4449, 0);
}

static void sl_gtk_builder_new_from_file (void)
{
   GtkBuilder* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_new_from_file(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4450, 4450, 0);
}

static void sl_gtk_tree_view_convert_widget_to_bin_window_coords (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_convert_widget_to_bin_window_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4451, 4451, 0);
}

static void sl_g_signal_connect_closure (void)
{
   gulong retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GClosure* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_signal_connect_closure(arg1, arg2, arg3,  arg4);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4452, 4452, 0);
}

static void sl_g_date_time_format (void)
{
   gchar* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_format(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4453, 4453, 0);
}

static void sl_gtk_widget_size_allocate_with_baseline (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GtkAllocation_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_size_allocate_with_baseline(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GtkAllocation_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4454, 4454, 0);
}

static void sl_gtk_entry_set_icon_tooltip_text (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_tooltip_text(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4455, 4455, 0);
}

static void sl_g_quark_to_string (void)
{
   const gchar* retval;
   GQuark arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_quark_to_string( arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4456, 4456, 0);
}

static void sl_pango_font_description_set_absolute_size (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_absolute_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4457, 4457, 0);
}

static void sl_gtk_window_get_mnemonic_modifier (void)
{
   GdkModifierType retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_mnemonic_modifier(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4458, 4458, 0);
}

static void sl_gtk_printer_get_hard_margins (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_hard_margins(arg1, &arg2, &arg3, &arg4, &arg5);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4459, 4459, 0);
}

static void sl_gtk_gesture_swipe_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_swipe_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4460, 4460, 0);
}

static void sl_gtk_icon_info_new_for_pixbuf (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_info_new_for_pixbuf(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4461, 4461, 0);
}

static void sl_g_get_codeset (void)
{
   gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_codeset();
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4462, 4462, 0);
}

static void sl_gtk_style_context_to_string (void)
{
   char* retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleContextPrintFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_to_string(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4463, 4463, 0);
}

static void sl_gtk_assistant_prepend_page (void)
{
   gint retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_prepend_page(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4464, 4464, 0);
}

static void sl_g_inet_address_get_family (void)
{
   GSocketFamily retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_family(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4465, 4465, 0);
}

static void sl_pango_font_description_get_variant (void)
{
   PangoVariant retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_variant(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4466, 4466, 0);
}

static void sl_gtk_recent_info_get_visited (void)
{
   time_t retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_visited(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4467, 4467, 0);
}

static void sl_g_resource_load (void)
{
   GResource* retval;
   gchar* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_resource_load(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4468, 4468, 0);
}

static void sl_pango_context_get_serial (void)
{
   guint retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_serial(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4469, 4469, 0);
}

static void sl_gtk_text_iter_free (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4470, 4470, 0);
}

static void sl_g_main_context_default (void)
{
   GMainContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_default();
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4471, 4471, 0);
}

static void sl_pango_font_metrics_get_underline_position (void)
{
   int retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_get_underline_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4472, 4472, 0);
}

static void sl_gtk_window_set_interactive_debugging (void)
{
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_interactive_debugging( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4473, 4473, 0);
}

static void sl_gtk_recent_chooser_get_select_multiple (void)
{
   gboolean retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_select_multiple(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4474, 4474, 0);
}

static void sl_gtk_label_get_width_chars (void)
{
   gint retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4475, 4475, 0);
}

static void sl_pango_font_family_is_variable (void)
{
   gboolean retval;
   PangoFontFamily* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_family_is_variable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4476, 4476, 0);
}

static void sl_pango_attr_show_new (void)
{
   PangoAttribute* retval;
   PangoShowFlags arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_show_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4477, 4477, 0);
}

static void sl_g_main_context_release (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_release(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4478, 4478, 0);
}

static void sl_gtk_tree_view_append_column (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumn* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_append_column(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4479, 4479, 0);
}

static void sl_gtk_entry_set_alignment (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_alignment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4480, 4480, 0);
}

static void sl_gtk_file_chooser_set_file (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_set_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4481, 4481, 0);
}

static void sl_pango_font_face_get_face_name (void)
{
   const char* retval;
   PangoFontFace* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_face_get_face_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4482, 4482, 0);
}

static void sl_gtk_print_settings_set_media_type (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_media_type(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4483, 4483, 0);
}

static void sl_gtk_label_set_mnemonic_widget (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_mnemonic_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4484, 4484, 0);
}

static void sl_gtk_text_iter_get_language (void)
{
   PangoLanguage* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_language(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4485, 4485, 0);
}

static void sl_gtk_tree_view_get_vadjustment (void)
{
   GtkAdjustment* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_vadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4486, 4486, 0);
}

static void sl_gtk_event_controller_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4487, 4487, 0);
}

static void sl_g_file_append_to_finish (void)
{
   GFileOutputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_append_to_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4488, 4488, 0);
}

static void sl_gtk_popover_popdown (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_popdown(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4489, 4489, 0);
}

static void sl_g_unichar_break_type (void)
{
   GUnicodeBreakType retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_break_type( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4490, 4490, 0);
}

static void sl_gtk_container_child_type (void)
{
   GType retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_child_type(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4491, 4491, 0);
}

static void sl_g_content_type_get_generic_icon_name (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_generic_icon_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4492, 4492, 0);
}

static void sl_pango_layout_iter_next_line (void)
{
   gboolean retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_next_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4493, 4493, 0);
}

static void sl_g_match_info_ref (void)
{
   GMatchInfo* retval;
   GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_match_info_ref(arg1);
   (void)SLang_push_opaque(GMatchInfo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4494, 4494, 0);
}

static void sl_gtk_selection_data_get_format (void)
{
   gint retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_format(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4495, 4495, 0);
}

static void sl_g_vfs_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_vfs_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4496, 4496, 0);
}

static void sl_g_file_info_list_attributes (void)
{
   char** retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_list_attributes(arg1, arg2);
   push_null_term_str_array (retval, "g_file_info_list_attributes", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4497, 4497, 0);
}

static void sl_gtk_text_iter_backward_line (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4498, 4498, 0);
}

static void sl_pango_font_description_get_stretch (void)
{
   PangoStretch retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_stretch(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4499, 4499, 0);
}

static void sl_gtk_gesture_is_recognized (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_is_recognized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4500, 4500, 0);
}

static void sl_pango_font_description_merge_static (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_merge_static(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4501, 4501, 0);
}

static void sl_gdk_window_lower (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_lower(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4502, 4502, 0);
}

static void sl_gdk_event_copy (void)
{
   GdkEvent* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_copy(arg1);
   (void)SLang_push_opaque(GdkEvent_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4503, 4503, 0);
}

static void sl_gtk_mount_operation_set_parent (void)
{
   GtkMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_mount_operation_set_parent(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4504, 4504, 0);
}

static void sl_g_menu_model_iterate_item_attributes (void)
{
   GMenuAttributeIter* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_model_iterate_item_attributes(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4505, 4505, 0);
}

static void sl_gtk_icon_view_path_is_selected (void)
{
   gboolean retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_view_path_is_selected(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4506, 4506, 0);
}

static void sl_gtk_print_settings_get_scale (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_scale(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4507, 4507, 0);
}

static void sl_g_param_spec_sink (void)
{
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_param_spec_sink(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4508, 4508, 0);
}

static void sl_gtk_print_job_get_reverse (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_reverse(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4509, 4509, 0);
}

static void sl_gtk_entry_completion_compute_prefix (void)
{
   gchar* retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_entry_completion_compute_prefix(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4510, 4510, 0);
}

static void sl_gtk_scrolled_window_get_min_content_height (void)
{
   gint retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_min_content_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4511, 4511, 0);
}

static void sl_g_variant_byteswap (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_byteswap(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4512, 4512, 0);
}

static void sl_gtk_about_dialog_set_website_label (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_website_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4513, 4513, 0);
}

static void sl_gtk_revealer_get_transition_type (void)
{
   GtkRevealerTransitionType retval;
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_get_transition_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4514, 4514, 0);
}

static void sl_gtk_spin_button_get_range (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_get_range(arg1, &arg2, &arg3);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4515, 4515, 0);
}

static void sl_gtk_tree_view_column_set_title (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4516, 4516, 0);
}

static void sl_g_app_launch_context_get_startup_notify_id (void)
{
   char* retval;
   GAppLaunchContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAppInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GList* arg3;
   Slirp_Ref *arg3_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_app_launch_context_get_startup_notify_id(arg1, arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4517, 4517, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gdk_window_geometry_changed (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_geometry_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4518, 4518, 0);
}

static void sl_gtk_text_iter_backward_lines (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_lines(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4519, 4519, 0);
}

static void sl_gdk_pango_layout_line_get_clip_region (void)
{
   cairo_region_t* retval;
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   const gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pango_layout_line_get_clip_region(arg1,  arg2,  arg3, arg4,  arg5);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4520, 4520, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_icon_info_load_icon_finish (void)
{
   GdkPixbuf* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_icon_info_load_icon_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4521, 4521, 0);
}

static void sl_gtk_print_settings_set_bool (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_bool(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4522, 4522, 0);
}

static void sl_gtk_tree_view_get_search_column (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_search_column(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4523, 4523, 0);
}

static void sl_g_mapped_file_new_from_fd (void)
{
   GMappedFile* retval;
   gint arg1;
   gboolean arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mapped_file_new_from_fd( arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GMappedFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4524, 4524, 0);
}

static void sl_g_app_info_set_as_default_for_extension (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_set_as_default_for_extension(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4525, 4525, 0);
}

static void sl_gtk_entry_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4526, 4526, 0);
}

static void sl_gtk_text_buffer_paste_clipboard (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkClipboard* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_paste_clipboard(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4527, 4527, 0);
}

static void sl_gtk_application_window_new (void)
{
   GtkWidget* retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_window_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4528, 4528, 0);
}

static void sl_gtk_list_box_invalidate_sort (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_invalidate_sort(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4529, 4529, 0);
}

static void sl_gtk_app_chooser_button_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_button_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4530, 4530, 0);
}

static void sl_gtk_combo_box_text_append (void)
{
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_text_append(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4531, 4531, 0);
}

static void sl_g_io_channel_set_close_on_unref (void)
{
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_io_channel_set_close_on_unref(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4532, 4532, 0);
}

static void sl_g_file_read_finish (void)
{
   GFileInputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_read_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4533, 4533, 0);
}

static void sl_gtk_gesture_rotate_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_rotate_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4534, 4534, 0);
}

static void sl_gtk_combo_box_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4535, 4535, 0);
}

static void sl_pango_font_get_font_map (void)
{
   PangoFontMap* retval;
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_get_font_map(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4536, 4536, 0);
}

static void sl_gtk_grid_set_column_spacing (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_column_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4537, 4537, 0);
}

static void sl_gtk_stack_set_interpolate_size (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_interpolate_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4538, 4538, 0);
}

static void sl_gtk_text_mark_new (void)
{
   GtkTextMark* retval;
   gchar* arg1;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_new(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4539, 4539, 0);
}

static void sl_gtk_search_entry_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_entry_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4540, 4540, 0);
}

static void sl_gtk_print_settings_set_dither (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_dither(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4541, 4541, 0);
}

static void sl_gtk_font_button_get_font_name (void)
{
   const gchar* retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_font_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4542, 4542, 0);
}

static void sl_gtk_gl_area_set_has_depth_buffer (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_has_depth_buffer(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4543, 4543, 0);
}

static void sl_gtk_spin_button_new_with_range (void)
{
   GtkWidget* retval;
   gdouble arg1;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_new_with_range( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4544, 4544, 0);
}

static void sl_gtk_search_bar_set_search_mode (void)
{
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_search_bar_set_search_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4545, 4545, 0);
}

static void sl_gtk_text_iter_backward_chars (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_chars(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4546, 4546, 0);
}

static void sl_gtk_clipboard_wait_is_rich_text_available (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextBuffer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_clipboard_wait_is_rich_text_available(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4547, 4547, 0);
}

static void sl_g_unichar_toupper (void)
{
   gunichar retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_toupper( arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4548, 4548, 0);
}

static void sl_g_getenv (void)
{
   const gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_getenv(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4549, 4549, 0);
}

static void sl_gtk_adjustment_set_step_increment (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_step_increment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4550, 4550, 0);
}

static void sl_gdk_screen_get_system_visual (void)
{
   GdkVisual* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_system_visual(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4551, 4551, 0);
}

static void sl_g_settings_schema_unref (void)
{
   GSettingsSchema* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_schema_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4552, 4552, 0);
}

static void sl_gtk_color_chooser_dialog_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_color_chooser_dialog_new(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4553, 4553, 0);
}

static void sl_gtk_message_dialog_set_markup (void)
{
   GtkMessageDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_message_dialog_set_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4554, 4554, 0);
}

static void sl_gtk_css_section_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4555, 4555, 0);
}

static void sl_gtk_adjustment_set_page_increment (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_page_increment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4556, 4556, 0);
}

static void sl_gtk_menu_button_get_direction (void)
{
   GtkArrowType retval;
   GtkMenuButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_direction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4557, 4557, 0);
}

static void sl_pango_quantize_line_geometry (void)
{
   int arg1;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   pango_quantize_line_geometry(&arg1, &arg2);
   (void)SLang_push_int(arg1);
   (void)SLang_push_int(arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4558, 4558, 0);
}

static void sl_gtk_popover_popup (void)
{
   GtkPopover* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_popover_popup(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4559, 4559, 0);
}

static void sl_gtk_tree_row_reference_copy (void)
{
   GtkTreeRowReference* retval;
   GtkTreeRowReference* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeRowReference_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_row_reference_copy(arg1);
   (void)SLang_push_opaque(GtkTreeRowReference_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4560, 4560, 0);
}

static void sl_gtk_image_new_from_icon_set (void)
{
   GtkWidget* retval;
   GtkIconSet* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_icon_set(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4561, 4561, 0);
}

static void sl_gtk_button_get_use_stock (void)
{
   gboolean retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_use_stock(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4562, 4562, 0);
}

static void sl_gdk_device_pad_get_n_groups (void)
{
   gint retval;
   GdkDevicePad* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_get_n_groups(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4563, 4563, 0);
}

static void sl_gtk_icon_theme_new (void)
{
   GtkIconTheme* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4564, 4564, 0);
}

static void sl_gtk_icon_theme_choose_icon (void)
{
   GtkIconInfo* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   gint arg3;
   GtkIconLookupFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_choose_icon(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4565, 4565, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_entry_completion_insert_action_markup (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_completion_insert_action_markup(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4566, 4566, 0);
}

static void sl_gtk_render_slider (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   GtkOrientation arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_slider(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4567, 4567, 0);
}

static void sl_gtk_tree_view_get_bin_window (void)
{
   GdkWindow* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_bin_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4568, 4568, 0);
}

static void sl_g_get_user_cache_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_cache_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4569, 4569, 0);
}

static void sl_g_resources_register (void)
{
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_resources_register(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4570, 4570, 0);
}

static void sl_gtk_color_button_set_alpha (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint16 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_color_button_set_alpha(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4571, 4571, 0);
}

static void sl_gtk_scale_button_set_adjustment (void)
{
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scale_button_set_adjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4572, 4572, 0);
}

static void sl_gtk_label_set_lines (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_lines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4573, 4573, 0);
}

static void sl_gtk_print_context_set_cairo_context (void)
{
   GtkPrintContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   double arg3;
   double arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_context_set_cairo_context(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4574, 4574, 0);
}

static void sl_gtk_recent_chooser_get_sort_type (void)
{
   GtkRecentSortType retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_sort_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4575, 4575, 0);
}

static void sl_gtk_tool_item_group_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4576, 4576, 0);
}

static void sl_gtk_tree_view_collapse_row (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_collapse_row(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4577, 4577, 0);
}

static void sl_gdk_device_set_axis_use (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkAxisUse arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_device_set_axis_use(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4578, 4578, 0);
}

static void sl_g_volume_monitor_get_mounts (void)
{
   GList* retval;
   GVolumeMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_monitor_get_mounts(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4579, 4579, 0);
}

static void sl_gtk_pad_controller_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_pad_controller_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4580, 4580, 0);
}

static void sl_gtk_application_is_inhibited (void)
{
   gboolean retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkApplicationInhibitFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_is_inhibited(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4581, 4581, 0);
}

static void sl_g_uri_parse_scheme (void)
{
   char* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_uri_parse_scheme(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4582, 4582, 0);
}

static void sl_g_strrstr_len (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_strrstr_len(arg1,  arg2, arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4583, 4583, 0);
}

static void sl_g_source_get_time (void)
{
   gint64 retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4584, 4584, 0);
}

static void sl_gtk_combo_box_set_popup_fixed_width (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_popup_fixed_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4585, 4585, 0);
}

static void sl_gtk_window_set_default_size (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_default_size(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4586, 4586, 0);
}

static void sl_gtk_render_line (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_line(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4587, 4587, 0);
}

static void sl_gtk_tree_view_expand_to_path (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_expand_to_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4588, 4588, 0);
}

static void sl_pango_font_description_get_weight (void)
{
   PangoWeight retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_weight(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4589, 4589, 0);
}

static void sl_gtk_label_get_max_width_chars (void)
{
   gint retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_max_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4590, 4590, 0);
}

static void sl_gtk_container_child_notify_by_pspec (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GParamSpec* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_container_child_notify_by_pspec(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4591, 4591, 0);
}

static void sl_gtk_widget_get_sensitive (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_sensitive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4592, 4592, 0);
}

static void sl_gtk_spinner_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_spinner_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4593, 4593, 0);
}

static void sl_gtk_accel_label_set_accel (void)
{
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_accel_label_set_accel(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4594, 4594, 0);
}

static void sl_gtk_print_settings_get_dither (void)
{
   const gchar* retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_dither(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4595, 4595, 0);
}

static void sl_pango_layout_line_x_to_index (void)
{
   gboolean retval;
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_line_x_to_index(arg1,  arg2, &arg3, &arg4);
   (void)SLang_push_int(retval);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4596, 4596, 0);
}

static void sl_gtk_selection_data_get_data (void)
{
   const guchar* retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_data(arg1);
   (void)SLang_push_opaque(uchar_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4597, 4597, 0);
}

static void sl_gtk_assistant_set_page_has_padding (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_has_padding(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4598, 4598, 0);
}

static void sl_gtk_print_settings_get_paper_height (void)
{
   gdouble retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_paper_height(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4599, 4599, 0);
}

static void sl_gdk_gl_context_clear_current (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_clear_current();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4600, 4600, 0);
}

static void sl_gtk_lock_button_set_permission (void)
{
   GtkLockButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPermission* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_lock_button_set_permission(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4601, 4601, 0);
}

static void sl_g_menu_prepend (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_prepend(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4602, 4602, 0);
}

static void sl_gtk_file_chooser_add_shortcut_folder_uri (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_add_shortcut_folder_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4603, 4603, 0);
}

static void sl_pango_layout_set_alignment (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAlignment arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_alignment(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4604, 4604, 0);
}

static void sl_gtk_entry_set_icon_from_pixbuf (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_from_pixbuf(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4605, 4605, 0);
}

static void sl_gtk_text_buffer_delete_selection (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_delete_selection(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4606, 4606, 0);
}

static void sl_gtk_label_set_markup (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_markup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4607, 4607, 0);
}

static void sl_gtk_application_new (void)
{
   GtkApplication* retval;
   gchar* arg1;
   GApplicationFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_new(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4608, 4608, 0);
}

static void sl_gtk_tree_model_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4609, 4609, 0);
}

static void sl_g_emblemed_icon_clear_emblems (void)
{
   GEmblemedIcon* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_emblemed_icon_clear_emblems(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4610, 4610, 0);
}

static void sl_g_timer_is_active (void)
{
   gboolean retval;
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_timer_is_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4611, 4611, 0);
}

static void sl_gtk_icon_info_get_display_name (void)
{
   const gchar* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_display_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4612, 4612, 0);
}

static void sl_gtk_separator_tool_item_set_draw (void)
{
   GtkSeparatorToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_separator_tool_item_set_draw(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4613, 4613, 0);
}

static void sl_g_file_read (void)
{
   GFileInputStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_read(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4614, 4614, 0);
}

static void sl_gtk_entry_get_layout (void)
{
   PangoLayout* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4615, 4615, 0);
}

static void sl_g_type_check_class_cast (void)
{
   GTypeClass* retval;
   GTypeClass* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_check_class_cast(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4616, 4616, 0);
}

static void sl_g_strchug (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strchug(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4617, 4617, 0);
}

static void sl_gtk_gesture_get_point (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventSequence* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_get_point(arg1, arg2, &arg3, &arg4);
   (void)SLang_push_int(retval);
   (void)SLang_push_double(arg3);
   (void)SLang_push_double(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4618, 4618, 0);
}

static void sl_gdk_window_process_updates (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_process_updates(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4619, 4619, 0);
}

static void sl_g_socket_listen (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_listen(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4620, 4620, 0);
}

static void sl_g_object_bind_property (void)
{
   GBinding* retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GBindingFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_object_bind_property(arg1, arg2, arg3, arg4,  arg5);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (4621, 4621, 0);
}

static void sl_g_main_loop_get_context (void)
{
   GMainContext* retval;
   GMainLoop* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainLoop_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_main_loop_get_context(arg1);
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4622, 4622, 0);
}

static void sl_gtk_widget_get_double_buffered (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_double_buffered(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4623, 4623, 0);
}

static void sl_g_mount_operation_set_password_save (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GPasswordSave arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_password_save(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4624, 4624, 0);
}

static void sl_g_time_zone_ref (void)
{
   GTimeZone* retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_ref(arg1);
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4625, 4625, 0);
}

static void sl_g_settings_schema_source_ref (void)
{
   GSettingsSchemaSource* retval;
   GSettingsSchemaSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_source_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4626, 4626, 0);
}

static void sl_gtk_file_chooser_button_set_title (void)
{
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_button_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4627, 4627, 0);
}

static void sl_g_menu_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4628, 4628, 0);
}

static void sl_g_inet_address_get_is_multicast (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_multicast(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4629, 4629, 0);
}

static void sl_g_network_monitor_get_network_metered (void)
{
   gboolean retval;
   GNetworkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_monitor_get_network_metered(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4630, 4630, 0);
}

static void sl_gtk_shortcuts_shortcut_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcuts_shortcut_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4631, 4631, 0);
}

static void sl_g_unichar_validate (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_validate( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4632, 4632, 0);
}

static void sl_gtk_assistant_get_page_side_image (void)
{
   GdkPixbuf* retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_assistant_get_page_side_image(arg1, arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4633, 4633, 0);
}

static void sl_gtk_scrolled_window_set_min_content_width (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_min_content_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4634, 4634, 0);
}

static void sl_gdk_seat_get_capabilities (void)
{
   GdkSeatCapabilities retval;
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_capabilities(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4635, 4635, 0);
}

static void sl_g_settings_delay (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_settings_delay(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4636, 4636, 0);
}

static void sl_g_menu_item_new_section (void)
{
   GMenuItem* retval;
   gchar* arg1;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_menu_item_new_section(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4637, 4637, 0);
}

static void sl_gdk_input_mode_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_input_mode_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4638, 4638, 0);
}

static void sl_gtk_event_controller_get_widget (void)
{
   GtkWidget* retval;
   GtkEventController* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_get_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4639, 4639, 0);
}

static void sl_gtk_print_settings_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4640, 4640, 0);
}

static void sl_gtk_tree_row_reference_valid (void)
{
   gboolean retval;
   GtkTreeRowReference* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeRowReference_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_row_reference_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4641, 4641, 0);
}

static void sl_gtk_button_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4642, 4642, 0);
}

static void sl_gtk_list_box_get_activate_on_single_click (void)
{
   gboolean retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_activate_on_single_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4643, 4643, 0);
}

static void sl_gtk_tree_view_column_clicked (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_clicked(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4644, 4644, 0);
}

static void sl_gtk_selection_data_get_data_type (void)
{
   GdkAtom retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_data_type(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4645, 4645, 0);
}

static void sl_gtk_style_context_new (void)
{
   GtkStyleContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4646, 4646, 0);
}

static void sl_pango_font_description_set_variations_static (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_set_variations_static(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4647, 4647, 0);
}

static void sl_g_type_get_instance_count (void)
{
   int retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_get_instance_count( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4648, 4648, 0);
}

static void sl_gtk_shortcut_label_set_accelerator (void)
{
   GtkShortcutLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_shortcut_label_set_accelerator(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4649, 4649, 0);
}

static void sl_gtk_range_set_show_fill_level (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_show_fill_level(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4650, 4650, 0);
}

static void sl_g_object_bind_property_with_closures (void)
{
   GBinding* retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GBindingFlags arg5;
   GClosure* arg6;
   Slirp_Opaque* arg6_o = NULL;
   GClosure* arg7;
   Slirp_Opaque* arg7_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg7, &arg7_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg6, &arg6_o)) goto free_and_return_7;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_object_bind_property_with_closures(arg1, arg2, arg3, arg4,  arg5, arg6, arg7);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_6:
   SLang_free_opaque(arg6_o);
free_and_return_7:
   SLang_free_opaque(arg7_o);
usage_label:
   if (issue_usage) Slirp_usage (4651, 4651, 0);
}

static void sl_gtk_tree_view_get_activate_on_single_click (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_activate_on_single_click(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4652, 4652, 0);
}

static void sl_gtk_file_chooser_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4653, 4653, 0);
}

static void sl_gtk_font_chooser_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4654, 4654, 0);
}

static void sl_gtk_level_bar_set_max_value (void)
{
   GtkLevelBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_level_bar_set_max_value(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4655, 4655, 0);
}

static void sl_gtk_get_interface_age (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_interface_age();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4656, 4656, 0);
}

static void sl_gtk_application_get_accels_for_action (void)
{
   gchar** retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_application_get_accels_for_action(arg1, arg2);
   push_null_term_str_array (retval, "gtk_application_get_accels_for_action", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4657, 4657, 0);
}

static void sl_gtk_recent_info_get_display_name (void)
{
   const gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_display_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4658, 4658, 0);
}

static void sl_gtk_progress_bar_pulse (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_pulse(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4659, 4659, 0);
}

static void sl_gtk_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4660, 4660, 0);
}

static void sl_gtk_app_chooser_widget_get_show_fallback (void)
{
   gboolean retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_show_fallback(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4661, 4661, 0);
}

static void sl_gtk_switch_set_active (void)
{
   GtkSwitch* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_switch_set_active(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4662, 4662, 0);
}

static void sl_gtk_tree_view_set_headers_visible (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_headers_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4663, 4663, 0);
}

static void sl_gtk_text_buffer_insert (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_insert(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4664, 4664, 0);
}

static void sl_gtk_recent_filter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_filter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4665, 4665, 0);
}

static void sl_gtk_window_is_maximized (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_is_maximized(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4666, 4666, 0);
}

static void sl_g_file_info_set_edit_name (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_edit_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4667, 4667, 0);
}

static void sl_gtk_font_button_get_show_size (void)
{
   gboolean retval;
   GtkFontButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_get_show_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4668, 4668, 0);
}

static void sl_gtk_style_context_set_scale (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_set_scale(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4669, 4669, 0);
}

static void sl_g_utf8_strchr (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   gunichar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strchr(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4670, 4670, 0);
}

static void sl_gtk_print_settings_to_file (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_print_settings_to_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4671, 4671, 0);
}

static void sl_gtk_tooltip_set_icon_from_stock (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_icon_from_stock(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4672, 4672, 0);
}

static void sl_gtk_calendar_set_detail_height_rows (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_set_detail_height_rows(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4673, 4673, 0);
}

static void sl_pango_layout_get_ellipsize (void)
{
   PangoEllipsizeMode retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_ellipsize(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4674, 4674, 0);
}

static void sl_gtk_widget_in_destruction (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_in_destruction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4675, 4675, 0);
}

static void sl_gtk_toggle_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4676, 4676, 0);
}

static void sl_gtk_print_job_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4677, 4677, 0);
}

static void sl_gtk_cell_area_box_new (void)
{
   GtkCellArea* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_box_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4678, 4678, 0);
}

static void sl_gtk_tree_view_column_clear (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4679, 4679, 0);
}

static void sl_gtk_tree_view_remove_column (void)
{
   gint retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeViewColumn* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_remove_column(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4680, 4680, 0);
}

static void sl_gdk_screen_set_resolution (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_screen_set_resolution(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4681, 4681, 0);
}

static void sl_gtk_adjustment_set_upper (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_set_upper(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4682, 4682, 0);
}

static void sl_gtk_widget_compute_expand (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_compute_expand(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4683, 4683, 0);
}

static void sl_gtk_page_setup_set_right_margin (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   GtkUnit arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_page_setup_set_right_margin(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4684, 4684, 0);
}

static void sl_g_menu_item_new_from_model (void)
{
   GMenuItem* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_item_new_from_model(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4685, 4685, 0);
}

static void sl_g_app_info_can_remove_supports_type (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_can_remove_supports_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4686, 4686, 0);
}

static void sl_gtk_places_sidebar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4687, 4687, 0);
}

static void sl_gtk_tree_path_compare (void)
{
   gint retval;
   const GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_path_compare(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4688, 4688, 0);
}

static void sl_gtk_text_view_set_editable (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_editable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4689, 4689, 0);
}

static void sl_g_cancellable_pop_current (void)
{
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_cancellable_pop_current(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4690, 4690, 0);
}

static void sl_gtk_app_chooser_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4691, 4691, 0);
}

static void sl_gtk_application_add_window (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_add_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4692, 4692, 0);
}

static void sl_g_inet_address_get_is_mc_org_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_mc_org_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4693, 4693, 0);
}

static void sl_gtk_flow_box_set_row_spacing (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_row_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4694, 4694, 0);
}

static void sl_g_object_remove_weak_pointer (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(gpointer),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_object_remove_weak_pointer(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4695, 4695, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_pango_attr_foreground_alpha_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_foreground_alpha_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4696, 4696, 0);
}

static void sl_gtk_frame_set_label_widget (void)
{
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_frame_set_label_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4697, 4697, 0);
}

static void sl_g_action_name_is_valid (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_action_name_is_valid(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4698, 4698, 0);
}

static void sl_gdk_device_tool_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_tool_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4699, 4699, 0);
}

static void sl_gtk_message_dialog_new (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gchar* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg5, NULL)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_5;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto free_and_return_5;
   issue_usage = 0;

   retval = gtk_message_dialog_new(arg1,  arg2,  arg3,  arg4, arg5);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_5:
   SLang_free_slstring(arg5);
usage_label:
   if (issue_usage) Slirp_usage (4700, 4700, 0);
}

static void sl_gtk_scale_set_value_pos (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPositionType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_set_value_pos(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4701, 4701, 0);
}

static void sl_g_input_stream_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_input_stream_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4702, 4702, 0);
}

static void sl_g_variant_type_hash (void)
{
   guint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4703, 4703, 0);
}

static void sl_gtk_text_view_get_overwrite (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_overwrite(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4704, 4704, 0);
}

static void sl_pango_language_get_sample_string (void)
{
   const char* retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_language_get_sample_string(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4705, 4705, 0);
}

static void sl_pango_coverage_new (void)
{
   PangoCoverage* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_new();
   (void)SLang_push_opaque(PangoCoverage_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4706, 4706, 0);
}

static void sl_gdk_window_set_transient_for (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_transient_for(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4707, 4707, 0);
}

static void sl_gtk_window_remove_mnemonic (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_window_remove_mnemonic(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4708, 4708, 0);
}

static void sl_g_iconv_open (void)
{
   GIConv retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_iconv_open(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4709, 4709, 0);
}

static void sl_gtk_toggle_tool_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_tool_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4710, 4710, 0);
}

static void sl_g_file_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4711, 4711, 0);
}

static void sl_gtk_text_iter_get_visible_line_index (void)
{
   gint retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_visible_line_index(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4712, 4712, 0);
}

static void sl_gtk_widget_set_realized (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_realized(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4713, 4713, 0);
}

static void sl_pango_font_description_free (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4714, 4714, 0);
}

static void sl_pango_attr_gravity_hint_new (void)
{
   PangoAttribute* retval;
   PangoGravityHint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_gravity_hint_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4715, 4715, 0);
}

static void sl_gtk_cell_layout_clear_attributes (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_layout_clear_attributes(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4716, 4716, 0);
}

static void sl_gtk_combo_box_set_entry_text_column (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_entry_text_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4717, 4717, 0);
}

static void sl_gtk_image_set_from_icon_name (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_icon_name(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4718, 4718, 0);
}

static void sl_gtk_widget_get_halign (void)
{
   GtkAlign retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_halign(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4719, 4719, 0);
}

static void sl_g_date_time_get_day_of_year (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_day_of_year(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4720, 4720, 0);
}

static void sl_g_ascii_strup (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_strup(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4721, 4721, 0);
}

static void sl_gtk_file_filter_to_gvariant (void)
{
   GVariant* retval;
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_to_gvariant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4722, 4722, 0);
}

static void sl_gtk_about_dialog_get_website (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_website(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4723, 4723, 0);
}

static void sl_g_file_attribute_info_list_add (void)
{
   GFileAttributeInfoList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GFileAttributeType arg3;
   GFileAttributeInfoFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_attribute_info_list_add(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4724, 4724, 0);
}

static void sl_gdk_window_get_events (void)
{
   GdkEventMask retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_events(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4725, 4725, 0);
}

static void sl_gtk_gesture_zoom_get_scale_delta (void)
{
   gdouble retval;
   GtkGestureZoom* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_zoom_get_scale_delta(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4726, 4726, 0);
}

static void sl_gtk_check_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4727, 4727, 0);
}

static void sl_g_key_file_set_comment (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg3, NULL)) goto free_and_return_4;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_key_file_set_comment(arg1, arg2, arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (4728, 4728, 0);
}

static void sl_g_uri_list_extract_uris (void)
{
   gchar** retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_uri_list_extract_uris(arg1);
   push_null_term_str_array (retval, "g_uri_list_extract_uris", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4729, 4729, 0);
}

static void sl_gdk_pixbuf_format_copy (void)
{
   GdkPixbufFormat* retval;
   const GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_copy(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4730, 4730, 0);
}

static void sl_g_value_get_char (void)
{
   gchar retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_char(arg1);
   (void)SLang_push_char(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4731, 4731, 0);
}

static void sl_g_signal_handler_disconnect (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gulong arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_signal_handler_disconnect(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4732, 4732, 0);
}

static void sl_gtk_print_settings_set_n_copies (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_n_copies(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4733, 4733, 0);
}

static void sl_gtk_widget_path_iter_has_name (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_name(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4734, 4734, 0);
}

static void sl_gtk_check_menu_item_get_active (void)
{
   gboolean retval;
   GtkCheckMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4735, 4735, 0);
}

static void sl_gtk_recent_info_has_application (void)
{
   gboolean retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_recent_info_has_application(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4736, 4736, 0);
}

static void sl_gtk_widget_override_cursor (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg3, (void**)GdkRGBA_Layout)) goto usage_label;
   if (-1 == pop_nullable(0, (void**)&arg2, (void**)GdkRGBA_Layout)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_override_cursor(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4737, 4737, 0);
}

static void sl_g_date_time_get_microsecond (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_microsecond(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4738, 4738, 0);
}

static void sl_gdk_drawing_context_get_cairo_context (void)
{
   cairo_t* retval;
   GdkDrawingContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drawing_context_get_cairo_context(arg1);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4739, 4739, 0);
}

static void sl_gtk_label_set_ellipsize (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoEllipsizeMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_ellipsize(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4740, 4740, 0);
}

static void sl_pango_layout_get_font_description (void)
{
   const PangoFontDescription* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_font_description(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4741, 4741, 0);
}

static void sl_gdk_display_manager_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_manager_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4742, 4742, 0);
}

static void sl_gtk_expander_set_use_underline (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_use_underline(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4743, 4743, 0);
}

static void sl_gdk_monitor_get_display (void)
{
   GdkDisplay* retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4744, 4744, 0);
}

static void sl_gtk_button_set_use_underline (void)
{
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_button_set_use_underline(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4745, 4745, 0);
}

static void sl_gdk_screen_get_monitor_geometry (void)
{
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_screen_get_monitor_geometry(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4746, 4746, 0);
}

static void sl_gtk_widget_set_opacity (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   double arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_opacity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4747, 4747, 0);
}

static void sl_gtk_places_sidebar_get_show_recent (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_recent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4748, 4748, 0);
}

static void sl_gtk_file_chooser_button_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkFileChooserAction arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_new(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4749, 4749, 0);
}

static void sl_gtk_widget_add_events (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_add_events(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4750, 4750, 0);
}

static void sl_gtk_file_chooser_set_show_hidden (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_show_hidden(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4751, 4751, 0);
}

static void sl_gtk_paper_size_new_from_ipp (void)
{
   GtkPaperSize* retval;
   gchar* arg1;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_new_from_ipp(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4752, 4752, 0);
}

static void sl_gtk_tree_view_column_cell_is_visible (void)
{
   gboolean retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_cell_is_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4753, 4753, 0);
}

static void sl_gtk_dialog_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4754, 4754, 0);
}

static void sl_gtk_widget_path_append_type (void)
{
   gint retval;
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_append_type(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4755, 4755, 0);
}

static void sl_gtk_range_get_show_fill_level (void)
{
   gboolean retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_show_fill_level(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4756, 4756, 0);
}

static void sl_g_null_settings_backend_new (void)
{
   GSettingsBackend* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_null_settings_backend_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4757, 4757, 0);
}

static void sl_g_vfs_get_file_for_uri (void)
{
   GFile* retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_vfs_get_file_for_uri(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4758, 4758, 0);
}

static void sl_gtk_widget_set_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4759, 4759, 0);
}

static void sl_g_uri_unescape_string (void)
{
   char* retval;
   char* arg1;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_uri_unescape_string(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4760, 4760, 0);
}

static void sl_gtk_file_chooser_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4761, 4761, 0);
}

static void sl_gtk_widget_path_iter_has_qclass (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GQuark arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_qclass(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4762, 4762, 0);
}

static void sl_gtk_printer_get_icon_name (void)
{
   const gchar* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_icon_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4763, 4763, 0);
}

static void sl_gdk_keymap_get_entries_for_keyval (void)
{
   gboolean retval;
   GdkKeymap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkKeymapKey** arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkKeymapKey_ptr_ptr_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gdk_keymap_get_entries_for_keyval(arg1,  arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4764, 4764, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_flow_box_select_all (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4765, 4765, 0);
}

static void sl_gtk_window_present (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_present(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4766, 4766, 0);
}

static void sl_gtk_label_get_justify (void)
{
   GtkJustification retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_justify(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4767, 4767, 0);
}

static void sl_g_inet_address_get_is_link_local (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_link_local(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4768, 4768, 0);
}

static void sl_gtk_cell_area_event (void)
{
   gint retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkEvent* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_area_event(arg1, arg2, arg3, arg4, arg5,  arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4769, 4769, 0);
}

static void sl_gtk_label_set_line_wrap_mode (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoWrapMode arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_line_wrap_mode(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4770, 4770, 0);
}

static void sl_gdk_drawing_context_get_window (void)
{
   GdkWindow* retval;
   GdkDrawingContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drawing_context_get_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4771, 4771, 0);
}

static void sl_g_network_address_new_loopback (void)
{
   GSocketConnectable* retval;
   guint16 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_new_loopback( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4772, 4772, 0);
}

static void sl_gtk_window_reshow_with_initial_size (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_reshow_with_initial_size(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4773, 4773, 0);
}

static void sl_gtk_text_tag_event (void)
{
   gboolean retval;
   GtkTextTag* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GObject* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkEvent* arg3;
   Slirp_Opaque* arg3_o = NULL;
   const GtkTextIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_tag_event(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4774, 4774, 0);
}

static void sl_gtk_toolbar_unset_icon_size (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toolbar_unset_icon_size(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4775, 4775, 0);
}

static void sl_g_mapped_file_new (void)
{
   GMappedFile* retval;
   gchar* arg1;
   gboolean arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_mapped_file_new(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GMappedFile_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4776, 4776, 0);
}

static void sl_gtk_menu_popup_at_rect (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkGravity arg4;
   GdkGravity arg5;
   const GdkEvent* arg6;
   Slirp_Opaque* arg6_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == pop_nullable(GdkEvent_Type, (void**)&arg6_o, (void**)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto free_and_return_6;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_6;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GdkRectangle_Layout)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_popup_at_rect(arg1, arg2, arg3,  arg4,  arg5, arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRectangle_Layout);
free_and_return_6:
   SLang_free_opaque(arg6_o);
usage_label:
   if (issue_usage) Slirp_usage (4777, 4777, 0);
}

static void sl_gtk_application_window_set_show_menubar (void)
{
   GtkApplicationWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_application_window_set_show_menubar(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4778, 4778, 0);
}

static void sl_g_type_init_with_debug_flags (void)
{
   GTypeDebugFlags arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_type_init_with_debug_flags( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4779, 4779, 0);
}

static void sl_gtk_app_chooser_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4780, 4780, 0);
}

static void sl_gdk_pixbuf_add_alpha (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   guchar arg3;
   guchar arg4;
   guchar arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uchar((unsigned char*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_add_alpha(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4781, 4781, 0);
}

static void sl_gtk_cell_area_attribute_disconnect (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_attribute_disconnect(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4782, 4782, 0);
}

static void sl_gtk_tooltip_trigger_tooltip_query (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tooltip_trigger_tooltip_query(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4783, 4783, 0);
}

static void sl_gtk_spin_button_get_increments (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_get_increments(arg1, &arg2, &arg3);
   (void)SLang_push_double(arg2);
   (void)SLang_push_double(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4784, 4784, 0);
}

static void sl_gtk_places_sidebar_set_drop_targets_visible (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   GdkDragContext* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_places_sidebar_set_drop_targets_visible(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4785, 4785, 0);
}

static void sl_gdk_pixbuf_composite_color (void)
{
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   double arg7;
   double arg8;
   double arg9;
   double arg10;
   GdkInterpType arg11;
   int arg12;
   int arg13;
   int arg14;
   int arg15;
   guint32 arg16;
   guint32 arg17;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 17) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg17)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg16)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg15)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg14)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg13)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg12)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg11)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg10)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg9)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_pixbuf_composite_color(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8,  arg9,  arg10,  arg11,  arg12,  arg13,  arg14,  arg15,  arg16,  arg17);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4786, 4786, 0);
}

static void sl_g_simple_action_group_lookup (void)
{
   GAction* retval;
   GSimpleActionGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_simple_action_group_lookup(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4787, 4787, 0);
}

static void sl_gtk_cell_area_create_context (void)
{
   GtkCellAreaContext* retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_create_context(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4788, 4788, 0);
}

static void sl_gtk_cell_view_set_background_color (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkColor* arg2 = (GdkColor*) alloca(sizeof(GdkColor));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkColor_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_view_set_background_color(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkColor_Layout);
usage_label:
   if (issue_usage) Slirp_usage (4789, 4789, 0);
}

static void sl_gdk_window_get_frame_clock (void)
{
   GdkFrameClock* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_frame_clock(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4790, 4790, 0);
}

static void sl_g_mount_get_drive (void)
{
   GDrive* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_drive(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4791, 4791, 0);
}

static void sl_g_regex_match_all (void)
{
   gboolean retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GRegexMatchFlags arg3;
   GMatchInfo** arg4;
   Slirp_Ref *arg4_r = ref_new(GMatchInfo_Type,sizeof(GMatchInfo*),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_match_all(arg1, arg2,  arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4792, 4792, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_text_mark_get_name (void)
{
   const gchar* retval;
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4793, 4793, 0);
}

static void sl_gdk_selection_owner_set_for_display (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkAtom arg3;
   Slirp_Opaque* arg3_o = NULL;
   guint32 arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_selection_owner_set_for_display(arg1, arg2, arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4794, 4794, 0);
}

static void sl_gtk_lock_button_get_permission (void)
{
   GPermission* retval;
   GtkLockButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_lock_button_get_permission(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4795, 4795, 0);
}

static void sl_gtk_cell_renderer_get_padding (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_get_padding(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4796, 4796, 0);
}

static void sl_gtk_text_tag_table_add (void)
{
   gboolean retval;
   GtkTextTagTable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_tag_table_add(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4797, 4797, 0);
}

static void sl_gtk_printer_get_backend (void)
{
   GtkPrintBackend* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_backend(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4798, 4798, 0);
}

static void sl_gtk_widget_set_parent_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_parent_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4799, 4799, 0);
}

static void sl_gtk_toggle_button_get_mode (void)
{
   gboolean retval;
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_get_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4800, 4800, 0);
}

static void sl_gtk_button_get_use_underline (void)
{
   gboolean retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_use_underline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4801, 4801, 0);
}

static void sl_pango_layout_get_justify (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_justify(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4802, 4802, 0);
}

static void sl_g_date_time_get_day_of_month (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_day_of_month(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4803, 4803, 0);
}

static void sl_g_resources_unregister (void)
{
   GResource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_resources_unregister(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4804, 4804, 0);
}

static void sl_g_socket_condition_wait (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOCondition arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_socket_condition_wait(arg1,  arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4805, 4805, 0);
}

static void sl_pango_font_description_set_stretch (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoStretch arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_stretch(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4806, 4806, 0);
}

static void sl_gtk_label_set_track_visited_links (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_track_visited_links(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4807, 4807, 0);
}

static void sl_gtk_grid_get_row_spacing (void)
{
   guint retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_row_spacing(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4808, 4808, 0);
}

static void sl_g_file_set_attribute_byte_string (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_byte_string(arg1, arg2, arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (4809, 4809, 0);
}

static void sl_gdk_window_set_keep_above (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_keep_above(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4810, 4810, 0);
}

static void sl_g_date_time_new_utc (void)
{
   GDateTime* retval;
   gint arg1;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_utc( arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4811, 4811, 0);
}

static void sl_gtk_printer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4812, 4812, 0);
}

static void sl_g_file_query_exists (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_query_exists(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4813, 4813, 0);
}

static void sl_pango_cairo_show_glyph_string (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFont* arg2;
   Slirp_Opaque* arg2_o = NULL;
   PangoGlyphString* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoGlyphString_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_show_glyph_string(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4814, 4814, 0);
}

static void sl_gtk_window_resize_grip_is_visible (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_resize_grip_is_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4815, 4815, 0);
}

static void sl_g_hmac_ref (void)
{
   GHmac* retval;
   GHmac* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GHmac_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_hmac_ref(arg1);
   (void)SLang_push_opaque(GHmac_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4816, 4816, 0);
}

static void sl_gtk_window_set_resizable (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_resizable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4817, 4817, 0);
}

static void sl_g_socket_get_credentials (void)
{
   GCredentials* retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_socket_get_credentials(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4818, 4818, 0);
}

static void sl_gtk_cell_renderer_toggle_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_toggle_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4819, 4819, 0);
}

static void sl_g_object_thaw_notify (void)
{
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_object_thaw_notify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4820, 4820, 0);
}

static void sl_gtk_container_set_reallocate_redraws (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_set_reallocate_redraws(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4821, 4821, 0);
}

static void sl_gtk_range_get_restrict_to_fill_level (void)
{
   gboolean retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_restrict_to_fill_level(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4822, 4822, 0);
}

static void sl_gtk_assistant_set_page_header_image (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GdkPixbuf_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_header_image(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4823, 4823, 0);
}

static void sl_gtk_recent_chooser_get_limit (void)
{
   gint retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_limit(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4824, 4824, 0);
}

static void sl_g_object_interface_install_property (void)
{
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   GParamSpec* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_object_interface_install_property(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4825, 4825, 0);
}

static void sl_gtk_file_chooser_set_current_folder (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_set_current_folder(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4826, 4826, 0);
}

static void sl_gtk_text_iter_is_end (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_is_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4827, 4827, 0);
}

static void sl_g_variant_print (void)
{
   gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_print(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4828, 4828, 0);
}

static void sl_gdk_screen_width (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_width();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4829, 4829, 0);
}

static void sl_gtk_icon_theme_load_icon_for_scale (void)
{
   GdkPixbuf* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint arg4;
   GtkIconLookupFlags arg5;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = gtk_icon_theme_load_icon_for_scale(arg1, arg2,  arg3,  arg4,  arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4830, 4830, 0);
}

static void sl_gtk_label_get_single_line_mode (void)
{
   gboolean retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_single_line_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4831, 4831, 0);
}

static void sl_g_app_info_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4832, 4832, 0);
}

static void sl_gtk_header_bar_get_title (void)
{
   const gchar* retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_title(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4833, 4833, 0);
}

static void sl_gtk_window_get_modal (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_modal(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4834, 4834, 0);
}

static void sl_gtk_application_get_actions_for_accel (void)
{
   gchar** retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_application_get_actions_for_accel(arg1, arg2);
   push_null_term_str_array (retval, "gtk_application_get_actions_for_accel", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4835, 4835, 0);
}

static void sl_pango_context_set_font_description (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_context_set_font_description(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4836, 4836, 0);
}

static void sl_gtk_print_settings_get_int_with_default (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_settings_get_int_with_default(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4837, 4837, 0);
}

static void sl_gtk_list_box_get_row_at_y (void)
{
   GtkListBoxRow* retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_row_at_y(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4838, 4838, 0);
}

static void sl_pango_layout_set_width (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4839, 4839, 0);
}

static void sl_gtk_text_iter_in_range (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_in_range(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4840, 4840, 0);
}

static void sl_gtk_about_dialog_get_logo (void)
{
   GdkPixbuf* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_logo(arg1);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4841, 4841, 0);
}

static void sl_gtk_notebook_append_page_menu (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkWidget* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_append_page_menu(arg1, arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4842, 4842, 0);
}

static void sl_gtk_requisition_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_requisition_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4843, 4843, 0);
}

static void sl_gdk_frame_clock_get_current_timings (void)
{
   GdkFrameTimings* retval;
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_clock_get_current_timings(arg1);
   (void)SLang_push_opaque(GdkFrameTimings_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4844, 4844, 0);
}

static void sl_g_simple_action_group_add_entries (void)
{
   GSimpleActionGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GActionEntry* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gpointer arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_simple_action_group_add_entries(arg1, arg2,  arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4845, 4845, 0);
}

static void sl_gtk_about_dialog_set_license_type (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkLicense arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_about_dialog_set_license_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4846, 4846, 0);
}

static void sl_gtk_render_frame (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_frame(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4847, 4847, 0);
}

static void sl_gtk_range_get_fill_level (void)
{
   gdouble retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_fill_level(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4848, 4848, 0);
}

static void sl_gdk_window_get_geometry (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_geometry(arg1, &arg2, &arg3, &arg4, &arg5);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4849, 4849, 0);
}

static void sl_gtk_entry_set_icon_from_gicon (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   GIcon* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_from_gicon(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4850, 4850, 0);
}

static void sl_gtk_label_set_yalign (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_yalign(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4851, 4851, 0);
}

static void sl_g_cancellable_set_error_if_cancelled (void)
{
   gboolean retval;
   GCancellable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_cancellable_set_error_if_cancelled(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4852, 4852, 0);
}

static void sl_gtk_invisible_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_invisible_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4853, 4853, 0);
}

static void sl_gtk_list_store_move_after (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_store_move_after(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4854, 4854, 0);
}

static void sl_gtk_tree_path_prev (void)
{
   gboolean retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_prev(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4855, 4855, 0);
}

static void sl_g_bytes_icon_new (void)
{
   GIcon* retval;
   GBytes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_bytes_icon_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4856, 4856, 0);
}

static void sl_gtk_cell_renderer_get_visible (void)
{
   gboolean retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_get_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4857, 4857, 0);
}

static void sl_gtk_text_buffer_get_char_count (void)
{
   gint retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_char_count(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4858, 4858, 0);
}

static void sl_gdk_device_get_last_event_window (void)
{
   GdkWindow* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_last_event_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4859, 4859, 0);
}

static void sl_gdk_device_tool_get_tool_type (void)
{
   GdkDeviceToolType retval;
   GdkDeviceTool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_tool_get_tool_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4860, 4860, 0);
}

static void sl_gtk_cell_area_stop_editing (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_stop_editing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4861, 4861, 0);
}

static void sl_pango_layout_get_indent (void)
{
   int retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_indent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4862, 4862, 0);
}

static void sl_g_date_time_to_timezone (void)
{
   GDateTime* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeZone* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_time_to_timezone(arg1, arg2);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4863, 4863, 0);
}

static void sl_gtk_cell_renderer_toggle_get_active (void)
{
   gboolean retval;
   GtkCellRendererToggle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_toggle_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4864, 4864, 0);
}

static void sl_gtk_accel_label_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_label_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4865, 4865, 0);
}

static void sl_gdk_event_get_event_sequence (void)
{
   GdkEventSequence* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_event_sequence(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4866, 4866, 0);
}

static void sl_gtk_selection_data_set_text (void)
{
   gboolean retval;
   GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_data_set_text(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4867, 4867, 0);
}

static void sl_g_bookmark_file_load_from_data_dirs (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_load_from_data_dirs(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4868, 4868, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_pango_cairo_context_get_resolution (void)
{
   double retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_context_get_resolution(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4869, 4869, 0);
}

static void sl_gtk_color_chooser_get_use_alpha (void)
{
   gboolean retval;
   GtkColorChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_chooser_get_use_alpha(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4870, 4870, 0);
}

static void sl_gtk_entry_get_icon_activatable (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_icon_activatable(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4871, 4871, 0);
}

static void sl_gtk_entry_buffer_delete_text (void)
{
   guint retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_delete_text(arg1,  arg2,  arg3);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4872, 4872, 0);
}

static void sl_gtk_tree_view_column_set_clickable (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_clickable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4873, 4873, 0);
}

static void sl_g_binding_get_flags (void)
{
   GBindingFlags retval;
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4874, 4874, 0);
}

static void sl_gdk_window_merge_child_shapes (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_merge_child_shapes(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4875, 4875, 0);
}

static void sl_gtk_widget_set_name (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_set_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4876, 4876, 0);
}

static void sl_gtk_font_chooser_get_font_family (void)
{
   PangoFontFamily* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_family(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4877, 4877, 0);
}

static void sl_gtk_gesture_zoom_new (void)
{
   GtkGesture* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_zoom_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4878, 4878, 0);
}

static void sl_g_bookmark_file_get_size (void)
{
   gint retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_bookmark_file_get_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4879, 4879, 0);
}

static void sl_gtk_tool_item_get_orientation (void)
{
   GtkOrientation retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4880, 4880, 0);
}

static void sl_gtk_icon_view_get_spacing (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_view_get_spacing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4881, 4881, 0);
}

static void sl_gdk_screen_get_rgba_visual (void)
{
   GdkVisual* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_rgba_visual(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4882, 4882, 0);
}

static void sl_gtk_application_list_action_descriptions (void)
{
   gchar** retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_list_action_descriptions(arg1);
   push_null_term_str_array (retval, "gtk_application_list_action_descriptions", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4883, 4883, 0);
}

static void sl_g_regex_split_simple (void)
{
   gchar** retval;
   gchar* arg1;
   gchar* arg2;
   GRegexCompileFlags arg3;
   GRegexMatchFlags arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_regex_split_simple(arg1, arg2,  arg3,  arg4);
   push_null_term_str_array (retval, "g_regex_split_simple", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4884, 4884, 0);
}

static void sl_gtk_tree_view_column_get_sizing (void)
{
   GtkTreeViewColumnSizing retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_sizing(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4885, 4885, 0);
}

static void sl_g_param_spec_get_nick (void)
{
   const gchar* retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_get_nick(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4886, 4886, 0);
}

static void sl_gtk_paper_size_is_ipp (void)
{
   gboolean retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_is_ipp(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4887, 4887, 0);
}

static void sl_gtk_style_context_restore (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_restore(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4888, 4888, 0);
}

static void sl_gtk_button_box_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_box_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4889, 4889, 0);
}

static void sl_gdk_display_is_closed (void)
{
   gboolean retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_is_closed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4890, 4890, 0);
}

static void sl_gtk_rgb_to_hsv (void)
{
   gdouble arg1;
   gdouble arg2;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_rgb_to_hsv( arg1,  arg2,  arg3, &arg4, &arg5, &arg6);
   (void)SLang_push_double(arg4);
   (void)SLang_push_double(arg5);
   (void)SLang_push_double(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4891, 4891, 0);
}

static void sl_gdk_screen_height_mm (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_height_mm();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4892, 4892, 0);
}

static void sl_gtk_text_view_get_editable (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_editable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4893, 4893, 0);
}

static void sl_g_file_copy_attributes (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GFileCopyFlags arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_file_copy_attributes(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4894, 4894, 0);
}

static void sl_gtk_file_chooser_set_current_folder_file (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_file_chooser_set_current_folder_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4895, 4895, 0);
}

static void sl_gtk_widget_path_iter_has_region (void)
{
   gboolean retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   GtkRegionFlags* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(GtkRegionFlags),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gtk_widget_path_iter_has_region(arg1,  arg2, arg3, arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4896, 4896, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_text_view_forward_display_line_end (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_forward_display_line_end(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4897, 4897, 0);
}

static void sl_gtk_icon_view_get_item_row (void)
{
   gint retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_view_get_item_row(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4898, 4898, 0);
}

static void sl_gtk_widget_grab_default (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_grab_default(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4899, 4899, 0);
}

static void sl_gtk_range_set_range (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_range(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4900, 4900, 0);
}

static void sl_g_key_file_save_to_file (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_key_file_save_to_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4901, 4901, 0);
}

static void sl_gtk_icon_info_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4902, 4902, 0);
}

static void sl_gtk_text_iter_backward_visible_lines (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_lines(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4903, 4903, 0);
}

static void sl_gtk_text_view_window_to_buffer_coords (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextWindowType arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_window_to_buffer_coords(arg1,  arg2,  arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4904, 4904, 0);
}

static void sl_gtk_color_chooser_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_chooser_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4905, 4905, 0);
}

static void sl_gtk_scrolled_window_set_vadjustment (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_scrolled_window_set_vadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4906, 4906, 0);
}

static void sl_gtk_toolbar_get_icon_size (void)
{
   GtkIconSize retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_icon_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4907, 4907, 0);
}

static void sl_gtk_file_filter_get_needed (void)
{
   GtkFileFilterFlags retval;
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_get_needed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4908, 4908, 0);
}

static void sl_gtk_tree_view_new_with_model (void)
{
   GtkWidget* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_new_with_model(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4909, 4909, 0);
}

static void sl_pango_attr_list_insert_before (void)
{
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoAttribute* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_attr_list_insert_before(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4910, 4910, 0);
}

static void sl_g_key_file_get_boolean (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_key_file_get_boolean(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4911, 4911, 0);
}

static void sl_gtk_button_get_label (void)
{
   const gchar* retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4912, 4912, 0);
}

static void sl_g_socket_get_option (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg4,0x0);
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_get_option(arg1,  arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4913, 4913, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gtk_tree_view_set_rubber_banding (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_rubber_banding(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4914, 4914, 0);
}

static void sl_gtk_print_settings_set_quality (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintQuality arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_quality(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4915, 4915, 0);
}

static void sl_gtk_selection_data_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4916, 4916, 0);
}

static void sl_gtk_editable_get_chars (void)
{
   gchar* retval;
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_editable_get_chars(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4917, 4917, 0);
}

static void sl_gtk_widget_remove_mnemonic_label (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_remove_mnemonic_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4918, 4918, 0);
}

static void sl_gtk_text_buffer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4919, 4919, 0);
}

static void sl_gtk_container_get_path_for_child (void)
{
   GtkWidgetPath* retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_container_get_path_for_child(arg1, arg2);
   (void)SLang_push_opaque(GtkWidgetPath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4920, 4920, 0);
}

static void sl_gtk_button_box_set_child_non_homogeneous (void)
{
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_button_box_set_child_non_homogeneous(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4921, 4921, 0);
}

static void sl_g_source_get_ready_time (void)
{
   gint64 retval;
   GSource* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GSource_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_source_get_ready_time(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4922, 4922, 0);
}

static void sl_g_strtod (void)
{
   gdouble retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_strtod(arg1, arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4923, 4923, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_entry_get_icon_area (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_get_icon_area(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4924, 4924, 0);
}

static void sl_g_socket_receive_from (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GSocketAddress** arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GSocketAddress*),&arg2,0x0);
   gchar* arg3;
   gsize arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_5;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_socket_receive_from(arg1, arg2, arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (4925, 4925, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_rectangle_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_rectangle_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4926, 4926, 0);
}

static void sl_gtk_file_chooser_unselect_file (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_unselect_file(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4927, 4927, 0);
}

static void sl_gtk_file_chooser_unselect_filename (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_unselect_filename(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4928, 4928, 0);
}

static void sl_g_regex_check_replacement (void)
{
   gboolean retval;
   gchar* arg1;
   gboolean* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg2,0x0);
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_regex_check_replacement(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4929, 4929, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_gesture_stylus_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_stylus_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4930, 4930, 0);
}

static void sl_pango_tab_array_get_size (void)
{
   gint retval;
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_tab_array_get_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4931, 4931, 0);
}

static void sl_gdk_pixbuf_animation_get_height (void)
{
   int retval;
   GdkPixbufAnimation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_get_height(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4932, 4932, 0);
}

static void sl_g_type_class_peek_static (void)
{
   gpointer retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_class_peek_static( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4933, 4933, 0);
}

static void sl_gtk_window_activate_focus (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_activate_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4934, 4934, 0);
}

static void sl_pango_renderer_draw_trapezoid (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   double arg3;
   double arg4;
   double arg5;
   double arg6;
   double arg7;
   double arg8;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_draw_trapezoid(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4935, 4935, 0);
}

static void sl_gdk_pixbuf_animation_iter_get_delay_time (void)
{
   int retval;
   GdkPixbufAnimationIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_animation_iter_get_delay_time(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4936, 4936, 0);
}

static void sl_g_notification_set_body (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_set_body(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4937, 4937, 0);
}

static void sl_gtk_icon_view_set_drag_dest_item (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconViewDropPosition arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_set_drag_dest_item(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4938, 4938, 0);
}

static void sl_g_file_info_get_attribute_as_string (void)
{
   char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_as_string(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4939, 4939, 0);
}

static void sl_gtk_menu_item_deselect (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_deselect(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4940, 4940, 0);
}

static void sl_gtk_text_child_anchor_new (void)
{
   GtkTextChildAnchor* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_child_anchor_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4941, 4941, 0);
}

static void sl_gtk_menu_shell_activate_item (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_activate_item(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4942, 4942, 0);
}

static void sl_g_date_new_julian (void)
{
   GDate* retval;
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_new_julian( arg1);
   (void)SLang_push_opaque(GDate_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4943, 4943, 0);
}

static void sl_gtk_menu_item_select (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_select(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4944, 4944, 0);
}

static void sl_gtk_tool_shell_get_style (void)
{
   GtkToolbarStyle retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_style(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4945, 4945, 0);
}

static void sl_g_menu_attribute_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_menu_attribute_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4946, 4946, 0);
}

static void sl_gtk_text_buffer_register_serialize_tagset (void)
{
   GdkAtom retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_register_serialize_tagset(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4947, 4947, 0);
}

static void sl_gtk_menu_get_reserve_toggle_size (void)
{
   gboolean retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_reserve_toggle_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4948, 4948, 0);
}

static void sl_gtk_file_chooser_get_preview_file (void)
{
   GFile* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_preview_file(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4949, 4949, 0);
}

static void sl_gtk_tool_item_rebuild_menu (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_rebuild_menu(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4950, 4950, 0);
}

static void sl_gtk_text_iter_get_toggled_tags (void)
{
   GSList* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_toggled_tags(arg1,  arg2);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4951, 4951, 0);
}

static void sl_gtk_tool_button_set_stock_id (void)
{
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tool_button_set_stock_id(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4952, 4952, 0);
}

static void sl_g_regex_replace (void)
{
   gchar* retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   gint arg4;
   gchar* arg5;
   GRegexMatchFlags arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_long((long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_regex_replace(arg1, arg2,  arg3,  arg4, arg5,  arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_slstring(arg5);
usage_label:
   if (issue_usage) Slirp_usage (4953, 4953, 0);
}

static void sl_gtk_drag_source_set_target_list (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTargetList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_source_set_target_list(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4954, 4954, 0);
}

static void sl_gtk_flow_box_get_column_spacing (void)
{
   guint retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_column_spacing(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4955, 4955, 0);
}

static void sl_gtk_widget_get_receives_default (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_receives_default(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4956, 4956, 0);
}

static void sl_g_file_monitor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_monitor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4957, 4957, 0);
}

static void sl_gdk_device_get_display (void)
{
   GdkDisplay* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4958, 4958, 0);
}

static void sl_gtk_css_section_get_parent (void)
{
   GtkCssSection* retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_parent(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4959, 4959, 0);
}

static void sl_gtk_entry_completion_get_inline_selection (void)
{
   gboolean retval;
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_get_inline_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4960, 4960, 0);
}

static void sl_gdk_display_notify_startup_complete (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_display_notify_startup_complete(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4961, 4961, 0);
}

static void sl_gtk_tree_model_get_string_from_iter (void)
{
   gchar* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_get_string_from_iter(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4962, 4962, 0);
}

static void sl_g_random_int_range (void)
{
   gint32 retval;
   gint32 arg1;
   gint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_random_int_range( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4963, 4963, 0);
}

static void sl_gtk_header_bar_pack_start (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_pack_start(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4964, 4964, 0);
}

static void sl_g_variant_get_maybe (void)
{
   GVariant* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_maybe(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4965, 4965, 0);
}

static void sl_g_variant_type_key (void)
{
   const GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_key(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4966, 4966, 0);
}

static void sl_gdk_pixbuf_animation_new_from_file (void)
{
   GdkPixbufAnimation* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_animation_new_from_file(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4967, 4967, 0);
}

static void sl_gtk_file_chooser_set_filter (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkFileFilter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_set_filter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4968, 4968, 0);
}

static void sl_g_drive_get_icon (void)
{
   GIcon* retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4969, 4969, 0);
}

static void sl_gtk_tree_store_insert_after (void)
{
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkTreeIter* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_store_insert_after(arg1, arg2, arg3, arg4);
   (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
free_and_return_3:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (4970, 4970, 0);
}

static void sl_g_object_steal_qdata (void)
{
   gpointer retval;
   GObject* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GQuark arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_object_steal_qdata(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4971, 4971, 0);
}

static void sl_g_proxy_address_get_destination_hostname (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_destination_hostname(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4972, 4972, 0);
}

static void sl_gtk_recent_filter_add_group (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_recent_filter_add_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4973, 4973, 0);
}

static void sl_g_content_type_guess (void)
{
   gchar* retval;
   gchar* arg1;
   const guchar* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg2,0x0);
   gsize arg3;
   gboolean* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(gboolean),&arg4,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_guess(arg1, arg2,  arg3, arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (4974, 4974, 0);
   finalize_refs(2,arg2_r,arg4_r); 
}

static void sl_gtk_print_settings_get_n_copies (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_n_copies(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4975, 4975, 0);
}

static void sl_gtk_print_settings_set_double (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_double(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4976, 4976, 0);
}

static void sl_gtk_text_buffer_get_insert (void)
{
   GtkTextMark* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_insert(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4977, 4977, 0);
}

static void sl_gtk_toolbar_set_drop_highlight_item (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_toolbar_set_drop_highlight_item(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4978, 4978, 0);
}

static void sl_gtk_grid_remove_column (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_remove_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4979, 4979, 0);
}

static void sl_pango_font_map_changed (void)
{
   PangoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_map_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4980, 4980, 0);
}

static void sl_g_file_poll_mountable_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_poll_mountable_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4981, 4981, 0);
}

static void sl_gdk_pixbuf_loader_close (void)
{
   gboolean retval;
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_loader_close(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4982, 4982, 0);
}

static void sl_gtk_icon_set_render_icon_pixbuf (void)
{
   GdkPixbuf* retval;
   GtkIconSet* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStyleContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_set_render_icon_pixbuf(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4983, 4983, 0);
}

static void sl_gtk_tree_view_column_get_alignment (void)
{
   gfloat retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_alignment(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4984, 4984, 0);
}

static void sl_gtk_print_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4985, 4985, 0);
}

static void sl_gdk_device_get_source (void)
{
   GdkInputSource retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_source(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4986, 4986, 0);
}

static void sl_g_file_peek_path (void)
{
   const char* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_peek_path(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4987, 4987, 0);
}

static void sl_gtk_revealer_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4988, 4988, 0);
}

static void sl_gtk_list_box_invalidate_headers (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_invalidate_headers(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4989, 4989, 0);
}

static void sl_g_file_info_set_attribute_uint32 (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   guint32 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_uint32(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (4990, 4990, 0);
}

static void sl_pango_renderer_set_alpha (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   guint16 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_set_alpha(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4991, 4991, 0);
}

static void sl_gtk_menu_shell_bind_model (void)
{
   GtkMenuShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   gboolean arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_shell_bind_model(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (4992, 4992, 0);
}

static void sl_gtk_box_set_center_widget (void)
{
   GtkBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_box_set_center_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4993, 4993, 0);
}

static void sl_gtk_cell_area_get_preferred_height (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_get_preferred_height(arg1, arg2, arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (4994, 4994, 0);
}

static void sl_gtk_notebook_set_tab_detachable (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_tab_detachable(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4995, 4995, 0);
}

static void sl_gtk_file_chooser_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (4996, 4996, 0);
}

static void sl_gtk_widget_get_composite_name (void)
{
   gchar* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_composite_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4997, 4997, 0);
}

static void sl_g_file_find_enclosing_mount_finish (void)
{
   GMount* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_find_enclosing_mount_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (4998, 4998, 0);
}

static void sl_g_inet_address_get_is_loopback (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_loopback(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (4999, 4999, 0);
}

static void sl_gtk_shortcut_label_get_accelerator (void)
{
   const gchar* retval;
   GtkShortcutLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_shortcut_label_get_accelerator(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5000, 5000, 0);
}

static void sl_g_zlib_compressor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_zlib_compressor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5001, 5001, 0);
}

static void sl_gtk_tree_model_sort_convert_child_iter_to_iter (void)
{
   gboolean retval;
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_sort_convert_child_iter_to_iter(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5002, 5002, 0);
}

static void sl_gtk_text_iter_forward_visible_cursor_positions (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_visible_cursor_positions(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5003, 5003, 0);
}

static void sl_gdk_window_set_device_cursor (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkCursor* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_device_cursor(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5004, 5004, 0);
}

static void sl_pango_font_description_set_family (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_description_set_family(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5005, 5005, 0);
}

static void sl_pango_layout_get_alignment (void)
{
   PangoAlignment retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_alignment(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5006, 5006, 0);
}

static void sl_gtk_stack_set_visible_child_full (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkStackTransitionType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_stack_set_visible_child_full(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5007, 5007, 0);
}

static void sl_gdk_display_get_n_screens (void)
{
   gint retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_get_n_screens(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5008, 5008, 0);
}

static void sl_gtk_dialog_response (void)
{
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_dialog_response(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5009, 5009, 0);
}

static void sl_gtk_spin_button_configure (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   guint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_spin_button_configure(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5010, 5010, 0);
}

static void sl_g_compute_checksum_for_string (void)
{
   gchar* retval;
   GChecksumType arg1;
   gchar* arg2;
   gssize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = (gssize) strlen (arg2);
   retval = g_compute_checksum_for_string( arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5011, 5011, 0);
}

static void sl_g_settings_bind (void)
{
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gpointer arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GSettingsBindFlags arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_settings_bind(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (5012, 5012, 0);
}

static void sl_g_settings_sync (void)
{
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   g_settings_sync();
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5013, 5013, 0);
}

static void sl_gtk_text_view_set_pixels_below_lines (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_pixels_below_lines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5014, 5014, 0);
}

static void sl_pango_font_get_glyph_extents (void)
{
   PangoFont* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoGlyph arg2;
   PangoRectangle* arg3 = (PangoRectangle*) alloca(sizeof(PangoRectangle));
   PangoRectangle* arg4 = (PangoRectangle*) alloca(sizeof(PangoRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg4, PangoRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, PangoRectangle_Layout)) goto free_and_return_4;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   pango_font_get_glyph_extents(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, PangoRectangle_Layout);
free_and_return_4:
   SLang_free_cstruct((VOID_STAR)arg4, PangoRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5015, 5015, 0);
}

static void sl_gtk_selection_data_set_pixbuf (void)
{
   gboolean retval;
   GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkPixbuf* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_data_set_pixbuf(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5016, 5016, 0);
}

static void sl_g_mount_get_sort_key (void)
{
   const gchar* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_sort_key(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5017, 5017, 0);
}

static void sl_g_file_info_get_attribute_uint64 (void)
{
   guint64 retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_uint64(arg1, arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5018, 5018, 0);
}

static void sl_gtk_tool_shell_rebuild_menu (void)
{
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_shell_rebuild_menu(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5019, 5019, 0);
}

static void sl_g_io_channel_set_buffer_size (void)
{
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_io_channel_set_buffer_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5020, 5020, 0);
}

static void sl_gtk_widget_show_now (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_show_now(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5021, 5021, 0);
}

static void sl_gtk_flow_box_child_get_index (void)
{
   gint retval;
   GtkFlowBoxChild* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_child_get_index(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5022, 5022, 0);
}

static void sl_gtk_container_get_focus_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_container_get_focus_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5023, 5023, 0);
}

static void sl_g_socket_get_available_bytes (void)
{
   gssize retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_available_bytes(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5024, 5024, 0);
}

static void sl_gtk_tree_path_append_index (void)
{
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_path_append_index(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5025, 5025, 0);
}

static void sl_gtk_event_controller_motion_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_event_controller_motion_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5026, 5026, 0);
}

static void sl_g_network_address_parse_uri (void)
{
   GSocketConnectable* retval;
   gchar* arg1;
   guint16 arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_network_address_parse_uri(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5027, 5027, 0);
}

static void sl_gtk_check_button_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_button_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5028, 5028, 0);
}

static void sl_g_volume_get_activation_root (void)
{
   GFile* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_activation_root(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5029, 5029, 0);
}

static void sl_g_get_real_time (void)
{
   gint64 retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_real_time();
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5030, 5030, 0);
}

static void sl_pango_layout_is_wrapped (void)
{
   gboolean retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_is_wrapped(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5031, 5031, 0);
}

static void sl_g_app_info_dup (void)
{
   GAppInfo* retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_dup(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5032, 5032, 0);
}

static void sl_g_io_channel_shutdown (void)
{
   GIOStatus retval;
   GIOChannel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GIOChannel_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_io_channel_shutdown(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5033, 5033, 0);
}

static void sl_gtk_app_chooser_button_set_show_dialog_item (void)
{
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_button_set_show_dialog_item(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5034, 5034, 0);
}

static void sl_gtk_tool_item_toolbar_reconfigured (void)
{
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_item_toolbar_reconfigured(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5035, 5035, 0);
}

static void sl_gdk_device_pad_get_n_features (void)
{
   gint retval;
   GdkDevicePad* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevicePadFeature arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_pad_get_n_features(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5036, 5036, 0);
}

static void sl_g_emblemed_icon_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_emblemed_icon_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5037, 5037, 0);
}

static void sl_g_utf8_collate_key (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_collate_key(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5038, 5038, 0);
}

static void sl_g_date_get_monday_week_of_year (void)
{
   guint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_monday_week_of_year(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5039, 5039, 0);
}

static void sl_g_utf8_collate_key_for_filename (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_collate_key_for_filename(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5040, 5040, 0);
}

static void sl_g_input_stream_close (void)
{
   gboolean retval;
   GInputStream* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_input_stream_close(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5041, 5041, 0);
}

static void sl_g_key_file_set_int64 (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gint64 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_int64(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5042, 5042, 0);
}

static void sl_gtk_widget_realize (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_realize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5043, 5043, 0);
}

static void sl_g_get_system_data_dirs (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_system_data_dirs();
   push_null_term_str_array ((char **) retval, "g_get_system_data_dirs", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5044, 5044, 0);
}

static void sl_gtk_combo_box_text_get_active_text (void)
{
   gchar* retval;
   GtkComboBoxText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_combo_box_text_get_active_text(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5045, 5045, 0);
}

static void sl_gtk_frame_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_frame_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5046, 5046, 0);
}

static void sl_gtk_frame_set_label (void)
{
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_frame_set_label(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5047, 5047, 0);
}

static void sl_gtk_widget_get_margin_end (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5048, 5048, 0);
}

static void sl_gdk_pixbuf_format_set_disabled (void)
{
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_pixbuf_format_set_disabled(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5049, 5049, 0);
}

static void sl_gdk_window_set_static_gravities (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_set_static_gravities(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5050, 5050, 0);
}

static void sl_gdk_device_manager_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_manager_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5051, 5051, 0);
}

static void sl_gtk_tool_item_get_text_alignment (void)
{
   gfloat retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_text_alignment(arg1);
   (void)SLang_push_float(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5052, 5052, 0);
}

static void sl_gtk_viewport_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5053, 5053, 0);
}

static void sl_g_file_query_default_handler (void)
{
   GAppInfo* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GCancellable* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_query_default_handler(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5054, 5054, 0);
}

static void sl_pango_coverage_get (void)
{
   PangoCoverageLevel retval;
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_get(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5055, 5055, 0);
}

static void sl_gtk_paned_set_position (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_paned_set_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5056, 5056, 0);
}

static void sl_pango_renderer_draw_error_underline (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_draw_error_underline(arg1,  arg2,  arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5057, 5057, 0);
}

static void sl_gdk_window_set_opacity (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_opacity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5058, 5058, 0);
}

static void sl_gtk_widget_path_iter_get_state (void)
{
   GtkStateFlags retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_get_state(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5059, 5059, 0);
}

static void sl_gtk_cell_layout_pack_end (void)
{
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_layout_pack_end(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5060, 5060, 0);
}

static void sl_gtk_widget_get_root_window (void)
{
   GdkWindow* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_root_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5061, 5061, 0);
}

static void sl_gdk_window_iconify (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_iconify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5062, 5062, 0);
}

static void sl_gtk_tool_item_group_get_drop_item (void)
{
   GtkToolItem* retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_drop_item(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5063, 5063, 0);
}

static void sl_gtk_page_setup_to_gvariant (void)
{
   GVariant* retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_to_gvariant(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5064, 5064, 0);
}

static void sl_gtk_recent_chooser_get_current_item (void)
{
   GtkRecentInfo* retval;
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_current_item(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5065, 5065, 0);
}

static void sl_gtk_cell_area_context_get_preferred_width (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_get_preferred_width(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5066, 5066, 0);
}

static void sl_gtk_entry_set_icon_from_icon_name (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_from_icon_name(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5067, 5067, 0);
}

static void sl_gtk_render_activity (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_activity(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5068, 5068, 0);
}

static void sl_gtk_style_context_lookup_color (void)
{
   gboolean retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_style_context_lookup_color(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5069, 5069, 0);
}

static void sl_gtk_page_setup_copy (void)
{
   GtkPageSetup* retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_copy(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5070, 5070, 0);
}

static void sl_g_get_tmp_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_tmp_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5071, 5071, 0);
}

static void sl_g_settings_get_enum (void)
{
   gint retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_enum(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5072, 5072, 0);
}

static void sl_gtk_tree_view_row_expanded (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_view_row_expanded(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5073, 5073, 0);
}

static void sl_gdk_pixbuf_composite_color_simple (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   GdkInterpType arg4;
   int arg5;
   int arg6;
   guint32 arg7;
   guint32 arg8;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_composite_color_simple(arg1,  arg2,  arg3,  arg4,  arg5,  arg6,  arg7,  arg8);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5074, 5074, 0);
}

static void sl_g_notification_set_default_action_and_target_value (void)
{
   GNotification* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_notification_set_default_action_and_target_value(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5075, 5075, 0);
}

static void sl_g_checksum_copy (void)
{
   GChecksum* retval;
   const GChecksum* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GChecksum_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_checksum_copy(arg1);
   (void)SLang_push_opaque(GChecksum_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5076, 5076, 0);
}

static void sl_gtk_tool_item_get_is_important (void)
{
   gboolean retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_is_important(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5077, 5077, 0);
}

static void sl_gtk_icon_view_set_spacing (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5078, 5078, 0);
}

static void sl_g_variant_get_int16 (void)
{
   gint16 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_int16(arg1);
   (void)SLang_push_short(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5079, 5079, 0);
}

static void sl_gdk_device_type_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_type_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5080, 5080, 0);
}

static void sl_g_value_set_enum (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_enum(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5081, 5081, 0);
}

static void sl_gtk_entry_set_max_width_chars (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_max_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5082, 5082, 0);
}

static void sl_g_action_get_state_hint (void)
{
   GVariant* retval;
   GAction* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_state_hint(arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5083, 5083, 0);
}

static void sl_g_param_spec_pool_list (void)
{
   GParamSpec** retval;
   GParamSpecPool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   guint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_UINT_TYPE,sizeof(guint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_pool_list(arg1,  arg2, arg3);
   (void)SLang_push_opaque(opaque_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5084, 5084, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_recent_chooser_menu_set_show_numbers (void)
{
   GtkRecentChooserMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_menu_set_show_numbers(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5085, 5085, 0);
}

static void sl_gtk_spin_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5086, 5086, 0);
}

static void sl_gtk_builder_new (void)
{
   GtkBuilder* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5087, 5087, 0);
}

static void sl_g_unichar_iszerowidth (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_iszerowidth( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5088, 5088, 0);
}

static void sl_gtk_tree_view_get_rubber_banding (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_rubber_banding(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5089, 5089, 0);
}

static void sl_g_file_attribute_matcher_unref (void)
{
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_attribute_matcher_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5090, 5090, 0);
}

static void sl_g_get_user_config_dir (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_user_config_dir();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5091, 5091, 0);
}

static void sl_g_type_default_interface_peek (void)
{
   gpointer retval;
   GType arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_default_interface_peek( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5092, 5092, 0);
}

static void sl_gdk_frame_clock_begin_updating (void)
{
   GdkFrameClock* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_frame_clock_begin_updating(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5093, 5093, 0);
}

static void sl_gtk_window_get_skip_taskbar_hint (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_skip_taskbar_hint(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5094, 5094, 0);
}

static void sl_g_setenv (void)
{
   gboolean retval;
   gchar* arg1;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_setenv(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5095, 5095, 0);
}

static void sl_gtk_widget_get_clip (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAllocation* arg2 = (GtkAllocation*) alloca(sizeof(GtkAllocation));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_clip(arg1, arg2);
   (void) SLang_push_cstruct ((VOID_STAR) arg2, GtkAllocation_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5096, 5096, 0);
}

static void sl_gtk_expander_set_spacing (void)
{
   GtkExpander* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_expander_set_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5097, 5097, 0);
}

static void sl_gtk_cell_area_is_activatable (void)
{
   gboolean retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_is_activatable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5098, 5098, 0);
}

static void sl_gdk_drag_context_get_source_window (void)
{
   GdkWindow* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_source_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5099, 5099, 0);
}

static void sl_gtk_page_setup_load_file (void)
{
   gboolean retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_page_setup_load_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5100, 5100, 0);
}

static void sl_gtk_button_box_set_child_secondary (void)
{
   GtkButtonBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_button_box_set_child_secondary(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5101, 5101, 0);
}

static void sl_gtk_assistant_set_page_side_image (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GdkPixbuf_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_side_image(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5102, 5102, 0);
}

static void sl_g_ascii_strtod (void)
{
   gdouble retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_strtod(arg1, arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5103, 5103, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_cell_area_remove (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5104, 5104, 0);
}

static void sl_gtk_print_job_new (void)
{
   GtkPrintJob* retval;
   gchar* arg1;
   GtkPrinter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkPrintSettings* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkPageSetup* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_print_job_new(arg1, arg2, arg3, arg4);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5105, 5105, 0);
}

static void sl_g_bookmark_file_get_app_info (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   guint arg5;
   time_t arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_bookmark_file_get_app_info(arg1, arg2, arg3, &arg4, &arg5, &arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_int(retval);
   (void)SLang_push_string(arg4);
   (void)SLang_push_uint(arg5);
   (void)SLang_push_ulong(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5106, 5106, 0);
}

static void sl_gdk_drag_protocol_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_protocol_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5107, 5107, 0);
}

static void sl_g_ascii_strcasecmp (void)
{
   gint retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_ascii_strcasecmp(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5108, 5108, 0);
}

static void sl_g_regex_get_pattern (void)
{
   const gchar* retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_get_pattern(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5109, 5109, 0);
}

static void sl_gtk_range_set_inverted (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_inverted(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5110, 5110, 0);
}

static void sl_gtk_scrollbar_new (void)
{
   GtkWidget* retval;
   GtkOrientation arg1;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_scrollbar_new( arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5111, 5111, 0);
}

static void sl_gtk_entry_completion_set_inline_selection (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_inline_selection(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5112, 5112, 0);
}

static void sl_gdk_test_render_sync (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_test_render_sync(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5113, 5113, 0);
}

static void sl_gtk_entry_get_has_frame (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_has_frame(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5114, 5114, 0);
}

static void sl_gtk_gl_area_attach_buffers (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_attach_buffers(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5115, 5115, 0);
}

static void sl_pango_font_metrics_ref (void)
{
   PangoFontMetrics* retval;
   PangoFontMetrics* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontMetrics_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_metrics_ref(arg1);
   (void)SLang_push_opaque(PangoFontMetrics_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5116, 5116, 0);
}

static void sl_gtk_gesture_pan_get_orientation (void)
{
   GtkOrientation retval;
   GtkGesturePan* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_pan_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5117, 5117, 0);
}

static void sl_g_resolver_lookup_by_address_finish (void)
{
   gchar* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resolver_lookup_by_address_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5118, 5118, 0);
}

static void sl_g_inet_address_mask_get_length (void)
{
   guint retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_mask_get_length(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5119, 5119, 0);
}

static void sl_gtk_recent_filter_add_pixbuf_formats (void)
{
   GtkRecentFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_filter_add_pixbuf_formats(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5120, 5120, 0);
}

static void sl_gdk_notify_startup_complete_with_id (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_notify_startup_complete_with_id(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5121, 5121, 0);
}

static void sl_gtk_list_box_drag_highlight_row (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkListBoxRow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_drag_highlight_row(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5122, 5122, 0);
}

static void sl_g_file_info_get_attribute_uint32 (void)
{
   guint32 retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_uint32(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5123, 5123, 0);
}

static void sl_gtk_assistant_set_current_page (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_assistant_set_current_page(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5124, 5124, 0);
}

static void sl_gtk_print_settings_set_duplex (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPrintDuplex arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_duplex(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5125, 5125, 0);
}

static void sl_g_str_tokenize_and_fold (void)
{
   gchar** retval;
   gchar* arg1;
   gchar* arg2;
   gchar*** arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(gchar_ptr_ptr_ptr_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_str_tokenize_and_fold(arg1, arg2, arg3);
   push_null_term_str_array (retval, "g_str_tokenize_and_fold", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5126, 5126, 0);
}

static void sl_g_variant_new_from_bytes (void)
{
   GVariant* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GBytes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_new_from_bytes(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5127, 5127, 0);
}

static void sl_gtk_flow_box_set_column_spacing (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_column_spacing(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5128, 5128, 0);
}

static void sl_gtk_tree_view_column_get_width (void)
{
   gint retval;
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5129, 5129, 0);
}

static void sl_g_file_stop_mountable_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_stop_mountable_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5130, 5130, 0);
}

static void sl_gtk_font_chooser_set_font (void)
{
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_font_chooser_set_font(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5131, 5131, 0);
}

static void sl_gdk_window_set_title (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5132, 5132, 0);
}

static void sl_gtk_toolbar_set_show_arrow (void)
{
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toolbar_set_show_arrow(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5133, 5133, 0);
}

static void sl_gtk_window_resize (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_resize(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5134, 5134, 0);
}

static void sl_gtk_paned_set_wide_handle (void)
{
   GtkPaned* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_paned_set_wide_handle(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5135, 5135, 0);
}

static void sl_gtk_widget_activate (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_activate(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5136, 5136, 0);
}

static void sl_gtk_cell_area_get_preferred_width_for_height (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_get_preferred_width_for_height(arg1, arg2, arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5137, 5137, 0);
}

static void sl_g_time_zone_get_identifier (void)
{
   const gchar* retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_get_identifier(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5138, 5138, 0);
}

static void sl_gtk_stack_switcher_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_switcher_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5139, 5139, 0);
}

static void sl_gdk_keyval_convert_case (void)
{
   guint arg1;
   guint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UINT_TYPE,sizeof(guint),&arg2,0x0);
   guint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_UINT_TYPE,sizeof(guint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_keyval_convert_case( arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5140, 5140, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_text_iter_starts_tag (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_starts_tag(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5141, 5141, 0);
}

static void sl_gtk_entry_completion_new (void)
{
   GtkEntryCompletion* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_completion_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5142, 5142, 0);
}

static void sl_gtk_tree_view_column_set_sort_indicator (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_sort_indicator(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5143, 5143, 0);
}

static void sl_gtk_info_bar_set_message_type (void)
{
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkMessageType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_info_bar_set_message_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5144, 5144, 0);
}

static void sl_g_intern_static_string (void)
{
   const gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_intern_static_string(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5145, 5145, 0);
}

static void sl_gtk_tree_path_to_string (void)
{
   gchar* retval;
   GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5146, 5146, 0);
}

static void sl_g_settings_set_boolean (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_boolean(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5147, 5147, 0);
}

static void sl_g_variant_hash (void)
{
   guint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5148, 5148, 0);
}

static void sl_gtk_stack_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5149, 5149, 0);
}

static void sl_gtk_text_iter_starts_word (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_starts_word(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5150, 5150, 0);
}

static void sl_gdk_window_set_debug_updates (void)
{
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_debug_updates( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5151, 5151, 0);
}

static void sl_g_file_info_has_namespace (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_has_namespace(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5152, 5152, 0);
}

static void sl_gtk_tree_view_get_cell_area (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_get_cell_area(arg1, arg2, arg3, arg4);
   (void) SLang_push_cstruct ((VOID_STAR) arg4, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5153, 5153, 0);
}

static void sl_gtk_radio_menu_item_new_with_label (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new_with_label(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5154, 5154, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_target_table_new_from_list (void)
{
   GtkTargetEntry* retval;
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_table_new_from_list(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5155, 5155, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_menu_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5156, 5156, 0);
}

static void sl_g_mount_operation_reply (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMountOperationResult arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_reply(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5157, 5157, 0);
}

static void sl_gtk_button_get_event_window (void)
{
   GdkWindow* retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_event_window(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5158, 5158, 0);
}

static void sl_gtk_grid_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5159, 5159, 0);
}

static void sl_gdk_pixbuf_calculate_rowstride (void)
{
   gint retval;
   GdkColorspace arg1;
   gboolean arg2;
   int arg3;
   int arg4;
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_calculate_rowstride( arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5160, 5160, 0);
}

static void sl_g_value_get_int (void)
{
   gint retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_int(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5161, 5161, 0);
}

static void sl_g_value_take_object (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_take_object(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5162, 5162, 0);
}

static void sl_g_bookmark_file_remove_group (void)
{
   gboolean retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_bookmark_file_remove_group(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5163, 5163, 0);
}

static void sl_g_key_file_set_double (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gdouble arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_double(arg1, arg2, arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5164, 5164, 0);
}

static void sl_g_file_info_set_attribute_string (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_attribute_string(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5165, 5165, 0);
}

static void sl_gtk_tree_view_get_model (void)
{
   GtkTreeModel* retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5166, 5166, 0);
}

static void sl_gtk_about_dialog_set_license (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_license(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5167, 5167, 0);
}

static void sl_gdk_window_get_source_events (void)
{
   GdkEventMask retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkInputSource arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_source_events(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5168, 5168, 0);
}

static void sl_pango_cairo_context_set_font_options (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_font_options_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_context_set_font_options(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5169, 5169, 0);
}

static void sl_gtk_widget_set_app_paintable (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_app_paintable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5170, 5170, 0);
}

static void sl_gtk_tree_model_iter_previous (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_previous(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5171, 5171, 0);
}

static void sl_gtk_selection_data_targets_include_uri (void)
{
   gboolean retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_targets_include_uri(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5172, 5172, 0);
}

static void sl_g_date_time_hash (void)
{
   guint retval;
   gconstpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_hash(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5173, 5173, 0);
}

static void sl_gdk_window_mark_paint_from_clip (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_mark_paint_from_clip(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5174, 5174, 0);
}

static void sl_g_network_service_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_network_service_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5175, 5175, 0);
}

static void sl_gtk_file_chooser_button_set_focus_on_click (void)
{
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_button_set_focus_on_click(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5176, 5176, 0);
}

static void sl_g_resolver_lookup_records_finish (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resolver_lookup_records_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5177, 5177, 0);
}

static void sl_gtk_tree_model_sort_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_sort_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5178, 5178, 0);
}

static void sl_gtk_gesture_is_grouped_with (void)
{
   gboolean retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkGesture* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_gesture_is_grouped_with(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5179, 5179, 0);
}

static void sl_g_file_has_prefix (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_has_prefix(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5180, 5180, 0);
}

static void sl_g_utf8_strrchr (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   gunichar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_strrchr(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5181, 5181, 0);
}

static void sl_gtk_spin_button_get_value (void)
{
   gdouble retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_value(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5182, 5182, 0);
}

static void sl_g_inet_address_to_bytes (void)
{
   const guint8* retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_to_bytes(arg1);
   (void)SLang_push_opaque(uchar_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5183, 5183, 0);
}

static void sl_g_app_info_set_as_default_for_type (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_set_as_default_for_type(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5184, 5184, 0);
}

static void sl_pango_font_description_get_variations (void)
{
   const char* retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_variations(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5185, 5185, 0);
}

static void sl_gdk_window_get_focus_on_map (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_focus_on_map(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5186, 5186, 0);
}

static void sl_gtk_css_provider_new (void)
{
   GtkCssProvider* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_provider_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5187, 5187, 0);
}

static void sl_gtk_cell_renderer_spinner_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_spinner_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5188, 5188, 0);
}

static void sl_g_resolver_lookup_service (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_resolver_lookup_service(arg1, arg2, arg3, arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (5189, 5189, 0);
}

static void sl_gtk_text_view_set_cursor_visible (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_cursor_visible(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5190, 5190, 0);
}

static void sl_g_app_info_set_as_last_used_for_type (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_set_as_last_used_for_type(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5191, 5191, 0);
}

static void sl_gtk_widget_reparent (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_reparent(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5192, 5192, 0);
}

static void sl_g_variant_n_children (void)
{
   gsize retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_n_children(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5193, 5193, 0);
}

static void sl_gtk_info_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5194, 5194, 0);
}

static void sl_gtk_entry_new_with_buffer (void)
{
   GtkWidget* retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_new_with_buffer(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5195, 5195, 0);
}

static void sl_gtk_widget_set_halign (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAlign arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_halign(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5196, 5196, 0);
}

static void sl_pango_cairo_font_map_new_for_font_type (void)
{
   PangoFontMap* retval;
   cairo_font_type_t arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_new_for_font_type( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5197, 5197, 0);
}

static void sl_gtk_header_bar_set_show_close_button (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_header_bar_set_show_close_button(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5198, 5198, 0);
}

static void sl_gtk_radio_tool_button_new (void)
{
   GtkToolItem* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_tool_button_new(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5199, 5199, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_checksum_reset (void)
{
   GChecksum* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GChecksum_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_checksum_reset(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5200, 5200, 0);
}

static void sl_gtk_notebook_set_tab_label_text (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_tab_label_text(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5201, 5201, 0);
}

static void sl_gtk_radio_menu_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_menu_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5202, 5202, 0);
}

static void sl_gtk_device_grab_add (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_device_grab_add(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5203, 5203, 0);
}

static void sl_gdk_event_get_keyval (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_keyval(arg1, &arg2);
   if (retval)
      (void)SLang_push_uint(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5204, 5204, 0);
}

static void sl_pango_font_map_load_font (void)
{
   PangoFont* retval;
   PangoFontMap* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const PangoFontDescription* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_font_map_load_font(arg1, arg2, arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5205, 5205, 0);
}

static void sl_gtk_file_chooser_native_get_cancel_label (void)
{
   const char* retval;
   GtkFileChooserNative* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_native_get_cancel_label(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5206, 5206, 0);
}

static void sl_gdk_rgba_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_rgba_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5207, 5207, 0);
}

static void sl_pango_coverage_from_bytes (void)
{
   PangoCoverage* retval;
   guchar* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guchar),&arg1,0x0);
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = pango_coverage_from_bytes(arg1,  arg2);
   (void)SLang_push_opaque(PangoCoverage_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5208, 5208, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_volume_get_drive (void)
{
   GDrive* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_drive(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5209, 5209, 0);
}

static void sl_gtk_places_sidebar_get_show_trash (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_trash(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5210, 5210, 0);
}

static void sl_g_ucs4_to_utf8 (void)
{
   gchar* retval;
   const gunichar* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UINT_TYPE,sizeof(gunichar),&arg1,0x0);
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_ucs4_to_utf8(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5211, 5211, 0);
   finalize_refs(2,arg1_r,arg3_r); 
}

static void sl_gtk_calendar_get_detail_width_chars (void)
{
   gint retval;
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_get_detail_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5212, 5212, 0);
}

static void sl_gtk_text_view_set_input_hints (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkInputHints arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_input_hints(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5213, 5213, 0);
}

static void sl_gtk_tree_model_get_flags (void)
{
   GtkTreeModelFlags retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_get_flags(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5214, 5214, 0);
}

static void sl_g_file_new_for_commandline_arg_and_cwd (void)
{
   GFile* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_new_for_commandline_arg_and_cwd(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5215, 5215, 0);
}

static void sl_gtk_menu_tool_button_get_menu (void)
{
   GtkWidget* retval;
   GtkMenuToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_tool_button_get_menu(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5216, 5216, 0);
}

static void sl_gtk_entry_buffer_new (void)
{
   GtkEntryBuffer* retval;
   gchar* arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = (gint) strlen (arg1);
   retval = gtk_entry_buffer_new(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5217, 5217, 0);
}

static void sl_gdk_device_tool_get_serial (void)
{
   guint64 retval;
   GdkDeviceTool* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_tool_get_serial(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5218, 5218, 0);
}

static void sl_g_socket_get_blocking (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_blocking(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5219, 5219, 0);
}

static void sl_g_file_info_get_modification_time (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GTimeVal_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_get_modification_time(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5220, 5220, 0);
}

static void sl_gtk_image_get_gicon (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon** arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GIcon*),&arg2,0x0);
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_image_get_gicon(arg1, arg2, &arg3);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5221, 5221, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_app_info_delete (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_delete(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5222, 5222, 0);
}

static void sl_gtk_stack_sidebar_get_stack (void)
{
   GtkStack* retval;
   GtkStackSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_stack_sidebar_get_stack(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5223, 5223, 0);
}

static void sl_gtk_widget_set_size_request (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_size_request(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5224, 5224, 0);
}

static void sl_gtk_dialog_add_button (void)
{
   GtkWidget* retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_dialog_add_button(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5225, 5225, 0);
}

static void sl_gdk_window_flush (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_flush(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5226, 5226, 0);
}

static void sl_gtk_cell_renderer_get_state (void)
{
   GtkStateFlags retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRendererState arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_cell_renderer_get_state(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5227, 5227, 0);
}

static void sl_gtk_check_menu_item_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_menu_item_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5228, 5228, 0);
}

static void sl_g_param_spec_pool_new (void)
{
   GParamSpecPool* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_param_spec_pool_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5229, 5229, 0);
}

static void sl_gtk_tree_path_copy (void)
{
   GtkTreePath* retval;
   const GtkTreePath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_path_copy(arg1);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5230, 5230, 0);
}

static void sl_gtk_entry_set_icon_sensitive (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_icon_sensitive(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5231, 5231, 0);
}

static void sl_gtk_buildable_get_internal_child (void)
{
   GObject* retval;
   GtkBuildable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkBuilder* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_buildable_get_internal_child(arg1, arg2, arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5232, 5232, 0);
}

static void sl_g_inet_address_get_is_any (void)
{
   gboolean retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_get_is_any(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5233, 5233, 0);
}

static void sl_g_mount_get_name (void)
{
   char* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_name(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5234, 5234, 0);
}

static void sl_gtk_combo_box_set_id_column (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_id_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5235, 5235, 0);
}

static void sl_gdk_window_unstick (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_unstick(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5236, 5236, 0);
}

static void sl_gdk_window_set_group (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5237, 5237, 0);
}

static void sl_g_file_info_get_is_backup (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_is_backup(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5238, 5238, 0);
}

static void sl_gtk_assistant_set_page_title (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_set_page_title(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5239, 5239, 0);
}

static void sl_g_proxy_address_get_uri (void)
{
   const gchar* retval;
   GProxyAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_proxy_address_get_uri(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5240, 5240, 0);
}

static void sl_gtk_native_dialog_set_title (void)
{
   GtkNativeDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_native_dialog_set_title(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5241, 5241, 0);
}

static void sl_gtk_color_chooser_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_chooser_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5242, 5242, 0);
}

static void sl_gtk_link_button_get_uri (void)
{
   const gchar* retval;
   GtkLinkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_link_button_get_uri(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5243, 5243, 0);
}

static void sl_gdk_display_set_double_click_distance (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_set_double_click_distance(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5244, 5244, 0);
}

static void sl_gtk_gl_area_get_required_version (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_get_required_version(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5245, 5245, 0);
}

static void sl_gtk_grid_set_row_baseline_position (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   GtkBaselinePosition arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grid_set_row_baseline_position(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5246, 5246, 0);
}

static void sl_gtk_tree_model_get_iter (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   retval = gtk_tree_model_get_iter(arg1, arg2, arg3);
   if (retval)
      (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   else
      {
         SLfree ((char *) arg2);
         (void) SLang_push_null ();
      }
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5247, 5247, 0);
}

static void sl_g_file_info_set_modification_time (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeVal* arg2 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GTimeVal_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_modification_time(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5248, 5248, 0);
}

static void sl_g_variant_get_uint64 (void)
{
   guint64 retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_uint64(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5249, 5249, 0);
}

static void sl_g_file_create_readwrite_finish (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_create_readwrite_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5250, 5250, 0);
}

static void sl_gtk_tree_model_sort_iter_is_valid (void)
{
   gboolean retval;
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_sort_iter_is_valid(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5251, 5251, 0);
}

static void sl_gtk_drag_dest_set_target_list (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTargetList* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_dest_set_target_list(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5252, 5252, 0);
}

static void sl_gtk_target_list_add_uri_targets (void)
{
   GtkTargetList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTargetList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_target_list_add_uri_targets(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5253, 5253, 0);
}

static void sl_gdk_seat_capabilities_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_capabilities_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5254, 5254, 0);
}

static void sl_gtk_accel_label_get_accel_widget (void)
{
   GtkWidget* retval;
   GtkAccelLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_label_get_accel_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5255, 5255, 0);
}

static void sl_gtk_range_set_increments (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_increments(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5256, 5256, 0);
}

static void sl_g_content_type_get_icon (void)
{
   GIcon* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5257, 5257, 0);
}

static void sl_gtk_frame_set_shadow_type (void)
{
   GtkFrame* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShadowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_frame_set_shadow_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5258, 5258, 0);
}

static void sl_gtk_combo_box_set_column_span_column (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_column_span_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5259, 5259, 0);
}

static void sl_gtk_style_context_set_frame_clock (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkFrameClock* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_set_frame_clock(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5260, 5260, 0);
}

static void sl_gtk_progress_bar_get_inverted (void)
{
   gboolean retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_inverted(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5261, 5261, 0);
}

static void sl_gtk_cell_view_new_with_markup (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_new_with_markup(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5262, 5262, 0);
}

static void sl_gtk_window_set_position (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWindowPosition arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_position(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5263, 5263, 0);
}

static void sl_g_file_attribute_info_list_dup (void)
{
   GFileAttributeInfoList* retval;
   GFileAttributeInfoList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_info_list_dup(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5264, 5264, 0);
}

static void sl_gdk_pixbuf_new_from_inline (void)
{
   GdkPixbuf* retval;
   gint arg1;
   const guint8* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_UCHAR_TYPE,sizeof(guint8),&arg2,0x0);
   gboolean arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   retval = gdk_pixbuf_new_from_inline( arg1, arg2,  arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5265, 5265, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_tree_view_column_cell_set_cell_data (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gboolean arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_cell_set_cell_data(arg1, arg2, arg3,  arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5266, 5266, 0);
}

static void sl_g_variant_parse_error_print_context (void)
{
   gchar* retval;
   GError* arg1 = (GError*) alloca(sizeof(GError));
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GError_Layout)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_parse_error_print_context(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GError_Layout);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5267, 5267, 0);
}

static void sl_gtk_dialog_run (void)
{
   gint retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_run(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5268, 5268, 0);
}

static void sl_gtk_image_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5269, 5269, 0);
}

static void sl_gtk_selection_data_free (void)
{
   GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_selection_data_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5270, 5270, 0);
}

static void sl_gtk_tree_model_iter_children (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_iter_children(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5271, 5271, 0);
}

static void sl_g_filename_to_uri (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_filename_to_uri(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5272, 5272, 0);
}

static void sl_gtk_print_unix_dialog_get_has_selection (void)
{
   gboolean retval;
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_has_selection(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5273, 5273, 0);
}

static void sl_gtk_notebook_set_show_tabs (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_set_show_tabs(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5274, 5274, 0);
}

static void sl_gtk_window_iconify (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_iconify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5275, 5275, 0);
}

static void sl_g_object_interface_find_property (void)
{
   GParamSpec* retval;
   gpointer arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_object_interface_find_property(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5276, 5276, 0);
}

static void sl_gdk_cairo_surface_create_from_pixbuf (void)
{
   cairo_surface_t* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   GdkWindow* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg3_o, (void**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = gdk_cairo_surface_create_from_pixbuf(arg1,  arg2, arg3);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5277, 5277, 0);
}

static void sl_gtk_entry_completion_set_minimum_key_length (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_completion_set_minimum_key_length(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5278, 5278, 0);
}

static void sl_g_content_types_get_registered (void)
{
   GList* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_content_types_get_registered();
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5279, 5279, 0);
}

static void sl_gtk_menu_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5280, 5280, 0);
}

static void sl_g_app_info_remove_supports_type (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_app_info_remove_supports_type(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5281, 5281, 0);
}

static void sl_gtk_menu_bar_new_from_model (void)
{
   GtkWidget* retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_bar_new_from_model(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5282, 5282, 0);
}

static void sl_g_socket_leave_multicast_group (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_leave_multicast_group(arg1, arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (5283, 5283, 0);
}

static void sl_gtk_action_bar_set_center_widget (void)
{
   GtkActionBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_action_bar_set_center_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5284, 5284, 0);
}

static void sl_gtk_drag_dest_get_target_list (void)
{
   GtkTargetList* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_drag_dest_get_target_list(arg1);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5285, 5285, 0);
}

static void sl_gtk_paper_size_new (void)
{
   GtkPaperSize* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_new(arg1);
   (void)SLang_push_opaque(GtkPaperSize_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5286, 5286, 0);
}

static void sl_gtk_widget_unregister_window (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_unregister_window(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5287, 5287, 0);
}

static void sl_g_mapped_file_get_bytes (void)
{
   GBytes* retval;
   GMappedFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMappedFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mapped_file_get_bytes(arg1);
   (void)SLang_push_opaque(GBytes_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5288, 5288, 0);
}

static void sl_gtk_list_box_row_changed (void)
{
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_row_changed(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5289, 5289, 0);
}

static void sl_g_file_replace_readwrite (void)
{
   GFileIOStream* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gboolean arg3;
   GFileCreateFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_replace_readwrite(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (5290, 5290, 0);
}

static void sl_gtk_application_set_app_menu (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_set_app_menu(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5291, 5291, 0);
}

static void sl_gtk_widget_set_margin_start (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_start(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5292, 5292, 0);
}

static void sl_gtk_drag_dest_add_text_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_dest_add_text_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5293, 5293, 0);
}

static void sl_g_date_get_iso8601_week_of_year (void)
{
   guint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_iso8601_week_of_year(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5294, 5294, 0);
}

static void sl_gtk_window_set_deletable (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_deletable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5295, 5295, 0);
}

static void sl_gtk_tree_view_set_enable_tree_lines (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_set_enable_tree_lines(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5296, 5296, 0);
}

static void sl_gtk_style_context_remove_region (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_remove_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5297, 5297, 0);
}

static void sl_g_mount_get_uuid (void)
{
   char* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_uuid(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5298, 5298, 0);
}

static void sl_pango_attr_family_new (void)
{
   PangoAttribute* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_family_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5299, 5299, 0);
}

static void sl_gtk_header_bar_get_decoration_layout (void)
{
   const gchar* retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_decoration_layout(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5300, 5300, 0);
}

static void sl_g_date_time_get_seconds (void)
{
   gdouble retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_seconds(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5301, 5301, 0);
}

static void sl_g_get_locale_variants (void)
{
   gchar** retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_get_locale_variants(arg1);
   push_null_term_str_array (retval, "g_get_locale_variants", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5302, 5302, 0);
}

static void sl_gtk_css_section_get_file (void)
{
   GFile* retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_file(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5303, 5303, 0);
}

static void sl_gtk_style_context_has_region (void)
{
   gboolean retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkRegionFlags* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(GtkRegionFlags),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_style_context_has_region(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5304, 5304, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_menu_link_iter_get_name (void)
{
   const gchar* retval;
   GMenuLinkIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_link_iter_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5305, 5305, 0);
}

static void sl_gtk_menu_set_accel_group (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAccelGroup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_set_accel_group(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5306, 5306, 0);
}

static void sl_g_date_time_get_second (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_second(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5307, 5307, 0);
}

static void sl_gtk_window_get_focus_visible (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_focus_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5308, 5308, 0);
}

static void sl_gtk_print_settings_set_resolution_xy (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_resolution_xy(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5309, 5309, 0);
}

static void sl_gtk_style_context_set_background (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_set_background(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5310, 5310, 0);
}

static void sl_gtk_toggle_button_get_inconsistent (void)
{
   gboolean retval;
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_get_inconsistent(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5311, 5311, 0);
}

static void sl_gtk_progress_bar_set_inverted (void)
{
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_progress_bar_set_inverted(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5312, 5312, 0);
}

static void sl_gtk_cell_view_set_background_rgba (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_view_set_background_rgba(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5313, 5313, 0);
}

static void sl_gtk_window_get_decorated (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_decorated(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5314, 5314, 0);
}

static void sl_gtk_color_chooser_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_color_chooser_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5315, 5315, 0);
}

static void sl_gtk_recent_info_get_uri (void)
{
   const gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_uri(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5316, 5316, 0);
}

static void sl_gtk_cell_view_set_fit_model (void)
{
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_view_set_fit_model(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5317, 5317, 0);
}

static void sl_gtk_image_set_from_surface (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_surface_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_surface(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5318, 5318, 0);
}

static void sl_gtk_file_chooser_add_choice (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   char* arg3;
   const char** arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg4,0x0);
   const char** arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_STRING_TYPE,sizeof(char*),&arg5,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_add_choice(arg1, arg2, arg3, arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5319, 5319, 0);
   finalize_refs(2,arg4_r,arg5_r); 
}

static void sl_gtk_gesture_single_get_exclusive (void)
{
   gboolean retval;
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_single_get_exclusive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5320, 5320, 0);
}

static void sl_g_resources_open_stream (void)
{
   GInputStream* retval;
   char* arg1;
   GResourceLookupFlags arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resources_open_stream(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5321, 5321, 0);
}

static void sl_g_variant_get_size (void)
{
   gsize retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_size(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5322, 5322, 0);
}

static void sl_gtk_tool_item_get_ellipsize_mode (void)
{
   PangoEllipsizeMode retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_ellipsize_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5323, 5323, 0);
}

static void sl_g_network_service_get_scheme (void)
{
   const gchar* retval;
   GNetworkService* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_service_get_scheme(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5324, 5324, 0);
}

static void sl_g_file_open_tmp (void)
{
   gint retval;
   gchar* arg1;
   gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_open_tmp(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5325, 5325, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gdk_axis_flags_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_axis_flags_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5326, 5326, 0);
}

static void sl_gtk_page_setup_unix_dialog_get_print_settings (void)
{
   GtkPrintSettings* retval;
   GtkPageSetupUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_unix_dialog_get_print_settings(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5327, 5327, 0);
}

static void sl_gtk_selection_data_targets_include_image (void)
{
   gboolean retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_targets_include_image(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5328, 5328, 0);
}

static void sl_gtk_widget_get_pango_context (void)
{
   PangoContext* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_pango_context(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5329, 5329, 0);
}

static void sl_g_main_context_unref (void)
{
   GMainContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMainContext_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_main_context_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5330, 5330, 0);
}

static void sl_gtk_info_bar_get_revealed (void)
{
   gboolean retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_revealed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5331, 5331, 0);
}

static void sl_gtk_tree_model_sort_get_model (void)
{
   GtkTreeModel* retval;
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_sort_get_model(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5332, 5332, 0);
}

static void sl_gtk_check_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_check_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5333, 5333, 0);
}

static void sl_gtk_tooltip_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tooltip_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5334, 5334, 0);
}

static void sl_gtk_header_bar_get_subtitle (void)
{
   const gchar* retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_subtitle(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5335, 5335, 0);
}

static void sl_gtk_popover_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_popover_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5336, 5336, 0);
}

static void sl_g_variant_get_fixed_array (void)
{
   gconstpointer retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_ULONG_TYPE,sizeof(gsize),&arg2,0x0);
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_get_fixed_array(arg1, arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5337, 5337, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_calendar_get_detail_height_rows (void)
{
   gint retval;
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_get_detail_height_rows(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5338, 5338, 0);
}

static void sl_gtk_text_tag_table_remove (void)
{
   GtkTextTagTable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_tag_table_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5339, 5339, 0);
}

static void sl_g_get_monotonic_time (void)
{
   gint64 retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_monotonic_time();
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5340, 5340, 0);
}

static void sl_gtk_style_context_get_scale (void)
{
   gint retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_scale(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5341, 5341, 0);
}

static void sl_gtk_spin_button_set_increments (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_increments(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5342, 5342, 0);
}

static void sl_gtk_builder_get_object (void)
{
   GObject* retval;
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_builder_get_object(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5343, 5343, 0);
}

static void sl_gtk_gesture_rotate_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_rotate_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5344, 5344, 0);
}

static void sl_gtk_menu_set_monitor (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_set_monitor(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5345, 5345, 0);
}

static void sl_gtk_text_view_get_border_window_size (void)
{
   gint retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextWindowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_border_window_size(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5346, 5346, 0);
}

static void sl_g_date_time_get_week_numbering_year (void)
{
   gint retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_week_numbering_year(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5347, 5347, 0);
}

static void sl_gtk_widget_get_margin_start (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_margin_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5348, 5348, 0);
}

static void sl_gtk_text_buffer_insert_pixbuf (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkPixbuf* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_insert_pixbuf(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5349, 5349, 0);
}

static void sl_gtk_recent_chooser_set_sort_type (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkRecentSortType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_set_sort_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5350, 5350, 0);
}

static void sl_g_file_info_get_content_type (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_content_type(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5351, 5351, 0);
}

static void sl_g_binding_flags_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_binding_flags_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5352, 5352, 0);
}

static void sl_gtk_accel_group_disconnect_key (void)
{
   gboolean retval;
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkModifierType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accel_group_disconnect_key(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5353, 5353, 0);
}

static void sl_gtk_places_sidebar_get_nth_bookmark (void)
{
   GFile* retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_nth_bookmark(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5354, 5354, 0);
}

static void sl_gtk_target_list_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_list_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5355, 5355, 0);
}

static void sl_gtk_notebook_set_action_widget (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkPackType arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_set_action_widget(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5356, 5356, 0);
}

static void sl_gtk_cell_area_get_request_mode (void)
{
   GtkSizeRequestMode retval;
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_area_get_request_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5357, 5357, 0);
}

static void sl_gtk_print_job_set_source_fd (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_print_job_set_source_fd(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5358, 5358, 0);
}

static void sl_pango_font_description_set_gravity (void)
{
   PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoGravity arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_font_description_set_gravity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5359, 5359, 0);
}

static void sl_gtk_tree_view_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5360, 5360, 0);
}

static void sl_g_variant_dup_string (void)
{
   gchar* retval;
   GVariant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gsize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_variant_dup_string(arg1, &arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5361, 5361, 0);
}

static void sl_gtk_label_get_angle (void)
{
   gdouble retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_angle(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5362, 5362, 0);
}

static void sl_gtk_widget_get_name (void)
{
   const gchar* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5363, 5363, 0);
}

static void sl_gtk_toggle_button_get_active (void)
{
   gboolean retval;
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5364, 5364, 0);
}

static void sl_g_variant_type_new_maybe (void)
{
   GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_new_maybe(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5365, 5365, 0);
}

static void sl_gtk_menu_tool_button_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_tool_button_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5366, 5366, 0);
}

static void sl_gtk_window_get_icon_name (void)
{
   const gchar* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_icon_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5367, 5367, 0);
}

static void sl_pango_layout_line_get_height (void)
{
   PangoLayoutLine* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutLine_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_line_get_height(arg1, &arg2);
   (void)SLang_push_int(arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5368, 5368, 0);
}

static void sl_gtk_printer_accepts_ps (void)
{
   gboolean retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_accepts_ps(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5369, 5369, 0);
}

static void sl_g_volume_get_sort_key (void)
{
   const gchar* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_sort_key(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5370, 5370, 0);
}

static void sl_gtk_window_set_icon_from_file (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_window_set_icon_from_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5371, 5371, 0);
}

static void sl_gtk_tree_model_sort_reset_default_sort_func (void)
{
   GtkTreeModelSort* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_model_sort_reset_default_sort_func(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5372, 5372, 0);
}

static void sl_gtk_text_tag_new (void)
{
   GtkTextTag* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_tag_new(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5373, 5373, 0);
}

static void sl_gtk_print_unix_dialog_set_page_setup (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageSetup* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_unix_dialog_set_page_setup(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5374, 5374, 0);
}

static void sl_gtk_text_iter_set_line_offset (void)
{
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_iter_set_line_offset(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5375, 5375, 0);
}

static void sl_gtk_text_view_add_child_at_anchor (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTextChildAnchor* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_view_add_child_at_anchor(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5376, 5376, 0);
}

static void sl_gtk_menu_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5377, 5377, 0);
}

static void sl_g_file_info_set_is_hidden (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_set_is_hidden(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5378, 5378, 0);
}

static void sl_g_socket_condition_timed_wait (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIOCondition arg2;
   gint64 arg3;
   GCancellable* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_4;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_condition_timed_wait(arg1,  arg2,  arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5379, 5379, 0);
}

static void sl_gtk_grid_attach_next_to (void)
{
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkPositionType arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_grid_attach_next_to(arg1, arg2, arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5380, 5380, 0);
}

static void sl_g_file_has_parent (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_has_parent(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5381, 5381, 0);
}

static void sl_gtk_cell_area_inner_cell_area (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GdkRectangle* arg3 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg4 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg3, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_inner_cell_area(arg1, arg2, arg3, arg4);
   (void) SLang_push_cstruct ((VOID_STAR) arg4, GdkRectangle_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_cstruct((VOID_STAR)arg3, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5382, 5382, 0);
}

static void sl_gtk_builder_new_from_resource (void)
{
   GtkBuilder* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_builder_new_from_resource(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5383, 5383, 0);
}

static void sl_gtk_widget_has_visible_focus (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_has_visible_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5384, 5384, 0);
}

static void sl_gtk_text_view_reset_im_context (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_reset_im_context(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5385, 5385, 0);
}

static void sl_gtk_window_set_skip_pager_hint (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_skip_pager_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5386, 5386, 0);
}

static void sl_gtk_scale_set_has_origin (void)
{
   GtkScale* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scale_set_has_origin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5387, 5387, 0);
}

static void sl_gtk_text_iter_ends_tag (void)
{
   gboolean retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextTag* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_ends_tag(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5388, 5388, 0);
}

static void sl_g_notification_new (void)
{
   GNotification* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_notification_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5389, 5389, 0);
}

static void sl_gtk_list_box_row_set_activatable (void)
{
   GtkListBoxRow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_row_set_activatable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5390, 5390, 0);
}

static void sl_g_app_info_can_delete (void)
{
   gboolean retval;
   GAppInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_app_info_can_delete(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5391, 5391, 0);
}

static void sl_g_date_time_new_from_timeval_local (void)
{
   GDateTime* retval;
   GTimeVal* arg1 = (GTimeVal*) alloca(sizeof(GTimeVal));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg1, GTimeVal_Layout)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_from_timeval_local(arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_cstruct((VOID_STAR)arg1, GTimeVal_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5392, 5392, 0);
}

static void sl_g_bookmark_file_free (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_bookmark_file_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5393, 5393, 0);
}

static void sl_gtk_widget_queue_resize_no_redraw (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_queue_resize_no_redraw(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5394, 5394, 0);
}

static void sl_gtk_menu_item_get_label (void)
{
   const gchar* retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5395, 5395, 0);
}

static void sl_g_path_skip_root (void)
{
   const gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_path_skip_root(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5396, 5396, 0);
}

static void sl_gtk_file_chooser_set_select_multiple (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_select_multiple(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5397, 5397, 0);
}

static void sl_g_time_zone_new_local (void)
{
   GTimeZone* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_new_local();
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5398, 5398, 0);
}

static void sl_gtk_file_chooser_set_do_overwrite_confirmation (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_chooser_set_do_overwrite_confirmation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5399, 5399, 0);
}

static void sl_gtk_tree_view_set_cursor_on_cell (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeViewColumn* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkCellRenderer* arg4;
   Slirp_Opaque* arg4_o = NULL;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_cursor_on_cell(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5400, 5400, 0);
}

static void sl_gtk_drag_source_add_text_targets (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_source_add_text_targets(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5401, 5401, 0);
}

static void sl_g_network_monitor_get_default (void)
{
   GNetworkMonitor* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_network_monitor_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5402, 5402, 0);
}

static void sl_gtk_page_setup_set_orientation (void)
{
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPageOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_page_setup_set_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5403, 5403, 0);
}

static void sl_gtk_print_settings_set_int (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_set_int(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5404, 5404, 0);
}

static void sl_gtk_window_set_accept_focus (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_accept_focus(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5405, 5405, 0);
}

static void sl_gtk_widget_path_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5406, 5406, 0);
}

static void sl_gdk_display_manager_open_display (void)
{
   GdkDisplay* retval;
   GdkDisplayManager* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_display_manager_open_display(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5407, 5407, 0);
}

static void sl_gtk_cell_renderer_set_fixed_size (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_set_fixed_size(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5408, 5408, 0);
}

static void sl_gtk_scrollable_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollable_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5409, 5409, 0);
}

static void sl_gdk_pixbuf_animation_new_from_resource (void)
{
   GdkPixbufAnimation* retval;
   char* arg1;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = gdk_pixbuf_animation_new_from_resource(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5410, 5410, 0);
}

static void sl_gtk_text_iter_forward_sentence_end (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_sentence_end(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5411, 5411, 0);
}

static void sl_gdk_pixbuf_simple_anim_new (void)
{
   GdkPixbufSimpleAnim* retval;
   gint arg1;
   gint arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_simple_anim_new( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5412, 5412, 0);
}

static void sl_g_volume_get_uuid (void)
{
   char* retval;
   GVolume* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_volume_get_uuid(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5413, 5413, 0);
}

static void sl_gtk_text_iter_backward_word_start (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_word_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5414, 5414, 0);
}

static void sl_gtk_entry_set_invisible_char (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gunichar arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_set_invisible_char(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5415, 5415, 0);
}

static void sl_g_resolver_lookup_by_name_with_flags_finish (void)
{
   GList* retval;
   GResolver* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_resolver_lookup_by_name_with_flags_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5416, 5416, 0);
}

static void sl_gdk_pixbuf_get_rowstride (void)
{
   int retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_rowstride(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5417, 5417, 0);
}

static void sl_g_strlcpy (void)
{
   gsize retval;
   gchar* arg1;
   gchar* arg2;
   gsize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strlcpy(arg1, arg2,  arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5418, 5418, 0);
}

static void sl_gtk_tree_view_column_new (void)
{
   GtkTreeViewColumn* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_column_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5419, 5419, 0);
}

static void sl_gtk_file_chooser_button_get_width_chars (void)
{
   gint retval;
   GtkFileChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_button_get_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5420, 5420, 0);
}

static void sl_g_network_monitor_can_reach_finish (void)
{
   gboolean retval;
   GNetworkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_network_monitor_can_reach_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5421, 5421, 0);
}

static void sl_gtk_print_operation_get_n_pages_to_print (void)
{
   gint retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_n_pages_to_print(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5422, 5422, 0);
}

static void sl_g_mount_shadow (void)
{
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_shadow(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5423, 5423, 0);
}

static void sl_g_file_info_get_is_hidden (void)
{
   gboolean retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_is_hidden(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5424, 5424, 0);
}

static void sl_g_variant_type_is_subtype_of (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GVariantType* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_type_is_subtype_of(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5425, 5425, 0);
}

static void sl_g_variant_type_is_dict_entry (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_dict_entry(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5426, 5426, 0);
}

static void sl_gdk_window_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5427, 5427, 0);
}

static void sl_g_socket_get_listen_backlog (void)
{
   gint retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_listen_backlog(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5428, 5428, 0);
}

static void sl_pango_attr_iterator_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_iterator_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5429, 5429, 0);
}

static void sl_gtk_tool_palette_unset_icon_size (void)
{
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tool_palette_unset_icon_size(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5430, 5430, 0);
}

static void sl_gtk_accelerator_get_label_with_keycode (void)
{
   gchar* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   GdkModifierType arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == pop_nullable(GObject_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_get_label_with_keycode(arg1,  arg2,  arg3,  arg4);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5431, 5431, 0);
}

static void sl_gtk_places_sidebar_get_show_connect_to_server (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_connect_to_server(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5432, 5432, 0);
}

static void sl_gtk_switch_get_active (void)
{
   gboolean retval;
   GtkSwitch* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_switch_get_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5433, 5433, 0);
}

static void sl_gdk_window_begin_paint_rect (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_begin_paint_rect(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5434, 5434, 0);
}

static void sl_g_menu_insert_submenu (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   GMenuModel* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   g_menu_insert_submenu(arg1,  arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5435, 5435, 0);
}

static void sl_gdk_window_state_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_state_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5436, 5436, 0);
}

static void sl_gtk_print_job_get_num_copies (void)
{
   gint retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_num_copies(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5437, 5437, 0);
}

static void sl_gtk_print_operation_set_allow_async (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_allow_async(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5438, 5438, 0);
}

static void sl_gtk_image_set_from_icon_set (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkIconSet* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_icon_set(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5439, 5439, 0);
}

static void sl_gtk_tree_view_get_fixed_height_mode (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_fixed_height_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5440, 5440, 0);
}

static void sl_g_action_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_action_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5441, 5441, 0);
}

static void sl_gtk_menu_get_attach_widget (void)
{
   GtkWidget* retval;
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_get_attach_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5442, 5442, 0);
}

static void sl_gtk_combo_box_set_active_iter (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkTreeIter_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_combo_box_set_active_iter(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5443, 5443, 0);
}

static void sl_gtk_window_set_default_geometry (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_default_geometry(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5444, 5444, 0);
}

static void sl_pango_font_description_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_font_description_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5445, 5445, 0);
}

static void sl_gtk_device_grab_remove (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkDevice* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_device_grab_remove(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5446, 5446, 0);
}

static void sl_gtk_file_chooser_set_current_name (void)
{
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_file_chooser_set_current_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5447, 5447, 0);
}

static void sl_g_menu_item_set_action_and_target_value (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_action_and_target_value(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5448, 5448, 0);
}

static void sl_gtk_text_buffer_get_modified (void)
{
   gboolean retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_buffer_get_modified(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5449, 5449, 0);
}

static void sl_gtk_radio_menu_item_new_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_menu_item_new_from_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5450, 5450, 0);
}

static void sl_gtk_places_sidebar_get_location (void)
{
   GFile* retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_location(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5451, 5451, 0);
}

static void sl_gtk_flow_box_set_max_children_per_line (void)
{
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_flow_box_set_max_children_per_line(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5452, 5452, 0);
}

static void sl_g_io_channel_unix_new (void)
{
   GIOChannel* retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_unix_new( arg1);
   (void)SLang_push_opaque(GIOChannel_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5453, 5453, 0);
}

static void sl_pango_cairo_update_layout (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayout* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_update_layout(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5454, 5454, 0);
}

static void sl_gtk_label_set_use_markup (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_use_markup(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5455, 5455, 0);
}

static void sl_gtk_icon_info_free (void)
{
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_info_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5456, 5456, 0);
}

static void sl_gtk_main_do_event (void)
{
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_main_do_event(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5457, 5457, 0);
}

static void sl_gtk_scrolled_window_get_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5458, 5458, 0);
}

static void sl_gtk_tree_view_get_enable_search (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_get_enable_search(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5459, 5459, 0);
}

static void sl_gtk_widget_override_font (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(GtkOpaque_Type, (void**)&arg2_o, (void**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_widget_override_font(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5460, 5460, 0);
}

static void sl_g_type_test_flags (void)
{
   gboolean retval;
   GType arg1;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_test_flags( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5461, 5461, 0);
}

static void sl_g_mapped_file_get_contents (void)
{
   gchar* retval;
   GMappedFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GMappedFile_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mapped_file_get_contents(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5462, 5462, 0);
}

static void sl_gtk_toolbar_get_drop_index (void)
{
   gint retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_drop_index(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5463, 5463, 0);
}

static void sl_gtk_window_deiconify (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_deiconify(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5464, 5464, 0);
}

static void sl_g_content_type_get_mime_dirs (void)
{
   const gchar** retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_mime_dirs();
   push_null_term_str_array ((char **) retval, "g_content_type_get_mime_dirs", 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5465, 5465, 0);
}

static void sl_g_vfs_get_default (void)
{
   GVfs* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_vfs_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5466, 5466, 0);
}

static void sl_gtk_application_prefers_app_menu (void)
{
   gboolean retval;
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_application_prefers_app_menu(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5467, 5467, 0);
}

static void sl_g_key_file_get_locale_string (void)
{
   gchar* retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg4, NULL)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_key_file_get_locale_string(arg1, arg2, arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (5468, 5468, 0);
}

static void sl_g_date_time_get_timezone (void)
{
   GTimeZone* retval;
   GDateTime* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDateTime_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_get_timezone(arg1);
   (void)SLang_push_opaque(GTimeZone_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5469, 5469, 0);
}

static void sl_g_file_set_display_name (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = g_file_set_display_name(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5470, 5470, 0);
}

static void sl_pango_layout_get_line_readonly (void)
{
   PangoLayoutLine* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_line_readonly(arg1,  arg2);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5471, 5471, 0);
}

static void sl_gtk_text_buffer_remove_all_tags (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_remove_all_tags(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5472, 5472, 0);
}

static void sl_g_type_is_a (void)
{
   gboolean retval;
   GType arg1;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_type_is_a( arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5473, 5473, 0);
}

static void sl_gtk_menu_item_get_accel_path (void)
{
   const gchar* retval;
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_accel_path(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5474, 5474, 0);
}

static void sl_g_socket_set_listen_backlog (void)
{
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_socket_set_listen_backlog(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5475, 5475, 0);
}

static void sl_gtk_font_chooser_get_font_map (void)
{
   PangoFontMap* retval;
   GtkFontChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_font_map(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5476, 5476, 0);
}

static void sl_gtk_print_unix_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_unix_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5477, 5477, 0);
}

static void sl_gtk_widget_reset_style (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_reset_style(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5478, 5478, 0);
}

static void sl_gtk_text_view_forward_display_line (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_forward_display_line(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5479, 5479, 0);
}

static void sl_gtk_menu_set_reserve_toggle_size (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_set_reserve_toggle_size(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5480, 5480, 0);
}

static void sl_g_type_name_from_class (void)
{
   const gchar* retval;
   GTypeClass* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_type_name_from_class(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5481, 5481, 0);
}

static void sl_gtk_icon_view_set_margin (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_margin(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5482, 5482, 0);
}

static void sl_gtk_accel_group_connect (void)
{
   GtkAccelGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GdkModifierType arg3;
   GtkAccelFlags arg4;
   GClosure* arg5;
   Slirp_Opaque* arg5_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_5;
   issue_usage = 0;

   gtk_accel_group_connect(arg1,  arg2,  arg3,  arg4, arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (5483, 5483, 0);
}

static void sl_gtk_radio_button_new_from_widget (void)
{
   GtkWidget* retval;
   GtkRadioButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg1_o, (void**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_radio_button_new_from_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5484, 5484, 0);
}

static void sl_gtk_label_set_pattern (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_label_set_pattern(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5485, 5485, 0);
}

static void sl_gtk_scrollable_get_hscroll_policy (void)
{
   GtkScrollablePolicy retval;
   GtkScrollable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollable_get_hscroll_policy(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5486, 5486, 0);
}

static void sl_gtk_scale_button_get_popup (void)
{
   GtkWidget* retval;
   GtkScaleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scale_button_get_popup(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5487, 5487, 0);
}

static void sl_g_resource_new_from_data (void)
{
   GResource* retval;
   GBytes* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GError* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg2 = NULL;
   retval = g_resource_new_from_data(arg1, &arg2);
   if (arg2 != NULL)
     throw_gerror(arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5488, 5488, 0);
}

static void sl_gtk_icon_view_create_drag_icon (void)
{
   cairo_surface_t* retval;
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreePath* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_icon_view_create_drag_icon(arg1, arg2);
   (void)SLang_push_opaque(Cairo_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5489, 5489, 0);
}

static void sl_gtk_tree_model_get_column_type (void)
{
   GType retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_model_get_column_type(arg1,  arg2);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5490, 5490, 0);
}

static void sl_gtk_editable_get_editable (void)
{
   gboolean retval;
   GtkEditable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_editable_get_editable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5491, 5491, 0);
}

static void sl_gtk_text_view_place_cursor_onscreen (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_place_cursor_onscreen(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5492, 5492, 0);
}

static void sl_gtk_scrolled_window_set_shadow_type (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShadowType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_shadow_type(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5493, 5493, 0);
}

static void sl_g_file_info_set_symbolic_icon (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GIcon* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_file_info_set_symbolic_icon(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5494, 5494, 0);
}

static void sl_g_variant_new_handle (void)
{
   GVariant* retval;
   gint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_handle( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5495, 5495, 0);
}

static void sl_gtk_print_job_get_scale (void)
{
   gdouble retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_scale(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5496, 5496, 0);
}

static void sl_gdk_frame_timings_get_frame_counter (void)
{
   gint64 retval;
   GdkFrameTimings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkFrameTimings_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_frame_timings_get_frame_counter(arg1);
   (void)SLang_push_long(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5497, 5497, 0);
}

static void sl_gdk_device_set_key (void)
{
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   guint arg3;
   GdkModifierType arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_device_set_key(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5498, 5498, 0);
}

static void sl_g_settings_new (void)
{
   GSettings* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_settings_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5499, 5499, 0);
}

static void sl_gtk_page_setup_get_paper_height (void)
{
   gdouble retval;
   GtkPageSetup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkUnit arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_page_setup_get_paper_height(arg1,  arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5500, 5500, 0);
}

static void sl_gtk_accel_map_load_fd (void)
{
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   gtk_accel_map_load_fd( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5501, 5501, 0);
}

static void sl_gtk_label_set_angle (void)
{
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_label_set_angle(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5502, 5502, 0);
}

static void sl_gtk_drag_get_source_widget (void)
{
   GtkWidget* retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_drag_get_source_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5503, 5503, 0);
}

static void sl_gdk_gl_context_get_required_version (void)
{
   GdkGLContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg2,0x0);
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_gl_context_get_required_version(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5504, 5504, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_css_section_unref (void)
{
   GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_css_section_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5505, 5505, 0);
}

static void sl_gtk_application_window_set_help_overlay (void)
{
   GtkApplicationWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkShortcutsWindow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_window_set_help_overlay(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5506, 5506, 0);
}

static void sl_gdk_window_unmaximize (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_unmaximize(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5507, 5507, 0);
}

static void sl_gtk_gl_area_set_has_stencil_buffer (void)
{
   GtkGLArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gl_area_set_has_stencil_buffer(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5508, 5508, 0);
}

static void sl_gdk_window_stick (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_stick(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5509, 5509, 0);
}

static void sl_gtk_scrollbar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollbar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5510, 5510, 0);
}

static void sl_pango_context_set_language (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLanguage* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_context_set_language(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5511, 5511, 0);
}

static void sl_pango_layout_get_line (void)
{
   PangoLayoutLine* retval;
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_line(arg1,  arg2);
   (void)SLang_push_opaque(PangoLayoutLine_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5512, 5512, 0);
}

static void sl_g_unichar_type (void)
{
   GUnicodeType retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_type( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5513, 5513, 0);
}

static void sl_gtk_window_group_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_group_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5514, 5514, 0);
}

static void sl_gtk_window_set_default_icon (void)
{
   GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_default_icon(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5515, 5515, 0);
}

static void sl_gdk_device_get_seat (void)
{
   GdkSeat* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_seat(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5516, 5516, 0);
}

static void sl_gtk_paper_size_is_equal (void)
{
   gboolean retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPaperSize* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_paper_size_is_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5517, 5517, 0);
}

static void sl_gtk_tree_model_filter_set_visible_column (void)
{
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_model_filter_set_visible_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5518, 5518, 0);
}

static void sl_gtk_assistant_get_nth_page (void)
{
   GtkWidget* retval;
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_assistant_get_nth_page(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5519, 5519, 0);
}

static void sl_gtk_file_filter_add_pixbuf_formats (void)
{
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_file_filter_add_pixbuf_formats(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5520, 5520, 0);
}

static void sl_gtk_cell_area_render (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   cairo_t* arg4;
   Slirp_Opaque* arg4_o = NULL;
   GdkRectangle* arg5 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkRectangle* arg6 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GtkCellRendererState arg7;
   gboolean arg8;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 8) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg8)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg6, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg5, GdkRectangle_Layout)) goto free_and_return_6;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg4, &arg4_o)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_render(arg1, arg2, arg3, arg4, arg5, arg6,  arg7,  arg8);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
free_and_return_5:
   SLang_free_cstruct((VOID_STAR)arg5, GdkRectangle_Layout);
free_and_return_6:
   SLang_free_cstruct((VOID_STAR)arg6, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5521, 5521, 0);
}

static void sl_gtk_places_sidebar_get_local_only (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_local_only(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5522, 5522, 0);
}

static void sl_gtk_model_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_model_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5523, 5523, 0);
}

static void sl_gtk_text_buffer_place_cursor (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_place_cursor(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5524, 5524, 0);
}

static void sl_g_key_file_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_key_file_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5525, 5525, 0);
}

static void sl_g_menu_remove (void)
{
   GMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_menu_remove(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5526, 5526, 0);
}

static void sl_gtk_about_dialog_get_version (void)
{
   const gchar* retval;
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_about_dialog_get_version(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5527, 5527, 0);
}

static void sl_pango_cairo_glyph_string_path (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFont* arg2;
   Slirp_Opaque* arg2_o = NULL;
   PangoGlyphString* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoGlyphString_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_glyph_string_path(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5528, 5528, 0);
}

static void sl_gtk_widget_unparent (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_unparent(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5529, 5529, 0);
}

static void sl_gtk_entry_set_icon_from_stock (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkEntryIconPosition arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_set_icon_from_stock(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5530, 5530, 0);
}

static void sl_gdk_visual_get_best (void)
{
   GdkVisual* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5531, 5531, 0);
}

static void sl_pango_attr_size_new (void)
{
   PangoAttribute* retval;
   int arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_size_new( arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5532, 5532, 0);
}

static void sl_gtk_text_buffer_move_mark (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextMark* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const GtkTextIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_move_mark(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5533, 5533, 0);
}

static void sl_pango_attr_list_ref (void)
{
   PangoAttrList* retval;
   PangoAttrList* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoAttrList_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_list_ref(arg1);
   (void)SLang_push_opaque(PangoAttrList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5534, 5534, 0);
}

static void sl_gtk_text_view_backward_display_line_start (void)
{
   gboolean retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_view_backward_display_line_start(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5535, 5535, 0);
}

static void sl_gtk_scrolled_window_get_min_content_width (void)
{
   gint retval;
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrolled_window_get_min_content_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5536, 5536, 0);
}

static void sl_gtk_text_iter_forward_cursor_positions (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_forward_cursor_positions(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5537, 5537, 0);
}

static void sl_gtk_text_iter_backward_sentence_start (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_sentence_start(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5538, 5538, 0);
}

static void sl_gtk_list_box_get_adjustment (void)
{
   GtkAdjustment* retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_adjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5539, 5539, 0);
}

static void sl_gtk_tooltip_set_icon_from_icon_name (void)
{
   GtkTooltip* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkIconSize arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tooltip_set_icon_from_icon_name(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5540, 5540, 0);
}

static void sl_gtk_color_button_set_rgba (void)
{
   GtkColorButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRGBA* arg2 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRGBA_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_color_button_set_rgba(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRGBA_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5541, 5541, 0);
}

static void sl_g_menu_attribute_iter_get_name (void)
{
   const gchar* retval;
   GMenuAttributeIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_attribute_iter_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5542, 5542, 0);
}

static void sl_gtk_image_set_from_file (void)
{
   GtkImage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_image_set_from_file(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5543, 5543, 0);
}

static void sl_g_variant_type_next (void)
{
   const GVariantType* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_next(arg1);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5544, 5544, 0);
}

static void sl_g_file_attribute_matcher_subtract (void)
{
   GFileAttributeMatcher* retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileAttributeMatcher* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_attribute_matcher_subtract(arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5545, 5545, 0);
}

static void sl_gtk_tree_view_column_set_resizable (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_resizable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5546, 5546, 0);
}

static void sl_gtk_style_context_set_junction_sides (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkJunctionSides arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_set_junction_sides(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5547, 5547, 0);
}

static void sl_g_volume_monitor_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_volume_monitor_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5548, 5548, 0);
}

static void sl_g_file_new_for_commandline_arg (void)
{
   GFile* retval;
   char* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_new_for_commandline_arg(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5549, 5549, 0);
}

static void sl_gdk_window_set_child_input_shapes (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_child_input_shapes(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5550, 5550, 0);
}

static void sl_gtk_list_box_drag_unhighlight_row (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_box_drag_unhighlight_row(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5551, 5551, 0);
}

static void sl_gtk_menu_bar_set_child_pack_direction (void)
{
   GtkMenuBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkPackDirection arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_bar_set_child_pack_direction(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5552, 5552, 0);
}

static void sl_pango_context_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5553, 5553, 0);
}

static void sl_g_strcanon (void)
{
   gchar* retval;
   gchar* arg1;
   gchar* arg2;
   gchar arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strcanon(arg1, arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5554, 5554, 0);
}

static void sl_g_time_zone_find_interval (void)
{
   gint retval;
   GTimeZone* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GTimeType arg2;
   gint64 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimeZone_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_time_zone_find_interval(arg1,  arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5555, 5555, 0);
}

static void sl_gtk_tree_model_filter_clear_cache (void)
{
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_model_filter_clear_cache(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5556, 5556, 0);
}

static void sl_g_hostname_is_ip_address (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hostname_is_ip_address(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5557, 5557, 0);
}

static void sl_gdk_window_get_pass_through (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_pass_through(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5558, 5558, 0);
}

static void sl_gdk_window_get_support_multidevice (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_support_multidevice(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5559, 5559, 0);
}

static void sl_gdk_pixbuf_format_is_scalable (void)
{
   gboolean retval;
   GdkPixbufFormat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_is_scalable(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5560, 5560, 0);
}

static void sl_gtk_toolbar_get_item_index (void)
{
   gint retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkToolItem* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_toolbar_get_item_index(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5561, 5561, 0);
}

static void sl_gtk_window_get_accept_focus (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_accept_focus(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5562, 5562, 0);
}

static void sl_gtk_entry_set_cursor_hadjustment (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkAdjustment* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_entry_set_cursor_hadjustment(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5563, 5563, 0);
}

static void sl_gtk_aspect_frame_new (void)
{
   GtkWidget* retval;
   gchar* arg1;
   gfloat arg2;
   gfloat arg3;
   gfloat arg4;
   gboolean arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg1, NULL)) goto usage_label;
   issue_usage = 0;

   retval = gtk_aspect_frame_new(arg1,  arg2,  arg3,  arg4,  arg5);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5564, 5564, 0);
}

static void sl_gtk_widget_set_margin_top (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_margin_top(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5565, 5565, 0);
}

static void sl_g_settings_schema_source_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_settings_schema_source_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5566, 5566, 0);
}

static void sl_pango_attribute_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_attribute_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5567, 5567, 0);
}

static void sl_gdk_visual_get_system (void)
{
   GdkVisual* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_system();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5568, 5568, 0);
}

static void sl_gtk_list_box_set_placeholder (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_set_placeholder(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5569, 5569, 0);
}

static void sl_gtk_notebook_get_current_page (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_current_page(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5570, 5570, 0);
}

static void sl_g_iconv_close (void)
{
   gint retval;
   GIConv arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_iconv_close(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5571, 5571, 0);
}

static void sl_gtk_range_set_restrict_to_fill_level (void)
{
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_range_set_restrict_to_fill_level(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5572, 5572, 0);
}

static void sl_gtk_action_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_action_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5573, 5573, 0);
}

static void sl_gdk_window_get_drag_protocol (void)
{
   GdkDragProtocol retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkWindow** arg2;
   Slirp_Ref *arg2_r = ref_new(GObject_Type,sizeof(GdkWindow*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_drag_protocol(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5574, 5574, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_text_mark_get_left_gravity (void)
{
   gboolean retval;
   GtkTextMark* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_mark_get_left_gravity(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5575, 5575, 0);
}

static void sl_gtk_print_operation_preview_end_preview (void)
{
   GtkPrintOperationPreview* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_preview_end_preview(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5576, 5576, 0);
}

static void sl_gtk_radio_button_new_with_label (void)
{
   GtkWidget* retval;
   GSList* arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(GSList),&arg1,0x0);
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x1, 0)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_radio_button_new_with_label(arg1, arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5577, 5577, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_action_bar_pack_start (void)
{
   GtkActionBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_action_bar_pack_start(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5578, 5578, 0);
}

static void sl_gtk_tree_model_get_path (void)
{
   GtkTreePath* retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_model_get_path(arg1, arg2);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5579, 5579, 0);
}

static void sl_gtk_file_chooser_get_uri (void)
{
   gchar* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_get_uri(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5580, 5580, 0);
}

static void sl_g_regex_replace_literal (void)
{
   gchar* retval;
   const GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gssize arg3;
   gint arg4;
   gchar* arg5;
   GRegexMatchFlags arg6;
   GError* arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_long((long*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg7 = NULL;
   retval = g_regex_replace_literal(arg1, arg2,  arg3,  arg4, arg5,  arg6, &arg7);
   if (arg7 != NULL)
     throw_gerror(arg7);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_slstring(arg5);
usage_label:
   if (issue_usage) Slirp_usage (5581, 5581, 0);
}

static void sl_gtk_image_new_from_icon_name (void)
{
   GtkWidget* retval;
   gchar* arg1;
   GtkIconSize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_icon_name(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5582, 5582, 0);
}

static void sl_g_cancellable_get_current (void)
{
   GCancellable* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_get_current();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5583, 5583, 0);
}

static void sl_pango_font_family_list_faces (void)
{
   PangoFontFamily* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontFace*** arg2;
   Slirp_Opaque* arg2_o = NULL;
   int* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoFontFace_ptr_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_font_family_list_faces(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5584, 5584, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_timer_continue (void)
{
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_timer_continue(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5585, 5585, 0);
}

static void sl_g_variant_new_boolean (void)
{
   GVariant* retval;
   gboolean arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_new_boolean( arg1);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5586, 5586, 0);
}

static void sl_gtk_notebook_get_tab_label_text (void)
{
   const gchar* retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_get_tab_label_text(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5587, 5587, 0);
}

static void sl_gtk_window_set_application (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkApplication* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_window_set_application(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5588, 5588, 0);
}

static void sl_gdk_keyval_from_name (void)
{
   guint retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gdk_keyval_from_name(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5589, 5589, 0);
}

static void sl_gtk_widget_get_font_map (void)
{
   PangoFontMap* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_font_map(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5590, 5590, 0);
}

static void sl_gtk_style_context_add_class (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_add_class(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5591, 5591, 0);
}

static void sl_gtk_tool_shell_get_ellipsize_mode (void)
{
   PangoEllipsizeMode retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_ellipsize_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5592, 5592, 0);
}

static void sl_gdk_set_allowed_backends (void)
{
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   gdk_set_allowed_backends(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5593, 5593, 0);
}

static void sl_gtk_clipboard_get_selection (void)
{
   GdkAtom retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_get_selection(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5594, 5594, 0);
}

static void sl_gdk_device_get_vendor_id (void)
{
   const gchar* retval;
   GdkDevice* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkDevice_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_device_get_vendor_id(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5595, 5595, 0);
}

static void sl_gtk_recent_info_last_application (void)
{
   gchar* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_last_application(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5596, 5596, 0);
}

static void sl_gtk_cell_renderer_get_sensitive (void)
{
   gboolean retval;
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_get_sensitive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5597, 5597, 0);
}

static void sl_gtk_printer_get_name (void)
{
   const gchar* retval;
   GtkPrinter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_printer_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5598, 5598, 0);
}

static void sl_g_format_size (void)
{
   gchar* retval;
   guint64 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_format_size( arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5599, 5599, 0);
}

static void sl_gtk_gesture_swipe_get_velocity (void)
{
   gboolean retval;
   GtkGestureSwipe* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_DOUBLE_TYPE,sizeof(gdouble),&arg2,0x0);
   gdouble* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_DOUBLE_TYPE,sizeof(gdouble),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_swipe_get_velocity(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5600, 5600, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_tree_view_set_model (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_set_model(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5601, 5601, 0);
}

static void sl_gdk_event_get_device (void)
{
   GdkDevice* retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_device(arg1);
   (void)SLang_push_opaque(GdkDevice_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5602, 5602, 0);
}

static void sl_gdk_drag_context_get_actions (void)
{
   GdkDragAction retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_actions(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5603, 5603, 0);
}

static void sl_gtk_list_store_swap (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_store_swap(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5604, 5604, 0);
}

static void sl_gtk_window_set_urgency_hint (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_urgency_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5605, 5605, 0);
}

static void sl_gtk_cell_area_get_preferred_height_for_width (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellAreaContext* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gint arg4;
   gint arg5;
   gint arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_get_preferred_height_for_width(arg1, arg2, arg3,  arg4, &arg5, &arg6);
   (void)SLang_push_int(arg5);
   (void)SLang_push_int(arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5606, 5606, 0);
}

static void sl_gtk_window_set_gravity (void)
{
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkGravity arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_window_set_gravity(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5607, 5607, 0);
}

static void sl_g_variant_type_new_tuple (void)
{
   GVariantType* retval;
   const GVariantType** arg1;
   Slirp_Ref *arg1_r = ref_new(GVariantType_Type,sizeof(GVariantType*),&arg1,0x0);
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_new_tuple(arg1,  arg2);
   (void)SLang_push_opaque(GVariantType_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5608, 5608, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_gtk_app_chooser_widget_set_show_other (void)
{
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_app_chooser_widget_set_show_other(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5609, 5609, 0);
}

static void sl_g_value_take_string (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_value_take_string(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5610, 5610, 0);
}

static void sl_gtk_entry_buffer_get_text (void)
{
   const gchar* retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_get_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5611, 5611, 0);
}

static void sl_gtk_notebook_detach_tab (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_notebook_detach_tab(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5612, 5612, 0);
}

static void sl_gdk_crossing_mode_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_crossing_mode_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5613, 5613, 0);
}

static void sl_gdk_drag_context_get_protocol (void)
{
   GdkDragProtocol retval;
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_drag_context_get_protocol(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5614, 5614, 0);
}

static void sl_gtk_places_sidebar_set_show_starred_location (void)
{
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_places_sidebar_set_show_starred_location(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5615, 5615, 0);
}

static void sl_g_bookmark_file_set_added (void)
{
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   time_t arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_bookmark_file_set_added(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5616, 5616, 0);
}

static void sl_gtk_accelerator_get_label (void)
{
   gchar* retval;
   guint arg1;
   GdkModifierType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_accelerator_get_label( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5617, 5617, 0);
}

static void sl_gtk_icon_view_set_tooltip_cell (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTooltip* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkTreePath* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkCellRenderer* arg4;
   Slirp_Opaque* arg4_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg4, &arg4_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreePath_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_icon_view_set_tooltip_cell(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5618, 5618, 0);
}

static void sl_g_file_test (void)
{
   gboolean retval;
   gchar* arg1;
   GFileTest arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_file_test(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5619, 5619, 0);
}

static void sl_gtk_grab_remove (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_grab_remove(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5620, 5620, 0);
}

static void sl_g_idle_source_new (void)
{
   GSource* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_idle_source_new();
   (void)SLang_push_opaque(GSource_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5621, 5621, 0);
}

static void sl_gdk_window_has_native (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_has_native(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5622, 5622, 0);
}

static void sl_gtk_application_set_accels_for_action (void)
{
   GtkApplication* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   const gchar** arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_application_set_accels_for_action(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5623, 5623, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_g_cancellable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_cancellable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5624, 5624, 0);
}

static void sl_gtk_widget_set_double_buffered (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_double_buffered(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5625, 5625, 0);
}

static void sl_gtk_notebook_insert_page_menu (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkWidget* arg3;
   Slirp_Opaque* arg3_o = NULL;
   GtkWidget* arg4;
   Slirp_Opaque* arg4_o = NULL;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg4_o, (void**)&arg4)) goto usage_label;
   if (-1 == pop_nullable(GtkWidget_Type, (void**)&arg3_o, (void**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_insert_page_menu(arg1, arg2, arg3, arg4,  arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_opaque(arg4_o);
usage_label:
   if (issue_usage) Slirp_usage (5626, 5626, 0);
}

static void sl_gtk_tree_row_reference_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_row_reference_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5627, 5627, 0);
}

static void sl_gdk_window_ensure_native (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_ensure_native(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5628, 5628, 0);
}

static void sl_gtk_widget_get_default_direction (void)
{
   GtkTextDirection retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_default_direction();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5629, 5629, 0);
}

static void sl_gtk_icon_theme_get_for_screen (void)
{
   GtkIconTheme* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_theme_get_for_screen(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5630, 5630, 0);
}

static void sl_gtk_icon_info_get_filename (void)
{
   const gchar* retval;
   GtkIconInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_icon_info_get_filename(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5631, 5631, 0);
}

static void sl_gtk_label_get_label (void)
{
   const gchar* retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_label(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5632, 5632, 0);
}

static void sl_gdk_pixbuf_loader_set_size (void)
{
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   int arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_pixbuf_loader_set_size(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5633, 5633, 0);
}

static void sl_g_value_reset (void)
{
   GValue* retval;
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_reset(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5634, 5634, 0);
}

static void sl_gtk_toggle_button_new_with_mnemonic (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_new_with_mnemonic(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5635, 5635, 0);
}

static void sl_g_variant_new_fixed_array (void)
{
   GVariant* retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gconstpointer arg2;
   Slirp_Opaque* arg2_o = NULL;
   gsize arg3;
   gsize arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_variant_new_fixed_array(arg1, arg2,  arg3,  arg4);
   (void)SLang_push_opaque(GVariant_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5636, 5636, 0);
}

static void sl_g_file_info_new (void)
{
   GFileInfo* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5637, 5637, 0);
}

static void sl_gtk_icon_theme_load_icon (void)
{
   GdkPixbuf* retval;
   GtkIconTheme* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   GtkIconLookupFlags arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = gtk_icon_theme_load_icon(arg1, arg2,  arg3,  arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5638, 5638, 0);
}

static void sl_gtk_print_unix_dialog_set_embed_page_setup (void)
{
   GtkPrintUnixDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_unix_dialog_set_embed_page_setup(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5639, 5639, 0);
}

static void sl_gtk_print_settings_load_key_file (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GKeyFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   GError* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg4 = NULL;
   retval = gtk_print_settings_load_key_file(arg1, arg2, arg3, &arg4);
   if (arg4 != NULL)
     throw_gerror(arg4);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5640, 5640, 0);
}

static void sl_gtk_icon_view_set_item_orientation (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkOrientation arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_item_orientation(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5641, 5641, 0);
}

static void sl_gtk_text_buffer_end_user_action (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_buffer_end_user_action(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5642, 5642, 0);
}

static void sl_gtk_entry_get_cursor_hadjustment (void)
{
   GtkAdjustment* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_cursor_hadjustment(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5643, 5643, 0);
}

static void sl_gtk_recent_info_get_added (void)
{
   time_t retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_added(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5644, 5644, 0);
}

static void sl_g_network_address_get_scheme (void)
{
   const gchar* retval;
   GNetworkAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_network_address_get_scheme(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5645, 5645, 0);
}

static void sl_gtk_widget_path_iter_list_classes (void)
{
   GSList* retval;
   const GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_path_iter_list_classes(arg1,  arg2);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_string ((gchar*) list->data);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5646, 5646, 0);
}

static void sl_g_file_unmount_mountable_with_operation_finish (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_unmount_mountable_with_operation_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5647, 5647, 0);
}

static void sl_gtk_switch_get_state (void)
{
   gboolean retval;
   GtkSwitch* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_switch_get_state(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5648, 5648, 0);
}

static void sl_gtk_text_buffer_deserialize_set_can_create_tags (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_deserialize_set_can_create_tags(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5649, 5649, 0);
}

static void sl_gdk_window_move_to_rect (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkRectangle* arg2 = (GdkRectangle*) alloca(sizeof(GdkRectangle));
   GdkGravity arg3;
   GdkGravity arg4;
   GdkAnchorHints arg5;
   gint arg6;
   gint arg7;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 7) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg7)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkRectangle_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_move_to_rect(arg1, arg2,  arg3,  arg4,  arg5,  arg6,  arg7);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkRectangle_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5650, 5650, 0);
}

static void sl_gtk_image_new_from_surface (void)
{
   GtkWidget* retval;
   cairo_surface_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_new_from_surface(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5651, 5651, 0);
}

static void sl_g_closure_new_object (void)
{
   GClosure* retval;
   guint arg1;
   GObject* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_closure_new_object( arg1, arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5652, 5652, 0);
}

static void sl_g_format_size_full (void)
{
   gchar* retval;
   guint64 arg1;
   GFormatSizeFlags arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_format_size_full( arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5653, 5653, 0);
}

static void sl_gtk_tree_store_iter_depth (void)
{
   gint retval;
   GtkTreeStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_tree_store_iter_depth(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5654, 5654, 0);
}

static void sl_g_param_value_validate (void)
{
   gboolean retval;
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_param_value_validate(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5655, 5655, 0);
}

static void sl_g_binding_get_source_property (void)
{
   const gchar* retval;
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_binding_get_source_property(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5656, 5656, 0);
}

static void sl_g_drive_stop_finish (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_drive_stop_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5657, 5657, 0);
}

static void sl_gtk_text_iter_get_visible_slice (void)
{
   gchar* retval;
   const GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTextIter* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_iter_get_visible_slice(arg1, arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5658, 5658, 0);
}

static void sl_g_bookmark_file_get_visited (void)
{
   time_t retval;
   GBookmarkFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GBookmarkFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_bookmark_file_get_visited(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5659, 5659, 0);
}

static void sl_gdk_window_get_root_coords (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_root_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5660, 5660, 0);
}

static void sl_gdk_window_set_skip_pager_hint (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_skip_pager_hint(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5661, 5661, 0);
}

static void sl_gtk_dialog_get_header_bar (void)
{
   GtkWidget* retval;
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_get_header_bar(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5662, 5662, 0);
}

static void sl_gtk_widget_set_vexpand_set (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_vexpand_set(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5663, 5663, 0);
}

static void sl_gtk_search_bar_handle_event (void)
{
   gboolean retval;
   GtkSearchBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_search_bar_handle_event(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5664, 5664, 0);
}

static void sl_g_rand_copy (void)
{
   GRand* retval;
   GRand* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRand_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_rand_copy(arg1);
   (void)SLang_push_opaque(GRand_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5665, 5665, 0);
}

static void sl_gdk_pixbuf_loader_write_bytes (void)
{
   gboolean retval;
   GdkPixbufLoader* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GBytes* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GBytes_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gdk_pixbuf_loader_write_bytes(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5666, 5666, 0);
}

static void sl_gtk_widget_get_accessible (void)
{
   AtkObject* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_accessible(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5667, 5667, 0);
}

static void sl_gtk_menu_reorder_child (void)
{
   GtkMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_menu_reorder_child(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5668, 5668, 0);
}

static void sl_gdk_seat_get_display (void)
{
   GdkDisplay* retval;
   GdkSeat* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5669, 5669, 0);
}

static void sl_gtk_app_chooser_get_app_info (void)
{
   GAppInfo* retval;
   GtkAppChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_get_app_info(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5670, 5670, 0);
}

static void sl_g_key_file_set_string (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gchar* arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto free_and_return_4;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_key_file_set_string(arg1, arg2, arg3, arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (5671, 5671, 0);
}

static void sl_gtk_assistant_remove_action_widget (void)
{
   GtkAssistant* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_assistant_remove_action_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5672, 5672, 0);
}

static void sl_g_random_set_seed (void)
{
   guint32 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   g_random_set_seed( arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5673, 5673, 0);
}

static void sl_gdk_visual_get_colormap_size (void)
{
   gint retval;
   GdkVisual* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_colormap_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5674, 5674, 0);
}

static void sl_gtk_info_bar_get_show_close_button (void)
{
   gboolean retval;
   GtkInfoBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_info_bar_get_show_close_button(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5675, 5675, 0);
}

static void sl_gtk_clipboard_wait_is_uris_available (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_clipboard_wait_is_uris_available(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5676, 5676, 0);
}

static void sl_pango_attr_strikethrough_color_new (void)
{
   PangoAttribute* retval;
   guint16 arg1;
   guint16 arg2;
   guint16 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_ushort((unsigned short*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_strikethrough_color_new( arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5677, 5677, 0);
}

static void sl_g_unichar_isupper (void)
{
   gboolean retval;
   gunichar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_unichar_isupper( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5678, 5678, 0);
}

static void sl_gtk_entry_completion_insert_action_text (void)
{
   GtkEntryCompletion* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   gtk_entry_completion_insert_action_text(arg1,  arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5679, 5679, 0);
}

static void sl_gtk_menu_item_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_menu_item_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5680, 5680, 0);
}

static void sl_gtk_tool_shell_get_orientation (void)
{
   GtkOrientation retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_orientation(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5681, 5681, 0);
}

static void sl_g_ascii_xdigit_value (void)
{
   gint retval;
   gchar arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_ascii_xdigit_value( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5682, 5682, 0);
}

static void sl_gtk_button_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5683, 5683, 0);
}

static void sl_g_strip_context (void)
{
   const gchar* retval;
   gchar* arg1;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_strip_context(arg1, arg2);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5684, 5684, 0);
}

static void sl_pango_context_get_font_map (void)
{
   PangoFontMap* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_context_get_font_map(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5685, 5685, 0);
}

static void sl_g_type_get_type_registration_serial (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_type_get_type_registration_serial();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5686, 5686, 0);
}

static void sl_g_menu_item_set_attribute_value (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GVariant* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariant_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_attribute_value(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5687, 5687, 0);
}

static void sl_gtk_widget_get_tooltip_text (void)
{
   gchar* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_tooltip_text(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5688, 5688, 0);
}

static void sl_gtk_app_chooser_widget_get_show_other (void)
{
   gboolean retval;
   GtkAppChooserWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_widget_get_show_other(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5689, 5689, 0);
}

static void sl_pango_layout_iter_get_layout (void)
{
   PangoLayout* retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_get_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5690, 5690, 0);
}

static void sl_gtk_get_binary_age (void)
{
   guint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_get_binary_age();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5691, 5691, 0);
}

static void sl_g_regex_ref (void)
{
   GRegex* retval;
   GRegex* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GRegex_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_ref(arg1);
   (void)SLang_push_opaque(GRegex_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5692, 5692, 0);
}

static void sl_pango_layout_index_to_line_x (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int arg2;
   gboolean arg3;
   int* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_INT_TYPE,sizeof(int),&arg4,0x0);
   int arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_index_to_line_x(arg1,  arg2,  arg3, arg4, &arg5);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5693, 5693, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_g_variant_parse_error_quark (void)
{
   GQuark retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_variant_parse_error_quark();
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5694, 5694, 0);
}

static void sl_gdk_pixbuf_get_width (void)
{
   int retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_width(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5695, 5695, 0);
}

static void sl_gtk_accessible_set_widget (void)
{
   GtkAccessible* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_accessible_set_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5696, 5696, 0);
}

static void sl_gdk_window_set_geometry_hints (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkGeometry* arg2 = (GdkGeometry*) alloca(sizeof(GdkGeometry));
   GdkWindowHints arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_cstruct ( (VOID_STAR)arg2, GdkGeometry_Layout)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_window_set_geometry_hints(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_cstruct((VOID_STAR)arg2, GdkGeometry_Layout);
usage_label:
   if (issue_usage) Slirp_usage (5697, 5697, 0);
}

static void sl_gtk_file_filter_get_name (void)
{
   const gchar* retval;
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_filter_get_name(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5698, 5698, 0);
}

static void sl_gdk_window_get_effective_parent (void)
{
   GdkWindow* retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_effective_parent(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5699, 5699, 0);
}

static void sl_gtk_flow_box_get_child_at_pos (void)
{
   GtkFlowBoxChild* retval;
   GtkFlowBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_flow_box_get_child_at_pos(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5700, 5700, 0);
}

static void sl_g_hostname_is_non_ascii (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_hostname_is_non_ascii(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5701, 5701, 0);
}

static void sl_g_filename_completer_get_completions (void)
{
   char** retval;
   GFilenameCompleter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_filename_completer_get_completions(arg1, arg2);
   push_null_term_str_array (retval, "g_filename_completer_get_completions", 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5702, 5702, 0);
}

static void sl_gtk_recent_chooser_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5703, 5703, 0);
}

static void sl_gtk_header_bar_get_has_subtitle (void)
{
   gboolean retval;
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_header_bar_get_has_subtitle(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5704, 5704, 0);
}

static void sl_gdk_window_is_visible (void)
{
   gboolean retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_is_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5705, 5705, 0);
}

static void sl_gtk_render_background (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_background(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5706, 5706, 0);
}

static void sl_gtk_text_buffer_get_mark (void)
{
   GtkTextMark* retval;
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_text_buffer_get_mark(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5707, 5707, 0);
}

static void sl_pango_cairo_font_map_get_default (void)
{
   PangoFontMap* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_get_default();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5708, 5708, 0);
}

static void sl_g_mount_get_icon (void)
{
   GIcon* retval;
   GMount* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_mount_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5709, 5709, 0);
}

static void sl_gdk_window_get_user_data (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gpointer* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(gpointer),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_get_user_data(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5710, 5710, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_tool_palette_get_drag_target_group (void)
{
   const GtkTargetEntry* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_drag_target_group();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5711, 5711, 0);
}

static void sl_pango_layout_new (void)
{
   PangoLayout* retval;
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5712, 5712, 0);
}

static void sl_g_date_new (void)
{
   GDate* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_date_new();
   (void)SLang_push_opaque(GDate_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5713, 5713, 0);
}

static void sl_gtk_notebook_prev_page (void)
{
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_notebook_prev_page(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5714, 5714, 0);
}

static void sl_gdk_window_configure_finished (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_configure_finished(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5715, 5715, 0);
}

static void sl_g_emblem_get_icon (void)
{
   GIcon* retval;
   GEmblem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_emblem_get_icon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5716, 5716, 0);
}

static void sl_g_date_days_between (void)
{
   gint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GDate* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_date_days_between(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5717, 5717, 0);
}

static void sl_gtk_list_box_get_selection_mode (void)
{
   GtkSelectionMode retval;
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_list_box_get_selection_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5718, 5718, 0);
}

static void sl_gtk_tool_shell_get_icon_size (void)
{
   GtkIconSize retval;
   GtkToolShell* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_shell_get_icon_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5719, 5719, 0);
}

static void sl_gtk_style_context_invalidate (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_invalidate(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5720, 5720, 0);
}

static void sl_gtk_text_iter_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5721, 5721, 0);
}

static void sl_pango_cairo_font_map_new (void)
{
   PangoFontMap* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_cairo_font_map_new();
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5722, 5722, 0);
}

static void sl_gtk_file_filter_filter (void)
{
   gboolean retval;
   GtkFileFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkFileFilterInfo* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_filter_filter(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5723, 5723, 0);
}

static void sl_gtk_widget_path_append_for_widget (void)
{
   gint retval;
   GtkWidgetPath* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidgetPath_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_path_append_for_widget(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5724, 5724, 0);
}

static void sl_gtk_widget_list_accel_closures (void)
{
   GList* retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_list_accel_closures(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5725, 5725, 0);
}

static void sl_gtk_stack_set_hhomogeneous (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_hhomogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5726, 5726, 0);
}

static void sl_gtk_notebook_page_num (void)
{
   gint retval;
   GtkNotebook* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_notebook_page_num(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5727, 5727, 0);
}

static void sl_gtk_paper_size_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5728, 5728, 0);
}

static void sl_gtk_about_dialog_set_comments (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_nullable(SLANG_STRING_TYPE, (void**)&arg2, NULL)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_comments(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5729, 5729, 0);
}

static void sl_gdk_property_state_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_property_state_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5730, 5730, 0);
}

static void sl_g_get_application_name (void)
{
   const gchar* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_get_application_name();
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5731, 5731, 0);
}

static void sl_gtk_combo_box_set_wrap_width (void)
{
   GtkComboBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_combo_box_set_wrap_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5732, 5732, 0);
}

static void sl_gtk_cell_renderer_combo_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_combo_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5733, 5733, 0);
}

static void sl_g_value_set_schar (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint8 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_char((char*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_schar(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5734, 5734, 0);
}

static void sl_g_menu_model_get_n_items (void)
{
   gint retval;
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_menu_model_get_n_items(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5735, 5735, 0);
}

static void sl_g_socket_speaks_ipv4 (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_speaks_ipv4(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5736, 5736, 0);
}

static void sl_gtk_text_iter_backward_visible_cursor_position (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_visible_cursor_position(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5737, 5737, 0);
}

static void sl_gtk_list_store_reorder (void)
{
   GtkListStore* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_list_store_reorder(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5738, 5738, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_g_settings_set_uint64 (void)
{
   gboolean retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   guint64 arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_set_uint64(arg1, arg2,  arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5739, 5739, 0);
}

static void sl_g_strfreev (void)
{
   gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   g_strfreev(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5740, 5740, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_socket_get_keepalive (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_socket_get_keepalive(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5741, 5741, 0);
}

static void sl_gdk_pointer_is_grabbed (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pointer_is_grabbed();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5742, 5742, 0);
}

static void sl_gtk_font_button_new_with_font (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_button_new_with_font(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5743, 5743, 0);
}

static void sl_gdk_display_close (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_display_close(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5744, 5744, 0);
}

static void sl_pango_attr_language_new (void)
{
   PangoAttribute* retval;
   PangoLanguage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_attr_language_new(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5745, 5745, 0);
}

static void sl_g_settings_get_double (void)
{
   gdouble retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_double(arg1, arg2);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5746, 5746, 0);
}

static void sl_gtk_calendar_set_detail_width_chars (void)
{
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_calendar_set_detail_width_chars(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5747, 5747, 0);
}

static void sl_g_content_type_is_unknown (void)
{
   gboolean retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_is_unknown(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5748, 5748, 0);
}

static void sl_pango_cairo_layout_path (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoLayout* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_cairo_layout_path(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5749, 5749, 0);
}

static void sl_gtk_range_get_round_digits (void)
{
   gint retval;
   GtkRange* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_range_get_round_digits(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5750, 5750, 0);
}

static void sl_gtk_tree_view_column_set_reorderable (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_view_column_set_reorderable(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5751, 5751, 0);
}

static void sl_g_param_spec_unref (void)
{
   GParamSpec* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_param_spec_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5752, 5752, 0);
}

static void sl_g_regex_escape_nul (void)
{
   gchar* retval;
   gchar* arg1;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_regex_escape_nul(arg1,  arg2);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5753, 5753, 0);
}

static void sl_gtk_print_job_set_source_file (void)
{
   gboolean retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = gtk_print_job_set_source_file(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5754, 5754, 0);
}

static void sl_g_drive_can_poll_for_media (void)
{
   gboolean retval;
   GDrive* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_drive_can_poll_for_media(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5755, 5755, 0);
}

static void sl_gdk_pixbuf_flip (void)
{
   GdkPixbuf* retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_flip(arg1,  arg2);
   (void)SLang_push_opaque(GdkPixbuf_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5756, 5756, 0);
}

static void sl_gtk_file_chooser_select_filename (void)
{
   gboolean retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_file_chooser_select_filename(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5757, 5757, 0);
}

static void sl_gtk_adjustment_clamp_page (void)
{
   GtkAdjustment* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_adjustment_clamp_page(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5758, 5758, 0);
}

static void sl_g_value_set_float (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_float(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5759, 5759, 0);
}

static void sl_g_file_attribute_matcher_ref (void)
{
   GFileAttributeMatcher* retval;
   GFileAttributeMatcher* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_attribute_matcher_ref(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5760, 5760, 0);
}

static void sl_gtk_entry_buffer_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5761, 5761, 0);
}

static void sl_gtk_stack_set_homogeneous (void)
{
   GtkStack* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_stack_set_homogeneous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5762, 5762, 0);
}

static void sl_gtk_spin_button_set_range (void)
{
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gdouble arg2;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spin_button_set_range(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5763, 5763, 0);
}

static void sl_g_file_query_file_type (void)
{
   GFileType retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GFileQueryInfoFlags arg2;
   GCancellable* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_3;
   issue_usage = 0;

   retval = g_file_query_file_type(arg1,  arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5764, 5764, 0);
}

static void sl_gtk_print_operation_set_track_print_status (void)
{
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_operation_set_track_print_status(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5765, 5765, 0);
}

static void sl_gtk_spin_button_get_snap_to_ticks (void)
{
   gboolean retval;
   GtkSpinButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_spin_button_get_snap_to_ticks(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5766, 5766, 0);
}

static void sl_gtk_scrolled_window_set_max_content_width (void)
{
   GtkScrolledWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_scrolled_window_set_max_content_width(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5767, 5767, 0);
}

static void sl_gtk_file_chooser_list_filters (void)
{
   GSList* retval;
   GtkFileChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_file_chooser_list_filters(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_slist_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5768, 5768, 0);
}

static void sl_gtk_recent_info_get_gicon (void)
{
   GIcon* retval;
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_info_get_gicon(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5769, 5769, 0);
}

static void sl_gtk_print_settings_get_collate (void)
{
   gboolean retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_collate(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5770, 5770, 0);
}

static void sl_gdk_cursor_new_from_name (void)
{
   GdkCursor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_cursor_new_from_name(arg1, arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5771, 5771, 0);
}

static void sl_gtk_cell_renderer_text_set_fixed_height_from_font (void)
{
   GtkCellRendererText* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_text_set_fixed_height_from_font(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5772, 5772, 0);
}

static void sl_gtk_places_sidebar_get_show_enter_location (void)
{
   gboolean retval;
   GtkPlacesSidebar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_places_sidebar_get_show_enter_location(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5773, 5773, 0);
}

static void sl_gtk_render_expander (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_expander(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5774, 5774, 0);
}

static void sl_g_key_file_remove_group (void)
{
   gboolean retval;
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_key_file_remove_group(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5775, 5775, 0);
}

static void sl_gtk_gesture_single_set_exclusive (void)
{
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gesture_single_set_exclusive(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5776, 5776, 0);
}

static void sl_gtk_app_chooser_button_get_heading (void)
{
   const gchar* retval;
   GtkAppChooserButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_app_chooser_button_get_heading(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5777, 5777, 0);
}

static void sl_pango_layout_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5778, 5778, 0);
}

static void sl_gtk_header_bar_pack_end (void)
{
   GtkHeaderBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_header_bar_pack_end(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5779, 5779, 0);
}

static void sl_gtk_grid_get_column_spacing (void)
{
   guint retval;
   GtkGrid* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_grid_get_column_spacing(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5780, 5780, 0);
}

static void sl_gtk_toolbar_get_nth_item (void)
{
   GtkToolItem* retval;
   GtkToolbar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toolbar_get_nth_item(arg1,  arg2);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5781, 5781, 0);
}

static void sl_gtk_gesture_get_last_updated_sequence (void)
{
   GdkEventSequence* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_last_updated_sequence(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5782, 5782, 0);
}

static void sl_gtk_builder_set_application (void)
{
   GtkBuilder* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkApplication* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_builder_set_application(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5783, 5783, 0);
}

static void sl_gtk_menu_item_toggle_size_request (void)
{
   GtkMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_menu_item_toggle_size_request(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5784, 5784, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_button_get_always_show_image (void)
{
   gboolean retval;
   GtkButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_button_get_always_show_image(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5785, 5785, 0);
}

static void sl_gtk_separator_tool_item_new (void)
{
   GtkToolItem* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_separator_tool_item_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5786, 5786, 0);
}

static void sl_g_io_channel_error_from_errno (void)
{
   GIOChannelError retval;
   gint arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_io_channel_error_from_errno( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5787, 5787, 0);
}

static void sl_gtk_tree_model_filter_refilter (void)
{
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_tree_model_filter_refilter(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5788, 5788, 0);
}

static void sl_g_initially_unowned_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_initially_unowned_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5789, 5789, 0);
}

static void sl_g_menu_item_set_submenu (void)
{
   GMenuItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GMenuModel* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   g_menu_item_set_submenu(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5790, 5790, 0);
}

static void sl_gdk_pixbuf_format_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_format_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5791, 5791, 0);
}

static void sl_g_value_get_ulong (void)
{
   gulong retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_ulong(arg1);
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5792, 5792, 0);
}

static void sl_gtk_drag_finish (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   gboolean arg3;
   guint32 arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_drag_finish(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5793, 5793, 0);
}

static void sl_g_file_set_attribute_int32 (void)
{
   gboolean retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   gint32 arg3;
   GFileQueryInfoFlags arg4;
   GCancellable* arg5;
   Slirp_Opaque* arg5_o = NULL;
   GError* arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 5) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg5, &arg5_o)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto free_and_return_5;
   if (-1 == SLang_pop_int((int*)&arg3)) goto free_and_return_5;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_5;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg6 = NULL;
   retval = g_file_set_attribute_int32(arg1, arg2,  arg3,  arg4, arg5, &arg6);
   if (arg6 != NULL)
     throw_gerror(arg6);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_5:
   SLang_free_opaque(arg5_o);
usage_label:
   if (issue_usage) Slirp_usage (5794, 5794, 0);
}

static void sl_g_mount_operation_set_anonymous (void)
{
   GMountOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_mount_operation_set_anonymous(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5795, 5795, 0);
}

static void sl_gtk_print_operation_get_embed_page_setup (void)
{
   gboolean retval;
   GtkPrintOperation* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_operation_get_embed_page_setup(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5796, 5796, 0);
}

static void sl_gtk_icon_view_select_all (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_select_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5797, 5797, 0);
}

static void sl_gtk_level_bar_new (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_level_bar_new();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5798, 5798, 0);
}

static void sl_gdk_setting_get (void)
{
   gboolean retval;
   gchar* arg1;
   GValue* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_setting_get(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5799, 5799, 0);
}

static void sl_g_file_info_get_attribute_byte_string (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   char* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_file_info_get_attribute_byte_string(arg1, arg2);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5800, 5800, 0);
}

static void sl_pango_layout_set_justify (void)
{
   PangoLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_layout_set_justify(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5801, 5801, 0);
}

static void sl_gtk_widget_set_vexpand (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_vexpand(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5802, 5802, 0);
}

static void sl_gtk_icon_view_set_text_column (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_set_text_column(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5803, 5803, 0);
}

static void sl_gtk_text_view_set_pixels_inside_wrap (void)
{
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_text_view_set_pixels_inside_wrap(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5804, 5804, 0);
}

static void sl_pango_font_descriptions_free (void)
{
   PangoFontDescription** arg1;
   Slirp_Ref *arg1_r = ref_new(GtkOpaque_Type,sizeof(PangoFontDescription*),&arg1,0x0);
   int arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   pango_font_descriptions_free(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5805, 5805, 0);
   finalize_refs(1,arg1_r); 
}

static void sl_g_content_type_get_mime_type (void)
{
   gchar* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_content_type_get_mime_type(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5806, 5806, 0);
}

static void sl_gdk_cairo_region (void)
{
   cairo_t* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const cairo_region_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_cairo_region(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5807, 5807, 0);
}

static void sl_gdk_cursor_new_for_display (void)
{
   GdkCursor* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkCursorType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_cursor_new_for_display(arg1,  arg2);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5808, 5808, 0);
}

static void sl_g_value_init (void)
{
   GValue* retval;
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GType arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_ulong((unsigned long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_init(arg1,  arg2);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5809, 5809, 0);
}

static void sl_gtk_cell_layout_get_area (void)
{
   GtkCellArea* retval;
   GtkCellLayout* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_layout_get_area(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5810, 5810, 0);
}

static void sl_gtk_calendar_get_display_options (void)
{
   GtkCalendarDisplayOptions retval;
   GtkCalendar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_calendar_get_display_options(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5811, 5811, 0);
}

static void sl_gtk_search_bar_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_search_bar_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5812, 5812, 0);
}

static void sl_g_main_context_ref_thread_default (void)
{
   GMainContext* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = g_main_context_ref_thread_default();
   (void)SLang_push_opaque(GMainContext_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5813, 5813, 0);
}

static void sl_g_utf8_get_char_validated (void)
{
   gunichar retval;
   gchar* arg1;
   gssize arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_get_char_validated(arg1,  arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5814, 5814, 0);
}

static void sl_gdk_display_list_seats (void)
{
   GList* retval;
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_display_list_seats(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5815, 5815, 0);
}

static void sl_g_file_mount_mountable_finish (void)
{
   GFile* retval;
   GFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GAsyncResult* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_file_mount_mountable_finish(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5816, 5816, 0);
}

static void sl_gtk_progress_bar_get_fraction (void)
{
   gdouble retval;
   GtkProgressBar* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_progress_bar_get_fraction(arg1);
   (void)SLang_push_double(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5817, 5817, 0);
}

static void sl_g_ucs4_to_utf16 (void)
{
   gunichar2* retval;
   const gunichar* arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_UINT_TYPE,sizeof(gunichar),&arg1,0x0);
   glong arg2;
   glong* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_LONG_TYPE,sizeof(glong),&arg3,0x0);
   glong arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x1, 0)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   arg4 = NULL;
   arg5 = NULL;
   retval = g_ucs4_to_utf16(arg1,  arg2, arg3, &arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_opaque(ushort_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5818, 5818, 0);
   finalize_refs(2,arg1_r,arg3_r); 
}

static void sl_gtk_icon_view_convert_widget_to_bin_window_coords (void)
{
   GtkIconView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_icon_view_convert_widget_to_bin_window_coords(arg1,  arg2,  arg3, &arg4, &arg5);
   (void)SLang_push_int(arg4);
   (void)SLang_push_int(arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5819, 5819, 0);
}

static void sl_pango_coverage_max (void)
{
   PangoCoverage* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoCoverage* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoCoverage_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_coverage_max(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5820, 5820, 0);
}

static void sl_gtk_toggle_button_set_inconsistent (void)
{
   GtkToggleButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_toggle_button_set_inconsistent(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5821, 5821, 0);
}

static void sl_gtk_style_context_add_region (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GtkRegionFlags arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_style_context_add_region(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5822, 5822, 0);
}

static void sl_gtk_tree_view_enable_model_drag_dest (void)
{
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const GtkTargetEntry* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   GdkDragAction arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_enable_model_drag_dest(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5823, 5823, 0);
}

static void sl_gtk_recent_chooser_unselect_all (void)
{
   GtkRecentChooser* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_chooser_unselect_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5824, 5824, 0);
}

static void sl_gtk_tree_model_filter_convert_iter_to_child_iter (void)
{
   GtkTreeModelFilter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   GtkTreeIter* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTreeIter_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   gtk_tree_model_filter_convert_iter_to_child_iter(arg1, arg2, arg3);
   (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5825, 5825, 0);
}

static void sl_gtk_entry_get_overwrite_mode (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_overwrite_mode(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5826, 5826, 0);
}

static void sl_gtk_widget_set_has_tooltip (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_set_has_tooltip(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5827, 5827, 0);
}

static void sl_pango_tab_array_free (void)
{
   PangoTabArray* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoTabArray_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_tab_array_free(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5828, 5828, 0);
}

static void sl_gtk_selection_data_get_text (void)
{
   guchar* retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_selection_data_get_text(arg1);
   (void)SLang_push_opaque(uchar_ptr_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5829, 5829, 0);
}

static void sl_gtk_grab_get_current (void)
{
   GtkWidget* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_grab_get_current();
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5830, 5830, 0);
}

static void sl_gtk_cell_renderer_text_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_text_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5831, 5831, 0);
}

static void sl_gtk_widget_get_visible (void)
{
   gboolean retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_visible(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5832, 5832, 0);
}

static void sl_gtk_widget_show_all (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_show_all(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5833, 5833, 0);
}

static void sl_gtk_recent_chooser_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_recent_chooser_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5834, 5834, 0);
}

static void sl_g_value_get_boolean (void)
{
   gboolean retval;
   const GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_value_get_boolean(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5835, 5835, 0);
}

static void sl_g_key_file_set_double_list (void)
{
   GKeyFile* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gchar* arg3;
   gdouble* arg4;
   Slirp_Ref *arg4_r = ref_new(SLANG_DOUBLE_TYPE,sizeof(gdouble),&arg4,0x0);
   gsize arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg4_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = (gsize) ref_get_size(arg4_r, 0);
   g_key_file_set_double_list(arg1, arg2, arg3, arg4,  arg5);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5836, 5836, 0);
   finalize_refs(1,arg4_r); 
}

static void sl_gdk_display_warp_pointer (void)
{
   GdkDisplay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkScreen* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gdk_display_warp_pointer(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5837, 5837, 0);
}

static void sl_gtk_widget_send_expose (void)
{
   gint retval;
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_widget_send_expose(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5838, 5838, 0);
}

static void sl_g_value_set_boolean (void)
{
   GValue* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_value_set_boolean(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5839, 5839, 0);
}

static void sl_gtk_overlay_set_overlay_pass_through (void)
{
   GtkOverlay* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_overlay_set_overlay_pass_through(arg1, arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5840, 5840, 0);
}

static void sl_gtk_scrollable_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_scrollable_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5841, 5841, 0);
}

static void sl_g_date_time_new_from_unix_utc (void)
{
   GDateTime* retval;
   gint64 arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_time_new_from_unix_utc( arg1);
   (void)SLang_push_opaque(GDateTime_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5842, 5842, 0);
}

static void sl_gtk_window_activate_key (void)
{
   gboolean retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventKey* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_window_activate_key(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5843, 5843, 0);
}

static void sl_gtk_label_get_lines (void)
{
   gint retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_lines(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5844, 5844, 0);
}

static void sl_gtk_clipboard_wait_for_targets (void)
{
   gboolean retval;
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkAtom** arg2;
   Slirp_Opaque* arg2_o = NULL;
   gint* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkAtom_ptr_ptr_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_clipboard_wait_for_targets(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5845, 5845, 0);
   finalize_refs(1,arg3_r); 
}

static void sl_gtk_entry_get_text (void)
{
   const gchar* retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_text(arg1);
   (void)SLang_push_string((gchar*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5846, 5846, 0);
}

static void sl_gdk_screen_get_primary_monitor (void)
{
   gint retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_primary_monitor(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5847, 5847, 0);
}

static void sl_gtk_dialog_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_dialog_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5848, 5848, 0);
}

static void sl_gtk_label_get_ellipsize (void)
{
   PangoEllipsizeMode retval;
   GtkLabel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_label_get_ellipsize(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5849, 5849, 0);
}

static void sl_g_menu_model_items_changed (void)
{
   GMenuModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_menu_model_items_changed(arg1,  arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5850, 5850, 0);
}

static void sl_gtk_print_settings_to_key_file (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GKeyFile* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gchar* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(GKeyFile_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_print_settings_to_key_file(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_slstring(arg3);
usage_label:
   if (issue_usage) Slirp_usage (5851, 5851, 0);
}

static void sl_g_binding_unbind (void)
{
   GBinding* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_binding_unbind(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5852, 5852, 0);
}

static void sl_gtk_notebook_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_notebook_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5853, 5853, 0);
}

static void sl_gtk_viewport_get_shadow_type (void)
{
   GtkShadowType retval;
   GtkViewport* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_viewport_get_shadow_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5854, 5854, 0);
}

static void sl_gtk_true (void)
{
   gboolean retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_true();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5855, 5855, 0);
}

static void sl_gtk_tool_palette_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5856, 5856, 0);
}

static void sl_g_file_info_set_sort_order (void)
{
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint32 arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_file_info_set_sort_order(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5857, 5857, 0);
}

static void sl_gdk_window_get_window_type (void)
{
   GdkWindowType retval;
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_window_get_window_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5858, 5858, 0);
}

static void sl_gdk_monitor_get_model (void)
{
   const char* retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_get_model(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5859, 5859, 0);
}

static void sl_gdk_events_get_distance (void)
{
   gboolean retval;
   GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEvent* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gdk_events_get_distance(arg1, arg2, &arg3);
   if (retval)
      (void)SLang_push_double(arg3);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5860, 5860, 0);
}

static void sl_gtk_gesture_get_sequences (void)
{
   GList* retval;
   GtkGesture* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_gesture_get_sequences(arg1);
   GList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_list_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   g_list_free (retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5861, 5861, 0);
}

static void sl_gtk_tree_view_is_rubber_banding_active (void)
{
   gboolean retval;
   GtkTreeView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_view_is_rubber_banding_active(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5862, 5862, 0);
}

static void sl_gtk_style_context_get_direction (void)
{
   GtkTextDirection retval;
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_style_context_get_direction(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5863, 5863, 0);
}

static void sl_gtk_tree_view_column_set_widget (void)
{
   GtkTreeViewColumn* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkWidget* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_tree_view_column_set_widget(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5864, 5864, 0);
}

static void sl_gtk_entry_get_max_width_chars (void)
{
   gint retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_get_max_width_chars(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5865, 5865, 0);
}

static void sl_gtk_spinner_stop (void)
{
   GtkSpinner* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_spinner_stop(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5866, 5866, 0);
}

static void sl_gtk_size_group_get_widgets (void)
{
   const GSList* retval;
   GtkSizeGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_size_group_get_widgets(arg1);
   GSList *list;
   SLang_List_Type *lst;
   if (NULL == (lst = SLang_create_list (0)))
      goto free_and_return;
   for (list = retval ; list ; list = g_slist_next (list))
   {
      (void) SLang_push_opaque (GtkOpaque_Type, (void*) list->data, 0);
      if (-1 == SLang_list_append (lst, -1))
        goto free_and_return;
   }
   (void) SLang_push_list (lst, 1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5867, 5867, 0);
}

static void sl_gtk_css_section_get_section_type (void)
{
   GtkCssSectionType retval;
   const GtkCssSection* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_css_section_get_section_type(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5868, 5868, 0);
}

static void sl_gtk_gesture_single_set_button (void)
{
   GtkGestureSingle* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_gesture_single_set_button(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5869, 5869, 0);
}

static void sl_gtk_entry_im_context_filter_keypress (void)
{
   gboolean retval;
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GdkEventKey* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_entry_im_context_filter_keypress(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5870, 5870, 0);
}

static void sl_g_date_get_sunday_week_of_year (void)
{
   guint retval;
   const GDate* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GDate_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_date_get_sunday_week_of_year(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5871, 5871, 0);
}

static void sl_g_strv_equal (void)
{
   gboolean retval;
   const gchar** arg1;
   Slirp_Ref *arg1_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg1,0x0);
   const gchar** arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_STRING_TYPE,sizeof(gchar*),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg1_r, 0x0, 0)) goto usage_label;
   issue_usage = 0;

   retval = g_strv_equal(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5872, 5872, 0);
   finalize_refs(2,arg1_r,arg2_r); 
}

static void sl_g_inet_address_mask_new (void)
{
   GInetAddressMask* retval;
   GInetAddress* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_inet_address_mask_new(arg1,  arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5873, 5873, 0);
}

static void sl_gtk_text_buffer_add_selection_clipboard (void)
{
   GtkTextBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkClipboard* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_text_buffer_add_selection_clipboard(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5874, 5874, 0);
}

static void sl_pango_layout_iter_at_last_line (void)
{
   gboolean retval;
   PangoLayoutIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(PangoLayoutIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_layout_iter_at_last_line(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5875, 5875, 0);
}

static void sl_gdk_seat_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_seat_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5876, 5876, 0);
}

static void sl_g_utf8_normalize (void)
{
   gchar* retval;
   gchar* arg1;
   gssize arg2;
   GNormalizeMode arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_long((long*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_utf8_normalize(arg1,  arg2,  arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5877, 5877, 0);
}

static void sl_gtk_paper_size_is_custom (void)
{
   gboolean retval;
   GtkPaperSize* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkPaperSize_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_paper_size_is_custom(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5878, 5878, 0);
}

static void sl_gtk_drag_set_icon_stock (void)
{
   GdkDragContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   gint arg3;
   gint arg4;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_drag_set_icon_stock(arg1, arg2,  arg3,  arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5879, 5879, 0);
}

static void sl_gdk_window_set_icon_list (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GList* arg2;
   Slirp_Ref *arg2_r = ref_new(GtkOpaque_Type,sizeof(GList),&arg2,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_set_icon_list(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5880, 5880, 0);
   finalize_refs(1,arg2_r); 
}

static void sl_gtk_render_focus (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   cairo_t* arg2;
   Slirp_Opaque* arg2_o = NULL;
   gdouble arg3;
   gdouble arg4;
   gdouble arg5;
   gdouble arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_double((double*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_opaque(Cairo_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_render_focus(arg1, arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5881, 5881, 0);
}

static void sl_gdk_monitor_is_primary (void)
{
   gboolean retval;
   GdkMonitor* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_monitor_is_primary(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5882, 5882, 0);
}

static void sl_pango_renderer_draw_rectangle (void)
{
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoRenderPart arg2;
   int arg3;
   int arg4;
   int arg5;
   int arg6;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 6) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg6)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg5)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg4)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   pango_renderer_draw_rectangle(arg1,  arg2,  arg3,  arg4,  arg5,  arg6);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5883, 5883, 0);
}

static void sl_gtk_popover_menu_open_submenu (void)
{
   GtkPopoverMenu* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_popover_menu_open_submenu(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5884, 5884, 0);
}

static void sl_gdk_pixbuf_get_bits_per_sample (void)
{
   int retval;
   const GdkPixbuf* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkPixbuf_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_pixbuf_get_bits_per_sample(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5885, 5885, 0);
}

static void sl_g_settings_get_uint (void)
{
   guint retval;
   GSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = g_settings_get_uint(arg1, arg2);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5886, 5886, 0);
}

static void sl_gdk_visual_get_best_depth (void)
{
   gint retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gdk_visual_get_best_depth();
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5887, 5887, 0);
}

static void sl_gtk_tree_model_get_iter_first (void)
{
   gboolean retval;
   GtkTreeModel* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTreeIter* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   if ((arg2 = (GtkTreeIter *) SLmalloc (sizeof (GtkTreeIter))) == NULL)
      goto free_and_return;
   retval = gtk_tree_model_get_iter_first(arg1, arg2);
   if (retval)
      (void) SLang_push_opaque (GtkTreeIter_Type, arg2, 1);
   else
      {
         SLfree ((char *) arg2);
         (void) SLang_push_null ();
      }
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5888, 5888, 0);
}

static void sl_gtk_font_chooser_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_font_chooser_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5889, 5889, 0);
}

static void sl_pango_renderer_get_layout (void)
{
   PangoLayout* retval;
   PangoRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = pango_renderer_get_layout(arg1);
   (void)SLang_push_opaque(GtkOpaque_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5890, 5890, 0);
}

static void sl_gtk_clipboard_clear (void)
{
   GtkClipboard* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_clipboard_clear(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5891, 5891, 0);
}

static void sl_g_timer_stop (void)
{
   GTimer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GTimer_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   g_timer_stop(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5892, 5892, 0);
}

static void sl_gtk_text_view_get_buffer (void)
{
   GtkTextBuffer* retval;
   GtkTextView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_view_get_buffer(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5893, 5893, 0);
}

static void sl_gtk_tool_item_get_icon_size (void)
{
   GtkIconSize retval;
   GtkToolItem* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_get_icon_size(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5894, 5894, 0);
}

static void sl_gtk_window_get_default_widget (void)
{
   GtkWidget* retval;
   GtkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_window_get_default_widget(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5895, 5895, 0);
}

static void sl_gtk_dialog_set_response_sensitive (void)
{
   GtkDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gboolean arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_dialog_set_response_sensitive(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5896, 5896, 0);
}

static void sl_gtk_target_list_new (void)
{
   GtkTargetList* retval;
   const GtkTargetEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_uint((unsigned int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_target_list_new(arg1,  arg2);
   (void)SLang_push_opaque(GtkTargetList_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5897, 5897, 0);
}

static void sl_gtk_revealer_get_transition_duration (void)
{
   guint retval;
   GtkRevealer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_revealer_get_transition_duration(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5898, 5898, 0);
}

static void sl_gtk_container_unset_focus_chain (void)
{
   GtkContainer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_container_unset_focus_chain(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5899, 5899, 0);
}

static void sl_gtk_text_iter_backward_word_starts (void)
{
   gboolean retval;
   GtkTextIter* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkTextIter_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_text_iter_backward_word_starts(arg1,  arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5900, 5900, 0);
}

static void sl_gtk_cell_renderer_set_alignment (void)
{
   GtkCellRenderer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gfloat arg2;
   gfloat arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_float((float*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_renderer_set_alignment(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5901, 5901, 0);
}

static void sl_gdk_window_destroy (void)
{
   GdkWindow* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gdk_window_destroy(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5902, 5902, 0);
}

static void sl_g_inet_address_mask_to_string (void)
{
   gchar* retval;
   GInetAddressMask* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_inet_address_mask_to_string(arg1);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5903, 5903, 0);
}

static void sl_pango_context_set_font_map (void)
{
   PangoContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   PangoFontMap* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   pango_context_set_font_map(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5904, 5904, 0);
}

static void sl_gtk_tree_sortable_get_sort_column_id (void)
{
   gboolean retval;
   GtkTreeSortable* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint* arg2;
   Slirp_Ref *arg2_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg2,0x0);
   GtkSortType* arg3;
   Slirp_Ref *arg3_r = ref_new(SLANG_INT_TYPE,sizeof(GtkSortType),&arg3,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == pop_array_or_ref( arg3_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg2_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tree_sortable_get_sort_column_id(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5905, 5905, 0);
   finalize_refs(2,arg2_r,arg3_r); 
}

static void sl_gtk_style_context_get_color (void)
{
   GtkStyleContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkStateFlags arg2;
   GdkRGBA* arg3 = (GdkRGBA*) alloca(sizeof(GdkRGBA));
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_style_context_get_color(arg1,  arg2, arg3);
   (void) SLang_push_cstruct ((VOID_STAR) arg3, GdkRGBA_Layout);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5906, 5906, 0);
}

static void sl_gdk_event_get_click_count (void)
{
   gboolean retval;
   const GdkEvent* arg1;
   Slirp_Opaque* arg1_o = NULL;
   guint arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GdkEvent_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_event_get_click_count(arg1, &arg2);
   if (retval)
      (void)SLang_push_uint(arg2);
   else
      (void) SLang_push_null ();
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5907, 5907, 0);
}

static void sl_gtk_selection_data_targets_include_rich_text (void)
{
   gboolean retval;
   const GtkSelectionData* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkTextBuffer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkSelectionData_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = gtk_selection_data_targets_include_rich_text(arg1, arg2);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5908, 5908, 0);
}

static void sl_gtk_entry_get_layout_offsets (void)
{
   GtkEntry* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_entry_get_layout_offsets(arg1, &arg2, &arg3);
   (void)SLang_push_int(arg2);
   (void)SLang_push_int(arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5909, 5909, 0);
}

static void sl_gtk_cell_area_remove_focus_sibling (void)
{
   GtkCellArea* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkCellRenderer* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GtkCellRenderer* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_cell_area_remove_focus_sibling(arg1, arg2, arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5910, 5910, 0);
}

static void sl_gtk_print_settings_get_resolution_x (void)
{
   gint retval;
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_settings_get_resolution_x(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5911, 5911, 0);
}

static void sl_gtk_tool_item_group_get_collapsed (void)
{
   gboolean retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_collapsed(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5912, 5912, 0);
}

static void sl_pango_font_description_better_match (void)
{
   gboolean retval;
   const PangoFontDescription* arg1;
   Slirp_Opaque* arg1_o = NULL;
   const PangoFontDescription* arg2;
   Slirp_Opaque* arg2_o = NULL;
   const PangoFontDescription* arg3;
   Slirp_Opaque* arg3_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg3, &arg3_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   retval = pango_font_description_better_match(arg1, arg2, arg3);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
usage_label:
   if (issue_usage) Slirp_usage (5913, 5913, 0);
}

static void sl_g_socket_leave_multicast_group_ssm (void)
{
   gboolean retval;
   GSocket* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GInetAddress* arg2;
   Slirp_Opaque* arg2_o = NULL;
   GInetAddress* arg3;
   Slirp_Opaque* arg3_o = NULL;
   gchar* arg4;
   GError* arg5;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg4)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg3, &arg3_o)) goto free_and_return_4;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg2, &arg2_o)) goto free_and_return_3;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg5 = NULL;
   retval = g_socket_leave_multicast_group_ssm(arg1, arg2, arg3, arg4, &arg5);
   if (arg5 != NULL)
     throw_gerror(arg5);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
free_and_return_3:
   SLang_free_opaque(arg3_o);
free_and_return_4:
   SLang_free_slstring(arg4);
usage_label:
   if (issue_usage) Slirp_usage (5914, 5914, 0);
}

static void sl_gtk_print_settings_set_reverse (void)
{
   GtkPrintSettings* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gboolean arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_print_settings_set_reverse(arg1,  arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5915, 5915, 0);
}

static void sl_gtk_tool_item_group_get_n_items (void)
{
   guint retval;
   GtkToolItemGroup* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_item_group_get_n_items(arg1);
   (void)SLang_push_uint(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5916, 5916, 0);
}

static void sl_gtk_toggle_button_new_with_label (void)
{
   GtkWidget* retval;
   gchar* arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = gtk_toggle_button_new_with_label(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_slstring(arg1);
usage_label:
   if (issue_usage) Slirp_usage (5917, 5917, 0);
}

static void sl_gtk_tool_button_get_use_underline (void)
{
   gboolean retval;
   GtkToolButton* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_button_get_use_underline(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5918, 5918, 0);
}

static void sl_gtk_list_box_select_row (void)
{
   GtkListBox* arg1;
   Slirp_Opaque* arg1_o = NULL;
   GtkListBoxRow* arg2;
   Slirp_Opaque* arg2_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg2, &arg2_o)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_list_box_select_row(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_opaque(arg2_o);
usage_label:
   if (issue_usage) Slirp_usage (5919, 5919, 0);
}

static void sl_g_vfs_get_supported_uri_schemes (void)
{
   const gchar** retval;
   GVfs* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkOpaque_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_vfs_get_supported_uri_schemes(arg1);
   push_null_term_str_array ((char **) retval, "g_vfs_get_supported_uri_schemes", 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5920, 5920, 0);
}

static void sl_gtk_recent_info_unref (void)
{
   GtkRecentInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_recent_info_unref(arg1);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5921, 5921, 0);
}

static void sl_g_file_info_get_display_name (void)
{
   const char* retval;
   GFileInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_file_info_get_display_name(arg1);
   (void)SLang_push_string((char*)retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5922, 5922, 0);
}

static void sl_gtk_about_dialog_set_program_name (void)
{
   GtkAboutDialog* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   gtk_about_dialog_set_program_name(arg1, arg2);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5923, 5923, 0);
}

static void sl_gdk_screen_get_display (void)
{
   GdkDisplay* retval;
   GdkScreen* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gdk_screen_get_display(arg1);
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5924, 5924, 0);
}

static void sl_gtk_tool_palette_get_drop_item (void)
{
   GtkToolItem* retval;
   GtkToolPalette* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_tool_palette_get_drop_item(arg1,  arg2,  arg3);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5925, 5925, 0);
}

static void sl_gtk_cell_view_get_displayed_row (void)
{
   GtkTreePath* retval;
   GtkCellView* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_view_get_displayed_row(arg1);
   (void)SLang_push_opaque(GtkTreePath_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5926, 5926, 0);
}

static void sl_gtk_cell_area_context_allocate (void)
{
   GtkCellAreaContext* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 3) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg3)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_cell_area_context_allocate(arg1,  arg2,  arg3);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5927, 5927, 0);
}

static void sl_gtk_widget_get_preferred_height_and_baseline_for_width (void)
{
   GtkWidget* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gint arg2;
   gint arg3;
   gint arg4;
   gint* arg5;
   Slirp_Ref *arg5_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg5,0x0);
   gint* arg6;
   Slirp_Ref *arg6_r = ref_new(SLANG_INT_TYPE,sizeof(gint),&arg6,0x0);
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 4) goto usage_label;
   if (-1 == pop_array_or_ref( arg6_r, 0x0, 0)) goto usage_label;
   if (-1 == pop_array_or_ref( arg5_r, 0x0, 0)) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   gtk_widget_get_preferred_height_and_baseline_for_width(arg1,  arg2, &arg3, &arg4, arg5, arg6);
   (void)SLang_push_int(arg3);
   (void)SLang_push_int(arg4);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5928, 5928, 0);
   finalize_refs(2,arg5_r,arg6_r); 
}

static void sl_g_date_valid_month (void)
{
   gboolean retval;
   GDateMonth arg1;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_int((int*)&arg1)) goto usage_label;
   issue_usage = 0;

   retval = g_date_valid_month( arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5929, 5929, 0);
}

static void sl_gtk_cell_renderer_progress_new (void)
{
   GtkCellRenderer* retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_cell_renderer_progress_new();
   (void)SLang_push_opaque(GObject_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5930, 5930, 0);
}

static void sl_gtk_bin_get_child (void)
{
   GtkWidget* retval;
   GtkBin* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GtkWidget_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_bin_get_child(arg1);
   (void)SLang_push_opaque(GtkWidget_Type, (void*)retval, 0);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5931, 5931, 0);
}

static void sl_gtk_print_job_get_n_up_layout (void)
{
   GtkNumberUpLayout retval;
   GtkPrintJob* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_print_job_get_n_up_layout(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5932, 5932, 0);
}

static void sl_gtk_entry_buffer_get_max_length (void)
{
   gint retval;
   GtkEntryBuffer* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GObject_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = gtk_entry_buffer_get_max_length(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5933, 5933, 0);
}

static void sl_gtk_widget_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_widget_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5934, 5934, 0);
}

static void sl_gtk_image_get_type (void)
{
   GType retval;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 0) goto usage_label;
   issue_usage = 0;

   retval = gtk_image_get_type();
   (void)SLang_push_ulong(retval);
   goto free_and_return;
free_and_return:
   /* drop */
usage_label:
   if (issue_usage) Slirp_usage (5935, 5935, 0);
}

static void sl_g_match_info_expand_references (void)
{
   gchar* retval;
   const GMatchInfo* arg1;
   Slirp_Opaque* arg1_o = NULL;
   gchar* arg2;
   GError* arg3;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 2) goto usage_label;
   if (-1 == SLang_pop_string((char**)&arg2)) goto usage_label;
   if (-1 == SLang_pop_opaque(GMatchInfo_Type, (void**)&arg1, &arg1_o)) goto free_and_return_2;
   issue_usage = 0;

   arg3 = NULL;
   retval = g_match_info_expand_references(arg1, arg2, &arg3);
   if (arg3 != NULL)
     throw_gerror(arg3);
   (void)SLang_push_malloced_string(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
free_and_return_2:
   SLang_free_slstring(arg2);
usage_label:
   if (issue_usage) Slirp_usage (5936, 5936, 0);
}

static void sl_g_variant_type_is_tuple (void)
{
   gboolean retval;
   const GVariantType* arg1;
   Slirp_Opaque* arg1_o = NULL;
   int issue_usage = 1;

   if (SLang_Num_Function_Args != 1) goto usage_label;
   if (-1 == SLang_pop_opaque(GVariantType_Type, (void**)&arg1, &arg1_o)) goto usage_label;
   issue_usage = 0;

   retval = g_variant_type_is_tuple(arg1);
   (void)SLang_push_int(retval);
   goto free_and_return;
free_and_return:
   /* drop */
   SLang_free_opaque(arg1_o);
usage_label:
   if (issue_usage) Slirp_usage (5937, 5937, 0);
}


static SLang_Intrin_Fun_Type gtk3_Funcs [] =
{
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_set_accel_closure",sl_gtk_accel_label_set_accel_closure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_cut_clipboard",sl_gtk_editable_cut_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_iter_is_selected",sl_gtk_tree_selection_iter_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_get_vscroll_policy",sl_gtk_scrollable_get_vscroll_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_decorations",sl_gdk_window_set_decorations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_editable_get_type",sl_gtk_cell_editable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_pointer",sl_g_value_get_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_fraction",sl_gtk_progress_bar_set_fraction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_parse_name",sl_g_vfs_parse_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add_rich_text_targets",sl_gtk_target_list_add_rich_text_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_get_drawing_context",sl_gdk_cairo_get_drawing_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_convert_iter_to_child_iter",sl_gtk_tree_model_sort_convert_iter_to_child_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_keyfile_settings_backend_new",sl_g_keyfile_settings_backend_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_max_children_per_line",sl_gtk_flow_box_get_max_children_per_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_check_resize",sl_gtk_container_check_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_use_underline",sl_gtk_menu_item_set_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_unselect_range",sl_gtk_tree_selection_unselect_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strncasecmp",sl_g_ascii_strncasecmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_cell_at_position",sl_gtk_cell_area_get_cell_at_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_is_removable",sl_g_drive_is_removable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_preferred_width",sl_gtk_cell_area_get_preferred_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_update",sl_g_hmac_update,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_hadjustment",sl_gtk_flow_box_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_button",sl_gdk_event_get_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_unset_placement",sl_gtk_scrolled_window_unset_placement,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_get_type",sl_gtk_message_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_group",sl_gdk_window_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_variant",sl_g_value_set_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_swap",sl_gtk_tree_store_swap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_new_offset",sl_g_time_zone_new_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_select_all",sl_gtk_recent_chooser_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_clear_targets",sl_gtk_selection_clear_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_image_position",sl_gtk_button_set_image_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_number_up_layout",sl_gtk_print_settings_get_number_up_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_display_name_finish",sl_g_file_set_display_name_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_move_region",sl_gdk_window_move_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_is_cancelled",sl_g_cancellable_is_cancelled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_new_from_directory",sl_g_settings_schema_source_new_from_directory,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_inner_border",sl_gtk_entry_set_inner_border,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_can_activate_accel",sl_gtk_widget_can_activate_accel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_new_with_label",sl_gtk_button_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_all_for_type",sl_g_app_info_get_all_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_child_at_index",sl_gtk_flow_box_get_child_at_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_modification_date_time",sl_g_file_info_set_modification_date_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_double",sl_g_variant_get_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_long",sl_g_value_set_long,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_test_simulate_key",sl_gdk_test_simulate_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_use_popover",sl_gtk_menu_button_set_use_popover,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_digits",sl_gtk_spin_button_get_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_tab_label",sl_gtk_notebook_set_tab_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_monitor",sl_gdk_display_get_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_has_user_ref_count",sl_gtk_window_set_has_user_ref_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_add_pattern",sl_gtk_file_filter_add_pattern,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_get_type",sl_pango_attr_list_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_invisible_char",sl_gtk_entry_get_invisible_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_local_only",sl_gtk_file_chooser_set_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_get_visited",sl_gtk_link_button_get_visited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_placeholder_text",sl_gtk_entry_get_placeholder_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_coords_from_parent",sl_gdk_window_coords_from_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_symbolic_icon",sl_g_content_type_get_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_uint16",sl_g_variant_new_uint16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_popup_enable",sl_gtk_notebook_popup_enable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_get_screen",sl_gtk_mount_operation_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_intersect",sl_gtk_widget_intersect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_ellipsize",sl_gtk_tool_item_group_set_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_type",sl_gtk_color_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_label_fill",sl_gtk_expander_set_label_fill,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_icon",sl_g_app_info_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_type",sl_gtk_application_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_style",sl_pango_font_description_set_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_mc_node_local",sl_g_inet_address_get_is_mc_node_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_spinner_new",sl_gtk_cell_renderer_spinner_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_freeze_child_notify",sl_gtk_widget_freeze_child_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_size_new_absolute",sl_pango_attr_size_new_absolute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new_with_entry",sl_gtk_combo_box_new_with_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_support_selection",sl_gtk_print_operation_get_support_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_pixbuf_get_type",sl_gtk_cell_renderer_pixbuf_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_flags",sl_g_value_get_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_get_type_from_name",sl_gtk_builder_get_type_from_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_popdown",sl_gtk_combo_box_popdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_strv",sl_g_settings_set_strv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_reorderable",sl_gtk_tree_view_get_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_iter_free",sl_pango_script_iter_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_alignment",sl_gtk_button_get_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_attached_to",sl_gtk_window_get_attached_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_parent",sl_gtk_style_context_set_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_link_iter_get_next",sl_g_menu_link_iter_get_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_round_glyph_positions",sl_pango_context_get_round_glyph_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_join_group",sl_gtk_radio_button_join_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_paper_size",sl_gtk_page_setup_get_paper_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_id",sl_g_app_info_get_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_type",sl_gtk_toolbar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_clear_signal_handler",sl_g_clear_signal_handler,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_activate_on_single_click",sl_gtk_icon_view_set_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_insert_column",sl_gtk_tree_view_insert_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_applications",sl_g_bookmark_file_get_applications,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_string",sl_g_value_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_hexpand",sl_gtk_widget_set_hexpand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_insert",sl_g_param_spec_pool_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_start_iter",sl_gtk_text_buffer_get_start_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_search_column",sl_gtk_tree_view_set_search_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_type",sl_gdk_pixbuf_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_name",sl_gtk_drag_set_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_down",sl_gtk_tree_path_down,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_application",sl_gtk_recent_filter_add_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_copy_static",sl_pango_font_description_copy_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_unmark_day",sl_gtk_calendar_unmark_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_class_get_instance_private_offset",sl_g_type_class_get_instance_private_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_level_indentation",sl_gtk_tree_view_get_level_indentation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_to_tag_toggle",sl_gtk_text_iter_forward_to_tag_toggle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_hints_get_type",sl_gdk_window_hints_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_child_anchor_get_type",sl_gtk_text_child_anchor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_dialog_new",sl_gtk_font_chooser_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_begins_tag",sl_gtk_text_iter_begins_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_load_from_data_dirs",sl_g_key_file_load_from_data_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_remove_tag",sl_gtk_text_buffer_remove_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_list_mnemonic_labels",sl_gtk_widget_list_mnemonic_labels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_double",sl_g_variant_new_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute",sl_g_file_info_set_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grab_add",sl_gtk_grab_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_set_double_click_time",sl_gdk_set_double_click_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_bounds",sl_gtk_text_buffer_get_bounds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_convert_child_path_to_path",sl_gtk_tree_model_sort_convert_child_path_to_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_predicted_presentation_time",sl_gdk_frame_timings_get_predicted_presentation_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_request_mode",sl_gtk_widget_get_request_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_line_yrange",sl_pango_layout_iter_get_line_yrange,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_register_dynamic",sl_g_type_register_dynamic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_get_child_pack_direction",sl_gtk_menu_bar_get_child_pack_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_object_path",sl_g_variant_new_object_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_attach",sl_gtk_grid_attach,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_end_updating",sl_gdk_frame_clock_end_updating,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_flags",sl_g_settings_get_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_poll_for_media_finish",sl_g_drive_poll_for_media_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_add2",sl_gtk_paned_add2,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_preview_widget_active",sl_gtk_file_chooser_set_preview_widget_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_reserve_indicator",sl_gtk_menu_item_get_reserve_indicator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_get_show_default_item",sl_gtk_app_chooser_button_get_show_default_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_icon_name",sl_gtk_tool_button_get_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_use_underline",sl_gtk_expander_get_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_get_type",sl_g_menu_model_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_ends_line",sl_gtk_text_iter_ends_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_disconnect",sl_gtk_accel_group_disconnect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strnfill",sl_g_strnfill,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_integer_list",sl_g_key_file_set_integer_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_icon_widget",sl_gtk_tool_button_get_icon_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_formatd",sl_g_ascii_formatd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_add_group",sl_g_bookmark_file_add_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_mc_site_local",sl_g_inet_address_get_is_mc_site_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_new",sl_gtk_popover_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_cursor",sl_gtk_tree_view_set_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_reset_widgets",sl_gtk_style_context_reset_widgets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_inside_sentence",sl_gtk_text_iter_inside_sentence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_add_offset_value",sl_gtk_level_bar_add_offset_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_save",sl_gtk_accel_map_save,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_paste_clipboard",sl_gtk_editable_paste_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_row_at_index",sl_gtk_list_box_get_row_at_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_print_pages",sl_gtk_print_settings_set_print_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_show_error_underline",sl_pango_cairo_show_error_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_current_event_time",sl_gtk_get_current_event_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_popup_set_width",sl_gtk_entry_completion_set_popup_set_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timeout_source_new",sl_g_timeout_source_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_should_show",sl_g_app_info_should_show,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_new_from_stream",sl_gdk_pixbuf_animation_new_from_stream,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_current_folder_uri",sl_gtk_file_chooser_set_current_folder_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_get_priority",sl_gtk_text_tag_get_priority,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_push_preferred_width",sl_gtk_cell_area_context_push_preferred_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_type",sl_gtk_entry_completion_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_device_events",sl_gtk_widget_get_device_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_icon",sl_gtk_icon_info_load_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_height",sl_gtk_widget_get_preferred_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_close",sl_gtk_window_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_reset",sl_gtk_cell_area_context_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_image",sl_gtk_button_set_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_unref",sl_pango_attr_list_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_start_stop_type",sl_g_drive_get_start_stop_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_line_count",sl_pango_layout_get_line_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_text_area",sl_gtk_entry_get_text_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_resize",sl_gtk_widget_queue_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_has_class",sl_gtk_style_context_has_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_animation",sl_gtk_image_set_from_animation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_tabs",sl_gtk_entry_set_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_title",sl_g_notification_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_open_readwrite",sl_g_file_open_readwrite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_role",sl_gtk_window_set_role,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_ascent",sl_pango_font_metrics_get_ascent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_add",sl_gtk_container_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_set_visible_window",sl_gtk_event_box_set_visible_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_name",sl_g_settings_schema_key_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_pim",sl_g_mount_operation_get_pim,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_variant",sl_g_value_get_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_get_translation_domain",sl_gtk_builder_get_translation_domain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_default_size",sl_gtk_window_get_default_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_handler_unblock",sl_g_signal_handler_unblock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_type_hint",sl_gtk_window_set_type_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_group_name",sl_gtk_notebook_set_group_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_paper_size",sl_gtk_page_setup_set_paper_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_use_markup",sl_gtk_expander_set_use_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_axis_use",sl_gdk_device_get_axis_use,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_translate_coordinates",sl_gtk_widget_translate_coordinates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_dup",sl_g_file_dup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_collate",sl_gtk_print_job_get_collate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_array",sl_g_variant_new_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_query_visual_types",sl_gdk_query_visual_types,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_type",sl_gtk_adjustment_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_hadjustment",sl_gtk_scrolled_window_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_cancel",sl_gtk_print_operation_cancel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_insert_before",sl_gtk_tree_store_insert_before,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_slider_size_fixed",sl_gtk_range_set_slider_size_fixed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strsignal",sl_g_strsignal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_unfullscreen",sl_gdk_window_unfullscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_popup",sl_gtk_menu_button_set_popup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_name",sl_gtk_accelerator_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_visible_vertical",sl_gtk_tool_item_set_visible_vertical,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_retrieve_proxy_menu_item",sl_gtk_tool_item_retrieve_proxy_menu_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_child_notify",sl_gtk_widget_child_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_get_title",sl_gtk_file_chooser_button_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_is_active",sl_gtk_window_is_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_output_bin",sl_gtk_print_settings_get_output_bin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_type",sl_gdk_screen_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_new_from_names",sl_g_themed_icon_new_from_names,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_get_font_type",sl_pango_cairo_font_map_get_font_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_window",sl_gdk_event_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_size_of_row",sl_gtk_cell_view_get_size_of_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_has_group",sl_gtk_recent_info_has_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_show_layout",sl_pango_cairo_show_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_height",sl_gdk_pixbuf_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_list_contexts",sl_gtk_icon_theme_list_contexts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_pixels_below_lines",sl_gtk_text_view_get_pixels_below_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_enumerate_next",sl_g_file_attribute_matcher_enumerate_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_transitions_enabled",sl_gtk_popover_get_transitions_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_insert_text",sl_gtk_entry_buffer_insert_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_default_widget",sl_gtk_popover_get_default_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_type",sl_gtk_container_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_flippable",sl_gtk_range_set_flippable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_model",sl_gtk_cell_view_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_set_sequence_state",sl_gtk_gesture_set_sequence_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_spin_get_type",sl_gtk_cell_renderer_spin_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_get_bytes",sl_gtk_entry_buffer_get_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_other_locations",sl_gtk_places_sidebar_set_show_other_locations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_value",sl_gtk_range_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_targets_include_text",sl_gtk_selection_data_targets_include_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_append_name",sl_g_themed_icon_append_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_to_data",sl_g_key_file_to_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_get_type",sl_gtk_combo_box_text_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_year",sl_g_date_time_get_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_match_full",sl_g_regex_match_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_ends_word",sl_gtk_text_iter_ends_word,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_widget_new",sl_gtk_font_chooser_widget_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_color",sl_gtk_color_button_get_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_fallback_for_type",sl_g_app_info_get_fallback_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_clip_region",sl_gdk_window_get_clip_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_show_layout_line",sl_pango_cairo_show_layout_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_set_arrow_tooltip_text",sl_gtk_menu_tool_button_set_arrow_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_input_purpose",sl_gtk_entry_get_input_purpose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_motion",sl_gdk_drag_motion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_label",sl_gtk_tool_item_group_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_tag_table",sl_gtk_text_buffer_get_tag_table,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_has_uri_scheme",sl_g_file_has_uri_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_new",sl_gtk_mount_operation_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_window_type",sl_gtk_text_view_get_window_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_load_key_file",sl_gtk_page_setup_load_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_insert_column",sl_gtk_grid_insert_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_has_application",sl_g_bookmark_file_has_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_yalign",sl_gtk_label_get_yalign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_focus",sl_gtk_window_set_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_tooltip_text",sl_gtk_entry_get_icon_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_value",sl_gtk_range_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_create_watch",sl_g_io_create_watch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_input_purpose",sl_gtk_text_view_get_input_purpose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_device_enabled",sl_gtk_widget_get_device_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_height",sl_gdk_screen_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_current_event_device",sl_gtk_get_current_event_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_socket_type",sl_g_socket_get_socket_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_get_alpha",sl_pango_renderer_get_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_proxy_menu_item",sl_gtk_tool_item_set_proxy_menu_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_button",sl_gtk_tree_view_column_get_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spinner_start",sl_gtk_spinner_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_sequence_get_type",sl_gdk_event_sequence_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_is_tcrypt_hidden_volume",sl_g_mount_operation_set_is_tcrypt_hidden_volume,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_resize_children",sl_gtk_container_resize_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_value_changed",sl_gtk_adjustment_value_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_name",sl_g_resolver_lookup_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_canonicalize_filename",sl_g_canonicalize_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_set_screen",sl_gtk_icon_theme_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_show_expanders",sl_gtk_tree_view_set_show_expanders,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_state",sl_gdk_window_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_new",sl_gtk_printer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_approximate_digit_width",sl_pango_font_metrics_get_approximate_digit_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_pack2",sl_gtk_paned_pack2,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_cairo_context",sl_gtk_print_context_get_cairo_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_add_child_in_window",sl_gtk_text_view_add_child_in_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_focus_on_click",sl_gtk_widget_get_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new_from_ppd",sl_gtk_paper_size_new_from_ppd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_use_es",sl_gdk_gl_context_get_use_es,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_hide_titlebar_when_maximized",sl_gtk_window_get_hide_titlebar_when_maximized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_make_directory_finish",sl_g_file_make_directory_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_icon_size",sl_gtk_tool_palette_set_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_unselect_uri",sl_gtk_file_chooser_unselect_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_lookup_icon_for_scale",sl_gtk_icon_theme_lookup_icon_for_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_new_with_default_fallbacks",sl_g_themed_icon_new_with_default_fallbacks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_handle_window",sl_gtk_paned_get_handle_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_domain",sl_g_mount_operation_get_domain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_current_uri",sl_gtk_recent_chooser_set_current_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_description",sl_g_content_type_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_model",sl_gtk_combo_box_set_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_mime_type",sl_gtk_recent_info_get_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_preferred_height",sl_gtk_cell_renderer_get_preferred_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_get_string",sl_g_checksum_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_get_family",sl_g_inet_address_mask_get_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_maybe",sl_g_variant_new_maybe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_object_type",sl_gtk_widget_path_iter_get_object_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_create_similar_image_surface",sl_gdk_window_create_similar_image_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_default_value",sl_g_param_spec_get_default_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_open_default_libgtk_only",sl_gdk_display_open_default_libgtk_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_cursor_positions",sl_gtk_text_iter_backward_visible_cursor_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_popup_fixed_width",sl_gtk_combo_box_get_popup_fixed_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_show_size",sl_gtk_font_button_set_show_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_get_propagation_phase",sl_gtk_event_controller_get_propagation_phase,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_ppd_name",sl_gtk_paper_size_get_ppd_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add_image_targets",sl_gtk_target_list_add_image_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_set_value",sl_gtk_level_bar_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_size_request",sl_gtk_widget_get_size_request,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_change_entry",sl_gtk_accel_map_change_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_run_page_setup_dialog",sl_gtk_print_run_page_setup_dialog,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_get_type",sl_gtk_icon_theme_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_background_get_clip",sl_gtk_render_background_get_clip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_uninhibit",sl_gtk_application_uninhibit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_has_toplevel_focus",sl_gtk_window_has_toplevel_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_location",sl_gtk_printer_get_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_widget",sl_gtk_tree_view_column_get_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_bottom",sl_gtk_widget_get_margin_bottom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_model",sl_gtk_combo_box_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_new",sl_gtk_switch_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_key",sl_gdk_device_get_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_set_draw_as_radio",sl_gtk_check_menu_item_set_draw_as_radio,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_create_pango_context",sl_gtk_print_context_create_pango_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_license",sl_gdk_pixbuf_format_get_license,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_get_type",sl_pango_cairo_font_map_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strncpy",sl_g_utf8_strncpy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_face",sl_gtk_font_chooser_get_font_face,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_set_default_response",sl_gtk_dialog_set_default_response,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_move",sl_gtk_layout_move,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcuts_section_get_type",sl_gtk_shortcuts_section_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_current_event",sl_gtk_get_current_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_list_families",sl_pango_font_map_list_families,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_size_allocate",sl_gtk_widget_size_allocate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_new_from_key_file",sl_gtk_page_setup_new_from_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_icon",sl_g_file_info_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_activate_on_single_click",sl_gtk_flow_box_set_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_remove",sl_gtk_tree_store_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_disable_multidevice",sl_gdk_disable_multidevice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_pixbuf",sl_gtk_drag_set_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_reorder_child",sl_gtk_box_reorder_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_popup_single_match",sl_gtk_entry_completion_get_popup_single_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_is_virtual",sl_gtk_printer_is_virtual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_min_children_per_line",sl_gtk_flow_box_get_min_children_per_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_attributes",sl_gtk_label_set_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_new",sl_gtk_adjustment_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_remove_tick_callback",sl_gtk_widget_remove_tick_callback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_receive",sl_g_socket_receive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_visible_line_index",sl_gtk_text_iter_set_visible_line_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_presentation_time",sl_gdk_frame_timings_get_presentation_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mkdtemp_full",sl_g_mkdtemp_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_show_default",sl_gtk_app_chooser_widget_set_show_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_new_full",sl_g_settings_new_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_single_paragraph_mode",sl_pango_layout_set_single_paragraph_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_list_slave_devices",sl_gdk_device_list_slave_devices,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_border",sl_gtk_style_context_get_border,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_is_text_available",sl_gtk_clipboard_wait_is_text_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_uint64",sl_g_variant_new_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_paper_width",sl_gtk_print_settings_set_paper_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_ref",sl_pango_coverage_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_events",sl_gtk_widget_set_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_sentence_ends",sl_gtk_text_iter_forward_sentence_ends,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_set_homogeneous",sl_gtk_box_set_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_stop_emission",sl_g_signal_stop_emission,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_type",sl_gtk_assistant_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_value",sl_g_settings_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_windows",sl_gtk_application_get_windows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_add_attribute",sl_gtk_tree_view_column_add_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_clear_marks",sl_gtk_calendar_clear_marks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_intern_string",sl_g_intern_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_n_keys",sl_gdk_device_get_n_keys,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_set_action_target_value",sl_gtk_actionable_set_action_target_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_has_resize_grip",sl_gtk_window_set_has_resize_grip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_text_length",sl_gtk_entry_get_text_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_symbolic_icon",sl_g_drive_get_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_visible_child",sl_gtk_stack_set_visible_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_new",sl_gdk_cursor_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_set_group",sl_gtk_radio_menu_item_set_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_opacity",sl_gtk_widget_get_opacity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_page_setup",sl_gtk_print_unix_dialog_get_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_tooltip_markup",sl_gtk_widget_set_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_set_mode",sl_gtk_level_bar_set_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_screen",sl_gdk_window_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_filename",sl_gtk_file_chooser_set_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_ref",sl_gtk_target_list_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_has_alpha",sl_gtk_gl_area_get_has_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_free_addresses",sl_g_resolver_free_addresses,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_set_icon_stock",sl_gtk_drag_source_set_icon_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_extra_widget",sl_gtk_file_chooser_set_extra_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_gravity_hint",sl_pango_context_get_gravity_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_get_link",sl_g_menu_item_get_link,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_list_keys",sl_g_settings_list_keys,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_copy",sl_pango_attr_list_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_move_item",sl_gtk_recent_manager_move_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_background_alpha_new",sl_pango_attr_background_alpha_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_new",sl_gtk_print_operation_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_substring",sl_g_utf8_substring,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_label_fill",sl_gtk_expander_get_label_fill,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_pulse_step",sl_gtk_progress_bar_get_pulse_step,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_new_from_stream_finish",sl_gdk_pixbuf_animation_new_from_stream_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_new_with_color",sl_gtk_color_button_new_with_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_location",sl_gtk_places_sidebar_set_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_prepend_type",sl_gtk_widget_path_prepend_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_set_text",sl_gtk_entry_buffer_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_position",sl_gtk_popover_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_file",sl_gtk_image_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_from_accel_closure",sl_gtk_accel_group_from_accel_closure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_new",sl_gtk_statusbar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_row_has_child_toggled",sl_gtk_tree_model_row_has_child_toggled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_find_next_char",sl_g_utf8_find_next_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_description",sl_g_settings_schema_key_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_parent",sl_gtk_tree_model_iter_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_volumes",sl_g_volume_monitor_get_volumes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_new",sl_g_hmac_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_get_qdata",sl_g_object_get_qdata,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_units_from_double",sl_pango_units_from_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_size",sl_g_file_info_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_fullscreen_mode",sl_gdk_window_set_fullscreen_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_remount_finish",sl_g_mount_remount_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_visible",sl_gtk_widget_set_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_new",sl_gtk_viewport_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_to_utc",sl_g_date_time_to_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_get_selected_item",sl_gtk_menu_shell_get_selected_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_new",sl_g_main_context_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_orientable_set_orientation",sl_gtk_orientable_set_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_new",sl_gtk_toolbar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_surface",sl_gtk_drag_set_icon_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_new_dmy",sl_g_date_new_dmy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_class",sl_gtk_widget_path_iter_has_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_composite",sl_gdk_pixbuf_composite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_month",sl_g_date_set_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_error_quark",sl_g_io_channel_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_focus_siblings",sl_gtk_cell_area_get_focus_siblings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_popup_single_match",sl_gtk_entry_completion_set_popup_single_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_menu_new",sl_gtk_popover_menu_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_opacity",sl_gtk_window_set_opacity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_n_columns",sl_gtk_tree_model_get_n_columns,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_targets_include_rich_text",sl_gtk_targets_include_rich_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_select_range",sl_gtk_text_buffer_select_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_version",sl_gdk_gl_context_get_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_text_alignment",sl_gtk_tool_shell_get_text_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_copy",sl_gtk_paper_size_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_hborder",sl_gtk_notebook_get_tab_hborder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_keep_above",sl_gtk_window_set_keep_above,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_new",sl_gtk_color_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_new_with_markup",sl_gtk_message_dialog_new_with_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_pan_new",sl_gtk_gesture_pan_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_dmy",sl_g_date_valid_dmy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_is_ancestor",sl_gtk_tree_store_is_ancestor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_convert",sl_gdk_selection_convert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_fixed_width",sl_gtk_tree_view_column_get_fixed_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_icon",sl_gtk_tooltip_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_begin_for_device",sl_gdk_drag_begin_for_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_remove",sl_gtk_combo_box_text_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_sidebar_new",sl_gtk_stack_sidebar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_double",sl_g_key_file_get_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_label",sl_gtk_menu_item_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_variant",sl_g_variant_get_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_new",sl_gtk_icon_view_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_close",sl_g_socket_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_append_page",sl_gtk_notebook_append_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_clear_status",sl_g_file_info_clear_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_blocking",sl_g_socket_set_blocking,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_activatable",sl_gtk_entry_set_icon_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strtoll",sl_g_ascii_strtoll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_object_name",sl_gtk_widget_path_iter_get_object_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_text",sl_gtk_label_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_error_underline_path",sl_pango_cairo_error_underline_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_to_local",sl_g_date_time_to_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_make_directory_with_parents",sl_g_file_make_directory_with_parents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_show_preview_entry",sl_gtk_font_chooser_set_show_preview_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_model",sl_gtk_entry_completion_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_uri",sl_g_file_get_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_title",sl_g_bookmark_file_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_remove_widget",sl_gtk_size_group_remove_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_bytestring_array",sl_g_variant_get_bytestring_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_exclusive",sl_gtk_tool_palette_set_exclusive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_width",sl_gtk_widget_get_preferred_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_descent",sl_pango_font_metrics_get_descent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_push_preferred_height",sl_gtk_cell_area_context_push_preferred_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_type",sl_gdk_drag_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_pad_controller_new",sl_gtk_pad_controller_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_get_default",sl_g_resolver_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_link_iter_get_value",sl_g_menu_link_iter_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_lock_button_get_type",sl_gtk_lock_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_default",sl_gtk_drag_set_icon_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_show_private",sl_gtk_recent_chooser_get_show_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_get_key",sl_g_settings_schema_get_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_match_all_full",sl_g_regex_match_all_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_pixel_size",sl_gtk_image_set_pixel_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_get_type",sl_gtk_frame_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_update",sl_pango_attr_list_update,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_get_baseline_position",sl_gtk_box_get_baseline_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_layout",sl_gtk_label_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_owner_get_for_display",sl_gdk_selection_owner_get_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_drag_source",sl_gtk_entry_set_icon_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_transition_running",sl_gtk_stack_get_transition_running,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_locale_string_list",sl_g_key_file_get_locale_string_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_select_file",sl_gtk_file_chooser_select_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_copy_finish",sl_g_file_copy_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_boolean",sl_g_variant_get_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_get_action_name",sl_gtk_actionable_get_action_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_text_size_group",sl_gtk_tool_item_get_text_size_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_invisible_new_for_screen",sl_gtk_invisible_new_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_summary",sl_g_settings_schema_key_get_summary,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_menu_get_show_numbers",sl_gtk_recent_chooser_menu_get_show_numbers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_scroll",sl_gdk_window_scroll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_bits_per_rgb",sl_gdk_visual_get_bits_per_rgb,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace_readwrite_finish",sl_g_file_replace_readwrite_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_can_eject",sl_g_drive_can_eject,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_int32",sl_g_variant_new_int32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_thaw_toplevel_updates_libgtk_only",sl_gdk_window_thaw_toplevel_updates_libgtk_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_file_at_scale",sl_gdk_pixbuf_new_from_file_at_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_ref",sl_g_param_spec_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_has_key",sl_g_key_file_has_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_new_for_content_type",sl_gtk_app_chooser_dialog_new_for_content_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_can_recurse",sl_g_source_get_can_recurse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_progress_pulse_step",sl_gtk_entry_get_progress_pulse_step,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_reserve_indicator",sl_gtk_menu_item_set_reserve_indicator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_parser_get_error_quark",sl_g_variant_parser_get_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_fetch_all",sl_g_match_info_fetch_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_new",sl_gtk_link_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strndup",sl_g_strndup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_type",sl_gtk_expander_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_popup",sl_gtk_combo_box_popup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_new",sl_g_cancellable_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_select_all",sl_gtk_tree_selection_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_pan_set_orientation",sl_gtk_gesture_pan_set_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_selection_mode",sl_gtk_icon_view_get_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_new",sl_g_network_service_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_from_string",sl_pango_font_description_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_search_entry",sl_gtk_tree_view_set_search_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_add_action_widget",sl_gtk_dialog_add_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_copy_clipboard",sl_gtk_editable_copy_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_attribute_iter_get_next",sl_g_menu_attribute_iter_get_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_n_monitors",sl_gdk_screen_get_n_monitors,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_iterate_item_links",sl_g_menu_model_iterate_item_links,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_new_from_string",sl_gtk_builder_new_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_unset",sl_gtk_print_settings_unset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_set_fields",sl_pango_font_description_get_set_fields,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_push",sl_gtk_statusbar_push,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_pack_end",sl_gtk_box_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_state",sl_gtk_style_context_set_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_right_justified",sl_gtk_menu_item_get_right_justified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_focus_visible",sl_gtk_window_set_focus_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_expand",sl_gtk_tool_palette_get_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_relative_path",sl_g_file_get_relative_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_tool_button_get_active",sl_gtk_toggle_tool_button_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_owner",sl_gtk_clipboard_get_owner,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_align_widget",sl_gtk_menu_button_set_align_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_hover_selection",sl_gtk_tree_view_get_hover_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_cursor_position",sl_gtk_text_iter_forward_visible_cursor_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_entry_handle_event",sl_gtk_search_entry_handle_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_font_description",sl_pango_context_get_font_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_toplevel",sl_gtk_widget_get_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_value",sl_gtk_adjustment_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_response_for_widget",sl_gtk_dialog_get_response_for_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_selection_bound",sl_gtk_text_buffer_get_selection_bound,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_add_custom_tab",sl_gtk_print_unix_dialog_add_custom_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_text",sl_pango_layout_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_get_type",sl_gtk_list_store_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_get_mode",sl_gtk_size_group_get_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_hide",sl_gtk_native_dialog_hide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_storage_type",sl_gtk_image_get_storage_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_cancel",sl_gtk_drag_cancel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_show_unraised",sl_gdk_window_show_unraised,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_resource",sl_gdk_pixbuf_new_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_finishings",sl_gtk_print_settings_set_finishings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_new_from_stock",sl_gtk_radio_tool_button_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_offscreen_window_get_type",sl_gtk_offscreen_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_display_name",sl_g_filename_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_required_version",sl_gtk_gl_area_set_required_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accessible_get_type",sl_gtk_accessible_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_flags_to_string",sl_g_flags_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bytes_icon_get_bytes",sl_g_bytes_icon_get_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_drag_new",sl_gtk_gesture_drag_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_path_at_pos",sl_gtk_icon_view_get_path_at_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_tooltip_row",sl_gtk_tree_view_set_tooltip_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_reorder_overlay",sl_gtk_overlay_reorder_overlay,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strdup_value_contents",sl_g_strdup_value_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_double",sl_gtk_print_settings_get_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_markup_with_mnemonic",sl_gtk_label_set_markup_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_right_justified",sl_gtk_menu_item_set_right_justified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_row_span_column",sl_gtk_combo_box_get_row_span_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_remove_region",sl_gtk_widget_path_iter_remove_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_label",sl_g_menu_item_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_changed",sl_pango_context_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_contents",sl_g_file_set_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_get_type",sl_gtk_separator_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strdown",sl_g_utf8_strdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_bin_window_to_widget_coords",sl_gtk_tree_view_convert_bin_window_to_widget_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_new",sl_gdk_pixbuf_loader_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_interactive_at_cursor",sl_gtk_text_buffer_insert_interactive_at_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_group_position",sl_gtk_tool_palette_set_group_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_instance",sl_g_type_check_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_element",sl_g_variant_type_element,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_native_size",sl_g_inet_address_get_native_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_string",sl_g_variant_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_volume_button_new",sl_gtk_volume_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_buffer",sl_gtk_entry_get_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_settings",sl_gtk_print_job_get_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_active_iter",sl_gtk_combo_box_get_active_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_app_paintable",sl_gtk_widget_get_app_paintable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_set_layout",sl_gtk_button_box_set_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_length",sl_gtk_widget_path_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_show_recommended",sl_gtk_app_chooser_widget_set_show_recommended,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_char",sl_gtk_text_iter_backward_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_protocol",sl_g_proxy_address_get_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_font_desc",sl_gtk_font_chooser_set_font_desc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_group",sl_gtk_gesture_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_set_default_mod_mask",sl_gtk_accelerator_set_default_mod_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_children",sl_gdk_window_get_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_cut_clipboard",sl_gtk_text_buffer_cut_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_get_message_area",sl_gtk_statusbar_get_message_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_fixed_get_type",sl_gtk_fixed_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_attributes_type_get_type",sl_gdk_window_attributes_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_username",sl_g_proxy_address_get_username,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_apply_tag",sl_gtk_text_buffer_apply_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_has_screen",sl_gtk_widget_has_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_user_data",sl_gdk_window_set_user_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_set_accel_widget",sl_gtk_accel_label_set_accel_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_unknown_glyphs_count",sl_pango_layout_get_unknown_glyphs_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_root_window",sl_gdk_screen_get_root_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_height_mm",sl_gdk_screen_get_height_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_data_dir",sl_g_get_user_data_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_placement",sl_gtk_scrolled_window_get_placement,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_inserted",sl_gtk_tree_row_reference_inserted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_monospace",sl_gtk_text_view_set_monospace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_type",sl_g_inet_address_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_sort_order",sl_g_file_info_get_sort_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_ref",sl_g_variant_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_has_entry",sl_gtk_combo_box_get_has_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_modal",sl_gtk_popover_set_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_tree_to_bin_window_coords",sl_gtk_tree_view_convert_tree_to_bin_window_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_type",sl_gtk_font_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_label",sl_gtk_tool_item_group_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_direction",sl_gtk_widget_set_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_spacing",sl_gtk_tree_view_column_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_insert_text",sl_gtk_combo_box_text_insert_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_name_with_keycode",sl_gtk_accelerator_name_with_keycode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_copy",sl_pango_layout_iter_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_can_focus",sl_gtk_widget_set_can_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dir_make_tmp",sl_g_dir_make_tmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_font_options",sl_gdk_screen_get_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_accel_group",sl_gtk_menu_get_accel_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_grab_focus_without_selecting",sl_gtk_entry_grab_focus_without_selecting,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_timeout",sl_g_socket_get_timeout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_match",sl_g_regex_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pango_context_get",sl_gdk_pango_context_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_put",sl_gtk_layout_put,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_surface",sl_gtk_icon_info_load_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_stringv",sl_g_file_info_get_attribute_stringv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_new",sl_gtk_scrolled_window_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rgba_copy",sl_gdk_rgba_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_make_symbolic_link",sl_g_file_make_symbolic_link,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_text_index_to_layout_index",sl_gtk_entry_text_index_to_layout_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_get_name",sl_gtk_buildable_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_setenv",sl_g_app_launch_context_setenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_max_width",sl_gtk_tree_view_column_get_max_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_icon_surface",sl_gtk_render_icon_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_detailed_action",sl_g_menu_item_set_detailed_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_place_on_monitor",sl_gtk_menu_place_on_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_new_with_area",sl_gtk_tree_view_column_new_with_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_allocated_size",sl_gtk_widget_get_allocated_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_check_threshold",sl_gtk_drag_check_threshold,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_visible_horizontal",sl_gtk_tool_item_set_visible_horizontal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_font_description",sl_pango_layout_set_font_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_fixed_new",sl_gtk_fixed_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_ymd",sl_g_date_time_get_ymd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_class_is_a",sl_g_type_check_class_is_a,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pango_context_get_for_display",sl_gdk_pango_context_get_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_weight_new",sl_pango_attr_weight_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_queue_resize",sl_gtk_tree_view_column_queue_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_detach",sl_gtk_menu_detach,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_offset",sl_gtk_text_iter_set_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_label_widget",sl_gtk_tool_item_group_set_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_new",sl_g_proxy_address_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_keyboard",sl_gdk_seat_get_keyboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_select_month",sl_gtk_calendar_select_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_new",sl_gtk_list_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_events_pending",sl_gdk_events_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best_type",sl_gdk_visual_get_best_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_value",sl_gtk_spin_button_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_gtype_get_type",sl_g_gtype_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_array",sl_g_variant_type_is_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_bind_model",sl_gtk_popover_bind_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_get_fd",sl_g_cancellable_get_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace_contents_finish",sl_g_file_replace_contents_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_line",sl_pango_layout_iter_get_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_text",sl_gtk_progress_bar_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_set_sensitive",sl_gtk_cell_renderer_set_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_width_mm",sl_gdk_screen_get_monitor_width_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_value",sl_gtk_adjustment_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_matches",sl_g_inet_address_mask_matches,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_tree_to_widget_coords",sl_gtk_tree_view_convert_tree_to_widget_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_get_radio",sl_gtk_cell_renderer_toggle_get_radio,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_create_app_info",sl_gtk_recent_info_create_app_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_visible",sl_gtk_tree_view_column_get_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_child_get_type",sl_gtk_flow_box_child_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_completer_get_completion_suffix",sl_g_filename_completer_get_completion_suffix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_table_free",sl_gtk_target_table_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_mask_get_type",sl_gdk_event_mask_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_unref",sl_g_source_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_opaque_region",sl_gdk_window_set_opaque_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_set_editable",sl_gtk_editable_set_editable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_free_instance",sl_g_type_free_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strdelimit",sl_g_strdelimit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_freeze_updates",sl_gdk_window_freeze_updates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_set_default_response",sl_gtk_info_bar_set_default_response,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_margin",sl_gtk_icon_view_get_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_get_type",sl_gdk_device_pad_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_destination_protocol",sl_g_proxy_address_get_destination_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_set_show_default_item",sl_gtk_app_chooser_button_set_show_default_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_bytestring",sl_g_variant_new_bytestring,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_new",sl_gtk_calendar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_maximize",sl_gdk_window_maximize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_equal",sl_gtk_text_iter_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_parent",sl_g_file_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_new",sl_gtk_recent_manager_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_show_arrow",sl_gtk_toolbar_get_show_arrow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_change",sl_pango_attr_list_change,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_abort",sl_gdk_drag_abort,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_tooltip_column",sl_gtk_tree_view_set_tooltip_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_nth_page",sl_gtk_notebook_get_nth_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_stringv",sl_g_file_info_set_attribute_stringv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_expanded",sl_gtk_expander_get_expanded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_set_size",sl_gtk_paper_size_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add",sl_gtk_target_list_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_start_line",sl_gtk_css_section_get_start_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_has_char",sl_pango_font_has_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_match",sl_gtk_recent_info_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_unref",sl_g_variant_builder_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_variant_new",sl_pango_attr_variant_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_xalign",sl_gtk_label_set_xalign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_to_ucs4_fast",sl_g_utf8_to_ucs4_fast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_list_regions",sl_gtk_widget_path_iter_list_regions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_set_modified",sl_gtk_text_buffer_set_modified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_unmaximize",sl_gtk_window_unmaximize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_error_get_type",sl_gdk_gl_error_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_icon_size",sl_gtk_tool_palette_get_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_to_unicode",sl_gdk_keyval_to_unicode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_homogeneous",sl_gtk_flow_box_set_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_bind",sl_g_socket_bind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_new",sl_g_mount_operation_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_new",sl_gtk_page_setup_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_family_static",sl_pango_font_description_set_family_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_default",sl_gdk_keymap_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_elapsed",sl_g_timer_elapsed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_get_visible",sl_gtk_native_dialog_get_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_get_type",sl_gtk_menu_shell_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_ref",sl_g_resource_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_start_mountable_finish",sl_g_file_start_mountable_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_insert_section",sl_g_menu_insert_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_is_active",sl_gtk_gesture_is_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_is_accepting_jobs",sl_gtk_printer_is_accepting_jobs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_top",sl_gtk_widget_get_margin_top,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_use_font",sl_gtk_font_button_set_use_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_support_multidevice",sl_gdk_window_set_support_multidevice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_add_years",sl_g_date_add_years,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_get_type",sl_g_notification_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_default_left_margin",sl_gtk_paper_size_get_default_left_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_type",sl_gdk_visual_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_iter_free",sl_gtk_tree_iter_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_internal",sl_g_param_spec_internal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pango_context_get_for_screen",sl_gdk_pango_context_get_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_get_animation",sl_gdk_pixbuf_loader_get_animation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_list_owned",sl_g_param_spec_pool_list_owned,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_matches",sl_pango_language_matches,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_get_program_class",sl_gdk_get_program_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_icon",sl_g_bookmark_file_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_menu_label_text",sl_gtk_notebook_set_menu_label_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_to_gvariant",sl_gtk_print_settings_to_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_type",sl_gtk_tree_view_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_buffered",sl_g_io_channel_get_buffered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_vscrollbar",sl_gtk_scrolled_window_get_vscrollbar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_layout_offsets",sl_gtk_label_get_layout_offsets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_quality",sl_gtk_print_settings_get_quality,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_to_tag_toggle",sl_gtk_text_iter_backward_to_tag_toggle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_load_from_path",sl_gtk_css_provider_load_from_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_get_type",sl_gtk_app_chooser_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_associated_device",sl_gdk_device_get_associated_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_scancode",sl_gdk_event_get_scancode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_active",sl_gtk_combo_box_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_double_range",sl_g_rand_double_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_border_width",sl_gtk_container_get_border_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_selected_children",sl_gtk_flow_box_get_selected_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_is_paused",sl_gtk_printer_is_paused,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_visible_text",sl_gtk_text_iter_get_visible_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_paint_region",sl_gdk_window_begin_paint_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_embed_page_setup",sl_gtk_print_unix_dialog_get_embed_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_now_utc",sl_g_date_time_new_now_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblem_new",sl_g_emblem_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_draw_value",sl_gtk_scale_get_draw_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_interface_get_plugin",sl_g_type_interface_get_plugin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_dup_objv",sl_g_variant_dup_objv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_homogeneous",sl_gtk_tool_item_set_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_preferred_width_for_height",sl_gtk_cell_renderer_get_preferred_width_for_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_remove",sl_gtk_target_list_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_level",sl_gtk_font_chooser_get_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_accel_path",sl_gtk_widget_set_accel_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_page_set",sl_gtk_print_settings_set_page_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_override_color",sl_gtk_widget_override_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_origin",sl_gdk_window_get_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_for_attach_widget",sl_gtk_menu_get_for_attach_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_reposition",sl_gtk_menu_reposition,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_save_to_streamv",sl_gdk_pixbuf_save_to_streamv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_environ_getenv",sl_g_environ_getenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_system_config_dirs",sl_g_get_system_config_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_set_width_chars",sl_gtk_file_chooser_button_set_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_destroy",sl_gtk_native_dialog_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_underline_new",sl_pango_attr_underline_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_active",sl_gtk_menu_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_lookup",sl_gtk_text_tag_table_lookup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_select_all",sl_gtk_file_chooser_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_size",sl_gtk_font_chooser_get_font_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_value_pos",sl_gtk_scale_get_value_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_attach",sl_gtk_menu_attach,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_get_info",sl_g_resources_get_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_prepend",sl_gtk_list_box_prepend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_send",sl_g_socket_send,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_get_focus_on_click",sl_gtk_file_chooser_button_get_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_sortable_has_default_sort_func",sl_gtk_tree_sortable_has_default_sort_func,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_int",sl_g_settings_set_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_add_action_widget",sl_gtk_assistant_add_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_text",sl_gtk_tooltip_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_reverse",sl_gtk_print_settings_get_reverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_should_automount",sl_g_volume_should_automount,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_ends_sentence",sl_gtk_text_iter_ends_sentence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_move_mark_by_name",sl_gtk_text_buffer_move_mark_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_current_folder_uri",sl_gtk_file_chooser_get_current_folder_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_charset_converter_set_use_fallback",sl_g_charset_converter_set_use_fallback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_set_disabled_text",sl_gtk_shortcut_label_set_disabled_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_map_lookup_action",sl_g_action_map_lookup_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_end",sl_gtk_widget_set_margin_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_use_color",sl_gtk_print_settings_get_use_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_remove_comment",sl_g_key_file_remove_comment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_events_pending",sl_gtk_events_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_gicon",sl_gtk_image_new_from_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_new",sl_pango_tab_array_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_page_setup_set",sl_gtk_print_unix_dialog_get_page_setup_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_new",sl_gtk_tree_path_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_track_print_status",sl_gtk_print_job_get_track_print_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_n_items",sl_g_variant_type_n_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_select_all",sl_gtk_list_box_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_lower",sl_gtk_adjustment_get_lower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_enable_search",sl_gtk_tree_view_set_enable_search,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_from_name",sl_g_type_from_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_height",sl_gtk_print_context_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_filter",sl_gtk_recent_filter_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_handle",sl_g_variant_get_handle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strup",sl_g_utf8_strup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_add_overlay",sl_gtk_overlay_add_overlay,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_encoding",sl_g_io_channel_get_encoding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_list_papers",sl_gtk_printer_list_papers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_unselect_row",sl_gtk_list_box_unselect_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_get_network_available",sl_g_network_monitor_get_network_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_get_icon",sl_g_emblemed_icon_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_set_visible",sl_gtk_text_mark_set_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_new",sl_gtk_entry_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_link_iter_next",sl_g_menu_link_iter_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_dup_string",sl_g_variant_type_dup_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_add_window",sl_gtk_window_group_add_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_fit_model",sl_gtk_cell_view_get_fit_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_set_program_class",sl_gdk_set_program_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_set_spacing",sl_gtk_box_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_unref",sl_g_mapped_file_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_display",sl_gdk_window_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strjoinv",sl_g_strjoinv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_phase_get_type",sl_gdk_frame_clock_phase_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_type",sl_gtk_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_new_with_path",sl_g_settings_new_with_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_new",sl_pango_context_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new",sl_gtk_radio_menu_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_metrics",sl_pango_context_get_metrics,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_open",sl_gdk_display_open,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_nth_item",sl_gtk_tool_item_group_get_nth_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_artists",sl_gtk_about_dialog_set_artists,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_new",sl_gtk_paned_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_action_get_type",sl_gdk_drag_action_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_left_margin",sl_gtk_page_setup_get_left_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_print_settings",sl_gtk_print_operation_set_print_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_offset",sl_gtk_text_iter_get_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_iswide",sl_g_unichar_iswide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_selectable",sl_gtk_label_set_selectable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_resize",sl_gdk_window_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_min_width",sl_gtk_tree_view_column_set_min_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_pixbuf",sl_gtk_image_new_from_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_menu_get_type",sl_gtk_popover_menu_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_acquire",sl_g_main_context_acquire,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_set_visible",sl_gtk_cell_renderer_set_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_qname",sl_gtk_widget_path_iter_has_qname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_use_size",sl_gtk_font_button_set_use_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_string_to_signed",sl_g_ascii_string_to_signed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_start_finish",sl_g_drive_start_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_new",sl_gtk_gl_area_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_option",sl_gdk_pixbuf_get_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_icon_name",sl_gtk_window_set_default_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_do_overwrite_confirmation",sl_gtk_file_chooser_get_do_overwrite_confirmation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_equal",sl_g_date_time_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_tab_reorderable",sl_gtk_notebook_set_tab_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_show_recommended",sl_gtk_app_chooser_widget_get_show_recommended,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_groups_from_object",sl_gtk_accel_groups_from_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_constrain_size",sl_gdk_window_constrain_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_mnemonic_keyval",sl_gtk_label_get_mnemonic_keyval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_new_with_dialog",sl_gtk_file_chooser_button_new_with_dialog,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_to_key_file",sl_gtk_page_setup_to_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_paper_width",sl_gtk_page_setup_get_paper_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_list_targets",sl_gdk_drag_context_list_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_child_anchor",sl_gtk_text_buffer_insert_child_anchor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_offscreen_window_get_embedder",sl_gdk_offscreen_window_get_embedder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_remove_emission_hook",sl_g_signal_remove_emission_hook,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_page_set",sl_gtk_print_job_set_page_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_focus_on_click",sl_gtk_combo_box_set_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_completion_prefix",sl_gtk_entry_completion_get_completion_prefix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_type",sl_gtk_assistant_get_page_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_length",sl_gtk_print_settings_set_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_julian",sl_g_date_valid_julian,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_destroyed",sl_gtk_widget_destroyed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_style_new",sl_pango_attr_style_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_always_show_image",sl_gtk_button_set_always_show_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_update_policy",sl_gtk_spin_button_set_update_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_get_is_locked",sl_gtk_accel_group_get_is_locked,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_complete",sl_gdk_frame_timings_get_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_matches",sl_g_file_attribute_matcher_matches,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_ref",sl_gdk_frame_timings_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_group",sl_gtk_gesture_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_pixbuf",sl_gtk_selection_data_get_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_device_tool",sl_gdk_event_get_device_tool,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_strikethrough_position",sl_pango_font_metrics_get_strikethrough_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_path",sl_gtk_style_context_set_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_condition_check",sl_g_socket_condition_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_set_icon_pixbuf",sl_gtk_drag_source_set_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_uint32",sl_g_variant_get_uint32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_resize_mode",sl_gtk_container_get_resize_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_copy_area",sl_gdk_pixbuf_copy_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_chars",sl_gtk_text_iter_forward_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_add_uri_targets",sl_gtk_drag_source_add_uri_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_desc",sl_gtk_font_chooser_get_font_desc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_spaced_primes_closest",sl_g_spaced_primes_closest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_feature_get_type",sl_gdk_device_pad_feature_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_new",sl_gtk_shortcut_label_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_id",sl_g_source_get_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_state_message",sl_gtk_printer_get_state_message,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_stock_id",sl_gtk_tool_button_get_stock_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_set_transition_duration",sl_gtk_revealer_set_transition_duration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_subtract_years",sl_g_date_subtract_years,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_compare",sl_gtk_printer_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_frame_extents",sl_gdk_window_get_frame_extents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new_with_mnemonic_from_widget",sl_gtk_radio_menu_item_new_with_mnemonic_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_wrap",sl_pango_layout_set_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_instance_get_private",sl_g_type_instance_get_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_new_for_path",sl_g_file_new_for_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_baseline",sl_pango_layout_get_baseline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_stock",sl_gtk_image_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_new",sl_gtk_spin_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_row_spacing",sl_gtk_icon_view_get_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_redirect_target",sl_g_param_spec_get_redirect_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_qname",sl_g_type_qname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_get_hadjustment",sl_gtk_layout_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_skip_pager_hint",sl_gtk_window_get_skip_pager_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_find_program_in_path",sl_g_find_program_in_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_attributes",sl_gtk_label_get_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set",sl_gtk_print_settings_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_interface_list_properties",sl_g_object_interface_list_properties,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_new",sl_gtk_tool_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_new_with_stock_from_widget",sl_gtk_radio_tool_button_new_with_stock_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_tooltip_text",sl_gtk_widget_set_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_order",sl_gtk_text_iter_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_move_mark_onscreen",sl_gtk_text_view_move_mark_onscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_scroll_lock_state",sl_gdk_keymap_get_scroll_lock_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_new",sl_gtk_button_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_trash",sl_gtk_places_sidebar_set_show_trash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_visible",sl_gtk_tree_view_column_set_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_name_from_instance",sl_g_type_name_from_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_set_default_display",sl_gdk_display_manager_set_default_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_has_selection",sl_gtk_print_operation_set_has_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_popover",sl_gtk_menu_button_get_popover,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_support_multidevice",sl_gtk_widget_get_support_multidevice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_opacity",sl_gtk_window_get_opacity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_name",sl_gdk_display_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_begin",sl_gtk_drag_begin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_printer",sl_gtk_print_settings_set_printer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_draw_frame",sl_gdk_window_begin_draw_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_unref",sl_pango_font_metrics_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_propagate_natural_height",sl_gtk_scrolled_window_set_propagate_natural_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_error_quark",sl_gtk_icon_theme_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_slice",sl_gtk_text_buffer_get_slice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_attributes",sl_gtk_entry_get_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hostname_is_ascii_encoded",sl_g_hostname_is_ascii_encoded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_child_visible",sl_gtk_widget_set_child_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_visible_horizontal",sl_gtk_tool_item_get_visible_horizontal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_int_range",sl_g_rand_int_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_type",sl_gtk_page_setup_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_hadjustment",sl_gtk_text_view_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_get_type",sl_g_simple_action_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_get_path",sl_gtk_tree_row_reference_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_settings",sl_gtk_print_unix_dialog_set_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_set_screen",sl_gtk_mount_operation_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_unselect_uri",sl_gtk_recent_chooser_unselect_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_to_data",sl_g_bookmark_file_to_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_from_file",sl_gtk_builder_add_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_writable_changed",sl_g_settings_backend_writable_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_attributes",sl_pango_layout_get_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_set_seed_array",sl_g_rand_set_seed_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_free_targets",sl_g_resolver_free_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_copy",sl_gdk_pixbuf_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_enumerate_identifiers",sl_g_volume_enumerate_identifiers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_move_cursor_visually",sl_pango_layout_move_cursor_visually,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_move_drag",sl_gdk_window_begin_move_drag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_popup_disable",sl_gtk_notebook_popup_disable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_selection_mode",sl_gtk_icon_view_set_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_type",sl_gtk_tool_shell_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_popup_set_width",sl_gtk_entry_completion_get_popup_set_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isdefined",sl_g_unichar_isdefined,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_set_show_close_button",sl_gtk_search_bar_set_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_deactivate",sl_gtk_menu_shell_deactivate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_end_paint",sl_gdk_window_end_paint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_type_hint",sl_gtk_window_get_type_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_display",sl_gtk_selection_data_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_value_set_default",sl_g_param_value_set_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_n_monitors",sl_gdk_display_get_n_monitors,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_face_list_sizes",sl_pango_font_face_list_sizes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_now_local",sl_g_date_time_new_now_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rgba_equal",sl_gdk_rgba_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_char",sl_gtk_text_iter_forward_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_remove_offset_value",sl_gtk_level_bar_remove_offset_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_insert",sl_gtk_list_box_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_refresh",sl_gtk_app_chooser_refresh,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_fetch_pos",sl_g_match_info_fetch_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_line_index",sl_gtk_text_buffer_get_iter_at_line_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_mode",sl_gtk_level_bar_get_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_header_image",sl_gtk_assistant_get_page_header_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_title",sl_gtk_header_bar_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_append_with_siblings",sl_gtk_widget_path_append_with_siblings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_class_adjust_private_offset",sl_g_type_class_adjust_private_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_list_displays",sl_gdk_display_manager_list_displays,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_type",sl_pango_layout_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_model",sl_gtk_cell_view_set_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_shape_combine_region",sl_gdk_window_shape_combine_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_arrow",sl_gtk_render_arrow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_fullscreen_on_monitor",sl_gtk_window_fullscreen_on_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_all",sl_g_app_info_get_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_have_bidi_layouts",sl_gdk_keymap_have_bidi_layouts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_auto_render",sl_gtk_gl_area_get_auto_render,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_receives_default",sl_gtk_widget_set_receives_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_add_widget",sl_gtk_size_group_add_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_unselect_all",sl_gtk_flow_box_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_left_margin",sl_gtk_text_view_set_left_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_byte",sl_g_variant_get_byte,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_prepend_page_menu",sl_gtk_notebook_prepend_page_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_reset_cursor_blink",sl_gtk_text_view_reset_cursor_blink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_hadjustment",sl_gtk_tree_view_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_path",sl_g_file_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_hscrollbar",sl_gtk_scrolled_window_get_hscrollbar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_focus_vadjustment",sl_gtk_container_get_focus_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_new",sl_gtk_recent_filter_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_activates_default",sl_gtk_entry_get_activates_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_iter_next",sl_pango_script_iter_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_broadcast",sl_g_socket_set_broadcast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_get_type",sl_pango_cairo_font_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_instance_is_a",sl_g_type_check_instance_is_a,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_rotate",sl_gtk_print_job_set_rotate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_micro_version",sl_gtk_get_micro_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_dup_bytestring",sl_g_variant_dup_bytestring,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_coords",sl_gdk_event_get_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_new_with_area",sl_gtk_entry_completion_new_with_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_path_get_basename",sl_g_path_get_basename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_focus",sl_gtk_window_get_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_context",sl_gtk_gl_area_get_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_min_content_height",sl_gtk_scrolled_window_set_min_content_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_set_use_es",sl_gdk_gl_context_set_use_es,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_source_new",sl_g_cancellable_source_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_user_value",sl_g_settings_get_user_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_get_feature_group",sl_gdk_device_pad_get_feature_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_tuple",sl_g_variant_new_tuple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_text_column",sl_gtk_icon_view_get_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_unref",sl_g_date_time_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_icon_get_type",sl_g_file_icon_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_set_column_types",sl_gtk_tree_store_set_column_types,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_new",sl_gtk_expander_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_object_path",sl_g_variant_is_object_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_word_ends",sl_gtk_text_iter_forward_visible_word_ends,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_keynav_failed",sl_gtk_widget_keynav_failed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_default_widget",sl_gtk_popover_set_default_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_get_type",sl_pango_coverage_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_convert_child_iter_to_iter",sl_gtk_tree_model_filter_convert_child_iter_to_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_track_print_status",sl_gtk_print_job_set_track_print_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_coords_to_parent",sl_gdk_window_coords_to_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_file_info",sl_gdk_pixbuf_get_file_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_content_area",sl_gtk_dialog_get_content_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_prepare",sl_g_main_context_prepare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_get_show_events",sl_gdk_get_show_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_get_type",sl_g_resource_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_subtitle",sl_gtk_header_bar_set_subtitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_insert_page",sl_gtk_notebook_insert_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_override_redirect",sl_gdk_window_set_override_redirect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_widget_to_tree_coords",sl_gtk_tree_view_convert_widget_to_tree_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_new_array",sl_g_variant_type_new_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_page_set",sl_gtk_print_job_get_page_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_is_same_user",sl_g_credentials_is_same_user,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_relief",sl_gtk_button_get_relief,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_string",sl_g_file_set_attribute_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_uris",sl_gtk_file_chooser_get_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_locale_string",sl_g_key_file_set_locale_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_name",sl_g_type_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_uint",sl_g_settings_set_uint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_type",sl_gtk_cell_area_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_make_current",sl_gtk_gl_area_make_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_new",sl_gtk_accel_label_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_axis",sl_gdk_device_get_axis,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_size",sl_gtk_widget_get_preferred_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_get_default_root_window",sl_gdk_get_default_root_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_device_events",sl_gdk_window_get_device_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_handler_is_connected",sl_g_signal_handler_is_connected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_focus",sl_gdk_window_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_skip",sl_g_input_stream_skip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_events_get_angle",sl_gdk_events_get_angle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_name",sl_g_action_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_peek_children",sl_gdk_window_peek_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_free",sl_g_date_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_combining_class",sl_g_unichar_combining_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_connect_to_server",sl_gtk_places_sidebar_set_show_connect_to_server,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_target_property",sl_g_binding_get_target_property,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_visual",sl_gtk_widget_get_visual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_text",sl_pango_layout_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_type",sl_gdk_device_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_convert",sl_gtk_selection_convert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_lookup",sl_g_param_spec_pool_lookup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_auto_render",sl_gtk_gl_area_set_auto_render,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_parent",sl_g_type_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_get_cells",sl_gtk_cell_layout_get_cells,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_item_position",sl_gtk_tool_item_group_set_item_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_spacing",sl_pango_layout_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_move_child",sl_gtk_text_view_move_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_cursor_position",sl_gtk_text_iter_forward_cursor_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_choice",sl_gtk_file_chooser_set_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_default_screen",sl_gdk_display_get_default_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_ungrab",sl_gdk_device_ungrab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_create_action",sl_g_settings_create_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_default",sl_gtk_clipboard_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_reorderable",sl_gtk_tree_view_set_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_has_selection",sl_gtk_print_unix_dialog_set_has_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_set_translation_domain",sl_gtk_builder_set_translation_domain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_to_filename",sl_pango_font_description_to_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_get_vadjustment",sl_gtk_scrollable_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_expand",sl_gtk_tree_view_column_get_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_popup_completion",sl_gtk_entry_completion_set_popup_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_sort_order",sl_gtk_tree_view_column_set_sort_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_container",sl_g_variant_type_is_container,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_copy_clipboard",sl_gtk_text_buffer_copy_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_widget_new",sl_gtk_file_chooser_widget_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_mc_global",sl_g_inet_address_get_is_mc_global,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"glib_check_version",sl_glib_check_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_get_type",sl_gdk_cursor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_day",sl_g_date_get_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_number_up",sl_gtk_print_settings_get_number_up,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_get_group",sl_gtk_radio_menu_item_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_commit",sl_gtk_assistant_commit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_validate",sl_g_utf8_validate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_valign",sl_gtk_widget_set_valign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_remove",sl_gtk_list_store_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_spacing",sl_gtk_tree_view_column_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_column_spacing",sl_gtk_icon_view_get_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_mark",sl_gtk_text_buffer_get_iter_at_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_add_mnemonic",sl_gtk_window_add_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_set_response_sensitive",sl_gtk_info_bar_set_response_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_getv",sl_g_object_getv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_ref",sl_gtk_text_attributes_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_use_font",sl_gtk_font_button_get_use_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_state",sl_gtk_style_context_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_signature",sl_g_variant_is_signature,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_targets_include_uri",sl_gtk_targets_include_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_move_drag_for_device",sl_gdk_window_begin_move_drag_for_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_char",sl_gtk_text_iter_get_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_upper_stepper_sensitivity",sl_gtk_range_set_upper_stepper_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_unref",sl_g_regex_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_weeks",sl_g_date_time_add_weeks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_width",sl_gdk_screen_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_minute",sl_g_date_time_get_minute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_new_from_bytes",sl_g_inet_address_new_from_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_connect_entry",sl_gtk_search_bar_connect_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_select_multiple",sl_gtk_file_chooser_get_select_multiple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_charset_converter_get_type",sl_g_charset_converter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_layout",sl_gtk_render_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_redraw_on_allocate",sl_gtk_widget_set_redraw_on_allocate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_get_coverage",sl_pango_font_get_coverage,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_screen",sl_gtk_style_context_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_months",sl_g_date_time_add_months,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_stretch_new",sl_pango_attr_stretch_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_type",sl_g_volume_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_sunday_weeks_in_year",sl_g_date_get_sunday_weeks_in_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_item_column",sl_gtk_icon_view_get_item_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_ungrab",sl_gdk_seat_ungrab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_default_language",sl_gtk_get_default_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_popup_completion",sl_gtk_entry_completion_get_popup_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_string",sl_g_key_file_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_list_schemas",sl_g_settings_schema_source_list_schemas,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_has_depth_buffer",sl_gtk_gl_area_get_has_depth_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_thaw_child_notify",sl_gtk_widget_thaw_child_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_is_ellipsized",sl_pango_layout_is_ellipsized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strdupv",sl_g_strdupv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_drag_window",sl_gdk_drag_context_get_drag_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_is_selected",sl_gtk_list_box_row_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_expanded",sl_gtk_expander_set_expanded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_type",sl_gtk_cell_view_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_description",sl_g_app_info_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_name",sl_g_app_info_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_background_rgba",sl_gdk_window_set_background_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_title",sl_gtk_combo_box_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_add_entry",sl_gtk_accel_map_add_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_blurb",sl_g_param_spec_get_blurb,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_preview_uri",sl_gtk_file_chooser_get_preview_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_set_window",sl_gtk_gesture_set_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_error_quark",sl_gtk_file_chooser_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_bin_window_to_tree_coords",sl_gtk_tree_view_convert_bin_window_to_tree_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_uri",sl_gtk_file_chooser_set_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_justify",sl_gtk_label_set_justify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_uris",sl_g_bookmark_file_get_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_has_default",sl_gtk_widget_has_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_property_get",sl_gdk_selection_property_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_has_prefix",sl_g_str_has_prefix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_pointer_to_offset",sl_g_utf8_pointer_to_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_range_check",sl_g_settings_range_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_can_default",sl_gtk_widget_set_can_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_insert_page",sl_gtk_assistant_insert_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_update_context",sl_pango_cairo_update_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_language_names",sl_g_get_language_names,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_store",sl_gtk_clipboard_store,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_font_desc_new",sl_pango_attr_font_desc_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_type",sl_gtk_header_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_mask",sl_g_file_info_set_attribute_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_merge",sl_pango_font_description_merge,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_border_color",sl_gtk_style_context_get_border_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_strv",sl_g_variant_new_strv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_tabs",sl_pango_layout_set_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_set_show_events",sl_gdk_set_show_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_reorderable",sl_gtk_notebook_get_tab_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_thaw_updates",sl_gdk_window_thaw_updates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_column_spacing",sl_gtk_icon_view_set_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_type",sl_g_settings_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_attribute_iter_next",sl_g_menu_attribute_iter_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_scroll_get_type",sl_gtk_event_controller_scroll_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_get_environment",sl_g_app_launch_context_get_environment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_modal_hint",sl_gdk_window_set_modal_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_type",sl_gtk_scale_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_slider_range",sl_gtk_range_get_slider_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_alignment",sl_gtk_button_set_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_pixbuf_column",sl_gtk_icon_view_get_pixbuf_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_reset_type_associations",sl_g_app_info_reset_type_associations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_n_pages",sl_gtk_notebook_get_n_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_root",sl_g_mount_get_root,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_set_propagation_phase",sl_gtk_event_controller_set_propagation_phase,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_stock",sl_gtk_image_get_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_set_vscroll_policy",sl_gtk_scrollable_set_vscroll_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_add_accelerator",sl_gtk_application_add_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_unref",sl_g_match_info_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_get_type",sl_gtk_list_box_row_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_submenu",sl_gtk_menu_item_get_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_copy_into",sl_g_file_info_copy_into,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_new",sl_gtk_search_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_ref_node",sl_gtk_tree_model_ref_node,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_set_mode",sl_gtk_toggle_button_set_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_integer",sl_g_key_file_get_integer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_default_value",sl_g_settings_schema_key_get_default_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rectangle_equal",sl_gdk_rectangle_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_alternative_dialog_button_order",sl_gtk_alternative_dialog_button_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_add_virtual_modifiers",sl_gdk_keymap_add_virtual_modifiers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_propagate_draw",sl_gtk_container_propagate_draw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_set_inverted",sl_gtk_level_bar_set_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_vhomogeneous",sl_gtk_stack_set_vhomogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_current_sequence",sl_gtk_gesture_single_get_current_sequence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_alignment",sl_gtk_entry_get_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_match_string",sl_g_str_match_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uuid_string_is_valid",sl_g_uuid_string_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_int32",sl_g_variant_get_int32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_strv",sl_g_variant_get_strv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_allocated_height",sl_gtk_widget_get_allocated_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_get_type",sl_gtk_cell_renderer_toggle_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_size",sl_pango_font_description_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_width",sl_pango_layout_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_lock",sl_gtk_accel_group_lock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_slice",sl_gtk_text_iter_get_slice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_focus_on_click",sl_gtk_button_get_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_grid_lines",sl_gtk_tree_view_set_grid_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_direction",sl_gtk_menu_button_set_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_new_with_mnemonic",sl_gtk_menu_item_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_multicast_ttl",sl_g_socket_set_multicast_ttl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_emit_deleted_text",sl_gtk_entry_buffer_emit_deleted_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_use_color",sl_gtk_print_settings_set_use_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_policy",sl_gtk_scrolled_window_get_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_local_only",sl_gtk_recent_chooser_set_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_delete_mark_by_name",sl_gtk_text_buffer_delete_mark_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_cursor_alpha",sl_gdk_display_supports_cursor_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_name",sl_gtk_entry_get_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_file_type",sl_g_file_info_get_file_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_proxy_resolver_set_uri_proxy",sl_g_simple_proxy_resolver_set_uri_proxy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_visible_line_offset",sl_gtk_text_iter_set_visible_line_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_uint32",sl_g_variant_new_uint32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_handle",sl_gtk_render_handle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_attributes",sl_gtk_entry_set_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_get_color",sl_pango_renderer_get_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_vexpand",sl_gtk_widget_get_vexpand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_resize_grip_area",sl_gtk_window_get_resize_grip_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_end_draw_frame",sl_gdk_window_end_draw_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_get_selection_bounds",sl_gtk_editable_get_selection_bounds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_urgency_hint",sl_gtk_window_get_urgency_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_deserialize_get_can_create_tags",sl_gtk_text_buffer_deserialize_get_can_create_tags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_monitor_at_point",sl_gdk_display_get_monitor_at_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_set_source_window",sl_gdk_cairo_set_source_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_get_metrics",sl_pango_font_get_metrics,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_modal",sl_gtk_popover_get_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_row_deleted",sl_gtk_tree_model_row_deleted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_dest_window",sl_gdk_drag_context_get_dest_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_remove_attribute",sl_g_file_info_remove_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_activate_cell",sl_gtk_cell_area_activate_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_window_by_id",sl_gtk_application_get_window_by_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_previous_page",sl_gtk_assistant_previous_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_iter_is_valid",sl_gtk_tree_store_iter_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_cursor",sl_gdk_window_set_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_id_column",sl_gtk_combo_box_get_id_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_from_resource",sl_gtk_builder_add_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_type_get_type",sl_gdk_cursor_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_entry_new",sl_gtk_target_entry_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_set_title",sl_gtk_color_button_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_extra_widget",sl_gtk_file_chooser_get_extra_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_warp",sl_gdk_device_warp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_bytes",sl_gdk_pixbuf_new_from_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_device_events",sl_gdk_window_set_device_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_path_changed",sl_g_settings_backend_path_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strv_length",sl_g_strv_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_default_location",sl_g_mount_get_default_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_child_anchor",sl_gtk_text_iter_get_child_anchor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_new",sl_gtk_about_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_multi_press_new",sl_gtk_gesture_multi_press_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_icon_name",sl_gtk_tool_button_set_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_text",sl_gtk_entry_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_open_flags",sl_gtk_places_sidebar_set_open_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_response",sl_gtk_info_bar_response,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_type",sl_g_file_info_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_auto_dir",sl_pango_layout_get_auto_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_features",sl_gtk_font_chooser_get_font_features,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_is_symbolic",sl_gtk_icon_info_is_symbolic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_tool_item_get_type",sl_gtk_separator_tool_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new_with_model_and_entry",sl_gtk_combo_box_new_with_model_and_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_add_device_events",sl_gtk_widget_add_device_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_iter_from_string",sl_gtk_tree_model_get_iter_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_insert",sl_gtk_combo_box_text_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_path_is_absolute",sl_g_path_is_absolute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_draw_from_gl",sl_gdk_cairo_draw_from_gl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_lower_stepper_sensitivity",sl_gtk_range_get_lower_stepper_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_new_with_label",sl_gtk_check_menu_item_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_max_value",sl_gtk_level_bar_get_max_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_new",sl_g_rand_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_string",sl_g_value_set_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_commandline",sl_g_app_info_get_commandline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_scale_factor",sl_gdk_window_get_scale_factor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_uint64",sl_g_key_file_set_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_approximate_char_width",sl_pango_font_metrics_get_approximate_char_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_cursor_locations",sl_gtk_text_view_get_cursor_locations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_current_folder_file",sl_gtk_file_chooser_get_current_folder_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_new",sl_g_socket_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_get_header",sl_gtk_list_box_row_get_header,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_minutes",sl_g_date_time_add_minutes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_type_string",sl_g_variant_get_type_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_add_mnemonic_label",sl_gtk_widget_add_mnemonic_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_clear_cache",sl_gtk_tree_model_sort_clear_cache,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_unshadow",sl_g_mount_unshadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_preferred_width_for_height",sl_gtk_cell_area_context_get_preferred_width_for_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_menubar",sl_gtk_application_get_menubar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_type",sl_g_mount_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_primary_monitor",sl_gdk_display_get_primary_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_boolean_list",sl_g_key_file_set_boolean_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_basic",sl_g_variant_type_is_basic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_type",sl_gtk_stack_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_new",sl_gtk_print_settings_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_tabs",sl_gtk_entry_get_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_bottom_margin",sl_gtk_text_view_set_bottom_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_tool_button_new_from_stock",sl_gtk_toggle_tool_button_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_compare",sl_g_variant_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_widget_new_for_manager",sl_gtk_recent_chooser_widget_new_for_manager,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_realize",sl_gdk_gl_context_realize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_begin_with_coordinates",sl_gtk_drag_begin_with_coordinates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_check_connect_result",sl_g_socket_check_connect_result,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_font_options",sl_gtk_widget_set_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_julian",sl_g_date_get_julian,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_scrollable",sl_gtk_notebook_get_scrollable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_button",sl_gtk_gesture_single_get_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_int64",sl_g_value_set_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_remove_key",sl_g_key_file_remove_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_show_uri_on_window",sl_gtk_show_uri_on_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_is_dst",sl_g_time_zone_is_dst,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_kinetic_scrolling",sl_gtk_scrolled_window_get_kinetic_scrolling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_get_title",sl_gtk_native_dialog_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_scroll_to_path",sl_gtk_icon_view_scroll_to_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_value_as_int",sl_gtk_spin_button_get_value_as_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_clear_attributes",sl_gtk_tree_view_column_clear_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_mount_enclosing_volume_finish",sl_g_file_mount_enclosing_volume_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_paste_target_list",sl_gtk_text_buffer_get_paste_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_monitor_get_type",sl_g_app_info_monitor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_set_visited",sl_gtk_link_button_set_visited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_startup_id",sl_gdk_window_set_startup_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_expand",sl_gtk_tool_item_get_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_remove_all",sl_gtk_combo_box_text_remove_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_show_icons",sl_gtk_recent_chooser_get_show_icons,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_add_poll",sl_g_main_context_add_poll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_get",sl_gdk_display_manager_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_activate",sl_gtk_menu_item_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_get_type",sl_pango_font_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_has_origin",sl_gtk_scale_get_has_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_new",sl_gtk_assistant_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_monitor_get",sl_g_app_info_monitor_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_get_model",sl_gtk_tree_model_filter_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_move_item",sl_g_bookmark_file_move_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_istitle",sl_g_unichar_istitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_send_notify",sl_gdk_selection_send_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_get_type",sl_gtk_link_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_authors",sl_gtk_about_dialog_set_authors,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_new_from_stock",sl_gtk_menu_tool_button_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_wm_function_get_type",sl_gdk_wm_function_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_parse_name",sl_g_file_get_parse_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_remove_shortcut_folder",sl_gtk_file_chooser_remove_shortcut_folder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_iter",sl_pango_layout_get_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_capabilities",sl_gtk_printer_get_capabilities,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_get_application",sl_gtk_builder_get_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_info_finish",sl_g_file_query_info_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_selection_mode",sl_gtk_flow_box_get_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_get_selected_rows",sl_gtk_tree_selection_get_selected_rows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_tabs",sl_pango_layout_get_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_type",sl_gtk_text_view_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_get_needed",sl_gtk_recent_filter_get_needed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_add_months",sl_g_date_add_months,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_lookup_by_gicon_for_scale",sl_gtk_icon_theme_lookup_by_gicon_for_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_complete",sl_gtk_entry_completion_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_delete_selection",sl_gtk_editable_delete_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_unref",sl_g_settings_schema_source_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_action",sl_gtk_file_chooser_get_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_prepend_page",sl_gtk_notebook_prepend_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_double",sl_g_value_set_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_tooltip_text",sl_gtk_tool_item_set_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_init_modules",sl_gdk_pixbuf_init_modules,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_append_search_path",sl_gtk_icon_theme_append_search_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_device_is_grabbed",sl_gdk_display_device_is_grabbed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_drag_target_item",sl_gtk_tool_palette_get_drag_target_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_right",sl_gtk_widget_set_margin_right,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_get_type",sl_g_app_launch_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_run",sl_gtk_native_dialog_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_type",sl_gdk_keymap_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_iter_is_valid",sl_gtk_list_store_iter_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_row_homogeneous",sl_gtk_grid_set_row_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_axes",sl_gdk_device_get_axes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_default_action",sl_g_notification_set_default_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_plus_button",sl_gtk_scale_button_get_plus_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_add_focus_sibling",sl_gtk_cell_area_add_focus_sibling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_schar",sl_g_value_get_schar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_site_local",sl_g_inet_address_get_is_site_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_license_type",sl_gtk_about_dialog_get_license_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_get_center_widget",sl_gtk_box_get_center_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_param",sl_g_value_get_param,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_get_parent_shell",sl_gtk_menu_shell_get_parent_shell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_keycode",sl_gdk_event_get_keycode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_lookup_data",sl_g_resources_lookup_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_get_type",sl_pango_tab_array_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_set_device",sl_gdk_event_set_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_child_value",sl_g_variant_get_child_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_sort_indicator",sl_gtk_tree_view_column_get_sort_indicator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_siblings",sl_gtk_widget_path_iter_get_siblings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_paper_size",sl_gtk_print_settings_get_paper_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_focus_vadjustment",sl_gtk_container_set_focus_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_is_cursor_position",sl_gtk_text_iter_is_cursor_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_tool_get_hardware_id",sl_gdk_device_tool_get_hardware_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_push_current",sl_g_cancellable_push_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_get_display_arg_name",sl_gdk_get_display_arg_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get",sl_gdk_event_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_special_dir",sl_g_get_user_special_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_error_quark",sl_g_resolver_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_printer",sl_gtk_print_job_get_printer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_sort_column_id",sl_gtk_tree_view_column_get_sort_column_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_get_label_widget",sl_gtk_frame_get_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_launch_failed",sl_g_app_launch_context_launch_failed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_range_check",sl_g_settings_schema_key_range_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_row_homogeneous",sl_gtk_grid_get_row_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_boolean",sl_g_key_file_set_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strdup",sl_g_strdup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_new",sl_gtk_file_filter_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_icon_get_file",sl_g_file_icon_get_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_is_destroyed",sl_gdk_window_is_destroyed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_selection",sl_gtk_tree_view_get_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_manager_list_devices",sl_gdk_device_manager_list_devices,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_local_only",sl_gtk_recent_chooser_get_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_child",sl_g_file_get_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_history_start",sl_gdk_frame_clock_get_history_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_new_from_gvariant",sl_gtk_file_filter_new_from_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_new",sl_g_bookmark_file_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_bytestring_array",sl_g_variant_new_bytestring_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_depth",sl_gdk_visual_get_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_ref",sl_g_file_attribute_info_list_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_to_file",sl_gtk_page_setup_to_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_relief",sl_gtk_button_set_relief,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_vhomogeneous",sl_gtk_stack_get_vhomogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_menu_label",sl_gtk_notebook_get_menu_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_mapped",sl_gtk_widget_get_mapped,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_new",sl_gtk_header_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_new_from_gvariant",sl_gtk_print_settings_new_from_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_selected_row",sl_gtk_list_box_get_selected_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_unmount_with_operation_finish",sl_g_mount_unmount_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_tooltip_window",sl_gtk_widget_set_tooltip_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_height",sl_gdk_window_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_remove_accel_group",sl_gtk_window_remove_accel_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_input_hints",sl_gtk_entry_set_input_hints,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_get_show_dialog_item",sl_gtk_app_chooser_button_get_show_dialog_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_default_page_setup",sl_gtk_print_operation_set_default_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_uint64",sl_g_file_info_set_attribute_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_dialog_get_type",sl_gtk_font_chooser_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_switcher_new",sl_gtk_stack_switcher_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_select_multiple",sl_gtk_recent_chooser_set_select_multiple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mkdtemp",sl_g_mkdtemp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_has_cr_or_lf",sl_g_regex_get_has_cr_or_lf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_uint64",sl_g_settings_get_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_section",sl_g_menu_item_set_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drop_finish",sl_gdk_drop_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_show_all",sl_gtk_app_chooser_widget_get_show_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_clip",sl_gtk_widget_set_clip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_to_end",sl_gtk_text_iter_forward_to_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_run_readonly",sl_pango_layout_iter_get_run_readonly,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_offscreen_window_get_surface",sl_gtk_offscreen_window_get_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_value",sl_g_key_file_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_scroll_mark_onscreen",sl_gtk_text_view_scroll_mark_onscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_bottom_margin",sl_gtk_page_setup_get_bottom_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_kinetic_scrolling",sl_gtk_scrolled_window_set_kinetic_scrolling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_reorder_child",sl_gtk_notebook_reorder_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_scale_factor",sl_gdk_screen_get_monitor_scale_factor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_set_padding",sl_gtk_cell_renderer_set_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attribute_copy",sl_pango_attribute_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_random_double",sl_g_random_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_type",sl_gtk_tool_item_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attributes_finish",sl_g_file_set_attributes_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_label",sl_gtk_tool_button_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_support_selection",sl_gtk_print_operation_set_support_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_reset",sl_g_timer_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_get_type",sl_gtk_mount_operation_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_get_bin_window",sl_gtk_layout_get_bin_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_instance_is_fundamentally_a",sl_g_type_check_instance_is_fundamentally_a,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_set_icon_gicon",sl_gtk_drag_source_set_icon_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_set_arrow_tooltip_markup",sl_gtk_menu_tool_button_set_arrow_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_unset_model_drag_dest",sl_gtk_icon_view_unset_model_drag_dest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_flush",sl_g_io_channel_flush,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_columns_autosize",sl_gtk_tree_view_columns_autosize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_alignment",sl_gtk_cell_renderer_get_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_active_window",sl_gtk_application_get_active_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_from_timeval_utc",sl_g_date_time_new_from_timeval_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_owner_change_get_type",sl_gdk_owner_change_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_match_simple",sl_g_regex_match_simple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_get_type",sl_gtk_buildable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_active",sl_gtk_combo_box_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_line_count",sl_gtk_text_buffer_get_line_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_dup_variant",sl_g_value_dup_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_printer",sl_gtk_print_settings_get_printer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_broadcast",sl_g_socket_get_broadcast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_pointer",sl_gdk_seat_get_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_join_multicast_group",sl_g_socket_join_multicast_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_compose",sl_g_unichar_compose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_get_layout",sl_gtk_button_box_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_list_shortcut_folder_uris",sl_gtk_file_chooser_list_shortcut_folder_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_scrollable",sl_gtk_notebook_set_scrollable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_equal",sl_pango_font_description_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_unset_style",sl_gtk_toolbar_unset_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_set_radio",sl_gtk_cell_renderer_toggle_set_radio,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_get_display",sl_g_app_launch_context_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mkstemp_full",sl_g_mkstemp_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_action_widget",sl_gtk_notebook_get_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_error",sl_gtk_gl_area_get_error,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_prepend_submenu",sl_g_menu_prepend_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_new",sl_gtk_places_sidebar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_can_unmount",sl_g_mount_can_unmount,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_children_with_user_data",sl_gdk_window_get_children_with_user_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_iteration",sl_g_main_context_iteration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_up",sl_gtk_tree_path_up,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_enable_tree_lines",sl_gtk_tree_view_get_enable_tree_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_new",sl_gtk_label_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_composited",sl_gdk_window_set_composited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_destroy",sl_g_source_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_formats",sl_gdk_pixbuf_get_formats,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_remove_page",sl_gtk_assistant_remove_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_focus_child",sl_gtk_container_set_focus_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_insert_action_group",sl_gtk_widget_insert_action_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_new_from_file",sl_gtk_page_setup_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_copy",sl_gtk_text_attributes_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_uint32",sl_g_file_set_attribute_uint32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_free",sl_g_rand_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_set_heading",sl_gtk_app_chooser_button_set_heading,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_sidebar_set_stack",sl_gtk_stack_sidebar_set_stack,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_take_param",sl_g_value_take_param,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_auto_dir",sl_pango_layout_set_auto_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_get_overlay_pass_through",sl_gtk_overlay_get_overlay_pass_through,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_frame_gap",sl_gtk_render_frame_gap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_text_new",sl_gtk_cell_renderer_text_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_unselect_all",sl_gtk_icon_view_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_init_check",sl_gdk_init_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_unref",sl_g_resource_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_monospace",sl_gtk_text_view_get_monospace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_default_for_type",sl_g_app_info_get_default_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_type_hint",sl_gdk_window_set_type_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_construct_child",sl_gtk_buildable_construct_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_set_display_options",sl_gtk_calendar_set_display_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_expander_column",sl_gtk_tree_view_set_expander_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_show_text",sl_gtk_progress_bar_set_show_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_add_class",sl_gtk_widget_path_iter_add_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_sensitive",sl_gtk_entry_get_icon_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_unref",sl_g_hmac_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_load",sl_gtk_accel_map_load,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_lookup_icon",sl_gtk_icon_theme_lookup_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_context",sl_g_source_get_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_label",sl_gtk_tool_button_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new_with_model",sl_gtk_combo_box_new_with_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_password_save",sl_g_mount_operation_get_password_save,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_type",sl_gtk_style_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_app_info",sl_g_bookmark_file_set_app_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_new_with_model",sl_gtk_icon_view_new_with_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_remove_all",sl_gtk_selection_remove_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_quark_from_static_string",sl_g_quark_from_static_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_depth",sl_g_main_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_append_text",sl_gtk_combo_box_text_append_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_to_gvariant",sl_gtk_paper_size_to_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_status",sl_gdk_drag_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_new",sl_gtk_size_group_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_value",sl_g_settings_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_get",sl_gtk_accel_map_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_maximize",sl_gtk_window_maximize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_propagate_key_event",sl_gtk_window_propagate_key_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_backward_display_line",sl_gtk_text_view_backward_display_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_get_parent",sl_gtk_mount_operation_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_begin_from_point",sl_gdk_drag_begin_from_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_set_vadjustment",sl_gtk_scrollable_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_deselect",sl_gtk_menu_shell_deselect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_deleted",sl_gtk_tree_row_reference_deleted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_parent",sl_gtk_widget_set_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_get_scripts",sl_pango_language_get_scripts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_description",sl_gtk_recent_info_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_new_with_pixbuf",sl_gtk_cell_view_new_with_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_left",sl_gtk_widget_get_margin_left,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_family_is_monospace",sl_pango_font_family_is_monospace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_icon",sl_g_file_info_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyboard_ungrab",sl_gdk_keyboard_ungrab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_insert",sl_g_menu_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_local_only",sl_gtk_file_chooser_get_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_unref",sl_gtk_target_list_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_copy",sl_pango_layout_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_invalidate_region",sl_gdk_window_invalidate_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_set_inconsistent",sl_gtk_check_menu_item_set_inconsistent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_prepend_index",sl_gtk_tree_path_prepend_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_bind_writable",sl_g_settings_bind_writable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_height",sl_pango_layout_set_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_bin_window",sl_gtk_viewport_get_bin_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyboard_grab",sl_gdk_keyboard_grab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_keyboard_ungrab",sl_gdk_display_keyboard_ungrab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_insert",sl_gtk_menu_shell_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_identifier",sl_g_drive_get_identifier,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_gicon",sl_gtk_entry_get_icon_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_get_type",sl_gtk_editable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_to_string",sl_g_inet_address_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hostname_to_ascii",sl_g_hostname_to_ascii,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_current_path_string",sl_gtk_cell_area_get_current_path_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_get_type",sl_pango_language_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_lookup_icon_set",sl_gtk_style_context_lookup_icon_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_defer_drawing",sl_gtk_print_operation_set_defer_drawing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_cursor",sl_gtk_icon_view_set_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_next_page",sl_gtk_notebook_next_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_display_name",sl_g_file_info_set_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_label_widget",sl_gtk_tool_button_set_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_visible",sl_gtk_text_mark_get_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_spin",sl_gtk_spin_button_spin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_set_page_setup",sl_gtk_page_setup_unix_dialog_set_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_toolbar_style",sl_gtk_tool_item_get_toolbar_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_get_address",sl_g_inet_address_mask_get_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_remove_window",sl_gtk_application_remove_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_error_quark",sl_gdk_gl_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_file",sl_gtk_file_chooser_get_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_modification_date_time",sl_g_file_info_get_modification_date_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_screen",sl_gtk_window_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_baseline",sl_pango_layout_iter_get_baseline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_int32",sl_g_file_info_set_attribute_int32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_day_of_year",sl_g_date_get_day_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dpgettext",sl_g_dpgettext,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_visible_child_name",sl_gtk_stack_set_visible_child_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_long",sl_g_value_get_long,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_visible_child",sl_gtk_stack_get_visible_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_get_target_list",sl_gtk_drag_source_get_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_colorspace",sl_gdk_pixbuf_get_colorspace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_hide",sl_gdk_window_hide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_constrain_to",sl_gtk_popover_set_constrain_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_init",sl_g_variant_builder_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best_with_depth",sl_gdk_visual_get_best_with_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblem_get_type",sl_g_emblem_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_scale",sl_gtk_print_job_set_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_set_selectable",sl_gtk_list_box_row_set_selectable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_set_mode",sl_gdk_device_set_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_error_quark",sl_g_file_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_get_type",sl_gtk_toggle_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_alignment",sl_gtk_tree_view_column_set_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_focus_cell",sl_gtk_cell_area_get_focus_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_choose_icon_for_scale",sl_gtk_icon_theme_choose_icon_for_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute",sl_g_file_set_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_set_debug_enabled",sl_gdk_gl_context_set_debug_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_has_tooltip",sl_gtk_widget_get_has_tooltip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_bottom_margin",sl_gtk_page_setup_set_bottom_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_get_match_count",sl_g_match_info_get_match_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_range",sl_g_settings_get_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_map_remove_action",sl_g_action_map_remove_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_selection_bounds",sl_gtk_label_get_selection_bounds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_error_quark",sl_g_bookmark_file_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_new",sl_g_inet_socket_address_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_unselect_path",sl_gtk_tree_selection_unselect_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_make_valid",sl_g_utf8_make_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_fallback_new",sl_pango_attr_fallback_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_value_type",sl_g_settings_schema_key_get_value_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_maybe",sl_g_variant_type_is_maybe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_motion_new",sl_gtk_event_controller_motion_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_remove_accelerator",sl_gtk_application_remove_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_cell_get_size",sl_gtk_tree_view_column_cell_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_progress_fraction",sl_gtk_entry_get_progress_fraction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_class_get_private",sl_g_type_class_get_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_new_from_string",sl_gtk_tree_path_new_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_casefold",sl_g_utf8_casefold,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_get_type",sl_g_settings_backend_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_type",sl_g_mount_operation_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_depth",sl_g_type_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_gravity_new",sl_pango_attr_gravity_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_resource",sl_gtk_image_set_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_mark_day",sl_gtk_calendar_mark_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_offscreen_window_get_pixbuf",sl_gtk_offscreen_window_get_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_long_press_new",sl_gtk_gesture_long_press_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_icon",sl_g_menu_item_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_launch_uris",sl_g_app_info_launch_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_set_resolution",sl_pango_cairo_font_map_set_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_menu_model",sl_gtk_menu_button_get_menu_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_resize_drag_for_device",sl_gdk_window_begin_resize_drag_for_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_send_focus_change",sl_gtk_widget_send_focus_change,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_visual",sl_gdk_window_get_visual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_byte_order_get_type",sl_gdk_byte_order_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_allocated_width",sl_gtk_widget_get_allocated_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_get_group_n_modes",sl_gdk_device_pad_get_group_n_modes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_get_type",sl_gtk_app_chooser_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_get_type",sl_gtk_text_attributes_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_unlock_path",sl_gtk_accel_map_unlock_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_ttl",sl_g_socket_set_ttl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_flush",sl_gdk_display_flush,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_label",sl_gtk_expander_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_weight",sl_pango_font_description_set_weight,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_preview_widget",sl_gtk_file_chooser_get_preview_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_double_with_default",sl_gtk_print_settings_get_double_with_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_glyph",sl_pango_renderer_draw_glyph,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_letter_spacing_new",sl_pango_attr_letter_spacing_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_objv",sl_g_variant_new_objv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_cursor_visible",sl_gtk_text_view_get_cursor_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_grab_ownership_get_type",sl_gdk_grab_ownership_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_new",sl_gtk_action_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_copy",sl_pango_coverage_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_type",sl_gdk_display_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_new_for_uri",sl_g_file_new_for_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_set_style",sl_gtk_toolbar_set_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_indent",sl_gtk_text_view_get_indent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_buffer_to_window_coords",sl_gtk_text_view_buffer_to_window_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_recommended_for_type",sl_g_app_info_get_recommended_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_foreground_new",sl_pango_attr_foreground_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_push_thread_default",sl_g_main_context_push_thread_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_choice",sl_gtk_file_chooser_get_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_anonymous",sl_g_mount_operation_get_anonymous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_type",sl_gtk_flow_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_next_page",sl_gtk_assistant_next_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_new_with_entry",sl_gtk_combo_box_text_new_with_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_iconv",sl_g_iconv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_symbolic",sl_gtk_icon_info_load_symbolic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_render_icon_pixbuf",sl_gtk_widget_render_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_entry",sl_gtk_entry_completion_get_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_new_from_icon_name",sl_gtk_button_new_from_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_new",sl_g_checksum_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_equal",sl_g_inet_address_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_expander_column",sl_gtk_tree_view_get_expander_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_get_data",sl_gtk_drag_get_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_withdraw",sl_gdk_window_withdraw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_set_active_custom_item",sl_gtk_app_chooser_button_set_active_custom_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_view_window",sl_gtk_viewport_get_view_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_child2",sl_gtk_paned_get_child2,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_set_min_value",sl_gtk_level_bar_set_min_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_unset_invisible_char",sl_gtk_entry_unset_invisible_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_activate",sl_gtk_cell_area_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_can_start_degraded",sl_g_drive_can_start_degraded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_custom_tab_label",sl_gtk_print_operation_set_custom_tab_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_events",sl_gtk_widget_get_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_uint",sl_g_value_get_uint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_tooltip_cell",sl_gtk_tree_view_set_tooltip_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_append_custom_item",sl_gtk_app_chooser_button_append_custom_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_map_add_action",sl_g_action_map_add_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_unref",sl_g_io_channel_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_display",sl_gtk_clipboard_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new",sl_gdk_pixbuf_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_compare",sl_gtk_text_iter_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_insert_text",sl_gtk_editable_insert_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_set_digits",sl_gtk_scale_set_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_is_private",sl_g_bookmark_file_set_is_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_remove_class",sl_gtk_widget_path_iter_remove_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_locale_direction",sl_gtk_get_locale_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_copy_values",sl_gtk_text_attributes_copy_values,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_new",sl_gtk_accel_group_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_columns",sl_gtk_icon_view_set_columns,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_toggle_size_allocate",sl_gtk_menu_item_toggle_size_allocate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_show_not_found",sl_gtk_recent_chooser_set_show_not_found,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drawing_area_new",sl_gtk_drawing_area_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_event_widget",sl_gtk_get_event_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_widget",sl_gtk_drag_set_icon_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_add_image_targets",sl_gtk_drag_source_add_image_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_text",sl_gtk_label_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_wrap_license",sl_gtk_about_dialog_set_wrap_license,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_get_id",sl_gtk_application_window_get_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_copy",sl_gtk_widget_path_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_next",sl_gtk_tree_model_iter_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_zlib_decompressor_get_file_info",sl_g_zlib_decompressor_get_file_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_event_compression",sl_gdk_window_set_event_compression,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_get_abbreviation",sl_g_time_zone_get_abbreviation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_export_filename",sl_gtk_print_operation_set_export_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_attributes",sl_gtk_text_iter_get_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_has_cursor",sl_gdk_device_get_has_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_reload_user_special_dirs_cache",sl_g_reload_user_special_dirs_cache,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_year",sl_g_date_get_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_join_multicast_group_ssm",sl_g_socket_join_multicast_group_ssm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_get_attributes",sl_pango_attr_list_get_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_init_from_instance",sl_g_value_init_from_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_tooltip_column",sl_gtk_icon_view_get_tooltip_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_file_at_size",sl_gdk_pixbuf_new_from_file_at_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_request_mode",sl_gtk_cell_renderer_get_request_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_display",sl_gdk_gl_context_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_new",sl_gtk_separator_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_ensure",sl_g_type_ensure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_manufacturer",sl_gdk_monitor_get_manufacturer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_timezone_abbreviation",sl_g_date_time_get_timezone_abbreviation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_numeric",sl_gtk_spin_button_set_numeric,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_cancel_reason_get_type",sl_gdk_drag_cancel_reason_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_ref",sl_g_mapped_file_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_enumerate_namespace",sl_g_file_attribute_matcher_enumerate_namespace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_cursor",sl_gdk_window_get_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_peek_pointer",sl_g_value_peek_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_set_action_name",sl_gtk_actionable_set_action_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_active_window",sl_gdk_screen_get_active_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_sort_column_id",sl_gtk_tree_view_column_set_sort_column_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_set_transient_for",sl_gtk_native_dialog_set_transient_for,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_get_type",sl_g_inet_socket_address_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_free",sl_gdk_event_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_expand",sl_gtk_tree_view_column_set_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_device_position_double",sl_gdk_window_get_device_position_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_index_to_x",sl_pango_layout_line_index_to_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_supported_types",sl_g_app_info_get_supported_types,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_queue_render",sl_gtk_gl_area_queue_render,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_name",sl_gtk_paper_size_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_offset_value",sl_gtk_level_bar_get_offset_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_get_type",sl_gdk_pixbuf_loader_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_line_readonly",sl_pango_layout_iter_get_line_readonly,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rgba_hash",sl_gdk_rgba_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_add_builtin_icon",sl_gtk_icon_theme_add_builtin_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_move_after",sl_gtk_tree_store_move_after,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_column_span_column",sl_gtk_combo_box_get_column_span_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_new",sl_gtk_text_view_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_sentence_starts",sl_gtk_text_iter_backward_sentence_starts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new_from_gvariant",sl_gtk_paper_size_new_from_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_type",sl_gtk_print_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_icon",sl_gtk_render_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unicode_script_to_iso15924",sl_g_unicode_script_to_iso15924,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_get_size",sl_gtk_text_tag_table_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_poll",sl_g_poll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_can_eject",sl_g_volume_can_eject,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_events_get_center",sl_gdk_events_get_center,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_entry_get_type",sl_gtk_target_entry_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_page_height",sl_gtk_page_setup_get_page_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_type_transformable",sl_g_value_type_transformable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_new",sl_gtk_text_buffer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_new_stateful",sl_g_simple_action_new_stateful,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_uint64",sl_g_value_get_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_version",sl_gtk_check_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_label",sl_gtk_notebook_get_tab_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_desktop",sl_gtk_places_sidebar_set_show_desktop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_has_group",sl_g_key_file_has_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_swipe_get_type",sl_gtk_gesture_swipe_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_valid",sl_gtk_accelerator_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_is_leap_year",sl_g_date_is_leap_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_format_iso8601",sl_g_date_time_format_iso8601,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_use_stock",sl_gtk_button_set_use_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_object",sl_g_file_info_get_attribute_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_show_close_button",sl_gtk_header_bar_get_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_unset_rows_drag_dest",sl_gtk_tree_view_unset_rows_drag_dest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_is_static_image",sl_gdk_pixbuf_animation_is_static_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_create_layout",sl_pango_cairo_create_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_enable_model_drag_source",sl_gtk_tree_view_enable_model_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_hexpand",sl_gtk_widget_get_hexpand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_status",sl_g_file_info_set_attribute_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_enum_to_string",sl_g_enum_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_realized",sl_gtk_widget_get_realized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bytes_icon_get_type",sl_g_bytes_icon_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strdown",sl_g_ascii_strdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_new_from_model",sl_gtk_popover_new_from_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_current_source",sl_g_main_current_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_list_shortcuts",sl_gtk_places_sidebar_list_shortcuts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_clear",sl_gtk_cell_layout_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_get_heading",sl_gtk_app_chooser_dialog_get_heading,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_class_add_private",sl_g_type_class_add_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_gravity_to_rotation",sl_pango_gravity_to_rotation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_vexpand_set",sl_gtk_widget_get_vexpand_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_handle_event",sl_gtk_event_controller_handle_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_n_pages",sl_gtk_print_operation_set_n_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_add_credit_section",sl_gtk_about_dialog_add_credit_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_activate",sl_gtk_cell_renderer_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_new_with_seed",sl_g_rand_new_with_seed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_tool_button_set_active",sl_gtk_toggle_tool_button_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_pango_fontmap",sl_gtk_print_context_get_pango_fontmap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_width_for_height",sl_gtk_widget_get_preferred_width_for_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_get_type",sl_gtk_statusbar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_new",sl_gtk_print_unix_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_clipboard",sl_gtk_widget_get_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_dup_param",sl_g_value_dup_param,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_get_spacing",sl_gtk_cell_area_box_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_width_mm",sl_gdk_monitor_get_width_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_entry_text_column",sl_gtk_combo_box_get_entry_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_font_options",sl_gtk_widget_get_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_background",sl_gdk_window_set_background,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_has_group",sl_g_bookmark_file_has_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_layout",sl_gtk_scale_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_single_line_mode",sl_gtk_label_set_single_line_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_stop_emission_by_name",sl_g_signal_stop_emission_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_iter_on_currently_loading_frame",sl_gdk_pixbuf_animation_iter_on_currently_loading_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_priority",sl_g_source_get_priority,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_add_frame",sl_gdk_pixbuf_simple_anim_add_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_end_position",sl_gtk_css_section_get_end_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_remove_application",sl_g_bookmark_file_remove_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_load_from_data",sl_g_bookmark_file_load_from_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_set_render_icon_surface",sl_gtk_icon_set_render_icon_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_can_insert",sl_gtk_text_iter_can_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_keep_below",sl_gtk_window_set_keep_below,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_no_show_all",sl_gtk_widget_set_no_show_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_relief_style",sl_gtk_toolbar_get_relief_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_menu_label",sl_gtk_notebook_set_menu_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_protocol",sl_g_socket_get_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_widget_get_type",sl_gtk_recent_chooser_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_is_a",sl_g_content_type_is_a,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_set_default",sl_pango_cairo_font_map_set_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_new",sl_gtk_window_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_contents",sl_gtk_clipboard_wait_for_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_gravity_hint",sl_pango_context_set_gravity_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_set_use_alpha",sl_gtk_color_button_set_use_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_ref",sl_g_date_time_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_type",sl_g_socket_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_scroll_to_mark",sl_gtk_text_view_scroll_to_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_begin_move_drag",sl_gtk_window_begin_move_drag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_page_width",sl_gtk_page_setup_get_page_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_new_with_rgba",sl_gtk_color_button_new_with_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_size",sl_pango_layout_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_use_es",sl_gtk_gl_area_set_use_es,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_trigger_tooltip_query",sl_gtk_widget_trigger_tooltip_query,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_remove",sl_g_param_spec_pool_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_type",sl_gtk_range_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_job_count",sl_gtk_printer_get_job_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_flags",sl_g_io_channel_get_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_real_name",sl_g_get_real_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_load_from_data",sl_g_key_file_load_from_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_unset_style",sl_gtk_tool_palette_unset_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_hover_selection",sl_gtk_tree_view_set_hover_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_parent",sl_gtk_style_context_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_underline_thickness",sl_pango_font_metrics_get_underline_thickness,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_resize_mode",sl_gtk_container_set_resize_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_type",sl_gtk_text_mark_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_int64",sl_g_key_file_get_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_is_start",sl_gtk_text_iter_is_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_keys_changed",sl_g_settings_backend_keys_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_draw",sl_gtk_widget_draw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_overlay_scrolling",sl_gtk_scrolled_window_set_overlay_scrolling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_show_tips",sl_gtk_recent_chooser_set_show_tips,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_append",sl_g_menu_append,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_path_get_dirname",sl_g_path_get_dirname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_forward_compatible",sl_gdk_gl_context_get_forward_compatible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_wrap",sl_gtk_spin_button_get_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_height",sl_gdk_screen_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mkstemp",sl_g_mkstemp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_icon_from_file",sl_gtk_window_set_default_icon_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_size_is_absolute",sl_pango_font_description_get_size_is_absolute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dir_close",sl_g_dir_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_int",sl_gtk_print_settings_get_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_convert_error_quark",sl_g_convert_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_rotate",sl_gtk_print_job_get_rotate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_name",sl_g_file_info_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dpgettext2",sl_g_dpgettext2,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_cursor_color",sl_gdk_display_supports_cursor_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_list_regions",sl_gtk_style_context_list_regions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_display_name",sl_g_app_info_get_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_editable_editing_done",sl_gtk_cell_editable_editing_done,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_setv",sl_g_object_setv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_changed",sl_gtk_adjustment_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_get_type",sl_g_simple_action_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_pack_end",sl_gtk_cell_area_box_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_next_run",sl_pango_layout_iter_next_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_default_top_margin",sl_gtk_paper_size_get_default_top_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new",sl_g_date_time_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_layout_index_to_text_index",sl_gtk_entry_layout_index_to_text_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_int64",sl_g_variant_new_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_scroll_to_cell",sl_gtk_tree_view_scroll_to_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_get_type",sl_gtk_size_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_lookup_value",sl_g_variant_lookup_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_markup_with_accel",sl_pango_layout_set_markup_with_accel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_clear_classes",sl_gtk_widget_path_iter_clear_classes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_move_column_after",sl_gtk_tree_view_move_column_after,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_hadjustment",sl_gtk_tree_view_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_normal_form",sl_g_variant_is_normal_form,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_interface_add_prerequisite",sl_g_type_interface_add_prerequisite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_editable_remove_widget",sl_gtk_cell_editable_remove_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_toggled",sl_gtk_toggle_button_toggled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_preview_text",sl_gtk_font_chooser_set_preview_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_password",sl_g_mount_operation_get_password,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_subpixel_layout_get_type",sl_gdk_subpixel_layout_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_layout_line",sl_pango_renderer_draw_layout_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_insert_prefix",sl_gtk_entry_completion_insert_prefix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_set_application_name",sl_g_set_application_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_filter",sl_gtk_file_chooser_get_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_insert",sl_gtk_toolbar_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_prepend_name",sl_g_themed_icon_prepend_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_week_of_year",sl_g_date_time_get_week_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_add_weak_pointer",sl_g_object_add_weak_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_load_from_resource",sl_gtk_css_provider_load_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_is_lower",sl_gdk_keyval_is_lower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_set_group",sl_gtk_radio_tool_button_set_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_columns",sl_gtk_icon_view_get_columns,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace_finish",sl_g_file_replace_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_compute_hmac_for_data",sl_g_compute_hmac_for_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_line",sl_gtk_text_buffer_get_iter_at_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_get_type",sl_g_object_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_region_intersect",sl_gtk_widget_region_intersect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_type_get_type",sl_gdk_window_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_draw_sensitive",sl_gtk_cell_view_get_draw_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_list_keys",sl_g_settings_schema_list_keys,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_checked_",sl_g_variant_type_checked_,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_get_modifier_mask",sl_gtk_accel_group_get_modifier_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_day",sl_g_date_valid_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_draw_region",sl_gtk_widget_queue_draw_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_compute_hmac_for_string",sl_g_compute_hmac_for_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_can_mount",sl_g_volume_can_mount,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_get_activatable",sl_gtk_list_box_row_get_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_rotate_get_angle_delta",sl_gtk_gesture_rotate_get_angle_delta,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_supports_thread_contexts",sl_g_file_supports_thread_contexts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_get_widget",sl_gtk_app_chooser_dialog_get_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_equal",sl_g_file_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_new_with_context",sl_gtk_cell_view_new_with_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_raise",sl_gdk_window_raise,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_type_hint",sl_gdk_window_get_type_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_sync",sl_gdk_display_sync,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_name",sl_g_signal_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attribute_destroy",sl_pango_attribute_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_prepend",sl_gtk_menu_shell_prepend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_n_items",sl_gtk_toolbar_get_n_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_byte_string",sl_g_file_info_set_attribute_byte_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_expose_object",sl_gtk_builder_expose_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_clear_pending",sl_g_input_stream_clear_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_is_image_available",sl_gtk_clipboard_wait_is_image_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_exists",sl_gtk_recent_info_exists,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_toggled",sl_gtk_check_menu_item_toggled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_choice",sl_g_mount_operation_set_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dir_open",sl_g_dir_open,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_unselect_iter",sl_gtk_tree_selection_unselect_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_get_default",sl_gtk_icon_theme_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_type",sl_gtk_print_operation_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_bin_get_type",sl_gtk_bin_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_default_text",sl_gtk_app_chooser_widget_get_default_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_row_activated",sl_gtk_tree_view_row_activated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_is_writable",sl_gdk_pixbuf_format_is_writable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_set_draw_value",sl_gtk_scale_set_draw_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcuts_group_get_type",sl_gtk_shortcuts_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_popdown",sl_gtk_menu_popdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_values_cmp",sl_g_param_values_cmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_double",sl_g_rand_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_override_background_color",sl_gtk_widget_override_background_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_deiconify",sl_gdk_window_deiconify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_ttl",sl_g_socket_get_ttl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_status_get_type",sl_gdk_status_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_prepend_section",sl_g_menu_prepend_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_resource_at_scale",sl_gdk_pixbuf_new_from_resource_at_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_no_show_all",sl_gtk_widget_get_no_show_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_locale_for_key",sl_g_key_file_get_locale_for_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strsplit_set",sl_g_strsplit_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_close",sl_g_variant_builder_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_pack_start",sl_gtk_tree_view_column_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_starred_location",sl_gtk_places_sidebar_get_show_starred_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_modified",sl_gtk_recent_info_get_modified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_label_widget",sl_gtk_expander_set_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_get_message_area",sl_gtk_message_dialog_get_message_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_close_on_unref",sl_g_io_channel_get_close_on_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_proxy_menu_item",sl_gtk_tool_item_get_proxy_menu_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_tearoff_state",sl_gtk_menu_get_tearoff_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_device_cursor",sl_gdk_window_get_device_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strerror",sl_g_strerror,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_new_with_backend_and_path",sl_g_settings_new_with_backend_and_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_effective_toplevel",sl_gdk_window_get_effective_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_get_id",sl_g_settings_schema_get_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_max_width",sl_gtk_tree_view_column_set_max_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_show_preview_entry",sl_gtk_font_chooser_get_show_preview_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_get_label_align",sl_gtk_frame_get_label_align,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_finishings",sl_gtk_print_settings_get_finishings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_activate",sl_gtk_accel_group_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_register_window",sl_gtk_widget_register_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_set_state",sl_gtk_switch_set_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_type",sl_g_file_info_get_attribute_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_freeze_notify",sl_g_object_freeze_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_pixels_inside_wrap",sl_gtk_text_view_get_pixels_inside_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_iter_get_type",sl_gtk_tree_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_focus_cell",sl_gtk_tree_view_column_focus_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_insert_hyphens_new",sl_pango_attr_insert_hyphens_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_mime_type",sl_g_bookmark_file_set_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_show_hidden",sl_gtk_file_chooser_get_show_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strlcat",sl_g_strlcat,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_get_type",sl_gtk_accel_map_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_new_loopback",sl_g_inet_address_new_loopback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_refresh_interval",sl_gdk_frame_timings_get_refresh_interval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_event",sl_gtk_widget_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_language",sl_gtk_font_chooser_get_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_new",sl_pango_font_description_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_progress_pulse_step",sl_gtk_entry_set_progress_pulse_step,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_new",sl_gtk_scale_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_get_selection",sl_gdk_drag_get_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_show",sl_gtk_native_dialog_show,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drop_reply",sl_gdk_drop_reply,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_range_interactive",sl_gtk_text_buffer_insert_range_interactive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_ref",sl_g_main_loop_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_wrap_license",sl_gtk_about_dialog_get_wrap_license,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_can_focus",sl_gtk_widget_get_can_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_transition_type",sl_gtk_stack_set_transition_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_new_with_properties",sl_g_object_new_with_properties,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_type",sl_g_drive_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isxdigit",sl_g_unichar_isxdigit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_activate",sl_g_action_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_iswide_cjk",sl_g_unichar_iswide_cjk,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_new",sl_g_simple_action_group_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_get_vadjustment",sl_gtk_layout_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_tabs",sl_gtk_text_view_get_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_eject_mountable_with_operation_finish",sl_g_file_eject_mountable_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_completion",sl_gtk_entry_set_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_get_show_menubar",sl_gtk_application_window_get_show_menubar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_type",sl_gtk_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_wakeup",sl_g_main_context_wakeup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_get_thread_default",sl_g_main_context_get_thread_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_take_string",sl_g_variant_new_take_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_new_from_string",sl_g_inet_socket_address_new_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcuts_window_get_type",sl_gtk_shortcuts_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new_with_label_from_widget",sl_gtk_radio_button_new_with_label_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_local",sl_g_date_time_new_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_get_default_mod_mask",sl_gtk_accelerator_get_default_mod_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_select_first",sl_gtk_menu_shell_select_first,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strv_contains",sl_g_strv_contains,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_variations",sl_pango_font_description_set_variations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_get_modal",sl_gtk_native_dialog_get_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_keep_below",sl_gdk_window_set_keep_below,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_get_type",sl_g_inet_address_mask_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_has_selection",sl_gtk_text_buffer_get_has_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_min_children_per_line",sl_gtk_flow_box_set_min_children_per_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_can_start",sl_g_drive_can_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_refresh_rate",sl_gdk_monitor_get_refresh_rate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_mount_finish",sl_g_volume_mount_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_debug_enabled",sl_gdk_gl_context_get_debug_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_peek_string",sl_g_variant_type_peek_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_short_name",sl_gtk_recent_info_get_short_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_offset_to_pointer",sl_g_utf8_offset_to_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_trash",sl_g_file_trash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_visible",sl_gtk_widget_is_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_description",sl_gdk_pixbuf_format_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_set_raw_coordinates",sl_gtk_icon_info_set_raw_coordinates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_round_digits",sl_gtk_range_set_round_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_flippable",sl_gtk_range_get_flippable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_matches",sl_g_match_info_matches,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_get_pixbuf",sl_gdk_pixbuf_loader_get_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_default_bottom_margin",sl_gtk_paper_size_get_default_bottom_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_value",sl_gtk_scale_button_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_stylus_new",sl_gtk_gesture_stylus_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_default_icon_list",sl_gtk_window_get_default_icon_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_activates_default",sl_gtk_entry_set_activates_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_prev_char",sl_g_utf8_prev_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_length",sl_gtk_print_settings_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_add_uri_targets",sl_gtk_drag_dest_add_uri_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_update_buttons_state",sl_gtk_assistant_update_buttons_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_role",sl_gdk_window_set_role,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_load_from_file",sl_gtk_css_provider_load_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_supports_uris",sl_g_app_info_supports_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_set_priority",sl_gtk_text_tag_set_priority,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_get_serial",sl_pango_font_map_get_serial,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_new",sl_gtk_list_store_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_title",sl_gtk_window_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_recent",sl_gtk_places_sidebar_set_show_recent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_face_describe",sl_pango_font_face_describe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_pointer",sl_g_value_set_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_get_string",sl_g_match_info_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_state_type",sl_g_action_get_state_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_select_uri",sl_gtk_recent_chooser_select_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_unset_fields",sl_pango_font_description_unset_fields,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_request_details",sl_gtk_printer_request_details,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_min_slider_size",sl_gtk_range_get_min_slider_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_mount_for_uuid",sl_g_volume_monitor_get_mount_for_uuid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_ungroup",sl_gtk_gesture_ungroup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_artists",sl_gtk_about_dialog_get_artists,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_delete",sl_g_file_delete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_slider_size_fixed",sl_gtk_range_get_slider_size_fixed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_instance_cast",sl_g_type_check_instance_cast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_tooltip_markup",sl_gtk_entry_get_icon_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_file",sl_gdk_pixbuf_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_unset_attribute_mask",sl_g_file_info_unset_attribute_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_get_content_type",sl_gtk_app_chooser_get_content_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_multi_press_set_area",sl_gtk_gesture_multi_press_set_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_blue_pixel_details",sl_gdk_visual_get_blue_pixel_details,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_add_filter",sl_gtk_accel_map_add_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_writable_namespaces",sl_g_file_query_writable_namespaces,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_move",sl_gtk_window_move,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_modal",sl_gtk_window_set_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_guess_content_type_finish",sl_g_mount_guess_content_type_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_left_margin",sl_gtk_text_view_get_left_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_input_shape_combine_region",sl_gdk_window_input_shape_combine_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_justification",sl_gtk_text_view_get_justification,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_output_bin",sl_gtk_print_settings_set_output_bin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_new_submenu",sl_g_menu_item_new_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_set_mode",sl_gtk_size_group_set_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_selected_printer",sl_gtk_print_unix_dialog_get_selected_printer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_search_entry",sl_gtk_tree_view_get_search_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_bounding_box_center",sl_gtk_gesture_get_bounding_box_center,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_pixbuf",sl_gtk_image_set_from_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_new_with_label",sl_gtk_menu_item_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_state_flags",sl_gtk_widget_get_state_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_justification",sl_gtk_text_view_set_justification,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_launch_default_for_uri_finish",sl_g_app_info_launch_default_for_uri_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_copy",sl_g_variant_type_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_homogeneous",sl_gtk_tool_item_get_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_add_resource_path",sl_gtk_icon_theme_add_resource_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_receive_with_blocking",sl_g_socket_receive_with_blocking,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_line_wrap",sl_gtk_label_set_line_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_modified",sl_g_bookmark_file_get_modified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_get_type",sl_gdk_pixbuf_animation_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_border_window_size",sl_gtk_text_view_set_border_window_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_get_type",sl_g_credentials_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_get_type",sl_gtk_file_filter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_max_width_chars",sl_gtk_label_set_max_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_read_link",sl_g_file_read_link,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_append_item",sl_g_menu_append_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_get_size",sl_gtk_layout_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_add1",sl_gtk_paned_add1,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_is_symlink",sl_g_file_info_get_is_symlink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_startup_id",sl_gtk_window_set_startup_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_request_phase",sl_gdk_frame_clock_request_phase,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_deletable",sl_gtk_window_get_deletable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_child_for_display_name",sl_g_file_get_child_for_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_new",sl_g_app_launch_context_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_ft2_font_map_new",sl_pango_ft2_font_map_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_set_image",sl_gtk_clipboard_set_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_tooltip_column",sl_gtk_icon_view_set_tooltip_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_get_type",sl_g_file_attribute_matcher_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_list_windows",sl_gtk_window_group_list_windows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_init",sl_g_io_channel_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_type_register",sl_pango_attr_type_register,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_append_to",sl_g_file_append_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_section",sl_gtk_style_context_get_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_move",sl_gdk_window_move,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_native_set_cancel_label",sl_gtk_file_chooser_native_set_cancel_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_focus_on_click",sl_gtk_combo_box_get_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_value_defaults",sl_g_param_value_defaults,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_stop_editing",sl_gtk_cell_renderer_stop_editing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_paper_size",sl_gtk_print_settings_set_paper_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_is_focus_sibling",sl_gtk_cell_area_is_focus_sibling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_proxy_resolver_new",sl_g_simple_proxy_resolver_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_visibility",sl_gtk_entry_set_visibility,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_get_index",sl_gtk_list_box_row_get_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_can_default",sl_gtk_widget_get_can_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_pass_through",sl_gdk_window_set_pass_through,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_charset_converter_get_num_fallbacks",sl_g_charset_converter_get_num_fallbacks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_collate",sl_gtk_print_job_set_collate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_title",sl_gtk_combo_box_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_parse",sl_g_network_address_parse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_is_writable",sl_g_settings_is_writable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_surface",sl_gtk_print_job_get_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drawing_area_get_type",sl_gtk_drawing_area_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_height_for_width",sl_gtk_widget_get_preferred_height_for_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_console_charset",sl_g_get_console_charset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_has_parent",sl_gtk_widget_path_has_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_unset_rows_drag_source",sl_gtk_tree_view_unset_rows_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_floating",sl_g_variant_is_floating,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_configure",sl_gtk_adjustment_configure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_duplex",sl_gtk_print_settings_get_duplex,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_reparent",sl_gdk_window_reparent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_spin_new",sl_gtk_cell_renderer_spin_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_ref_sink",sl_g_object_ref_sink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_use_underline",sl_gtk_menu_item_get_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_get_type",sl_gtk_tree_path_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_new_with_mnemonic",sl_gtk_label_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_equal",sl_g_inet_address_mask_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_focus_from_sibling",sl_gtk_cell_area_get_focus_from_sibling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_tool_item_get_draw",sl_gtk_separator_tool_item_get_draw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_window",sl_gtk_widget_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_title",sl_gtk_color_button_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_long_press_get_type",sl_gtk_gesture_long_press_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_pointing_to",sl_gtk_popover_get_pointing_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_minus_button",sl_gtk_scale_button_get_minus_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_join_group",sl_gtk_radio_menu_item_join_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_resolution",sl_gtk_print_settings_get_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_stpcpy",sl_g_stpcpy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_emit_inserted_text",sl_gtk_entry_buffer_emit_inserted_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_type",sl_g_settings_schema_key_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strlen",sl_g_utf8_strlen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_insert_next_to",sl_gtk_grid_insert_next_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_instance",sl_g_value_set_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_splice",sl_pango_attr_list_splice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_gicon",sl_gtk_image_set_from_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_icon",sl_gtk_recent_info_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_set_image",sl_gtk_message_dialog_set_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_set_screen",sl_gdk_event_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_double",sl_g_settings_set_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_monday_weeks_in_year",sl_g_date_get_monday_weeks_in_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_new_from_stock",sl_gtk_button_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_preview_is_selected",sl_gtk_print_operation_preview_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_set_state",sl_gtk_widget_path_iter_set_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_set_ignore_hidden",sl_gtk_size_group_set_ignore_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_get_type",sl_gtk_builder_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_accel_get_type",sl_gtk_cell_renderer_accel_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_list_shortcut_folders",sl_gtk_file_chooser_list_shortcut_folders,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_get_inconsistent",sl_gtk_check_menu_item_get_inconsistent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_get_type",sl_gtk_page_setup_unix_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_create_child_anchor",sl_gtk_text_buffer_create_child_anchor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_item_width",sl_gtk_icon_view_get_item_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_has_key",sl_g_settings_schema_has_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_chars_in_line",sl_gtk_text_iter_get_chars_in_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_signature",sl_g_variant_new_signature,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_set_hadjustment",sl_gtk_layout_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_error_quark",sl_gtk_builder_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_completer_new",sl_g_filename_completer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strreverse",sl_g_strreverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_transient_for",sl_gtk_window_set_transient_for,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_is_media_removable",sl_g_drive_is_media_removable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_sort_key",sl_g_drive_get_sort_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_focus",sl_gtk_widget_is_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_resizable",sl_gtk_window_get_resizable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_wm_decoration_get_type",sl_gdk_wm_decoration_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_next",sl_gtk_tree_path_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_family",sl_g_socket_get_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_symbolic_for_context",sl_gtk_icon_info_load_symbolic_for_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uri_escape_string",sl_g_uri_escape_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_has_subtitle",sl_gtk_header_bar_set_has_subtitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_min_value",sl_gtk_level_bar_get_min_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_boolean",sl_g_settings_get_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_set_track_motion",sl_gtk_drag_dest_set_track_motion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_preview_widget_active",sl_gtk_file_chooser_get_preview_widget_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_item_position",sl_gtk_tool_item_group_get_item_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_get_path",sl_g_settings_schema_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_new",sl_gtk_combo_box_text_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_drawable",sl_gtk_widget_is_drawable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_list_children",sl_g_settings_list_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_pan_get_type",sl_gtk_gesture_pan_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_lock_button_new",sl_gtk_lock_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_model",sl_gtk_icon_view_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_show_style",sl_gtk_font_button_set_show_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_path",sl_gtk_style_context_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_string",sl_g_variant_new_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_active_id",sl_gtk_combo_box_set_active_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_default_for_uri_scheme",sl_g_app_info_get_default_for_uri_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_tearoff_state",sl_gtk_menu_set_tearoff_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_n_up",sl_gtk_print_job_set_n_up,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_transient_for",sl_gtk_window_get_transient_for,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_year",sl_g_date_set_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_networking_init",sl_g_networking_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_username",sl_g_mount_operation_get_username,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_title",sl_gtk_font_button_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_value_convert",sl_g_param_value_convert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_level_indentation",sl_gtk_tree_view_set_level_indentation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_data",sl_g_file_info_get_attribute_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_get_example_icon_name",sl_gtk_icon_theme_get_example_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_entry_copy",sl_gtk_target_entry_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_is_scroll_stop_event",sl_gdk_event_is_scroll_stop_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_init",sl_g_type_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_list_children",sl_g_settings_schema_list_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_new",sl_gtk_menu_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_aligned_area",sl_gtk_cell_renderer_get_aligned_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_fixed_put",sl_gtk_fixed_put,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_editable",sl_gtk_text_iter_editable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_is_owner",sl_g_main_context_is_owner,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_for_display",sl_gtk_clipboard_get_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_begin_user_action",sl_gtk_text_buffer_begin_user_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_type",sl_pango_font_metrics_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_name",sl_g_drive_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_can_reach",sl_g_network_monitor_can_reach,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_new_with_mnemonic",sl_gtk_check_menu_item_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_row_spacing",sl_gtk_grid_set_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_update",sl_gtk_spin_button_update,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_image_position",sl_gtk_button_get_image_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_definite",sl_g_variant_type_is_definite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_flush",sl_gdk_flush,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_resolution",sl_gdk_screen_get_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_attributes",sl_pango_layout_set_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_new_with_text",sl_gtk_cell_view_new_with_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_input_shape_combine_region",sl_gtk_widget_input_shape_combine_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_date",sl_gtk_calendar_get_date,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_clear",sl_gtk_image_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_parse",sl_g_date_set_parse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_get_type",sl_gtk_overlay_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_unref",sl_pango_layout_line_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_create_from_commandline",sl_g_app_info_create_from_commandline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_set_font_name",sl_gtk_font_button_set_font_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_red_pixel_details",sl_gdk_visual_get_red_pixel_details,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_get_type",sl_gtk_tree_model_filter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_placeholder_text",sl_gtk_entry_set_placeholder_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_send_to",sl_g_socket_send_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_position",sl_gtk_popover_set_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_anchor_hints_get_type",sl_gdk_anchor_hints_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_current_icon_drag_source",sl_gtk_entry_get_current_icon_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_fullscreen_on_monitor",sl_gdk_window_fullscreen_on_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_button_new_with_label",sl_gtk_check_button_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_iter_get_type",sl_gdk_pixbuf_simple_anim_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_device_manager",sl_gdk_display_get_device_manager,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_remove",sl_g_simple_action_group_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_drag_get_type",sl_gtk_gesture_drag_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_child_is_selected",sl_gtk_flow_box_child_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_iter_copy",sl_gtk_tree_iter_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_limit",sl_gtk_recent_chooser_set_limit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_use_es",sl_gtk_gl_area_get_use_es,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_select_child",sl_gtk_flow_box_select_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_visible_rect",sl_gtk_text_view_get_visible_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_add_child_source",sl_g_source_add_child_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_completer_set_dirs_only",sl_g_filename_completer_set_dirs_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_error_quark",sl_gtk_recent_chooser_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_error_quark",sl_gdk_pixbuf_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_default_page_setup",sl_gtk_print_operation_get_default_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_insert",sl_g_simple_action_group_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_send_notify_for_display",sl_gdk_selection_send_notify_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_focus_on_map",sl_gtk_window_set_focus_on_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_type_get_length",sl_g_checksum_type_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_get_transient_for",sl_gtk_native_dialog_get_transient_for,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_equal",sl_g_variant_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_new",sl_gtk_tool_palette_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_paper_width",sl_gtk_print_settings_get_paper_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_remove_page",sl_gtk_notebook_remove_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_remove_poll",sl_g_source_remove_poll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_manual_capabilities",sl_gtk_print_unix_dialog_set_manual_capabilities,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_highlight",sl_gtk_drag_highlight,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_snap_to_ticks",sl_gtk_spin_button_set_snap_to_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_new",sl_g_variant_builder_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_caps_lock_state",sl_gdk_keymap_get_caps_lock_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_fully_decompose",sl_g_unichar_fully_decompose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_type",sl_gtk_label_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_new",sl_g_variant_type_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_from_surface",sl_gdk_pixbuf_get_from_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_next_char",sl_pango_layout_iter_next_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_manage_dnd",sl_gdk_drag_context_manage_dnd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_set_option",sl_gdk_pixbuf_set_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new_custom",sl_gtk_paper_size_new_custom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_end",sl_g_variant_builder_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_qregion",sl_gtk_widget_path_iter_has_qregion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_uint16",sl_g_variant_get_uint16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_set_ready_time",sl_g_source_set_ready_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_widget_get_type",sl_gtk_file_chooser_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_watch_closure",sl_g_object_watch_closure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_parse_markup",sl_pango_parse_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_unix_get_fd",sl_g_io_channel_unix_get_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_draw_insertion_cursor",sl_gtk_draw_insertion_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_current_page",sl_gtk_print_unix_dialog_set_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_state",sl_gdk_event_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_remove_selection_clipboard",sl_gtk_text_buffer_remove_selection_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_max_content_height",sl_gtk_scrolled_window_set_max_content_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_is_floating",sl_g_object_is_floating,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_set_loop",sl_gdk_pixbuf_simple_anim_set_loop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_format_secondary_markup",sl_gtk_message_dialog_format_secondary_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_icon",sl_gtk_window_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_use_underline",sl_gtk_label_set_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_glyphs",sl_pango_renderer_draw_glyphs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_set_adjustment",sl_gtk_list_box_set_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_menu_new",sl_gtk_recent_chooser_menu_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_logo",sl_gtk_about_dialog_set_logo,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_utc_offset",sl_g_date_time_get_utc_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_delete_action",sl_gtk_entry_completion_delete_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_icon",sl_g_notification_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_show_tabs",sl_gtk_notebook_get_show_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_displayed_row",sl_gtk_cell_view_set_displayed_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_request_selection_notification",sl_gdk_display_request_selection_notification,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_compare",sl_g_date_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_value_holds",sl_g_type_check_value_holds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_file_type",sl_g_file_info_set_file_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_set_double_click_time",sl_gdk_display_set_double_click_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_fill",sl_gdk_pixbuf_fill,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_deletion_date",sl_g_file_info_get_deletion_date,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_set_heading",sl_gtk_app_chooser_dialog_set_heading,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_load_from_data",sl_gtk_css_provider_load_from_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_offscreen_window_set_embedder",sl_gdk_offscreen_window_set_embedder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_name",sl_gdk_keyval_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_create_mark",sl_gtk_text_buffer_create_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_transition_type",sl_gtk_stack_get_transition_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_vadjustment",sl_gtk_flow_box_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_set_native",sl_g_credentials_set_native,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_preview_get_type",sl_gtk_print_operation_preview_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_set_state",sl_gtk_gesture_set_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attributes_from_info",sl_g_file_set_attributes_from_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_submenu",sl_gtk_menu_item_set_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_range",sl_gtk_text_buffer_insert_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_keepalive",sl_g_socket_set_keepalive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_font_map",sl_gtk_font_chooser_set_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_get_tree_view",sl_gtk_tree_selection_get_tree_view,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_titlebar",sl_gtk_window_get_titlebar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_link",sl_g_menu_item_set_link,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_selection",sl_gtk_selection_data_get_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_detachable",sl_gtk_notebook_get_tab_detachable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_new_first",sl_gtk_tree_path_new_first,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_remove_all",sl_g_menu_remove_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_clear",sl_gtk_tree_store_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_overwrite",sl_gtk_text_view_set_overwrite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_objects_from_resource",sl_gtk_builder_add_objects_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_unrealize",sl_gtk_widget_unrealize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_popup_accessible",sl_gtk_combo_box_get_popup_accessible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_select_region",sl_gtk_editable_select_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_ref",sl_g_source_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_revert",sl_g_settings_revert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_input_shapes",sl_gdk_display_supports_input_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_animation",sl_gtk_image_new_from_animation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_bounding_box",sl_gtk_gesture_get_bounding_box,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_layout",sl_pango_renderer_draw_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_get_static_image",sl_gdk_pixbuf_animation_get_static_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_int64",sl_g_file_set_attribute_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_get_default",sl_gtk_recent_manager_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_set_object_type",sl_gtk_widget_path_iter_set_object_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_fetch_named",sl_g_match_info_fetch_named,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_free",sl_gtk_tree_path_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_get_plugin",sl_g_type_get_plugin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_track_visited_links",sl_gtk_label_get_track_visited_links,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_set_required_version",sl_gdk_gl_context_set_required_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_page_increment",sl_gtk_adjustment_get_page_increment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_open_readwrite_finish",sl_g_file_open_readwrite_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_buffer",sl_gtk_entry_set_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_composited",sl_gdk_window_get_composited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_to_string",sl_gtk_widget_path_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_get_mirror_char",sl_g_unichar_get_mirror_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_gicon",sl_gtk_drag_set_icon_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_new",sl_g_network_address_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_clickable",sl_gtk_tree_view_column_get_clickable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_pixbuf",sl_gtk_entry_get_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_event_type",sl_gdk_event_get_event_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_hover_expand",sl_gtk_tree_view_get_hover_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_copy_options",sl_gdk_pixbuf_copy_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_is_upper",sl_gdk_keyval_is_upper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_byte_length",sl_gdk_pixbuf_get_byte_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_is_target_available",sl_gtk_clipboard_wait_is_target_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_get_names",sl_g_themed_icon_get_names,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_grab_status_get_type",sl_gdk_grab_status_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_current_dir",sl_g_get_current_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_iter_at_location",sl_gtk_text_view_get_iter_at_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_interpolate_size",sl_gtk_stack_get_interpolate_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_to_ucs4",sl_g_utf8_to_ucs4,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_child_focus",sl_gtk_widget_child_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_edited_cell",sl_gtk_cell_area_get_edited_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_unref",sl_gdk_frame_timings_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_get_reveal_child",sl_gtk_revealer_get_reveal_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_current_page",sl_gtk_print_unix_dialog_get_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_resize_toplevel",sl_gtk_expander_get_resize_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_right_margin",sl_gtk_text_view_set_right_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_pack_end",sl_gtk_tree_view_column_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_n_up_layout",sl_gtk_print_job_set_n_up_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_display",sl_gtk_widget_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_unset",sl_gtk_drag_source_unset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_parse_args",sl_gtk_parse_args,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_drop_done",sl_gdk_drag_drop_done,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_remove_class",sl_gtk_style_context_remove_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_set_default",sl_g_resolver_set_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_next_base",sl_g_type_next_base,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_markup",sl_gtk_tooltip_set_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best_with_type",sl_gdk_visual_get_best_with_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_target",sl_g_binding_get_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_connect_by_path",sl_gtk_accel_group_connect_by_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_set_object_name",sl_gtk_widget_path_iter_set_object_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_parse_geometry",sl_gtk_window_parse_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_unselect_all",sl_gtk_list_box_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_background_area",sl_gtk_tree_view_get_background_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_new",sl_pango_attr_list_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_rectangle",sl_gdk_cairo_rectangle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_destroy_with_parent",sl_gtk_window_get_destroy_with_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_add_tearoffs",sl_gtk_combo_box_set_add_tearoffs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_has_frame",sl_gtk_entry_set_has_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_fixed_width",sl_gtk_tree_view_column_set_fixed_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_add_application",sl_g_bookmark_file_add_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_to_key_file",sl_gtk_paper_size_to_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_uri_display",sl_gtk_recent_info_get_uri_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get",sl_gtk_clipboard_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_text_column",sl_gtk_entry_completion_get_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_accept_focus",sl_gdk_window_set_accept_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_get_page_setup",sl_gtk_page_setup_unix_dialog_get_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_min_slider_size",sl_gtk_range_set_min_slider_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_stock",sl_gtk_image_set_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_program_name",sl_gtk_about_dialog_get_program_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_is_finished",sl_gtk_print_operation_is_finished,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_lock_path",sl_gtk_accel_map_lock_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_delete_text",sl_gtk_editable_delete_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_is_tcrypt_system_volume",sl_g_mount_operation_get_is_tcrypt_system_volume,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_insert_item",sl_g_menu_insert_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_use_full_page",sl_gtk_print_operation_set_use_full_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_popup_for_device",sl_gtk_combo_box_popup_for_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_sequence_state",sl_gtk_gesture_get_sequence_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_copy",sl_g_hmac_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_new",sl_gtk_app_chooser_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_tolower",sl_g_ascii_tolower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_type",sl_gtk_progress_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_groups",sl_g_bookmark_file_get_groups,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_screen",sl_gdk_event_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_provider_get_type",sl_gtk_style_provider_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_set_active",sl_gtk_check_menu_item_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_new_from_string",sl_g_inet_address_new_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_error_quark",sl_g_resource_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_type",sl_gtk_cell_area_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_new",sl_g_regex_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_key_get_type",sl_gtk_event_controller_key_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new_with_label_from_widget",sl_gtk_radio_menu_item_new_with_label_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_create_pango_context",sl_gtk_widget_create_pango_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_length",sl_gtk_selection_data_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_get_type",sl_pango_renderer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_selected_rows",sl_gtk_list_box_get_selected_rows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_default",sl_gdk_screen_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_fixed_size",sl_gtk_cell_renderer_get_fixed_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_item_width",sl_gtk_icon_view_set_item_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isgraph",sl_g_unichar_isgraph,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_add_drag_dest",sl_gtk_tool_palette_add_drag_dest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_extension",sl_gtk_render_extension,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_get_above_child",sl_gtk_event_box_get_above_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_dict_entry",sl_g_variant_new_dict_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_first",sl_g_variant_type_first,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_manual_capabilities",sl_gtk_print_unix_dialog_get_manual_capabilities,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_height",sl_pango_layout_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_ispunct",sl_g_unichar_ispunct,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_set_uri",sl_gtk_link_button_set_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_add",sl_gtk_cell_area_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_ref",sl_g_main_context_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_bool",sl_gtk_print_settings_get_bool,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_activate_on_single_click",sl_gtk_tree_view_set_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_reorderable",sl_gtk_icon_view_get_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_has_focus",sl_gtk_widget_has_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_show_window_menu",sl_gdk_window_show_window_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_visual",sl_gtk_widget_set_visual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_transition_duration",sl_gtk_stack_get_transition_duration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_capture_button_press",sl_gtk_scrolled_window_get_capture_button_press,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_proxy_resolver_set_default_proxy",sl_g_simple_proxy_resolver_set_default_proxy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_headers_clickable",sl_gtk_tree_view_get_headers_clickable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_tooltip_column",sl_gtk_tree_view_get_tooltip_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_float",sl_g_value_get_float,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_new_from_model",sl_gtk_menu_new_from_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_monitor",sl_gtk_menu_get_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_stock",sl_gtk_entry_get_icon_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_strikethrough_new",sl_pango_attr_strikethrough_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_apply_embedded_orientation",sl_gdk_pixbuf_apply_embedded_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_row_span_column",sl_gtk_combo_box_set_row_span_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_get_user_data",sl_gtk_tree_selection_get_user_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_get_type",sl_gtk_event_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_get_display",sl_gdk_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_hide",sl_gtk_widget_hide,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_new",sl_gtk_layout_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_find_target",sl_gtk_drag_dest_find_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_age",sl_gtk_recent_info_get_age,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_visible_region",sl_gdk_window_get_visible_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_get_string_length",sl_g_variant_type_get_string_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_private_hint",sl_gtk_recent_info_get_private_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_unselect_all",sl_gtk_tree_selection_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_to_utf16",sl_g_utf8_to_utf16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_base_gravity",sl_pango_context_set_base_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_get_protocol",sl_g_network_service_get_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_string_list",sl_g_key_file_get_string_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_gtype",sl_g_value_set_gtype,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_show_all",sl_gtk_app_chooser_widget_set_show_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_set_forward_compatible",sl_gdk_gl_context_set_forward_compatible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_local_address",sl_g_socket_get_local_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_gravity",sl_pango_font_description_get_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_home_dir",sl_g_get_home_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_extend_with_template",sl_gtk_builder_extend_with_template,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_set_name_by_id",sl_g_source_set_name_by_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_preferred_height",sl_gtk_cell_area_context_get_preferred_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_notify_by_pspec",sl_g_object_notify_by_pspec,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_get_named",sl_gtk_css_provider_get_named,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_description",sl_g_bookmark_file_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_max_content_height",sl_gtk_scrolled_window_get_max_content_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_font_map",sl_gtk_widget_set_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_next_cluster",sl_pango_layout_iter_next_cluster,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_get_info",sl_g_resource_get_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_group_name",sl_gtk_notebook_get_group_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_aspect_frame_get_type",sl_gtk_aspect_frame_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_item_padding",sl_gtk_icon_view_set_item_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_select_path",sl_gtk_tree_selection_select_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_mnemonic_modifier",sl_gtk_window_set_mnemonic_modifier,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_style",sl_gtk_tool_palette_set_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_settable_attributes",sl_g_file_query_settable_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_axis_use_get_type",sl_gdk_axis_use_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_remove_provider_for_screen",sl_gtk_style_context_remove_provider_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_at_cursor",sl_gtk_text_buffer_insert_at_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_begin",sl_gdk_drag_begin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_int64",sl_g_settings_get_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_get_activatable",sl_gtk_cell_renderer_toggle_get_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_accel_path",sl_gtk_menu_get_accel_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_baseline_row",sl_gtk_grid_get_baseline_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_allocation",sl_gtk_widget_get_allocation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_show_style",sl_gtk_font_button_get_show_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_screen",sl_gtk_style_context_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_model",sl_gtk_entry_completion_set_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_invalidate_sort",sl_gtk_flow_box_invalidate_sort,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_add_poll",sl_g_source_add_poll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_freeze_toplevel_updates_libgtk_only",sl_gdk_window_freeze_toplevel_updates_libgtk_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_remove_provider",sl_gtk_style_context_remove_provider,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dir_read_name",sl_g_dir_read_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_application",sl_gtk_window_get_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_next",sl_g_match_info_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add_table",sl_gtk_target_list_add_table,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_sortable_sort_column_changed",sl_gtk_tree_sortable_sort_column_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_set_mime_dirs",sl_g_content_type_set_mime_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_set_position",sl_gtk_editable_set_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_fullscreen",sl_gtk_window_fullscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_unsetenv",sl_g_app_launch_context_unsetenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_resize_to_geometry",sl_gtk_window_resize_to_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_complete",sl_gtk_assistant_get_page_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_remove",sl_gtk_statusbar_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_inhibit",sl_gtk_application_inhibit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_new_from_pixbuf",sl_gdk_cursor_new_from_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_face_is_synthesized",sl_pango_font_face_is_synthesized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_describe",sl_pango_font_describe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_action_area",sl_gtk_info_bar_get_action_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_use_markup",sl_gtk_label_get_use_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_list_families",sl_pango_context_list_families,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_urgent",sl_g_notification_set_urgent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_preview_filename",sl_gtk_file_chooser_get_preview_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_set_hscroll_policy",sl_gtk_scrollable_set_hscroll_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_geometry",sl_gdk_monitor_get_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_paper_sizes",sl_gtk_paper_size_get_paper_sizes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_get_show_close_button",sl_gtk_search_bar_get_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_window_class_get_type",sl_gdk_window_window_class_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_executable",sl_g_app_info_get_executable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_fetch",sl_g_match_info_fetch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_get_current_device_grab",sl_gtk_window_group_get_current_device_grab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_insert_row",sl_gtk_grid_insert_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mkdir_with_parents",sl_g_mkdir_with_parents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_mode",sl_gdk_device_get_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_show_tips",sl_gtk_recent_chooser_get_show_tips,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_remove_poll",sl_g_main_context_remove_poll,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_subtract_days",sl_g_date_subtract_days,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_buffer_size",sl_g_io_channel_get_buffer_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_register_deserialize_tagset",sl_gtk_text_buffer_register_deserialize_tagset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_adjustment",sl_gtk_scale_button_get_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_display_name",sl_gtk_paper_size_get_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_invalidate_filter",sl_gtk_flow_box_invalidate_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_show_progress",sl_gtk_print_operation_set_show_progress,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_input_purpose",sl_gtk_text_view_set_input_purpose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_main_iteration",sl_gtk_main_iteration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_face_get_type",sl_pango_font_face_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_new_proxy",sl_gtk_tree_row_reference_new_proxy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_rescan_if_needed",sl_gtk_icon_theme_rescan_if_needed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_filename",sl_gtk_file_chooser_get_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_parse",sl_gtk_accelerator_parse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_get_connectivity",sl_g_network_monitor_get_connectivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_line_offset",sl_gtk_text_iter_get_line_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_current_event_state",sl_gtk_get_current_event_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_part_changed",sl_pango_renderer_part_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_month",sl_g_date_time_get_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_workarea",sl_gdk_monitor_get_workarea,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_digits",sl_gtk_spin_button_set_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_set_debug_flags",sl_gtk_set_debug_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_list_separator",sl_g_key_file_set_list_separator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_capture_button_press",sl_gtk_scrolled_window_set_capture_button_press,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_get_label",sl_gtk_frame_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_slaves",sl_gdk_seat_get_slaves,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_content_type",sl_g_file_info_set_content_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_rules_hint",sl_gtk_tree_view_set_rules_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_media_type",sl_gtk_print_settings_get_media_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new_with_mnemonic",sl_gtk_radio_menu_item_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_tree_view",sl_gtk_tree_view_column_get_tree_view,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_xdigit_value",sl_g_unichar_xdigit_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_run",sl_g_main_loop_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spinner_new",sl_gtk_spinner_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strtoull",sl_g_ascii_strtoull,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_set_print_settings",sl_gtk_page_setup_unix_dialog_set_print_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_from_window",sl_gdk_pixbuf_get_from_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_has_resize_grip",sl_gtk_window_get_has_resize_grip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_to_string",sl_g_credentials_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_object",sl_g_value_get_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_page_setup",sl_gtk_print_context_get_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_take_variant",sl_g_value_take_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_get_type",sl_gtk_tree_selection_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_objects_from_file",sl_gtk_builder_add_objects_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_has_window",sl_gtk_widget_set_has_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visibility_state_get_type",sl_gdk_visibility_state_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_username",sl_g_mount_operation_set_username,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_list_action_prefixes",sl_gtk_widget_list_action_prefixes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_unselect_all",sl_gtk_file_chooser_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_request_renderer",sl_gtk_cell_area_request_renderer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_groups",sl_g_bookmark_file_set_groups,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_memdup",sl_g_memdup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_set_source_rgba",sl_gdk_cairo_set_source_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_width_chars",sl_gtk_entry_get_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add_text_targets",sl_gtk_target_list_add_text_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_prepend",sl_gtk_combo_box_text_prepend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_buffer",sl_gtk_text_mark_get_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_state_flags",sl_gtk_widget_set_state_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_is_viewable",sl_gdk_window_is_viewable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_targets_include_image",sl_gtk_targets_include_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_get_type",sl_g_network_monitor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_remove_item",sl_g_bookmark_file_remove_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_get_tab",sl_pango_tab_array_get_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_identifier",sl_g_volume_get_identifier,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_button_sensitivity",sl_gtk_combo_box_set_button_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_check_format_string",sl_g_variant_check_format_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_lookup",sl_g_signal_lookup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_get_type",sl_gtk_tree_store_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_multicast_loopback",sl_g_socket_get_multicast_loopback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_line_wrap",sl_gtk_label_get_line_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_resizable",sl_gtk_tree_view_column_get_resizable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_get_range",sl_g_settings_schema_key_get_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_flags",sl_g_settings_set_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_list_schemas",sl_g_settings_list_schemas,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_preview_widget",sl_gtk_file_chooser_set_preview_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_drop_succeeded",sl_gdk_drag_drop_succeeded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_refetch",sl_gtk_accel_label_refetch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_selection_bounds",sl_gtk_text_buffer_get_selection_bounds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_get_item_link",sl_g_menu_model_get_item_link,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_message_type",sl_gtk_info_bar_get_message_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_ref",sl_g_settings_schema_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isspace",sl_g_unichar_isspace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_icon",sl_gtk_window_set_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_compute_hmac_for_bytes",sl_g_compute_hmac_for_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_state",sl_g_action_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_lookup_item",sl_gtk_recent_manager_lookup_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_app_launch_context",sl_gdk_display_get_app_launch_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_alpha",sl_gtk_color_button_get_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_drag_get_offset",sl_gtk_gesture_drag_get_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_has_pending",sl_g_input_stream_has_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_device_type",sl_gdk_device_get_device_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_round_glyph_positions",sl_pango_context_set_round_glyph_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_model",sl_gtk_icon_view_set_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_unstick",sl_gtk_window_unstick,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_select_item",sl_gtk_menu_shell_select_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strchomp",sl_g_strchomp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_bytes_in_line",sl_gtk_text_iter_get_bytes_in_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_device_is_shadowed",sl_gtk_widget_device_is_shadowed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_word_ends",sl_gtk_text_iter_forward_word_ends,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_ref",sl_g_variant_builder_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_set_vadjustment",sl_gtk_viewport_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_max_length",sl_gtk_entry_set_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_create_readwrite",sl_g_file_create_readwrite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_default_right_margin",sl_gtk_paper_size_get_default_right_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_modifier_state",sl_gdk_keymap_get_modifier_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_random_int",sl_g_random_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_visible_vertical",sl_gtk_tool_item_get_visible_vertical,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_max_content_width",sl_gtk_scrolled_window_get_max_content_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_param",sl_g_value_set_param,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_line_index",sl_gtk_text_iter_get_line_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_hash",sl_g_file_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_label_widget",sl_gtk_expander_get_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_type",sl_gdk_monitor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_invalidate_filter",sl_gtk_list_box_invalidate_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_rotate_simple",sl_gdk_pixbuf_rotate_simple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_is_ancestor",sl_gtk_tree_path_is_ancestor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_website",sl_gtk_about_dialog_set_website,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_eject_with_operation_finish",sl_g_mount_eject_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_add_region",sl_gtk_widget_path_iter_add_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_icon_name",sl_gdk_window_set_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_layout_line_path",sl_pango_cairo_layout_line_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_at_pos",sl_gtk_entry_get_icon_at_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_hover_expand",sl_gtk_tree_view_set_hover_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_from_iso8601",sl_g_date_time_new_from_iso8601,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_to_string",sl_pango_font_description_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_to_line_end",sl_gtk_text_iter_forward_to_line_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_get_homogeneous",sl_gtk_box_get_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_is_ascii",sl_g_str_is_ascii,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_to_unix",sl_g_date_time_to_unix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_get_type",sl_gtk_actionable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_event_compression",sl_gdk_window_get_event_compression,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_beep",sl_gdk_beep,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_progress_fraction",sl_gtk_entry_set_progress_fraction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_allow_breaks_new",sl_pango_attr_allow_breaks_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_top_margin",sl_gtk_text_view_get_top_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_get_iter",sl_gdk_pixbuf_animation_get_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_widget_for_response",sl_gtk_dialog_get_widget_for_response,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_get_default",sl_pango_language_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_begin_resize_drag",sl_gtk_window_begin_resize_drag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_icon_name",sl_gtk_window_set_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_static_string",sl_g_value_set_static_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_owner_set",sl_gtk_selection_owner_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_clear",sl_gtk_list_store_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_set_detailed_action_name",sl_gtk_actionable_set_detailed_action_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_pixbuf_new",sl_gtk_cell_renderer_pixbuf_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_popup_at_pointer",sl_gtk_menu_popup_at_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_combo_new",sl_gtk_cell_renderer_combo_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_append_section",sl_g_menu_append_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_line",sl_gtk_text_iter_set_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_shutdown",sl_g_socket_shutdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_sensitive",sl_gtk_widget_is_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_label",sl_gtk_button_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uri_unescape_segment",sl_g_uri_unescape_segment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_create_context",sl_pango_cairo_create_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_proxy_resolver_set_ignore_hosts",sl_g_simple_proxy_resolver_set_ignore_hosts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_default_value",sl_g_settings_get_default_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_pointing_to",sl_gtk_popover_set_pointing_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_local",sl_g_vfs_get_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_selection_notification",sl_gdk_display_supports_selection_notification,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_dpi_x",sl_gtk_print_context_get_dpi_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_type",sl_gtk_calendar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_add_shortcut",sl_gtk_places_sidebar_add_shortcut,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_character_count",sl_pango_layout_get_character_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_new_from_widget",sl_gtk_radio_tool_button_new_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_row_baseline_position",sl_gtk_grid_get_row_baseline_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_focus_child",sl_gtk_container_get_focus_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_line_yrange",sl_gtk_text_view_get_line_yrange,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_get_type",sl_gtk_cell_area_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_strikethrough_thickness",sl_pango_font_metrics_get_strikethrough_thickness,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_icon_list",sl_gtk_window_get_icon_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_variant",sl_g_variant_new_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_other_locations",sl_gtk_places_sidebar_get_show_other_locations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_current_folder",sl_gtk_file_chooser_get_current_folder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_min_width",sl_gtk_tree_view_column_get_min_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_current_page",sl_gtk_print_operation_set_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_urgency_hint",sl_gdk_window_set_urgency_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_string",sl_g_settings_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_add_target",sl_gtk_selection_add_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_invalidate_rect",sl_gdk_window_invalidate_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_has_renderer",sl_gtk_cell_area_has_renderer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_equal",sl_g_app_info_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_child",sl_g_settings_get_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_fundamental",sl_g_type_fundamental,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_beep",sl_gdk_display_beep,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_new",sl_g_time_zone_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_model_button_get_type",sl_gtk_model_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_n_up",sl_gtk_print_job_get_n_up,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_password",sl_g_proxy_address_get_password,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_type",sl_gtk_viewport_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_display_basename",sl_g_filename_display_basename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_pop",sl_gtk_statusbar_pop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_transition_duration",sl_gtk_stack_set_transition_duration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_copy_context",sl_gtk_cell_area_copy_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_int32",sl_g_file_info_get_attribute_int32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_type",sl_gtk_scrolled_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_progress_get_type",sl_gtk_cell_renderer_progress_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_get_object_type",sl_gtk_widget_path_get_object_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_spacing",sl_pango_layout_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_enter_location",sl_gtk_places_sidebar_set_show_enter_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_input_hints",sl_gtk_entry_get_input_hints,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_use_popover",sl_gtk_menu_button_get_use_popover,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_set_source_device",sl_gdk_event_set_source_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_collapse_all",sl_gtk_tree_view_collapse_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_get_type",sl_g_settings_schema_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_name",sl_g_param_spec_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_level",sl_gtk_font_chooser_set_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_icon_pixbuf",sl_gtk_render_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_pattern",sl_gtk_recent_filter_add_pattern,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_filesystem_info",sl_g_file_query_filesystem_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_random_double_range",sl_g_random_double_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_new",sl_g_timer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_shapes",sl_gdk_display_supports_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_pixel_size",sl_gtk_image_get_pixel_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_from_uri",sl_g_filename_from_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_position",sl_gdk_window_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_title",sl_gtk_font_button_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_type",sl_gtk_tool_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_height",sl_gtk_paper_size_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_new_with_seed_array",sl_g_rand_new_with_seed_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_save_fd",sl_gtk_accel_map_save_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_is_closed",sl_g_socket_is_closed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_menu_item_get_type",sl_gtk_separator_menu_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_is_running",sl_g_main_loop_is_running,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_menu_by_id",sl_gtk_application_get_menu_by_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_get_visible_window",sl_gtk_event_box_get_visible_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_ref",sl_g_key_file_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_focus_on_click",sl_gtk_widget_set_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_destination_port",sl_g_proxy_address_get_destination_port,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_set_group",sl_gtk_radio_button_set_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_icon",sl_g_volume_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_page_size",sl_gtk_adjustment_get_page_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_native_get_accept_label",sl_gtk_file_chooser_native_get_accept_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_is_descendant",sl_gtk_tree_path_is_descendant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_native_set_accept_label",sl_gtk_file_chooser_native_set_accept_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_list_classes",sl_gtk_style_context_list_classes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_has_group",sl_gtk_window_has_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pango_layout_get_clip_region",sl_gdk_pango_layout_get_clip_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_override_symbolic_color",sl_gtk_widget_override_symbolic_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_find",sl_gtk_target_list_find,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_get_help_overlay",sl_gtk_application_window_get_help_overlay,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_create_source",sl_g_socket_create_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_byte_order",sl_gdk_visual_get_byte_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_digit_value",sl_g_ascii_digit_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_logo_icon_name",sl_gtk_about_dialog_set_logo_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_n_columns",sl_gtk_tree_view_get_n_columns,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_pixel_size",sl_pango_layout_get_pixel_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_top_margin",sl_gtk_page_setup_set_top_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_gravity",sl_pango_context_get_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_new",sl_gtk_widget_path_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_width_chars",sl_gtk_label_set_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_type",sl_gtk_gesture_single_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_default_source",sl_gtk_print_settings_get_default_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_groups",sl_gtk_recent_info_get_groups,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new_with_mnemonic",sl_gtk_radio_button_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_julian",sl_g_date_set_julian,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_get_sample_language",sl_pango_script_get_sample_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_set_hadjustment",sl_gtk_viewport_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_add_mark",sl_gtk_scale_add_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_auto_startup_notification",sl_gtk_window_set_auto_startup_notification,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_tooltip_item",sl_gtk_icon_view_set_tooltip_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_image",sl_gtk_button_get_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_functions",sl_gdk_window_set_functions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_int",sl_g_settings_get_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_handler_block",sl_g_signal_handler_block,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_child_at",sl_gtk_grid_get_child_at,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_word_end",sl_gtk_text_iter_forward_visible_word_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_default_interface_ref",sl_g_type_default_interface_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_error",sl_gtk_gl_area_set_error,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_get_depth",sl_gtk_tree_path_get_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_add_item",sl_gtk_recent_manager_add_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_new_with_range",sl_gtk_scale_new_with_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_add_button",sl_g_notification_add_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_equals",sl_g_content_type_equals,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_row_spacing",sl_gtk_flow_box_get_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_parse",sl_g_variant_parse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_zoom_get_type",sl_gtk_gesture_zoom_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_symbolic_icon",sl_g_volume_get_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_composite",sl_gdk_display_supports_composite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_add_image_targets",sl_gtk_drag_dest_add_image_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_content_area",sl_gtk_info_bar_get_content_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_resolve_relative_path",sl_g_file_resolve_relative_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_run",sl_pango_layout_iter_get_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_value",sl_g_type_check_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_parameter_type",sl_g_action_get_parameter_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_add_named",sl_gtk_stack_add_named,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_create_similar_surface",sl_gdk_window_create_similar_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_target",sl_gtk_selection_data_get_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_type",sl_g_variant_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_convert_child_path_to_path",sl_gtk_tree_model_filter_convert_child_path_to_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_free",sl_gtk_paper_size_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_free",sl_gtk_widget_path_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_tooltip_markup",sl_gtk_entry_set_icon_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_default_text",sl_gtk_app_chooser_widget_set_default_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_name",sl_g_source_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_style",sl_gtk_tool_palette_get_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_value",sl_g_variant_type_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_resize",sl_pango_tab_array_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_new",sl_g_key_file_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_printer_lpi",sl_gtk_print_settings_set_printer_lpi,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_row_changed",sl_gtk_tree_model_row_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_pixbuf",sl_gtk_image_get_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_units_to_double",sl_pango_units_to_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_new_with_type",sl_gdk_pixbuf_loader_new_with_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_type",sl_gtk_icon_view_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_icon_list",sl_gtk_window_set_default_icon_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_start_group",sl_g_key_file_get_start_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_buffer",sl_gtk_text_iter_get_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_unref_node",sl_gtk_tree_model_unref_node,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_remove_shortcut",sl_gtk_places_sidebar_remove_shortcut,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_weekday",sl_g_date_valid_weekday,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_new_from_gvariant",sl_gtk_page_setup_new_from_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_tab_pos",sl_gtk_notebook_set_tab_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_days",sl_g_date_time_add_days,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_int64",sl_g_value_get_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_set_max_length",sl_gtk_entry_buffer_set_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_default_source",sl_gtk_print_settings_set_default_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_disconnect",sl_g_cancellable_disconnect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_dmy",sl_g_date_set_dmy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_enabled",sl_g_action_get_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_context_get_font_options",sl_pango_cairo_context_get_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_flags",sl_g_value_set_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_memory_settings_backend_new",sl_g_memory_settings_backend_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_fullscreen",sl_gdk_window_fullscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_get_model",sl_gtk_tree_row_reference_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_type",sl_gdk_frame_timings_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_set_scheme",sl_g_network_service_set_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_relief_style",sl_gtk_tool_shell_get_relief_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_status",sl_gtk_print_operation_get_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_update_area",sl_gdk_window_get_update_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_new_from_surface",sl_gdk_cursor_new_from_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_put",sl_gdk_event_put,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_name",sl_gdk_pixbuf_format_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_remove_window",sl_gtk_window_group_remove_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_editable_start_editing",sl_gtk_cell_editable_start_editing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_rich_text",sl_gtk_clipboard_wait_for_rich_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_is_shadowed",sl_g_mount_is_shadowed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_screen",sl_gtk_menu_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_variant",sl_pango_font_description_set_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_scale",sl_gdk_pixbuf_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_link_iter_get_type",sl_g_menu_link_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_zlib_decompressor_new",sl_g_zlib_decompressor_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_get_regex",sl_g_match_info_get_regex,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_pixbuf",sl_gtk_text_iter_get_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_clear",sl_g_variant_builder_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_day_is_marked",sl_gtk_calendar_get_day_is_marked,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_hash",sl_pango_font_description_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_address",sl_g_resolver_lookup_by_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_drag_item",sl_gtk_tool_palette_get_drag_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_get_type",sl_gtk_text_tag_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_n_axes",sl_gdk_device_get_n_axes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_set_touch_only",sl_gtk_gesture_single_set_touch_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_get_port",sl_g_inet_socket_address_get_port,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_default_seat",sl_gdk_display_get_default_seat,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_mnemonic_activate",sl_gtk_window_mnemonic_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_default_attributes",sl_gtk_text_view_get_default_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_ref",sl_pango_layout_line_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_modified",sl_g_bookmark_file_set_modified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_modifier_type_get_type",sl_gdk_modifier_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_select_iter",sl_gtk_tree_selection_select_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_top_margin",sl_gtk_page_setup_get_top_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_type_get_type",sl_gdk_event_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_type",sl_gtk_gesture_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_gtype",sl_g_value_get_gtype,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_add_instance_private",sl_g_type_add_instance_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_mnemonic_widget",sl_gtk_label_get_mnemonic_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_setting_action_get_type",sl_gdk_setting_action_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_get_type",sl_gtk_accel_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_propagate_natural_width",sl_gtk_scrolled_window_get_propagate_natural_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_line_index",sl_gtk_text_iter_set_line_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_orientable_get_type",sl_gtk_orientable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_load_surface",sl_gtk_icon_theme_load_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_is_destroyed",sl_g_source_is_destroyed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_insert",sl_gtk_flow_box_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_position_double",sl_gdk_device_get_position_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_tooltip_window",sl_gtk_widget_get_tooltip_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_path_is_selected",sl_gtk_tree_selection_path_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_orientation",sl_gtk_print_settings_set_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_xy_to_index",sl_pango_layout_xy_to_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_uint",sl_g_value_set_uint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_set_size",sl_gtk_layout_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_totitle",sl_g_unichar_totitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_objv",sl_g_variant_get_objv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_type",sl_gtk_info_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_from_string",sl_pango_language_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_unselect_child",sl_gtk_flow_box_unselect_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_scale_new",sl_pango_attr_scale_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_enumerate_identifiers",sl_g_drive_enumerate_identifiers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_pack_start",sl_gtk_box_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_headers_clickable",sl_gtk_tree_view_set_headers_clickable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_get_flowinfo",sl_g_inet_socket_address_get_flowinfo,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace",sl_g_file_replace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_type",sl_g_binding_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_mime_type",sl_gtk_recent_filter_add_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_frame_time",sl_gdk_frame_timings_get_frame_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_valign_with_baseline",sl_gtk_widget_get_valign_with_baseline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_offscreen_window_new",sl_gtk_offscreen_window_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_set_tab",sl_pango_tab_array_set_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_copy",sl_gtk_text_iter_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_bottom_margin",sl_gtk_text_view_get_bottom_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_error_quark",sl_gtk_recent_manager_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_current_button",sl_gtk_gesture_single_get_current_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_add_provider_for_screen",sl_gtk_style_context_add_provider_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_end_iter",sl_gtk_text_buffer_get_end_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_iter_new",sl_pango_script_iter_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_get_service",sl_g_network_service_get_service,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_draw_sensitive",sl_gtk_cell_view_set_draw_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_find_window_for_screen",sl_gdk_drag_find_window_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_copy",sl_g_value_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_adjustment",sl_gtk_spin_button_set_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_directory",sl_g_file_monitor_directory,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_scroll_to_point",sl_gtk_tree_view_scroll_to_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_resize_drag",sl_gdk_window_begin_resize_drag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_get_type",sl_gtk_shortcut_label_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_remove_all",sl_gtk_statusbar_remove_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_add_button",sl_gtk_info_bar_add_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strsplit",sl_g_strsplit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_window_at_pointer",sl_gdk_display_get_window_at_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_height_mm",sl_gdk_monitor_get_height_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_from_mime_type",sl_g_content_type_from_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_padding",sl_gtk_style_context_get_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_list_relocatable_schemas",sl_g_settings_list_relocatable_schemas,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_title",sl_gtk_menu_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_uchar",sl_g_value_set_uchar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_text_size_group",sl_gtk_tool_shell_get_text_size_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_entry_new",sl_gtk_search_entry_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_load_from_bytes",sl_g_key_file_load_from_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_family_get_name",sl_pango_font_family_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_get_type",sl_gtk_layout_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_new",sl_g_emblemed_icon_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_show_expanders",sl_gtk_tree_view_get_show_expanders,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_hours",sl_g_date_time_add_hours,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_list_visuals",sl_gdk_list_visuals,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_indent",sl_pango_layout_set_indent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_unbind",sl_g_settings_unbind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_etag",sl_g_file_info_get_etag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_translator_credits",sl_gtk_about_dialog_set_translator_credits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_new_from_fd",sl_g_socket_new_from_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_accepts_pdf",sl_gtk_printer_accepts_pdf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_get_display",sl_gdk_cursor_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_enum",sl_g_value_get_enum,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_proxy_resolver_get_type",sl_g_simple_proxy_resolver_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_get_type",sl_gtk_menu_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_attribute_iter_get_value",sl_g_menu_attribute_iter_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_max_backref",sl_g_regex_get_max_backref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_iter_advance",sl_gdk_pixbuf_animation_iter_advance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_new_with_buffer",sl_gtk_text_view_new_with_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_modal_hint",sl_gdk_window_get_modal_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_set_modal",sl_gtk_native_dialog_set_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_input_purpose",sl_gtk_entry_set_input_purpose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_items",sl_gtk_recent_chooser_get_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_child_watch_source_new",sl_g_child_watch_source_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_full",sl_g_date_time_add_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_get_width",sl_gdk_pixbuf_animation_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_years",sl_g_date_time_add_years,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_get_type",sl_g_network_address_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_line_spacing",sl_pango_layout_set_line_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_create_folders",sl_gtk_file_chooser_set_create_folders,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_dispatch",sl_g_main_context_dispatch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_position",sl_gtk_window_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_connected_drives",sl_g_volume_monitor_get_connected_drives,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_has_unapplied",sl_g_settings_get_has_unapplied,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_symbolic_icon",sl_g_file_info_get_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_iter_get_range",sl_pango_script_iter_get_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_scale_simple",sl_gdk_pixbuf_scale_simple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_free",sl_gdk_pixbuf_format_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_valign",sl_gtk_widget_get_valign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_quark_from_string",sl_g_quark_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_can_eject",sl_g_mount_can_eject,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_device",sl_gtk_gesture_get_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_set_state",sl_g_simple_action_set_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_fd",sl_g_socket_get_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_underline_color_new",sl_pango_attr_underline_color_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_touchpad_gesture_phase_get_type",sl_gdk_touchpad_gesture_phase_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_set_name",sl_gtk_widget_path_iter_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_copy",sl_gtk_print_settings_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_set_prgname",sl_g_set_prgname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_append_submenu",sl_g_menu_append_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new_with_mnemonic_from_widget",sl_gtk_radio_button_new_with_mnemonic_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_accepts_tab",sl_gtk_text_view_get_accepts_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_show",sl_gtk_widget_show,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_ref",sl_g_io_channel_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_left_margin",sl_gtk_page_setup_set_left_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_normal_form",sl_g_variant_get_normal_form,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_ref",sl_gtk_css_section_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_drag_source",sl_gtk_tool_palette_set_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_overwrite_mode",sl_gtk_entry_set_overwrite_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_reorderable",sl_gtk_icon_view_set_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_new",sl_gtk_notebook_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_accel_path",sl_gtk_menu_set_accel_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_new",sl_gtk_menu_tool_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unsetenv",sl_g_unsetenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_get_char",sl_g_utf8_get_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_new_for_interval",sl_gtk_level_bar_new_for_interval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_is_cancelled",sl_g_file_monitor_is_cancelled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_filesystem_info_finish",sl_g_file_query_filesystem_info_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_expand_row",sl_gtk_tree_view_expand_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_password",sl_g_mount_operation_set_password,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_draw",sl_gtk_widget_queue_draw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_language_names_with_category",sl_g_get_language_names_with_category,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uuid_string_random",sl_g_uuid_string_random,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_current",sl_gdk_gl_context_get_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_pop_composite_child",sl_gtk_widget_pop_composite_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_get_length",sl_g_mapped_file_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_get_type",sl_gtk_application_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_type",sl_gtk_tool_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_text_orientation",sl_gtk_tool_item_get_text_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_script_iter_get_type",sl_pango_script_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_convert_path_to_child_path",sl_gtk_tree_model_sort_convert_path_to_child_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_im_context_filter_keypress",sl_gtk_text_view_im_context_filter_keypress,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_child_notify",sl_gtk_container_child_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_color_get_type",sl_pango_color_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_uint64",sl_g_file_set_attribute_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_launch_uris_finish",sl_g_app_info_launch_uris_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_major_version",sl_gtk_get_major_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_line_offset",sl_gtk_text_buffer_get_iter_at_line_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_single_paragraph_mode",sl_pango_layout_get_single_paragraph_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_title",sl_gtk_print_job_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_measure_disk_usage_finish",sl_g_file_measure_disk_usage_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_text_with_mnemonic",sl_gtk_label_set_text_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_get_search_mode",sl_gtk_search_bar_get_search_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_relative_to",sl_gtk_popover_set_relative_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_get_default",sl_g_settings_schema_source_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_step_increment",sl_gtk_adjustment_get_step_increment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_width_mm",sl_gdk_screen_width_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_shadow_type",sl_gtk_scrolled_window_get_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_scroll_to_iter",sl_gtk_text_view_scroll_to_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_changed",sl_gtk_text_tag_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_sort_order",sl_gtk_tree_view_column_get_sort_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_settings",sl_gtk_print_unix_dialog_get_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_number_parser_error_quark",sl_g_number_parser_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_launch",sl_g_app_info_launch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_pointer_type_register_static",sl_g_pointer_type_register_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_scroll_direction",sl_gdk_event_get_scroll_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_use_drag_window",sl_gtk_tool_item_set_use_drag_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_handles_sequence",sl_gtk_gesture_handles_sequence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_pixels_above_lines",sl_gtk_text_view_get_pixels_above_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_pointer_emulated",sl_gdk_event_get_pointer_emulated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_remove",sl_g_source_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_xalign",sl_gtk_label_get_xalign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_policy",sl_gtk_scrolled_window_set_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_decorations",sl_gdk_window_get_decorations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_find_enclosing_mount",sl_g_file_find_enclosing_mount,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_month",sl_g_date_get_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_load_font",sl_pango_context_load_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_check",sl_gtk_render_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf16_to_utf8",sl_g_utf16_to_utf8,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_edit_widget",sl_gtk_cell_area_get_edit_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_year",sl_g_date_valid_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_base_gravity",sl_pango_context_get_base_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_start_position",sl_gtk_css_section_get_start_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_set_font_options",sl_gdk_screen_set_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_sizing",sl_gtk_tree_view_column_set_sizing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_basename",sl_g_file_get_basename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_to_lower",sl_gdk_keyval_to_lower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_top_margin",sl_gtk_text_view_set_top_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_activate",sl_pango_renderer_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_preview_render_page",sl_gtk_print_operation_preview_render_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_unref",sl_pango_coverage_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_visible_line_offset",sl_gtk_text_iter_get_visible_line_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_set_menubar",sl_gtk_application_set_menubar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_open_stream",sl_g_resource_open_stream,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_add_titled",sl_gtk_stack_add_titled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_zlib_decompressor_get_type",sl_g_zlib_decompressor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_title",sl_gtk_assistant_get_page_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_peek",sl_gdk_event_peek,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_unregister_uri_scheme",sl_g_vfs_unregister_uri_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_is_active",sl_g_vfs_is_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_quit",sl_g_main_loop_quit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_init",sl_gdk_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_starts_line",sl_gtk_text_iter_starts_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_day",sl_g_date_set_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new_with_area",sl_gtk_combo_box_new_with_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_set_selection_mode",sl_gtk_list_box_set_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_pim",sl_g_mount_operation_set_pim,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_propagate_event",sl_gtk_propagate_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_clear_marks",sl_gtk_scale_clear_marks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_remove_item",sl_gtk_recent_manager_remove_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_is_connected",sl_g_socket_is_connected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_owner_set",sl_gdk_selection_owner_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_page_size",sl_gtk_adjustment_set_page_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_unref",sl_g_object_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_get_ignore_hidden",sl_gtk_size_group_get_ignore_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_get_type",sl_gtk_radio_tool_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isprint",sl_g_unichar_isprint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_compile_flags",sl_g_regex_get_compile_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cairo_transform_to_window",sl_gtk_cairo_transform_to_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_connect_closure_by_id",sl_g_signal_connect_closure_by_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_end_line",sl_gtk_css_section_get_end_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_clear",sl_g_date_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_layout_offsets",sl_gtk_scale_get_layout_offsets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_collate",sl_gtk_print_settings_set_collate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_get_type",sl_gtk_recent_manager_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_activate_default",sl_gtk_window_activate_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_insert",sl_gtk_tool_item_group_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font",sl_gtk_font_chooser_get_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_window",sl_gdk_gl_context_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_activate_on_single_click",sl_gtk_icon_view_get_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_get_offset",sl_g_time_zone_get_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_get_type",sl_g_menu_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_set_active",sl_gtk_cell_renderer_toggle_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_default_direction",sl_gtk_widget_set_default_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_border_width",sl_gtk_container_set_border_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_notify",sl_g_object_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_status",sl_g_file_info_get_attribute_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_is_value_type",sl_g_type_check_is_value_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_string_scan",sl_g_variant_type_string_scan,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_new_utc",sl_g_time_zone_new_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_days_in_month",sl_g_date_get_days_in_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_get_surface",sl_gdk_cursor_get_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_list_devices",sl_gdk_display_list_devices,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_int64",sl_g_settings_set_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_tool_type_get_type",sl_gdk_device_tool_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_type_compatible",sl_g_value_type_compatible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_unref",sl_g_file_attribute_info_list_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_type_get_name",sl_pango_attr_type_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_set_color",sl_gtk_color_button_set_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_has_child",sl_gtk_tree_model_iter_has_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_support_selection",sl_gtk_print_unix_dialog_set_support_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_markup_column",sl_gtk_icon_view_set_markup_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_scroll_new",sl_gtk_event_controller_scroll_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drawing_context_is_valid",sl_gdk_drawing_context_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_show_border",sl_gtk_notebook_get_show_border,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_move_before",sl_gtk_list_store_move_before,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_group",sl_gtk_window_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_unhighlight",sl_gtk_drag_unhighlight,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_create_finish",sl_g_file_create_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_to_ascii",sl_g_str_to_ascii,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_set_transitions_enabled",sl_gtk_popover_set_transitions_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_uchar",sl_g_value_get_uchar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_set_activate_on_single_click",sl_gtk_list_box_set_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_create_folders",sl_gtk_file_chooser_get_create_folders,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_set_activatable",sl_gtk_cell_renderer_toggle_set_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_clamp",sl_g_date_clamp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dngettext",sl_g_dngettext,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_search",sl_gtk_text_iter_forward_search,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_new_from_string",sl_g_inet_address_mask_new_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_margin",sl_gtk_style_context_get_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_set_priority",sl_g_source_set_priority,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_label",sl_gtk_expander_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_cursor_positions",sl_gtk_text_iter_backward_cursor_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_apply",sl_g_settings_apply,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_is_zero_width",sl_pango_is_zero_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_remove_option",sl_gdk_pixbuf_remove_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_new",sl_g_menu_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_send_with_blocking",sl_g_socket_send_with_blocking,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_source_events",sl_gdk_window_set_source_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_wrap_width",sl_gtk_combo_box_get_wrap_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_default_interface_unref",sl_g_type_default_interface_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_double",sl_g_value_get_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_present_with_time",sl_gtk_window_present_with_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_has_pending",sl_gdk_display_has_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_grid_lines",sl_gtk_tree_view_get_grid_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_info",sl_g_file_query_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isalpha",sl_g_unichar_isalpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_translator_credits",sl_gtk_about_dialog_get_translator_credits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_sortable_set_sort_column_id",sl_gtk_tree_sortable_set_sort_column_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_set_spacing",sl_gtk_cell_area_box_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_line_wrap_mode",sl_gtk_label_get_line_wrap_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_load_partial_contents_finish",sl_g_file_load_partial_contents_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_new",sl_gtk_text_attributes_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_launch_default_for_uri",sl_g_app_info_launch_default_for_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_attributes_unref",sl_gtk_text_attributes_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_wmclass",sl_gtk_window_set_wmclass,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_modifier_mask",sl_gtk_widget_get_modifier_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_page_set",sl_gtk_print_settings_get_page_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_eject_with_operation_finish",sl_g_volume_eject_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_get_default_display",sl_gdk_display_manager_get_default_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_byte",sl_g_variant_new_byte,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_touch_only",sl_gtk_gesture_single_get_touch_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_hexpand_set",sl_gtk_widget_get_hexpand_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_resize_toplevel",sl_gtk_expander_set_resize_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_column_homogeneous",sl_gtk_grid_get_column_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_new",sl_g_file_attribute_matcher_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_free",sl_g_checksum_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_set_above_child",sl_gtk_event_box_set_above_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_false",sl_gtk_false,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_insert",sl_pango_attr_list_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_inline_completion",sl_gtk_entry_completion_set_inline_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_aspect_frame_set",sl_gtk_aspect_frame_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_guess_for_tree",sl_g_content_type_guess_for_tree,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_boolean",sl_g_file_info_set_attribute_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_height_mm",sl_gdk_screen_get_monitor_height_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_ellipsize",sl_pango_layout_set_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_actionable_get_action_target_value",sl_gtk_actionable_get_action_target_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_file",sl_g_file_monitor_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_title",sl_gtk_menu_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_add_shortcut_folder",sl_gtk_file_chooser_add_shortcut_folder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_unref",sl_g_key_file_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_notify_startup_complete",sl_gdk_notify_startup_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_child_anchor",sl_gtk_text_buffer_get_iter_at_child_anchor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_constrain_to",sl_gtk_popover_get_constrain_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accessible_get_widget",sl_gtk_accessible_get_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_columns",sl_gtk_tree_view_get_columns,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_filenames",sl_gtk_file_chooser_get_filenames,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add",sl_g_date_time_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_device_enabled",sl_gtk_widget_set_device_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_enum",sl_g_settings_set_enum,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_accept",sl_g_socket_accept,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_fundamental_next",sl_g_type_fundamental_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_seat",sl_gdk_event_get_seat,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_statusbar_get_context_id",sl_gtk_statusbar_get_context_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_child_visible",sl_gtk_widget_get_child_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_action_area",sl_gtk_dialog_get_action_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_focus_on_click",sl_gtk_button_set_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_trash_finish",sl_g_file_trash_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_ellipsize",sl_gtk_progress_bar_set_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_records",sl_g_resolver_lookup_records,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_move_resize",sl_gdk_window_move_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_filter",sl_gtk_recent_chooser_set_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_title",sl_g_bookmark_file_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_version_check",sl_pango_version_check,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_text_column",sl_gtk_entry_completion_set_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_lines",sl_gtk_text_iter_forward_visible_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_set_shadow_type",sl_gtk_viewport_set_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_set_revealed",sl_gtk_info_bar_set_revealed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attribute_equal",sl_pango_attribute_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_label_widget",sl_gtk_tool_item_group_get_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_fullscreen_mode",sl_gdk_window_get_fullscreen_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_multi_press_get_type",sl_gtk_gesture_multi_press_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_guess_content_type_sync",sl_g_mount_guess_content_type_sync,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_new",sl_gtk_text_tag_table_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_left",sl_gtk_widget_set_margin_left,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_delete_finish",sl_g_file_delete_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_get_layout_line",sl_pango_renderer_get_layout_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_timings",sl_gdk_frame_clock_get_timings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_has_alpha",sl_gdk_pixbuf_get_has_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_name_with_flags",sl_g_resolver_lookup_by_name_with_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_set_rate_limit",sl_g_file_monitor_set_rate_limit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strreverse",sl_g_utf8_strreverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_marks",sl_gtk_text_iter_get_marks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_deactivate",sl_pango_renderer_deactivate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_set_child_packing",sl_gtk_box_set_child_packing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_new",sl_gtk_progress_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_child_new",sl_gtk_flow_box_child_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_delete",sl_gtk_text_buffer_delete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_spacing",sl_gtk_expander_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_is_default",sl_gtk_printer_is_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_create_instance",sl_g_type_create_instance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_use_preview_label",sl_gtk_file_chooser_get_use_preview_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_name",sl_gdk_device_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_new_tmp",sl_g_file_new_tmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_string",sl_g_file_info_get_attribute_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_is_local",sl_gtk_recent_info_is_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_add_interface_dynamic",sl_g_type_add_interface_dynamic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_set_alternative_button_order_from_array",sl_gtk_dialog_set_alternative_button_order_from_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_is_daylight_savings",sl_g_date_time_is_daylight_savings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_right",sl_gtk_widget_get_margin_right,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_set_text",sl_gtk_text_buffer_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_new",sl_gtk_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_new",sl_g_credentials_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_tolower",sl_g_unichar_tolower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_get_type",sl_pango_layout_line_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_child_anchor_get_widgets",sl_gtk_text_child_anchor_get_widgets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_rules_hint",sl_gtk_tree_view_get_rules_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_day_of_week",sl_g_date_time_get_day_of_week,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_width",sl_gtk_print_context_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_font",sl_gtk_style_context_get_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_vadjustment",sl_gtk_scrolled_window_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_website_label",sl_gtk_about_dialog_get_website_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_root_coords",sl_gdk_event_get_root_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_savev",sl_gdk_pixbuf_savev,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_name",sl_gtk_widget_path_iter_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_role",sl_gtk_window_get_role,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_pages",sl_gtk_print_job_set_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_remove_filter",sl_gtk_file_chooser_remove_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_reset_im_context",sl_gtk_entry_reset_im_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_new_from_key_file",sl_gtk_print_settings_new_from_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_list_toplevels",sl_gtk_window_list_toplevels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_type",sl_gtk_scale_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_int",sl_g_rand_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_description",sl_g_bookmark_file_set_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_get_mode",sl_gtk_tree_selection_get_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_int64",sl_g_file_info_get_attribute_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_owner_set_for_display",sl_gtk_selection_owner_set_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_type",sl_gtk_combo_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_set_take_focus",sl_gtk_menu_shell_set_take_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_attached_to",sl_gtk_window_set_attached_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_map_get_type",sl_g_action_map_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_set_focus_cell",sl_gtk_cell_area_set_focus_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_append",sl_gtk_menu_shell_append,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_paper_height",sl_gtk_print_settings_set_paper_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_relative_to",sl_gtk_popover_get_relative_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_equal",sl_g_variant_type_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_icon_name",sl_gtk_image_get_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_new_with_mime_type",sl_gdk_pixbuf_loader_new_with_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_type_get_type",sl_gdk_visual_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_render",sl_gtk_cell_renderer_render,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_header_relief",sl_gtk_tool_item_group_set_header_relief,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_get_type",sl_gtk_css_provider_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_set_qdata",sl_g_object_set_qdata,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_get_tabs",sl_pango_tab_array_get_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_get_disabled_text",sl_gtk_shortcut_label_get_disabled_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_new",sl_gtk_window_group_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_free",sl_pango_layout_iter_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_set_text",sl_gtk_clipboard_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_sidebar_get_type",sl_gtk_stack_sidebar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_collate",sl_g_utf8_collate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_at_point",sl_gdk_screen_get_monitor_at_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_last_event",sl_gtk_gesture_get_last_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_clicked",sl_gtk_button_clicked,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_language",sl_gtk_font_chooser_set_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_set",sl_gtk_selection_data_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_current_name",sl_gtk_file_chooser_get_current_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_match_flags",sl_g_regex_get_match_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_now",sl_g_date_time_new_now,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_multicast_loopback",sl_g_socket_set_multicast_loopback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_context_set_resolution",sl_pango_cairo_context_set_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_word_starts",sl_gtk_text_iter_backward_visible_word_starts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_ref",sl_gtk_widget_path_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_add_attribute",sl_gtk_cell_layout_add_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_hhomogeneous",sl_gtk_stack_get_hhomogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_sensitive",sl_gtk_widget_set_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_wrap",sl_gtk_spin_button_set_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_show_private",sl_gtk_recent_chooser_set_show_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_extensions",sl_gdk_pixbuf_format_get_extensions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_event",sl_gdk_display_get_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_tabs",sl_gtk_text_view_set_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_reorder",sl_gtk_cell_layout_reorder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_align_widget",sl_gtk_menu_button_get_align_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_set_expand",sl_gtk_tool_palette_set_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_builtin_pixbuf",sl_gtk_icon_info_get_builtin_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_backspace",sl_gtk_text_buffer_backspace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_active_id",sl_gtk_combo_box_get_active_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_orientable_get_orientation",sl_gtk_orientable_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_width_chars",sl_gtk_entry_set_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_custom_title",sl_gtk_header_bar_set_custom_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_wide_handle",sl_gtk_paned_get_wide_handle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_add_class_private",sl_g_type_add_class_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_unref",sl_gtk_widget_path_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_text",sl_gtk_progress_bar_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_layout_set_vadjustment",sl_gtk_layout_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_set_state_hint",sl_g_simple_action_set_state_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_is_showing",sl_gtk_mount_operation_is_showing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_dup_string",sl_g_value_dup_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_skip_taskbar_hint",sl_gtk_window_set_skip_taskbar_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_scale",sl_gtk_print_settings_set_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_symbolic_icon",sl_g_mount_get_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_frame_clock",sl_gtk_widget_get_frame_clock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_ulong",sl_g_value_set_ulong,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_get_hostname",sl_g_network_address_get_hostname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_draw_area",sl_gtk_widget_queue_draw_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_default_handler_finish",sl_g_file_query_default_handler_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_shape_combine_region",sl_gtk_widget_shape_combine_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_copy",sl_pango_tab_array_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_screen",sl_gtk_widget_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_change_state",sl_g_action_change_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_popup_at_widget",sl_gtk_menu_popup_at_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_set_pending",sl_g_input_stream_set_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_progress_pulse",sl_gtk_entry_progress_pulse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_window",sl_gtk_gesture_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_set_uris",sl_gtk_selection_data_set_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_activate_on_single_click",sl_gtk_flow_box_get_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hostname_to_unicode",sl_g_hostname_to_unicode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_icon_new",sl_g_file_icon_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_get_digits",sl_gtk_scale_get_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_unref",sl_g_time_zone_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_set_rgba",sl_gtk_color_chooser_set_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drawing_context_get_clip",sl_gdk_drawing_context_get_clip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_prop_mode_get_type",sl_gdk_prop_mode_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_unset",sl_gtk_drag_dest_unset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_unref",sl_g_main_loop_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_make_directory",sl_g_file_make_directory,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_titlebar",sl_gtk_window_set_titlebar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_is_partial_match",sl_g_match_info_is_partial_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_default_cursor_size",sl_gdk_display_get_default_cursor_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_copyright",sl_gtk_about_dialog_get_copyright,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_enumerate_children",sl_g_resources_enumerate_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_is_type",sl_gtk_widget_path_is_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_usleep",sl_g_usleep,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_make_pollfd",sl_g_cancellable_make_pollfd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_add_mark",sl_gtk_text_buffer_add_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get",sl_g_volume_monitor_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_expand",sl_gtk_tool_item_set_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_get_rgba",sl_gtk_color_chooser_get_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_completer_get_type",sl_g_filename_completer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_preferred_height_for_width",sl_gtk_cell_area_context_get_preferred_height_for_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblem_get_origin",sl_g_emblem_get_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_add_with_viewport",sl_gtk_scrolled_window_add_with_viewport,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_keys",sl_g_key_file_get_keys,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_key_snooper_remove",sl_gtk_key_snooper_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_select_range",sl_gtk_tree_selection_select_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_set_hadjustment",sl_gtk_scrollable_set_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_type",sl_gdk_gl_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_family_get_type",sl_pango_font_family_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_mapped",sl_gtk_widget_set_mapped,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_size",sl_gtk_window_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_input_source_get_type",sl_gdk_input_source_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_numeric",sl_gtk_spin_button_get_numeric,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_use_underline",sl_gtk_label_get_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_main_level",sl_gtk_main_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_template_child",sl_gtk_widget_get_template_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_destroy",sl_g_timer_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_get_draw_as_radio",sl_gtk_check_menu_item_get_draw_as_radio,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_line",sl_gtk_text_iter_get_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_remove_shortcut_folder_uri",sl_gtk_file_chooser_remove_shortcut_folder_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_iscntrl",sl_g_unichar_iscntrl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_notify_type_get_type",sl_gdk_notify_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_width",sl_gdk_window_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_charset_converter_new",sl_g_charset_converter_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_environ",sl_g_get_environ,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_load_bytes_finish",sl_g_file_load_bytes_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_delete_mark",sl_gtk_text_buffer_delete_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_get_use_markup",sl_gtk_expander_get_use_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_popover",sl_gtk_menu_button_set_popover,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_test_simulate_button",sl_gdk_test_simulate_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_host_name",sl_g_get_host_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_background_color",sl_gtk_style_context_get_background_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_current_page",sl_gtk_notebook_set_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drawing_context_get_type",sl_gdk_drawing_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_adjustment",sl_gtk_spin_button_get_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_update",sl_g_checksum_update,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_destroy_with_parent",sl_gtk_window_set_destroy_with_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_line",sl_gtk_text_iter_forward_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_is_closed",sl_g_input_stream_is_closed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_new_with_area",sl_gtk_icon_view_new_with_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_file_info_finish",sl_gdk_pixbuf_get_file_info_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_cursor_position",sl_gtk_text_iter_backward_cursor_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_value",sl_gtk_level_bar_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_get_type",sl_g_themed_icon_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_use_alpha",sl_gtk_color_button_get_use_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_position",sl_gtk_paned_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_family",sl_pango_font_description_get_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_animation",sl_gtk_image_get_animation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_get_rgba",sl_gtk_color_button_get_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_sibling_index",sl_gtk_widget_path_iter_get_sibling_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_name",sl_g_file_info_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_size",sl_pango_font_description_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_resolution_y",sl_gtk_print_settings_get_resolution_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_create_gl_context",sl_gdk_window_create_gl_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_minimum_key_length",sl_gtk_entry_completion_get_minimum_key_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_plug_name",sl_gdk_screen_get_monitor_plug_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_time",sl_gdk_event_get_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_is_last_of_month",sl_g_date_is_last_of_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_to_file",sl_g_bookmark_file_to_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_set_value",sl_gtk_scale_button_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_lookup_by_gicon",sl_gtk_icon_theme_lookup_by_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_freeze",sl_g_menu_freeze,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_selected_action",sl_gdk_drag_context_get_selected_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_triggers_context_menu",sl_gdk_event_triggers_context_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_new",sl_gtk_menu_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_unit",sl_gtk_print_operation_set_unit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_font_features_new",sl_pango_attr_font_features_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_line_spacing",sl_pango_layout_get_line_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_visual_type",sl_gdk_visual_get_visual_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_create_context",sl_pango_font_map_create_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_new",sl_gtk_page_setup_unix_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_volumes",sl_g_drive_get_volumes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_reorderable",sl_gtk_tree_view_column_get_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_is_shaped",sl_gdk_window_is_shaped,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_focus_on_map",sl_gtk_window_get_focus_on_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_visible_child_name",sl_gtk_stack_get_visible_child_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unicode_canonical_decomposition",sl_g_unicode_canonical_decomposition,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_append_page",sl_gtk_assistant_append_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_bottom",sl_gtk_widget_set_margin_bottom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_is_disabled",sl_gdk_pixbuf_format_is_disabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_is_important",sl_gtk_tool_item_set_is_important,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_insert_after",sl_gtk_list_store_insert_after,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_has_suffix",sl_g_str_has_suffix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_parent_window",sl_gtk_widget_get_parent_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_style",sl_pango_font_description_get_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_mc_link_local",sl_g_inet_address_get_is_mc_link_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_select_region",sl_gtk_label_select_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_copy",sl_g_date_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_steal_data",sl_g_object_steal_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_type_hint_get_type",sl_gdk_window_type_hint_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_widget_new",sl_gtk_color_chooser_widget_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_new",sl_gtk_font_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_has_attribute",sl_g_file_info_has_attribute,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_action_group",sl_gtk_widget_get_action_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_right_margin",sl_gtk_page_setup_get_right_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_manager_get_display",sl_gdk_device_manager_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_allocate",sl_gtk_widget_queue_allocate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_filter_return_get_type",sl_gdk_filter_return_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_has_selection",sl_gtk_print_operation_get_has_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_style_context",sl_gtk_widget_get_style_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_save",sl_gtk_style_context_save,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_has_tag",sl_gtk_text_iter_has_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_preview_text",sl_gtk_font_chooser_get_preview_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_add_days",sl_g_date_add_days,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_get_domain",sl_g_network_service_get_domain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_scale_factor",sl_gtk_widget_get_scale_factor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_data_as_bytes",sl_g_variant_get_data_as_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_input_hints",sl_gtk_text_view_get_input_hints,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_shared_context",sl_gdk_gl_context_get_shared_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_quark_try_string",sl_g_quark_try_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_inside_word",sl_gtk_text_iter_inside_word,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_license",sl_gtk_about_dialog_get_license,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_product_id",sl_gdk_device_get_product_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_get_scope_id",sl_g_inet_socket_address_get_scope_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_new_from_stock",sl_gtk_tool_button_new_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_drop_group",sl_gtk_tool_palette_get_drop_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_get_string",sl_g_hmac_get_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_set_encoding",sl_g_io_channel_set_encoding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_targets_include_text",sl_gtk_targets_include_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_volume",sl_g_mount_get_volume,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_unlock",sl_gtk_accel_group_unlock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor",sl_g_file_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_toplevel",sl_gtk_widget_is_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_dup_bytestring_array",sl_g_variant_dup_bytestring_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_prepend_search_path",sl_gtk_icon_theme_prepend_search_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_parent",sl_gtk_widget_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_number_up",sl_gtk_print_settings_set_number_up,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_set_source_pixbuf",sl_gdk_cairo_set_source_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_window_type",sl_gtk_window_get_window_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_events",sl_gdk_window_set_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_children",sl_gtk_container_get_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_position",sl_gdk_device_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_get_take_focus",sl_gtk_menu_shell_get_take_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_skip_taskbar_hint",sl_gdk_window_set_skip_taskbar_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_completion",sl_gtk_entry_get_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_start",sl_g_timer_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_load_contents_finish",sl_g_file_load_contents_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_copyright",sl_gtk_about_dialog_set_copyright,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_order",sl_g_date_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_range_rect",sl_gtk_range_get_range_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_relief_style",sl_gtk_tool_item_get_relief_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_pixbuf_column",sl_gtk_icon_view_set_pixbuf_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_ft2_font_map_get_type",sl_pango_ft2_font_map_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_starts_sentence",sl_gtk_text_iter_starts_sentence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_line",sl_gtk_text_iter_backward_visible_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_print_settings",sl_gtk_print_operation_get_print_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_interactive",sl_gtk_text_buffer_insert_interactive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_show_icons",sl_gtk_recent_chooser_set_show_icons,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_wrap_mode",sl_gtk_text_view_get_wrap_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_width_mm",sl_gdk_screen_get_width_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_width",sl_gtk_paper_size_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_manager_get_client_pointer",sl_gdk_device_manager_get_client_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_background_new",sl_pango_attr_background_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_cancel",sl_gtk_menu_shell_cancel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_main",sl_gtk_main,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_pad_controller_set_action",sl_gtk_pad_controller_set_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_switcher_get_stack",sl_gtk_stack_switcher_get_stack,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_init_template",sl_gtk_widget_init_template,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_set_pack_direction",sl_gtk_menu_bar_set_pack_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_inverted",sl_gtk_level_bar_get_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_add_provider",sl_gtk_style_context_add_provider,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_default_icon_name",sl_gtk_window_get_default_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_drop",sl_gdk_drag_drop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_filter",sl_gtk_recent_chooser_get_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_get_length",sl_gtk_entry_buffer_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_describe_with_absolute_size",sl_pango_font_describe_with_absolute_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_buffer",sl_gtk_text_view_set_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_text",sl_gtk_text_buffer_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_has_volumes",sl_g_drive_has_volumes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_find_prev_char",sl_g_utf8_find_prev_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_hexpand_set",sl_gtk_widget_set_hexpand_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_hide_titlebar_when_maximized",sl_gtk_window_set_hide_titlebar_when_maximized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_child_anchor_get_deleted",sl_gtk_text_child_anchor_get_deleted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_get_script",sl_g_unichar_get_script,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_headers_visible",sl_gtk_tree_view_get_headers_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_remove_row",sl_gtk_grid_remove_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_iter_at_offset",sl_gtk_text_buffer_get_iter_at_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_set_tooltip_markup",sl_gtk_tool_item_set_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_has_grab",sl_gtk_widget_has_grab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_unregister_serialize_format",sl_gtk_text_buffer_unregister_serialize_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_add_filter",sl_gtk_recent_chooser_add_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_documenters",sl_gtk_about_dialog_get_documenters,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_remove",sl_gtk_container_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_tool_button_new",sl_gtk_toggle_tool_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_remove_accelerator",sl_gtk_widget_remove_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_get_type",sl_gtk_cell_layout_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_get_type",sl_gdk_pixbuf_simple_anim_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_header_relief",sl_gtk_tool_item_group_get_header_relief,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_prgname",sl_g_get_prgname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_child_changed",sl_gtk_flow_box_child_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_subpixbuf",sl_gdk_pixbuf_new_subpixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_show",sl_gdk_window_show,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_priority",sl_g_notification_set_priority,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_source",sl_g_binding_get_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_invisible_get_screen",sl_gtk_invisible_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_custom",sl_gtk_tooltip_set_custom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_type",sl_gtk_tree_view_column_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid",sl_g_date_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pre_parse_libgtk_only",sl_gdk_pre_parse_libgtk_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_groups",sl_g_key_file_get_groups,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_scroll_deltas",sl_gdk_event_get_scroll_deltas,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_has_media",sl_g_drive_has_media,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_get_position",sl_gtk_editable_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_dup",sl_g_file_info_dup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timeout_source_new_seconds",sl_g_timeout_source_new_seconds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_group_position",sl_gtk_tool_palette_get_group_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_copy",sl_pango_font_description_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_validate_len",sl_g_utf8_validate_len,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_lines",sl_gtk_text_iter_forward_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_overlay_scrolling",sl_gtk_scrolled_window_get_overlay_scrolling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_load_from_file",sl_g_bookmark_file_load_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_comments",sl_gtk_about_dialog_get_comments,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace_contents",sl_g_file_replace_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_error_trap_pop_ignored",sl_gdk_error_trap_pop_ignored,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_n_children",sl_gtk_tree_model_iter_n_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_get_center_widget",sl_gtk_action_bar_get_center_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_subtract_months",sl_g_date_subtract_months,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_add_mime_type",sl_gtk_file_filter_add_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_homogeneous",sl_gtk_stack_get_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_read_pixels",sl_gdk_pixbuf_read_pixels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_unset_state_flags",sl_gtk_widget_unset_state_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_inverted",sl_gtk_range_get_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_owner_get",sl_gdk_selection_owner_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_get_loop",sl_gdk_pixbuf_simple_anim_get_loop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_set_enabled",sl_g_simple_action_set_enabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_is_private",sl_g_bookmark_file_get_is_private,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_device_position",sl_gdk_window_get_device_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_convert_path_to_child_path",sl_gtk_tree_model_filter_convert_path_to_child_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_set_name",sl_gtk_file_filter_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_reset",sl_g_settings_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_load_from_file",sl_g_key_file_load_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_set_show_close_button",sl_gtk_info_bar_set_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_is_media_check_automatic",sl_g_drive_is_media_check_automatic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_set_menu_model",sl_gtk_menu_button_set_menu_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_visibility",sl_gtk_entry_get_visibility,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_state",sl_gtk_widget_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_upper",sl_gtk_adjustment_get_upper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_offscreen_window_get_surface",sl_gdk_offscreen_window_get_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_set_buffered",sl_g_io_channel_set_buffered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_age",sl_gtk_recent_filter_add_age,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_subpixel_layout",sl_gdk_monitor_get_subpixel_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_contents",sl_g_file_get_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_add_accel_group",sl_gtk_window_add_accel_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_get_child_revealed",sl_gtk_revealer_get_child_revealed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_get_child_non_homogeneous",sl_gtk_button_box_get_child_non_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_pos",sl_gtk_notebook_get_tab_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_eject_with_operation_finish",sl_g_drive_eject_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_set_use_alpha",sl_gtk_color_chooser_set_use_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_connect",sl_g_socket_connect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_int16",sl_g_variant_new_int16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_error_quark",sl_gtk_css_provider_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_set_color",sl_pango_renderer_set_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_prepend_item",sl_g_menu_prepend_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_weekday",sl_g_date_get_weekday,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default",sl_gtk_window_set_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_uint64",sl_g_key_file_get_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_ref_sink",sl_g_param_spec_ref_sink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_bidi_type_for_unichar",sl_pango_bidi_type_for_unichar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_copy",sl_gtk_icon_info_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_objects_from_string",sl_gtk_builder_add_objects_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_show_not_found",sl_gtk_recent_chooser_get_show_not_found,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new",sl_gtk_radio_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_right_margin",sl_gtk_text_view_get_right_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_put_event",sl_gdk_display_put_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_pulse_step",sl_gtk_progress_bar_set_pulse_step,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_fits_pointer",sl_g_value_fits_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_adjustment",sl_gtk_range_get_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_status_string",sl_gtk_print_operation_get_status_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rgba_to_string",sl_gdk_rgba_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_hsv_to_rgb",sl_gtk_hsv_to_rgb,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_hide_on_delete",sl_gtk_widget_hide_on_delete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_unfullscreen",sl_gtk_window_unfullscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_symlink_target",sl_g_file_info_get_symlink_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_string_to_unsigned",sl_g_ascii_string_to_unsigned,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_error_quark",sl_g_regex_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_domain",sl_g_mount_operation_set_domain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isdigit",sl_g_unichar_isdigit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_select_uri",sl_gtk_file_chooser_select_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_get_buffer_condition",sl_g_io_channel_get_buffer_condition,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_add_value",sl_g_variant_builder_add_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_has_item",sl_gtk_recent_manager_has_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_remove_child_source",sl_g_source_remove_child_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_reverse",sl_gtk_print_job_set_reverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_iter_at_position",sl_gtk_text_view_get_iter_at_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_number_up_layout",sl_gtk_print_settings_set_number_up_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_new",sl_gtk_list_box_row_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_column_homogeneous",sl_gtk_grid_set_column_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_is_symlink",sl_g_file_info_set_is_symlink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_reset",sl_gtk_event_controller_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_embed_page_setup",sl_gtk_print_operation_set_embed_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_app_menu",sl_gtk_application_get_app_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_has_item",sl_g_bookmark_file_has_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_preferred_width",sl_gtk_cell_renderer_get_preferred_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_format_secondary_text",sl_gtk_message_dialog_format_secondary_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_desktop",sl_gtk_places_sidebar_get_show_desktop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_type",sl_gtk_cell_renderer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_workarea",sl_gdk_screen_get_monitor_workarea,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_add_button_with_target_value",sl_g_notification_add_button_with_target_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_set_label_align",sl_gtk_frame_set_label_align,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_paper_size_and_default_margins",sl_gtk_page_setup_set_paper_size_and_default_margins,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_new_with_backend",sl_g_settings_new_with_backend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_set_baseline_position",sl_gtk_box_set_baseline_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_adjustment",sl_gtk_range_set_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_run",sl_gtk_print_operation_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dgettext",sl_g_dgettext,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_copy_target_list",sl_gtk_text_buffer_get_copy_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_uri_scheme",sl_g_file_get_uri_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_attribute_connect",sl_gtk_cell_area_attribute_connect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_new",sl_gtk_tree_model_filter_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_set_header",sl_gtk_list_box_row_set_header,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_get_selectable",sl_gtk_list_box_row_get_selectable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_fixed_move",sl_gtk_fixed_move,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_edge_get_type",sl_gdk_window_edge_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_markup_column",sl_gtk_icon_view_get_markup_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_icon_set",sl_gtk_image_get_icon_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_inline_completion",sl_gtk_entry_completion_get_inline_completion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_pages",sl_gtk_print_job_get_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_new",sl_gtk_tree_row_reference_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_new",sl_g_simple_action_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_pointer_is_grabbed",sl_gdk_display_pointer_is_grabbed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_update_policy",sl_gtk_spin_button_get_update_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_lower_stepper_sensitivity",sl_gtk_range_set_lower_stepper_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_lookup_data",sl_g_resource_lookup_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_allocation",sl_gtk_cell_area_context_get_allocation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_menu_label_text",sl_gtk_notebook_get_menu_label_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_string_list",sl_g_key_file_set_string_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_menu_get_type",sl_gtk_recent_chooser_menu_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_object",sl_g_file_info_set_attribute_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_switcher_set_stack",sl_gtk_stack_switcher_set_stack,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_pixels_above_lines",sl_gtk_text_view_set_pixels_above_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_listenv",sl_g_listenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_dup_strv",sl_g_variant_dup_strv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_capabilities_get_type",sl_gtk_print_capabilities_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_set_flags",sl_g_io_channel_set_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_modifier_intent_get_type",sl_gdk_modifier_intent_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_option",sl_g_socket_set_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_new",sl_g_menu_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_suggested_action",sl_gdk_drag_context_get_suggested_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_cancel",sl_g_file_monitor_cancel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_action",sl_gtk_file_chooser_set_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_clear_regions",sl_gtk_widget_path_iter_clear_regions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_split",sl_g_regex_split,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_hard_margins",sl_gtk_print_context_get_hard_margins,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_transform",sl_g_value_transform,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_is_legacy",sl_gdk_gl_context_is_legacy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_x_offset",sl_gtk_tree_view_column_get_x_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_icon_from_gicon",sl_gtk_tooltip_set_icon_from_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_map_virtual_modifiers",sl_gdk_keymap_map_virtual_modifiers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_get_type",sl_gtk_switch_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_comment",sl_g_key_file_get_comment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_get_track_motion",sl_gtk_drag_dest_get_track_motion,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new_with_area_and_entry",sl_gtk_combo_box_new_with_area_and_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_visible_rect",sl_gtk_tree_view_get_visible_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_tooltip_markup",sl_gtk_widget_get_tooltip_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_new_file",sl_g_io_channel_new_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_int64",sl_g_variant_get_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_string_get_depth_",sl_g_variant_type_string_get_depth_,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_multicast_ttl",sl_g_socket_get_multicast_ttl,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_lower",sl_gtk_adjustment_set_lower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_n_channels",sl_gdk_pixbuf_get_n_channels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_ref_sink",sl_g_variant_ref_sink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_escape_string",sl_g_regex_escape_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_placement",sl_gtk_scrolled_window_set_placement,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_merge_child_input_shapes",sl_gdk_window_merge_child_input_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_parser_finished",sl_gtk_buildable_parser_finished,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_has_stencil_buffer",sl_gtk_gl_area_get_has_stencil_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_register_dnd",sl_gdk_window_register_dnd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_get_group",sl_gtk_radio_tool_button_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_scale_factor",sl_gdk_monitor_get_scale_factor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_uris",sl_gtk_clipboard_wait_for_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_mime_type",sl_g_bookmark_file_get_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_resource",sl_gtk_image_new_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_set_column_types",sl_gtk_list_store_set_column_types,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_show_border",sl_gtk_notebook_set_show_border,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_get_name",sl_gtk_recent_filter_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_tags",sl_gtk_text_iter_get_tags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_for_display",sl_gdk_keymap_get_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_ellipsize",sl_gtk_tool_item_group_get_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_toupper",sl_g_ascii_toupper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_time_t",sl_g_date_set_time_t,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_modifier_mask",sl_gdk_keymap_get_modifier_mask,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_set_icon_name",sl_gtk_drag_source_set_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_area",sl_gtk_cell_area_context_get_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_base_scale",sl_gtk_icon_info_get_base_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_open_flags",sl_gtk_places_sidebar_get_open_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_button_sensitivity",sl_gtk_combo_box_get_button_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_has_window",sl_gtk_widget_get_has_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new_from_key_file",sl_gtk_paper_size_new_from_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_new",sl_gtk_app_chooser_widget_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_islower",sl_g_unichar_islower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_focus_hadjustment",sl_gtk_container_set_focus_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_get_attribute_value",sl_g_menu_item_get_attribute_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_new_with_mnemonic",sl_gtk_expander_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_load_bytes",sl_g_file_load_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_invisible_set_screen",sl_gtk_invisible_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_frame_clock",sl_gtk_style_context_get_frame_clock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_set_device_tool",sl_gdk_event_set_device_tool,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_enable_synchronized_configure",sl_gdk_window_enable_synchronized_configure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_cell_get_position",sl_gtk_tree_view_column_cell_get_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_pending",sl_g_main_context_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_ancestor",sl_gtk_widget_get_ancestor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_get_default",sl_g_settings_backend_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_parse_args",sl_gdk_parse_args,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_set_menu",sl_gtk_menu_tool_button_set_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_map",sl_gtk_widget_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_add_filter",sl_gtk_file_chooser_add_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_text_orientation",sl_gtk_tool_shell_get_text_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_vadjustment",sl_gtk_tree_view_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_row_spacing",sl_gtk_icon_view_set_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_propagate_natural_width",sl_gtk_scrolled_window_set_propagate_natural_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_data",sl_g_variant_get_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_entry_free",sl_gtk_target_entry_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_nth_child",sl_gtk_tree_model_iter_nth_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_gravity",sl_gtk_window_get_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_is_composited",sl_gdk_screen_is_composited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_get_emblems",sl_g_emblemed_icon_get_emblems,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_n_pages",sl_gtk_assistant_get_n_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_word_end",sl_gtk_text_iter_forward_word_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_minor_version",sl_gtk_get_minor_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_add_accelerator",sl_gtk_widget_add_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_mnemonics_visible",sl_gtk_window_set_mnemonics_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_value",sl_g_key_file_set_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_shadow_width",sl_gdk_window_set_shadow_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_expand_all",sl_gtk_tree_view_expand_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_move_before",sl_gtk_tree_store_move_before,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_supports_files",sl_g_app_info_supports_files,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_active",sl_gtk_menu_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_device_events",sl_gtk_widget_set_device_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_use_preview_label",sl_gtk_file_chooser_set_use_preview_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_description",sl_gtk_printer_get_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_file_for_path",sl_g_vfs_get_file_for_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unicode_canonical_ordering",sl_g_unicode_canonical_ordering,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_status",sl_gtk_print_job_get_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_symbolic_for_style",sl_gtk_icon_info_load_symbolic_for_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_allocation",sl_gtk_widget_set_allocation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_logo_icon_name",sl_gtk_about_dialog_get_logo_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_selection_mode",sl_gtk_flow_box_set_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_language",sl_pango_context_get_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_is_tcrypt_hidden_volume",sl_g_mount_operation_get_is_tcrypt_hidden_volume,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_volume_button_get_type",sl_gtk_volume_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_new_from_file",sl_gtk_print_settings_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_container",sl_g_variant_is_container,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_string",sl_g_settings_set_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_prepend_text",sl_gtk_combo_box_text_prepend_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_charset_converter_get_use_fallback",sl_g_charset_converter_get_use_fallback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_column",sl_gtk_tree_view_get_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_get_type",sl_gtk_revealer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_strv",sl_g_settings_get_strv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_current_uri",sl_gtk_recent_chooser_get_current_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_support_multidevice",sl_gtk_widget_set_support_multidevice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_dup_object",sl_g_value_dup_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_unselect_path",sl_gtk_icon_view_unselect_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_fixed_height_mode",sl_gtk_tree_view_set_fixed_height_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_default",sl_gdk_display_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_add_child",sl_gtk_buildable_add_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_default_page_size",sl_gtk_printer_get_default_page_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_is_active",sl_gtk_printer_is_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_grab",sl_gdk_device_grab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_get_format",sl_gdk_pixbuf_loader_get_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_get_spacing",sl_gtk_box_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_context_changed",sl_pango_layout_context_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_dtostr",sl_g_ascii_dtostr,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_difference",sl_g_date_time_difference,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_query_child_packing",sl_gtk_box_query_child_packing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_uris",sl_gtk_selection_data_get_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_is_mutable",sl_g_menu_model_is_mutable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_use_underline",sl_gtk_tool_button_set_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_get_type",sl_gtk_radio_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_resolution",sl_gtk_print_settings_set_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_direction",sl_gtk_widget_get_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_type",sl_gtk_clipboard_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_compute_expand",sl_gtk_widget_queue_compute_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_gravity_get_for_script_and_width",sl_pango_gravity_get_for_script_and_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_compare",sl_g_date_time_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_count_selected_rows",sl_gtk_tree_selection_count_selected_rows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_insert_before",sl_gtk_list_store_insert_before,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_add_action_widget",sl_gtk_info_bar_add_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_is_mime_type",sl_g_content_type_is_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_release_fd",sl_g_cancellable_release_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_device",sl_gdk_drag_context_get_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_compute_checksum_for_data",sl_g_compute_checksum_for_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_type",sl_gtk_gl_area_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_type",sl_gtk_grid_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_has_padding",sl_gtk_assistant_get_page_has_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_pack_end",sl_gtk_action_bar_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_to_timeval",sl_g_date_time_to_timeval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_to_string",sl_g_file_attribute_matcher_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_word_start",sl_gtk_text_iter_backward_visible_word_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cairo_should_draw_window",sl_gtk_cairo_should_draw_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_unmap",sl_gtk_widget_unmap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_has_details",sl_gtk_printer_has_details,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_widget_new",sl_gtk_recent_chooser_widget_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_emit_event",sl_g_file_monitor_emit_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_new_with_label",sl_gtk_link_button_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_focus_on_map",sl_gdk_window_set_focus_on_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_drag_get_start_point",sl_gtk_gesture_drag_get_start_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_authors",sl_gtk_about_dialog_get_authors,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_variant",sl_g_variant_type_is_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_set_transition_type",sl_gtk_revealer_set_transition_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_remove_tag_by_name",sl_gtk_text_buffer_remove_tag_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_load_contents",sl_g_file_load_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_from_unix_local",sl_g_date_time_new_from_unix_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best_with_both",sl_gdk_visual_get_best_with_both,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_get_type",sl_gtk_check_menu_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_child_shapes",sl_gdk_window_set_child_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_main_iteration_do",sl_gtk_main_iteration_do,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_iter_location",sl_gtk_text_view_get_iter_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_item_padding",sl_gtk_icon_view_get_item_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_unref",sl_g_settings_schema_key_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_disable_setlocale",sl_gtk_disable_setlocale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dcgettext",sl_g_dcgettext,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_orientation",sl_gtk_page_setup_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_reset",sl_g_cancellable_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_item_activated",sl_gtk_icon_view_item_activated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_at_window",sl_gdk_screen_get_monitor_at_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get",sl_gtk_print_settings_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_vadjustment",sl_gtk_text_view_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_new_dict_entry",sl_g_variant_type_new_dict_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strrstr",sl_g_strrstr,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_support_selection",sl_gtk_print_unix_dialog_get_support_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_type",sl_gtk_list_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_val_to_iso8601",sl_g_time_val_to_iso8601,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_ismark",sl_g_unichar_ismark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_load_from_dirs",sl_g_key_file_load_from_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_unregister_deserialize_format",sl_gtk_text_buffer_unregister_deserialize_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_documenters",sl_gtk_about_dialog_set_documenters,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_name_quark",sl_g_param_spec_get_name_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_mount",sl_g_volume_get_mount,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_type",sl_gdk_event_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_set_seed",sl_g_rand_set_seed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_key_ref",sl_g_settings_schema_key_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_number",sl_gdk_screen_get_number,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_new",sl_gdk_event_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_set_hotspot",sl_gdk_drag_context_set_hotspot,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_set_proxy",sl_gtk_drag_dest_set_proxy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_starts_display_line",sl_gtk_text_view_starts_display_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_load_file",sl_gtk_print_settings_load_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_digit_value",sl_g_unichar_digit_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_get_pack_direction",sl_gtk_menu_bar_get_pack_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_menu_new_for_manager",sl_gtk_recent_chooser_menu_new_for_manager,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_pack1",sl_gtk_paned_pack1,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_ellipsize",sl_gtk_progress_bar_get_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_scroll_direction_get_type",sl_gdk_scroll_direction_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_show_text",sl_gtk_progress_bar_get_show_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_read_pixel_bytes",sl_gdk_pixbuf_read_pixel_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_add_emblem",sl_g_emblemed_icon_add_emblem,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_unref",sl_g_variant_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_set_reveal_child",sl_gtk_revealer_set_reveal_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_screen",sl_gdk_visual_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_is_input_only",sl_gdk_window_is_input_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_use_size",sl_gtk_font_button_get_use_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblem_new_with_origin",sl_g_emblem_new_with_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_cancel",sl_g_cancellable_cancel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_integer",sl_g_key_file_set_integer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_box_new",sl_gtk_event_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_set",sl_pango_coverage_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_applications",sl_gtk_recent_info_get_applications,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_credentials_get_native",sl_g_credentials_get_native,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_type",sl_g_proxy_address_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_frame_time",sl_gdk_frame_clock_get_frame_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_focus",sl_gtk_cell_area_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_remove_filter",sl_gtk_recent_chooser_remove_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_socket_address_get_address",sl_g_inet_socket_address_get_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_files",sl_gtk_file_chooser_get_files,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_capture_count",sl_g_regex_get_capture_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_to_upper",sl_gdk_keyval_to_upper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unicode_script_from_iso15924",sl_g_unicode_script_from_iso15924,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_unset_model_drag_source",sl_gtk_icon_view_unset_model_drag_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_locale_string_list",sl_g_key_file_set_locale_string_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_get_choice",sl_g_mount_operation_get_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_seek_position",sl_g_io_channel_seek_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_version_string",sl_pango_version_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_context",sl_pango_layout_get_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_bytestring",sl_g_variant_get_bytestring,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_homogeneous",sl_gtk_flow_box_get_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_mnemonics_visible",sl_gtk_window_get_mnemonics_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_get_image",sl_gdk_cursor_get_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_set_name",sl_gtk_recent_filter_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_int",sl_g_value_set_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_ref",sl_g_object_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_string_number",sl_g_regex_get_string_number,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_axis",sl_gdk_event_get_axis,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_get_image",sl_gtk_message_dialog_get_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_accel_new",sl_gtk_cell_renderer_accel_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_default",sl_gtk_paper_size_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_name",sl_g_get_user_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_set_name",sl_gtk_buildable_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_store",sl_g_variant_store,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_fill_level",sl_gtk_range_set_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_root_origin",sl_gdk_window_get_root_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_get_resolution",sl_pango_cairo_font_map_get_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_shape_new",sl_pango_attr_shape_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_get_child_by_name",sl_gtk_stack_get_child_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_is_first_of_month",sl_g_date_is_first_of_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_current_page",sl_gtk_assistant_get_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_is_ancestor",sl_gtk_widget_is_ancestor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_apply_tag_by_name",sl_gtk_text_buffer_apply_tag_by_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_themed_icon_new",sl_g_themed_icon_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_default_group",sl_gdk_display_get_default_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_list_icons",sl_gtk_icon_theme_list_icons,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_get_cursor_type",sl_gdk_cursor_get_cursor_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_local_only",sl_gtk_places_sidebar_set_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_new_with_model",sl_gtk_tree_model_sort_new_with_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_mnemonic_activate",sl_gtk_widget_mnemonic_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_debug_flags",sl_gtk_get_debug_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_get_port",sl_g_network_address_get_port,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_child1",sl_gtk_paned_get_child1,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_set_device",sl_gdk_drag_context_set_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_peek_event",sl_gdk_display_peek_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_create_pango_layout",sl_gtk_widget_create_pango_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_has_alpha",sl_gtk_gl_area_set_has_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_junction_sides",sl_gtk_style_context_get_junction_sides,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_move_visually",sl_gtk_text_view_move_visually,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_wrap_mode",sl_gtk_text_view_set_wrap_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_selected_items",sl_gtk_icon_view_get_selected_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_rise_new",sl_pango_attr_rise_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_add_from_string",sl_gtk_builder_add_from_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_split_full",sl_g_regex_split_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_baseline_row",sl_gtk_grid_set_baseline_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_num_lock_state",sl_gdk_keymap_get_num_lock_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_add_supports_type",sl_g_app_info_add_supports_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_is_of_type",sl_g_variant_is_of_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_set_can_recurse",sl_g_source_set_can_recurse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_matches_only",sl_g_file_attribute_matcher_matches_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_new",sl_gtk_menu_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_draw_page_finish",sl_gtk_print_operation_draw_page_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_row_inserted",sl_gtk_tree_model_row_inserted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_current_uri",sl_gtk_label_get_current_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_delete_interactive",sl_gtk_text_buffer_delete_interactive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_upper_stepper_sensitivity",sl_gtk_range_get_upper_stepper_sensitivity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_menu_item_new",sl_gtk_separator_menu_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_beep",sl_gdk_window_beep,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_set_icon_size",sl_gtk_toolbar_set_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_base_size",sl_gtk_icon_info_get_base_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_has_icon",sl_gtk_icon_theme_has_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_is_save_option_supported",sl_gdk_pixbuf_format_is_save_option_supported,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_job_name",sl_gtk_print_operation_set_job_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_maximal_cursor_size",sl_gdk_display_get_maximal_cursor_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_runtime_dir",sl_g_get_user_runtime_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_grab_info_libgtk_only",sl_gdk_device_grab_info_libgtk_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_get_item_attribute_value",sl_g_menu_model_get_item_attribute_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_service_finish",sl_g_resolver_lookup_service_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_error_from_errno",sl_g_file_error_from_errno,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_screen",sl_gtk_window_set_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_new",sl_g_main_loop_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_includes_script",sl_pango_language_includes_script,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_get_accel_width",sl_gtk_accel_label_get_accel_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_printer_lpi",sl_gtk_print_settings_get_printer_lpi,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_int64",sl_g_file_info_set_attribute_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_allocated_baseline",sl_gtk_widget_get_allocated_baseline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_parse_name",sl_g_file_parse_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_decompose",sl_g_unichar_decompose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_remote_address",sl_g_socket_get_remote_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_name",sl_g_volume_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_select_path",sl_gtk_icon_view_select_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_new",sl_gtk_flow_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_max_lookbehind",sl_g_regex_get_max_lookbehind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_get_type",sl_gtk_level_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_item_orientation",sl_gtk_icon_view_get_item_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_custom_title",sl_gtk_header_bar_get_custom_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_copy",sl_gtk_selection_data_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_symlink_target",sl_g_file_info_set_symlink_target,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_line",sl_gtk_text_iter_forward_visible_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_volume_for_uuid",sl_g_volume_monitor_get_volume_for_uuid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_propagate_natural_height",sl_gtk_scrolled_window_get_propagate_natural_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_version",sl_gtk_about_dialog_set_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_add_seconds",sl_g_date_time_add_seconds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_invisible_new",sl_gtk_invisible_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_get_type",sl_g_file_attribute_info_list_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_type",sl_gdk_frame_clock_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_new",sl_gtk_overlay_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_settings",sl_gtk_widget_get_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_free",sl_g_variant_type_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_serial",sl_pango_layout_get_serial,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_parse_detailed_name",sl_g_action_parse_detailed_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_height",sl_pango_font_metrics_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_pop_thread_default",sl_g_main_context_pop_thread_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_print_detailed_name",sl_g_action_print_detailed_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_set_custom_theme",sl_gtk_icon_theme_set_custom_theme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_exclusive",sl_gtk_tool_palette_get_exclusive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_frame_counter",sl_gdk_frame_clock_get_frame_counter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_vadjustment",sl_gtk_viewport_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_get_type",sl_gtk_paned_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_attach",sl_g_source_attach,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gravity_get_type",sl_gdk_gravity_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_make_display_name",sl_gdk_screen_make_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_set_accel_path",sl_gtk_menu_item_set_accel_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_accept_focus",sl_gdk_window_get_accept_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_free",sl_gtk_tree_row_reference_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_selection_set_mode",sl_gtk_tree_selection_set_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_hour",sl_g_date_time_get_hour,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_size",sl_g_file_info_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_preferred_size",sl_gtk_cell_renderer_get_preferred_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_green_pixel_details",sl_gdk_visual_get_green_pixel_details,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_show_fallback",sl_gtk_app_chooser_widget_set_show_fallback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_can_stop",sl_g_drive_can_stop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_enumerate_children",sl_g_resource_enumerate_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_free",sl_g_key_file_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_version",sl_pango_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_get_type",sl_g_resolver_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_path",sl_gtk_widget_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_decorated",sl_gtk_window_set_decorated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_mime_types",sl_gdk_pixbuf_format_get_mime_types,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_iter_get_type",sl_gdk_pixbuf_animation_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_markup",sl_pango_layout_set_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_error_bell",sl_gtk_widget_error_bell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_get_digest",sl_g_hmac_get_digest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_show_default",sl_gtk_app_chooser_widget_get_show_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_edit_name",sl_g_file_info_get_edit_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_lookup_key",sl_gdk_keymap_lookup_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_option",sl_gtk_render_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_toplevel",sl_gdk_window_get_toplevel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_wrap",sl_pango_layout_get_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_vborder",sl_gtk_notebook_get_tab_vborder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_remove_choice",sl_gtk_file_chooser_remove_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_decoration_layout",sl_gtk_header_bar_set_decoration_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_get_current_grab",sl_gtk_window_group_get_current_grab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_set_name",sl_g_source_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_get_type",sl_pango_font_map_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_to_string",sl_gtk_css_provider_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_parent",sl_gdk_window_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_source_device",sl_gdk_event_get_source_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_print_pages",sl_gtk_print_settings_get_print_pages,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_has_key",sl_gtk_print_settings_has_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_get_type",sl_gtk_text_tag_table_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_ref",sl_gtk_recent_info_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_is_activatable",sl_gtk_cell_renderer_is_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_orientation",sl_gtk_print_settings_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_get_minimum_increment",sl_gtk_adjustment_get_minimum_increment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_text",sl_gtk_text_iter_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_error",sl_gtk_print_operation_get_error,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_selectable",sl_gtk_label_get_selectable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_image",sl_gtk_clipboard_wait_for_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_added",sl_g_bookmark_file_get_added,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_toggles_tag",sl_gtk_text_iter_toggles_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_grab_focus",sl_gtk_widget_grab_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_markup",sl_gtk_text_buffer_insert_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_process_all_updates",sl_gdk_window_process_all_updates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf16_to_ucs4",sl_g_utf16_to_ucs4,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_fetch_named_pos",sl_g_match_info_fetch_named_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_title",sl_gtk_window_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_max_length",sl_gtk_entry_get_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_timeout",sl_g_socket_set_timeout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_get_add_tearoffs",sl_gtk_combo_box_get_add_tearoffs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_screen",sl_gdk_display_get_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_apply_attributes",sl_gtk_cell_area_apply_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_targets",sl_gtk_selection_data_get_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_get_shadow_type",sl_gtk_frame_get_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_dir_rewind",sl_g_dir_rewind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_monitor_at_window",sl_gdk_display_get_monitor_at_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_set_time_val",sl_g_date_set_time_val,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_builder_open",sl_g_variant_builder_open,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strcompress",sl_g_strcompress,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_free",sl_g_match_info_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_refresh_info",sl_gdk_frame_clock_get_refresh_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_add_targets",sl_gtk_selection_add_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_cell_allocation",sl_gtk_cell_area_get_cell_allocation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_get_positions_in_pixels",sl_pango_tab_array_get_positions_in_pixels,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_to_string",sl_pango_language_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_type",sl_gtk_assistant_set_page_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_changed",sl_g_settings_backend_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_search",sl_gtk_text_iter_backward_search,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_append_separator",sl_gtk_app_chooser_button_append_separator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_has_handler_pending",sl_g_signal_has_handler_pending,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_indent",sl_gtk_text_view_set_indent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_popup",sl_gtk_menu_button_get_popup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_create_pango_layout",sl_gtk_print_context_create_pango_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_title",sl_gtk_tree_view_column_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_supports_clipboard_persistence",sl_gdk_display_supports_clipboard_persistence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_preferred_height_for_width",sl_gtk_cell_renderer_get_preferred_height_for_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_assign",sl_gtk_text_iter_assign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_name_finish",sl_g_resolver_lookup_by_name_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_accepts_tab",sl_gtk_text_view_set_accepts_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_boolean",sl_g_file_info_get_attribute_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_stick",sl_gtk_window_stick,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_is_tcrypt_system_volume",sl_g_mount_operation_set_is_tcrypt_system_volume,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_get_child_secondary",sl_gtk_button_box_get_child_secondary,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_can_be_executable",sl_g_content_type_can_be_executable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_lookup",sl_g_settings_schema_source_lookup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_string_is_valid",sl_g_variant_type_string_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_new",sl_gtk_tool_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_window",sl_gtk_text_view_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_index",sl_pango_layout_iter_get_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_restack",sl_gdk_window_restack,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_label_widget",sl_gtk_tool_button_get_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strstr_len",sl_g_strstr_len,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_style",sl_gtk_toolbar_get_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_tip_area",sl_gtk_tooltip_set_tip_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_label",sl_gtk_label_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_get_items",sl_gtk_recent_manager_get_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_complete",sl_gtk_assistant_set_page_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_make_current",sl_gdk_gl_context_make_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_classify",sl_g_variant_classify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_pack_start",sl_gtk_cell_area_box_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_fullscreen_mode_get_type",sl_gdk_fullscreen_mode_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_create",sl_g_file_create,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_set_active",sl_gtk_toggle_button_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_select_day",sl_gtk_calendar_select_day,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_manager_purge_items",sl_gtk_recent_manager_purge_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_use_drag_window",sl_gtk_tool_item_get_use_drag_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_type",sl_gtk_about_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_gravity_get_for_script",sl_pango_gravity_get_for_script,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_text",sl_gtk_clipboard_wait_for_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_icon_widget",sl_gtk_tool_button_set_icon_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_handlers_destroy",sl_g_signal_handlers_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accessible_connect_widget_destroyed",sl_gtk_accessible_connect_widget_destroyed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_clear_object",sl_g_clear_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_unicode_to_keyval",sl_gdk_unicode_to_keyval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_key_new",sl_gtk_event_controller_key_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_set_source_color",sl_gdk_cairo_set_source_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_get_group",sl_gtk_radio_button_get_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_visited",sl_g_bookmark_file_set_visited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_new",sl_gtk_cell_view_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_set_collapsed",sl_gtk_tool_item_group_set_collapsed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strescape",sl_g_strescape,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_take_ref",sl_g_variant_take_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_unset",sl_g_value_unset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_deleted",sl_gtk_text_mark_get_deleted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_groups_activate",sl_gtk_accel_groups_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_backend_path_writable_changed",sl_g_settings_backend_path_writable_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_new",sl_g_file_attribute_info_list_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_num_copies",sl_gtk_print_job_set_num_copies,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_new_any",sl_g_inet_address_new_any,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_type",sl_gtk_recent_info_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_attribute_get_column",sl_gtk_cell_area_attribute_get_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_is_native",sl_g_file_is_native,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isalnum",sl_g_unichar_isalnum,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_pack_start",sl_gtk_cell_layout_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_uint64",sl_g_value_set_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_get_dpi_y",sl_gtk_print_context_get_dpi_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_new_from_file",sl_gtk_builder_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_convert_widget_to_bin_window_coords",sl_gtk_tree_view_convert_widget_to_bin_window_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_connect_closure",sl_g_signal_connect_closure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_format",sl_g_date_time_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_size_allocate_with_baseline",sl_gtk_widget_size_allocate_with_baseline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_tooltip_text",sl_gtk_entry_set_icon_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_quark_to_string",sl_g_quark_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_absolute_size",sl_pango_font_description_set_absolute_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_mnemonic_modifier",sl_gtk_window_get_mnemonic_modifier,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_hard_margins",sl_gtk_printer_get_hard_margins,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_swipe_new",sl_gtk_gesture_swipe_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_new_for_pixbuf",sl_gtk_icon_info_new_for_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_codeset",sl_g_get_codeset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_to_string",sl_gtk_style_context_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_prepend_page",sl_gtk_assistant_prepend_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_family",sl_g_inet_address_get_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_variant",sl_pango_font_description_get_variant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_visited",sl_gtk_recent_info_get_visited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_load",sl_g_resource_load,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_serial",sl_pango_context_get_serial,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_free",sl_gtk_text_iter_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_default",sl_g_main_context_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_get_underline_position",sl_pango_font_metrics_get_underline_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_interactive_debugging",sl_gtk_window_set_interactive_debugging,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_select_multiple",sl_gtk_recent_chooser_get_select_multiple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_width_chars",sl_gtk_label_get_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_family_is_variable",sl_pango_font_family_is_variable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_show_new",sl_pango_attr_show_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_release",sl_g_main_context_release,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_append_column",sl_gtk_tree_view_append_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_alignment",sl_gtk_entry_set_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_file",sl_gtk_file_chooser_set_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_face_get_face_name",sl_pango_font_face_get_face_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_media_type",sl_gtk_print_settings_set_media_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_mnemonic_widget",sl_gtk_label_set_mnemonic_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_language",sl_gtk_text_iter_get_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_vadjustment",sl_gtk_tree_view_get_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_get_type",sl_gtk_event_controller_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_append_to_finish",sl_g_file_append_to_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_popdown",sl_gtk_popover_popdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_break_type",sl_g_unichar_break_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_child_type",sl_gtk_container_child_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_generic_icon_name",sl_g_content_type_get_generic_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_next_line",sl_pango_layout_iter_next_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_ref",sl_g_match_info_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_format",sl_gtk_selection_data_get_format,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_type",sl_g_vfs_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_list_attributes",sl_g_file_info_list_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_line",sl_gtk_text_iter_backward_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_stretch",sl_pango_font_description_get_stretch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_is_recognized",sl_gtk_gesture_is_recognized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_merge_static",sl_pango_font_description_merge_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_lower",sl_gdk_window_lower,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_copy",sl_gdk_event_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_mount_operation_set_parent",sl_gtk_mount_operation_set_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_iterate_item_attributes",sl_g_menu_model_iterate_item_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_path_is_selected",sl_gtk_icon_view_path_is_selected,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_scale",sl_gtk_print_settings_get_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_sink",sl_g_param_spec_sink,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_reverse",sl_gtk_print_job_get_reverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_compute_prefix",sl_gtk_entry_completion_compute_prefix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_min_content_height",sl_gtk_scrolled_window_get_min_content_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_byteswap",sl_g_variant_byteswap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_website_label",sl_gtk_about_dialog_set_website_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_get_transition_type",sl_gtk_revealer_get_transition_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_range",sl_gtk_spin_button_get_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_title",sl_gtk_tree_view_column_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_launch_context_get_startup_notify_id",sl_g_app_launch_context_get_startup_notify_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_geometry_changed",sl_gdk_window_geometry_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_lines",sl_gtk_text_iter_backward_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pango_layout_line_get_clip_region",sl_gdk_pango_layout_line_get_clip_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_load_icon_finish",sl_gtk_icon_info_load_icon_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_bool",sl_gtk_print_settings_set_bool,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_search_column",sl_gtk_tree_view_get_search_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_new_from_fd",sl_g_mapped_file_new_from_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_set_as_default_for_extension",sl_g_app_info_set_as_default_for_extension,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_type",sl_gtk_entry_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_paste_clipboard",sl_gtk_text_buffer_paste_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_new",sl_gtk_application_window_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_invalidate_sort",sl_gtk_list_box_invalidate_sort,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_new",sl_gtk_app_chooser_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_append",sl_gtk_combo_box_text_append,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_set_close_on_unref",sl_g_io_channel_set_close_on_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_read_finish",sl_g_file_read_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_rotate_new",sl_gtk_gesture_rotate_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_new",sl_gtk_combo_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_get_font_map",sl_pango_font_get_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_column_spacing",sl_gtk_grid_set_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_interpolate_size",sl_gtk_stack_set_interpolate_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_new",sl_gtk_text_mark_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_entry_get_type",sl_gtk_search_entry_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_dither",sl_gtk_print_settings_set_dither,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_font_name",sl_gtk_font_button_get_font_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_has_depth_buffer",sl_gtk_gl_area_set_has_depth_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_new_with_range",sl_gtk_spin_button_new_with_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_set_search_mode",sl_gtk_search_bar_set_search_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_chars",sl_gtk_text_iter_backward_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_is_rich_text_available",sl_gtk_clipboard_wait_is_rich_text_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_toupper",sl_g_unichar_toupper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_getenv",sl_g_getenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_step_increment",sl_gtk_adjustment_set_step_increment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_system_visual",sl_gdk_screen_get_system_visual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_unref",sl_g_settings_schema_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_dialog_new",sl_gtk_color_chooser_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_set_markup",sl_gtk_message_dialog_set_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_type",sl_gtk_css_section_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_page_increment",sl_gtk_adjustment_set_page_increment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_direction",sl_gtk_menu_button_get_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_quantize_line_geometry",sl_pango_quantize_line_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_popup",sl_gtk_popover_popup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_copy",sl_gtk_tree_row_reference_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_icon_set",sl_gtk_image_new_from_icon_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_use_stock",sl_gtk_button_get_use_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_get_n_groups",sl_gdk_device_pad_get_n_groups,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_new",sl_gtk_icon_theme_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_choose_icon",sl_gtk_icon_theme_choose_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_insert_action_markup",sl_gtk_entry_completion_insert_action_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_slider",sl_gtk_render_slider,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_bin_window",sl_gtk_tree_view_get_bin_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_cache_dir",sl_g_get_user_cache_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_register",sl_g_resources_register,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_set_alpha",sl_gtk_color_button_set_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_set_adjustment",sl_gtk_scale_button_set_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_lines",sl_gtk_label_set_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_context_set_cairo_context",sl_gtk_print_context_set_cairo_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_sort_type",sl_gtk_recent_chooser_get_sort_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_new",sl_gtk_tool_item_group_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_collapse_row",sl_gtk_tree_view_collapse_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_set_axis_use",sl_gdk_device_set_axis_use,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_mounts",sl_g_volume_monitor_get_mounts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_pad_controller_get_type",sl_gtk_pad_controller_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_is_inhibited",sl_gtk_application_is_inhibited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uri_parse_scheme",sl_g_uri_parse_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strrstr_len",sl_g_strrstr_len,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_time",sl_g_source_get_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_popup_fixed_width",sl_gtk_combo_box_set_popup_fixed_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_size",sl_gtk_window_set_default_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_line",sl_gtk_render_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_expand_to_path",sl_gtk_tree_view_expand_to_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_weight",sl_pango_font_description_get_weight,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_max_width_chars",sl_gtk_label_get_max_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_child_notify_by_pspec",sl_gtk_container_child_notify_by_pspec,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_sensitive",sl_gtk_widget_get_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spinner_get_type",sl_gtk_spinner_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_set_accel",sl_gtk_accel_label_set_accel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_dither",sl_gtk_print_settings_get_dither,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_x_to_index",sl_pango_layout_line_x_to_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_data",sl_gtk_selection_data_get_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_has_padding",sl_gtk_assistant_set_page_has_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_paper_height",sl_gtk_print_settings_get_paper_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_clear_current",sl_gdk_gl_context_clear_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_lock_button_set_permission",sl_gtk_lock_button_set_permission,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_prepend",sl_g_menu_prepend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_add_shortcut_folder_uri",sl_gtk_file_chooser_add_shortcut_folder_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_alignment",sl_pango_layout_set_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_from_pixbuf",sl_gtk_entry_set_icon_from_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_delete_selection",sl_gtk_text_buffer_delete_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_markup",sl_gtk_label_set_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_new",sl_gtk_application_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_type",sl_gtk_tree_model_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_clear_emblems",sl_g_emblemed_icon_clear_emblems,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_is_active",sl_g_timer_is_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_display_name",sl_gtk_icon_info_get_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_tool_item_set_draw",sl_gtk_separator_tool_item_set_draw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_read",sl_g_file_read,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_layout",sl_gtk_entry_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_check_class_cast",sl_g_type_check_class_cast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strchug",sl_g_strchug,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_point",sl_gtk_gesture_get_point,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_process_updates",sl_gdk_window_process_updates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_listen",sl_g_socket_listen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_bind_property",sl_g_object_bind_property,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_loop_get_context",sl_g_main_loop_get_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_double_buffered",sl_gtk_widget_get_double_buffered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_password_save",sl_g_mount_operation_set_password_save,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_ref",sl_g_time_zone_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_ref",sl_g_settings_schema_source_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_set_title",sl_gtk_file_chooser_button_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_get_type",sl_g_menu_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_multicast",sl_g_inet_address_get_is_multicast,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_get_network_metered",sl_g_network_monitor_get_network_metered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcuts_shortcut_get_type",sl_gtk_shortcuts_shortcut_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_validate",sl_g_unichar_validate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_page_side_image",sl_gtk_assistant_get_page_side_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_min_content_width",sl_gtk_scrolled_window_set_min_content_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_capabilities",sl_gdk_seat_get_capabilities,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_delay",sl_g_settings_delay,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_new_section",sl_g_menu_item_new_section,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_input_mode_get_type",sl_gdk_input_mode_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_get_widget",sl_gtk_event_controller_get_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_type",sl_gtk_print_settings_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_valid",sl_gtk_tree_row_reference_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_new_with_mnemonic",sl_gtk_button_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_activate_on_single_click",sl_gtk_list_box_get_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_clicked",sl_gtk_tree_view_column_clicked,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_data_type",sl_gtk_selection_data_get_data_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_new",sl_gtk_style_context_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_variations_static",sl_pango_font_description_set_variations_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_get_instance_count",sl_g_type_get_instance_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_set_accelerator",sl_gtk_shortcut_label_set_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_show_fill_level",sl_gtk_range_set_show_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_bind_property_with_closures",sl_g_object_bind_property_with_closures,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_activate_on_single_click",sl_gtk_tree_view_get_activate_on_single_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_type",sl_gtk_file_chooser_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_widget_get_type",sl_gtk_font_chooser_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_set_max_value",sl_gtk_level_bar_set_max_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_interface_age",sl_gtk_get_interface_age,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_accels_for_action",sl_gtk_application_get_accels_for_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_display_name",sl_gtk_recent_info_get_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_pulse",sl_gtk_progress_bar_pulse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_get_type",sl_gtk_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_show_fallback",sl_gtk_app_chooser_widget_get_show_fallback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_set_active",sl_gtk_switch_set_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_headers_visible",sl_gtk_tree_view_set_headers_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert",sl_gtk_text_buffer_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_get_type",sl_gtk_recent_filter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_is_maximized",sl_gtk_window_is_maximized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_edit_name",sl_g_file_info_set_edit_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_get_show_size",sl_gtk_font_button_get_show_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_scale",sl_gtk_style_context_set_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strchr",sl_g_utf8_strchr,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_to_file",sl_gtk_print_settings_to_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_icon_from_stock",sl_gtk_tooltip_set_icon_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_set_detail_height_rows",sl_gtk_calendar_set_detail_height_rows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_ellipsize",sl_pango_layout_get_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_in_destruction",sl_gtk_widget_in_destruction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_new",sl_gtk_toggle_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_type",sl_gtk_print_job_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_box_new",sl_gtk_cell_area_box_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_clear",sl_gtk_tree_view_column_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_remove_column",sl_gtk_tree_view_remove_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_set_resolution",sl_gdk_screen_set_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_set_upper",sl_gtk_adjustment_set_upper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_compute_expand",sl_gtk_widget_compute_expand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_right_margin",sl_gtk_page_setup_set_right_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_new_from_model",sl_g_menu_item_new_from_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_can_remove_supports_type",sl_g_app_info_can_remove_supports_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_type",sl_gtk_places_sidebar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_compare",sl_gtk_tree_path_compare,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_editable",sl_gtk_text_view_set_editable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_pop_current",sl_g_cancellable_pop_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_dialog_get_type",sl_gtk_app_chooser_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_add_window",sl_gtk_application_add_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_mc_org_local",sl_g_inet_address_get_is_mc_org_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_row_spacing",sl_gtk_flow_box_set_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_remove_weak_pointer",sl_g_object_remove_weak_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_foreground_alpha_new",sl_pango_attr_foreground_alpha_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_set_label_widget",sl_gtk_frame_set_label_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_name_is_valid",sl_g_action_name_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_tool_get_type",sl_gdk_device_tool_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_message_dialog_new",sl_gtk_message_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_set_value_pos",sl_gtk_scale_set_value_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_get_type",sl_g_input_stream_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_hash",sl_g_variant_type_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_overwrite",sl_gtk_text_view_get_overwrite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_language_get_sample_string",sl_pango_language_get_sample_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_new",sl_pango_coverage_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_transient_for",sl_gdk_window_set_transient_for,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_remove_mnemonic",sl_gtk_window_remove_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_iconv_open",sl_g_iconv_open,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_tool_button_get_type",sl_gtk_toggle_tool_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_get_type",sl_g_file_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_visible_line_index",sl_gtk_text_iter_get_visible_line_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_realized",sl_gtk_widget_set_realized,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_free",sl_pango_font_description_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_gravity_hint_new",sl_pango_attr_gravity_hint_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_clear_attributes",sl_gtk_cell_layout_clear_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_entry_text_column",sl_gtk_combo_box_set_entry_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_icon_name",sl_gtk_image_set_from_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_halign",sl_gtk_widget_get_halign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_day_of_year",sl_g_date_time_get_day_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strup",sl_g_ascii_strup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_to_gvariant",sl_gtk_file_filter_to_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_website",sl_gtk_about_dialog_get_website,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_add",sl_g_file_attribute_info_list_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_events",sl_gdk_window_get_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_zoom_get_scale_delta",sl_gtk_gesture_zoom_get_scale_delta,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_button_get_type",sl_gtk_check_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_comment",sl_g_key_file_set_comment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uri_list_extract_uris",sl_g_uri_list_extract_uris,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_copy",sl_gdk_pixbuf_format_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_char",sl_g_value_get_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_signal_handler_disconnect",sl_g_signal_handler_disconnect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_n_copies",sl_gtk_print_settings_set_n_copies,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_name",sl_gtk_widget_path_iter_has_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_get_active",sl_gtk_check_menu_item_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_has_application",sl_gtk_recent_info_has_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_override_cursor",sl_gtk_widget_override_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_microsecond",sl_g_date_time_get_microsecond,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drawing_context_get_cairo_context",sl_gdk_drawing_context_get_cairo_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_ellipsize",sl_gtk_label_set_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_font_description",sl_pango_layout_get_font_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_get_type",sl_gdk_display_manager_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_use_underline",sl_gtk_expander_set_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_display",sl_gdk_monitor_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_set_use_underline",sl_gtk_button_set_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_monitor_geometry",sl_gdk_screen_get_monitor_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_opacity",sl_gtk_widget_set_opacity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_recent",sl_gtk_places_sidebar_get_show_recent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_new",sl_gtk_file_chooser_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_add_events",sl_gtk_widget_add_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_show_hidden",sl_gtk_file_chooser_set_show_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new_from_ipp",sl_gtk_paper_size_new_from_ipp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_cell_is_visible",sl_gtk_tree_view_column_cell_is_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_new",sl_gtk_dialog_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_append_type",sl_gtk_widget_path_append_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_show_fill_level",sl_gtk_range_get_show_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_null_settings_backend_new",sl_g_null_settings_backend_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_file_for_uri",sl_g_vfs_get_file_for_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_window",sl_gtk_widget_set_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_uri_unescape_string",sl_g_uri_unescape_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_dialog_get_type",sl_gtk_file_chooser_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_qclass",sl_gtk_widget_path_iter_has_qclass,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_icon_name",sl_gtk_printer_get_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keymap_get_entries_for_keyval",sl_gdk_keymap_get_entries_for_keyval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_select_all",sl_gtk_flow_box_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_present",sl_gtk_window_present,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_justify",sl_gtk_label_get_justify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_link_local",sl_g_inet_address_get_is_link_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_event",sl_gtk_cell_area_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_line_wrap_mode",sl_gtk_label_set_line_wrap_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drawing_context_get_window",sl_gdk_drawing_context_get_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_new_loopback",sl_g_network_address_new_loopback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_reshow_with_initial_size",sl_gtk_window_reshow_with_initial_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_event",sl_gtk_text_tag_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_unset_icon_size",sl_gtk_toolbar_unset_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_new",sl_g_mapped_file_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_popup_at_rect",sl_gtk_menu_popup_at_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_set_show_menubar",sl_gtk_application_window_set_show_menubar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_init_with_debug_flags",sl_g_type_init_with_debug_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_type",sl_gtk_app_chooser_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_add_alpha",sl_gdk_pixbuf_add_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_attribute_disconnect",sl_gtk_cell_area_attribute_disconnect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_trigger_tooltip_query",sl_gtk_tooltip_trigger_tooltip_query,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_increments",sl_gtk_spin_button_get_increments,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_drop_targets_visible",sl_gtk_places_sidebar_set_drop_targets_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_composite_color",sl_gdk_pixbuf_composite_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_lookup",sl_g_simple_action_group_lookup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_create_context",sl_gtk_cell_area_create_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_background_color",sl_gtk_cell_view_set_background_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_frame_clock",sl_gdk_window_get_frame_clock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_drive",sl_g_mount_get_drive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_match_all",sl_g_regex_match_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_name",sl_gtk_text_mark_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_selection_owner_set_for_display",sl_gdk_selection_owner_set_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_lock_button_get_permission",sl_gtk_lock_button_get_permission,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_padding",sl_gtk_cell_renderer_get_padding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_add",sl_gtk_text_tag_table_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_backend",sl_gtk_printer_get_backend,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_parent_window",sl_gtk_widget_set_parent_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_get_mode",sl_gtk_toggle_button_get_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_use_underline",sl_gtk_button_get_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_justify",sl_pango_layout_get_justify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_day_of_month",sl_g_date_time_get_day_of_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_unregister",sl_g_resources_unregister,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_condition_wait",sl_g_socket_condition_wait,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_stretch",sl_pango_font_description_set_stretch,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_track_visited_links",sl_gtk_label_set_track_visited_links,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_row_spacing",sl_gtk_grid_get_row_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_byte_string",sl_g_file_set_attribute_byte_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_keep_above",sl_gdk_window_set_keep_above,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_utc",sl_g_date_time_new_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_type",sl_gtk_printer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_exists",sl_g_file_query_exists,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_show_glyph_string",sl_pango_cairo_show_glyph_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_resize_grip_is_visible",sl_gtk_window_resize_grip_is_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hmac_ref",sl_g_hmac_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_resizable",sl_gtk_window_set_resizable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_credentials",sl_g_socket_get_credentials,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_new",sl_gtk_cell_renderer_toggle_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_thaw_notify",sl_g_object_thaw_notify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_set_reallocate_redraws",sl_gtk_container_set_reallocate_redraws,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_restrict_to_fill_level",sl_gtk_range_get_restrict_to_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_header_image",sl_gtk_assistant_set_page_header_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_limit",sl_gtk_recent_chooser_get_limit,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_interface_install_property",sl_g_object_interface_install_property,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_current_folder",sl_gtk_file_chooser_set_current_folder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_is_end",sl_gtk_text_iter_is_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_print",sl_g_variant_print,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_width",sl_gdk_screen_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_load_icon_for_scale",sl_gtk_icon_theme_load_icon_for_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_single_line_mode",sl_gtk_label_get_single_line_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_get_type",sl_g_app_info_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_title",sl_gtk_header_bar_get_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_modal",sl_gtk_window_get_modal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_get_actions_for_accel",sl_gtk_application_get_actions_for_accel,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_font_description",sl_pango_context_set_font_description,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_int_with_default",sl_gtk_print_settings_get_int_with_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_row_at_y",sl_gtk_list_box_get_row_at_y,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_width",sl_pango_layout_set_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_in_range",sl_gtk_text_iter_in_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_logo",sl_gtk_about_dialog_get_logo,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_append_page_menu",sl_gtk_notebook_append_page_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_requisition_get_type",sl_gtk_requisition_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_get_current_timings",sl_gdk_frame_clock_get_current_timings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_simple_action_group_add_entries",sl_g_simple_action_group_add_entries,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_license_type",sl_gtk_about_dialog_set_license_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_frame",sl_gtk_render_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_fill_level",sl_gtk_range_get_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_geometry",sl_gdk_window_get_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_from_gicon",sl_gtk_entry_set_icon_from_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_yalign",sl_gtk_label_set_yalign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_set_error_if_cancelled",sl_g_cancellable_set_error_if_cancelled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_invisible_get_type",sl_gtk_invisible_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_move_after",sl_gtk_list_store_move_after,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_prev",sl_gtk_tree_path_prev,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bytes_icon_new",sl_g_bytes_icon_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_visible",sl_gtk_cell_renderer_get_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_char_count",sl_gtk_text_buffer_get_char_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_last_event_window",sl_gdk_device_get_last_event_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_tool_get_tool_type",sl_gdk_device_tool_get_tool_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_stop_editing",sl_gtk_cell_area_stop_editing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_indent",sl_pango_layout_get_indent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_to_timezone",sl_g_date_time_to_timezone,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_toggle_get_active",sl_gtk_cell_renderer_toggle_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_get_type",sl_gtk_accel_label_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_event_sequence",sl_gdk_event_get_event_sequence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_set_text",sl_gtk_selection_data_set_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_load_from_data_dirs",sl_g_bookmark_file_load_from_data_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_context_get_resolution",sl_pango_cairo_context_get_resolution,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_get_use_alpha",sl_gtk_color_chooser_get_use_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_activatable",sl_gtk_entry_get_icon_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_delete_text",sl_gtk_entry_buffer_delete_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_clickable",sl_gtk_tree_view_column_set_clickable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_flags",sl_g_binding_get_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_merge_child_shapes",sl_gdk_window_merge_child_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_name",sl_gtk_widget_set_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_family",sl_gtk_font_chooser_get_font_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_zoom_new",sl_gtk_gesture_zoom_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_size",sl_g_bookmark_file_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_orientation",sl_gtk_tool_item_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_spacing",sl_gtk_icon_view_get_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_rgba_visual",sl_gdk_screen_get_rgba_visual,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_list_action_descriptions",sl_gtk_application_list_action_descriptions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_split_simple",sl_g_regex_split_simple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_sizing",sl_gtk_tree_view_column_get_sizing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_get_nick",sl_g_param_spec_get_nick,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_is_ipp",sl_gtk_paper_size_is_ipp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_restore",sl_gtk_style_context_restore,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_get_type",sl_gtk_button_box_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_is_closed",sl_gdk_display_is_closed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_rgb_to_hsv",sl_gtk_rgb_to_hsv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_height_mm",sl_gdk_screen_height_mm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_editable",sl_gtk_text_view_get_editable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_copy_attributes",sl_g_file_copy_attributes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_current_folder_file",sl_gtk_file_chooser_set_current_folder_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_has_region",sl_gtk_widget_path_iter_has_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_forward_display_line_end",sl_gtk_text_view_forward_display_line_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_get_item_row",sl_gtk_icon_view_get_item_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_grab_default",sl_gtk_widget_grab_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_range",sl_gtk_range_set_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_save_to_file",sl_g_key_file_save_to_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_type",sl_gtk_icon_info_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_lines",sl_gtk_text_iter_backward_visible_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_window_to_buffer_coords",sl_gtk_text_view_window_to_buffer_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_get_type",sl_gtk_color_chooser_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_vadjustment",sl_gtk_scrolled_window_set_vadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_icon_size",sl_gtk_toolbar_get_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_get_needed",sl_gtk_file_filter_get_needed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_new_with_model",sl_gtk_tree_view_new_with_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_insert_before",sl_pango_attr_list_insert_before,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_boolean",sl_g_key_file_get_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_label",sl_gtk_button_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_option",sl_g_socket_get_option,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_rubber_banding",sl_gtk_tree_view_set_rubber_banding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_quality",sl_gtk_print_settings_set_quality,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_type",sl_gtk_selection_data_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_get_chars",sl_gtk_editable_get_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_remove_mnemonic_label",sl_gtk_widget_remove_mnemonic_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_type",sl_gtk_text_buffer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_path_for_child",sl_gtk_container_get_path_for_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_set_child_non_homogeneous",sl_gtk_button_box_set_child_non_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_source_get_ready_time",sl_g_source_get_ready_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strtod",sl_g_strtod,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_icon_area",sl_gtk_entry_get_icon_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_receive_from",sl_g_socket_receive_from,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rectangle_get_type",sl_gdk_rectangle_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_unselect_file",sl_gtk_file_chooser_unselect_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_unselect_filename",sl_gtk_file_chooser_unselect_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_check_replacement",sl_g_regex_check_replacement,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_stylus_get_type",sl_gtk_gesture_stylus_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_get_size",sl_pango_tab_array_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_get_height",sl_gdk_pixbuf_animation_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_class_peek_static",sl_g_type_class_peek_static,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_activate_focus",sl_gtk_window_activate_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_trapezoid",sl_pango_renderer_draw_trapezoid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_iter_get_delay_time",sl_gdk_pixbuf_animation_iter_get_delay_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_body",sl_g_notification_set_body,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_drag_dest_item",sl_gtk_icon_view_set_drag_dest_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_as_string",sl_g_file_info_get_attribute_as_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_deselect",sl_gtk_menu_item_deselect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_child_anchor_new",sl_gtk_text_child_anchor_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_activate_item",sl_gtk_menu_shell_activate_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_new_julian",sl_g_date_new_julian,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_select",sl_gtk_menu_item_select,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_style",sl_gtk_tool_shell_get_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_attribute_iter_get_type",sl_g_menu_attribute_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_register_serialize_tagset",sl_gtk_text_buffer_register_serialize_tagset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_reserve_toggle_size",sl_gtk_menu_get_reserve_toggle_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_preview_file",sl_gtk_file_chooser_get_preview_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_rebuild_menu",sl_gtk_tool_item_rebuild_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_toggled_tags",sl_gtk_text_iter_get_toggled_tags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_set_stock_id",sl_gtk_tool_button_set_stock_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_replace",sl_g_regex_replace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_set_target_list",sl_gtk_drag_source_set_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_column_spacing",sl_gtk_flow_box_get_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_receives_default",sl_gtk_widget_get_receives_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_monitor_get_type",sl_g_file_monitor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_display",sl_gdk_device_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_parent",sl_gtk_css_section_get_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_get_inline_selection",sl_gtk_entry_completion_get_inline_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_notify_startup_complete",sl_gdk_display_notify_startup_complete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_string_from_iter",sl_gtk_tree_model_get_string_from_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_random_int_range",sl_g_random_int_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_pack_start",sl_gtk_header_bar_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_maybe",sl_g_variant_get_maybe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_key",sl_g_variant_type_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_new_from_file",sl_gdk_pixbuf_animation_new_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_filter",sl_gtk_file_chooser_set_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_get_icon",sl_g_drive_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_insert_after",sl_gtk_tree_store_insert_after,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_steal_qdata",sl_g_object_steal_qdata,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_destination_hostname",sl_g_proxy_address_get_destination_hostname,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_group",sl_gtk_recent_filter_add_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_guess",sl_g_content_type_guess,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_n_copies",sl_gtk_print_settings_get_n_copies,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_double",sl_gtk_print_settings_set_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_insert",sl_gtk_text_buffer_get_insert,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_set_drop_highlight_item",sl_gtk_toolbar_set_drop_highlight_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_remove_column",sl_gtk_grid_remove_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_changed",sl_pango_font_map_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_poll_mountable_finish",sl_g_file_poll_mountable_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_close",sl_gdk_pixbuf_loader_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_set_render_icon_pixbuf",sl_gtk_icon_set_render_icon_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_alignment",sl_gtk_tree_view_column_get_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_error_quark",sl_gtk_print_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_source",sl_gdk_device_get_source,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_peek_path",sl_g_file_peek_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_new",sl_gtk_revealer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_invalidate_headers",sl_gtk_list_box_invalidate_headers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_uint32",sl_g_file_info_set_attribute_uint32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_set_alpha",sl_pango_renderer_set_alpha,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_shell_bind_model",sl_gtk_menu_shell_bind_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_box_set_center_widget",sl_gtk_box_set_center_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_preferred_height",sl_gtk_cell_area_get_preferred_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_tab_detachable",sl_gtk_notebook_set_tab_detachable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_get_type",sl_gtk_file_chooser_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_composite_name",sl_gtk_widget_get_composite_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_find_enclosing_mount_finish",sl_g_file_find_enclosing_mount_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_loopback",sl_g_inet_address_get_is_loopback,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_shortcut_label_get_accelerator",sl_gtk_shortcut_label_get_accelerator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_zlib_compressor_get_type",sl_g_zlib_compressor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_convert_child_iter_to_iter",sl_gtk_tree_model_sort_convert_child_iter_to_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_visible_cursor_positions",sl_gtk_text_iter_forward_visible_cursor_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_device_cursor",sl_gdk_window_set_device_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_family",sl_pango_font_description_set_family,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_alignment",sl_pango_layout_get_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_visible_child_full",sl_gtk_stack_set_visible_child_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_get_n_screens",sl_gdk_display_get_n_screens,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_response",sl_gtk_dialog_response,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_configure",sl_gtk_spin_button_configure,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_compute_checksum_for_string",sl_g_compute_checksum_for_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_bind",sl_g_settings_bind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_sync",sl_g_settings_sync,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_pixels_below_lines",sl_gtk_text_view_set_pixels_below_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_get_glyph_extents",sl_pango_font_get_glyph_extents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_set_pixbuf",sl_gtk_selection_data_set_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_sort_key",sl_g_mount_get_sort_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_uint64",sl_g_file_info_get_attribute_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_rebuild_menu",sl_gtk_tool_shell_rebuild_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_set_buffer_size",sl_g_io_channel_set_buffer_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_show_now",sl_gtk_widget_show_now,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_child_get_index",sl_gtk_flow_box_child_get_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_get_focus_hadjustment",sl_gtk_container_get_focus_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_available_bytes",sl_g_socket_get_available_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_append_index",sl_gtk_tree_path_append_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_event_controller_motion_get_type",sl_gtk_event_controller_motion_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_parse_uri",sl_g_network_address_parse_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_button_new_with_mnemonic",sl_gtk_check_button_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_activation_root",sl_g_volume_get_activation_root,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_real_time",sl_g_get_real_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_is_wrapped",sl_pango_layout_is_wrapped,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_dup",sl_g_app_info_dup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_shutdown",sl_g_io_channel_shutdown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_set_show_dialog_item",sl_gtk_app_chooser_button_set_show_dialog_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_toolbar_reconfigured",sl_gtk_tool_item_toolbar_reconfigured,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_pad_get_n_features",sl_gdk_device_pad_get_n_features,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblemed_icon_get_type",sl_g_emblemed_icon_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_collate_key",sl_g_utf8_collate_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_monday_week_of_year",sl_g_date_get_monday_week_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_collate_key_for_filename",sl_g_utf8_collate_key_for_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_input_stream_close",sl_g_input_stream_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_int64",sl_g_key_file_set_int64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_realize",sl_gtk_widget_realize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_system_data_dirs",sl_g_get_system_data_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_text_get_active_text",sl_gtk_combo_box_text_get_active_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_new",sl_gtk_frame_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_set_label",sl_gtk_frame_set_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_end",sl_gtk_widget_get_margin_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_set_disabled",sl_gdk_pixbuf_format_set_disabled,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_static_gravities",sl_gdk_window_set_static_gravities,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_manager_get_type",sl_gdk_device_manager_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_text_alignment",sl_gtk_tool_item_get_text_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_hadjustment",sl_gtk_viewport_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_default_handler",sl_g_file_query_default_handler,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_get",sl_pango_coverage_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_set_position",sl_gtk_paned_set_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_error_underline",sl_pango_renderer_draw_error_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_opacity",sl_gdk_window_set_opacity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_get_state",sl_gtk_widget_path_iter_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_pack_end",sl_gtk_cell_layout_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_root_window",sl_gtk_widget_get_root_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_iconify",sl_gdk_window_iconify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_drop_item",sl_gtk_tool_item_group_get_drop_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_to_gvariant",sl_gtk_page_setup_to_gvariant,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_current_item",sl_gtk_recent_chooser_get_current_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_get_preferred_width",sl_gtk_cell_area_context_get_preferred_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_from_icon_name",sl_gtk_entry_set_icon_from_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_activity",sl_gtk_render_activity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_lookup_color",sl_gtk_style_context_lookup_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_copy",sl_gtk_page_setup_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_tmp_dir",sl_g_get_tmp_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_enum",sl_g_settings_get_enum,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_row_expanded",sl_gtk_tree_view_row_expanded,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_composite_color_simple",sl_gdk_pixbuf_composite_color_simple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_set_default_action_and_target_value",sl_g_notification_set_default_action_and_target_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_copy",sl_g_checksum_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_is_important",sl_gtk_tool_item_get_is_important,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_spacing",sl_gtk_icon_view_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_int16",sl_g_variant_get_int16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_type_get_type",sl_gdk_device_type_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_enum",sl_g_value_set_enum,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_max_width_chars",sl_gtk_entry_set_max_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_state_hint",sl_g_action_get_state_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_list",sl_g_param_spec_pool_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_menu_set_show_numbers",sl_gtk_recent_chooser_menu_set_show_numbers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_type",sl_gtk_spin_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_new",sl_gtk_builder_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_iszerowidth",sl_g_unichar_iszerowidth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_rubber_banding",sl_gtk_tree_view_get_rubber_banding,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_unref",sl_g_file_attribute_matcher_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_user_config_dir",sl_g_get_user_config_dir,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_default_interface_peek",sl_g_type_default_interface_peek,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_clock_begin_updating",sl_gdk_frame_clock_begin_updating,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_skip_taskbar_hint",sl_gtk_window_get_skip_taskbar_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_setenv",sl_g_setenv,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_clip",sl_gtk_widget_get_clip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_expander_set_spacing",sl_gtk_expander_set_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_is_activatable",sl_gtk_cell_area_is_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_source_window",sl_gdk_drag_context_get_source_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_load_file",sl_gtk_page_setup_load_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_box_set_child_secondary",sl_gtk_button_box_set_child_secondary,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_side_image",sl_gtk_assistant_set_page_side_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strtod",sl_g_ascii_strtod,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_remove",sl_gtk_cell_area_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_new",sl_gtk_print_job_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_app_info",sl_g_bookmark_file_get_app_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_protocol_get_type",sl_gdk_drag_protocol_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_strcasecmp",sl_g_ascii_strcasecmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_get_pattern",sl_g_regex_get_pattern,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_inverted",sl_gtk_range_set_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollbar_new",sl_gtk_scrollbar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_inline_selection",sl_gtk_entry_completion_set_inline_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_test_render_sync",sl_gdk_test_render_sync,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_has_frame",sl_gtk_entry_get_has_frame,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_attach_buffers",sl_gtk_gl_area_attach_buffers,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_metrics_ref",sl_pango_font_metrics_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_pan_get_orientation",sl_gtk_gesture_pan_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_address_finish",sl_g_resolver_lookup_by_address_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_get_length",sl_g_inet_address_mask_get_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_filter_add_pixbuf_formats",sl_gtk_recent_filter_add_pixbuf_formats,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_notify_startup_complete_with_id",sl_gdk_notify_startup_complete_with_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_drag_highlight_row",sl_gtk_list_box_drag_highlight_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_uint32",sl_g_file_info_get_attribute_uint32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_current_page",sl_gtk_assistant_set_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_duplex",sl_gtk_print_settings_set_duplex,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_str_tokenize_and_fold",sl_g_str_tokenize_and_fold,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_from_bytes",sl_g_variant_new_from_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_column_spacing",sl_gtk_flow_box_set_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_get_width",sl_gtk_tree_view_column_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_stop_mountable_finish",sl_g_file_stop_mountable_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_set_font",sl_gtk_font_chooser_set_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_title",sl_gdk_window_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_set_show_arrow",sl_gtk_toolbar_set_show_arrow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_resize",sl_gtk_window_resize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paned_set_wide_handle",sl_gtk_paned_set_wide_handle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_activate",sl_gtk_widget_activate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_preferred_width_for_height",sl_gtk_cell_area_get_preferred_width_for_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_get_identifier",sl_g_time_zone_get_identifier,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_switcher_get_type",sl_gtk_stack_switcher_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_convert_case",sl_gdk_keyval_convert_case,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_starts_tag",sl_gtk_text_iter_starts_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_new",sl_gtk_entry_completion_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_sort_indicator",sl_gtk_tree_view_column_set_sort_indicator,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_set_message_type",sl_gtk_info_bar_set_message_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_intern_static_string",sl_g_intern_static_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_to_string",sl_gtk_tree_path_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_boolean",sl_g_settings_set_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_hash",sl_g_variant_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_new",sl_gtk_stack_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_starts_word",sl_gtk_text_iter_starts_word,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_debug_updates",sl_gdk_window_set_debug_updates,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_has_namespace",sl_g_file_info_has_namespace,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_cell_area",sl_gtk_tree_view_get_cell_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new_with_label",sl_gtk_radio_menu_item_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_table_new_from_list",sl_gtk_target_table_new_from_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_button_get_type",sl_gtk_menu_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_reply",sl_g_mount_operation_reply,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_event_window",sl_gtk_button_get_event_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_new",sl_gtk_grid_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_calculate_rowstride",sl_gdk_pixbuf_calculate_rowstride,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_int",sl_g_value_get_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_take_object",sl_g_value_take_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_remove_group",sl_g_bookmark_file_remove_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_double",sl_g_key_file_set_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_attribute_string",sl_g_file_info_set_attribute_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_model",sl_gtk_tree_view_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_license",sl_gtk_about_dialog_set_license,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_source_events",sl_gdk_window_get_source_events,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_context_set_font_options",sl_pango_cairo_context_set_font_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_app_paintable",sl_gtk_widget_set_app_paintable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_previous",sl_gtk_tree_model_iter_previous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_targets_include_uri",sl_gtk_selection_data_targets_include_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_hash",sl_g_date_time_hash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_mark_paint_from_clip",sl_gdk_window_mark_paint_from_clip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_get_type",sl_g_network_service_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_set_focus_on_click",sl_gtk_file_chooser_button_set_focus_on_click,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_records_finish",sl_g_resolver_lookup_records_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_get_type",sl_gtk_tree_model_sort_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_is_grouped_with",sl_gtk_gesture_is_grouped_with,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_has_prefix",sl_g_file_has_prefix,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_strrchr",sl_g_utf8_strrchr,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_value",sl_gtk_spin_button_get_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_to_bytes",sl_g_inet_address_to_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_set_as_default_for_type",sl_g_app_info_set_as_default_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_variations",sl_pango_font_description_get_variations,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_focus_on_map",sl_gdk_window_get_focus_on_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_provider_new",sl_gtk_css_provider_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_spinner_get_type",sl_gtk_cell_renderer_spinner_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_service",sl_g_resolver_lookup_service,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_cursor_visible",sl_gtk_text_view_set_cursor_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_set_as_last_used_for_type",sl_g_app_info_set_as_last_used_for_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_reparent",sl_gtk_widget_reparent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_n_children",sl_g_variant_n_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_new",sl_gtk_info_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_new_with_buffer",sl_gtk_entry_new_with_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_halign",sl_gtk_widget_set_halign,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_new_for_font_type",sl_pango_cairo_font_map_new_for_font_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_set_show_close_button",sl_gtk_header_bar_set_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_tool_button_new",sl_gtk_radio_tool_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_checksum_reset",sl_g_checksum_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_tab_label_text",sl_gtk_notebook_set_tab_label_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_get_type",sl_gtk_radio_menu_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_device_grab_add",sl_gtk_device_grab_add,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_keyval",sl_gdk_event_get_keyval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_map_load_font",sl_pango_font_map_load_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_native_get_cancel_label",sl_gtk_file_chooser_native_get_cancel_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_rgba_get_type",sl_gdk_rgba_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_from_bytes",sl_pango_coverage_from_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_drive",sl_g_volume_get_drive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_trash",sl_gtk_places_sidebar_get_show_trash,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ucs4_to_utf8",sl_g_ucs4_to_utf8,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_detail_width_chars",sl_gtk_calendar_get_detail_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_input_hints",sl_gtk_text_view_set_input_hints,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_flags",sl_gtk_tree_model_get_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_new_for_commandline_arg_and_cwd",sl_g_file_new_for_commandline_arg_and_cwd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_get_menu",sl_gtk_menu_tool_button_get_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_new",sl_gtk_entry_buffer_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_tool_get_serial",sl_gdk_device_tool_get_serial,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_blocking",sl_g_socket_get_blocking,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_modification_time",sl_g_file_info_get_modification_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_gicon",sl_gtk_image_get_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_delete",sl_g_app_info_delete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_sidebar_get_stack",sl_gtk_stack_sidebar_get_stack,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_size_request",sl_gtk_widget_set_size_request,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_add_button",sl_gtk_dialog_add_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_flush",sl_gdk_window_flush,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_state",sl_gtk_cell_renderer_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_menu_item_new",sl_gtk_check_menu_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_pool_new",sl_g_param_spec_pool_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_path_copy",sl_gtk_tree_path_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_sensitive",sl_gtk_entry_set_icon_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_buildable_get_internal_child",sl_gtk_buildable_get_internal_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_get_is_any",sl_g_inet_address_get_is_any,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_name",sl_g_mount_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_id_column",sl_gtk_combo_box_set_id_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_unstick",sl_gdk_window_unstick,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_group",sl_gdk_window_set_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_is_backup",sl_g_file_info_get_is_backup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_set_page_title",sl_gtk_assistant_set_page_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_proxy_address_get_uri",sl_g_proxy_address_get_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_native_dialog_set_title",sl_gtk_native_dialog_set_title,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_widget_get_type",sl_gtk_color_chooser_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_link_button_get_uri",sl_gtk_link_button_get_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_set_double_click_distance",sl_gdk_display_set_double_click_distance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_get_required_version",sl_gtk_gl_area_get_required_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_set_row_baseline_position",sl_gtk_grid_set_row_baseline_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_iter",sl_gtk_tree_model_get_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_modification_time",sl_g_file_info_set_modification_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_uint64",sl_g_variant_get_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_create_readwrite_finish",sl_g_file_create_readwrite_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_iter_is_valid",sl_gtk_tree_model_sort_iter_is_valid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_set_target_list",sl_gtk_drag_dest_set_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_add_uri_targets",sl_gtk_target_list_add_uri_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_capabilities_get_type",sl_gdk_seat_capabilities_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_label_get_accel_widget",sl_gtk_accel_label_get_accel_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_increments",sl_gtk_range_set_increments,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_icon",sl_g_content_type_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_frame_set_shadow_type",sl_gtk_frame_set_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_column_span_column",sl_gtk_combo_box_set_column_span_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_frame_clock",sl_gtk_style_context_set_frame_clock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_inverted",sl_gtk_progress_bar_get_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_new_with_markup",sl_gtk_cell_view_new_with_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_position",sl_gtk_window_set_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_info_list_dup",sl_g_file_attribute_info_list_dup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_new_from_inline",sl_gdk_pixbuf_new_from_inline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_cell_set_cell_data",sl_gtk_tree_view_column_cell_set_cell_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_parse_error_print_context",sl_g_variant_parse_error_print_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_run",sl_gtk_dialog_run,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new",sl_gtk_image_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_free",sl_gtk_selection_data_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_iter_children",sl_gtk_tree_model_iter_children,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_to_uri",sl_g_filename_to_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_has_selection",sl_gtk_print_unix_dialog_get_has_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_show_tabs",sl_gtk_notebook_set_show_tabs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_iconify",sl_gtk_window_iconify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_object_interface_find_property",sl_g_object_interface_find_property,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_surface_create_from_pixbuf",sl_gdk_cairo_surface_create_from_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_set_minimum_key_length",sl_gtk_entry_completion_set_minimum_key_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_types_get_registered",sl_g_content_types_get_registered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_type",sl_gtk_menu_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_remove_supports_type",sl_g_app_info_remove_supports_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_new_from_model",sl_gtk_menu_bar_new_from_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_leave_multicast_group",sl_g_socket_leave_multicast_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_set_center_widget",sl_gtk_action_bar_set_center_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_get_target_list",sl_gtk_drag_dest_get_target_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_new",sl_gtk_paper_size_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_unregister_window",sl_gtk_widget_unregister_window,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_get_bytes",sl_g_mapped_file_get_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_changed",sl_gtk_list_box_row_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_replace_readwrite",sl_g_file_replace_readwrite,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_set_app_menu",sl_gtk_application_set_app_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_start",sl_gtk_widget_set_margin_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_dest_add_text_targets",sl_gtk_drag_dest_add_text_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_iso8601_week_of_year",sl_g_date_get_iso8601_week_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_deletable",sl_gtk_window_set_deletable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_enable_tree_lines",sl_gtk_tree_view_set_enable_tree_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_remove_region",sl_gtk_style_context_remove_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_uuid",sl_g_mount_get_uuid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_family_new",sl_pango_attr_family_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_decoration_layout",sl_gtk_header_bar_get_decoration_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_seconds",sl_g_date_time_get_seconds,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_locale_variants",sl_g_get_locale_variants,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_file",sl_gtk_css_section_get_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_has_region",sl_gtk_style_context_has_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_link_iter_get_name",sl_g_menu_link_iter_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_accel_group",sl_gtk_menu_set_accel_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_second",sl_g_date_time_get_second,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_focus_visible",sl_gtk_window_get_focus_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_resolution_xy",sl_gtk_print_settings_set_resolution_xy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_background",sl_gtk_style_context_set_background,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_get_inconsistent",sl_gtk_toggle_button_get_inconsistent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_set_inverted",sl_gtk_progress_bar_set_inverted,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_background_rgba",sl_gtk_cell_view_set_background_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_decorated",sl_gtk_window_get_decorated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_chooser_dialog_get_type",sl_gtk_color_chooser_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_uri",sl_gtk_recent_info_get_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_set_fit_model",sl_gtk_cell_view_set_fit_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_surface",sl_gtk_image_set_from_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_add_choice",sl_gtk_file_chooser_add_choice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_get_exclusive",sl_gtk_gesture_single_get_exclusive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resources_open_stream",sl_g_resources_open_stream,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_size",sl_g_variant_get_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_ellipsize_mode",sl_gtk_tool_item_get_ellipsize_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_service_get_scheme",sl_g_network_service_get_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_open_tmp",sl_g_file_open_tmp,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_axis_flags_get_type",sl_gdk_axis_flags_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_unix_dialog_get_print_settings",sl_gtk_page_setup_unix_dialog_get_print_settings,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_targets_include_image",sl_gtk_selection_data_targets_include_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_pango_context",sl_gtk_widget_get_pango_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_unref",sl_g_main_context_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_revealed",sl_gtk_info_bar_get_revealed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_get_model",sl_gtk_tree_model_sort_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_check_button_new",sl_gtk_check_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_get_type",sl_gtk_tooltip_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_subtitle",sl_gtk_header_bar_get_subtitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_get_type",sl_gtk_popover_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_get_fixed_array",sl_g_variant_get_fixed_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_detail_height_rows",sl_gtk_calendar_get_detail_height_rows,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_table_remove",sl_gtk_text_tag_table_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_monotonic_time",sl_g_get_monotonic_time,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_scale",sl_gtk_style_context_get_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_increments",sl_gtk_spin_button_set_increments,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_get_object",sl_gtk_builder_get_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_rotate_get_type",sl_gtk_gesture_rotate_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_monitor",sl_gtk_menu_set_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_border_window_size",sl_gtk_text_view_get_border_window_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_week_numbering_year",sl_g_date_time_get_week_numbering_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_margin_start",sl_gtk_widget_get_margin_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_insert_pixbuf",sl_gtk_text_buffer_insert_pixbuf,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_set_sort_type",sl_gtk_recent_chooser_set_sort_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_content_type",sl_g_file_info_get_content_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_flags_get_type",sl_g_binding_flags_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_disconnect_key",sl_gtk_accel_group_disconnect_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_nth_bookmark",sl_gtk_places_sidebar_get_nth_bookmark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_get_type",sl_gtk_target_list_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_set_action_widget",sl_gtk_notebook_set_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_request_mode",sl_gtk_cell_area_get_request_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_source_fd",sl_gtk_print_job_set_source_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_set_gravity",sl_pango_font_description_set_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_new",sl_gtk_tree_view_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_dup_string",sl_g_variant_dup_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_angle",sl_gtk_label_get_angle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_name",sl_gtk_widget_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_get_active",sl_gtk_toggle_button_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_new_maybe",sl_g_variant_type_new_maybe,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_tool_button_get_type",sl_gtk_menu_tool_button_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_icon_name",sl_gtk_window_get_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_line_get_height",sl_pango_layout_line_get_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_accepts_ps",sl_gtk_printer_accepts_ps,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_sort_key",sl_g_volume_get_sort_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_icon_from_file",sl_gtk_window_set_icon_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_sort_reset_default_sort_func",sl_gtk_tree_model_sort_reset_default_sort_func,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_tag_new",sl_gtk_text_tag_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_page_setup",sl_gtk_print_unix_dialog_set_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_set_line_offset",sl_gtk_text_iter_set_line_offset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_add_child_at_anchor",sl_gtk_text_view_add_child_at_anchor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_new",sl_gtk_menu_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_is_hidden",sl_g_file_info_set_is_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_condition_timed_wait",sl_g_socket_condition_timed_wait,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_attach_next_to",sl_gtk_grid_attach_next_to,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_has_parent",sl_g_file_has_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_inner_cell_area",sl_gtk_cell_area_inner_cell_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_new_from_resource",sl_gtk_builder_new_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_has_visible_focus",sl_gtk_widget_has_visible_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_reset_im_context",sl_gtk_text_view_reset_im_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_skip_pager_hint",sl_gtk_window_set_skip_pager_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_set_has_origin",sl_gtk_scale_set_has_origin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_ends_tag",sl_gtk_text_iter_ends_tag,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_notification_new",sl_g_notification_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_row_set_activatable",sl_gtk_list_box_row_set_activatable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_app_info_can_delete",sl_g_app_info_can_delete,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_from_timeval_local",sl_g_date_time_new_from_timeval_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_free",sl_g_bookmark_file_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_queue_resize_no_redraw",sl_gtk_widget_queue_resize_no_redraw,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_label",sl_gtk_menu_item_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_path_skip_root",sl_g_path_skip_root,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_select_multiple",sl_gtk_file_chooser_set_select_multiple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_new_local",sl_g_time_zone_new_local,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_do_overwrite_confirmation",sl_gtk_file_chooser_set_do_overwrite_confirmation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_cursor_on_cell",sl_gtk_tree_view_set_cursor_on_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_source_add_text_targets",sl_gtk_drag_source_add_text_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_get_default",sl_g_network_monitor_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_set_orientation",sl_gtk_page_setup_set_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_int",sl_gtk_print_settings_set_int,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_accept_focus",sl_gtk_window_set_accept_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_get_type",sl_gtk_widget_path_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_manager_open_display",sl_gdk_display_manager_open_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_set_fixed_size",sl_gtk_cell_renderer_set_fixed_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_get_hadjustment",sl_gtk_scrollable_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_animation_new_from_resource",sl_gdk_pixbuf_animation_new_from_resource,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_sentence_end",sl_gtk_text_iter_forward_sentence_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_simple_anim_new",sl_gdk_pixbuf_simple_anim_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_get_uuid",sl_g_volume_get_uuid,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_word_start",sl_gtk_text_iter_backward_word_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_invisible_char",sl_gtk_entry_set_invisible_char,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resolver_lookup_by_name_with_flags_finish",sl_g_resolver_lookup_by_name_with_flags_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_rowstride",sl_gdk_pixbuf_get_rowstride,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strlcpy",sl_g_strlcpy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_new",sl_gtk_tree_view_column_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_button_get_width_chars",sl_gtk_file_chooser_button_get_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_monitor_can_reach_finish",sl_g_network_monitor_can_reach_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_n_pages_to_print",sl_gtk_print_operation_get_n_pages_to_print,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_shadow",sl_g_mount_shadow,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_is_hidden",sl_g_file_info_get_is_hidden,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_subtype_of",sl_g_variant_type_is_subtype_of,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_dict_entry",sl_g_variant_type_is_dict_entry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_type",sl_gdk_window_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_listen_backlog",sl_g_socket_get_listen_backlog,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_iterator_get_type",sl_pango_attr_iterator_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_unset_icon_size",sl_gtk_tool_palette_unset_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_get_label_with_keycode",sl_gtk_accelerator_get_label_with_keycode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_connect_to_server",sl_gtk_places_sidebar_get_show_connect_to_server,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_get_active",sl_gtk_switch_get_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_begin_paint_rect",sl_gdk_window_begin_paint_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_insert_submenu",sl_g_menu_insert_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_state_get_type",sl_gdk_window_state_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_num_copies",sl_gtk_print_job_get_num_copies,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_allow_async",sl_gtk_print_operation_set_allow_async,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_icon_set",sl_gtk_image_set_from_icon_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_fixed_height_mode",sl_gtk_tree_view_get_fixed_height_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_action_get_type",sl_g_action_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_get_attach_widget",sl_gtk_menu_get_attach_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_active_iter",sl_gtk_combo_box_set_active_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_geometry",sl_gtk_window_set_default_geometry,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_get_type",sl_pango_font_description_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_device_grab_remove",sl_gtk_device_grab_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_set_current_name",sl_gtk_file_chooser_set_current_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_action_and_target_value",sl_g_menu_item_set_action_and_target_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_modified",sl_gtk_text_buffer_get_modified,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_menu_item_new_from_widget",sl_gtk_radio_menu_item_new_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_location",sl_gtk_places_sidebar_get_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_set_max_children_per_line",sl_gtk_flow_box_set_max_children_per_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_unix_new",sl_g_io_channel_unix_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_update_layout",sl_pango_cairo_update_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_use_markup",sl_gtk_label_set_use_markup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_free",sl_gtk_icon_info_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_main_do_event",sl_gtk_main_do_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_hadjustment",sl_gtk_scrolled_window_get_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_get_enable_search",sl_gtk_tree_view_get_enable_search,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_override_font",sl_gtk_widget_override_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_test_flags",sl_g_type_test_flags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mapped_file_get_contents",sl_g_mapped_file_get_contents,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_drop_index",sl_gtk_toolbar_get_drop_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_deiconify",sl_gtk_window_deiconify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_mime_dirs",sl_g_content_type_get_mime_dirs,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_default",sl_g_vfs_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_prefers_app_menu",sl_gtk_application_prefers_app_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_get_locale_string",sl_g_key_file_get_locale_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_get_timezone",sl_g_date_time_get_timezone,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_display_name",sl_g_file_set_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_line_readonly",sl_pango_layout_get_line_readonly,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_remove_all_tags",sl_gtk_text_buffer_remove_all_tags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_is_a",sl_g_type_is_a,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_accel_path",sl_gtk_menu_item_get_accel_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_set_listen_backlog",sl_g_socket_set_listen_backlog,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_font_map",sl_gtk_font_chooser_get_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_get_type",sl_gtk_print_unix_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_reset_style",sl_gtk_widget_reset_style,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_forward_display_line",sl_gtk_text_view_forward_display_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_set_reserve_toggle_size",sl_gtk_menu_set_reserve_toggle_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_name_from_class",sl_g_type_name_from_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_margin",sl_gtk_icon_view_set_margin,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_group_connect",sl_gtk_accel_group_connect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new_from_widget",sl_gtk_radio_button_new_from_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_pattern",sl_gtk_label_set_pattern,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_get_hscroll_policy",sl_gtk_scrollable_get_hscroll_policy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scale_button_get_popup",sl_gtk_scale_button_get_popup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_resource_new_from_data",sl_g_resource_new_from_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_create_drag_icon",sl_gtk_icon_view_create_drag_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_column_type",sl_gtk_tree_model_get_column_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_editable_get_editable",sl_gtk_editable_get_editable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_place_cursor_onscreen",sl_gtk_text_view_place_cursor_onscreen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_shadow_type",sl_gtk_scrolled_window_set_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_symbolic_icon",sl_g_file_info_set_symbolic_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_handle",sl_g_variant_new_handle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_scale",sl_gtk_print_job_get_scale,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_frame_timings_get_frame_counter",sl_gdk_frame_timings_get_frame_counter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_set_key",sl_gdk_device_set_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_new",sl_g_settings_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_page_setup_get_paper_height",sl_gtk_page_setup_get_paper_height,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accel_map_load_fd",sl_gtk_accel_map_load_fd,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_set_angle",sl_gtk_label_set_angle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_get_source_widget",sl_gtk_drag_get_source_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_gl_context_get_required_version",sl_gdk_gl_context_get_required_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_unref",sl_gtk_css_section_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_window_set_help_overlay",sl_gtk_application_window_set_help_overlay,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_unmaximize",sl_gdk_window_unmaximize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gl_area_set_has_stencil_buffer",sl_gtk_gl_area_set_has_stencil_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_stick",sl_gdk_window_stick,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollbar_get_type",sl_gtk_scrollbar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_language",sl_pango_context_set_language,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_line",sl_pango_layout_get_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_type",sl_g_unichar_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_group_get_type",sl_gtk_window_group_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_default_icon",sl_gtk_window_set_default_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_seat",sl_gdk_device_get_seat,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_is_equal",sl_gtk_paper_size_is_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_set_visible_column",sl_gtk_tree_model_filter_set_visible_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_get_nth_page",sl_gtk_assistant_get_nth_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_add_pixbuf_formats",sl_gtk_file_filter_add_pixbuf_formats,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_render",sl_gtk_cell_area_render,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_local_only",sl_gtk_places_sidebar_get_local_only,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_model_button_new",sl_gtk_model_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_place_cursor",sl_gtk_text_buffer_place_cursor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_error_quark",sl_g_key_file_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_remove",sl_g_menu_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_get_version",sl_gtk_about_dialog_get_version,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_glyph_string_path",sl_pango_cairo_glyph_string_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_unparent",sl_gtk_widget_unparent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_icon_from_stock",sl_gtk_entry_set_icon_from_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best",sl_gdk_visual_get_best,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_size_new",sl_pango_attr_size_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_move_mark",sl_gtk_text_buffer_move_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_list_ref",sl_pango_attr_list_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_backward_display_line_start",sl_gtk_text_view_backward_display_line_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_get_min_content_width",sl_gtk_scrolled_window_get_min_content_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_forward_cursor_positions",sl_gtk_text_iter_forward_cursor_positions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_sentence_start",sl_gtk_text_iter_backward_sentence_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_adjustment",sl_gtk_list_box_get_adjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tooltip_set_icon_from_icon_name",sl_gtk_tooltip_set_icon_from_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_color_button_set_rgba",sl_gtk_color_button_set_rgba,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_attribute_iter_get_name",sl_g_menu_attribute_iter_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_set_from_file",sl_gtk_image_set_from_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_next",sl_g_variant_type_next,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_subtract",sl_g_file_attribute_matcher_subtract,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_resizable",sl_gtk_tree_view_column_set_resizable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_set_junction_sides",sl_gtk_style_context_set_junction_sides,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_volume_monitor_get_type",sl_g_volume_monitor_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_new_for_commandline_arg",sl_g_file_new_for_commandline_arg,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_child_input_shapes",sl_gdk_window_set_child_input_shapes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_drag_unhighlight_row",sl_gtk_list_box_drag_unhighlight_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_bar_set_child_pack_direction",sl_gtk_menu_bar_set_child_pack_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_type",sl_pango_context_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strcanon",sl_g_strcanon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_time_zone_find_interval",sl_g_time_zone_find_interval,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_clear_cache",sl_gtk_tree_model_filter_clear_cache,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hostname_is_ip_address",sl_g_hostname_is_ip_address,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_pass_through",sl_gdk_window_get_pass_through,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_support_multidevice",sl_gdk_window_get_support_multidevice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_is_scalable",sl_gdk_pixbuf_format_is_scalable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_item_index",sl_gtk_toolbar_get_item_index,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_accept_focus",sl_gtk_window_get_accept_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_set_cursor_hadjustment",sl_gtk_entry_set_cursor_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_aspect_frame_new",sl_gtk_aspect_frame_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_margin_top",sl_gtk_widget_set_margin_top,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_schema_source_get_type",sl_g_settings_schema_source_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attribute_get_type",sl_pango_attribute_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_system",sl_gdk_visual_get_system,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_set_placeholder",sl_gtk_list_box_set_placeholder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_current_page",sl_gtk_notebook_get_current_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_iconv_close",sl_g_iconv_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_set_restrict_to_fill_level",sl_gtk_range_set_restrict_to_fill_level,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_get_type",sl_gtk_action_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_drag_protocol",sl_gdk_window_get_drag_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_mark_get_left_gravity",sl_gtk_text_mark_get_left_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_preview_end_preview",sl_gtk_print_operation_preview_end_preview,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_radio_button_new_with_label",sl_gtk_radio_button_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_action_bar_pack_start",sl_gtk_action_bar_pack_start,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_path",sl_gtk_tree_model_get_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_get_uri",sl_gtk_file_chooser_get_uri,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_replace_literal",sl_g_regex_replace_literal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_icon_name",sl_gtk_image_new_from_icon_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_get_current",sl_g_cancellable_get_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_family_list_faces",sl_pango_font_family_list_faces,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_continue",sl_g_timer_continue,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_boolean",sl_g_variant_new_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_tab_label_text",sl_gtk_notebook_get_tab_label_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_application",sl_gtk_window_set_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_keyval_from_name",sl_gdk_keyval_from_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_font_map",sl_gtk_widget_get_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_add_class",sl_gtk_style_context_add_class,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_ellipsize_mode",sl_gtk_tool_shell_get_ellipsize_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_set_allowed_backends",sl_gdk_set_allowed_backends,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_get_selection",sl_gtk_clipboard_get_selection,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_device_get_vendor_id",sl_gdk_device_get_vendor_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_last_application",sl_gtk_recent_info_last_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_get_sensitive",sl_gtk_cell_renderer_get_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_printer_get_name",sl_gtk_printer_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_format_size",sl_g_format_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_swipe_get_velocity",sl_gtk_gesture_swipe_get_velocity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_set_model",sl_gtk_tree_view_set_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_device",sl_gdk_event_get_device,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_actions",sl_gdk_drag_context_get_actions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_swap",sl_gtk_list_store_swap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_urgency_hint",sl_gtk_window_set_urgency_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_get_preferred_height_for_width",sl_gtk_cell_area_get_preferred_height_for_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_set_gravity",sl_gtk_window_set_gravity,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_new_tuple",sl_g_variant_type_new_tuple,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_set_show_other",sl_gtk_app_chooser_widget_set_show_other,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_take_string",sl_g_value_take_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_get_text",sl_gtk_entry_buffer_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_detach_tab",sl_gtk_notebook_detach_tab,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_crossing_mode_get_type",sl_gdk_crossing_mode_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_drag_context_get_protocol",sl_gdk_drag_context_get_protocol,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_set_show_starred_location",sl_gtk_places_sidebar_set_show_starred_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_set_added",sl_g_bookmark_file_set_added,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accelerator_get_label",sl_gtk_accelerator_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_tooltip_cell",sl_gtk_icon_view_set_tooltip_cell,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_test",sl_g_file_test,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grab_remove",sl_gtk_grab_remove,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_idle_source_new",sl_g_idle_source_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_has_native",sl_gdk_window_has_native,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_application_set_accels_for_action",sl_gtk_application_set_accels_for_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_cancellable_get_type",sl_g_cancellable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_double_buffered",sl_gtk_widget_set_double_buffered,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_insert_page_menu",sl_gtk_notebook_insert_page_menu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_row_reference_get_type",sl_gtk_tree_row_reference_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_ensure_native",sl_gdk_window_ensure_native,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_default_direction",sl_gtk_widget_get_default_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_get_for_screen",sl_gtk_icon_theme_get_for_screen,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_info_get_filename",sl_gtk_icon_info_get_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_label",sl_gtk_label_get_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_set_size",sl_gdk_pixbuf_loader_set_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_reset",sl_g_value_reset,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_new_with_mnemonic",sl_gtk_toggle_button_new_with_mnemonic,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_new_fixed_array",sl_g_variant_new_fixed_array,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_new",sl_g_file_info_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_theme_load_icon",sl_gtk_icon_theme_load_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_unix_dialog_set_embed_page_setup",sl_gtk_print_unix_dialog_set_embed_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_load_key_file",sl_gtk_print_settings_load_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_item_orientation",sl_gtk_icon_view_set_item_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_end_user_action",sl_gtk_text_buffer_end_user_action,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_cursor_hadjustment",sl_gtk_entry_get_cursor_hadjustment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_added",sl_gtk_recent_info_get_added,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_network_address_get_scheme",sl_g_network_address_get_scheme,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_iter_list_classes",sl_gtk_widget_path_iter_list_classes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_unmount_mountable_with_operation_finish",sl_g_file_unmount_mountable_with_operation_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_switch_get_state",sl_gtk_switch_get_state,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_deserialize_set_can_create_tags",sl_gtk_text_buffer_deserialize_set_can_create_tags,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_move_to_rect",sl_gdk_window_move_to_rect,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_new_from_surface",sl_gtk_image_new_from_surface,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_closure_new_object",sl_g_closure_new_object,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_format_size_full",sl_g_format_size_full,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_store_iter_depth",sl_gtk_tree_store_iter_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_value_validate",sl_g_param_value_validate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_get_source_property",sl_g_binding_get_source_property,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_stop_finish",sl_g_drive_stop_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_visible_slice",sl_gtk_text_iter_get_visible_slice,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_bookmark_file_get_visited",sl_g_bookmark_file_get_visited,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_root_coords",sl_gdk_window_get_root_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_skip_pager_hint",sl_gdk_window_set_skip_pager_hint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_header_bar",sl_gtk_dialog_get_header_bar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_vexpand_set",sl_gtk_widget_set_vexpand_set,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_handle_event",sl_gtk_search_bar_handle_event,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_rand_copy",sl_g_rand_copy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_loader_write_bytes",sl_gdk_pixbuf_loader_write_bytes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_accessible",sl_gtk_widget_get_accessible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_reorder_child",sl_gtk_menu_reorder_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_display",sl_gdk_seat_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_get_app_info",sl_gtk_app_chooser_get_app_info,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_string",sl_g_key_file_set_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_assistant_remove_action_widget",sl_gtk_assistant_remove_action_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_random_set_seed",sl_g_random_set_seed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_colormap_size",sl_gdk_visual_get_colormap_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_info_bar_get_show_close_button",sl_gtk_info_bar_get_show_close_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_is_uris_available",sl_gtk_clipboard_wait_is_uris_available,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_strikethrough_color_new",sl_pango_attr_strikethrough_color_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_unichar_isupper",sl_g_unichar_isupper,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_completion_insert_action_text",sl_gtk_entry_completion_insert_action_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_get_type",sl_gtk_menu_item_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_orientation",sl_gtk_tool_shell_get_orientation,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ascii_xdigit_value",sl_g_ascii_xdigit_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_new",sl_gtk_button_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strip_context",sl_g_strip_context,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_get_font_map",sl_pango_context_get_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_type_get_type_registration_serial",sl_g_type_get_type_registration_serial,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_attribute_value",sl_g_menu_item_set_attribute_value,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_tooltip_text",sl_gtk_widget_get_tooltip_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_widget_get_show_other",sl_gtk_app_chooser_widget_get_show_other,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_get_layout",sl_pango_layout_iter_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_get_binary_age",sl_gtk_get_binary_age,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_ref",sl_g_regex_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_index_to_line_x",sl_pango_layout_index_to_line_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_parse_error_quark",sl_g_variant_parse_error_quark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_width",sl_gdk_pixbuf_get_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_accessible_set_widget",sl_gtk_accessible_set_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_geometry_hints",sl_gdk_window_set_geometry_hints,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_get_name",sl_gtk_file_filter_get_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_effective_parent",sl_gdk_window_get_effective_parent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_flow_box_get_child_at_pos",sl_gtk_flow_box_get_child_at_pos,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_hostname_is_non_ascii",sl_g_hostname_is_non_ascii,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_filename_completer_get_completions",sl_g_filename_completer_get_completions,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_get_type",sl_gtk_recent_chooser_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_get_has_subtitle",sl_gtk_header_bar_get_has_subtitle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_is_visible",sl_gdk_window_is_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_background",sl_gtk_render_background,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_get_mark",sl_gtk_text_buffer_get_mark,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_get_default",sl_pango_cairo_font_map_get_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_get_icon",sl_g_mount_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_user_data",sl_gdk_window_get_user_data,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_drag_target_group",sl_gtk_tool_palette_get_drag_target_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_new",sl_pango_layout_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_new",sl_g_date_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_prev_page",sl_gtk_notebook_prev_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_configure_finished",sl_gdk_window_configure_finished,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_emblem_get_icon",sl_g_emblem_get_icon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_days_between",sl_g_date_days_between,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_get_selection_mode",sl_gtk_list_box_get_selection_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_shell_get_icon_size",sl_gtk_tool_shell_get_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_invalidate",sl_gtk_style_context_invalidate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_get_type",sl_gtk_text_iter_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_font_map_new",sl_pango_cairo_font_map_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_filter_filter",sl_gtk_file_filter_filter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_path_append_for_widget",sl_gtk_widget_path_append_for_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_list_accel_closures",sl_gtk_widget_list_accel_closures,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_hhomogeneous",sl_gtk_stack_set_hhomogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_page_num",sl_gtk_notebook_page_num,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_get_type",sl_gtk_paper_size_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_comments",sl_gtk_about_dialog_set_comments,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_property_state_get_type",sl_gdk_property_state_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_get_application_name",sl_g_get_application_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_combo_box_set_wrap_width",sl_gtk_combo_box_set_wrap_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_combo_get_type",sl_gtk_cell_renderer_combo_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_schar",sl_g_value_set_schar,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_get_n_items",sl_g_menu_model_get_n_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_speaks_ipv4",sl_g_socket_speaks_ipv4,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_visible_cursor_position",sl_gtk_text_iter_backward_visible_cursor_position,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_store_reorder",sl_gtk_list_store_reorder,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_set_uint64",sl_g_settings_set_uint64,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strfreev",sl_g_strfreev,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_get_keepalive",sl_g_socket_get_keepalive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pointer_is_grabbed",sl_gdk_pointer_is_grabbed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_button_new_with_font",sl_gtk_font_button_new_with_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_close",sl_gdk_display_close,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_attr_language_new",sl_pango_attr_language_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_double",sl_g_settings_get_double,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_set_detail_width_chars",sl_gtk_calendar_set_detail_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_is_unknown",sl_g_content_type_is_unknown,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_cairo_layout_path",sl_pango_cairo_layout_path,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_range_get_round_digits",sl_gtk_range_get_round_digits,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_reorderable",sl_gtk_tree_view_column_set_reorderable,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_param_spec_unref",sl_g_param_spec_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_regex_escape_nul",sl_g_regex_escape_nul,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_set_source_file",sl_gtk_print_job_set_source_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_drive_can_poll_for_media",sl_g_drive_can_poll_for_media,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_flip",sl_gdk_pixbuf_flip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_select_filename",sl_gtk_file_chooser_select_filename,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_adjustment_clamp_page",sl_gtk_adjustment_clamp_page,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_float",sl_g_value_set_float,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_attribute_matcher_ref",sl_g_file_attribute_matcher_ref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_get_type",sl_gtk_entry_buffer_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_stack_set_homogeneous",sl_gtk_stack_set_homogeneous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_set_range",sl_gtk_spin_button_set_range,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_query_file_type",sl_g_file_query_file_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_set_track_print_status",sl_gtk_print_operation_set_track_print_status,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spin_button_get_snap_to_ticks",sl_gtk_spin_button_get_snap_to_ticks,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrolled_window_set_max_content_width",sl_gtk_scrolled_window_set_max_content_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_file_chooser_list_filters",sl_gtk_file_chooser_list_filters,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_get_gicon",sl_gtk_recent_info_get_gicon,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_collate",sl_gtk_print_settings_get_collate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_new_from_name",sl_gdk_cursor_new_from_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_text_set_fixed_height_from_font",sl_gtk_cell_renderer_text_set_fixed_height_from_font,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_places_sidebar_get_show_enter_location",sl_gtk_places_sidebar_get_show_enter_location,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_expander",sl_gtk_render_expander,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_remove_group",sl_g_key_file_remove_group,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_set_exclusive",sl_gtk_gesture_single_set_exclusive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_app_chooser_button_get_heading",sl_gtk_app_chooser_button_get_heading,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_get_type",sl_pango_layout_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_header_bar_pack_end",sl_gtk_header_bar_pack_end,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grid_get_column_spacing",sl_gtk_grid_get_column_spacing,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toolbar_get_nth_item",sl_gtk_toolbar_get_nth_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_last_updated_sequence",sl_gtk_gesture_get_last_updated_sequence,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_builder_set_application",sl_gtk_builder_set_application,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_menu_item_toggle_size_request",sl_gtk_menu_item_toggle_size_request,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_button_get_always_show_image",sl_gtk_button_get_always_show_image,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_separator_tool_item_new",sl_gtk_separator_tool_item_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_io_channel_error_from_errno",sl_g_io_channel_error_from_errno,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_refilter",sl_gtk_tree_model_filter_refilter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_initially_unowned_get_type",sl_g_initially_unowned_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_item_set_submenu",sl_g_menu_item_set_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_format_get_type",sl_gdk_pixbuf_format_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_ulong",sl_g_value_get_ulong,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_finish",sl_gtk_drag_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_set_attribute_int32",sl_g_file_set_attribute_int32,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_mount_operation_set_anonymous",sl_g_mount_operation_set_anonymous,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_operation_get_embed_page_setup",sl_gtk_print_operation_get_embed_page_setup,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_select_all",sl_gtk_icon_view_select_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_level_bar_new",sl_gtk_level_bar_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_setting_get",sl_gdk_setting_get,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_attribute_byte_string",sl_g_file_info_get_attribute_byte_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_set_justify",sl_pango_layout_set_justify,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_vexpand",sl_gtk_widget_set_vexpand,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_set_text_column",sl_gtk_icon_view_set_text_column,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_set_pixels_inside_wrap",sl_gtk_text_view_set_pixels_inside_wrap,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_descriptions_free",sl_pango_font_descriptions_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_content_type_get_mime_type",sl_g_content_type_get_mime_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cairo_region",sl_gdk_cairo_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_cursor_new_for_display",sl_gdk_cursor_new_for_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_init",sl_g_value_init,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_layout_get_area",sl_gtk_cell_layout_get_area,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_calendar_get_display_options",sl_gtk_calendar_get_display_options,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_search_bar_get_type",sl_gtk_search_bar_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_main_context_ref_thread_default",sl_g_main_context_ref_thread_default,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_get_char_validated",sl_g_utf8_get_char_validated,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_list_seats",sl_gdk_display_list_seats,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_mount_mountable_finish",sl_g_file_mount_mountable_finish,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_progress_bar_get_fraction",sl_gtk_progress_bar_get_fraction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_ucs4_to_utf16",sl_g_ucs4_to_utf16,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_icon_view_convert_widget_to_bin_window_coords",sl_gtk_icon_view_convert_widget_to_bin_window_coords,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_coverage_max",sl_pango_coverage_max,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_set_inconsistent",sl_gtk_toggle_button_set_inconsistent,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_add_region",sl_gtk_style_context_add_region,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_enable_model_drag_dest",sl_gtk_tree_view_enable_model_drag_dest,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_unselect_all",sl_gtk_recent_chooser_unselect_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_filter_convert_iter_to_child_iter",sl_gtk_tree_model_filter_convert_iter_to_child_iter,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_overwrite_mode",sl_gtk_entry_get_overwrite_mode,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_set_has_tooltip",sl_gtk_widget_set_has_tooltip,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_tab_array_free",sl_pango_tab_array_free,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_get_text",sl_gtk_selection_data_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_grab_get_current",sl_gtk_grab_get_current,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_text_get_type",sl_gtk_cell_renderer_text_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_visible",sl_gtk_widget_get_visible,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_show_all",sl_gtk_widget_show_all,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_chooser_dialog_get_type",sl_gtk_recent_chooser_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_get_boolean",sl_g_value_get_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_key_file_set_double_list",sl_g_key_file_set_double_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_display_warp_pointer",sl_gdk_display_warp_pointer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_send_expose",sl_gtk_widget_send_expose,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_value_set_boolean",sl_g_value_set_boolean,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_overlay_set_overlay_pass_through",sl_gtk_overlay_set_overlay_pass_through,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_scrollable_get_type",sl_gtk_scrollable_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_time_new_from_unix_utc",sl_g_date_time_new_from_unix_utc,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_activate_key",sl_gtk_window_activate_key,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_lines",sl_gtk_label_get_lines,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_wait_for_targets",sl_gtk_clipboard_wait_for_targets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_text",sl_gtk_entry_get_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_primary_monitor",sl_gdk_screen_get_primary_monitor,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_get_type",sl_gtk_dialog_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_label_get_ellipsize",sl_gtk_label_get_ellipsize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_menu_model_items_changed",sl_g_menu_model_items_changed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_to_key_file",sl_gtk_print_settings_to_key_file,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_binding_unbind",sl_g_binding_unbind,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_notebook_get_type",sl_gtk_notebook_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_viewport_get_shadow_type",sl_gtk_viewport_get_shadow_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_true",sl_gtk_true,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_type",sl_gtk_tool_palette_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_set_sort_order",sl_g_file_info_set_sort_order,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_get_window_type",sl_gdk_window_get_window_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_get_model",sl_gdk_monitor_get_model,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_events_get_distance",sl_gdk_events_get_distance,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_get_sequences",sl_gtk_gesture_get_sequences,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_is_rubber_banding_active",sl_gtk_tree_view_is_rubber_banding_active,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_direction",sl_gtk_style_context_get_direction,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_view_column_set_widget",sl_gtk_tree_view_column_set_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_max_width_chars",sl_gtk_entry_get_max_width_chars,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_spinner_stop",sl_gtk_spinner_stop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_size_group_get_widgets",sl_gtk_size_group_get_widgets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_css_section_get_section_type",sl_gtk_css_section_get_section_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_gesture_single_set_button",sl_gtk_gesture_single_set_button,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_im_context_filter_keypress",sl_gtk_entry_im_context_filter_keypress,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_get_sunday_week_of_year",sl_g_date_get_sunday_week_of_year,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_strv_equal",sl_g_strv_equal,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_new",sl_g_inet_address_mask_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_buffer_add_selection_clipboard",sl_gtk_text_buffer_add_selection_clipboard,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_layout_iter_at_last_line",sl_pango_layout_iter_at_last_line,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_seat_get_type",sl_gdk_seat_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_utf8_normalize",sl_g_utf8_normalize,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_paper_size_is_custom",sl_gtk_paper_size_is_custom,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_drag_set_icon_stock",sl_gtk_drag_set_icon_stock,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_set_icon_list",sl_gdk_window_set_icon_list,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_render_focus",sl_gtk_render_focus,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_monitor_is_primary",sl_gdk_monitor_is_primary,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_draw_rectangle",sl_pango_renderer_draw_rectangle,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_popover_menu_open_submenu",sl_gtk_popover_menu_open_submenu,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_pixbuf_get_bits_per_sample",sl_gdk_pixbuf_get_bits_per_sample,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_settings_get_uint",sl_g_settings_get_uint,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_visual_get_best_depth",sl_gdk_visual_get_best_depth,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_model_get_iter_first",sl_gtk_tree_model_get_iter_first,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_font_chooser_get_type",sl_gtk_font_chooser_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_renderer_get_layout",sl_pango_renderer_get_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_clipboard_clear",sl_gtk_clipboard_clear,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_timer_stop",sl_g_timer_stop,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_view_get_buffer",sl_gtk_text_view_get_buffer,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_get_icon_size",sl_gtk_tool_item_get_icon_size,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_window_get_default_widget",sl_gtk_window_get_default_widget,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_dialog_set_response_sensitive",sl_gtk_dialog_set_response_sensitive,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_target_list_new",sl_gtk_target_list_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_revealer_get_transition_duration",sl_gtk_revealer_get_transition_duration,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_container_unset_focus_chain",sl_gtk_container_unset_focus_chain,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_text_iter_backward_word_starts",sl_gtk_text_iter_backward_word_starts,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_set_alignment",sl_gtk_cell_renderer_set_alignment,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_window_destroy",sl_gdk_window_destroy,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_inet_address_mask_to_string",sl_g_inet_address_mask_to_string,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_context_set_font_map",sl_pango_context_set_font_map,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tree_sortable_get_sort_column_id",sl_gtk_tree_sortable_get_sort_column_id,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_style_context_get_color",sl_gtk_style_context_get_color,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_event_get_click_count",sl_gdk_event_get_click_count,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_selection_data_targets_include_rich_text",sl_gtk_selection_data_targets_include_rich_text,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_get_layout_offsets",sl_gtk_entry_get_layout_offsets,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_remove_focus_sibling",sl_gtk_cell_area_remove_focus_sibling,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_get_resolution_x",sl_gtk_print_settings_get_resolution_x,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_collapsed",sl_gtk_tool_item_group_get_collapsed,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"pango_font_description_better_match",sl_pango_font_description_better_match,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_socket_leave_multicast_group_ssm",sl_g_socket_leave_multicast_group_ssm,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_settings_set_reverse",sl_gtk_print_settings_set_reverse,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_item_group_get_n_items",sl_gtk_tool_item_group_get_n_items,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_toggle_button_new_with_label",sl_gtk_toggle_button_new_with_label,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_button_get_use_underline",sl_gtk_tool_button_get_use_underline,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_list_box_select_row",sl_gtk_list_box_select_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_vfs_get_supported_uri_schemes",sl_g_vfs_get_supported_uri_schemes,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_recent_info_unref",sl_gtk_recent_info_unref,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_file_info_get_display_name",sl_g_file_info_get_display_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_about_dialog_set_program_name",sl_gtk_about_dialog_set_program_name,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gdk_screen_get_display",sl_gdk_screen_get_display,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_tool_palette_get_drop_item",sl_gtk_tool_palette_get_drop_item,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_view_get_displayed_row",sl_gtk_cell_view_get_displayed_row,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_area_context_allocate",sl_gtk_cell_area_context_allocate,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_preferred_height_and_baseline_for_width",sl_gtk_widget_get_preferred_height_and_baseline_for_width,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_date_valid_month",sl_g_date_valid_month,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_cell_renderer_progress_new",sl_gtk_cell_renderer_progress_new,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_bin_get_child",sl_gtk_bin_get_child,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_print_job_get_n_up_layout",sl_gtk_print_job_get_n_up_layout,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_entry_buffer_get_max_length",sl_gtk_entry_buffer_get_max_length,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_widget_get_type",sl_gtk_widget_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"gtk_image_get_type",sl_gtk_image_get_type,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_match_info_expand_references",sl_g_match_info_expand_references,SLANG_VOID_TYPE),
   MAKE_INTRINSIC_0((char*)"g_variant_type_is_tuple",sl_g_variant_type_is_tuple,SLANG_VOID_TYPE),
   SLANG_END_INTRIN_FUN_TABLE
};   /* }}} */

static const char* usage_strings[] = { /* {{{ */
   "gtk_accel_label_set_accel_closure(GtkWidget,GtkOpaque)",
   "gtk_editable_cut_clipboard(GObject)",
   "int = gtk_tree_selection_iter_is_selected(GObject,GtkTreeIter)",
   "int = gtk_scrollable_get_vscroll_policy(GObject)",
   "gdk_window_set_decorations(GObject,int)",
   "ulong = gtk_cell_editable_get_type()",
   "GtkOpaque = g_value_get_pointer(GtkOpaque)",
   "gtk_progress_bar_set_fraction(GtkWidget,double)",
   "GtkOpaque = g_vfs_parse_name(GtkOpaque,string)",
   "gtk_target_list_add_rich_text_targets(GtkTargetList,uint,int,GObject)",
   "GObject = gdk_cairo_get_drawing_context(Cairo)",
   "gtk_tree_model_sort_convert_iter_to_child_iter(GObject,GtkTreeIter,GtkTreeIter)",
   "GtkOpaque = g_keyfile_settings_backend_new(string,string,string)",
   "uint = gtk_flow_box_get_max_children_per_line(GtkWidget)",
   "gtk_container_check_resize(GtkWidget)",
   "gtk_menu_item_set_use_underline(GtkWidget,int)",
   "gtk_tree_selection_unselect_range(GObject,GtkTreePath,GtkTreePath)",
   "int = g_ascii_strncasecmp(string,string,ulong)",
   "GdkRectangle = gtk_cell_area_get_cell_at_position(GObject,GObject,GtkWidget,struct,int,int)",
   "int = g_drive_is_removable(GtkOpaque)",
   "(int,int) = gtk_cell_area_get_preferred_width(GObject,GObject,GtkWidget)",
   "g_hmac_update(GHmac,uchar[],long)",
   "gtk_flow_box_set_hadjustment(GtkWidget,GObject)",
   "uint = gdk_event_get_button(GdkEvent)",
   "gtk_scrolled_window_unset_placement(GtkWidget)",
   "ulong = gtk_message_dialog_get_type()",
   "GObject = gdk_window_get_group(GObject)",
   "g_value_set_variant(GtkOpaque,GVariant)",
   "gtk_tree_store_swap(GObject,GtkTreeIter,GtkTreeIter)",
   "GTimeZone = g_time_zone_new_offset(int)",
   "gtk_recent_chooser_select_all(GObject)",
   "gtk_selection_clear_targets(GtkWidget,GObject)",
   "gtk_button_set_image_position(GtkWidget,int)",
   "int = gtk_print_settings_get_number_up_layout(GObject)",
   "GtkOpaque = g_file_set_display_name_finish(GtkOpaque,GtkOpaque)",
   "gdk_window_move_region(GObject,Cairo,int,int)",
   "int = g_cancellable_is_cancelled(GtkOpaque)",
   "GtkOpaque = g_settings_schema_source_new_from_directory(string,GtkOpaque,int)",
   "gtk_entry_set_inner_border(GtkWidget,struct)",
   "int = gtk_widget_can_activate_accel(GtkWidget,uint)",
   "GtkWidget = gtk_button_new_with_label(string)",
   "GtkOpaque = g_app_info_get_all_for_type(string)",
   "GtkWidget = gtk_flow_box_get_child_at_index(GtkWidget,int)",
   "g_file_info_set_modification_date_time(GObject,GDateTime)",
   "double = g_variant_get_double(GVariant)",
   "g_value_set_long(GtkOpaque,long)",
   "int = gdk_test_simulate_key(GObject,int,int,uint,int,int)",
   "gtk_menu_button_set_use_popover(GtkWidget,int)",
   "uint = gtk_spin_button_get_digits(GtkWidget)",
   "gtk_notebook_set_tab_label(GtkWidget,GtkWidget,GtkWidget)",
   "GObject = gdk_display_get_monitor(GObject,int)",
   "gtk_window_set_has_user_ref_count(GtkWidget,int)",
   "gtk_file_filter_add_pattern(GObject,string)",
   "ulong = pango_attr_list_get_type()",
   "uint = gtk_entry_get_invisible_char(GtkWidget)",
   "gtk_file_chooser_set_local_only(GObject,int)",
   "int = gtk_link_button_get_visited(GtkWidget)",
   "string = gtk_entry_get_placeholder_text(GtkWidget)",
   "(double,double) = gdk_window_coords_from_parent(GObject,double,double)",
   "GtkOpaque = g_content_type_get_symbolic_icon(string)",
   "GVariant = g_variant_new_uint16(ushort)",
   "gtk_notebook_popup_enable(GtkWidget)",
   "GObject = gtk_mount_operation_get_screen(GObject)",
   "GdkRectangle = gtk_widget_intersect(GtkWidget,struct)",
   "gtk_tool_item_group_set_ellipsize(GtkWidget,int)",
   "ulong = gtk_color_button_get_type()",
   "gtk_expander_set_label_fill(GtkWidget,int)",
   "GtkOpaque = g_app_info_get_icon(GtkOpaque)",
   "ulong = gtk_application_get_type()",
   "pango_font_description_set_style(GtkOpaque,int)",
   "int = g_inet_address_get_is_mc_node_local(GObject)",
   "GObject = gtk_cell_renderer_spinner_new()",
   "gtk_widget_freeze_child_notify(GtkWidget)",
   "GtkOpaque = pango_attr_size_new_absolute(int)",
   "GtkWidget = gtk_combo_box_new_with_entry()",
   "int = gtk_print_operation_get_support_selection(GObject)",
   "ulong = gtk_cell_renderer_pixbuf_get_type()",
   "uint = g_value_get_flags(GtkOpaque)",
   "ulong = gtk_builder_get_type_from_name(GObject,string)",
   "gtk_combo_box_popdown(GtkWidget)",
   "int = g_settings_set_strv(GtkOpaque,string,string[])",
   "int = gtk_tree_view_get_reorderable(GtkWidget)",
   "pango_script_iter_free(PangoScriptIter)",
   "(float,float) = gtk_button_get_alignment(GtkWidget)",
   "GtkWidget = gtk_window_get_attached_to(GtkWidget)",
   "gtk_style_context_set_parent(GObject,GObject)",
   "int = g_menu_link_iter_get_next(GObject,string[],GObject[])",
   "int = pango_context_get_round_glyph_positions(GtkOpaque)",
   "gtk_radio_button_join_group(GtkWidget,GtkWidget)",
   "GtkPaperSize = gtk_page_setup_get_paper_size(GObject)",
   "string = g_app_info_get_id(GtkOpaque)",
   "ulong = gtk_toolbar_get_type()",
   "g_clear_signal_handler(ulong[],GtkOpaque)",
   "gtk_icon_view_set_activate_on_single_click(GtkWidget,int)",
   "int = gtk_tree_view_insert_column(GtkWidget,GtkWidget,int)",
   "string = g_bookmark_file_get_applications(GBookmarkFile,string)",
   "string = g_value_get_string(GtkOpaque)",
   "gtk_widget_set_hexpand(GtkWidget,int)",
   "g_param_spec_pool_insert(GtkOpaque,GtkOpaque,ulong)",
   "GtkTextIter = gtk_text_buffer_get_start_iter(GObject)",
   "gtk_tree_view_set_search_column(GtkWidget,int)",
   "ulong = gdk_pixbuf_get_type()",
   "gtk_drag_set_icon_name(GObject,string,int,int)",
   "gtk_tree_path_down(GtkTreePath)",
   "gtk_recent_filter_add_application(GObject,string)",
   "GtkOpaque = pango_font_description_copy_static(GtkOpaque)",
   "gtk_calendar_unmark_day(GtkWidget,uint)",
   "int = g_type_class_get_instance_private_offset(GtkOpaque)",
   "int = gtk_tree_view_get_level_indentation(GtkWidget)",
   "int = gtk_text_iter_forward_to_tag_toggle(GtkTextIter,GObject)",
   "ulong = gdk_window_hints_get_type()",
   "ulong = gtk_text_child_anchor_get_type()",
   "GtkWidget = gtk_font_chooser_dialog_new(string,GtkWidget)",
   "int = gtk_text_iter_begins_tag(GtkTextIter,GObject)",
   "int = g_key_file_load_from_data_dirs(string,string[],int)",
   "gtk_text_buffer_remove_tag(GObject,GObject,GtkTextIter,GtkTextIter)",
   "GtkOpaque = gtk_widget_list_mnemonic_labels(GtkWidget)",
   "GVariant = g_variant_new_double(double)",
   "g_file_info_set_attribute(GObject,string,int,GtkOpaque)",
   "gtk_grab_add(GtkWidget)",
   "gdk_set_double_click_time(uint)",
   "(GtkTextIter,GtkTextIter) = gtk_text_buffer_get_bounds(GObject)",
   "GtkTreePath = gtk_tree_model_sort_convert_child_path_to_path(GObject,GtkTreePath)",
   "long = gdk_frame_timings_get_predicted_presentation_time(GdkFrameTimings)",
   "int = gtk_widget_get_request_mode(GtkWidget)",
   "(int,int) = pango_layout_iter_get_line_yrange(PangoLayoutIter)",
   "ulong = g_type_register_dynamic(ulong,string,GtkOpaque,int)",
   "int = gtk_menu_bar_get_child_pack_direction(GtkWidget)",
   "GVariant = g_variant_new_object_path(string)",
   "gtk_grid_attach(GtkWidget,GtkWidget,int,int,int,int)",
   "gdk_frame_clock_end_updating(GObject)",
   "uint = g_settings_get_flags(GtkOpaque,string)",
   "int = g_drive_poll_for_media_finish(GtkOpaque,GtkOpaque)",
   "gtk_paned_add2(GtkWidget,GtkWidget)",
   "gtk_file_chooser_set_preview_widget_active(GObject,int)",
   "int = gtk_menu_item_get_reserve_indicator(GtkWidget)",
   "int = gtk_app_chooser_button_get_show_default_item(GtkWidget)",
   "string = gtk_tool_button_get_icon_name(GtkWidget)",
   "int = gtk_expander_get_use_underline(GtkWidget)",
   "ulong = g_menu_model_get_type()",
   "int = gtk_text_iter_ends_line(GtkTextIter)",
   "int = gtk_accel_group_disconnect(GObject,GtkOpaque)",
   "string = g_strnfill(ulong,char)",
   "g_key_file_set_integer_list(GKeyFile,string,string,int[])",
   "GtkWidget = gtk_tool_button_get_icon_widget(GtkWidget)",
   "string = g_ascii_formatd(string,int,string,double)",
   "g_bookmark_file_add_group(GBookmarkFile,string,string)",
   "int = g_inet_address_get_is_mc_site_local(GObject)",
   "GtkWidget = gtk_popover_new(GtkWidget)",
   "gtk_tree_view_set_cursor(GtkWidget,GtkTreePath,GtkWidget,int)",
   "gtk_style_context_reset_widgets(GObject)",
   "int = gtk_text_iter_inside_sentence(GtkTextIter)",
   "gtk_level_bar_add_offset_value(GtkWidget,string,double)",
   "gtk_accel_map_save(string)",
   "gtk_editable_paste_clipboard(GObject)",
   "GtkWidget = gtk_list_box_get_row_at_index(GtkWidget,int)",
   "gtk_print_settings_set_print_pages(GObject,int)",
   "pango_cairo_show_error_underline(Cairo,double,double,double,double)",
   "uint = gtk_get_current_event_time()",
   "gtk_entry_completion_set_popup_set_width(GObject,int)",
   "GSource = g_timeout_source_new(uint)",
   "int = g_app_info_should_show(GtkOpaque)",
   "GObject = gdk_pixbuf_animation_new_from_stream(GObject,GtkOpaque)",
   "int = gtk_file_chooser_set_current_folder_uri(GObject,string)",
   "int = gtk_text_tag_get_priority(GObject)",
   "gtk_cell_area_context_push_preferred_width(GObject,int,int)",
   "ulong = gtk_entry_completion_get_type()",
   "int = gtk_widget_get_device_events(GtkWidget,GdkDevice)",
   "GdkPixbuf = gtk_icon_info_load_icon(GObject)",
   "(int,int) = gtk_widget_get_preferred_height(GtkWidget)",
   "gtk_window_close(GtkWidget)",
   "gtk_cell_area_context_reset(GObject)",
   "gtk_button_set_image(GtkWidget,GtkWidget)",
   "pango_attr_list_unref(PangoAttrList)",
   "int = g_drive_get_start_stop_type(GtkOpaque)",
   "int = pango_layout_get_line_count(GtkOpaque)",
   "GdkRectangle = gtk_entry_get_text_area(GtkWidget)",
   "gtk_widget_queue_resize(GtkWidget)",
   "int = gtk_style_context_has_class(GObject,string)",
   "gtk_image_set_from_animation(GtkWidget,GObject)",
   "gtk_entry_set_tabs(GtkWidget,PangoTabArray)",
   "g_notification_set_title(GtkOpaque,string)",
   "GtkOpaque = g_file_open_readwrite(GtkOpaque,GtkOpaque)",
   "gtk_window_set_role(GtkWidget,string)",
   "int = pango_font_metrics_get_ascent(PangoFontMetrics)",
   "gtk_container_add(GtkWidget,GtkWidget)",
   "gtk_event_box_set_visible_window(GtkWidget,int)",
   "string = g_settings_schema_key_get_name(GtkOpaque)",
   "uint = g_mount_operation_get_pim(GObject)",
   "GVariant = g_value_get_variant(GtkOpaque)",
   "string = gtk_builder_get_translation_domain(GObject)",
   "(int,int) = gtk_window_get_default_size(GtkWidget)",
   "g_signal_handler_unblock(GtkOpaque,ulong)",
   "gtk_window_set_type_hint(GtkWidget,int)",
   "gtk_notebook_set_group_name(GtkWidget,string)",
   "gtk_page_setup_set_paper_size(GObject,GtkPaperSize)",
   "gtk_expander_set_use_markup(GtkWidget,int)",
   "int = gdk_device_get_axis_use(GdkDevice,uint)",
   "(int,int,int) = gtk_widget_translate_coordinates(GtkWidget,GtkWidget,int,int)",
   "GtkOpaque = g_file_dup(GtkOpaque)",
   "int = gtk_print_job_get_collate(GObject)",
   "GVariant = g_variant_new_array(GVariantType,GVariant[],ulong)",
   "gdk_query_visual_types(GdkVisualType_ptr_ptr,int[])",
   "ulong = gtk_adjustment_get_type()",
   "gtk_scrolled_window_set_hadjustment(GtkWidget,GObject)",
   "gtk_print_operation_cancel(GObject)",
   "GtkTreeIter = gtk_tree_store_insert_before(GObject,GtkTreeIter,GtkTreeIter)",
   "gtk_range_set_slider_size_fixed(GtkWidget,int)",
   "string = g_strsignal(int)",
   "gdk_window_unfullscreen(GObject)",
   "gtk_menu_button_set_popup(GtkWidget,GtkWidget)",
   "string = gtk_accelerator_name(uint,int)",
   "gtk_tool_item_set_visible_vertical(GtkWidget,int)",
   "GtkWidget = gtk_tool_item_retrieve_proxy_menu_item(GtkWidget)",
   "gtk_widget_child_notify(GtkWidget,string)",
   "string = gtk_file_chooser_button_get_title(GtkWidget)",
   "int = gtk_window_is_active(GtkWidget)",
   "string = gtk_print_settings_get_output_bin(GObject)",
   "ulong = gdk_screen_get_type()",
   "GtkOpaque = g_themed_icon_new_from_names(string[],int)",
   "int = pango_cairo_font_map_get_font_type(GtkOpaque)",
   "GObject = gdk_event_get_window(GdkEvent)",
   "int = gtk_cell_view_get_size_of_row(GtkWidget,GtkTreePath,struct)",
   "int = gtk_recent_info_has_group(GObject,string)",
   "pango_cairo_show_layout(Cairo,GtkOpaque)",
   "int = gdk_pixbuf_get_height(GdkPixbuf)",
   "GtkOpaque = gtk_icon_theme_list_contexts(GObject)",
   "int = gtk_text_view_get_pixels_below_lines(GtkWidget)",
   "string = g_file_attribute_matcher_enumerate_next(GtkOpaque)",
   "int = gtk_popover_get_transitions_enabled(GtkWidget)",
   "uint = gtk_entry_buffer_insert_text(GObject,uint,string)",
   "GtkWidget = gtk_popover_get_default_widget(GtkWidget)",
   "ulong = gtk_container_get_type()",
   "gtk_range_set_flippable(GtkWidget,int)",
   "GObject = gtk_cell_view_get_model(GtkWidget)",
   "int = gtk_gesture_set_sequence_state(GObject,GtkOpaque,int)",
   "ulong = gtk_cell_renderer_spin_get_type()",
   "ulong = gtk_entry_buffer_get_bytes(GObject)",
   "gtk_places_sidebar_set_show_other_locations(GtkWidget,int)",
   "gtk_range_set_value(GtkWidget,double)",
   "int = gtk_selection_data_targets_include_text(GtkSelectionData)",
   "g_themed_icon_append_name(GObject,string)",
   "string = g_key_file_to_data(GKeyFile)",
   "ulong = gtk_combo_box_text_get_type()",
   "int = g_date_time_get_year(GDateTime)",
   "int = g_regex_match_full(GRegex,string,long,int,int,GMatchInfo[])",
   "int = gtk_text_iter_ends_word(GtkTextIter)",
   "GtkWidget = gtk_font_chooser_widget_new()",
   "GdkColor = gtk_color_button_get_color(GtkWidget)",
   "GtkOpaque = g_app_info_get_fallback_for_type(string)",
   "Cairo = gdk_window_get_clip_region(GObject)",
   "pango_cairo_show_layout_line(Cairo,PangoLayoutLine)",
   "gtk_menu_tool_button_set_arrow_tooltip_text(GtkWidget,string)",
   "int = gtk_entry_get_input_purpose(GtkWidget)",
   "int = gdk_drag_motion(GObject,GObject,int,int,int,int,int,uint)",
   "gtk_tool_item_group_set_label(GtkWidget,string)",
   "GObject = gtk_text_buffer_get_tag_table(GObject)",
   "int = g_file_has_uri_scheme(GtkOpaque,string)",
   "GObject = gtk_mount_operation_new(GtkWidget)",
   "int = gtk_text_view_get_window_type(GtkWidget,GObject)",
   "int = gtk_page_setup_load_key_file(GObject,GKeyFile,string)",
   "gtk_grid_insert_column(GtkWidget,int)",
   "int = g_bookmark_file_has_application(GBookmarkFile,string,string)",
   "float = gtk_label_get_yalign(GtkWidget)",
   "gtk_window_set_focus(GtkWidget,GtkWidget)",
   "string = gtk_entry_get_icon_tooltip_text(GtkWidget,int)",
   "double = gtk_range_get_value(GtkWidget)",
   "GSource = g_io_create_watch(GIOChannel,int)",
   "int = gtk_text_view_get_input_purpose(GtkWidget)",
   "int = gtk_widget_get_device_enabled(GtkWidget,GdkDevice)",
   "int = gdk_screen_height()",
   "GdkDevice = gtk_get_current_event_device()",
   "int = g_socket_get_socket_type(GObject)",
   "ushort = pango_renderer_get_alpha(GtkOpaque,int)",
   "gtk_tool_item_set_proxy_menu_item(GtkWidget,string,GtkWidget)",
   "GtkWidget = gtk_tree_view_column_get_button(GtkWidget)",
   "gtk_spinner_start(GtkWidget)",
   "ulong = gdk_event_sequence_get_type()",
   "g_mount_operation_set_is_tcrypt_hidden_volume(GObject,int)",
   "gtk_container_resize_children(GtkWidget)",
   "gtk_adjustment_value_changed(GObject)",
   "GtkOpaque = g_resolver_lookup_by_name(GtkOpaque,string,GtkOpaque)",
   "string = g_canonicalize_filename(string,string)",
   "gtk_icon_theme_set_screen(GObject,GObject)",
   "gtk_tree_view_set_show_expanders(GtkWidget,int)",
   "int = gdk_window_get_state(GObject)",
   "GObject = gtk_printer_new(string,GObject,int)",
   "int = pango_font_metrics_get_approximate_digit_width(PangoFontMetrics)",
   "gtk_paned_pack2(GtkWidget,GtkWidget,int,int)",
   "Cairo = gtk_print_context_get_cairo_context(GObject)",
   "gtk_text_view_add_child_in_window(GtkWidget,GtkWidget,int,int,int)",
   "int = gtk_widget_get_focus_on_click(GtkWidget)",
   "GtkPaperSize = gtk_paper_size_new_from_ppd(string,string,double,double)",
   "int = gdk_gl_context_get_use_es(GObject)",
   "int = gtk_window_get_hide_titlebar_when_maximized(GtkWidget)",
   "int = g_file_make_directory_finish(GtkOpaque,GtkOpaque)",
   "gtk_tool_palette_set_icon_size(GtkWidget,int)",
   "gtk_file_chooser_unselect_uri(GObject,string)",
   "GObject = gtk_icon_theme_lookup_icon_for_scale(GObject,string,int,int,int)",
   "GtkOpaque = g_themed_icon_new_with_default_fallbacks(string)",
   "GObject = gtk_paned_get_handle_window(GtkWidget)",
   "string = g_mount_operation_get_domain(GObject)",
   "int = gtk_recent_chooser_set_current_uri(GObject,string)",
   "string = g_content_type_get_description(string)",
   "gtk_combo_box_set_model(GtkWidget,GObject)",
   "string = gtk_recent_info_get_mime_type(GObject)",
   "(int,int) = gtk_cell_renderer_get_preferred_height(GObject,GtkWidget)",
   "string = g_checksum_get_string(GChecksum)",
   "int = g_inet_address_mask_get_family(GtkOpaque)",
   "GVariant = g_variant_new_maybe(GVariantType,GVariant)",
   "ulong = gtk_widget_path_iter_get_object_type(GtkWidgetPath,int)",
   "Cairo = gdk_window_create_similar_image_surface(GObject,int,int,int,int)",
   "GtkOpaque = g_param_spec_get_default_value(GtkOpaque)",
   "GObject = gdk_display_open_default_libgtk_only()",
   "int = gtk_text_iter_backward_visible_cursor_positions(GtkTextIter,int)",
   "int = gtk_combo_box_get_popup_fixed_width(GtkWidget)",
   "gtk_font_button_set_show_size(GtkWidget,int)",
   "int = gtk_event_controller_get_propagation_phase(GObject)",
   "string = gtk_paper_size_get_ppd_name(GtkPaperSize)",
   "gtk_target_list_add_image_targets(GtkTargetList,uint,int)",
   "gtk_level_bar_set_value(GtkWidget,double)",
   "(int,int) = gtk_widget_get_size_request(GtkWidget)",
   "int = gtk_accel_map_change_entry(string,uint,int,int)",
   "GObject = gtk_print_run_page_setup_dialog(GtkWidget,GObject,GObject)",
   "ulong = gtk_icon_theme_get_type()",
   "GdkRectangle = gtk_render_background_get_clip(GObject,double,double,double,double)",
   "gtk_application_uninhibit(GObject,uint)",
   "int = gtk_window_has_toplevel_focus(GtkWidget)",
   "string = gtk_printer_get_location(GObject)",
   "GtkWidget = gtk_tree_view_column_get_widget(GtkWidget)",
   "int = gtk_widget_get_margin_bottom(GtkWidget)",
   "GObject = gtk_combo_box_get_model(GtkWidget)",
   "GtkWidget = gtk_switch_new()",
   "(uint,int) = gdk_device_get_key(GdkDevice,uint)",
   "gtk_check_menu_item_set_draw_as_radio(GtkWidget,int)",
   "GtkOpaque = gtk_print_context_create_pango_context(GObject)",
   "string = gdk_pixbuf_format_get_license(GtkOpaque)",
   "ulong = pango_cairo_font_map_get_type()",
   "string = g_utf8_strncpy(string,string,ulong)",
   "GtkOpaque = gtk_font_chooser_get_font_face(GObject)",
   "gtk_dialog_set_default_response(GtkWidget,int)",
   "gtk_layout_move(GtkWidget,GtkWidget,int,int)",
   "ulong = gtk_shortcuts_section_get_type()",
   "GdkEvent = gtk_get_current_event()",
   "pango_font_map_list_families(GtkOpaque,PangoFontFamily_ptr_ptr_ptr,int[])",
   "gtk_widget_size_allocate(GtkWidget,struct)",
   "GObject = gtk_page_setup_new_from_key_file(GKeyFile,string)",
   "GtkOpaque = g_file_info_get_icon(GObject)",
   "gtk_flow_box_set_activate_on_single_click(GtkWidget,int)",
   "int = gtk_tree_store_remove(GObject,GtkTreeIter)",
   "gdk_disable_multidevice()",
   "gtk_drag_set_icon_pixbuf(GObject,GdkPixbuf,int,int)",
   "gtk_box_reorder_child(GtkWidget,GtkWidget,int)",
   "int = gtk_entry_completion_get_popup_single_match(GObject)",
   "int = gtk_printer_is_virtual(GObject)",
   "uint = gtk_flow_box_get_min_children_per_line(GtkWidget)",
   "gtk_label_set_attributes(GtkWidget,PangoAttrList)",
   "GObject = gtk_adjustment_new(double,double,double,double,double,double)",
   "gtk_widget_remove_tick_callback(GtkWidget,uint)",
   "long = g_socket_receive(GObject,string,ulong,GtkOpaque)",
   "gtk_text_iter_set_visible_line_index(GtkTextIter,int)",
   "long = gdk_frame_timings_get_presentation_time(GdkFrameTimings)",
   "string = g_mkdtemp_full(string,int)",
   "gtk_app_chooser_widget_set_show_default(GtkWidget,int)",
   "GtkOpaque = g_settings_new_full(GtkOpaque,GtkOpaque,string)",
   "pango_layout_set_single_paragraph_mode(GtkOpaque,int)",
   "GtkOpaque = gdk_device_list_slave_devices(GdkDevice)",
   "GtkBorder = gtk_style_context_get_border(GObject,int)",
   "int = gtk_clipboard_wait_is_text_available(GObject)",
   "GVariant = g_variant_new_uint64(ulong)",
   "gtk_print_settings_set_paper_width(GObject,double,int)",
   "PangoCoverage = pango_coverage_ref(PangoCoverage)",
   "gtk_widget_set_events(GtkWidget,int)",
   "int = gtk_text_iter_forward_sentence_ends(GtkTextIter,int)",
   "gtk_box_set_homogeneous(GtkWidget,int)",
   "g_signal_stop_emission(GtkOpaque,uint,uint)",
   "ulong = gtk_assistant_get_type()",
   "GVariant = g_settings_get_value(GtkOpaque,string)",
   "GtkOpaque = gtk_application_get_windows(GObject)",
   "gtk_tree_view_column_add_attribute(GtkWidget,GObject,string,int)",
   "gtk_calendar_clear_marks(GtkWidget)",
   "string = g_intern_string(string)",
   "int = gdk_device_get_n_keys(GdkDevice)",
   "gtk_actionable_set_action_target_value(GObject,GVariant)",
   "gtk_window_set_has_resize_grip(GtkWidget,int)",
   "ushort = gtk_entry_get_text_length(GtkWidget)",
   "GtkOpaque = g_drive_get_symbolic_icon(GtkOpaque)",
   "gtk_stack_set_visible_child(GtkWidget,GtkWidget)",
   "GObject = gdk_cursor_new(int)",
   "gtk_radio_menu_item_set_group(GtkWidget,GtkOpaque[])",
   "double = gtk_widget_get_opacity(GtkWidget)",
   "GObject = gtk_print_unix_dialog_get_page_setup(GtkWidget)",
   "gtk_widget_set_tooltip_markup(GtkWidget,string)",
   "gtk_level_bar_set_mode(GtkWidget,int)",
   "GObject = gdk_window_get_screen(GObject)",
   "int = gtk_file_chooser_set_filename(GObject,string)",
   "GtkTargetList = gtk_target_list_ref(GtkTargetList)",
   "int = gtk_gl_area_get_has_alpha(GtkWidget)",
   "g_resolver_free_addresses(GtkOpaque[])",
   "gtk_drag_source_set_icon_stock(GtkWidget,string)",
   "gtk_file_chooser_set_extra_widget(GObject,GtkWidget)",
   "int = pango_context_get_gravity_hint(GtkOpaque)",
   "GObject = g_menu_item_get_link(GObject,string)",
   "string = g_settings_list_keys(GtkOpaque)",
   "PangoAttrList = pango_attr_list_copy(PangoAttrList)",
   "int = gtk_recent_manager_move_item(GObject,string,string)",
   "GtkOpaque = pango_attr_background_alpha_new(ushort)",
   "GObject = gtk_print_operation_new()",
   "string = g_utf8_substring(string,long,long)",
   "int = gtk_expander_get_label_fill(GtkWidget)",
   "double = gtk_progress_bar_get_pulse_step(GtkWidget)",
   "GObject = gdk_pixbuf_animation_new_from_stream_finish(GtkOpaque)",
   "GtkWidget = gtk_color_button_new_with_color(struct)",
   "gtk_places_sidebar_set_location(GtkWidget,GtkOpaque)",
   "gtk_widget_path_prepend_type(GtkWidgetPath,ulong)",
   "gtk_entry_buffer_set_text(GObject,string)",
   "int = gtk_popover_get_position(GtkWidget)",
   "GtkWidget = gtk_image_new_from_file(string)",
   "GObject = gtk_accel_group_from_accel_closure(GtkOpaque)",
   "GtkWidget = gtk_statusbar_new()",
   "gtk_tree_model_row_has_child_toggled(GObject,GtkTreePath,GtkTreeIter)",
   "string = g_utf8_find_next_char(string,string)",
   "string = g_settings_schema_key_get_description(GtkOpaque)",
   "int = gtk_tree_model_iter_parent(GObject,GtkTreeIter,GtkTreeIter)",
   "GtkOpaque = g_volume_monitor_get_volumes(GObject)",
   "GHmac = g_hmac_new(int,uchar[],ulong)",
   "GtkOpaque = g_object_get_qdata(GObject,uint)",
   "int = pango_units_from_double(double)",
   "g_file_info_set_size(GObject,long)",
   "gdk_window_set_fullscreen_mode(GObject,int)",
   "int = g_mount_remount_finish(GtkOpaque,GtkOpaque)",
   "gtk_widget_set_visible(GtkWidget,int)",
   "GtkWidget = gtk_viewport_new(GObject,GObject)",
   "GDateTime = g_date_time_to_utc(GDateTime)",
   "GtkWidget = gtk_menu_shell_get_selected_item(GtkWidget)",
   "GMainContext = g_main_context_new()",
   "gtk_orientable_set_orientation(GObject,int)",
   "GtkWidget = gtk_toolbar_new()",
   "gtk_drag_set_icon_surface(GObject,Cairo)",
   "GDate = g_date_new_dmy(uchar,int,ushort)",
   "int = gtk_widget_path_iter_has_class(GtkWidgetPath,int,string)",
   "gdk_pixbuf_composite(GdkPixbuf,GdkPixbuf,int,int,int,int,double,double,double,double,int,int)",
   "g_date_set_month(GDate,int)",
   "uint = g_io_channel_error_quark()",
   "GtkOpaque = gtk_cell_area_get_focus_siblings(GObject,GObject)",
   "gtk_entry_completion_set_popup_single_match(GObject,int)",
   "GtkWidget = gtk_popover_menu_new()",
   "gtk_window_set_opacity(GtkWidget,double)",
   "int = gtk_tree_model_get_n_columns(GObject)",
   "int = gtk_targets_include_rich_text(GObject[],int,GObject)",
   "gtk_text_buffer_select_range(GObject,GtkTextIter,GtkTextIter)",
   "gdk_gl_context_get_version(GObject,int[],int[])",
   "float = gtk_tool_shell_get_text_alignment(GObject)",
   "GtkPaperSize = gtk_paper_size_copy(GtkPaperSize)",
   "ushort = gtk_notebook_get_tab_hborder(GtkWidget)",
   "gtk_window_set_keep_above(GtkWidget,int)",
   "GtkWidget = gtk_color_button_new()",
   "GtkWidget = gtk_message_dialog_new_with_markup(GtkWidget,int,int,int,string)",
   "GObject = gtk_gesture_pan_new(GtkWidget,int)",
   "int = g_date_valid_dmy(uchar,int,ushort)",
   "int = gtk_tree_store_is_ancestor(GObject,GtkTreeIter,GtkTreeIter)",
   "gdk_selection_convert(GObject,GObject,GObject,uint)",
   "int = gtk_tree_view_column_get_fixed_width(GtkWidget)",
   "gtk_tooltip_set_icon(GObject,GdkPixbuf)",
   "GObject = gdk_drag_begin_for_device(GObject,GdkDevice,GtkOpaque[])",
   "gtk_combo_box_text_remove(GtkWidget,int)",
   "GtkWidget = gtk_stack_sidebar_new()",
   "double = g_key_file_get_double(GKeyFile,string,string)",
   "gtk_menu_item_set_label(GtkWidget,string)",
   "GVariant = g_variant_get_variant(GVariant)",
   "GtkWidget = gtk_icon_view_new()",
   "int = g_socket_close(GObject)",
   "int = gtk_notebook_append_page(GtkWidget,GtkWidget,GtkWidget)",
   "g_file_info_clear_status(GObject)",
   "g_socket_set_blocking(GObject,int)",
   "gtk_entry_set_icon_activatable(GtkWidget,int,int)",
   "long = g_ascii_strtoll(string,string[],uint)",
   "string = gtk_widget_path_iter_get_object_name(GtkWidgetPath,int)",
   "gtk_label_set_text(GtkWidget,string)",
   "pango_cairo_error_underline_path(Cairo,double,double,double,double)",
   "GDateTime = g_date_time_to_local(GDateTime)",
   "int = g_file_make_directory_with_parents(GtkOpaque,GtkOpaque)",
   "gtk_font_chooser_set_show_preview_entry(GObject,int)",
   "GObject = gtk_entry_completion_get_model(GObject)",
   "string = g_file_get_uri(GtkOpaque)",
   "string = g_bookmark_file_get_title(GBookmarkFile,string)",
   "gtk_size_group_remove_widget(GObject,GtkWidget)",
   "string = g_variant_get_bytestring_array(GVariant)",
   "gtk_tool_palette_set_exclusive(GtkWidget,GtkWidget,int)",
   "(int,int) = gtk_widget_get_preferred_width(GtkWidget)",
   "int = pango_font_metrics_get_descent(PangoFontMetrics)",
   "gtk_cell_area_context_push_preferred_height(GObject,int,int)",
   "ulong = gdk_drag_context_get_type()",
   "GObject = gtk_pad_controller_new(GtkWidget,GtkOpaque,GdkDevice)",
   "GtkOpaque = g_resolver_get_default()",
   "GObject = g_menu_link_iter_get_value(GObject)",
   "ulong = gtk_lock_button_get_type()",
   "gtk_drag_set_icon_default(GObject)",
   "int = gtk_recent_chooser_get_show_private(GObject)",
   "GtkOpaque = g_settings_schema_get_key(GtkOpaque,string)",
   "int = g_regex_match_all_full(GRegex,string,long,int,int,GMatchInfo[])",
   "gtk_image_set_pixel_size(GtkWidget,int)",
   "ulong = gtk_frame_get_type()",
   "pango_attr_list_update(PangoAttrList,int,int,int)",
   "int = gtk_box_get_baseline_position(GtkWidget)",
   "GtkOpaque = gtk_label_get_layout(GtkWidget)",
   "GObject = gdk_selection_owner_get_for_display(GObject,GObject)",
   "gtk_entry_set_icon_drag_source(GtkWidget,int,GtkTargetList,int)",
   "int = gtk_stack_get_transition_running(GtkWidget)",
   "string = g_key_file_get_locale_string_list(GKeyFile,string,string,string)",
   "int = gtk_file_chooser_select_file(GObject,GtkOpaque)",
   "int = g_file_copy_finish(GtkOpaque,GtkOpaque)",
   "int = g_variant_get_boolean(GVariant)",
   "string = gtk_actionable_get_action_name(GObject)",
   "GObject = gtk_tool_item_get_text_size_group(GtkWidget)",
   "GtkWidget = gtk_invisible_new_for_screen(GObject)",
   "string = g_settings_schema_key_get_summary(GtkOpaque)",
   "int = gtk_recent_chooser_menu_get_show_numbers(GtkWidget)",
   "gdk_window_scroll(GObject,int,int)",
   "int = gdk_visual_get_bits_per_rgb(GObject)",
   "GtkOpaque = g_file_replace_readwrite_finish(GtkOpaque,GtkOpaque)",
   "int = g_drive_can_eject(GtkOpaque)",
   "GVariant = g_variant_new_int32(int)",
   "gdk_window_thaw_toplevel_updates_libgtk_only(GObject)",
   "GdkPixbuf = gdk_pixbuf_new_from_file_at_scale(string,int,int,int)",
   "GtkOpaque = g_param_spec_ref(GtkOpaque)",
   "int = g_key_file_has_key(GKeyFile,string,string)",
   "GtkWidget = gtk_app_chooser_dialog_new_for_content_type(GtkWidget,int,string)",
   "int = g_source_get_can_recurse(GSource)",
   "double = gtk_entry_get_progress_pulse_step(GtkWidget)",
   "gtk_menu_item_set_reserve_indicator(GtkWidget,int)",
   "uint = g_variant_parser_get_error_quark()",
   "string = g_match_info_fetch_all(GMatchInfo)",
   "GtkWidget = gtk_link_button_new(string)",
   "string = g_strndup(string,ulong)",
   "ulong = gtk_expander_get_type()",
   "gtk_combo_box_popup(GtkWidget)",
   "GtkOpaque = g_cancellable_new()",
   "gtk_tree_selection_select_all(GObject)",
   "gtk_gesture_pan_set_orientation(GObject,int)",
   "int = gtk_icon_view_get_selection_mode(GtkWidget)",
   "GtkOpaque = g_network_service_new(string,string,string)",
   "GtkOpaque = pango_font_description_from_string(string)",
   "gtk_tree_view_set_search_entry(GtkWidget,GtkWidget)",
   "gtk_dialog_add_action_widget(GtkWidget,GtkWidget,int)",
   "gtk_editable_copy_clipboard(GObject)",
   "int = g_menu_attribute_iter_get_next(GObject,string[],GVariant[])",
   "int = gdk_screen_get_n_monitors(GObject)",
   "GObject = g_menu_model_iterate_item_links(GObject,int)",
   "GObject = gtk_builder_new_from_string(string,long)",
   "gtk_print_settings_unset(GObject,string)",
   "int = pango_font_description_get_set_fields(GtkOpaque)",
   "uint = gtk_statusbar_push(GtkWidget,uint,string)",
   "gtk_box_pack_end(GtkWidget,GtkWidget,int,int,uint)",
   "gtk_style_context_set_state(GObject,int)",
   "int = gtk_menu_item_get_right_justified(GtkWidget)",
   "gtk_window_set_focus_visible(GtkWidget,int)",
   "int = gtk_tool_palette_get_expand(GtkWidget,GtkWidget)",
   "string = g_file_get_relative_path(GtkOpaque,GtkOpaque)",
   "int = gtk_toggle_tool_button_get_active(GtkWidget)",
   "GObject = gtk_clipboard_get_owner(GObject)",
   "gtk_menu_button_set_align_widget(GtkWidget,GtkWidget)",
   "int = gtk_tree_view_get_hover_selection(GtkWidget)",
   "int = gtk_text_iter_forward_visible_cursor_position(GtkTextIter)",
   "int = gtk_search_entry_handle_event(GtkWidget,GdkEvent)",
   "GtkOpaque = pango_context_get_font_description(GtkOpaque)",
   "GtkWidget = gtk_widget_get_toplevel(GtkWidget)",
   "double = gtk_adjustment_get_value(GObject)",
   "int = gtk_dialog_get_response_for_widget(GtkWidget,GtkWidget)",
   "GObject = gtk_text_buffer_get_selection_bound(GObject)",
   "gtk_print_unix_dialog_add_custom_tab(GtkWidget,GtkWidget,GtkWidget)",
   "pango_layout_set_text(GtkOpaque,string)",
   "ulong = gtk_list_store_get_type()",
   "int = gtk_size_group_get_mode(GObject)",
   "gtk_native_dialog_hide(GtkWidget)",
   "int = gtk_image_get_storage_type(GtkWidget)",
   "gtk_drag_cancel(GObject)",
   "gdk_window_show_unraised(GObject)",
   "GdkPixbuf = gdk_pixbuf_new_from_resource(string)",
   "gtk_print_settings_set_finishings(GObject,string)",
   "GtkWidget = gtk_radio_tool_button_new_from_stock(GtkOpaque[],string)",
   "ulong = gtk_offscreen_window_get_type()",
   "string = g_filename_display_name(string)",
   "gtk_gl_area_set_required_version(GtkWidget,int,int)",
   "ulong = gtk_accessible_get_type()",
   "string = g_flags_to_string(ulong,uint)",
   "GBytes = g_bytes_icon_get_bytes(GObject)",
   "GObject = gtk_gesture_drag_new(GtkWidget)",
   "GtkTreePath = gtk_icon_view_get_path_at_pos(GtkWidget,int,int)",
   "gtk_tree_view_set_tooltip_row(GtkWidget,GObject,GtkTreePath)",
   "gtk_overlay_reorder_overlay(GtkWidget,GtkWidget,int)",
   "string = g_strdup_value_contents(GtkOpaque)",
   "double = gtk_print_settings_get_double(GObject,string)",
   "gtk_label_set_markup_with_mnemonic(GtkWidget,string)",
   "gtk_menu_item_set_right_justified(GtkWidget,int)",
   "int = gtk_combo_box_get_row_span_column(GtkWidget)",
   "gtk_widget_path_iter_remove_region(GtkWidgetPath,int,string)",
   "g_menu_item_set_label(GObject,string)",
   "pango_context_changed(GtkOpaque)",
   "int = g_file_set_contents(string,string,long)",
   "ulong = gtk_separator_get_type()",
   "string = g_utf8_strdown(string,long)",
   "(int,int) = gtk_tree_view_convert_bin_window_to_widget_coords(GtkWidget,int,int)",
   "GObject = gdk_pixbuf_loader_new()",
   "int = gtk_text_buffer_insert_interactive_at_cursor(GObject,string,int)",
   "gtk_tool_palette_set_group_position(GtkWidget,GtkWidget,int)",
   "int = g_type_check_instance(GtkOpaque)",
   "GVariantType = g_variant_type_element(GVariantType)",
   "ulong = g_inet_address_get_native_size(GObject)",
   "string = g_variant_get_string(GVariant)",
   "GtkWidget = gtk_volume_button_new()",
   "GObject = gtk_entry_get_buffer(GtkWidget)",
   "GObject = gtk_print_job_get_settings(GObject)",
   "GtkTreeIter = gtk_combo_box_get_active_iter(GtkWidget)",
   "int = gtk_widget_get_app_paintable(GtkWidget)",
   "gtk_button_box_set_layout(GtkWidget,int)",
   "int = gtk_widget_path_length(GtkWidgetPath)",
   "gtk_app_chooser_widget_set_show_recommended(GtkWidget,int)",
   "int = gtk_text_iter_backward_char(GtkTextIter)",
   "string = g_proxy_address_get_protocol(GtkOpaque)",
   "gtk_font_chooser_set_font_desc(GObject,GtkOpaque)",
   "gtk_gesture_group(GObject,GObject)",
   "gtk_accelerator_set_default_mod_mask(int)",
   "GtkOpaque = gdk_window_get_children(GObject)",
   "gtk_text_buffer_cut_clipboard(GObject,GObject,int)",
   "GtkWidget = gtk_statusbar_get_message_area(GtkWidget)",
   "ulong = gtk_fixed_get_type()",
   "ulong = gdk_window_attributes_type_get_type()",
   "string = g_proxy_address_get_username(GtkOpaque)",
   "gtk_text_buffer_apply_tag(GObject,GObject,GtkTextIter,GtkTextIter)",
   "int = gtk_widget_has_screen(GtkWidget)",
   "gdk_window_set_user_data(GObject,GtkOpaque)",
   "gtk_accel_label_set_accel_widget(GtkWidget,GtkWidget)",
   "int = pango_layout_get_unknown_glyphs_count(GtkOpaque)",
   "GObject = gdk_screen_get_root_window(GObject)",
   "int = gdk_screen_get_height_mm(GObject)",
   "string = g_get_user_data_dir()",
   "int = gtk_scrolled_window_get_placement(GtkWidget)",
   "gtk_tree_row_reference_inserted(GObject,GtkTreePath)",
   "gtk_text_view_set_monospace(GtkWidget,int)",
   "ulong = g_inet_address_get_type()",
   "int = g_file_info_get_sort_order(GObject)",
   "GVariant = g_variant_ref(GVariant)",
   "int = gtk_combo_box_get_has_entry(GtkWidget)",
   "gtk_popover_set_modal(GtkWidget,int)",
   "(int,int) = gtk_tree_view_convert_tree_to_bin_window_coords(GtkWidget,int,int)",
   "ulong = gtk_font_button_get_type()",
   "string = gtk_tool_item_group_get_label(GtkWidget)",
   "gtk_widget_set_direction(GtkWidget,int)",
   "gtk_tree_view_column_set_spacing(GtkWidget,int)",
   "gtk_combo_box_text_insert_text(GtkWidget,int,string)",
   "string = gtk_accelerator_name_with_keycode(GObject,uint,uint,int)",
   "PangoLayoutIter = pango_layout_iter_copy(PangoLayoutIter)",
   "gtk_widget_set_can_focus(GtkWidget,int)",
   "string = g_dir_make_tmp(string)",
   "Cairo = gdk_screen_get_font_options(GObject)",
   "GObject = gtk_menu_get_accel_group(GtkWidget)",
   "gtk_entry_grab_focus_without_selecting(GtkWidget)",
   "uint = g_socket_get_timeout(GObject)",
   "int = g_regex_match(GRegex,string,int,GMatchInfo[])",
   "GtkOpaque = gdk_pango_context_get()",
   "gtk_layout_put(GtkWidget,GtkWidget,int,int)",
   "Cairo = gtk_icon_info_load_surface(GObject,GObject)",
   "string = g_file_info_get_attribute_stringv(GObject,string)",
   "GtkWidget = gtk_scrolled_window_new(GObject,GObject)",
   "struct = gdk_rgba_copy(struct)",
   "int = g_file_make_symbolic_link(GtkOpaque,string,GtkOpaque)",
   "int = gtk_entry_text_index_to_layout_index(GtkWidget,int)",
   "string = gtk_buildable_get_name(GObject)",
   "g_app_launch_context_setenv(GObject,string,string)",
   "int = gtk_tree_view_column_get_max_width(GtkWidget)",
   "gtk_render_icon_surface(GObject,Cairo,Cairo,double,double)",
   "g_menu_item_set_detailed_action(GObject,string)",
   "gtk_menu_place_on_monitor(GtkWidget,GObject)",
   "GtkWidget = gtk_tree_view_column_new_with_area(GObject)",
   "GtkAllocation = gtk_widget_get_allocated_size(GtkWidget,int[])",
   "int = gtk_drag_check_threshold(GtkWidget,int,int,int,int)",
   "gtk_tool_item_set_visible_horizontal(GtkWidget,int)",
   "pango_layout_set_font_description(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_fixed_new()",
   "g_date_time_get_ymd(GDateTime,int[],int[],int[])",
   "int = g_type_check_class_is_a(GtkOpaque,ulong)",
   "GtkOpaque = gdk_pango_context_get_for_display(GObject)",
   "GtkOpaque = pango_attr_weight_new(int)",
   "gtk_tree_view_column_queue_resize(GtkWidget)",
   "gtk_menu_detach(GtkWidget)",
   "gtk_text_iter_set_offset(GtkTextIter,int)",
   "gtk_tool_item_group_set_label_widget(GtkWidget,GtkWidget)",
   "GtkOpaque = g_proxy_address_new(GObject,ushort,string,string,ushort,string,string)",
   "GdkDevice = gdk_seat_get_keyboard(GObject)",
   "gtk_calendar_select_month(GtkWidget,uint,uint)",
   "GtkWidget = gtk_list_box_new()",
   "int = gdk_events_pending()",
   "int = gdk_visual_get_best_type()",
   "gtk_spin_button_set_value(GtkWidget,double)",
   "ulong = g_gtype_get_type()",
   "int = g_variant_type_is_array(GVariantType)",
   "gtk_popover_bind_model(GtkWidget,GObject,string)",
   "int = g_cancellable_get_fd(GtkOpaque)",
   "int = g_file_replace_contents_finish(GtkOpaque,GtkOpaque,string[])",
   "PangoLayoutLine = pango_layout_iter_get_line(PangoLayoutIter)",
   "gtk_progress_bar_set_text(GtkWidget,string)",
   "gtk_cell_renderer_set_sensitive(GObject,int)",
   "int = gdk_screen_get_monitor_width_mm(GObject,int)",
   "gtk_adjustment_set_value(GObject,double)",
   "int = g_inet_address_mask_matches(GtkOpaque,GObject)",
   "(int,int) = gtk_tree_view_convert_tree_to_widget_coords(GtkWidget,int,int)",
   "int = gtk_cell_renderer_toggle_get_radio(GObject)",
   "GtkOpaque = gtk_recent_info_create_app_info(GObject,string)",
   "int = gtk_tree_view_column_get_visible(GtkWidget)",
   "ulong = gtk_flow_box_child_get_type()",
   "string = g_filename_completer_get_completion_suffix(GObject,string)",
   "gtk_target_table_free(GObject,int)",
   "ulong = gdk_event_mask_get_type()",
   "g_source_unref(GSource)",
   "gdk_window_set_opaque_region(GObject,Cairo)",
   "gtk_editable_set_editable(GObject,int)",
   "g_type_free_instance(GtkOpaque)",
   "string = g_strdelimit(string,string,char)",
   "gdk_window_freeze_updates(GObject)",
   "gtk_info_bar_set_default_response(GtkWidget,int)",
   "int = gtk_icon_view_get_margin(GtkWidget)",
   "ulong = gdk_device_pad_get_type()",
   "string = g_proxy_address_get_destination_protocol(GtkOpaque)",
   "gtk_app_chooser_button_set_show_default_item(GtkWidget,int)",
   "GVariant = g_variant_new_bytestring(string)",
   "GtkWidget = gtk_calendar_new()",
   "gdk_window_maximize(GObject)",
   "int = gtk_text_iter_equal(GtkTextIter,GtkTextIter)",
   "GtkOpaque = g_file_get_parent(GtkOpaque)",
   "GObject = gtk_recent_manager_new()",
   "int = gtk_toolbar_get_show_arrow(GtkWidget)",
   "pango_attr_list_change(PangoAttrList,GtkOpaque)",
   "gdk_drag_abort(GObject,uint)",
   "gtk_tree_view_set_tooltip_column(GtkWidget,int)",
   "GtkWidget = gtk_notebook_get_nth_page(GtkWidget,int)",
   "g_file_info_set_attribute_stringv(GObject,string,string[])",
   "int = gtk_expander_get_expanded(GtkWidget)",
   "gtk_paper_size_set_size(GtkPaperSize,double,double,int)",
   "gtk_target_list_add(GtkTargetList,GObject,uint,uint)",
   "uint = gtk_css_section_get_start_line(GtkOpaque)",
   "int = pango_font_has_char(GtkOpaque,uint)",
   "int = gtk_recent_info_match(GObject,GObject)",
   "g_variant_builder_unref(GVariantBuilder)",
   "GtkOpaque = pango_attr_variant_new(int)",
   "gtk_label_set_xalign(GtkWidget,float)",
   "uint = g_utf8_to_ucs4_fast(string,long)",
   "GtkOpaque = gtk_widget_path_iter_list_regions(GtkWidgetPath,int)",
   "gtk_text_buffer_set_modified(GObject,int)",
   "gtk_window_unmaximize(GtkWidget)",
   "ulong = gdk_gl_error_get_type()",
   "int = gtk_tool_palette_get_icon_size(GtkWidget)",
   "uint = gdk_keyval_to_unicode(uint)",
   "gtk_flow_box_set_homogeneous(GtkWidget,int)",
   "int = g_socket_bind(GObject,GtkOpaque,int)",
   "GObject = g_mount_operation_new()",
   "GObject = gtk_page_setup_new()",
   "pango_font_description_set_family_static(GtkOpaque,string)",
   "GObject = gdk_keymap_get_default()",
   "(double,ulong) = g_timer_elapsed(GTimer)",
   "int = gtk_native_dialog_get_visible(GtkWidget)",
   "ulong = gtk_menu_shell_get_type()",
   "GtkOpaque = g_resource_ref(GtkOpaque)",
   "int = g_file_start_mountable_finish(GtkOpaque,GtkOpaque)",
   "g_menu_insert_section(GObject,int,string,GObject)",
   "int = gtk_gesture_is_active(GObject)",
   "int = gtk_printer_is_accepting_jobs(GObject)",
   "int = gtk_widget_get_margin_top(GtkWidget)",
   "gtk_font_button_set_use_font(GtkWidget,int)",
   "gdk_window_set_support_multidevice(GObject,int)",
   "g_date_add_years(GDate,uint)",
   "ulong = g_notification_get_type()",
   "double = gtk_paper_size_get_default_left_margin(GtkPaperSize,int)",
   "ulong = gdk_visual_get_type()",
   "gtk_tree_iter_free(GtkTreeIter)",
   "GtkOpaque = g_param_spec_internal(ulong,string,string,string,int)",
   "GtkOpaque = gdk_pango_context_get_for_screen(GObject)",
   "GObject = gdk_pixbuf_loader_get_animation(GObject)",
   "GtkOpaque = g_param_spec_pool_list_owned(GtkOpaque,ulong)",
   "int = pango_language_matches(GtkOpaque,string)",
   "string = gdk_get_program_class()",
   "g_bookmark_file_set_icon(GBookmarkFile,string,string,string)",
   "gtk_notebook_set_menu_label_text(GtkWidget,GtkWidget,string)",
   "GVariant = gtk_print_settings_to_gvariant(GObject)",
   "ulong = gtk_tree_view_get_type()",
   "int = g_io_channel_get_buffered(GIOChannel)",
   "GtkWidget = gtk_scrolled_window_get_vscrollbar(GtkWidget)",
   "(int,int) = gtk_label_get_layout_offsets(GtkWidget)",
   "int = gtk_print_settings_get_quality(GObject)",
   "int = gtk_text_iter_backward_to_tag_toggle(GtkTextIter,GObject)",
   "int = gtk_css_provider_load_from_path(GObject,string)",
   "ulong = gtk_app_chooser_button_get_type()",
   "GdkDevice = gdk_device_get_associated_device(GdkDevice)",
   "int = gdk_event_get_scancode(GdkEvent)",
   "int = gtk_combo_box_get_active(GtkWidget)",
   "double = g_rand_double_range(GRand,double,double)",
   "uint = gtk_container_get_border_width(GtkWidget)",
   "GtkOpaque = gtk_flow_box_get_selected_children(GtkWidget)",
   "int = gtk_printer_is_paused(GObject)",
   "string = gtk_text_iter_get_visible_text(GtkTextIter,GtkTextIter)",
   "gdk_window_begin_paint_region(GObject,Cairo)",
   "int = gtk_print_unix_dialog_get_embed_page_setup(GtkWidget)",
   "GDateTime = g_date_time_new_now_utc()",
   "GObject = g_emblem_new(GtkOpaque)",
   "int = gtk_scale_get_draw_value(GtkWidget)",
   "GtkOpaque = g_type_interface_get_plugin(ulong,ulong)",
   "string = g_variant_dup_objv(GVariant)",
   "gtk_tool_item_set_homogeneous(GtkWidget,int)",
   "(int,int) = gtk_cell_renderer_get_preferred_width_for_height(GObject,GtkWidget,int)",
   "gtk_target_list_remove(GtkTargetList,GObject)",
   "int = gtk_font_chooser_get_level(GObject)",
   "gtk_widget_set_accel_path(GtkWidget,string,GObject)",
   "gtk_print_settings_set_page_set(GObject,int)",
   "gtk_widget_override_color(GtkWidget,int,struct)",
   "(int,int,int) = gdk_window_get_origin(GObject)",
   "GtkOpaque = gtk_menu_get_for_attach_widget(GtkWidget)",
   "gtk_menu_reposition(GtkWidget)",
   "int = gdk_pixbuf_save_to_streamv(GdkPixbuf,GObject,string,string[],string[],GtkOpaque)",
   "string = g_environ_getenv(string[],string)",
   "string = g_get_system_config_dirs()",
   "gtk_file_chooser_button_set_width_chars(GtkWidget,int)",
   "gtk_native_dialog_destroy(GtkWidget)",
   "GtkOpaque = pango_attr_underline_new(int)",
   "gtk_menu_set_active(GtkWidget,uint)",
   "GObject = gtk_text_tag_table_lookup(GObject,string)",
   "gtk_file_chooser_select_all(GObject)",
   "int = gtk_font_chooser_get_font_size(GObject)",
   "int = gtk_scale_get_value_pos(GtkWidget)",
   "gtk_menu_attach(GtkWidget,GtkWidget,uint,uint,uint,uint)",
   "(int,ulong,uint) = g_resources_get_info(string,int)",
   "gtk_list_box_prepend(GtkWidget,GtkWidget)",
   "long = g_socket_send(GObject,string,ulong,GtkOpaque)",
   "int = gtk_file_chooser_button_get_focus_on_click(GtkWidget)",
   "int = gtk_tree_sortable_has_default_sort_func(GObject)",
   "int = g_settings_set_int(GtkOpaque,string,int)",
   "gtk_assistant_add_action_widget(GtkWidget,GtkWidget)",
   "gtk_tooltip_set_text(GObject,string)",
   "int = gtk_print_settings_get_reverse(GObject)",
   "int = g_volume_should_automount(GtkOpaque)",
   "int = gtk_text_iter_ends_sentence(GtkTextIter)",
   "gtk_text_buffer_move_mark_by_name(GObject,string,GtkTextIter)",
   "string = gtk_file_chooser_get_current_folder_uri(GObject)",
   "g_charset_converter_set_use_fallback(GObject,int)",
   "gtk_shortcut_label_set_disabled_text(GtkWidget,string)",
   "GtkOpaque = g_action_map_lookup_action(GtkOpaque,string)",
   "gtk_widget_set_margin_end(GtkWidget,int)",
   "int = gtk_print_settings_get_use_color(GObject)",
   "int = g_key_file_remove_comment(GKeyFile,string,string)",
   "int = gtk_events_pending()",
   "GtkWidget = gtk_image_new_from_gicon(GtkOpaque,int)",
   "PangoTabArray = pango_tab_array_new(int,int)",
   "int = gtk_print_unix_dialog_get_page_setup_set(GtkWidget)",
   "GtkTreePath = gtk_tree_path_new()",
   "int = gtk_print_job_get_track_print_status(GObject)",
   "ulong = g_variant_type_n_items(GVariantType)",
   "gtk_list_box_select_all(GtkWidget)",
   "double = gtk_adjustment_get_lower(GObject)",
   "gtk_tree_view_set_enable_search(GtkWidget,int)",
   "ulong = g_type_from_name(string)",
   "double = gtk_print_context_get_height(GObject)",
   "int = gtk_recent_filter_filter(GObject,GObject)",
   "int = g_variant_get_handle(GVariant)",
   "string = g_utf8_strup(string,long)",
   "gtk_overlay_add_overlay(GtkWidget,GtkWidget)",
   "string = g_io_channel_get_encoding(GIOChannel)",
   "GtkOpaque = gtk_printer_list_papers(GObject)",
   "gtk_list_box_unselect_row(GtkWidget,GtkWidget)",
   "int = g_network_monitor_get_network_available(GtkOpaque)",
   "GtkOpaque = g_emblemed_icon_get_icon(GObject)",
   "gtk_text_mark_set_visible(GObject,int)",
   "GtkWidget = gtk_entry_new()",
   "int = g_menu_link_iter_next(GObject)",
   "string = g_variant_type_dup_string(GVariantType)",
   "gtk_window_group_add_window(GObject,GtkWidget)",
   "int = gtk_cell_view_get_fit_model(GtkWidget)",
   "gdk_set_program_class(string)",
   "gtk_box_set_spacing(GtkWidget,int)",
   "g_mapped_file_unref(GMappedFile)",
   "GObject = gdk_window_get_display(GObject)",
   "string = g_strjoinv(string,string[])",
   "ulong = gdk_frame_clock_phase_get_type()",
   "ulong = gtk_window_get_type()",
   "GtkOpaque = g_settings_new_with_path(string,string)",
   "GtkOpaque = pango_context_new()",
   "GtkWidget = gtk_radio_menu_item_new(GtkOpaque[])",
   "PangoFontMetrics = pango_context_get_metrics(GtkOpaque,GtkOpaque,GtkOpaque)",
   "GObject = gdk_display_open(string)",
   "GtkWidget = gtk_tool_item_group_get_nth_item(GtkWidget,uint)",
   "gtk_about_dialog_set_artists(GtkWidget,string[])",
   "GtkWidget = gtk_paned_new(int)",
   "ulong = gdk_drag_action_get_type()",
   "double = gtk_page_setup_get_left_margin(GObject,int)",
   "gtk_print_operation_set_print_settings(GObject,GObject)",
   "int = gtk_text_iter_get_offset(GtkTextIter)",
   "int = g_unichar_iswide(uint)",
   "gtk_label_set_selectable(GtkWidget,int)",
   "gdk_window_resize(GObject,int,int)",
   "gtk_tree_view_column_set_min_width(GtkWidget,int)",
   "GtkWidget = gtk_image_new_from_pixbuf(GdkPixbuf)",
   "ulong = gtk_popover_menu_get_type()",
   "int = g_main_context_acquire(GMainContext)",
   "gtk_cell_renderer_set_visible(GObject,int)",
   "int = gtk_widget_path_iter_has_qname(GtkWidgetPath,int,uint)",
   "gtk_font_button_set_use_size(GtkWidget,int)",
   "int = g_ascii_string_to_signed(string,uint,long,long,long[])",
   "int = g_drive_start_finish(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_gl_area_new()",
   "string = gdk_pixbuf_get_option(GdkPixbuf,string)",
   "gtk_window_set_default_icon_name(string)",
   "int = gtk_file_chooser_get_do_overwrite_confirmation(GObject)",
   "int = g_date_time_equal(GtkOpaque,GtkOpaque)",
   "gtk_notebook_set_tab_reorderable(GtkWidget,GtkWidget,int)",
   "int = gtk_app_chooser_widget_get_show_recommended(GtkWidget)",
   "GtkOpaque = gtk_accel_groups_from_object(GObject)",
   "(int,int) = gdk_window_constrain_size(struct,int,int,int)",
   "uint = gtk_label_get_mnemonic_keyval(GtkWidget)",
   "GtkWidget = gtk_file_chooser_button_new_with_dialog(GtkWidget)",
   "gtk_page_setup_to_key_file(GObject,GKeyFile,string)",
   "double = gtk_page_setup_get_paper_width(GObject,int)",
   "GtkOpaque = gdk_drag_context_list_targets(GObject)",
   "gtk_text_buffer_insert_child_anchor(GObject,GtkTextIter,GObject)",
   "GObject = gdk_offscreen_window_get_embedder(GObject)",
   "g_signal_remove_emission_hook(uint,ulong)",
   "gtk_print_job_set_page_set(GObject,int)",
   "gtk_combo_box_set_focus_on_click(GtkWidget,int)",
   "string = gtk_entry_completion_get_completion_prefix(GObject)",
   "int = gtk_assistant_get_page_type(GtkWidget,GtkWidget)",
   "gtk_print_settings_set_length(GObject,string,double,int)",
   "int = g_date_valid_julian(uint)",
   "gtk_widget_destroyed(GtkWidget,GtkWidget[])",
   "GtkOpaque = pango_attr_style_new(int)",
   "gtk_button_set_always_show_image(GtkWidget,int)",
   "gtk_spin_button_set_update_policy(GtkWidget,int)",
   "int = gtk_accel_group_get_is_locked(GObject)",
   "int = gdk_frame_timings_get_complete(GdkFrameTimings)",
   "int = g_file_attribute_matcher_matches(GtkOpaque,string)",
   "GdkFrameTimings = gdk_frame_timings_ref(GdkFrameTimings)",
   "GtkOpaque = gtk_gesture_get_group(GObject)",
   "GdkPixbuf = gtk_selection_data_get_pixbuf(GtkSelectionData)",
   "GObject = gdk_event_get_device_tool(GdkEvent)",
   "int = pango_font_metrics_get_strikethrough_position(PangoFontMetrics)",
   "gtk_style_context_set_path(GObject,GtkWidgetPath)",
   "int = g_socket_condition_check(GObject,int)",
   "gtk_drag_source_set_icon_pixbuf(GtkWidget,GdkPixbuf)",
   "uint = g_variant_get_uint32(GVariant)",
   "int = gtk_container_get_resize_mode(GtkWidget)",
   "gdk_pixbuf_copy_area(GdkPixbuf,int,int,int,int,GdkPixbuf,int,int)",
   "int = gtk_text_iter_forward_chars(GtkTextIter,int)",
   "gtk_drag_source_add_uri_targets(GtkWidget)",
   "GtkOpaque = gtk_font_chooser_get_font_desc(GObject)",
   "uint = g_spaced_primes_closest(uint)",
   "ulong = gdk_device_pad_feature_get_type()",
   "GtkWidget = gtk_shortcut_label_new(string)",
   "uint = g_source_get_id(GSource)",
   "string = gtk_printer_get_state_message(GObject)",
   "string = gtk_tool_button_get_stock_id(GtkWidget)",
   "gtk_revealer_set_transition_duration(GtkWidget,uint)",
   "g_date_subtract_years(GDate,uint)",
   "int = gtk_printer_compare(GObject,GObject)",
   "GdkRectangle = gdk_window_get_frame_extents(GObject)",
   "GtkWidget = gtk_radio_menu_item_new_with_mnemonic_from_widget(GtkWidget,string)",
   "pango_layout_set_wrap(GtkOpaque,int)",
   "GtkOpaque = g_type_instance_get_private(GtkOpaque,ulong)",
   "GtkOpaque = g_file_new_for_path(string)",
   "int = pango_layout_get_baseline(GtkOpaque)",
   "GtkWidget = gtk_image_new_from_stock(string,int)",
   "GtkWidget = gtk_spin_button_new(GObject,double,uint)",
   "int = gtk_icon_view_get_row_spacing(GtkWidget)",
   "GtkOpaque = g_param_spec_get_redirect_target(GtkOpaque)",
   "uint = g_type_qname(ulong)",
   "GObject = gtk_layout_get_hadjustment(GtkWidget)",
   "int = gtk_window_get_skip_pager_hint(GtkWidget)",
   "string = g_find_program_in_path(string)",
   "PangoAttrList = gtk_label_get_attributes(GtkWidget)",
   "gtk_print_settings_set(GObject,string,string)",
   "GtkOpaque = g_object_interface_list_properties(GtkOpaque,uint[])",
   "GtkWidget = gtk_tool_item_new()",
   "GtkWidget = gtk_radio_tool_button_new_with_stock_from_widget(GtkWidget,string)",
   "gtk_widget_set_tooltip_text(GtkWidget,string)",
   "gtk_text_iter_order(GtkTextIter,GtkTextIter)",
   "int = gtk_text_view_move_mark_onscreen(GtkWidget,GObject)",
   "int = gdk_keymap_get_scroll_lock_state(GObject)",
   "GtkWidget = gtk_button_box_new(int)",
   "gtk_places_sidebar_set_show_trash(GtkWidget,int)",
   "gtk_tree_view_column_set_visible(GtkWidget,int)",
   "string = g_type_name_from_instance(GtkOpaque)",
   "gdk_display_manager_set_default_display(GObject,GObject)",
   "gtk_print_operation_set_has_selection(GObject,int)",
   "GtkWidget = gtk_menu_button_get_popover(GtkWidget)",
   "int = gtk_widget_get_support_multidevice(GtkWidget)",
   "double = gtk_window_get_opacity(GtkWidget)",
   "string = gdk_display_get_name(GObject)",
   "GObject = gtk_drag_begin(GtkWidget,GtkTargetList,int,int,GdkEvent)",
   "gtk_print_settings_set_printer(GObject,string)",
   "GObject = gdk_window_begin_draw_frame(GObject,Cairo)",
   "pango_font_metrics_unref(PangoFontMetrics)",
   "gtk_scrolled_window_set_propagate_natural_height(GtkWidget,int)",
   "uint = gtk_icon_theme_error_quark()",
   "string = gtk_text_buffer_get_slice(GObject,GtkTextIter,GtkTextIter,int)",
   "PangoAttrList = gtk_entry_get_attributes(GtkWidget)",
   "int = g_hostname_is_ascii_encoded(string)",
   "gtk_widget_set_child_visible(GtkWidget,int)",
   "int = gtk_tool_item_get_visible_horizontal(GtkWidget)",
   "int = g_rand_int_range(GRand,int,int)",
   "ulong = gtk_page_setup_get_type()",
   "GObject = gtk_text_view_get_hadjustment(GtkWidget)",
   "ulong = g_simple_action_get_type()",
   "GtkTreePath = gtk_tree_row_reference_get_path(GtkTreeRowReference)",
   "gtk_print_unix_dialog_set_settings(GtkWidget,GObject)",
   "gtk_mount_operation_set_screen(GObject,GObject)",
   "gtk_recent_chooser_unselect_uri(GObject,string)",
   "string = g_bookmark_file_to_data(GBookmarkFile)",
   "uint = gtk_builder_add_from_file(GObject,string)",
   "g_settings_backend_writable_changed(GtkOpaque,string)",
   "PangoAttrList = pango_layout_get_attributes(GtkOpaque)",
   "g_rand_set_seed_array(GRand,uint[],uint)",
   "g_resolver_free_targets(GtkOpaque[])",
   "GdkPixbuf = gdk_pixbuf_copy(GdkPixbuf)",
   "string = g_volume_enumerate_identifiers(GtkOpaque)",
   "(int,int) = pango_layout_move_cursor_visually(GtkOpaque,int,int,int,int)",
   "gdk_window_begin_move_drag(GObject,int,int,int,uint)",
   "gtk_notebook_popup_disable(GtkWidget)",
   "gtk_icon_view_set_selection_mode(GtkWidget,int)",
   "ulong = gtk_tool_shell_get_type()",
   "int = gtk_entry_completion_get_popup_set_width(GObject)",
   "int = g_unichar_isdefined(uint)",
   "gtk_search_bar_set_show_close_button(GtkWidget,int)",
   "gtk_menu_shell_deactivate(GtkWidget)",
   "gdk_window_end_paint(GObject)",
   "int = gtk_window_get_type_hint(GtkWidget)",
   "GObject = gtk_selection_data_get_display(GtkSelectionData)",
   "g_param_value_set_default(GtkOpaque,GtkOpaque)",
   "int = gdk_display_get_n_monitors(GObject)",
   "pango_font_face_list_sizes(GtkOpaque,int_ptr_ptr,int[])",
   "GDateTime = g_date_time_new_now_local()",
   "int = gdk_rgba_equal(GtkOpaque,GtkOpaque)",
   "int = gtk_text_iter_forward_char(GtkTextIter)",
   "gtk_level_bar_remove_offset_value(GtkWidget,string)",
   "gtk_list_box_insert(GtkWidget,GtkWidget,int)",
   "gtk_app_chooser_refresh(GObject)",
   "int = g_match_info_fetch_pos(GMatchInfo,int,int[],int[])",
   "GtkTextIter = gtk_text_buffer_get_iter_at_line_index(GObject,int,int)",
   "int = gtk_level_bar_get_mode(GtkWidget)",
   "GdkPixbuf = gtk_assistant_get_page_header_image(GtkWidget,GtkWidget)",
   "gtk_header_bar_set_title(GtkWidget,string)",
   "int = gtk_widget_path_append_with_siblings(GtkWidgetPath,GtkWidgetPath,uint)",
   "g_type_class_adjust_private_offset(GtkOpaque,int[])",
   "GtkOpaque = gdk_display_manager_list_displays(GObject)",
   "ulong = pango_layout_iter_get_type()",
   "gtk_cell_view_set_model(GtkWidget,GObject)",
   "gdk_window_shape_combine_region(GObject,Cairo,int,int)",
   "gtk_render_arrow(GObject,Cairo,double,double,double,double)",
   "gtk_window_fullscreen_on_monitor(GtkWidget,GObject,int)",
   "GtkOpaque = g_app_info_get_all()",
   "int = gdk_keymap_have_bidi_layouts(GObject)",
   "int = gtk_gl_area_get_auto_render(GtkWidget)",
   "gtk_widget_set_receives_default(GtkWidget,int)",
   "gtk_size_group_add_widget(GObject,GtkWidget)",
   "gtk_flow_box_unselect_all(GtkWidget)",
   "gtk_text_view_set_left_margin(GtkWidget,int)",
   "uchar = g_variant_get_byte(GVariant)",
   "int = gtk_notebook_prepend_page_menu(GtkWidget,GtkWidget,GtkWidget,GtkWidget)",
   "gtk_text_view_reset_cursor_blink(GtkWidget)",
   "GObject = gtk_tree_view_get_hadjustment(GtkWidget)",
   "string = g_file_get_path(GtkOpaque)",
   "GtkWidget = gtk_scrolled_window_get_hscrollbar(GtkWidget)",
   "GObject = gtk_container_get_focus_vadjustment(GtkWidget)",
   "GObject = gtk_recent_filter_new()",
   "int = gtk_entry_get_activates_default(GtkWidget)",
   "int = pango_script_iter_next(PangoScriptIter)",
   "g_socket_set_broadcast(GObject,int)",
   "ulong = pango_cairo_font_get_type()",
   "int = g_type_check_instance_is_a(GtkOpaque,ulong)",
   "gtk_print_job_set_rotate(GObject,int)",
   "uint = gtk_get_micro_version()",
   "string = g_variant_dup_bytestring(GVariant)",
   "(double,double) = gdk_event_get_coords(GdkEvent)",
   "GObject = gtk_entry_completion_new_with_area(GObject)",
   "string = g_path_get_basename(string)",
   "GtkWidget = gtk_window_get_focus(GtkWidget)",
   "GObject = gtk_gl_area_get_context(GtkWidget)",
   "gtk_scrolled_window_set_min_content_height(GtkWidget,int)",
   "gdk_gl_context_set_use_es(GObject,int)",
   "GSource = g_cancellable_source_new(GtkOpaque)",
   "GVariant = g_settings_get_user_value(GtkOpaque,string)",
   "int = gdk_device_pad_get_feature_group(GObject,int,int)",
   "GVariant = g_variant_new_tuple(GVariant[],ulong)",
   "int = gtk_icon_view_get_text_column(GtkWidget)",
   "g_date_time_unref(GDateTime)",
   "ulong = g_file_icon_get_type()",
   "gtk_tree_store_set_column_types(GObject,ulong[])",
   "GtkWidget = gtk_expander_new(string)",
   "int = g_variant_is_object_path(string)",
   "int = gtk_text_iter_forward_visible_word_ends(GtkTextIter,int)",
   "int = gtk_widget_keynav_failed(GtkWidget,int)",
   "gtk_popover_set_default_widget(GtkWidget,GtkWidget)",
   "ulong = pango_coverage_get_type()",
   "GtkTreeIter = gtk_tree_model_filter_convert_child_iter_to_iter(GObject,GtkTreeIter)",
   "gtk_print_job_set_track_print_status(GObject,int)",
   "(double,double) = gdk_window_coords_to_parent(GObject,double,double)",
   "(GtkOpaque,int,int) = gdk_pixbuf_get_file_info(string)",
   "GtkWidget = gtk_dialog_get_content_area(GtkWidget)",
   "int = g_main_context_prepare(GMainContext,int[])",
   "int = gdk_get_show_events()",
   "ulong = g_resource_get_type()",
   "gtk_header_bar_set_subtitle(GtkWidget,string)",
   "int = gtk_notebook_insert_page(GtkWidget,GtkWidget,GtkWidget,int)",
   "gdk_window_set_override_redirect(GObject,int)",
   "(int,int) = gtk_tree_view_convert_widget_to_tree_coords(GtkWidget,int,int)",
   "GVariantType = g_variant_type_new_array(GVariantType)",
   "int = gtk_print_job_get_page_set(GObject)",
   "int = g_credentials_is_same_user(GObject,GObject)",
   "int = gtk_button_get_relief(GtkWidget)",
   "int = g_file_set_attribute_string(GtkOpaque,string,string,int,GtkOpaque)",
   "GtkOpaque = gtk_file_chooser_get_uris(GObject)",
   "g_key_file_set_locale_string(GKeyFile,string,string,string,string)",
   "string = g_type_name(ulong)",
   "int = g_settings_set_uint(GtkOpaque,string,uint)",
   "ulong = gtk_cell_area_context_get_type()",
   "gtk_gl_area_make_current(GtkWidget)",
   "GtkWidget = gtk_accel_label_new(string)",
   "(int,double,double) = gdk_device_get_axis(GdkDevice,int)",
   "(GtkRequisition, GtkRequisition) = gtk_widget_get_preferred_size(GtkWidget)",
   "GObject = gdk_get_default_root_window()",
   "int = gdk_window_get_device_events(GObject,GdkDevice)",
   "int = g_signal_handler_is_connected(GtkOpaque,ulong)",
   "gdk_window_focus(GObject,uint)",
   "long = g_input_stream_skip(GObject,ulong,GtkOpaque)",
   "double = gdk_events_get_angle(GdkEvent,GdkEvent)",
   "string = g_action_get_name(GtkOpaque)",
   "GtkOpaque = gdk_window_peek_children(GObject)",
   "g_date_free(GDate)",
   "int = g_unichar_combining_class(uint)",
   "gtk_places_sidebar_set_show_connect_to_server(GtkWidget,int)",
   "string = g_binding_get_target_property(GtkOpaque)",
   "GObject = gtk_widget_get_visual(GtkWidget)",
   "string = pango_layout_get_text(GtkOpaque)",
   "ulong = gdk_device_get_type()",
   "int = gtk_selection_convert(GtkWidget,GObject,GObject,uint)",
   "GtkOpaque = g_param_spec_pool_lookup(GtkOpaque,string,ulong,int)",
   "gtk_gl_area_set_auto_render(GtkWidget,int)",
   "ulong = g_type_parent(ulong)",
   "GtkOpaque = gtk_cell_layout_get_cells(GObject)",
   "gtk_tool_item_group_set_item_position(GtkWidget,GtkWidget,int)",
   "int = pango_layout_get_spacing(GtkOpaque)",
   "gtk_text_view_move_child(GtkWidget,GtkWidget,int,int)",
   "int = gtk_text_iter_forward_cursor_position(GtkTextIter)",
   "gtk_file_chooser_set_choice(GObject,string,string)",
   "GObject = gdk_display_get_default_screen(GObject)",
   "gdk_device_ungrab(GdkDevice,uint)",
   "GtkOpaque = g_settings_create_action(GtkOpaque,string)",
   "GObject = gtk_clipboard_get_default(GObject)",
   "gtk_tree_view_set_reorderable(GtkWidget,int)",
   "gtk_print_unix_dialog_set_has_selection(GtkWidget,int)",
   "gtk_builder_set_translation_domain(GObject,string)",
   "string = pango_font_description_to_filename(GtkOpaque)",
   "GObject = gtk_scrollable_get_vadjustment(GObject)",
   "int = gtk_tree_view_column_get_expand(GtkWidget)",
   "gtk_entry_completion_set_popup_completion(GObject,int)",
   "gtk_tree_view_column_set_sort_order(GtkWidget,int)",
   "int = g_variant_type_is_container(GVariantType)",
   "gtk_text_buffer_copy_clipboard(GObject,GObject)",
   "GtkWidget = gtk_file_chooser_widget_new(int)",
   "int = g_inet_address_get_is_mc_global(GObject)",
   "string = glib_check_version(uint,uint,uint)",
   "ulong = gdk_cursor_get_type()",
   "uchar = g_date_get_day(GDate)",
   "int = gtk_print_settings_get_number_up(GObject)",
   "GtkOpaque = gtk_radio_menu_item_get_group(GtkWidget)",
   "gtk_assistant_commit(GtkWidget)",
   "int = g_utf8_validate(string,long,string[])",
   "gtk_widget_set_valign(GtkWidget,int)",
   "int = gtk_list_store_remove(GObject,GtkTreeIter)",
   "int = gtk_tree_view_column_get_spacing(GtkWidget)",
   "int = gtk_icon_view_get_column_spacing(GtkWidget)",
   "GtkTextIter = gtk_text_buffer_get_iter_at_mark(GObject,GObject)",
   "gtk_window_add_mnemonic(GtkWidget,uint,GtkWidget)",
   "gtk_info_bar_set_response_sensitive(GtkWidget,int,int)",
   "g_object_getv(GObject,uint,string[],GtkOpaque)",
   "GtkTextAttributes = gtk_text_attributes_ref(GtkTextAttributes)",
   "int = gtk_font_button_get_use_font(GtkWidget)",
   "int = gtk_style_context_get_state(GObject)",
   "int = g_variant_is_signature(string)",
   "int = gtk_targets_include_uri(GObject[],int)",
   "gdk_window_begin_move_drag_for_device(GObject,GdkDevice,int,int,int,uint)",
   "uint = gtk_text_iter_get_char(GtkTextIter)",
   "gtk_range_set_upper_stepper_sensitivity(GtkWidget,int)",
   "g_regex_unref(GRegex)",
   "GDateTime = g_date_time_add_weeks(GDateTime,int)",
   "int = gdk_screen_get_width(GObject)",
   "int = g_date_time_get_minute(GDateTime)",
   "GObject = g_inet_address_new_from_bytes(uchar[],int)",
   "gtk_search_bar_connect_entry(GtkWidget,GtkWidget)",
   "int = gtk_file_chooser_get_select_multiple(GObject)",
   "ulong = g_charset_converter_get_type()",
   "gtk_render_layout(GObject,Cairo,double,double,GtkOpaque)",
   "gtk_widget_set_redraw_on_allocate(GtkWidget,int)",
   "PangoCoverage = pango_font_get_coverage(GtkOpaque,GtkOpaque)",
   "gtk_style_context_set_screen(GObject,GObject)",
   "GDateTime = g_date_time_add_months(GDateTime,int)",
   "GtkOpaque = pango_attr_stretch_new(int)",
   "ulong = g_volume_get_type()",
   "uchar = g_date_get_sunday_weeks_in_year(ushort)",
   "int = gtk_icon_view_get_item_column(GtkWidget,GtkTreePath)",
   "gdk_seat_ungrab(GObject)",
   "GtkOpaque = gtk_get_default_language()",
   "int = gtk_entry_completion_get_popup_completion(GObject)",
   "string = g_key_file_get_string(GKeyFile,string,string)",
   "g_settings_schema_source_list_schemas(GtkOpaque,int,gchar_ptr_ptr_ptr,gchar_ptr_ptr_ptr)",
   "int = gtk_gl_area_get_has_depth_buffer(GtkWidget)",
   "gtk_widget_thaw_child_notify(GtkWidget)",
   "int = pango_layout_is_ellipsized(GtkOpaque)",
   "string = g_strdupv(string[])",
   "GObject = gdk_drag_context_get_drag_window(GObject)",
   "int = gtk_list_box_row_is_selected(GtkWidget)",
   "gtk_expander_set_expanded(GtkWidget,int)",
   "ulong = gtk_cell_view_get_type()",
   "string = g_app_info_get_description(GtkOpaque)",
   "string = g_app_info_get_name(GtkOpaque)",
   "gdk_window_set_background_rgba(GObject,struct)",
   "string = gtk_combo_box_get_title(GtkWidget)",
   "gtk_accel_map_add_entry(string,uint,int)",
   "string = g_param_spec_get_blurb(GtkOpaque)",
   "string = gtk_file_chooser_get_preview_uri(GObject)",
   "gtk_gesture_set_window(GObject,GObject)",
   "uint = gtk_file_chooser_error_quark()",
   "(int,int) = gtk_tree_view_convert_bin_window_to_tree_coords(GtkWidget,int,int)",
   "int = gtk_file_chooser_set_uri(GObject,string)",
   "gtk_label_set_justify(GtkWidget,int)",
   "string = g_bookmark_file_get_uris(GBookmarkFile)",
   "int = gtk_widget_has_default(GtkWidget)",
   "int = gdk_selection_property_get(GObject,guchar_ptr_ptr,GObject[],int[])",
   "int = g_str_has_prefix(string,string)",
   "long = g_utf8_pointer_to_offset(string,string)",
   "int = g_settings_range_check(GtkOpaque,string,GVariant)",
   "gtk_widget_set_can_default(GtkWidget,int)",
   "int = gtk_assistant_insert_page(GtkWidget,GtkWidget,int)",
   "pango_cairo_update_context(Cairo,GtkOpaque)",
   "string = g_get_language_names()",
   "gtk_clipboard_store(GObject)",
   "GtkOpaque = pango_attr_font_desc_new(GtkOpaque)",
   "ulong = gtk_header_bar_get_type()",
   "g_file_info_set_attribute_mask(GObject,GtkOpaque)",
   "pango_font_description_merge(GtkOpaque,GtkOpaque,int)",
   "GdkRGBA = gtk_style_context_get_border_color(GObject,int)",
   "GVariant = g_variant_new_strv(string[],long)",
   "pango_layout_set_tabs(GtkOpaque,PangoTabArray)",
   "gdk_set_show_events(int)",
   "int = gtk_notebook_get_tab_reorderable(GtkWidget,GtkWidget)",
   "gdk_window_thaw_updates(GObject)",
   "gtk_icon_view_set_column_spacing(GtkWidget,int)",
   "ulong = g_settings_get_type()",
   "int = g_menu_attribute_iter_next(GObject)",
   "ulong = gtk_event_controller_scroll_get_type()",
   "string = g_app_launch_context_get_environment(GObject)",
   "gdk_window_set_modal_hint(GObject,int)",
   "ulong = gtk_scale_get_type()",
   "(int,int) = gtk_range_get_slider_range(GtkWidget)",
   "gtk_button_set_alignment(GtkWidget,float,float)",
   "int = gtk_icon_view_get_pixbuf_column(GtkWidget)",
   "g_app_info_reset_type_associations(string)",
   "int = gtk_notebook_get_n_pages(GtkWidget)",
   "GtkOpaque = g_mount_get_root(GtkOpaque)",
   "gtk_event_controller_set_propagation_phase(GObject,int)",
   "int = gtk_image_get_stock(GtkWidget,string[])",
   "gtk_scrollable_set_vscroll_policy(GObject,int)",
   "gtk_application_add_accelerator(GObject,string,string,GVariant)",
   "g_match_info_unref(GMatchInfo)",
   "ulong = gtk_list_box_row_get_type()",
   "GtkWidget = gtk_menu_item_get_submenu(GtkWidget)",
   "g_file_info_copy_into(GObject,GObject)",
   "GtkWidget = gtk_search_bar_new()",
   "gtk_tree_model_ref_node(GObject,GtkTreeIter)",
   "gtk_toggle_button_set_mode(GtkWidget,int)",
   "int = g_key_file_get_integer(GKeyFile,string,string)",
   "GVariant = g_settings_schema_key_get_default_value(GtkOpaque)",
   "int = gdk_rectangle_equal(struct,struct)",
   "int = gtk_alternative_dialog_button_order(GObject)",
   "gdk_keymap_add_virtual_modifiers(GObject,int[])",
   "gtk_container_propagate_draw(GtkWidget,GtkWidget,Cairo)",
   "gtk_level_bar_set_inverted(GtkWidget,int)",
   "gtk_stack_set_vhomogeneous(GtkWidget,int)",
   "GtkOpaque = gtk_gesture_single_get_current_sequence(GObject)",
   "float = gtk_entry_get_alignment(GtkWidget)",
   "int = g_str_match_string(string,string,int)",
   "int = g_uuid_string_is_valid(string)",
   "int = g_variant_get_int32(GVariant)",
   "string = g_variant_get_strv(GVariant)",
   "int = gtk_widget_get_allocated_height(GtkWidget)",
   "ulong = gtk_cell_renderer_toggle_get_type()",
   "pango_font_description_set_size(GtkOpaque,int)",
   "int = pango_layout_get_width(GtkOpaque)",
   "gtk_accel_group_lock(GObject)",
   "string = gtk_text_iter_get_slice(GtkTextIter,GtkTextIter)",
   "int = gtk_button_get_focus_on_click(GtkWidget)",
   "gtk_tree_view_set_grid_lines(GtkWidget,int)",
   "gtk_menu_button_set_direction(GtkWidget,int)",
   "GtkWidget = gtk_menu_item_new_with_mnemonic(string)",
   "g_socket_set_multicast_ttl(GObject,uint)",
   "gtk_entry_buffer_emit_deleted_text(GObject,uint,uint)",
   "gtk_print_settings_set_use_color(GObject,int)",
   "(int,int) = gtk_scrolled_window_get_policy(GtkWidget)",
   "gtk_recent_chooser_set_local_only(GObject,int)",
   "gtk_text_buffer_delete_mark_by_name(GObject,string)",
   "int = gdk_display_supports_cursor_alpha(GObject)",
   "string = gtk_entry_get_icon_name(GtkWidget,int)",
   "int = g_file_info_get_file_type(GObject)",
   "g_simple_proxy_resolver_set_uri_proxy(GObject,string,string)",
   "gtk_text_iter_set_visible_line_offset(GtkTextIter,int)",
   "GVariant = g_variant_new_uint32(uint)",
   "gtk_render_handle(GObject,Cairo,double,double,double,double)",
   "gtk_entry_set_attributes(GtkWidget,PangoAttrList)",
   "struct = pango_renderer_get_color(GtkOpaque,int)",
   "int = gtk_widget_get_vexpand(GtkWidget)",
   "GdkRectangle = gtk_window_get_resize_grip_area(GtkWidget)",
   "gdk_window_end_draw_frame(GObject,GObject)",
   "int = gtk_editable_get_selection_bounds(GObject,int[],int[])",
   "int = gtk_window_get_urgency_hint(GtkWidget)",
   "int = gtk_text_buffer_deserialize_get_can_create_tags(GObject,GObject)",
   "GObject = gdk_display_get_monitor_at_point(GObject,int,int)",
   "gdk_cairo_set_source_window(Cairo,GObject,double,double)",
   "PangoFontMetrics = pango_font_get_metrics(GtkOpaque,GtkOpaque)",
   "int = gtk_popover_get_modal(GtkWidget)",
   "gtk_tree_model_row_deleted(GObject,GtkTreePath)",
   "GObject = gdk_drag_context_get_dest_window(GObject)",
   "g_file_info_remove_attribute(GObject,string)",
   "int = gtk_cell_area_activate_cell(GObject,GtkWidget,GObject,GdkEvent,struct,int)",
   "GtkWidget = gtk_application_get_window_by_id(GObject,uint)",
   "gtk_assistant_previous_page(GtkWidget)",
   "int = gtk_tree_store_iter_is_valid(GObject,GtkTreeIter)",
   "gdk_window_set_cursor(GObject,GObject)",
   "int = gtk_combo_box_get_id_column(GtkWidget)",
   "uint = gtk_builder_add_from_resource(GObject,string)",
   "ulong = gdk_cursor_type_get_type()",
   "GObject = gtk_target_entry_new(string,uint,uint)",
   "gtk_color_button_set_title(GtkWidget,string)",
   "GtkWidget = gtk_file_chooser_get_extra_widget(GObject)",
   "gdk_device_warp(GdkDevice,GObject,int,int)",
   "GdkPixbuf = gdk_pixbuf_new_from_bytes(GBytes,int,int,int,int,int,int)",
   "gdk_window_set_device_events(GObject,GdkDevice,int)",
   "g_settings_backend_path_changed(GtkOpaque,string,GtkOpaque)",
   "uint = g_strv_length(string[])",
   "GtkOpaque = g_mount_get_default_location(GtkOpaque)",
   "GObject = gtk_text_iter_get_child_anchor(GtkTextIter)",
   "GtkWidget = gtk_about_dialog_new()",
   "GObject = gtk_gesture_multi_press_new(GtkWidget)",
   "gtk_tool_button_set_icon_name(GtkWidget,string)",
   "gtk_entry_set_text(GtkWidget,string)",
   "gtk_places_sidebar_set_open_flags(GtkWidget,int)",
   "gtk_info_bar_response(GtkWidget,int)",
   "ulong = g_file_info_get_type()",
   "int = pango_layout_get_auto_dir(GtkOpaque)",
   "string = gtk_font_chooser_get_font_features(GObject)",
   "int = gtk_icon_info_is_symbolic(GObject)",
   "ulong = gtk_separator_tool_item_get_type()",
   "GtkWidget = gtk_combo_box_new_with_model_and_entry(GObject)",
   "gtk_widget_add_device_events(GtkWidget,GdkDevice,int)",
   "GtkTreeIter = gtk_tree_model_get_iter_from_string(GObject,string)",
   "gtk_combo_box_text_insert(GtkWidget,int,string,string)",
   "int = g_path_is_absolute(string)",
   "gdk_cairo_draw_from_gl(Cairo,GObject,int,int,int,int,int,int,int)",
   "int = gtk_range_get_lower_stepper_sensitivity(GtkWidget)",
   "GtkWidget = gtk_check_menu_item_new_with_label(string)",
   "double = gtk_level_bar_get_max_value(GtkWidget)",
   "GRand = g_rand_new()",
   "g_value_set_string(GtkOpaque,string)",
   "string = g_app_info_get_commandline(GtkOpaque)",
   "int = gdk_window_get_scale_factor(GObject)",
   "g_key_file_set_uint64(GKeyFile,string,string,ulong)",
   "int = pango_font_metrics_get_approximate_char_width(PangoFontMetrics)",
   "(GdkRectangle, GdkRectangle) = gtk_text_view_get_cursor_locations(GtkWidget,GtkTextIter)",
   "GtkOpaque = gtk_file_chooser_get_current_folder_file(GObject)",
   "GObject = g_socket_new(int,int,int)",
   "GtkWidget = gtk_list_box_row_get_header(GtkWidget)",
   "GDateTime = g_date_time_add_minutes(GDateTime,int)",
   "string = g_variant_get_type_string(GVariant)",
   "gtk_widget_add_mnemonic_label(GtkWidget,GtkWidget)",
   "gtk_tree_model_sort_clear_cache(GObject)",
   "g_mount_unshadow(GtkOpaque)",
   "(int,int) = gtk_cell_area_context_get_preferred_width_for_height(GObject,int)",
   "GObject = gtk_application_get_menubar(GObject)",
   "ulong = g_mount_get_type()",
   "GObject = gdk_display_get_primary_monitor(GObject)",
   "g_key_file_set_boolean_list(GKeyFile,string,string,int[])",
   "int = g_variant_type_is_basic(GVariantType)",
   "ulong = gtk_stack_get_type()",
   "GObject = gtk_print_settings_new()",
   "PangoTabArray = gtk_entry_get_tabs(GtkWidget)",
   "gtk_text_view_set_bottom_margin(GtkWidget,int)",
   "GtkWidget = gtk_toggle_tool_button_new_from_stock(string)",
   "int = g_variant_compare(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_recent_chooser_widget_new_for_manager(GObject)",
   "int = gdk_gl_context_realize(GObject)",
   "GObject = gtk_drag_begin_with_coordinates(GtkWidget,GtkTargetList,int,int,GdkEvent,int,int)",
   "int = g_socket_check_connect_result(GObject)",
   "gtk_widget_set_font_options(GtkWidget,Cairo)",
   "uint = g_date_get_julian(GDate)",
   "int = gtk_notebook_get_scrollable(GtkWidget)",
   "uint = gtk_gesture_single_get_button(GObject)",
   "g_value_set_int64(GtkOpaque,long)",
   "int = g_key_file_remove_key(GKeyFile,string,string)",
   "int = gtk_show_uri_on_window(GtkWidget,string,uint)",
   "int = g_time_zone_is_dst(GTimeZone,int)",
   "int = gtk_scrolled_window_get_kinetic_scrolling(GtkWidget)",
   "string = gtk_native_dialog_get_title(GtkWidget)",
   "gtk_icon_view_scroll_to_path(GtkWidget,GtkTreePath,int,float,float)",
   "int = gtk_spin_button_get_value_as_int(GtkWidget)",
   "gtk_tree_view_column_clear_attributes(GtkWidget,GObject)",
   "int = g_file_mount_enclosing_volume_finish(GtkOpaque,GtkOpaque)",
   "GtkTargetList = gtk_text_buffer_get_paste_target_list(GObject)",
   "ulong = g_app_info_monitor_get_type()",
   "gtk_link_button_set_visited(GtkWidget,int)",
   "gdk_window_set_startup_id(GObject,string)",
   "int = gtk_tool_item_get_expand(GtkWidget)",
   "gtk_combo_box_text_remove_all(GtkWidget)",
   "int = gtk_recent_chooser_get_show_icons(GObject)",
   "g_main_context_add_poll(GMainContext,GtkOpaque,int)",
   "GObject = gdk_display_manager_get()",
   "gtk_menu_item_activate(GtkWidget)",
   "ulong = pango_font_get_type()",
   "int = gtk_scale_get_has_origin(GtkWidget)",
   "GtkWidget = gtk_assistant_new()",
   "GObject = g_app_info_monitor_get()",
   "GObject = gtk_tree_model_filter_get_model(GObject)",
   "int = g_bookmark_file_move_item(GBookmarkFile,string,string)",
   "int = g_unichar_istitle(uint)",
   "gdk_selection_send_notify(GObject,GObject,GObject,GObject,uint)",
   "ulong = gtk_link_button_get_type()",
   "gtk_about_dialog_set_authors(GtkWidget,string[])",
   "GtkWidget = gtk_menu_tool_button_new_from_stock(string)",
   "ulong = gdk_wm_function_get_type()",
   "string = g_file_get_parse_name(GtkOpaque)",
   "int = gtk_file_chooser_remove_shortcut_folder(GObject,string)",
   "PangoLayoutIter = pango_layout_get_iter(GtkOpaque)",
   "int = gtk_printer_get_capabilities(GObject)",
   "GObject = gtk_builder_get_application(GObject)",
   "GObject = g_file_query_info_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_flow_box_get_selection_mode(GtkWidget)",
   "GtkOpaque = gtk_tree_selection_get_selected_rows(GObject,GObject[])",
   "PangoTabArray = pango_layout_get_tabs(GtkOpaque)",
   "ulong = gtk_text_view_get_type()",
   "int = gtk_recent_filter_get_needed(GObject)",
   "g_date_add_months(GDate,uint)",
   "GObject = gtk_icon_theme_lookup_by_gicon_for_scale(GObject,GtkOpaque,int,int,int)",
   "gtk_entry_completion_complete(GObject)",
   "gtk_editable_delete_selection(GObject)",
   "g_settings_schema_source_unref(GtkOpaque)",
   "int = gtk_file_chooser_get_action(GObject)",
   "int = gtk_notebook_prepend_page(GtkWidget,GtkWidget,GtkWidget)",
   "g_value_set_double(GtkOpaque,double)",
   "gtk_tool_item_set_tooltip_text(GtkWidget,string)",
   "int = gdk_pixbuf_init_modules(string)",
   "gtk_icon_theme_append_search_path(GObject,string)",
   "int = gdk_display_device_is_grabbed(GObject,GdkDevice)",
   "GObject = gtk_tool_palette_get_drag_target_item()",
   "gtk_widget_set_margin_right(GtkWidget,int)",
   "ulong = g_app_launch_context_get_type()",
   "int = gtk_native_dialog_run(GtkWidget)",
   "ulong = gdk_keymap_get_type()",
   "int = gtk_list_store_iter_is_valid(GObject,GtkTreeIter)",
   "gtk_grid_set_row_homogeneous(GtkWidget,int)",
   "int = gdk_device_get_axes(GdkDevice)",
   "g_notification_set_default_action(GtkOpaque,string)",
   "GtkWidget = gtk_scale_button_get_plus_button(GtkWidget)",
   "gtk_cell_area_add_focus_sibling(GObject,GObject,GObject)",
   "char = g_value_get_schar(GtkOpaque)",
   "int = g_inet_address_get_is_site_local(GObject)",
   "int = gtk_about_dialog_get_license_type(GtkWidget)",
   "GtkWidget = gtk_box_get_center_widget(GtkWidget)",
   "GtkOpaque = g_value_get_param(GtkOpaque)",
   "GtkWidget = gtk_menu_shell_get_parent_shell(GtkWidget)",
   "ushort = gdk_event_get_keycode(GdkEvent)",
   "GBytes = g_resources_lookup_data(string,int)",
   "ulong = pango_tab_array_get_type()",
   "gdk_event_set_device(GdkEvent,GdkDevice)",
   "GVariant = g_variant_get_child_value(GVariant,ulong)",
   "int = gtk_tree_view_column_get_sort_indicator(GtkWidget)",
   "GtkWidgetPath = gtk_widget_path_iter_get_siblings(GtkWidgetPath,int)",
   "GtkPaperSize = gtk_print_settings_get_paper_size(GObject)",
   "gtk_container_set_focus_vadjustment(GtkWidget,GObject)",
   "int = gtk_text_iter_is_cursor_position(GtkTextIter)",
   "ulong = gdk_device_tool_get_hardware_id(GObject)",
   "g_cancellable_push_current(GtkOpaque)",
   "string = gdk_get_display_arg_name()",
   "GdkEvent = gdk_event_get()",
   "string = g_get_user_special_dir(int)",
   "uint = g_resolver_error_quark()",
   "GObject = gtk_print_job_get_printer(GObject)",
   "int = gtk_tree_view_column_get_sort_column_id(GtkWidget)",
   "GtkWidget = gtk_frame_get_label_widget(GtkWidget)",
   "g_app_launch_context_launch_failed(GObject,string)",
   "int = g_settings_schema_key_range_check(GtkOpaque,GVariant)",
   "int = gtk_grid_get_row_homogeneous(GtkWidget)",
   "g_key_file_set_boolean(GKeyFile,string,string,int)",
   "string = g_strdup(string)",
   "GObject = gtk_file_filter_new()",
   "GtkOpaque = g_file_icon_get_file(GObject)",
   "int = gdk_window_is_destroyed(GObject)",
   "GObject = gtk_tree_view_get_selection(GtkWidget)",
   "GtkOpaque = gdk_device_manager_list_devices(GObject,int)",
   "int = gtk_recent_chooser_get_local_only(GObject)",
   "GtkOpaque = g_file_get_child(GtkOpaque,string)",
   "long = gdk_frame_clock_get_history_start(GObject)",
   "GObject = gtk_file_filter_new_from_gvariant(GVariant)",
   "GBookmarkFile = g_bookmark_file_new()",
   "GVariant = g_variant_new_bytestring_array(string[],long)",
   "int = gdk_visual_get_depth(GObject)",
   "GtkOpaque = g_file_attribute_info_list_ref(GtkOpaque)",
   "int = gtk_page_setup_to_file(GObject,string)",
   "gtk_button_set_relief(GtkWidget,int)",
   "int = gtk_stack_get_vhomogeneous(GtkWidget)",
   "GtkWidget = gtk_notebook_get_menu_label(GtkWidget,GtkWidget)",
   "int = gtk_widget_get_mapped(GtkWidget)",
   "GtkWidget = gtk_header_bar_new()",
   "GObject = gtk_print_settings_new_from_gvariant(GVariant)",
   "GtkWidget = gtk_list_box_get_selected_row(GtkWidget)",
   "int = g_mount_unmount_with_operation_finish(GtkOpaque,GtkOpaque)",
   "gtk_widget_set_tooltip_window(GtkWidget,GtkWidget)",
   "int = gdk_window_get_height(GObject)",
   "gtk_window_remove_accel_group(GtkWidget,GObject)",
   "gtk_entry_set_input_hints(GtkWidget,int)",
   "int = gtk_app_chooser_button_get_show_dialog_item(GtkWidget)",
   "gtk_print_operation_set_default_page_setup(GObject,GObject)",
   "g_file_info_set_attribute_uint64(GObject,string,ulong)",
   "ulong = gtk_font_chooser_dialog_get_type()",
   "GtkWidget = gtk_stack_switcher_new()",
   "gtk_recent_chooser_set_select_multiple(GObject,int)",
   "string = g_mkdtemp(string)",
   "int = g_regex_get_has_cr_or_lf(GRegex)",
   "ulong = g_settings_get_uint64(GtkOpaque,string)",
   "g_menu_item_set_section(GObject,GObject)",
   "gdk_drop_finish(GObject,int,uint)",
   "int = gtk_app_chooser_widget_get_show_all(GtkWidget)",
   "gtk_widget_set_clip(GtkWidget,struct)",
   "gtk_text_iter_forward_to_end(GtkTextIter)",
   "GtkOpaque = pango_layout_iter_get_run_readonly(PangoLayoutIter)",
   "Cairo = gtk_offscreen_window_get_surface(GtkWidget)",
   "string = g_key_file_get_value(GKeyFile,string,string)",
   "gtk_text_view_scroll_mark_onscreen(GtkWidget,GObject)",
   "double = gtk_page_setup_get_bottom_margin(GObject,int)",
   "gtk_scrolled_window_set_kinetic_scrolling(GtkWidget,int)",
   "gtk_notebook_reorder_child(GtkWidget,GtkWidget,int)",
   "int = gdk_screen_get_monitor_scale_factor(GObject,int)",
   "gtk_cell_renderer_set_padding(GObject,int,int)",
   "GtkOpaque = pango_attribute_copy(GtkOpaque)",
   "double = g_random_double()",
   "ulong = gtk_tool_item_group_get_type()",
   "int = g_file_set_attributes_finish(GtkOpaque,GtkOpaque,GObject[])",
   "gtk_tool_button_set_label(GtkWidget,string)",
   "gtk_print_operation_set_support_selection(GObject,int)",
   "g_timer_reset(GTimer)",
   "ulong = gtk_mount_operation_get_type()",
   "GObject = gtk_layout_get_bin_window(GtkWidget)",
   "int = g_type_check_instance_is_fundamentally_a(GtkOpaque,ulong)",
   "gtk_drag_source_set_icon_gicon(GtkWidget,GtkOpaque)",
   "gtk_menu_tool_button_set_arrow_tooltip_markup(GtkWidget,string)",
   "gtk_icon_view_unset_model_drag_dest(GtkWidget)",
   "int = g_io_channel_flush(GIOChannel)",
   "gtk_tree_view_columns_autosize(GtkWidget)",
   "(float,float) = gtk_cell_renderer_get_alignment(GObject)",
   "GtkWidget = gtk_application_get_active_window(GObject)",
   "GDateTime = g_date_time_new_from_timeval_utc(struct)",
   "ulong = gdk_owner_change_get_type()",
   "int = g_regex_match_simple(string,string,int,int)",
   "ulong = gtk_buildable_get_type()",
   "gtk_combo_box_set_active(GtkWidget,int)",
   "int = gtk_text_buffer_get_line_count(GObject)",
   "GVariant = g_value_dup_variant(GtkOpaque)",
   "string = gtk_print_settings_get_printer(GObject)",
   "int = g_socket_get_broadcast(GObject)",
   "GdkDevice = gdk_seat_get_pointer(GObject)",
   "int = g_socket_join_multicast_group(GObject,GObject,int,string)",
   "(int,uint) = g_unichar_compose(uint,uint)",
   "int = gtk_button_box_get_layout(GtkWidget)",
   "GtkOpaque = gtk_file_chooser_list_shortcut_folder_uris(GObject)",
   "gtk_notebook_set_scrollable(GtkWidget,int)",
   "int = pango_font_description_equal(GtkOpaque,GtkOpaque)",
   "gtk_toolbar_unset_style(GtkWidget)",
   "gtk_cell_renderer_toggle_set_radio(GObject,int)",
   "string = g_app_launch_context_get_display(GObject,GtkOpaque,GtkOpaque[])",
   "int = g_mkstemp_full(string,int,int)",
   "GtkWidget = gtk_notebook_get_action_widget(GtkWidget,int)",
   "struct = gtk_gl_area_get_error(GtkWidget)",
   "g_menu_prepend_submenu(GObject,string,GObject)",
   "GtkWidget = gtk_places_sidebar_new()",
   "int = g_mount_can_unmount(GtkOpaque)",
   "GtkOpaque = gdk_window_get_children_with_user_data(GObject,GtkOpaque)",
   "int = g_main_context_iteration(GMainContext,int)",
   "int = gtk_tree_path_up(GtkTreePath)",
   "int = gtk_tree_view_get_enable_tree_lines(GtkWidget)",
   "GtkWidget = gtk_label_new(string)",
   "gdk_window_set_composited(GObject,int)",
   "g_source_destroy(GSource)",
   "GtkOpaque = gdk_pixbuf_get_formats()",
   "gtk_assistant_remove_page(GtkWidget,int)",
   "gtk_container_set_focus_child(GtkWidget,GtkWidget)",
   "gtk_widget_insert_action_group(GtkWidget,string,GtkOpaque)",
   "GObject = gtk_page_setup_new_from_file(string)",
   "GtkTextAttributes = gtk_text_attributes_copy(GtkTextAttributes)",
   "int = g_file_set_attribute_uint32(GtkOpaque,string,uint,int,GtkOpaque)",
   "g_rand_free(GRand)",
   "gtk_app_chooser_button_set_heading(GtkWidget,string)",
   "gtk_stack_sidebar_set_stack(GtkWidget,GtkWidget)",
   "g_value_take_param(GtkOpaque,GtkOpaque)",
   "pango_layout_set_auto_dir(GtkOpaque,int)",
   "int = gtk_overlay_get_overlay_pass_through(GtkWidget,GtkWidget)",
   "gtk_render_frame_gap(GObject,Cairo,double,double,double,double,int,double,double)",
   "GObject = gtk_cell_renderer_text_new()",
   "gtk_icon_view_unselect_all(GtkWidget)",
   "int = gdk_init_check(int[],gchar_ptr_ptr_ptr)",
   "g_resource_unref(GtkOpaque)",
   "int = gtk_text_view_get_monospace(GtkWidget)",
   "GtkOpaque = g_app_info_get_default_for_type(string,int)",
   "gdk_window_set_type_hint(GObject,int)",
   "GObject = gtk_buildable_construct_child(GObject,GObject,string)",
   "gtk_calendar_set_display_options(GtkWidget,int)",
   "gtk_tree_view_set_expander_column(GtkWidget,GtkWidget)",
   "gtk_progress_bar_set_show_text(GtkWidget,int)",
   "gtk_widget_path_iter_add_class(GtkWidgetPath,int,string)",
   "int = gtk_entry_get_icon_sensitive(GtkWidget,int)",
   "g_hmac_unref(GHmac)",
   "gtk_accel_map_load(string)",
   "GObject = gtk_icon_theme_lookup_icon(GObject,string,int,int)",
   "GMainContext = g_source_get_context(GSource)",
   "string = gtk_tool_button_get_label(GtkWidget)",
   "GtkWidget = gtk_combo_box_new_with_model(GObject)",
   "int = g_mount_operation_get_password_save(GObject)",
   "ulong = gtk_style_context_get_type()",
   "int = g_bookmark_file_set_app_info(GBookmarkFile,string,string,string,int,ulong)",
   "GtkWidget = gtk_icon_view_new_with_model(GObject)",
   "gtk_selection_remove_all(GtkWidget)",
   "uint = g_quark_from_static_string(string)",
   "int = g_main_depth()",
   "gtk_combo_box_text_append_text(GtkWidget,string)",
   "GVariant = gtk_paper_size_to_gvariant(GtkPaperSize)",
   "gdk_drag_status(GObject,int,uint)",
   "GObject = gtk_size_group_new(int)",
   "int = g_settings_set_value(GtkOpaque,string,GVariant)",
   "GObject = gtk_accel_map_get()",
   "gtk_window_maximize(GtkWidget)",
   "int = gtk_window_propagate_key_event(GtkWidget,GObject)",
   "int = gtk_text_view_backward_display_line(GtkWidget,GtkTextIter)",
   "GtkWidget = gtk_mount_operation_get_parent(GObject)",
   "GObject = gdk_drag_begin_from_point(GObject,GdkDevice,GtkOpaque[],int,int)",
   "gtk_scrollable_set_vadjustment(GObject,GObject)",
   "gtk_menu_shell_deselect(GtkWidget)",
   "gtk_tree_row_reference_deleted(GObject,GtkTreePath)",
   "gtk_widget_set_parent(GtkWidget,GtkWidget)",
   "int = pango_language_get_scripts(GtkOpaque,int[])",
   "string = gtk_recent_info_get_description(GObject)",
   "GtkWidget = gtk_cell_view_new_with_pixbuf(GdkPixbuf)",
   "int = gtk_widget_get_margin_left(GtkWidget)",
   "int = pango_font_family_is_monospace(GtkOpaque)",
   "g_file_info_set_icon(GObject,GtkOpaque)",
   "gdk_keyboard_ungrab(uint)",
   "g_menu_insert(GObject,int,string,string)",
   "int = gtk_file_chooser_get_local_only(GObject)",
   "gtk_target_list_unref(GtkTargetList)",
   "GtkOpaque = pango_layout_copy(GtkOpaque)",
   "gdk_window_invalidate_region(GObject,Cairo,int)",
   "gtk_check_menu_item_set_inconsistent(GtkWidget,int)",
   "gtk_tree_path_prepend_index(GtkTreePath,int)",
   "g_settings_bind_writable(GtkOpaque,string,GtkOpaque,string,int)",
   "pango_layout_set_height(GtkOpaque,int)",
   "GObject = gtk_viewport_get_bin_window(GtkWidget)",
   "int = gdk_keyboard_grab(GObject,int,uint)",
   "gdk_display_keyboard_ungrab(GObject,uint)",
   "gtk_menu_shell_insert(GtkWidget,GtkWidget,int)",
   "string = g_drive_get_identifier(GtkOpaque,string)",
   "GtkOpaque = gtk_entry_get_icon_gicon(GtkWidget,int)",
   "ulong = gtk_editable_get_type()",
   "string = g_inet_address_to_string(GObject)",
   "string = g_hostname_to_ascii(string)",
   "string = gtk_cell_area_get_current_path_string(GObject)",
   "ulong = pango_language_get_type()",
   "GtkOpaque = gtk_style_context_lookup_icon_set(GObject,string)",
   "gtk_print_operation_set_defer_drawing(GObject)",
   "gtk_icon_view_set_cursor(GtkWidget,GtkTreePath,GObject,int)",
   "gtk_notebook_next_page(GtkWidget)",
   "g_file_info_set_display_name(GObject,string)",
   "gtk_tool_button_set_label_widget(GtkWidget,GtkWidget)",
   "int = gtk_text_mark_get_visible(GObject)",
   "gtk_spin_button_spin(GtkWidget,int,double)",
   "gtk_page_setup_unix_dialog_set_page_setup(GtkWidget,GObject)",
   "int = gtk_tool_item_get_toolbar_style(GtkWidget)",
   "GObject = g_inet_address_mask_get_address(GtkOpaque)",
   "gtk_application_remove_window(GObject,GtkWidget)",
   "uint = gdk_gl_error_quark()",
   "GtkOpaque = gtk_file_chooser_get_file(GObject)",
   "GDateTime = g_file_info_get_modification_date_time(GObject)",
   "GObject = gtk_window_get_screen(GtkWidget)",
   "int = pango_layout_iter_get_baseline(PangoLayoutIter)",
   "g_file_info_set_attribute_int32(GObject,string,int)",
   "uint = g_date_get_day_of_year(GDate)",
   "string = g_dpgettext(string,string,ulong)",
   "gtk_stack_set_visible_child_name(GtkWidget,string)",
   "long = g_value_get_long(GtkOpaque)",
   "GtkWidget = gtk_stack_get_visible_child(GtkWidget)",
   "GtkTargetList = gtk_drag_source_get_target_list(GtkWidget)",
   "int = gdk_pixbuf_get_colorspace(GdkPixbuf)",
   "gdk_window_hide(GObject)",
   "gtk_popover_set_constrain_to(GtkWidget,int)",
   "g_variant_builder_init(GVariantBuilder,GVariantType)",
   "GObject = gdk_visual_get_best_with_depth(int)",
   "ulong = g_emblem_get_type()",
   "gtk_print_job_set_scale(GObject,double)",
   "gtk_list_box_row_set_selectable(GtkWidget,int)",
   "int = gdk_device_set_mode(GdkDevice,int)",
   "uint = g_file_error_quark()",
   "ulong = gtk_toggle_button_get_type()",
   "gtk_tree_view_column_set_alignment(GtkWidget,float)",
   "GObject = gtk_cell_area_get_focus_cell(GObject)",
   "GObject = gtk_icon_theme_choose_icon_for_scale(GObject,string[],int,int,int)",
   "int = g_file_set_attribute(GtkOpaque,string,int,GtkOpaque,int,GtkOpaque)",
   "gdk_gl_context_set_debug_enabled(GObject,int)",
   "int = gtk_widget_get_has_tooltip(GtkWidget)",
   "gtk_page_setup_set_bottom_margin(GObject,double,int)",
   "int = g_match_info_get_match_count(GMatchInfo)",
   "GVariant = g_settings_get_range(GtkOpaque,string)",
   "g_action_map_remove_action(GtkOpaque,string)",
   "(int,int,int) = gtk_label_get_selection_bounds(GtkWidget)",
   "uint = g_bookmark_file_error_quark()",
   "GtkOpaque = g_inet_socket_address_new(GObject,ushort)",
   "gtk_tree_selection_unselect_path(GObject,GtkTreePath)",
   "string = g_utf8_make_valid(string,long)",
   "GtkOpaque = pango_attr_fallback_new(int)",
   "GVariantType = g_settings_schema_key_get_value_type(GtkOpaque)",
   "int = g_variant_type_is_maybe(GVariantType)",
   "GObject = gtk_event_controller_motion_new(GtkWidget)",
   "gtk_application_remove_accelerator(GObject,string,GVariant)",
   "(int,int,int,int) = gtk_tree_view_column_cell_get_size(GtkWidget,struct)",
   "double = gtk_entry_get_progress_fraction(GtkWidget)",
   "GtkOpaque = g_type_class_get_private(GtkOpaque,ulong)",
   "GtkTreePath = gtk_tree_path_new_from_string(string)",
   "string = g_utf8_casefold(string,long)",
   "ulong = g_settings_backend_get_type()",
   "ulong = g_mount_operation_get_type()",
   "uint = g_type_depth(ulong)",
   "GtkOpaque = pango_attr_gravity_new(int)",
   "gtk_image_set_from_resource(GtkWidget,string)",
   "gtk_calendar_mark_day(GtkWidget,uint)",
   "GdkPixbuf = gtk_offscreen_window_get_pixbuf(GtkWidget)",
   "GObject = gtk_gesture_long_press_new(GtkWidget)",
   "g_menu_item_set_icon(GObject,GtkOpaque)",
   "int = g_app_info_launch_uris(GtkOpaque,GtkOpaque[],GObject)",
   "pango_cairo_font_map_set_resolution(GtkOpaque,double)",
   "GObject = gtk_menu_button_get_menu_model(GtkWidget)",
   "gdk_window_begin_resize_drag_for_device(GObject,int,GdkDevice,int,int,int,uint)",
   "int = gtk_widget_send_focus_change(GtkWidget,GdkEvent)",
   "GObject = gdk_window_get_visual(GObject)",
   "ulong = gdk_byte_order_get_type()",
   "int = gtk_widget_get_allocated_width(GtkWidget)",
   "int = gdk_device_pad_get_group_n_modes(GObject,int)",
   "ulong = gtk_app_chooser_get_type()",
   "ulong = gtk_text_attributes_get_type()",
   "gtk_accel_map_unlock_path(string)",
   "g_socket_set_ttl(GObject,uint)",
   "gdk_display_flush(GObject)",
   "gtk_expander_set_label(GtkWidget,string)",
   "pango_font_description_set_weight(GtkOpaque,int)",
   "GtkWidget = gtk_file_chooser_get_preview_widget(GObject)",
   "double = gtk_print_settings_get_double_with_default(GObject,string,double)",
   "pango_renderer_draw_glyph(GtkOpaque,GtkOpaque,uint,double,double)",
   "GtkOpaque = pango_attr_letter_spacing_new(int)",
   "GVariant = g_variant_new_objv(string[],long)",
   "int = gtk_text_view_get_cursor_visible(GtkWidget)",
   "ulong = gdk_grab_ownership_get_type()",
   "GtkWidget = gtk_action_bar_new()",
   "PangoCoverage = pango_coverage_copy(PangoCoverage)",
   "ulong = gdk_display_get_type()",
   "GtkOpaque = g_file_new_for_uri(string)",
   "gtk_toolbar_set_style(GtkWidget,int)",
   "int = gtk_text_view_get_indent(GtkWidget)",
   "(int,int) = gtk_text_view_buffer_to_window_coords(GtkWidget,int,int,int)",
   "GtkOpaque = g_app_info_get_recommended_for_type(string)",
   "GtkOpaque = pango_attr_foreground_new(ushort,ushort,ushort)",
   "g_main_context_push_thread_default(GMainContext)",
   "string = gtk_file_chooser_get_choice(GObject,string)",
   "int = g_mount_operation_get_anonymous(GObject)",
   "ulong = gtk_flow_box_get_type()",
   "gtk_assistant_next_page(GtkWidget)",
   "GtkWidget = gtk_combo_box_text_new_with_entry()",
   "ulong = g_iconv(GtkOpaque,string[],ulong[],string[],ulong[])",
   "GdkPixbuf = gtk_icon_info_load_symbolic(GObject,struct,struct,struct,struct,int[])",
   "GdkPixbuf = gtk_widget_render_icon_pixbuf(GtkWidget,string,int)",
   "GtkWidget = gtk_entry_completion_get_entry(GObject)",
   "GtkWidget = gtk_button_new_from_icon_name(string,int)",
   "GChecksum = g_checksum_new(int)",
   "int = g_inet_address_equal(GObject,GObject)",
   "GtkWidget = gtk_tree_view_get_expander_column(GtkWidget)",
   "gtk_drag_get_data(GtkWidget,GObject,GObject,uint)",
   "gdk_window_withdraw(GObject)",
   "gtk_app_chooser_button_set_active_custom_item(GtkWidget,string)",
   "GObject = gtk_viewport_get_view_window(GtkWidget)",
   "GtkWidget = gtk_paned_get_child2(GtkWidget)",
   "gtk_level_bar_set_min_value(GtkWidget,double)",
   "gtk_entry_unset_invisible_char(GtkWidget)",
   "int = gtk_cell_area_activate(GObject,GObject,GtkWidget,struct,int,int)",
   "int = g_drive_can_start_degraded(GtkOpaque)",
   "gtk_print_operation_set_custom_tab_label(GObject,string)",
   "int = gtk_widget_get_events(GtkWidget)",
   "uint = g_value_get_uint(GtkOpaque)",
   "gtk_tree_view_set_tooltip_cell(GtkWidget,GObject,GtkTreePath,GtkWidget,GObject)",
   "gtk_app_chooser_button_append_custom_item(GtkWidget,string,string,GtkOpaque)",
   "g_action_map_add_action(GtkOpaque,GtkOpaque)",
   "g_io_channel_unref(GIOChannel)",
   "GObject = gtk_clipboard_get_display(GObject)",
   "GdkPixbuf = gdk_pixbuf_new(int,int,int,int,int)",
   "int = gtk_text_iter_compare(GtkTextIter,GtkTextIter)",
   "gtk_editable_insert_text(GObject,string,int,int[])",
   "gtk_scale_set_digits(GtkWidget,int)",
   "g_bookmark_file_set_is_private(GBookmarkFile,string,int)",
   "gtk_widget_path_iter_remove_class(GtkWidgetPath,int,string)",
   "int = gtk_get_locale_direction()",
   "gtk_text_attributes_copy_values(GtkTextAttributes,GtkTextAttributes)",
   "GObject = gtk_accel_group_new()",
   "gtk_icon_view_set_columns(GtkWidget,int)",
   "gtk_menu_item_toggle_size_allocate(GtkWidget,int)",
   "gtk_recent_chooser_set_show_not_found(GObject,int)",
   "GtkWidget = gtk_drawing_area_new()",
   "GtkWidget = gtk_get_event_widget(GdkEvent)",
   "gtk_drag_set_icon_widget(GObject,GtkWidget,int,int)",
   "gtk_drag_source_add_image_targets(GtkWidget)",
   "string = gtk_label_get_text(GtkWidget)",
   "gtk_about_dialog_set_wrap_license(GtkWidget,int)",
   "uint = gtk_application_window_get_id(GtkWidget)",
   "GtkWidgetPath = gtk_widget_path_copy(GtkWidgetPath)",
   "int = gtk_tree_model_iter_next(GObject,GtkTreeIter)",
   "GObject = g_zlib_decompressor_get_file_info(GtkOpaque)",
   "gdk_window_set_event_compression(GObject,int)",
   "string = g_time_zone_get_abbreviation(GTimeZone,int)",
   "gtk_print_operation_set_export_filename(GObject,string)",
   "int = gtk_text_iter_get_attributes(GtkTextIter,GtkTextAttributes)",
   "int = gdk_device_get_has_cursor(GdkDevice)",
   "g_reload_user_special_dirs_cache()",
   "ushort = g_date_get_year(GDate)",
   "int = g_socket_join_multicast_group_ssm(GObject,GObject,GObject,string)",
   "GtkOpaque = pango_attr_list_get_attributes(PangoAttrList)",
   "g_value_init_from_instance(GtkOpaque,GtkOpaque)",
   "int = gtk_icon_view_get_tooltip_column(GtkWidget)",
   "GdkPixbuf = gdk_pixbuf_new_from_file_at_size(string,int,int)",
   "int = gtk_cell_renderer_get_request_mode(GObject)",
   "GObject = gdk_gl_context_get_display(GObject)",
   "GtkWidget = gtk_separator_new(int)",
   "g_type_ensure(ulong)",
   "string = gdk_monitor_get_manufacturer(GObject)",
   "string = g_date_time_get_timezone_abbreviation(GDateTime)",
   "gtk_spin_button_set_numeric(GtkWidget,int)",
   "ulong = gdk_drag_cancel_reason_get_type()",
   "GMappedFile = g_mapped_file_ref(GMappedFile)",
   "int = g_file_attribute_matcher_enumerate_namespace(GtkOpaque,string)",
   "GObject = gdk_window_get_cursor(GObject)",
   "GtkOpaque = g_value_peek_pointer(GtkOpaque)",
   "gtk_actionable_set_action_name(GObject,string)",
   "GObject = gdk_screen_get_active_window(GObject)",
   "gtk_tree_view_column_set_sort_column_id(GtkWidget,int)",
   "gtk_native_dialog_set_transient_for(GtkWidget,GtkWidget)",
   "ulong = g_inet_socket_address_get_type()",
   "gdk_event_free(GdkEvent)",
   "gtk_tree_view_column_set_expand(GtkWidget,int)",
   "(GObject,double,double,int) = gdk_window_get_device_position_double(GObject,GdkDevice)",
   "int = pango_layout_line_index_to_x(PangoLayoutLine,int,int)",
   "string = g_app_info_get_supported_types(GtkOpaque)",
   "gtk_gl_area_queue_render(GtkWidget)",
   "string = gtk_paper_size_get_name(GtkPaperSize)",
   "(int,double) = gtk_level_bar_get_offset_value(GtkWidget,string)",
   "ulong = gdk_pixbuf_loader_get_type()",
   "PangoLayoutLine = pango_layout_iter_get_line_readonly(PangoLayoutIter)",
   "uint = gdk_rgba_hash(GtkOpaque)",
   "gtk_icon_theme_add_builtin_icon(string,int,GdkPixbuf)",
   "gtk_tree_store_move_after(GObject,GtkTreeIter,GtkTreeIter)",
   "int = gtk_combo_box_get_column_span_column(GtkWidget)",
   "GtkWidget = gtk_text_view_new()",
   "int = gtk_text_iter_backward_sentence_starts(GtkTextIter,int)",
   "GtkPaperSize = gtk_paper_size_new_from_gvariant(GVariant)",
   "ulong = gtk_print_context_get_type()",
   "gtk_render_icon(GObject,Cairo,GdkPixbuf,double,double)",
   "uint = g_unicode_script_to_iso15924(int)",
   "int = gtk_text_tag_table_get_size(GObject)",
   "int = g_poll(GtkOpaque,uint,int)",
   "int = g_volume_can_eject(GtkOpaque)",
   "(double,double) = gdk_events_get_center(GdkEvent,GdkEvent)",
   "ulong = gtk_target_entry_get_type()",
   "double = gtk_page_setup_get_page_height(GObject,int)",
   "int = g_value_type_transformable(ulong,ulong)",
   "GObject = gtk_text_buffer_new(GObject)",
   "GtkOpaque = g_simple_action_new_stateful(string,GVariantType,GVariant)",
   "ulong = g_value_get_uint64(GtkOpaque)",
   "string = gtk_check_version(uint,uint,uint)",
   "GtkWidget = gtk_notebook_get_tab_label(GtkWidget,GtkWidget)",
   "gtk_places_sidebar_set_show_desktop(GtkWidget,int)",
   "int = g_key_file_has_group(GKeyFile,string)",
   "ulong = gtk_gesture_swipe_get_type()",
   "int = gtk_accelerator_valid(uint,int)",
   "int = g_date_is_leap_year(ushort)",
   "string = g_date_time_format_iso8601(GDateTime)",
   "gtk_button_set_use_stock(GtkWidget,int)",
   "GObject = g_file_info_get_attribute_object(GObject,string)",
   "int = gtk_header_bar_get_show_close_button(GtkWidget)",
   "gtk_tree_view_unset_rows_drag_dest(GtkWidget)",
   "int = gdk_pixbuf_animation_is_static_image(GObject)",
   "GtkOpaque = pango_cairo_create_layout(Cairo)",
   "gtk_tree_view_enable_model_drag_source(GtkWidget,int,GObject,int,int)",
   "int = gtk_widget_get_hexpand(GtkWidget)",
   "int = g_file_info_set_attribute_status(GObject,string,int)",
   "string = g_enum_to_string(ulong,int)",
   "int = gtk_widget_get_realized(GtkWidget)",
   "ulong = g_bytes_icon_get_type()",
   "string = g_ascii_strdown(string,long)",
   "GtkWidget = gtk_popover_new_from_model(GtkWidget,GObject)",
   "GSource = g_main_current_source()",
   "GtkOpaque = gtk_places_sidebar_list_shortcuts(GtkWidget)",
   "gtk_cell_layout_clear(GObject)",
   "string = gtk_app_chooser_dialog_get_heading(GtkWidget)",
   "g_type_class_add_private(GtkOpaque,ulong)",
   "double = pango_gravity_to_rotation(int)",
   "int = gtk_widget_get_vexpand_set(GtkWidget)",
   "int = gtk_event_controller_handle_event(GObject,GdkEvent)",
   "gtk_print_operation_set_n_pages(GObject,int)",
   "gtk_about_dialog_add_credit_section(GtkWidget,string,string[])",
   "int = gtk_cell_renderer_activate(GObject,GdkEvent,GtkWidget,string,struct,struct,int)",
   "GRand = g_rand_new_with_seed(uint)",
   "gtk_toggle_tool_button_set_active(GtkWidget,int)",
   "GtkOpaque = gtk_print_context_get_pango_fontmap(GObject)",
   "(int,int) = gtk_widget_get_preferred_width_for_height(GtkWidget,int)",
   "ulong = gtk_statusbar_get_type()",
   "GtkWidget = gtk_print_unix_dialog_new(string,GtkWidget)",
   "GObject = gtk_widget_get_clipboard(GtkWidget,GObject)",
   "GtkOpaque = g_value_dup_param(GtkOpaque)",
   "int = gtk_cell_area_box_get_spacing(GObject)",
   "int = gdk_monitor_get_width_mm(GObject)",
   "int = gtk_combo_box_get_entry_text_column(GtkWidget)",
   "Cairo = gtk_widget_get_font_options(GtkWidget)",
   "gdk_window_set_background(GObject,struct)",
   "int = g_bookmark_file_has_group(GBookmarkFile,string,string)",
   "GtkOpaque = gtk_scale_get_layout(GtkWidget)",
   "gtk_label_set_single_line_mode(GtkWidget,int)",
   "g_signal_stop_emission_by_name(GtkOpaque,string)",
   "int = gdk_pixbuf_animation_iter_on_currently_loading_frame(GObject)",
   "int = g_source_get_priority(GSource)",
   "gdk_pixbuf_simple_anim_add_frame(GObject,GdkPixbuf)",
   "uint = gtk_css_section_get_end_position(GtkOpaque)",
   "int = g_bookmark_file_remove_application(GBookmarkFile,string,string)",
   "int = g_bookmark_file_load_from_data(GBookmarkFile,string,ulong)",
   "Cairo = gtk_icon_set_render_icon_surface(GtkOpaque,GObject,int,int,GObject)",
   "int = gtk_text_iter_can_insert(GtkTextIter,int)",
   "gtk_window_set_keep_below(GtkWidget,int)",
   "gtk_widget_set_no_show_all(GtkWidget,int)",
   "int = gtk_toolbar_get_relief_style(GtkWidget)",
   "gtk_notebook_set_menu_label(GtkWidget,GtkWidget,GtkWidget)",
   "int = g_socket_get_protocol(GObject)",
   "ulong = gtk_recent_chooser_widget_get_type()",
   "int = g_content_type_is_a(string,string)",
   "pango_cairo_font_map_set_default(GtkOpaque)",
   "GtkWidget = gtk_window_new(int)",
   "GtkSelectionData = gtk_clipboard_wait_for_contents(GObject,GObject)",
   "pango_context_set_gravity_hint(GtkOpaque,int)",
   "gtk_color_button_set_use_alpha(GtkWidget,int)",
   "GDateTime = g_date_time_ref(GDateTime)",
   "ulong = g_socket_get_type()",
   "gtk_text_view_scroll_to_mark(GtkWidget,GObject,double,int,double,double)",
   "gtk_window_begin_move_drag(GtkWidget,int,int,int,uint)",
   "double = gtk_page_setup_get_page_width(GObject,int)",
   "GtkWidget = gtk_color_button_new_with_rgba(struct)",
   "(int,int) = pango_layout_get_size(GtkOpaque)",
   "gtk_gl_area_set_use_es(GtkWidget,int)",
   "gtk_widget_trigger_tooltip_query(GtkWidget)",
   "g_param_spec_pool_remove(GtkOpaque,GtkOpaque)",
   "ulong = gtk_range_get_type()",
   "int = gtk_printer_get_job_count(GObject)",
   "int = g_io_channel_get_flags(GIOChannel)",
   "string = g_get_real_name()",
   "int = g_key_file_load_from_data(string,ulong,int)",
   "gtk_tool_palette_unset_style(GtkWidget)",
   "gtk_tree_view_set_hover_selection(GtkWidget,int)",
   "GObject = gtk_style_context_get_parent(GObject)",
   "int = pango_font_metrics_get_underline_thickness(PangoFontMetrics)",
   "gtk_container_set_resize_mode(GtkWidget,int)",
   "ulong = gtk_text_mark_get_type()",
   "long = g_key_file_get_int64(GKeyFile,string,string)",
   "int = gtk_text_iter_is_start(GtkTextIter)",
   "g_settings_backend_keys_changed(GtkOpaque,string,string[],GtkOpaque)",
   "gtk_widget_draw(GtkWidget,Cairo)",
   "gtk_scrolled_window_set_overlay_scrolling(GtkWidget,int)",
   "gtk_recent_chooser_set_show_tips(GObject,int)",
   "g_menu_append(GObject,string,string)",
   "string = g_path_get_dirname(string)",
   "int = gdk_gl_context_get_forward_compatible(GObject)",
   "int = gtk_spin_button_get_wrap(GtkWidget)",
   "int = gdk_screen_get_height(GObject)",
   "int = g_mkstemp(string)",
   "int = gtk_window_set_default_icon_from_file(string)",
   "int = pango_font_description_get_size_is_absolute(GtkOpaque)",
   "g_dir_close(GDir)",
   "int = gtk_print_settings_get_int(GObject,string)",
   "uint = g_convert_error_quark()",
   "int = gtk_print_job_get_rotate(GObject)",
   "g_file_info_set_name(GObject,string)",
   "string = g_dpgettext2(string,string,string)",
   "int = gdk_display_supports_cursor_color(GObject)",
   "GtkOpaque = gtk_style_context_list_regions(GObject)",
   "string = g_app_info_get_display_name(GtkOpaque)",
   "gtk_cell_editable_editing_done(GObject)",
   "g_object_setv(GObject,uint,string[],GtkOpaque)",
   "gtk_adjustment_changed(GObject)",
   "ulong = g_simple_action_group_get_type()",
   "gtk_cell_area_box_pack_end(GObject,GObject,int,int,int)",
   "int = pango_layout_iter_next_run(PangoLayoutIter)",
   "double = gtk_paper_size_get_default_top_margin(GtkPaperSize,int)",
   "GDateTime = g_date_time_new(GTimeZone,int,int,int,int,int,double)",
   "int = gtk_entry_layout_index_to_text_index(GtkWidget,int)",
   "GVariant = g_variant_new_int64(long)",
   "gtk_tree_view_scroll_to_cell(GtkWidget,GtkTreePath,GtkWidget,int,float,float)",
   "ulong = gtk_size_group_get_type()",
   "GVariant = g_variant_lookup_value(GVariant,string,GVariantType)",
   "pango_layout_set_markup_with_accel(GtkOpaque,string,int,uint,uint[])",
   "gtk_widget_path_iter_clear_classes(GtkWidgetPath,int)",
   "gtk_tree_view_move_column_after(GtkWidget,GtkWidget,GtkWidget)",
   "gtk_tree_view_set_hadjustment(GtkWidget,GObject)",
   "int = g_variant_is_normal_form(GVariant)",
   "g_type_interface_add_prerequisite(ulong,ulong)",
   "gtk_cell_editable_remove_widget(GObject)",
   "gtk_toggle_button_toggled(GtkWidget)",
   "gtk_font_chooser_set_preview_text(GObject,string)",
   "string = g_mount_operation_get_password(GObject)",
   "ulong = gdk_subpixel_layout_get_type()",
   "pango_renderer_draw_layout_line(GtkOpaque,PangoLayoutLine,int,int)",
   "gtk_entry_completion_insert_prefix(GObject)",
   "g_set_application_name(string)",
   "GObject = gtk_file_chooser_get_filter(GObject)",
   "gtk_toolbar_insert(GtkWidget,GtkWidget,int)",
   "g_themed_icon_prepend_name(GObject,string)",
   "int = g_date_time_get_week_of_year(GDateTime)",
   "g_object_add_weak_pointer(GObject,GtkOpaque[])",
   "gtk_css_provider_load_from_resource(GObject,string)",
   "int = gdk_keyval_is_lower(uint)",
   "gtk_radio_tool_button_set_group(GtkWidget,GtkOpaque[])",
   "int = gtk_icon_view_get_columns(GtkWidget)",
   "GtkOpaque = g_file_replace_finish(GtkOpaque,GtkOpaque)",
   "string = g_compute_hmac_for_data(int,uchar[],ulong,uchar[],ulong)",
   "GtkTextIter = gtk_text_buffer_get_iter_at_line(GObject,int)",
   "ulong = g_object_get_type()",
   "Cairo = gtk_widget_region_intersect(GtkWidget,Cairo)",
   "ulong = gdk_window_type_get_type()",
   "int = gtk_cell_view_get_draw_sensitive(GtkWidget)",
   "string = g_settings_schema_list_keys(GtkOpaque)",
   "GVariantType = g_variant_type_checked_(string)",
   "int = gtk_accel_group_get_modifier_mask(GObject)",
   "int = g_date_valid_day(uchar)",
   "gtk_widget_queue_draw_region(GtkWidget,Cairo)",
   "string = g_compute_hmac_for_string(int,uchar[],ulong,string,long)",
   "int = g_volume_can_mount(GtkOpaque)",
   "int = gtk_list_box_row_get_activatable(GtkWidget)",
   "double = gtk_gesture_rotate_get_angle_delta(GObject)",
   "int = g_file_supports_thread_contexts(GtkOpaque)",
   "GtkWidget = gtk_app_chooser_dialog_get_widget(GtkWidget)",
   "int = g_file_equal(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_cell_view_new_with_context(GObject,GObject)",
   "gdk_window_raise(GObject)",
   "int = gdk_window_get_type_hint(GObject)",
   "gdk_display_sync(GObject)",
   "string = g_signal_name(uint)",
   "pango_attribute_destroy(GtkOpaque)",
   "gtk_menu_shell_prepend(GtkWidget,GtkWidget)",
   "int = gtk_toolbar_get_n_items(GtkWidget)",
   "g_file_info_set_attribute_byte_string(GObject,string,string)",
   "gtk_builder_expose_object(GObject,string,GObject)",
   "g_input_stream_clear_pending(GObject)",
   "int = gtk_clipboard_wait_is_image_available(GObject)",
   "int = gtk_recent_info_exists(GObject)",
   "gtk_check_menu_item_toggled(GtkWidget)",
   "g_mount_operation_set_choice(GObject,int)",
   "GDir = g_dir_open(string,uint)",
   "gtk_tree_selection_unselect_iter(GObject,GtkTreeIter)",
   "GObject = gtk_icon_theme_get_default()",
   "ulong = gtk_print_operation_get_type()",
   "ulong = gtk_bin_get_type()",
   "string = gtk_app_chooser_widget_get_default_text(GtkWidget)",
   "gtk_tree_view_row_activated(GtkWidget,GtkTreePath,GtkWidget)",
   "int = gdk_pixbuf_format_is_writable(GtkOpaque)",
   "gtk_scale_set_draw_value(GtkWidget,int)",
   "ulong = gtk_shortcuts_group_get_type()",
   "gtk_menu_popdown(GtkWidget)",
   "int = g_param_values_cmp(GtkOpaque,GtkOpaque,GtkOpaque)",
   "double = g_rand_double(GRand)",
   "gtk_widget_override_background_color(GtkWidget,int,struct)",
   "gdk_window_deiconify(GObject)",
   "uint = g_socket_get_ttl(GObject)",
   "ulong = gdk_status_get_type()",
   "g_menu_prepend_section(GObject,string,GObject)",
   "GdkPixbuf = gdk_pixbuf_new_from_resource_at_scale(string,int,int,int)",
   "int = gtk_widget_get_no_show_all(GtkWidget)",
   "string = g_key_file_get_locale_for_key(GKeyFile,string,string,string)",
   "string = g_strsplit_set(string,string,int)",
   "g_variant_builder_close(GVariantBuilder)",
   "gtk_tree_view_column_pack_start(GtkWidget,GObject,int)",
   "int = gtk_places_sidebar_get_show_starred_location(GtkWidget)",
   "ulong = gtk_recent_info_get_modified(GObject)",
   "gtk_expander_set_label_widget(GtkWidget,GtkWidget)",
   "GtkWidget = gtk_message_dialog_get_message_area(GtkWidget)",
   "int = g_io_channel_get_close_on_unref(GIOChannel)",
   "GtkWidget = gtk_tool_item_get_proxy_menu_item(GtkWidget,string)",
   "int = gtk_menu_get_tearoff_state(GtkWidget)",
   "GObject = gdk_window_get_device_cursor(GObject,GdkDevice)",
   "string = g_strerror(int)",
   "GtkOpaque = g_settings_new_with_backend_and_path(string,GtkOpaque,string)",
   "GObject = gdk_window_get_effective_toplevel(GObject)",
   "string = g_settings_schema_get_id(GtkOpaque)",
   "gtk_tree_view_column_set_max_width(GtkWidget,int)",
   "int = gtk_font_chooser_get_show_preview_entry(GObject)",
   "(float,float) = gtk_frame_get_label_align(GtkWidget)",
   "string = gtk_print_settings_get_finishings(GObject)",
   "int = gtk_accel_group_activate(GObject,uint,GObject,uint,int)",
   "gtk_widget_register_window(GtkWidget,GObject)",
   "gtk_switch_set_state(GtkWidget,int)",
   "int = g_file_info_get_attribute_type(GObject,string)",
   "g_object_freeze_notify(GObject)",
   "int = gtk_text_view_get_pixels_inside_wrap(GtkWidget)",
   "ulong = gtk_tree_iter_get_type()",
   "gtk_tree_view_column_focus_cell(GtkWidget,GObject)",
   "GtkOpaque = pango_attr_insert_hyphens_new(int)",
   "g_bookmark_file_set_mime_type(GBookmarkFile,string,string)",
   "int = gtk_file_chooser_get_show_hidden(GObject)",
   "ulong = g_strlcat(string,string,ulong)",
   "ulong = gtk_accel_map_get_type()",
   "GObject = g_inet_address_new_loopback(int)",
   "long = gdk_frame_timings_get_refresh_interval(GdkFrameTimings)",
   "int = gtk_widget_event(GtkWidget,GdkEvent)",
   "string = gtk_font_chooser_get_language(GObject)",
   "GtkOpaque = pango_font_description_new()",
   "gtk_entry_set_progress_pulse_step(GtkWidget,double)",
   "GtkWidget = gtk_scale_new(int,GObject)",
   "GObject = gdk_drag_get_selection(GObject)",
   "gtk_native_dialog_show(GtkWidget)",
   "gdk_drop_reply(GObject,int,uint)",
   "int = gtk_text_buffer_insert_range_interactive(GObject,GtkTextIter,GtkTextIter,GtkTextIter,int)",
   "GMainLoop = g_main_loop_ref(GMainLoop)",
   "int = gtk_about_dialog_get_wrap_license(GtkWidget)",
   "int = gtk_widget_get_can_focus(GtkWidget)",
   "gtk_stack_set_transition_type(GtkWidget,int)",
   "GObject = g_object_new_with_properties(ulong,uint,string[],GtkOpaque)",
   "ulong = g_drive_get_type()",
   "int = g_unichar_isxdigit(uint)",
   "g_action_activate(GtkOpaque,GVariant)",
   "int = g_unichar_iswide_cjk(uint)",
   "GtkOpaque = g_simple_action_group_new()",
   "GObject = gtk_layout_get_vadjustment(GtkWidget)",
   "PangoTabArray = gtk_text_view_get_tabs(GtkWidget)",
   "int = g_file_eject_mountable_with_operation_finish(GtkOpaque,GtkOpaque)",
   "gtk_entry_set_completion(GtkWidget,GObject)",
   "int = gtk_application_window_get_show_menubar(GtkWidget)",
   "ulong = gtk_button_get_type()",
   "g_main_context_wakeup(GMainContext)",
   "GMainContext = g_main_context_get_thread_default()",
   "GVariant = g_variant_new_take_string(string)",
   "GtkOpaque = g_inet_socket_address_new_from_string(string,uint)",
   "ulong = gtk_shortcuts_window_get_type()",
   "GtkWidget = gtk_radio_button_new_with_label_from_widget(GtkWidget,string)",
   "GDateTime = g_date_time_new_local(int,int,int,int,int,double)",
   "int = gtk_accelerator_get_default_mod_mask()",
   "gtk_menu_shell_select_first(GtkWidget,int)",
   "int = g_strv_contains(string[],string)",
   "pango_font_description_set_variations(GtkOpaque,string)",
   "int = gtk_native_dialog_get_modal(GtkWidget)",
   "gdk_window_set_keep_below(GObject,int)",
   "ulong = g_inet_address_mask_get_type()",
   "int = gtk_text_buffer_get_has_selection(GObject)",
   "gtk_flow_box_set_min_children_per_line(GtkWidget,uint)",
   "int = g_drive_can_start(GtkOpaque)",
   "int = gdk_monitor_get_refresh_rate(GObject)",
   "int = g_volume_mount_finish(GtkOpaque,GtkOpaque)",
   "int = gdk_gl_context_get_debug_enabled(GObject)",
   "string = g_variant_type_peek_string(GVariantType)",
   "string = gtk_recent_info_get_short_name(GObject)",
   "string = g_utf8_offset_to_pointer(string,long)",
   "int = g_file_trash(GtkOpaque,GtkOpaque)",
   "int = gtk_widget_is_visible(GtkWidget)",
   "string = gdk_pixbuf_format_get_description(GtkOpaque)",
   "gtk_icon_info_set_raw_coordinates(GObject,int)",
   "gtk_range_set_round_digits(GtkWidget,int)",
   "int = gtk_range_get_flippable(GtkWidget)",
   "int = g_match_info_matches(GMatchInfo)",
   "GdkPixbuf = gdk_pixbuf_loader_get_pixbuf(GObject)",
   "double = gtk_paper_size_get_default_bottom_margin(GtkPaperSize,int)",
   "double = gtk_scale_button_get_value(GtkWidget)",
   "GObject = gtk_gesture_stylus_new(GtkWidget)",
   "GtkOpaque = gtk_window_get_default_icon_list()",
   "gtk_entry_set_activates_default(GtkWidget,int)",
   "string = g_utf8_prev_char(string)",
   "double = gtk_print_settings_get_length(GObject,string,int)",
   "gtk_drag_dest_add_uri_targets(GtkWidget)",
   "gtk_assistant_update_buttons_state(GtkWidget)",
   "gdk_window_set_role(GObject,string)",
   "int = gtk_css_provider_load_from_file(GObject,GtkOpaque)",
   "int = g_app_info_supports_uris(GtkOpaque)",
   "gtk_text_tag_set_priority(GObject,int)",
   "uint = pango_font_map_get_serial(GtkOpaque)",
   "GObject = gtk_list_store_new(ulong[])",
   "string = gtk_window_get_title(GtkWidget)",
   "gtk_places_sidebar_set_show_recent(GtkWidget,int)",
   "GtkOpaque = pango_font_face_describe(GtkOpaque)",
   "g_value_set_pointer(GtkOpaque,GtkOpaque)",
   "string = g_match_info_get_string(GMatchInfo)",
   "GVariantType = g_action_get_state_type(GtkOpaque)",
   "int = gtk_recent_chooser_select_uri(GObject,string)",
   "pango_font_description_unset_fields(GtkOpaque,int)",
   "gtk_printer_request_details(GObject)",
   "int = gtk_range_get_min_slider_size(GtkWidget)",
   "GtkOpaque = g_volume_monitor_get_mount_for_uuid(GObject,string)",
   "gtk_gesture_ungroup(GObject)",
   "string = gtk_about_dialog_get_artists(GtkWidget)",
   "int = g_file_delete(GtkOpaque,GtkOpaque)",
   "int = gtk_range_get_slider_size_fixed(GtkWidget)",
   "GtkOpaque = g_type_check_instance_cast(GtkOpaque,ulong)",
   "string = gtk_entry_get_icon_tooltip_markup(GtkWidget,int)",
   "GdkPixbuf = gdk_pixbuf_new_from_file(string)",
   "g_file_info_unset_attribute_mask(GObject)",
   "string = gtk_app_chooser_get_content_type(GObject)",
   "gtk_gesture_multi_press_set_area(GObject,struct)",
   "(uint,int,int) = gdk_visual_get_blue_pixel_details(GObject)",
   "gtk_accel_map_add_filter(string)",
   "GtkOpaque = g_file_query_writable_namespaces(GtkOpaque,GtkOpaque)",
   "gtk_window_move(GtkWidget,int,int)",
   "gtk_window_set_modal(GtkWidget,int)",
   "string = g_mount_guess_content_type_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_text_view_get_left_margin(GtkWidget)",
   "gdk_window_input_shape_combine_region(GObject,Cairo,int,int)",
   "int = gtk_text_view_get_justification(GtkWidget)",
   "gtk_print_settings_set_output_bin(GObject,string)",
   "GObject = g_menu_item_new_submenu(string,GObject)",
   "gtk_size_group_set_mode(GObject,int)",
   "GObject = gtk_print_unix_dialog_get_selected_printer(GtkWidget)",
   "GtkWidget = gtk_tree_view_get_search_entry(GtkWidget)",
   "(int,double,double) = gtk_gesture_get_bounding_box_center(GObject)",
   "gtk_image_set_from_pixbuf(GtkWidget,GdkPixbuf)",
   "GtkWidget = gtk_menu_item_new_with_label(string)",
   "int = gtk_widget_get_state_flags(GtkWidget)",
   "gtk_text_view_set_justification(GtkWidget,int)",
   "int = g_app_info_launch_default_for_uri_finish(GtkOpaque)",
   "GVariantType = g_variant_type_copy(GVariantType)",
   "int = gtk_tool_item_get_homogeneous(GtkWidget)",
   "gtk_icon_theme_add_resource_path(GObject,string)",
   "long = g_socket_receive_with_blocking(GObject,string,ulong,int,GtkOpaque)",
   "gtk_label_set_line_wrap(GtkWidget,int)",
   "ulong = g_bookmark_file_get_modified(GBookmarkFile,string)",
   "ulong = gdk_pixbuf_animation_get_type()",
   "gtk_text_view_set_border_window_size(GtkWidget,int,int)",
   "ulong = g_credentials_get_type()",
   "ulong = gtk_file_filter_get_type()",
   "gtk_label_set_max_width_chars(GtkWidget,int)",
   "string = g_file_read_link(string)",
   "g_menu_append_item(GObject,GObject)",
   "(uint,uint) = gtk_layout_get_size(GtkWidget)",
   "gtk_paned_add1(GtkWidget,GtkWidget)",
   "int = g_file_info_get_is_symlink(GObject)",
   "gtk_window_set_startup_id(GtkWidget,string)",
   "gdk_frame_clock_request_phase(GObject,int)",
   "int = gtk_window_get_deletable(GtkWidget)",
   "GtkOpaque = g_file_get_child_for_display_name(GtkOpaque,string)",
   "GObject = g_app_launch_context_new()",
   "GtkOpaque = pango_ft2_font_map_new()",
   "gtk_clipboard_set_image(GObject,GdkPixbuf)",
   "gtk_icon_view_set_tooltip_column(GtkWidget,int)",
   "ulong = g_file_attribute_matcher_get_type()",
   "GtkOpaque = gtk_window_group_list_windows(GObject)",
   "g_io_channel_init(GIOChannel)",
   "int = pango_attr_type_register(string)",
   "GtkOpaque = g_file_append_to(GtkOpaque,int,GtkOpaque)",
   "GtkOpaque = gtk_style_context_get_section(GObject,string)",
   "gdk_window_move(GObject,int,int)",
   "gtk_file_chooser_native_set_cancel_label(GtkWidget,string)",
   "int = gtk_combo_box_get_focus_on_click(GtkWidget)",
   "int = g_param_value_defaults(GtkOpaque,GtkOpaque)",
   "gtk_cell_renderer_stop_editing(GObject,int)",
   "gtk_print_settings_set_paper_size(GObject,GtkPaperSize)",
   "int = gtk_cell_area_is_focus_sibling(GObject,GObject,GObject)",
   "GtkOpaque = g_simple_proxy_resolver_new(string,string[])",
   "gtk_entry_set_visibility(GtkWidget,int)",
   "int = gtk_list_box_row_get_index(GtkWidget)",
   "int = gtk_widget_get_can_default(GtkWidget)",
   "gdk_window_set_pass_through(GObject,int)",
   "uint = g_charset_converter_get_num_fallbacks(GObject)",
   "gtk_print_job_set_collate(GObject,int)",
   "gtk_combo_box_set_title(GtkWidget,string)",
   "GtkOpaque = g_network_address_parse(string,ushort)",
   "int = g_settings_is_writable(GtkOpaque,string)",
   "Cairo = gtk_print_job_get_surface(GObject)",
   "ulong = gtk_drawing_area_get_type()",
   "(int,int) = gtk_widget_get_preferred_height_for_width(GtkWidget,int)",
   "int = g_get_console_charset(string[])",
   "int = gtk_widget_path_has_parent(GtkWidgetPath,ulong)",
   "gtk_tree_view_unset_rows_drag_source(GtkWidget)",
   "int = g_variant_is_floating(GVariant)",
   "gtk_adjustment_configure(GObject,double,double,double,double,double,double)",
   "int = gtk_print_settings_get_duplex(GObject)",
   "gdk_window_reparent(GObject,GObject,int,int)",
   "GObject = gtk_cell_renderer_spin_new()",
   "GtkOpaque = g_object_ref_sink(GtkOpaque)",
   "int = gtk_menu_item_get_use_underline(GtkWidget)",
   "ulong = gtk_tree_path_get_type()",
   "GtkWidget = gtk_label_new_with_mnemonic(string)",
   "int = g_inet_address_mask_equal(GtkOpaque,GtkOpaque)",
   "GObject = gtk_cell_area_get_focus_from_sibling(GObject,GObject)",
   "int = gtk_separator_tool_item_get_draw(GtkWidget)",
   "GObject = gtk_widget_get_window(GtkWidget)",
   "string = gtk_color_button_get_title(GtkWidget)",
   "ulong = gtk_gesture_long_press_get_type()",
   "GdkRectangle = gtk_popover_get_pointing_to(GtkWidget)",
   "GtkWidget = gtk_scale_button_get_minus_button(GtkWidget)",
   "gtk_radio_menu_item_join_group(GtkWidget,GtkWidget)",
   "int = gtk_print_settings_get_resolution(GObject)",
   "string = g_stpcpy(string,string)",
   "gtk_entry_buffer_emit_inserted_text(GObject,uint,string,uint)",
   "ulong = g_settings_schema_key_get_type()",
   "long = g_utf8_strlen(string,long)",
   "gtk_grid_insert_next_to(GtkWidget,GtkWidget,int)",
   "g_value_set_instance(GtkOpaque,GtkOpaque)",
   "pango_attr_list_splice(PangoAttrList,PangoAttrList,int,int)",
   "gtk_image_set_from_gicon(GtkWidget,GtkOpaque,int)",
   "GdkPixbuf = gtk_recent_info_get_icon(GObject,int)",
   "gtk_message_dialog_set_image(GtkWidget,GtkWidget)",
   "gdk_event_set_screen(GdkEvent,GObject)",
   "int = g_settings_set_double(GtkOpaque,string,double)",
   "uchar = g_date_get_monday_weeks_in_year(ushort)",
   "GtkWidget = gtk_button_new_from_stock(string)",
   "int = gtk_print_operation_preview_is_selected(GObject,int)",
   "gtk_widget_path_iter_set_state(GtkWidgetPath,int,int)",
   "gtk_size_group_set_ignore_hidden(GObject,int)",
   "ulong = gtk_builder_get_type()",
   "ulong = gtk_cell_renderer_accel_get_type()",
   "GtkOpaque = gtk_file_chooser_list_shortcut_folders(GObject)",
   "int = gtk_check_menu_item_get_inconsistent(GtkWidget)",
   "ulong = gtk_page_setup_unix_dialog_get_type()",
   "GObject = gtk_text_buffer_create_child_anchor(GObject,GtkTextIter)",
   "int = gtk_icon_view_get_item_width(GtkWidget)",
   "int = g_settings_schema_has_key(GtkOpaque,string)",
   "int = gtk_text_iter_get_chars_in_line(GtkTextIter)",
   "GVariant = g_variant_new_signature(string)",
   "gtk_layout_set_hadjustment(GtkWidget,GObject)",
   "uint = gtk_builder_error_quark()",
   "GObject = g_filename_completer_new()",
   "string = g_strreverse(string)",
   "gtk_window_set_transient_for(GtkWidget,GtkWidget)",
   "int = g_drive_is_media_removable(GtkOpaque)",
   "string = g_drive_get_sort_key(GtkOpaque)",
   "int = gtk_widget_is_focus(GtkWidget)",
   "int = gtk_window_get_resizable(GtkWidget)",
   "ulong = gdk_wm_decoration_get_type()",
   "gtk_tree_path_next(GtkTreePath)",
   "int = g_socket_get_family(GObject)",
   "GdkPixbuf = gtk_icon_info_load_symbolic_for_context(GObject,GObject,int[])",
   "string = g_uri_escape_string(string,string,int)",
   "gtk_header_bar_set_has_subtitle(GtkWidget,int)",
   "double = gtk_level_bar_get_min_value(GtkWidget)",
   "int = g_settings_get_boolean(GtkOpaque,string)",
   "gtk_drag_dest_set_track_motion(GtkWidget,int)",
   "int = gtk_file_chooser_get_preview_widget_active(GObject)",
   "int = gtk_tool_item_group_get_item_position(GtkWidget,GtkWidget)",
   "string = g_settings_schema_get_path(GtkOpaque)",
   "GtkWidget = gtk_combo_box_text_new()",
   "int = gtk_widget_is_drawable(GtkWidget)",
   "string = g_settings_list_children(GtkOpaque)",
   "ulong = gtk_gesture_pan_get_type()",
   "GtkWidget = gtk_lock_button_new(GObject)",
   "GObject = gtk_icon_view_get_model(GtkWidget)",
   "gtk_font_button_set_show_style(GtkWidget,int)",
   "GtkWidgetPath = gtk_style_context_get_path(GObject)",
   "GVariant = g_variant_new_string(string)",
   "int = gtk_combo_box_set_active_id(GtkWidget,string)",
   "GtkOpaque = g_app_info_get_default_for_uri_scheme(string)",
   "gtk_menu_set_tearoff_state(GtkWidget,int)",
   "gtk_print_job_set_n_up(GObject,uint)",
   "GtkWidget = gtk_window_get_transient_for(GtkWidget)",
   "g_date_set_year(GDate,ushort)",
   "g_networking_init()",
   "string = g_mount_operation_get_username(GObject)",
   "gtk_font_button_set_title(GtkWidget,string)",
   "int = g_param_value_convert(GtkOpaque,GtkOpaque,GtkOpaque,int)",
   "gtk_tree_view_set_level_indentation(GtkWidget,int)",
   "int = g_file_info_get_attribute_data(GObject,string,int[],GtkOpaque[],int[])",
   "string = gtk_icon_theme_get_example_icon_name(GObject)",
   "GObject = gtk_target_entry_copy(GObject)",
   "int = gdk_event_is_scroll_stop_event(GdkEvent)",
   "g_type_init()",
   "string = g_settings_schema_list_children(GtkOpaque)",
   "GtkWidget = gtk_menu_new()",
   "GdkRectangle = gtk_cell_renderer_get_aligned_area(GObject,GtkWidget,int,struct)",
   "gtk_fixed_put(GtkWidget,GtkWidget,int,int)",
   "int = gtk_text_iter_editable(GtkTextIter,int)",
   "int = g_main_context_is_owner(GMainContext)",
   "GObject = gtk_clipboard_get_for_display(GObject,GObject)",
   "gtk_text_buffer_begin_user_action(GObject)",
   "ulong = pango_font_metrics_get_type()",
   "string = g_drive_get_name(GtkOpaque)",
   "int = g_network_monitor_can_reach(GtkOpaque,GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_check_menu_item_new_with_mnemonic(string)",
   "gtk_grid_set_row_spacing(GtkWidget,uint)",
   "gtk_spin_button_update(GtkWidget)",
   "int = gtk_button_get_image_position(GtkWidget)",
   "int = g_variant_type_is_definite(GVariantType)",
   "gdk_flush()",
   "double = gdk_screen_get_resolution(GObject)",
   "pango_layout_set_attributes(GtkOpaque,PangoAttrList)",
   "GtkWidget = gtk_cell_view_new_with_text(string)",
   "gtk_widget_input_shape_combine_region(GtkWidget,Cairo)",
   "(uint,uint,uint) = gtk_calendar_get_date(GtkWidget)",
   "gtk_image_clear(GtkWidget)",
   "g_date_set_parse(GDate,string)",
   "ulong = gtk_overlay_get_type()",
   "pango_layout_line_unref(PangoLayoutLine)",
   "GtkOpaque = g_app_info_create_from_commandline(string,string,int)",
   "int = gtk_font_button_set_font_name(GtkWidget,string)",
   "(uint,int,int) = gdk_visual_get_red_pixel_details(GObject)",
   "ulong = gtk_tree_model_filter_get_type()",
   "gtk_entry_set_placeholder_text(GtkWidget,string)",
   "long = g_socket_send_to(GObject,GtkOpaque,string,ulong,GtkOpaque)",
   "gtk_popover_set_position(GtkWidget,int)",
   "ulong = gdk_anchor_hints_get_type()",
   "int = gtk_entry_get_current_icon_drag_source(GtkWidget)",
   "gdk_window_fullscreen_on_monitor(GObject,int)",
   "GtkWidget = gtk_check_button_new_with_label(string)",
   "ulong = gdk_pixbuf_simple_anim_iter_get_type()",
   "GObject = gdk_display_get_device_manager(GObject)",
   "g_simple_action_group_remove(GtkOpaque,string)",
   "ulong = gtk_gesture_drag_get_type()",
   "int = gtk_flow_box_child_is_selected(GtkWidget)",
   "GtkTreeIter = gtk_tree_iter_copy(GtkTreeIter)",
   "gtk_recent_chooser_set_limit(GObject,int)",
   "int = gtk_gl_area_get_use_es(GtkWidget)",
   "gtk_flow_box_select_child(GtkWidget,GtkWidget)",
   "GdkRectangle = gtk_text_view_get_visible_rect(GtkWidget)",
   "g_source_add_child_source(GSource,GSource)",
   "g_filename_completer_set_dirs_only(GObject,int)",
   "uint = gtk_recent_chooser_error_quark()",
   "uint = gdk_pixbuf_error_quark()",
   "GObject = gtk_print_operation_get_default_page_setup(GObject)",
   "g_simple_action_group_insert(GtkOpaque,GtkOpaque)",
   "gdk_selection_send_notify_for_display(GObject,GObject,GObject,GObject,GObject,uint)",
   "gtk_window_set_focus_on_map(GtkWidget,int)",
   "long = g_checksum_type_get_length(int)",
   "GtkWidget = gtk_native_dialog_get_transient_for(GtkWidget)",
   "int = g_variant_equal(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_tool_palette_new()",
   "double = gtk_print_settings_get_paper_width(GObject,int)",
   "gtk_notebook_remove_page(GtkWidget,int)",
   "g_source_remove_poll(GSource,GtkOpaque)",
   "gtk_print_unix_dialog_set_manual_capabilities(GtkWidget,int)",
   "gtk_drag_highlight(GtkWidget)",
   "gtk_spin_button_set_snap_to_ticks(GtkWidget,int)",
   "GVariantBuilder = g_variant_builder_new(GVariantType)",
   "int = gdk_keymap_get_caps_lock_state(GObject)",
   "(ulong,uint) = g_unichar_fully_decompose(uint,int,ulong)",
   "ulong = gtk_label_get_type()",
   "GVariantType = g_variant_type_new(string)",
   "GdkPixbuf = gdk_pixbuf_get_from_surface(Cairo,int,int,int,int)",
   "int = pango_layout_iter_next_char(PangoLayoutIter)",
   "int = gdk_drag_context_manage_dnd(GObject,GObject,int)",
   "int = gdk_pixbuf_set_option(GdkPixbuf,string,string)",
   "GtkPaperSize = gtk_paper_size_new_custom(string,string,double,double,int)",
   "GVariant = g_variant_builder_end(GVariantBuilder)",
   "int = gtk_widget_path_iter_has_qregion(GtkWidgetPath,int,uint,int[])",
   "ushort = g_variant_get_uint16(GVariant)",
   "g_source_set_ready_time(GSource,long)",
   "ulong = gtk_file_chooser_widget_get_type()",
   "g_object_watch_closure(GObject,GtkOpaque)",
   "int = pango_parse_markup(string,int,uint,PangoAttrList[],string[],uint[])",
   "int = g_io_channel_unix_get_fd(GIOChannel)",
   "gtk_draw_insertion_cursor(GtkWidget,Cairo,struct,int,int,int)",
   "gtk_print_unix_dialog_set_current_page(GtkWidget,int)",
   "int = gdk_event_get_state(GdkEvent)",
   "gtk_text_buffer_remove_selection_clipboard(GObject,GObject)",
   "gtk_scrolled_window_set_max_content_height(GtkWidget,int)",
   "int = g_object_is_floating(GtkOpaque)",
   "gdk_pixbuf_simple_anim_set_loop(GObject,int)",
   "gtk_message_dialog_format_secondary_markup(GtkWidget,string)",
   "GdkPixbuf = gtk_window_get_icon(GtkWidget)",
   "gtk_label_set_use_underline(GtkWidget,int)",
   "pango_renderer_draw_glyphs(GtkOpaque,GtkOpaque,PangoGlyphString,int,int)",
   "gtk_list_box_set_adjustment(GtkWidget,GObject)",
   "GtkWidget = gtk_recent_chooser_menu_new()",
   "gtk_about_dialog_set_logo(GtkWidget,GdkPixbuf)",
   "long = g_date_time_get_utc_offset(GDateTime)",
   "gtk_entry_completion_delete_action(GObject,int)",
   "g_notification_set_icon(GtkOpaque,GtkOpaque)",
   "int = gtk_notebook_get_show_tabs(GtkWidget)",
   "gtk_cell_view_set_displayed_row(GtkWidget,GtkTreePath)",
   "int = gdk_display_request_selection_notification(GObject,GObject)",
   "int = g_date_compare(GDate,GDate)",
   "int = g_type_check_value_holds(GtkOpaque,ulong)",
   "g_file_info_set_file_type(GObject,int)",
   "gdk_display_set_double_click_time(GObject,uint)",
   "gdk_pixbuf_fill(GdkPixbuf,uint)",
   "GDateTime = g_file_info_get_deletion_date(GObject)",
   "gtk_app_chooser_dialog_set_heading(GtkWidget,string)",
   "int = gtk_css_provider_load_from_data(GObject,string,long)",
   "gdk_offscreen_window_set_embedder(GObject,GObject)",
   "string = gdk_keyval_name(uint)",
   "GObject = gtk_text_buffer_create_mark(GObject,string,GtkTextIter,int)",
   "int = gtk_stack_get_transition_type(GtkWidget)",
   "gtk_flow_box_set_vadjustment(GtkWidget,GObject)",
   "g_credentials_set_native(GObject,int,GtkOpaque)",
   "ulong = gtk_print_operation_preview_get_type()",
   "int = gtk_gesture_set_state(GObject,int)",
   "int = g_file_set_attributes_from_info(GtkOpaque,GObject,int,GtkOpaque)",
   "gtk_menu_item_set_submenu(GtkWidget,GtkWidget)",
   "gtk_text_buffer_insert_range(GObject,GtkTextIter,GtkTextIter,GtkTextIter)",
   "g_socket_set_keepalive(GObject,int)",
   "gtk_font_chooser_set_font_map(GObject,GtkOpaque)",
   "GtkWidget = gtk_tree_selection_get_tree_view(GObject)",
   "GtkWidget = gtk_window_get_titlebar(GtkWidget)",
   "g_menu_item_set_link(GObject,string,GObject)",
   "GObject = gtk_selection_data_get_selection(GtkSelectionData)",
   "int = gtk_notebook_get_tab_detachable(GtkWidget,GtkWidget)",
   "GtkTreePath = gtk_tree_path_new_first()",
   "g_menu_remove_all(GObject)",
   "gtk_tree_store_clear(GObject)",
   "gtk_text_view_set_overwrite(GtkWidget,int)",
   "uint = gtk_builder_add_objects_from_resource(GObject,string,string[])",
   "gtk_widget_unrealize(GtkWidget)",
   "GObject = gtk_combo_box_get_popup_accessible(GtkWidget)",
   "gtk_editable_select_region(GObject,int,int)",
   "GSource = g_source_ref(GSource)",
   "g_settings_revert(GtkOpaque)",
   "int = gdk_display_supports_input_shapes(GObject)",
   "GtkWidget = gtk_image_new_from_animation(GObject)",
   "GdkRectangle = gtk_gesture_get_bounding_box(GObject)",
   "pango_renderer_draw_layout(GtkOpaque,GtkOpaque,int,int)",
   "GdkPixbuf = gdk_pixbuf_animation_get_static_image(GObject)",
   "int = g_file_set_attribute_int64(GtkOpaque,string,long,int,GtkOpaque)",
   "GObject = gtk_recent_manager_get_default()",
   "gtk_widget_path_iter_set_object_type(GtkWidgetPath,int,ulong)",
   "string = g_match_info_fetch_named(GMatchInfo,string)",
   "gtk_tree_path_free(GtkTreePath)",
   "GtkOpaque = g_type_get_plugin(ulong)",
   "int = gtk_label_get_track_visited_links(GtkWidget)",
   "gdk_gl_context_set_required_version(GObject,int,int)",
   "double = gtk_adjustment_get_page_increment(GObject)",
   "GtkOpaque = g_file_open_readwrite_finish(GtkOpaque,GtkOpaque)",
   "gtk_entry_set_buffer(GtkWidget,GObject)",
   "int = gdk_window_get_composited(GObject)",
   "string = gtk_widget_path_to_string(GtkWidgetPath)",
   "(int,uint) = g_unichar_get_mirror_char(uint)",
   "gtk_drag_set_icon_gicon(GObject,GtkOpaque,int,int)",
   "GtkOpaque = g_network_address_new(string,ushort)",
   "int = gtk_tree_view_column_get_clickable(GtkWidget)",
   "GdkPixbuf = gtk_entry_get_icon_pixbuf(GtkWidget,int)",
   "int = gdk_event_get_event_type(GdkEvent)",
   "int = gtk_tree_view_get_hover_expand(GtkWidget)",
   "int = gdk_pixbuf_copy_options(GdkPixbuf,GdkPixbuf)",
   "int = gdk_keyval_is_upper(uint)",
   "ulong = gdk_pixbuf_get_byte_length(GdkPixbuf)",
   "int = gtk_clipboard_wait_is_target_available(GObject,GObject)",
   "string = g_themed_icon_get_names(GObject)",
   "ulong = gdk_grab_status_get_type()",
   "string = g_get_current_dir()",
   "(int,GtkTextIter) = gtk_text_view_get_iter_at_location(GtkWidget,int,int)",
   "int = gtk_stack_get_interpolate_size(GtkWidget)",
   "uint = g_utf8_to_ucs4(string,long,long[])",
   "int = gtk_widget_child_focus(GtkWidget,int)",
   "GObject = gtk_cell_area_get_edited_cell(GObject)",
   "gdk_frame_timings_unref(GdkFrameTimings)",
   "int = gtk_revealer_get_reveal_child(GtkWidget)",
   "int = gtk_print_unix_dialog_get_current_page(GtkWidget)",
   "int = gtk_expander_get_resize_toplevel(GtkWidget)",
   "gtk_text_view_set_right_margin(GtkWidget,int)",
   "gtk_tree_view_column_pack_end(GtkWidget,GObject,int)",
   "gtk_print_job_set_n_up_layout(GObject,int)",
   "GObject = gtk_widget_get_display(GtkWidget)",
   "gtk_drag_source_unset(GtkWidget)",
   "int = gtk_parse_args(int[],char_ptr_ptr_ptr)",
   "gdk_drag_drop_done(GObject,int)",
   "gtk_style_context_remove_class(GObject,string)",
   "g_resolver_set_default(GtkOpaque)",
   "ulong = g_type_next_base(ulong,ulong)",
   "gtk_tooltip_set_markup(GObject,string)",
   "GObject = gdk_visual_get_best_with_type(int)",
   "GObject = g_binding_get_target(GtkOpaque)",
   "gtk_accel_group_connect_by_path(GObject,string,GtkOpaque)",
   "gtk_widget_path_iter_set_object_name(GtkWidgetPath,int,string)",
   "int = gtk_window_parse_geometry(GtkWidget,string)",
   "gtk_list_box_unselect_all(GtkWidget)",
   "GdkRectangle = gtk_tree_view_get_background_area(GtkWidget,GtkTreePath,GtkWidget)",
   "PangoAttrList = pango_attr_list_new()",
   "gdk_cairo_rectangle(Cairo,struct)",
   "int = gtk_window_get_destroy_with_parent(GtkWidget)",
   "gtk_combo_box_set_add_tearoffs(GtkWidget,int)",
   "gtk_entry_set_has_frame(GtkWidget,int)",
   "gtk_tree_view_column_set_fixed_width(GtkWidget,int)",
   "g_bookmark_file_add_application(GBookmarkFile,string,string,string)",
   "gtk_paper_size_to_key_file(GtkPaperSize,GKeyFile,string)",
   "string = gtk_recent_info_get_uri_display(GObject)",
   "GObject = gtk_clipboard_get(GObject)",
   "int = gtk_entry_completion_get_text_column(GObject)",
   "gdk_window_set_accept_focus(GObject,int)",
   "GObject = gtk_page_setup_unix_dialog_get_page_setup(GtkWidget)",
   "gtk_range_set_min_slider_size(GtkWidget,int)",
   "gtk_image_set_from_stock(GtkWidget,string,int)",
   "string = gtk_about_dialog_get_program_name(GtkWidget)",
   "int = gtk_print_operation_is_finished(GObject)",
   "gtk_accel_map_lock_path(string)",
   "gtk_editable_delete_text(GObject,int,int)",
   "int = g_mount_operation_get_is_tcrypt_system_volume(GObject)",
   "g_menu_insert_item(GObject,int,GObject)",
   "gtk_print_operation_set_use_full_page(GObject,int)",
   "gtk_combo_box_popup_for_device(GtkWidget,GdkDevice)",
   "int = gtk_gesture_get_sequence_state(GObject,GtkOpaque)",
   "GHmac = g_hmac_copy(GHmac)",
   "GtkWidget = gtk_app_chooser_dialog_new(GtkWidget,int,GtkOpaque)",
   "char = g_ascii_tolower(char)",
   "ulong = gtk_progress_bar_get_type()",
   "string = g_bookmark_file_get_groups(GBookmarkFile,string)",
   "GObject = gdk_event_get_screen(GdkEvent)",
   "ulong = gtk_style_provider_get_type()",
   "gtk_check_menu_item_set_active(GtkWidget,int)",
   "GObject = g_inet_address_new_from_string(string)",
   "uint = g_resource_error_quark()",
   "ulong = gtk_cell_area_get_type()",
   "GRegex = g_regex_new(string,int,int)",
   "ulong = gtk_event_controller_key_get_type()",
   "GtkWidget = gtk_radio_menu_item_new_with_label_from_widget(GtkWidget,string)",
   "GtkOpaque = gtk_widget_create_pango_context(GtkWidget)",
   "int = gtk_selection_data_get_length(GtkSelectionData)",
   "ulong = pango_renderer_get_type()",
   "GtkOpaque = gtk_list_box_get_selected_rows(GtkWidget)",
   "GObject = gdk_screen_get_default()",
   "(int,int) = gtk_cell_renderer_get_fixed_size(GObject)",
   "gtk_icon_view_set_item_width(GtkWidget,int)",
   "int = g_unichar_isgraph(uint)",
   "gtk_tool_palette_add_drag_dest(GtkWidget,GtkWidget,int,int,int)",
   "gtk_render_extension(GObject,Cairo,double,double,double,double,int)",
   "int = gtk_event_box_get_above_child(GtkWidget)",
   "GVariant = g_variant_new_dict_entry(GVariant,GVariant)",
   "GVariantType = g_variant_type_first(GVariantType)",
   "int = gtk_print_unix_dialog_get_manual_capabilities(GtkWidget)",
   "int = pango_layout_get_height(GtkOpaque)",
   "int = g_unichar_ispunct(uint)",
   "gtk_link_button_set_uri(GtkWidget,string)",
   "gtk_cell_area_add(GObject,GObject)",
   "GMainContext = g_main_context_ref(GMainContext)",
   "int = gtk_print_settings_get_bool(GObject,string)",
   "gtk_tree_view_set_activate_on_single_click(GtkWidget,int)",
   "int = gtk_icon_view_get_reorderable(GtkWidget)",
   "int = gtk_widget_has_focus(GtkWidget)",
   "int = gdk_window_show_window_menu(GObject,GdkEvent)",
   "gtk_widget_set_visual(GtkWidget,GObject)",
   "uint = gtk_stack_get_transition_duration(GtkWidget)",
   "int = gtk_scrolled_window_get_capture_button_press(GtkWidget)",
   "g_simple_proxy_resolver_set_default_proxy(GObject,string)",
   "int = gtk_tree_view_get_headers_clickable(GtkWidget)",
   "int = gtk_tree_view_get_tooltip_column(GtkWidget)",
   "float = g_value_get_float(GtkOpaque)",
   "GtkWidget = gtk_menu_new_from_model(GObject)",
   "int = gtk_menu_get_monitor(GtkWidget)",
   "string = gtk_entry_get_icon_stock(GtkWidget,int)",
   "GtkOpaque = pango_attr_strikethrough_new(int)",
   "GdkPixbuf = gdk_pixbuf_apply_embedded_orientation(GdkPixbuf)",
   "gtk_combo_box_set_row_span_column(GtkWidget,int)",
   "GtkOpaque = gtk_tree_selection_get_user_data(GObject)",
   "ulong = gtk_event_box_get_type()",
   "string = gdk_get_display()",
   "gtk_widget_hide(GtkWidget)",
   "GtkWidget = gtk_layout_new(GObject,GObject)",
   "GObject = gtk_drag_dest_find_target(GtkWidget,GObject,GtkTargetList)",
   "int = gtk_recent_info_get_age(GObject)",
   "Cairo = gdk_window_get_visible_region(GObject)",
   "ulong = g_variant_type_get_string_length(GVariantType)",
   "int = gtk_recent_info_get_private_hint(GObject)",
   "gtk_tree_selection_unselect_all(GObject)",
   "ushort = g_utf8_to_utf16(string,long,long[])",
   "pango_context_set_base_gravity(GtkOpaque,int)",
   "string = g_network_service_get_protocol(GtkOpaque)",
   "string = g_key_file_get_string_list(GKeyFile,string,string)",
   "g_value_set_gtype(GtkOpaque,ulong)",
   "gtk_app_chooser_widget_set_show_all(GtkWidget,int)",
   "gdk_gl_context_set_forward_compatible(GObject,int)",
   "GtkOpaque = g_socket_get_local_address(GObject)",
   "int = pango_font_description_get_gravity(GtkOpaque)",
   "string = g_get_home_dir()",
   "uint = gtk_builder_extend_with_template(GObject,GtkWidget,ulong,string,ulong)",
   "g_source_set_name_by_id(uint,string)",
   "(int,int) = gtk_cell_area_context_get_preferred_height(GObject)",
   "g_object_notify_by_pspec(GObject,GtkOpaque)",
   "GObject = gtk_css_provider_get_named(string,string)",
   "string = g_bookmark_file_get_description(GBookmarkFile,string)",
   "int = gtk_scrolled_window_get_max_content_height(GtkWidget)",
   "gtk_widget_set_font_map(GtkWidget,GtkOpaque)",
   "int = pango_layout_iter_next_cluster(PangoLayoutIter)",
   "(int,ulong,uint) = g_resource_get_info(GtkOpaque,string,int)",
   "string = gtk_notebook_get_group_name(GtkWidget)",
   "ulong = gtk_aspect_frame_get_type()",
   "gtk_icon_view_set_item_padding(GtkWidget,int)",
   "gtk_tree_selection_select_path(GObject,GtkTreePath)",
   "gtk_window_set_mnemonic_modifier(GtkWidget,int)",
   "gtk_tool_palette_set_style(GtkWidget,int)",
   "GtkOpaque = g_file_query_settable_attributes(GtkOpaque,GtkOpaque)",
   "ulong = gdk_axis_use_get_type()",
   "gtk_style_context_remove_provider_for_screen(GObject,GObject)",
   "gtk_text_buffer_insert_at_cursor(GObject,string)",
   "GObject = gdk_drag_begin(GObject,GtkOpaque[])",
   "long = g_settings_get_int64(GtkOpaque,string)",
   "int = gtk_cell_renderer_toggle_get_activatable(GObject)",
   "string = gtk_menu_get_accel_path(GtkWidget)",
   "int = gtk_grid_get_baseline_row(GtkWidget)",
   "GtkAllocation = gtk_widget_get_allocation(GtkWidget)",
   "int = gtk_font_button_get_show_style(GtkWidget)",
   "GObject = gtk_style_context_get_screen(GObject)",
   "gtk_entry_completion_set_model(GObject,GObject)",
   "gtk_flow_box_invalidate_sort(GtkWidget)",
   "g_source_add_poll(GSource,GtkOpaque)",
   "gdk_window_freeze_toplevel_updates_libgtk_only(GObject)",
   "gtk_style_context_remove_provider(GObject,GObject)",
   "string = g_dir_read_name(GDir)",
   "GObject = gtk_window_get_application(GtkWidget)",
   "int = g_match_info_next(GMatchInfo)",
   "gtk_target_list_add_table(GtkTargetList,GObject,uint)",
   "gtk_tree_sortable_sort_column_changed(GObject)",
   "g_content_type_set_mime_dirs(string[])",
   "gtk_editable_set_position(GObject,int)",
   "gtk_window_fullscreen(GtkWidget)",
   "g_app_launch_context_unsetenv(GObject,string)",
   "gtk_window_resize_to_geometry(GtkWidget,int,int)",
   "int = gtk_assistant_get_page_complete(GtkWidget,GtkWidget)",
   "gtk_statusbar_remove(GtkWidget,uint,uint)",
   "uint = gtk_application_inhibit(GObject,GtkWidget,int,string)",
   "GObject = gdk_cursor_new_from_pixbuf(GObject,GdkPixbuf,int,int)",
   "int = pango_font_face_is_synthesized(GtkOpaque)",
   "GtkOpaque = pango_font_describe(GtkOpaque)",
   "GtkWidget = gtk_info_bar_get_action_area(GtkWidget)",
   "int = gtk_label_get_use_markup(GtkWidget)",
   "pango_context_list_families(GtkOpaque,PangoFontFamily_ptr_ptr_ptr,int[])",
   "g_notification_set_urgent(GtkOpaque,int)",
   "string = gtk_file_chooser_get_preview_filename(GObject)",
   "gtk_scrollable_set_hscroll_policy(GObject,int)",
   "GdkRectangle = gdk_monitor_get_geometry(GObject)",
   "GtkOpaque = gtk_paper_size_get_paper_sizes(int)",
   "int = gtk_search_bar_get_show_close_button(GtkWidget)",
   "ulong = gdk_window_window_class_get_type()",
   "string = g_app_info_get_executable(GtkOpaque)",
   "string = g_match_info_fetch(GMatchInfo,int)",
   "GtkWidget = gtk_window_group_get_current_device_grab(GObject,GdkDevice)",
   "gtk_grid_insert_row(GtkWidget,int)",
   "int = g_mkdir_with_parents(string,int)",
   "int = gdk_device_get_mode(GdkDevice)",
   "int = gtk_recent_chooser_get_show_tips(GObject)",
   "g_main_context_remove_poll(GMainContext,GtkOpaque)",
   "g_date_subtract_days(GDate,uint)",
   "ulong = g_io_channel_get_buffer_size(GIOChannel)",
   "GObject = gtk_text_buffer_register_deserialize_tagset(GObject,string)",
   "GObject = gtk_scale_button_get_adjustment(GtkWidget)",
   "string = gtk_paper_size_get_display_name(GtkPaperSize)",
   "gtk_flow_box_invalidate_filter(GtkWidget)",
   "gtk_print_operation_set_show_progress(GObject,int)",
   "gtk_text_view_set_input_purpose(GtkWidget,int)",
   "int = gtk_main_iteration()",
   "ulong = pango_font_face_get_type()",
   "GtkTreeRowReference = gtk_tree_row_reference_new_proxy(GObject,GObject,GtkTreePath)",
   "int = gtk_icon_theme_rescan_if_needed(GObject)",
   "string = gtk_file_chooser_get_filename(GObject)",
   "(uint,int) = gtk_accelerator_parse(string)",
   "int = g_network_monitor_get_connectivity(GtkOpaque)",
   "int = gtk_text_iter_get_line_offset(GtkTextIter)",
   "int = gtk_get_current_event_state(int[])",
   "pango_renderer_part_changed(GtkOpaque,int)",
   "int = g_date_time_get_month(GDateTime)",
   "GdkRectangle = gdk_monitor_get_workarea(GObject)",
   "gtk_spin_button_set_digits(GtkWidget,uint)",
   "gtk_set_debug_flags(uint)",
   "g_key_file_set_list_separator(GKeyFile,char)",
   "gtk_scrolled_window_set_capture_button_press(GtkWidget,int)",
   "string = gtk_frame_get_label(GtkWidget)",
   "GtkOpaque = gdk_seat_get_slaves(GObject,int)",
   "g_file_info_set_content_type(GObject,string)",
   "gtk_tree_view_set_rules_hint(GtkWidget,int)",
   "string = gtk_print_settings_get_media_type(GObject)",
   "GtkWidget = gtk_radio_menu_item_new_with_mnemonic(GtkOpaque[],string)",
   "GtkWidget = gtk_tree_view_column_get_tree_view(GtkWidget)",
   "int = g_unichar_xdigit_value(uint)",
   "g_main_loop_run(GMainLoop)",
   "GtkWidget = gtk_spinner_new()",
   "ulong = g_ascii_strtoull(string,string[],uint)",
   "gtk_page_setup_unix_dialog_set_print_settings(GtkWidget,GObject)",
   "GdkPixbuf = gdk_pixbuf_get_from_window(GObject,int,int,int,int)",
   "int = gtk_window_get_has_resize_grip(GtkWidget)",
   "string = g_credentials_to_string(GObject)",
   "GtkOpaque = g_value_get_object(GtkOpaque)",
   "GObject = gtk_print_context_get_page_setup(GObject)",
   "g_value_take_variant(GtkOpaque,GVariant)",
   "ulong = gtk_tree_selection_get_type()",
   "uint = gtk_builder_add_objects_from_file(GObject,string,string[])",
   "gtk_widget_set_has_window(GtkWidget,int)",
   "ulong = gdk_visibility_state_get_type()",
   "g_mount_operation_set_username(GObject,string)",
   "string = gtk_widget_list_action_prefixes(GtkWidget)",
   "gtk_file_chooser_unselect_all(GObject)",
   "(int,int) = gtk_cell_area_request_renderer(GObject,GObject,int,GtkWidget,int)",
   "g_bookmark_file_set_groups(GBookmarkFile,string,string[],ulong)",
   "GtkOpaque = g_memdup(GtkOpaque,uint)",
   "gdk_cairo_set_source_rgba(Cairo,struct)",
   "int = gtk_entry_get_width_chars(GtkWidget)",
   "gtk_target_list_add_text_targets(GtkTargetList,uint)",
   "gtk_combo_box_text_prepend(GtkWidget,string,string)",
   "GObject = gtk_text_mark_get_buffer(GObject)",
   "gtk_widget_set_state_flags(GtkWidget,int,int)",
   "int = gdk_window_is_viewable(GObject)",
   "int = gtk_targets_include_image(GObject[],int,int)",
   "ulong = g_network_monitor_get_type()",
   "int = g_bookmark_file_remove_item(GBookmarkFile,string)",
   "pango_tab_array_get_tab(PangoTabArray,int,int[],int[])",
   "string = g_volume_get_identifier(GtkOpaque,string)",
   "gtk_combo_box_set_button_sensitivity(GtkWidget,int)",
   "int = g_variant_check_format_string(GVariant,string,int)",
   "uint = g_signal_lookup(string,ulong)",
   "ulong = gtk_tree_store_get_type()",
   "int = g_socket_get_multicast_loopback(GObject)",
   "int = gtk_label_get_line_wrap(GtkWidget)",
   "int = gtk_tree_view_column_get_resizable(GtkWidget)",
   "GVariant = g_settings_schema_key_get_range(GtkOpaque)",
   "int = g_settings_set_flags(GtkOpaque,string,uint)",
   "string = g_settings_list_schemas()",
   "gtk_file_chooser_set_preview_widget(GObject,GtkWidget)",
   "int = gdk_drag_drop_succeeded(GObject)",
   "int = gtk_accel_label_refetch(GtkWidget)",
   "(GtkTextIter,GtkTextIter) = gtk_text_buffer_get_selection_bounds(GObject)",
   "GObject = g_menu_model_get_item_link(GObject,int,string)",
   "int = gtk_info_bar_get_message_type(GtkWidget)",
   "GtkOpaque = g_settings_schema_ref(GtkOpaque)",
   "int = g_unichar_isspace(uint)",
   "gtk_window_set_icon(GtkWidget,GdkPixbuf)",
   "string = g_compute_hmac_for_bytes(int,GBytes,GBytes)",
   "GVariant = g_action_get_state(GtkOpaque)",
   "GObject = gtk_recent_manager_lookup_item(GObject,string)",
   "GObject = gdk_display_get_app_launch_context(GObject)",
   "ushort = gtk_color_button_get_alpha(GtkWidget)",
   "(int,double,double) = gtk_gesture_drag_get_offset(GObject)",
   "int = g_input_stream_has_pending(GObject)",
   "int = gdk_device_get_device_type(GdkDevice)",
   "pango_context_set_round_glyph_positions(GtkOpaque,int)",
   "gtk_icon_view_set_model(GtkWidget,GObject)",
   "gtk_window_unstick(GtkWidget)",
   "gtk_menu_shell_select_item(GtkWidget,GtkWidget)",
   "string = g_strchomp(string)",
   "int = gtk_text_iter_get_bytes_in_line(GtkTextIter)",
   "int = gtk_widget_device_is_shadowed(GtkWidget,GdkDevice)",
   "int = gtk_text_iter_forward_word_ends(GtkTextIter,int)",
   "GVariantBuilder = g_variant_builder_ref(GVariantBuilder)",
   "gtk_viewport_set_vadjustment(GtkWidget,GObject)",
   "gtk_entry_set_max_length(GtkWidget,int)",
   "GtkOpaque = g_file_create_readwrite(GtkOpaque,int,GtkOpaque)",
   "double = gtk_paper_size_get_default_right_margin(GtkPaperSize,int)",
   "uint = gdk_keymap_get_modifier_state(GObject)",
   "uint = g_random_int()",
   "int = gtk_tool_item_get_visible_vertical(GtkWidget)",
   "int = gtk_scrolled_window_get_max_content_width(GtkWidget)",
   "g_value_set_param(GtkOpaque,GtkOpaque)",
   "int = gtk_text_iter_get_line_index(GtkTextIter)",
   "uint = g_file_hash(GtkOpaque)",
   "GtkWidget = gtk_expander_get_label_widget(GtkWidget)",
   "ulong = gdk_monitor_get_type()",
   "gtk_list_box_invalidate_filter(GtkWidget)",
   "GdkPixbuf = gdk_pixbuf_rotate_simple(GdkPixbuf,int)",
   "int = gtk_tree_path_is_ancestor(GtkTreePath,GtkTreePath)",
   "gtk_about_dialog_set_website(GtkWidget,string)",
   "int = g_mount_eject_with_operation_finish(GtkOpaque,GtkOpaque)",
   "gtk_widget_path_iter_add_region(GtkWidgetPath,int,string,int)",
   "gdk_window_set_icon_name(GObject,string)",
   "pango_cairo_layout_line_path(Cairo,PangoLayoutLine)",
   "int = gtk_entry_get_icon_at_pos(GtkWidget,int,int)",
   "gtk_tree_view_set_hover_expand(GtkWidget,int)",
   "GDateTime = g_date_time_new_from_iso8601(string,GTimeZone)",
   "string = pango_font_description_to_string(GtkOpaque)",
   "int = gtk_text_iter_forward_to_line_end(GtkTextIter)",
   "int = gtk_box_get_homogeneous(GtkWidget)",
   "int = g_str_is_ascii(string)",
   "long = g_date_time_to_unix(GDateTime)",
   "ulong = gtk_actionable_get_type()",
   "int = gdk_window_get_event_compression(GObject)",
   "gdk_beep()",
   "gtk_entry_set_progress_fraction(GtkWidget,double)",
   "GtkOpaque = pango_attr_allow_breaks_new(int)",
   "int = gtk_text_view_get_top_margin(GtkWidget)",
   "GObject = gdk_pixbuf_animation_get_iter(GObject,struct)",
   "GtkWidget = gtk_dialog_get_widget_for_response(GtkWidget,int)",
   "GtkOpaque = pango_language_get_default()",
   "gtk_window_begin_resize_drag(GtkWidget,int,int,int,int,uint)",
   "gtk_window_set_icon_name(GtkWidget,string)",
   "g_value_set_static_string(GtkOpaque,string)",
   "int = gtk_selection_owner_set(GtkWidget,GObject,uint)",
   "gtk_list_store_clear(GObject)",
   "gtk_actionable_set_detailed_action_name(GObject,string)",
   "GObject = gtk_cell_renderer_pixbuf_new()",
   "gtk_menu_popup_at_pointer(GtkWidget,GdkEvent)",
   "GObject = gtk_cell_renderer_combo_new()",
   "g_menu_append_section(GObject,string,GObject)",
   "gtk_text_iter_set_line(GtkTextIter,int)",
   "int = g_socket_shutdown(GObject,int,int)",
   "int = gtk_widget_is_sensitive(GtkWidget)",
   "gtk_button_set_label(GtkWidget,string)",
   "string = g_uri_unescape_segment(string,string,string)",
   "GtkOpaque = pango_cairo_create_context(Cairo)",
   "g_simple_proxy_resolver_set_ignore_hosts(GObject,string[])",
   "GVariant = g_settings_get_default_value(GtkOpaque,string)",
   "gtk_popover_set_pointing_to(GtkWidget,struct)",
   "GtkOpaque = g_vfs_get_local()",
   "int = gdk_display_supports_selection_notification(GObject)",
   "double = gtk_print_context_get_dpi_x(GObject)",
   "ulong = gtk_calendar_get_type()",
   "gtk_places_sidebar_add_shortcut(GtkWidget,GtkOpaque)",
   "int = pango_layout_get_character_count(GtkOpaque)",
   "GtkWidget = gtk_radio_tool_button_new_from_widget(GtkWidget)",
   "int = gtk_grid_get_row_baseline_position(GtkWidget,int)",
   "GtkWidget = gtk_container_get_focus_child(GtkWidget)",
   "(int,int) = gtk_text_view_get_line_yrange(GtkWidget,GtkTextIter)",
   "ulong = gtk_cell_area_box_get_type()",
   "int = pango_font_metrics_get_strikethrough_thickness(PangoFontMetrics)",
   "GtkOpaque = gtk_window_get_icon_list(GtkWidget)",
   "GVariant = g_variant_new_variant(GVariant)",
   "int = gtk_places_sidebar_get_show_other_locations(GtkWidget)",
   "string = gtk_file_chooser_get_current_folder(GObject)",
   "int = gtk_tree_view_column_get_min_width(GtkWidget)",
   "gtk_print_operation_set_current_page(GObject,int)",
   "gdk_window_set_urgency_hint(GObject,int)",
   "string = g_settings_get_string(GtkOpaque,string)",
   "gtk_selection_add_target(GtkWidget,GObject,GObject,uint)",
   "gdk_window_invalidate_rect(GObject,struct,int)",
   "int = gtk_cell_area_has_renderer(GObject,GObject)",
   "int = g_app_info_equal(GtkOpaque,GtkOpaque)",
   "GtkOpaque = g_settings_get_child(GtkOpaque,string)",
   "ulong = g_type_fundamental(ulong)",
   "gdk_display_beep(GObject)",
   "GTimeZone = g_time_zone_new(string)",
   "ulong = gtk_model_button_get_type()",
   "uint = gtk_print_job_get_n_up(GObject)",
   "string = g_proxy_address_get_password(GtkOpaque)",
   "ulong = gtk_viewport_get_type()",
   "string = g_filename_display_basename(string)",
   "gtk_statusbar_pop(GtkWidget,uint)",
   "gtk_stack_set_transition_duration(GtkWidget,uint)",
   "GObject = gtk_cell_area_copy_context(GObject,GObject)",
   "int = g_file_info_get_attribute_int32(GObject,string)",
   "ulong = gtk_scrolled_window_get_type()",
   "ulong = gtk_cell_renderer_progress_get_type()",
   "ulong = gtk_widget_path_get_object_type(GtkWidgetPath)",
   "pango_layout_set_spacing(GtkOpaque,int)",
   "gtk_places_sidebar_set_show_enter_location(GtkWidget,int)",
   "int = gtk_entry_get_input_hints(GtkWidget)",
   "int = gtk_menu_button_get_use_popover(GtkWidget)",
   "gdk_event_set_source_device(GdkEvent,GdkDevice)",
   "gtk_tree_view_collapse_all(GtkWidget)",
   "ulong = g_settings_schema_get_type()",
   "string = g_param_spec_get_name(GtkOpaque)",
   "gtk_font_chooser_set_level(GObject,int)",
   "GdkPixbuf = gtk_render_icon_pixbuf(GObject,GObject,int)",
   "gtk_recent_filter_add_pattern(GObject,string)",
   "GObject = g_file_query_filesystem_info(GtkOpaque,string,GtkOpaque)",
   "double = g_random_double_range(double,double)",
   "GTimer = g_timer_new()",
   "int = gdk_display_supports_shapes(GObject)",
   "int = gtk_image_get_pixel_size(GtkWidget)",
   "string = g_filename_from_uri(string,string[])",
   "(int,int) = gdk_window_get_position(GObject)",
   "string = gtk_font_button_get_title(GtkWidget)",
   "ulong = gtk_tool_item_get_type()",
   "double = gtk_paper_size_get_height(GtkPaperSize,int)",
   "GRand = g_rand_new_with_seed_array(uint[],uint)",
   "gtk_accel_map_save_fd(int)",
   "int = g_socket_is_closed(GObject)",
   "ulong = gtk_separator_menu_item_get_type()",
   "int = g_main_loop_is_running(GMainLoop)",
   "GObject = gtk_application_get_menu_by_id(GObject,string)",
   "int = gtk_event_box_get_visible_window(GtkWidget)",
   "GKeyFile = g_key_file_ref(GKeyFile)",
   "gtk_widget_set_focus_on_click(GtkWidget,int)",
   "ushort = g_proxy_address_get_destination_port(GtkOpaque)",
   "gtk_radio_button_set_group(GtkWidget,GtkOpaque[])",
   "GtkOpaque = g_volume_get_icon(GtkOpaque)",
   "double = gtk_adjustment_get_page_size(GObject)",
   "string = gtk_file_chooser_native_get_accept_label(GtkWidget)",
   "int = gtk_tree_path_is_descendant(GtkTreePath,GtkTreePath)",
   "gtk_file_chooser_native_set_accept_label(GtkWidget,string)",
   "GtkOpaque = gtk_style_context_list_classes(GObject)",
   "int = gtk_window_has_group(GtkWidget)",
   "Cairo = gdk_pango_layout_get_clip_region(GtkOpaque,int,int,int[],int)",
   "gtk_widget_override_symbolic_color(GtkWidget,string,struct)",
   "int = gtk_target_list_find(GtkTargetList,GObject,uint[])",
   "GtkWidget = gtk_application_window_get_help_overlay(GtkWidget)",
   "GSource = g_socket_create_source(GObject,int,GtkOpaque)",
   "int = gdk_visual_get_byte_order(GObject)",
   "int = g_ascii_digit_value(char)",
   "gtk_about_dialog_set_logo_icon_name(GtkWidget,string)",
   "uint = gtk_tree_view_get_n_columns(GtkWidget)",
   "(int,int) = pango_layout_get_pixel_size(GtkOpaque)",
   "gtk_page_setup_set_top_margin(GObject,double,int)",
   "int = pango_context_get_gravity(GtkOpaque)",
   "GtkWidgetPath = gtk_widget_path_new()",
   "gtk_label_set_width_chars(GtkWidget,int)",
   "ulong = gtk_gesture_single_get_type()",
   "string = gtk_print_settings_get_default_source(GObject)",
   "string = gtk_recent_info_get_groups(GObject)",
   "GtkWidget = gtk_radio_button_new_with_mnemonic(GtkOpaque[],string)",
   "g_date_set_julian(GDate,uint)",
   "GtkOpaque = pango_script_get_sample_language(int)",
   "gtk_viewport_set_hadjustment(GtkWidget,GObject)",
   "gtk_scale_add_mark(GtkWidget,double,int,string)",
   "gtk_window_set_auto_startup_notification(int)",
   "gtk_icon_view_set_tooltip_item(GtkWidget,GObject,GtkTreePath)",
   "GtkWidget = gtk_button_get_image(GtkWidget)",
   "gdk_window_set_functions(GObject,int)",
   "int = g_settings_get_int(GtkOpaque,string)",
   "g_signal_handler_block(GtkOpaque,ulong)",
   "GtkWidget = gtk_grid_get_child_at(GtkWidget,int,int)",
   "int = gtk_text_iter_forward_visible_word_end(GtkTextIter)",
   "GtkOpaque = g_type_default_interface_ref(ulong)",
   "gtk_gl_area_set_error(GtkWidget,struct)",
   "int = gtk_tree_path_get_depth(GtkTreePath)",
   "int = gtk_recent_manager_add_item(GObject,string)",
   "GtkWidget = gtk_scale_new_with_range(int,double,double,double)",
   "g_notification_add_button(GtkOpaque,string,string)",
   "int = g_content_type_equals(string,string)",
   "uint = gtk_flow_box_get_row_spacing(GtkWidget)",
   "GVariant = g_variant_parse(GVariantType,string,string,string[])",
   "ulong = gtk_gesture_zoom_get_type()",
   "GtkOpaque = g_volume_get_symbolic_icon(GtkOpaque)",
   "int = gdk_display_supports_composite(GObject)",
   "gtk_drag_dest_add_image_targets(GtkWidget)",
   "GtkWidget = gtk_info_bar_get_content_area(GtkWidget)",
   "GtkOpaque = g_file_resolve_relative_path(GtkOpaque,string)",
   "GtkOpaque = pango_layout_iter_get_run(PangoLayoutIter)",
   "int = g_type_check_value(GtkOpaque)",
   "GVariantType = g_action_get_parameter_type(GtkOpaque)",
   "gtk_stack_add_named(GtkWidget,GtkWidget,string)",
   "Cairo = gdk_window_create_similar_surface(GObject,int,int,int)",
   "GObject = gtk_selection_data_get_target(GtkSelectionData)",
   "GVariantType = g_variant_get_type(GVariant)",
   "GtkTreePath = gtk_tree_model_filter_convert_child_path_to_path(GObject,GtkTreePath)",
   "gtk_paper_size_free(GtkPaperSize)",
   "gtk_widget_path_free(GtkWidgetPath)",
   "gtk_entry_set_icon_tooltip_markup(GtkWidget,int,string)",
   "gtk_app_chooser_widget_set_default_text(GtkWidget,string)",
   "string = g_source_get_name(GSource)",
   "int = gtk_tool_palette_get_style(GtkWidget)",
   "GVariantType = g_variant_type_value(GVariantType)",
   "pango_tab_array_resize(PangoTabArray,int)",
   "GKeyFile = g_key_file_new()",
   "gtk_print_settings_set_printer_lpi(GObject,double)",
   "gtk_tree_model_row_changed(GObject,GtkTreePath,GtkTreeIter)",
   "GdkPixbuf = gtk_image_get_pixbuf(GtkWidget)",
   "double = pango_units_to_double(int)",
   "GObject = gdk_pixbuf_loader_new_with_type(string)",
   "ulong = gtk_icon_view_get_type()",
   "gtk_window_set_default_icon_list(GtkOpaque[])",
   "string = g_key_file_get_start_group(GKeyFile)",
   "GObject = gtk_text_iter_get_buffer(GtkTextIter)",
   "gtk_tree_model_unref_node(GObject,GtkTreeIter)",
   "gtk_places_sidebar_remove_shortcut(GtkWidget,GtkOpaque)",
   "int = g_date_valid_weekday(int)",
   "GObject = gtk_page_setup_new_from_gvariant(GVariant)",
   "gtk_notebook_set_tab_pos(GtkWidget,int)",
   "GDateTime = g_date_time_add_days(GDateTime,int)",
   "long = g_value_get_int64(GtkOpaque)",
   "gtk_entry_buffer_set_max_length(GObject,int)",
   "gtk_print_settings_set_default_source(GObject,string)",
   "g_cancellable_disconnect(GtkOpaque,ulong)",
   "g_date_set_dmy(GDate,uchar,int,ushort)",
   "int = g_action_get_enabled(GtkOpaque)",
   "Cairo = pango_cairo_context_get_font_options(GtkOpaque)",
   "g_value_set_flags(GtkOpaque,uint)",
   "GtkOpaque = g_memory_settings_backend_new()",
   "gdk_window_fullscreen(GObject)",
   "GObject = gtk_tree_row_reference_get_model(GtkTreeRowReference)",
   "ulong = gdk_frame_timings_get_type()",
   "g_network_service_set_scheme(GtkOpaque,string)",
   "int = gtk_tool_shell_get_relief_style(GObject)",
   "int = gtk_print_operation_get_status(GObject)",
   "Cairo = gdk_window_get_update_area(GObject)",
   "GObject = gdk_cursor_new_from_surface(GObject,Cairo,double,double)",
   "gdk_event_put(GdkEvent)",
   "string = gdk_pixbuf_format_get_name(GtkOpaque)",
   "gtk_window_group_remove_window(GObject,GtkWidget)",
   "gtk_cell_editable_start_editing(GObject,GdkEvent)",
   "uchar = gtk_clipboard_wait_for_rich_text(GObject,GObject,GObject[])",
   "int = g_mount_is_shadowed(GtkOpaque)",
   "gtk_menu_set_screen(GtkWidget,GObject)",
   "pango_font_description_set_variant(GtkOpaque,int)",
   "gdk_pixbuf_scale(GdkPixbuf,GdkPixbuf,int,int,int,int,double,double,double,double,int)",
   "ulong = g_menu_link_iter_get_type()",
   "GtkOpaque = g_zlib_decompressor_new(int)",
   "GRegex = g_match_info_get_regex(GMatchInfo)",
   "GdkPixbuf = gtk_text_iter_get_pixbuf(GtkTextIter)",
   "g_variant_builder_clear(GVariantBuilder)",
   "int = gtk_calendar_get_day_is_marked(GtkWidget,uint)",
   "uint = pango_font_description_hash(GtkOpaque)",
   "string = g_resolver_lookup_by_address(GtkOpaque,GObject,GtkOpaque)",
   "GtkWidget = gtk_tool_palette_get_drag_item(GtkWidget,GtkSelectionData)",
   "ulong = gtk_text_tag_get_type()",
   "int = gdk_device_get_n_axes(GdkDevice)",
   "gtk_gesture_single_set_touch_only(GObject,int)",
   "ushort = g_inet_socket_address_get_port(GtkOpaque)",
   "GObject = gdk_display_get_default_seat(GObject)",
   "int = gtk_window_mnemonic_activate(GtkWidget,uint,int)",
   "GtkTextAttributes = gtk_text_view_get_default_attributes(GtkWidget)",
   "PangoLayoutLine = pango_layout_line_ref(PangoLayoutLine)",
   "g_bookmark_file_set_modified(GBookmarkFile,string,ulong)",
   "ulong = gdk_modifier_type_get_type()",
   "gtk_tree_selection_select_iter(GObject,GtkTreeIter)",
   "double = gtk_page_setup_get_top_margin(GObject,int)",
   "ulong = gdk_event_type_get_type()",
   "ulong = gtk_gesture_get_type()",
   "ulong = g_value_get_gtype(GtkOpaque)",
   "int = g_type_add_instance_private(ulong,ulong)",
   "GtkWidget = gtk_label_get_mnemonic_widget(GtkWidget)",
   "ulong = gdk_setting_action_get_type()",
   "ulong = gtk_accel_group_get_type()",
   "int = gtk_scrolled_window_get_propagate_natural_width(GtkWidget)",
   "gtk_text_iter_set_line_index(GtkTextIter,int)",
   "ulong = gtk_orientable_get_type()",
   "Cairo = gtk_icon_theme_load_surface(GObject,string,int,int,GObject,int)",
   "int = g_source_is_destroyed(GSource)",
   "gtk_flow_box_insert(GtkWidget,GtkWidget,int)",
   "(double,double) = gdk_device_get_position_double(GdkDevice,GObject[])",
   "GtkWidget = gtk_widget_get_tooltip_window(GtkWidget)",
   "int = gtk_tree_selection_path_is_selected(GObject,GtkTreePath)",
   "gtk_print_settings_set_orientation(GObject,int)",
   "(int,int,int) = pango_layout_xy_to_index(GtkOpaque,int,int)",
   "g_value_set_uint(GtkOpaque,uint)",
   "gtk_layout_set_size(GtkWidget,uint,uint)",
   "uint = g_unichar_totitle(uint)",
   "string = g_variant_get_objv(GVariant)",
   "ulong = gtk_info_bar_get_type()",
   "GtkOpaque = pango_language_from_string(string)",
   "gtk_flow_box_unselect_child(GtkWidget,GtkWidget)",
   "GtkOpaque = pango_attr_scale_new(double)",
   "string = g_drive_enumerate_identifiers(GtkOpaque)",
   "gtk_box_pack_start(GtkWidget,GtkWidget,int,int,uint)",
   "gtk_tree_view_set_headers_clickable(GtkWidget,int)",
   "uint = g_inet_socket_address_get_flowinfo(GtkOpaque)",
   "GtkOpaque = g_file_replace(GtkOpaque,string,int,int,GtkOpaque)",
   "ulong = g_binding_get_type()",
   "gtk_recent_filter_add_mime_type(GObject,string)",
   "long = gdk_frame_timings_get_frame_time(GdkFrameTimings)",
   "int = gtk_widget_get_valign_with_baseline(GtkWidget)",
   "GtkWidget = gtk_offscreen_window_new()",
   "pango_tab_array_set_tab(PangoTabArray,int,int,int)",
   "GtkTextIter = gtk_text_iter_copy(GtkTextIter)",
   "int = gtk_text_view_get_bottom_margin(GtkWidget)",
   "uint = gtk_recent_manager_error_quark()",
   "uint = gtk_gesture_single_get_current_button(GObject)",
   "gtk_style_context_add_provider_for_screen(GObject,GObject,uint)",
   "GtkTextIter = gtk_text_buffer_get_end_iter(GObject)",
   "PangoScriptIter = pango_script_iter_new(string,int)",
   "string = g_network_service_get_service(GtkOpaque)",
   "gtk_cell_view_set_draw_sensitive(GtkWidget,int)",
   "gdk_drag_find_window_for_screen(GObject,GObject,GObject,int,int,GObject[],int[])",
   "g_value_copy(GtkOpaque,GtkOpaque)",
   "gtk_spin_button_set_adjustment(GtkWidget,GObject)",
   "GObject = g_file_monitor_directory(GtkOpaque,int,GtkOpaque)",
   "gtk_tree_view_scroll_to_point(GtkWidget,int,int)",
   "gdk_window_begin_resize_drag(GObject,int,int,int,int,uint)",
   "ulong = gtk_shortcut_label_get_type()",
   "gtk_statusbar_remove_all(GtkWidget,uint)",
   "GtkWidget = gtk_info_bar_add_button(GtkWidget,string,int)",
   "string = g_strsplit(string,string,int)",
   "(GObject,int,int) = gdk_display_get_window_at_pointer(GObject)",
   "int = gdk_monitor_get_height_mm(GObject)",
   "string = g_content_type_from_mime_type(string)",
   "GtkBorder = gtk_style_context_get_padding(GObject,int)",
   "string = g_settings_list_relocatable_schemas()",
   "string = gtk_menu_get_title(GtkWidget)",
   "g_value_set_uchar(GtkOpaque,uchar)",
   "GObject = gtk_tool_shell_get_text_size_group(GObject)",
   "GtkWidget = gtk_search_entry_new()",
   "int = g_key_file_load_from_bytes(GKeyFile,GBytes,int)",
   "string = pango_font_family_get_name(GtkOpaque)",
   "ulong = gtk_layout_get_type()",
   "GtkOpaque = g_emblemed_icon_new(GtkOpaque,GObject)",
   "int = gtk_tree_view_get_show_expanders(GtkWidget)",
   "GDateTime = g_date_time_add_hours(GDateTime,int)",
   "GtkOpaque = gdk_list_visuals()",
   "pango_layout_set_indent(GtkOpaque,int)",
   "g_settings_unbind(GtkOpaque,string)",
   "string = g_file_info_get_etag(GObject)",
   "gtk_about_dialog_set_translator_credits(GtkWidget,string)",
   "GObject = g_socket_new_from_fd(int)",
   "int = gtk_printer_accepts_pdf(GObject)",
   "GObject = gdk_cursor_get_display(GObject)",
   "int = g_value_get_enum(GtkOpaque)",
   "ulong = g_simple_proxy_resolver_get_type()",
   "ulong = gtk_menu_bar_get_type()",
   "GVariant = g_menu_attribute_iter_get_value(GObject)",
   "int = g_regex_get_max_backref(GRegex)",
   "int = gdk_pixbuf_animation_iter_advance(GObject,struct)",
   "GtkWidget = gtk_text_view_new_with_buffer(GObject)",
   "int = gdk_window_get_modal_hint(GObject)",
   "gtk_native_dialog_set_modal(GtkWidget,int)",
   "gtk_entry_set_input_purpose(GtkWidget,int)",
   "GtkOpaque = gtk_recent_chooser_get_items(GObject)",
   "GSource = g_child_watch_source_new(int)",
   "GDateTime = g_date_time_add_full(GDateTime,int,int,int,int,int,double)",
   "int = gdk_pixbuf_animation_get_width(GObject)",
   "GDateTime = g_date_time_add_years(GDateTime,int)",
   "ulong = g_network_address_get_type()",
   "pango_layout_set_line_spacing(GtkOpaque,float)",
   "gtk_file_chooser_set_create_folders(GObject,int)",
   "g_main_context_dispatch(GMainContext)",
   "(int,int) = gtk_window_get_position(GtkWidget)",
   "GtkOpaque = g_volume_monitor_get_connected_drives(GObject)",
   "int = g_settings_get_has_unapplied(GtkOpaque)",
   "GtkOpaque = g_file_info_get_symbolic_icon(GObject)",
   "pango_script_iter_get_range(PangoScriptIter,string[],string[],int[])",
   "GdkPixbuf = gdk_pixbuf_scale_simple(GdkPixbuf,int,int,int)",
   "gdk_pixbuf_format_free(GtkOpaque)",
   "int = gtk_widget_get_valign(GtkWidget)",
   "uint = g_quark_from_string(string)",
   "int = g_mount_can_eject(GtkOpaque)",
   "GdkDevice = gtk_gesture_get_device(GObject)",
   "g_simple_action_set_state(GtkOpaque,GVariant)",
   "int = g_socket_get_fd(GObject)",
   "GtkOpaque = pango_attr_underline_color_new(ushort,ushort,ushort)",
   "ulong = gdk_touchpad_gesture_phase_get_type()",
   "gtk_widget_path_iter_set_name(GtkWidgetPath,int,string)",
   "GObject = gtk_print_settings_copy(GObject)",
   "g_set_prgname(string)",
   "g_menu_append_submenu(GObject,string,GObject)",
   "GtkWidget = gtk_radio_button_new_with_mnemonic_from_widget(GtkWidget,string)",
   "int = gtk_text_view_get_accepts_tab(GtkWidget)",
   "gtk_widget_show(GtkWidget)",
   "GIOChannel = g_io_channel_ref(GIOChannel)",
   "gtk_page_setup_set_left_margin(GObject,double,int)",
   "GVariant = g_variant_get_normal_form(GVariant)",
   "GtkOpaque = gtk_css_section_ref(GtkOpaque)",
   "gtk_tool_palette_set_drag_source(GtkWidget,int)",
   "gtk_entry_set_overwrite_mode(GtkWidget,int)",
   "gtk_icon_view_set_reorderable(GtkWidget,int)",
   "GtkWidget = gtk_notebook_new()",
   "gtk_menu_set_accel_path(GtkWidget,string)",
   "GtkWidget = gtk_menu_tool_button_new(GtkWidget,string)",
   "g_unsetenv(string)",
   "uint = g_utf8_get_char(string)",
   "GtkWidget = gtk_level_bar_new_for_interval(double,double)",
   "int = g_file_monitor_is_cancelled(GObject)",
   "GObject = g_file_query_filesystem_info_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_tree_view_expand_row(GtkWidget,GtkTreePath,int)",
   "g_mount_operation_set_password(GObject,string)",
   "gtk_widget_queue_draw(GtkWidget)",
   "string = g_get_language_names_with_category(string)",
   "string = g_uuid_string_random()",
   "GObject = gdk_gl_context_get_current()",
   "gtk_widget_pop_composite_child()",
   "ulong = g_mapped_file_get_length(GMappedFile)",
   "ulong = gtk_application_window_get_type()",
   "ulong = gtk_tool_button_get_type()",
   "int = gtk_tool_item_get_text_orientation(GtkWidget)",
   "ulong = pango_script_iter_get_type()",
   "GtkTreePath = gtk_tree_model_sort_convert_path_to_child_path(GObject,GtkTreePath)",
   "int = gtk_text_view_im_context_filter_keypress(GtkWidget,GObject)",
   "gtk_container_child_notify(GtkWidget,GtkWidget,string)",
   "ulong = pango_color_get_type()",
   "int = g_file_set_attribute_uint64(GtkOpaque,string,ulong,int,GtkOpaque)",
   "int = g_app_info_launch_uris_finish(GtkOpaque,GtkOpaque)",
   "uint = gtk_get_major_version()",
   "GtkTextIter = gtk_text_buffer_get_iter_at_line_offset(GObject,int,int)",
   "int = pango_layout_get_single_paragraph_mode(GtkOpaque)",
   "string = gtk_print_job_get_title(GObject)",
   "(ulong,ulong,ulong) = g_file_measure_disk_usage_finish(GtkOpaque,GtkOpaque)",
   "gtk_label_set_text_with_mnemonic(GtkWidget,string)",
   "int = gtk_search_bar_get_search_mode(GtkWidget)",
   "gtk_popover_set_relative_to(GtkWidget,GtkWidget)",
   "GtkOpaque = g_settings_schema_source_get_default()",
   "double = gtk_adjustment_get_step_increment(GObject)",
   "int = gdk_screen_width_mm()",
   "int = gtk_scrolled_window_get_shadow_type(GtkWidget)",
   "int = gtk_text_view_scroll_to_iter(GtkWidget,GtkTextIter,double,int,double,double)",
   "gtk_text_tag_changed(GObject,int)",
   "int = gtk_tree_view_column_get_sort_order(GtkWidget)",
   "GObject = gtk_print_unix_dialog_get_settings(GtkWidget)",
   "uint = g_number_parser_error_quark()",
   "int = g_app_info_launch(GtkOpaque,GtkOpaque[],GObject)",
   "ulong = g_pointer_type_register_static(string)",
   "int = gdk_event_get_scroll_direction(GdkEvent)",
   "gtk_tool_item_set_use_drag_window(GtkWidget,int)",
   "int = gtk_gesture_handles_sequence(GObject,GtkOpaque)",
   "int = gtk_text_view_get_pixels_above_lines(GtkWidget)",
   "int = gdk_event_get_pointer_emulated(GdkEvent)",
   "int = g_source_remove(uint)",
   "float = gtk_label_get_xalign(GtkWidget)",
   "gtk_scrolled_window_set_policy(GtkWidget,int,int)",
   "int = gdk_window_get_decorations(GObject,int[])",
   "GtkOpaque = g_file_find_enclosing_mount(GtkOpaque,GtkOpaque)",
   "int = g_date_get_month(GDate)",
   "GtkOpaque = pango_context_load_font(GtkOpaque,GtkOpaque)",
   "gtk_render_check(GObject,Cairo,double,double,double,double)",
   "string = g_utf16_to_utf8(ushort[],long,long[])",
   "GObject = gtk_cell_area_get_edit_widget(GObject)",
   "int = g_date_valid_year(ushort)",
   "int = pango_context_get_base_gravity(GtkOpaque)",
   "uint = gtk_css_section_get_start_position(GtkOpaque)",
   "gdk_screen_set_font_options(GObject,Cairo)",
   "gtk_tree_view_column_set_sizing(GtkWidget,int)",
   "string = g_file_get_basename(GtkOpaque)",
   "uint = gdk_keyval_to_lower(uint)",
   "gtk_text_view_set_top_margin(GtkWidget,int)",
   "pango_renderer_activate(GtkOpaque)",
   "gtk_print_operation_preview_render_page(GObject,int)",
   "pango_coverage_unref(PangoCoverage)",
   "int = gtk_text_iter_get_visible_line_offset(GtkTextIter)",
   "gtk_application_set_menubar(GObject,GObject)",
   "GObject = g_resource_open_stream(GtkOpaque,string,int)",
   "gtk_stack_add_titled(GtkWidget,GtkWidget,string,string)",
   "ulong = g_zlib_decompressor_get_type()",
   "string = gtk_assistant_get_page_title(GtkWidget,GtkWidget)",
   "GdkEvent = gdk_event_peek()",
   "int = g_vfs_unregister_uri_scheme(GtkOpaque,string)",
   "int = g_vfs_is_active(GtkOpaque)",
   "g_main_loop_quit(GMainLoop)",
   "gdk_init(int[],gchar_ptr_ptr_ptr)",
   "int = gtk_text_iter_starts_line(GtkTextIter)",
   "g_date_set_day(GDate,uchar)",
   "GtkWidget = gtk_combo_box_new_with_area(GObject)",
   "gtk_list_box_set_selection_mode(GtkWidget,int)",
   "g_mount_operation_set_pim(GObject,uint)",
   "gtk_propagate_event(GtkWidget,GdkEvent)",
   "gtk_scale_clear_marks(GtkWidget)",
   "int = gtk_recent_manager_remove_item(GObject,string)",
   "int = g_socket_is_connected(GObject)",
   "int = gdk_selection_owner_set(GObject,GObject,uint,int)",
   "gtk_adjustment_set_page_size(GObject,double)",
   "g_object_unref(GtkOpaque)",
   "int = gtk_size_group_get_ignore_hidden(GObject)",
   "ulong = gtk_radio_tool_button_get_type()",
   "int = g_unichar_isprint(uint)",
   "int = g_regex_get_compile_flags(GRegex)",
   "gtk_cairo_transform_to_window(Cairo,GtkWidget,GObject)",
   "ulong = g_signal_connect_closure_by_id(GtkOpaque,uint,uint,GtkOpaque,int)",
   "uint = gtk_css_section_get_end_line(GtkOpaque)",
   "g_date_clear(GDate,uint)",
   "(int,int) = gtk_scale_get_layout_offsets(GtkWidget)",
   "gtk_print_settings_set_collate(GObject,int)",
   "ulong = gtk_recent_manager_get_type()",
   "int = gtk_window_activate_default(GtkWidget)",
   "gtk_tool_item_group_insert(GtkWidget,GtkWidget,int)",
   "string = gtk_font_chooser_get_font(GObject)",
   "GObject = gdk_gl_context_get_window(GObject)",
   "int = gtk_icon_view_get_activate_on_single_click(GtkWidget)",
   "int = g_time_zone_get_offset(GTimeZone,int)",
   "ulong = g_menu_get_type()",
   "gtk_cell_renderer_toggle_set_active(GObject,int)",
   "gtk_widget_set_default_direction(int)",
   "gtk_container_set_border_width(GtkWidget,uint)",
   "g_object_notify(GObject,string)",
   "int = g_file_info_get_attribute_status(GObject,string)",
   "int = g_type_check_is_value_type(ulong)",
   "int = g_variant_type_string_scan(string,string,string[])",
   "GTimeZone = g_time_zone_new_utc()",
   "uchar = g_date_get_days_in_month(int,ushort)",
   "(Cairo,double,double) = gdk_cursor_get_surface(GObject)",
   "GtkOpaque = gdk_display_list_devices(GObject)",
   "int = g_settings_set_int64(GtkOpaque,string,long)",
   "ulong = gdk_device_tool_type_get_type()",
   "int = g_value_type_compatible(ulong,ulong)",
   "g_file_attribute_info_list_unref(GtkOpaque)",
   "string = pango_attr_type_get_name(int)",
   "gtk_color_button_set_color(GtkWidget,struct)",
   "int = gtk_tree_model_iter_has_child(GObject,GtkTreeIter)",
   "gtk_print_unix_dialog_set_support_selection(GtkWidget,int)",
   "gtk_icon_view_set_markup_column(GtkWidget,int)",
   "GObject = gtk_event_controller_scroll_new(GtkWidget,int)",
   "int = gdk_drawing_context_is_valid(GObject)",
   "int = gtk_notebook_get_show_border(GtkWidget)",
   "gtk_list_store_move_before(GObject,GtkTreeIter,GtkTreeIter)",
   "GObject = gtk_window_get_group(GtkWidget)",
   "gtk_drag_unhighlight(GtkWidget)",
   "GtkOpaque = g_file_create_finish(GtkOpaque,GtkOpaque)",
   "string = g_str_to_ascii(string,string)",
   "gtk_popover_set_transitions_enabled(GtkWidget,int)",
   "uchar = g_value_get_uchar(GtkOpaque)",
   "gtk_list_box_set_activate_on_single_click(GtkWidget,int)",
   "int = gtk_file_chooser_get_create_folders(GObject)",
   "gtk_cell_renderer_toggle_set_activatable(GObject,int)",
   "g_date_clamp(GDate,GDate,GDate)",
   "string = g_dngettext(string,string,string,ulong)",
   "(GtkTextIter,GtkTextIter) = gtk_text_iter_forward_search(GtkTextIter,GtkTextIter)",
   "GtkOpaque = g_inet_address_mask_new_from_string(string)",
   "GtkBorder = gtk_style_context_get_margin(GObject,int)",
   "g_source_set_priority(GSource,int)",
   "string = gtk_expander_get_label(GtkWidget)",
   "int = gtk_text_iter_backward_cursor_positions(GtkTextIter,int)",
   "g_settings_apply(GtkOpaque)",
   "int = pango_is_zero_width(uint)",
   "int = gdk_pixbuf_remove_option(GdkPixbuf,string)",
   "GObject = g_menu_item_new(string,string)",
   "long = g_socket_send_with_blocking(GObject,string,ulong,int,GtkOpaque)",
   "gdk_window_set_source_events(GObject,int,int)",
   "int = gtk_combo_box_get_wrap_width(GtkWidget)",
   "g_type_default_interface_unref(GtkOpaque)",
   "double = g_value_get_double(GtkOpaque)",
   "gtk_window_present_with_time(GtkWidget,uint)",
   "int = gdk_display_has_pending(GObject)",
   "int = gtk_tree_view_get_grid_lines(GtkWidget)",
   "GObject = g_file_query_info(GtkOpaque,string,int,GtkOpaque)",
   "int = g_unichar_isalpha(uint)",
   "string = gtk_about_dialog_get_translator_credits(GtkWidget)",
   "gtk_tree_sortable_set_sort_column_id(GObject,int,int)",
   "gtk_cell_area_box_set_spacing(GObject,int)",
   "int = gtk_label_get_line_wrap_mode(GtkWidget)",
   "int = g_file_load_partial_contents_finish(GtkOpaque,GtkOpaque,string[],string[])",
   "GtkTextAttributes = gtk_text_attributes_new()",
   "int = g_app_info_launch_default_for_uri(string,GObject)",
   "gtk_text_attributes_unref(GtkTextAttributes)",
   "gtk_window_set_wmclass(GtkWidget,string,string)",
   "int = gtk_widget_get_modifier_mask(GtkWidget,int)",
   "int = gtk_print_settings_get_page_set(GObject)",
   "int = g_volume_eject_with_operation_finish(GtkOpaque,GtkOpaque)",
   "GObject = gdk_display_manager_get_default_display(GObject)",
   "GVariant = g_variant_new_byte(uchar)",
   "int = gtk_gesture_single_get_touch_only(GObject)",
   "int = gtk_widget_get_hexpand_set(GtkWidget)",
   "gtk_expander_set_resize_toplevel(GtkWidget,int)",
   "int = gtk_grid_get_column_homogeneous(GtkWidget)",
   "GtkOpaque = g_file_attribute_matcher_new(string)",
   "g_checksum_free(GChecksum)",
   "gtk_event_box_set_above_child(GtkWidget,int)",
   "int = gtk_false()",
   "pango_attr_list_insert(PangoAttrList,GtkOpaque)",
   "gtk_entry_completion_set_inline_completion(GObject,int)",
   "gtk_aspect_frame_set(GtkWidget,float,float,float,int)",
   "string = g_content_type_guess_for_tree(GtkOpaque)",
   "g_file_info_set_attribute_boolean(GObject,string,int)",
   "int = gdk_screen_get_monitor_height_mm(GObject,int)",
   "pango_layout_set_ellipsize(GtkOpaque,int)",
   "GVariant = gtk_actionable_get_action_target_value(GObject)",
   "GObject = g_file_monitor_file(GtkOpaque,int,GtkOpaque)",
   "gtk_menu_set_title(GtkWidget,string)",
   "int = gtk_file_chooser_add_shortcut_folder(GObject,string)",
   "g_key_file_unref(GKeyFile)",
   "gdk_notify_startup_complete()",
   "GtkTextIter = gtk_text_buffer_get_iter_at_child_anchor(GObject,GObject)",
   "int = gtk_popover_get_constrain_to(GtkWidget)",
   "GtkWidget = gtk_accessible_get_widget(GObject)",
   "GtkOpaque = gtk_tree_view_get_columns(GtkWidget)",
   "GtkOpaque = gtk_file_chooser_get_filenames(GObject)",
   "GDateTime = g_date_time_add(GDateTime,long)",
   "gtk_widget_set_device_enabled(GtkWidget,GdkDevice,int)",
   "int = g_settings_set_enum(GtkOpaque,string,int)",
   "GObject = g_socket_accept(GObject,GtkOpaque)",
   "ulong = g_type_fundamental_next()",
   "GObject = gdk_event_get_seat(GdkEvent)",
   "uint = gtk_statusbar_get_context_id(GtkWidget,string)",
   "int = gtk_widget_get_child_visible(GtkWidget)",
   "GtkWidget = gtk_dialog_get_action_area(GtkWidget)",
   "gtk_button_set_focus_on_click(GtkWidget,int)",
   "int = g_file_trash_finish(GtkOpaque,GtkOpaque)",
   "gtk_progress_bar_set_ellipsize(GtkWidget,int)",
   "GtkOpaque = g_resolver_lookup_records(GtkOpaque,string,int,GtkOpaque)",
   "gdk_window_move_resize(GObject,int,int,int,int)",
   "gtk_recent_chooser_set_filter(GObject,GObject)",
   "g_bookmark_file_set_title(GBookmarkFile,string,string)",
   "string = pango_version_check(int,int,int)",
   "gtk_entry_completion_set_text_column(GObject,int)",
   "int = gtk_text_iter_forward_visible_lines(GtkTextIter,int)",
   "gtk_viewport_set_shadow_type(GtkWidget,int)",
   "gtk_info_bar_set_revealed(GtkWidget,int)",
   "int = pango_attribute_equal(GtkOpaque,GtkOpaque)",
   "GtkWidget = gtk_tool_item_group_get_label_widget(GtkWidget)",
   "int = gdk_window_get_fullscreen_mode(GObject)",
   "ulong = gtk_gesture_multi_press_get_type()",
   "string = g_mount_guess_content_type_sync(GtkOpaque,int,GtkOpaque)",
   "GObject = gtk_text_tag_table_new()",
   "gtk_widget_set_margin_left(GtkWidget,int)",
   "int = g_file_delete_finish(GtkOpaque,GtkOpaque)",
   "PangoLayoutLine = pango_renderer_get_layout_line(GtkOpaque)",
   "GdkFrameTimings = gdk_frame_clock_get_timings(GObject,long)",
   "int = gdk_pixbuf_get_has_alpha(GdkPixbuf)",
   "GtkOpaque = g_resolver_lookup_by_name_with_flags(GtkOpaque,string,int,GtkOpaque)",
   "g_file_monitor_set_rate_limit(GObject,int)",
   "string = g_utf8_strreverse(string,long)",
   "GtkOpaque = gtk_text_iter_get_marks(GtkTextIter)",
   "pango_renderer_deactivate(GtkOpaque)",
   "gtk_box_set_child_packing(GtkWidget,GtkWidget,int,int,uint,int)",
   "GtkWidget = gtk_progress_bar_new()",
   "GtkWidget = gtk_flow_box_child_new()",
   "gtk_text_buffer_delete(GObject,GtkTextIter,GtkTextIter)",
   "int = gtk_expander_get_spacing(GtkWidget)",
   "int = gtk_printer_is_default(GObject)",
   "GtkOpaque = g_type_create_instance(ulong)",
   "int = gtk_file_chooser_get_use_preview_label(GObject)",
   "string = gdk_device_get_name(GdkDevice)",
   "GtkOpaque = g_file_new_tmp(string,GtkOpaque[])",
   "string = g_file_info_get_attribute_string(GObject,string)",
   "int = gtk_recent_info_is_local(GObject)",
   "g_type_add_interface_dynamic(ulong,ulong,GtkOpaque)",
   "gtk_dialog_set_alternative_button_order_from_array(GtkWidget,int,int[])",
   "int = g_date_time_is_daylight_savings(GDateTime)",
   "int = gtk_widget_get_margin_right(GtkWidget)",
   "gtk_text_buffer_set_text(GObject,string)",
   "GtkWidget = gtk_box_new(int,int)",
   "GObject = g_credentials_new()",
   "uint = g_unichar_tolower(uint)",
   "ulong = pango_layout_line_get_type()",
   "GtkOpaque = gtk_text_child_anchor_get_widgets(GObject)",
   "int = gtk_tree_view_get_rules_hint(GtkWidget)",
   "int = g_date_time_get_day_of_week(GDateTime)",
   "double = gtk_print_context_get_width(GObject)",
   "GtkOpaque = gtk_style_context_get_font(GObject,int)",
   "GObject = gtk_scrolled_window_get_vadjustment(GtkWidget)",
   "string = gtk_about_dialog_get_website_label(GtkWidget)",
   "(double,double) = gdk_event_get_root_coords(GdkEvent)",
   "int = gdk_pixbuf_savev(GdkPixbuf,string,string,string[],string[])",
   "string = gtk_widget_path_iter_get_name(GtkWidgetPath,int)",
   "string = gtk_window_get_role(GtkWidget)",
   "gtk_print_job_set_pages(GObject,int)",
   "gtk_file_chooser_remove_filter(GObject,GObject)",
   "gtk_entry_reset_im_context(GtkWidget)",
   "GObject = gtk_print_settings_new_from_key_file(GKeyFile,string)",
   "GtkOpaque = gtk_window_list_toplevels()",
   "ulong = gtk_scale_button_get_type()",
   "uint = g_rand_int(GRand)",
   "g_bookmark_file_set_description(GBookmarkFile,string,string)",
   "int = gtk_tree_selection_get_mode(GObject)",
   "long = g_file_info_get_attribute_int64(GObject,string)",
   "int = gtk_selection_owner_set_for_display(GObject,GtkWidget,GObject,uint)",
   "ulong = gtk_combo_box_get_type()",
   "gtk_menu_shell_set_take_focus(GtkWidget,int)",
   "gtk_window_set_attached_to(GtkWidget,GtkWidget)",
   "ulong = g_action_map_get_type()",
   "gtk_cell_area_set_focus_cell(GObject,GObject)",
   "gtk_menu_shell_append(GtkWidget,GtkWidget)",
   "gtk_print_settings_set_paper_height(GObject,double,int)",
   "GtkWidget = gtk_popover_get_relative_to(GtkWidget)",
   "int = g_variant_type_equal(GtkOpaque,GtkOpaque)",
   "(string,int) = gtk_image_get_icon_name(GtkWidget)",
   "GObject = gdk_pixbuf_loader_new_with_mime_type(string)",
   "ulong = gdk_visual_type_get_type()",
   "gtk_cell_renderer_render(GObject,Cairo,GtkWidget,struct,struct,int)",
   "gtk_tool_item_group_set_header_relief(GtkWidget,int)",
   "ulong = gtk_css_provider_get_type()",
   "g_object_set_qdata(GObject,uint,GtkOpaque)",
   "pango_tab_array_get_tabs(PangoTabArray,PangoTabAlign_ptr_ptr,gint_ptr_ptr)",
   "string = gtk_shortcut_label_get_disabled_text(GtkWidget)",
   "GObject = gtk_window_group_new()",
   "pango_layout_iter_free(PangoLayoutIter)",
   "gtk_clipboard_set_text(GObject,string,int)",
   "ulong = gtk_stack_sidebar_get_type()",
   "int = g_utf8_collate(string,string)",
   "int = gdk_screen_get_monitor_at_point(GObject,int,int)",
   "GdkEvent = gtk_gesture_get_last_event(GObject,GtkOpaque)",
   "gtk_button_clicked(GtkWidget)",
   "gtk_font_chooser_set_language(GObject,string)",
   "gtk_selection_data_set(GtkSelectionData,GObject,int,uchar[],int)",
   "string = gtk_file_chooser_get_current_name(GObject)",
   "int = g_regex_get_match_flags(GRegex)",
   "GDateTime = g_date_time_new_now(GTimeZone)",
   "g_socket_set_multicast_loopback(GObject,int)",
   "pango_cairo_context_set_resolution(GtkOpaque,double)",
   "int = gtk_text_iter_backward_visible_word_starts(GtkTextIter,int)",
   "GtkWidgetPath = gtk_widget_path_ref(GtkWidgetPath)",
   "gtk_cell_layout_add_attribute(GObject,GObject,string,int)",
   "int = gtk_stack_get_hhomogeneous(GtkWidget)",
   "gtk_widget_set_sensitive(GtkWidget,int)",
   "gtk_spin_button_set_wrap(GtkWidget,int)",
   "gtk_recent_chooser_set_show_private(GObject,int)",
   "string = gdk_pixbuf_format_get_extensions(GtkOpaque)",
   "GdkEvent = gdk_display_get_event(GObject)",
   "gtk_text_view_set_tabs(GtkWidget,PangoTabArray)",
   "gtk_cell_layout_reorder(GObject,GObject,int)",
   "GtkWidget = gtk_menu_button_get_align_widget(GtkWidget)",
   "gtk_tool_palette_set_expand(GtkWidget,GtkWidget,int)",
   "GdkPixbuf = gtk_icon_info_get_builtin_pixbuf(GObject)",
   "int = gtk_text_buffer_backspace(GObject,GtkTextIter,int,int)",
   "string = gtk_combo_box_get_active_id(GtkWidget)",
   "int = gtk_orientable_get_orientation(GObject)",
   "gtk_entry_set_width_chars(GtkWidget,int)",
   "gtk_header_bar_set_custom_title(GtkWidget,GtkWidget)",
   "int = gtk_paned_get_wide_handle(GtkWidget)",
   "g_type_add_class_private(ulong,ulong)",
   "gtk_widget_path_unref(GtkWidgetPath)",
   "string = gtk_progress_bar_get_text(GtkWidget)",
   "gtk_layout_set_vadjustment(GtkWidget,GObject)",
   "g_simple_action_set_state_hint(GtkOpaque,GVariant)",
   "int = gtk_mount_operation_is_showing(GObject)",
   "string = g_value_dup_string(GtkOpaque)",
   "gtk_window_set_skip_taskbar_hint(GtkWidget,int)",
   "gtk_print_settings_set_scale(GObject,double)",
   "GtkOpaque = g_mount_get_symbolic_icon(GtkOpaque)",
   "GObject = gtk_widget_get_frame_clock(GtkWidget)",
   "g_value_set_ulong(GtkOpaque,ulong)",
   "string = g_network_address_get_hostname(GtkOpaque)",
   "gtk_widget_queue_draw_area(GtkWidget,int,int,int,int)",
   "GtkOpaque = g_file_query_default_handler_finish(GtkOpaque,GtkOpaque)",
   "gtk_widget_shape_combine_region(GtkWidget,Cairo)",
   "PangoTabArray = pango_tab_array_copy(PangoTabArray)",
   "GObject = gtk_widget_get_screen(GtkWidget)",
   "g_action_change_state(GtkOpaque,GVariant)",
   "gtk_menu_popup_at_widget(GtkWidget,GtkWidget,int,int,GdkEvent)",
   "int = g_input_stream_set_pending(GObject)",
   "gtk_entry_progress_pulse(GtkWidget)",
   "GObject = gtk_gesture_get_window(GObject)",
   "int = gtk_selection_data_set_uris(GtkSelectionData,string[])",
   "int = gtk_flow_box_get_activate_on_single_click(GtkWidget)",
   "string = g_hostname_to_unicode(string)",
   "GtkOpaque = g_file_icon_new(GtkOpaque)",
   "int = gtk_scale_get_digits(GtkWidget)",
   "g_time_zone_unref(GTimeZone)",
   "gtk_color_chooser_set_rgba(GObject,struct)",
   "Cairo = gdk_drawing_context_get_clip(GObject)",
   "ulong = gdk_prop_mode_get_type()",
   "gtk_drag_dest_unset(GtkWidget)",
   "g_main_loop_unref(GMainLoop)",
   "int = g_file_make_directory(GtkOpaque,GtkOpaque)",
   "gtk_window_set_titlebar(GtkWidget,GtkWidget)",
   "int = g_match_info_is_partial_match(GMatchInfo)",
   "uint = gdk_display_get_default_cursor_size(GObject)",
   "string = gtk_about_dialog_get_copyright(GtkWidget)",
   "string = g_resources_enumerate_children(string,int)",
   "int = gtk_widget_path_is_type(GtkWidgetPath,ulong)",
   "g_usleep(ulong)",
   "int = g_cancellable_make_pollfd(GtkOpaque,GtkOpaque)",
   "gtk_text_buffer_add_mark(GObject,GObject,GtkTextIter)",
   "GObject = g_volume_monitor_get()",
   "gtk_tool_item_set_expand(GtkWidget,int)",
   "GdkRGBA = gtk_color_chooser_get_rgba(GObject)",
   "ulong = g_filename_completer_get_type()",
   "(int,int) = gtk_cell_area_context_get_preferred_height_for_width(GObject,int)",
   "int = g_emblem_get_origin(GObject)",
   "gtk_scrolled_window_add_with_viewport(GtkWidget,GtkWidget)",
   "string = g_key_file_get_keys(GKeyFile,string)",
   "gtk_key_snooper_remove(uint)",
   "gtk_tree_selection_select_range(GObject,GtkTreePath,GtkTreePath)",
   "gtk_scrollable_set_hadjustment(GObject,GObject)",
   "ulong = gdk_gl_context_get_type()",
   "ulong = pango_font_family_get_type()",
   "gtk_widget_set_mapped(GtkWidget,int)",
   "(int,int) = gtk_window_get_size(GtkWidget)",
   "ulong = gdk_input_source_get_type()",
   "int = gtk_spin_button_get_numeric(GtkWidget)",
   "int = gtk_label_get_use_underline(GtkWidget)",
   "uint = gtk_main_level()",
   "GObject = gtk_widget_get_template_child(GtkWidget,ulong,string)",
   "g_timer_destroy(GTimer)",
   "int = gtk_check_menu_item_get_draw_as_radio(GtkWidget)",
   "int = gtk_text_iter_get_line(GtkTextIter)",
   "int = gtk_file_chooser_remove_shortcut_folder_uri(GObject,string)",
   "int = g_unichar_iscntrl(uint)",
   "ulong = gdk_notify_type_get_type()",
   "int = gdk_window_get_width(GObject)",
   "GObject = g_charset_converter_new(string,string)",
   "string = g_get_environ()",
   "GBytes = g_file_load_bytes_finish(GtkOpaque,GtkOpaque,string[])",
   "gtk_text_buffer_delete_mark(GObject,GObject)",
   "int = gtk_expander_get_use_markup(GtkWidget)",
   "gtk_menu_button_set_popover(GtkWidget,GtkWidget)",
   "int = gdk_test_simulate_button(GObject,int,int,uint,int,int)",
   "string = g_get_host_name()",
   "GdkRGBA = gtk_style_context_get_background_color(GObject,int)",
   "gtk_notebook_set_current_page(GtkWidget,int)",
   "ulong = gdk_drawing_context_get_type()",
   "GObject = gtk_spin_button_get_adjustment(GtkWidget)",
   "g_checksum_update(GChecksum,uchar[],long)",
   "gtk_window_set_destroy_with_parent(GtkWidget,int)",
   "int = gtk_text_iter_forward_line(GtkTextIter)",
   "int = g_input_stream_is_closed(GObject)",
   "GtkWidget = gtk_icon_view_new_with_area(GObject)",
   "(GtkOpaque,int,int) = gdk_pixbuf_get_file_info_finish(GtkOpaque)",
   "int = gtk_text_iter_backward_cursor_position(GtkTextIter)",
   "double = gtk_level_bar_get_value(GtkWidget)",
   "ulong = g_themed_icon_get_type()",
   "int = gtk_color_button_get_use_alpha(GtkWidget)",
   "int = gtk_paned_get_position(GtkWidget)",
   "string = pango_font_description_get_family(GtkOpaque)",
   "GObject = gtk_image_get_animation(GtkWidget)",
   "GdkRGBA = gtk_color_button_get_rgba(GtkWidget)",
   "uint = gtk_widget_path_iter_get_sibling_index(GtkWidgetPath,int)",
   "string = g_file_info_get_name(GObject)",
   "int = pango_font_description_get_size(GtkOpaque)",
   "int = gtk_print_settings_get_resolution_y(GObject)",
   "GObject = gdk_window_create_gl_context(GObject)",
   "int = gtk_entry_completion_get_minimum_key_length(GObject)",
   "string = gdk_screen_get_monitor_plug_name(GObject,int)",
   "uint = gdk_event_get_time(GdkEvent)",
   "int = g_date_is_last_of_month(GDate)",
   "int = g_bookmark_file_to_file(GBookmarkFile,string)",
   "gtk_scale_button_set_value(GtkWidget,double)",
   "GObject = gtk_icon_theme_lookup_by_gicon(GObject,GtkOpaque,int,int)",
   "g_menu_freeze(GObject)",
   "int = gdk_drag_context_get_selected_action(GObject)",
   "int = gdk_event_triggers_context_menu(GdkEvent)",
   "GtkWidget = gtk_menu_button_new()",
   "gtk_print_operation_set_unit(GObject,int)",
   "GtkOpaque = pango_attr_font_features_new(string)",
   "float = pango_layout_get_line_spacing(GtkOpaque)",
   "int = gdk_visual_get_visual_type(GObject)",
   "GtkOpaque = pango_font_map_create_context(GtkOpaque)",
   "GtkWidget = gtk_page_setup_unix_dialog_new(string,GtkWidget)",
   "GtkOpaque = g_drive_get_volumes(GtkOpaque)",
   "int = gtk_tree_view_column_get_reorderable(GtkWidget)",
   "int = gdk_window_is_shaped(GObject)",
   "int = gtk_window_get_focus_on_map(GtkWidget)",
   "string = gtk_stack_get_visible_child_name(GtkWidget)",
   "uint = g_unicode_canonical_decomposition(uint,ulong[])",
   "int = gtk_assistant_append_page(GtkWidget,GtkWidget)",
   "gtk_widget_set_margin_bottom(GtkWidget,int)",
   "int = gdk_pixbuf_format_is_disabled(GtkOpaque)",
   "gtk_tool_item_set_is_important(GtkWidget,int)",
   "GtkTreeIter = gtk_list_store_insert_after(GObject,GtkTreeIter)",
   "int = g_str_has_suffix(string,string)",
   "GObject = gtk_widget_get_parent_window(GtkWidget)",
   "int = pango_font_description_get_style(GtkOpaque)",
   "int = g_inet_address_get_is_mc_link_local(GObject)",
   "gtk_label_select_region(GtkWidget,int,int)",
   "GDate = g_date_copy(GDate)",
   "GtkOpaque = g_object_steal_data(GObject,string)",
   "ulong = gdk_window_type_hint_get_type()",
   "GtkWidget = gtk_color_chooser_widget_new()",
   "GtkWidget = gtk_font_button_new()",
   "int = g_file_info_has_attribute(GObject,string)",
   "GtkOpaque = gtk_widget_get_action_group(GtkWidget,string)",
   "double = gtk_page_setup_get_right_margin(GObject,int)",
   "GObject = gdk_device_manager_get_display(GObject)",
   "gtk_widget_queue_allocate(GtkWidget)",
   "ulong = gdk_filter_return_get_type()",
   "int = gtk_print_operation_get_has_selection(GObject)",
   "GObject = gtk_widget_get_style_context(GtkWidget)",
   "gtk_style_context_save(GObject)",
   "int = gtk_text_iter_has_tag(GtkTextIter,GObject)",
   "string = gtk_font_chooser_get_preview_text(GObject)",
   "g_date_add_days(GDate,uint)",
   "string = g_network_service_get_domain(GtkOpaque)",
   "int = gtk_widget_get_scale_factor(GtkWidget)",
   "GBytes = g_variant_get_data_as_bytes(GVariant)",
   "int = gtk_text_view_get_input_hints(GtkWidget)",
   "GObject = gdk_gl_context_get_shared_context(GObject)",
   "uint = g_quark_try_string(string)",
   "int = gtk_text_iter_inside_word(GtkTextIter)",
   "string = gtk_about_dialog_get_license(GtkWidget)",
   "string = gdk_device_get_product_id(GdkDevice)",
   "uint = g_inet_socket_address_get_scope_id(GtkOpaque)",
   "GtkWidget = gtk_tool_button_new_from_stock(string)",
   "GtkWidget = gtk_tool_palette_get_drop_group(GtkWidget,int,int)",
   "string = g_hmac_get_string(GHmac)",
   "int = g_io_channel_set_encoding(GIOChannel,string)",
   "int = gtk_targets_include_text(GObject[],int)",
   "GtkOpaque = g_mount_get_volume(GtkOpaque)",
   "gtk_accel_group_unlock(GObject)",
   "GObject = g_file_monitor(GtkOpaque,int,GtkOpaque)",
   "int = gtk_widget_is_toplevel(GtkWidget)",
   "string = g_variant_dup_bytestring_array(GVariant)",
   "gtk_icon_theme_prepend_search_path(GObject,string)",
   "GtkWidget = gtk_widget_get_parent(GtkWidget)",
   "gtk_print_settings_set_number_up(GObject,int)",
   "gdk_cairo_set_source_pixbuf(Cairo,GdkPixbuf,double,double)",
   "int = gtk_window_get_window_type(GtkWidget)",
   "gdk_window_set_events(GObject,int)",
   "GtkOpaque = gtk_container_get_children(GtkWidget)",
   "(int,int) = gdk_device_get_position(GdkDevice,GObject[])",
   "int = gtk_menu_shell_get_take_focus(GtkWidget)",
   "gdk_window_set_skip_taskbar_hint(GObject,int)",
   "GObject = gtk_entry_get_completion(GtkWidget)",
   "g_timer_start(GTimer)",
   "int = g_file_load_contents_finish(GtkOpaque,GtkOpaque,string[],string[])",
   "gtk_about_dialog_set_copyright(GtkWidget,string)",
   "g_date_order(GDate,GDate)",
   "GdkRectangle = gtk_range_get_range_rect(GtkWidget)",
   "int = gtk_tool_item_get_relief_style(GtkWidget)",
   "gtk_icon_view_set_pixbuf_column(GtkWidget,int)",
   "ulong = pango_ft2_font_map_get_type()",
   "int = gtk_text_iter_starts_sentence(GtkTextIter)",
   "int = gtk_text_iter_backward_visible_line(GtkTextIter)",
   "GObject = gtk_print_operation_get_print_settings(GObject)",
   "int = gtk_text_buffer_insert_interactive(GObject,GtkTextIter,string,int,int)",
   "gtk_recent_chooser_set_show_icons(GObject,int)",
   "int = gtk_text_view_get_wrap_mode(GtkWidget)",
   "int = gdk_screen_get_width_mm(GObject)",
   "double = gtk_paper_size_get_width(GtkPaperSize,int)",
   "GdkDevice = gdk_device_manager_get_client_pointer(GObject)",
   "GtkOpaque = pango_attr_background_new(ushort,ushort,ushort)",
   "gtk_menu_shell_cancel(GtkWidget)",
   "gtk_main()",
   "gtk_pad_controller_set_action(GObject,int,int,int,string,string)",
   "GtkWidget = gtk_stack_switcher_get_stack(GtkWidget)",
   "gtk_widget_init_template(GtkWidget)",
   "gtk_menu_bar_set_pack_direction(GtkWidget,int)",
   "int = gtk_level_bar_get_inverted(GtkWidget)",
   "gtk_style_context_add_provider(GObject,GObject,uint)",
   "string = gtk_window_get_default_icon_name()",
   "gdk_drag_drop(GObject,uint)",
   "GObject = gtk_recent_chooser_get_filter(GObject)",
   "uint = gtk_entry_buffer_get_length(GObject)",
   "GtkOpaque = pango_font_describe_with_absolute_size(GtkOpaque)",
   "gtk_text_view_set_buffer(GtkWidget,GObject)",
   "string = gtk_text_buffer_get_text(GObject,GtkTextIter,GtkTextIter,int)",
   "int = g_drive_has_volumes(GtkOpaque)",
   "string = g_utf8_find_prev_char(string,string)",
   "gtk_widget_set_hexpand_set(GtkWidget,int)",
   "gtk_window_set_hide_titlebar_when_maximized(GtkWidget,int)",
   "int = gtk_text_child_anchor_get_deleted(GObject)",
   "int = g_unichar_get_script(uint)",
   "int = gtk_tree_view_get_headers_visible(GtkWidget)",
   "gtk_grid_remove_row(GtkWidget,int)",
   "GtkTextIter = gtk_text_buffer_get_iter_at_offset(GObject,int)",
   "gtk_tool_item_set_tooltip_markup(GtkWidget,string)",
   "int = gtk_widget_has_grab(GtkWidget)",
   "gtk_text_buffer_unregister_serialize_format(GObject,GObject)",
   "gtk_recent_chooser_add_filter(GObject,GObject)",
   "string = gtk_about_dialog_get_documenters(GtkWidget)",
   "gtk_container_remove(GtkWidget,GtkWidget)",
   "GtkWidget = gtk_toggle_tool_button_new()",
   "int = gtk_widget_remove_accelerator(GtkWidget,GObject,uint,int)",
   "ulong = gtk_cell_layout_get_type()",
   "ulong = gdk_pixbuf_simple_anim_get_type()",
   "int = gtk_tool_item_group_get_header_relief(GtkWidget)",
   "string = g_get_prgname()",
   "gtk_flow_box_child_changed(GtkWidget)",
   "GdkPixbuf = gdk_pixbuf_new_subpixbuf(GdkPixbuf,int,int,int,int)",
   "gdk_window_show(GObject)",
   "g_notification_set_priority(GtkOpaque,int)",
   "GObject = g_binding_get_source(GtkOpaque)",
   "GObject = gtk_invisible_get_screen(GtkWidget)",
   "gtk_tooltip_set_custom(GObject,GtkWidget)",
   "ulong = gtk_tree_view_column_get_type()",
   "int = g_date_valid(GDate)",
   "gdk_pre_parse_libgtk_only()",
   "string = g_key_file_get_groups(GKeyFile)",
   "(double,double) = gdk_event_get_scroll_deltas(GdkEvent)",
   "int = g_drive_has_media(GtkOpaque)",
   "int = gtk_editable_get_position(GObject)",
   "GObject = g_file_info_dup(GObject)",
   "GSource = g_timeout_source_new_seconds(uint)",
   "int = gtk_tool_palette_get_group_position(GtkWidget,GtkWidget)",
   "GtkOpaque = pango_font_description_copy(GtkOpaque)",
   "int = g_utf8_validate_len(string,ulong,string[])",
   "int = gtk_text_iter_forward_lines(GtkTextIter,int)",
   "int = gtk_scrolled_window_get_overlay_scrolling(GtkWidget)",
   "int = g_bookmark_file_load_from_file(GBookmarkFile,string)",
   "string = gtk_about_dialog_get_comments(GtkWidget)",
   "int = g_file_replace_contents(GtkOpaque,string,ulong,string,int,int,string[],GtkOpaque)",
   "gdk_error_trap_pop_ignored()",
   "int = gtk_tree_model_iter_n_children(GObject,GtkTreeIter)",
   "GtkWidget = gtk_action_bar_get_center_widget(GtkWidget)",
   "g_date_subtract_months(GDate,uint)",
   "gtk_file_filter_add_mime_type(GObject,string)",
   "int = gtk_stack_get_homogeneous(GtkWidget)",
   "uchar = gdk_pixbuf_read_pixels(GdkPixbuf)",
   "gtk_widget_unset_state_flags(GtkWidget,int)",
   "int = gtk_range_get_inverted(GtkWidget)",
   "GObject = gdk_selection_owner_get(GObject)",
   "int = gdk_pixbuf_simple_anim_get_loop(GObject)",
   "g_simple_action_set_enabled(GtkOpaque,int)",
   "int = g_bookmark_file_get_is_private(GBookmarkFile,string)",
   "(GObject,int,int,int) = gdk_window_get_device_position(GObject,GdkDevice)",
   "GtkTreePath = gtk_tree_model_filter_convert_path_to_child_path(GObject,GtkTreePath)",
   "gtk_file_filter_set_name(GObject,string)",
   "g_settings_reset(GtkOpaque,string)",
   "int = g_key_file_load_from_file(string,int)",
   "gtk_info_bar_set_show_close_button(GtkWidget,int)",
   "int = g_drive_is_media_check_automatic(GtkOpaque)",
   "gtk_menu_button_set_menu_model(GtkWidget,GObject)",
   "int = gtk_entry_get_visibility(GtkWidget)",
   "int = gtk_widget_get_state(GtkWidget)",
   "double = gtk_adjustment_get_upper(GObject)",
   "Cairo = gdk_offscreen_window_get_surface(GObject)",
   "g_io_channel_set_buffered(GIOChannel,int)",
   "gtk_recent_filter_add_age(GObject,int)",
   "int = gdk_monitor_get_subpixel_layout(GObject)",
   "int = g_file_get_contents(string,string[])",
   "gtk_window_add_accel_group(GtkWidget,GObject)",
   "int = gtk_revealer_get_child_revealed(GtkWidget)",
   "int = gtk_button_box_get_child_non_homogeneous(GtkWidget,GtkWidget)",
   "int = gtk_notebook_get_tab_pos(GtkWidget)",
   "int = g_drive_eject_with_operation_finish(GtkOpaque,GtkOpaque)",
   "gtk_color_chooser_set_use_alpha(GObject,int)",
   "int = g_socket_connect(GObject,GtkOpaque,GtkOpaque)",
   "GVariant = g_variant_new_int16(short)",
   "uint = gtk_css_provider_error_quark()",
   "pango_renderer_set_color(GtkOpaque,int,struct)",
   "g_menu_prepend_item(GObject,GObject)",
   "int = g_date_get_weekday(GDate)",
   "gtk_window_set_default(GtkWidget,GtkWidget)",
   "ulong = g_key_file_get_uint64(GKeyFile,string,string)",
   "GtkOpaque = g_param_spec_ref_sink(GtkOpaque)",
   "int = pango_bidi_type_for_unichar(uint)",
   "GObject = gtk_icon_info_copy(GObject)",
   "uint = gtk_builder_add_objects_from_string(GObject,string,ulong,string[])",
   "int = gtk_recent_chooser_get_show_not_found(GObject)",
   "GtkWidget = gtk_radio_button_new(GtkOpaque[])",
   "int = gtk_text_view_get_right_margin(GtkWidget)",
   "gdk_display_put_event(GObject,GdkEvent)",
   "gtk_progress_bar_set_pulse_step(GtkWidget,double)",
   "int = g_value_fits_pointer(GtkOpaque)",
   "GObject = gtk_range_get_adjustment(GtkWidget)",
   "string = gtk_print_operation_get_status_string(GObject)",
   "string = gdk_rgba_to_string(struct)",
   "(double,double,double) = gtk_hsv_to_rgb(double,double,double)",
   "int = gtk_widget_hide_on_delete(GtkWidget)",
   "gtk_window_unfullscreen(GtkWidget)",
   "string = g_file_info_get_symlink_target(GObject)",
   "(int,ulong) = g_ascii_string_to_unsigned(string,uint,ulong,ulong)",
   "uint = g_regex_error_quark()",
   "g_mount_operation_set_domain(GObject,string)",
   "int = g_unichar_isdigit(uint)",
   "int = gtk_file_chooser_select_uri(GObject,string)",
   "int = g_io_channel_get_buffer_condition(GIOChannel)",
   "g_variant_builder_add_value(GVariantBuilder,GVariant)",
   "int = gtk_recent_manager_has_item(GObject,string)",
   "g_source_remove_child_source(GSource,GSource)",
   "gtk_print_job_set_reverse(GObject,int)",
   "(int,GtkTextIter,int) = gtk_text_view_get_iter_at_position(GtkWidget,int,int)",
   "gtk_print_settings_set_number_up_layout(GObject,int)",
   "GtkWidget = gtk_list_box_row_new()",
   "gtk_grid_set_column_homogeneous(GtkWidget,int)",
   "g_file_info_set_is_symlink(GObject,int)",
   "gtk_event_controller_reset(GObject)",
   "gtk_print_operation_set_embed_page_setup(GObject,int)",
   "GObject = gtk_application_get_app_menu(GObject)",
   "int = g_bookmark_file_has_item(GBookmarkFile,string)",
   "(int,int) = gtk_cell_renderer_get_preferred_width(GObject,GtkWidget)",
   "gtk_message_dialog_format_secondary_text(GtkWidget,string)",
   "int = gtk_places_sidebar_get_show_desktop(GtkWidget)",
   "ulong = gtk_cell_renderer_get_type()",
   "GdkRectangle = gdk_screen_get_monitor_workarea(GObject,int)",
   "g_notification_add_button_with_target_value(GtkOpaque,string,string,GVariant)",
   "gtk_frame_set_label_align(GtkWidget,float,float)",
   "gtk_page_setup_set_paper_size_and_default_margins(GObject,GtkPaperSize)",
   "GtkOpaque = g_settings_new_with_backend(string,GtkOpaque)",
   "gtk_box_set_baseline_position(GtkWidget,int)",
   "gtk_range_set_adjustment(GtkWidget,GObject)",
   "int = gtk_print_operation_run(GObject,int,GtkWidget)",
   "string = g_dgettext(string,string)",
   "GtkTargetList = gtk_text_buffer_get_copy_target_list(GObject)",
   "string = g_file_get_uri_scheme(GtkOpaque)",
   "gtk_cell_area_attribute_connect(GObject,GObject,string,int)",
   "GObject = gtk_tree_model_filter_new(GObject,GtkTreePath)",
   "gtk_list_box_row_set_header(GtkWidget,GtkWidget)",
   "int = gtk_list_box_row_get_selectable(GtkWidget)",
   "gtk_fixed_move(GtkWidget,GtkWidget,int,int)",
   "ulong = gdk_window_edge_get_type()",
   "int = gtk_icon_view_get_markup_column(GtkWidget)",
   "int = gtk_image_get_icon_set(GtkWidget,GtkOpaque[])",
   "int = gtk_entry_completion_get_inline_completion(GObject)",
   "int = gtk_print_job_get_pages(GObject)",
   "GtkTreeRowReference = gtk_tree_row_reference_new(GObject,GtkTreePath)",
   "GtkOpaque = g_simple_action_new(string,GVariantType)",
   "int = gdk_display_pointer_is_grabbed(GObject)",
   "int = gtk_spin_button_get_update_policy(GtkWidget)",
   "gtk_range_set_lower_stepper_sensitivity(GtkWidget,int)",
   "GBytes = g_resource_lookup_data(GtkOpaque,string,int)",
   "(int,int) = gtk_cell_area_context_get_allocation(GObject)",
   "string = gtk_notebook_get_menu_label_text(GtkWidget,GtkWidget)",
   "g_key_file_set_string_list(GKeyFile,string,string,string[])",
   "ulong = gtk_recent_chooser_menu_get_type()",
   "g_file_info_set_attribute_object(GObject,string,GObject)",
   "gtk_stack_switcher_set_stack(GtkWidget,GtkWidget)",
   "gtk_text_view_set_pixels_above_lines(GtkWidget,int)",
   "string = g_listenv()",
   "string = g_variant_dup_strv(GVariant)",
   "ulong = gtk_print_capabilities_get_type()",
   "int = g_io_channel_set_flags(GIOChannel,int)",
   "ulong = gdk_modifier_intent_get_type()",
   "int = g_socket_set_option(GObject,int,int,int)",
   "GObject = g_menu_new()",
   "int = gdk_drag_context_get_suggested_action(GObject)",
   "int = g_file_monitor_cancel(GObject)",
   "gtk_file_chooser_set_action(GObject,int)",
   "gtk_widget_path_iter_clear_regions(GtkWidgetPath,int)",
   "string = g_regex_split(GRegex,string,int)",
   "(int,double,double,double,double) = gtk_print_context_get_hard_margins(GObject)",
   "int = g_value_transform(GtkOpaque,GtkOpaque)",
   "int = gdk_gl_context_is_legacy(GObject)",
   "int = gtk_tree_view_column_get_x_offset(GtkWidget)",
   "gtk_tooltip_set_icon_from_gicon(GObject,GtkOpaque,int)",
   "int = gdk_keymap_map_virtual_modifiers(GObject,int[])",
   "ulong = gtk_switch_get_type()",
   "string = g_key_file_get_comment(GKeyFile,string,string)",
   "int = gtk_drag_dest_get_track_motion(GtkWidget)",
   "GtkWidget = gtk_combo_box_new_with_area_and_entry(GObject)",
   "GdkRectangle = gtk_tree_view_get_visible_rect(GtkWidget)",
   "string = gtk_widget_get_tooltip_markup(GtkWidget)",
   "GIOChannel = g_io_channel_new_file(string,string)",
   "long = g_variant_get_int64(GVariant)",
   "ulong = g_variant_type_string_get_depth_(string)",
   "uint = g_socket_get_multicast_ttl(GObject)",
   "gtk_adjustment_set_lower(GObject,double)",
   "int = gdk_pixbuf_get_n_channels(GdkPixbuf)",
   "GVariant = g_variant_ref_sink(GVariant)",
   "string = g_regex_escape_string(string,int)",
   "gtk_scrolled_window_set_placement(GtkWidget,int)",
   "gdk_window_merge_child_input_shapes(GObject)",
   "gtk_buildable_parser_finished(GObject,GObject)",
   "int = gtk_gl_area_get_has_stencil_buffer(GtkWidget)",
   "gdk_window_register_dnd(GObject)",
   "GtkOpaque = gtk_radio_tool_button_get_group(GtkWidget)",
   "int = gdk_monitor_get_scale_factor(GObject)",
   "string = gtk_clipboard_wait_for_uris(GObject)",
   "string = g_bookmark_file_get_mime_type(GBookmarkFile,string)",
   "GtkWidget = gtk_image_new_from_resource(string)",
   "gtk_list_store_set_column_types(GObject,ulong[])",
   "gtk_notebook_set_show_border(GtkWidget,int)",
   "string = gtk_recent_filter_get_name(GObject)",
   "GtkOpaque = gtk_text_iter_get_tags(GtkTextIter)",
   "GObject = gdk_keymap_get_for_display(GObject)",
   "int = gtk_tool_item_group_get_ellipsize(GtkWidget)",
   "char = g_ascii_toupper(char)",
   "g_date_set_time_t(GDate,ulong)",
   "int = gdk_keymap_get_modifier_mask(GObject,int)",
   "gtk_drag_source_set_icon_name(GtkWidget,string)",
   "GObject = gtk_cell_area_context_get_area(GObject)",
   "int = gtk_icon_info_get_base_scale(GObject)",
   "int = gtk_places_sidebar_get_open_flags(GtkWidget)",
   "int = gtk_combo_box_get_button_sensitivity(GtkWidget)",
   "int = gtk_widget_get_has_window(GtkWidget)",
   "GtkPaperSize = gtk_paper_size_new_from_key_file(GKeyFile,string)",
   "GtkWidget = gtk_app_chooser_widget_new(string)",
   "int = g_unichar_islower(uint)",
   "gtk_container_set_focus_hadjustment(GtkWidget,GObject)",
   "GVariant = g_menu_item_get_attribute_value(GObject,string,GVariantType)",
   "GtkWidget = gtk_expander_new_with_mnemonic(string)",
   "GBytes = g_file_load_bytes(GtkOpaque,GtkOpaque,string[])",
   "gtk_invisible_set_screen(GtkWidget,GObject)",
   "GObject = gtk_style_context_get_frame_clock(GObject)",
   "gdk_event_set_device_tool(GdkEvent,GObject)",
   "gdk_window_enable_synchronized_configure(GObject)",
   "(int,int,int) = gtk_tree_view_column_cell_get_position(GtkWidget,GObject)",
   "int = g_main_context_pending(GMainContext)",
   "GtkWidget = gtk_widget_get_ancestor(GtkWidget,ulong)",
   "GtkOpaque = g_settings_backend_get_default()",
   "gdk_parse_args(int[],gchar_ptr_ptr_ptr)",
   "gtk_menu_tool_button_set_menu(GtkWidget,GtkWidget)",
   "gtk_widget_map(GtkWidget)",
   "gtk_file_chooser_add_filter(GObject,GObject)",
   "int = gtk_tool_shell_get_text_orientation(GObject)",
   "gtk_tree_view_set_vadjustment(GtkWidget,GObject)",
   "gtk_icon_view_set_row_spacing(GtkWidget,int)",
   "gtk_scrolled_window_set_propagate_natural_width(GtkWidget,int)",
   "GtkOpaque = g_variant_get_data(GVariant)",
   "gtk_target_entry_free(GObject)",
   "int = gtk_tree_model_iter_nth_child(GObject,GtkTreeIter,GtkTreeIter,int)",
   "int = gtk_window_get_gravity(GtkWidget)",
   "int = gdk_screen_is_composited(GObject)",
   "GtkOpaque = g_emblemed_icon_get_emblems(GObject)",
   "int = gtk_assistant_get_n_pages(GtkWidget)",
   "int = gtk_text_iter_forward_word_end(GtkTextIter)",
   "uint = gtk_get_minor_version()",
   "gtk_widget_add_accelerator(GtkWidget,string,GObject,uint,int,int)",
   "gtk_window_set_mnemonics_visible(GtkWidget,int)",
   "g_key_file_set_value(GKeyFile,string,string,string)",
   "gdk_window_set_shadow_width(GObject,int,int,int,int)",
   "gtk_tree_view_expand_all(GtkWidget)",
   "gtk_tree_store_move_before(GObject,GtkTreeIter,GtkTreeIter)",
   "int = g_app_info_supports_files(GtkOpaque)",
   "GtkWidget = gtk_menu_get_active(GtkWidget)",
   "gtk_widget_set_device_events(GtkWidget,GdkDevice,int)",
   "gtk_file_chooser_set_use_preview_label(GObject,int)",
   "string = gtk_printer_get_description(GObject)",
   "GtkOpaque = g_vfs_get_file_for_path(GtkOpaque,string)",
   "g_unicode_canonical_ordering(uint[],ulong)",
   "int = gtk_print_job_get_status(GObject)",
   "GdkPixbuf = gtk_icon_info_load_symbolic_for_style(GObject,GObject,int,int[])",
   "gtk_widget_set_allocation(GtkWidget,struct)",
   "string = gtk_about_dialog_get_logo_icon_name(GtkWidget)",
   "gtk_flow_box_set_selection_mode(GtkWidget,int)",
   "GtkOpaque = pango_context_get_language(GtkOpaque)",
   "int = g_mount_operation_get_is_tcrypt_hidden_volume(GObject)",
   "ulong = gtk_volume_button_get_type()",
   "GObject = gtk_print_settings_new_from_file(string)",
   "int = g_variant_is_container(GVariant)",
   "int = g_settings_set_string(GtkOpaque,string,string)",
   "gtk_combo_box_text_prepend_text(GtkWidget,string)",
   "int = g_charset_converter_get_use_fallback(GObject)",
   "GtkWidget = gtk_tree_view_get_column(GtkWidget,int)",
   "ulong = gtk_revealer_get_type()",
   "string = g_settings_get_strv(GtkOpaque,string)",
   "string = gtk_recent_chooser_get_current_uri(GObject)",
   "gtk_widget_set_support_multidevice(GtkWidget,int)",
   "GtkOpaque = g_value_dup_object(GtkOpaque)",
   "gtk_icon_view_unselect_path(GtkWidget,GtkTreePath)",
   "gtk_tree_view_set_fixed_height_mode(GtkWidget,int)",
   "GObject = gdk_display_get_default()",
   "gtk_buildable_add_child(GObject,GObject,GObject,string)",
   "GObject = gtk_printer_get_default_page_size(GObject)",
   "int = gtk_printer_is_active(GObject)",
   "int = gdk_device_grab(GdkDevice,GObject,int,int,int,GObject,uint)",
   "GtkOpaque = gdk_pixbuf_loader_get_format(GObject)",
   "int = gtk_box_get_spacing(GtkWidget)",
   "pango_layout_context_changed(GtkOpaque)",
   "string = g_ascii_dtostr(string,int,double)",
   "long = g_date_time_difference(GDateTime,GDateTime)",
   "(int,int,uint) = gtk_box_query_child_packing(GtkWidget,GtkWidget,int[])",
   "string = gtk_selection_data_get_uris(GtkSelectionData)",
   "int = g_menu_model_is_mutable(GObject)",
   "gtk_tool_button_set_use_underline(GtkWidget,int)",
   "ulong = gtk_radio_button_get_type()",
   "gtk_print_settings_set_resolution(GObject,int)",
   "int = gtk_widget_get_direction(GtkWidget)",
   "ulong = gtk_clipboard_get_type()",
   "gtk_widget_queue_compute_expand(GtkWidget)",
   "int = pango_gravity_get_for_script_and_width(int,int,int,int)",
   "int = g_date_time_compare(GtkOpaque,GtkOpaque)",
   "int = gtk_tree_selection_count_selected_rows(GObject)",
   "GtkTreeIter = gtk_list_store_insert_before(GObject,GtkTreeIter)",
   "gtk_info_bar_add_action_widget(GtkWidget,GtkWidget,int)",
   "int = g_content_type_is_mime_type(string,string)",
   "g_cancellable_release_fd(GtkOpaque)",
   "GdkDevice = gdk_drag_context_get_device(GObject)",
   "string = g_compute_checksum_for_data(int,uchar[],ulong)",
   "ulong = gtk_gl_area_get_type()",
   "ulong = gtk_grid_get_type()",
   "int = gtk_assistant_get_page_has_padding(GtkWidget,GtkWidget)",
   "gtk_action_bar_pack_end(GtkWidget,GtkWidget)",
   "GTimeVal = g_date_time_to_timeval(GDateTime)",
   "string = g_file_attribute_matcher_to_string(GtkOpaque)",
   "int = gtk_text_iter_backward_visible_word_start(GtkTextIter)",
   "int = gtk_cairo_should_draw_window(Cairo,GObject)",
   "gtk_widget_unmap(GtkWidget)",
   "int = gtk_printer_has_details(GObject)",
   "GtkWidget = gtk_recent_chooser_widget_new()",
   "g_file_monitor_emit_event(GObject,GtkOpaque,GtkOpaque,int)",
   "GtkWidget = gtk_link_button_new_with_label(string,string)",
   "gdk_window_set_focus_on_map(GObject,int)",
   "(int,double,double) = gtk_gesture_drag_get_start_point(GObject)",
   "string = gtk_about_dialog_get_authors(GtkWidget)",
   "int = g_variant_type_is_variant(GVariantType)",
   "gtk_revealer_set_transition_type(GtkWidget,int)",
   "gtk_text_buffer_remove_tag_by_name(GObject,string,GtkTextIter,GtkTextIter)",
   "int = g_file_load_contents(GtkOpaque,GtkOpaque,string[],string[])",
   "GDateTime = g_date_time_new_from_unix_local(long)",
   "GObject = gdk_visual_get_best_with_both(int,int)",
   "ulong = gtk_check_menu_item_get_type()",
   "gdk_window_set_child_shapes(GObject)",
   "int = gtk_main_iteration_do(int)",
   "GdkRectangle = gtk_text_view_get_iter_location(GtkWidget,GtkTextIter)",
   "int = gtk_icon_view_get_item_padding(GtkWidget)",
   "g_settings_schema_key_unref(GtkOpaque)",
   "gtk_disable_setlocale()",
   "string = g_dcgettext(string,string,int)",
   "int = gtk_page_setup_get_orientation(GObject)",
   "g_cancellable_reset(GtkOpaque)",
   "gtk_icon_view_item_activated(GtkWidget,GtkTreePath)",
   "int = gdk_screen_get_monitor_at_window(GObject,GObject)",
   "string = gtk_print_settings_get(GObject,string)",
   "GObject = gtk_text_view_get_vadjustment(GtkWidget)",
   "GVariantType = g_variant_type_new_dict_entry(GVariantType,GVariantType)",
   "string = g_strrstr(string,string)",
   "int = gtk_print_unix_dialog_get_support_selection(GtkWidget)",
   "ulong = gtk_list_box_get_type()",
   "string = g_time_val_to_iso8601(struct)",
   "int = g_unichar_ismark(uint)",
   "int = g_key_file_load_from_dirs(string,string[],string[],int)",
   "gtk_text_buffer_unregister_deserialize_format(GObject,GObject)",
   "gtk_about_dialog_set_documenters(GtkWidget,string[])",
   "uint = g_param_spec_get_name_quark(GtkOpaque)",
   "GtkOpaque = g_volume_get_mount(GtkOpaque)",
   "ulong = gdk_event_get_type()",
   "g_rand_set_seed(GRand,uint)",
   "GtkOpaque = g_settings_schema_key_ref(GtkOpaque)",
   "int = gdk_screen_get_number(GObject)",
   "GdkEvent = gdk_event_new(int)",
   "gdk_drag_context_set_hotspot(GObject,int,int)",
   "gtk_drag_dest_set_proxy(GtkWidget,GObject,int,int)",
   "int = gtk_text_view_starts_display_line(GtkWidget,GtkTextIter)",
   "int = gtk_print_settings_load_file(GObject,string)",
   "int = g_unichar_digit_value(uint)",
   "int = gtk_menu_bar_get_pack_direction(GtkWidget)",
   "GtkWidget = gtk_recent_chooser_menu_new_for_manager(GObject)",
   "gtk_paned_pack1(GtkWidget,GtkWidget,int,int)",
   "int = gtk_progress_bar_get_ellipsize(GtkWidget)",
   "ulong = gdk_scroll_direction_get_type()",
   "int = gtk_progress_bar_get_show_text(GtkWidget)",
   "GBytes = gdk_pixbuf_read_pixel_bytes(GdkPixbuf)",
   "g_emblemed_icon_add_emblem(GObject,GObject)",
   "g_variant_unref(GVariant)",
   "gtk_revealer_set_reveal_child(GtkWidget,int)",
   "GObject = gdk_visual_get_screen(GObject)",
   "int = gdk_window_is_input_only(GObject)",
   "int = gtk_font_button_get_use_size(GtkWidget)",
   "GObject = g_emblem_new_with_origin(GtkOpaque,int)",
   "g_cancellable_cancel(GtkOpaque)",
   "g_key_file_set_integer(GKeyFile,string,string,int)",
   "GtkWidget = gtk_event_box_new()",
   "pango_coverage_set(PangoCoverage,int,int)",
   "string = gtk_recent_info_get_applications(GObject)",
   "GtkOpaque = g_credentials_get_native(GObject,int)",
   "ulong = g_proxy_address_get_type()",
   "long = gdk_frame_clock_get_frame_time(GObject)",
   "int = gtk_cell_area_focus(GObject,int)",
   "gtk_recent_chooser_remove_filter(GObject,GObject)",
   "GObject = g_inet_socket_address_get_address(GtkOpaque)",
   "GtkOpaque = gtk_file_chooser_get_files(GObject)",
   "int = g_regex_get_capture_count(GRegex)",
   "uint = gdk_keyval_to_upper(uint)",
   "int = g_unicode_script_from_iso15924(uint)",
   "gtk_icon_view_unset_model_drag_source(GtkWidget)",
   "g_key_file_set_locale_string_list(GKeyFile,string,string,string,string[])",
   "int = g_mount_operation_get_choice(GObject)",
   "int = g_io_channel_seek_position(GIOChannel,long,int)",
   "string = pango_version_string()",
   "GtkOpaque = pango_layout_get_context(GtkOpaque)",
   "string = g_variant_get_bytestring(GVariant)",
   "int = gtk_flow_box_get_homogeneous(GtkWidget)",
   "int = gtk_window_get_mnemonics_visible(GtkWidget)",
   "GdkPixbuf = gdk_cursor_get_image(GObject)",
   "gtk_recent_filter_set_name(GObject,string)",
   "g_value_set_int(GtkOpaque,int)",
   "GtkOpaque = g_object_ref(GtkOpaque)",
   "int = g_regex_get_string_number(GRegex,string)",
   "double = gdk_event_get_axis(GdkEvent,int)",
   "GtkWidget = gtk_message_dialog_get_image(GtkWidget)",
   "GObject = gtk_cell_renderer_accel_new()",
   "string = gtk_paper_size_get_default()",
   "string = g_get_user_name()",
   "gtk_buildable_set_name(GObject,string)",
   "g_variant_store(GVariant,GtkOpaque)",
   "gtk_range_set_fill_level(GtkWidget,double)",
   "(int,int) = gdk_window_get_root_origin(GObject)",
   "double = pango_cairo_font_map_get_resolution(GtkOpaque)",
   "GtkOpaque = pango_attr_shape_new(struct,struct)",
   "GtkWidget = gtk_stack_get_child_by_name(GtkWidget,string)",
   "int = g_date_is_first_of_month(GDate)",
   "int = gtk_assistant_get_current_page(GtkWidget)",
   "int = gtk_widget_is_ancestor(GtkWidget,GtkWidget)",
   "gtk_text_buffer_apply_tag_by_name(GObject,string,GtkTextIter,GtkTextIter)",
   "GtkOpaque = g_themed_icon_new(string)",
   "GObject = gdk_display_get_default_group(GObject)",
   "GtkOpaque = gtk_icon_theme_list_icons(GObject,string)",
   "int = gdk_cursor_get_cursor_type(GObject)",
   "gtk_places_sidebar_set_local_only(GtkWidget,int)",
   "GObject = gtk_tree_model_sort_new_with_model(GObject)",
   "int = gtk_widget_mnemonic_activate(GtkWidget,int)",
   "uint = gtk_get_debug_flags()",
   "ushort = g_network_address_get_port(GtkOpaque)",
   "GtkWidget = gtk_paned_get_child1(GtkWidget)",
   "gdk_drag_context_set_device(GObject,GdkDevice)",
   "GdkEvent = gdk_display_peek_event(GObject)",
   "GtkOpaque = gtk_widget_create_pango_layout(GtkWidget,string)",
   "gtk_gl_area_set_has_alpha(GtkWidget,int)",
   "int = gtk_style_context_get_junction_sides(GObject)",
   "int = gtk_text_view_move_visually(GtkWidget,GtkTextIter,int)",
   "gtk_text_view_set_wrap_mode(GtkWidget,int)",
   "GtkOpaque = gtk_icon_view_get_selected_items(GtkWidget)",
   "GtkOpaque = pango_attr_rise_new(int)",
   "uint = gtk_builder_add_from_string(GObject,string,ulong)",
   "string = g_regex_split_full(GRegex,string,long,int,int,int)",
   "gtk_grid_set_baseline_row(GtkWidget,int)",
   "int = gdk_keymap_get_num_lock_state(GObject)",
   "int = g_app_info_add_supports_type(GtkOpaque,string)",
   "int = g_variant_is_of_type(GVariant,GVariantType)",
   "g_source_set_can_recurse(GSource,int)",
   "int = g_file_attribute_matcher_matches_only(GtkOpaque,string)",
   "GtkWidget = gtk_menu_item_new()",
   "gtk_print_operation_draw_page_finish(GObject)",
   "gtk_tree_model_row_inserted(GObject,GtkTreePath,GtkTreeIter)",
   "string = gtk_label_get_current_uri(GtkWidget)",
   "int = gtk_text_buffer_delete_interactive(GObject,GtkTextIter,GtkTextIter,int)",
   "int = gtk_range_get_upper_stepper_sensitivity(GtkWidget)",
   "GtkWidget = gtk_separator_menu_item_new()",
   "gdk_window_beep(GObject)",
   "gtk_toolbar_set_icon_size(GtkWidget,int)",
   "int = gtk_icon_info_get_base_size(GObject)",
   "int = gtk_icon_theme_has_icon(GObject,string)",
   "int = gdk_pixbuf_format_is_save_option_supported(GtkOpaque,string)",
   "gtk_print_operation_set_job_name(GObject,string)",
   "(uint,uint) = gdk_display_get_maximal_cursor_size(GObject)",
   "string = g_get_user_runtime_dir()",
   "int = gdk_device_grab_info_libgtk_only(GObject,GdkDevice,GObject[],int[])",
   "GVariant = g_menu_model_get_item_attribute_value(GObject,int,string,GVariantType)",
   "GtkOpaque = g_resolver_lookup_service_finish(GtkOpaque,GtkOpaque)",
   "int = g_file_error_from_errno(int)",
   "gtk_window_set_screen(GtkWidget,GObject)",
   "GMainLoop = g_main_loop_new(GMainContext,int)",
   "int = pango_language_includes_script(GtkOpaque,int)",
   "uint = gtk_accel_label_get_accel_width(GtkWidget)",
   "double = gtk_print_settings_get_printer_lpi(GObject)",
   "g_file_info_set_attribute_int64(GObject,string,long)",
   "int = gtk_widget_get_allocated_baseline(GtkWidget)",
   "GtkOpaque = g_file_parse_name(string)",
   "(int,uint,uint) = g_unichar_decompose(uint)",
   "GtkOpaque = g_socket_get_remote_address(GObject)",
   "string = g_volume_get_name(GtkOpaque)",
   "gtk_icon_view_select_path(GtkWidget,GtkTreePath)",
   "GtkWidget = gtk_flow_box_new()",
   "int = g_regex_get_max_lookbehind(GRegex)",
   "ulong = gtk_level_bar_get_type()",
   "int = gtk_icon_view_get_item_orientation(GtkWidget)",
   "GtkWidget = gtk_header_bar_get_custom_title(GtkWidget)",
   "GtkSelectionData = gtk_selection_data_copy(GtkSelectionData)",
   "g_file_info_set_symlink_target(GObject,string)",
   "int = gtk_text_iter_forward_visible_line(GtkTextIter)",
   "GtkOpaque = g_volume_monitor_get_volume_for_uuid(GObject,string)",
   "int = gtk_scrolled_window_get_propagate_natural_height(GtkWidget)",
   "gtk_about_dialog_set_version(GtkWidget,string)",
   "GDateTime = g_date_time_add_seconds(GDateTime,double)",
   "GtkWidget = gtk_invisible_new()",
   "ulong = g_file_attribute_info_list_get_type()",
   "ulong = gdk_frame_clock_get_type()",
   "GtkWidget = gtk_overlay_new()",
   "GObject = gtk_widget_get_settings(GtkWidget)",
   "g_variant_type_free(GVariantType)",
   "uint = pango_layout_get_serial(GtkOpaque)",
   "int = g_action_parse_detailed_name(string,string[],GVariant[])",
   "int = pango_font_metrics_get_height(PangoFontMetrics)",
   "g_main_context_pop_thread_default(GMainContext)",
   "string = g_action_print_detailed_name(string,GVariant)",
   "gtk_icon_theme_set_custom_theme(GObject,string)",
   "int = gtk_tool_palette_get_exclusive(GtkWidget,GtkWidget)",
   "long = gdk_frame_clock_get_frame_counter(GObject)",
   "GObject = gtk_viewport_get_vadjustment(GtkWidget)",
   "ulong = gtk_paned_get_type()",
   "uint = g_source_attach(GSource,GMainContext)",
   "ulong = gdk_gravity_get_type()",
   "string = gdk_screen_make_display_name(GObject)",
   "gtk_menu_item_set_accel_path(GtkWidget,string)",
   "int = gdk_window_get_accept_focus(GObject)",
   "gtk_tree_row_reference_free(GtkTreeRowReference)",
   "gtk_tree_selection_set_mode(GObject,int)",
   "int = g_date_time_get_hour(GDateTime)",
   "long = g_file_info_get_size(GObject)",
   "(GtkRequisition, GtkRequisition) = gtk_cell_renderer_get_preferred_size(GObject,GtkWidget)",
   "(uint,int,int) = gdk_visual_get_green_pixel_details(GObject)",
   "gtk_app_chooser_widget_set_show_fallback(GtkWidget,int)",
   "int = g_drive_can_stop(GtkOpaque)",
   "string = g_resource_enumerate_children(GtkOpaque,string,int)",
   "g_key_file_free(GKeyFile)",
   "int = pango_version()",
   "ulong = g_resolver_get_type()",
   "GtkWidgetPath = gtk_widget_get_path(GtkWidget)",
   "gtk_window_set_decorated(GtkWidget,int)",
   "string = gdk_pixbuf_format_get_mime_types(GtkOpaque)",
   "ulong = gdk_pixbuf_animation_iter_get_type()",
   "pango_layout_set_markup(GtkOpaque,string,int)",
   "gtk_widget_error_bell(GtkWidget)",
   "g_hmac_get_digest(GHmac,uchar[],ulong[])",
   "int = gtk_app_chooser_widget_get_show_default(GtkWidget)",
   "string = g_file_info_get_edit_name(GObject)",
   "uint = gdk_keymap_lookup_key(GObject,struct)",
   "gtk_render_option(GObject,Cairo,double,double,double,double)",
   "GObject = gdk_window_get_toplevel(GObject)",
   "int = pango_layout_get_wrap(GtkOpaque)",
   "ushort = gtk_notebook_get_tab_vborder(GtkWidget)",
   "gtk_file_chooser_remove_choice(GObject,string)",
   "gtk_header_bar_set_decoration_layout(GtkWidget,string)",
   "GtkWidget = gtk_window_group_get_current_grab(GObject)",
   "g_source_set_name(GSource,string)",
   "ulong = pango_font_map_get_type()",
   "string = gtk_css_provider_to_string(GObject)",
   "GObject = gdk_window_get_parent(GObject)",
   "GdkDevice = gdk_event_get_source_device(GdkEvent)",
   "int = gtk_print_settings_get_print_pages(GObject)",
   "int = gtk_print_settings_has_key(GObject,string)",
   "ulong = gtk_text_tag_table_get_type()",
   "GObject = gtk_recent_info_ref(GObject)",
   "int = gtk_cell_renderer_is_activatable(GObject)",
   "int = gtk_print_settings_get_orientation(GObject)",
   "double = gtk_adjustment_get_minimum_increment(GObject)",
   "string = gtk_text_iter_get_text(GtkTextIter,GtkTextIter)",
   "gtk_print_operation_get_error(GObject)",
   "int = gtk_label_get_selectable(GtkWidget)",
   "GdkPixbuf = gtk_clipboard_wait_for_image(GObject)",
   "ulong = g_bookmark_file_get_added(GBookmarkFile,string)",
   "int = gtk_text_iter_toggles_tag(GtkTextIter,GObject)",
   "gtk_widget_grab_focus(GtkWidget)",
   "gtk_text_buffer_insert_markup(GObject,GtkTextIter,string,int)",
   "gdk_window_process_all_updates()",
   "uint = g_utf16_to_ucs4(ushort[],long,long[])",
   "int = g_match_info_fetch_named_pos(GMatchInfo,string,int[],int[])",
   "gtk_window_set_title(GtkWidget,string)",
   "int = gtk_entry_get_max_length(GtkWidget)",
   "g_socket_set_timeout(GObject,uint)",
   "int = gtk_combo_box_get_add_tearoffs(GtkWidget)",
   "GObject = gdk_display_get_screen(GObject,int)",
   "gtk_cell_area_apply_attributes(GObject,GObject,GtkTreeIter,int,int)",
   "int = gtk_selection_data_get_targets(GtkSelectionData,GdkAtom_ptr_ptr,int[])",
   "int = gtk_frame_get_shadow_type(GtkWidget)",
   "g_dir_rewind(GDir)",
   "GObject = gdk_display_get_monitor_at_window(GObject,GObject)",
   "g_date_set_time_val(GDate,struct)",
   "g_variant_builder_open(GVariantBuilder,GVariantType)",
   "string = g_strcompress(string)",
   "g_match_info_free(GMatchInfo)",
   "gdk_frame_clock_get_refresh_info(GObject,long,long[],long[])",
   "gtk_selection_add_targets(GtkWidget,GObject,GObject,uint)",
   "GdkRectangle = gtk_cell_area_get_cell_allocation(GObject,GObject,GtkWidget,GObject,struct)",
   "int = pango_tab_array_get_positions_in_pixels(PangoTabArray)",
   "string = pango_language_to_string(GtkOpaque)",
   "gtk_assistant_set_page_type(GtkWidget,GtkWidget,int)",
   "g_settings_backend_changed(GtkOpaque,string,GtkOpaque)",
   "(GtkTextIter,GtkTextIter) = gtk_text_iter_backward_search(GtkTextIter,GtkTextIter)",
   "gtk_app_chooser_button_append_separator(GtkWidget)",
   "int = g_signal_has_handler_pending(GtkOpaque,uint,uint,int)",
   "gtk_text_view_set_indent(GtkWidget,int)",
   "GtkWidget = gtk_menu_button_get_popup(GtkWidget)",
   "GtkOpaque = gtk_print_context_create_pango_layout(GObject)",
   "string = gtk_tree_view_column_get_title(GtkWidget)",
   "int = gdk_display_supports_clipboard_persistence(GObject)",
   "(int,int) = gtk_cell_renderer_get_preferred_height_for_width(GObject,GtkWidget,int)",
   "gtk_text_iter_assign(GtkTextIter,GtkTextIter)",
   "GtkOpaque = g_resolver_lookup_by_name_finish(GtkOpaque,GtkOpaque)",
   "gtk_text_view_set_accepts_tab(GtkWidget,int)",
   "int = g_file_info_get_attribute_boolean(GObject,string)",
   "gtk_window_stick(GtkWidget)",
   "g_mount_operation_set_is_tcrypt_system_volume(GObject,int)",
   "int = gtk_button_box_get_child_secondary(GtkWidget,GtkWidget)",
   "int = g_content_type_can_be_executable(string)",
   "GtkOpaque = g_settings_schema_source_lookup(GtkOpaque,string,int)",
   "int = g_variant_type_string_is_valid(string)",
   "GtkWidget = gtk_tool_button_new(GtkWidget,string)",
   "GObject = gtk_text_view_get_window(GtkWidget,int)",
   "int = pango_layout_iter_get_index(PangoLayoutIter)",
   "gdk_window_restack(GObject,GObject,int)",
   "GtkWidget = gtk_tool_button_get_label_widget(GtkWidget)",
   "string = g_strstr_len(string,long,string)",
   "int = gtk_toolbar_get_style(GtkWidget)",
   "gtk_tooltip_set_tip_area(GObject,struct)",
   "gtk_label_set_label(GtkWidget,string)",
   "GtkOpaque = gtk_recent_manager_get_items(GObject)",
   "gtk_assistant_set_page_complete(GtkWidget,GtkWidget,int)",
   "gdk_gl_context_make_current(GObject)",
   "int = g_variant_classify(GVariant)",
   "gtk_cell_area_box_pack_start(GObject,GObject,int,int,int)",
   "ulong = gdk_fullscreen_mode_get_type()",
   "GtkOpaque = g_file_create(GtkOpaque,int,GtkOpaque)",
   "gtk_toggle_button_set_active(GtkWidget,int)",
   "gtk_calendar_select_day(GtkWidget,uint)",
   "int = gtk_recent_manager_purge_items(GObject)",
   "int = gtk_tool_item_get_use_drag_window(GtkWidget)",
   "ulong = gtk_about_dialog_get_type()",
   "int = pango_gravity_get_for_script(int,int,int)",
   "string = gtk_clipboard_wait_for_text(GObject)",
   "gtk_tool_button_set_icon_widget(GtkWidget,GtkWidget)",
   "g_signal_handlers_destroy(GtkOpaque)",
   "gtk_accessible_connect_widget_destroyed(GObject)",
   "g_clear_object(GObject[])",
   "uint = gdk_unicode_to_keyval(uint)",
   "GObject = gtk_event_controller_key_new(GtkWidget)",
   "gdk_cairo_set_source_color(Cairo,struct)",
   "GtkOpaque = gtk_radio_button_get_group(GtkWidget)",
   "g_bookmark_file_set_visited(GBookmarkFile,string,ulong)",
   "GtkWidget = gtk_cell_view_new()",
   "gtk_tool_item_group_set_collapsed(GtkWidget,int)",
   "string = g_strescape(string,string)",
   "GVariant = g_variant_take_ref(GVariant)",
   "g_value_unset(GtkOpaque)",
   "int = gtk_text_mark_get_deleted(GObject)",
   "int = gtk_accel_groups_activate(GObject,uint,int)",
   "g_settings_backend_path_writable_changed(GtkOpaque,string)",
   "GtkOpaque = g_file_attribute_info_list_new()",
   "gtk_print_job_set_num_copies(GObject,int)",
   "GObject = g_inet_address_new_any(int)",
   "ulong = gtk_recent_info_get_type()",
   "int = gtk_cell_area_attribute_get_column(GObject,GObject,string)",
   "int = g_file_is_native(GtkOpaque)",
   "int = g_unichar_isalnum(uint)",
   "gtk_cell_layout_pack_start(GObject,GObject,int)",
   "g_value_set_uint64(GtkOpaque,ulong)",
   "double = gtk_print_context_get_dpi_y(GObject)",
   "GObject = gtk_builder_new_from_file(string)",
   "(int,int) = gtk_tree_view_convert_widget_to_bin_window_coords(GtkWidget,int,int)",
   "ulong = g_signal_connect_closure(GtkOpaque,string,GtkOpaque,int)",
   "string = g_date_time_format(GDateTime,string)",
   "gtk_widget_size_allocate_with_baseline(GtkWidget,struct,int)",
   "gtk_entry_set_icon_tooltip_text(GtkWidget,int,string)",
   "string = g_quark_to_string(uint)",
   "pango_font_description_set_absolute_size(GtkOpaque,double)",
   "int = gtk_window_get_mnemonic_modifier(GtkWidget)",
   "(int,double,double,double,double) = gtk_printer_get_hard_margins(GObject)",
   "GObject = gtk_gesture_swipe_new(GtkWidget)",
   "GObject = gtk_icon_info_new_for_pixbuf(GObject,GdkPixbuf)",
   "string = g_get_codeset()",
   "string = gtk_style_context_to_string(GObject,int)",
   "int = gtk_assistant_prepend_page(GtkWidget,GtkWidget)",
   "int = g_inet_address_get_family(GObject)",
   "int = pango_font_description_get_variant(GtkOpaque)",
   "ulong = gtk_recent_info_get_visited(GObject)",
   "GtkOpaque = g_resource_load(string)",
   "uint = pango_context_get_serial(GtkOpaque)",
   "gtk_text_iter_free(GtkTextIter)",
   "GMainContext = g_main_context_default()",
   "int = pango_font_metrics_get_underline_position(PangoFontMetrics)",
   "gtk_window_set_interactive_debugging(int)",
   "int = gtk_recent_chooser_get_select_multiple(GObject)",
   "int = gtk_label_get_width_chars(GtkWidget)",
   "int = pango_font_family_is_variable(GtkOpaque)",
   "GtkOpaque = pango_attr_show_new(int)",
   "g_main_context_release(GMainContext)",
   "int = gtk_tree_view_append_column(GtkWidget,GtkWidget)",
   "gtk_entry_set_alignment(GtkWidget,float)",
   "int = gtk_file_chooser_set_file(GObject,GtkOpaque)",
   "string = pango_font_face_get_face_name(GtkOpaque)",
   "gtk_print_settings_set_media_type(GObject,string)",
   "gtk_label_set_mnemonic_widget(GtkWidget,GtkWidget)",
   "GtkOpaque = gtk_text_iter_get_language(GtkTextIter)",
   "GObject = gtk_tree_view_get_vadjustment(GtkWidget)",
   "ulong = gtk_event_controller_get_type()",
   "GtkOpaque = g_file_append_to_finish(GtkOpaque,GtkOpaque)",
   "gtk_popover_popdown(GtkWidget)",
   "int = g_unichar_break_type(uint)",
   "ulong = gtk_container_child_type(GtkWidget)",
   "string = g_content_type_get_generic_icon_name(string)",
   "int = pango_layout_iter_next_line(PangoLayoutIter)",
   "GMatchInfo = g_match_info_ref(GMatchInfo)",
   "int = gtk_selection_data_get_format(GtkSelectionData)",
   "ulong = g_vfs_get_type()",
   "string = g_file_info_list_attributes(GObject,string)",
   "int = gtk_text_iter_backward_line(GtkTextIter)",
   "int = pango_font_description_get_stretch(GtkOpaque)",
   "int = gtk_gesture_is_recognized(GObject)",
   "pango_font_description_merge_static(GtkOpaque,GtkOpaque,int)",
   "gdk_window_lower(GObject)",
   "GdkEvent = gdk_event_copy(GdkEvent)",
   "gtk_mount_operation_set_parent(GObject,GtkWidget)",
   "GObject = g_menu_model_iterate_item_attributes(GObject,int)",
   "int = gtk_icon_view_path_is_selected(GtkWidget,GtkTreePath)",
   "double = gtk_print_settings_get_scale(GObject)",
   "g_param_spec_sink(GtkOpaque)",
   "int = gtk_print_job_get_reverse(GObject)",
   "string = gtk_entry_completion_compute_prefix(GObject,string)",
   "int = gtk_scrolled_window_get_min_content_height(GtkWidget)",
   "GVariant = g_variant_byteswap(GVariant)",
   "gtk_about_dialog_set_website_label(GtkWidget,string)",
   "int = gtk_revealer_get_transition_type(GtkWidget)",
   "(double,double) = gtk_spin_button_get_range(GtkWidget)",
   "gtk_tree_view_column_set_title(GtkWidget,string)",
   "string = g_app_launch_context_get_startup_notify_id(GObject,GtkOpaque,GtkOpaque[])",
   "gdk_window_geometry_changed(GObject)",
   "int = gtk_text_iter_backward_lines(GtkTextIter,int)",
   "Cairo = gdk_pango_layout_line_get_clip_region(PangoLayoutLine,int,int,int[],int)",
   "GdkPixbuf = gtk_icon_info_load_icon_finish(GObject,GtkOpaque)",
   "gtk_print_settings_set_bool(GObject,string,int)",
   "int = gtk_tree_view_get_search_column(GtkWidget)",
   "GMappedFile = g_mapped_file_new_from_fd(int,int)",
   "int = g_app_info_set_as_default_for_extension(GtkOpaque,string)",
   "ulong = gtk_entry_get_type()",
   "gtk_text_buffer_paste_clipboard(GObject,GObject,GtkTextIter,int)",
   "GtkWidget = gtk_application_window_new(GObject)",
   "gtk_list_box_invalidate_sort(GtkWidget)",
   "GtkWidget = gtk_app_chooser_button_new(string)",
   "gtk_combo_box_text_append(GtkWidget,string,string)",
   "g_io_channel_set_close_on_unref(GIOChannel,int)",
   "GtkOpaque = g_file_read_finish(GtkOpaque,GtkOpaque)",
   "GObject = gtk_gesture_rotate_new(GtkWidget)",
   "GtkWidget = gtk_combo_box_new()",
   "GtkOpaque = pango_font_get_font_map(GtkOpaque)",
   "gtk_grid_set_column_spacing(GtkWidget,uint)",
   "gtk_stack_set_interpolate_size(GtkWidget,int)",
   "GObject = gtk_text_mark_new(string,int)",
   "ulong = gtk_search_entry_get_type()",
   "gtk_print_settings_set_dither(GObject,string)",
   "string = gtk_font_button_get_font_name(GtkWidget)",
   "gtk_gl_area_set_has_depth_buffer(GtkWidget,int)",
   "GtkWidget = gtk_spin_button_new_with_range(double,double,double)",
   "gtk_search_bar_set_search_mode(GtkWidget,int)",
   "int = gtk_text_iter_backward_chars(GtkTextIter,int)",
   "int = gtk_clipboard_wait_is_rich_text_available(GObject,GObject)",
   "uint = g_unichar_toupper(uint)",
   "string = g_getenv(string)",
   "gtk_adjustment_set_step_increment(GObject,double)",
   "GObject = gdk_screen_get_system_visual(GObject)",
   "g_settings_schema_unref(GtkOpaque)",
   "GtkWidget = gtk_color_chooser_dialog_new(string,GtkWidget)",
   "gtk_message_dialog_set_markup(GtkWidget,string)",
   "ulong = gtk_css_section_get_type()",
   "gtk_adjustment_set_page_increment(GObject,double)",
   "int = gtk_menu_button_get_direction(GtkWidget)",
   "(int,int) = pango_quantize_line_geometry()",
   "gtk_popover_popup(GtkWidget)",
   "GtkTreeRowReference = gtk_tree_row_reference_copy(GtkTreeRowReference)",
   "GtkWidget = gtk_image_new_from_icon_set(GtkOpaque,int)",
   "int = gtk_button_get_use_stock(GtkWidget)",
   "int = gdk_device_pad_get_n_groups(GObject)",
   "GObject = gtk_icon_theme_new()",
   "GObject = gtk_icon_theme_choose_icon(GObject,string[],int,int)",
   "gtk_entry_completion_insert_action_markup(GObject,int,string)",
   "gtk_render_slider(GObject,Cairo,double,double,double,double,int)",
   "GObject = gtk_tree_view_get_bin_window(GtkWidget)",
   "string = g_get_user_cache_dir()",
   "g_resources_register(GtkOpaque)",
   "gtk_color_button_set_alpha(GtkWidget,ushort)",
   "gtk_scale_button_set_adjustment(GtkWidget,GObject)",
   "gtk_label_set_lines(GtkWidget,int)",
   "gtk_print_context_set_cairo_context(GObject,Cairo,double,double)",
   "int = gtk_recent_chooser_get_sort_type(GObject)",
   "GtkWidget = gtk_tool_item_group_new(string)",
   "int = gtk_tree_view_collapse_row(GtkWidget,GtkTreePath)",
   "gdk_device_set_axis_use(GdkDevice,uint,int)",
   "GtkOpaque = g_volume_monitor_get_mounts(GObject)",
   "ulong = gtk_pad_controller_get_type()",
   "int = gtk_application_is_inhibited(GObject,int)",
   "string = g_uri_parse_scheme(string)",
   "string = g_strrstr_len(string,long,string)",
   "long = g_source_get_time(GSource)",
   "gtk_combo_box_set_popup_fixed_width(GtkWidget,int)",
   "gtk_window_set_default_size(GtkWidget,int,int)",
   "gtk_render_line(GObject,Cairo,double,double,double,double)",
   "gtk_tree_view_expand_to_path(GtkWidget,GtkTreePath)",
   "int = pango_font_description_get_weight(GtkOpaque)",
   "int = gtk_label_get_max_width_chars(GtkWidget)",
   "gtk_container_child_notify_by_pspec(GtkWidget,GtkWidget,GtkOpaque)",
   "int = gtk_widget_get_sensitive(GtkWidget)",
   "ulong = gtk_spinner_get_type()",
   "gtk_accel_label_set_accel(GtkWidget,uint,int)",
   "string = gtk_print_settings_get_dither(GObject)",
   "(int,int,int) = pango_layout_line_x_to_index(PangoLayoutLine,int)",
   "uchar = gtk_selection_data_get_data(GtkSelectionData)",
   "gtk_assistant_set_page_has_padding(GtkWidget,GtkWidget,int)",
   "double = gtk_print_settings_get_paper_height(GObject,int)",
   "gdk_gl_context_clear_current()",
   "gtk_lock_button_set_permission(GtkWidget,GObject)",
   "g_menu_prepend(GObject,string,string)",
   "int = gtk_file_chooser_add_shortcut_folder_uri(GObject,string)",
   "pango_layout_set_alignment(GtkOpaque,int)",
   "gtk_entry_set_icon_from_pixbuf(GtkWidget,int,GdkPixbuf)",
   "int = gtk_text_buffer_delete_selection(GObject,int,int)",
   "gtk_label_set_markup(GtkWidget,string)",
   "GObject = gtk_application_new(string,int)",
   "ulong = gtk_tree_model_get_type()",
   "g_emblemed_icon_clear_emblems(GObject)",
   "int = g_timer_is_active(GTimer)",
   "string = gtk_icon_info_get_display_name(GObject)",
   "gtk_separator_tool_item_set_draw(GtkWidget,int)",
   "GtkOpaque = g_file_read(GtkOpaque,GtkOpaque)",
   "GtkOpaque = gtk_entry_get_layout(GtkWidget)",
   "GtkOpaque = g_type_check_class_cast(GtkOpaque,ulong)",
   "string = g_strchug(string)",
   "(int,double,double) = gtk_gesture_get_point(GObject,GtkOpaque)",
   "gdk_window_process_updates(GObject,int)",
   "int = g_socket_listen(GObject)",
   "GtkOpaque = g_object_bind_property(GtkOpaque,string,GtkOpaque,string,int)",
   "GMainContext = g_main_loop_get_context(GMainLoop)",
   "int = gtk_widget_get_double_buffered(GtkWidget)",
   "g_mount_operation_set_password_save(GObject,int)",
   "GTimeZone = g_time_zone_ref(GTimeZone)",
   "GtkOpaque = g_settings_schema_source_ref(GtkOpaque)",
   "gtk_file_chooser_button_set_title(GtkWidget,string)",
   "ulong = g_menu_item_get_type()",
   "int = g_inet_address_get_is_multicast(GObject)",
   "int = g_network_monitor_get_network_metered(GtkOpaque)",
   "ulong = gtk_shortcuts_shortcut_get_type()",
   "int = g_unichar_validate(uint)",
   "GdkPixbuf = gtk_assistant_get_page_side_image(GtkWidget,GtkWidget)",
   "gtk_scrolled_window_set_min_content_width(GtkWidget,int)",
   "int = gdk_seat_get_capabilities(GObject)",
   "g_settings_delay(GtkOpaque)",
   "GObject = g_menu_item_new_section(string,GObject)",
   "ulong = gdk_input_mode_get_type()",
   "GtkWidget = gtk_event_controller_get_widget(GObject)",
   "ulong = gtk_print_settings_get_type()",
   "int = gtk_tree_row_reference_valid(GtkTreeRowReference)",
   "GtkWidget = gtk_button_new_with_mnemonic(string)",
   "int = gtk_list_box_get_activate_on_single_click(GtkWidget)",
   "gtk_tree_view_column_clicked(GtkWidget)",
   "GObject = gtk_selection_data_get_data_type(GtkSelectionData)",
   "GObject = gtk_style_context_new()",
   "pango_font_description_set_variations_static(GtkOpaque,string)",
   "int = g_type_get_instance_count(ulong)",
   "gtk_shortcut_label_set_accelerator(GtkWidget,string)",
   "gtk_range_set_show_fill_level(GtkWidget,int)",
   "GtkOpaque = g_object_bind_property_with_closures(GtkOpaque,string,GtkOpaque,string,int,GtkOpaque,GtkOpaque)",
   "int = gtk_tree_view_get_activate_on_single_click(GtkWidget)",
   "ulong = gtk_file_chooser_get_type()",
   "ulong = gtk_font_chooser_widget_get_type()",
   "gtk_level_bar_set_max_value(GtkWidget,double)",
   "uint = gtk_get_interface_age()",
   "string = gtk_application_get_accels_for_action(GObject,string)",
   "string = gtk_recent_info_get_display_name(GObject)",
   "gtk_progress_bar_pulse(GtkWidget)",
   "ulong = gtk_box_get_type()",
   "int = gtk_app_chooser_widget_get_show_fallback(GtkWidget)",
   "gtk_switch_set_active(GtkWidget,int)",
   "gtk_tree_view_set_headers_visible(GtkWidget,int)",
   "gtk_text_buffer_insert(GObject,GtkTextIter,string,int)",
   "ulong = gtk_recent_filter_get_type()",
   "int = gtk_window_is_maximized(GtkWidget)",
   "g_file_info_set_edit_name(GObject,string)",
   "int = gtk_font_button_get_show_size(GtkWidget)",
   "gtk_style_context_set_scale(GObject,int)",
   "string = g_utf8_strchr(string,long,uint)",
   "int = gtk_print_settings_to_file(GObject,string)",
   "gtk_tooltip_set_icon_from_stock(GObject,string,int)",
   "gtk_calendar_set_detail_height_rows(GtkWidget,int)",
   "int = pango_layout_get_ellipsize(GtkOpaque)",
   "int = gtk_widget_in_destruction(GtkWidget)",
   "GtkWidget = gtk_toggle_button_new()",
   "ulong = gtk_print_job_get_type()",
   "GObject = gtk_cell_area_box_new()",
   "gtk_tree_view_column_clear(GtkWidget)",
   "int = gtk_tree_view_remove_column(GtkWidget,GtkWidget)",
   "gdk_screen_set_resolution(GObject,double)",
   "gtk_adjustment_set_upper(GObject,double)",
   "int = gtk_widget_compute_expand(GtkWidget,int)",
   "gtk_page_setup_set_right_margin(GObject,double,int)",
   "GObject = g_menu_item_new_from_model(GObject,int)",
   "int = g_app_info_can_remove_supports_type(GtkOpaque)",
   "ulong = gtk_places_sidebar_get_type()",
   "int = gtk_tree_path_compare(GtkTreePath,GtkTreePath)",
   "gtk_text_view_set_editable(GtkWidget,int)",
   "g_cancellable_pop_current(GtkOpaque)",
   "ulong = gtk_app_chooser_dialog_get_type()",
   "gtk_application_add_window(GObject,GtkWidget)",
   "int = g_inet_address_get_is_mc_org_local(GObject)",
   "gtk_flow_box_set_row_spacing(GtkWidget,uint)",
   "g_object_remove_weak_pointer(GObject,GtkOpaque[])",
   "GtkOpaque = pango_attr_foreground_alpha_new(ushort)",
   "gtk_frame_set_label_widget(GtkWidget,GtkWidget)",
   "int = g_action_name_is_valid(string)",
   "ulong = gdk_device_tool_get_type()",
   "GtkWidget = gtk_message_dialog_new(GtkWidget,int,int,int,string)",
   "gtk_scale_set_value_pos(GtkWidget,int)",
   "ulong = g_input_stream_get_type()",
   "uint = g_variant_type_hash(GtkOpaque)",
   "int = gtk_text_view_get_overwrite(GtkWidget)",
   "string = pango_language_get_sample_string(GtkOpaque)",
   "PangoCoverage = pango_coverage_new()",
   "gdk_window_set_transient_for(GObject,GObject)",
   "gtk_window_remove_mnemonic(GtkWidget,uint,GtkWidget)",
   "GtkOpaque = g_iconv_open(string,string)",
   "ulong = gtk_toggle_tool_button_get_type()",
   "ulong = g_file_get_type()",
   "int = gtk_text_iter_get_visible_line_index(GtkTextIter)",
   "gtk_widget_set_realized(GtkWidget,int)",
   "pango_font_description_free(GtkOpaque)",
   "GtkOpaque = pango_attr_gravity_hint_new(int)",
   "gtk_cell_layout_clear_attributes(GObject,GObject)",
   "gtk_combo_box_set_entry_text_column(GtkWidget,int)",
   "gtk_image_set_from_icon_name(GtkWidget,string,int)",
   "int = gtk_widget_get_halign(GtkWidget)",
   "int = g_date_time_get_day_of_year(GDateTime)",
   "string = g_ascii_strup(string,long)",
   "GVariant = gtk_file_filter_to_gvariant(GObject)",
   "string = gtk_about_dialog_get_website(GtkWidget)",
   "g_file_attribute_info_list_add(GtkOpaque,string,int,int)",
   "int = gdk_window_get_events(GObject)",
   "double = gtk_gesture_zoom_get_scale_delta(GObject)",
   "ulong = gtk_check_button_get_type()",
   "int = g_key_file_set_comment(GKeyFile,string,string,string)",
   "string = g_uri_list_extract_uris(string)",
   "GtkOpaque = gdk_pixbuf_format_copy(GtkOpaque)",
   "char = g_value_get_char(GtkOpaque)",
   "g_signal_handler_disconnect(GtkOpaque,ulong)",
   "gtk_print_settings_set_n_copies(GObject,int)",
   "int = gtk_widget_path_iter_has_name(GtkWidgetPath,int,string)",
   "int = gtk_check_menu_item_get_active(GtkWidget)",
   "int = gtk_recent_info_has_application(GObject,string)",
   "gtk_widget_override_cursor(GtkWidget,struct,struct)",
   "int = g_date_time_get_microsecond(GDateTime)",
   "Cairo = gdk_drawing_context_get_cairo_context(GObject)",
   "gtk_label_set_ellipsize(GtkWidget,int)",
   "GtkOpaque = pango_layout_get_font_description(GtkOpaque)",
   "ulong = gdk_display_manager_get_type()",
   "gtk_expander_set_use_underline(GtkWidget,int)",
   "GObject = gdk_monitor_get_display(GObject)",
   "gtk_button_set_use_underline(GtkWidget,int)",
   "GdkRectangle = gdk_screen_get_monitor_geometry(GObject,int)",
   "gtk_widget_set_opacity(GtkWidget,double)",
   "int = gtk_places_sidebar_get_show_recent(GtkWidget)",
   "GtkWidget = gtk_file_chooser_button_new(string,int)",
   "gtk_widget_add_events(GtkWidget,int)",
   "gtk_file_chooser_set_show_hidden(GObject,int)",
   "GtkPaperSize = gtk_paper_size_new_from_ipp(string,double,double)",
   "int = gtk_tree_view_column_cell_is_visible(GtkWidget)",
   "GtkWidget = gtk_dialog_new()",
   "int = gtk_widget_path_append_type(GtkWidgetPath,ulong)",
   "int = gtk_range_get_show_fill_level(GtkWidget)",
   "GtkOpaque = g_null_settings_backend_new()",
   "GtkOpaque = g_vfs_get_file_for_uri(GtkOpaque,string)",
   "gtk_widget_set_window(GtkWidget,GObject)",
   "string = g_uri_unescape_string(string,string)",
   "ulong = gtk_file_chooser_dialog_get_type()",
   "int = gtk_widget_path_iter_has_qclass(GtkWidgetPath,int,uint)",
   "string = gtk_printer_get_icon_name(GObject)",
   "int = gdk_keymap_get_entries_for_keyval(GObject,uint,GdkKeymapKey_ptr_ptr,int[])",
   "gtk_flow_box_select_all(GtkWidget)",
   "gtk_window_present(GtkWidget)",
   "int = gtk_label_get_justify(GtkWidget)",
   "int = g_inet_address_get_is_link_local(GObject)",
   "int = gtk_cell_area_event(GObject,GObject,GtkWidget,GdkEvent,struct,int)",
   "gtk_label_set_line_wrap_mode(GtkWidget,int)",
   "GObject = gdk_drawing_context_get_window(GObject)",
   "GtkOpaque = g_network_address_new_loopback(ushort)",
   "gtk_window_reshow_with_initial_size(GtkWidget)",
   "int = gtk_text_tag_event(GObject,GObject,GdkEvent,GtkTextIter)",
   "gtk_toolbar_unset_icon_size(GtkWidget)",
   "GMappedFile = g_mapped_file_new(string,int)",
   "gtk_menu_popup_at_rect(GtkWidget,GObject,struct,int,int,GdkEvent)",
   "gtk_application_window_set_show_menubar(GtkWidget,int)",
   "g_type_init_with_debug_flags(int)",
   "ulong = gtk_app_chooser_widget_get_type()",
   "GdkPixbuf = gdk_pixbuf_add_alpha(GdkPixbuf,int,uchar,uchar,uchar)",
   "gtk_cell_area_attribute_disconnect(GObject,GObject,string)",
   "gtk_tooltip_trigger_tooltip_query(GObject)",
   "(double,double) = gtk_spin_button_get_increments(GtkWidget)",
   "gtk_places_sidebar_set_drop_targets_visible(GtkWidget,int,GObject)",
   "gdk_pixbuf_composite_color(GdkPixbuf,GdkPixbuf,int,int,int,int,double,double,double,double,int,int,int,int,int,uint,uint)",
   "GtkOpaque = g_simple_action_group_lookup(GtkOpaque,string)",
   "GObject = gtk_cell_area_create_context(GObject)",
   "gtk_cell_view_set_background_color(GtkWidget,struct)",
   "GObject = gdk_window_get_frame_clock(GObject)",
   "GtkOpaque = g_mount_get_drive(GtkOpaque)",
   "int = g_regex_match_all(GRegex,string,int,GMatchInfo[])",
   "string = gtk_text_mark_get_name(GObject)",
   "int = gdk_selection_owner_set_for_display(GObject,GObject,GObject,uint,int)",
   "GObject = gtk_lock_button_get_permission(GtkWidget)",
   "(int,int) = gtk_cell_renderer_get_padding(GObject)",
   "int = gtk_text_tag_table_add(GObject,GObject)",
   "GObject = gtk_printer_get_backend(GObject)",
   "gtk_widget_set_parent_window(GtkWidget,GObject)",
   "int = gtk_toggle_button_get_mode(GtkWidget)",
   "int = gtk_button_get_use_underline(GtkWidget)",
   "int = pango_layout_get_justify(GtkOpaque)",
   "int = g_date_time_get_day_of_month(GDateTime)",
   "g_resources_unregister(GtkOpaque)",
   "int = g_socket_condition_wait(GObject,int,GtkOpaque)",
   "pango_font_description_set_stretch(GtkOpaque,int)",
   "gtk_label_set_track_visited_links(GtkWidget,int)",
   "uint = gtk_grid_get_row_spacing(GtkWidget)",
   "int = g_file_set_attribute_byte_string(GtkOpaque,string,string,int,GtkOpaque)",
   "gdk_window_set_keep_above(GObject,int)",
   "GDateTime = g_date_time_new_utc(int,int,int,int,int,double)",
   "ulong = gtk_printer_get_type()",
   "int = g_file_query_exists(GtkOpaque,GtkOpaque)",
   "pango_cairo_show_glyph_string(Cairo,GtkOpaque,PangoGlyphString)",
   "int = gtk_window_resize_grip_is_visible(GtkWidget)",
   "GHmac = g_hmac_ref(GHmac)",
   "gtk_window_set_resizable(GtkWidget,int)",
   "GObject = g_socket_get_credentials(GObject)",
   "GObject = gtk_cell_renderer_toggle_new()",
   "g_object_thaw_notify(GObject)",
   "gtk_container_set_reallocate_redraws(GtkWidget,int)",
   "int = gtk_range_get_restrict_to_fill_level(GtkWidget)",
   "gtk_assistant_set_page_header_image(GtkWidget,GtkWidget,GdkPixbuf)",
   "int = gtk_recent_chooser_get_limit(GObject)",
   "g_object_interface_install_property(GtkOpaque,GtkOpaque)",
   "int = gtk_file_chooser_set_current_folder(GObject,string)",
   "int = gtk_text_iter_is_end(GtkTextIter)",
   "string = g_variant_print(GVariant,int)",
   "int = gdk_screen_width()",
   "GdkPixbuf = gtk_icon_theme_load_icon_for_scale(GObject,string,int,int,int)",
   "int = gtk_label_get_single_line_mode(GtkWidget)",
   "ulong = g_app_info_get_type()",
   "string = gtk_header_bar_get_title(GtkWidget)",
   "int = gtk_window_get_modal(GtkWidget)",
   "string = gtk_application_get_actions_for_accel(GObject,string)",
   "pango_context_set_font_description(GtkOpaque,GtkOpaque)",
   "int = gtk_print_settings_get_int_with_default(GObject,string,int)",
   "GtkWidget = gtk_list_box_get_row_at_y(GtkWidget,int)",
   "pango_layout_set_width(GtkOpaque,int)",
   "int = gtk_text_iter_in_range(GtkTextIter,GtkTextIter,GtkTextIter)",
   "GdkPixbuf = gtk_about_dialog_get_logo(GtkWidget)",
   "int = gtk_notebook_append_page_menu(GtkWidget,GtkWidget,GtkWidget,GtkWidget)",
   "ulong = gtk_requisition_get_type()",
   "GdkFrameTimings = gdk_frame_clock_get_current_timings(GObject)",
   "g_simple_action_group_add_entries(GtkOpaque,GtkOpaque,int,GtkOpaque)",
   "gtk_about_dialog_set_license_type(GtkWidget,int)",
   "gtk_render_frame(GObject,Cairo,double,double,double,double)",
   "double = gtk_range_get_fill_level(GtkWidget)",
   "(int,int,int,int) = gdk_window_get_geometry(GObject)",
   "gtk_entry_set_icon_from_gicon(GtkWidget,int,GtkOpaque)",
   "gtk_label_set_yalign(GtkWidget,float)",
   "int = g_cancellable_set_error_if_cancelled(GtkOpaque)",
   "ulong = gtk_invisible_get_type()",
   "gtk_list_store_move_after(GObject,GtkTreeIter,GtkTreeIter)",
   "int = gtk_tree_path_prev(GtkTreePath)",
   "GtkOpaque = g_bytes_icon_new(GBytes)",
   "int = gtk_cell_renderer_get_visible(GObject)",
   "int = gtk_text_buffer_get_char_count(GObject)",
   "GObject = gdk_device_get_last_event_window(GdkDevice)",
   "int = gdk_device_tool_get_tool_type(GObject)",
   "gtk_cell_area_stop_editing(GObject,int)",
   "int = pango_layout_get_indent(GtkOpaque)",
   "GDateTime = g_date_time_to_timezone(GDateTime,GTimeZone)",
   "int = gtk_cell_renderer_toggle_get_active(GObject)",
   "ulong = gtk_accel_label_get_type()",
   "GtkOpaque = gdk_event_get_event_sequence(GdkEvent)",
   "int = gtk_selection_data_set_text(GtkSelectionData,string,int)",
   "int = g_bookmark_file_load_from_data_dirs(GBookmarkFile,string,string[])",
   "double = pango_cairo_context_get_resolution(GtkOpaque)",
   "int = gtk_color_chooser_get_use_alpha(GObject)",
   "int = gtk_entry_get_icon_activatable(GtkWidget,int)",
   "uint = gtk_entry_buffer_delete_text(GObject,uint,int)",
   "gtk_tree_view_column_set_clickable(GtkWidget,int)",
   "int = g_binding_get_flags(GtkOpaque)",
   "gdk_window_merge_child_shapes(GObject)",
   "gtk_widget_set_name(GtkWidget,string)",
   "GtkOpaque = gtk_font_chooser_get_font_family(GObject)",
   "GObject = gtk_gesture_zoom_new(GtkWidget)",
   "int = g_bookmark_file_get_size(GBookmarkFile)",
   "int = gtk_tool_item_get_orientation(GtkWidget)",
   "int = gtk_icon_view_get_spacing(GtkWidget)",
   "GObject = gdk_screen_get_rgba_visual(GObject)",
   "string = gtk_application_list_action_descriptions(GObject)",
   "string = g_regex_split_simple(string,string,int,int)",
   "int = gtk_tree_view_column_get_sizing(GtkWidget)",
   "string = g_param_spec_get_nick(GtkOpaque)",
   "int = gtk_paper_size_is_ipp(GtkPaperSize)",
   "gtk_style_context_restore(GObject)",
   "ulong = gtk_button_box_get_type()",
   "int = gdk_display_is_closed(GObject)",
   "(double,double,double) = gtk_rgb_to_hsv(double,double,double)",
   "int = gdk_screen_height_mm()",
   "int = gtk_text_view_get_editable(GtkWidget)",
   "int = g_file_copy_attributes(GtkOpaque,GtkOpaque,int,GtkOpaque)",
   "int = gtk_file_chooser_set_current_folder_file(GObject,GtkOpaque)",
   "int = gtk_widget_path_iter_has_region(GtkWidgetPath,int,string,int[])",
   "int = gtk_text_view_forward_display_line_end(GtkWidget,GtkTextIter)",
   "int = gtk_icon_view_get_item_row(GtkWidget,GtkTreePath)",
   "gtk_widget_grab_default(GtkWidget)",
   "gtk_range_set_range(GtkWidget,double,double)",
   "int = g_key_file_save_to_file(GKeyFile,string)",
   "ulong = gtk_icon_info_get_type()",
   "int = gtk_text_iter_backward_visible_lines(GtkTextIter,int)",
   "(int,int) = gtk_text_view_window_to_buffer_coords(GtkWidget,int,int,int)",
   "ulong = gtk_color_chooser_get_type()",
   "gtk_scrolled_window_set_vadjustment(GtkWidget,GObject)",
   "int = gtk_toolbar_get_icon_size(GtkWidget)",
   "int = gtk_file_filter_get_needed(GObject)",
   "GtkWidget = gtk_tree_view_new_with_model(GObject)",
   "pango_attr_list_insert_before(PangoAttrList,GtkOpaque)",
   "int = g_key_file_get_boolean(GKeyFile,string,string)",
   "string = gtk_button_get_label(GtkWidget)",
   "int = g_socket_get_option(GObject,int,int,int[])",
   "gtk_tree_view_set_rubber_banding(GtkWidget,int)",
   "gtk_print_settings_set_quality(GObject,int)",
   "ulong = gtk_selection_data_get_type()",
   "string = gtk_editable_get_chars(GObject,int,int)",
   "gtk_widget_remove_mnemonic_label(GtkWidget,GtkWidget)",
   "ulong = gtk_text_buffer_get_type()",
   "GtkWidgetPath = gtk_container_get_path_for_child(GtkWidget,GtkWidget)",
   "gtk_button_box_set_child_non_homogeneous(GtkWidget,GtkWidget,int)",
   "long = g_source_get_ready_time(GSource)",
   "double = g_strtod(string,string[])",
   "GdkRectangle = gtk_entry_get_icon_area(GtkWidget,int)",
   "long = g_socket_receive_from(GObject,GtkOpaque[],string,ulong,GtkOpaque)",
   "ulong = gdk_rectangle_get_type()",
   "gtk_file_chooser_unselect_file(GObject,GtkOpaque)",
   "gtk_file_chooser_unselect_filename(GObject,string)",
   "int = g_regex_check_replacement(string,int[])",
   "ulong = gtk_gesture_stylus_get_type()",
   "int = pango_tab_array_get_size(PangoTabArray)",
   "int = gdk_pixbuf_animation_get_height(GObject)",
   "GtkOpaque = g_type_class_peek_static(ulong)",
   "int = gtk_window_activate_focus(GtkWidget)",
   "pango_renderer_draw_trapezoid(GtkOpaque,int,double,double,double,double,double,double)",
   "int = gdk_pixbuf_animation_iter_get_delay_time(GObject)",
   "g_notification_set_body(GtkOpaque,string)",
   "gtk_icon_view_set_drag_dest_item(GtkWidget,GtkTreePath,int)",
   "string = g_file_info_get_attribute_as_string(GObject,string)",
   "gtk_menu_item_deselect(GtkWidget)",
   "GObject = gtk_text_child_anchor_new()",
   "gtk_menu_shell_activate_item(GtkWidget,GtkWidget,int)",
   "GDate = g_date_new_julian(uint)",
   "gtk_menu_item_select(GtkWidget)",
   "int = gtk_tool_shell_get_style(GObject)",
   "ulong = g_menu_attribute_iter_get_type()",
   "GObject = gtk_text_buffer_register_serialize_tagset(GObject,string)",
   "int = gtk_menu_get_reserve_toggle_size(GtkWidget)",
   "GtkOpaque = gtk_file_chooser_get_preview_file(GObject)",
   "gtk_tool_item_rebuild_menu(GtkWidget)",
   "GtkOpaque = gtk_text_iter_get_toggled_tags(GtkTextIter,int)",
   "gtk_tool_button_set_stock_id(GtkWidget,string)",
   "string = g_regex_replace(GRegex,string,long,int,string,int)",
   "gtk_drag_source_set_target_list(GtkWidget,GtkTargetList)",
   "uint = gtk_flow_box_get_column_spacing(GtkWidget)",
   "int = gtk_widget_get_receives_default(GtkWidget)",
   "ulong = g_file_monitor_get_type()",
   "GObject = gdk_device_get_display(GdkDevice)",
   "GtkOpaque = gtk_css_section_get_parent(GtkOpaque)",
   "int = gtk_entry_completion_get_inline_selection(GObject)",
   "gdk_display_notify_startup_complete(GObject,string)",
   "string = gtk_tree_model_get_string_from_iter(GObject,GtkTreeIter)",
   "int = g_random_int_range(int,int)",
   "gtk_header_bar_pack_start(GtkWidget,GtkWidget)",
   "GVariant = g_variant_get_maybe(GVariant)",
   "GVariantType = g_variant_type_key(GVariantType)",
   "GObject = gdk_pixbuf_animation_new_from_file(string)",
   "gtk_file_chooser_set_filter(GObject,GObject)",
   "GtkOpaque = g_drive_get_icon(GtkOpaque)",
   "GtkTreeIter = gtk_tree_store_insert_after(GObject,GtkTreeIter,GtkTreeIter)",
   "GtkOpaque = g_object_steal_qdata(GObject,uint)",
   "string = g_proxy_address_get_destination_hostname(GtkOpaque)",
   "gtk_recent_filter_add_group(GObject,string)",
   "string = g_content_type_guess(string,uchar[],ulong,int[])",
   "int = gtk_print_settings_get_n_copies(GObject)",
   "gtk_print_settings_set_double(GObject,string,double)",
   "GObject = gtk_text_buffer_get_insert(GObject)",
   "gtk_toolbar_set_drop_highlight_item(GtkWidget,GtkWidget,int)",
   "gtk_grid_remove_column(GtkWidget,int)",
   "pango_font_map_changed(GtkOpaque)",
   "int = g_file_poll_mountable_finish(GtkOpaque,GtkOpaque)",
   "int = gdk_pixbuf_loader_close(GObject)",
   "GdkPixbuf = gtk_icon_set_render_icon_pixbuf(GtkOpaque,GObject,int)",
   "float = gtk_tree_view_column_get_alignment(GtkWidget)",
   "uint = gtk_print_error_quark()",
   "int = gdk_device_get_source(GdkDevice)",
   "string = g_file_peek_path(GtkOpaque)",
   "GtkWidget = gtk_revealer_new()",
   "gtk_list_box_invalidate_headers(GtkWidget)",
   "g_file_info_set_attribute_uint32(GObject,string,uint)",
   "pango_renderer_set_alpha(GtkOpaque,int,ushort)",
   "gtk_menu_shell_bind_model(GtkWidget,GObject,string,int)",
   "gtk_box_set_center_widget(GtkWidget,GtkWidget)",
   "(int,int) = gtk_cell_area_get_preferred_height(GObject,GObject,GtkWidget)",
   "gtk_notebook_set_tab_detachable(GtkWidget,GtkWidget,int)",
   "ulong = gtk_file_chooser_button_get_type()",
   "string = gtk_widget_get_composite_name(GtkWidget)",
   "GtkOpaque = g_file_find_enclosing_mount_finish(GtkOpaque,GtkOpaque)",
   "int = g_inet_address_get_is_loopback(GObject)",
   "string = gtk_shortcut_label_get_accelerator(GtkWidget)",
   "ulong = g_zlib_compressor_get_type()",
   "int = gtk_tree_model_sort_convert_child_iter_to_iter(GObject,GtkTreeIter,GtkTreeIter)",
   "int = gtk_text_iter_forward_visible_cursor_positions(GtkTextIter,int)",
   "gdk_window_set_device_cursor(GObject,GdkDevice,GObject)",
   "pango_font_description_set_family(GtkOpaque,string)",
   "int = pango_layout_get_alignment(GtkOpaque)",
   "gtk_stack_set_visible_child_full(GtkWidget,string,int)",
   "int = gdk_display_get_n_screens(GObject)",
   "gtk_dialog_response(GtkWidget,int)",
   "gtk_spin_button_configure(GtkWidget,GObject,double,uint)",
   "string = g_compute_checksum_for_string(int,string)",
   "g_settings_bind(GtkOpaque,string,GtkOpaque,string,int)",
   "g_settings_sync()",
   "gtk_text_view_set_pixels_below_lines(GtkWidget,int)",
   "pango_font_get_glyph_extents(GtkOpaque,uint,struct,struct)",
   "int = gtk_selection_data_set_pixbuf(GtkSelectionData,GdkPixbuf)",
   "string = g_mount_get_sort_key(GtkOpaque)",
   "ulong = g_file_info_get_attribute_uint64(GObject,string)",
   "gtk_tool_shell_rebuild_menu(GObject)",
   "g_io_channel_set_buffer_size(GIOChannel,ulong)",
   "gtk_widget_show_now(GtkWidget)",
   "int = gtk_flow_box_child_get_index(GtkWidget)",
   "GObject = gtk_container_get_focus_hadjustment(GtkWidget)",
   "long = g_socket_get_available_bytes(GObject)",
   "gtk_tree_path_append_index(GtkTreePath,int)",
   "ulong = gtk_event_controller_motion_get_type()",
   "GtkOpaque = g_network_address_parse_uri(string,ushort)",
   "GtkWidget = gtk_check_button_new_with_mnemonic(string)",
   "GtkOpaque = g_volume_get_activation_root(GtkOpaque)",
   "long = g_get_real_time()",
   "int = pango_layout_is_wrapped(GtkOpaque)",
   "GtkOpaque = g_app_info_dup(GtkOpaque)",
   "int = g_io_channel_shutdown(GIOChannel,int)",
   "gtk_app_chooser_button_set_show_dialog_item(GtkWidget,int)",
   "gtk_tool_item_toolbar_reconfigured(GtkWidget)",
   "int = gdk_device_pad_get_n_features(GObject,int)",
   "ulong = g_emblemed_icon_get_type()",
   "string = g_utf8_collate_key(string,long)",
   "uint = g_date_get_monday_week_of_year(GDate)",
   "string = g_utf8_collate_key_for_filename(string,long)",
   "int = g_input_stream_close(GObject,GtkOpaque)",
   "g_key_file_set_int64(GKeyFile,string,string,long)",
   "gtk_widget_realize(GtkWidget)",
   "string = g_get_system_data_dirs()",
   "string = gtk_combo_box_text_get_active_text(GtkWidget)",
   "GtkWidget = gtk_frame_new(string)",
   "gtk_frame_set_label(GtkWidget,string)",
   "int = gtk_widget_get_margin_end(GtkWidget)",
   "gdk_pixbuf_format_set_disabled(GtkOpaque,int)",
   "int = gdk_window_set_static_gravities(GObject,int)",
   "ulong = gdk_device_manager_get_type()",
   "float = gtk_tool_item_get_text_alignment(GtkWidget)",
   "GObject = gtk_viewport_get_hadjustment(GtkWidget)",
   "GtkOpaque = g_file_query_default_handler(GtkOpaque,GtkOpaque)",
   "int = pango_coverage_get(PangoCoverage,int)",
   "gtk_paned_set_position(GtkWidget,int)",
   "pango_renderer_draw_error_underline(GtkOpaque,int,int,int,int)",
   "gdk_window_set_opacity(GObject,double)",
   "int = gtk_widget_path_iter_get_state(GtkWidgetPath,int)",
   "gtk_cell_layout_pack_end(GObject,GObject,int)",
   "GObject = gtk_widget_get_root_window(GtkWidget)",
   "gdk_window_iconify(GObject)",
   "GtkWidget = gtk_tool_item_group_get_drop_item(GtkWidget,int,int)",
   "GVariant = gtk_page_setup_to_gvariant(GObject)",
   "GObject = gtk_recent_chooser_get_current_item(GObject)",
   "(int,int) = gtk_cell_area_context_get_preferred_width(GObject)",
   "gtk_entry_set_icon_from_icon_name(GtkWidget,int,string)",
   "gtk_render_activity(GObject,Cairo,double,double,double,double)",
   "GdkRGBA = gtk_style_context_lookup_color(GObject,string)",
   "GObject = gtk_page_setup_copy(GObject)",
   "string = g_get_tmp_dir()",
   "int = g_settings_get_enum(GtkOpaque,string)",
   "int = gtk_tree_view_row_expanded(GtkWidget,GtkTreePath)",
   "GdkPixbuf = gdk_pixbuf_composite_color_simple(GdkPixbuf,int,int,int,int,int,uint,uint)",
   "g_notification_set_default_action_and_target_value(GtkOpaque,string,GVariant)",
   "GChecksum = g_checksum_copy(GChecksum)",
   "int = gtk_tool_item_get_is_important(GtkWidget)",
   "gtk_icon_view_set_spacing(GtkWidget,int)",
   "short = g_variant_get_int16(GVariant)",
   "ulong = gdk_device_type_get_type()",
   "g_value_set_enum(GtkOpaque,int)",
   "gtk_entry_set_max_width_chars(GtkWidget,int)",
   "GVariant = g_action_get_state_hint(GtkOpaque)",
   "GtkOpaque = g_param_spec_pool_list(GtkOpaque,ulong,uint[])",
   "gtk_recent_chooser_menu_set_show_numbers(GtkWidget,int)",
   "ulong = gtk_spin_button_get_type()",
   "GObject = gtk_builder_new()",
   "int = g_unichar_iszerowidth(uint)",
   "int = gtk_tree_view_get_rubber_banding(GtkWidget)",
   "g_file_attribute_matcher_unref(GtkOpaque)",
   "string = g_get_user_config_dir()",
   "GtkOpaque = g_type_default_interface_peek(ulong)",
   "gdk_frame_clock_begin_updating(GObject)",
   "int = gtk_window_get_skip_taskbar_hint(GtkWidget)",
   "int = g_setenv(string,string,int)",
   "GtkAllocation = gtk_widget_get_clip(GtkWidget)",
   "gtk_expander_set_spacing(GtkWidget,int)",
   "int = gtk_cell_area_is_activatable(GObject)",
   "GObject = gdk_drag_context_get_source_window(GObject)",
   "int = gtk_page_setup_load_file(GObject,string)",
   "gtk_button_box_set_child_secondary(GtkWidget,GtkWidget,int)",
   "gtk_assistant_set_page_side_image(GtkWidget,GtkWidget,GdkPixbuf)",
   "double = g_ascii_strtod(string,string[])",
   "gtk_cell_area_remove(GObject,GObject)",
   "GObject = gtk_print_job_new(string,GObject,GObject,GObject)",
   "(int,string,uint,ulong) = g_bookmark_file_get_app_info(GBookmarkFile,string,string)",
   "ulong = gdk_drag_protocol_get_type()",
   "int = g_ascii_strcasecmp(string,string)",
   "string = g_regex_get_pattern(GRegex)",
   "gtk_range_set_inverted(GtkWidget,int)",
   "GtkWidget = gtk_scrollbar_new(int,GObject)",
   "gtk_entry_completion_set_inline_selection(GObject,int)",
   "gdk_test_render_sync(GObject)",
   "int = gtk_entry_get_has_frame(GtkWidget)",
   "gtk_gl_area_attach_buffers(GtkWidget)",
   "PangoFontMetrics = pango_font_metrics_ref(PangoFontMetrics)",
   "int = gtk_gesture_pan_get_orientation(GObject)",
   "string = g_resolver_lookup_by_address_finish(GtkOpaque,GtkOpaque)",
   "uint = g_inet_address_mask_get_length(GtkOpaque)",
   "gtk_recent_filter_add_pixbuf_formats(GObject)",
   "gdk_notify_startup_complete_with_id(string)",
   "gtk_list_box_drag_highlight_row(GtkWidget,GtkWidget)",
   "uint = g_file_info_get_attribute_uint32(GObject,string)",
   "gtk_assistant_set_current_page(GtkWidget,int)",
   "gtk_print_settings_set_duplex(GObject,int)",
   "string = g_str_tokenize_and_fold(string,string,gchar_ptr_ptr_ptr)",
   "GVariant = g_variant_new_from_bytes(GVariantType,GBytes,int)",
   "gtk_flow_box_set_column_spacing(GtkWidget,uint)",
   "int = gtk_tree_view_column_get_width(GtkWidget)",
   "int = g_file_stop_mountable_finish(GtkOpaque,GtkOpaque)",
   "gtk_font_chooser_set_font(GObject,string)",
   "gdk_window_set_title(GObject,string)",
   "gtk_toolbar_set_show_arrow(GtkWidget,int)",
   "gtk_window_resize(GtkWidget,int,int)",
   "gtk_paned_set_wide_handle(GtkWidget,int)",
   "int = gtk_widget_activate(GtkWidget)",
   "(int,int) = gtk_cell_area_get_preferred_width_for_height(GObject,GObject,GtkWidget,int)",
   "string = g_time_zone_get_identifier(GTimeZone)",
   "ulong = gtk_stack_switcher_get_type()",
   "gdk_keyval_convert_case(uint,uint[],uint[])",
   "int = gtk_text_iter_starts_tag(GtkTextIter,GObject)",
   "GObject = gtk_entry_completion_new()",
   "gtk_tree_view_column_set_sort_indicator(GtkWidget,int)",
   "gtk_info_bar_set_message_type(GtkWidget,int)",
   "string = g_intern_static_string(string)",
   "string = gtk_tree_path_to_string(GtkTreePath)",
   "int = g_settings_set_boolean(GtkOpaque,string,int)",
   "uint = g_variant_hash(GtkOpaque)",
   "GtkWidget = gtk_stack_new()",
   "int = gtk_text_iter_starts_word(GtkTextIter)",
   "gdk_window_set_debug_updates(int)",
   "int = g_file_info_has_namespace(GObject,string)",
   "GdkRectangle = gtk_tree_view_get_cell_area(GtkWidget,GtkTreePath,GtkWidget)",
   "GtkWidget = gtk_radio_menu_item_new_with_label(GtkOpaque[],string)",
   "GObject = gtk_target_table_new_from_list(GtkTargetList,int[])",
   "ulong = gtk_menu_button_get_type()",
   "g_mount_operation_reply(GObject,int)",
   "GObject = gtk_button_get_event_window(GtkWidget)",
   "GtkWidget = gtk_grid_new()",
   "int = gdk_pixbuf_calculate_rowstride(int,int,int,int,int)",
   "int = g_value_get_int(GtkOpaque)",
   "g_value_take_object(GtkOpaque,GtkOpaque)",
   "int = g_bookmark_file_remove_group(GBookmarkFile,string,string)",
   "g_key_file_set_double(GKeyFile,string,string,double)",
   "g_file_info_set_attribute_string(GObject,string,string)",
   "GObject = gtk_tree_view_get_model(GtkWidget)",
   "gtk_about_dialog_set_license(GtkWidget,string)",
   "int = gdk_window_get_source_events(GObject,int)",
   "pango_cairo_context_set_font_options(GtkOpaque,Cairo)",
   "gtk_widget_set_app_paintable(GtkWidget,int)",
   "int = gtk_tree_model_iter_previous(GObject,GtkTreeIter)",
   "int = gtk_selection_data_targets_include_uri(GtkSelectionData)",
   "uint = g_date_time_hash(GtkOpaque)",
   "gdk_window_mark_paint_from_clip(GObject,Cairo)",
   "ulong = g_network_service_get_type()",
   "gtk_file_chooser_button_set_focus_on_click(GtkWidget,int)",
   "GtkOpaque = g_resolver_lookup_records_finish(GtkOpaque,GtkOpaque)",
   "ulong = gtk_tree_model_sort_get_type()",
   "int = gtk_gesture_is_grouped_with(GObject,GObject)",
   "int = g_file_has_prefix(GtkOpaque,GtkOpaque)",
   "string = g_utf8_strrchr(string,long,uint)",
   "double = gtk_spin_button_get_value(GtkWidget)",
   "uchar = g_inet_address_to_bytes(GObject)",
   "int = g_app_info_set_as_default_for_type(GtkOpaque,string)",
   "string = pango_font_description_get_variations(GtkOpaque)",
   "int = gdk_window_get_focus_on_map(GObject)",
   "GObject = gtk_css_provider_new()",
   "ulong = gtk_cell_renderer_spinner_get_type()",
   "GtkOpaque = g_resolver_lookup_service(GtkOpaque,string,string,string,GtkOpaque)",
   "gtk_text_view_set_cursor_visible(GtkWidget,int)",
   "int = g_app_info_set_as_last_used_for_type(GtkOpaque,string)",
   "gtk_widget_reparent(GtkWidget,GtkWidget)",
   "ulong = g_variant_n_children(GVariant)",
   "GtkWidget = gtk_info_bar_new()",
   "GtkWidget = gtk_entry_new_with_buffer(GObject)",
   "gtk_widget_set_halign(GtkWidget,int)",
   "GtkOpaque = pango_cairo_font_map_new_for_font_type(int)",
   "gtk_header_bar_set_show_close_button(GtkWidget,int)",
   "GtkWidget = gtk_radio_tool_button_new(GtkOpaque[])",
   "g_checksum_reset(GChecksum)",
   "gtk_notebook_set_tab_label_text(GtkWidget,GtkWidget,string)",
   "ulong = gtk_radio_menu_item_get_type()",
   "gtk_device_grab_add(GtkWidget,GdkDevice,int)",
   "uint = gdk_event_get_keyval(GdkEvent)",
   "GtkOpaque = pango_font_map_load_font(GtkOpaque,GtkOpaque,GtkOpaque)",
   "string = gtk_file_chooser_native_get_cancel_label(GtkWidget)",
   "ulong = gdk_rgba_get_type()",
   "PangoCoverage = pango_coverage_from_bytes(uchar[],int)",
   "GtkOpaque = g_volume_get_drive(GtkOpaque)",
   "int = gtk_places_sidebar_get_show_trash(GtkWidget)",
   "string = g_ucs4_to_utf8(uint[],long,long[])",
   "int = gtk_calendar_get_detail_width_chars(GtkWidget)",
   "gtk_text_view_set_input_hints(GtkWidget,int)",
   "int = gtk_tree_model_get_flags(GObject)",
   "GtkOpaque = g_file_new_for_commandline_arg_and_cwd(string,string)",
   "GtkWidget = gtk_menu_tool_button_get_menu(GtkWidget)",
   "GObject = gtk_entry_buffer_new(string)",
   "ulong = gdk_device_tool_get_serial(GObject)",
   "int = g_socket_get_blocking(GObject)",
   "g_file_info_get_modification_time(GObject,struct)",
   "int = gtk_image_get_gicon(GtkWidget,GtkOpaque[])",
   "int = g_app_info_delete(GtkOpaque)",
   "GtkWidget = gtk_stack_sidebar_get_stack(GtkWidget)",
   "gtk_widget_set_size_request(GtkWidget,int,int)",
   "GtkWidget = gtk_dialog_add_button(GtkWidget,string,int)",
   "gdk_window_flush(GObject)",
   "int = gtk_cell_renderer_get_state(GObject,GtkWidget,int)",
   "GtkWidget = gtk_check_menu_item_new()",
   "GtkOpaque = g_param_spec_pool_new(int)",
   "GtkTreePath = gtk_tree_path_copy(GtkTreePath)",
   "gtk_entry_set_icon_sensitive(GtkWidget,int,int)",
   "GObject = gtk_buildable_get_internal_child(GObject,GObject,string)",
   "int = g_inet_address_get_is_any(GObject)",
   "string = g_mount_get_name(GtkOpaque)",
   "gtk_combo_box_set_id_column(GtkWidget,int)",
   "gdk_window_unstick(GObject)",
   "gdk_window_set_group(GObject,GObject)",
   "int = g_file_info_get_is_backup(GObject)",
   "gtk_assistant_set_page_title(GtkWidget,GtkWidget,string)",
   "string = g_proxy_address_get_uri(GtkOpaque)",
   "gtk_native_dialog_set_title(GtkWidget,string)",
   "ulong = gtk_color_chooser_widget_get_type()",
   "string = gtk_link_button_get_uri(GtkWidget)",
   "gdk_display_set_double_click_distance(GObject,uint)",
   "(int,int) = gtk_gl_area_get_required_version(GtkWidget)",
   "gtk_grid_set_row_baseline_position(GtkWidget,int,int)",
   "GtkTreeIter = gtk_tree_model_get_iter(GObject,GtkTreePath)",
   "g_file_info_set_modification_time(GObject,struct)",
   "ulong = g_variant_get_uint64(GVariant)",
   "GtkOpaque = g_file_create_readwrite_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_tree_model_sort_iter_is_valid(GObject,GtkTreeIter)",
   "gtk_drag_dest_set_target_list(GtkWidget,GtkTargetList)",
   "gtk_target_list_add_uri_targets(GtkTargetList,uint)",
   "ulong = gdk_seat_capabilities_get_type()",
   "GtkWidget = gtk_accel_label_get_accel_widget(GtkWidget)",
   "gtk_range_set_increments(GtkWidget,double,double)",
   "GtkOpaque = g_content_type_get_icon(string)",
   "gtk_frame_set_shadow_type(GtkWidget,int)",
   "gtk_combo_box_set_column_span_column(GtkWidget,int)",
   "gtk_style_context_set_frame_clock(GObject,GObject)",
   "int = gtk_progress_bar_get_inverted(GtkWidget)",
   "GtkWidget = gtk_cell_view_new_with_markup(string)",
   "gtk_window_set_position(GtkWidget,int)",
   "GtkOpaque = g_file_attribute_info_list_dup(GtkOpaque)",
   "GdkPixbuf = gdk_pixbuf_new_from_inline(int,uchar[],int)",
   "gtk_tree_view_column_cell_set_cell_data(GtkWidget,GObject,GtkTreeIter,int,int)",
   "string = g_variant_parse_error_print_context(struct,string)",
   "int = gtk_dialog_run(GtkWidget)",
   "GtkWidget = gtk_image_new()",
   "gtk_selection_data_free(GtkSelectionData)",
   "int = gtk_tree_model_iter_children(GObject,GtkTreeIter,GtkTreeIter)",
   "string = g_filename_to_uri(string,string)",
   "int = gtk_print_unix_dialog_get_has_selection(GtkWidget)",
   "gtk_notebook_set_show_tabs(GtkWidget,int)",
   "gtk_window_iconify(GtkWidget)",
   "GtkOpaque = g_object_interface_find_property(GtkOpaque,string)",
   "Cairo = gdk_cairo_surface_create_from_pixbuf(GdkPixbuf,int,GObject)",
   "gtk_entry_completion_set_minimum_key_length(GObject,int)",
   "GtkOpaque = g_content_types_get_registered()",
   "ulong = gtk_menu_get_type()",
   "int = g_app_info_remove_supports_type(GtkOpaque,string)",
   "GtkWidget = gtk_menu_bar_new_from_model(GObject)",
   "int = g_socket_leave_multicast_group(GObject,GObject,int,string)",
   "gtk_action_bar_set_center_widget(GtkWidget,GtkWidget)",
   "GtkTargetList = gtk_drag_dest_get_target_list(GtkWidget)",
   "GtkPaperSize = gtk_paper_size_new(string)",
   "gtk_widget_unregister_window(GtkWidget,GObject)",
   "GBytes = g_mapped_file_get_bytes(GMappedFile)",
   "gtk_list_box_row_changed(GtkWidget)",
   "GtkOpaque = g_file_replace_readwrite(GtkOpaque,string,int,int,GtkOpaque)",
   "gtk_application_set_app_menu(GObject,GObject)",
   "gtk_widget_set_margin_start(GtkWidget,int)",
   "gtk_drag_dest_add_text_targets(GtkWidget)",
   "uint = g_date_get_iso8601_week_of_year(GDate)",
   "gtk_window_set_deletable(GtkWidget,int)",
   "gtk_tree_view_set_enable_tree_lines(GtkWidget,int)",
   "gtk_style_context_remove_region(GObject,string)",
   "string = g_mount_get_uuid(GtkOpaque)",
   "GtkOpaque = pango_attr_family_new(string)",
   "string = gtk_header_bar_get_decoration_layout(GtkWidget)",
   "double = g_date_time_get_seconds(GDateTime)",
   "string = g_get_locale_variants(string)",
   "GtkOpaque = gtk_css_section_get_file(GtkOpaque)",
   "int = gtk_style_context_has_region(GObject,string,int[])",
   "string = g_menu_link_iter_get_name(GObject)",
   "gtk_menu_set_accel_group(GtkWidget,GObject)",
   "int = g_date_time_get_second(GDateTime)",
   "int = gtk_window_get_focus_visible(GtkWidget)",
   "gtk_print_settings_set_resolution_xy(GObject,int,int)",
   "gtk_style_context_set_background(GObject,GObject)",
   "int = gtk_toggle_button_get_inconsistent(GtkWidget)",
   "gtk_progress_bar_set_inverted(GtkWidget,int)",
   "gtk_cell_view_set_background_rgba(GtkWidget,struct)",
   "int = gtk_window_get_decorated(GtkWidget)",
   "ulong = gtk_color_chooser_dialog_get_type()",
   "string = gtk_recent_info_get_uri(GObject)",
   "gtk_cell_view_set_fit_model(GtkWidget,int)",
   "gtk_image_set_from_surface(GtkWidget,Cairo)",
   "gtk_file_chooser_add_choice(GObject,string,string,string[],string[])",
   "int = gtk_gesture_single_get_exclusive(GObject)",
   "GObject = g_resources_open_stream(string,int)",
   "ulong = g_variant_get_size(GVariant)",
   "int = gtk_tool_item_get_ellipsize_mode(GtkWidget)",
   "string = g_network_service_get_scheme(GtkOpaque)",
   "int = g_file_open_tmp(string,string[])",
   "ulong = gdk_axis_flags_get_type()",
   "GObject = gtk_page_setup_unix_dialog_get_print_settings(GtkWidget)",
   "int = gtk_selection_data_targets_include_image(GtkSelectionData,int)",
   "GtkOpaque = gtk_widget_get_pango_context(GtkWidget)",
   "g_main_context_unref(GMainContext)",
   "int = gtk_info_bar_get_revealed(GtkWidget)",
   "GObject = gtk_tree_model_sort_get_model(GObject)",
   "GtkWidget = gtk_check_button_new()",
   "ulong = gtk_tooltip_get_type()",
   "string = gtk_header_bar_get_subtitle(GtkWidget)",
   "ulong = gtk_popover_get_type()",
   "GtkOpaque = g_variant_get_fixed_array(GVariant,ulong[],ulong)",
   "int = gtk_calendar_get_detail_height_rows(GtkWidget)",
   "gtk_text_tag_table_remove(GObject,GObject)",
   "long = g_get_monotonic_time()",
   "int = gtk_style_context_get_scale(GObject)",
   "gtk_spin_button_set_increments(GtkWidget,double,double)",
   "GObject = gtk_builder_get_object(GObject,string)",
   "ulong = gtk_gesture_rotate_get_type()",
   "gtk_menu_set_monitor(GtkWidget,int)",
   "int = gtk_text_view_get_border_window_size(GtkWidget,int)",
   "int = g_date_time_get_week_numbering_year(GDateTime)",
   "int = gtk_widget_get_margin_start(GtkWidget)",
   "gtk_text_buffer_insert_pixbuf(GObject,GtkTextIter,GdkPixbuf)",
   "gtk_recent_chooser_set_sort_type(GObject,int)",
   "string = g_file_info_get_content_type(GObject)",
   "ulong = g_binding_flags_get_type()",
   "int = gtk_accel_group_disconnect_key(GObject,uint,int)",
   "GtkOpaque = gtk_places_sidebar_get_nth_bookmark(GtkWidget,int)",
   "ulong = gtk_target_list_get_type()",
   "gtk_notebook_set_action_widget(GtkWidget,GtkWidget,int)",
   "int = gtk_cell_area_get_request_mode(GObject)",
   "int = gtk_print_job_set_source_fd(GObject,int)",
   "pango_font_description_set_gravity(GtkOpaque,int)",
   "GtkWidget = gtk_tree_view_new()",
   "string = g_variant_dup_string(GVariant)",
   "double = gtk_label_get_angle(GtkWidget)",
   "string = gtk_widget_get_name(GtkWidget)",
   "int = gtk_toggle_button_get_active(GtkWidget)",
   "GVariantType = g_variant_type_new_maybe(GVariantType)",
   "ulong = gtk_menu_tool_button_get_type()",
   "string = gtk_window_get_icon_name(GtkWidget)",
   "int = pango_layout_line_get_height(PangoLayoutLine)",
   "int = gtk_printer_accepts_ps(GObject)",
   "string = g_volume_get_sort_key(GtkOpaque)",
   "int = gtk_window_set_icon_from_file(GtkWidget,string)",
   "gtk_tree_model_sort_reset_default_sort_func(GObject)",
   "GObject = gtk_text_tag_new(string)",
   "gtk_print_unix_dialog_set_page_setup(GtkWidget,GObject)",
   "gtk_text_iter_set_line_offset(GtkTextIter,int)",
   "gtk_text_view_add_child_at_anchor(GtkWidget,GtkWidget,GObject)",
   "GtkWidget = gtk_menu_bar_new()",
   "g_file_info_set_is_hidden(GObject,int)",
   "int = g_socket_condition_timed_wait(GObject,int,long,GtkOpaque)",
   "gtk_grid_attach_next_to(GtkWidget,GtkWidget,GtkWidget,int,int,int)",
   "int = g_file_has_parent(GtkOpaque,GtkOpaque)",
   "GdkRectangle = gtk_cell_area_inner_cell_area(GObject,GtkWidget,struct)",
   "GObject = gtk_builder_new_from_resource(string)",
   "int = gtk_widget_has_visible_focus(GtkWidget)",
   "gtk_text_view_reset_im_context(GtkWidget)",
   "gtk_window_set_skip_pager_hint(GtkWidget,int)",
   "gtk_scale_set_has_origin(GtkWidget,int)",
   "int = gtk_text_iter_ends_tag(GtkTextIter,GObject)",
   "GtkOpaque = g_notification_new(string)",
   "gtk_list_box_row_set_activatable(GtkWidget,int)",
   "int = g_app_info_can_delete(GtkOpaque)",
   "GDateTime = g_date_time_new_from_timeval_local(struct)",
   "g_bookmark_file_free(GBookmarkFile)",
   "gtk_widget_queue_resize_no_redraw(GtkWidget)",
   "string = gtk_menu_item_get_label(GtkWidget)",
   "string = g_path_skip_root(string)",
   "gtk_file_chooser_set_select_multiple(GObject,int)",
   "GTimeZone = g_time_zone_new_local()",
   "gtk_file_chooser_set_do_overwrite_confirmation(GObject,int)",
   "gtk_tree_view_set_cursor_on_cell(GtkWidget,GtkTreePath,GtkWidget,GObject,int)",
   "gtk_drag_source_add_text_targets(GtkWidget)",
   "GtkOpaque = g_network_monitor_get_default()",
   "gtk_page_setup_set_orientation(GObject,int)",
   "gtk_print_settings_set_int(GObject,string,int)",
   "gtk_window_set_accept_focus(GtkWidget,int)",
   "ulong = gtk_widget_path_get_type()",
   "GObject = gdk_display_manager_open_display(GObject,string)",
   "gtk_cell_renderer_set_fixed_size(GObject,int,int)",
   "GObject = gtk_scrollable_get_hadjustment(GObject)",
   "GObject = gdk_pixbuf_animation_new_from_resource(string)",
   "int = gtk_text_iter_forward_sentence_end(GtkTextIter)",
   "GObject = gdk_pixbuf_simple_anim_new(int,int,float)",
   "string = g_volume_get_uuid(GtkOpaque)",
   "int = gtk_text_iter_backward_word_start(GtkTextIter)",
   "gtk_entry_set_invisible_char(GtkWidget,uint)",
   "GtkOpaque = g_resolver_lookup_by_name_with_flags_finish(GtkOpaque,GtkOpaque)",
   "int = gdk_pixbuf_get_rowstride(GdkPixbuf)",
   "ulong = g_strlcpy(string,string,ulong)",
   "GtkWidget = gtk_tree_view_column_new()",
   "int = gtk_file_chooser_button_get_width_chars(GtkWidget)",
   "int = g_network_monitor_can_reach_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_print_operation_get_n_pages_to_print(GObject)",
   "g_mount_shadow(GtkOpaque)",
   "int = g_file_info_get_is_hidden(GObject)",
   "int = g_variant_type_is_subtype_of(GVariantType,GVariantType)",
   "int = g_variant_type_is_dict_entry(GVariantType)",
   "ulong = gdk_window_get_type()",
   "int = g_socket_get_listen_backlog(GObject)",
   "ulong = pango_attr_iterator_get_type()",
   "gtk_tool_palette_unset_icon_size(GtkWidget)",
   "string = gtk_accelerator_get_label_with_keycode(GObject,uint,uint,int)",
   "int = gtk_places_sidebar_get_show_connect_to_server(GtkWidget)",
   "int = gtk_switch_get_active(GtkWidget)",
   "gdk_window_begin_paint_rect(GObject,struct)",
   "g_menu_insert_submenu(GObject,int,string,GObject)",
   "ulong = gdk_window_state_get_type()",
   "int = gtk_print_job_get_num_copies(GObject)",
   "gtk_print_operation_set_allow_async(GObject,int)",
   "gtk_image_set_from_icon_set(GtkWidget,GtkOpaque,int)",
   "int = gtk_tree_view_get_fixed_height_mode(GtkWidget)",
   "ulong = g_action_get_type()",
   "GtkWidget = gtk_menu_get_attach_widget(GtkWidget)",
   "gtk_combo_box_set_active_iter(GtkWidget,GtkTreeIter)",
   "gtk_window_set_default_geometry(GtkWidget,int,int)",
   "ulong = pango_font_description_get_type()",
   "gtk_device_grab_remove(GtkWidget,GdkDevice)",
   "gtk_file_chooser_set_current_name(GObject,string)",
   "g_menu_item_set_action_and_target_value(GObject,string,GVariant)",
   "int = gtk_text_buffer_get_modified(GObject)",
   "GtkWidget = gtk_radio_menu_item_new_from_widget(GtkWidget)",
   "GtkOpaque = gtk_places_sidebar_get_location(GtkWidget)",
   "gtk_flow_box_set_max_children_per_line(GtkWidget,uint)",
   "GIOChannel = g_io_channel_unix_new(int)",
   "pango_cairo_update_layout(Cairo,GtkOpaque)",
   "gtk_label_set_use_markup(GtkWidget,int)",
   "gtk_icon_info_free(GObject)",
   "gtk_main_do_event(GdkEvent)",
   "GObject = gtk_scrolled_window_get_hadjustment(GtkWidget)",
   "int = gtk_tree_view_get_enable_search(GtkWidget)",
   "gtk_widget_override_font(GtkWidget,GtkOpaque)",
   "int = g_type_test_flags(ulong,uint)",
   "string = g_mapped_file_get_contents(GMappedFile)",
   "int = gtk_toolbar_get_drop_index(GtkWidget,int,int)",
   "gtk_window_deiconify(GtkWidget)",
   "string = g_content_type_get_mime_dirs()",
   "GtkOpaque = g_vfs_get_default()",
   "int = gtk_application_prefers_app_menu(GObject)",
   "string = g_key_file_get_locale_string(GKeyFile,string,string,string)",
   "GTimeZone = g_date_time_get_timezone(GDateTime)",
   "GtkOpaque = g_file_set_display_name(GtkOpaque,string,GtkOpaque)",
   "PangoLayoutLine = pango_layout_get_line_readonly(GtkOpaque,int)",
   "gtk_text_buffer_remove_all_tags(GObject,GtkTextIter,GtkTextIter)",
   "int = g_type_is_a(ulong,ulong)",
   "string = gtk_menu_item_get_accel_path(GtkWidget)",
   "g_socket_set_listen_backlog(GObject,int)",
   "GtkOpaque = gtk_font_chooser_get_font_map(GObject)",
   "ulong = gtk_print_unix_dialog_get_type()",
   "gtk_widget_reset_style(GtkWidget)",
   "int = gtk_text_view_forward_display_line(GtkWidget,GtkTextIter)",
   "gtk_menu_set_reserve_toggle_size(GtkWidget,int)",
   "string = g_type_name_from_class(GtkOpaque)",
   "gtk_icon_view_set_margin(GtkWidget,int)",
   "gtk_accel_group_connect(GObject,uint,int,int,GtkOpaque)",
   "GtkWidget = gtk_radio_button_new_from_widget(GtkWidget)",
   "gtk_label_set_pattern(GtkWidget,string)",
   "int = gtk_scrollable_get_hscroll_policy(GObject)",
   "GtkWidget = gtk_scale_button_get_popup(GtkWidget)",
   "GtkOpaque = g_resource_new_from_data(GBytes)",
   "Cairo = gtk_icon_view_create_drag_icon(GtkWidget,GtkTreePath)",
   "ulong = gtk_tree_model_get_column_type(GObject,int)",
   "int = gtk_editable_get_editable(GObject)",
   "int = gtk_text_view_place_cursor_onscreen(GtkWidget)",
   "gtk_scrolled_window_set_shadow_type(GtkWidget,int)",
   "g_file_info_set_symbolic_icon(GObject,GtkOpaque)",
   "GVariant = g_variant_new_handle(int)",
   "double = gtk_print_job_get_scale(GObject)",
   "long = gdk_frame_timings_get_frame_counter(GdkFrameTimings)",
   "gdk_device_set_key(GdkDevice,uint,uint,int)",
   "GtkOpaque = g_settings_new(string)",
   "double = gtk_page_setup_get_paper_height(GObject,int)",
   "gtk_accel_map_load_fd(int)",
   "gtk_label_set_angle(GtkWidget,double)",
   "GtkWidget = gtk_drag_get_source_widget(GObject)",
   "gdk_gl_context_get_required_version(GObject,int[],int[])",
   "gtk_css_section_unref(GtkOpaque)",
   "gtk_application_window_set_help_overlay(GtkWidget,GtkWidget)",
   "gdk_window_unmaximize(GObject)",
   "gtk_gl_area_set_has_stencil_buffer(GtkWidget,int)",
   "gdk_window_stick(GObject)",
   "ulong = gtk_scrollbar_get_type()",
   "pango_context_set_language(GtkOpaque,GtkOpaque)",
   "PangoLayoutLine = pango_layout_get_line(GtkOpaque,int)",
   "int = g_unichar_type(uint)",
   "ulong = gtk_window_group_get_type()",
   "gtk_window_set_default_icon(GdkPixbuf)",
   "GObject = gdk_device_get_seat(GdkDevice)",
   "int = gtk_paper_size_is_equal(GtkPaperSize,GtkPaperSize)",
   "gtk_tree_model_filter_set_visible_column(GObject,int)",
   "GtkWidget = gtk_assistant_get_nth_page(GtkWidget,int)",
   "gtk_file_filter_add_pixbuf_formats(GObject)",
   "gtk_cell_area_render(GObject,GObject,GtkWidget,Cairo,struct,struct,int,int)",
   "int = gtk_places_sidebar_get_local_only(GtkWidget)",
   "GtkWidget = gtk_model_button_new()",
   "gtk_text_buffer_place_cursor(GObject,GtkTextIter)",
   "uint = g_key_file_error_quark()",
   "g_menu_remove(GObject,int)",
   "string = gtk_about_dialog_get_version(GtkWidget)",
   "pango_cairo_glyph_string_path(Cairo,GtkOpaque,PangoGlyphString)",
   "gtk_widget_unparent(GtkWidget)",
   "gtk_entry_set_icon_from_stock(GtkWidget,int,string)",
   "GObject = gdk_visual_get_best()",
   "GtkOpaque = pango_attr_size_new(int)",
   "gtk_text_buffer_move_mark(GObject,GObject,GtkTextIter)",
   "PangoAttrList = pango_attr_list_ref(PangoAttrList)",
   "int = gtk_text_view_backward_display_line_start(GtkWidget,GtkTextIter)",
   "int = gtk_scrolled_window_get_min_content_width(GtkWidget)",
   "int = gtk_text_iter_forward_cursor_positions(GtkTextIter,int)",
   "int = gtk_text_iter_backward_sentence_start(GtkTextIter)",
   "GObject = gtk_list_box_get_adjustment(GtkWidget)",
   "gtk_tooltip_set_icon_from_icon_name(GObject,string,int)",
   "gtk_color_button_set_rgba(GtkWidget,struct)",
   "string = g_menu_attribute_iter_get_name(GObject)",
   "gtk_image_set_from_file(GtkWidget,string)",
   "GVariantType = g_variant_type_next(GVariantType)",
   "GtkOpaque = g_file_attribute_matcher_subtract(GtkOpaque,GtkOpaque)",
   "gtk_tree_view_column_set_resizable(GtkWidget,int)",
   "gtk_style_context_set_junction_sides(GObject,int)",
   "ulong = g_volume_monitor_get_type()",
   "GtkOpaque = g_file_new_for_commandline_arg(string)",
   "gdk_window_set_child_input_shapes(GObject)",
   "gtk_list_box_drag_unhighlight_row(GtkWidget)",
   "gtk_menu_bar_set_child_pack_direction(GtkWidget,int)",
   "ulong = pango_context_get_type()",
   "string = g_strcanon(string,string,char)",
   "int = g_time_zone_find_interval(GTimeZone,int,long)",
   "gtk_tree_model_filter_clear_cache(GObject)",
   "int = g_hostname_is_ip_address(string)",
   "int = gdk_window_get_pass_through(GObject)",
   "int = gdk_window_get_support_multidevice(GObject)",
   "int = gdk_pixbuf_format_is_scalable(GtkOpaque)",
   "int = gtk_toolbar_get_item_index(GtkWidget,GtkWidget)",
   "int = gtk_window_get_accept_focus(GtkWidget)",
   "gtk_entry_set_cursor_hadjustment(GtkWidget,GObject)",
   "GtkWidget = gtk_aspect_frame_new(string,float,float,float,int)",
   "gtk_widget_set_margin_top(GtkWidget,int)",
   "ulong = g_settings_schema_source_get_type()",
   "ulong = pango_attribute_get_type()",
   "GObject = gdk_visual_get_system()",
   "gtk_list_box_set_placeholder(GtkWidget,GtkWidget)",
   "int = gtk_notebook_get_current_page(GtkWidget)",
   "int = g_iconv_close(GtkOpaque)",
   "gtk_range_set_restrict_to_fill_level(GtkWidget,int)",
   "ulong = gtk_action_bar_get_type()",
   "int = gdk_window_get_drag_protocol(GObject,GObject[])",
   "int = gtk_text_mark_get_left_gravity(GObject)",
   "gtk_print_operation_preview_end_preview(GObject)",
   "GtkWidget = gtk_radio_button_new_with_label(GtkOpaque[],string)",
   "gtk_action_bar_pack_start(GtkWidget,GtkWidget)",
   "GtkTreePath = gtk_tree_model_get_path(GObject,GtkTreeIter)",
   "string = gtk_file_chooser_get_uri(GObject)",
   "string = g_regex_replace_literal(GRegex,string,long,int,string,int)",
   "GtkWidget = gtk_image_new_from_icon_name(string,int)",
   "GtkOpaque = g_cancellable_get_current()",
   "pango_font_family_list_faces(GtkOpaque,PangoFontFace_ptr_ptr_ptr,int[])",
   "g_timer_continue(GTimer)",
   "GVariant = g_variant_new_boolean(int)",
   "string = gtk_notebook_get_tab_label_text(GtkWidget,GtkWidget)",
   "gtk_window_set_application(GtkWidget,GObject)",
   "uint = gdk_keyval_from_name(string)",
   "GtkOpaque = gtk_widget_get_font_map(GtkWidget)",
   "gtk_style_context_add_class(GObject,string)",
   "int = gtk_tool_shell_get_ellipsize_mode(GObject)",
   "gdk_set_allowed_backends(string)",
   "GObject = gtk_clipboard_get_selection(GObject)",
   "string = gdk_device_get_vendor_id(GdkDevice)",
   "string = gtk_recent_info_last_application(GObject)",
   "int = gtk_cell_renderer_get_sensitive(GObject)",
   "string = gtk_printer_get_name(GObject)",
   "string = g_format_size(ulong)",
   "int = gtk_gesture_swipe_get_velocity(GObject,double[],double[])",
   "gtk_tree_view_set_model(GtkWidget,GObject)",
   "GdkDevice = gdk_event_get_device(GdkEvent)",
   "int = gdk_drag_context_get_actions(GObject)",
   "gtk_list_store_swap(GObject,GtkTreeIter,GtkTreeIter)",
   "gtk_window_set_urgency_hint(GtkWidget,int)",
   "(int,int) = gtk_cell_area_get_preferred_height_for_width(GObject,GObject,GtkWidget,int)",
   "gtk_window_set_gravity(GtkWidget,int)",
   "GVariantType = g_variant_type_new_tuple(GVariantType[],int)",
   "gtk_app_chooser_widget_set_show_other(GtkWidget,int)",
   "g_value_take_string(GtkOpaque,string)",
   "string = gtk_entry_buffer_get_text(GObject)",
   "gtk_notebook_detach_tab(GtkWidget,GtkWidget)",
   "ulong = gdk_crossing_mode_get_type()",
   "int = gdk_drag_context_get_protocol(GObject)",
   "gtk_places_sidebar_set_show_starred_location(GtkWidget,int)",
   "g_bookmark_file_set_added(GBookmarkFile,string,ulong)",
   "string = gtk_accelerator_get_label(uint,int)",
   "gtk_icon_view_set_tooltip_cell(GtkWidget,GObject,GtkTreePath,GObject)",
   "int = g_file_test(string,int)",
   "gtk_grab_remove(GtkWidget)",
   "GSource = g_idle_source_new()",
   "int = gdk_window_has_native(GObject)",
   "gtk_application_set_accels_for_action(GObject,string,string[])",
   "ulong = g_cancellable_get_type()",
   "gtk_widget_set_double_buffered(GtkWidget,int)",
   "int = gtk_notebook_insert_page_menu(GtkWidget,GtkWidget,GtkWidget,GtkWidget,int)",
   "ulong = gtk_tree_row_reference_get_type()",
   "int = gdk_window_ensure_native(GObject)",
   "int = gtk_widget_get_default_direction()",
   "GObject = gtk_icon_theme_get_for_screen(GObject)",
   "string = gtk_icon_info_get_filename(GObject)",
   "string = gtk_label_get_label(GtkWidget)",
   "gdk_pixbuf_loader_set_size(GObject,int,int)",
   "GtkOpaque = g_value_reset(GtkOpaque)",
   "GtkWidget = gtk_toggle_button_new_with_mnemonic(string)",
   "GVariant = g_variant_new_fixed_array(GVariantType,GtkOpaque,ulong,ulong)",
   "GObject = g_file_info_new()",
   "GdkPixbuf = gtk_icon_theme_load_icon(GObject,string,int,int)",
   "gtk_print_unix_dialog_set_embed_page_setup(GtkWidget,int)",
   "int = gtk_print_settings_load_key_file(GObject,GKeyFile,string)",
   "gtk_icon_view_set_item_orientation(GtkWidget,int)",
   "gtk_text_buffer_end_user_action(GObject)",
   "GObject = gtk_entry_get_cursor_hadjustment(GtkWidget)",
   "ulong = gtk_recent_info_get_added(GObject)",
   "string = g_network_address_get_scheme(GtkOpaque)",
   "GtkOpaque = gtk_widget_path_iter_list_classes(GtkWidgetPath,int)",
   "int = g_file_unmount_mountable_with_operation_finish(GtkOpaque,GtkOpaque)",
   "int = gtk_switch_get_state(GtkWidget)",
   "gtk_text_buffer_deserialize_set_can_create_tags(GObject,GObject,int)",
   "gdk_window_move_to_rect(GObject,struct,int,int,int,int,int)",
   "GtkWidget = gtk_image_new_from_surface(Cairo)",
   "GtkOpaque = g_closure_new_object(uint,GObject)",
   "string = g_format_size_full(ulong,int)",
   "int = gtk_tree_store_iter_depth(GObject,GtkTreeIter)",
   "int = g_param_value_validate(GtkOpaque,GtkOpaque)",
   "string = g_binding_get_source_property(GtkOpaque)",
   "int = g_drive_stop_finish(GtkOpaque,GtkOpaque)",
   "string = gtk_text_iter_get_visible_slice(GtkTextIter,GtkTextIter)",
   "ulong = g_bookmark_file_get_visited(GBookmarkFile,string)",
   "(int,int) = gdk_window_get_root_coords(GObject,int,int)",
   "gdk_window_set_skip_pager_hint(GObject,int)",
   "GtkWidget = gtk_dialog_get_header_bar(GtkWidget)",
   "gtk_widget_set_vexpand_set(GtkWidget,int)",
   "int = gtk_search_bar_handle_event(GtkWidget,GdkEvent)",
   "GRand = g_rand_copy(GRand)",
   "int = gdk_pixbuf_loader_write_bytes(GObject,GBytes)",
   "GObject = gtk_widget_get_accessible(GtkWidget)",
   "gtk_menu_reorder_child(GtkWidget,GtkWidget,int)",
   "GObject = gdk_seat_get_display(GObject)",
   "GtkOpaque = gtk_app_chooser_get_app_info(GObject)",
   "g_key_file_set_string(GKeyFile,string,string,string)",
   "gtk_assistant_remove_action_widget(GtkWidget,GtkWidget)",
   "g_random_set_seed(uint)",
   "int = gdk_visual_get_colormap_size(GObject)",
   "int = gtk_info_bar_get_show_close_button(GtkWidget)",
   "int = gtk_clipboard_wait_is_uris_available(GObject)",
   "GtkOpaque = pango_attr_strikethrough_color_new(ushort,ushort,ushort)",
   "int = g_unichar_isupper(uint)",
   "gtk_entry_completion_insert_action_text(GObject,int,string)",
   "ulong = gtk_menu_item_get_type()",
   "int = gtk_tool_shell_get_orientation(GObject)",
   "int = g_ascii_xdigit_value(char)",
   "GtkWidget = gtk_button_new()",
   "string = g_strip_context(string,string)",
   "GtkOpaque = pango_context_get_font_map(GtkOpaque)",
   "uint = g_type_get_type_registration_serial()",
   "g_menu_item_set_attribute_value(GObject,string,GVariant)",
   "string = gtk_widget_get_tooltip_text(GtkWidget)",
   "int = gtk_app_chooser_widget_get_show_other(GtkWidget)",
   "GtkOpaque = pango_layout_iter_get_layout(PangoLayoutIter)",
   "uint = gtk_get_binary_age()",
   "GRegex = g_regex_ref(GRegex)",
   "int = pango_layout_index_to_line_x(GtkOpaque,int,int,int[])",
   "uint = g_variant_parse_error_quark()",
   "int = gdk_pixbuf_get_width(GdkPixbuf)",
   "gtk_accessible_set_widget(GObject,GtkWidget)",
   "gdk_window_set_geometry_hints(GObject,struct,int)",
   "string = gtk_file_filter_get_name(GObject)",
   "GObject = gdk_window_get_effective_parent(GObject)",
   "GtkWidget = gtk_flow_box_get_child_at_pos(GtkWidget,int,int)",
   "int = g_hostname_is_non_ascii(string)",
   "string = g_filename_completer_get_completions(GObject,string)",
   "ulong = gtk_recent_chooser_get_type()",
   "int = gtk_header_bar_get_has_subtitle(GtkWidget)",
   "int = gdk_window_is_visible(GObject)",
   "gtk_render_background(GObject,Cairo,double,double,double,double)",
   "GObject = gtk_text_buffer_get_mark(GObject,string)",
   "GtkOpaque = pango_cairo_font_map_get_default()",
   "GtkOpaque = g_mount_get_icon(GtkOpaque)",
   "gdk_window_get_user_data(GObject,GtkOpaque[])",
   "GObject = gtk_tool_palette_get_drag_target_group()",
   "GtkOpaque = pango_layout_new(GtkOpaque)",
   "GDate = g_date_new()",
   "gtk_notebook_prev_page(GtkWidget)",
   "gdk_window_configure_finished(GObject)",
   "GtkOpaque = g_emblem_get_icon(GObject)",
   "int = g_date_days_between(GDate,GDate)",
   "int = gtk_list_box_get_selection_mode(GtkWidget)",
   "int = gtk_tool_shell_get_icon_size(GObject)",
   "gtk_style_context_invalidate(GObject)",
   "ulong = gtk_text_iter_get_type()",
   "GtkOpaque = pango_cairo_font_map_new()",
   "int = gtk_file_filter_filter(GObject,GObject)",
   "int = gtk_widget_path_append_for_widget(GtkWidgetPath,GtkWidget)",
   "GtkOpaque = gtk_widget_list_accel_closures(GtkWidget)",
   "gtk_stack_set_hhomogeneous(GtkWidget,int)",
   "int = gtk_notebook_page_num(GtkWidget,GtkWidget)",
   "ulong = gtk_paper_size_get_type()",
   "gtk_about_dialog_set_comments(GtkWidget,string)",
   "ulong = gdk_property_state_get_type()",
   "string = g_get_application_name()",
   "gtk_combo_box_set_wrap_width(GtkWidget,int)",
   "ulong = gtk_cell_renderer_combo_get_type()",
   "g_value_set_schar(GtkOpaque,char)",
   "int = g_menu_model_get_n_items(GObject)",
   "int = g_socket_speaks_ipv4(GObject)",
   "int = gtk_text_iter_backward_visible_cursor_position(GtkTextIter)",
   "gtk_list_store_reorder(GObject,int[])",
   "int = g_settings_set_uint64(GtkOpaque,string,ulong)",
   "g_strfreev(string[])",
   "int = g_socket_get_keepalive(GObject)",
   "int = gdk_pointer_is_grabbed()",
   "GtkWidget = gtk_font_button_new_with_font(string)",
   "gdk_display_close(GObject)",
   "GtkOpaque = pango_attr_language_new(GtkOpaque)",
   "double = g_settings_get_double(GtkOpaque,string)",
   "gtk_calendar_set_detail_width_chars(GtkWidget,int)",
   "int = g_content_type_is_unknown(string)",
   "pango_cairo_layout_path(Cairo,GtkOpaque)",
   "int = gtk_range_get_round_digits(GtkWidget)",
   "gtk_tree_view_column_set_reorderable(GtkWidget,int)",
   "g_param_spec_unref(GtkOpaque)",
   "string = g_regex_escape_nul(string,int)",
   "int = gtk_print_job_set_source_file(GObject,string)",
   "int = g_drive_can_poll_for_media(GtkOpaque)",
   "GdkPixbuf = gdk_pixbuf_flip(GdkPixbuf,int)",
   "int = gtk_file_chooser_select_filename(GObject,string)",
   "gtk_adjustment_clamp_page(GObject,double,double)",
   "g_value_set_float(GtkOpaque,float)",
   "GtkOpaque = g_file_attribute_matcher_ref(GtkOpaque)",
   "ulong = gtk_entry_buffer_get_type()",
   "gtk_stack_set_homogeneous(GtkWidget,int)",
   "gtk_spin_button_set_range(GtkWidget,double,double)",
   "int = g_file_query_file_type(GtkOpaque,int,GtkOpaque)",
   "gtk_print_operation_set_track_print_status(GObject,int)",
   "int = gtk_spin_button_get_snap_to_ticks(GtkWidget)",
   "gtk_scrolled_window_set_max_content_width(GtkWidget,int)",
   "GtkOpaque = gtk_file_chooser_list_filters(GObject)",
   "GtkOpaque = gtk_recent_info_get_gicon(GObject)",
   "int = gtk_print_settings_get_collate(GObject)",
   "GObject = gdk_cursor_new_from_name(GObject,string)",
   "gtk_cell_renderer_text_set_fixed_height_from_font(GObject,int)",
   "int = gtk_places_sidebar_get_show_enter_location(GtkWidget)",
   "gtk_render_expander(GObject,Cairo,double,double,double,double)",
   "int = g_key_file_remove_group(GKeyFile,string)",
   "gtk_gesture_single_set_exclusive(GObject,int)",
   "string = gtk_app_chooser_button_get_heading(GtkWidget)",
   "ulong = pango_layout_get_type()",
   "gtk_header_bar_pack_end(GtkWidget,GtkWidget)",
   "uint = gtk_grid_get_column_spacing(GtkWidget)",
   "GtkWidget = gtk_toolbar_get_nth_item(GtkWidget,int)",
   "GtkOpaque = gtk_gesture_get_last_updated_sequence(GObject)",
   "gtk_builder_set_application(GObject,GObject)",
   "gtk_menu_item_toggle_size_request(GtkWidget,int[])",
   "int = gtk_button_get_always_show_image(GtkWidget)",
   "GtkWidget = gtk_separator_tool_item_new()",
   "int = g_io_channel_error_from_errno(int)",
   "gtk_tree_model_filter_refilter(GObject)",
   "ulong = g_initially_unowned_get_type()",
   "g_menu_item_set_submenu(GObject,GObject)",
   "ulong = gdk_pixbuf_format_get_type()",
   "ulong = g_value_get_ulong(GtkOpaque)",
   "gtk_drag_finish(GObject,int,int,uint)",
   "int = g_file_set_attribute_int32(GtkOpaque,string,int,int,GtkOpaque)",
   "g_mount_operation_set_anonymous(GObject,int)",
   "int = gtk_print_operation_get_embed_page_setup(GObject)",
   "gtk_icon_view_select_all(GtkWidget)",
   "GtkWidget = gtk_level_bar_new()",
   "int = gdk_setting_get(string,GtkOpaque)",
   "string = g_file_info_get_attribute_byte_string(GObject,string)",
   "pango_layout_set_justify(GtkOpaque,int)",
   "gtk_widget_set_vexpand(GtkWidget,int)",
   "gtk_icon_view_set_text_column(GtkWidget,int)",
   "gtk_text_view_set_pixels_inside_wrap(GtkWidget,int)",
   "pango_font_descriptions_free(GtkOpaque[],int)",
   "string = g_content_type_get_mime_type(string)",
   "gdk_cairo_region(Cairo,Cairo)",
   "GObject = gdk_cursor_new_for_display(GObject,int)",
   "GtkOpaque = g_value_init(GtkOpaque,ulong)",
   "GObject = gtk_cell_layout_get_area(GObject)",
   "int = gtk_calendar_get_display_options(GtkWidget)",
   "ulong = gtk_search_bar_get_type()",
   "GMainContext = g_main_context_ref_thread_default()",
   "uint = g_utf8_get_char_validated(string,long)",
   "GtkOpaque = gdk_display_list_seats(GObject)",
   "GtkOpaque = g_file_mount_mountable_finish(GtkOpaque,GtkOpaque)",
   "double = gtk_progress_bar_get_fraction(GtkWidget)",
   "ushort = g_ucs4_to_utf16(uint[],long,long[])",
   "(int,int) = gtk_icon_view_convert_widget_to_bin_window_coords(GtkWidget,int,int)",
   "pango_coverage_max(PangoCoverage,PangoCoverage)",
   "gtk_toggle_button_set_inconsistent(GtkWidget,int)",
   "gtk_style_context_add_region(GObject,string,int)",
   "gtk_tree_view_enable_model_drag_dest(GtkWidget,GObject,int,int)",
   "gtk_recent_chooser_unselect_all(GObject)",
   "GtkTreeIter = gtk_tree_model_filter_convert_iter_to_child_iter(GObject,GtkTreeIter)",
   "int = gtk_entry_get_overwrite_mode(GtkWidget)",
   "gtk_widget_set_has_tooltip(GtkWidget,int)",
   "pango_tab_array_free(PangoTabArray)",
   "uchar = gtk_selection_data_get_text(GtkSelectionData)",
   "GtkWidget = gtk_grab_get_current()",
   "ulong = gtk_cell_renderer_text_get_type()",
   "int = gtk_widget_get_visible(GtkWidget)",
   "gtk_widget_show_all(GtkWidget)",
   "ulong = gtk_recent_chooser_dialog_get_type()",
   "int = g_value_get_boolean(GtkOpaque)",
   "g_key_file_set_double_list(GKeyFile,string,string,double[])",
   "gdk_display_warp_pointer(GObject,GObject,int,int)",
   "int = gtk_widget_send_expose(GtkWidget,GdkEvent)",
   "g_value_set_boolean(GtkOpaque,int)",
   "gtk_overlay_set_overlay_pass_through(GtkWidget,GtkWidget,int)",
   "ulong = gtk_scrollable_get_type()",
   "GDateTime = g_date_time_new_from_unix_utc(long)",
   "int = gtk_window_activate_key(GtkWidget,GObject)",
   "int = gtk_label_get_lines(GtkWidget)",
   "int = gtk_clipboard_wait_for_targets(GObject,GdkAtom_ptr_ptr,int[])",
   "string = gtk_entry_get_text(GtkWidget)",
   "int = gdk_screen_get_primary_monitor(GObject)",
   "ulong = gtk_dialog_get_type()",
   "int = gtk_label_get_ellipsize(GtkWidget)",
   "g_menu_model_items_changed(GObject,int,int,int)",
   "gtk_print_settings_to_key_file(GObject,GKeyFile,string)",
   "g_binding_unbind(GtkOpaque)",
   "ulong = gtk_notebook_get_type()",
   "int = gtk_viewport_get_shadow_type(GtkWidget)",
   "int = gtk_true()",
   "ulong = gtk_tool_palette_get_type()",
   "g_file_info_set_sort_order(GObject,int)",
   "int = gdk_window_get_window_type(GObject)",
   "string = gdk_monitor_get_model(GObject)",
   "double = gdk_events_get_distance(GdkEvent,GdkEvent)",
   "GtkOpaque = gtk_gesture_get_sequences(GObject)",
   "int = gtk_tree_view_is_rubber_banding_active(GtkWidget)",
   "int = gtk_style_context_get_direction(GObject)",
   "gtk_tree_view_column_set_widget(GtkWidget,GtkWidget)",
   "int = gtk_entry_get_max_width_chars(GtkWidget)",
   "gtk_spinner_stop(GtkWidget)",
   "GtkOpaque = gtk_size_group_get_widgets(GObject)",
   "int = gtk_css_section_get_section_type(GtkOpaque)",
   "gtk_gesture_single_set_button(GObject,uint)",
   "int = gtk_entry_im_context_filter_keypress(GtkWidget,GObject)",
   "uint = g_date_get_sunday_week_of_year(GDate)",
   "int = g_strv_equal(string[],string[])",
   "GtkOpaque = g_inet_address_mask_new(GObject,uint)",
   "gtk_text_buffer_add_selection_clipboard(GObject,GObject)",
   "int = pango_layout_iter_at_last_line(PangoLayoutIter)",
   "ulong = gdk_seat_get_type()",
   "string = g_utf8_normalize(string,long,int)",
   "int = gtk_paper_size_is_custom(GtkPaperSize)",
   "gtk_drag_set_icon_stock(GObject,string,int,int)",
   "gdk_window_set_icon_list(GObject,GtkOpaque[])",
   "gtk_render_focus(GObject,Cairo,double,double,double,double)",
   "int = gdk_monitor_is_primary(GObject)",
   "pango_renderer_draw_rectangle(GtkOpaque,int,int,int,int,int)",
   "gtk_popover_menu_open_submenu(GtkWidget,string)",
   "int = gdk_pixbuf_get_bits_per_sample(GdkPixbuf)",
   "uint = g_settings_get_uint(GtkOpaque,string)",
   "int = gdk_visual_get_best_depth()",
   "GtkTreeIter = gtk_tree_model_get_iter_first(GObject)",
   "ulong = gtk_font_chooser_get_type()",
   "GtkOpaque = pango_renderer_get_layout(GtkOpaque)",
   "gtk_clipboard_clear(GObject)",
   "g_timer_stop(GTimer)",
   "GObject = gtk_text_view_get_buffer(GtkWidget)",
   "int = gtk_tool_item_get_icon_size(GtkWidget)",
   "GtkWidget = gtk_window_get_default_widget(GtkWidget)",
   "gtk_dialog_set_response_sensitive(GtkWidget,int,int)",
   "GtkTargetList = gtk_target_list_new(GObject,uint)",
   "uint = gtk_revealer_get_transition_duration(GtkWidget)",
   "gtk_container_unset_focus_chain(GtkWidget)",
   "int = gtk_text_iter_backward_word_starts(GtkTextIter,int)",
   "gtk_cell_renderer_set_alignment(GObject,float,float)",
   "gdk_window_destroy(GObject)",
   "string = g_inet_address_mask_to_string(GtkOpaque)",
   "pango_context_set_font_map(GtkOpaque,GtkOpaque)",
   "int = gtk_tree_sortable_get_sort_column_id(GObject,int[],int[])",
   "GdkRGBA = gtk_style_context_get_color(GObject,int)",
   "uint = gdk_event_get_click_count(GdkEvent)",
   "int = gtk_selection_data_targets_include_rich_text(GtkSelectionData,GObject)",
   "(int,int) = gtk_entry_get_layout_offsets(GtkWidget)",
   "gtk_cell_area_remove_focus_sibling(GObject,GObject,GObject)",
   "int = gtk_print_settings_get_resolution_x(GObject)",
   "int = gtk_tool_item_group_get_collapsed(GtkWidget)",
   "int = pango_font_description_better_match(GtkOpaque,GtkOpaque,GtkOpaque)",
   "int = g_socket_leave_multicast_group_ssm(GObject,GObject,GObject,string)",
   "gtk_print_settings_set_reverse(GObject,int)",
   "uint = gtk_tool_item_group_get_n_items(GtkWidget)",
   "GtkWidget = gtk_toggle_button_new_with_label(string)",
   "int = gtk_tool_button_get_use_underline(GtkWidget)",
   "gtk_list_box_select_row(GtkWidget,GtkWidget)",
   "string = g_vfs_get_supported_uri_schemes(GtkOpaque)",
   "gtk_recent_info_unref(GObject)",
   "string = g_file_info_get_display_name(GObject)",
   "gtk_about_dialog_set_program_name(GtkWidget,string)",
   "GObject = gdk_screen_get_display(GObject)",
   "GtkWidget = gtk_tool_palette_get_drop_item(GtkWidget,int,int)",
   "GtkTreePath = gtk_cell_view_get_displayed_row(GtkWidget)",
   "gtk_cell_area_context_allocate(GObject,int,int)",
   "(int,int) = gtk_widget_get_preferred_height_and_baseline_for_width(GtkWidget,int,int[],int[])",
   "int = g_date_valid_month(int)",
   "GObject = gtk_cell_renderer_progress_new()",
   "GtkWidget = gtk_bin_get_child(GtkWidget)",
   "int = gtk_print_job_get_n_up_layout(GObject)",
   "int = gtk_entry_buffer_get_max_length(GObject)",
   "ulong = gtk_widget_get_type()",
   "ulong = gtk_image_get_type()",
   "string = g_match_info_expand_references(GMatchInfo,string)",
   "int = g_variant_type_is_tuple(GVariantType)",
NULL
}; /* }}} */

static void Slirp_usage(int i, int last, int flags) /* {{{ */
{
   char *indent;
   int npop = SLstack_depth();
   if (npop > SLang_Num_Function_Args) npop = SLang_Num_Function_Args;
   SLdo_pop_n(npop);
   if (last == i)
	indent = (char*)"Usage:  ";
   else {
	indent = (char*)"\t";
	SLang_verror(SL_USAGE_ERROR, (char*)"Usage: one of");
   }
   do
	SLang_verror(SL_USAGE_ERROR, (char*)"%s%s", indent, usage_strings[i++]);
   while (i < last);
   if (flags & 0x2)
	SLang_verror(SL_USAGE_ERROR,
		(char*)"\tThis function has been vectorized and parallelized.");
   else if (flags & 0x1)
	SLang_verror(SL_USAGE_ERROR, (char*)"\tThis function has been vectorized.");
} /* }}} */

static SLang_IConstant_Type gtk3_IConsts [] =	/* {{{ */
{
   MAKE_ICONSTANT((char*)"GDK_KEY_Back",0x1008ff26),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_U",0x6f5),
   MAKE_ICONSTANT((char*)"GTK_BASELINE_POSITION_CENTER",GTK_BASELINE_POSITION_CENTER),
   MAKE_ICONSTANT((char*)"G_NETWORK_CONNECTIVITY_PORTAL",G_NETWORK_CONNECTIVITY_PORTAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button1",0xfee9),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_DIR_LTR",GTK_ICON_LOOKUP_DIR_LTR),
   MAKE_ICONSTANT((char*)"GTK_ORIENTATION_HORIZONTAL",GTK_ORIENTATION_HORIZONTAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioRaiseVolume",0x1008ff13),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TIBETAN",G_UNICODE_SCRIPT_TIBETAN),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ri",0x1000d8d),
   MAKE_ICONSTANT((char*)"GDK_hstroke",0x2b1),
   MAKE_ICONSTANT((char*)"GDK_kana_A",0x4b1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Codeinput",0xff37),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_zhe",0x6d6),
   MAKE_ICONSTANT((char*)"GDK_kana_YU",0x4d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_doubleacute",0x1bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhorn",0x10001af),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2368",0x10028a6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_hae",0x10010f0),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ALPHA_FULL",GDK_PIXBUF_ALPHA_FULL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflexgrave",0x1001ec0),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_WA",0x4dc),
   MAKE_ICONSTANT((char*)"GDK_KEY_WebCam",0x1008ff8f),
   MAKE_ICONSTANT((char*)"GDK_AudioMedia",0x1008ff32),
   MAKE_ICONSTANT((char*)"GDK_Spell",0x1008ff7c),
   MAKE_ICONSTANT((char*)"GDK_hebrew_zadi",0xcf6),
   MAKE_ICONSTANT((char*)"GDK_KEY_PreviousCandidate",0xff3e),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_AGE",GTK_RECENT_FILTER_AGE),
   MAKE_ICONSTANT((char*)"GDK_dead_invertedbreve",0xfe6d),
   MAKE_ICONSTANT((char*)"GDK_KEY_babovedot",0x1001e03),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_NORTH_WEST",GDK_WINDOW_EDGE_NORTH_WEST),
   MAKE_ICONSTANT((char*)"GDK_Armenian_KEN",0x100053f),
   MAKE_ICONSTANT((char*)"GDK_KEY_notidentical",0x1002262),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_ICONS",GTK_TOOLBAR_ICONS),
   MAKE_ICONSTANT((char*)"GDK_Arabic_seen",0x5d3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Iacute",0x0cd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_IOTAdieresis",0x7a5),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_NORTH",GDK_GRAVITY_NORTH),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12478",0x10028cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_3",0x10006f3),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_TAG",GTK_BUILDER_ERROR_INVALID_TAG),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_KO",0x4ba),
   MAKE_ICONSTANT((char*)"GDK_F9",0xffc6),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_EXTEND_SELECTION",GDK_MODIFIER_INTENT_EXTEND_SELECTION),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_kuf",0xcf7),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NAME_HAS_NO_OWNER",G_DBUS_ERROR_NAME_HAS_NO_OWNER),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2568",0x10028b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizlinescan1",0x9ef),
   MAKE_ICONSTANT((char*)"GDK_Serbian_NJE",0x6ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftt",0x9f4),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NONE",G_IO_ERROR_NONE),
   MAKE_ICONSTANT((char*)"GTK_IM_PREEDIT_CALLBACK",GTK_IM_PREEDIT_CALLBACK),
   MAKE_ICONSTANT((char*)"GDK_udiaeresis",0x0fc),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_FAULT",G_FILE_ERROR_FAULT),
   MAKE_ICONSTANT((char*)"GDK_dollar",0x024),
   MAKE_ICONSTANT((char*)"GDK_Hangul_I",0xed3),
   MAKE_ICONSTANT((char*)"GDK_OWNERSHIP_APPLICATION",GDK_OWNERSHIP_APPLICATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Massyo",0xff2c),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_STOP_TYPE_UNKNOWN",G_DRIVE_START_STOP_TYPE_UNKNOWN),
   MAKE_ICONSTANT((char*)"T_SRV",33),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HAN",G_UNICODE_SCRIPT_HAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1",0x1002801),
   MAKE_ICONSTANT((char*)"GDK_FrameBack",0x1008ff9d),
   MAKE_ICONSTANT((char*)"G_DATE_THURSDAY",G_DATE_THURSDAY),
   MAKE_ICONSTANT((char*)"GDK_Thai_chochoe",0xdac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SingleCandidate",0xff3c),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ai2",0x1000ddb),
   MAKE_ICONSTANT((char*)"GDK_KEY_hyphen",0x0ad),
   MAKE_ICONSTANT((char*)"GDK_GRAB_BROKEN",GDK_GRAB_BROKEN),
   MAKE_ICONSTANT((char*)"G_TLS_AUTHENTICATION_REQUIRED",G_TLS_AUTHENTICATION_REQUIRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_eabovedot",0x3ec),
   MAKE_ICONSTANT((char*)"GTK_SHADOW_ETCHED_OUT",GTK_SHADOW_ETCHED_OUT),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL",GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL),
   MAKE_ICONSTANT((char*)"GDK_KP_4",0xffb4),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_8",0xffb8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Hanja",0xff34),
   MAKE_ICONSTANT((char*)"GDK_dead_A",0xfe81),
   MAKE_ICONSTANT((char*)"GDK_ISO_Discontinuous_Underline",0xfe31),
   MAKE_ICONSTANT((char*)"G_FILE_TEST_IS_SYMLINK",G_FILE_TEST_IS_SYMLINK),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_PDF",PANGO_BIDI_TYPE_PDF),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_SCALE",PANGO_ATTR_SCALE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Spell",0x1008ff7c),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_DESKTOP",GDK_WINDOW_TYPE_HINT_DESKTOP),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PENDING",G_IO_ERROR_PENDING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_ain",0x5d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_EZH",0x10001b7),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioMute",0x1008ff12),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_comma",0x4a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_10",0xfffa),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDERR_PIPE",G_SUBPROCESS_FLAGS_STDERR_PIPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Discontinuous_Underline",0xfe31),
   MAKE_ICONSTANT((char*)"GDK_Armenian_DA",0x1000534),
   MAKE_ICONSTANT((char*)"GDK_ediaeresis",0x0eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_vertconnector",0x8a6),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflexacute",0x1001ed0),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2348",0x100288e),
   MAKE_ICONSTANT((char*)"GDK_Arabic_zain",0x5d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_heart",0xaee),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_CHE",0x6fe),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Prior",0xff9a),
   MAKE_ICONSTANT((char*)"GDK_Georgian_in",0x10010d8),
   MAKE_ICONSTANT((char*)"GDK_EXPOSURE_MASK",GDK_EXPOSURE_MASK),
   MAKE_ICONSTANT((char*)"GDK_R14",0xffdf),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_468",0x10028a8),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_DOWN",GTK_SCROLL_PAGE_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_yo",0x4ae),
   MAKE_ICONSTANT((char*)"GTK_WRAP_WORD",GTK_WRAP_WORD),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftopentriangle",0xacc),
   MAKE_ICONSTANT((char*)"GDK_Armenian_KHE",0x100053d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Reply",0x1008ff72),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_MA",0x4cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Group_Shift",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_ooblique",0x0f8),
   MAKE_ICONSTANT((char*)"GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH",GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH),
   MAKE_ICONSTANT((char*)"GDK_slash",0x02f),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_CHARACTER_VALUE_TOO_LARGE",G_REGEX_ERROR_CHARACTER_VALUE_TOO_LARGE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_COPTIC",G_UNICODE_SCRIPT_COPTIC),
   MAKE_ICONSTANT((char*)"GDK_ssharp",0x0df),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_RHO",0x7d1),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_SYNTAX",GTK_CSS_PROVIDER_ERROR_SYNTAX),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Ident",0xfd13),
   MAKE_ICONSTANT((char*)"GDK_KEY_F27",0xffd8),
   MAKE_ICONSTANT((char*)"GDK_KP_Page_Down",0xff9b),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_WRONG_ETAG",G_IO_ERROR_WRONG_ETAG),
   MAKE_ICONSTANT((char*)"G_UNIX_SOCKET_ADDRESS_ANONYMOUS",G_UNIX_SOCKET_ADDRESS_ANONYMOUS),
   MAKE_ICONSTANT((char*)"GDK_TOP_SIDE",GDK_TOP_SIDE),
   MAKE_ICONSTANT((char*)"GDK_Armenian_HO",0x1000540),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_NORTH_EAST",GDK_WINDOW_EDGE_NORTH_EAST),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_QUANTIFIERS_OUT_OF_ORDER",G_REGEX_ERROR_QUANTIFIERS_OUT_OF_ORDER),
   MAKE_ICONSTANT((char*)"GTK_REGION_SORTED",GTK_REGION_SORTED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13467",0x100286d),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OLD_NORTH_ARABIAN",PANGO_SCRIPT_OLD_NORTH_ARABIAN),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_DOGRA",G_UNICODE_SCRIPT_DOGRA),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNKNOWN_BACKTRACKING_CONTROL_VERB",G_REGEX_ERROR_UNKNOWN_BACKTRACKING_CONTROL_VERB),
   MAKE_ICONSTANT((char*)"GDK_R7",0xffd8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_COMMON",PANGO_SCRIPT_COMMON),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_vo",0x1000578),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_CARRIAGE_RETURN",G_UNICODE_BREAK_CARRIAGE_RETURN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ndha",0x1000db3),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Ieung",0xee8),
   MAKE_ICONSTANT((char*)"GDK_A",0x041),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_RESULT_IN_PROGRESS",GTK_PRINT_OPERATION_RESULT_IN_PROGRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123578",0x10028d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sabovedot",0x1001e60),
   MAKE_ICONSTANT((char*)"GDK_Acircumflex",0x0c2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Page_Down",0xff56),
   MAKE_ICONSTANT((char*)"GDK_eabovedot",0x3ec),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftanglebracket",0xabc),
   MAKE_ICONSTANT((char*)"GDK_KEY_R2",0xffd3),
   MAKE_ICONSTANT((char*)"GDK_3270_PrintScreen",0xfd1d),
   MAKE_ICONSTANT((char*)"GDK_Launch9",0x1008ff49),
   MAKE_ICONSTANT((char*)"G_TLS_INTERACTION_UNHANDLED",G_TLS_INTERACTION_UNHANDLED),
   MAKE_ICONSTANT((char*)"GDK_Insert",0xff63),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_14568",0x10028b9),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_NONE",GTK_BUTTONS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_teh",0x5ca),
   MAKE_ICONSTANT((char*)"GDK_SB_DOWN_ARROW",GDK_SB_DOWN_ARROW),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_10",0x1008fe0a),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_blank",0x1002800),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_VERTICAL_WRITING",GTK_INPUT_HINT_VERTICAL_WRITING),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_PAD_FEATURE_RING",GDK_DEVICE_PAD_FEATURE_RING),
   MAKE_ICONSTANT((char*)"GDK_onehalf",0x0bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_CHI",0x7d7),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_29_MASK",GDK_MODIFIER_RESERVED_29_MASK),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_ANCHORED",G_REGEX_MATCH_ANCHORED),
   MAKE_ICONSTANT((char*)"GDK_KEY_semicolon",0x03b),
   MAKE_ICONSTANT((char*)"GDK_Thai_totao",0xdb5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Return",0xff0d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2368",0x10028a6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch1",0x1008ff41),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_MESSAGE_BUS_CONNECTION",G_DBUS_CONNECTION_FLAGS_MESSAGE_BUS_CONNECTION),
   MAKE_ICONSTANT((char*)"GDK_Itilde",0x3a5),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13578",0x10028d5),
   MAKE_ICONSTANT((char*)"GDK_R11",0xffdc),
   MAKE_ICONSTANT((char*)"GDK_PROXIMITY_OUT_MASK",GDK_PROXIMITY_OUT_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_ScrollDown",0x1008ff79),
   MAKE_ICONSTANT((char*)"GDK_PROPERTY_NOTIFY",GDK_PROPERTY_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_NJE",0x6ba),
   MAKE_ICONSTANT((char*)"GDK_Launch6",0x1008ff46),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_LINUX_UCRED",G_CREDENTIALS_TYPE_LINUX_UCRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_TCHE",0x1000543),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_en_descender",0x10004a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_verjaket",0x1000589),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ka_vertstroke",0x100049d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_DELTA",0x7c4),
   MAKE_ICONSTANT((char*)"G_NUMBER_PARSER_ERROR_OUT_OF_BOUNDS",G_NUMBER_PARSER_ERROR_OUT_OF_BOUNDS),
   MAKE_ICONSTANT((char*)"GDK_Armenian_accent",0x100055b),
   MAKE_ICONSTANT((char*)"G_DATE_BAD_WEEKDAY",G_DATE_BAD_WEEKDAY),
   MAKE_ICONSTANT((char*)"GDK_3270_Ident",0xfd13),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eabovedot",0x3cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_PieubSios",0xee5),
   MAKE_ICONSTANT((char*)"GDK_Greek_finalsmallsigma",0x7f3),
   MAKE_ICONSTANT((char*)"GDK_KEY_PesetaSign",0x10020a7),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_UP",GTK_STACK_TRANSITION_TYPE_OVER_UP),
   MAKE_ICONSTANT((char*)"GDK_ecircumflexbelowdot",0x1001ec7),
   MAKE_ICONSTANT((char*)"GDK_ocircumflexacute",0x1001ed1),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_STOP_TYPE_NETWORK",G_DRIVE_START_STOP_TYPE_NETWORK),
   MAKE_ICONSTANT((char*)"GDK_emfilledcircle",0xade),
   MAKE_ICONSTANT((char*)"G_RESOLVER_RECORD_MX",G_RESOLVER_RECORD_MX),
   MAKE_ICONSTANT((char*)"GDK_Armenian_yech",0x1000565),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_4",0x1008fe04),
   MAKE_ICONSTANT((char*)"PANGO_WRAP_WORD_CHAR",PANGO_WRAP_WORD_CHAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_TSO",0x1000551),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_NONE",GDK_SUBPIXEL_LAYOUT_NONE),
   MAKE_ICONSTANT((char*)"G_REGEX_JAVASCRIPT_COMPAT",G_REGEX_JAVASCRIPT_COMPAT),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_dzhe",0x6af),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Partial_Space_Left",0xfe25),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_lje",0x6a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_267",0x1002862),
   MAKE_ICONSTANT((char*)"GDK_leftradical",0x8a1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_tah",0x5d7),
   MAKE_ICONSTANT((char*)"GDK_Armenian_LYUN",0x100053c),
   MAKE_ICONSTANT((char*)"GDK_TABLET_PAD_MASK",GDK_TABLET_PAD_MASK),
   MAKE_ICONSTANT((char*)"GDK_Armenian_za",0x1000566),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_MATCH_RULE_NOT_FOUND",G_DBUS_ERROR_MATCH_RULE_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_kana_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_137",0x1002845),
   MAKE_ICONSTANT((char*)"PANGO_RENDER_PART_UNDERLINE",PANGO_RENDER_PART_UNDERLINE),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_IO_ERROR",G_DBUS_ERROR_IO_ERROR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Green",0x1008ffa4),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulKiyeog",0xeaa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_tche",0x1000573),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_20_MASK",GDK_MODIFIER_RESERVED_20_MASK),
   MAKE_ICONSTANT((char*)"GDK_HINT_POS",GDK_HINT_POS),
   MAKE_ICONSTANT((char*)"PANGO_UNDERLINE_ERROR",PANGO_UNDERLINE_ERROR),
   MAKE_ICONSTANT((char*)"G_NOTIFICATION_PRIORITY_URGENT",G_NOTIFICATION_PRIORITY_URGENT),
   MAKE_ICONSTANT((char*)"GDK_Begin",0xff58),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ya",0x1000dba),
   MAKE_ICONSTANT((char*)"PANGO_UNDERLINE_DOUBLE",PANGO_UNDERLINE_DOUBLE),
   MAKE_ICONSTANT((char*)"G_DATE_YEAR",G_DATE_YEAR),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_DIRECTORY",G_IO_ERROR_NOT_DIRECTORY),
   MAKE_ICONSTANT((char*)"GDK_doubleacute",0x1bd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GLAGOLITIC",G_UNICODE_SCRIPT_GLAGOLITIC),
   MAKE_ICONSTANT((char*)"GDK_Hangul_AraeA",0xef6),
   MAKE_ICONSTANT((char*)"GDK_KbdLightOnOff",0x1008ff04),
   MAKE_ICONSTANT((char*)"GDK_F32",0xffdd),
   MAKE_ICONSTANT((char*)"GDK_bar",0x07c),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2358",0x1002896),
   MAKE_ICONSTANT((char*)"GDK_KEY_ebelowdot",0x1001eb9),
   MAKE_ICONSTANT((char*)"GDK_LaunchE",0x1008ff4e),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_EXIST",G_FILE_ERROR_EXIST),
   MAKE_ICONSTANT((char*)"GDK_KEY_h",0x068),
   MAKE_ICONSTANT((char*)"GDK_Georgian_char",0x10010ed),
   MAKE_ICONSTANT((char*)"GDK_3270_Duplicate",0xfd01),
   MAKE_ICONSTANT((char*)"GDK_AXIS_DISTANCE",GDK_AXIS_DISTANCE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1235678",0x10028f7),
   MAKE_ICONSTANT((char*)"GDK_ColonSign",0x10020a1),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_REGULAR",G_FILE_TYPE_REGULAR),
   MAKE_ICONSTANT((char*)"GTK_PLACES_OPEN_NORMAL",GTK_PLACES_OPEN_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_onesixth",0xab6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12358",0x1002897),
   MAKE_ICONSTANT((char*)"GDK_KEY_igrave",0x0ec),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_368",0x10028a4),
   MAKE_ICONSTANT((char*)"GDK_downcaret",0xba8),
   MAKE_ICONSTANT((char*)"GDK_Explorer",0x1008ff5d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Gabovedot",0x2d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_16",0x1002821),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12567",0x1002873),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_yeh",0x10006cc),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_ICONTHEME",GTK_DEBUG_ICONTHEME),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ka_vertstroke",0x100049d),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_SUCCESS",GTK_DRAG_RESULT_SUCCESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_yoying",0xdad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Terminal",0x1008ff80),
   MAKE_ICONSTANT((char*)"GDK_ISO_Prev_Group_Lock",0xfe0b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_38",0x1002884),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_1",0xfff1),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_SOUTH",GDK_WINDOW_EDGE_SOUTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SsangSios",0xeb6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ve",0x6d7),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick3",0xfef1),
   MAKE_ICONSTANT((char*)"GDK_KP_3",0xffb3),
   MAKE_ICONSTANT((char*)"GDK_ClearGrab",0x1008fe21),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_taw",0xcfa),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_kaph",0xceb),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SsangSios",0xeb6),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_FAILED",GDK_PIXBUF_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"GDK_kana_I",0x4b2),
   MAKE_ICONSTANT((char*)"GDK_circle",0xbcf),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1246",0x100282b),
   MAKE_ICONSTANT((char*)"GTK_STYLE_PROVIDER_PRIORITY_FALLBACK",1),
   MAKE_ICONSTANT((char*)"GDK_KEY_1",0x031),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_KEY_NOT_FOUND",G_KEY_FILE_ERROR_KEY_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button2",0xfeea),
   MAKE_ICONSTANT((char*)"GDK_kana_SA",0x4bb),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_FILE_NOT_FOUND",G_BOOKMARK_FILE_ERROR_FILE_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_NO_DROP",GTK_ICON_VIEW_NO_DROP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Redo",0xff66),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_u_straight",0x10004af),
   MAKE_ICONSTANT((char*)"GDK_quotedbl",0x022),
   MAKE_ICONSTANT((char*)"GDK_Shift_R",0xffe2),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_BYTE",G_VARIANT_CLASS_BYTE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Search",0x1008ff1b),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NOTEOL",G_REGEX_MATCH_NOTEOL),
   MAKE_ICONSTANT((char*)"GDK_ERROR_PARAM",GDK_ERROR_PARAM),
   MAKE_ICONSTANT((char*)"GDK_BOTTOM_SIDE",GDK_BOTTOM_SIDE),
   MAKE_ICONSTANT((char*)"GDK_period",0x02e),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_ACTION_PRINT",GTK_PRINT_OPERATION_ACTION_PRINT),
   MAKE_ICONSTANT((char*)"GTK_ALIGN_FILL",GTK_ALIGN_FILL),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_NOT_SUPPORTED_IN_CLASS",G_REGEX_ERROR_NOT_SUPPORTED_IN_CLASS),
   MAKE_ICONSTANT((char*)"GDK_d",0x064),
   MAKE_ICONSTANT((char*)"GDK_INTERP_NEAREST",GDK_INTERP_NEAREST),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_A",0x4b1),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_URL",GTK_INPUT_PURPOSE_URL),
   MAKE_ICONSTANT((char*)"GDK_KEY_nabla",0x8c5),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_POINTER",GDK_SEAT_CAPABILITY_POINTER),
   MAKE_ICONSTANT((char*)"GDK_Iabovedot",0x2a9),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_LINE_FEED",G_UNICODE_BREAK_LINE_FEED),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_EMAIL",GTK_INPUT_PURPOSE_EMAIL),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_WEST",GDK_GRAVITY_WEST),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_CONDITION",G_REGEX_ERROR_INVALID_CONDITION),
   MAKE_ICONSTANT((char*)"GDK_n",0x06e),
   MAKE_ICONSTANT((char*)"GDK_IRON_CROSS",GDK_IRON_CROSS),
   MAKE_ICONSTANT((char*)"GDK_Forward",0x1008ff27),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_xan",0x10010ee),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_124",0x100280b),
   MAKE_ICONSTANT((char*)"GDK_rcedilla",0x3b3),
   MAKE_ICONSTANT((char*)"GDK_Arabic_question_mark",0x5bf),
   MAKE_ICONSTANT((char*)"GDK_Start",0x1008ff1a),
   MAKE_ICONSTANT((char*)"GDK_Armenian_men",0x1000574),
   MAKE_ICONSTANT((char*)"GDK_KEY_eacute",0x0e9),
   MAKE_ICONSTANT((char*)"GDK_Adiaeresis",0x0c4),
   MAKE_ICONSTANT((char*)"GDK_Georgian_tar",0x10010e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_gamma",0x7e3),
   MAKE_ICONSTANT((char*)"GDK_W",0x057),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_OFFSCREEN",GDK_WINDOW_OFFSCREEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflextilde",0x1001ec4),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_VALUE",GTK_CSS_SECTION_VALUE),
   MAKE_ICONSTANT((char*)"GDK_filledtribulletup",0xae8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_6",0x1000666),
   MAKE_ICONSTANT((char*)"GTK_DIR_UP",GTK_DIR_UP),
   MAKE_ICONSTANT((char*)"GDK_KEY_ugrave",0x0f9),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_NUMBER_TOO_BIG",G_VARIANT_PARSE_ERROR_NUMBER_TOO_BIG),
   MAKE_ICONSTANT((char*)"GDK_Thai_hohip",0xdcb),
   MAKE_ICONSTANT((char*)"GDK_KEY_RELEASE",GDK_KEY_RELEASE),
   MAKE_ICONSTANT((char*)"G_ASCII_DIGIT",G_ASCII_DIGIT),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Rieul",0xedb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_5678",0x10028f0),
   MAKE_ICONSTANT((char*)"GDK_KEY_dstroke",0x1f0),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_SsangSios",0xee7),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ghe_bar",0x1000493),
   MAKE_ICONSTANT((char*)"GDK_Ntilde",0x0d1),
   MAKE_ICONSTANT((char*)"GDK_Armenian_lyun",0x100056c),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_12",0x1008fe0c),
   MAKE_ICONSTANT((char*)"GDK_KEY_k",0x06b),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK",GDK_MODIFIER_INTENT_DEFAULT_MOD_MASK),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_RIDGE",GTK_BORDER_STYLE_RIDGE),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_SURFACE",GTK_IMAGE_SURFACE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_i_macron",0x10004e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_crossinglines",0x9ee),
   MAKE_ICONSTANT((char*)"GDK_KEY_doubledagger",0xaf2),
   MAKE_ICONSTANT((char*)"GDK_LEFT_TEE",GDK_LEFT_TEE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HATRAN",G_UNICODE_SCRIPT_HATRAN),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NOSYS",G_FILE_ERROR_NOSYS),
   MAKE_ICONSTANT((char*)"G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS",G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS),
   MAKE_ICONSTANT((char*)"GTK_TOOL_PALETTE_DRAG_GROUPS",GTK_TOOL_PALETTE_DRAG_GROUPS),
   MAKE_ICONSTANT((char*)"GDK_amacron",0x3e0),
   MAKE_ICONSTANT((char*)"G_TYPE_FUNDAMENTAL_SHIFT",2),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12345678",0x10028ff),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1",0x1002801),
   MAKE_ICONSTANT((char*)"GDK_KEY_Control_L",0xffe3),
   MAKE_ICONSTANT((char*)"GDK_Abrevehook",0x1001eb2),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_FAILED",G_DBUS_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_parenright",0x029),
   MAKE_ICONSTANT((char*)"GDK_Armenian_dza",0x1000571),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maitaikhu",0xde7),
   MAKE_ICONSTANT((char*)"GDK_KEY_odiaeresis",0x0f6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_EM",0x6ed),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_NEWLINE_TYPE_CR",G_DATA_STREAM_NEWLINE_TYPE_CR),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_I",0x6b6),
   MAKE_ICONSTANT((char*)"GDK_Armenian_KE",0x1000554),
   MAKE_ICONSTANT((char*)"GDK_L2",0xffc9),
   MAKE_ICONSTANT((char*)"GDK_kana_NA",0x4c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_VYUN",0x1000552),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YE",0xec6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_el",0x6cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Udoubleacute",0x1db),
   MAKE_ICONSTANT((char*)"GDK_BASED_ARROW_UP",GDK_BASED_ARROW_UP),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflextilde",0x1001eab),
   MAKE_ICONSTANT((char*)"GDK_KEY_dabovedot",0x1001e0b),
   MAKE_ICONSTANT((char*)"GTK_PRINT_QUALITY_LOW",GTK_PRINT_QUALITY_LOW),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_SORTED",GTK_CELL_RENDERER_SORTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Up",0xff52),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_UPPERCASE_SENTENCES",GTK_INPUT_HINT_UPPERCASE_SENTENCES),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HANGUL_LVT_SYLLABLE",G_UNICODE_BREAK_HANGUL_LVT_SYLLABLE),
   MAKE_ICONSTANT((char*)"GDK_GL_ERROR_UNSUPPORTED_PROFILE",GDK_GL_ERROR_UNSUPPORTED_PROFILE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MALAYALAM",G_UNICODE_SCRIPT_MALAYALAM),
   MAKE_ICONSTANT((char*)"GDK_Terminal",0x1008ff80),
   MAKE_ICONSTANT((char*)"GDK_KEY_less",0x03c),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightdoublequotemark",0xad3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23456",0x100283e),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_OBJECT_TYPE_REFUSED",GTK_BUILDER_ERROR_OBJECT_TYPE_REFUSED),
   MAKE_ICONSTANT((char*)"GDK_Eabovedot",0x3cc),
   MAKE_ICONSTANT((char*)"GDK_J",0x04a),
   MAKE_ICONSTANT((char*)"GDK_sevensuperior",0x1002077),
   MAKE_ICONSTANT((char*)"GTK_EVENT_SEQUENCE_DENIED",GTK_EVENT_SEQUENCE_DENIED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_comma",0x5ac),
   MAKE_ICONSTANT((char*)"GDK_FOCUS_CHANGE_MASK",GDK_FOCUS_CHANGE_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_P",0x050),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_DELAY_MESSAGE_PROCESSING",G_DBUS_CONNECTION_FLAGS_DELAY_MESSAGE_PROCESSING),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_NONE",GTK_RESPONSE_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12458",0x100289b),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhornacute",0x1001ee9),
   MAKE_ICONSTANT((char*)"GDK_KEY_mabovedot",0x1001e41),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulPieub",0xeac),
   MAKE_ICONSTANT((char*)"GDK_Oslash",0x0d8),
   MAKE_ICONSTANT((char*)"GDK_mabovedot",0x1001e41),
   MAKE_ICONSTANT((char*)"G_APP_INFO_CREATE_SUPPORTS_STARTUP_NOTIFICATION",G_APP_INFO_CREATE_SUPPORTS_STARTUP_NOTIFICATION),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_DOWN",GDK_SCROLL_DOWN),
   MAKE_ICONSTANT((char*)"GDK_GL_ERROR_NOT_AVAILABLE",GDK_GL_ERROR_NOT_AVAILABLE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_tteh",0x1000679),
   MAKE_ICONSTANT((char*)"GDK_KEY_marker",0xabf),
   MAKE_ICONSTANT((char*)"GTK_IM_PREEDIT_NONE",GTK_IM_PREEDIT_NONE),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NEWLINE_LF",G_REGEX_MATCH_NEWLINE_LF),
   MAKE_ICONSTANT((char*)"GDK_End",0xff57),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_FAILED",G_VARIANT_PARSE_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_PERSIAN",G_UNICODE_SCRIPT_OLD_PERSIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch6",0x1008ff46),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_dzhe",0x6af),
   MAKE_ICONSTANT((char*)"GDK_acircumflextilde",0x1001eab),
   MAKE_ICONSTANT((char*)"PANGO_COVERAGE_EXACT",PANGO_COVERAGE_EXACT),
   MAKE_ICONSTANT((char*)"GDK_Obelowdot",0x1001ecc),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ERROR_NONEXISTENT",GTK_FILE_CHOOSER_ERROR_NONEXISTENT),
   MAKE_ICONSTANT((char*)"GDK_DRAG_MOTION",GDK_DRAG_MOTION),
   MAKE_ICONSTANT((char*)"GTK_CORNER_BOTTOM_LEFT",GTK_CORNER_BOTTOM_LEFT),
   MAKE_ICONSTANT((char*)"G_ASCII_XDIGIT",G_ASCII_XDIGIT),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_COMPLEX_CONTEXT",G_UNICODE_BREAK_COMPLEX_CONTEXT),
   MAKE_ICONSTANT((char*)"GDK_imacron",0x3ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_NU",0x4c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_A",0x041),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TIRHUTA",G_UNICODE_SCRIPT_TIRHUTA),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_horn",0xfe62),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_37",0x1002844),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NODEV",G_FILE_ERROR_NODEV),
   MAKE_ICONSTANT((char*)"GDK_Agrave",0x0c0),
   MAKE_ICONSTANT((char*)"GDK_RTL_LOGO",GDK_RTL_LOGO),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NXIO",G_FILE_ERROR_NXIO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_YI",0x6b7),
   MAKE_ICONSTANT((char*)"GTK_POLICY_EXTERNAL",GTK_POLICY_EXTERNAL),
   MAKE_ICONSTANT((char*)"GDK_Support",0x1008ff7e),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BUGINESE",G_UNICODE_SCRIPT_BUGINESE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_258",0x1002892),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_don",0x10010d3),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_NKO",PANGO_SCRIPT_NKO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Agrave",0x0c0),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_IS_READABLE",G_IO_FLAG_IS_READABLE),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_SIZE_REQUEST",GTK_DEBUG_SIZE_REQUEST),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_STATIC",GDK_GRAVITY_STATIC),
   MAKE_ICONSTANT((char*)"GDK_digitspace",0xaa5),
   MAKE_ICONSTANT((char*)"GDK_caron",0x1b7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SsangJieuj",0xeb9),
   MAKE_ICONSTANT((char*)"GDK_Greek_PSI",0x7d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13467",0x100286d),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_NOT_FOUND",G_KEY_FILE_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ke",0x1000584),
   MAKE_ICONSTANT((char*)"GDK_KEY_lf",0x9e5),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_TEXT",GTK_TEXT_WINDOW_TEXT),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_SIGNATURE",G_VARIANT_CLASS_SIGNATURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_FU",0x4cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_I",0x6e9),
   MAKE_ICONSTANT((char*)"GTK_PRINT_ERROR_INVALID_FILE",GTK_PRINT_ERROR_INVALID_FILE),
   MAKE_ICONSTANT((char*)"GDK_c_h",0xfea3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_234578",0x10028de),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MAHAJANI",PANGO_SCRIPT_MAHAJANI),
   MAKE_ICONSTANT((char*)"GDK_Pointer_UpLeft",0xfee4),
   MAKE_ICONSTANT((char*)"GTK_PRIORITY_RESIZE",110),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_shorti",0x6ca),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_ABSOLUTE_SIZE",PANGO_ATTR_ABSOLUTE_SIZE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamzaonwaw",0x5c4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YA",0xec1),
   MAKE_ICONSTANT((char*)"GDK_KEY_mu",0x0b5),
   MAKE_ICONSTANT((char*)"GTK_DIR_TAB_BACKWARD",GTK_DIR_TAB_BACKWARD),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ken",0x100056f),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_NOFOLLOW_SYMLINKS",G_FILE_COPY_NOFOLLOW_SYMLINKS),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_I",0x4b2),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SsangKiyeog",0xea2),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_CS",PANGO_BIDI_TYPE_CS),
   MAKE_ICONSTANT((char*)"GDK_Acircumflexgrave",0x1001ea6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hstroke",0x2a1),
   MAKE_ICONSTANT((char*)"GDK_DECOR_MAXIMIZE",GDK_DECOR_MAXIMIZE),
   MAKE_ICONSTANT((char*)"GDK_oslash",0x0f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Imacron",0x3cf),
   MAKE_ICONSTANT((char*)"GDK_Tcaron",0x1ab),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalzadi",0xcf5),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_TREE",GTK_DEBUG_TREE),
   MAKE_ICONSTANT((char*)"GDK_Thai_fofan",0xdbf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_question_mark",0x5bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Babovedot",0x1001e02),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_OVERFLOW",G_IO_CHANNEL_ERROR_OVERFLOW),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_CONNECTED",G_SOCKET_CLIENT_CONNECTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2578",0x10028d2),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_INT16",G_VARIANT_CLASS_INT16),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INPUT_NOT_AT_END",G_VARIANT_PARSE_ERROR_INPUT_NOT_AT_END),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ka_descender",0x100049b),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_GEOMETRY",GTK_DEBUG_GEOMETRY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_lje",0x6a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_iotadieresis",0x7b5),
   MAKE_ICONSTANT((char*)"GDK_History",0x1008ff37),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_EMBEDDED_NUL",G_CONVERT_ERROR_EMBEDDED_NUL),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflexacute",0x1001ebf),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_CONTEXT_MENU",GDK_MODIFIER_INTENT_CONTEXT_MENU),
   MAKE_ICONSTANT((char*)"G_UNICODE_MODIFIER_LETTER",G_UNICODE_MODIFIER_LETTER),
   MAKE_ICONSTANT((char*)"GDK_Farsi_1",0x10006f1),
   MAKE_ICONSTANT((char*)"GDK_Thai_thanthakhat",0xdec),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cancel",0xff69),
   MAKE_ICONSTANT((char*)"GDK_threeeighths",0xac4),
   MAKE_ICONSTANT((char*)"GDK_KP_Insert",0xff9e),
   MAKE_ICONSTANT((char*)"GTK_STATE_INSENSITIVE",GTK_STATE_INSENSITIVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_dse",0x6a5),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_FORWARD",GTK_SCROLL_STEP_FORWARD),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12",0x1002803),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Setup",0xfd17),
   MAKE_ICONSTANT((char*)"GDK_3270_Left2",0xfd04),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_GRID_LINES_BOTH",GTK_TREE_VIEW_GRID_LINES_BOTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_sha",0x1000dc1),
   MAKE_ICONSTANT((char*)"GDK_oneeighth",0xac3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_247",0x100284a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ncaron",0x1d2),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_INSENSITIVE",GTK_CELL_RENDERER_INSENSITIVE),
   MAKE_ICONSTANT((char*)"GTK_PACK_DIRECTION_RTL",GTK_PACK_DIRECTION_RTL),
   MAKE_ICONSTANT((char*)"GDK_emacron",0x3ba),
   MAKE_ICONSTANT((char*)"G_REGEX_FIRSTLINE",G_REGEX_FIRSTLINE),
   MAKE_ICONSTANT((char*)"G_FORMAT_SIZE_IEC_UNITS",G_FORMAT_SIZE_IEC_UNITS),
   MAKE_ICONSTANT((char*)"GDK_Thai_lekha",0xdf5),
   MAKE_ICONSTANT((char*)"GTK_FILE_FILTER_DISPLAY_NAME",GTK_FILE_FILTER_DISPLAY_NAME),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2346",0x100282e),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_PRIMARY",1),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowmacron",0xfe68),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_RELEASE_MASK",GDK_BUTTON_RELEASE_MASK),
   MAKE_ICONSTANT((char*)"GTK_REGION_LAST",GTK_REGION_LAST),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_REQUIRED",G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_REQUIRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraaa",0xdd2),
   MAKE_ICONSTANT((char*)"GDK_lacute",0x1e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_u",0x075),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_NUMBER_OUT_OF_RANGE",G_VARIANT_PARSE_ERROR_NUMBER_OUT_OF_RANGE),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ya",0x1000dba),
   MAKE_ICONSTANT((char*)"GDK_Thai_lu",0xdc6),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_STATE_CHANGED",GDK_CROSSING_STATE_CHANGED),
   MAKE_ICONSTANT((char*)"GDK_Arabic_peh",0x100067e),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_OLE2",GDK_DRAG_PROTO_OLE2),
   MAKE_ICONSTANT((char*)"GDK_KEY_eth",0x0f0),
   MAKE_ICONSTANT((char*)"GDK_club",0xaec),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_ADDRESS_IN_USE",G_DBUS_ERROR_ADDRESS_IN_USE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_em",0x6cd),
   MAKE_ICONSTANT((char*)"GDK_KEY_F15",0xffcc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_zhar",0x10010df),
   MAKE_ICONSTANT((char*)"GDK_Cacute",0x1c6),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_IDEOGRAPHIC",G_UNICODE_BREAK_IDEOGRAPHIC),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDERR_SILENCE",G_SUBPROCESS_FLAGS_STDERR_SILENCE),
   MAKE_ICONSTANT((char*)"GDK_KEY_ydiaeresis",0x0ff),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_58",0x1002890),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_dda",0x1000da9),
   MAKE_ICONSTANT((char*)"GDK_Down",0xff54),
   MAKE_ICONSTANT((char*)"GDK_onethird",0xab0),
   MAKE_ICONSTANT((char*)"GDK_KEY_ballotcross",0xaf4),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_stroke",0xfe63),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_236",0x1002826),
   MAKE_ICONSTANT((char*)"GTK_PRINT_QUALITY_NORMAL",GTK_PRINT_QUALITY_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohornhook",0x1001ede),
   MAKE_ICONSTANT((char*)"GDK_Prior",0xff55),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MEROITIC_HIEROGLYPHS",PANGO_SCRIPT_MEROITIC_HIEROGLYPHS),
   MAKE_ICONSTANT((char*)"GDK_kana_O",0x4b5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_56",0x1002830),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eth",0x0d0),
   MAKE_ICONSTANT((char*)"GDK_dintegral",0x100222c),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_FOCUSED",GTK_CELL_RENDERER_FOCUSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tslash",0x3ac),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_INVERT_BOOLEAN",G_SETTINGS_BIND_INVERT_BOOLEAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_o",0xfe86),
   MAKE_ICONSTANT((char*)"PANGO_ALIGN_LEFT",PANGO_ALIGN_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_questiondown",0x0bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_bracketleft",0x05b),
   MAKE_ICONSTANT((char*)"GDK_Next_VMode",0x1008fe22),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioCycleTrack",0x1008ff9b),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Set_Margin_Right",0xfe28),
   MAKE_ICONSTANT((char*)"G_IO_IN",G_IO_IN),
   MAKE_ICONSTANT((char*)"GDK_Close",0x1008ff56),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_48",0x1002888),
   MAKE_ICONSTANT((char*)"GDK_KEY_Suspend",0x1008ffa7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HANUNOO",PANGO_SCRIPT_HANUNOO),
   MAKE_ICONSTANT((char*)"GDK_Hangul_switch",0xff7e),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_OBJECT",G_FILE_ATTRIBUTE_TYPE_OBJECT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zcaron",0x1ae),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ybelowdot",0x1001ef4),
   MAKE_ICONSTANT((char*)"GDK_KEY_ifonlyif",0x8cd),
   MAKE_ICONSTANT((char*)"GDK_Arabic_waw",0x5e8),
   MAKE_ICONSTANT((char*)"GDK_KEY_l",0x06c),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12456",0x100283b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DownRight",0xfee7),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_INVALID_VALUE",G_KEY_FILE_ERROR_INVALID_VALUE),
   MAKE_ICONSTANT((char*)"GDK_checkmark",0xaf3),
   MAKE_ICONSTANT((char*)"GDK_EVENT_PROPAGATE",0),
   MAKE_ICONSTANT((char*)"G_DBUS_SEND_MESSAGE_FLAGS_NONE",G_DBUS_SEND_MESSAGE_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GTK_CALENDAR_SHOW_WEEK_NUMBERS",GTK_CALENDAR_SHOW_WEEK_NUMBERS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_fe",0x1000586),
   MAKE_ICONSTANT((char*)"GDK_F30",0xffdb),
   MAKE_ICONSTANT((char*)"GDK_exclam",0x021),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_bobaimai",0xdba),
   MAKE_ICONSTANT((char*)"GDK_C_H",0xfea5),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INVALID_CHARACTER",G_VARIANT_PARSE_ERROR_INVALID_CHARACTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Yellow",0x1008ffa5),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick1",0xfeef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_kan",0x10010d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Etilde",0x1001ebc),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1235",0x1002817),
   MAKE_ICONSTANT((char*)"G_APPLICATION_IS_SERVICE",G_APPLICATION_IS_SERVICE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_dje",0x6a1),
   MAKE_ICONSTANT((char*)"GTK_MESSAGE_INFO",GTK_MESSAGE_INFO),
   MAKE_ICONSTANT((char*)"G_REGEX_NEWLINE_CRLF",G_REGEX_NEWLINE_CRLF),
   MAKE_ICONSTANT((char*)"GDK_KEY_ae",0x0e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_can",0x10010ea),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_MOTION_MASK",GDK_BUTTON_MOTION_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftsinglequotemark",0xad0),
   MAKE_ICONSTANT((char*)"GDK_Thai_khokhon",0xda5),
   MAKE_ICONSTANT((char*)"G_DBUS_SUBTREE_FLAGS_NONE",G_DBUS_SUBTREE_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TI",0x4c1),
   MAKE_ICONSTANT((char*)"GDK_question",0x03f),
   MAKE_ICONSTANT((char*)"GDK_Ohook",0x1001ece),
   MAKE_ICONSTANT((char*)"GDK_KEY_fabovedot",0x1001e1f),
   MAKE_ICONSTANT((char*)"GDK_hebrew_resh",0xcf8),
   MAKE_ICONSTANT((char*)"GDK_MenuPB",0x1008ff66),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1378",0x10028c5),
   MAKE_ICONSTANT((char*)"GDK_degree",0x0b0),
   MAKE_ICONSTANT((char*)"GDK_KEY_WonSign",0x10020a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_trademarkincircle",0xacb),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Prev_Group_Lock",0xfe0b),
   MAKE_ICONSTANT((char*)"GDK_rightt",0x9f5),
   MAKE_ICONSTANT((char*)"GDK_Greek_PHI",0x7d6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_lyun",0x100056c),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_156",0x1002831),
   MAKE_ICONSTANT((char*)"GDK_Sinh_aa",0x1000d86),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_LEFT_RESIZABLE",GDK_WINDOW_STATE_LEFT_RESIZABLE),
   MAKE_ICONSTANT((char*)"GDK_abelowdot",0x1001ea1),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_EXPANDED",GTK_CELL_RENDERER_EXPANDED),
   MAKE_ICONSTANT((char*)"GDK_uhornbelowdot",0x1001ef1),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_POSTFIX",G_UNICODE_BREAK_POSTFIX),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_NieunHieuh",0xed9),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1348",0x100288d),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Kiyeog",0xea1),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_1",0x1008fe01),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_378",0x10028c4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PALMYRENE",G_UNICODE_SCRIPT_PALMYRENE),
   MAKE_ICONSTANT((char*)"GDK_KEY_topleftparens",0x8ab),
   MAKE_ICONSTANT((char*)"GDK_META_MASK",GDK_META_MASK),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_AGAIN",G_IO_ERROR_AGAIN),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_NO_PIXEL_CACHE",GTK_DEBUG_NO_PIXEL_CACHE),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_DISPLAY_LINES",GTK_MOVEMENT_DISPLAY_LINES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_amanak",0x100055c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_tshe",0x6ab),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_TOP_TO_BOTTOM",GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_TOP_TO_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_F26",0xffd7),
   MAKE_ICONSTANT((char*)"GDK_apostrophe",0x027),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_DIR_RTL",GTK_STATE_FLAG_DIR_RTL),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_FORK_FAILED",G_DBUS_ERROR_SPAWN_FORK_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_AltCursor",0xfd10),
   MAKE_ICONSTANT((char*)"GDK_KEY_r",0x072),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12346",0x100282f),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_NieunJieuj",0xed8),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_HORIZONTAL_PAGES",GTK_SCROLL_HORIZONTAL_PAGES),
   MAKE_ICONSTANT((char*)"GDK_SETTING",GDK_SETTING),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamza",0x5c1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_accent",0x100055b),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_LIMITS_EXCEEDED",G_DBUS_ERROR_LIMITS_EXCEEDED),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_QUANTIFIER_TOO_BIG",G_REGEX_ERROR_QUANTIFIER_TOO_BIG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflexacute",0x1001ebe),
   MAKE_ICONSTANT((char*)"GDK_KEY_lstroke",0x1b3),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SIDDHAM",G_UNICODE_SCRIPT_SIDDHAM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Battery",0x1008ff93),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BATAK",PANGO_SCRIPT_BATAK),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulPhieuf",0xeaf),
   MAKE_ICONSTANT((char*)"GDK_KEY_fiveeighths",0xac5),
   MAKE_ICONSTANT((char*)"GDK_Udiaeresis",0x0dc),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_yi",0x6a7),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_GHE_bar",0x1000492),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_TEXT",GTK_DEBUG_TEXT),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_MAXIMIZED",GDK_WINDOW_STATE_MAXIMIZED),
   MAKE_ICONSTANT((char*)"GDK_Greek_psi",0x7f8),
   MAKE_ICONSTANT((char*)"GTK_REGION_ODD",GTK_REGION_ODD),
   MAKE_ICONSTANT((char*)"GTK_SIZE_GROUP_NONE",GTK_SIZE_GROUP_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Kiyeog",0xed4),
   MAKE_ICONSTANT((char*)"GDK_L4",0xffcb),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_x",0x078),
   MAKE_ICONSTANT((char*)"GDK_R1",0xffd2),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_INVALID_ARGUMENT",G_IO_ERROR_INVALID_ARGUMENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_RupeeSign",0x10020a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_waw",0xce5),
   MAKE_ICONSTANT((char*)"GDK_Serbian_TSHE",0x6bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_threefifths",0xab4),
   MAKE_ICONSTANT((char*)"GDK_KEY_BounceKeys_Enable",0xfe74),
   MAKE_ICONSTANT((char*)"GDK_ZoomIn",0x1008ff8b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_25678",0x10028f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_club",0xaec),
   MAKE_ICONSTANT((char*)"GDK_Launch5",0x1008ff45),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_khokhuat",0xda3),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_U",0x4b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3568",0x10028b4),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_DIGIT",G_REGEX_ERROR_MISSING_DIGIT),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDIN_INHERIT",G_SUBPROCESS_FLAGS_STDIN_INHERIT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohornacute",0x1001eda),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_24678",0x10028ea),
   MAKE_ICONSTANT((char*)"GDK_FrameForward",0x1008ff9e),
   MAKE_ICONSTANT((char*)"GDK_3270_AltCursor",0xfd10),
   MAKE_ICONSTANT((char*)"GDK_ygrave",0x1001ef3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_o_bar",0x10004e9),
   MAKE_ICONSTANT((char*)"GDK_KEY_caron",0x1b7),
   MAKE_ICONSTANT((char*)"GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT",GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT),
   MAKE_ICONSTANT((char*)"G_USER_N_DIRECTORIES",G_USER_N_DIRECTORIES),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_135",0x1002815),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_MUSIC",G_USER_DIRECTORY_MUSIC),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_hardsign",0x6df),
   MAKE_ICONSTANT((char*)"GDK_lcaron",0x1b5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_re",0x1000580),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_LEFT_TILED",GDK_WINDOW_STATE_LEFT_TILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1456",0x1002839),
   MAKE_ICONSTANT((char*)"GDK_crossinglines",0x9ee),
   MAKE_ICONSTANT((char*)"GDK_Sinh_uu2",0x1000dd6),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_STATIC_COLOR",GDK_VISUAL_STATIC_COLOR),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SOFTSIGN",0x6f8),
   MAKE_ICONSTANT((char*)"GDK_MAX_TIMECOORD_AXES",128),
   MAKE_ICONSTANT((char*)"GDK_KEY_minus",0x02d),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_WIDGET",GTK_TEXT_WINDOW_WIDGET),
   MAKE_ICONSTANT((char*)"GDK_R2",0xffd3),
   MAKE_ICONSTANT((char*)"GDK_Linefeed",0xff0a),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_CHE_vertstroke",0x10004b8),
   MAKE_ICONSTANT((char*)"GDK_braceleft",0x07b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button3",0xfeeb),
   MAKE_ICONSTANT((char*)"GDK_Bluetooth",0x1008ff94),
   MAKE_ICONSTANT((char*)"GDK_KEY_ht",0x9e2),
   MAKE_ICONSTANT((char*)"GDK_WA_TITLE",GDK_WA_TITLE),
   MAKE_ICONSTANT((char*)"GDK_Serbian_LJE",0x6b9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ve",0x6d7),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_WEIGHT",PANGO_FONT_MASK_WEIGHT),
   MAKE_ICONSTANT((char*)"GDK_Zenkaku_Hankaku",0xff2a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulTieut",0xee0),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightcaret",0xba6),
   MAKE_ICONSTANT((char*)"GDK_dead_hook",0xfe61),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_UNEXPECTED_TOKEN",G_VARIANT_PARSE_ERROR_UNEXPECTED_TOKEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_125",0x1002813),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_rreh",0x1000691),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_TRUE_COLOR",GDK_VISUAL_TRUE_COLOR),
   MAKE_ICONSTANT((char*)"G_FORMAT_SIZE_LONG_FORMAT",G_FORMAT_SIZE_LONG_FORMAT),
   MAKE_ICONSTANT((char*)"GTK_TEXT_VIEW_LAYER_BELOW_TEXT",GTK_TEXT_VIEW_LAYER_BELOW_TEXT),
   MAKE_ICONSTANT((char*)"GDK_View",0x1008ffa1),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_ERASER",GDK_DEVICE_TOOL_TYPE_ERASER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraaimaimuan",0xde3),
   MAKE_ICONSTANT((char*)"GDK_Arabic_beh",0x5c8),
   MAKE_ICONSTANT((char*)"GDK_PIRATE",GDK_PIRATE),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_CONFIRM",GTK_ASSISTANT_PAGE_CONFIRM),
   MAKE_ICONSTANT((char*)"G_TIME_TYPE_DAYLIGHT",G_TIME_TYPE_DAYLIGHT),
   MAKE_ICONSTANT((char*)"GTK_PLACES_OPEN_NEW_TAB",GTK_PLACES_OPEN_NEW_TAB),
   MAKE_ICONSTANT((char*)"GDK_KEY_circle",0xbcf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag1",0xfef5),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_macron",0xfe54),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1235",0x1002817),
   MAKE_ICONSTANT((char*)"GDK_KP_Space",0xff80),
   MAKE_ICONSTANT((char*)"GDK_RotateWindows",0x1008ff74),
   MAKE_ICONSTANT((char*)"GDK_KEY_News",0x1008ff69),
   MAKE_ICONSTANT((char*)"GDK_Serbian_nje",0x6aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Wdiaeresis",0x1001e84),
   MAKE_ICONSTANT((char*)"GTK_TARGET_SAME_WIDGET",GTK_TARGET_SAME_WIDGET),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ho",0x1000570),
   MAKE_ICONSTANT((char*)"GDK_KEY_History",0x1008ff37),
   MAKE_ICONSTANT((char*)"GDK_Sinh_i2",0x1000dd2),
   MAKE_ICONSTANT((char*)"G_SOCKET_TYPE_STREAM",G_SOCKET_TYPE_STREAM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_iota",0x7e9),
   MAKE_ICONSTANT((char*)"GDK_KEY_uparrow",0x8fc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch3",0x1008ff43),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_TILED",GDK_WINDOW_STATE_TILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch8",0x1008ff48),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_DEFAULT_COMPOSE",G_NORMALIZE_DEFAULT_COMPOSE),
   MAKE_ICONSTANT((char*)"GDK_MultipleCandidate",0xff3d),
   MAKE_ICONSTANT((char*)"GDK_4",0x034),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_aa",0x1000d86),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES",G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES),
   MAKE_ICONSTANT((char*)"PANGO_STYLE_ITALIC",PANGO_STYLE_ITALIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalkaph",0xcea),
   MAKE_ICONSTANT((char*)"GDK_Georgian_las",0x10010da),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_O",0xec7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YEO",0xec5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_NU",0x1000546),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12345",0x100281f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_3",0x1000663),
   MAKE_ICONSTANT((char*)"GDK_at",0x040),
   MAKE_ICONSTANT((char*)"G_DATE_JUNE",G_DATE_JUNE),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_VAI",PANGO_SCRIPT_VAI),
   MAKE_ICONSTANT((char*)"GDK_KEY_F25",0xffd6),
   MAKE_ICONSTANT((char*)"GDK_KP_Home",0xff95),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_JE",0x6b8),
   MAKE_ICONSTANT((char*)"GDK_lstroke",0x1b3),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_WORDS",GTK_MOVEMENT_WORDS),
   MAKE_ICONSTANT((char*)"GDK_kana_YA",0x4d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_N",0x04e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1248",0x100288b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_OMICRON",0x7cf),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_EAST",PANGO_GRAVITY_EAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3467",0x100286c),
   MAKE_ICONSTANT((char*)"GDK_KEY_ubreve",0x2fd),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_STRETCH",PANGO_FONT_MASK_STRETCH),
   MAKE_ICONSTANT((char*)"GDK_kana_a",0x4a7),
   MAKE_ICONSTANT((char*)"G_FILE_MEASURE_APPARENT_SIZE",G_FILE_MEASURE_APPARENT_SIZE),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MULTANI",PANGO_SCRIPT_MULTANI),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_124",0x100280b),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_UPPERCASE_CHARS",GTK_INPUT_HINT_UPPERCASE_CHARS),
   MAKE_ICONSTANT((char*)"G_IO_NVAL",G_IO_NVAL),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_145",0x1002819),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_UINT32",G_FILE_ATTRIBUTE_TYPE_UINT32),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_INVALID_URI",GTK_RECENT_MANAGER_ERROR_INVALID_URI),
   MAKE_ICONSTANT((char*)"GDK_Armenian_VYUN",0x1000552),
   MAKE_ICONSTANT((char*)"GDK_TouchpadToggle",0x1008ffa9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul",0xff31),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MALFORMED_CONDITION",G_REGEX_ERROR_MALFORMED_CONDITION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick4",0xfef2),
   MAKE_ICONSTANT((char*)"GDK_Last_Virtual_Screen",0xfed4),
   MAKE_ICONSTANT((char*)"GTK_SENSITIVITY_OFF",GTK_SENSITIVITY_OFF),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SERVICE_UNKNOWN",G_DBUS_ERROR_SERVICE_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maiyamok",0xde6),
   MAKE_ICONSTANT((char*)"GDK_seconds",0xad7),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_TLS_HANDSHAKING",G_SOCKET_CLIENT_TLS_HANDSHAKING),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_GRAYSCALE",GDK_VISUAL_GRAYSCALE),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_yi",0x6a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_asciitilde",0x07e),
   MAKE_ICONSTANT((char*)"GDK_therefore",0x8c0),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BENGALI",PANGO_SCRIPT_BENGALI),
   MAKE_ICONSTANT((char*)"GDK_FUNC_MAXIMIZE",GDK_FUNC_MAXIMIZE),
   MAKE_ICONSTANT((char*)"G_TYPE_DEBUG_NONE",G_TYPE_DEBUG_NONE),
   MAKE_ICONSTANT((char*)"GDK_WA_NOREDIR",GDK_WA_NOREDIR),
   MAKE_ICONSTANT((char*)"GTK_SIZE_GROUP_HORIZONTAL",GTK_SIZE_GROUP_HORIZONTAL),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_pe",0x6d0),
   MAKE_ICONSTANT((char*)"GDK_KEY_onehalf",0x0bd),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_YU",0x6e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Send",0x1008ff7b),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HANGUL_LV_SYLLABLE",G_UNICODE_BREAK_HANGUL_LV_SYLLABLE),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_DND",GDK_WINDOW_TYPE_HINT_DND),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_348",0x100288c),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_INT32",G_VARIANT_CLASS_INT32),
   MAKE_ICONSTANT((char*)"GDK_comma",0x02c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_tatweel",0x5e0),
   MAKE_ICONSTANT((char*)"GDK_Gcircumflex",0x2d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2345",0x100281e),
   MAKE_ICONSTANT((char*)"GDK_ScrollUp",0x1008ff78),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamzaunderalef",0x5c5),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_124678",0x10028eb),
   MAKE_ICONSTANT((char*)"GDK_quoteright",0x027),
   MAKE_ICONSTANT((char*)"GDK_Pabovedot",0x1001e56),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_58",0x1002890),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ka_descender",0x100049b),
   MAKE_ICONSTANT((char*)"GDK_kana_RI",0x4d8),
   MAKE_ICONSTANT((char*)"GDK_L8",0xffcf),
   MAKE_ICONSTANT((char*)"GDK_Messenger",0x1008ff8e),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_NO_SENSITIVITY",G_SETTINGS_BIND_NO_SENSITIVITY),
   MAKE_ICONSTANT((char*)"GDK_dead_macron",0xfe54),
   MAKE_ICONSTANT((char*)"GDK_hebrew_dalet",0xce3),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_DIGITS",GTK_INPUT_PURPOSE_DIGITS),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflexgrave",0x1001ed2),
   MAKE_ICONSTANT((char*)"GDK_KEY_abrevebelowdot",0x1001eb7),
   MAKE_ICONSTANT((char*)"GDK_Armenian_RE",0x1000550),
   MAKE_ICONSTANT((char*)"GDK_FUNC_MOVE",GDK_FUNC_MOVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_em3space",0xaa3),
   MAKE_ICONSTANT((char*)"GDK_asciitilde",0x07e),
   MAKE_ICONSTANT((char*)"GTK_SPIN_USER_DEFINED",GTK_SPIN_USER_DEFINED),
   MAKE_ICONSTANT((char*)"GDK_KEY_v",0x076),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_GRID_LINES_NONE",GTK_TREE_VIEW_GRID_LINES_NONE),
   MAKE_ICONSTANT((char*)"GDK_uogonek",0x3f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_farsi_yeh",0x10006cc),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_INSCRIPTIONAL_PARTHIAN",G_UNICODE_SCRIPT_INSCRIPTIONAL_PARTHIAN),
   MAKE_ICONSTANT((char*)"GDK_scedilla",0x1ba),
   MAKE_ICONSTANT((char*)"GDK_Alt_L",0xffe9),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchC",0x1008ff4c),
   MAKE_ICONSTANT((char*)"GDK_KEY_q",0x071),
   MAKE_ICONSTANT((char*)"GDK_KEY_aring",0x0e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag3",0xfef7),
   MAKE_ICONSTANT((char*)"GDK_topleftparens",0x8ab),
   MAKE_ICONSTANT((char*)"GDK_Greek_OMICRONaccent",0x7a7),
   MAKE_ICONSTANT((char*)"GTK_STYLE_PROVIDER_PRIORITY_USER",800),
   MAKE_ICONSTANT((char*)"GTK_BUTTON_ROLE_NORMAL",GTK_BUTTON_ROLE_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_9",0x039),
   MAKE_ICONSTANT((char*)"GDK_KEY_egrave",0x0e8),
   MAKE_ICONSTANT((char*)"G_CONVERTER_FINISHED",G_CONVERTER_FINISHED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_dodek",0xdb4),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchD",0x1008ff4d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_KA_vertstroke",0x100049c),
   MAKE_ICONSTANT((char*)"GTK_DELETE_WORD_ENDS",GTK_DELETE_WORD_ENDS),
   MAKE_ICONSTANT((char*)"GDK_h",0x068),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_478",0x10028c8),
   MAKE_ICONSTANT((char*)"GDK_tslash",0x3bc),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MYANMAR",PANGO_SCRIPT_MYANMAR),
   MAKE_ICONSTANT((char*)"G_UNICODE_PARAGRAPH_SEPARATOR",G_UNICODE_PARAGRAPH_SEPARATOR),
   MAKE_ICONSTANT((char*)"GDK_a",0x061),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TSU",0x4c2),
   MAKE_ICONSTANT((char*)"GDK_Go",0x1008ff5f),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MANICHAEAN",PANGO_SCRIPT_MANICHAEAN),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_4",0x1002808),
   MAKE_ICONSTANT((char*)"GDK_Greek_ETA",0x7c7),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_INVALID_URI",G_BOOKMARK_FILE_ERROR_INVALID_URI),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_136",0x1002825),
   MAKE_ICONSTANT((char*)"GDK_Arabic_7",0x1000667),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PHOENICIAN",G_UNICODE_SCRIPT_PHOENICIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_RockerEnter",0x1008ff25),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_aa2",0x1000dcf),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarai",0xdd4),
   MAKE_ICONSTANT((char*)"GDK_Standby",0x1008ff10),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_es",0x6d3),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Jeonja",0xff38),
   MAKE_ICONSTANT((char*)"GDK_kana_YO",0x4d6),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_18_MASK",GDK_MODIFIER_RESERVED_18_MASK),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Special",0xff3f),
   MAKE_ICONSTANT((char*)"GTK_REGION_EVEN",GTK_REGION_EVEN),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_9",0xfff9),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YE",0xec6),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_SPREAD",GTK_BUTTONBOX_SPREAD),
   MAKE_ICONSTANT((char*)"GDK_KEY_R5",0xffd6),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflexhook",0x1001ec2),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LYCIAN",PANGO_SCRIPT_LYCIAN),
   MAKE_ICONSTANT((char*)"G_ZLIB_COMPRESSOR_FORMAT_RAW",G_ZLIB_COMPRESSOR_FORMAT_RAW),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_125",0x1002813),
   MAKE_ICONSTANT((char*)"GDK_ubelowdot",0x1001ee5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_yeh_baree",0x10006d2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_U_macron",0x10004ee),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_BOTTOM",GTK_TEXT_WINDOW_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_jha",0x1000da3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cut",0x1008ff58),
   MAKE_ICONSTANT((char*)"GDK_LogGrabInfo",0x1008fe25),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_NOT_FOUND",GTK_RECENT_MANAGER_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_LETTER_SPACING",PANGO_ATTR_LETTER_SPACING),
   MAKE_ICONSTANT((char*)"GDK_KEY_stricteq",0x1002263),
   MAKE_ICONSTANT((char*)"GDK_KEY_DongSign",0x10020ab),
   MAKE_ICONSTANT((char*)"GDK_Muhenkan",0xff22),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2457",0x100285a),
   MAKE_ICONSTANT((char*)"GDK_KEY_upstile",0xbd3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123458",0x100289f),
   MAKE_ICONSTANT((char*)"GDK_TOUCH_MASK",GDK_TOUCH_MASK),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CHEROKEE",PANGO_SCRIPT_CHEROKEE),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_DeleteWord",0xfd1a),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_NOSPC",G_IO_CHANNEL_ERROR_NOSPC),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_AIRBRUSH",GDK_DEVICE_TOOL_TYPE_AIRBRUSH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Reload",0x1008ff73),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_NONE",G_DBUS_PROXY_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_EM",0x6ed),
   MAKE_ICONSTANT((char*)"GDK_multiply",0x0d7),
   MAKE_ICONSTANT((char*)"GDK_Thai_phosamphao",0xdc0),
   MAKE_ICONSTANT((char*)"GDK_telephone",0xaf9),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NEWLINE_CR",G_REGEX_MATCH_NEWLINE_CR),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Left2",0xfd04),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_iotaaccentdieresis",0x7b6),
   MAKE_ICONSTANT((char*)"GDK_OK",GDK_OK),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_WORD_COMPLETION",GTK_INPUT_HINT_WORD_COMPLETION),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_NORTH",GDK_WINDOW_EDGE_NORTH),
   MAKE_ICONSTANT((char*)"GTK_WINDOW_POPUP",GTK_WINDOW_POPUP),
   MAKE_ICONSTANT((char*)"GDK_KEY_DOS",0x1008ff5a),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MRO",PANGO_SCRIPT_MRO),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12348",0x100288f),
   MAKE_ICONSTANT((char*)"GDK_Mode_switch",0xff7e),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAI_LE",G_UNICODE_SCRIPT_TAI_LE),
   MAKE_ICONSTANT((char*)"GTK_STYLE_PROVIDER_PRIORITY_SETTINGS",400),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_IS_DIRECTORY",G_IO_ERROR_IS_DIRECTORY),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23568",0x10028b6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_te",0x6d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12345678",0x10028ff),
   MAKE_ICONSTANT((char*)"GDK_Thai_leksong",0xdf2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Down",0xfee3),
   MAKE_ICONSTANT((char*)"GDK_dead_cedilla",0xfe5b),
   MAKE_ICONSTANT((char*)"GDK_Yellow",0x1008ffa5),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_SEMILIGHT",PANGO_WEIGHT_SEMILIGHT),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PARTIAL_INPUT",G_IO_ERROR_PARTIAL_INPUT),
   MAKE_ICONSTANT((char*)"GDK_openrectbullet",0xae2),
   MAKE_ICONSTANT((char*)"GDK_KEY_View",0x1008ffa1),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_DOCUMENT",GTK_CSS_SECTION_DOCUMENT),
   MAKE_ICONSTANT((char*)"G_UNICODE_SPACING_MARK",G_UNICODE_SPACING_MARK),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_CHILD_EXITED",G_DBUS_ERROR_SPAWN_CHILD_EXITED),
   MAKE_ICONSTANT((char*)"GDK_KEY_twosubscript",0x1002082),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_INSECURE",G_TLS_CERTIFICATE_INSECURE),
   MAKE_ICONSTANT((char*)"GDK_minutes",0xad6),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraii",0xdd5),
   MAKE_ICONSTANT((char*)"G_UNICODE_CONNECT_PUNCTUATION",G_UNICODE_CONNECT_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_F21",0xffd2),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Down",0xff99),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_DA",0x1000534),
   MAKE_ICONSTANT((char*)"G_ZLIB_COMPRESSOR_FORMAT_ZLIB",G_ZLIB_COMPRESSOR_FORMAT_ZLIB),
   MAKE_ICONSTANT((char*)"GDK_LEFTBUTTON",GDK_LEFTBUTTON),
   MAKE_ICONSTANT((char*)"GDK_variation",0x8c1),
   MAKE_ICONSTANT((char*)"GDK_KEY_caret",0xafc),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LATIN",G_UNICODE_SCRIPT_LATIN),
   MAKE_ICONSTANT((char*)"GDK_kana_NU",0x4c7),
   MAKE_ICONSTANT((char*)"G_FILE_MEASURE_NO_XDEV",G_FILE_MEASURE_NO_XDEV),
   MAKE_ICONSTANT((char*)"GDK_Armenian_sha",0x1000577),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightt",0x9f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Muhenkan",0xff22),
   MAKE_ICONSTANT((char*)"GDK_SCHWA",0x100018f),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12568",0x10028b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflexbelowdot",0x1001ec7),
   MAKE_ICONSTANT((char*)"GDK_0",0x030),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulSios",0xedf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_VE",0x6f7),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_SPELLCHECK",GTK_INPUT_HINT_SPELLCHECK),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_COMPLETE",G_SOCKET_CLIENT_COMPLETE),
   MAKE_ICONSTANT((char*)"GDK_j",0x06a),
   MAKE_ICONSTANT((char*)"GDK_Home",0xff50),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_USER_CANCELLED",GTK_DRAG_RESULT_USER_CANCELLED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Jamo",0xff35),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_POSIX_NAMED_CLASS_OUTSIDE_CLASS",G_REGEX_ERROR_POSIX_NAMED_CLASS_OUTSIDE_CLASS),
   MAKE_ICONSTANT((char*)"GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT",GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT),
   MAKE_ICONSTANT((char*)"G_PARAM_CONSTRUCT",G_PARAM_CONSTRUCT),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PSALTER_PAHLAVI",G_UNICODE_SCRIPT_PSALTER_PAHLAVI),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_MOUNTED",G_IO_ERROR_NOT_MOUNTED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAKRI",G_UNICODE_SCRIPT_TAKRI),
   MAKE_ICONSTANT((char*)"GTK_SPIN_STEP_BACKWARD",GTK_SPIN_STEP_BACKWARD),
   MAKE_ICONSTANT((char*)"G_DBUS_SUBTREE_FLAGS_DISPATCH_TO_UNENUMERATED_NODES",G_DBUS_SUBTREE_FLAGS_DISPATCH_TO_UNENUMERATED_NODES),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_WEIGHT",PANGO_ATTR_WEIGHT),
   MAKE_ICONSTANT((char*)"GDK_Greek_alphaaccent",0x7b1),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TYPE_SLAVE",GDK_DEVICE_TYPE_SLAVE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BOPOMOFO",G_UNICODE_SCRIPT_BOPOMOFO),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12567",0x1002873),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_DBUS_ERROR",G_IO_ERROR_DBUS_ERROR),
   MAKE_ICONSTANT((char*)"GDK_DRAG_CANCEL_USER_CANCELLED",GDK_DRAG_CANCEL_USER_CANCELLED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HIRAGANA",G_UNICODE_SCRIPT_HIRAGANA),
   MAKE_ICONSTANT((char*)"GDK_Greek_MU",0x7cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_StickyKeys_Enable",0xfe75),
   MAKE_ICONSTANT((char*)"GTK_POPOVER_CONSTRAINT_NONE",GTK_POPOVER_CONSTRAINT_NONE),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_MISC",G_TLS_ERROR_MISC),
   MAKE_ICONSTANT((char*)"GDK_KEY_Scircumflex",0x2de),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_CLOSE",GTK_BUTTONS_CLOSE),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MEMORY_ERROR",G_REGEX_ERROR_MEMORY_ERROR),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulMieum",0xeab),
   MAKE_ICONSTANT((char*)"GDK_KEY_ampersand",0x026),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftshoe",0xbda),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BUGINESE",PANGO_SCRIPT_BUGINESE),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_gimmel",0xce2),
   MAKE_ICONSTANT((char*)"GDK_OWNER_CHANGE",GDK_OWNER_CHANGE),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_B",PANGO_BIDI_TYPE_B),
   MAKE_ICONSTANT((char*)"GDK_uhorntilde",0x1001eef),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR",GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_perispomeni",0xfe53),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulHieuh",0xeb0),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_ACTIVE",GTK_STATE_FLAG_ACTIVE),
   MAKE_ICONSTANT((char*)"GDK_L7",0xffce),
   MAKE_ICONSTANT((char*)"GDK_fabovedot",0x1001e1f),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Ieung",0xeb7),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_PARAGRAPH_ENDS",GTK_MOVEMENT_PARAGRAPH_ENDS),
   MAKE_ICONSTANT((char*)"GDK_Armenian_FE",0x1000556),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_CHI",0x4c1),
   MAKE_ICONSTANT((char*)"GDK_Farsi_0",0x10006f0),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ddha",0x1000daa),
   MAKE_ICONSTANT((char*)"GDK_numerosign",0x6b0),
   MAKE_ICONSTANT((char*)"GDK_Sinh_kha",0x1000d9b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_leksong",0xdf2),
   MAKE_ICONSTANT((char*)"GDK_Serbian_dze",0x6af),
   MAKE_ICONSTANT((char*)"GDK_hebrew_he",0xce4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_i_macron",0x10004e3),
   MAKE_ICONSTANT((char*)"GDK_Dabovedot",0x1001e0a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_156",0x1002831),
   MAKE_ICONSTANT((char*)"GDK_ezh",0x1000292),
   MAKE_ICONSTANT((char*)"GDK_Cancel",0xff69),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SYRIAC",G_UNICODE_SCRIPT_SYRIAC),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN",GTK_FILE_CHOOSER_CONFIRMATION_SELECT_AGAIN),
   MAKE_ICONSTANT((char*)"GDK_Hangul_WEO",0xecd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HEBREW",G_UNICODE_SCRIPT_HEBREW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick1",0xfeef),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_34578",0x10028dc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_3",0x1008fe03),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamzaonalef",0x5c3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_25",0x1002812),
   MAKE_ICONSTANT((char*)"GDK_KEY_zerosubscript",0x1002080),
   MAKE_ICONSTANT((char*)"GDK_ocircumflexhook",0x1001ed5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_en",0x6ce),
   MAKE_ICONSTANT((char*)"GDK_dcaron",0x1ef),
   MAKE_ICONSTANT((char*)"GDK_R5",0xffd6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_238",0x1002886),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_INFIX_SEPARATOR",G_UNICODE_BREAK_INFIX_SEPARATOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Mieum",0xeb1),
   MAKE_ICONSTANT((char*)"G_POLLABLE_RETURN_WOULD_BLOCK",G_POLLABLE_RETURN_WOULD_BLOCK),
   MAKE_ICONSTANT((char*)"GDK_registered",0x0ae),
   MAKE_ICONSTANT((char*)"GDK_KEY_botleftparens",0x8ac),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_CLASSED",G_TYPE_FLAG_CLASSED),
   MAKE_ICONSTANT((char*)"GDK_ApplicationLeft",0x1008ff50),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_2",0xffb2),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_ICON_NAME",GTK_IMAGE_ICON_NAME),
   MAKE_ICONSTANT((char*)"G_FILE_TEST_IS_DIR",G_FILE_TEST_IS_DIR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12347",0x100284f),
   MAKE_ICONSTANT((char*)"GDK_Thai_popla",0xdbb),
   MAKE_ICONSTANT((char*)"GDK_UNMAP",GDK_UNMAP),
   MAKE_ICONSTANT((char*)"GDK_R9",0xffda),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1237",0x1002847),
   MAKE_ICONSTANT((char*)"GDK_ACTION_ASK",GDK_ACTION_ASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_peh",0x100067e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ca",0x1000da0),
   MAKE_ICONSTANT((char*)"GDK_maltesecross",0xaf0),
   MAKE_ICONSTANT((char*)"GDK_Armenian_O",0x1000555),
   MAKE_ICONSTANT((char*)"GDK_Launch8",0x1008ff48),
   MAKE_ICONSTANT((char*)"GDK_braceright",0x07d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ungrab",0x1008fe20),
   MAKE_ICONSTANT((char*)"GDK_KEY_hairspace",0xaa8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ga",0x1000d9c),
   MAKE_ICONSTANT((char*)"GDK_Arabic_ain",0x5d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_S",0x053),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MUST_COLLECT",G_SIGNAL_MUST_COLLECT),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NOTBOL",G_REGEX_MATCH_NOTBOL),
   MAKE_ICONSTANT((char*)"GDK_ohook",0x1001ecf),
   MAKE_ICONSTANT((char*)"GDK_KEY_union",0x8dd),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_HORIZONTAL_PAGES",GTK_MOVEMENT_HORIZONTAL_PAGES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag_Dflt",0xfef4),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ae",0x1000d87),
   MAKE_ICONSTANT((char*)"GDK_Kana_Shift",0xff2e),
   MAKE_ICONSTANT((char*)"G_TLS_PASSWORD_MANY_TRIES",G_TLS_PASSWORD_MANY_TRIES),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23468",0x10028ae),
   MAKE_ICONSTANT((char*)"GDK_HotLinks",0x1008ff3a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Standby",0x1008ff10),
   MAKE_ICONSTANT((char*)"GDK_Subtitle",0x1008ff9a),
   MAKE_ICONSTANT((char*)"GDK_KEY_implies",0x8ce),
   MAKE_ICONSTANT((char*)"GDK_Armenian_tche",0x1000573),
   MAKE_ICONSTANT((char*)"GDK_ISO_Fast_Cursor_Up",0xfe2e),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT",GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ACTION_SAVE",GTK_FILE_CHOOSER_ACTION_SAVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudibleBell_Enable",0xfe7a),
   MAKE_ICONSTANT((char*)"GDK_KEY_BackForward",0x1008ff3f),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Separator",0xffac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_je",0x100057b),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_INFO_COPY_WHEN_MOVED",G_FILE_ATTRIBUTE_INFO_COPY_WHEN_MOVED),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_UP",GTK_SCROLL_PAGE_UP),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEPS",GTK_SCROLL_STEPS),
   MAKE_ICONSTANT((char*)"GDK_w",0x077),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_RESOLVED",G_SOCKET_CLIENT_RESOLVED),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_F3",0xff93),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_nje",0x6aa),
   MAKE_ICONSTANT((char*)"GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID",-2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ha",0x6c8),
   MAKE_ICONSTANT((char*)"GDK_F28",0xffd9),
   MAKE_ICONSTANT((char*)"GTK_DELETE_CHARS",GTK_DELETE_CHARS),
   MAKE_ICONSTANT((char*)"GDK_Cut",0x1008ff58),
   MAKE_ICONSTANT((char*)"GDK_KEY_L2",0xffc9),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_SETUP_FAILED",G_DBUS_ERROR_SPAWN_SETUP_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KP_Next",0xff9b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_tsa",0x100056e),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CUNEIFORM",PANGO_SCRIPT_CUNEIFORM),
   MAKE_ICONSTANT((char*)"GDK_Armenian_GIM",0x1000533),
   MAKE_ICONSTANT((char*)"GDK_Sinh_sha",0x1000dc1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick_Dflt",0xfeee),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_DEFINE_REPETION",G_REGEX_ERROR_DEFINE_REPETION),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_NO",0x4c9),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_RLO",PANGO_BIDI_TYPE_RLO),
   MAKE_ICONSTANT((char*)"GDK_kana_RA",0x4d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_lambda",0x7eb),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNKNOWN_PROPERTY",G_REGEX_ERROR_UNKNOWN_PROPERTY),
   MAKE_ICONSTANT((char*)"GTK_PAN_DIRECTION_RIGHT",GTK_PAN_DIRECTION_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23468",0x10028ae),
   MAKE_ICONSTANT((char*)"GTK_PRINT_PAGES_SELECTION",GTK_PRINT_PAGES_SELECTION),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_qoph",0xcf7),
   MAKE_ICONSTANT((char*)"G_PRIORITY_DEFAULT",0),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KHAROSHTHI",PANGO_SCRIPT_KHAROSHTHI),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_RIGHT_TO_LEFT",GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_RIGHT_TO_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_UPSILONaccent",0x7a8),
   MAKE_ICONSTANT((char*)"GDK_3270_Play",0xfd16),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_IO",G_FILE_ERROR_IO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_ETAaccent",0x7a3),
   MAKE_ICONSTANT((char*)"G_IO_STATUS_NORMAL",G_IO_STATUS_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_3",0xfff3),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_UNBLOCKED",G_SIGNAL_MATCH_UNBLOCKED),
   MAKE_ICONSTANT((char*)"GDK_ocircumflexgrave",0x1001ed3),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button4",0xfeec),
   MAKE_ICONSTANT((char*)"GDK_Community",0x1008ff3d),
   MAKE_ICONSTANT((char*)"GDK_KEY_percent",0x025),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_BACKGROUND",PANGO_ATTR_BACKGROUND),
   MAKE_ICONSTANT((char*)"GDK_hebrew_yod",0xce9),
   MAKE_ICONSTANT((char*)"GDK_Sinh_lu",0x1000d8f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_I",0x6b6),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_ULTRABOLD",PANGO_WEIGHT_ULTRABOLD),
   MAKE_ICONSTANT((char*)"GDK_INTERP_BILINEAR",GDK_INTERP_BILINEAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_ApplicationLeft",0x1008ff50),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_BACKDROP",GTK_STATE_FLAG_BACKDROP),
   MAKE_ICONSTANT((char*)"GDK_KEY_3",0x033),
   MAKE_ICONSTANT((char*)"G_UNICODE_ENCLOSING_MARK",G_UNICODE_ENCLOSING_MARK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_PE",0x6f0),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_TARGET_DEFAULT_PERMS",G_FILE_COPY_TARGET_DEFAULT_PERMS),
   MAKE_ICONSTANT((char*)"GDK_enspace",0xaa2),
   MAKE_ICONSTANT((char*)"GDK_CROSS",GDK_CROSS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hiragana_Katakana",0xff27),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_gaf",0x10006af),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_PRESS_MASK",GDK_BUTTON_PRESS_MASK),
   MAKE_ICONSTANT((char*)"G_REGEX_NEWLINE_ANYCRLF",G_REGEX_NEWLINE_ANYCRLF),
   MAKE_ICONSTANT((char*)"GDK_abovedot",0x1ff),
   MAKE_ICONSTANT((char*)"GDK_onesuperior",0x0b9),
   MAKE_ICONSTANT((char*)"GTK_POPOVER_CONSTRAINT_WINDOW",GTK_POPOVER_CONSTRAINT_WINDOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Video",0x1008ff87),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_jhan",0x10010ef),
   MAKE_ICONSTANT((char*)"G_POLLABLE_RETURN_FAILED",G_POLLABLE_RETURN_FAILED),
   MAKE_ICONSTANT((char*)"GDK_heart",0xaee),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_PERMIC",G_UNICODE_SCRIPT_OLD_PERMIC),
   MAKE_ICONSTANT((char*)"GTK_CORNER_TOP_LEFT",GTK_CORNER_TOP_LEFT),
   MAKE_ICONSTANT((char*)"GTK_PRINT_PAGES_RANGES",GTK_PRINT_PAGES_RANGES),
   MAKE_ICONSTANT((char*)"GDK_KEY_registered",0x0ae),
   MAKE_ICONSTANT((char*)"GTK_BUTTON_ROLE_CHECK",GTK_BUTTON_ROLE_CHECK),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_15_MASK",GDK_MODIFIER_RESERVED_15_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_345",0x100281c),
   MAKE_ICONSTANT((char*)"GDK_BUTTON5_MASK",GDK_BUTTON5_MASK),
   MAKE_ICONSTANT((char*)"GDK_semicolon",0x03b),
   MAKE_ICONSTANT((char*)"GTK_WIDGET_HELP_TOOLTIP",GTK_WIDGET_HELP_TOOLTIP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_HO",0x1000540),
   MAKE_ICONSTANT((char*)"GDK_Armenian_TCHE",0x1000543),
   MAKE_ICONSTANT((char*)"GDK_MailForward",0x1008ff90),
   MAKE_ICONSTANT((char*)"GTK_CORNER_BOTTOM_RIGHT",GTK_CORNER_BOTTOM_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2467",0x100286a),
   MAKE_ICONSTANT((char*)"GDK_ISO_Fast_Cursor_Down",0xfe2f),
   MAKE_ICONSTANT((char*)"GDK_KEY_eightsubscript",0x1002088),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1278",0x10028c3),
   MAKE_ICONSTANT((char*)"GDK_Arabic_9",0x1000669),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CHAM",G_UNICODE_SCRIPT_CHAM),
   MAKE_ICONSTANT((char*)"GTK_PRINT_DUPLEX_VERTICAL",GTK_PRINT_DUPLEX_VERTICAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_wdiaeresis",0x1001e85),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ccedilla",0x0c7),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_BINDING_SET",GTK_CSS_SECTION_BINDING_SET),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_FORCE_SVG",GTK_ICON_LOOKUP_FORCE_SVG),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level5_Latch",0xfe12),
   MAKE_ICONSTANT((char*)"GDK_T",0x054),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23457",0x100285e),
   MAKE_ICONSTANT((char*)"GTK_RELIEF_NONE",GTK_RELIEF_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_YU",0x4d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_rii",0x1000d8e),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_NOTIFICATION",GDK_WINDOW_TYPE_HINT_NOTIFICATION),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_DEFAULT",G_SETTINGS_BIND_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_UserPB",0x1008ff84),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ka",0x6cb),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_8",0x1008fe08),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_VIDEOS",G_USER_DIRECTORY_VIDEOS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_UpLeft",0xfee4),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_TOOLBAR",GDK_WINDOW_TYPE_HINT_TOOLBAR),
   MAKE_ICONSTANT((char*)"GDK_Romaji",0xff24),
   MAKE_ICONSTANT((char*)"GDK_RepeatKeys_Enable",0xfe72),
   MAKE_ICONSTANT((char*)"GDK_prolongedsound",0x4b0),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_GESTURE_PHASE_CANCEL",GDK_TOUCHPAD_GESTURE_PHASE_CANCEL),
   MAKE_ICONSTANT((char*)"GTK_UNIT_INCH",GTK_UNIT_INCH),
   MAKE_ICONSTANT((char*)"GDK_NairaSign",0x10020a6),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ndha",0x1000db3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1234678",0x10028ef),
   MAKE_ICONSTANT((char*)"GDK_kana_E",0x4b4),
   MAKE_ICONSTANT((char*)"GDK_Scaron",0x1a9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_NEW_TAI_LUE",PANGO_SCRIPT_NEW_TAI_LUE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_134678",0x10028ed),
   MAKE_ICONSTANT((char*)"GDK_opentribulletdown",0xae4),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_NEED_PASSWORD",G_ASK_PASSWORD_NEED_PASSWORD),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GREEK",G_UNICODE_SCRIPT_GREEK),
   MAKE_ICONSTANT((char*)"GDK_Armenian_TO",0x1000539),
   MAKE_ICONSTANT((char*)"GDK_KEY_Home",0xff50),
   MAKE_ICONSTANT((char*)"GDK_DRAPED_BOX",GDK_DRAPED_BOX),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_RELEASE",GDK_BUTTON_RELEASE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_E",0x6fc),
   MAKE_ICONSTANT((char*)"GDK_ecircumflex",0x0ea),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAI_THAM",G_UNICODE_SCRIPT_TAI_THAM),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_CUSTOM",GTK_ASSISTANT_PAGE_CUSTOM),
   MAKE_ICONSTANT((char*)"G_EMBLEM_ORIGIN_LIVEMETADATA",G_EMBLEM_ORIGIN_LIVEMETADATA),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE",GDK_WINDOW_STATE),
   MAKE_ICONSTANT((char*)"GDK_ERROR",GDK_ERROR),
   MAKE_ICONSTANT((char*)"G_TYPE_DEBUG_OBJECTS",G_TYPE_DEBUG_OBJECTS),
   MAKE_ICONSTANT((char*)"GDK_KEY_F5",0xffc2),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Up",0xfee2),
   MAKE_ICONSTANT((char*)"GDK_twosubscript",0x1002082),
   MAKE_ICONSTANT((char*)"GDK_KEY_therefore",0x8c0),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_i",0x6c9),
   MAKE_ICONSTANT((char*)"GDK_Sinh_h2",0x1000d83),
   MAKE_ICONSTANT((char*)"GDK_Georgian_rae",0x10010e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_conjunctive",0x4a5),
   MAKE_ICONSTANT((char*)"GDK_adiaeresis",0x0e4),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_TOUCH",GDK_SEAT_CAPABILITY_TOUCH),
   MAKE_ICONSTANT((char*)"GDK_Sinh_dha",0x1000daf),
   MAKE_ICONSTANT((char*)"GDK_KEY_signifblank",0xaac),
   MAKE_ICONSTANT((char*)"GDK_Greek_OMICRON",0x7cf),
   MAKE_ICONSTANT((char*)"GDK_utilde",0x3fd),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_MOVED_IN",G_FILE_MONITOR_EVENT_MOVED_IN),
   MAKE_ICONSTANT((char*)"GTK_UNIT_POINTS",GTK_UNIT_POINTS),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_FLIP",GDK_ANCHOR_FLIP),
   MAKE_ICONSTANT((char*)"GDK_R3",0xffd4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_THAI",G_UNICODE_SCRIPT_THAI),
   MAKE_ICONSTANT((char*)"GDK_KEY_L6",0xffcd),
   MAKE_ICONSTANT((char*)"GDK_KEY_prolongedsound",0x4b0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_phinthu",0xdda),
   MAKE_ICONSTANT((char*)"G_SOCKET_PROTOCOL_SCTP",G_SOCKET_PROTOCOL_SCTP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarai",0xdd4),
   MAKE_ICONSTANT((char*)"GDK_Y",0x059),
   MAKE_ICONSTANT((char*)"G_PARAM_DEPRECATED",G_PARAM_DEPRECATED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NEWA",G_UNICODE_SCRIPT_NEWA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_UpRight",0xfee5),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftdoublequotemark",0xad2),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_FILE_NOT_FOUND",G_DBUS_ERROR_FILE_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_braceleft",0x07b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Phone",0x1008ff6e),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CANADIAN_ABORIGINAL",G_UNICODE_SCRIPT_CANADIAN_ABORIGINAL),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_DROP_LEFT",GTK_ICON_VIEW_DROP_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ytilde",0x1001ef8),
   MAKE_ICONSTANT((char*)"GDK_Armenian_vo",0x1000578),
   MAKE_ICONSTANT((char*)"GDK_CruzeiroSign",0x10020a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_o",0x4ab),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_34567",0x100287c),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CHAKMA",PANGO_SCRIPT_CHAKMA),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TAI_LE",PANGO_SCRIPT_TAI_LE),
   MAKE_ICONSTANT((char*)"GDK_Thai_lekkao",0xdf9),
   MAKE_ICONSTANT((char*)"GDK_function",0x8f6),
   MAKE_ICONSTANT((char*)"G_PASSWORD_SAVE_FOR_SESSION",G_PASSWORD_SAVE_FOR_SESSION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_TSHE",0x6bb),
   MAKE_ICONSTANT((char*)"GTK_SHADOW_IN",GTK_SHADOW_IN),
   MAKE_ICONSTANT((char*)"GDK_PowerDown",0x1008ff21),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraam",0xdd3),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_INT64",G_VARIANT_CLASS_INT64),
   MAKE_ICONSTANT((char*)"G_UNIX_SOCKET_ADDRESS_ABSTRACT_PADDED",G_UNIX_SOCKET_ADDRESS_ABSTRACT_PADDED),
   MAKE_ICONSTANT((char*)"GDK_horizlinescan7",0x9f2),
   MAKE_ICONSTANT((char*)"GDK_obarred",0x1000275),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_NONE",GTK_REVEALER_TRANSITION_TYPE_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Odiaeresis",0x0d6),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_ALREADY_MOUNTED",G_IO_ERROR_ALREADY_MOUNTED),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OL_CHIKI",PANGO_SCRIPT_OL_CHIKI),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_EGYPTIAN_HIEROGLYPHS",G_UNICODE_SCRIPT_EGYPTIAN_HIEROGLYPHS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_hi",0x1000575),
   MAKE_ICONSTANT((char*)"GDK_dead_acute",0xfe51),
   MAKE_ICONSTANT((char*)"GTK_JUSTIFY_LEFT",GTK_JUSTIFY_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_ogonek",0x1b2),
   MAKE_ICONSTANT((char*)"G_RESOLVER_RECORD_NS",G_RESOLVER_RECORD_NS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_las",0x10010da),
   MAKE_ICONSTANT((char*)"GDK_KEY_bar",0x07c),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SsangDikeud",0xea8),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Page_Down",0xff9b),
   MAKE_ICONSTANT((char*)"GDK_WebCam",0x1008ff8f),
   MAKE_ICONSTANT((char*)"GDK_punctspace",0xaa6),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_SHORTCUT",G_FILE_TYPE_SHORTCUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_small_schwa",0xfe8a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eisu_toggle",0xff30),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_an",0x10010d0),
   MAKE_ICONSTANT((char*)"G_SEEK_CUR",G_SEEK_CUR),
   MAKE_ICONSTANT((char*)"GDK_KP_F3",0xff93),
   MAKE_ICONSTANT((char*)"GDK_SELECTION_REQUEST",GDK_SELECTION_REQUEST),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_BASELINES",GTK_DEBUG_BASELINES),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_ATTRIBUTE",GTK_BUILDER_ERROR_INVALID_ATTRIBUTE),
   MAKE_ICONSTANT((char*)"GDK_kra",0x3a2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_sha",0x6db),
   MAKE_ICONSTANT((char*)"GDK_KEY_Calculator",0x1008ff1d),
   MAKE_ICONSTANT((char*)"GDK_KEY_s",0x073),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_NORMAL",GDK_CROSSING_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_filledrectbullet",0xadb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12357",0x1002857),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_146",0x1002829),
   MAKE_ICONSTANT((char*)"G_BINDING_INVERT_BOOLEAN",G_BINDING_INVERT_BOOLEAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_overbar",0xbc0),
   MAKE_ICONSTANT((char*)"GDK_kana_comma",0x4a4),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_DROP_ACTIVE",GTK_STATE_FLAG_DROP_ACTIVE),
   MAKE_ICONSTANT((char*)"GDK_Thai_khokhuat",0xda3),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_END",GTK_BUTTONBOX_END),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_23_MASK",GDK_MODIFIER_RESERVED_23_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_itilde",0x3b5),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_LJE",0x6b9),
   MAKE_ICONSTANT((char*)"GDK_Arabic_percent",0x100066a),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Test",0xfd0d),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_AFTER_PAINT",GDK_FRAME_CLOCK_PHASE_AFTER_PAINT),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_NAME_TOO_LONG",G_REGEX_ERROR_NAME_TOO_LONG),
   MAKE_ICONSTANT((char*)"GDK_DOT",GDK_DOT),
   MAKE_ICONSTANT((char*)"GDK_botrightparens",0x8ae),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1235678",0x10028f7),
   MAKE_ICONSTANT((char*)"GDK_Thai_maitri",0xdea),
   MAKE_ICONSTANT((char*)"GDK_zerosuperior",0x1002070),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OGHAM",G_UNICODE_SCRIPT_OGHAM),
   MAKE_ICONSTANT((char*)"GDK_KEY_voicedsound",0x4de),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_ABOVE",GDK_WINDOW_STATE_ABOVE),
   MAKE_ICONSTANT((char*)"G_IO_MODULE_SCOPE_NONE",G_IO_MODULE_SCOPE_NONE),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_MATCH_RULE_INVALID",G_DBUS_ERROR_MATCH_RULE_INVALID),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_BE",0x6e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_OpenURL",0x1008ff38),
   MAKE_ICONSTANT((char*)"GDK_KEY_equal",0x03d),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123",0x1002807),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_de",0x6c4),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_DOCUMENTS",G_USER_DIRECTORY_DOCUMENTS),
   MAKE_ICONSTANT((char*)"GDK_Armenian_at",0x1000568),
   MAKE_ICONSTANT((char*)"GDK_Page_Down",0xff56),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SunkyeongeumPieub",0xef1),
   MAKE_ICONSTANT((char*)"GDK_User2KB",0x1008ff86),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_LENS",GDK_DEVICE_TOOL_TYPE_LENS),
   MAKE_ICONSTANT((char*)"GDK_DongSign",0x10020ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioNext",0x1008ff17),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_124567",0x100287b),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LINEAR_A",PANGO_SCRIPT_LINEAR_A),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Mieum",0xee3),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button2",0xfeea),
   MAKE_ICONSTANT((char*)"GDK_doublelowquotemark",0xafe),
   MAKE_ICONSTANT((char*)"GTK_BASELINE_POSITION_TOP",GTK_BASELINE_POSITION_TOP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_PreviousCandidate",0xff3e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23678",0x10028e6),
   MAKE_ICONSTANT((char*)"GDK_Overlay2_Enable",0xfe79),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_YI",G_UNICODE_SCRIPT_YI),
   MAKE_ICONSTANT((char*)"GDK_KEY_6",0x036),
   MAKE_ICONSTANT((char*)"GDK_otilde",0x0f5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PSALTER_PAHLAVI",PANGO_SCRIPT_PSALTER_PAHLAVI),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_MODE_EDITABLE",GTK_CELL_RENDERER_MODE_EDITABLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_schwa",0x1000259),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_XTILT",GDK_AXIS_FLAG_XTILT),
   MAKE_ICONSTANT((char*)"GDK_FUNC_RESIZE",GDK_FUNC_RESIZE),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_LGPL_2_1",GTK_LICENSE_LGPL_2_1),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick_Dflt",0xfeee),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_en",0x10010d4),
   MAKE_ICONSTANT((char*)"GDK_Video",0x1008ff87),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_U_straight",0x10004ae),
   MAKE_ICONSTANT((char*)"GDK_Georgian_don",0x10010d3),
   MAKE_ICONSTANT((char*)"GDK_ninesubscript",0x1002089),
   MAKE_ICONSTANT((char*)"GDK_Music",0x1008ff92),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_CHECKED",GTK_STATE_FLAG_CHECKED),
   MAKE_ICONSTANT((char*)"GDK_Hangul_WI",0xecf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_KiyeogSios",0xed6),
   MAKE_ICONSTANT((char*)"GDK_Calculator",0x1008ff1d),
   MAKE_ICONSTANT((char*)"GDK_KEY_R11",0xffdc),
   MAKE_ICONSTANT((char*)"GDK_hebrew_kaph",0xceb),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_ARRAY",G_VARIANT_CLASS_ARRAY),
   MAKE_ICONSTANT((char*)"GDK_gcaron",0x10001e7),
   MAKE_ICONSTANT((char*)"G_CHECKSUM_SHA1",G_CHECKSUM_SHA1),
   MAKE_ICONSTANT((char*)"GDK_partdifferential",0x1002202),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_superscript_alef",0x1000670),
   MAKE_ICONSTANT((char*)"GTK_WRAP_NONE",GTK_WRAP_NONE),
   MAKE_ICONSTANT((char*)"G_TYPE_RESERVED_BSE_LAST",48),
   MAKE_ICONSTANT((char*)"GDK_zstroke",0x10001b6),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_GENERIC_FALLBACK",GTK_ICON_LOOKUP_GENERIC_FALLBACK),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_SERVICE_INVALID",G_DBUS_ERROR_SPAWN_SERVICE_INVALID),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_OWNER_FLAGS_NONE",G_BUS_NAME_OWNER_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Byelorussian_SHORTU",0x6be),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_taf",0xcfa),
   MAKE_ICONSTANT((char*)"GDK_KEY_scedilla",0x1ba),
   MAKE_ICONSTANT((char*)"GDK_Georgian_chin",0x10010e9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_234578",0x10028de),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SAMARITAN",G_UNICODE_SCRIPT_SAMARITAN),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ai",0x1000d93),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_phophung",0xdbc),
   MAKE_ICONSTANT((char*)"GTK_POLICY_NEVER",GTK_POLICY_NEVER),
   MAKE_ICONSTANT((char*)"GTK_SIZE_GROUP_VERTICAL",GTK_SIZE_GROUP_VERTICAL),
   MAKE_ICONSTANT((char*)"G_REGEX_DOTALL",G_REGEX_DOTALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_145",0x1002819),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13458",0x100289d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_NieunHieuh",0xed9),
   MAKE_ICONSTANT((char*)"GDK_partialderivative",0x8ef),
   MAKE_ICONSTANT((char*)"GDK_8",0x038),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2367",0x1002866),
   MAKE_ICONSTANT((char*)"GDK_kana_e",0x4aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_F12",0xffc9),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_VARIANT",G_VARIANT_CLASS_VARIANT),
   MAKE_ICONSTANT((char*)"GDK_emfilledrect",0xadf),
   MAKE_ICONSTANT((char*)"GDK_STAR",GDK_STAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_righttack",0xbfc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Nacute",0x1d1),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN",GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN),
   MAKE_ICONSTANT((char*)"GDK_dead_caron",0xfe5a),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraaimaimuan",0xde3),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_CURSOR",GDK_SOURCE_CURSOR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_26",0x1002822),
   MAKE_ICONSTANT((char*)"GDK_ISO_Enter",0xfe34),
   MAKE_ICONSTANT((char*)"GTK_PAGE_SET_ODD",GTK_PAGE_SET_ODD),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12357",0x1002857),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDERR_MERGE",G_SUBPROCESS_FLAGS_STDERR_MERGE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_kha",0x1000d9b),
   MAKE_ICONSTANT((char*)"GDK_malesymbol",0xaf7),
   MAKE_ICONSTANT((char*)"GDK_MAN",GDK_MAN),
   MAKE_ICONSTANT((char*)"GDK_F24",0xffd5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamza_below",0x1000655),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_EMOJI_BASE",G_UNICODE_BREAK_EMOJI_BASE),
   MAKE_ICONSTANT((char*)"G_SIGNAL_DETAILED",G_SIGNAL_DETAILED),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_RENAMED",G_FILE_MONITOR_EVENT_RENAMED),
   MAKE_ICONSTANT((char*)"GDK_kana_tu",0x4af),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ccircumflex",0x2c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Lcedilla",0x3a6),
   MAKE_ICONSTANT((char*)"GDK_doubbaselinedot",0xaaf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_MU",0x7cc),
   MAKE_ICONSTANT((char*)"GDK_Armenian_fe",0x1000586),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_hie",0x10010f2),
   MAKE_ICONSTANT((char*)"GDK_Tools",0x1008ff81),
   MAKE_ICONSTANT((char*)"GDK_m",0x06d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Start",0x1008ff1a),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Left",0xff96),
   MAKE_ICONSTANT((char*)"GDK_Greek_epsilon",0x7e5),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_SMALL_TOOLBAR",GTK_ICON_SIZE_SMALL_TOOLBAR),
   MAKE_ICONSTANT((char*)"GDK_Book",0x1008ff52),
   MAKE_ICONSTANT((char*)"GDK_KEY_gabovedot",0x2f5),
   MAKE_ICONSTANT((char*)"GTK_DIALOG_DESTROY_WITH_PARENT",GTK_DIALOG_DESTROY_WITH_PARENT),
   MAKE_ICONSTANT((char*)"G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_DO_NOT_AUTO_START",G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_DO_NOT_AUTO_START),
   MAKE_ICONSTANT((char*)"GDK_KEY_lefttack",0xbdc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ncedilla",0x3d1),
   MAKE_ICONSTANT((char*)"GDK_Arabic_ghain",0x5da),
   MAKE_ICONSTANT((char*)"GTK_NOTEBOOK_TAB_LAST",GTK_NOTEBOOK_TAB_LAST),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button3",0xfeeb),
   MAKE_ICONSTANT((char*)"GDK_Sacute",0x1a6),
   MAKE_ICONSTANT((char*)"GDK_because",0x1002235),
   MAKE_ICONSTANT((char*)"GDK_Thai_thothung",0xdb6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23678",0x10028e6),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_COLUMN_FIXED",GTK_TREE_VIEW_COLUMN_FIXED),
   MAKE_ICONSTANT((char*)"GDK_Hankaku",0xff29),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_NETBSD_UNPCBID",G_CREDENTIALS_TYPE_NETBSD_UNPCBID),
   MAKE_ICONSTANT((char*)"GDK_KEY_R1",0xffd2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_kappa",0x7ea),
   MAKE_ICONSTANT((char*)"GDK_telephonerecorder",0xafa),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_INVALID_CODE",G_UNICODE_SCRIPT_INVALID_CODE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_te",0x6d4),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_BAD_URI",G_CONVERT_ERROR_BAD_URI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_WA",0xec8),
   MAKE_ICONSTANT((char*)"GTK_RELIEF_HALF",GTK_RELIEF_HALF),
   MAKE_ICONSTANT((char*)"GDK_DRAG_CANCEL_ERROR",GDK_DRAG_CANCEL_ERROR),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_LGPL_3_0_ONLY",GTK_LICENSE_LGPL_3_0_ONLY),
   MAKE_ICONSTANT((char*)"G_SIGNAL_NO_HOOKS",G_SIGNAL_NO_HOOKS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1257",0x1002853),
   MAKE_ICONSTANT((char*)"GDK_c",0x063),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNTERMINATED_CHARACTER_CLASS",G_REGEX_ERROR_UNTERMINATED_CHARACTER_CLASS),
   MAKE_ICONSTANT((char*)"GDK_Sinh_o2",0x1000ddc),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BUHID",G_UNICODE_SCRIPT_BUHID),
   MAKE_ICONSTANT((char*)"GDK_KEY_V",0x056),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2345",0x100281e),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_TSE",0x6e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Control_R",0xffe4),
   MAKE_ICONSTANT((char*)"GDK_icircumflex",0x0ee),
   MAKE_ICONSTANT((char*)"GDK_KEY_scaron",0x1b9),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_PARAGRAPHS",GTK_MOVEMENT_PARAGRAPHS),
   MAKE_ICONSTANT((char*)"GDK_KEY_endash",0xaaa),
   MAKE_ICONSTANT((char*)"GDK_Multi_key",0xff20),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_PAGES",GTK_MOVEMENT_PAGES),
   MAKE_ICONSTANT((char*)"GDK_KEY_doubbaselinedot",0xaaf),
   MAKE_ICONSTANT((char*)"G_BUS_TYPE_SYSTEM",G_BUS_TYPE_SYSTEM),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_134",0x100280d),
   MAKE_ICONSTANT((char*)"GTK_PRINT_DUPLEX_SIMPLEX",GTK_PRINT_DUPLEX_SIMPLEX),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Hieuh",0xeee),
   MAKE_ICONSTANT((char*)"G_NETWORK_CONNECTIVITY_LOCAL",G_NETWORK_CONNECTIVITY_LOCAL),
   MAKE_ICONSTANT((char*)"GDK_Sinh_kunddaliya",0x1000df4),
   MAKE_ICONSTANT((char*)"GDK_KEY_F19",0xffd0),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_CLOSED",G_IO_ERROR_CLOSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_aee",0x1000d88),
   MAKE_ICONSTANT((char*)"GDK_KEY_script_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftarrow",0x8fb),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_EraseEOF",0xfd06),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_145678",0x10028f9),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_DESTINATION",G_DBUS_MESSAGE_HEADER_FIELD_DESTINATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hebrew_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_PanSios",0xef2),
   MAKE_ICONSTANT((char*)"GDK_WA_X",GDK_WA_X),
   MAKE_ICONSTANT((char*)"GDK_BUTTON2_MASK",GDK_BUTTON2_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Umacron",0x3de),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eogonek",0x1ca),
   MAKE_ICONSTANT((char*)"GDK_WLAN",0x1008ff95),
   MAKE_ICONSTANT((char*)"GDK_currency",0x0a4),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NOT_SUPPORTED",G_DBUS_ERROR_NOT_SUPPORTED),
   MAKE_ICONSTANT((char*)"GDK_Shop",0x1008ff36),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Banja",0xff39),
   MAKE_ICONSTANT((char*)"GDK_Sinh_sa",0x1000dc3),
   MAKE_ICONSTANT((char*)"GDK_Sinh_mba",0x1000db9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Idiaeresis",0x0cf),
   MAKE_ICONSTANT((char*)"GDK_Terminate_Server",0xfed5),
   MAKE_ICONSTANT((char*)"GDK_KEY_c_h",0xfea3),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_BEFORE_AND_AFTER",G_UNICODE_BREAK_BEFORE_AND_AFTER),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_INSENSITIVE",GTK_STATE_FLAG_INSENSITIVE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_CHE_descender",0x10004b6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12348",0x100288f),
   MAKE_ICONSTANT((char*)"GDK_kana_ME",0x4d2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_au",0x1000d96),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LIMBU",G_UNICODE_SCRIPT_LIMBU),
   MAKE_ICONSTANT((char*)"GDK_KEY_Shift_R",0xffe2),
   MAKE_ICONSTANT((char*)"GDK_dead_belowbreve",0xfe6b),
   MAKE_ICONSTANT((char*)"GDK_KEY_numbersign",0x023),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DfltBtnNext",0xfefb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_bha",0x1000db7),
   MAKE_ICONSTANT((char*)"GDK_ballotcross",0xaf4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SORA_SOMPENG",G_UNICODE_SCRIPT_SORA_SOMPENG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SunkyeongeumMieum",0xef0),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchE",0x1008ff4e),
   MAKE_ICONSTANT((char*)"G_BINDING_BIDIRECTIONAL",G_BINDING_BIDIRECTIONAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Henkan_Mode",0xff23),
   MAKE_ICONSTANT((char*)"GTK_RELIEF_NORMAL",GTK_RELIEF_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2347",0x100284e),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ANATOLIAN_HIEROGLYPHS",PANGO_SCRIPT_ANATOLIAN_HIEROGLYPHS),
   MAKE_ICONSTANT((char*)"GDK_KEY_8",0x038),
   MAKE_ICONSTANT((char*)"G_ASCII_PUNCT",G_ASCII_PUNCT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_7",0x1008fe07),
   MAKE_ICONSTANT((char*)"GDK_Armenian_tyun",0x100057f),
   MAKE_ICONSTANT((char*)"GTK_CALENDAR_SHOW_DAY_NAMES",GTK_CALENDAR_SHOW_DAY_NAMES),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_GESTURE_PHASE_UPDATE",GDK_TOUCHPAD_GESTURE_PHASE_UPDATE),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_2",0x1008fe02),
   MAKE_ICONSTANT((char*)"GDK_KEY_ograve",0x0f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_openingbracket",0x4a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_botrightsummation",0x8b6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_zah",0x5d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ScreenSaver",0x1008ff2d),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LAO",G_UNICODE_SCRIPT_LAO),
   MAKE_ICONSTANT((char*)"GDK_KEY_F18",0xffcf),
   MAKE_ICONSTANT((char*)"GDK_Armenian_zhe",0x100056a),
   MAKE_ICONSTANT((char*)"GDK_LaunchF",0x1008ff4f),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MEDEFAIDRIN",G_UNICODE_SCRIPT_MEDEFAIDRIN),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HEBREW",PANGO_SCRIPT_HEBREW),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_NORTH_ARABIAN",G_UNICODE_SCRIPT_OLD_NORTH_ARABIAN),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_OK",GTK_RESPONSE_OK),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MARCHEN",G_UNICODE_SCRIPT_MARCHEN),
   MAKE_ICONSTANT((char*)"G_REGEX_NO_AUTO_CAPTURE",G_REGEX_NO_AUTO_CAPTURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_134578",0x10028dd),
   MAKE_ICONSTANT((char*)"GDK_Greek_omicronaccent",0x7b7),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_EXEC_FAILED",G_DBUS_ERROR_SPAWN_EXEC_FAILED),
   MAKE_ICONSTANT((char*)"GDK_Thai_dochada",0xdae),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick2",0xfef0),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_YA",0x4d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_sabovedot",0x1001e61),
   MAKE_ICONSTANT((char*)"G_DATE_DAY",G_DATE_DAY),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarau",0xdd8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12346",0x100282f),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocaron",0x10001d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightopentriangle",0xacd),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_11",0x1008fe0b),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_IMPORT",GTK_CSS_PROVIDER_ERROR_IMPORT),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_FLAGS_NONE",G_DBUS_MESSAGE_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_schwa",0x10004d9),
   MAKE_ICONSTANT((char*)"G_REGEX_BSR_ANYCRLF",G_REGEX_BSR_ANYCRLF),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_ghe_with_upturn",0x6ad),
   MAKE_ICONSTANT((char*)"GDK_Arabic_kaf",0x5e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hyper_L",0xffed),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_TOUCHPAD",GDK_SOURCE_TOUCHPAD),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_epsilon",0x7e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_268",0x10028a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_24568",0x10028ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_TopMenu",0x1008ffa2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_omicronaccent",0x7b7),
   MAKE_ICONSTANT((char*)"GDK_ht",0x9e2),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_MAYBE",G_VARIANT_CLASS_MAYBE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Hieuh",0xebe),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_CANNOT_INFER_TYPE",G_VARIANT_PARSE_ERROR_CANNOT_INFER_TYPE),
   MAKE_ICONSTANT((char*)"GDK_Ccaron",0x1c8),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_MI",0x4d0),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ka",0x1000d9a),
   MAKE_ICONSTANT((char*)"GDK_emptyset",0x1002205),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT",GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_JE",0x6b8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Kcedilla",0x3d3),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_INTRO",GTK_ASSISTANT_PAGE_INTRO),
   MAKE_ICONSTANT((char*)"GDK_ecircumflexacute",0x1001ebf),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ZHE_descender",0x1000496),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2356",0x1002836),
   MAKE_ICONSTANT((char*)"GDK_kana_NE",0x4c8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_veh",0x10006a4),
   MAKE_ICONSTANT((char*)"GTK_ACCEL_VISIBLE",GTK_ACCEL_VISIBLE),
   MAKE_ICONSTANT((char*)"GDK_Ohorntilde",0x1001ee0),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_CursorSelect",0xfd1c),
   MAKE_ICONSTANT((char*)"G_UNICODE_LETTER_NUMBER",G_UNICODE_LETTER_NUMBER),
   MAKE_ICONSTANT((char*)"GDK_KEY_M",0x04d),
   MAKE_ICONSTANT((char*)"GDK_Shift_Lock",0xffe6),
   MAKE_ICONSTANT((char*)"GDK_KEY_cacute",0x1e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ka",0x1000d9a),
   MAKE_ICONSTANT((char*)"GDK_BOTTOM_LEFT_CORNER",GDK_BOTTOM_LEFT_CORNER),
   MAKE_ICONSTANT((char*)"GDK_Arabic_alef",0x5c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TA",0x4c0),
   MAKE_ICONSTANT((char*)"GTK_SENSITIVITY_AUTO",GTK_SENSITIVITY_AUTO),
   MAKE_ICONSTANT((char*)"GDK_KEY_cabovedot",0x2e5),
   MAKE_ICONSTANT((char*)"GDK_Greek_rho",0x7f1),
   MAKE_ICONSTANT((char*)"GDK_dead_abovering",0xfe58),
   MAKE_ICONSTANT((char*)"GDK_Menu",0xff67),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP",GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_GENERIC_ERROR",G_TLS_CERTIFICATE_GENERIC_ERROR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Pieub",0xee4),
   MAKE_ICONSTANT((char*)"GDK_uparrow",0x8fc),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GUJARATI",PANGO_SCRIPT_GUJARATI),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hah",0x5cd),
   MAKE_ICONSTANT((char*)"GDK_Ibreve",0x100012c),
   MAKE_ICONSTANT((char*)"GDK_Byelorussian_shortu",0x6ae),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_DZE",0x6bf),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_FORWARD",GTK_SCROLL_PAGE_FORWARD),
   MAKE_ICONSTANT((char*)"GTK_STATE_NORMAL",GTK_STATE_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_KE",0x1000554),
   MAKE_ICONSTANT((char*)"GTK_FILE_FILTER_URI",GTK_FILE_FILTER_URI),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1247",0x100284b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ra",0x1000dbb),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ef",0x6c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_BrightnessAdjust",0x1008ff3b),
   MAKE_ICONSTANT((char*)"GDK_KEY_ygrave",0x1001ef3),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_ET",PANGO_BIDI_TYPE_ET),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_UNKNOWN",GDK_SUBPIXEL_LAYOUT_UNKNOWN),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KAYAH_LI",PANGO_SCRIPT_KAYAH_LI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thophuthao",0xdb2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YAE",0xec2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_na",0x1000db1),
   MAKE_ICONSTANT((char*)"GDK_hyphen",0x0ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_RI",0x4d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_L3",0xffca),
   MAKE_ICONSTANT((char*)"GDK_KEY_RockerDown",0x1008ff24),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_HA_descender",0x10004b2),
   MAKE_ICONSTANT((char*)"GDK_V",0x056),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_CANT_CREATE_BACKUP",G_IO_ERROR_CANT_CREATE_BACKUP),
   MAKE_ICONSTANT((char*)"GDK_3270_CursorBlink",0xfd0f),
   MAKE_ICONSTANT((char*)"GDK_KEY_sevensubscript",0x1002087),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_GHE_WITH_UPTURN",0x6bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_WI",0xecf),
   MAKE_ICONSTANT((char*)"GDK_Display",0x1008ff59),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_DIR_RTL",GTK_ICON_LOOKUP_DIR_RTL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Memo",0x1008ff1e),
   MAKE_ICONSTANT((char*)"GDK_Greek_upsilon",0x7f5),
   MAKE_ICONSTANT((char*)"GDK_ACTION_LINK",GDK_ACTION_LINK),
   MAKE_ICONSTANT((char*)"G_DBUS_PROPERTY_INFO_FLAGS_NONE",G_DBUS_PROPERTY_INFO_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Close",0x1008ff56),
   MAKE_ICONSTANT((char*)"PANGO_VARIANT_SMALL_CAPS",PANGO_VARIANT_SMALL_CAPS),
   MAKE_ICONSTANT((char*)"GDK_QUESTION_ARROW",GDK_QUESTION_ARROW),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_SUBSURFACE",GDK_WINDOW_SUBSURFACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_dal",0x5cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_uu2",0x1000dd6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohook",0x1001ece),
   MAKE_ICONSTANT((char*)"GDK_Sinh_dhha",0x1000db0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraaimaimalai",0xde4),
   MAKE_ICONSTANT((char*)"GDK_KEY_CH",0xfea2),
   MAKE_ICONSTANT((char*)"GDK_KP_End",0xff9c),
   MAKE_ICONSTANT((char*)"GDK_LogOff",0x1008ff61),
   MAKE_ICONSTANT((char*)"GDK_SHUTTLE",GDK_SHUTTLE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_farsi_yeh",0x10006cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_alef",0x5c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_notelementof",0x1002209),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_waw",0x5e8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3",0x1002804),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_134",0x100280d),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhornbelowdot",0x1001ef1),
   MAKE_ICONSTANT((char*)"PANGO_COVERAGE_APPROXIMATE",PANGO_COVERAGE_APPROXIMATE),
   MAKE_ICONSTANT((char*)"PANGO_TAB_LEFT",PANGO_TAB_LEFT),
   MAKE_ICONSTANT((char*)"GDK_Thai_maihanakat_maitho",0xdde),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_MIDDLE",2),
   MAKE_ICONSTANT((char*)"G_UNICODE_TITLECASE_LETTER",G_UNICODE_TITLECASE_LETTER),
   MAKE_ICONSTANT((char*)"G_APPLICATION_SEND_ENVIRONMENT",G_APPLICATION_SEND_ENVIRONMENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_beh",0x5c8),
   MAKE_ICONSTANT((char*)"GDK_Ytilde",0x1001ef8),
   MAKE_ICONSTANT((char*)"GDK_KEY_PRESS_MASK",GDK_KEY_PRESS_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ntilde",0x0d1),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HANGUL_L_JAMO",G_UNICODE_BREAK_HANGUL_L_JAMO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zstroke",0x10001b5),
   MAKE_ICONSTANT((char*)"GDK_o",0x06f),
   MAKE_ICONSTANT((char*)"GDK_Arabic_6",0x1000666),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_PIPE",G_FILE_ERROR_PIPE),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_UPPERCASE_WORDS",GTK_INPUT_HINT_UPPERCASE_WORDS),
   MAKE_ICONSTANT((char*)"GDK_KEY_checkerboard",0x9e1),
   MAKE_ICONSTANT((char*)"G_FILE_TEST_IS_REGULAR",G_FILE_TEST_IS_REGULAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Market",0x1008ff62),
   MAKE_ICONSTANT((char*)"GDK_KEY_yhook",0x1001ef7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_FE",0x1000556),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_PEN",GDK_DEVICE_TOOL_TYPE_PEN),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TANGUT",G_UNICODE_SCRIPT_TANGUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23568",0x10028b6),
   MAKE_ICONSTANT((char*)"GTK_IM_STATUS_CALLBACK",GTK_IM_STATUS_CALLBACK),
   MAKE_ICONSTANT((char*)"GDK_Serbian_DZE",0x6bf),
   MAKE_ICONSTANT((char*)"GDK_Help",0xff6a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Forward",0x1008ff27),
   MAKE_ICONSTANT((char*)"GDK_KEY_Igrave",0x0cc),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulKiyeog",0xedc),
   MAKE_ICONSTANT((char*)"GDK_Armenian_khe",0x100056d),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Enter",0xfd1e),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_CLOSE",GTK_RESPONSE_CLOSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_AccessX_Feedback_Enable",0xfe71),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1567",0x1002871),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_u_straight_bar",0x10004b1),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KAYAH_LI",G_UNICODE_SCRIPT_KAYAH_LI),
   MAKE_ICONSTANT((char*)"GDK_kana_N",0x4dd),
   MAKE_ICONSTANT((char*)"GDK_Greek_gamma",0x7e3),
   MAKE_ICONSTANT((char*)"GDK_jot",0xbca),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_BUSY",G_IO_ERROR_BUSY),
   MAKE_ICONSTANT((char*)"GDK_KEY_T",0x054),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_KeyClick",0xfd11),
   MAKE_ICONSTANT((char*)"GDK_Sinh_la",0x1000dbd),
   MAKE_ICONSTANT((char*)"GDK_Hiragana_Katakana",0xff27),
   MAKE_ICONSTANT((char*)"GTK_WRAP_CHAR",GTK_WRAP_CHAR),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_PHONE",GTK_INPUT_PURPOSE_PHONE),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_S",PANGO_BIDI_TYPE_S),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick5",0xfef3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_em",0x6cd),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_FREE_FORM",GTK_INPUT_PURPOSE_FREE_FORM),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflexacute",0x1001ebe),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SunkyeongeumPhieuf",0xef4),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNRECOGNIZED_ESCAPE",G_REGEX_ERROR_UNRECOGNIZED_ESCAPE),
   MAKE_ICONSTANT((char*)"GDK_SB_UP_ARROW",GDK_SB_UP_ARROW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ibreve",0x100012c),
   MAKE_ICONSTANT((char*)"GDK_Page_Up",0xff55),
   MAKE_ICONSTANT((char*)"GTK_SIZE_REQUEST_CONSTANT_SIZE",GTK_SIZE_REQUEST_CONSTANT_SIZE),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Partial_Line_Down",0xfe24),
   MAKE_ICONSTANT((char*)"GDK_dead_E",0xfe83),
   MAKE_ICONSTANT((char*)"GDK_Sabovedot",0x1001e60),
   MAKE_ICONSTANT((char*)"G_SEEK_END",G_SEEK_END),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_INVALID_FILE_CONTENT",G_DBUS_ERROR_INVALID_FILE_CONTENT),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_TOOLTIP",GDK_WINDOW_TYPE_HINT_TOOLTIP),
   MAKE_ICONSTANT((char*)"GDK_KEY_R13",0xffde),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_NieunJieuj",0xea5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SCHWA",0x10004d8),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_PAD_FEATURE_BUTTON",GDK_DEVICE_PAD_FEATURE_BUTTON),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_SEMI_EXPANDED",PANGO_STRETCH_SEMI_EXPANDED),
   MAKE_ICONSTANT((char*)"GDK_KEY_slash",0x02f),
   MAKE_ICONSTANT((char*)"GTK_EVENT_SEQUENCE_CLAIMED",GTK_EVENT_SEQUENCE_CLAIMED),
   MAKE_ICONSTANT((char*)"GDK_Zstroke",0x10001b5),
   MAKE_ICONSTANT((char*)"GDK_quad",0xbcc),
   MAKE_ICONSTANT((char*)"GDK_MenuKB",0x1008ff65),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_DJE",0x6b1),
   MAKE_ICONSTANT((char*)"GDK_Igrave",0x0cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_35678",0x10028f4),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_NONE",G_FILE_COPY_NONE),
   MAKE_ICONSTANT((char*)"GDK_Thai_loling",0xdc5),
   MAKE_ICONSTANT((char*)"GDK_WonSign",0x10020a9),
   MAKE_ICONSTANT((char*)"GDK_AudioLowerVolume",0x1008ff11),
   MAKE_ICONSTANT((char*)"GDK_HINT_ASPECT",GDK_HINT_ASPECT),
   MAKE_ICONSTANT((char*)"GDK_enopensquarebullet",0xae1),
   MAKE_ICONSTANT((char*)"GDK_Arabic_thal",0x5d0),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_dse",0x6a5),
   MAKE_ICONSTANT((char*)"GDK_KEY_F20",0xffd1),
   MAKE_ICONSTANT((char*)"GDK_threefifths",0xab4),
   MAKE_ICONSTANT((char*)"GDK_kana_SHI",0x4bc),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_BYTE_ORDER_LITTLE_ENDIAN",G_DATA_STREAM_BYTE_ORDER_LITTLE_ENDIAN),
   MAKE_ICONSTANT((char*)"GDK_TOUCH_END",GDK_TOUCH_END),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2468",0x10028aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_ngongu",0xda7),
   MAKE_ICONSTANT((char*)"GDK_H",0x048),
   MAKE_ICONSTANT((char*)"GDK_KEY_Fabovedot",0x1001e1e),
   MAKE_ICONSTANT((char*)"GDK_First_Virtual_Screen",0xfed0),
   MAKE_ICONSTANT((char*)"GDK_R12",0xffdd),
   MAKE_ICONSTANT((char*)"GDK_ecircumflexhook",0x1001ec3),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraae",0xde1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ZA",0x1000536),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_SET",G_SETTINGS_BIND_SET),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_ACTION_PREVIEW",GTK_PRINT_OPERATION_ACTION_PREVIEW),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GEORGIAN",G_UNICODE_SCRIPT_GEORGIAN),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_34",0x100280c),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_doublelowline",0xcdf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Itilde",0x3a5),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_NFKD",G_NORMALIZE_NFKD),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Jieuj",0xee9),
   MAKE_ICONSTANT((char*)"G_PARAM_EXPLICIT_NOTIFY",G_PARAM_EXPLICIT_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_Greek_THETA",0x7c8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_A",0xebf),
   MAKE_ICONSTANT((char*)"GDK_emopencircle",0xace),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_VALIDATE_ALL",G_TLS_CERTIFICATE_VALIDATE_ALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pabovedot",0x1001e56),
   MAKE_ICONSTANT((char*)"GDK_PAD_STRIP",GDK_PAD_STRIP),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_HANDLE",G_VARIANT_CLASS_HANDLE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BASSA_VAH",G_UNICODE_SCRIPT_BASSA_VAH),
   MAKE_ICONSTANT((char*)"GDK_PROXIMITY_IN",GDK_PROXIMITY_IN),
   MAKE_ICONSTANT((char*)"G_UNICODE_OPEN_PUNCTUATION",G_UNICODE_OPEN_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_lam",0x5e4),
   MAKE_ICONSTANT((char*)"GDK_LEAVE_NOTIFY",GDK_LEAVE_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_r",0x072),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Mieum",0xeb1),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_samech",0xcf1),
   MAKE_ICONSTANT((char*)"G_CONVERTER_ERROR",G_CONVERTER_ERROR),
   MAKE_ICONSTANT((char*)"GDK_DRAG_STATUS",GDK_DRAG_STATUS),
   MAKE_ICONSTANT((char*)"GDK_kana_WA",0x4dc),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Down",0xfee3),
   MAKE_ICONSTANT((char*)"GDK_Thai_thothong",0xdb8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_14568",0x10028b9),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_HINT_LINE",PANGO_GRAVITY_HINT_LINE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_UNKNOWN",G_UNICODE_SCRIPT_UNKNOWN),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_AGAIN",G_FILE_ERROR_AGAIN),
   MAKE_ICONSTANT((char*)"GDK_AudioForward",0x1008ff97),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KATAKANA",G_UNICODE_SCRIPT_KATAKANA),
   MAKE_ICONSTANT((char*)"GTK_PAN_DIRECTION_DOWN",GTK_PAN_DIRECTION_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Gcircumflex",0x2d8),
   MAKE_ICONSTANT((char*)"GDK_3270_Rule",0xfd14),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_UNKNOWN_INTERFACE",G_DBUS_ERROR_UNKNOWN_INTERFACE),
   MAKE_ICONSTANT((char*)"GDK_hebrew_daleth",0xce3),
   MAKE_ICONSTANT((char*)"GTK_STYLE_PROVIDER_PRIORITY_APPLICATION",600),
   MAKE_ICONSTANT((char*)"GDK_Thai_fofa",0xdbd),
   MAKE_ICONSTANT((char*)"GDK_KEY_L7",0xffce),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_6",0xffb6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_7",0x1002840),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_KU",0x4b8),
   MAKE_ICONSTANT((char*)"G_SIGNAL_FLAGS_MASK",0x1ff),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhook",0x1001ee7),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_PRESSURE",GDK_AXIS_FLAG_PRESSURE),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_INTERACTIVE",GTK_DEBUG_INTERACTIVE),
   MAKE_ICONSTANT((char*)"GDK_VISIBILITY_NOTIFY",GDK_VISIBILITY_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_Zcaron",0x1ae),
   MAKE_ICONSTANT((char*)"GDK_kana_middledot",0x4a5),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_F4",0xff94),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_KkogjiDalrinIeung",0xef9),
   MAKE_ICONSTANT((char*)"G_PASSWORD_SAVE_PERMANENTLY",G_PASSWORD_SAVE_PERMANENTLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lekpaet",0xdf8),
   MAKE_ICONSTANT((char*)"GDK_Hangul_KiyeogSios",0xea3),
   MAKE_ICONSTANT((char*)"GDK_Armenian_amanak",0x100055c),
   MAKE_ICONSTANT((char*)"GDK_KEY_upleftcorner",0x9ec),
   MAKE_ICONSTANT((char*)"GDK_KEY_Korean_Won",0xeff),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_REPLACE",G_REGEX_ERROR_REPLACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_je",0x6a8),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NEWLINE_ANYCRLF",G_REGEX_MATCH_NEWLINE_ANYCRLF),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1234578",0x10028df),
   MAKE_ICONSTANT((char*)"GDK_botrightsqbracket",0x8aa),
   MAKE_ICONSTANT((char*)"GDK_hebrew_samech",0xcf1),
   MAKE_ICONSTANT((char*)"GDK_L10",0xffd1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Oacute",0x0d3),
   MAKE_ICONSTANT((char*)"GDK_implies",0x8ce),
   MAKE_ICONSTANT((char*)"G_UNIX_SOCKET_ADDRESS_INVALID",G_UNIX_SOCKET_ADDRESS_INVALID),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_CHE_descender",0x10004b6),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME",GTK_FILE_CHOOSER_CONFIRMATION_ACCEPT_FILENAME),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_SELECTED",GTK_CELL_RENDERER_SELECTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_tabovedot",0x1001e6b),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchA",0x1008ff4a),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_PrintScreen",0xfd1d),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_LEFT",GTK_SCROLL_STEP_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_VendorHome",0x1008ff34),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_GRID_LINES_HORIZONTAL",GTK_TREE_VIEW_GRID_LINES_HORIZONTAL),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13678",0x10028e5),
   MAKE_ICONSTANT((char*)"G_SOCKET_FAMILY_IPV6",G_SOCKET_FAMILY_IPV6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_iotaaccent",0x7b4),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_VERSION_MISMATCH",GTK_BUILDER_ERROR_VERSION_MISMATCH),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1678",0x10028e1),
   MAKE_ICONSTANT((char*)"G_SIGNAL_RUN_FIRST",G_SIGNAL_RUN_FIRST),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT",GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalpe",0xcf3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_zhe_descender",0x1000497),
   MAKE_ICONSTANT((char*)"GDK_Aring",0x0c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_be",0x6c2),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_FLIP_Y",GDK_ANCHOR_FLIP_Y),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_UGARITIC",G_UNICODE_SCRIPT_UGARITIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1278",0x10028c3),
   MAKE_ICONSTANT((char*)"GDK_KbdBrightnessDown",0x1008ff06),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_FLIP_X",GDK_ANCHOR_FLIP_X),
   MAKE_ICONSTANT((char*)"GDK_KEY_aacute",0x0e1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_khah",0x5ce),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_126",0x1002823),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NKO",G_UNICODE_SCRIPT_NKO),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick4",0xfef2),
   MAKE_ICONSTANT((char*)"G_REGEX_RAW",G_REGEX_RAW),
   MAKE_ICONSTANT((char*)"GDK_KEY_notsign",0x0ac),
   MAKE_ICONSTANT((char*)"GDK_Arabic_ra",0x5d1),
   MAKE_ICONSTANT((char*)"GDK_dead_belowdot",0xfe60),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level5_Lock",0xfe13),
   MAKE_ICONSTANT((char*)"GDK_Georgian_en",0x10010d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_gan",0x10010d2),
   MAKE_ICONSTANT((char*)"G_DBUS_PROPERTY_INFO_FLAGS_READABLE",G_DBUS_PROPERTY_INFO_FLAGS_READABLE),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_INVALID_CODE",PANGO_SCRIPT_INVALID_CODE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2458",0x100289a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_dza",0x1000571),
   MAKE_ICONSTANT((char*)"GDK_gcedilla",0x3bb),
   MAKE_ICONSTANT((char*)"GDK_Zenkaku",0xff28),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_TRACKPOINT",GDK_SOURCE_TRACKPOINT),
   MAKE_ICONSTANT((char*)"GDK_KEY_ZoomIn",0x1008ff8b),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ayb",0x1000561),
   MAKE_ICONSTANT((char*)"GDK_Greek_beta",0x7e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_New",0x1008ff68),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_SOGDIAN",G_UNICODE_SCRIPT_OLD_SOGDIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1234567",0x100287f),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NUSHU",G_UNICODE_SCRIPT_NUSHU),
   MAKE_ICONSTANT((char*)"GDK_Uhornacute",0x1001ee8),
   MAKE_ICONSTANT((char*)"GDK_KEY_PRESS",GDK_KEY_PRESS),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_AL",PANGO_BIDI_TYPE_AL),
   MAKE_ICONSTANT((char*)"GDK_3BUTTON_PRESS",GDK_3BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_5",0x10006f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Meeting",0x1008ff63),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_CANCELLED",G_IO_ERROR_CANCELLED),
   MAKE_ICONSTANT((char*)"GTK_CORNER_TOP_RIGHT",GTK_CORNER_TOP_RIGHT),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BUHID",PANGO_SCRIPT_BUHID),
   MAKE_ICONSTANT((char*)"G_TYPE_RESERVED_GLIB_FIRST",22),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_SE",0x100054d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23467",0x100286e),
   MAKE_ICONSTANT((char*)"GDK_Pictures",0x1008ff91),
   MAKE_ICONSTANT((char*)"GDK_signifblank",0xaac),
   MAKE_ICONSTANT((char*)"GDK_paragraph",0x0b6),
   MAKE_ICONSTANT((char*)"GDK_Sinh_a",0x1000d85),
   MAKE_ICONSTANT((char*)"G_SOCKET_LISTENER_LISTENED",G_SOCKET_LISTENER_LISTENED),
   MAKE_ICONSTANT((char*)"G_TLS_AUTHENTICATION_NONE",G_TLS_AUTHENTICATION_NONE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ghe",0x6c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_IOTAaccent",0x7a4),
   MAKE_ICONSTANT((char*)"GDK_Eth",0x0d0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1234578",0x10028df),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1267",0x1002863),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3468",0x10028ac),
   MAKE_ICONSTANT((char*)"GDK_pabovedot",0x1001e57),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_INI",0x100053b),
   MAKE_ICONSTANT((char*)"GDK_dead_a",0xfe80),
   MAKE_ICONSTANT((char*)"PANGO_COVERAGE_FALLBACK",PANGO_COVERAGE_FALLBACK),
   MAKE_ICONSTANT((char*)"GDK_Arabic_1",0x1000661),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftcaret",0xba3),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CHEROKEE",G_UNICODE_SCRIPT_CHEROKEE),
   MAKE_ICONSTANT((char*)"GDK_VISIBILITY_NOTIFY_MASK",GDK_VISIBILITY_NOTIFY_MASK),
   MAKE_ICONSTANT((char*)"GDK_Farsi_2",0x10006f2),
   MAKE_ICONSTANT((char*)"GDK_Greek_eta",0x7e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Adiaeresis",0x0c4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12457",0x100285b),
   MAKE_ICONSTANT((char*)"GDK_KEY_5",0x035),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_EN",PANGO_BIDI_TYPE_EN),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123458",0x100289f),
   MAKE_ICONSTANT((char*)"G_UNICODE_LINE_SEPARATOR",G_UNICODE_LINE_SEPARATOR),
   MAKE_ICONSTANT((char*)"GDK_Georgian_on",0x10010dd),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_FILE_EXISTS",G_DBUS_ERROR_FILE_EXISTS),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_RISE",PANGO_ATTR_RISE),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_NO_FALLBACK_FOR_MOVE",G_FILE_COPY_NO_FALLBACK_FOR_MOVE),
   MAKE_ICONSTANT((char*)"GTK_UPDATE_IF_VALID",GTK_UPDATE_IF_VALID),
   MAKE_ICONSTANT((char*)"G_MOUNT_UNMOUNT_FORCE",G_MOUNT_UNMOUNT_FORCE),
   MAKE_ICONSTANT((char*)"GDK_KEY_intersection",0x8dc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zenkaku",0xff28),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SORA_SOMPENG",PANGO_SCRIPT_SORA_SOMPENG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_JE",0x6b4),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_che",0x6de),
   MAKE_ICONSTANT((char*)"GDK_LEFT_PTR",GDK_LEFT_PTR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13457",0x100285d),
   MAKE_ICONSTANT((char*)"GDK_Hangul",0xff31),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_en_descender",0x10004a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_chochoe",0xdac),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhorngrave",0x1001eeb),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohornacute",0x1001edb),
   MAKE_ICONSTANT((char*)"GDK_KEY_filledtribulletdown",0xae9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SYLOTI_NAGRI",PANGO_SCRIPT_SYLOTI_NAGRI),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_NUMBER_TOO_BIG",G_REGEX_ERROR_NUMBER_TOO_BIG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflexgrave",0x1001ea6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_o_bar",0x10004e9),
   MAKE_ICONSTANT((char*)"GDK_Armenian_but",0x100055d),
   MAKE_ICONSTANT((char*)"GTK_DEST_DEFAULT_MOTION",GTK_DEST_DEFAULT_MOTION),
   MAKE_ICONSTANT((char*)"GTK_WIN_POS_NONE",GTK_WIN_POS_NONE),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_GRAVITY_HINT",PANGO_ATTR_GRAVITY_HINT),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_DUPLOYAN",G_UNICODE_SCRIPT_DUPLOYAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_currency",0x0a4),
   MAKE_ICONSTANT((char*)"GDK_MODE_WINDOW",GDK_MODE_WINDOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_closingbracket",0x4a3),
   MAKE_ICONSTANT((char*)"GDK_p",0x070),
   MAKE_ICONSTANT((char*)"GTK_RECENT_SORT_CUSTOM",GTK_RECENT_SORT_CUSTOM),
   MAKE_ICONSTANT((char*)"G_REGEX_EXTENDED",G_REGEX_EXTENDED),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_8",0x1002880),
   MAKE_ICONSTANT((char*)"GDK_lowrightcorner",0x9ea),
   MAKE_ICONSTANT((char*)"GTK_SELECTION_MULTIPLE",GTK_SELECTION_MULTIPLE),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HYPHEN",G_UNICODE_BREAK_HYPHEN),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_24",0x100280a),
   MAKE_ICONSTANT((char*)"GDK_dead_greek",0xfe8c),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_INSCRIPTIONAL_PAHLAVI",G_UNICODE_SCRIPT_INSCRIPTIONAL_PAHLAVI),
   MAKE_ICONSTANT((char*)"GDK_Greek_UPSILONaccent",0x7a8),
   MAKE_ICONSTANT((char*)"GTK_WINDOW_TOPLEVEL",GTK_WINDOW_TOPLEVEL),
   MAKE_ICONSTANT((char*)"GDK_Greek_iotadieresis",0x7b5),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ae2",0x1000dd0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_AT",0x1000538),
   MAKE_ICONSTANT((char*)"GDK_Yacute",0x0dd),
   MAKE_ICONSTANT((char*)"GDK_TaskPane",0x1008ff7f),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NOENT",G_FILE_ERROR_NOENT),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_NOT_ACTIVATED",G_TLS_CERTIFICATE_NOT_ACTIVATED),
   MAKE_ICONSTANT((char*)"GDK_Greek_accentdieresis",0x7ae),
   MAKE_ICONSTANT((char*)"G_TLS_PASSWORD_NONE",G_TLS_PASSWORD_NONE),
   MAKE_ICONSTANT((char*)"G_TLS_DATABASE_VERIFY_NONE",G_TLS_DATABASE_VERIFY_NONE),
   MAKE_ICONSTANT((char*)"GDK_INPUT_ONLY",GDK_INPUT_ONLY),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Sios",0xee6),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_MU",0x4d1),
   MAKE_ICONSTANT((char*)"GTK_DIR_DOWN",GTK_DIR_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_pyur",0x1000583),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ya",0x6d1),
   MAKE_ICONSTANT((char*)"GDK_HAND2",GDK_HAND2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhook",0x1001ee6),
   MAKE_ICONSTANT((char*)"G_PARAM_PRIVATE",G_PARAM_PRIVATE),
   MAKE_ICONSTANT((char*)"GDK_F10",0xffc7),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightanglebracket",0xabe),
   MAKE_ICONSTANT((char*)"GDK_TOUCH_CANCEL",GDK_TOUCH_CANCEL),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ELBASAN",PANGO_SCRIPT_ELBASAN),
   MAKE_ICONSTANT((char*)"GDK_MSB_FIRST",GDK_MSB_FIRST),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_UINT32",G_VARIANT_CLASS_UINT32),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2457",0x100285a),
   MAKE_ICONSTANT((char*)"G_DATE_SATURDAY",G_DATE_SATURDAY),
   MAKE_ICONSTANT((char*)"GDK_ccaron",0x1e8),
   MAKE_ICONSTANT((char*)"GDK_ISO_Partial_Line_Down",0xfe24),
   MAKE_ICONSTANT((char*)"GDK_Next",0xff56),
   MAKE_ICONSTANT((char*)"GDK_BrightnessAdjust",0x1008ff3b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Aacute",0x0c1),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_NEED_USERNAME",G_ASK_PASSWORD_NEED_USERNAME),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_ALLOW_ANONYMOUS",G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_ALLOW_ANONYMOUS),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BRAHMI",PANGO_SCRIPT_BRAHMI),
   MAKE_ICONSTANT((char*)"GDK_3270_Reset",0xfd08),
   MAKE_ICONSTANT((char*)"GDK_Red",0x1008ffa3),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_5",0xfff5),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ha_descender",0x10004b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_threesuperior",0x0b3),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_TYPE_METHOD_RETURN",G_DBUS_MESSAGE_TYPE_METHOD_RETURN),
   MAKE_ICONSTANT((char*)"GDK_KEY_dollar",0x024),
   MAKE_ICONSTANT((char*)"GDK_G",0x047),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_ENDS",GTK_SCROLL_ENDS),
   MAKE_ICONSTANT((char*)"PANGO_UNKNOWN_GLYPH_WIDTH",10),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CHAKMA",G_UNICODE_SCRIPT_CHAKMA),
   MAKE_ICONSTANT((char*)"GDK_notequal",0x8bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_twosuperior",0x0b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_etaaccent",0x7b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_zayin",0xce6),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_BEFORE",G_UNICODE_BREAK_BEFORE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1578",0x10028d1),
   MAKE_ICONSTANT((char*)"GDK_KP_Divide",0xffaf),
   MAKE_ICONSTANT((char*)"GDK_F33",0xffde),
   MAKE_ICONSTANT((char*)"GDK_KEY_Select",0xff60),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1258",0x1002893),
   MAKE_ICONSTANT((char*)"GDK_KEY_botrightsqbracket",0x8aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_F9",0xffc6),
   MAKE_ICONSTANT((char*)"GDK_Super_R",0xffec),
   MAKE_ICONSTANT((char*)"GTK_TOOL_PALETTE_DRAG_ITEMS",GTK_TOOL_PALETTE_DRAG_ITEMS),
   MAKE_ICONSTANT((char*)"GDK_Georgian_zhar",0x10010df),
   MAKE_ICONSTANT((char*)"GDK_Left",0xff51),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_UPSILONdieresis",0x7a9),
   MAKE_ICONSTANT((char*)"GDK_wcircumflex",0x1000175),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_VARIABLE_LENGTH_LOOKBEHIND",G_REGEX_ERROR_VARIABLE_LENGTH_LOOKBEHIND),
   MAKE_ICONSTANT((char*)"GDK_Serbian_lje",0x6a9),
   MAKE_ICONSTANT((char*)"GDK_Otilde",0x0d5),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_ACCEPT",GTK_RESPONSE_ACCEPT),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_HIDDEN",GTK_BORDER_STYLE_HIDDEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_quad",0xbcc),
   MAKE_ICONSTANT((char*)"GDK_Codeinput",0xff37),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_GPL_2_0",GTK_LICENSE_GPL_2_0),
   MAKE_ICONSTANT((char*)"GTK_PAD_ACTION_BUTTON",GTK_PAD_ACTION_BUTTON),
   MAKE_ICONSTANT((char*)"GDK_Yhook",0x1001ef6),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MANDAIC",PANGO_SCRIPT_MANDAIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_ellipsis",0xaae),
   MAKE_ICONSTANT((char*)"GDK_PROPERTY_NEW_VALUE",GDK_PROPERTY_NEW_VALUE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_124567",0x100287b),
   MAKE_ICONSTANT((char*)"GDK_PreviousCandidate",0xff3e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_234568",0x10028be),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_ha",0x5e7),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MAKASAR",G_UNICODE_SCRIPT_MAKASAR),
   MAKE_ICONSTANT((char*)"GDK_Thai_maitaikhu",0xde7),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_I",0x6b6),
   MAKE_ICONSTANT((char*)"GDK_topt",0x9f7),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_MINIMUM",GTK_SCROLL_MINIMUM),
   MAKE_ICONSTANT((char*)"GDK_dead_voiced_sound",0xfe5e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_SIGMA",0x7d2),
   MAKE_ICONSTANT((char*)"GDK_Greek_ALPHAaccent",0x7a1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_346",0x100282c),
   MAKE_ICONSTANT((char*)"GDK_KEY_scircumflex",0x2fe),
   MAKE_ICONSTANT((char*)"G_UNICHAR_MAX_DECOMPOSITION_LENGTH",18),
   MAKE_ICONSTANT((char*)"GDK_Thai_thothan",0xdb0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_oo2",0x1000ddd),
   MAKE_ICONSTANT((char*)"GDK_KEY_LightBulb",0x1008ff35),
   MAKE_ICONSTANT((char*)"GDK_KEY_squareroot",0x100221a),
   MAKE_ICONSTANT((char*)"GDK_hebrew_qoph",0xcf7),
   MAKE_ICONSTANT((char*)"GTK_PRINT_PAGES_ALL",GTK_PRINT_PAGES_ALL),
   MAKE_ICONSTANT((char*)"GDK_Blue",0x1008ffa6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_totao",0xdb5),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_REVOKED",G_TLS_CERTIFICATE_REVOKED),
   MAKE_ICONSTANT((char*)"GDK_KEY_underscore",0x05f),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2568",0x10028b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_LJE",0x6b9),
   MAKE_ICONSTANT((char*)"GDK_Arabic_tah",0x5d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_separation_mark",0x100055d),
   MAKE_ICONSTANT((char*)"GDK_script_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_16_MASK",GDK_MODIFIER_RESERVED_16_MASK),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_RIGHT",GTK_SCROLL_STEP_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Mabovedot",0x1001e40),
   MAKE_ICONSTANT((char*)"GDK_Armenian_vev",0x100057e),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Rule",0xfd14),
   MAKE_ICONSTANT((char*)"GDK_AudioRecord",0x1008ff1c),
   MAKE_ICONSTANT((char*)"GDK_F25",0xffd6),
   MAKE_ICONSTANT((char*)"GDK_kana_yo",0x4ae),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarauu",0xdd9),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ER",0x6f2),
   MAKE_ICONSTANT((char*)"GDK_Greek_upsilondieresis",0x7b9),
   MAKE_ICONSTANT((char*)"GDK_Arabic_heh_doachashmee",0x10006be),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_shha",0x10004bb),
   MAKE_ICONSTANT((char*)"GDK_Hyper_R",0xffee),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_248",0x100288a),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_ASSERTION_EXPECTED",G_REGEX_ERROR_ASSERTION_EXPECTED),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TIRHUTA",PANGO_SCRIPT_TIRHUTA),
   MAKE_ICONSTANT((char*)"GTK_UNIT_PIXEL",GTK_UNIT_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_chin",0x10010e9),
   MAKE_ICONSTANT((char*)"GDK_3270_EraseInput",0xfd07),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_8",0x1002880),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Dikeud",0xeda),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_KHE",0x100053d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_8",0x1008fe08),
   MAKE_ICONSTANT((char*)"GDK_Thai_leknung",0xdf1),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ii",0x1000d8a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123568",0x10028b7),
   MAKE_ICONSTANT((char*)"GDK_filledlefttribullet",0xadc),
   MAKE_ICONSTANT((char*)"GDK_KP_Separator",0xffac),
   MAKE_ICONSTANT((char*)"GDK_upshoe",0xbc3),
   MAKE_ICONSTANT((char*)"GDK_KEY_cedilla",0x0b8),
   MAKE_ICONSTANT((char*)"GDK_kappa",0x3a2),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_YI",0x6b7),
   MAKE_ICONSTANT((char*)"GDK_BOAT",GDK_BOAT),
   MAKE_ICONSTANT((char*)"GDK_kana_KA",0x4b6),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_ANONYMOUS_SUPPORTED",G_ASK_PASSWORD_ANONYMOUS_SUPPORTED),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_LEFT",GTK_TEXT_WINDOW_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_XI",0x7ce),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_BOOK",PANGO_WEIGHT_BOOK),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1236",0x1002827),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_4568",0x10028b8),
   MAKE_ICONSTANT((char*)"GDK_KEY_WWW",0x1008ff2e),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Khieuq",0xeeb),
   MAKE_ICONSTANT((char*)"GDK_F11",0xffc8),
   MAKE_ICONSTANT((char*)"G_EMBLEM_ORIGIN_TAG",G_EMBLEM_ORIGIN_TAG),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_e",0xfe82),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecaron",0x1ec),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_BACKWARD",GTK_SCROLL_STEP_BACKWARD),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Prev_Group",0xfe0a),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TYPE_MASTER",GDK_DEVICE_TYPE_MASTER),
   MAKE_ICONSTANT((char*)"GDK_notidentical",0x1002262),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_UNGRAB",GDK_CROSSING_UNGRAB),
   MAKE_ICONSTANT((char*)"GDK_SelectButton",0x1008ffa0),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_ADT_AUDIT_DATA_UNKNOWN",G_DBUS_ERROR_ADT_AUDIT_DATA_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_kana_KU",0x4b8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3458",0x100289c),
   MAKE_ICONSTANT((char*)"GDK_kana_MI",0x4d0),
   MAKE_ICONSTANT((char*)"GDK_Georgian_we",0x10010f3),
   MAKE_ICONSTANT((char*)"GDK_COFFEE_MUG",GDK_COFFEE_MUG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_psi",0x7f8),
   MAKE_ICONSTANT((char*)"PANGO_UNDERLINE_LOW",PANGO_UNDERLINE_LOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_fourthroot",0x100221c),
   MAKE_ICONSTANT((char*)"GDK_Greek_delta",0x7e4),
   MAKE_ICONSTANT((char*)"GDK_Thai_phinthu",0xdda),
   MAKE_ICONSTANT((char*)"GDK_KEY_Kana_Lock",0xff2d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflexhook",0x1001ed4),
   MAKE_ICONSTANT((char*)"GDK_topleftradical",0x8a2),
   MAKE_ICONSTANT((char*)"GDK_SETTING_ACTION_NEW",GDK_SETTING_ACTION_NEW),
   MAKE_ICONSTANT((char*)"GDK_KEY_R8",0xffd9),
   MAKE_ICONSTANT((char*)"GDK_KEY_onefifth",0xab2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_nje",0x6aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Messenger",0x1008ff8e),
   MAKE_ICONSTANT((char*)"GDK_kana_o",0x4ab),
   MAKE_ICONSTANT((char*)"GDK_Greek_UPSILONdieresis",0x7a9),
   MAKE_ICONSTANT((char*)"GDK_z",0x07a),
   MAKE_ICONSTANT((char*)"GDK_Armenian_e",0x1000567),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_HARDSIGN",0x6ff),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Pieub",0xeb2),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_u",0xfe88),
   MAKE_ICONSTANT((char*)"GDK_RotationPB",0x1008ff75),
   MAKE_ICONSTANT((char*)"GDK_KEY_filledrighttribullet",0xadd),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalnun",0xcef),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_N",0x4dd),
   MAKE_ICONSTANT((char*)"G_APP_INFO_CREATE_SUPPORTS_URIS",G_APP_INFO_CREATE_SUPPORTS_URIS),
   MAKE_ICONSTANT((char*)"GDK_kana_TI",0x4c1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braceright",0x07d),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MODI",PANGO_SCRIPT_MODI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_a",0x1000d85),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_PENDING_ISSUE",GTK_PRINT_STATUS_PENDING_ISSUE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KHAROSHTHI",G_UNICODE_SCRIPT_KHAROSHTHI),
   MAKE_ICONSTANT((char*)"GDK_KEY_greater",0x03e),
   MAKE_ICONSTANT((char*)"GDK_OWNERSHIP_WINDOW",GDK_OWNERSHIP_WINDOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Dabovedot",0x1001e0a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Super_L",0xffeb),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_DASHED",GTK_BORDER_STYLE_DASHED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2345678",0x10028fe),
   MAKE_ICONSTANT((char*)"GDK_Georgian_qar",0x10010e7),
   MAKE_ICONSTANT((char*)"G_APP_INFO_CREATE_NONE",G_APP_INFO_CREATE_NONE),
   MAKE_ICONSTANT((char*)"GDK_Sinh_tha",0x1000dad),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_E",0x6fc),
   MAKE_ICONSTANT((char*)"GDK_dead_belowtilde",0xfe6a),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAI_VIET",G_UNICODE_SCRIPT_TAI_VIET),
   MAKE_ICONSTANT((char*)"GDK_KEY_ContrastAdjust",0x1008ff22),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123467",0x100286f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_e",0x1000d91),
   MAKE_ICONSTANT((char*)"GDK_Etilde",0x1001ebc),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_SEND_MOVED",G_FILE_MONITOR_SEND_MOVED),
   MAKE_ICONSTANT((char*)"GDK_Sinh_e",0x1000d91),
   MAKE_ICONSTANT((char*)"GDK_Abrevegrave",0x1001eb0),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_MENU",GTK_ICON_SIZE_MENU),
   MAKE_ICONSTANT((char*)"G_PASSWORD_SAVE_NEVER",G_PASSWORD_SAVE_NEVER),
   MAKE_ICONSTANT((char*)"GDK_PAD_BUTTON_PRESS",GDK_PAD_BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GTK_SPIN_STEP_FORWARD",GTK_SPIN_STEP_FORWARD),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13568",0x10028b5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohornbelowdot",0x1001ee2),
   MAKE_ICONSTANT((char*)"GDK_hebrew_teth",0xce8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Clear",0xff0b),
   MAKE_ICONSTANT((char*)"GDK_ISO_Last_Group_Lock",0xfe0f),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Quit",0xfd09),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uogonek",0x3d9),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflextilde",0x1001ec4),
   MAKE_ICONSTANT((char*)"GDK_PROPERTY_CHANGE_MASK",GDK_PROPERTY_CHANGE_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_9",0x10006f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_235678",0x10028f6),
   MAKE_ICONSTANT((char*)"GTK_RECENT_SORT_MRU",GTK_RECENT_SORT_MRU),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_LANGUAGE",PANGO_ATTR_LANGUAGE),
   MAKE_ICONSTANT((char*)"G_REGEX_ANCHORED",G_REGEX_ANCHORED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_ddal",0x1000688),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_a",0xfe80),
   MAKE_ICONSTANT((char*)"GDK_odoubleacute",0x1f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_WEO",0xecd),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_NO_EMOJI",GTK_INPUT_HINT_NO_EMOJI),
   MAKE_ICONSTANT((char*)"GDK_KEY_FrameForward",0x1008ff9e),
   MAKE_ICONSTANT((char*)"GDK_KEY_ninesuperior",0x1002079),
   MAKE_ICONSTANT((char*)"G_NOTIFICATION_PRIORITY_NORMAL",G_NOTIFICATION_PRIORITY_NORMAL),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_WOULD_RECURSE",G_IO_ERROR_WOULD_RECURSE),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_STYLE",PANGO_FONT_MASK_STYLE),
   MAKE_ICONSTANT((char*)"GDK_Ygrave",0x1001ef2),
   MAKE_ICONSTANT((char*)"GDK_Thai_thothahan",0xdb7),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_NEXT_LINE",G_UNICODE_BREAK_NEXT_LINE),
   MAKE_ICONSTANT((char*)"GDK_KEY_permille",0xad5),
   MAKE_ICONSTANT((char*)"GDK_KEY_fivesuperior",0x1002075),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_SENDING_DATA",GTK_PRINT_STATUS_SENDING_DATA),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NO_REPLY",G_DBUS_ERROR_NO_REPLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_348",0x100288c),
   MAKE_ICONSTANT((char*)"GDK_Sinh_jha",0x1000da3),
   MAKE_ICONSTANT((char*)"GDK_KEY_adiaeresis",0x0e4),
   MAKE_ICONSTANT((char*)"G_SOCKET_TYPE_INVALID",G_SOCKET_TYPE_INVALID),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_SOUTH_ARABIAN",G_UNICODE_SCRIPT_OLD_SOUTH_ARABIAN),
   MAKE_ICONSTANT((char*)"GDK_STRUCTURE_MASK",GDK_STRUCTURE_MASK),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DownRight",0xfee7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_246",0x100282a),
   MAKE_ICONSTANT((char*)"GDK_AXIS_X",GDK_AXIS_X),
   MAKE_ICONSTANT((char*)"GDK_KEY_F10",0xffc7),
   MAKE_ICONSTANT((char*)"GDK_toprightsqbracket",0x8a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_upcaret",0xba9),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_MANDATORY",G_UNICODE_BREAK_MANDATORY),
   MAKE_ICONSTANT((char*)"G_REGEX_CASELESS",G_REGEX_CASELESS),
   MAKE_ICONSTANT((char*)"GDK_LogWindowTree",0x1008fe24),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_dha",0x1000daf),
   MAKE_ICONSTANT((char*)"GDK_Arabic_0",0x1000660),
   MAKE_ICONSTANT((char*)"GDK_eth",0x0f0),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ZA",0x1000536),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_268",0x10028a2),
   MAKE_ICONSTANT((char*)"GDK_hebrew_beth",0xce1),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_BackTab",0xfd05),
   MAKE_ICONSTANT((char*)"GDK_leftcaret",0xba3),
   MAKE_ICONSTANT((char*)"G_TYPE_DEBUG_MASK",G_TYPE_DEBUG_MASK),
   MAKE_ICONSTANT((char*)"GDK_Imacron",0x3cf),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_6",0xfff6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1237",0x1002847),
   MAKE_ICONSTANT((char*)"GDK_openstar",0xae5),
   MAKE_ICONSTANT((char*)"GDK_SB_V_DOUBLE_ARROW",GDK_SB_V_DOUBLE_ARROW),
   MAKE_ICONSTANT((char*)"GTK_SPIN_PAGE_BACKWARD",GTK_SPIN_PAGE_BACKWARD),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ADLAM",G_UNICODE_SCRIPT_ADLAM),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_COLOR_DEFINITION",GTK_CSS_SECTION_COLOR_DEFINITION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Super_R",0xffec),
   MAKE_ICONSTANT((char*)"GDK_Ohornacute",0x1001eda),
   MAKE_ICONSTANT((char*)"GDK_Greek_kappa",0x7ea),
   MAKE_ICONSTANT((char*)"GDK_Armenian_PYUR",0x1000553),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123478",0x10028cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_YU",0x6e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_D",0x044),
   MAKE_ICONSTANT((char*)"GDK_Thai_maichattawa",0xdeb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_i2",0x1000dd2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button5",0xfeed),
   MAKE_ICONSTANT((char*)"G_PRIORITY_LOW",300),
   MAKE_ICONSTANT((char*)"GDK_Georgian_san",0x10010e1),
   MAKE_ICONSTANT((char*)"GDK_SplitScreen",0x1008ff7d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_shin",0x10010e8),
   MAKE_ICONSTANT((char*)"G_FILE_CREATE_PRIVATE",G_FILE_CREATE_PRIVATE),
   MAKE_ICONSTANT((char*)"GDK_KEY_F11",0xffc8),
   MAKE_ICONSTANT((char*)"GTK_SPIN_PAGE_FORWARD",GTK_SPIN_PAGE_FORWARD),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ROTATE_NONE",GDK_PIXBUF_ROTATE_NONE),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_LGPL_3_0",GTK_LICENSE_LGPL_3_0),
   MAKE_ICONSTANT((char*)"GDK_dead_breve",0xfe55),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_346",0x100282c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Music",0x1008ff92),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_BASIC_TYPE_EXPECTED",G_VARIANT_PARSE_ERROR_BASIC_TYPE_EXPECTED),
   MAKE_ICONSTANT((char*)"GDK_aogonek",0x1b1),
   MAKE_ICONSTANT((char*)"GDK_em3space",0xaa3),
   MAKE_ICONSTANT((char*)"GDK_hebrew_taf",0xcfa),
   MAKE_ICONSTANT((char*)"G_SIGNAL_NO_RECURSE",G_SIGNAL_NO_RECURSE),
   MAKE_ICONSTANT((char*)"GDK_Ungrab",0x1008fe20),
   MAKE_ICONSTANT((char*)"GDK_KP_9",0xffb9),
   MAKE_ICONSTANT((char*)"GDK_Ocaron",0x10001d1),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_UNKNOWN_CA",G_TLS_CERTIFICATE_UNKNOWN_CA),
   MAKE_ICONSTANT((char*)"GDK_Excel",0x1008ff5c),
   MAKE_ICONSTANT((char*)"GDK_Greek_zeta",0x7e6),
   MAKE_ICONSTANT((char*)"GDK_Hangul_WE",0xece),
   MAKE_ICONSTANT((char*)"GDK_KEY_a",0x061),
   MAKE_ICONSTANT((char*)"GDK_Return",0xff0d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3678",0x10028e4),
   MAKE_ICONSTANT((char*)"G_RESOLVER_ERROR_TEMPORARY_FAILURE",G_RESOLVER_ERROR_TEMPORARY_FAILURE),
   MAKE_ICONSTANT((char*)"GDK_3270_BackTab",0xfd05),
   MAKE_ICONSTANT((char*)"GDK_KEY_ninesubscript",0x1002089),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_36",0x1002824),
   MAKE_ICONSTANT((char*)"GTK_REGION_ONLY",GTK_REGION_ONLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_khe",0x100056d),
   MAKE_ICONSTANT((char*)"GDK_ACTION_DEFAULT",GDK_ACTION_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Aring",0x0c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Nieun",0xed7),
   MAKE_ICONSTANT((char*)"G_CONVERTER_FLUSHED",G_CONVERTER_FLUSHED),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_UNDER_LEFT",GTK_STACK_TRANSITION_TYPE_UNDER_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_sterling",0x0a3),
   MAKE_ICONSTANT((char*)"GDK_Thai_nonu",0xdb9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_VEV",0x100054e),
   MAKE_ICONSTANT((char*)"GDK_KEY_udiaeresis",0x0fc),
   MAKE_ICONSTANT((char*)"GDK_WA_TYPE_HINT",GDK_WA_TYPE_HINT),
   MAKE_ICONSTANT((char*)"GTK_MENU_DIR_PARENT",GTK_MENU_DIR_PARENT),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_ROOTWIN",GDK_DRAG_PROTO_ROOTWIN),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_PROPERTY",GTK_BUILDER_ERROR_INVALID_PROPERTY),
   MAKE_ICONSTANT((char*)"GDK_KEY_w",0x077),
   MAKE_ICONSTANT((char*)"GDK_MOD4_MASK",GDK_MOD4_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_umacron",0x3fe),
   MAKE_ICONSTANT((char*)"GDK_Arabic_sukun",0x5f2),
   MAKE_ICONSTANT((char*)"GTK_SELECTION_NONE",GTK_SELECTION_NONE),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TEMP",GDK_WINDOW_TEMP),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_456",0x1002838),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_356",0x1002834),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NO_NETWORK",G_DBUS_ERROR_NO_NETWORK),
   MAKE_ICONSTANT((char*)"GDK_KEY_sevensuperior",0x1002077),
   MAKE_ICONSTANT((char*)"GDK_KEY_emfilledcircle",0xade),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_RESOLVING",G_SOCKET_CLIENT_RESOLVING),
   MAKE_ICONSTANT((char*)"GDK_Stop",0x1008ff28),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3478",0x10028cc),
   MAKE_ICONSTANT((char*)"GDK_toprightparens",0x8ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_theta",0x7e8),
   MAKE_ICONSTANT((char*)"G_RESOURCE_FLAGS_COMPRESSED",G_RESOURCE_FLAGS_COMPRESSED),
   MAKE_ICONSTANT((char*)"GDK_MIDDLEBUTTON",GDK_MIDDLEBUTTON),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_SIZE",PANGO_ATTR_SIZE),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FAMILY",PANGO_ATTR_FAMILY),
   MAKE_ICONSTANT((char*)"GDK_kana_TA",0x4c0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pictures",0x1008ff91),
   MAKE_ICONSTANT((char*)"GDK_breve",0x1a2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_che_vertstroke",0x10004b9),
   MAKE_ICONSTANT((char*)"GDK_Armenian_VEV",0x100054e),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_TOO_MANY_FORWARD_REFERENCES",G_REGEX_ERROR_TOO_MANY_FORWARD_REFERENCES),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level3_Latch",0xfe04),
   MAKE_ICONSTANT((char*)"GDK_Serbian_JE",0x6b8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1256",0x1002833),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Center_Object",0xfe33),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_DATA",G_SIGNAL_MATCH_DATA),
   MAKE_ICONSTANT((char*)"GDK_Num_Lock",0xff7f),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_U",0xfe89),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioPlay",0x1008ff14),
   MAKE_ICONSTANT((char*)"GDK_KEY_L1",0xffc8),
   MAKE_ICONSTANT((char*)"GDK_KEY_lcedilla",0x3b6),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_DELETE_EVENT",GTK_RESPONSE_DELETE_EVENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_4",0xfff4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Meta_R",0xffe8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_47",0x1002848),
   MAKE_ICONSTANT((char*)"GDK_KEY_Terminate_Server",0xfed5),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_BOTH",GTK_TOOLBAR_BOTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_34568",0x10028bc),
   MAKE_ICONSTANT((char*)"GDK_KEY_RockerUp",0x1008ff23),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_DECLARATION",GTK_CSS_SECTION_DECLARATION),
   MAKE_ICONSTANT((char*)"GDK_Ehook",0x1001eba),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_NORTH_WEST",GDK_GRAVITY_NORTH_WEST),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_PSEUDO_COLOR",GDK_VISUAL_PSEUDO_COLOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_yu",0x6c0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflexacute",0x1001ed0),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_TOUCH_END",GDK_CROSSING_TOUCH_END),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_IE",0x6e5),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2357",0x1002856),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1678",0x10028e1),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_JE",0x6b8),
   MAKE_ICONSTANT((char*)"GDK_BUTTON1_MASK",GDK_BUTTON1_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_moma",0xdc1),
   MAKE_ICONSTANT((char*)"GDK_KEY_F4",0xffc1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_ghan",0x10010e6),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_CANCEL",GTK_RESPONSE_CANCEL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_to",0x1000569),
   MAKE_ICONSTANT((char*)"GDK_Greek_BETA",0x7c2),
   MAKE_ICONSTANT((char*)"GDK_hebrew_waw",0xce5),
   MAKE_ICONSTANT((char*)"GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE",GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE),
   MAKE_ICONSTANT((char*)"GTK_SORT_DESCENDING",GTK_SORT_DESCENDING),
   MAKE_ICONSTANT((char*)"GDK_yen",0x0a5),
   MAKE_ICONSTANT((char*)"GTK_BASELINE_POSITION_BOTTOM",GTK_BASELINE_POSITION_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_6",0xfff6),
   MAKE_ICONSTANT((char*)"GDK_VISIBILITY_PARTIAL",GDK_VISIBILITY_PARTIAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_teh",0x5ca),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HANIFI_ROHINGYA",G_UNICODE_SCRIPT_HANIFI_ROHINGYA),
   MAKE_ICONSTANT((char*)"G_DBUS_SIGNAL_FLAGS_NO_MATCH_RULE",G_DBUS_SIGNAL_FLAGS_NO_MATCH_RULE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_EU",0xed1),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_CONNECTED",G_IO_ERROR_NOT_CONNECTED),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_GPL_3_0_ONLY",GTK_LICENSE_GPL_3_0_ONLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_lcaron",0x1b5),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_lje",0x6a9),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_URI_NOT_FOUND",G_BOOKMARK_FILE_ERROR_URI_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioRecord",0x1008ff1c),
   MAKE_ICONSTANT((char*)"GDK_ecircumflextilde",0x1001ec5),
   MAKE_ICONSTANT((char*)"GDK_AXIS_SLIDER",GDK_AXIS_SLIDER),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_VAI",G_UNICODE_SCRIPT_VAI),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_138",0x1002885),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BRAILLE",PANGO_SCRIPT_BRAILLE),
   MAKE_ICONSTANT((char*)"GDK_Georgian_khar",0x10010e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Finance",0x1008ff3c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sleep",0x1008ff2f),
   MAKE_ICONSTANT((char*)"G_IO_OUT",G_IO_OUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_ETA",0x7c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_emdash",0xaa9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_246",0x100282a),
   MAKE_ICONSTANT((char*)"GDK_KEY_opentribulletdown",0xae4),
   MAKE_ICONSTANT((char*)"GDK_VISIBILITY_FULLY_OBSCURED",GDK_VISIBILITY_FULLY_OBSCURED),
   MAKE_ICONSTANT((char*)"GDK_Armenian_VO",0x1000548),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2456",0x100283a),
   MAKE_ICONSTANT((char*)"GDK_KEY_TaskPane",0x1008ff7f),
   MAKE_ICONSTANT((char*)"G_RESOURCE_ERROR_NOT_FOUND",G_RESOURCE_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_78",0x10028c0),
   MAKE_ICONSTANT((char*)"GDK_Arabic_4",0x1000664),
   MAKE_ICONSTANT((char*)"G_CONVERTER_CONVERTED",G_CONVERTER_CONVERTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_AE",0xec0),
   MAKE_ICONSTANT((char*)"GDK_KEY_F3",0xffc0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Xfer",0x1008ff8a),
   MAKE_ICONSTANT((char*)"GDK_Armenian_shesht",0x100055b),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_45",0x1002818),
   MAKE_ICONSTANT((char*)"G_FILESYSTEM_PREVIEW_TYPE_IF_LOCAL",G_FILESYSTEM_PREVIEW_TYPE_IF_LOCAL),
   MAKE_ICONSTANT((char*)"PANGO_COVERAGE_NONE",PANGO_COVERAGE_NONE),
   MAKE_ICONSTANT((char*)"GDK_Sinh_aa2",0x1000dcf),
   MAKE_ICONSTANT((char*)"GDK_Aacute",0x0c1),
   MAKE_ICONSTANT((char*)"GDK_Armenian_full_stop",0x1000589),
   MAKE_ICONSTANT((char*)"GTK_RESIZE_QUEUE",GTK_RESIZE_QUEUE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12345",0x100281f),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulTieut",0xeae),
   MAKE_ICONSTANT((char*)"GDK_KEY_Multi_key",0xff20),
   MAKE_ICONSTANT((char*)"GDK_KEY_MillSign",0x10020a5),
   MAKE_ICONSTANT((char*)"GDK_KP_5",0xffb5),
   MAKE_ICONSTANT((char*)"GDK_KEY_botrightparens",0x8ae),
   MAKE_ICONSTANT((char*)"GDK_Arabic_shadda",0x5f1),
   MAKE_ICONSTANT((char*)"GTK_POS_TOP",GTK_POS_TOP),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_SMOOTH",GDK_SCROLL_SMOOTH),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_FORCE_SYMBOLIC",GTK_ICON_LOOKUP_FORCE_SYMBOLIC),
   MAKE_ICONSTANT((char*)"GDK_fourthroot",0x100221c),
   MAKE_ICONSTANT((char*)"G_PARAM_MASK",0x000000ff),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_nu",0x1000576),
   MAKE_ICONSTANT((char*)"GDK_K",0x04b),
   MAKE_ICONSTANT((char*)"GDK_KEY_MySites",0x1008ff67),
   MAKE_ICONSTANT((char*)"GDK_foursubscript",0x1002084),
   MAKE_ICONSTANT((char*)"GTK_RESIZE_IMMEDIATE",GTK_RESIZE_IMMEDIATE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1567",0x1002871),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1356",0x1002835),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_0",0x1000660),
   MAKE_ICONSTANT((char*)"GDK_Hiragana",0xff25),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_ULTRALIGHT",PANGO_WEIGHT_ULTRALIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_luu2",0x1000df3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1268",0x10028a3),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_TOO_MANY_SUBPATTERNS",G_REGEX_ERROR_TOO_MANY_SUBPATTERNS),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_je",0x6a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_467",0x1002868),
   MAKE_ICONSTANT((char*)"GDK_Kana_Lock",0xff2d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pause",0xff13),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thothan",0xdb0),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FOREGROUND",PANGO_ATTR_FOREGROUND),
   MAKE_ICONSTANT((char*)"GDK_Eisu_Shift",0xff2f),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightmiddlecurlybrace",0x8b0),
   MAKE_ICONSTANT((char*)"GDK_ACTION_PRIVATE",GDK_ACTION_PRIVATE),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_NONE",G_FILE_MONITOR_NONE),
   MAKE_ICONSTANT((char*)"GDK_ifonlyif",0x8cd),
   MAKE_ICONSTANT((char*)"GDK_SMOOTH_SCROLL_MASK",GDK_SMOOTH_SCROLL_MASK),
   MAKE_ICONSTANT((char*)"G_UNICODE_DECIMAL_NUMBER",G_UNICODE_DECIMAL_NUMBER),
   MAKE_ICONSTANT((char*)"GDK_Ubreve",0x2dd),
   MAKE_ICONSTANT((char*)"GDK_INTERP_TILES",GDK_INTERP_TILES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Help",0xff6a),
   MAKE_ICONSTANT((char*)"G_TLS_PASSWORD_FINAL_TRY",G_TLS_PASSWORD_FINAL_TRY),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1468",0x10028a9),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE",GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_U_straight_bar",0x10004b0),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_abovedot",0xfe56),
   MAKE_ICONSTANT((char*)"GDK_kana_SO",0x4bf),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_TLS_HANDSHAKED",G_SOCKET_CLIENT_TLS_HANDSHAKED),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_ERASER",GDK_SOURCE_ERASER),
   MAKE_ICONSTANT((char*)"GDK_wgrave",0x1001e81),
   MAKE_ICONSTANT((char*)"GDK_Arabic_yeh_baree",0x10006d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Kanji_Bangou",0xff37),
   MAKE_ICONSTANT((char*)"G_ASCII_LOWER",G_ASCII_LOWER),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Up",0xff97),
   MAKE_ICONSTANT((char*)"GDK_Ihook",0x1001ec8),
   MAKE_ICONSTANT((char*)"GDK_KEY_lbelowdot",0x1001e37),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_TABLET_PAD",GDK_SOURCE_TABLET_PAD),
   MAKE_ICONSTANT((char*)"GDK_kana_MU",0x4d1),
   MAKE_ICONSTANT((char*)"GDK_POINTER_MOTION_HINT_MASK",GDK_POINTER_MOTION_HINT_MASK),
   MAKE_ICONSTANT((char*)"GDK_dagger",0xaf1),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Phieuf",0xebd),
   MAKE_ICONSTANT((char*)"GDK_Ahook",0x1001ea2),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_UP",GTK_SCROLL_STEP_UP),
   MAKE_ICONSTANT((char*)"GDK_F17",0xffce),
   MAKE_ICONSTANT((char*)"GDK_KEY_fivesubscript",0x1002085),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_BOLD",PANGO_WEIGHT_BOLD),
   MAKE_ICONSTANT((char*)"GDK_Thai_phophung",0xdbc),
   MAKE_ICONSTANT((char*)"GDK_Hangul_WAE",0xec9),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalmem",0xced),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_DISPLAY_LINE_ENDS",GTK_MOVEMENT_DISPLAY_LINE_ENDS),
   MAKE_ICONSTANT((char*)"GDK_KEY_underbar",0xbc6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraii",0xdd5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_THAANA",PANGO_SCRIPT_THAANA),
   MAKE_ICONSTANT((char*)"GDK_HYPER_MASK",GDK_HYPER_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_caron",0xfe5a),
   MAKE_ICONSTANT((char*)"GDK_trademarkincircle",0xacb),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ANATOLIAN_HIEROGLYPHS",G_UNICODE_SCRIPT_ANATOLIAN_HIEROGLYPHS),
   MAKE_ICONSTANT((char*)"GDK_Ecaron",0x1cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23457",0x100285e),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_SINGLE_BYTE_MATCH_IN_LOOKBEHIND",G_REGEX_ERROR_SINGLE_BYTE_MATCH_IN_LOOKBEHIND),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_BOTTOM",GTK_JUNCTION_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_kokai",0xda1),
   MAKE_ICONSTANT((char*)"GDK_OE",0x13bc),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_GTK_GRAB",GDK_CROSSING_GTK_GRAB),
   MAKE_ICONSTANT((char*)"GDK_Armenian_MEN",0x1000544),
   MAKE_ICONSTANT((char*)"GTK_FONT_CHOOSER_LEVEL_FAMILY",GTK_FONT_CHOOSER_LEVEL_FAMILY),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_FORCE_REGULAR",GTK_ICON_LOOKUP_FORCE_REGULAR),
   MAKE_ICONSTANT((char*)"GDK_Greek_RHO",0x7d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_oneeighth",0xac3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_lu",0x1000d8f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ka",0x6cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Shift_L",0xffe1),
   MAKE_ICONSTANT((char*)"GDK_Refresh",0x1008ff29),
   MAKE_ICONSTANT((char*)"GDK_KEY_Menu",0xff67),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_ES",PANGO_BIDI_TYPE_ES),
   MAKE_ICONSTANT((char*)"G_PARAM_STATIC_NICK",G_PARAM_STATIC_NICK),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_PARTIAL_SOFT",G_REGEX_MATCH_PARTIAL_SOFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ahook",0x1001ea2),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_SOUTH_EAST",GDK_GRAVITY_SOUTH_EAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_paragraph",0x0b6),
   MAKE_ICONSTANT((char*)"GDK_Armenian_INI",0x100053b),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_i",0x6a6),
   MAKE_ICONSTANT((char*)"GDK_Arabic_tcheh",0x1000686),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2678",0x10028e2),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_VALUE_ABSTRACT",G_TYPE_FLAG_VALUE_ABSTRACT),
   MAKE_ICONSTANT((char*)"GDK_Memo",0x1008ff1e),
   MAKE_ICONSTANT((char*)"GTK_ALIGN_START",GTK_ALIGN_START),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_chochan",0xda8),
   MAKE_ICONSTANT((char*)"GTK_PACK_DIRECTION_BTT",GTK_PACK_DIRECTION_BTT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Right",0xfee1),
   MAKE_ICONSTANT((char*)"G_CONVERTER_INPUT_AT_END",G_CONVERTER_INPUT_AT_END),
   MAKE_ICONSTANT((char*)"G_UNICODE_FINAL_PUNCTUATION",G_UNICODE_FINAL_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_uhornacute",0x1001ee9),
   MAKE_ICONSTANT((char*)"GDK_BUTTON3_MOTION_MASK",GDK_BUTTON3_MOTION_MASK),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_ACCEL_MODE_GTK",GTK_CELL_RENDERER_ACCEL_MODE_GTK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ng",0x1000d82),
   MAKE_ICONSTANT((char*)"GDK_ISO_Continuous_Underline",0xfe30),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_NFC",G_NORMALIZE_NFC),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_0",0x10006f0),
   MAKE_ICONSTANT((char*)"GDK_KEY_LiraSign",0x10020a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_DZA",0x1000541),
   MAKE_ICONSTANT((char*)"GDK_sevensubscript",0x1002087),
   MAKE_ICONSTANT((char*)"G_FILE_CREATE_NONE",G_FILE_CREATE_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_aee2",0x1000dd1),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME",GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PROXY_FAILED",G_IO_ERROR_PROXY_FAILED),
   MAKE_ICONSTANT((char*)"G_SOCKET_TYPE_DATAGRAM",G_SOCKET_TYPE_DATAGRAM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch4",0x1008ff44),
   MAKE_ICONSTANT((char*)"GDK_KEY_hexagram",0xada),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_24678",0x10028ea),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PAHAWH_HMONG",G_UNICODE_SCRIPT_PAHAWH_HMONG),
   MAKE_ICONSTANT((char*)"GDK_quoteleft",0x060),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_REGIONAL_INDICATOR",G_UNICODE_BREAK_REGIONAL_INDICATOR),
   MAKE_ICONSTANT((char*)"GDK_DAMAGE",GDK_DAMAGE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulMieum",0xedd),
   MAKE_ICONSTANT((char*)"GDK_Greek_CHI",0x7d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulSios",0xedf),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level5_Latch",0xfe12),
   MAKE_ICONSTANT((char*)"GDK_KEY_uprightcorner",0x9eb),
   MAKE_ICONSTANT((char*)"G_CONVERTER_FLUSH",G_CONVERTER_FLUSH),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_UNDERLINE_COLOR",PANGO_ATTR_UNDERLINE_COLOR),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_TYPE_METHOD_CALL",G_DBUS_MESSAGE_TYPE_METHOD_CALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abreveacute",0x1001eae),
   MAKE_ICONSTANT((char*)"GDK_KEY_exclam",0x021),
   MAKE_ICONSTANT((char*)"GDK_Greek_EPSILONaccent",0x7a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2456",0x100283a),
   MAKE_ICONSTANT((char*)"GDK_dead_iota",0xfe5d),
   MAKE_ICONSTANT((char*)"GDK_sterling",0x0a3),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_VARIANT",PANGO_FONT_MASK_VARIANT),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_WAYLAND",GDK_DRAG_PROTO_WAYLAND),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2367",0x1002866),
   MAKE_ICONSTANT((char*)"GDK_News",0x1008ff69),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_BACKGROUND_ALPHA",PANGO_ATTR_BACKGROUND_ALPHA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_ALPHA",0x7c1),
   MAKE_ICONSTANT((char*)"G_DATE_APRIL",G_DATE_APRIL),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_PRE_UNMOUNT",G_FILE_MONITOR_EVENT_PRE_UNMOUNT),
   MAKE_ICONSTANT((char*)"GTK_MESSAGE_WARNING",GTK_MESSAGE_WARNING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_percent",0x100066a),
   MAKE_ICONSTANT((char*)"GDK_KP_F2",0xff92),
   MAKE_ICONSTANT((char*)"GDK_FFrancSign",0x10020a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhornhook",0x1001eec),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulKiyeog",0xedc),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_CORNER_BOTTOMLEFT",GTK_JUNCTION_CORNER_BOTTOMLEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Right",0xff53),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_LOGICAL_POSITIONS",GTK_MOVEMENT_LOGICAL_POSITIONS),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_INT32",G_FILE_ATTRIBUTE_TYPE_INT32),
   MAKE_ICONSTANT((char*)"GTK_APPLICATION_INHIBIT_SUSPEND",GTK_APPLICATION_INHIBIT_SUSPEND),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflexgrave",0x1001ea7),
   MAKE_ICONSTANT((char*)"GDK_emdash",0xaa9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Khieuq",0xeeb),
   MAKE_ICONSTANT((char*)"GDK_Launch0",0x1008ff40),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION",GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulSios",0xead),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_EN",0x6ee),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_GRAVITY",PANGO_ATTR_GRAVITY),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_PIN",GTK_INPUT_PURPOSE_PIN),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ja",0x1000da2),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level5_Shift",0xfe11),
   MAKE_ICONSTANT((char*)"GDK_KEY_onesubscript",0x1002081),
   MAKE_ICONSTANT((char*)"GDK_udoubleacute",0x1fb),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_347",0x100284c),
   MAKE_ICONSTANT((char*)"GDK_Georgian_xan",0x10010ee),
   MAKE_ICONSTANT((char*)"GDK_KEY_Atilde",0x0c3),
   MAKE_ICONSTANT((char*)"GDK_yhook",0x1001ef7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_56",0x1002830),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_paruyk",0x100055e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ha_descender",0x10004b3),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_RESIZE",GTK_DEBUG_RESIZE),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_BACK_REFERENCE",G_REGEX_ERROR_MISSING_BACK_REFERENCE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23478",0x10028ce),
   MAKE_ICONSTANT((char*)"GDK_Arabic_dal",0x5cf),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraa",0xdd0),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_I_macron",0x10004e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_fatha",0x5ee),
   MAKE_ICONSTANT((char*)"GDK_Georgian_par",0x10010de),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level3_Latch",0xfe04),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_456",0x1002838),
   MAKE_ICONSTANT((char*)"GDK_RotationKB",0x1008ff76),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Nieun",0xea4),
   MAKE_ICONSTANT((char*)"GDK_Kanji_Bangou",0xff37),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CYPRIOT",G_UNICODE_SCRIPT_CYPRIOT),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_ALL_POINTING",GDK_SEAT_CAPABILITY_ALL_POINTING),
   MAKE_ICONSTANT((char*)"GDK_KP_Right",0xff98),
   MAKE_ICONSTANT((char*)"GTK_STYLE_PROVIDER_PRIORITY_THEME",200),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1245678",0x10028fb),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_SYMBOL",G_UNICODE_BREAK_SYMBOL),
   MAKE_ICONSTANT((char*)"GDK_dead_currency",0xfe6f),
   MAKE_ICONSTANT((char*)"GDK_KEY_greaterthanequal",0x8be),
   MAKE_ICONSTANT((char*)"GDK_MonBrightnessUp",0x1008ff02),
   MAKE_ICONSTANT((char*)"GDK_Wgrave",0x1001e80),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2346",0x100282e),
   MAKE_ICONSTANT((char*)"GTK_PAGE_SET_EVEN",GTK_PAGE_SET_EVEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_R7",0xffd8),
   MAKE_ICONSTANT((char*)"GDK_Armenian_re",0x1000580),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_9",0xfff9),
   MAKE_ICONSTANT((char*)"GDK_KEY_F17",0xffce),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_o",0x1000d94),
   MAKE_ICONSTANT((char*)"GDK_AXIS_IGNORE",GDK_AXIS_IGNORE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_TSA",0x100053e),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_TOUCH_BEGIN",GDK_CROSSING_TOUCH_BEGIN),
   MAKE_ICONSTANT((char*)"GTK_TREE_MODEL_LIST_ONLY",GTK_TREE_MODEL_LIST_ONLY),
   MAKE_ICONSTANT((char*)"GDK_fivesixths",0xab7),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_BSR_ANY",G_REGEX_MATCH_BSR_ANY),
   MAKE_ICONSTANT((char*)"GDK_KEY_blank",0x9df),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_TEXT",GTK_TOOLBAR_TEXT),
   MAKE_ICONSTANT((char*)"GDK_hebrew_tet",0xce8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ytilde",0x1001ef9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_pe",0x100057a),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_SUPPORTED",G_IO_ERROR_NOT_SUPPORTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_threesubscript",0x1002083),
   MAKE_ICONSTANT((char*)"G_SOCKET_FAMILY_IPV4",G_SOCKET_FAMILY_IPV4),
   MAKE_ICONSTANT((char*)"GDK_KEY_gcircumflex",0x2f8),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_IS_WRITABLE",G_IO_FLAG_IS_WRITABLE),
   MAKE_ICONSTANT((char*)"GDK_leftopentriangle",0xacc),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GRANTHA",G_UNICODE_SCRIPT_GRANTHA),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_WRITE",G_BOOKMARK_FILE_ERROR_WRITE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_14567",0x1002879),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_TIMEOUT",G_DBUS_ERROR_TIMEOUT),
   MAKE_ICONSTANT((char*)"GDK_FOCUS_CHANGE",GDK_FOCUS_CHANGE),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizlinescan5",0x9f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Icircumflex",0x0ce),
   MAKE_ICONSTANT((char*)"GDK_TouchpadOff",0x1008ffb1),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_u",0x4a9),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_WRITE",GTK_RECENT_MANAGER_ERROR_WRITE),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ra",0x100057c),
   MAKE_ICONSTANT((char*)"GDK_3270_CursorSelect",0xfd1c),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_STRINGV",G_FILE_ATTRIBUTE_TYPE_STRINGV),
   MAKE_ICONSTANT((char*)"GDK_KEY_foursuperior",0x1002074),
   MAKE_ICONSTANT((char*)"G_PRIORITY_HIGH",-100),
   MAKE_ICONSTANT((char*)"GDK_KEY_enfilledsqbullet",0xae7),
   MAKE_ICONSTANT((char*)"GDK_KEY_R10",0xffdb),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_GESTURE_PHASE_END",GDK_TOUCHPAD_GESTURE_PHASE_END),
   MAKE_ICONSTANT((char*)"GDK_Zacute",0x1ac),
   MAKE_ICONSTANT((char*)"G_SOCKET_PROTOCOL_DEFAULT",G_SOCKET_PROTOCOL_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Start",0xff32),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_JUMP",GTK_SCROLL_JUMP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_wowaen",0xdc7),
   MAKE_ICONSTANT((char*)"GDK_Thai_nonen",0xdb3),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_REPLY_SERIAL",G_DBUS_MESSAGE_HEADER_FIELD_REPLY_SERIAL),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_ZERO_WIDTH_SPACE",G_UNICODE_BREAK_ZERO_WIDTH_SPACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_HARDSIGN",0x6ff),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_REQUEST_NONE",G_TLS_CERTIFICATE_REQUEST_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_mem",0xcee),
   MAKE_ICONSTANT((char*)"GDK_KEY_F33",0xffde),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_ALPHAaccent",0x7a1),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_35",0x1002814),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3568",0x10028b4),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Enter",0xff8d),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_TOUCHSCREEN",GDK_SOURCE_TOUCHSCREEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_uogonek",0x3f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_dad",0x5d6),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_CORNER_TOPLEFT",GTK_JUNCTION_CORNER_TOPLEFT),
   MAKE_ICONSTANT((char*)"G_PARAM_STATIC_NAME",G_PARAM_STATIC_NAME),
   MAKE_ICONSTANT((char*)"GDK_KEY_Obelowdot",0x1001ecc),
   MAKE_ICONSTANT((char*)"GDK_Greek_lamda",0x7eb),
   MAKE_ICONSTANT((char*)"GDK_Favorites",0x1008ff30),
   MAKE_ICONSTANT((char*)"GDK_acute",0x0b4),
   MAKE_ICONSTANT((char*)"GDK_Greek_xi",0x7ee),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Hieuh",0xeee),
   MAKE_ICONSTANT((char*)"GDK_HAND1",GDK_HAND1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_qar",0x10010e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_h2",0x1000d83),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_8",0x10006f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_grave",0x060),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MYANMAR",G_UNICODE_SCRIPT_MYANMAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohorntilde",0x1001ee0),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_GENERATE_PS",GTK_PRINT_CAPABILITY_GENERATE_PS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_la",0x1000dbd),
   MAKE_ICONSTANT((char*)"PANGO_ALIGN_RIGHT",PANGO_ALIGN_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_rightopentriangle",0xacd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_full_stop",0x1000589),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_STOP_TYPE_PASSWORD",G_DRIVE_START_STOP_TYPE_PASSWORD),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_DUPLICATE_SUBPATTERN_NAME",G_REGEX_ERROR_DUPLICATE_SUBPATTERN_NAME),
   MAKE_ICONSTANT((char*)"GDK_Greek_epsilonaccent",0x7b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_345678",0x10028fc),
   MAKE_ICONSTANT((char*)"GDK_Arabic_fatha",0x5ee),
   MAKE_ICONSTANT((char*)"GDK_Open",0x1008ff6b),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MATCH",G_REGEX_ERROR_MATCH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Red",0x1008ffa3),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_LOOP",G_FILE_ERROR_LOOP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_UPSILON",0x7d5),
   MAKE_ICONSTANT((char*)"GDK_L",0x04c),
   MAKE_ICONSTANT((char*)"GDK_New",0x1008ff68),
   MAKE_ICONSTANT((char*)"GDK_KEY_oe",0x13bd),
   MAKE_ICONSTANT((char*)"GDK_dead_O",0xfe87),
   MAKE_ICONSTANT((char*)"GDK_hebrew_pe",0xcf4),
   MAKE_ICONSTANT((char*)"GTK_ARROW_UP",GTK_ARROW_UP),
   MAKE_ICONSTANT((char*)"GDK_KP_Prior",0xff9a),
   MAKE_ICONSTANT((char*)"GDK_KEY_HotLinks",0x1008ff3a),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Sios",0xeb5),
   MAKE_ICONSTANT((char*)"GDK_EXCHANGE",GDK_EXCHANGE),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_CHILD_SIGNALED",G_DBUS_ERROR_SPAWN_CHILD_SIGNALED),
   MAKE_ICONSTANT((char*)"GTK_DIALOG_MODAL",GTK_DIALOG_MODAL),
   MAKE_ICONSTANT((char*)"GTK_DIR_TAB_FORWARD",GTK_DIR_TAB_FORWARD),
   MAKE_ICONSTANT((char*)"GDK_Armenian_SE",0x100054d),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GLAGOLITIC",PANGO_SCRIPT_GLAGOLITIC),
   MAKE_ICONSTANT((char*)"GTK_RECENT_SORT_LRU",GTK_RECENT_SORT_LRU),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowtilde",0xfe6a),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS",GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS),
   MAKE_ICONSTANT((char*)"GDK_F23",0xffd4),
   MAKE_ICONSTANT((char*)"GDK_hebrew_mem",0xcee),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_237",0x1002846),
   MAKE_ICONSTANT((char*)"GTK_TEXT_VIEW_LAYER_ABOVE_TEXT",GTK_TEXT_VIEW_LAYER_ABOVE_TEXT),
   MAKE_ICONSTANT((char*)"G_EMBLEM_ORIGIN_DEVICE",G_EMBLEM_ORIGIN_DEVICE),
   MAKE_ICONSTANT((char*)"GDK_KEY_4",0x034),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_234567",0x100287e),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_EXCLAMATION",G_UNICODE_BREAK_EXCLAMATION),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_68",0x10028a0),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MENDE_KIKAKUI",PANGO_SCRIPT_MENDE_KIKAKUI),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_DZHE",0x6bf),
   MAKE_ICONSTANT((char*)"GDK_KP_Subtract",0xffad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_upsilon",0x7f5),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_INTERFACE",G_DBUS_MESSAGE_HEADER_FIELD_INTERFACE),
   MAKE_ICONSTANT((char*)"GDK_zerosubscript",0x1002080),
   MAKE_ICONSTANT((char*)"G_REGEX_DUPNAMES",G_REGEX_DUPNAMES),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER",GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_678",0x10028e0),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_NONE",G_DBUS_CONNECTION_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_MOUSE",GDK_SOURCE_MOUSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Travel",0x1008ff82),
   MAKE_ICONSTANT((char*)"GDK_KEY_F7",0xffc4),
   MAKE_ICONSTANT((char*)"G_TYPE_RESERVED_BSE_FIRST",32),
   MAKE_ICONSTANT((char*)"GDK_acircumflexacute",0x1001ea5),
   MAKE_ICONSTANT((char*)"GTK_JUSTIFY_FILL",GTK_JUSTIFY_FILL),
   MAKE_ICONSTANT((char*)"GDK_ocircumflextilde",0x1001ed7),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNMATCHED_PARENTHESIS",G_REGEX_ERROR_UNMATCHED_PARENTHESIS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_da",0x1000564),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INFINITE_LOOP",G_REGEX_ERROR_INFINITE_LOOP),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_EXTRA_SUBPATTERN_NAME",G_REGEX_ERROR_EXTRA_SUBPATTERN_NAME),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_alphaaccent",0x7b1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_thal",0x5d0),
   MAKE_ICONSTANT((char*)"GDK_Thai_lochula",0xdcc),
   MAKE_ICONSTANT((char*)"GDK_Georgian_jil",0x10010eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_partialderivative",0x8ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_gcedilla",0x3bb),
   MAKE_ICONSTANT((char*)"G_FILE_TEST_EXISTS",G_FILE_TEST_EXISTS),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NOTEMPTY_ATSTART",G_REGEX_MATCH_NOTEMPTY_ATSTART),
   MAKE_ICONSTANT((char*)"GDK_Travel",0x1008ff82),
   MAKE_ICONSTANT((char*)"GDK_KEY_Display",0x1008ff59),
   MAKE_ICONSTANT((char*)"GTK_DELETE_PARAGRAPH_ENDS",GTK_DELETE_PARAGRAPH_ENDS),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_BAD_OPTION",GDK_PIXBUF_ERROR_BAD_OPTION),
   MAKE_ICONSTANT((char*)"GDK_Control_R",0xffe4),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_INFO_NONE",G_FILE_ATTRIBUTE_INFO_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_cursor",0xaff),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1234568",0x10028bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_DSE",0x6b5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ru2",0x1000dd8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_noon",0x5e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_diaeresis",0x0a8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ARMENIAN",PANGO_SCRIPT_ARMENIAN),
   MAKE_ICONSTANT((char*)"GDK_Arabic_theh",0x5cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_257",0x1002852),
   MAKE_ICONSTANT((char*)"GDK_racute",0x1e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_bott",0x9f6),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_SAVING_SUPPORTED",G_ASK_PASSWORD_SAVING_SUPPORTED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1357",0x1002855),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1345",0x100281d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_tse",0x6c3),
   MAKE_ICONSTANT((char*)"GDK_Armenian_vyun",0x1000582),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KHOJKI",G_UNICODE_SCRIPT_KHOJKI),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_UNDERLINE",PANGO_ATTR_UNDERLINE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_EO",0xec3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_245678",0x10028fa),
   MAKE_ICONSTANT((char*)"G_SOCKET_LISTENER_BINDING",G_SOCKET_LISTENER_BINDING),
   MAKE_ICONSTANT((char*)"GDK_uacute",0x0fa),
   MAKE_ICONSTANT((char*)"GDK_KEY_CycleAngle",0x1008ff9c),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT",GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT),
   MAKE_ICONSTANT((char*)"GTK_FILE_FILTER_MIME_TYPE",GTK_FILE_FILTER_MIME_TYPE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_maddaonalef",0x5c2),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_WATCHER_FLAGS_AUTO_START",G_BUS_NAME_WATCHER_FLAGS_AUTO_START),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SHARADA",G_UNICODE_SCRIPT_SHARADA),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_URI",GTK_RECENT_FILTER_URI),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Accelerate",0xfefa),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ruu2",0x1000df2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_CHE_vertstroke",0x10004b8),
   MAKE_ICONSTANT((char*)"GDK_Georgian_vin",0x10010d5),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Cieuc",0xeea),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_TOO_MANY_OPEN_FILES",G_IO_ERROR_TOO_MANY_OPEN_FILES),
   MAKE_ICONSTANT((char*)"GDK_Sinh_i",0x1000d89),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_nje",0x6aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_F1",0xff91),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_INHERITED",PANGO_SCRIPT_INHERITED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_tso",0x1000581),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HANGUL_T_JAMO",G_UNICODE_BREAK_HANGUL_T_JAMO),
   MAKE_ICONSTANT((char*)"GDK_KEY_approxeq",0x1002248),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_sa",0x1000dc3),
   MAKE_ICONSTANT((char*)"GDK_KEY_diamond",0xaed),
   MAKE_ICONSTANT((char*)"GDK_KEY_Paste",0x1008ff6d),
   MAKE_ICONSTANT((char*)"GDK_Greek_KAPPA",0x7ca),
   MAKE_ICONSTANT((char*)"G_DBUS_SEND_MESSAGE_FLAGS_PRESERVE_SERIAL",G_DBUS_SEND_MESSAGE_FLAGS_PRESERVE_SERIAL),
   MAKE_ICONSTANT((char*)"GDK_rightanglebracket",0xabe),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_236",0x1002826),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_EDGE",GTK_BUTTONBOX_EDGE),
   MAKE_ICONSTANT((char*)"G_APPLICATION_REPLACE",G_APPLICATION_REPLACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_botintegral",0x8a5),
   MAKE_ICONSTANT((char*)"GDK_AXIS_ROTATION",GDK_AXIS_ROTATION),
   MAKE_ICONSTANT((char*)"GDK_Away",0x1008ff8d),
   MAKE_ICONSTANT((char*)"GDK_intersection",0x8dc),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_UNKNOWN_TYPE",GDK_PIXBUF_ERROR_UNKNOWN_TYPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflex",0x0d4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123478",0x10028cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Record",0xfd18),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_nonu",0xdb9),
   MAKE_ICONSTANT((char*)"GTK_POS_BOTTOM",GTK_POS_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_Super_L",0xffeb),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3456",0x100283c),
   MAKE_ICONSTANT((char*)"GDK_Arabic_kasra",0x5f0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SsangPieub",0xeb3),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_DEFAULT",G_NORMALIZE_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_Prev_VMode",0x1008fe23),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_ME",0x4d2),
   MAKE_ICONSTANT((char*)"GTK_TEXT_VIEW_LAYER_BELOW",GTK_TEXT_VIEW_LAYER_BELOW),
   MAKE_ICONSTANT((char*)"GDK_iacute",0x0ed),
   MAKE_ICONSTANT((char*)"GTK_SHADOW_OUT",GTK_SHADOW_OUT),
   MAKE_ICONSTANT((char*)"GDK_Eject",0x1008ff2c),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_EMOJI",GTK_INPUT_HINT_EMOJI),
   MAKE_ICONSTANT((char*)"GDK_kana_KE",0x4b9),
   MAKE_ICONSTANT((char*)"GDK_Sinh_o",0x1000d94),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_HORIZONTAL_STEPS",GTK_SCROLL_HORIZONTAL_STEPS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ii",0x1000d8a),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_NUMBER_UP_LAYOUT",GTK_PRINT_CAPABILITY_NUMBER_UP_LAYOUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_shha",0x10004bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Jeonja",0xff38),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_shcha",0x6dd),
   MAKE_ICONSTANT((char*)"G_DATE_SUNDAY",G_DATE_SUNDAY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_ghain",0x5da),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_WATCH_HARD_LINKS",G_FILE_MONITOR_WATCH_HARD_LINKS),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_ayin",0xcf2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Favorites",0x1008ff30),
   MAKE_ICONSTANT((char*)"GDK_diaeresis",0x0a8),
   MAKE_ICONSTANT((char*)"G_REGEX_OPTIMIZE",G_REGEX_OPTIMIZE),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_TIMED_OUT",G_IO_ERROR_TIMED_OUT),
   MAKE_ICONSTANT((char*)"GDK_MySites",0x1008ff67),
   MAKE_ICONSTANT((char*)"GDK_Hangul_PreviousCandidate",0xff3e),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_UNMOUNTED",G_FILE_MONITOR_EVENT_UNMOUNTED),
   MAKE_ICONSTANT((char*)"GDK_DECOR_MINIMIZE",GDK_DECOR_MINIMIZE),
   MAKE_ICONSTANT((char*)"GDK_LEAVE_NOTIFY_MASK",GDK_LEAVE_NOTIFY_MASK),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_ESCAPE_IN_CHARACTER_CLASS",G_REGEX_ERROR_INVALID_ESCAPE_IN_CHARACTER_CLASS),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1456",0x1002839),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_UP",GTK_STACK_TRANSITION_TYPE_SLIDE_UP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_KkogjiDalrinIeung",0xef9),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_UNKNOWN",GTK_RECENT_MANAGER_ERROR_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_shorti",0x6ca),
   MAKE_ICONSTANT((char*)"G_CHECKSUM_SHA384",G_CHECKSUM_SHA384),
   MAKE_ICONSTANT((char*)"GDK_Thai_kokai",0xda1),
   MAKE_ICONSTANT((char*)"GDK_cent",0x0a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_O",0x6ef),
   MAKE_ICONSTANT((char*)"G_IO_MODULE_SCOPE_BLOCK_DUPLICATES",G_IO_MODULE_SCOPE_BLOCK_DUPLICATES),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflexacute",0x1001ea5),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_1",0xfff1),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_DEFINITE_TYPE_EXPECTED",G_VARIANT_PARSE_ERROR_DEFINITE_TYPE_EXPECTED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1458",0x1002899),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_pi",0x7f0),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SAURASHTRA",G_UNICODE_SCRIPT_SAURASHTRA),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1346",0x100282d),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE",GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_RELATIVE_REFERENCE",G_REGEX_ERROR_INVALID_RELATIVE_REFERENCE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_238",0x1002886),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalzade",0xcf5),
   MAKE_ICONSTANT((char*)"G_FORMAT_SIZE_BITS",G_FORMAT_SIZE_BITS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_e2",0x1000dd9),
   MAKE_ICONSTANT((char*)"GDK_dead_diaeresis",0xfe57),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1368",0x10028a5),
   MAKE_ICONSTANT((char*)"GDK_Armenian_da",0x1000564),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_367",0x1002864),
   MAKE_ICONSTANT((char*)"GDK_Icircumflex",0x0ce),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_468",0x10028a8),
   MAKE_ICONSTANT((char*)"GDK_Greek_chi",0x7f7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ee2",0x1000dda),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hiragana",0xff25),
   MAKE_ICONSTANT((char*)"GDK_Wdiaeresis",0x1001e84),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2468",0x10028aa),
   MAKE_ICONSTANT((char*)"GDK_Zen_Koho",0xff3d),
   MAKE_ICONSTANT((char*)"GDK_idiaeresis",0x0ef),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_TE",0x6f4),
   MAKE_ICONSTANT((char*)"G_REGEX_NEWLINE_CR",G_REGEX_NEWLINE_CR),
   MAKE_ICONSTANT((char*)"GDK_Armenian_gim",0x1000563),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zenkaku_Hankaku",0xff2a),
   MAKE_ICONSTANT((char*)"GDK_KEY_ahook",0x1001ea3),
   MAKE_ICONSTANT((char*)"GDK_Tabovedot",0x1001e6a),
   MAKE_ICONSTANT((char*)"GDK_diamond",0xaed),
   MAKE_ICONSTANT((char*)"GTK_TEXT_EXTEND_SELECTION_WORD",GTK_TEXT_EXTEND_SELECTION_WORD),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_OMEGAaccent",0x7ab),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_PRIVATE",GTK_TEXT_WINDOW_PRIVATE),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_NORTH_EAST",GDK_GRAVITY_NORTH_EAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ja",0x1000da2),
   MAKE_ICONSTANT((char*)"GDK_Armenian_JE",0x100054b),
   MAKE_ICONSTANT((char*)"GDK_Alt_R",0xffea),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_I_macron",0x10004e2),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LEPCHA",G_UNICODE_SCRIPT_LEPCHA),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_OPENBSD_SOCKPEERCRED",G_CREDENTIALS_TYPE_OPENBSD_SOCKPEERCRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_imacron",0x3ef),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ZANABAZAR_SQUARE",G_UNICODE_SCRIPT_ZANABAZAR_SQUARE),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_QUOTATION",G_UNICODE_BREAK_QUOTATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflexhook",0x1001ec3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23",0x1002806),
   MAKE_ICONSTANT((char*)"GDK_KEY_ezh",0x1000292),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_E",0x1000537),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_ULTRA_CONDENSED",PANGO_STRETCH_ULTRA_CONDENSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_khokhai",0xda2),
   MAKE_ICONSTANT((char*)"GDK_MOUSE",GDK_MOUSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_tehmarbuta",0x5c9),
   MAKE_ICONSTANT((char*)"GDK_FLEUR",GDK_FLEUR),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_NONLINEAR",GDK_NOTIFY_NONLINEAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Move_Line_Up",0xfe21),
   MAKE_ICONSTANT((char*)"GTK_ALIGN_BASELINE",GTK_ALIGN_BASELINE),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_STRAY_BACKSLASH",G_REGEX_ERROR_STRAY_BACKSLASH),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflex",0x0f4),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_BAD_CERTIFICATE",G_TLS_ERROR_BAD_CERTIFICATE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_234",0x100280e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_upsilonaccent",0x7b8),
   MAKE_ICONSTANT((char*)"GDK_dead_semivoiced_sound",0xfe5f),
   MAKE_ICONSTANT((char*)"GDK_KEY_guillemotright",0x0bb),
   MAKE_ICONSTANT((char*)"GDK_Thai_thophuthao",0xdb2),
   MAKE_ICONSTANT((char*)"GDK_KEY_guillemotleft",0x0ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_openstar",0xae5),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN",GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_tcaron",0x1bb),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_ULTRA_EXPANDED",PANGO_STRETCH_ULTRA_EXPANDED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_shadda",0x5f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_End",0xff57),
   MAKE_ICONSTANT((char*)"GDK_KEY_foursubscript",0x1002084),
   MAKE_ICONSTANT((char*)"GDK_KEY_signaturemark",0xaca),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BALINESE",G_UNICODE_SCRIPT_BALINESE),
   MAKE_ICONSTANT((char*)"GDK_DECOR_BORDER",GDK_DECOR_BORDER),
   MAKE_ICONSTANT((char*)"GDK_Sinh_gha",0x1000d9d),
   MAKE_ICONSTANT((char*)"GDK_CH",0xfea2),
   MAKE_ICONSTANT((char*)"GDK_KP_F4",0xff94),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_WORD_JOINER",G_UNICODE_BREAK_WORD_JOINER),
   MAKE_ICONSTANT((char*)"GDK_Armenian_o",0x1000585),
   MAKE_ICONSTANT((char*)"GDK_Ugrave",0x0d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_NJE",0x6ba),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_YES",GTK_RESPONSE_YES),
   MAKE_ICONSTANT((char*)"PANGO_STYLE_OBLIQUE",PANGO_STYLE_OBLIQUE),
   MAKE_ICONSTANT((char*)"GDK_KEY_J",0x04a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulYeorinHieuh",0xeef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ghat",0x1000572),
   MAKE_ICONSTANT((char*)"GDK_KEY_gbreve",0x2bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_ordfeminine",0x0aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_tilde",0xfe53),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_MOVED_OUT",G_FILE_MONITOR_EVENT_MOVED_OUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SHA",0x6fb),
   MAKE_ICONSTANT((char*)"GDK_overline",0x47e),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflexbelowdot",0x1001ed8),
   MAKE_ICONSTANT((char*)"GDK_upleftcorner",0x9ec),
   MAKE_ICONSTANT((char*)"GDK_copyright",0x0a9),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_che_descender",0x10004b7),
   MAKE_ICONSTANT((char*)"GDK_KEY_containsas",0x100220b),
   MAKE_ICONSTANT((char*)"GDK_leftshoe",0xbda),
   MAKE_ICONSTANT((char*)"GDK_KEY_ucircumflex",0x0fb),
   MAKE_ICONSTANT((char*)"GDK_enfilledsqbullet",0xae7),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NOSPC",G_FILE_ERROR_NOSPC),
   MAKE_ICONSTANT((char*)"GDK_7",0x037),
   MAKE_ICONSTANT((char*)"GDK_stricteq",0x1002263),
   MAKE_ICONSTANT((char*)"GDK_dead_belowdiaeresis",0xfe6c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_CHE",0x6fe),
   MAKE_ICONSTANT((char*)"GDK_voicedsound",0x4de),
   MAKE_ICONSTANT((char*)"GDK_Pointer_EnableKeys",0xfef9),
   MAKE_ICONSTANT((char*)"GDK_radical",0x8d6),
   MAKE_ICONSTANT((char*)"GDK_section",0x0a7),
   MAKE_ICONSTANT((char*)"GDK_TRIPLE_BUTTON_PRESS",GDK_TRIPLE_BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GDK_Hangul_U",0xecc),
   MAKE_ICONSTANT((char*)"GDK_ocaron",0x10001d2),
   MAKE_ICONSTANT((char*)"GDK_ohornhook",0x1001edf),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_SLIDE",GDK_ANCHOR_SLIDE),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START_AT_CONSTRUCTION",G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START_AT_CONSTRUCTION),
   MAKE_ICONSTANT((char*)"GDK_ISO_Release_Both_Margins",0xfe2b),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_DROP_INTO_OR_AFTER",GTK_TREE_VIEW_DROP_INTO_OR_AFTER),
   MAKE_ICONSTANT((char*)"GDK_AccessX_Enable",0xfe70),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_25",0x1002812),
   MAKE_ICONSTANT((char*)"GTK_NOTEBOOK_TAB_FIRST",GTK_NOTEBOOK_TAB_FIRST),
   MAKE_ICONSTANT((char*)"GDK_Ncedilla",0x3d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_KbdLightOnOff",0x1008ff04),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_24578",0x10028da),
   MAKE_ICONSTANT((char*)"GDK_KEY_quoteright",0x027),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamza_above",0x1000654),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_zen",0x10010d6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123467",0x100286f),
   MAKE_ICONSTANT((char*)"GDK_Greek_pi",0x7f0),
   MAKE_ICONSTANT((char*)"GTK_RECENT_CHOOSER_ERROR_NOT_FOUND",GTK_RECENT_CHOOSER_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_MOD2_MASK",GDK_MOD2_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ygrave",0x1001ef2),
   MAKE_ICONSTANT((char*)"GDK_uprightcorner",0x9eb),
   MAKE_ICONSTANT((char*)"GDK_Greek_omega",0x7f9),
   MAKE_ICONSTANT((char*)"GDK_horizlinescan1",0x9ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1245678",0x10028fb),
   MAKE_ICONSTANT((char*)"GDK_KEY_0",0x030),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_o",0x1000585),
   MAKE_ICONSTANT((char*)"GDK_Sinh_oo2",0x1000ddd),
   MAKE_ICONSTANT((char*)"G_SOCKET_PROTOCOL_TCP",G_SOCKET_PROTOCOL_TCP),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_14_MASK",GDK_MODIFIER_RESERVED_14_MASK),
   MAKE_ICONSTANT((char*)"GDK_ISO_Center_Object",0xfe33),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_INVALID",G_DBUS_MESSAGE_HEADER_FIELD_INVALID),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflexbelowdot",0x1001ec6),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_iota",0xfe5d),
   MAKE_ICONSTANT((char*)"GDK_KP_Multiply",0xffaa),
   MAKE_ICONSTANT((char*)"GDK_agrave",0x0e0),
   MAKE_ICONSTANT((char*)"GDK_dead_grave",0xfe50),
   MAKE_ICONSTANT((char*)"GDK_Thai_honokhuk",0xdce),
   MAKE_ICONSTANT((char*)"GDK_Armenian_se",0x100057d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflexhook",0x1001ea8),
   MAKE_ICONSTANT((char*)"GDK_Abreve",0x1c3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_tha",0x1000dad),
   MAKE_ICONSTANT((char*)"GTK_ENTRY_ICON_PRIMARY",GTK_ENTRY_ICON_PRIMARY),
   MAKE_ICONSTANT((char*)"GDK_masculine",0x0ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Last_Group_Lock",0xfe0f),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MENDE_KIKAKUI",G_UNICODE_SCRIPT_MENDE_KIKAKUI),
   MAKE_ICONSTANT((char*)"GDK_Thai_chochang",0xdaa),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Pieub",0xee4),
   MAKE_ICONSTANT((char*)"GDK_plusminus",0x0b1),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TIFINAGH",PANGO_SCRIPT_TIFINAGH),
   MAKE_ICONSTANT((char*)"GDK_Thai_lekhok",0xdf6),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Dikeud",0xeda),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1234",0x100280f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhorntilde",0x1001eee),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_PAD_FEATURE_STRIP",GDK_DEVICE_PAD_FEATURE_STRIP),
   MAKE_ICONSTANT((char*)"GDK_nl",0x9e8),
   MAKE_ICONSTANT((char*)"GDK_RIGHT_TEE",GDK_RIGHT_TEE),
   MAKE_ICONSTANT((char*)"GDK_Ydiaeresis",0x13be),
   MAKE_ICONSTANT((char*)"GTK_TARGET_OTHER_WIDGET",GTK_TARGET_OTHER_WIDGET),
   MAKE_ICONSTANT((char*)"GDK_KEY_RotationPB",0x1008ff75),
   MAKE_ICONSTANT((char*)"GDK_B",0x042),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_9",0x1008fe09),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KHOJKI",PANGO_SCRIPT_KHOJKI),
   MAKE_ICONSTANT((char*)"GTK_UNIT_MM",GTK_UNIT_MM),
   MAKE_ICONSTANT((char*)"GDK_KEY_ZoomOut",0x1008ff8c),
   MAKE_ICONSTANT((char*)"GDK_KEY_apostrophe",0x027),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1234568",0x10028bf),
   MAKE_ICONSTANT((char*)"G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_NONE",G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Farsi_6",0x10006f6),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ROTATE_UPSIDEDOWN",GDK_PIXBUF_ROTATE_UPSIDEDOWN),
   MAKE_ICONSTANT((char*)"GDK_Greek_LAMDA",0x7cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_SlowKeys_Enable",0xfe73),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizlinescan7",0x9f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhorn",0x10001b0),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_135678",0x10028f5),
   MAKE_ICONSTANT((char*)"GDK_acircumflexgrave",0x1001ea7),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Tieut",0xebc),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_UNKNOWN",G_IO_ERROR_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_abovedot",0x1ff),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_COMBINING_MARK",G_UNICODE_BREAK_COMBINING_MARK),
   MAKE_ICONSTANT((char*)"GTK_STATE_SELECTED",GTK_STATE_SELECTED),
   MAKE_ICONSTANT((char*)"GDK_Serbian_DJE",0x6b1),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NO_SERVER",G_DBUS_ERROR_NO_SERVER),
   MAKE_ICONSTANT((char*)"GDK_KEY_U",0x055),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_15",0x1002811),
   MAKE_ICONSTANT((char*)"GDK_KEY_MouseKeys_Enable",0xfe76),
   MAKE_ICONSTANT((char*)"GDK_Armenian_E",0x1000537),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PALMYRENE",PANGO_SCRIPT_PALMYRENE),
   MAKE_ICONSTANT((char*)"G_CONNECT_SWAPPED",G_CONNECT_SWAPPED),
   MAKE_ICONSTANT((char*)"GDK_Greek_iotaaccent",0x7b4),
   MAKE_ICONSTANT((char*)"GDK_igrave",0x0ec),
   MAKE_ICONSTANT((char*)"G_USEC_PER_SEC",1000000),
   MAKE_ICONSTANT((char*)"GDK_KEY_lessthanequal",0x8bc),
   MAKE_ICONSTANT((char*)"GTK_ARROWS_START",GTK_ARROWS_START),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_LINK",GTK_STATE_FLAG_LINK),
   MAKE_ICONSTANT((char*)"GDK_KEY_sixsuperior",0x1002076),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_567",0x1002870),
   MAKE_ICONSTANT((char*)"GDK_Abreveacute",0x1001eae),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TELUGU",PANGO_SCRIPT_TELUGU),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulMieum",0xeab),
   MAKE_ICONSTANT((char*)"GDK_PAD_GROUP_MODE",GDK_PAD_GROUP_MODE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1568",0x10028b1),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioLowerVolume",0x1008ff11),
   MAKE_ICONSTANT((char*)"GDK_KEY_atilde",0x0e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Shift_Lock",0xffe6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Lstroke",0x1a3),
   MAKE_ICONSTANT((char*)"G_DATE_OCTOBER",G_DATE_OCTOBER),
   MAKE_ICONSTANT((char*)"GDK_Georgian_kan",0x10010d9),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_COMMON",G_UNICODE_SCRIPT_COMMON),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_hardsign",0x6df),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_KEEP_COMMENTS",G_KEY_FILE_KEEP_COMMENTS),
   MAKE_ICONSTANT((char*)"GDK_POINTER_MOTION_MASK",GDK_POINTER_MOTION_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_u2",0x1000dd4),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_DROP_INTO_OR_BEFORE",GTK_TREE_VIEW_DROP_INTO_OR_BEFORE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123567",0x1002877),
   MAKE_ICONSTANT((char*)"GTK_TEXT_BUFFER_TARGET_INFO_TEXT",GTK_TEXT_BUFFER_TARGET_INFO_TEXT),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1248",0x100288b),
   MAKE_ICONSTANT((char*)"GDK_UMBRELLA",GDK_UMBRELLA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_yi",0x6a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Accelerate",0xfefa),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Partial_Line_Up",0xfe23),
   MAKE_ICONSTANT((char*)"GDK_Thai_baht",0xddf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_upsilonaccentdieresis",0x7ba),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_CLIENT",G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_CLIENT),
   MAKE_ICONSTANT((char*)"G_REGEX_NEWLINE_LF",G_REGEX_NEWLINE_LF),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_O",0x1000555),
   MAKE_ICONSTANT((char*)"PANGO_UNDERLINE_SINGLE",PANGO_UNDERLINE_SINGLE),
   MAKE_ICONSTANT((char*)"GDK_botintegral",0x8a5),
   MAKE_ICONSTANT((char*)"GDK_KEY_wcircumflex",0x1000175),
   MAKE_ICONSTANT((char*)"GDK_3270_Right2",0xfd03),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_345678",0x10028fc),
   MAKE_ICONSTANT((char*)"GDK_KEY_RotationKB",0x1008ff76),
   MAKE_ICONSTANT((char*)"GDK_Armenian_NU",0x1000546),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_SPACE_LINE",GTK_TOOLBAR_SPACE_LINE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_semicolon",0x5bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Z",0x05a),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_157",0x1002851),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_13_MASK",GDK_MODIFIER_RESERVED_13_MASK),
   MAKE_ICONSTANT((char*)"GDK_OpenURL",0x1008ff38),
   MAKE_ICONSTANT((char*)"GDK_R4",0xffd5),
   MAKE_ICONSTANT((char*)"GDK_KEY_division",0x0f7),
   MAKE_ICONSTANT((char*)"GDK_KEY_openrectbullet",0xae2),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_4",0xffb4),
   MAKE_ICONSTANT((char*)"GTK_TEXT_DIR_NONE",GTK_TEXT_DIR_NONE),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_WS",PANGO_BIDI_TYPE_WS),
   MAKE_ICONSTANT((char*)"G_SOCKET_PROTOCOL_UNKNOWN",G_SOCKET_PROTOCOL_UNKNOWN),
   MAKE_ICONSTANT((char*)"G_DBUS_INTERFACE_SKELETON_FLAGS_HANDLE_METHOD_INVOCATIONS_IN_THREAD",G_DBUS_INTERFACE_SKELETON_FLAGS_HANDLE_METHOD_INVOCATIONS_IN_THREAD),
   MAKE_ICONSTANT((char*)"GDK_KEY_Support",0x1008ff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_theh",0x5cb),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_UNKNOWN",GDK_NOTIFY_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_MAP",GDK_MAP),
   MAKE_ICONSTANT((char*)"GDK_PRIORITY_EVENTS",0),
   MAKE_ICONSTANT((char*)"GDK_leftpointer",0xaea),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_17_MASK",GDK_MODIFIER_RESERVED_17_MASK),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_YI",PANGO_SCRIPT_YI),
   MAKE_ICONSTANT((char*)"GDK_GRAB_FAILED",GDK_GRAB_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Utilde",0x3dd),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_PieubSios",0xee5),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ba",0x1000db6),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Enter",0xfe34),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_45678",0x10028f8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_25678",0x10028f2),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SunkyeongeumMieum",0xef0),
   MAKE_ICONSTANT((char*)"GDK_KEY_integral",0x8bf),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_DE",0x6e4),
   MAKE_ICONSTANT((char*)"GTK_PHASE_BUBBLE",GTK_PHASE_BUBBLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_topintegral",0x8a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123468",0x10028af),
   MAKE_ICONSTANT((char*)"GDK_KEY_THORN",0x0de),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1378",0x10028c5),
   MAKE_ICONSTANT((char*)"GDK_CENTER_PTR",GDK_CENTER_PTR),
   MAKE_ICONSTANT((char*)"GDK_Thai_leksam",0xdf3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_heh",0x5e7),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_HEAVY",PANGO_WEIGHT_HEAVY),
   MAKE_ICONSTANT((char*)"GDK_KEY_zerosuperior",0x1002070),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2",0x1002802),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NANDINAGARI",G_UNICODE_SCRIPT_NANDINAGARI),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Phieuf",0xeed),
   MAKE_ICONSTANT((char*)"GDK_KEY_F14",0xffcb),
   MAKE_ICONSTANT((char*)"GDK_kana_conjunctive",0x4a5),
   MAKE_ICONSTANT((char*)"GDK_Armenian_HI",0x1000545),
   MAKE_ICONSTANT((char*)"GTK_PACK_END",GTK_PACK_END),
   MAKE_ICONSTANT((char*)"GDK_rightarrow",0x8fd),
   MAKE_ICONSTANT((char*)"G_SIGNAL_RUN_LAST",G_SIGNAL_RUN_LAST),
   MAKE_ICONSTANT((char*)"GTK_PHASE_NONE",GTK_PHASE_NONE),
   MAKE_ICONSTANT((char*)"GTK_WIN_POS_CENTER_ON_PARENT",GTK_WIN_POS_CENTER_ON_PARENT),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_24567",0x100287a),
   MAKE_ICONSTANT((char*)"GTK_ALIGN_CENTER",GTK_ALIGN_CENTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_abovering",0xfe58),
   MAKE_ICONSTANT((char*)"GDK_leftsinglequotemark",0xad0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_5",0x1008fe05),
   MAKE_ICONSTANT((char*)"GDK_CycleAngle",0x1008ff9c),
   MAKE_ICONSTANT((char*)"G_APPLICATION_CAN_OVERRIDE_APP_ID",G_APPLICATION_CAN_OVERRIDE_APP_ID),
   MAKE_ICONSTANT((char*)"GTK_ARROW_LEFT",GTK_ARROW_LEFT),
   MAKE_ICONSTANT((char*)"GDK_Georgian_hie",0x10010f2),
   MAKE_ICONSTANT((char*)"GDK_TOUCH_BEGIN",GDK_TOUCH_BEGIN),
   MAKE_ICONSTANT((char*)"GDK_ugrave",0x0f9),
   MAKE_ICONSTANT((char*)"GDK_FUNC_ALL",GDK_FUNC_ALL),
   MAKE_ICONSTANT((char*)"G_UNICODE_UNASSIGNED",G_UNICODE_UNASSIGNED),
   MAKE_ICONSTANT((char*)"GDK_righttack",0xbfc),
   MAKE_ICONSTANT((char*)"GDK_kana_SE",0x4be),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_KA_vertstroke",0x100049c),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_FAILED",G_FILE_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"G_RESOLVER_NAME_LOOKUP_FLAGS_IPV4_ONLY",G_RESOLVER_NAME_LOOKUP_FLAGS_IPV4_ONLY),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER",GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SunkyeongeumPhieuf",0xef4),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_MODIFY_SELECTION",GDK_MODIFIER_INTENT_MODIFY_SELECTION),
   MAKE_ICONSTANT((char*)"GDK_BounceKeys_Enable",0xfe74),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ae2",0x1000dd0),
   MAKE_ICONSTANT((char*)"GDK_KP_1",0xffb1),
   MAKE_ICONSTANT((char*)"GDK_Wcircumflex",0x1000174),
   MAKE_ICONSTANT((char*)"GDK_KEY_Gcaron",0x10001e6),
   MAKE_ICONSTANT((char*)"PANGO_RENDER_PART_BACKGROUND",PANGO_RENDER_PART_BACKGROUND),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_UNKNOWN",G_FILE_TYPE_UNKNOWN),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BHAIKSUKI",G_UNICODE_SCRIPT_BHAIKSUKI),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_NONE",GTK_STACK_TRANSITION_TYPE_NONE),
   MAKE_ICONSTANT((char*)"GDK_Armenian_separation_mark",0x100055d),
   MAKE_ICONSTANT((char*)"GTK_POS_LEFT",GTK_POS_LEFT),
   MAKE_ICONSTANT((char*)"GDK_Greek_tau",0x7f4),
   MAKE_ICONSTANT((char*)"GDK_PROPERTY_DELETE",GDK_PROPERTY_DELETE),
   MAKE_ICONSTANT((char*)"G_SOCKET_MSG_PEEK",G_SOCKET_MSG_PEEK),
   MAKE_ICONSTANT((char*)"GDK_Sinh_al",0x1000dca),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_THAANA",G_UNICODE_SCRIPT_THAANA),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_PROXY_NEGOTIATED",G_SOCKET_CLIENT_PROXY_NEGOTIATED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SHORTI",0x6ea),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_SEMIBOLD",PANGO_WEIGHT_SEMIBOLD),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_PATH",G_DBUS_MESSAGE_HEADER_FIELD_PATH),
   MAKE_ICONSTANT((char*)"GDK_KP_Decimal",0xffae),
   MAKE_ICONSTANT((char*)"GDK_Greek_EPSILON",0x7c5),
   MAKE_ICONSTANT((char*)"GDK_Armenian_TSA",0x100053e),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LINEAR_B",PANGO_SCRIPT_LINEAR_B),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_kaf",0x5e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_H",0x048),
   MAKE_ICONSTANT((char*)"GDK_KEY_TouchpadOff",0x1008ffb1),
   MAKE_ICONSTANT((char*)"GDK_dead_horn",0xfe62),
   MAKE_ICONSTANT((char*)"GDK_mu",0x0b5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23467",0x100286e),
   MAKE_ICONSTANT((char*)"GDK_Up",0xff52),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_CLOSURE",G_SIGNAL_MATCH_CLOSURE),
   MAKE_ICONSTANT((char*)"GTK_TEXT_DIR_RTL",GTK_TEXT_DIR_RTL),
   MAKE_ICONSTANT((char*)"G_UNICODE_DASH_PUNCTUATION",G_UNICODE_DASH_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_Thai_rorua",0xdc3),
   MAKE_ICONSTANT((char*)"GDK_KEY_uptack",0xbce),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_ban",0x10010d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_YI",0x6b7),
   MAKE_ICONSTANT((char*)"GTK_MENU_DIR_CHILD",GTK_MENU_DIR_CHILD),
   MAKE_ICONSTANT((char*)"GDK_KEY_otilde",0x0f5),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_BOOLEAN",G_FILE_ATTRIBUTE_TYPE_BOOLEAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_iTouch",0x1008ff60),
   MAKE_ICONSTANT((char*)"GDK_KEY_ff",0x9e3),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_AGPL_3_0",GTK_LICENSE_AGPL_3_0),
   MAKE_ICONSTANT((char*)"GDK_KEY_L5",0xffcc),
   MAKE_ICONSTANT((char*)"GDK_Hcircumflex",0x2a6),
   MAKE_ICONSTANT((char*)"GDK_KEY_sixsubscript",0x1002086),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_A",0x6e1),
   MAKE_ICONSTANT((char*)"GDK_DOUBLE_ARROW",GDK_DOUBLE_ARROW),
   MAKE_ICONSTANT((char*)"GDK_KEY_ssharp",0x0df),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_MISSING_PROPERTY_VALUE",GTK_BUILDER_ERROR_MISSING_PROPERTY_VALUE),
   MAKE_ICONSTANT((char*)"G_TYPE_RESERVED_GLIB_LAST",31),
   MAKE_ICONSTANT((char*)"GDK_BackSpace",0xff08),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_5",0x1002810),
   MAKE_ICONSTANT((char*)"GDK_dead_stroke",0xfe63),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ES",0x6f3),
   MAKE_ICONSTANT((char*)"GTK_EVENT_SEQUENCE_NONE",GTK_EVENT_SEQUENCE_NONE),
   MAKE_ICONSTANT((char*)"GDK_ybelowdot",0x1001ef5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ETHIOPIC",PANGO_SCRIPT_ETHIOPIC),
   MAKE_ICONSTANT((char*)"GDK_AudioPlay",0x1008ff14),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_tse",0x6c3),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_O_bar",0x10004e8),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_INCONSISTENT",GTK_STATE_FLAG_INCONSISTENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_lowrightcorner",0x9ea),
   MAKE_ICONSTANT((char*)"GDK_hebrew_doublelowline",0xcdf),
   MAKE_ICONSTANT((char*)"GDK_KEY_idiaeresis",0x0ef),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level3_Lock",0xfe05),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_NORMAL",PANGO_WEIGHT_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_vin",0x10010d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_C_h",0xfea4),
   MAKE_ICONSTANT((char*)"PANGO_SHOW_IGNORABLES",PANGO_SHOW_IGNORABLES),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_INVAL",G_IO_ERROR_INVAL),
   MAKE_ICONSTANT((char*)"G_UNICODE_CONTROL",G_UNICODE_CONTROL),
   MAKE_ICONSTANT((char*)"GDK_Sinh_pha",0x1000db5),
   MAKE_ICONSTANT((char*)"GDK_HINT_BASE_SIZE",GDK_HINT_BASE_SIZE),
   MAKE_ICONSTANT((char*)"GDK_KEY_phonographcopyright",0xafb),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamza_below",0x1000655),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123456",0x100283f),
   MAKE_ICONSTANT((char*)"GDK_KEY_L8",0xffcf),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_GESTURE_PHASE_BEGIN",GDK_TOUCHPAD_GESTURE_PHASE_BEGIN),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_TYPE_ERROR",G_VARIANT_PARSE_ERROR_TYPE_ERROR),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_SIGNATURE",G_DBUS_MESSAGE_HEADER_FIELD_SIGNATURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abrevebelowdot",0x1001eb6),
   MAKE_ICONSTANT((char*)"GDK_Greek_theta",0x7e8),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_ARTISTIC",GTK_LICENSE_ARTISTIC),
   MAKE_ICONSTANT((char*)"GDK_Arabic_meem",0x5e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_HA",0x6e8),
   MAKE_ICONSTANT((char*)"GDK_KEY_lacute",0x1e5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GEORGIAN",PANGO_SCRIPT_GEORGIAN),
   MAKE_ICONSTANT((char*)"GDK_Farsi_5",0x10006f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thonangmontho",0xdb1),
   MAKE_ICONSTANT((char*)"GDK_zabovedot",0x1bf),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PROXY_NEED_AUTH",G_IO_ERROR_PROXY_NEED_AUTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_chochang",0xdaa),
   MAKE_ICONSTANT((char*)"GDK_Sinh_bha",0x1000db7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3467",0x100286c),
   MAKE_ICONSTANT((char*)"GDK_twothirds",0xab1),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_LEFT",GTK_JUNCTION_LEFT),
   MAKE_ICONSTANT((char*)"GTK_MESSAGE_ERROR",GTK_MESSAGE_ERROR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_2",0xfff2),
   MAKE_ICONSTANT((char*)"GDK_KEY_WLAN",0x1008ff95),
   MAKE_ICONSTANT((char*)"G_VALUE_NOCOPY_CONTENTS",134217728),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_tsu",0x4af),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maichattawa",0xdeb),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_u_straight",0x10004af),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eacute",0x0c9),
   MAKE_ICONSTANT((char*)"GTK_SORT_ASCENDING",GTK_SORT_ASCENDING),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OL_CHIKI",G_UNICODE_SCRIPT_OL_CHIKI),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_245678",0x10028fa),
   MAKE_ICONSTANT((char*)"GDK_KEY_ooblique",0x0f8),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_UNDER_UP",GTK_STACK_TRANSITION_TYPE_UNDER_UP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Byelorussian_SHORTU",0x6be),
   MAKE_ICONSTANT((char*)"GDK_Armenian_tsa",0x100056e),
   MAKE_ICONSTANT((char*)"G_MOUNT_UNMOUNT_NONE",G_MOUNT_UNMOUNT_NONE),
   MAKE_ICONSTANT((char*)"GTK_SELECTION_SINGLE",GTK_SELECTION_SINGLE),
   MAKE_ICONSTANT((char*)"GDK_Meta_R",0xffe8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ccaron",0x1e8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1268",0x10028a3),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ii2",0x1000dd3),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_DELETED",G_FILE_MONITOR_EVENT_DELETED),
   MAKE_ICONSTANT((char*)"GDK_Greek_omegaaccent",0x7bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Dstroke",0x1d0),
   MAKE_ICONSTANT((char*)"GDK_Ncaron",0x1d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_L10",0xffd1),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NAMETOOLONG",G_FILE_ERROR_NAMETOOLONG),
   MAKE_ICONSTANT((char*)"GDK_KEY_eogonek",0x1ea),
   MAKE_ICONSTANT((char*)"GDK_TOUCH_UPDATE",GDK_TOUCH_UPDATE),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_EraseInput",0xfd07),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OLD_PERSIAN",PANGO_SCRIPT_OLD_PERSIAN),
   MAKE_ICONSTANT((char*)"GDK_femalesymbol",0xaf8),
   MAKE_ICONSTANT((char*)"GDK_rightmiddlecurlybrace",0x8b0),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_MEDIUM",PANGO_WEIGHT_MEDIUM),
   MAKE_ICONSTANT((char*)"GDK_KEY_fourfifths",0xab5),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_WEST",PANGO_GRAVITY_WEST),
   MAKE_ICONSTANT((char*)"GTK_DELETE_PARAGRAPHS",GTK_DELETE_PARAGRAPHS),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_TEMPLATE_MISMATCH",GTK_BUILDER_ERROR_TEMPLATE_MISMATCH),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_PA2",0xfd0b),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_acute",0xfe51),
   MAKE_ICONSTANT((char*)"GTK_APPLICATION_INHIBIT_SWITCH",GTK_APPLICATION_INHIBIT_SWITCH),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BATAK",G_UNICODE_SCRIPT_BATAK),
   MAKE_ICONSTANT((char*)"GDK_KEY_musicalflat",0xaf6),
   MAKE_ICONSTANT((char*)"GDK_emspace",0xaa1),
   MAKE_ICONSTANT((char*)"GDK_caret",0xafc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_4",0x1008fe04),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_SOUTH_WEST",GDK_WINDOW_EDGE_SOUTH_WEST),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HANGUL",G_UNICODE_SCRIPT_HANGUL),
   MAKE_ICONSTANT((char*)"GDK_KEY_emopencircle",0xace),
   MAKE_ICONSTANT((char*)"GDK_KEY_i",0x069),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Set_Margin_Left",0xfe27),
   MAKE_ICONSTANT((char*)"G_TLS_REHANDSHAKE_SAFELY",G_TLS_REHANDSHAKE_SAFELY),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_ya",0x4ac),
   MAKE_ICONSTANT((char*)"GTK_ARROW_DOWN",GTK_ARROW_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YeorinHieuh",0xef5),
   MAKE_ICONSTANT((char*)"GDK_AXIS_YTILT",GDK_AXIS_YTILT),
   MAKE_ICONSTANT((char*)"GDK_Rcedilla",0x3a3),
   MAKE_ICONSTANT((char*)"GDK_Greek_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3468",0x10028ac),
   MAKE_ICONSTANT((char*)"GDK_KEY_2",0x032),
   MAKE_ICONSTANT((char*)"GDK_guillemotleft",0x0ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_WE",0xece),
   MAKE_ICONSTANT((char*)"GDK_KEY_cent",0x0a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_MultipleCandidate",0xff3d),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_DROP_INTO",GTK_ICON_VIEW_DROP_INTO),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2567",0x1002872),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1367",0x1002865),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_MEN",0x1000544),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_CORNER_TOPRIGHT",GTK_JUNCTION_CORNER_TOPRIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhornbelowdot",0x1001ef0),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_greek",0xfe8c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_maddaonalef",0x5c2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_GHE_bar",0x1000492),
   MAKE_ICONSTANT((char*)"GDK_KEY_pabovedot",0x1001e57),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflextilde",0x1001ed6),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_MASK",GDK_SCROLL_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ze",0x6da),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_PA3",0xfd0c),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_17",0x1002841),
   MAKE_ICONSTANT((char*)"GDK_Eogonek",0x1ca),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioRepeat",0x1008ff98),
   MAKE_ICONSTANT((char*)"GTK_WIN_POS_CENTER",GTK_WIN_POS_CENTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Odoubleacute",0x1d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_topleftsummation",0x8b1),
   MAKE_ICONSTANT((char*)"GDK_cursor",0xaff),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_PERM",G_FILE_ERROR_PERM),
   MAKE_ICONSTANT((char*)"GDK_KEY_ETH",0x0d0),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_FLUSH_EVENTS",GDK_FRAME_CLOCK_PHASE_FLUSH_EVENTS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_278",0x10028c2),
   MAKE_ICONSTANT((char*)"GDK_Arabic_noon_ghunna",0x10006ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Copy",0x1008ff57),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_DESERET",G_UNICODE_SCRIPT_DESERET),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12578",0x10028d3),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FALLBACK",PANGO_ATTR_FALLBACK),
   MAKE_ICONSTANT((char*)"GDK_Obarred",0x100019f),
   MAKE_ICONSTANT((char*)"GDK_KEY_botvertsummationconnector",0x8b4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_134578",0x10028dd),
   MAKE_ICONSTANT((char*)"GDK_UL_ANGLE",GDK_UL_ANGLE),
   MAKE_ICONSTANT((char*)"GDK_DRAFT_SMALL",GDK_DRAFT_SMALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_234567",0x100287e),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Delete",0xff9f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Amacron",0x3c0),
   MAKE_ICONSTANT((char*)"G_UNICODE_OTHER_LETTER",G_UNICODE_OTHER_LETTER),
   MAKE_ICONSTANT((char*)"GDK_Uhornbelowdot",0x1001ef0),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Next_Group",0xfe08),
   MAKE_ICONSTANT((char*)"GDK_botrightsummation",0x8b6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_u_macron",0x10004ef),
   MAKE_ICONSTANT((char*)"GDK_3270_FieldMark",0xfd02),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_DZHE",0x6bf),
   MAKE_ICONSTANT((char*)"GDK_3270_Enter",0xfd1e),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_BOTTOM_TILED",GDK_WINDOW_STATE_BOTTOM_TILED),
   MAKE_ICONSTANT((char*)"GDK_leftarrow",0x8fb),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag4",0xfef8),
   MAKE_ICONSTANT((char*)"GDK_kana_closingbracket",0x4a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_ModeLock",0x1008ff01),
   MAKE_ICONSTANT((char*)"GTK_ARROW_RIGHT",GTK_ARROW_RIGHT),
   MAKE_ICONSTANT((char*)"G_IO_ERR",G_IO_ERR),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_RESUME_EVENTS",GDK_FRAME_CLOCK_PHASE_RESUME_EVENTS),
   MAKE_ICONSTANT((char*)"GDK_KEY_at",0x040),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_COPTIC",PANGO_SCRIPT_COPTIC),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB",GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB),
   MAKE_ICONSTANT((char*)"GDK_SUPER_MASK",GDK_SUPER_MASK),
   MAKE_ICONSTANT((char*)"G_UNICODE_INITIAL_PUNCTUATION",G_UNICODE_INITIAL_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecaron",0x1cc),
   MAKE_ICONSTANT((char*)"GDK_hebrew_kuf",0xcf7),
   MAKE_ICONSTANT((char*)"GDK_Amacron",0x3c0),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ssha",0x1000dc2),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YU",0xed0),
   MAKE_ICONSTANT((char*)"GDK_opentribulletup",0xae3),
   MAKE_ICONSTANT((char*)"G_DATE_TUESDAY",G_DATE_TUESDAY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_we",0x10010f3),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_MEMBER",G_DBUS_MESSAGE_HEADER_FIELD_MEMBER),
   MAKE_ICONSTANT((char*)"GDK_twofifths",0xab3),
   MAKE_ICONSTANT((char*)"G_ZLIB_COMPRESSOR_FORMAT_GZIP",G_ZLIB_COMPRESSOR_FORMAT_GZIP),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_BOTTOM_TO_TOP",GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_BOTTOM_TO_TOP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohorn",0x10001a0),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraue",0xdd6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ligature_ew",0x1000587),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Release_Margin_Left",0xfe29),
   MAKE_ICONSTANT((char*)"GDK_horizlinescan3",0x9f0),
   MAKE_ICONSTANT((char*)"GDK_Reload",0x1008ff73),
   MAKE_ICONSTANT((char*)"GDK_ISO_Fast_Cursor_Right",0xfe2d),
   MAKE_ICONSTANT((char*)"FALSE",0),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_el",0x6cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_partdifferential",0x1002202),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_UNKNOWN_ENCODING",G_BOOKMARK_FILE_ERROR_UNKNOWN_ENCODING),
   MAKE_ICONSTANT((char*)"GDK_hebrew_ayin",0xcf2),
   MAKE_ICONSTANT((char*)"G_UNICODE_PRIVATE_USE",G_UNICODE_PRIVATE_USE),
   MAKE_ICONSTANT((char*)"G_PARAM_CONSTRUCT_ONLY",G_PARAM_CONSTRUCT_ONLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_va",0x1000dc0),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_ICONIFIED",GDK_WINDOW_STATE_ICONIFIED),
   MAKE_ICONSTANT((char*)"GDK_dead_i",0xfe84),
   MAKE_ICONSTANT((char*)"GDK_KEY_em4space",0xaa4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_paiyannoi",0xdcf),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_WEST",GDK_WINDOW_EDGE_WEST),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CYPRIOT",PANGO_SCRIPT_CYPRIOT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_GIM",0x1000533),
   MAKE_ICONSTANT((char*)"GDK_kana_ya",0x4ac),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_SUBPATTERN_NAME_TERMINATOR",G_REGEX_ERROR_MISSING_SUBPATTERN_NAME_TERMINATOR),
   MAKE_ICONSTANT((char*)"GDK_Ooblique",0x0d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_K",0x04b),
   MAKE_ICONSTANT((char*)"GDK_KEY_F23",0xffd4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_5",0x1002810),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_man",0x10010db),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_es",0x6d3),
   MAKE_ICONSTANT((char*)"GDK_leftanglebracket",0xabc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YI",0xed2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_zhe",0x6d6),
   MAKE_ICONSTANT((char*)"GDK_Sinh_cha",0x1000da1),
   MAKE_ICONSTANT((char*)"GDK_KEY_TouchpadToggle",0x1008ffa9),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_BACKUP",G_FILE_COPY_BACKUP),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123578",0x10028d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tcaron",0x1ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_question",0x100055e),
   MAKE_ICONSTANT((char*)"GDK_SB_LEFT_ARROW",GDK_SB_LEFT_ARROW),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS",G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_47",0x1002848),
   MAKE_ICONSTANT((char*)"GDK_KEY_Mail",0x1008ff19),
   MAKE_ICONSTANT((char*)"GDK_KEY_botleftsqbracket",0x8a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_leksun",0xdf0),
   MAKE_ICONSTANT((char*)"GDK_CD",0x1008ff53),
   MAKE_ICONSTANT((char*)"GDK_Georgian_fi",0x10010f6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_EN_descender",0x10004a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchB",0x1008ff4b),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_TOP_TO_BOTTOM",GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_TOP_TO_BOTTOM),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_7",0xfff7),
   MAKE_ICONSTANT((char*)"GDK_MillSign",0x10020a5),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DownLeft",0xfee6),
   MAKE_ICONSTANT((char*)"GDK_Scroll_Lock",0xff14),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_VALUE_EXPECTED",G_VARIANT_PARSE_ERROR_VALUE_EXPECTED),
   MAKE_ICONSTANT((char*)"GDK_Thai_maihanakat",0xdd1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_45",0x1002818),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ttha",0x1000da8),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_ON",PANGO_BIDI_TYPE_ON),
   MAKE_ICONSTANT((char*)"G_UNICODE_NON_SPACING_MARK",G_UNICODE_NON_SPACING_MARK),
   MAKE_ICONSTANT((char*)"GDK_Sinh_nga",0x1000d9f),
   MAKE_ICONSTANT((char*)"G_CONNECT_AFTER",G_CONNECT_AFTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_jil",0x10010eb),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_READ",G_BOOKMARK_FILE_ERROR_READ),
   MAKE_ICONSTANT((char*)"G_BINDING_DEFAULT",G_BINDING_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_BOTTOM_TEE",GDK_BOTTOM_TEE),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_LEFT",GTK_SCROLL_PAGE_LEFT),
   MAKE_ICONSTANT((char*)"GDK_aacute",0x0e1),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_DOUBLE",GTK_BORDER_STYLE_DOUBLE),
   MAKE_ICONSTANT((char*)"GDK_F1",0xffbe),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_DEVICE_SWITCH",GDK_CROSSING_DEVICE_SWITCH),
   MAKE_ICONSTANT((char*)"GDK_dead_doubleacute",0xfe59),
   MAKE_ICONSTANT((char*)"GDK_Greek_IOTAdieresis",0x7a5),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_PROGRESS",GTK_ASSISTANT_PAGE_PROGRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1347",0x100284d),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_NA",0x4c5),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_VARIATIONS",PANGO_FONT_MASK_VARIATIONS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_KAPPA",0x7ca),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ng2",0x1000d9e),
   MAKE_ICONSTANT((char*)"GDK_Dstroke",0x1d0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1467",0x1002869),
   MAKE_ICONSTANT((char*)"GDK_ibreve",0x100012d),
   MAKE_ICONSTANT((char*)"GDK_Gcaron",0x10001e6),
   MAKE_ICONSTANT((char*)"GTK_BUTTON_ROLE_RADIO",GTK_BUTTON_ROLE_RADIO),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1358",0x1002895),
   MAKE_ICONSTANT((char*)"GDK_Hangul_PreHanja",0xff3a),
   MAKE_ICONSTANT((char*)"G_SOCKET_MSG_DONTROUTE",G_SOCKET_MSG_DONTROUTE),
   MAKE_ICONSTANT((char*)"GDK_botleftsqbracket",0x8a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Jump",0xfd12),
   MAKE_ICONSTANT((char*)"G_PARAM_USER_SHIFT",8),
   MAKE_ICONSTANT((char*)"GDK_Sinh_va",0x1000dc0),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ligature_ew",0x1000587),
   MAKE_ICONSTANT((char*)"PANGO_WRAP_WORD",PANGO_WRAP_WORD),
   MAKE_ICONSTANT((char*)"GDK_plus",0x02b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Alt_L",0xffe9),
   MAKE_ICONSTANT((char*)"GDK_Thai_maitho",0xde9),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowring",0xfe67),
   MAKE_ICONSTANT((char*)"GDK_GRAB_FROZEN",GDK_GRAB_FROZEN),
   MAKE_ICONSTANT((char*)"G_ASCII_ALPHA",G_ASCII_ALPHA),
   MAKE_ICONSTANT((char*)"GDK_blank",0x9df),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_char",0x10010ed),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YeorinHieuh",0xef5),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_NONE",GTK_JUNCTION_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_VoidSymbol",0xffffff),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_phophan",0xdbe),
   MAKE_ICONSTANT((char*)"GDK_lf",0x9e5),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES",G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES),
   MAKE_ICONSTANT((char*)"G_RESOLVER_NAME_LOOKUP_FLAGS_DEFAULT",G_RESOLVER_NAME_LOOKUP_FLAGS_DEFAULT),
   MAKE_ICONSTANT((char*)"G_APPLICATION_NON_UNIQUE",G_APPLICATION_NON_UNIQUE),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_GENERATE_PDF",GTK_PRINT_CAPABILITY_GENERATE_PDF),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_67",0x1002860),
   MAKE_ICONSTANT((char*)"GDK_KEY_ENG",0x3bd),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_BSR_ANYCRLF",G_REGEX_MATCH_BSR_ANYCRLF),
   MAKE_ICONSTANT((char*)"GDK_Launch7",0x1008ff47),
   MAKE_ICONSTANT((char*)"GDK_topleftsummation",0x8b1),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_SECONDARY",3),
   MAKE_ICONSTANT((char*)"GDK_KEY_notequal",0x8bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_R4",0xffd5),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_schwa",0x10004d9),
   MAKE_ICONSTANT((char*)"GDK_semivoicedsound",0x4df),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_JAVANESE",G_UNICODE_SCRIPT_JAVANESE),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_E",0xfe83),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_148",0x1002889),
   MAKE_ICONSTANT((char*)"G_FILESYSTEM_PREVIEW_TYPE_IF_ALWAYS",G_FILESYSTEM_PREVIEW_TYPE_IF_ALWAYS),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_INHERIT_FDS",G_SUBPROCESS_FLAGS_INHERIT_FDS),
   MAKE_ICONSTANT((char*)"GDK_M",0x04d),
   MAKE_ICONSTANT((char*)"GDK_KEY_toprightsummation",0x8b5),
   MAKE_ICONSTANT((char*)"GDK_Hangul_MultipleCandidate",0xff3d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2358",0x1002896),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Banja",0xff39),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_LAMBDA",0x7cb),
   MAKE_ICONSTANT((char*)"GDK_musicalflat",0xaf6),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_UNKNOWN_KEYWORD",G_VARIANT_PARSE_ERROR_UNKNOWN_KEYWORD),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KATAKANA",PANGO_SCRIPT_KATAKANA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Next_Virtual_Screen",0xfed2),
   MAKE_ICONSTANT((char*)"GDK_hebrew_chet",0xce7),
   MAKE_ICONSTANT((char*)"GTK_PRINT_ERROR_INTERNAL_ERROR",GTK_PRINT_ERROR_INTERNAL_ERROR),
   MAKE_ICONSTANT((char*)"GDK_EZH",0x10001b7),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_GRAB_BROKEN",GTK_DRAG_RESULT_GRAB_BROKEN),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_NON_BREAKING_GLUE",G_UNICODE_BREAK_NON_BREAKING_GLUE),
   MAKE_ICONSTANT((char*)"GDK_KEY_vt",0x9e9),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_DERIVABLE",G_TYPE_FLAG_DERIVABLE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_57",0x1002850),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocaron",0x10001d1),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_3",0x1008fe03),
   MAKE_ICONSTANT((char*)"GDK_CIRCLE",GDK_CIRCLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13678",0x10028e5),
   MAKE_ICONSTANT((char*)"GDK_approximate",0x8c8),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT",GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DownLeft",0xfee6),
   MAKE_ICONSTANT((char*)"GDK_dead_o",0xfe86),
   MAKE_ICONSTANT((char*)"GDK_gcircumflex",0x2f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_10",0x1008fe0a),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_daleth",0xce3),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_BE",0x6e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Prev_VMode",0x1008fe23),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_tar",0x10010e2),
   MAKE_ICONSTANT((char*)"GDK_kana_RO",0x4db),
   MAKE_ICONSTANT((char*)"G_RESOLVER_ERROR_INTERNAL",G_RESOLVER_ERROR_INTERNAL),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13478",0x10028cd),
   MAKE_ICONSTANT((char*)"GDK_5",0x035),
   MAKE_ICONSTANT((char*)"GDK_Scedilla",0x1aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level3_Lock",0xfe05),
   MAKE_ICONSTANT((char*)"GTK_FILE_FILTER_FILENAME",GTK_FILE_FILTER_FILENAME),
   MAKE_ICONSTANT((char*)"GDK_KEY_FFrancSign",0x10020a3),
   MAKE_ICONSTANT((char*)"GDK_NOTHING",GDK_NOTHING),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OLD_ITALIC",PANGO_SCRIPT_OLD_ITALIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_24567",0x100287a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraae",0xde1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulPieub",0xeac),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_38",0x1002884),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Tab",0xff89),
   MAKE_ICONSTANT((char*)"GTK_TEXT_VIEW_LAYER_ABOVE",GTK_TEXT_VIEW_LAYER_ABOVE),
   MAKE_ICONSTANT((char*)"G_DBUS_CALL_FLAGS_NO_AUTO_START",G_DBUS_CALL_FLAGS_NO_AUTO_START),
   MAKE_ICONSTANT((char*)"GDK_AccessX_Feedback_Enable",0xfe71),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_357",0x1002854),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflexgrave",0x1001ec1),
   MAKE_ICONSTANT((char*)"GDK_v",0x076),
   MAKE_ICONSTANT((char*)"GDK_Armenian_question",0x100055e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflexbelowdot",0x1001ec6),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_abovereversedcomma",0xfe65),
   MAKE_ICONSTANT((char*)"G_DBUS_SIGNAL_FLAGS_NONE",G_DBUS_SIGNAL_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_filledlefttribullet",0xadc),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_io",0x6a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_multiply",0x0d7),
   MAKE_ICONSTANT((char*)"GTK_PAGE_ORIENTATION_PORTRAIT",GTK_PAGE_ORIENTATION_PORTRAIT),
   MAKE_ICONSTANT((char*)"GDK_dead_e",0xfe82),
   MAKE_ICONSTANT((char*)"GDK_KEY_Obarred",0x100019f),
   MAKE_ICONSTANT((char*)"GDK_infinity",0x8c2),
   MAKE_ICONSTANT((char*)"GDK_iTouch",0x1008ff60),
   MAKE_ICONSTANT((char*)"G_IO_STREAM_SPLICE_CLOSE_STREAM1",G_IO_STREAM_SPLICE_CLOSE_STREAM1),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_NOT_ABSOLUTE_PATH",G_CONVERT_ERROR_NOT_ABSOLUTE_PATH),
   MAKE_ICONSTANT((char*)"GDK_AddFavorite",0x1008ff39),
   MAKE_ICONSTANT((char*)"GDK_abreve",0x1e3),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_TOP",GTK_JUNCTION_TOP),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_SIGNAL",GTK_BUILDER_ERROR_INVALID_SIGNAL),
   MAKE_ICONSTANT((char*)"GDK_dead_capital_schwa",0xfe8b),
   MAKE_ICONSTANT((char*)"GDK_KEY_topt",0x9f7),
   MAKE_ICONSTANT((char*)"GDK_topintegral",0x8a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_E",0x4b4),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_LEFT_TO_RIGHT",GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_LEFT_TO_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_tau",0x7f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_epsilonaccent",0x7b2),
   MAKE_ICONSTANT((char*)"GDK_Thai_nikhahit",0xded),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12456",0x100283b),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_18",0x1002881),
   MAKE_ICONSTANT((char*)"GDK_figdash",0xabb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_4678",0x10028e8),
   MAKE_ICONSTANT((char*)"GDK_Armenian_AT",0x1000538),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_SERVICE_NOT_FOUND",G_DBUS_ERROR_SPAWN_SERVICE_NOT_FOUND),
   MAKE_ICONSTANT((char*)"G_SOCKET_LISTENER_BOUND",G_SOCKET_LISTENER_BOUND),
   MAKE_ICONSTANT((char*)"GDK_RupeeSign",0x10020a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_End",0xff33),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_CursorBlink",0xfd0f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_sigma",0x7f2),
   MAKE_ICONSTANT((char*)"GDK_topleftsqbracket",0x8a7),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_SIZE",PANGO_FONT_MASK_SIZE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123567",0x1002877),
   MAKE_ICONSTANT((char*)"GDK_L3",0xffca),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_DIRECT_COLOR",GDK_VISUAL_DIRECT_COLOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_GJE",0x6b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_IOTAdiaeresis",0x7a5),
   MAKE_ICONSTANT((char*)"GDK_Thai_maiek",0xde8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohorn",0x10001a1),
   MAKE_ICONSTANT((char*)"GDK_umacron",0x3fe),
   MAKE_ICONSTANT((char*)"GDK_Greek_lambda",0x7eb),
   MAKE_ICONSTANT((char*)"G_DATE_FEBRUARY",G_DATE_FEBRUARY),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_NONE",G_SUBPROCESS_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_containsas",0x100220b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ee",0x1000d92),
   MAKE_ICONSTANT((char*)"GDK_gabovedot",0x2f5),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_SOLARIS_UCRED",G_CREDENTIALS_TYPE_SOLARIS_UCRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_a",0x4a7),
   MAKE_ICONSTANT((char*)"GDK_Iogonek",0x3c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_sukun",0x5f2),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_HANUNOO",G_UNICODE_SCRIPT_HANUNOO),
   MAKE_ICONSTANT((char*)"GDK_AudioRandomPlay",0x1008ff99),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_9",0xffb9),
   MAKE_ICONSTANT((char*)"GDK_leftt",0x9f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_R12",0xffdd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Page_Up",0xff9a),
   MAKE_ICONSTANT((char*)"GDK_Georgian_har",0x10010f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamza_above",0x1000654),
   MAKE_ICONSTANT((char*)"GDK_hexagram",0xada),
   MAKE_ICONSTANT((char*)"GDK_Kcedilla",0x3d3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_upsilondieresis",0x7b9),
   MAKE_ICONSTANT((char*)"GDK_KEY_OE",0x13bc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_xi",0x7ee),
   MAKE_ICONSTANT((char*)"GDK_EcuSign",0x10020a0),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MIAO",G_UNICODE_SCRIPT_MIAO),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_COMPILE",G_REGEX_ERROR_COMPILE),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_TUPLE",G_VARIANT_CLASS_TUPLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_topleftradical",0x8a2),
   MAKE_ICONSTANT((char*)"GDK_3270_Test",0xfd0d),
   MAKE_ICONSTANT((char*)"GTK_POLICY_ALWAYS",GTK_POLICY_ALWAYS),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_14678",0x10028e9),
   MAKE_ICONSTANT((char*)"GDK_SPIDER",GDK_SPIDER),
   MAKE_ICONSTANT((char*)"GDK_odiaeresis",0x0f6),
   MAKE_ICONSTANT((char*)"GDK_cedilla",0x0b8),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1234567",0x100287f),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_ACCELERATOR",GTK_SHORTCUT_ACCELERATOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thothahan",0xdb7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_RUNIC",PANGO_SCRIPT_RUNIC),
   MAKE_ICONSTANT((char*)"GDK_Option",0x1008ff6c),
   MAKE_ICONSTANT((char*)"GDK_KEY_R3",0xffd4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ELBASAN",G_UNICODE_SCRIPT_ELBASAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_MenuPB",0x1008ff66),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_ACTION_EXPORT",GTK_PRINT_OPERATION_ACTION_EXPORT),
   MAKE_ICONSTANT((char*)"GDK_Hangul_PieubSios",0xeb4),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_DETAIL",G_SIGNAL_MATCH_DETAIL),
   MAKE_ICONSTANT((char*)"GDK_Documents",0x1008ff5b),
   MAKE_ICONSTANT((char*)"GDK_KEY_MailForward",0x1008ff90),
   MAKE_ICONSTANT((char*)"GTK_WIN_POS_MOUSE",GTK_WIN_POS_MOUSE),
   MAKE_ICONSTANT((char*)"GDK_R13",0xffde),
   MAKE_ICONSTANT((char*)"GDK_kana_HA",0x4ca),
   MAKE_ICONSTANT((char*)"GDK_Armenian_verjaket",0x1000589),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1458",0x1002899),
   MAKE_ICONSTANT((char*)"GDK_ISO_Emphasize",0xfe32),
   MAKE_ICONSTANT((char*)"GDK_KEY_comma",0x02c),
   MAKE_ICONSTANT((char*)"G_RESOLVER_ERROR_NOT_FOUND",G_RESOLVER_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_Thai_sorusi",0xdc9),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SINHALA",G_UNICODE_SCRIPT_SINHALA),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflexhook",0x1001ed5),
   MAKE_ICONSTANT((char*)"GDK_KEY_WindowClear",0x1008ff55),
   MAKE_ICONSTANT((char*)"GDK_F",0x046),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_256",0x1002832),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_17",0x1002841),
   MAKE_ICONSTANT((char*)"GDK_KEY_because",0x1002235),
   MAKE_ICONSTANT((char*)"GDK_ytilde",0x1001ef9),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_GENERATING_DATA",GTK_PRINT_STATUS_GENERATING_DATA),
   MAKE_ICONSTANT((char*)"GDK_Udoubleacute",0x1db),
   MAKE_ICONSTANT((char*)"GDK_Delete",0xffff),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_PASSWORD",GTK_INPUT_PURPOSE_PASSWORD),
   MAKE_ICONSTANT((char*)"GDK_acircumflexhook",0x1001ea9),
   MAKE_ICONSTANT((char*)"GTK_FONT_CHOOSER_LEVEL_STYLE",GTK_FONT_CHOOSER_LEVEL_STYLE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_WA",0xec8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KHUDAWADI",PANGO_SCRIPT_KHUDAWADI),
   MAKE_ICONSTANT((char*)"PANGO_SHOW_LINE_BREAKS",PANGO_SHOW_LINE_BREAKS),
   MAKE_ICONSTANT((char*)"GDK_MyComputer",0x1008ff33),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LIMBU",PANGO_SCRIPT_LIMBU),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_8",0xfff8),
   MAKE_ICONSTANT((char*)"GDK_Meta_L",0xffe7),
   MAKE_ICONSTANT((char*)"GDK_KEY_dagger",0xaf1),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_MASK",GDK_MODIFIER_MASK),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_22_MASK",GDK_MODIFIER_RESERVED_22_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_1",0xffb1),
   MAKE_ICONSTANT((char*)"GDK_checkerboard",0x9e1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_127",0x1002843),
   MAKE_ICONSTANT((char*)"GDK_Hangul_OE",0xeca),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_zain",0x5d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_ApplicationRight",0x1008ff51),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_VALUE",GTK_BUILDER_ERROR_INVALID_VALUE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DblClick3",0xfef1),
   MAKE_ICONSTANT((char*)"GDK_Thai_soso",0xdab),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1457",0x1002859),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_TYPE_SIGNAL",G_DBUS_MESSAGE_TYPE_SIGNAL),
   MAKE_ICONSTANT((char*)"GDK_Thorn",0x0de),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MANDAIC",G_UNICODE_SCRIPT_MANDAIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_KbdBrightnessDown",0x1008ff06),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_EPSILON",0x7c5),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAGALOG",G_UNICODE_SCRIPT_TAGALOG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflextilde",0x1001ed6),
   MAKE_ICONSTANT((char*)"GDK_Armenian_exclam",0x100055c),
   MAKE_ICONSTANT((char*)"GDK_Launch3",0x1008ff43),
   MAKE_ICONSTANT((char*)"GTK_DEST_DEFAULT_ALL",GTK_DEST_DEFAULT_ALL),
   MAKE_ICONSTANT((char*)"GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE",GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE),
   MAKE_ICONSTANT((char*)"GDK_BASED_ARROW_DOWN",GDK_BASED_ARROW_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohook",0x1001ecf),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_PROXY_NEGOTIATING",G_SOCKET_CLIENT_PROXY_NEGOTIATING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_EnableKeys",0xfef9),
   MAKE_ICONSTANT((char*)"GDK_questiondown",0x0bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_PYUR",0x1000553),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_134567",0x100287d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_cha",0x1000579),
   MAKE_ICONSTANT((char*)"GDK_Thai_lakkhangyao",0xde5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_WAE",0xec9),
   MAKE_ICONSTANT((char*)"GDK_Odiaeresis",0x0d6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_yeh",0x5ea),
   MAKE_ICONSTANT((char*)"GDK_F29",0xffda),
   MAKE_ICONSTANT((char*)"GTK_TEXT_SEARCH_VISIBLE_ONLY",GTK_TEXT_SEARCH_VISIBLE_ONLY),
   MAKE_ICONSTANT((char*)"GDK_Sinh_u2",0x1000dd4),
   MAKE_ICONSTANT((char*)"GDK_AudioMute",0x1008ff12),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LAO",PANGO_SCRIPT_LAO),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_CORRUPT_IMAGE",GDK_PIXBUF_ERROR_CORRUPT_IMAGE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ha",0x6c8),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraaa",0xdd2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_lla",0x1000dc5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_softsign",0x6d8),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ZHE",0x100053a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_14567",0x1002879),
   MAKE_ICONSTANT((char*)"GDK_KEY_Lbelowdot",0x1001e36),
   MAKE_ICONSTANT((char*)"GDK_KEY_udoubleacute",0x1fb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_3270_PA1",0xfd0a),
   MAKE_ICONSTANT((char*)"GDK_Greek_IOTAdiaeresis",0x7a5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ng2",0x1000d9e),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_356",0x1002834),
   MAKE_ICONSTANT((char*)"GDK_Search",0x1008ff1b),
   MAKE_ICONSTANT((char*)"GDK_KEY_colon",0x03a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1468",0x10028a9),
   MAKE_ICONSTANT((char*)"G_DBUS_CALL_FLAGS_ALLOW_INTERACTIVE_AUTHORIZATION",G_DBUS_CALL_FLAGS_ALLOW_INTERACTIVE_AUTHORIZATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Divide",0xffaf),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflexgrave",0x1001ec0),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level5_Lock",0xfe13),
   MAKE_ICONSTANT((char*)"GDK_GOBBLER",GDK_GOBBLER),
   MAKE_ICONSTANT((char*)"GDK_botvertsummationconnector",0x8b4),
   MAKE_ICONSTANT((char*)"GDK_Georgian_gan",0x10010d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_F6",0xffc3),
   MAKE_ICONSTANT((char*)"GDK_colon",0x03a),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_AHOM",G_UNICODE_SCRIPT_AHOM),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2378",0x10028c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_het",0xce7),
   MAKE_ICONSTANT((char*)"GDK_RockerDown",0x1008ff24),
   MAKE_ICONSTANT((char*)"GDK_Serbian_dje",0x6a1),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_ghe_with_upturn",0x6ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Explorer",0x1008ff5d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_fa",0x1000dc6),
   MAKE_ICONSTANT((char*)"GDK_Arabic_khah",0x5ce),
   MAKE_ICONSTANT((char*)"GDK_3270_Attn",0xfd0e),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_ChangeScreen",0xfd19),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_BACKWARD",GTK_SCROLL_PAGE_BACKWARD),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_GROUP",GTK_RECENT_FILTER_GROUP),
   MAKE_ICONSTANT((char*)"GDK_Georgian_shin",0x10010e8),
   MAKE_ICONSTANT((char*)"GDK_Nacute",0x1d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_tslash",0x3bc),
   MAKE_ICONSTANT((char*)"GDK_KEY_ccedilla",0x0e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_134567",0x100287d),
   MAKE_ICONSTANT((char*)"GDK_Henkan",0xff23),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ben",0x1000562),
   MAKE_ICONSTANT((char*)"GDK_Undo",0xff65),
   MAKE_ICONSTANT((char*)"GDK_ae",0x0e6),
   MAKE_ICONSTANT((char*)"GDK_Omacron",0x3d2),
   MAKE_ICONSTANT((char*)"GDK_F13",0xffca),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button4",0xfeec),
   MAKE_ICONSTANT((char*)"GDK_KEY_NewSheqelSign",0x10020aa),
   MAKE_ICONSTANT((char*)"GTK_PAGE_SET_ALL",GTK_PAGE_SET_ALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_1",0x10006f1),
   MAKE_ICONSTANT((char*)"GDK_Sinh_luu2",0x1000df3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13567",0x1002875),
   MAKE_ICONSTANT((char*)"GDK_KEY_minutes",0xad6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13458",0x100289d),
   MAKE_ICONSTANT((char*)"GDK_KEY_thorn",0x0fe),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_ABSTRACT",G_TYPE_FLAG_ABSTRACT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Scedilla",0x1aa),
   MAKE_ICONSTANT((char*)"GDK_Thai_moma",0xdc1),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Left_Tab",0xfe20),
   MAKE_ICONSTANT((char*)"GDK_MODE_DISABLED",GDK_MODE_DISABLED),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE",GTK_SHORTCUT_GESTURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_PostHanja",0xff3b),
   MAKE_ICONSTANT((char*)"GDK_KEY_c",0x063),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch2",0x1008ff42),
   MAKE_ICONSTANT((char*)"GDK_KEY_enspace",0xaa2),
   MAKE_ICONSTANT((char*)"GDK_Arabic_alefmaksura",0x5e9),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123468",0x10028af),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_HO",0x4ce),
   MAKE_ICONSTANT((char*)"GDK_KEY_Otilde",0x0d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_I",0x049),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GUJARATI",G_UNICODE_SCRIPT_GUJARATI),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_FAILED",GTK_CSS_PROVIDER_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAMIL",G_UNICODE_SCRIPT_TAMIL),
   MAKE_ICONSTANT((char*)"G_DATE_BAD_DAY",0U),
   MAKE_ICONSTANT((char*)"GDK_KEY_X",0x058),
   MAKE_ICONSTANT((char*)"GDK_SPRAYCAN",GDK_SPRAYCAN),
   MAKE_ICONSTANT((char*)"G_SOCKET_MSG_OOB",G_SOCKET_MSG_OOB),
   MAKE_ICONSTANT((char*)"GDK_abrevehook",0x1001eb3),
   MAKE_ICONSTANT((char*)"GDK_OWNER_CHANGE_CLOSE",GDK_OWNER_CHANGE_CLOSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Duplicate",0xfd01),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_ie",0x6a4),
   MAKE_ICONSTANT((char*)"GDK_Hyper_L",0xffed),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_invertedbreve",0xfe6d),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_INT64",G_FILE_ATTRIBUTE_TYPE_INT64),
   MAKE_ICONSTANT((char*)"GDK_kana_SU",0x4bd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_DEVANAGARI",G_UNICODE_SCRIPT_DEVANAGARI),
   MAKE_ICONSTANT((char*)"G_DATE_BAD_YEAR",0U),
   MAKE_ICONSTANT((char*)"GDK_Greek_nu",0x7ed),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_MESSAGE_TOO_LARGE",G_IO_ERROR_MESSAGE_TOO_LARGE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_un",0x10010e3),
   MAKE_ICONSTANT((char*)"GDK_Greek_SIGMA",0x7d2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_aee2",0x1000dd1),
   MAKE_ICONSTANT((char*)"GDK_Georgian_an",0x10010d0),
   MAKE_ICONSTANT((char*)"GDK_KEY_radical",0x8d6),
   MAKE_ICONSTANT((char*)"GDK_Hibernate",0x1008ffa8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamzaonalef",0x5c3),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NYIAKENG_PUACHUE_HMONG",G_UNICODE_SCRIPT_NYIAKENG_PUACHUE_HMONG),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23478",0x10028ce),
   MAKE_ICONSTANT((char*)"GDK_Thai_paiyannoi",0xdcf),
   MAKE_ICONSTANT((char*)"G_DATE_MAY",G_DATE_MAY),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13457",0x100285d),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_SLIDER",GDK_AXIS_FLAG_SLIDER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_HI",0x1000545),
   MAKE_ICONSTANT((char*)"GDK_jcircumflex",0x2bc),
   MAKE_ICONSTANT((char*)"GDK_etilde",0x1001ebd),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_O",0x6ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Racute",0x1c0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_che",0x6de),
   MAKE_ICONSTANT((char*)"GDK_Sinh_fa",0x1000dc6),
   MAKE_ICONSTANT((char*)"GDK_ScreenSaver",0x1008ff2d),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_COPIES",GTK_PRINT_CAPABILITY_COPIES),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_KE",0x4b9),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_MISC",GTK_DEBUG_MISC),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NEWLINE_CRLF",G_REGEX_MATCH_NEWLINE_CRLF),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_yi",0x6a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_psili",0xfe64),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_HE",0x4cd),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulPhieuf",0xee1),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_SHAPE",PANGO_ATTR_SHAPE),
   MAKE_ICONSTANT((char*)"GDK_Greek_DELTA",0x7c4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MEETEI_MAYEK",G_UNICODE_SCRIPT_MEETEI_MAYEK),
   MAKE_ICONSTANT((char*)"GDK_Georgian_phar",0x10010e4),
   MAKE_ICONSTANT((char*)"G_RESOLVER_RECORD_SOA",G_RESOLVER_RECORD_SOA),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_START",GTK_BUTTONBOX_START),
   MAKE_ICONSTANT((char*)"GTK_POS_RIGHT",GTK_POS_RIGHT),
   MAKE_ICONSTANT((char*)"GTK_UPDATE_ALWAYS",GTK_UPDATE_ALWAYS),
   MAKE_ICONSTANT((char*)"GDK_ISO_Next_Group_Lock",0xfe09),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_HINT_NATURAL",PANGO_GRAVITY_HINT_NATURAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_uacute",0x0fa),
   MAKE_ICONSTANT((char*)"GDK_kana_HI",0x4cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12356",0x1002837),
   MAKE_ICONSTANT((char*)"GDK_KEY_j",0x06a),
   MAKE_ICONSTANT((char*)"GDK_KEY_asterisk",0x02a),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalkaph",0xcea),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3458",0x100289c),
   MAKE_ICONSTANT((char*)"GDK_DRAG_CANCEL_NO_TARGET",GDK_DRAG_CANCEL_NO_TARGET),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick2",0xfef0),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_SLIDE_Y",GDK_ANCHOR_SLIDE_Y),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_ICON_SET",GTK_IMAGE_ICON_SET),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_DISCRETE",GTK_EVENT_CONTROLLER_SCROLL_DISCRETE),
   MAKE_ICONSTANT((char*)"GDK_ohorn",0x10001a1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_IO",0x6b3),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_MIME_TYPE",GTK_RECENT_FILTER_MIME_TYPE),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_EXPAND",GTK_BUTTONBOX_EXPAND),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_First_Group",0xfe0c),
   MAKE_ICONSTANT((char*)"GDK_Lcaron",0x1a5),
   MAKE_ICONSTANT((char*)"G_UNICODE_OTHER_NUMBER",G_UNICODE_OTHER_NUMBER),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_NORMAL",PANGO_STRETCH_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_abelowdot",0x1001ea1),
   MAKE_ICONSTANT((char*)"GDK_PAD_RING",GDK_PAD_RING),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_NO_CONVERSION",G_CONVERT_ERROR_NO_CONVERSION),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_TOO_MANY_LINKS",G_IO_ERROR_TOO_MANY_LINKS),
   MAKE_ICONSTANT((char*)"GDK_Farsi_4",0x10006f4),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INVALID_SIGNATURE",G_VARIANT_PARSE_ERROR_INVALID_SIGNATURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightsinglequotemark",0xad1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_che_descender",0x10004b7),
   MAKE_ICONSTANT((char*)"GDK_endash",0xaaa),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflex",0x0e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulPieub",0xede),
   MAKE_ICONSTANT((char*)"GDK_MOD5_MASK",GDK_MOD5_MASK),
   MAKE_ICONSTANT((char*)"GDK_Armenian_paruyk",0x100055e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Hieuh",0xebe),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_DEVANAGARI",PANGO_SCRIPT_DEVANAGARI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_O_bar",0x10004e8),
   MAKE_ICONSTANT((char*)"GDK_nobreakspace",0x0a0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DfltBtnPrev",0xfefc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_6",0x1008fe06),
   MAKE_ICONSTANT((char*)"GDK_Arabic_2",0x1000662),
   MAKE_ICONSTANT((char*)"G_UNICODE_MODIFIER_SYMBOL",G_UNICODE_MODIFIER_SYMBOL),
   MAKE_ICONSTANT((char*)"GDK_numbersign",0x023),
   MAKE_ICONSTANT((char*)"G_DATE_MONTH",G_DATE_MONTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_ScrollClick",0x1008ff7a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_257",0x1002852),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_ACTIONS",GTK_DEBUG_ACTIONS),
   MAKE_ICONSTANT((char*)"GDK_yacute",0x0fd),
   MAKE_ICONSTANT((char*)"GDK_KEY_acute",0x0b4),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ee2",0x1000dda),
   MAKE_ICONSTANT((char*)"GDK_Arabic_tehmarbuta",0x5c9),
   MAKE_ICONSTANT((char*)"GDK_KEY_e",0x065),
   MAKE_ICONSTANT((char*)"GDK_AudioCycleTrack",0x1008ff9b),
   MAKE_ICONSTANT((char*)"GDK_KEY_topvertsummationconnector",0x8b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_emptyset",0x1002205),
   MAKE_ICONSTANT((char*)"G_PARAM_STATIC_STRINGS",G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB),
   MAKE_ICONSTANT((char*)"GDK_logicalor",0x8df),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_heh_goal",0x10006c1),
   MAKE_ICONSTANT((char*)"GDK_KEY_R9",0xffda),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_DUPLOYAN",PANGO_SCRIPT_DUPLOYAN),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_TOP",GTK_TEXT_WINDOW_TOP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abrevetilde",0x1001eb4),
   MAKE_ICONSTANT((char*)"GTK_DELETE_WORDS",GTK_DELETE_WORDS),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12378",0x10028c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_jot",0xbca),
   MAKE_ICONSTANT((char*)"GDK_rightsinglequotemark",0xad1),
   MAKE_ICONSTANT((char*)"GDK_F19",0xffd0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Caps_Lock",0xffe5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LYDIAN",PANGO_SCRIPT_LYDIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioPause",0x1008ff31),
   MAKE_ICONSTANT((char*)"GDK_KEY_nl",0x9e8),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_LEFT",GDK_SCROLL_LEFT),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_BUTTON",GTK_ICON_SIZE_BUTTON),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_APPLICATION",GTK_RECENT_FILTER_APPLICATION),
   MAKE_ICONSTANT((char*)"GTK_STYLE_CONTEXT_PRINT_RECURSE",GTK_STYLE_CONTEXT_PRINT_RECURSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_sha",0x1000577),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioStop",0x1008ff15),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button1",0xfee9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulPhieuf",0xeaf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lu",0xdc6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Ieung",0xee8),
   MAKE_ICONSTANT((char*)"GTK_STATE_ACTIVE",GTK_STATE_ACTIVE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1257",0x1002853),
   MAKE_ICONSTANT((char*)"G_FILE_CREATE_REPLACE_DESTINATION",G_FILE_CREATE_REPLACE_DESTINATION),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_DND",GTK_ICON_SIZE_DND),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_19_MASK",GDK_MODIFIER_RESERVED_19_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_p",0x070),
   MAKE_ICONSTANT((char*)"G_DATE_BAD_MONTH",G_DATE_BAD_MONTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Lock",0xfe01),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ini",0x100056b),
   MAKE_ICONSTANT((char*)"GDK_RIGHT_SIDE",GDK_RIGHT_SIDE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Jieuj",0xeb8),
   MAKE_ICONSTANT((char*)"GDK_KP_Tab",0xff89),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_lamda",0x7eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_har",0x10010f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_F2",0xff92),
   MAKE_ICONSTANT((char*)"GDK_KEY_OfficeHome",0x1008ff6a),
   MAKE_ICONSTANT((char*)"GDK_downshoe",0xbd6),
   MAKE_ICONSTANT((char*)"GDK_toprightsummation",0x8b5),
   MAKE_ICONSTANT((char*)"GTK_RESIZE_PARENT",GTK_RESIZE_PARENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_AE",0x0c6),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN",G_DBUS_ERROR_SELINUX_SECURITY_CONTEXT_UNKNOWN),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ORIYA",G_UNICODE_SCRIPT_ORIYA),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioRandomPlay",0x1008ff99),
   MAKE_ICONSTANT((char*)"GTK_POLICY_AUTOMATIC",GTK_POLICY_AUTOMATIC),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_i",0x6a6),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BRAILLE",G_UNICODE_SCRIPT_BRAILLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Execute",0xff62),
   MAKE_ICONSTANT((char*)"GDK_Right",0xff53),
   MAKE_ICONSTANT((char*)"GDK_GRAB_NOT_VIEWABLE",GDK_GRAB_NOT_VIEWABLE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_127",0x1002843),
   MAKE_ICONSTANT((char*)"GDK_Paste",0x1008ff6d),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MODI",G_UNICODE_SCRIPT_MODI),
   MAKE_ICONSTANT((char*)"GDK_asterisk",0x02a),
   MAKE_ICONSTANT((char*)"GDK_KP_Delete",0xff9f),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SOGDIAN",G_UNICODE_SCRIPT_SOGDIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_pe",0x6d0),
   MAKE_ICONSTANT((char*)"G_SIGNAL_DEPRECATED",G_SIGNAL_DEPRECATED),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_STRIKETHROUGH",PANGO_ATTR_STRIKETHROUGH),
   MAKE_ICONSTANT((char*)"GDK_KEY_odoubleacute",0x1f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Attn",0xfd0e),
   MAKE_ICONSTANT((char*)"GDK_KEY_obarred",0x1000275),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SHHA",0x10004ba),
   MAKE_ICONSTANT((char*)"GDK_greaterthanequal",0x8be),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_he",0xce4),
   MAKE_ICONSTANT((char*)"GDK_KEY_L9",0xffd0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Next",0xff56),
   MAKE_ICONSTANT((char*)"GDK_braille_blank",0x1002800),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_KA_descender",0x100049a),
   MAKE_ICONSTANT((char*)"GDK_ecaron",0x1ec),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_PENCIL",GDK_DEVICE_TOOL_TYPE_PENCIL),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_UINT16",G_VARIANT_CLASS_UINT16),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12468",0x10028ab),
   MAKE_ICONSTANT((char*)"G_IO_STREAM_SPLICE_WAIT_FOR_BOTH",G_IO_STREAM_SPLICE_WAIT_FOR_BOTH),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_lamed",0xcec),
   MAKE_ICONSTANT((char*)"GDK_dead_belowmacron",0xfe68),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13567",0x1002875),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1347",0x100284d),
   MAKE_ICONSTANT((char*)"GDK_grave",0x060),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_BROKEN_PIPE",G_IO_ERROR_BROKEN_PIPE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CAUCASIAN_ALBANIAN",G_UNICODE_SCRIPT_CAUCASIAN_ALBANIAN),
   MAKE_ICONSTANT((char*)"GTK_PRINT_ERROR_GENERAL",GTK_PRINT_ERROR_GENERAL),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ghat",0x1000572),
   MAKE_ICONSTANT((char*)"GTK_FONT_CHOOSER_LEVEL_SIZE",GTK_FONT_CHOOSER_LEVEL_SIZE),
   MAKE_ICONSTANT((char*)"GDK_upcaret",0xba9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_UNKNOWN",PANGO_SCRIPT_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Henkan",0xff23),
   MAKE_ICONSTANT((char*)"GDK_HINT_MIN_SIZE",GDK_HINT_MIN_SIZE),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_THIN",PANGO_WEIGHT_THIN),
   MAKE_ICONSTANT((char*)"GDK_Pause",0xff13),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_SHI",0x4bc),
   MAKE_ICONSTANT((char*)"GTK_DEST_DEFAULT_DROP",GTK_DEST_DEFAULT_DROP),
   MAKE_ICONSTANT((char*)"GDK_Katakana",0xff26),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_Y",GDK_AXIS_FLAG_Y),
   MAKE_ICONSTANT((char*)"GDK_KEY_Calendar",0x1008ff20),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflexhook",0x1001ea9),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FONT_FEATURES",PANGO_ATTR_FONT_FEATURES),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_ALL",G_NORMALIZE_ALL),
   MAKE_ICONSTANT((char*)"GDK_Word",0x1008ff89),
   MAKE_ICONSTANT((char*)"GDK_I",0x049),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_POPUP_MENU",GDK_WINDOW_TYPE_HINT_POPUP_MENU),
   MAKE_ICONSTANT((char*)"GDK_ISO_Next_Group",0xfe08),
   MAKE_ICONSTANT((char*)"GDK_ScrollClick",0x1008ff7a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cacute",0x1c6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ie",0x6c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ucircumflex",0x0db),
   MAKE_ICONSTANT((char*)"GDK_Thai_thonangmontho",0xdb1),
   MAKE_ICONSTANT((char*)"PANGO_SCALE",1024),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarae",0xde0),
   MAKE_ICONSTANT((char*)"GDK_DESTROY",GDK_DESTROY),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ELYMAIC",G_UNICODE_SCRIPT_ELYMAIC),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG",GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ccaron",0x1c8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2347",0x100284e),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_GROUP_NOT_FOUND",G_KEY_FILE_ERROR_GROUP_NOT_FOUND),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_CONTINGENT",G_UNICODE_BREAK_CONTINGENT),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_DESERET",PANGO_SCRIPT_DESERET),
   MAKE_ICONSTANT((char*)"GDK_eng",0x3bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abreve",0x1c3),
   MAKE_ICONSTANT((char*)"GDK_KEY_singlelowquotemark",0xafd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Dcaron",0x1cf),
   MAKE_ICONSTANT((char*)"GTK_PRINT_ERROR_NOMEM",GTK_PRINT_ERROR_NOMEM),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_SOUTH",GDK_GRAVITY_SOUTH),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_DISCONNECTED",G_DBUS_ERROR_DISCONNECTED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_ITALIC",G_UNICODE_SCRIPT_OLD_ITALIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_voiced_sound",0xfe5e),
   MAKE_ICONSTANT((char*)"GDK_ISO_Partial_Space_Right",0xfe26),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_UNDER_DOWN",GTK_STACK_TRANSITION_TYPE_UNDER_DOWN),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1238",0x1002887),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_NO_MEMORY",G_DBUS_ERROR_SPAWN_NO_MEMORY),
   MAKE_ICONSTANT((char*)"GDK_KP_Add",0xffab),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalmem",0xced),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_YI",0x6b7),
   MAKE_ICONSTANT((char*)"GDK_X_CURSOR",GDK_X_CURSOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zacute",0x1ac),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_BAD_ADDRESS",G_DBUS_ERROR_BAD_ADDRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maihanakat",0xdd1),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_OBJECT_PATH_IN_USE",G_DBUS_ERROR_OBJECT_PATH_IN_USE),
   MAKE_ICONSTANT((char*)"GDK_ISO_Group_Latch",0xfe06),
   MAKE_ICONSTANT((char*)"G_DBUS_SERVER_FLAGS_AUTHENTICATION_ALLOW_ANONYMOUS",G_DBUS_SERVER_FLAGS_AUTHENTICATION_ALLOW_ANONYMOUS),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Home",0xff95),
   MAKE_ICONSTANT((char*)"GDK_ISO_First_Group",0xfe0c),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightmiddlesummation",0x8b7),
   MAKE_ICONSTANT((char*)"GDK_horizlinescan5",0x9f1),
   MAKE_ICONSTANT((char*)"GDK_Sinh_oo",0x1000d95),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflexgrave",0x1001ed3),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TAGBANWA",PANGO_SCRIPT_TAGBANWA),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Continuous_Underline",0xfe30),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_7",0x1000667),
   MAKE_ICONSTANT((char*)"GDK_KEY_Emacron",0x3aa),
   MAKE_ICONSTANT((char*)"GDK_ETH",0x0d0),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_HOST_NOT_FOUND",G_IO_ERROR_HOST_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2478",0x10028ca),
   MAKE_ICONSTANT((char*)"GDK_scircumflex",0x2fe),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_at",0x1000568),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Khieuq",0xebb),
   MAKE_ICONSTANT((char*)"GDK_Farsi_9",0x10006f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Game",0x1008ff5e),
   MAKE_ICONSTANT((char*)"GDK_Armenian_apostrophe",0x100055a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uring",0x1d9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_WARANG_CITI",PANGO_SCRIPT_WARANG_CITI),
   MAKE_ICONSTANT((char*)"GDK_MODE_SCREEN",GDK_MODE_SCREEN),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_CLOSE_PARANTHESIS",G_UNICODE_BREAK_CLOSE_PARANTHESIS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Blue",0x1008ffa6),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizlinescan3",0x9f0),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_BN",PANGO_BIDI_TYPE_BN),
   MAKE_ICONSTANT((char*)"GDK_Sinh_na",0x1000db1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13456",0x100283d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_147",0x1002849),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT",GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_amacron",0x3e0),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_INVAL",G_IO_CHANNEL_ERROR_INVAL),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_PICTURES",G_USER_DIRECTORY_PICTURES),
   MAKE_ICONSTANT((char*)"GDK_ContrastAdjust",0x1008ff22),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_MULTIHEAD",GTK_DEBUG_MULTIHEAD),
   MAKE_ICONSTANT((char*)"GDK_F2",0xffbf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_U_macron",0x10004ee),
   MAKE_ICONSTANT((char*)"GDK_kana_TU",0x4c2),
   MAKE_ICONSTANT((char*)"GDK_Georgian_ghan",0x10010e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflex",0x0ea),
   MAKE_ICONSTANT((char*)"GDK_KEY_Gbreve",0x2ab),
   MAKE_ICONSTANT((char*)"GDK_Arabic_gaf",0x10006af),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalnun",0xcef),
   MAKE_ICONSTANT((char*)"GDK_Battery",0x1008ff93),
   MAKE_ICONSTANT((char*)"GDK_SlowKeys_Enable",0xfe73),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Jamo",0xff35),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_HA",0x6e8),
   MAKE_ICONSTANT((char*)"GDK_KEY_LogGrabInfo",0x1008fe25),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_GHE_WITH_UPTURN",0x6bd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_34",0x100280c),
   MAKE_ICONSTANT((char*)"GDK_KEY_F30",0xffdb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_pa",0x1000db4),
   MAKE_ICONSTANT((char*)"GDK_sixsubscript",0x1002086),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_5",0x1000665),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_EMPTY",GTK_IMAGE_EMPTY),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_HINT_STRONG",PANGO_GRAVITY_HINT_STRONG),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_BOTH_HORIZ",GTK_TOOLBAR_BOTH_HORIZ),
   MAKE_ICONSTANT((char*)"GDK_3270_Quit",0xfd09),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_u",0x6d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_RE",0x4da),
   MAKE_ICONSTANT((char*)"GDK_Armenian_tso",0x1000581),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2345678",0x10028fe),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamzaunderalef",0x5c5),
   MAKE_ICONSTANT((char*)"GDK_lowleftcorner",0x9ed),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HATRAN",PANGO_SCRIPT_HATRAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_167",0x1002861),
   MAKE_ICONSTANT((char*)"G_UNICODE_UPPERCASE_LETTER",G_UNICODE_UPPERCASE_LETTER),
   MAKE_ICONSTANT((char*)"GDK_F31",0xffdc),
   MAKE_ICONSTANT((char*)"GDK_KEY_brokenbar",0x0a6),
   MAKE_ICONSTANT((char*)"GDK_Thai_topatak",0xdaf),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_TCRYPT",G_ASK_PASSWORD_TCRYPT),
   MAKE_ICONSTANT((char*)"GDK_Control_L",0xffe3),
   MAKE_ICONSTANT((char*)"GDK_LR_ANGLE",GDK_LR_ANGLE),
   MAKE_ICONSTANT((char*)"GTK_JUSTIFY_CENTER",GTK_JUSTIFY_CENTER),
   MAKE_ICONSTANT((char*)"GDK_Armenian_SHA",0x1000547),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_ACCESS_DENIED",G_DBUS_ERROR_ACCESS_DENIED),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_MODULES",GTK_DEBUG_MODULES),
   MAKE_ICONSTANT((char*)"GDK_Ohorngrave",0x1001edc),
   MAKE_ICONSTANT((char*)"GDK_LEFT_SIDE",GDK_LEFT_SIDE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SsangKiyeog",0xea2),
   MAKE_ICONSTANT((char*)"GTK_STYLE_CONTEXT_PRINT_NONE",GTK_STYLE_CONTEXT_PRINT_NONE),
   MAKE_ICONSTANT((char*)"GDK_AudioStop",0x1008ff15),
   MAKE_ICONSTANT((char*)"GTK_MENU_DIR_PREV",GTK_MENU_DIR_PREV),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_HELP",GTK_RESPONSE_HELP),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_OWNER_FLAGS_DO_NOT_QUEUE",G_BUS_NAME_OWNER_FLAGS_DO_NOT_QUEUE),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_FILE_INVALID",G_DBUS_ERROR_SPAWN_FILE_INVALID),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_NUMERIC",G_UNICODE_BREAK_NUMERIC),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ee",0x1000d92),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_a",0x6c1),
   MAKE_ICONSTANT((char*)"GDK_SB_H_DOUBLE_ARROW",GDK_SB_H_DOUBLE_ARROW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_u",0x1000d8b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_14",0x1002809),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_NEWLINE_TYPE_ANY",G_DATA_STREAM_NEWLINE_TYPE_ANY),
   MAKE_ICONSTANT((char*)"GDK_Pointer_UpRight",0xfee5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_kje",0x6ac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sys_Req",0xff15),
   MAKE_ICONSTANT((char*)"GDK_3270_DeleteWord",0xfd1a),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_BOTTOM_RESIZABLE",GDK_WINDOW_STATE_BOTTOM_RESIZABLE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_48",0x1002888),
   MAKE_ICONSTANT((char*)"GDK_KEY_FrameBack",0x1008ff9d),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_OPTIMIZE",G_REGEX_ERROR_OPTIMIZE),
   MAKE_ICONSTANT((char*)"GDK_SingleCandidate",0xff3c),
   MAKE_ICONSTANT((char*)"GDK_KEY_UserPB",0x1008ff84),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_SENDER",G_DBUS_MESSAGE_HEADER_FIELD_SENDER),
   MAKE_ICONSTANT((char*)"GDK_dead_abovedot",0xfe56),
   MAKE_ICONSTANT((char*)"GTK_APPLICATION_INHIBIT_LOGOUT",GTK_APPLICATION_INHIBIT_LOGOUT),
   MAKE_ICONSTANT((char*)"GDK_AudioPause",0x1008ff31),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_pha",0x1000db5),
   MAKE_ICONSTANT((char*)"GDK_KEY_filledrectbullet",0xadb),
   MAKE_ICONSTANT((char*)"GDK_Mae_Koho",0xff3e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Mae_Koho",0xff3e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_cha",0x1000da1),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_IS_WRITEABLE",G_IO_FLAG_IS_WRITEABLE),
   MAKE_ICONSTANT((char*)"G_TLS_DATABASE_LOOKUP_KEYPAIR",G_TLS_DATABASE_LOOKUP_KEYPAIR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Open",0x1008ff6b),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YAE",0xec2),
   MAKE_ICONSTANT((char*)"GDK_KEY_oslash",0x0f8),
   MAKE_ICONSTANT((char*)"G_TIME_TYPE_UNIVERSAL",G_TIME_TYPE_UNIVERSAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Subtract",0xffad),
   MAKE_ICONSTANT((char*)"GDK_dead_I",0xfe85),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_SUBPATTERN_NAME_TOO_LONG",G_REGEX_ERROR_SUBPATTERN_NAME_TOO_LONG),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_STEP_DOWN",GTK_SCROLL_STEP_DOWN),
   MAKE_ICONSTANT((char*)"GDK_AudioMicMute",0x1008ffb2),
   MAKE_ICONSTANT((char*)"GDK_hebrew_nun",0xcf0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_u_macron",0x10004ef),
   MAKE_ICONSTANT((char*)"GDK_kana_i",0x4a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2348",0x100288e),
   MAKE_ICONSTANT((char*)"GDK_Arabic_sad",0x5d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Udiaeresis",0x0dc),
   MAKE_ICONSTANT((char*)"GDK_approxeq",0x1002248),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_se",0x100057d),
   MAKE_ICONSTANT((char*)"GTK_WIDGET_HELP_WHATS_THIS",GTK_WIDGET_HELP_WHATS_THIS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_24",0x100280a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_2",0x1008fe02),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_zeta",0x7e6),
   MAKE_ICONSTANT((char*)"GDK_filledtribulletdown",0xae9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hibernate",0x1008ffa8),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_DUPLICATE_ID",GTK_BUILDER_ERROR_DUPLICATE_ID),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Sios",0xee6),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDOUT_PIPE",G_SUBPROCESS_FLAGS_STDOUT_PIPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_AccessX_Enable",0xfe70),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowcomma",0xfe6e),
   MAKE_ICONSTANT((char*)"GDK_Greek_mu",0x7ec),
   MAKE_ICONSTANT((char*)"GDK_ARROW",GDK_ARROW),
   MAKE_ICONSTANT((char*)"GDK_Sinh_dda",0x1000da9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch7",0x1008ff47),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_WIN32_DROPFILES",GDK_DRAG_PROTO_WIN32_DROPFILES),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_FOREIGN",GDK_WINDOW_FOREIGN),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_WHEEL",GDK_AXIS_FLAG_WHEEL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_beta",0x7e2),
   MAKE_ICONSTANT((char*)"GTK_MENU_DIR_NEXT",GTK_MENU_DIR_NEXT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulMieum",0xedd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_IE",0x6b4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_feh",0x5e1),
   MAKE_ICONSTANT((char*)"GDK_Arabic_jeh",0x1000698),
   MAKE_ICONSTANT((char*)"GDK_MouseKeys_Accel_Enable",0xfe77),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_TOUCHSCREEN",GTK_DEBUG_TOUCHSCREEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_omacron",0x3f2),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_SPECIAL",G_FILE_TYPE_SPECIAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maiek",0xde8),
   MAKE_ICONSTANT((char*)"GDK_KEY_g",0x067),
   MAKE_ICONSTANT((char*)"GDK_KEY_careof",0xab8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ScrollUp",0x1008ff78),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_357",0x1002854),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PAU_CIN_HAU",PANGO_SCRIPT_PAU_CIN_HAU),
   MAKE_ICONSTANT((char*)"GDK_KEY_Refresh",0x1008ff29),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ARABIC",G_UNICODE_SCRIPT_ARABIC),
   MAKE_ICONSTANT((char*)"GDK_Arabic_lam",0x5e4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_68",0x10028a0),
   MAKE_ICONSTANT((char*)"GDK_Uhorn",0x10001af),
   MAKE_ICONSTANT((char*)"GDK_F7",0xffc4),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_POSIX_COLLATING_ELEMENTS_NOT_SUPPORTED",G_REGEX_ERROR_POSIX_COLLATING_ELEMENTS_NOT_SUPPORTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_AraeA",0xef6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ai",0x1000d93),
   MAKE_ICONSTANT((char*)"GDK_L9",0xffd0),
   MAKE_ICONSTANT((char*)"G_SOCKET_MSG_NONE",G_SOCKET_MSG_NONE),
   MAKE_ICONSTANT((char*)"GDK_downtack",0xbc2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_pa",0x1000db4),
   MAKE_ICONSTANT((char*)"G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START",G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_omicron",0x7ef),
   MAKE_ICONSTANT((char*)"GDK_kana_KO",0x4ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abrevehook",0x1001eb2),
   MAKE_ICONSTANT((char*)"GDK_Umacron",0x3de),
   MAKE_ICONSTANT((char*)"GDK_notelementof",0x1002209),
   MAKE_ICONSTANT((char*)"GDK_Greek_iotaaccentdieresis",0x7b6),
   MAKE_ICONSTANT((char*)"GDK_KEY_7",0x037),
   MAKE_ICONSTANT((char*)"GDK_KEY_trademark",0xac9),
   MAKE_ICONSTANT((char*)"GDK_decimalpoint",0xabd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ZHE",0x100053a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_U",0xecc),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Release_Both_Margins",0xfe2b),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_SWIPE",GDK_TOUCHPAD_SWIPE),
   MAKE_ICONSTANT((char*)"GDK_PesetaSign",0x10020a7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_NABATAEAN",PANGO_SCRIPT_NABATAEAN),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_10",0xfffa),
   MAKE_ICONSTANT((char*)"GDK_Armenian_ke",0x1000584),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_u_straight_bar",0x10004b1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_168",0x10028a1),
   MAKE_ICONSTANT((char*)"GDK_WATCH",GDK_WATCH),
   MAKE_ICONSTANT((char*)"GDK_Farsi_yeh",0x10006cc),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_WATCH_MOVES",G_FILE_MONITOR_WATCH_MOVES),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3478",0x10028cc),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_RESULT_ERROR",GTK_PRINT_OPERATION_RESULT_ERROR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_378",0x10028c4),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflexhook",0x1001ed4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_AVESTAN",G_UNICODE_SCRIPT_AVESTAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_d",0x064),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TAGBANWA",G_UNICODE_SCRIPT_TAGBANWA),
   MAKE_ICONSTANT((char*)"GDK_Select",0xff60),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TE",0x4c3),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_er",0x6d2),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ze",0x6da),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Last_Group",0xfe0e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ibelowdot",0x1001eca),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_noon_ghunna",0x10006ba),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SsangJieuj",0xeb9),
   MAKE_ICONSTANT((char*)"GDK_BUTTON4_MASK",GDK_BUTTON4_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_PHI",0x7d6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_234678",0x10028ee),
   MAKE_ICONSTANT((char*)"G_MOUNT_OPERATION_HANDLED",G_MOUNT_OPERATION_HANDLED),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_INVALID_SIGNATURE",G_DBUS_ERROR_INVALID_SIGNATURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflexacute",0x1001ed1),
   MAKE_ICONSTANT((char*)"GDK_Odoubleacute",0x1d5),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_gje",0x6a2),
   MAKE_ICONSTANT((char*)"GDK_trademark",0xac9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Codeinput",0xff37),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_semicolon",0x5bb),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BALINESE",PANGO_SCRIPT_BALINESE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_PSI",0x7d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_NJE",0x6ba),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_ROTATION",GDK_AXIS_FLAG_ROTATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Last_Virtual_Screen",0xfed4),
   MAKE_ICONSTANT((char*)"GDK_Abrevetilde",0x1001eb4),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_7",0xffb7),
   MAKE_ICONSTANT((char*)"GDK_LOCK_MASK",GDK_LOCK_MASK),
   MAKE_ICONSTANT((char*)"GDK_kana_U",0x4b3),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_SOUTH_EAST",GDK_WINDOW_EDGE_SOUTH_EAST),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PROXY_AUTH_FAILED",G_IO_ERROR_PROXY_AUTH_FAILED),
   MAKE_ICONSTANT((char*)"GDK_Greek_alpha",0x7e1),
   MAKE_ICONSTANT((char*)"GDK_Armenian_hi",0x1000575),
   MAKE_ICONSTANT((char*)"GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS",GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS),
   MAKE_ICONSTANT((char*)"G_ASCII_DTOSTR_BUF_SIZE",39),
   MAKE_ICONSTANT((char*)"GDK_ISO_Prev_Group",0xfe0a),
   MAKE_ICONSTANT((char*)"GTK_TEXT_SEARCH_CASE_INSENSITIVE",GTK_TEXT_SEARCH_CASE_INSENSITIVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_threeeighths",0xac4),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_SELECTOR",GTK_CSS_SECTION_SELECTOR),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GREEK",PANGO_SCRIPT_GREEK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflexhook",0x1001ec2),
   MAKE_ICONSTANT((char*)"GDK_horizlinescan9",0x9f3),
   MAKE_ICONSTANT((char*)"GDK_periodcentered",0x0b7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LEPCHA",PANGO_SCRIPT_LEPCHA),
   MAKE_ICONSTANT((char*)"GDK_AXIS_WHEEL",GDK_AXIS_WHEEL),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_CONTENT",GTK_ASSISTANT_PAGE_CONTENT),
   MAKE_ICONSTANT((char*)"GDK_FILTER_CONTINUE",GDK_FILTER_CONTINUE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_15",0x1002811),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ma",0x1000db8),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_dalet",0xce3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamza",0x5c1),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12568",0x10028b3),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_RUNIC",G_UNICODE_SCRIPT_RUNIC),
   MAKE_ICONSTANT((char*)"PANGO_RENDER_PART_FOREGROUND",PANGO_RENDER_PART_FOREGROUND),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_124678",0x10028eb),
   MAKE_ICONSTANT((char*)"GDK_VoidSymbol",0xffffff),
   MAKE_ICONSTANT((char*)"GDK_KEY_F8",0xffc5),
   MAKE_ICONSTANT((char*)"GDK_Zabovedot",0x1af),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_ERROR_NAME",G_DBUS_MESSAGE_HEADER_FIELD_ERROR_NAME),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Right",0xfee1),
   MAKE_ICONSTANT((char*)"PANGO_VARIANT_NORMAL",PANGO_VARIANT_NORMAL),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_INDEX_FROM_TEXT_BEGINNING",0),
   MAKE_ICONSTANT((char*)"GTK_TARGET_OTHER_APP",GTK_TARGET_OTHER_APP),
   MAKE_ICONSTANT((char*)"GDK_KEY_R15",0xffe0),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ya",0x6d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_vertbar",0x9f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Next_Group_Lock",0xfe09),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_seen",0x5d3),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ORIYA",PANGO_SCRIPT_ORIYA),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_NO_SVG",GTK_ICON_LOOKUP_NO_SVG),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_COMBO",GDK_WINDOW_TYPE_HINT_COMBO),
   MAKE_ICONSTANT((char*)"G_NOTIFICATION_PRIORITY_HIGH",G_NOTIFICATION_PRIORITY_HIGH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Community",0x1008ff3d),
   MAKE_ICONSTANT((char*)"GDK_cr",0x9e4),
   MAKE_ICONSTANT((char*)"GDK_Armenian_nu",0x1000576),
   MAKE_ICONSTANT((char*)"GDK_kana_RE",0x4da),
   MAKE_ICONSTANT((char*)"G_PRIORITY_HIGH_IDLE",100),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_TXTBSY",G_FILE_ERROR_TXTBSY),
   MAKE_ICONSTANT((char*)"GDK_KEY_telephone",0xaf9),
   MAKE_ICONSTANT((char*)"GDK_notapproxeq",0x1002247),
   MAKE_ICONSTANT((char*)"GDK_KEY_ch",0xfea0),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_GRAVITY",PANGO_FONT_MASK_GRAVITY),
   MAKE_ICONSTANT((char*)"GDK_less",0x03c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_EU",0xed1),
   MAKE_ICONSTANT((char*)"GDK_KEY_periodcentered",0x0b7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_popla",0xdbb),
   MAKE_ICONSTANT((char*)"GDK_KEY_zabovedot",0x1bf),
   MAKE_ICONSTANT((char*)"GDK_Georgian_un",0x10010e3),
   MAKE_ICONSTANT((char*)"GDK_Sinh_au2",0x1000dde),
   MAKE_ICONSTANT((char*)"GDK_itilde",0x3b5),
   MAKE_ICONSTANT((char*)"GDK_SIZING",GDK_SIZING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Down",0xff54),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_CUSTOM",GTK_LICENSE_CUSTOM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag2",0xfef6),
   MAKE_ICONSTANT((char*)"GTK_TEXT_EXTEND_SELECTION_LINE",GTK_TEXT_EXTEND_SELECTION_LINE),
   MAKE_ICONSTANT((char*)"GDK_KEY_onethird",0xab0),
   MAKE_ICONSTANT((char*)"GDK_MonBrightnessDown",0x1008ff03),
   MAKE_ICONSTANT((char*)"GDK_KEY_idotless",0x2b9),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NOMEM",G_FILE_ERROR_NOMEM),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YO",0xecb),
   MAKE_ICONSTANT((char*)"GDK_KEY_figdash",0xabb),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Rieul",0xea9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_YECH",0x1000535),
   MAKE_ICONSTANT((char*)"GDK_ordfeminine",0x0aa),
   MAKE_ICONSTANT((char*)"GDK_6",0x036),
   MAKE_ICONSTANT((char*)"GDK_KEY_ibreve",0x100012d),
   MAKE_ICONSTANT((char*)"GDK_AudioRepeat",0x1008ff98),
   MAKE_ICONSTANT((char*)"GDK_Ibelowdot",0x1001eca),
   MAKE_ICONSTANT((char*)"GDK_BOX_SPIRAL",GDK_BOX_SPIRAL),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_KiyeogSios",0xed6),
   MAKE_ICONSTANT((char*)"GDK_KEY_rcaron",0x1f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13478",0x10028cd),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SIGNWRITING",PANGO_SCRIPT_SIGNWRITING),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_RO",0x4db),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_UNKNOWN",GTK_LICENSE_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightarrow",0x8fd),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_AUTH_FAILED",G_DBUS_ERROR_AUTH_FAILED),
   MAKE_ICONSTANT((char*)"GDK_EVENT_LAST",GDK_EVENT_LAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulPhieuf",0xee1),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarae",0xde0),
   MAKE_ICONSTANT((char*)"GDK_KEY_iogonek",0x3e7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_34678",0x10028ec),
   MAKE_ICONSTANT((char*)"GDK_Hangul_O",0xec7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_KA",0x4b6),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarao",0xde2),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_NO_MEMORY",G_DBUS_ERROR_NO_MEMORY),
   MAKE_ICONSTANT((char*)"GDK_onesubscript",0x1002081),
   MAKE_ICONSTANT((char*)"GDK_PRIORITY_REDRAW",120),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_MOUSE",GDK_DEVICE_TOOL_TYPE_MOUSE),
   MAKE_ICONSTANT((char*)"GDK_TouchpadOn",0x1008ffb0),
   MAKE_ICONSTANT((char*)"GDK_ydiaeresis",0x0ff),
   MAKE_ICONSTANT((char*)"GDK_KEY_EcuSign",0x10020a0),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_AFTER",G_UNICODE_BREAK_AFTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamzaonwaw",0x5c4),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_REVERSE",GTK_PRINT_CAPABILITY_REVERSE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3567",0x1002874),
   MAKE_ICONSTANT((char*)"GDK_Time",0x1008ff9f),
   MAKE_ICONSTANT((char*)"G_SOCKET_FAMILY_UNIX",G_SOCKET_FAMILY_UNIX),
   MAKE_ICONSTANT((char*)"G_RESOLVER_RECORD_SRV",G_RESOLVER_RECORD_SRV),
   MAKE_ICONSTANT((char*)"GDK_WA_Y",GDK_WA_Y),
   MAKE_ICONSTANT((char*)"GDK_onefifth",0xab2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_368",0x10028a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_fullstop",0x10006d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_RieulHieuh",0xee2),
   MAKE_ICONSTANT((char*)"GDK_1",0x031),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_alpha",0x7e1),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT",GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_WheelButton",0x1008ff88),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_3",0xfff3),
   MAKE_ICONSTANT((char*)"GDK_Tab",0xff09),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNTERMINATED_COMMENT",G_REGEX_ERROR_UNTERMINATED_COMMENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_meem",0x5e5),
   MAKE_ICONSTANT((char*)"GDK_obelowdot",0x1001ecd),
   MAKE_ICONSTANT((char*)"GDK_KEY_cuberoot",0x100221b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3",0x1002804),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_NORTH",PANGO_GRAVITY_NORTH),
   MAKE_ICONSTANT((char*)"GDK_AXIS_PRESSURE",GDK_AXIS_PRESSURE),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_8",0xfff8),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulHieuh",0xeb0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_258",0x1002892),
   MAKE_ICONSTANT((char*)"GTK_WIN_POS_CENTER_ALWAYS",GTK_WIN_POS_CENTER_ALWAYS),
   MAKE_ICONSTANT((char*)"GDK_phonographcopyright",0xafb),
   MAKE_ICONSTANT((char*)"GDK_Sinh_lla",0x1000dc5),
   MAKE_ICONSTANT((char*)"GDK_BOTTOM_RIGHT_CORNER",GDK_BOTTOM_RIGHT_CORNER),
   MAKE_ICONSTANT((char*)"GDK_KEY_C",0x043),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_FORCE_SIZE",GTK_ICON_LOOKUP_FORCE_SIZE),
   MAKE_ICONSTANT((char*)"GDK_KEY_bracketright",0x05d),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1368",0x10028a5),
   MAKE_ICONSTANT((char*)"GDK_Greek_upsilonaccentdieresis",0x7ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_tan",0x10010d7),
   MAKE_ICONSTANT((char*)"GDK_dead_belowring",0xfe67),
   MAKE_ICONSTANT((char*)"G_DATE_NOVEMBER",G_DATE_NOVEMBER),
   MAKE_ICONSTANT((char*)"GDK_Arabic_damma",0x5ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sorusi",0xdc9),
   MAKE_ICONSTANT((char*)"GDK_HINT_WIN_GRAVITY",GDK_HINT_WIN_GRAVITY),
   MAKE_ICONSTANT((char*)"GDK_KEY_space",0x020),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_6",0x1008fe06),
   MAKE_ICONSTANT((char*)"GDK_lbelowdot",0x1001e37),
   MAKE_ICONSTANT((char*)"GDK_kana_RU",0x4d9),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_OPEN_PUNCTUATION",G_UNICODE_BREAK_OPEN_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Find",0xff68),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_NONE",GTK_EVENT_CONTROLLER_SCROLL_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13468",0x10028ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_R14",0xffdf),
   MAKE_ICONSTANT((char*)"GDK_Armenian_pyur",0x1000583),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_DICT_ENTRY",G_VARIANT_CLASS_DICT_ENTRY),
   MAKE_ICONSTANT((char*)"GDK_ntilde",0x0f1),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_UNKNOWN_PROPERTY",G_DBUS_ERROR_UNKNOWN_PROPERTY),
   MAKE_ICONSTANT((char*)"G_RESOLVER_RECORD_TXT",G_RESOLVER_RECORD_TXT),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_ExSelect",0xfd1b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_gim",0x1000563),
   MAKE_ICONSTANT((char*)"GDK_KEY_CruzeiroSign",0x10020a2),
   MAKE_ICONSTANT((char*)"GDK_Greek_UPSILON",0x7d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Escape",0xff1b),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_zadi",0xcf6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_147",0x1002849),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_rorua",0xdc3),
   MAKE_ICONSTANT((char*)"GDK_KEY_seveneighths",0xac6),
   MAKE_ICONSTANT((char*)"GDK_KEY_TouchpadOn",0x1008ffb0),
   MAKE_ICONSTANT((char*)"G_ASK_PASSWORD_NEED_DOMAIN",G_ASK_PASSWORD_NEED_DOMAIN),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_OUTSET",GTK_BORDER_STYLE_OUTSET),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_PAINT",GDK_FRAME_CLOCK_PHASE_PAINT),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_CHANGED",G_FILE_MONITOR_EVENT_CHANGED),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CUNEIFORM",G_UNICODE_SCRIPT_CUNEIFORM),
   MAKE_ICONSTANT((char*)"GDK_BUTTON_PRESS",GDK_BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Gcedilla",0x3ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizconnector",0x8a3),
   MAKE_ICONSTANT((char*)"GDK_KP_Down",0xff99),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_457",0x1002858),
   MAKE_ICONSTANT((char*)"GDK_Emacron",0x3aa),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_DROP_BEFORE",GTK_TREE_VIEW_DROP_BEFORE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_24578",0x10028da),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_NONE",GTK_INPUT_HINT_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23458",0x100289e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_par",0x10010de),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SAURASHTRA",PANGO_SCRIPT_SAURASHTRA),
   MAKE_ICONSTANT((char*)"GDK_KEY_toprightsqbracket",0x8a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Kiyeog",0xea1),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_YO",0x4d6),
   MAKE_ICONSTANT((char*)"GTK_FONT_CHOOSER_LEVEL_FEATURES",GTK_FONT_CHOOSER_LEVEL_FEATURES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_finalsmallsigma",0x7f3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_er",0x6d2),
   MAKE_ICONSTANT((char*)"GDK_SETTING_ACTION_DELETED",GDK_SETTING_ACTION_DELETED),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowdot",0xfe60),
   MAKE_ICONSTANT((char*)"GDK_threesuperior",0x0b3),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_teth",0xce8),
   MAKE_ICONSTANT((char*)"GDK_DECOR_ALL",GDK_DECOR_ALL),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Partial_Space_Right",0xfe26),
   MAKE_ICONSTANT((char*)"GDK_Acircumflexacute",0x1001ea4),
   MAKE_ICONSTANT((char*)"GDK_L1",0xffc8),
   MAKE_ICONSTANT((char*)"GDK_F5",0xffc2),
   MAKE_ICONSTANT((char*)"GDK_KEY_filledtribulletup",0xae8),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_FAILED_HANDLED",G_IO_ERROR_FAILED_HANDLED),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhornhook",0x1001eed),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_LAMDA",0x7cb),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_INVALID",GTK_ICON_SIZE_INVALID),
   MAKE_ICONSTANT((char*)"G_NETWORK_CONNECTIVITY_FULL",G_NETWORK_CONNECTIVITY_FULL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ra",0x100057c),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KHUDAWADI",G_UNICODE_SCRIPT_KHUDAWADI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_PI",0x7d0),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_NO_TARGET",GTK_DRAG_RESULT_NO_TARGET),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_1",0x1008fe01),
   MAKE_ICONSTANT((char*)"GDK_Gbreve",0x2ab),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_BYTE_ORDER_BIG_ENDIAN",G_DBUS_MESSAGE_BYTE_ORDER_BIG_ENDIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_capital_schwa",0xfe8b),
   MAKE_ICONSTANT((char*)"GDK_AXIS_Y",GDK_AXIS_Y),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_GET_NO_CHANGES",G_SETTINGS_BIND_GET_NO_CHANGES),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NEWLINE_ANY",G_REGEX_MATCH_NEWLINE_ANY),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12368",0x10028a7),
   MAKE_ICONSTANT((char*)"GDK_Thai_maiyamok",0xde6),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_BOTTOM_TO_TOP",GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_BOTTOM_TO_TOP),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_SO",0x4bf),
   MAKE_ICONSTANT((char*)"G_MOUNT_MOUNT_NONE",G_MOUNT_MOUNT_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12367",0x1002867),
   MAKE_ICONSTANT((char*)"G_SOCKET_LISTENER_LISTENING",G_SOCKET_LISTENER_LISTENING),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_235",0x1002816),
   MAKE_ICONSTANT((char*)"GDK_WindowClear",0x1008ff55),
   MAKE_ICONSTANT((char*)"GDK_Market",0x1008ff62),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_267",0x1002862),
   MAKE_ICONSTANT((char*)"GDK_Ograve",0x0d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch0",0x1008ff40),
   MAKE_ICONSTANT((char*)"G_SOCKET_TYPE_SEQPACKET",G_SOCKET_TYPE_SEQPACKET),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_keheh",0x10006a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_ihook",0x1001ec9),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ETHIOPIC",G_UNICODE_SCRIPT_ETHIOPIC),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_HEADER_FIELD_NUM_UNIX_FDS",G_DBUS_MESSAGE_HEADER_FIELD_NUM_UNIX_FDS),
   MAKE_ICONSTANT((char*)"GDK_Thai_sarauee",0xdd7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_shesht",0x100055b),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LISU",G_UNICODE_SCRIPT_LISU),
   MAKE_ICONSTANT((char*)"G_CONVERTER_NO_FLAGS",G_CONVERTER_NO_FLAGS),
   MAKE_ICONSTANT((char*)"GDK_Thai_khokhai",0xda2),
   MAKE_ICONSTANT((char*)"GDK_KEY_dintegral",0x100222c),
   MAKE_ICONSTANT((char*)"G_PARAM_READABLE",G_PARAM_READABLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_lu2",0x1000ddf),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED",G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED),
   MAKE_ICONSTANT((char*)"GDK_Georgian_jhan",0x10010ef),
   MAKE_ICONSTANT((char*)"GDK_Launch2",0x1008ff42),
   MAKE_ICONSTANT((char*)"GDK_Uacute",0x0da),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thanthakhat",0xdec),
   MAKE_ICONSTANT((char*)"GDK_includedin",0x8da),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zen_Koho",0xff3d),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_NOT_TLS",G_TLS_ERROR_NOT_TLS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SHCHA",0x6fd),
   MAKE_ICONSTANT((char*)"GDK_Greek_horizbar",0x7af),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_EF",0x6e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_qaf",0x5e2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_uu",0x1000d8c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_EPSILONaccent",0x7a2),
   MAKE_ICONSTANT((char*)"GTK_CALENDAR_SHOW_HEADING",GTK_CALENDAR_SHOW_HEADING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Xabovedot",0x1001e8a),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_doubleacute",0xfe59),
   MAKE_ICONSTANT((char*)"GDK_hebrew_het",0xce7),
   MAKE_ICONSTANT((char*)"G_PARAM_READWRITE",G_PARAM_READWRITE),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_EXPIRED",G_TLS_CERTIFICATE_EXPIRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_kasratan",0x5ed),
   MAKE_ICONSTANT((char*)"GTK_JUSTIFY_RIGHT",GTK_JUSTIFY_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_LYUN",0x100053c),
   MAKE_ICONSTANT((char*)"GDK_nacute",0x1f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_backslash",0x05c),
   MAKE_ICONSTANT((char*)"GDK_KEY_enopensquarebullet",0xae1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_TSE",0x6e3),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PAHAWH_HMONG",PANGO_SCRIPT_PAHAWH_HMONG),
   MAKE_ICONSTANT((char*)"GDK_Lacute",0x1c5),
   MAKE_ICONSTANT((char*)"GDK_uhook",0x1001ee7),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_YTILT",GDK_AXIS_FLAG_YTILT),
   MAKE_ICONSTANT((char*)"GDK_dead_perispomeni",0xfe53),
   MAKE_ICONSTANT((char*)"GDK_greater",0x03e),
   MAKE_ICONSTANT((char*)"GDK_Jcircumflex",0x2ac),
   MAKE_ICONSTANT((char*)"GDK_Ohornhook",0x1001ede),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1258",0x1002893),
   MAKE_ICONSTANT((char*)"GDK_KEY_ntilde",0x0f1),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_34568",0x10028bc),
   MAKE_ICONSTANT((char*)"GDK_i",0x069),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag2",0xfef6),
   MAKE_ICONSTANT((char*)"GDK_KEY_SelectButton",0x1008ffa0),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_EXTRA_EXPANDED",PANGO_STRETCH_EXTRA_EXPANDED),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level5_Shift",0xfe11),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_INSTANTIATABLE",G_TYPE_FLAG_INSTANTIATABLE),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_UPDATE",GDK_FRAME_CLOCK_PHASE_UPDATE),
   MAKE_ICONSTANT((char*)"GDK_Gcedilla",0x3ab),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_RLE",PANGO_BIDI_TYPE_RLE),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT",G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT),
   MAKE_ICONSTANT((char*)"GTK_SPIN_END",GTK_SPIN_END),
   MAKE_ICONSTANT((char*)"GDK_KEY_MultipleCandidate",0xff3d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23578",0x10028d6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_mu",0x7ec),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_BYTE_ORDER_HOST_ENDIAN",G_DATA_STREAM_BYTE_ORDER_HOST_ENDIAN),
   MAKE_ICONSTANT((char*)"GDK_ff",0x9e3),
   MAKE_ICONSTANT((char*)"GDK_Armenian_BEN",0x1000532),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hah",0x5cd),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12",0x1002803),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_VIRTUAL",GDK_NOTIFY_VIRTUAL),
   MAKE_ICONSTANT((char*)"GTK_PAD_ACTION_RING",GTK_PAD_ACTION_RING),
   MAKE_ICONSTANT((char*)"G_DBUS_SERVER_FLAGS_NONE",G_DBUS_SERVER_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OSAGE",G_UNICODE_SCRIPT_OSAGE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_8",0x1000668),
   MAKE_ICONSTANT((char*)"GDK_RIGHTBUTTON",GDK_RIGHTBUTTON),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MAHAJANI",G_UNICODE_SCRIPT_MAHAJANI),
   MAKE_ICONSTANT((char*)"PANGO_UNDERLINE_NONE",PANGO_UNDERLINE_NONE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3578",0x10028d4),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_NATURAL",GTK_SCROLL_NATURAL),
   MAKE_ICONSTANT((char*)"GDK_ncedilla",0x3f1),
   MAKE_ICONSTANT((char*)"GDK_Henkan_Mode",0xff23),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12458",0x100289b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thothong",0xdb8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sacute",0x1a6),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Space",0xff80),
   MAKE_ICONSTANT((char*)"GDK_Massyo",0xff2c),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_21_MASK",GDK_MODIFIER_RESERVED_21_MASK),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_WATCH_MOUNTS",G_FILE_MONITOR_WATCH_MOUNTS),
   MAKE_ICONSTANT((char*)"GDK_Escape",0xff1b),
   MAKE_ICONSTANT((char*)"GDK_Hangul_NieunHieuh",0xea6),
   MAKE_ICONSTANT((char*)"GDK_KEY_jcircumflex",0x2bc),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_RIGHT_RESIZABLE",GDK_WINDOW_STATE_RIGHT_RESIZABLE),
   MAKE_ICONSTANT((char*)"GDK_EuroSign",0x20ac),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_RESULT_CANCEL",GTK_PRINT_OPERATION_RESULT_CANCEL),
   MAKE_ICONSTANT((char*)"GDK_KEY_racute",0x1e0),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_TOP_TILED",GDK_WINDOW_STATE_TOP_TILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_chi",0x7f7),
   MAKE_ICONSTANT((char*)"GDK_FULLSCREEN_ON_ALL_MONITORS",GDK_FULLSCREEN_ON_ALL_MONITORS),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_beth",0xce1),
   MAKE_ICONSTANT((char*)"GDK_KEY_User2KB",0x1008ff86),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_OWNER_FLAGS_REPLACE",G_BUS_NAME_OWNER_FLAGS_REPLACE),
   MAKE_ICONSTANT((char*)"GDK_GRAB_SUCCESS",GDK_GRAB_SUCCESS),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT",GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT),
   MAKE_ICONSTANT((char*)"GDK_Ebelowdot",0x1001eb8),
   MAKE_ICONSTANT((char*)"GDK_KEY_includes",0x8db),
   MAKE_ICONSTANT((char*)"GDK_Uhorngrave",0x1001eea),
   MAKE_ICONSTANT((char*)"GDK_F15",0xffcc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_tcheh",0x1000686),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_345",0x100281c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_e",0x6dc),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_diaeresis",0xfe57),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_fi",0x10010f6),
   MAKE_ICONSTANT((char*)"GDK_careof",0xab8),
   MAKE_ICONSTANT((char*)"GDK_dead_abovereversedcomma",0xfe65),
   MAKE_ICONSTANT((char*)"G_APP_INFO_CREATE_NEEDS_TERMINAL",G_APP_INFO_CREATE_NEEDS_TERMINAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_aleph",0xce0),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_STATUS_ERROR_SETTING",G_FILE_ATTRIBUTE_STATUS_ERROR_SETTING),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_PERMISSIONS_INVALID",G_DBUS_ERROR_SPAWN_PERMISSIONS_INVALID),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB",GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB),
   MAKE_ICONSTANT((char*)"GDK_musicalsharp",0xaf5),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Romaja",0xff36),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1568",0x10028b1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_KEN",0x100053f),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_e",0x6dc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_gje",0x6a2),
   MAKE_ICONSTANT((char*)"GDK_ogonek",0x1b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Cieuc",0xeea),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_NFD",G_NORMALIZE_NFD),
   MAKE_ICONSTANT((char*)"GDK_cabovedot",0x2e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ubelowdot",0x1001ee4),
   MAKE_ICONSTANT((char*)"GDK_ERROR_MEM",GDK_ERROR_MEM),
   MAKE_ICONSTANT((char*)"GDK_ISO_Set_Margin_Left",0xfe27),
   MAKE_ICONSTANT((char*)"GDK_threequarters",0x0be),
   MAKE_ICONSTANT((char*)"GDK_ocircumflexbelowdot",0x1001ed9),
   MAKE_ICONSTANT((char*)"GDK_s",0x073),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_478",0x10028c8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_alefmaksura",0x5e9),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_CANCEL",GTK_BUTTONS_CANCEL),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_NONE",GTK_SCROLL_NONE),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDIN_PIPE",G_SUBPROCESS_FLAGS_STDIN_PIPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_io",0x6a3),
   MAKE_ICONSTANT((char*)"G_SOCKET_PROTOCOL_UDP",G_SOCKET_PROTOCOL_UDP),
   MAKE_ICONSTANT((char*)"GDK_Greek_GAMMA",0x7c3),
   MAKE_ICONSTANT((char*)"G_FILE_QUERY_INFO_NONE",G_FILE_QUERY_INFO_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Right",0xff98),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflexbelowdot",0x1001ed8),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_FILENAME_TOO_LONG",G_IO_ERROR_FILENAME_TOO_LONG),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_DOWNLOAD",G_USER_DIRECTORY_DOWNLOAD),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_4578",0x10028d8),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_NSM",PANGO_BIDI_TYPE_NSM),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_SPACE",G_UNICODE_BREAK_SPACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_4567",0x1002878),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_SCALE",GTK_PRINT_CAPABILITY_SCALE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarauu",0xdd9),
   MAKE_ICONSTANT((char*)"GDK_guillemotright",0x0bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_46",0x1002828),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ru2",0x1000dd8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level2_Latch",0xfe02),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_NONE",GDK_FRAME_CLOCK_PHASE_NONE),
   MAKE_ICONSTANT((char*)"GDK_PROXIMITY_IN_MASK",GDK_PROXIMITY_IN_MASK),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SHA",0x6fb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_san",0x10010e1),
   MAKE_ICONSTANT((char*)"GDK_Arabic_fathatan",0x5eb),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OLD_PERMIC",PANGO_SCRIPT_OLD_PERMIC),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_REGULAR_FILE",G_IO_ERROR_NOT_REGULAR_FILE),
   MAKE_ICONSTANT((char*)"GDK_Xabovedot",0x1001e8a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Romaja",0xff36),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioMicMute",0x1008ffb2),
   MAKE_ICONSTANT((char*)"GDK_Hangul_PostHanja",0xff3b),
   MAKE_ICONSTANT((char*)"GDK_KEY_y",0x079),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_UNKNOWN",G_UNICODE_BREAK_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_ICON",GDK_ICON),
   MAKE_ICONSTANT((char*)"GDK_KEY_ibelowdot",0x1001ecb),
   MAKE_ICONSTANT((char*)"GDK_KEY_LaunchF",0x1008ff4f),
   MAKE_ICONSTANT((char*)"GTK_ACCEL_LOCKED",GTK_ACCEL_LOCKED),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_FOCUSED",GDK_WINDOW_STATE_FOCUSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_etilde",0x1001ebd),
   MAKE_ICONSTANT((char*)"GDK_tcedilla",0x1fe),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_INITIAL",GTK_PRINT_STATUS_INITIAL),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SHHA",0x10004ba),
   MAKE_ICONSTANT((char*)"G_CHECKSUM_SHA512",G_CHECKSUM_SHA512),
   MAKE_ICONSTANT((char*)"GDK_uhorngrave",0x1001eeb),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_134568",0x10028bd),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_GHE",0x6e7),
   MAKE_ICONSTANT((char*)"GDK_Arabic_comma",0x5ac),
   MAKE_ICONSTANT((char*)"G_TIME_TYPE_STANDARD",G_TIME_TYPE_STANDARD),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowdiaeresis",0xfe6c),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_INVALID",PANGO_ATTR_INVALID),
   MAKE_ICONSTANT((char*)"GDK_Gabovedot",0x2d5),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_AUTO",PANGO_GRAVITY_AUTO),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_SPLASHSCREEN",GDK_WINDOW_TYPE_HINT_SPLASHSCREEN),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_LARGE_TOOLBAR",GTK_ICON_SIZE_LARGE_TOOLBAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_ncaron",0x1f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_decimalpoint",0xabd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2357",0x1002856),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulKiyeog",0xeaa),
   MAKE_ICONSTANT((char*)"GDK_KEY_icircumflex",0x0ee),
   MAKE_ICONSTANT((char*)"GTK_SENSITIVITY_ON",GTK_SENSITIVITY_ON),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_24568",0x10028ba),
   MAKE_ICONSTANT((char*)"G_DATE_MONDAY",G_DATE_MONDAY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhornacute",0x1001ee8),
   MAKE_ICONSTANT((char*)"GDK_KEY_toprightparens",0x8ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftradical",0x8a1),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_INVALID",G_FILE_ATTRIBUTE_TYPE_INVALID),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_PLUGSOCKET",GTK_DEBUG_PLUGSOCKET),
   MAKE_ICONSTANT((char*)"GDK_nabla",0x8c5),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_BRUSH",GDK_DEVICE_TOOL_TYPE_BRUSH),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_135",0x1002815),
   MAKE_ICONSTANT((char*)"GTK_PACK_DIRECTION_TTB",GTK_PACK_DIRECTION_TTB),
   MAKE_ICONSTANT((char*)"G_OUTPUT_STREAM_SPLICE_CLOSE_TARGET",G_OUTPUT_STREAM_SPLICE_CLOSE_TARGET),
   MAKE_ICONSTANT((char*)"GDK_KEY_seconds",0xad7),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_STATUS_UNSET",G_FILE_ATTRIBUTE_STATUS_UNSET),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_FUNC",G_SIGNAL_MATCH_FUNC),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_NieunHieuh",0xea6),
   MAKE_ICONSTANT((char*)"GDK_F35",0xffe0),
   MAKE_ICONSTANT((char*)"G_DATE_MARCH",G_DATE_MARCH),
   MAKE_ICONSTANT((char*)"G_IO_PRI",G_IO_PRI),
   MAKE_ICONSTANT((char*)"GDK_KEY_exclamdown",0x0a1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_237",0x1002846),
   MAKE_ICONSTANT((char*)"GDK_OWNERSHIP_NONE",GDK_OWNERSHIP_NONE),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_TIMEOUT_EXPIRED",GTK_DRAG_RESULT_TIMEOUT_EXPIRED),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TAGALOG",PANGO_SCRIPT_TAGALOG),
   MAKE_ICONSTANT((char*)"GTK_RECENT_CHOOSER_ERROR_INVALID_URI",GTK_RECENT_CHOOSER_ERROR_INVALID_URI),
   MAKE_ICONSTANT((char*)"GDK_KEY_quoteleft",0x060),
   MAKE_ICONSTANT((char*)"GDK_Thai_lekchet",0xdf7),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_STICKY",GDK_WINDOW_STATE_STICKY),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_CLOSE_PUNCTUATION",G_UNICODE_BREAK_CLOSE_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_DSE",0x6b5),
   MAKE_ICONSTANT((char*)"GDK_Next_Virtual_Screen",0xfed2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hcircumflex",0x2a6),
   MAKE_ICONSTANT((char*)"GDK_LightBulb",0x1008ff35),
   MAKE_ICONSTANT((char*)"GDK_KEY_plus",0x02b),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_ID",GTK_BUILDER_ERROR_INVALID_ID),
   MAKE_ICONSTANT((char*)"GDK_KEY_period",0x02e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Time",0x1008ff9f),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123678",0x10028e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_KkogjiDalrinIeung",0xef3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_i",0x1000d89),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NABATAEAN",G_UNICODE_SCRIPT_NABATAEAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_26",0x1002822),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12347",0x100284f),
   MAKE_ICONSTANT((char*)"GDK_Ocircumflex",0x0d4),
   MAKE_ICONSTANT((char*)"GDK_l",0x06c),
   MAKE_ICONSTANT((char*)"GDK_underscore",0x05f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Excel",0x1008ff5c),
   MAKE_ICONSTANT((char*)"GDK_Thai_choching",0xda9),
   MAKE_ICONSTANT((char*)"GDK_Georgian_nar",0x10010dc),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_SURROGATE",G_UNICODE_BREAK_SURROGATE),
   MAKE_ICONSTANT((char*)"GTK_ASSISTANT_PAGE_SUMMARY",GTK_ASSISTANT_PAGE_SUMMARY),
   MAKE_ICONSTANT((char*)"GDK_AudibleBell_Enable",0xfe7a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maitri",0xdea),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_yu",0x6c0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_nga",0x1000d9f),
   MAKE_ICONSTANT((char*)"GDK_KEY_enopencircbullet",0xae0),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HEBREW_LETTER",G_UNICODE_BREAK_HEBREW_LETTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_uhorntilde",0x1001eef),
   MAKE_ICONSTANT((char*)"GTK_ICON_LOOKUP_USE_BUILTIN",GTK_ICON_LOOKUP_USE_BUILTIN),
   MAKE_ICONSTANT((char*)"G_POLLABLE_RETURN_OK",G_POLLABLE_RETURN_OK),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_BELOW",GDK_WINDOW_STATE_BELOW),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_L",PANGO_BIDI_TYPE_L),
   MAKE_ICONSTANT((char*)"GDK_KEY_utilde",0x3fd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Q",0x051),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Nieun",0xea4),
   MAKE_ICONSTANT((char*)"G_NOTIFICATION_PRIORITY_LOW",G_NOTIFICATION_PRIORITY_LOW),
   MAKE_ICONSTANT((char*)"GDK_Oacute",0x0d3),
   MAKE_ICONSTANT((char*)"GDK_elementof",0x1002208),
   MAKE_ICONSTANT((char*)"GDK_Ybelowdot",0x1001ef4),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_INITIALIZED",G_IO_ERROR_NOT_INITIALIZED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_accentdieresis",0x7ae),
   MAKE_ICONSTANT((char*)"GTK_DIALOG_USE_HEADER_BAR",GTK_DIALOG_USE_HEADER_BAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Alt_R",0xffea),
   MAKE_ICONSTANT((char*)"GDK_KEY_PowerDown",0x1008ff21),
   MAKE_ICONSTANT((char*)"GDK_KEY_tintegral",0x100222d),
   MAKE_ICONSTANT((char*)"PANGO_ELLIPSIZE_NONE",PANGO_ELLIPSIZE_NONE),
   MAKE_ICONSTANT((char*)"G_ASCII_UPPER",G_ASCII_UPPER),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_SOLID",GTK_BORDER_STYLE_SOLID),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Emphasize",0xfe32),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_First_Group_Lock",0xfe0d),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_UNKNOWN_OBJECT",G_DBUS_ERROR_UNKNOWN_OBJECT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lochula",0xdcc),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13",0x1002805),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_UINT64",G_VARIANT_CLASS_UINT64),
   MAKE_ICONSTANT((char*)"GDK_BOGOSITY",GDK_BOGOSITY),
   MAKE_ICONSTANT((char*)"GDK_VISIBILITY_UNOBSCURED",GDK_VISIBILITY_UNOBSCURED),
   MAKE_ICONSTANT((char*)"GDK_AudioRaiseVolume",0x1008ff13),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_ALL_METADATA",G_FILE_COPY_ALL_METADATA),
   MAKE_ICONSTANT((char*)"GDK_Ecircumflex",0x0ca),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_leknung",0xdf1),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_GTK_UNGRAB",GDK_CROSSING_GTK_UNGRAB),
   MAKE_ICONSTANT((char*)"G_TLS_INTERACTION_FAILED",G_TLS_INTERACTION_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_jeem",0x5cc),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_EXTRA_CONDENSED",PANGO_STRETCH_EXTRA_CONDENSED),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_VISUAL_POSITIONS",GTK_MOVEMENT_VISUAL_POSITIONS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_omegaaccent",0x7bb),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_AGPL_3_0_ONLY",GTK_LICENSE_AGPL_3_0_ONLY),
   MAKE_ICONSTANT((char*)"G_UNICODE_SURROGATE",G_UNICODE_SURROGATE),
   MAKE_ICONSTANT((char*)"GDK_Sys_Req",0xff15),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_khokhwai",0xda4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarao",0xde2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_exclam",0x100055c),
   MAKE_ICONSTANT((char*)"GDK_abrevetilde",0x1001eb5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_thothung",0xdb6),
   MAKE_ICONSTANT((char*)"GDK_KEY_section",0x0a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ae",0x1000d87),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ER",0x6f2),
   MAKE_ICONSTANT((char*)"GDK_dead_small_schwa",0xfe8a),
   MAKE_ICONSTANT((char*)"GDK_kana_CHI",0x4c1),
   MAKE_ICONSTANT((char*)"GDK_Greek_phi",0x7f6),
   MAKE_ICONSTANT((char*)"GDK_xabovedot",0x1001e8b),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_DIRECTORY",G_FILE_TYPE_DIRECTORY),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_78",0x10028c0),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_GET_MASK",G_IO_FLAG_GET_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_ogonek",0xfe5c),
   MAKE_ICONSTANT((char*)"GDK_KEY_hstroke",0x2b1),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_DESKTOP",G_USER_DIRECTORY_DESKTOP),
   MAKE_ICONSTANT((char*)"GDK_HINT_USER_POS",GDK_HINT_USER_POS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Egrave",0x0c8),
   MAKE_ICONSTANT((char*)"GDK_Clear",0xff0b),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_EXPANDED",PANGO_STRETCH_EXPANDED),
   MAKE_ICONSTANT((char*)"GDK_WWW",0x1008ff2e),
   MAKE_ICONSTANT((char*)"GDK_TARGET",GDK_TARGET),
   MAKE_ICONSTANT((char*)"GDK_KEY_ToDoList",0x1008ff1f),
   MAKE_ICONSTANT((char*)"GDK_Georgian_hae",0x10010f0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_THETA",0x7c8),
   MAKE_ICONSTANT((char*)"GDK_F22",0xffd3),
   MAKE_ICONSTANT((char*)"GDK_3270_ExSelect",0xfd1b),
   MAKE_ICONSTANT((char*)"GDK_Thai_oang",0xdcd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1578",0x10028d1),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_SUBPATTERN_NAME",G_REGEX_ERROR_MISSING_SUBPATTERN_NAME),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_je",0x6a4),
   MAKE_ICONSTANT((char*)"GTK_DIR_LEFT",GTK_DIR_LEFT),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_O",0xfe87),
   MAKE_ICONSTANT((char*)"GDK_TopMenu",0x1008ffa2),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_BEFORE_PAINT",GDK_FRAME_CLOCK_PHASE_BEFORE_PAINT),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_CONDITIONAL_JAPANESE_STARTER",G_UNICODE_BREAK_CONDITIONAL_JAPANESE_STARTER),
   MAKE_ICONSTANT((char*)"G_EMBLEM_ORIGIN_UNKNOWN",G_EMBLEM_ORIGIN_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_currency",0xfe6f),
   MAKE_ICONSTANT((char*)"GDK_kana_openingbracket",0x4a2),
   MAKE_ICONSTANT((char*)"GDK_wdiaeresis",0x1001e85),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_tteh",0x1000679),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NO_SPACE",G_IO_ERROR_NO_SPACE),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_DOWN",GTK_STACK_TRANSITION_TYPE_OVER_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Up",0xfee2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maihanakat_maitho",0xdde),
   MAKE_ICONSTANT((char*)"GTK_ARROW_NONE",GTK_ARROW_NONE),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_CROSSFADE",GTK_REVEALER_TRANSITION_TYPE_CROSSFADE),
   MAKE_ICONSTANT((char*)"GDK_Sinh_thha",0x1000dae),
   MAKE_ICONSTANT((char*)"GDK_Caps_Lock",0xffe5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_nikhahit",0xded),
   MAKE_ICONSTANT((char*)"GDK_DIAMOND_CROSS",GDK_DIAMOND_CROSS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_GHAT",0x1000542),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_INVALID_DATA",G_IO_ERROR_INVALID_DATA),
   MAKE_ICONSTANT((char*)"GDK_Sinh_e2",0x1000dd9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Button_Dflt",0xfee8),
   MAKE_ICONSTANT((char*)"GDK_Hangul_AE",0xec0),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_PARTIAL_HARD",G_REGEX_MATCH_PARTIAL_HARD),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PHAGS_PA",G_UNICODE_SCRIPT_PHAGS_PA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eisu_Shift",0xff2f),
   MAKE_ICONSTANT((char*)"GDK_KEY_twofifths",0xab3),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_PRELIT",GTK_CELL_RENDERER_PRELIT),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_15678",0x10028f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_BackSpace",0xff08),
   MAKE_ICONSTANT((char*)"GDK_WakeUp",0x1008ff2b),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_NORMAL",GTK_STATE_FLAG_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_U_straight",0x10004ae),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button_Dflt",0xfee8),
   MAKE_ICONSTANT((char*)"GDK_Georgian_can",0x10010ea),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_APPLY",GTK_RESPONSE_APPLY),
   MAKE_ICONSTANT((char*)"GDK_scaron",0x1b9),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_pe",0xcf4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_248",0x100288a),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_MODE_INERT",GTK_CELL_RENDERER_MODE_INERT),
   MAKE_ICONSTANT((char*)"GDK_KEY_F2",0xffbf),
   MAKE_ICONSTANT((char*)"PANGO_UNKNOWN_GLYPH_HEIGHT",14),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE",GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123457",0x100285f),
   MAKE_ICONSTANT((char*)"GDK_Abelowdot",0x1001ea0),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_128",0x1002883),
   MAKE_ICONSTANT((char*)"GTK_SELECTION_BROWSE",GTK_SELECTION_BROWSE),
   MAKE_ICONSTANT((char*)"GDK_backslash",0x05c),
   MAKE_ICONSTANT((char*)"GDK_XTERM",GDK_XTERM),
   MAKE_ICONSTANT((char*)"GDK_ApplicationRight",0x1008ff51),
   MAKE_ICONSTANT((char*)"GDK_macron",0x0af),
   MAKE_ICONSTANT((char*)"GDK_tabovedot",0x1001e6b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_hohip",0xdcb),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_INVAL",G_FILE_ERROR_INVAL),
   MAKE_ICONSTANT((char*)"GDK_Arabic_madda_above",0x1000653),
   MAKE_ICONSTANT((char*)"GDK_KEY_femalesymbol",0xaf8),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MANICHAEAN",G_UNICODE_SCRIPT_MANICHAEAN),
   MAKE_ICONSTANT((char*)"GDK_Greek_IOTA",0x7c9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MONGOLIAN",PANGO_SCRIPT_MONGOLIAN),
   MAKE_ICONSTANT((char*)"GDK_tcaron",0x1bb),
   MAKE_ICONSTANT((char*)"GDK_Arabic_feh",0x5e1),
   MAKE_ICONSTANT((char*)"GDK_KEY_downshoe",0xbd6),
   MAKE_ICONSTANT((char*)"GDK_Greek_TAU",0x7d4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_16",0x1002821),
   MAKE_ICONSTANT((char*)"PANGO_ALIGN_CENTER",PANGO_ALIGN_CENTER),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_BADF",G_FILE_ERROR_BADF),
   MAKE_ICONSTANT((char*)"GDK_EXPOSE",GDK_EXPOSE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_dammatan",0x5ec),
   MAKE_ICONSTANT((char*)"GDK_FILTER_REMOVE",GDK_FILTER_REMOVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_gimel",0xce2),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_WARANG_CITI",G_UNICODE_SCRIPT_WARANG_CITI),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_2",0xfff2),
   MAKE_ICONSTANT((char*)"GDK_seveneighths",0xac6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_IE",0x6e5),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PERMISSION_DENIED",G_IO_ERROR_PERMISSION_DENIED),
   MAKE_ICONSTANT((char*)"GDK_sabovedot",0x1001e61),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_FINISHED_ABORTED",GTK_PRINT_STATUS_FINISHED_ABORTED),
   MAKE_ICONSTANT((char*)"G_BUS_TYPE_STARTER",G_BUS_TYPE_STARTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_yod",0xce9),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_4678",0x10028e8),
   MAKE_ICONSTANT((char*)"GDK_Uhook",0x1001ee6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Jieuj",0xeb8),
   MAKE_ICONSTANT((char*)"GDK_Greek_NU",0x7cd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BAMUM",G_UNICODE_SCRIPT_BAMUM),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NETWORK_UNREACHABLE",G_IO_ERROR_NETWORK_UNREACHABLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_IOTA",0x7c9),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_PARTIAL",G_REGEX_MATCH_PARTIAL),
   MAKE_ICONSTANT((char*)"GTK_BUTTONBOX_CENTER",GTK_BUTTONBOX_CENTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflexbelowdot",0x1001ed9),
   MAKE_ICONSTANT((char*)"GDK_ISO_Fast_Cursor_Left",0xfe2c),
   MAKE_ICONSTANT((char*)"GDK_ALL_EVENTS_MASK",GDK_ALL_EVENTS_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thorn",0x0de),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KHMER",PANGO_SCRIPT_KHMER),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_5",0xfff5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_e",0x1000567),
   MAKE_ICONSTANT((char*)"GDK_KEY_punctspace",0xaa6),
   MAKE_ICONSTANT((char*)"GDK_KEY_enfilledcircbullet",0xae6),
   MAKE_ICONSTANT((char*)"GDK_Sinh_aee",0x1000d88),
   MAKE_ICONSTANT((char*)"GDK_Execute",0xff62),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_phosamphao",0xdc0),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_NON_STARTER",G_UNICODE_BREAK_NON_STARTER),
   MAKE_ICONSTANT((char*)"GDK_Arabic_tatweel",0x5e0),
   MAKE_ICONSTANT((char*)"GDK_F18",0xffcf),
   MAKE_ICONSTANT((char*)"GDK_Thai_ru",0xdc4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ba",0x1000db6),
   MAKE_ICONSTANT((char*)"GDK_Uhornhook",0x1001eec),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_124578",0x10028db),
   MAKE_ICONSTANT((char*)"GDK_KEY_Overlay2_Enable",0xfe79),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_IO",0x6b3),
   MAKE_ICONSTANT((char*)"PANGO_STYLE_NORMAL",PANGO_STYLE_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_dead_dasia",0xfe65),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_oang",0xdcd),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YI",0xed2),
   MAKE_ICONSTANT((char*)"GDK_KEY_nacute",0x1f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_R6",0xffd7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PHAGS_PA",PANGO_SCRIPT_PHAGS_PA),
   MAKE_ICONSTANT((char*)"GDK_enfilledcircbullet",0xae6),
   MAKE_ICONSTANT((char*)"GTK_PRINT_QUALITY_DRAFT",GTK_PRINT_QUALITY_DRAFT),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INTERNAL",G_REGEX_ERROR_INTERNAL),
   MAKE_ICONSTANT((char*)"G_DATE_FRIDAY",G_DATE_FRIDAY),
   MAKE_ICONSTANT((char*)"GTK_PRINT_QUALITY_HIGH",GTK_PRINT_QUALITY_HIGH),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Left",0xfee0),
   MAKE_ICONSTANT((char*)"G_TLS_REHANDSHAKE_UNSAFELY",G_TLS_REHANDSHAKE_UNSAFELY),
   MAKE_ICONSTANT((char*)"G_ANALYZER_ANALYZING",0),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftpointer",0xaea),
   MAKE_ICONSTANT((char*)"GTK_SIZE_GROUP_BOTH",GTK_SIZE_GROUP_BOTH),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MIAO",PANGO_SCRIPT_MIAO),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_FOUND",G_IO_ERROR_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GDK_ISO_Last_Group",0xfe0e),
   MAKE_ICONSTANT((char*)"G_IO_HUP",G_IO_HUP),
   MAKE_ICONSTANT((char*)"GDK_Uhorntilde",0x1001eee),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Dikeud",0xea7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_467",0x1002868),
   MAKE_ICONSTANT((char*)"GDK_Greek_ETAaccent",0x7a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_sheen",0x5d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Scaron",0x1a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cabovedot",0x2c5),
   MAKE_ICONSTANT((char*)"G_UNIX_SOCKET_ADDRESS_PATH",G_UNIX_SOCKET_ADDRESS_PATH),
   MAKE_ICONSTANT((char*)"GDK_uptack",0xbce),
   MAKE_ICONSTANT((char*)"GDK_Hebrew_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ooblique",0x0d8),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SHAVIAN",G_UNICODE_SCRIPT_SHAVIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_semivoiced_sound",0xfe5f),
   MAKE_ICONSTANT((char*)"GDK_N",0x04e),
   MAKE_ICONSTANT((char*)"GDK_Georgian_hoe",0x10010f5),
   MAKE_ICONSTANT((char*)"GDK_ISO_Group_Lock",0xfe07),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SUNDANESE",G_UNICODE_SCRIPT_SUNDANESE),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_OK",GTK_BUTTONS_OK),
   MAKE_ICONSTANT((char*)"GTK_ARROWS_END",GTK_ARROWS_END),
   MAKE_ICONSTANT((char*)"GTK_IM_STATUS_NOTHING",GTK_IM_STATUS_NOTHING),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MEROITIC_CURSIVE",G_UNICODE_SCRIPT_MEROITIC_CURSIVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_tta",0x1000da7),
   MAKE_ICONSTANT((char*)"GDK_dead_doublegrave",0xfe66),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_SsangSios",0xee7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_WO",0x4a6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_KA_descender",0x100049a),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_HA_descender",0x10004b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohorntilde",0x1001ee1),
   MAKE_ICONSTANT((char*)"GDK_KEY_fivesixths",0xab7),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_INVALID_TYPE_FUNCTION",GTK_BUILDER_ERROR_INVALID_TYPE_FUNCTION),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13456",0x100283d),
   MAKE_ICONSTANT((char*)"GDK_Dcaron",0x1cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Fast_Cursor_Right",0xfe2d),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_END",GTK_SCROLL_END),
   MAKE_ICONSTANT((char*)"GDK_hebrew_shin",0xcf9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarau",0xdd8),
   MAKE_ICONSTANT((char*)"GDK_rightcaret",0xba6),
   MAKE_ICONSTANT((char*)"GDK_Greek_OMEGAaccent",0x7ab),
   MAKE_ICONSTANT((char*)"G_DATE_BAD_JULIAN",0U),
   MAKE_ICONSTANT((char*)"G_UNICODE_CLOSE_PUNCTUATION",G_UNICODE_CLOSE_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GTK_REGION_FIRST",GTK_REGION_FIRST),
   MAKE_ICONSTANT((char*)"GDK_KEY_L4",0xffcb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_kasra",0x5f0),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_NONBLOCK",G_IO_FLAG_NONBLOCK),
   MAKE_ICONSTANT((char*)"GTK_ICON_THEME_FAILED",GTK_ICON_THEME_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_MenuKB",0x1008ff65),
   MAKE_ICONSTANT((char*)"GDK_q",0x071),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_ZERO_WIDTH_JOINER",G_UNICODE_BREAK_ZERO_WIDTH_JOINER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_phi",0x7f6),
   MAKE_ICONSTANT((char*)"G_PARAM_LAX_VALIDATION",G_PARAM_LAX_VALIDATION),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_ARMENIAN",G_UNICODE_SCRIPT_ARMENIAN),
   MAKE_ICONSTANT((char*)"GDK_Acircumflexhook",0x1001ea8),
   MAKE_ICONSTANT((char*)"GTK_PAD_ACTION_STRIP",GTK_PAD_ACTION_STRIP),
   MAKE_ICONSTANT((char*)"GDK_KEY_ncedilla",0x3f1),
   MAKE_ICONSTANT((char*)"G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_SERVER",G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_SERVER),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INEXISTENT_SUBPATTERN_REFERENCE",G_REGEX_ERROR_INEXISTENT_SUBPATTERN_REFERENCE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_6",0x1002820),
   MAKE_ICONSTANT((char*)"GDK_lcedilla",0x3b6),
   MAKE_ICONSTANT((char*)"GDK_RockerEnter",0x1008ff25),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3678",0x10028e4),
   MAKE_ICONSTANT((char*)"GDK_permille",0xad5),
   MAKE_ICONSTANT((char*)"G_TLS_CERTIFICATE_BAD_IDENTITY",G_TLS_CERTIFICATE_BAD_IDENTITY),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12356",0x1002837),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_ISDIR",G_IO_CHANNEL_ERROR_ISDIR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_6",0x1002820),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_GROOVE",GTK_BORDER_STYLE_GROOVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_kunddaliya",0x1000df4),
   MAKE_ICONSTANT((char*)"G_TYPE_FLAG_DEEP_DERIVABLE",G_TYPE_FLAG_DEEP_DERIVABLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_JE",0x100054b),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_VARIANT",PANGO_ATTR_VARIANT),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_LAYOUT",GTK_DEBUG_LAYOUT),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_WANCHO",G_UNICODE_SCRIPT_WANCHO),
   MAKE_ICONSTANT((char*)"GDK_Find",0xff68),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3457",0x100285c),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_4567",0x1002878),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_je",0x6a8),
   MAKE_ICONSTANT((char*)"GDK_KEY_similarequal",0x8c9),
   MAKE_ICONSTANT((char*)"GDK_ampersand",0x026),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_STRETCH",PANGO_ATTR_STRETCH),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12678",0x10028e3),
   MAKE_ICONSTANT((char*)"GDK_PLUS",GDK_PLUS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_dammatan",0x5ec),
   MAKE_ICONSTANT((char*)"GDK_KEY_Jcircumflex",0x2ac),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_UNKNOWN_VALUE",GTK_CSS_PROVIDER_ERROR_UNKNOWN_VALUE),
   MAKE_ICONSTANT((char*)"G_TLS_AUTHENTICATION_REQUESTED",G_TLS_AUTHENTICATION_REQUESTED),
   MAKE_ICONSTANT((char*)"GDK_KEY_emopenrectangle",0xacf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Num_Lock",0xff7f),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_UNHANDLED_TAG",GTK_BUILDER_ERROR_UNHANDLED_TAG),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_BYTE_ORDER_LITTLE_ENDIAN",G_DBUS_MESSAGE_BYTE_ORDER_LITTLE_ENDIAN),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag1",0xfef5),
   MAKE_ICONSTANT((char*)"GDK_Ohorn",0x10001a0),
   MAKE_ICONSTANT((char*)"GDK_tintegral",0x100222d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulSios",0xead),
   MAKE_ICONSTANT((char*)"GDK_KEY_Omacron",0x3d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_khar",0x10010e5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_oo",0x1000d95),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_EF",0x6e6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1236",0x1002827),
   MAKE_ICONSTANT((char*)"GDK_KEY_Wacute",0x1001e82),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_apostrophe",0x100055a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Katakana",0xff26),
   MAKE_ICONSTANT((char*)"G_BUS_TYPE_NONE",G_BUS_TYPE_NONE),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_OBJECT_PATH",G_VARIANT_CLASS_OBJECT_PATH),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_mba",0x1000db9),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SHORTI",0x6ea),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_245",0x100281a),
   MAKE_ICONSTANT((char*)"GDK_Send",0x1008ff7b),
   MAKE_ICONSTANT((char*)"GDK_3270_EraseEOF",0xfd06),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_but",0x100055d),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_PARSE",G_KEY_FILE_ERROR_PARSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_R",0x052),
   MAKE_ICONSTANT((char*)"GDK_gbreve",0x2bb),
   MAKE_ICONSTANT((char*)"GDK_Greek_XI",0x7ce),
   MAKE_ICONSTANT((char*)"GDK_ohorntilde",0x1001ee1),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalzade",0xcf5),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_CONTROL_CHAR",G_REGEX_ERROR_INVALID_CONTROL_CHAR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_235678",0x10028f6),
   MAKE_ICONSTANT((char*)"GDK_3270_PA2",0xfd0b),
   MAKE_ICONSTANT((char*)"GDK_KEY_PowerOff",0x1008ff2a),
   MAKE_ICONSTANT((char*)"GDK_PAD_BUTTON_RELEASE",GDK_PAD_BUTTON_RELEASE),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_INSEPARABLE",G_UNICODE_BREAK_INSEPARABLE),
   MAKE_ICONSTANT((char*)"GDK_hebrew_zain",0xce6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Break",0xff6b),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CHAM",PANGO_SCRIPT_CHAM),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BASSA_VAH",PANGO_SCRIPT_BASSA_VAH),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_157",0x1002851),
   MAKE_ICONSTANT((char*)"GDK_vertbar",0x9f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ubreve",0x2dd),
   MAKE_ICONSTANT((char*)"GTK_LEVEL_BAR_MODE_DISCRETE",GTK_LEVEL_BAR_MODE_DISCRETE),
   MAKE_ICONSTANT((char*)"GDK_kana_tsu",0x4af),
   MAKE_ICONSTANT((char*)"GDK_Armenian_hyphen",0x100058a),
   MAKE_ICONSTANT((char*)"GDK_KEY_upshoe",0xbc3),
   MAKE_ICONSTANT((char*)"G_FILESYSTEM_PREVIEW_TYPE_NEVER",G_FILESYSTEM_PREVIEW_TYPE_NEVER),
   MAKE_ICONSTANT((char*)"GTK_CALENDAR_SHOW_DETAILS",GTK_CALENDAR_SHOW_DETAILS),
   MAKE_ICONSTANT((char*)"GDK_Arabic_ddal",0x1000688),
   MAKE_ICONSTANT((char*)"GDK_KEY_uring",0x1f9),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ra",0x1000dbb),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_NO_CSS_CACHE",GTK_DEBUG_NO_CSS_CACHE),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_resh",0xcf8),
   MAKE_ICONSTANT((char*)"GDK_rightshoe",0xbd8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Word",0x1008ff89),
   MAKE_ICONSTANT((char*)"GDK_bott",0x9f6),
   MAKE_ICONSTANT((char*)"GDK_KP_8",0xffb8),
   MAKE_ICONSTANT((char*)"PANGO_SHOW_NONE",PANGO_SHOW_NONE),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_MASK",G_IO_FLAG_MASK),
   MAKE_ICONSTANT((char*)"GDK_signaturemark",0xaca),
   MAKE_ICONSTANT((char*)"GDK_uhorn",0x10001b0),
   MAKE_ICONSTANT((char*)"G_DATE_JULY",G_DATE_JULY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_12",0x1008fe0c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_VO",0x1000548),
   MAKE_ICONSTANT((char*)"GDK_omacron",0x3f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_TO",0x1000539),
   MAKE_ICONSTANT((char*)"GDK_Greek_IOTAaccent",0x7a4),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INVALID_FORMAT_STRING",G_VARIANT_PARSE_ERROR_INVALID_FORMAT_STRING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_hyphen",0x100058a),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_158",0x1002891),
   MAKE_ICONSTANT((char*)"GDK_KEY_downstile",0xbc4),
   MAKE_ICONSTANT((char*)"GDK_KEY_ecircumflextilde",0x1001ec5),
   MAKE_ICONSTANT((char*)"GDK_ISO_Partial_Space_Left",0xfe25),
   MAKE_ICONSTANT((char*)"GDK_acircumflex",0x0e2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_ie",0x6a4),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_7",0x1008fe07),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_125678",0x10028f3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ihook",0x1001ec8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_BOPOMOFO",PANGO_SCRIPT_BOPOMOFO),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ACTION_OPEN",GTK_FILE_CHOOSER_ACTION_OPEN),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_WITHDRAWN",GDK_WINDOW_STATE_WITHDRAWN),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN",GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_vev",0x100057e),
   MAKE_ICONSTANT((char*)"G_TYPE_DEBUG_INSTANCE_COUNT",G_TYPE_DEBUG_INSTANCE_COUNT),
   MAKE_ICONSTANT((char*)"G_DBUS_SIGNAL_FLAGS_MATCH_ARG0_NAMESPACE",G_DBUS_SIGNAL_FLAGS_MATCH_ARG0_NAMESPACE),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_NO_MEMORY",G_CONVERT_ERROR_NO_MEMORY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_I",0xed3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abelowdot",0x1001ea0),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_INHERITED",G_UNICODE_SCRIPT_INHERITED),
   MAKE_ICONSTANT((char*)"GDK_Greek_ZETA",0x7c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Option",0x1008ff6c),
   MAKE_ICONSTANT((char*)"GDK_Sinh_luu",0x1000d90),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_NORMAL",GDK_WINDOW_TYPE_HINT_NORMAL),
   MAKE_ICONSTANT((char*)"GDK_CLOCK",GDK_CLOCK),
   MAKE_ICONSTANT((char*)"G_SEEK_SET",G_SEEK_SET),
   MAKE_ICONSTANT((char*)"GDK_KEY_logicalor",0x8df),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Fast_Cursor_Down",0xfe2f),
   MAKE_ICONSTANT((char*)"GDK_KEY_F24",0xffd5),
   MAKE_ICONSTANT((char*)"GTK_SHADOW_NONE",GTK_SHADOW_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_hoe",0x10010f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Kana_Shift",0xff2e),
   MAKE_ICONSTANT((char*)"GDK_hcircumflex",0x2b6),
   MAKE_ICONSTANT((char*)"GDK_fivesubscript",0x1002085),
   MAKE_ICONSTANT((char*)"GDK_R",0x052),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflextilde",0x1001eaa),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1245",0x100281b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Start",0xff32),
   MAKE_ICONSTANT((char*)"GDK_KP_0",0xffb0),
   MAKE_ICONSTANT((char*)"GDK_LaunchA",0x1008ff4a),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_KEEP_TRANSLATIONS",G_KEY_FILE_KEEP_TRANSLATIONS),
   MAKE_ICONSTANT((char*)"G_BUS_TYPE_SESSION",G_BUS_TYPE_SESSION),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SingleCandidate",0xff3c),
   MAKE_ICONSTANT((char*)"GDK_union",0x8dd),
   MAKE_ICONSTANT((char*)"GDK_KEY_F34",0xffdf),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12578",0x10028d3),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2458",0x100289a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_DE",0x6e4),
   MAKE_ICONSTANT((char*)"GDK_horizconnector",0x8a3),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_PREVIEW",GTK_PRINT_CAPABILITY_PREVIEW),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_zhe_descender",0x1000497),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_A",0xfe81),
   MAKE_ICONSTANT((char*)"GDK_Serbian_je",0x6a8),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_STYLE",PANGO_ATTR_STYLE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BENGALI",G_UNICODE_SCRIPT_BENGALI),
   MAKE_ICONSTANT((char*)"GDK_fivesuperior",0x1002075),
   MAKE_ICONSTANT((char*)"GDK_Ccedilla",0x0c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_ClearGrab",0x1008fe21),
   MAKE_ICONSTANT((char*)"GDK_X",0x058),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Right2",0xfd03),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1247",0x100284b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_235",0x1002816),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1238",0x1002887),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_28",0x1002882),
   MAKE_ICONSTANT((char*)"GDK_CONFIGURE",GDK_CONFIGURE),
   MAKE_ICONSTANT((char*)"GDK_HEART",GDK_HEART),
   MAKE_ICONSTANT((char*)"GDK_aring",0x0e5),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNKNOWN_POSIX_CLASS_NAME",G_REGEX_ERROR_UNKNOWN_POSIX_CLASS_NAME),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_OWNER_FLAGS_ALLOW_REPLACEMENT",G_BUS_NAME_OWNER_FLAGS_ALLOW_REPLACEMENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Rieul",0xea9),
   MAKE_ICONSTANT((char*)"GDK_latincross",0xad9),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_be",0x6c2),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_PROXY_NOT_ALLOWED",G_IO_ERROR_PROXY_NOT_ALLOWED),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohornbelowdot",0x1001ee3),
   MAKE_ICONSTANT((char*)"GDK_KEY_threequarters",0x0be),
   MAKE_ICONSTANT((char*)"GDK_Hangul_End",0xff33),
   MAKE_ICONSTANT((char*)"G_TLS_REHANDSHAKE_NEVER",G_TLS_REHANDSHAKE_NEVER),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_KEYBINDINGS",GTK_DEBUG_KEYBINDINGS),
   MAKE_ICONSTANT((char*)"GTK_PAN_DIRECTION_UP",GTK_PAN_DIRECTION_UP),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_ERROR_UNKNOWN_ENCODING",G_KEY_FILE_ERROR_UNKNOWN_ENCODING),
   MAKE_ICONSTANT((char*)"GDK_Greek_omicron",0x7ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_dasia",0xfe65),
   MAKE_ICONSTANT((char*)"GDK_ebelowdot",0x1001eb9),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_ADDRESS_IN_USE",G_IO_ERROR_ADDRESS_IN_USE),
   MAKE_ICONSTANT((char*)"GDK_KEY_W",0x057),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1345678",0x10028fd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_U_straight_bar",0x10004b0),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_COLUMN_GROW_ONLY",GTK_TREE_VIEW_COLUMN_GROW_ONLY),
   MAKE_ICONSTANT((char*)"GDK_ENTER_NOTIFY_MASK",GDK_ENTER_NOTIFY_MASK),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_XDND",GDK_DRAG_PROTO_XDND),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lekkao",0xdf9),
   MAKE_ICONSTANT((char*)"GDK_KEY_z",0x07a),
   MAKE_ICONSTANT((char*)"G_TYPE_DEBUG_SIGNALS",G_TYPE_DEBUG_SIGNALS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hankaku",0xff29),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_NO_COMMON_TYPE",G_VARIANT_PARSE_ERROR_NO_COMMON_TYPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_downtack",0xbc2),
   MAKE_ICONSTANT((char*)"GDK_R6",0xffd7),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_178",0x10028c1),
   MAKE_ICONSTANT((char*)"GDK_3270_Record",0xfd18),
   MAKE_ICONSTANT((char*)"GDK_KEY_F29",0xffda),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KAITHI",G_UNICODE_SCRIPT_KAITHI),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Equal",0xffbd),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Level3_Shift",0xfe03),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_PRELIGHT",GTK_STATE_FLAG_PRELIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Bluetooth",0x1008ff94),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_36",0x1002824),
   MAKE_ICONSTANT((char*)"GTK_PRINT_DUPLEX_HORIZONTAL",GTK_PRINT_DUPLEX_HORIZONTAL),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_TYPE_INVALID",G_DBUS_MESSAGE_TYPE_INVALID),
   MAKE_ICONSTANT((char*)"GDK_acircumflexbelowdot",0x1001ead),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_SEMI_CONDENSED",PANGO_STRETCH_SEMI_CONDENSED),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_9",0x1008fe09),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_PINCH",GDK_TOUCHPAD_PINCH),
   MAKE_ICONSTANT((char*)"GTK_RECENT_SORT_NONE",GTK_RECENT_SORT_NONE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_247",0x100284a),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_BSD",GTK_LICENSE_BSD),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1356",0x1002835),
   MAKE_ICONSTANT((char*)"GDK_Serbian_tshe",0x6ab),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_135678",0x10028f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Dikeud",0xea7),
   MAKE_ICONSTANT((char*)"GDK_minus",0x02d),
   MAKE_ICONSTANT((char*)"GDK_PowerOff",0x1008ff2a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uhorngrave",0x1001eea),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ZHE",0x6f6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_14",0x1002809),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_UNKNOWN_METHOD",G_DBUS_ERROR_UNKNOWN_METHOD),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_zhe",0x100056a),
   MAKE_ICONSTANT((char*)"GDK_hebrew_finalpe",0xcf3),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GURMUKHI",G_UNICODE_SCRIPT_GURMUKHI),
   MAKE_ICONSTANT((char*)"GDK_TCROSS",GDK_TCROSS),
   MAKE_ICONSTANT((char*)"GDK_KEY_elementof",0x1002208),
   MAKE_ICONSTANT((char*)"GDK_KEY_F32",0xffdd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_YA",0x6f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12678",0x10028e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_KI",0x4b7),
   MAKE_ICONSTANT((char*)"GTK_PACK_DIRECTION_LTR",GTK_PACK_DIRECTION_LTR),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_PRINTING",GTK_PRINT_STATUS_PRINTING),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_R",PANGO_BIDI_TYPE_R),
   MAKE_ICONSTANT((char*)"GDK_KEY_Undo",0xff65),
   MAKE_ICONSTANT((char*)"GDK_Georgian_tan",0x10010d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_FieldMark",0xfd02),
   MAKE_ICONSTANT((char*)"GDK_KP_Left",0xff96),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SHARADA",PANGO_SCRIPT_SHARADA),
   MAKE_ICONSTANT((char*)"GDK_Mail",0x1008ff19),
   MAKE_ICONSTANT((char*)"GDK_Ukrainian_IE",0x6b4),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_347",0x100284c),
   MAKE_ICONSTANT((char*)"GDK_KEY_HomePage",0x1008ff18),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT",GTK_STACK_TRANSITION_TYPE_OVER_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_hebrew_gimel",0xce2),
   MAKE_ICONSTANT((char*)"GDK_THORN",0x0de),
   MAKE_ICONSTANT((char*)"G_MOUNT_OPERATION_ABORTED",G_MOUNT_OPERATION_ABORTED),
   MAKE_ICONSTANT((char*)"GDK_Ycircumflex",0x1000176),
   MAKE_ICONSTANT((char*)"GDK_KEY_F",0x046),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sosala",0xdc8),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_ALPHA",GTK_INPUT_PURPOSE_ALPHA),
   MAKE_ICONSTANT((char*)"GDK_percent",0x025),
   MAKE_ICONSTANT((char*)"GDK_Greek_OMEGA",0x7d9),
   MAKE_ICONSTANT((char*)"GDK_SELECTION_CLEAR",GDK_SELECTION_CLEAR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2478",0x10028ca),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_35678",0x10028f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_musicalsharp",0xaf5),
   MAKE_ICONSTANT((char*)"GDK_ograve",0x0f2),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_INHIBIT_OSK",GTK_INPUT_HINT_INHIBIT_OSK),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_UNIX_PROCESS_ID_UNKNOWN",G_DBUS_ERROR_UNIX_PROCESS_ID_UNKNOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_middledot",0x4a5),
   MAKE_ICONSTANT((char*)"GDK_Launch4",0x1008ff44),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SHAVIAN",PANGO_SCRIPT_SHAVIAN),
   MAKE_ICONSTANT((char*)"G_FILE_MEASURE_REPORT_ANY_ERROR",G_FILE_MEASURE_REPORT_ANY_ERROR),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level2_Latch",0xfe02),
   MAKE_ICONSTANT((char*)"GDK_foursuperior",0x1002074),
   MAKE_ICONSTANT((char*)"GDK_KEY_G",0x047),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_ALPHABETIC",G_UNICODE_BREAK_ALPHABETIC),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_yeru",0x6d9),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_DROP_ABOVE",GTK_ICON_VIEW_DROP_ABOVE),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_FOCUSED",GTK_STATE_FLAG_FOCUSED),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OGHAM",PANGO_SCRIPT_OGHAM),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2",0x1002802),
   MAKE_ICONSTANT((char*)"GDK_x",0x078),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_TYPE_ERROR",G_DBUS_MESSAGE_TYPE_ERROR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_NU",0x7cd),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12467",0x100286b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ndda",0x1000dac),
   MAKE_ICONSTANT((char*)"GDK_KEY_tcedilla",0x1fe),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_YES_NO",GTK_BUTTONS_YES_NO),
   MAKE_ICONSTANT((char*)"GDK_KEY_ocircumflextilde",0x1001ed7),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_ULTRAHEAVY",PANGO_WEIGHT_ULTRAHEAVY),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_PA1",0xfd0a),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_IMPORT",GTK_CSS_SECTION_IMPORT),
   MAKE_ICONSTANT((char*)"G_UNICODE_FORMAT",G_UNICODE_FORMAT),
   MAKE_ICONSTANT((char*)"GDK_bracketleft",0x05b),
   MAKE_ICONSTANT((char*)"G_BINDING_SYNC_CREATE",G_BINDING_SYNC_CREATE),
   MAKE_ICONSTANT((char*)"GDK_Iacute",0x0cd),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MALAYALAM",PANGO_SCRIPT_MALAYALAM),
   MAKE_ICONSTANT((char*)"GTK_BUILDER_ERROR_MISSING_ATTRIBUTE",GTK_BUILDER_ERROR_MISSING_ATTRIBUTE),
   MAKE_ICONSTANT((char*)"GDK_KEY_quotedbl",0x022),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_ARABIC",PANGO_SCRIPT_ARABIC),
   MAKE_ICONSTANT((char*)"GDK_idotless",0x2b9),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CYRILLIC",PANGO_SCRIPT_CYRILLIC),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag5",0xfefd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1246",0x100282b),
   MAKE_ICONSTANT((char*)"GDK_iogonek",0x3e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_SsangDikeud",0xea8),
   MAKE_ICONSTANT((char*)"PANGO_FONT_MASK_FAMILY",PANGO_FONT_MASK_FAMILY),
   MAKE_ICONSTANT((char*)"GDK_DECOR_RESIZEH",GDK_DECOR_RESIZEH),
   MAKE_ICONSTANT((char*)"GDK_Arabic_hamzaonyeh",0x5c6),
   MAKE_ICONSTANT((char*)"GDK_FILTER_TRANSLATE",GDK_FILTER_TRANSLATE),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_IO",G_IO_CHANNEL_ERROR_IO),
   MAKE_ICONSTANT((char*)"PANGO_ELLIPSIZE_MIDDLE",PANGO_ELLIPSIZE_MIDDLE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_fullstop",0x10006d4),
   MAKE_ICONSTANT((char*)"GTK_ACCEL_MASK",GTK_ACCEL_MASK),
   MAKE_ICONSTANT((char*)"GDK_parenright",0x029),
   MAKE_ICONSTANT((char*)"G_IO_STATUS_EOF",G_IO_STATUS_EOF),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_27",0x1002842),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_dze",0x6af),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_SLIDE_X",GDK_ANCHOR_SLIDE_X),
   MAKE_ICONSTANT((char*)"GDK_exclamdown",0x0a1),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM",GTK_FILE_CHOOSER_CONFIRMATION_CONFIRM),
   MAKE_ICONSTANT((char*)"GDK_KEY_xabovedot",0x1001e8b),
   MAKE_ICONSTANT((char*)"GDK_ENG",0x3bd),
   MAKE_ICONSTANT((char*)"G_FILE_MEASURE_NONE",G_FILE_MEASURE_NONE),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_PEN",GDK_SOURCE_PEN),
   MAKE_ICONSTANT((char*)"GDK_ACTION_MOVE",GDK_ACTION_MOVE),
   MAKE_ICONSTANT((char*)"GDK_SCROLL",GDK_SCROLL),
   MAKE_ICONSTANT((char*)"GDK_hebrew_samekh",0xcf1),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123457",0x100285f),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_DROP_AFTER",GTK_TREE_VIEW_DROP_AFTER),
   MAKE_ICONSTANT((char*)"GDK_ISO_Move_Line_Down",0xfe22),
   MAKE_ICONSTANT((char*)"GDK_kana_yu",0x4ad),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_NONE",GDK_SEAT_CAPABILITY_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_oacute",0x0f3),
   MAKE_ICONSTANT((char*)"GDK_Thai_saraaimaimalai",0xde4),
   MAKE_ICONSTANT((char*)"GDK_f",0x066),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ha",0x1000dc4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_125678",0x10028f3),
   MAKE_ICONSTANT((char*)"GDK_Break",0xff6b),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_NAME",GTK_INPUT_PURPOSE_NAME),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_148",0x1002889),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ocircumflexgrave",0x1001ed2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_loling",0xdc5),
   MAKE_ICONSTANT((char*)"GDK_dead_belowcircumflex",0xfe69),
   MAKE_ICONSTANT((char*)"GDK_KEY_KbdBrightnessUp",0x1008ff05),
   MAKE_ICONSTANT((char*)"GDK_KP_2",0xffb2),
   MAKE_ICONSTANT((char*)"GDK_KEY_F35",0xffe0),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INVALID_TYPE_STRING",G_VARIANT_PARSE_ERROR_INVALID_TYPE_STRING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_jeh",0x1000698),
   MAKE_ICONSTANT((char*)"GDK_KEY_ybelowdot",0x1001ef5),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HIRAGANA",PANGO_SCRIPT_HIRAGANA),
   MAKE_ICONSTANT((char*)"GDK_botleftparens",0x8ac),
   MAKE_ICONSTANT((char*)"GDK_braille_dot_4",0xfff4),
   MAKE_ICONSTANT((char*)"GDK_Xfer",0x1008ff8a),
   MAKE_ICONSTANT((char*)"GDK_bracketright",0x05d),
   MAKE_ICONSTANT((char*)"GDK_BUTTON3_MASK",GDK_BUTTON3_MASK),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_CONTROL_CHAR",G_REGEX_ERROR_MISSING_CONTROL_CHAR),
   MAKE_ICONSTANT((char*)"GDK_ibelowdot",0x1001ecb),
   MAKE_ICONSTANT((char*)"GDK_F6",0xffc3),
   MAKE_ICONSTANT((char*)"GDK_Armenian_TYUN",0x100054f),
   MAKE_ICONSTANT((char*)"GDK_Mabovedot",0x1001e40),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_X",GDK_AXIS_FLAG_X),
   MAKE_ICONSTANT((char*)"G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE",G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_nar",0x10010dc),
   MAKE_ICONSTANT((char*)"GDK_Sinh_jnya",0x1000da5),
   MAKE_ICONSTANT((char*)"GDK_Arabic_keheh",0x10006a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_wgrave",0x1001e81),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_BRAHMI",G_UNICODE_SCRIPT_BRAHMI),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OSMANYA",G_UNICODE_SCRIPT_OSMANYA),
   MAKE_ICONSTANT((char*)"G_RESOURCE_LOOKUP_FLAGS_NONE",G_RESOURCE_LOOKUP_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Wgrave",0x1001e80),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_UNAVAILABLE",G_TLS_ERROR_UNAVAILABLE),
   MAKE_ICONSTANT((char*)"GDK_BUTTON1_MOTION_MASK",GDK_BUTTON1_MOTION_MASK),
   MAKE_ICONSTANT((char*)"GDK_emopenrectangle",0xacf),
   MAKE_ICONSTANT((char*)"GDK_KEY_includedin",0x8da),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_CREATED",G_FILE_MONITOR_EVENT_CREATED),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_e",0x4aa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_i",0x6c9),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_REJECT",GTK_RESPONSE_REJECT),
   MAKE_ICONSTANT((char*)"GDK_DROP_FINISHED",GDK_DROP_FINISHED),
   MAKE_ICONSTANT((char*)"GDK_enopencircbullet",0xae0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_128",0x1002883),
   MAKE_ICONSTANT((char*)"GDK_Racute",0x1c0),
   MAKE_ICONSTANT((char*)"GDK_KEY_masculine",0x0ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_1",0x1000661),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_PREPARING",GTK_PRINT_STATUS_PREPARING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Y",0x059),
   MAKE_ICONSTANT((char*)"G_CHECKSUM_MD5",G_CHECKSUM_MD5),
   MAKE_ICONSTANT((char*)"GDK_ecircumflexgrave",0x1001ec1),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_U",0x6f5),
   MAKE_ICONSTANT((char*)"GDK_KEY_hcircumflex",0x2b6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_568",0x10028b0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_457",0x1002858),
   MAKE_ICONSTANT((char*)"GDK_fiveeighths",0xac5),
   MAKE_ICONSTANT((char*)"GDK_KEY_kra",0x3a2),
   MAKE_ICONSTANT((char*)"GTK_ALIGN_END",GTK_ALIGN_END),
   MAKE_ICONSTANT((char*)"GDK_3270_Setup",0xfd17),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TU",0x4c2),
   MAKE_ICONSTANT((char*)"GDK_Ediaeresis",0x0cb),
   MAKE_ICONSTANT((char*)"G_DATE_WEDNESDAY",G_DATE_WEDNESDAY),
   MAKE_ICONSTANT((char*)"GDK_FUNC_CLOSE",GDK_FUNC_CLOSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_GAMMA",0x7c3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ZHE_descender",0x1000496),
   MAKE_ICONSTANT((char*)"GDK_SAILBOAT",GDK_SAILBOAT),
   MAKE_ICONSTANT((char*)"GTK_TEXT_DIR_LTR",GTK_TEXT_DIR_LTR),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_A",0x6e1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_8",0x1000668),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_124578",0x10028db),
   MAKE_ICONSTANT((char*)"GDK_KEY_E",0x045),
   MAKE_ICONSTANT((char*)"GDK_KEY_plusminus",0x0b1),
   MAKE_ICONSTANT((char*)"GDK_uhornhook",0x1001eed),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_NUMBER_UP",GTK_PRINT_CAPABILITY_NUMBER_UP),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_OCTAL_VALUE",G_REGEX_ERROR_INVALID_OCTAL_VALUE),
   MAKE_ICONSTANT((char*)"GDK_Q",0x051),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_7",0x1002840),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulTieut",0xee0),
   MAKE_ICONSTANT((char*)"GDK_ScrollDown",0x1008ff79),
   MAKE_ICONSTANT((char*)"GDK_WA_CURSOR",GDK_WA_CURSOR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23456",0x100283e),
   MAKE_ICONSTANT((char*)"GDK_wacute",0x1001e83),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_HANDSHAKE",G_TLS_ERROR_HANDSHAKE),
   MAKE_ICONSTANT((char*)"GDK_BLANK_CURSOR",GDK_BLANK_CURSOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123678",0x10028e7),
   MAKE_ICONSTANT((char*)"GDK_Lcedilla",0x3a6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_YERU",0x6f9),
   MAKE_ICONSTANT((char*)"GDK_ccedilla",0x0e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_ra",0x5d1),
   MAKE_ICONSTANT((char*)"GDK_KEY_b",0x062),
   MAKE_ICONSTANT((char*)"G_SOURCE_REMOVE",FALSE),
   MAKE_ICONSTANT((char*)"GDK_cacute",0x1e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_nu",0x7ed),
   MAKE_ICONSTANT((char*)"G_SETTINGS_BIND_GET",G_SETTINGS_BIND_GET),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_167",0x1002861),
   MAKE_ICONSTANT((char*)"GDK_dead_belowcomma",0xfe6e),
   MAKE_ICONSTANT((char*)"GDK_OWNER_CHANGE_NEW_OWNER",GDK_OWNER_CHANGE_NEW_OWNER),
   MAKE_ICONSTANT((char*)"G_ASCII_SPACE",G_ASCII_SPACE),
   MAKE_ICONSTANT((char*)"GDK_KEY_yen",0x0a5),
   MAKE_ICONSTANT((char*)"G_SUBPROCESS_FLAGS_STDOUT_SILENCE",G_SUBPROCESS_FLAGS_STDOUT_SILENCE),
   MAKE_ICONSTANT((char*)"GDK_F8",0xffc5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Touroku",0xff2b),
   MAKE_ICONSTANT((char*)"GDK_sacute",0x1b6),
   MAKE_ICONSTANT((char*)"GTK_TARGET_SAME_APP",GTK_TARGET_SAME_APP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ri",0x1000d8d),
   MAKE_ICONSTANT((char*)"GDK_TOP_RIGHT_CORNER",GDK_TOP_RIGHT_CORNER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_4",0x1000664),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_STATUS_SET",G_FILE_ATTRIBUTE_STATUS_SET),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_tet",0xce8),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_MENU",GDK_WINDOW_TYPE_HINT_MENU),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_je",0x6a4),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_RIGHT",GTK_JUNCTION_RIGHT),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_ACCEL_MODE_OTHER",GTK_CELL_RENDERER_ACCEL_MODE_OTHER),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_SsangKiyeog",0xed5),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_PINCH",GTK_SHORTCUT_GESTURE_PINCH),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_INVALID_OBJECT_PATH",G_VARIANT_PARSE_ERROR_INVALID_OBJECT_PATH),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13468",0x10028ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tabovedot",0x1001e6a),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ndda",0x1000dac),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_hook",0xfe61),
   MAKE_ICONSTANT((char*)"GDK_em4space",0xaa4),
   MAKE_ICONSTANT((char*)"GTK_PRINT_PAGES_CURRENT",GTK_PRINT_PAGES_CURRENT),
   MAKE_ICONSTANT((char*)"GTK_PAGE_ORIENTATION_LANDSCAPE",GTK_PAGE_ORIENTATION_LANDSCAPE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_che_vertstroke",0x10004b9),
   MAKE_ICONSTANT((char*)"GDK_leftmiddlecurlybrace",0x8af),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_YERU",0x6f9),
   MAKE_ICONSTANT((char*)"GDK_BUTTON2_MOTION_MASK",GDK_BUTTON2_MOTION_MASK),
   MAKE_ICONSTANT((char*)"GDK_Arabic_superscript_alef",0x1000670),
   MAKE_ICONSTANT((char*)"G_FILE_TEST_IS_EXECUTABLE",G_FILE_TEST_IS_EXECUTABLE),
   MAKE_ICONSTANT((char*)"GTK_APPLICATION_INHIBIT_IDLE",GTK_APPLICATION_INHIBIT_IDLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_n",0x06e),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Copy",0xfd15),
   MAKE_ICONSTANT((char*)"GDK_DRAG_ENTER",GDK_DRAG_ENTER),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Khieuq",0xebb),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_FBIG",G_IO_CHANNEL_ERROR_FBIG),
   MAKE_ICONSTANT((char*)"GDK_F14",0xffcb),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR",GDK_MODIFIER_INTENT_PRIMARY_ACCELERATOR),
   MAKE_ICONSTANT((char*)"GTK_WRAP_WORD_CHAR",GTK_WRAP_WORD_CHAR),
   MAKE_ICONSTANT((char*)"G_SOCKET_CLIENT_CONNECTING",G_SOCKET_CLIENT_CONNECTING),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Fast_Cursor_Up",0xfe2e),
   MAKE_ICONSTANT((char*)"GDK_OWNER_CHANGE_DESTROY",GDK_OWNER_CHANGE_DESTROY),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_INAPPROPRIATE_FALLBACK",G_TLS_ERROR_INAPPROPRIATE_FALLBACK),
   MAKE_ICONSTANT((char*)"GDK_AXIS_FLAG_DISTANCE",GDK_AXIS_FLAG_DISTANCE),
   MAKE_ICONSTANT((char*)"GDK_Armenian_pe",0x100057a),
   MAKE_ICONSTANT((char*)"GDK_KEY_CD",0x1008ff53),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lekchet",0xdf7),
   MAKE_ICONSTANT((char*)"GDK_Thai_chochan",0xda8),
   MAKE_ICONSTANT((char*)"GDK_dead_tilde",0xfe53),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflex",0x0c2),
   MAKE_ICONSTANT((char*)"GTK_DEST_DEFAULT_HIGHLIGHT",GTK_DEST_DEFAULT_HIGHLIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_leksi",0xdf4),
   MAKE_ICONSTANT((char*)"GDK_KEY_latincross",0xad9),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_RIGHT_TO_LEFT",GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_RIGHT_TO_LEFT),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_STOCK",GTK_IMAGE_STOCK),
   MAKE_ICONSTANT((char*)"GTK_PLACES_OPEN_NEW_WINDOW",GTK_PLACES_OPEN_NEW_WINDOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lekhok",0xdf6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Iabovedot",0x2a9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_hamzaonyeh",0x5c6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12457",0x100285b),
   MAKE_ICONSTANT((char*)"GDK_MOD3_MASK",GDK_MOD3_MASK),
   MAKE_ICONSTANT((char*)"GDK_ohorngrave",0x1001edd),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_UP",GDK_SCROLL_UP),
   MAKE_ICONSTANT((char*)"GDK_kana_HO",0x4ce),
   MAKE_ICONSTANT((char*)"GDK_ERROR_FILE",GDK_ERROR_FILE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_146",0x1002829),
   MAKE_ICONSTANT((char*)"GDK_dead_circumflex",0xfe52),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_ROFS",G_FILE_ERROR_ROFS),
   MAKE_ICONSTANT((char*)"GDK_DROP_START",GDK_DROP_START),
   MAKE_ICONSTANT((char*)"GDK_Finance",0x1008ff3c),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_NAME",GTK_CSS_PROVIDER_ERROR_NAME),
   MAKE_ICONSTANT((char*)"GTK_DELETE_DISPLAY_LINES",GTK_DELETE_DISPLAY_LINES),
   MAKE_ICONSTANT((char*)"GDK_soliddiamond",0x9e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_4",0x1002808),
   MAKE_ICONSTANT((char*)"GDK_e",0x065),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1478",0x10028c9),
   MAKE_ICONSTANT((char*)"GDK_KEY_SCHWA",0x100018f),
   MAKE_ICONSTANT((char*)"G_ASCII_PRINT",G_ASCII_PRINT),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_25_MASK",GDK_MODIFIER_RESERVED_25_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_EL",0x6ec),
   MAKE_ICONSTANT((char*)"GTK_ICON_THEME_NOT_FOUND",GTK_ICON_THEME_NOT_FOUND),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_VERTICAL",GTK_EVENT_CONTROLLER_SCROLL_VERTICAL),
   MAKE_ICONSTANT((char*)"GDK_RockerUp",0x1008ff23),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_FAILED",G_DBUS_ERROR_SPAWN_FAILED),
   MAKE_ICONSTANT((char*)"GTK_IM_STATUS_NONE",GTK_IM_STATUS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DblClick5",0xfef3),
   MAKE_ICONSTANT((char*)"GDK_lefttack",0xbdc),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_PREFIX",G_UNICODE_BREAK_PREFIX),
   MAKE_ICONSTANT((char*)"GDK_uring",0x1f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_identical",0x8cf),
   MAKE_ICONSTANT((char*)"GDK_DRAG_LEAVE",GDK_DRAG_LEAVE),
   MAKE_ICONSTANT((char*)"GDK_Korean_Won",0xeff),
   MAKE_ICONSTANT((char*)"GDK_Touroku",0xff2b),
   MAKE_ICONSTANT((char*)"GDK_Arabic_3",0x1000663),
   MAKE_ICONSTANT((char*)"GDK_KEY_Uacute",0x0da),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_UNRECOGNIZED_CHARACTER",G_REGEX_ERROR_UNRECOGNIZED_CHARACTER),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulPieub",0xede),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sosua",0xdca),
   MAKE_ICONSTANT((char*)"GDK_KEY_emacron",0x3ba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ayb",0x1000561),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_PieubSios",0xeb4),
   MAKE_ICONSTANT((char*)"GTK_INPUT_ERROR",-1),
   MAKE_ICONSTANT((char*)"GDK_KEY_thinspace",0xaa7),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TIFINAGH",G_UNICODE_SCRIPT_TIFINAGH),
   MAKE_ICONSTANT((char*)"GDK_ZoomOut",0x1008ff8c),
   MAKE_ICONSTANT((char*)"GDK_Reply",0x1008ff72),
   MAKE_ICONSTANT((char*)"GDK_Georgian_he",0x10010f1),
   MAKE_ICONSTANT((char*)"GTK_TOOLBAR_SPACE_EMPTY",GTK_TOOLBAR_SPACE_EMPTY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Rcaron",0x1d8),
   MAKE_ICONSTANT((char*)"GDK_FRAME_CLOCK_PHASE_LAYOUT",GDK_FRAME_CLOCK_PHASE_LAYOUT),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_INVALID_ARGS",G_DBUS_ERROR_INVALID_ARGS),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_nun",0xcf0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_57",0x1002850),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_LEFT",GTK_STACK_TRANSITION_TYPE_OVER_LEFT),
   MAKE_ICONSTANT((char*)"GDK_Thai_khorakhang",0xda6),
   MAKE_ICONSTANT((char*)"GTK_PRINT_OPERATION_RESULT_APPLY",GTK_PRINT_OPERATION_RESULT_APPLY),
   MAKE_ICONSTANT((char*)"GDK_filledrighttribullet",0xadd),
   MAKE_ICONSTANT((char*)"GDK_ubreve",0x2fd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MEROITIC_HIEROGLYPHS",G_UNICODE_SCRIPT_MEROITIC_HIEROGLYPHS),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_EN",0x6ee),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TAKRI",PANGO_SCRIPT_TAKRI),
   MAKE_ICONSTANT((char*)"GDK_hebrew_lamed",0xcec),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CARIAN",G_UNICODE_SCRIPT_CARIAN),
   MAKE_ICONSTANT((char*)"GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_LEFT_TO_RIGHT",GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_LEFT_TO_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_yoyak",0xdc2),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_DOCK",GDK_WINDOW_TYPE_HINT_DOCK),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_28",0x1002882),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_khorakhang",0xda6),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_SA",0x4bb),
   MAKE_ICONSTANT((char*)"GTK_SPIN_HOME",GTK_SPIN_HOME),
   MAKE_ICONSTANT((char*)"GDK_KEY_Scroll_Lock",0xff14),
   MAKE_ICONSTANT((char*)"GDK_Game",0x1008ff5e),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_SYMBOLIC_LINK",G_IO_ERROR_NOT_SYMBOLIC_LINK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraue",0xdd6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Next_VMode",0x1008fe22),
   MAKE_ICONSTANT((char*)"GDK_Greek_PI",0x7d0),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ma",0x1000db8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SYRIAC",PANGO_SCRIPT_SYRIAC),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HANGUL",PANGO_SCRIPT_HANGUL),
   MAKE_ICONSTANT((char*)"G_DATE_DECEMBER",G_DATE_DECEMBER),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ttha",0x1000da8),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_INSET",GTK_BORDER_STYLE_INSET),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_finalzadi",0xcf5),
   MAKE_ICONSTANT((char*)"GDK_KEY_F26",0xffd7),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MASARAM_GONDI",G_UNICODE_SCRIPT_MASARAM_GONDI),
   MAKE_ICONSTANT((char*)"GDK_kana_KI",0x4b7),
   MAKE_ICONSTANT((char*)"GDK_F27",0xffd8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_horizbar",0x7af),
   MAKE_ICONSTANT((char*)"GDK_parenleft",0x028),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_tu",0x4af),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_CONNECTION_REFUSED",G_IO_ERROR_CONNECTION_REFUSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_RE",0x1000550),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SIDDHAM",PANGO_SCRIPT_SIDDHAM),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_ANIMATION",GTK_IMAGE_ANIMATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_NE",0x4c8),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_ANCESTOR",GDK_NOTIFY_ANCESTOR),
   MAKE_ICONSTANT((char*)"GDK_t",0x074),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1367",0x1002865),
   MAKE_ICONSTANT((char*)"G_VARIANT_PARSE_ERROR_UNTERMINATED_STRING_CONSTANT",G_VARIANT_PARSE_ERROR_UNTERMINATED_STRING_CONSTANT),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Fast_Cursor_Left",0xfe2c),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_DOTTED",GTK_BORDER_STYLE_DOTTED),
   MAKE_ICONSTANT((char*)"GDK_Acircumflextilde",0x1001eaa),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_MFILE",G_FILE_ERROR_MFILE),
   MAKE_ICONSTANT((char*)"GDK_KEY_yacute",0x0fd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Away",0x1008ff8d),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_178",0x10028c1),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CAUCASIAN_ALBANIAN",PANGO_SCRIPT_CAUCASIAN_ALBANIAN),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_INVALID_FILENAME",G_IO_ERROR_INVALID_FILENAME),
   MAKE_ICONSTANT((char*)"GDK_Georgian_man",0x10010db),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_NXIO",G_IO_CHANNEL_ERROR_NXIO),
   MAKE_ICONSTANT((char*)"GDK_TOP_LEFT_CORNER",GDK_TOP_LEFT_CORNER),
   MAKE_ICONSTANT((char*)"GDK_rightdoublequotemark",0xad3),
   MAKE_ICONSTANT((char*)"G_SIGNAL_ACTION",G_SIGNAL_ACTION),
   MAKE_ICONSTANT((char*)"GDK_KEY_question",0x03f),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_breve",0xfe55),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_TO",0x4c4),
   MAKE_ICONSTANT((char*)"GDK_g",0x067),
   MAKE_ICONSTANT((char*)"GDK_KEY_Zabovedot",0x1af),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_ZE",0x6fa),
   MAKE_ICONSTANT((char*)"GDK_Arabic_5",0x1000665),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FONT_DESC",PANGO_ATTR_FONT_DESC),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_FORBIDDEN",G_REGEX_ERROR_BACKTRACKING_CONTROL_VERB_ARGUMENT_FORBIDDEN),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1345",0x100281d),
   MAKE_ICONSTANT((char*)"GDK_L5",0xffcc),
   MAKE_ICONSTANT((char*)"GDK_vt",0x9e9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Kanji",0xff21),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Rieul",0xedb),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OLD_HUNGARIAN",PANGO_SCRIPT_OLD_HUNGARIAN),
   MAKE_ICONSTANT((char*)"GDK_Meeting",0x1008ff63),
   MAKE_ICONSTANT((char*)"GDK_KEY_ubelowdot",0x1001ee5),
   MAKE_ICONSTANT((char*)"GDK_Thai_ngongu",0xda7),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_MASK",0x3f),
   MAKE_ICONSTANT((char*)"GDK_KEY_MonBrightnessDown",0x1008ff03),
   MAKE_ICONSTANT((char*)"GDK_logicaland",0x8de),
   MAKE_ICONSTANT((char*)"GDK_division",0x0f7),
   MAKE_ICONSTANT((char*)"GDK_Armenian_GHAT",0x1000542),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_FOREGROUND_ALPHA",PANGO_ATTR_FOREGROUND_ALPHA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ugrave",0x0d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_7",0x10006f7),
   MAKE_ICONSTANT((char*)"GDK_KEY_abrevegrave",0x1001eb1),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_bet",0xce1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ebelowdot",0x1001eb8),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YO",0xecb),
   MAKE_ICONSTANT((char*)"GDK_Sinh_nna",0x1000dab),
   MAKE_ICONSTANT((char*)"GDK_onesixth",0xab6),
   MAKE_ICONSTANT((char*)"GDK_botleftsummation",0x8b2),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_RANGE_OUT_OF_ORDER",G_REGEX_ERROR_RANGE_OUT_OF_ORDER),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_34578",0x10028dc),
   MAKE_ICONSTANT((char*)"GTK_TEXT_WINDOW_RIGHT",GTK_TEXT_WINDOW_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_abrevetilde",0x1001eb5),
   MAKE_ICONSTANT((char*)"GDK_kcedilla",0x3f3),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_NEWLINE_TYPE_CR_LF",G_DATA_STREAM_NEWLINE_TYPE_CR_LF),
   MAKE_ICONSTANT((char*)"GDK_Arabic_ha",0x5e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Lacute",0x1c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_a",0x6c1),
   MAKE_ICONSTANT((char*)"GDK_KEY_RELEASE_MASK",GDK_KEY_RELEASE_MASK),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_CONNECTION_CLOSED",G_IO_ERROR_CONNECTION_CLOSED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_168",0x10028a1),
   MAKE_ICONSTANT((char*)"GDK_KEY_overline",0x47e),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_678",0x10028e0),
   MAKE_ICONSTANT((char*)"GDK_threesubscript",0x1002083),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Cieuc",0xeba),
   MAKE_ICONSTANT((char*)"GDK_abreveacute",0x1001eaf),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_27",0x1002842),
   MAKE_ICONSTANT((char*)"GDK_similarequal",0x8c9),
   MAKE_ICONSTANT((char*)"GDK_KEY_emspace",0xaa1),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_ILLEGAL_SEQUENCE",G_CONVERT_ERROR_ILLEGAL_SEQUENCE),
   MAKE_ICONSTANT((char*)"GDK_DELETE",GDK_DELETE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LINEAR_B",G_UNICODE_SCRIPT_LINEAR_B),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_INVALID",G_CREDENTIALS_TYPE_INVALID),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_rho",0x7f1),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioMedia",0x1008ff32),
   MAKE_ICONSTANT((char*)"GDK_ucircumflex",0x0fb),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_NI",0x4c6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23567",0x1002876),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_ALLOW_BREAKS",PANGO_ATTR_ALLOW_BREAKS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_TE",0x6f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch9",0x1008ff49),
   MAKE_ICONSTANT((char*)"GDK_TOP_TEE",GDK_TOP_TEE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_o2",0x1000ddc),
   MAKE_ICONSTANT((char*)"GTK_ORIENTATION_VERTICAL",GTK_ORIENTATION_VERTICAL),
   MAKE_ICONSTANT((char*)"GDK_KP_Up",0xff97),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23",0x1002806),
   MAKE_ICONSTANT((char*)"GDK_hebrew_taw",0xcfa),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_CHILD",GDK_WINDOW_CHILD),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_PHOENICIAN",PANGO_SCRIPT_PHOENICIAN),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_THAI",PANGO_SCRIPT_THAI),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_AHOM",PANGO_SCRIPT_AHOM),
   MAKE_ICONSTANT((char*)"GDK_KP_F1",0xff91),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_PARTIAL_INPUT",G_CONVERT_ERROR_PARTIAL_INPUT),
   MAKE_ICONSTANT((char*)"GTK_DRAG_RESULT_ERROR",GTK_DRAG_RESULT_ERROR),
   MAKE_ICONSTANT((char*)"GDK_Greek_LAMBDA",0x7cb),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_PAGE_SET",GTK_PRINT_CAPABILITY_PAGE_SET),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_MOUNTABLE",G_FILE_TYPE_MOUNTABLE),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_AN",PANGO_BIDI_TYPE_AN),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_INVALID_VALUE",G_BOOKMARK_FILE_ERROR_INVALID_VALUE),
   MAKE_ICONSTANT((char*)"GDK_Green",0x1008ffa4),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_RieulHieuh",0xee2),
   MAKE_ICONSTANT((char*)"GDK_KEY_dcaron",0x1ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_EO",0xec3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_234568",0x10028be),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_SOFTSIGN",0x6f8),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_HOST_UNREACHABLE",G_IO_ERROR_HOST_UNREACHABLE),
   MAKE_ICONSTANT((char*)"GDK_LL_ANGLE",GDK_LL_ANGLE),
   MAKE_ICONSTANT((char*)"GDK_R8",0xffd9),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_CROSSFADE",GTK_STACK_TRANSITION_TYPE_CROSSFADE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflexacute",0x1001ea4),
   MAKE_ICONSTANT((char*)"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR",GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_358",0x1002894),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SsangPieub",0xeb3),
   MAKE_ICONSTANT((char*)"GDK_ncaron",0x1f2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Ieung",0xeb7),
   MAKE_ICONSTANT((char*)"GDK_ninesuperior",0x1002079),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KANNADA",G_UNICODE_SCRIPT_KANNADA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ssha",0x1000dc2),
   MAKE_ICONSTANT((char*)"GDK_TOP_LEFT_ARROW",GDK_TOP_LEFT_ARROW),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_AMBIGUOUS",G_UNICODE_BREAK_AMBIGUOUS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lakkhangyao",0xde5),
   MAKE_ICONSTANT((char*)"GDK_Calendar",0x1008ff20),
   MAKE_ICONSTANT((char*)"GDK_S",0x053),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Tieut",0xeec),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_EMPTY",G_IO_ERROR_NOT_EMPTY),
   MAKE_ICONSTANT((char*)"GDK_WA_WMCLASS",GDK_WA_WMCLASS),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGE_RIGHT",GTK_SCROLL_PAGE_RIGHT),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TAMIL",PANGO_SCRIPT_TAMIL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ie",0x6c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_yech",0x1000565),
   MAKE_ICONSTANT((char*)"GDK_Thai_phophan",0xdbe),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_PIXEL_CACHE",GTK_DEBUG_PIXEL_CACHE),
   MAKE_ICONSTANT((char*)"GDK_kana_NI",0x4c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3578",0x10028d4),
   MAKE_ICONSTANT((char*)"GDK_KEY_F31",0xffdc),
   MAKE_ICONSTANT((char*)"GDK_9",0x039),
   MAKE_ICONSTANT((char*)"GDK_Thai_sosala",0xdc8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_34567",0x100287c),
   MAKE_ICONSTANT((char*)"GTK_RECENT_FILTER_DISPLAY_NAME",GTK_RECENT_FILTER_DISPLAY_NAME),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_I",0xfe85),
   MAKE_ICONSTANT((char*)"GDK_KEY_Subtitle",0x1008ff9a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_leksam",0xdf3),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_i",0xfe84),
   MAKE_ICONSTANT((char*)"GDK_leftdoublequotemark",0xad2),
   MAKE_ICONSTANT((char*)"GDK_LSB_FIRST",GDK_LSB_FIRST),
   MAKE_ICONSTANT((char*)"GDK_R15",0xffe0),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Sios",0xeb5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_568",0x10028b0),
   MAKE_ICONSTANT((char*)"GDK_Arabic_sheen",0x5d4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_3457",0x100285c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Jieuj",0xee9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Launch5",0x1008ff45),
   MAKE_ICONSTANT((char*)"G_APPLICATION_FLAGS_NONE",G_APPLICATION_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_INSERT_HYPHENS",PANGO_ATTR_INSERT_HYPHENS),
   MAKE_ICONSTANT((char*)"GDK_Wacute",0x1001e82),
   MAKE_ICONSTANT((char*)"GDK_KEY_Go",0x1008ff5f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_AraeAE",0xef7),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_TABLET_STYLUS",GDK_SEAT_CAPABILITY_TABLET_STYLUS),
   MAKE_ICONSTANT((char*)"GDK_KP_Page_Up",0xff9a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_YeorinHieuh",0xefa),
   MAKE_ICONSTANT((char*)"G_REGEX_MATCH_NOTEMPTY",G_REGEX_MATCH_NOTEMPTY),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_YeorinHieuh",0xefa),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_CERTIFICATE_REQUIRED",G_TLS_ERROR_CERTIFICATE_REQUIRED),
   MAKE_ICONSTANT((char*)"GDK_KEY_function",0x8f6),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_45678",0x10028f8),
   MAKE_ICONSTANT((char*)"GDK_atilde",0x0e3),
   MAKE_ICONSTANT((char*)"GTK_BUTTONS_OK_CANCEL",GTK_BUTTONS_OK_CANCEL),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Release_Margin_Right",0xfe2a),
   MAKE_ICONSTANT((char*)"GDK_KEY_F28",0xffd9),
   MAKE_ICONSTANT((char*)"GDK_FUNC_MINIMIZE",GDK_FUNC_MINIMIZE),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_TIMED_OUT",G_DBUS_ERROR_TIMED_OUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Multiply",0xffaa),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Phieuf",0xeed),
   MAKE_ICONSTANT((char*)"G_UNICODE_SPACE_SEPARATOR",G_UNICODE_SPACE_SEPARATOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_4578",0x10028d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_he",0x10010f1),
   MAKE_ICONSTANT((char*)"GDK_MOD1_MASK",GDK_MOD1_MASK),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_ROOT",GDK_WINDOW_ROOT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_sad",0x5d5),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2678",0x10028e2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ca",0x1000da0),
   MAKE_ICONSTANT((char*)"GDK_Arabic_veh",0x10006a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_SplitScreen",0x1008ff7d),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1358",0x1002895),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_NO_SPELLCHECK",GTK_INPUT_HINT_NO_SPELLCHECK),
   MAKE_ICONSTANT((char*)"GDK_KEY_Acircumflexbelowdot",0x1001eac),
   MAKE_ICONSTANT((char*)"GDK_MouseKeys_Enable",0xfe76),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT",GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_PE",0x100054a),
   MAKE_ICONSTANT((char*)"GDK_LaunchD",0x1008ff4d),
   MAKE_ICONSTANT((char*)"GDK_hebrew_bet",0xce1),
   MAKE_ICONSTANT((char*)"G_FILE_MONITOR_EVENT_MOVED",G_FILE_MONITOR_EVENT_MOVED),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_MO",0x4d3),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INCONSISTENT_NEWLINE_OPTIONS",G_REGEX_ERROR_INCONSISTENT_NEWLINE_OPTIONS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ben",0x1000562),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_MOTIF",GDK_DRAG_PROTO_MOTIF),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_FINISHED",GTK_PRINT_STATUS_FINISHED),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_I",0x6e9),
   MAKE_ICONSTANT((char*)"GDK_AXIS_LAST",GDK_AXIS_LAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_Overlay1_Enable",0xfe78),
   MAKE_ICONSTANT((char*)"GDK_KEY_ediaeresis",0x0eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Left",0xfee0),
   MAKE_ICONSTANT((char*)"GDK_KEY_wacute",0x1001e83),
   MAKE_ICONSTANT((char*)"GDK_ISO_Level3_Shift",0xfe03),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightpointer",0xaeb),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_SHIFT_GROUP",GDK_MODIFIER_INTENT_SHIFT_GROUP),
   MAKE_ICONSTANT((char*)"GDK_Thai_lekpaet",0xdf8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_145678",0x10028f9),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_NONLINEAR_VIRTUAL",GDK_NOTIFY_NONLINEAR_VIRTUAL),
   MAKE_ICONSTANT((char*)"GDK_kana_u",0x4a9),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_INCOMPLETE_ANIMATION",GDK_PIXBUF_ERROR_INCOMPLETE_ANIMATION),
   MAKE_ICONSTANT((char*)"GDK_KEY_First_Virtual_Screen",0xfed0),
   MAKE_ICONSTANT((char*)"GDK_GRAB_ALREADY_GRABBED",GDK_GRAB_ALREADY_GRABBED),
   MAKE_ICONSTANT((char*)"GDK_Hangul_RieulYeorinHieuh",0xeef),
   MAKE_ICONSTANT((char*)"GDK_eightsuperior",0x1002078),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ho",0x1000570),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1357",0x1002855),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioPrev",0x1008ff16),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_yentamna",0x100058a),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_samekh",0xcf1),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_EMOJI_MODIFIER",G_UNICODE_BREAK_EMOJI_MODIFIER),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Kiyeog",0xed4),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_TIBETAN",PANGO_SCRIPT_TIBETAN),
   MAKE_ICONSTANT((char*)"GDK_LiraSign",0x10020a4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_BEN",0x1000532),
   MAKE_ICONSTANT((char*)"GDK_SETTING_ACTION_CHANGED",GDK_SETTING_ACTION_CHANGED),
   MAKE_ICONSTANT((char*)"GDK_Uogonek",0x3d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_nonen",0xdb3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_567",0x1002870),
   MAKE_ICONSTANT((char*)"G_APPLICATION_HANDLES_COMMAND_LINE",G_APPLICATION_HANDLES_COMMAND_LINE),
   MAKE_ICONSTANT((char*)"GDK_KEY_f",0x066),
   MAKE_ICONSTANT((char*)"GDK_Armenian_to",0x1000569),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_AYB",0x1000531),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_NEW_TAI_LUE",G_UNICODE_SCRIPT_NEW_TAI_LUE),
   MAKE_ICONSTANT((char*)"GDK_HINT_RESIZE_INC",GDK_HINT_RESIZE_INC),
   MAKE_ICONSTANT((char*)"GDK_cuberoot",0x100221b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_CHA",0x1000549),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_EL",0x6ec),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_ALL_COMPOSE",G_NORMALIZE_ALL_COMPOSE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2378",0x10028c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_ccircumflex",0x2e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_kcedilla",0x3f3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ehook",0x1001eba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag5",0xfefd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_TELUGU",G_UNICODE_SCRIPT_TELUGU),
   MAKE_ICONSTANT((char*)"GDK_KEY_abreve",0x1e3),
   MAKE_ICONSTANT((char*)"GDK_KEY_semivoicedsound",0x4df),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_EN_descender",0x10004a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ZE",0x6fa),
   MAKE_ICONSTANT((char*)"GDK_KEY_eightsuperior",0x1002078),
   MAKE_ICONSTANT((char*)"GDK_F3",0xffc0),
   MAKE_ICONSTANT((char*)"GDK_SUBSTRUCTURE_MASK",GDK_SUBSTRUCTURE_MASK),
   MAKE_ICONSTANT((char*)"GDK_dead_abovecomma",0xfe64),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_FULLSCREEN",GDK_WINDOW_STATE_FULLSCREEN),
   MAKE_ICONSTANT((char*)"GDK_KP_Begin",0xff9d),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tools",0x1008ff81),
   MAKE_ICONSTANT((char*)"GDK_Armenian_YECH",0x1000535),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_EXPANDABLE",GTK_CELL_RENDERER_EXPANDABLE),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CARIAN",PANGO_SCRIPT_CARIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_damma",0x5ef),
   MAKE_ICONSTANT((char*)"GDK_Hangul_E",0xec4),
   MAKE_ICONSTANT((char*)"GDK_VendorHome",0x1008ff34),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_ZETA",0x7c6),
   MAKE_ICONSTANT((char*)"G_SOCKET_FAMILY_INVALID",G_SOCKET_FAMILY_INVALID),
   MAKE_ICONSTANT((char*)"GDK_KEY_infinity",0x8c2),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SINHALA",PANGO_SCRIPT_SINHALA),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_ALL",GDK_SEAT_CAPABILITY_ALL),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_REJANG",G_UNICODE_SCRIPT_REJANG),
   MAKE_ICONSTANT((char*)"GDK_KEY_ehook",0x1001ebb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_SHA",0x1000547),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ef",0x6c6),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP",GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ini",0x100056b),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_14578",0x10028d9),
   MAKE_ICONSTANT((char*)"GDK_Thai_leksi",0xdf4),
   MAKE_ICONSTANT((char*)"GDK_RIGHT_PTR",GDK_RIGHT_PTR),
   MAKE_ICONSTANT((char*)"GDK_integral",0x8bf),
   MAKE_ICONSTANT((char*)"GDK_overbar",0xbc0),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_cedilla",0xfe5b),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_kje",0x6ac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_KiyeogSios",0xea3),
   MAKE_ICONSTANT((char*)"GDK_Launch1",0x1008ff41),
   MAKE_ICONSTANT((char*)"GDK_y",0x079),
   MAKE_ICONSTANT((char*)"GDK_Pointer_DfltBtnPrev",0xfefc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_2",0x1000662),
   MAKE_ICONSTANT((char*)"GDK_ISO_Partial_Line_Up",0xfe23),
   MAKE_ICONSTANT((char*)"GTK_DELETE_DISPLAY_LINE_ENDS",GTK_DELETE_DISPLAY_LINE_ENDS),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_PAU_CIN_HAU",G_UNICODE_SCRIPT_PAU_CIN_HAU),
   MAKE_ICONSTANT((char*)"GDK_KEY_Prior",0xff55),
   MAKE_ICONSTANT((char*)"GDK_E",0x045),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_READ_ONLY",G_IO_ERROR_READ_ONLY),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1478",0x10028c9),
   MAKE_ICONSTANT((char*)"GDK_GL_ERROR_UNSUPPORTED_FORMAT",GDK_GL_ERROR_UNSUPPORTED_FORMAT),
   MAKE_ICONSTANT((char*)"GDK_KEY_B",0x042),
   MAKE_ICONSTANT((char*)"GDK_KEY_Abrevegrave",0x1001eb0),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SOYOMBO",G_UNICODE_SCRIPT_SOYOMBO),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_en",0x6ce),
   MAKE_ICONSTANT((char*)"GDK_NOTIFY_INFERIOR",GDK_NOTIFY_INFERIOR),
   MAKE_ICONSTANT((char*)"GDK_Hstroke",0x2a1),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_PAGES",GTK_SCROLL_PAGES),
   MAKE_ICONSTANT((char*)"GDK_DRAFT_LARGE",GDK_DRAFT_LARGE),
   MAKE_ICONSTANT((char*)"GDK_lessthanequal",0x8bc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Delete",0xffff),
   MAKE_ICONSTANT((char*)"GDK_KEY_Iogonek",0x3c7),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_DIR_LTR",GTK_STATE_FLAG_DIR_LTR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_46",0x1002828),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_PE",0x6f0),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_MEROITIC_CURSIVE",PANGO_SCRIPT_MEROITIC_CURSIVE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Begin",0xff58),
   MAKE_ICONSTANT((char*)"GDK_KEY_gcaron",0x10001e7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2567",0x1002872),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ydiaeresis",0x13be),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12378",0x10028c7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_vyun",0x1000582),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohornhook",0x1001edf),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_23458",0x100289e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ycircumflex",0x1000176),
   MAKE_ICONSTANT((char*)"GDK_kana_HE",0x4cd),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_RIGHT_TILED",GDK_WINDOW_STATE_RIGHT_TILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Lcaron",0x1a5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_KA",0x6eb),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_13",0x1002805),
   MAKE_ICONSTANT((char*)"GDK_KEY_checkmark",0xaf3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_578",0x10028d0),
   MAKE_ICONSTANT((char*)"GDK_AudioNext",0x1008ff17),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SYLOTI_NAGRI",G_UNICODE_SCRIPT_SYLOTI_NAGRI),
   MAKE_ICONSTANT((char*)"GDK_Arabic_heh",0x5e7),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_HAN",PANGO_SCRIPT_HAN),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_DOUBLE",G_VARIANT_CLASS_DOUBLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_malesymbol",0xaf7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Oslash",0x0d8),
   MAKE_ICONSTANT((char*)"GDK_Print",0xff61),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_NieunJieuj",0xed8),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Group_Lock",0xfe07),
   MAKE_ICONSTANT((char*)"GDK_KEY_prescription",0xad4),
   MAKE_ICONSTANT((char*)"GDK_KP_7",0xffb7),
   MAKE_ICONSTANT((char*)"G_IO_STREAM_SPLICE_CLOSE_STREAM2",G_IO_STREAM_SPLICE_CLOSE_STREAM2),
   MAKE_ICONSTANT((char*)"GDK_Arabic_switch",0xff7e),
   MAKE_ICONSTANT((char*)"GDK_CONTROL_MASK",GDK_CONTROL_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_topleftsqbracket",0x8a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_m",0x06d),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioRewind",0x1008ff3e),
   MAKE_ICONSTANT((char*)"GDK_KEY_abreveacute",0x1001eaf),
   MAKE_ICONSTANT((char*)"PANGO_WRAP_CHAR",PANGO_WRAP_CHAR),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowbreve",0xfe6b),
   MAKE_ICONSTANT((char*)"GDK_Armenian_AYB",0x1000531),
   MAKE_ICONSTANT((char*)"GDK_Thai_dodek",0xdb4),
   MAKE_ICONSTANT((char*)"GDK_Atilde",0x0c3),
   MAKE_ICONSTANT((char*)"GDK_ahook",0x1001ea3),
   MAKE_ICONSTANT((char*)"GDK_VISUAL_STATIC_GRAY",GDK_VISUAL_STATIC_GRAY),
   MAKE_ICONSTANT((char*)"GDK_SELECTION_NOTIFY",GDK_SELECTION_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_BETA",0x7c2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_67",0x1002860),
   MAKE_ICONSTANT((char*)"G_RESOURCE_FLAGS_NONE",G_RESOURCE_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1346",0x100282d),
   MAKE_ICONSTANT((char*)"G_DBUS_CAPABILITY_FLAGS_UNIX_FD_PASSING",G_DBUS_CAPABILITY_FLAGS_UNIX_FD_PASSING),
   MAKE_ICONSTANT((char*)"GDK_Thai_wowaen",0xdc7),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_SOUTH_WEST",GDK_GRAVITY_SOUTH_WEST),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TOPLEVEL",GDK_WINDOW_TOPLEVEL),
   MAKE_ICONSTANT((char*)"GTK_SHADOW_ETCHED_IN",GTK_SHADOW_ETCHED_IN),
   MAKE_ICONSTANT((char*)"GDK_Phone",0x1008ff6e),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NFILE",G_FILE_ERROR_NFILE),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_KA",0x6eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_MouseKeys_Accel_Enable",0xfe77),
   MAKE_ICONSTANT((char*)"GDK_SHIFT_MASK",GDK_SHIFT_MASK),
   MAKE_ICONSTANT((char*)"GDK_ch",0xfea0),
   MAKE_ICONSTANT((char*)"GDK_schwa",0x1000259),
   MAKE_ICONSTANT((char*)"GTK_JUNCTION_CORNER_BOTTOMRIGHT",GTK_JUNCTION_CORNER_BOTTOMRIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ES",0x6f3),
   MAKE_ICONSTANT((char*)"GDK_Tcedilla",0x1de),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_14578",0x10028d9),
   MAKE_ICONSTANT((char*)"GDK_Thai_bobaimai",0xdba),
   MAKE_ICONSTANT((char*)"GDK_ihook",0x1001ec9),
   MAKE_ICONSTANT((char*)"GDK_U",0x055),
   MAKE_ICONSTANT((char*)"GDK_L6",0xffcd),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Play",0xfd16),
   MAKE_ICONSTANT((char*)"GTK_ICON_SIZE_DIALOG",GTK_ICON_SIZE_DIALOG),
   MAKE_ICONSTANT((char*)"GDK_KEY_variation",0x8c1),
   MAKE_ICONSTANT((char*)"GDK_C_h",0xfea4),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_PIPE",G_IO_CHANNEL_ERROR_PIPE),
   MAKE_ICONSTANT((char*)"GDK_INPUT_OUTPUT",GDK_INPUT_OUTPUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ograve",0x0d2),
   MAKE_ICONSTANT((char*)"GDK_Arabic_qaf",0x5e2),
   MAKE_ICONSTANT((char*)"GDK_notsign",0x0ac),
   MAKE_ICONSTANT((char*)"G_NETWORK_CONNECTIVITY_LIMITED",G_NETWORK_CONNECTIVITY_LIMITED),
   MAKE_ICONSTANT((char*)"GDK_KEY_t",0x074),
   MAKE_ICONSTANT((char*)"GDK_CROSSING_GRAB",GDK_CROSSING_GRAB),
   MAKE_ICONSTANT((char*)"G_RESOURCE_ERROR_INTERNAL",G_RESOURCE_ERROR_INTERNAL),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_STRING",G_FILE_ATTRIBUTE_TYPE_STRING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tab",0xff09),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_LRO",PANGO_BIDI_TYPE_LRO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukrainian_i",0x6a6),
   MAKE_ICONSTANT((char*)"GDK_Rcaron",0x1d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_circumflex",0xfe52),
   MAKE_ICONSTANT((char*)"GDK_Greek_ALPHA",0x7c1),
   MAKE_ICONSTANT((char*)"GDK_b",0x062),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Cieuc",0xeba),
   MAKE_ICONSTANT((char*)"GDK_KEY_Shop",0x1008ff36),
   MAKE_ICONSTANT((char*)"GDK_Arabic_zah",0x5d8),
   MAKE_ICONSTANT((char*)"GTK_TEXT_SEARCH_TEXT_ONLY",GTK_TEXT_SEARCH_TEXT_ONLY),
   MAKE_ICONSTANT((char*)"G_UNICODE_OTHER_SYMBOL",G_UNICODE_OTHER_SYMBOL),
   MAKE_ICONSTANT((char*)"G_UNICODE_MATH_SYMBOL",G_UNICODE_MATH_SYMBOL),
   MAKE_ICONSTANT((char*)"GDK_Arabic_kasratan",0x5ed),
   MAKE_ICONSTANT((char*)"GTK_FONT_CHOOSER_LEVEL_VARIATIONS",GTK_FONT_CHOOSER_LEVEL_VARIATIONS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_de",0x6c4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GOTHIC",G_UNICODE_SCRIPT_GOTHIC),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_GICON",GTK_IMAGE_GICON),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_LATIN",PANGO_SCRIPT_LATIN),
   MAKE_ICONSTANT((char*)"GDK_KEY_soliddiamond",0x9e0),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Next",0xff9b),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_BYTE_STRING",G_FILE_ATTRIBUTE_TYPE_BYTE_STRING),
   MAKE_ICONSTANT((char*)"GDK_F16",0xffcd),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraam",0xdd3),
   MAKE_ICONSTANT((char*)"GDK_kana_MO",0x4d3),
   MAKE_ICONSTANT((char*)"GTK_DIR_RIGHT",GTK_DIR_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_Hangul_NieunJieuj",0xea5),
   MAKE_ICONSTANT((char*)"GDK_KEY_NairaSign",0x10020a6),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SCHWA",0x10004d8),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_BYTE_ORDER_BIG_ENDIAN",G_DATA_STREAM_BYTE_ORDER_BIG_ENDIAN),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_i",0x4a8),
   MAKE_ICONSTANT((char*)"GDK_HomePage",0x1008ff18),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_KANNADA",PANGO_SCRIPT_KANNADA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Left",0xff51),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1267",0x1002863),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_o",0x6cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_3270_Reset",0xfd08),
   MAKE_ICONSTANT((char*)"GDK_KEY_MyComputer",0x1008ff33),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_zain",0xce6),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_5",0xffb5),
   MAKE_ICONSTANT((char*)"GDK_dstroke",0x1f0),
   MAKE_ICONSTANT((char*)"GDK_KEY_breve",0x1a2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_sha",0x6db),
   MAKE_ICONSTANT((char*)"GDK_KEY_C_H",0xfea5),
   MAKE_ICONSTANT((char*)"GDK_Armenian_cha",0x1000579),
   MAKE_ICONSTANT((char*)"GDK_KEY_Linefeed",0xff0a),
   MAKE_ICONSTANT((char*)"GDK_KEY_LogWindowTree",0x1008fe24),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Insert",0xff9e),
   MAKE_ICONSTANT((char*)"GDK_AXIS_XTILT",GDK_AXIS_XTILT),
   MAKE_ICONSTANT((char*)"GDK_ccircumflex",0x2e6),
   MAKE_ICONSTANT((char*)"GDK_KEY_ycircumflex",0x1000177),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_EXISTS",G_IO_ERROR_EXISTS),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1457",0x1002859),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_GPL_3_0",GTK_LICENSE_GPL_3_0),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TYPE_FLOATING",GDK_DEVICE_TYPE_FLOATING),
   MAKE_ICONSTANT((char*)"GTK_SHORTCUT_GESTURE_STRETCH",GTK_SHORTCUT_GESTURE_STRETCH),
   MAKE_ICONSTANT((char*)"GDK_Sinh_nja",0x1000da6),
   MAKE_ICONSTANT((char*)"GDK_CLIENT_EVENT",GDK_CLIENT_EVENT),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Codeinput",0xff37),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_saraa",0xdd0),
   MAKE_ICONSTANT((char*)"GDK_Hangul_A",0xebf),
   MAKE_ICONSTANT((char*)"GDK_KEY_EuroSign",0x20ac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ghe",0x6c7),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_NOT_MOUNTABLE_FILE",G_IO_ERROR_NOT_MOUNTABLE_FILE),
   MAKE_ICONSTANT((char*)"GDK_hairspace",0xaa8),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GOTHIC",PANGO_SCRIPT_GOTHIC),
   MAKE_ICONSTANT((char*)"GDK_marker",0xabf),
   MAKE_ICONSTANT((char*)"GDK_KEY_parenleft",0x028),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_phar",0x10010e4),
   MAKE_ICONSTANT((char*)"G_TLS_ERROR_EOF",G_TLS_ERROR_EOF),
   MAKE_ICONSTANT((char*)"GDK_hebrew_aleph",0xce0),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_34678",0x10028ec),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MULTANI",G_UNICODE_SCRIPT_MULTANI),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ddha",0x1000daa),
   MAKE_ICONSTANT((char*)"G_DBUS_SERVER_FLAGS_RUN_IN_THREAD",G_DBUS_SERVER_FLAGS_RUN_IN_THREAD),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_SU",0x4bd),
   MAKE_ICONSTANT((char*)"GDK_Arabic_dad",0x5d6),
   MAKE_ICONSTANT((char*)"GDK_hebrew_gimmel",0xce2),
   MAKE_ICONSTANT((char*)"G_OUTPUT_STREAM_SPLICE_NONE",G_OUTPUT_STREAM_SPLICE_NONE),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_FLAGS_ALLOW_INTERACTIVE_AUTHORIZATION",G_DBUS_MESSAGE_FLAGS_ALLOW_INTERACTIVE_AUTHORIZATION),
   MAKE_ICONSTANT((char*)"G_APPLICATION_HANDLES_OPEN",G_APPLICATION_HANDLES_OPEN),
   MAKE_ICONSTANT((char*)"GDK_kana_TO",0x4c4),
   MAKE_ICONSTANT((char*)"GDK_twosuperior",0x0b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_nna",0x1000dab),
   MAKE_ICONSTANT((char*)"GDK_upstile",0xbd3),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_O",0x4b5),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_VE",0x6f7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_RA",0x100054c),
   MAKE_ICONSTANT((char*)"GDK_kana_HU",0x4cc),
   MAKE_ICONSTANT((char*)"GDK_ocircumflex",0x0f4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_shcha",0x6dd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_578",0x10028d0),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_STOP_TYPE_SHUTDOWN",G_DRIVE_START_STOP_TYPE_SHUTDOWN),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_fofa",0xdbd),
   MAKE_ICONSTANT((char*)"GDK_babovedot",0x1001e03),
   MAKE_ICONSTANT((char*)"GDK_Shift_L",0xffe1),
   MAKE_ICONSTANT((char*)"GDK_Acircumflexbelowdot",0x1001eac),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_thha",0x1000dae),
   MAKE_ICONSTANT((char*)"GDK_KEY_maltesecross",0xaf0),
   MAKE_ICONSTANT((char*)"G_RESOLVER_NAME_LOOKUP_FLAGS_IPV6_ONLY",G_RESOLVER_NAME_LOOKUP_FLAGS_IPV6_ONLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_F16",0xffcd),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13578",0x10028d5),
   MAKE_ICONSTANT((char*)"G_TLS_INTERACTION_HANDLED",G_TLS_INTERACTION_HANDLED),
   MAKE_ICONSTANT((char*)"G_ASCII_ALNUM",G_ASCII_ALNUM),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING",GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING),
   MAKE_ICONSTANT((char*)"GTK_STATE_FOCUSED",GTK_STATE_FOCUSED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_234",0x100280e),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MALFORMED_PROPERTY",G_REGEX_ERROR_MALFORMED_PROPERTY),
   MAKE_ICONSTANT((char*)"GDK_space",0x020),
   MAKE_ICONSTANT((char*)"GTK_INPUT_HINT_LOWERCASE",GTK_INPUT_HINT_LOWERCASE),
   MAKE_ICONSTANT((char*)"GDK_ycircumflex",0x1000177),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_VISITED",GTK_STATE_FLAG_VISITED),
   MAKE_ICONSTANT((char*)"G_REGEX_MULTILINE",G_REGEX_MULTILINE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_OE",0xeca),
   MAKE_ICONSTANT((char*)"GDK_squareroot",0x100221a),
   MAKE_ICONSTANT((char*)"GDK_NewSheqelSign",0x10020aa),
   MAKE_ICONSTANT((char*)"GDK_Sinh_lu2",0x1000ddf),
   MAKE_ICONSTANT((char*)"GDK_thorn",0x0fe),
   MAKE_ICONSTANT((char*)"GDK_rightpointer",0xaeb),
   MAKE_ICONSTANT((char*)"GDK_P",0x050),
   MAKE_ICONSTANT((char*)"GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID",-1),
   MAKE_ICONSTANT((char*)"GDK_eogonek",0x1ea),
   MAKE_ICONSTANT((char*)"GDK_kana_FU",0x4cc),
   MAKE_ICONSTANT((char*)"GDK_fourfifths",0xab5),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_HA",0x4ca),
   MAKE_ICONSTANT((char*)"GDK_AudioPrev",0x1008ff16),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_INTENT_NO_TEXT_INPUT",GDK_MODIFIER_INTENT_NO_TEXT_INPUT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_au2",0x1000dde),
   MAKE_ICONSTANT((char*)"GTK_CALENDAR_NO_MONTH_CHANGE",GTK_CALENDAR_NO_MONTH_CHANGE),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_MIT_X11",GTK_LICENSE_MIT_X11),
   MAKE_ICONSTANT((char*)"GDK_Greek_upsilonaccent",0x7b8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hyper_R",0xffee),
   MAKE_ICONSTANT((char*)"GDK_ISO_Lock",0xfe01),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_SUNDANESE",PANGO_SCRIPT_SUNDANESE),
   MAKE_ICONSTANT((char*)"GDK_Cabovedot",0x2c5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Meta_L",0xffe7),
   MAKE_ICONSTANT((char*)"GDK_KEY_F13",0xffca),
   MAKE_ICONSTANT((char*)"GDK_includes",0x8db),
   MAKE_ICONSTANT((char*)"GDK_Fabovedot",0x1001e1e),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_BOOLEAN",G_VARIANT_CLASS_BOOLEAN),
   MAKE_ICONSTANT((char*)"GDK_3270_KeyClick",0xfd11),
   MAKE_ICONSTANT((char*)"GDK_KEY_kappa",0x3a2),
   MAKE_ICONSTANT((char*)"GDK_MODIFIER_RESERVED_24_MASK",GDK_MODIFIER_RESERVED_24_MASK),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_245",0x100281a),
   MAKE_ICONSTANT((char*)"PANGO_WEIGHT_LIGHT",PANGO_WEIGHT_LIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_i",0x6a6),
   MAKE_ICONSTANT((char*)"GDK_vertconnector",0x8a6),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_SET_MASK",G_IO_FLAG_SET_MASK),
   MAKE_ICONSTANT((char*)"GDK_KEY_L",0x04c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_honokhuk",0xdce),
   MAKE_ICONSTANT((char*)"GTK_MOVEMENT_BUFFER_ENDS",GTK_MOVEMENT_BUFFER_ENDS),
   MAKE_ICONSTANT((char*)"GDK_kana_WO",0x4a6),
   MAKE_ICONSTANT((char*)"GDK_Armenian_DZA",0x1000541),
   MAKE_ICONSTANT((char*)"GDK_KEY_onesuperior",0x0b9),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_READ",GTK_RECENT_MANAGER_ERROR_READ),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_TOO_MANY_CONDITIONAL_BRANCHES",G_REGEX_ERROR_TOO_MANY_CONDITIONAL_BRANCHES),
   MAKE_ICONSTANT((char*)"GDK_ohornbelowdot",0x1001ee3),
   MAKE_ICONSTANT((char*)"GDK_KEY_degree",0x0b0),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_yu",0x4ad),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Tieut",0xebc),
   MAKE_ICONSTANT((char*)"GDK_KEY_opentribulletup",0xae3),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU",GDK_WINDOW_TYPE_HINT_DROPDOWN_MENU),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3567",0x1002874),
   MAKE_ICONSTANT((char*)"GDK_DECOR_MENU",GDK_DECOR_MENU),
   MAKE_ICONSTANT((char*)"G_IO_CHANNEL_ERROR_FAILED",G_IO_CHANNEL_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Insert",0xff63),
   MAKE_ICONSTANT((char*)"PANGO_ELLIPSIZE_END",PANGO_ELLIPSIZE_END),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_gha",0x1000d9d),
   MAKE_ICONSTANT((char*)"GDK_KEY_copyright",0x0a9),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_DIALOG",GDK_WINDOW_TYPE_HINT_DIALOG),
   MAKE_ICONSTANT((char*)"GDK_F4",0xffc1),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_STRIKETHROUGH_COLOR",PANGO_ATTR_STRIKETHROUGH_COLOR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_2356",0x1002836),
   MAKE_ICONSTANT((char*)"G_UNICODE_OTHER_PUNCTUATION",G_UNICODE_OTHER_PUNCTUATION),
   MAKE_ICONSTANT((char*)"GDK_C",0x043),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Phieuf",0xebd),
   MAKE_ICONSTANT((char*)"GDK_brokenbar",0x0a6),
   MAKE_ICONSTANT((char*)"GDK_CROSS_REVERSE",GDK_CROSS_REVERSE),
   MAKE_ICONSTANT((char*)"GDK_kana_NO",0x4c9),
   MAKE_ICONSTANT((char*)"GDK_SB_RIGHT_ARROW",GDK_SB_RIGHT_ARROW),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY",GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_nja",0x1000da6),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_grave",0xfe50),
   MAKE_ICONSTANT((char*)"GDK_downstile",0xbc4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_4568",0x10028b8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Prev_Virtual_Screen",0xfed1),
   MAKE_ICONSTANT((char*)"GDK_topvertsummationconnector",0x8b3),
   MAKE_ICONSTANT((char*)"G_IO_STATUS_ERROR",G_IO_STATUS_ERROR),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12468",0x10028ab),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2578",0x10028d2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_PreHanja",0xff3a),
   MAKE_ICONSTANT((char*)"GDK_Arabic_jeem",0x5cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_WakeUp",0x1008ff2b),
   MAKE_ICONSTANT((char*)"GDK_Thai_leksun",0xdf0),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_DROP_BELOW",GTK_ICON_VIEW_DROP_BELOW),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YA",0xec1),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_RESIZE_X",GDK_ANCHOR_RESIZE_X),
   MAKE_ICONSTANT((char*)"GDK_rcaron",0x1f8),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_256",0x1002832),
   MAKE_ICONSTANT((char*)"GDK_KEY_twothirds",0xab1),
   MAKE_ICONSTANT((char*)"GDK_Tslash",0x3ac),
   MAKE_ICONSTANT((char*)"G_REGEX_DOLLAR_ENDONLY",G_REGEX_DOLLAR_ENDONLY),
   MAKE_ICONSTANT((char*)"GDK_KEY_LogOff",0x1008ff61),
   MAKE_ICONSTANT((char*)"GTK_BORDER_STYLE_NONE",GTK_BORDER_STYLE_NONE),
   MAKE_ICONSTANT((char*)"GTK_MESSAGE_QUESTION",GTK_MESSAGE_QUESTION),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_lekha",0xdf5),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123456",0x100283f),
   MAKE_ICONSTANT((char*)"GDK_KEY_ColonSign",0x10020a1),
   MAKE_ICONSTANT((char*)"GDK_kana_MA",0x4cf),
   MAKE_ICONSTANT((char*)"GDK_2",0x032),
   MAKE_ICONSTANT((char*)"G_REGEX_UNGREEDY",G_REGEX_UNGREEDY),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_NOTDIR",G_FILE_ERROR_NOTDIR),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GRANTHA",PANGO_SCRIPT_GRANTHA),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_dhha",0x1000db0),
   MAKE_ICONSTANT((char*)"GDK_Z",0x05a),
   MAKE_ICONSTANT((char*)"GDK_Armenian_PE",0x100054a),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_NONE",G_DRIVE_START_NONE),
   MAKE_ICONSTANT((char*)"GDK_User1KB",0x1008ff85),
   MAKE_ICONSTANT((char*)"GTK_INPUT_PURPOSE_NUMBER",GTK_INPUT_PURPOSE_NUMBER),
   MAKE_ICONSTANT((char*)"GDK_Sinh_rii",0x1000d8e),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_jnya",0x1000da5),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1467",0x1002869),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_OMICRONaccent",0x7a7),
   MAKE_ICONSTANT((char*)"GDK_KEY_telephonerecorder",0xafa),
   MAKE_ICONSTANT((char*)"GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT",GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT),
   MAKE_ICONSTANT((char*)"GDK_BackForward",0x1008ff3f),
   MAKE_ICONSTANT((char*)"GDK_ModeLock",0x1008ff01),
   MAKE_ICONSTANT((char*)"GDK_KEY_ohorngrave",0x1001edd),
   MAKE_ICONSTANT((char*)"GDK_KEY_downarrow",0x8fe),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_GPL_2_0_ONLY",GTK_LICENSE_GPL_2_0_ONLY),
   MAKE_ICONSTANT((char*)"GDK_egrave",0x0e8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_TAU",0x7d4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LYDIAN",G_UNICODE_SCRIPT_LYDIAN),
   MAKE_ICONSTANT((char*)"GDK_eacute",0x0e9),
   MAKE_ICONSTANT((char*)"GDK_Back",0x1008ff26),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Decimal",0xffae),
   MAKE_ICONSTANT((char*)"GDK_Sinh_u",0x1000d8b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ch",0xfea1),
   MAKE_ICONSTANT((char*)"GDK_KEY_abrevehook",0x1001eb3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Eject",0x1008ff2c),
   MAKE_ICONSTANT((char*)"GDK_oacute",0x0f3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_ken",0x100056f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_YU",0xed0),
   MAKE_ICONSTANT((char*)"GDK_dead_ogonek",0xfe5c),
   MAKE_ICONSTANT((char*)"GDK_singlelowquotemark",0xafd),
   MAKE_ICONSTANT((char*)"G_FORMAT_SIZE_DEFAULT",G_FORMAT_SIZE_DEFAULT),
   MAKE_ICONSTANT((char*)"GDK_Ccircumflex",0x2c6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Aogonek",0x1a1),
   MAKE_ICONSTANT((char*)"GDK_Save",0x1008ff77),
   MAKE_ICONSTANT((char*)"GDK_KEY_AudioForward",0x1008ff97),
   MAKE_ICONSTANT((char*)"GDK_Farsi_8",0x10006f8),
   MAKE_ICONSTANT((char*)"PANGO_ATTR_SHOW",PANGO_ATTR_SHOW),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_134568",0x10028bd),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MRO",G_UNICODE_SCRIPT_MRO),
   MAKE_ICONSTANT((char*)"GDK_UWB",0x1008ff96),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_baht",0xddf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Pieub",0xeb2),
   MAKE_ICONSTANT((char*)"GTK_CELL_RENDERER_MODE_ACTIVATABLE",GTK_CELL_RENDERER_MODE_ACTIVATABLE),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LINEAR_A",G_UNICODE_SCRIPT_LINEAR_A),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23567",0x1002876),
   MAKE_ICONSTANT((char*)"G_DATE_JANUARY",G_DATE_JANUARY),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_FLAGS_NO_AUTO_START",G_DBUS_MESSAGE_FLAGS_NO_AUTO_START),
   MAKE_ICONSTANT((char*)"GDK_Egrave",0x0c8),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_BUILDER",GTK_DEBUG_BUILDER),
   MAKE_ICONSTANT((char*)"G_CONVERT_ERROR_FAILED",G_CONVERT_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ruu2",0x1000df2),
   MAKE_ICONSTANT((char*)"GDK_KbdBrightnessUp",0x1008ff05),
   MAKE_ICONSTANT((char*)"GDK_ISO_Release_Margin_Right",0xfe2a),
   MAKE_ICONSTANT((char*)"G_ASCII_GRAPH",G_ASCII_GRAPH),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ROTATE_CLOCKWISE",GDK_PIXBUF_ROTATE_CLOCKWISE),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_TYPE_UINT64",G_FILE_ATTRIBUTE_TYPE_UINT64),
   MAKE_ICONSTANT((char*)"GDK_zacute",0x1bc),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_IMPERIAL_ARAMAIC",G_UNICODE_SCRIPT_IMPERIAL_ARAMAIC),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_TEMPLATES",G_USER_DIRECTORY_TEMPLATES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Serbian_LJE",0x6b9),
   MAKE_ICONSTANT((char*)"GDK_KEY_RotateWindows",0x1008ff74),
   MAKE_ICONSTANT((char*)"GDK_KEY_zacute",0x1bc),
   MAKE_ICONSTANT((char*)"GDK_Sinh_nya",0x1000da4),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_o",0x6cf),
   MAKE_ICONSTANT((char*)"GDK_k",0x06b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Yacute",0x0dd),
   MAKE_ICONSTANT((char*)"GDK_KEY_UWB",0x1008ff96),
   MAKE_ICONSTANT((char*)"GDK_UR_ANGLE",GDK_UR_ANGLE),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_138",0x1002885),
   MAKE_ICONSTANT((char*)"GDK_D",0x044),
   MAKE_ICONSTANT((char*)"GDK_underbar",0xbc6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_126",0x1002823),
   MAKE_ICONSTANT((char*)"GDK_oe",0x13bd),
   MAKE_ICONSTANT((char*)"G_USER_DIRECTORY_PUBLIC_SHARE",G_USER_DIRECTORY_PUBLIC_SHARE),
   MAKE_ICONSTANT((char*)"GDK_Arabic_heh_goal",0x10006c1),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_GJE",0x6b2),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Add",0xffab),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_sarauee",0xdd7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_RA",0x4d7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_SE",0x4be),
   MAKE_ICONSTANT((char*)"GDK_KEY_nobreakspace",0x0a0),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_COLUMN_AUTOSIZE",GTK_TREE_VIEW_COLUMN_AUTOSIZE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_khokhon",0xda5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_TYUN",0x100054f),
   MAKE_ICONSTANT((char*)"GDK_F34",0xffdf),
   MAKE_ICONSTANT((char*)"GDK_KEY_cr",0x9e4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ghe_bar",0x1000493),
   MAKE_ICONSTANT((char*)"GDK_KP_Enter",0xff8d),
   MAKE_ICONSTANT((char*)"G_DBUS_SIGNAL_FLAGS_MATCH_ARG0_PATH",G_DBUS_SIGNAL_FLAGS_MATCH_ARG0_PATH),
   MAKE_ICONSTANT((char*)"GDK_Greek_etaaccent",0x7b3),
   MAKE_ICONSTANT((char*)"GDK_prescription",0xad4),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1345678",0x10028fd),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_fullstop",0x4a1),
   MAKE_ICONSTANT((char*)"GDK_Greek_iota",0x7e9),
   MAKE_ICONSTANT((char*)"GTK_ARROWS_BOTH",GTK_ARROWS_BOTH),
   MAKE_ICONSTANT((char*)"G_APPLICATION_IS_LAUNCHER",G_APPLICATION_IS_LAUNCHER),
   MAKE_ICONSTANT((char*)"GTK_LEVEL_BAR_MODE_CONTINUOUS",GTK_LEVEL_BAR_MODE_CONTINUOUS),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_rae",0x10010e0),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_PROPERTY_READ_ONLY",G_DBUS_ERROR_PROPERTY_READ_ONLY),
   MAKE_ICONSTANT((char*)"GDK_Prev_Virtual_Screen",0xfed1),
   MAKE_ICONSTANT((char*)"G_DATA_STREAM_NEWLINE_TYPE_LF",G_DATA_STREAM_NEWLINE_TYPE_LF),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_CANADIAN_ABORIGINAL",PANGO_SCRIPT_CANADIAN_ABORIGINAL),
   MAKE_ICONSTANT((char*)"GDK_SOURCE_KEYBOARD",GDK_SOURCE_KEYBOARD),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_chet",0xce7),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_HI",0x4cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_35",0x1002814),
   MAKE_ICONSTANT((char*)"G_DBUS_CALL_FLAGS_NONE",G_DBUS_CALL_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ng",0x1000d82),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_INTR",G_FILE_ERROR_INTR),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_RieulTieut",0xeae),
   MAKE_ICONSTANT((char*)"GDK_Hangul_AraeAE",0xef7),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12368",0x10028a7),
   MAKE_ICONSTANT((char*)"G_TLS_DATABASE_LOOKUP_NONE",G_TLS_DATABASE_LOOKUP_NONE),
   MAKE_ICONSTANT((char*)"G_IO_STREAM_SPLICE_NONE",G_IO_STREAM_SPLICE_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ii2",0x1000dd3),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_124568",0x10028bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_RepeatKeys_Enable",0xfe72),
   MAKE_ICONSTANT((char*)"GDK_Copy",0x1008ff57),
   MAKE_ICONSTANT((char*)"GDK_StickyKeys_Enable",0xfe75),
   MAKE_ICONSTANT((char*)"GDK_3270_Copy",0xfd15),
   MAKE_ICONSTANT((char*)"G_PARAM_STATIC_BLURB",G_PARAM_STATIC_BLURB),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_GUNJALA_GONDI",G_UNICODE_SCRIPT_GUNJALA_GONDI),
   MAKE_ICONSTANT((char*)"GDK_abrevebelowdot",0x1001eb7),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1234678",0x10028ef),
   MAKE_ICONSTANT((char*)"GDK_KEY_Macedonia_KJE",0x6bc),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_RESIZE_Y",GDK_ANCHOR_RESIZE_Y),
   MAKE_ICONSTANT((char*)"G_VARIANT_CLASS_STRING",G_VARIANT_CLASS_STRING),
   MAKE_ICONSTANT((char*)"GDK_KEY_Tcedilla",0x1de),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_SHCHA",0x6fd),
   MAKE_ICONSTANT((char*)"GDK_OfficeHome",0x1008ff6a),
   MAKE_ICONSTANT((char*)"GDK_F12",0xffc9),
   MAKE_ICONSTANT((char*)"GDK_Hangul_PanSios",0xef2),
   MAKE_ICONSTANT((char*)"GDK_Sinh_tta",0x1000da7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Yhook",0x1001ef6),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_Drag4",0xfef8),
   MAKE_ICONSTANT((char*)"GDK_CROSSHAIR",GDK_CROSSHAIR),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_234678",0x10028ee),
   MAKE_ICONSTANT((char*)"GDK_3270_Jump",0xfd12),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_fofan",0xdbf),
   MAKE_ICONSTANT((char*)"GDK_ANCHOR_RESIZE",GDK_ANCHOR_RESIZE),
   MAKE_ICONSTANT((char*)"G_IO_STATUS_AGAIN",G_IO_STATUS_AGAIN),
   MAKE_ICONSTANT((char*)"GTK_STATE_INCONSISTENT",GTK_STATE_INCONSISTENT),
   MAKE_ICONSTANT((char*)"GDK_KEY_O",0x04f),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_15678",0x10028f1),
   MAKE_ICONSTANT((char*)"G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED",G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED),
   MAKE_ICONSTANT((char*)"GDK_Farsi_3",0x10006f3),
   MAKE_ICONSTANT((char*)"GDK_dead_U",0xfe89),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_3456",0x100283c),
   MAKE_ICONSTANT((char*)"GDK_dabovedot",0x1001e0b),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_PRINTING",GTK_DEBUG_PRINTING),
   MAKE_ICONSTANT((char*)"GDK_Hangul_SunkyeongeumPieub",0xef1),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_ai2",0x1000ddb),
   MAKE_ICONSTANT((char*)"GDK_hebrew_zade",0xcf6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12467",0x100286b),
   MAKE_ICONSTANT((char*)"GTK_IM_PREEDIT_NOTHING",GTK_IM_PREEDIT_NOTHING),
   MAKE_ICONSTANT((char*)"G_SIGNAL_RUN_CLEANUP",G_SIGNAL_RUN_CLEANUP),
   MAKE_ICONSTANT((char*)"GDK_DOUBLE_BUTTON_PRESS",GDK_DOUBLE_BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GDK_KEY_emfilledrect",0xadf),
   MAKE_ICONSTANT((char*)"GTK_CSS_PROVIDER_ERROR_DEPRECATED",GTK_CSS_PROVIDER_ERROR_DEPRECATED),
   MAKE_ICONSTANT((char*)"GDK_Georgian_cil",0x10010ec),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_End",0xff9c),
   MAKE_ICONSTANT((char*)"GDK_Ubelowdot",0x1001ee4),
   MAKE_ICONSTANT((char*)"GDK_KEY_digitspace",0xaa5),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_abovecomma",0xfe64),
   MAKE_ICONSTANT((char*)"G_FILE_COPY_OVERWRITE",G_FILE_COPY_OVERWRITE),
   MAKE_ICONSTANT((char*)"G_ASCII_CNTRL",G_ASCII_CNTRL),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_doublegrave",0xfe66),
   MAKE_ICONSTANT((char*)"GDK_Abrevebelowdot",0x1001eb6),
   MAKE_ICONSTANT((char*)"G_DRIVE_START_STOP_TYPE_MULTIDISK",G_DRIVE_START_STOP_TYPE_MULTIDISK),
   MAKE_ICONSTANT((char*)"GDK_KEY_MonBrightnessUp",0x1008ff02),
   MAKE_ICONSTANT((char*)"GDK_WheelButton",0x1008ff88),
   MAKE_ICONSTANT((char*)"GDK_Thai_yoyak",0xdc2),
   MAKE_ICONSTANT((char*)"GDK_KEY_Print",0xff61),
   MAKE_ICONSTANT((char*)"GDK_equal",0x03d),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1234",0x100280f),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_YA",0x6f1),
   MAKE_ICONSTANT((char*)"GTK_UNIT_NONE",GTK_UNIT_NONE),
   MAKE_ICONSTANT((char*)"GDK_sixsuperior",0x1002076),
   MAKE_ICONSTANT((char*)"GTK_STATE_FLAG_SELECTED",GTK_STATE_FLAG_SELECTED),
   MAKE_ICONSTANT((char*)"GDK_Babovedot",0x1001e02),
   MAKE_ICONSTANT((char*)"GDK_Uring",0x1d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_18",0x1002881),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_278",0x10028c2),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_136",0x1002825),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_HORIZONTAL_ENDS",GTK_SCROLL_HORIZONTAL_ENDS),
   MAKE_ICONSTANT((char*)"G_UNIX_SOCKET_ADDRESS_ABSTRACT",G_UNIX_SOCKET_ADDRESS_ABSTRACT),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_TOO_MANY_BRANCHES_IN_DEFINE",G_REGEX_ERROR_TOO_MANY_BRANCHES_IN_DEFINE),
   MAKE_ICONSTANT((char*)"GDK_Armenian_CHA",0x1000549),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_KHMER",G_UNICODE_SCRIPT_KHMER),
   MAKE_ICONSTANT((char*)"GDK_Lbelowdot",0x1001e36),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_heh_doachashmee",0x10006be),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_13568",0x10028b5),
   MAKE_ICONSTANT((char*)"G_DBUS_ERROR_SPAWN_CONFIG_INVALID",G_DBUS_ERROR_SPAWN_CONFIG_INVALID),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_TYPE_HINT_UTILITY",GDK_WINDOW_TYPE_HINT_UTILITY),
   MAKE_ICONSTANT((char*)"GDK_dead_psili",0xfe64),
   MAKE_ICONSTANT((char*)"GDK_3",0x033),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_on",0x10010dd),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_EDGE_EAST",GDK_WINDOW_EDGE_EAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12358",0x1002897),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_458",0x1002898),
   MAKE_ICONSTANT((char*)"GDK_Armenian_yentamna",0x100058a),
   MAKE_ICONSTANT((char*)"GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT",GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Documents",0x1008ff5b),
   MAKE_ICONSTANT((char*)"GDK_KEY_leftmiddlecurlybrace",0x8af),
   MAKE_ICONSTANT((char*)"GDK_identical",0x8cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_horizlinescan9",0x9f3),
   MAKE_ICONSTANT((char*)"G_OUTPUT_STREAM_SPLICE_CLOSE_SOURCE",G_OUTPUT_STREAM_SPLICE_CLOSE_SOURCE),
   MAKE_ICONSTANT((char*)"G_NORMALIZE_NFKC",G_NORMALIZE_NFKC),
   MAKE_ICONSTANT((char*)"GDK_Armenian_TSO",0x1000551),
   MAKE_ICONSTANT((char*)"GDK_KEY_o",0x06f),
   MAKE_ICONSTANT((char*)"G_BOOKMARK_FILE_ERROR_APP_NOT_REGISTERED",G_BOOKMARK_FILE_ERROR_APP_NOT_REGISTERED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_al",0x1000dca),
   MAKE_ICONSTANT((char*)"PANGO_RENDER_PART_STRIKETHROUGH",PANGO_RENDER_PART_STRIKETHROUGH),
   MAKE_ICONSTANT((char*)"GTK_PRINT_STATUS_PENDING",GTK_PRINT_STATUS_PENDING),
   MAKE_ICONSTANT((char*)"GDK_ehook",0x1001ebb),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_367",0x1002864),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_nya",0x1000da4),
   MAKE_ICONSTANT((char*)"G_TYPE_RESERVED_USER_FIRST",49),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_tyun",0x100057f),
   MAKE_ICONSTANT((char*)"GTK_MESSAGE_OTHER",GTK_MESSAGE_OTHER),
   MAKE_ICONSTANT((char*)"GDK_Idiaeresis",0x0cf),
   MAKE_ICONSTANT((char*)"GDK_KEY_AddFavorite",0x1008ff39),
   MAKE_ICONSTANT((char*)"GDK_KEY_Page_Up",0xff55),
   MAKE_ICONSTANT((char*)"GDK_KEY_asciicircum",0x05e),
   MAKE_ICONSTANT((char*)"GDK_DEVICE_TOOL_TYPE_UNKNOWN",GDK_DEVICE_TOOL_TYPE_UNKNOWN),
   MAKE_ICONSTANT((char*)"G_DBUS_INTERFACE_SKELETON_FLAGS_NONE",G_DBUS_INTERFACE_SKELETON_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Lstroke",0x1a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_uu",0x1000d8c),
   MAKE_ICONSTANT((char*)"GDK_ENTER_NOTIFY",GDK_ENTER_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag3",0xfef7),
   MAKE_ICONSTANT((char*)"GDK_Hangul_YEO",0xec5),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ediaeresis",0x0cb),
   MAKE_ICONSTANT((char*)"GDK_ellipsis",0xaae),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_MISSING_NAME",G_REGEX_ERROR_MISSING_NAME),
   MAKE_ICONSTANT((char*)"G_DATE_AUGUST",G_DATE_AUGUST),
   MAKE_ICONSTANT((char*)"GTK_LICENSE_LGPL_2_1_ONLY",GTK_LICENSE_LGPL_2_1_ONLY),
   MAKE_ICONSTANT((char*)"G_DATE_SEPTEMBER",G_DATE_SEPTEMBER),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ukranian_I",0x6b6),
   MAKE_ICONSTANT((char*)"PANGO_SHOW_SPACES",PANGO_SHOW_SPACES),
   MAKE_ICONSTANT((char*)"GDK_KEY_aogonek",0x1b1),
   MAKE_ICONSTANT((char*)"GDK_Armenian_RA",0x100054c),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ohorngrave",0x1001edc),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dot_7",0xfff7),
   MAKE_ICONSTANT((char*)"G_TEST_DBUS_NONE",G_TEST_DBUS_NONE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_Hanja",0xff34),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_INVALID_DATA_CHARACTER",G_REGEX_ERROR_INVALID_DATA_CHARACTER),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_37",0x1002844),
   MAKE_ICONSTANT((char*)"GDK_O",0x04f),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_123",0x1002807),
   MAKE_ICONSTANT((char*)"GDK_KEY_onequarter",0x0bc),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_NONE",GDK_DRAG_PROTO_NONE),
   MAKE_ICONSTANT((char*)"GDK_LaunchB",0x1008ff4b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_GHE",0x6e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_12478",0x10028cb),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_14678",0x10028e9),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_EXPRESSION_TOO_LARGE",G_REGEX_ERROR_EXPRESSION_TOO_LARGE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_PanSios",0xef8),
   MAKE_ICONSTANT((char*)"GDK_KEY_macron",0x0af),
   MAKE_ICONSTANT((char*)"GDK_Georgian_zen",0x10010d6),
   MAKE_ICONSTANT((char*)"GDK_F20",0xffd1),
   MAKE_ICONSTANT((char*)"GDK_doubledagger",0xaf2),
   MAKE_ICONSTANT((char*)"GDK_GRAB_INVALID_TIME",GDK_GRAB_INVALID_TIME),
   MAKE_ICONSTANT((char*)"GDK_zcaron",0x1be),
   MAKE_ICONSTANT((char*)"GDK_Thai_khokhwai",0xda4),
   MAKE_ICONSTANT((char*)"G_FILE_ATTRIBUTE_INFO_COPY_WITH_FILE",G_FILE_ATTRIBUTE_INFO_COPY_WITH_FILE),
   MAKE_ICONSTANT((char*)"GDK_KEY_agrave",0x0e0),
   MAKE_ICONSTANT((char*)"GDK_hebrew_zayin",0xce6),
   MAKE_ICONSTANT((char*)"GDK_FULLSCREEN_ON_CURRENT_MONITOR",GDK_FULLSCREEN_ON_CURRENT_MONITOR),
   MAKE_ICONSTANT((char*)"GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN",GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN),
   MAKE_ICONSTANT((char*)"GDK_Farsi_7",0x10006f7),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_zade",0xcf6),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_EAST",GDK_GRAVITY_EAST),
   MAKE_ICONSTANT((char*)"GDK_KEY_hebrew_shin",0xcf9),
   MAKE_ICONSTANT((char*)"GDK_KEY_doublelowquotemark",0xafe),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_men",0x1000574),
   MAKE_ICONSTANT((char*)"G_PARAM_WRITABLE",G_PARAM_WRITABLE),
   MAKE_ICONSTANT((char*)"PANGO_GRAVITY_SOUTH",PANGO_GRAVITY_SOUTH),
   MAKE_ICONSTANT((char*)"GDK_Kanji",0xff21),
   MAKE_ICONSTANT((char*)"GDK_KEY_Switch_VT_11",0x1008fe0b),
   MAKE_ICONSTANT((char*)"GDK_KEY_User1KB",0x1008ff85),
   MAKE_ICONSTANT((char*)"GDK_KEY_Wcircumflex",0x1000174),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_Begin",0xff9d),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_ACCES",G_FILE_ERROR_ACCES),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_E",0xec4),
   MAKE_ICONSTANT((char*)"GDK_Thai_yoying",0xdad),
   MAKE_ICONSTANT((char*)"GTK_ENTRY_ICON_SECONDARY",GTK_ENTRY_ICON_SECONDARY),
   MAKE_ICONSTANT((char*)"PANGO_BIDI_TYPE_LRE",PANGO_BIDI_TYPE_LRE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Book",0x1008ff52),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_WOULD_BLOCK",G_IO_ERROR_WOULD_BLOCK),
   MAKE_ICONSTANT((char*)"GDK_Ucircumflex",0x0db),
   MAKE_ICONSTANT((char*)"GDK_dead_u",0xfe88),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_Special",0xff3f),
   MAKE_ICONSTANT((char*)"G_CREDENTIALS_TYPE_FREEBSD_CMSGCRED",G_CREDENTIALS_TYPE_FREEBSD_CMSGCRED),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1256",0x1002833),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_TURKIC",G_UNICODE_SCRIPT_OLD_TURKIC),
   MAKE_ICONSTANT((char*)"G_KEY_FILE_NONE",G_KEY_FILE_NONE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_2467",0x100286a),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_1245",0x100281b),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_ru",0xdc4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Rcedilla",0x3a3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_OMEGA",0x7d9),
   MAKE_ICONSTANT((char*)"GDK_COLORSPACE_RGB",GDK_COLORSPACE_RGB),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_5678",0x10028f0),
   MAKE_ICONSTANT((char*)"GDK_3270_ChangeScreen",0xfd19),
   MAKE_ICONSTANT((char*)"GDK_Georgian_ban",0x10010d1),
   MAKE_ICONSTANT((char*)"GDK_Arabic_rreh",0x1000691),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ha",0x1000dc4),
   MAKE_ICONSTANT((char*)"GTK_TREE_VIEW_GRID_LINES_VERTICAL",GTK_TREE_VIEW_GRID_LINES_VERTICAL),
   MAKE_ICONSTANT((char*)"G_APPLICATION_ALLOW_REPLACEMENT",G_APPLICATION_ALLOW_REPLACEMENT),
   MAKE_ICONSTANT((char*)"G_UNICODE_LOWERCASE_LETTER",G_UNICODE_LOWERCASE_LETTER),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_137",0x1002845),
   MAKE_ICONSTANT((char*)"GDK_KEY_obelowdot",0x1001ecd),
   MAKE_ICONSTANT((char*)"G_DBUS_CAPABILITY_FLAGS_NONE",G_DBUS_CAPABILITY_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_LAST_CURSOR",GDK_LAST_CURSOR),
   MAKE_ICONSTANT((char*)"GDK_u",0x075),
   MAKE_ICONSTANT((char*)"GTK_PRINT_CAPABILITY_COLLATE",GTK_PRINT_CAPABILITY_COLLATE),
   MAKE_ICONSTANT((char*)"GDK_Eacute",0x0c9),
   MAKE_ICONSTANT((char*)"GDK_KEY_acircumflexbelowdot",0x1001ead),
   MAKE_ICONSTANT((char*)"GDK_eightsubscript",0x1002088),
   MAKE_ICONSTANT((char*)"GTK_PHASE_TARGET",GTK_PHASE_TARGET),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_delta",0x7e4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_choching",0xda9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_4",0x10006f4),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_LYCIAN",G_UNICODE_SCRIPT_LYCIAN),
   MAKE_ICONSTANT((char*)"GDK_Suspend",0x1008ffa7),
   MAKE_ICONSTANT((char*)"GTK_TREE_MODEL_ITERS_PERSIST",GTK_TREE_MODEL_ITERS_PERSIST),
   MAKE_ICONSTANT((char*)"GDK_Arabic_noon",0x5e6),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_KINETIC",GTK_EVENT_CONTROLLER_SCROLL_KINETIC),
   MAKE_ICONSTANT((char*)"GDK_AudioRewind",0x1008ff3e),
   MAKE_ICONSTANT((char*)"G_PRIORITY_DEFAULT_IDLE",200),
   MAKE_ICONSTANT((char*)"GDK_2BUTTON_PRESS",GDK_2BUTTON_PRESS),
   MAKE_ICONSTANT((char*)"GDK_KP_6",0xffb6),
   MAKE_ICONSTANT((char*)"GDK_Ukranian_JE",0x6b4),
   MAKE_ICONSTANT((char*)"GDK_kana_TE",0x4c3),
   MAKE_ICONSTANT((char*)"GDK_GUMBY",GDK_GUMBY),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_OSMANYA",PANGO_SCRIPT_OSMANYA),
   MAKE_ICONSTANT((char*)"GDK_Switch_VT_5",0x1008fe05),
   MAKE_ICONSTANT((char*)"GDK_Armenian_je",0x100057b),
   MAKE_ICONSTANT((char*)"GDK_Utilde",0x3dd),
   MAKE_ICONSTANT((char*)"GDK_INTERP_HYPER",GDK_INTERP_HYPER),
   MAKE_ICONSTANT((char*)"GDK_KEY_zcaron",0x1be),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_12367",0x1002867),
   MAKE_ICONSTANT((char*)"GDK_PENCIL",GDK_PENCIL),
   MAKE_ICONSTANT((char*)"G_SIGNAL_MATCH_ID",G_SIGNAL_MATCH_ID),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_358",0x1002894),
   MAKE_ICONSTANT((char*)"GTK_FILE_CHOOSER_ERROR_BAD_FILENAME",GTK_FILE_CHOOSER_ERROR_BAD_FILENAME),
   MAKE_ICONSTANT((char*)"G_CHECKSUM_SHA256",G_CHECKSUM_SHA256),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_NOTHING_TO_REPEAT",G_REGEX_ERROR_NOTHING_TO_REPEAT),
   MAKE_ICONSTANT((char*)"GDK_Ch",0xfea1),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_IS_SEEKABLE",G_IO_FLAG_IS_SEEKABLE),
   MAKE_ICONSTANT((char*)"GDK_ACTION_COPY",GDK_ACTION_COPY),
   MAKE_ICONSTANT((char*)"GDK_KEY_zstroke",0x10001b6),
   MAKE_ICONSTANT((char*)"GDK_Greek_sigma",0x7f2),
   MAKE_ICONSTANT((char*)"GDK_kana_fullstop",0x4a1),
   MAKE_ICONSTANT((char*)"GDK_thinspace",0xaa7),
   MAKE_ICONSTANT((char*)"GDK_downarrow",0x8fe),
   MAKE_ICONSTANT((char*)"GDK_R10",0xffdb),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Button5",0xfeed),
   MAKE_ICONSTANT((char*)"GDK_KEY_rightshoe",0xbd8),
   MAKE_ICONSTANT((char*)"GDK_SCROLL_RIGHT",GDK_SCROLL_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_luu",0x1000d90),
   MAKE_ICONSTANT((char*)"GDK_KEY_Sinh_au",0x1000d96),
   MAKE_ICONSTANT((char*)"GDK_KEY_logicaland",0x8de),
   MAKE_ICONSTANT((char*)"GDK_onequarter",0x0bc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_madda_above",0x1000653),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_RU",0x4d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_eta",0x7e7),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_yeru",0x6d9),
   MAKE_ICONSTANT((char*)"GDK_KEY_downcaret",0xba8),
   MAKE_ICONSTANT((char*)"GDK_MOTION_NOTIFY",GDK_MOTION_NOTIFY),
   MAKE_ICONSTANT((char*)"GDK_abrevegrave",0x1001eb1),
   MAKE_ICONSTANT((char*)"GDK_KEY_rcedilla",0x3b3),
   MAKE_ICONSTANT((char*)"GDK_ISO_Group_Shift",0xff7e),
   MAKE_ICONSTANT((char*)"GTK_IMAGE_PIXBUF",GTK_IMAGE_PIXBUF),
   MAKE_ICONSTANT((char*)"GDK_DOS",0x1008ff5a),
   MAKE_ICONSTANT((char*)"GDK_KEY_Ecircumflex",0x0ca),
   MAKE_ICONSTANT((char*)"GDK_KEY_kana_HU",0x4cc),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_maitho",0xde9),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_124568",0x10028bb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_6",0x10006f6),
   MAKE_ICONSTANT((char*)"G_TLS_PASSWORD_RETRY",G_TLS_PASSWORD_RETRY),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_RULESET",GTK_CSS_SECTION_RULESET),
   MAKE_ICONSTANT((char*)"GDK_DRAG_PROTO_LOCAL",GDK_DRAG_PROTO_LOCAL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_in",0x10010d8),
   MAKE_ICONSTANT((char*)"GDK_KEY_sacute",0x1b6),
   MAKE_ICONSTANT((char*)"GDK_Sinh_ga",0x1000d9c),
   MAKE_ICONSTANT((char*)"GDK_KEY_F21",0xffd2),
   MAKE_ICONSTANT((char*)"GTK_PACK_START",GTK_PACK_START),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_3",0xffb3),
   MAKE_ICONSTANT((char*)"GDK_KEY_Georgian_cil",0x10010ec),
   MAKE_ICONSTANT((char*)"G_REGEX_ERROR_HEX_CODE_TOO_LARGE",G_REGEX_ERROR_HEX_CODE_TOO_LARGE),
   MAKE_ICONSTANT((char*)"GDK_ISO_Set_Margin_Right",0xfe28),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_GURMUKHI",PANGO_SCRIPT_GURMUKHI),
   MAKE_ICONSTANT((char*)"GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED",GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED),
   MAKE_ICONSTANT((char*)"GDK_Arabic_yeh",0x5ea),
   MAKE_ICONSTANT((char*)"GDK_KEY_botleftsummation",0x8b2),
   MAKE_ICONSTANT((char*)"GDK_AE",0x0c6),
   MAKE_ICONSTANT((char*)"GDK_Eisu_toggle",0xff30),
   MAKE_ICONSTANT((char*)"GDK_TOUCHPAD_GESTURE_MASK",GDK_TOUCHPAD_GESTURE_MASK),
   MAKE_ICONSTANT((char*)"GDK_LaunchC",0x1008ff4c),
   MAKE_ICONSTANT((char*)"GDK_KEY_iacute",0x0ed),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Move_Line_Down",0xfe22),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_soso",0xdab),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_SIGNWRITING",G_UNICODE_SCRIPT_SIGNWRITING),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_FAILED",G_IO_ERROR_FAILED),
   MAKE_ICONSTANT((char*)"GDK_KEY_KP_0",0xffb0),
   MAKE_ICONSTANT((char*)"GDK_Pointer_Drag_Dflt",0xfef4),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_9",0x1000669),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_134678",0x10028ed),
   MAKE_ICONSTANT((char*)"GDK_KEY_SingleCandidate",0xff3c),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_MONGOLIAN",G_UNICODE_SCRIPT_MONGOLIAN),
   MAKE_ICONSTANT((char*)"GDK_Aogonek",0x1a1),
   MAKE_ICONSTANT((char*)"GDK_ISO_First_Group_Lock",0xfe0d),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_1348",0x100288d),
   MAKE_ICONSTANT((char*)"GDK_WINDOW_STATE_TOP_RESIZABLE",GDK_WINDOW_STATE_TOP_RESIZABLE),
   MAKE_ICONSTANT((char*)"GDK_DECOR_TITLE",GDK_DECOR_TITLE),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_UGARITIC",PANGO_SCRIPT_UGARITIC),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_dochada",0xdae),
   MAKE_ICONSTANT((char*)"GDK_KEY_lowleftcorner",0x9ed),
   MAKE_ICONSTANT((char*)"GDK_asciicircum",0x05e),
   MAKE_ICONSTANT((char*)"GDK_Thai_sosua",0xdca),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_Mieum",0xee3),
   MAKE_ICONSTANT((char*)"GDK_rightmiddlesummation",0x8b7),
   MAKE_ICONSTANT((char*)"GDK_CURSOR_IS_PIXMAP",GDK_CURSOR_IS_PIXMAP),
   MAKE_ICONSTANT((char*)"GDK_KEY_Armenian_za",0x1000566),
   MAKE_ICONSTANT((char*)"GDK_Overlay1_Enable",0xfe78),
   MAKE_ICONSTANT((char*)"GTK_RESPONSE_NO",GTK_RESPONSE_NO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_SsangKiyeog",0xed5),
   MAKE_ICONSTANT((char*)"GTK_CSS_SECTION_KEYFRAMES",GTK_CSS_SECTION_KEYFRAMES),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_CYRILLIC",G_UNICODE_SCRIPT_CYRILLIC),
   MAKE_ICONSTANT((char*)"GTK_DELETE_WHITESPACE",GTK_DELETE_WHITESPACE),
   MAKE_ICONSTANT((char*)"GDK_Redo",0xff66),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Tieut",0xeec),
   MAKE_ICONSTANT((char*)"GDK_ohornacute",0x1001edb),
   MAKE_ICONSTANT((char*)"G_IO_FLAG_APPEND",G_IO_FLAG_APPEND),
   MAKE_ICONSTANT((char*)"GDK_Scircumflex",0x2de),
   MAKE_ICONSTANT((char*)"GDK_Macedonia_KJE",0x6bc),
   MAKE_ICONSTANT((char*)"GDK_Ohornbelowdot",0x1001ee2),
   MAKE_ICONSTANT((char*)"GDK_KEY_F22",0xffd3),
   MAKE_ICONSTANT((char*)"GDK_KEY_F1",0xffbe),
   MAKE_ICONSTANT((char*)"GDK_ISO_Move_Line_Up",0xfe21),
   MAKE_ICONSTANT((char*)"GTK_SCROLL_START",GTK_SCROLL_START),
   MAKE_ICONSTANT((char*)"G_UNICODE_CURRENCY_SYMBOL",G_UNICODE_CURRENCY_SYMBOL),
   MAKE_ICONSTANT((char*)"GDK_KEY_Romaji",0xff24),
   MAKE_ICONSTANT((char*)"GDK_3270_PA3",0xfd0c),
   MAKE_ICONSTANT((char*)"GTK_PHASE_CAPTURE",GTK_PHASE_CAPTURE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Farsi_2",0x10006f2),
   MAKE_ICONSTANT((char*)"G_FILE_TYPE_SYMBOLIC_LINK",G_FILE_TYPE_SYMBOLIC_LINK),
   MAKE_ICONSTANT((char*)"GDK_KEY_ISO_Group_Latch",0xfe06),
   MAKE_ICONSTANT((char*)"GDK_KEY_approximate",0x8c8),
   MAKE_ICONSTANT((char*)"G_FILE_ERROR_ISDIR",G_FILE_ERROR_ISDIR),
   MAKE_ICONSTANT((char*)"GDK_ToDoList",0x1008ff1f),
   MAKE_ICONSTANT((char*)"GDK_DOTBOX",GDK_DOTBOX),
   MAKE_ICONSTANT((char*)"GDK_KEY_eng",0x3bf),
   MAKE_ICONSTANT((char*)"GDK_KEY_Save",0x1008ff77),
   MAKE_ICONSTANT((char*)"PANGO_ELLIPSIZE_START",PANGO_ELLIPSIZE_START),
   MAKE_ICONSTANT((char*)"GDK_HINT_USER_SIZE",GDK_HINT_USER_SIZE),
   MAKE_ICONSTANT((char*)"GDK_braille_dots_158",0x1002891),
   MAKE_ICONSTANT((char*)"G_UNICODE_SCRIPT_OLD_HUNGARIAN",G_UNICODE_SCRIPT_OLD_HUNGARIAN),
   MAKE_ICONSTANT((char*)"GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES",GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES),
   MAKE_ICONSTANT((char*)"GDK_KP_Equal",0xffbd),
   MAKE_ICONSTANT((char*)"GTK_DEBUG_UPDATES",GTK_DEBUG_UPDATES),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_458",0x1002898),
   MAKE_ICONSTANT((char*)"GDK_TREK",GDK_TREK),
   MAKE_ICONSTANT((char*)"GTK_STATE_PRELIGHT",GTK_STATE_PRELIGHT),
   MAKE_ICONSTANT((char*)"GDK_PIXBUF_ALPHA_BILEVEL",GDK_PIXBUF_ALPHA_BILEVEL),
   MAKE_ICONSTANT((char*)"GDK_GRAVITY_CENTER",GDK_GRAVITY_CENTER),
   MAKE_ICONSTANT((char*)"GDK_KEY_notapproxeq",0x1002247),
   MAKE_ICONSTANT((char*)"GDK_ISO_Left_Tab",0xfe20),
   MAKE_ICONSTANT((char*)"GDK_ISO_Release_Margin_Left",0xfe29),
   MAKE_ICONSTANT((char*)"GDK_kana_TSU",0x4c2),
   MAKE_ICONSTANT((char*)"GDK_KEY_dead_belowcircumflex",0xfe69),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_ZHE",0x6f6),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_123568",0x10028b7),
   MAKE_ICONSTANT((char*)"GDK_WA_VISUAL",GDK_WA_VISUAL),
   MAKE_ICONSTANT((char*)"GDK_Sleep",0x1008ff2f),
   MAKE_ICONSTANT((char*)"GDK_KEY_Cyrillic_u",0x6d5),
   MAKE_ICONSTANT((char*)"GTK_PAN_DIRECTION_LEFT",GTK_PAN_DIRECTION_LEFT),
   MAKE_ICONSTANT((char*)"GDK_PROXIMITY_OUT",GDK_PROXIMITY_OUT),
   MAKE_ICONSTANT((char*)"GDK_RELEASE_MASK",GDK_RELEASE_MASK),
   MAKE_ICONSTANT((char*)"PANGO_STRETCH_CONDENSED",PANGO_STRETCH_CONDENSED),
   MAKE_ICONSTANT((char*)"GDK_KEY_Stop",0x1008ff28),
   MAKE_ICONSTANT((char*)"GDK_KEY_Byelorussian_shortu",0x6ae),
   MAKE_ICONSTANT((char*)"G_BUS_NAME_WATCHER_FLAGS_NONE",G_BUS_NAME_WATCHER_FLAGS_NONE),
   MAKE_ICONSTANT((char*)"GDK_KEY_Thai_topatak",0xdaf),
   MAKE_ICONSTANT((char*)"G_MOUNT_OPERATION_UNHANDLED",G_MOUNT_OPERATION_UNHANDLED),
   MAKE_ICONSTANT((char*)"G_UNICODE_BREAK_HANGUL_V_JAMO",G_UNICODE_BREAK_HANGUL_V_JAMO),
   MAKE_ICONSTANT((char*)"GDK_KEY_Greek_omega",0x7f9),
   MAKE_ICONSTANT((char*)"GDK_KEY_Arabic_fathatan",0x5eb),
   MAKE_ICONSTANT((char*)"GDK_KEY_Hangul_J_PanSios",0xef8),
   MAKE_ICONSTANT((char*)"GDK_KEY_Pointer_DfltBtnNext",0xfefb),
   MAKE_ICONSTANT((char*)"PANGO_SCRIPT_REJANG",PANGO_SCRIPT_REJANG),
   MAKE_ICONSTANT((char*)"GDK_KEY_Mode_switch",0xff7e),
   MAKE_ICONSTANT((char*)"G_IO_ERROR_WOULD_MERGE",G_IO_ERROR_WOULD_MERGE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_J_Nieun",0xed7),
   MAKE_ICONSTANT((char*)"GDK_KEY_braille_dots_23578",0x10028d6),
   MAKE_ICONSTANT((char*)"GTK_ICON_VIEW_DROP_RIGHT",GTK_ICON_VIEW_DROP_RIGHT),
   MAKE_ICONSTANT((char*)"GDK_HINT_MAX_SIZE",GDK_HINT_MAX_SIZE),
   MAKE_ICONSTANT((char*)"GDK_Hangul_KkogjiDalrinIeung",0xef3),
   MAKE_ICONSTANT((char*)"GDK_KEY_numerosign",0x6b0),
   MAKE_ICONSTANT((char*)"G_NUMBER_PARSER_ERROR_INVALID",G_NUMBER_PARSER_ERROR_INVALID),
   MAKE_ICONSTANT((char*)"GDK_SEAT_CAPABILITY_KEYBOARD",GDK_SEAT_CAPABILITY_KEYBOARD),
   MAKE_ICONSTANT((char*)"GDK_Cyrillic_softsign",0x6d8),
   SLANG_END_ICONST_TABLE
};	/* }}} */

static SLang_LConstant_Type gtk3_LConsts [] =	/* {{{ */
{
   MAKE_LCONSTANT((char*)"GDK_TARGET_COLORMAP",_GDK_MAKE_ATOM(7)),
   MAKE_LCONSTANT((char*)"G_TIME_SPAN_SECOND",G_GINT64_CONSTANT(1000000)),
   MAKE_LCONSTANT((char*)"G_TYPE_CHAR",G_TYPE_MAKE_FUNDAMENTAL(3)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_ATOM",_GDK_MAKE_ATOM(4)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_DRAWABLE",_GDK_MAKE_ATOM(17)),
   MAKE_LCONSTANT((char*)"G_TYPE_NONE",G_TYPE_MAKE_FUNDAMENTAL(1)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_STRING",_GDK_MAKE_ATOM(31)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_PRIMARY",_GDK_MAKE_ATOM(1)),
   MAKE_LCONSTANT((char*)"G_TYPE_UINT64",G_TYPE_MAKE_FUNDAMENTAL(11)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_SECONDARY",_GDK_MAKE_ATOM(2)),
   MAKE_LCONSTANT((char*)"G_TYPE_LONG",G_TYPE_MAKE_FUNDAMENTAL(8)),
   MAKE_LCONSTANT((char*)"GDK_TARGET_DRAWABLE",_GDK_MAKE_ATOM(17)),
   MAKE_LCONSTANT((char*)"G_TYPE_INT",G_TYPE_MAKE_FUNDAMENTAL(6)),
   MAKE_LCONSTANT((char*)"G_TYPE_STRING",G_TYPE_MAKE_FUNDAMENTAL(16)),
   MAKE_LCONSTANT((char*)"G_TYPE_OBJECT",G_TYPE_MAKE_FUNDAMENTAL(20)),
   MAKE_LCONSTANT((char*)"G_TYPE_UCHAR",G_TYPE_MAKE_FUNDAMENTAL(4)),
   MAKE_LCONSTANT((char*)"G_TYPE_FLOAT",G_TYPE_MAKE_FUNDAMENTAL(14)),
   MAKE_LCONSTANT((char*)"G_TIME_SPAN_HOUR",G_GINT64_CONSTANT(3600000000)),
   MAKE_LCONSTANT((char*)"G_TYPE_BOXED",G_TYPE_MAKE_FUNDAMENTAL(18)),
   MAKE_LCONSTANT((char*)"G_TIME_SPAN_MILLISECOND",G_GINT64_CONSTANT(1000)),
   MAKE_LCONSTANT((char*)"GDK_PARENT_RELATIVE",1L),
   MAKE_LCONSTANT((char*)"G_TYPE_UINT",G_TYPE_MAKE_FUNDAMENTAL(7)),
   MAKE_LCONSTANT((char*)"G_TYPE_BOOLEAN",G_TYPE_MAKE_FUNDAMENTAL(5)),
   MAKE_LCONSTANT((char*)"G_TYPE_INT64",G_TYPE_MAKE_FUNDAMENTAL(10)),
   MAKE_LCONSTANT((char*)"G_TYPE_POINTER",G_TYPE_MAKE_FUNDAMENTAL(17)),
   MAKE_LCONSTANT((char*)"G_TYPE_INTERFACE",G_TYPE_MAKE_FUNDAMENTAL(2)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_PIXMAP",_GDK_MAKE_ATOM(20)),
   MAKE_LCONSTANT((char*)"GDK_CURRENT_TIME",0L),
   MAKE_LCONSTANT((char*)"G_TYPE_INVALID",G_TYPE_MAKE_FUNDAMENTAL(0)),
   MAKE_LCONSTANT((char*)"GDK_TARGET_STRING",_GDK_MAKE_ATOM(31)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_INTEGER",_GDK_MAKE_ATOM(19)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_COLORMAP",_GDK_MAKE_ATOM(7)),
   MAKE_LCONSTANT((char*)"G_TYPE_FLAGS",G_TYPE_MAKE_FUNDAMENTAL(13)),
   MAKE_LCONSTANT((char*)"G_TIME_SPAN_DAY",G_GINT64_CONSTANT(86400000000)),
   MAKE_LCONSTANT((char*)"GDK_TARGET_BITMAP",_GDK_MAKE_ATOM(5)),
   MAKE_LCONSTANT((char*)"G_TYPE_ULONG",G_TYPE_MAKE_FUNDAMENTAL(9)),
   MAKE_LCONSTANT((char*)"GDK_NONE",_GDK_MAKE_ATOM(0)),
   MAKE_LCONSTANT((char*)"G_TYPE_ENUM",G_TYPE_MAKE_FUNDAMENTAL(12)),
   MAKE_LCONSTANT((char*)"G_TYPE_VARIANT",G_TYPE_MAKE_FUNDAMENTAL(21)),
   MAKE_LCONSTANT((char*)"G_TIME_SPAN_MINUTE",G_GINT64_CONSTANT(60000000)),
   MAKE_LCONSTANT((char*)"G_TYPE_PARAM",G_TYPE_MAKE_FUNDAMENTAL(19)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_WINDOW",_GDK_MAKE_ATOM(33)),
   MAKE_LCONSTANT((char*)"G_TYPE_DOUBLE",G_TYPE_MAKE_FUNDAMENTAL(15)),
   MAKE_LCONSTANT((char*)"GDK_TARGET_PIXMAP",_GDK_MAKE_ATOM(20)),
   MAKE_LCONSTANT((char*)"GDK_SELECTION_TYPE_BITMAP",_GDK_MAKE_ATOM(5)),
   SLANG_END_LCONST_TABLE
};	/* }}} */

static SLang_DConstant_Type gtk3_DConsts [] =	/* {{{ */
{
   MAKE_DCONSTANT((char*)"PANGO_SCALE_X_LARGE",(double)1.44),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_XX_SMALL",(double)0.5787037037037),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_SMALL",(double)0.8333333333333),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_XX_LARGE",(double)1.728),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_LARGE",(double)1.2),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_MEDIUM",(double)1.0),
   MAKE_DCONSTANT((char*)"PANGO_SCALE_X_SMALL",(double)0.6944444444444),
   SLANG_END_DCONST_TABLE
};	/* }}} */

static const char *gtk3_strings[] = {	/* {{{ */
   "gio-network-monitor",
   "class",
   "standard::target-uri",
   "owner::group",
   "scale",
   "unix::device",
   "action-namespace",
   "printer-lpi",
   "mountable::is-media-check-automatic",
   "standard::icon",
   "mountable::can-poll",
   "paper-height",
   "spinbutton",
   "dim-label",
   "spinner",
   "grip",
   "popover",
   "standard::content-type",
   "URL",
   "standard::name",
   "standard::is-backup",
   "thumbnail::failed",
   "osd",
   "subtitle",
   "border-style",
   "filesystem::used",
   "standard::allocated-size",
   "iso_b5",
   "arrow",
   "mountable::can-eject",
   "standard::display-name",
   "standard::is-volatile",
   "label",
   "unix-device",
   "output-basename",
   "raised",
   "/etc/resolv.conf",
   "access::can-trash",
   "StartupWMClass",
   "needs-attention",
   "top",
   "radio",
   "resolution",
   "time::created-usec",
   "scale-has-marks-above",
   "OnlyShowIn",
   "mountable::unix-device-file",
   "inline-toolbar",
   "error",
   "flat",
   "iso_a4",
   "target",
   "info",
   "dos::is-mountpoint",
   "owner::user-real",
   "unix::nlink",
   "access::can-read",
   "n-copies",
   "cursor-handle",
   "list-row",
   "page-ranges",
   "mountable::can-unmount",
   "filesystem::readonly",
   "notebook",
   "horizontal",
   "resolution-x",
   "dos::reparse-point-tag",
   "background-image",
   "uuid",
   "unix::inode",
   "low",
   "list",
   "Categories",
   "standard::is-symlink",
   "mountable::can-start",
   "collate",
   "pane-separator",
   "time::modified-usec",
   "time::created",
   "calendar",
   "pulse",
   "nfs-mount",
   "standard::symlink-target",
   "filesystem::free",
   "progressbar",
   "warning",
   "mountable::start-stop-type",
   "standard::is-hidden",
   "primary-toolbar",
   "full",
   "duplex",
   "Version",
   "popup",
   "!$&'()*+,;=" ":",
   "Directory",
   "output-dir",
   "csd",
   "filesystem::remote",
   "mountable::can-stop",
   "read-only",
   "label",
   "output-file-format",
   "submenu",
   "StartupNotify",
   "menubar",
   "standard::edit-name",
   "view",
   "menuitem",
   "standard::symbolic-icon",
   "undershoot",
   "trash::deletion-date",
   "border-width",
   "Comment",
   "_-|> <.",
   "context-menu",
   "level-bar",
   "question",
   "win32-driver-extra",
   "finishings",
   "mountable::hal-udi",
   "sidebar",
   "unix::is-mountpoint",
   "time::changed-usec",
   "scrollbar",
   "gio-volume-monitor",
   "message-dialog",
   "header",
   "high",
   "left",
   "column-header",
   "paper",
   "titlebar",
   "mountable::can-mount",
   "orientation",
   "border-radius",
   "overshoot",
   "mountable::unix-device",
   "unix::block-size",
   "selinux::context",
   "default-source",
   "unix::blocks",
   "NotShowIn",
   "gio-vfs",
   "reverse",
   "Name",
   "monospace",
   "number-up-layout",
   "access::can-rename",
   "dock",
   "standard::is-virtual",
   "image",
   "resolution-y",
   "thumbnail::is-valid",
   "standard::fast-content-type",
   "standard::size",
   "DBusActivatable",
   "suggested-action",
   "destructive-action",
   "background-color",
   "column",
   "expander",
   "iso_a3",
   "access::can-delete",
   "time::access-usec",
   "slider",
   "Path",
   "button",
   ":/?#[]@",
   "color",
   "time::changed",
   "PangoRenderFT2",
   "recent::modified",
   "Hidden",
   "preview::icon",
   "cell",
   "standard::type",
   "padding",
   "vertical",
   "rubberband",
   "section",
   "right",
   "Actions",
   "number-up",
   "action",
   "mark",
   "entry",
   "use-color",
   "time::access",
   "na_legal",
   "gsettings-backend",
   "border-color",
   "win32-driver-version",
   "scrollbars-junction",
   "trash::orig-path",
   "unix::gid",
   "toolbar",
   "filesystem::size",
   "Link",
   "menu",
   "Terminal",
   "scale-has-marks-below",
   "unix::mode",
   "standard::description",
   "trough",
   "id::file",
   "bottom",
   "gvfs::backend",
   "frame",
   "icon",
   "row",
   "MimeType",
   "unix::rdev",
   "output-bin",
   "owner::user",
   "standard::sort-order",
   "mountable::can-start-degraded",
   "print-pages",
   "GenericName",
   "na_letter",
   "Desktop Entry",
   "na_executive",
   "margin",
   "dos::is-system",
   "highlight",
   "time::modified",
   "!$&'()*+,;=" ":@",
   "statusbar",
   "page-set",
   "tooltip",
   "unix::uid",
   "font",
   "access::can-write",
   "filesystem::use-preview",
   "filesystem::type",
   "scale",
   "dos::is-archive",
   "id::filesystem",
   "Type",
   "unix-device",
   "media-type",
   "thumbnail::path",
   "combobox-entry",
   "dither",
   "NoDisplay",
   "trash::item-count",
   "title",
   "!$&'()*+,;=",
   "standard::copy-name",
   "Application",
   "access::can-execute",
   "output-uri",
   "TryExec",
   "linked",
   "accelerator",
   "tab",
   "iso_a5",
   "paper-width",
   "separator",
   "printer",
   "etag::value",
   "wide",
   "check",
   "!$&'()*+,;=" ":@" "/",
   "dnd",
   "touch-selection",
   "default",
   "background",
   "Exec",
   "quality",
   "paper-format",
   "Icon",
   "insertion-cursor",
   "label",
NULL
};	/* }}} */


static SLang_Intrin_Var_Type gtk3_IVars [] = /* {{{ */
{
   MAKE_VARIABLE((char*)"G_NETWORK_MONITOR_EXTENSION_POINT_NAME",&gtk3_strings[0], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_IDENTIFIER_KIND_CLASS",&gtk3_strings[1], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_TARGET_URI",&gtk3_strings[2], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_OWNER_GROUP",&gtk3_strings[3], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SCALE",&gtk3_strings[4], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_DEVICE",&gtk3_strings[5], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_ATTRIBUTE_ACTION_NAMESPACE",&gtk3_strings[6], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PRINTER_LPI",&gtk3_strings[7], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_IS_MEDIA_CHECK_AUTOMATIC",&gtk3_strings[8], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_ICON",&gtk3_strings[9], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_POLL",&gtk3_strings[10], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PAPER_HEIGHT",&gtk3_strings[11], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SPINBUTTON",&gtk3_strings[12], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_DIM_LABEL",&gtk3_strings[13], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SPINNER",&gtk3_strings[14], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_GRIP",&gtk3_strings[15], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_POPOVER",&gtk3_strings[16], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE",&gtk3_strings[17], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_URL",&gtk3_strings[18], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_NAME",&gtk3_strings[19], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP",&gtk3_strings[20], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_THUMBNAILING_FAILED",&gtk3_strings[21], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_OSD",&gtk3_strings[22], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SUBTITLE",&gtk3_strings[23], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BORDER_STYLE",&gtk3_strings[24], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_USED",&gtk3_strings[25], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE",&gtk3_strings[26], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_B5",&gtk3_strings[27], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_ARROW",&gtk3_strings[28], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_EJECT",&gtk3_strings[29], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME",&gtk3_strings[30], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_IS_VOLATILE",&gtk3_strings[31], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LABEL",&gtk3_strings[32], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE",&gtk3_strings[33], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_OUTPUT_BASENAME",&gtk3_strings[34], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_RAISED",&gtk3_strings[35], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"_PATH_RESCONF",&gtk3_strings[36], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_TRASH",&gtk3_strings[37], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_STARTUP_WM_CLASS",&gtk3_strings[38], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_NEEDS_ATTENTION",&gtk3_strings[39], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TOP",&gtk3_strings[40], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_RADIO",&gtk3_strings[41], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_RESOLUTION",&gtk3_strings[42], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_CREATED_USEC",&gtk3_strings[43], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SCALE_HAS_MARKS_ABOVE",&gtk3_strings[44], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN",&gtk3_strings[45], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_UNIX_DEVICE_FILE",&gtk3_strings[46], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_INLINE_TOOLBAR",&gtk3_strings[47], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_ERROR",&gtk3_strings[48], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_FLAT",&gtk3_strings[49], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_A4",&gtk3_strings[50], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_ATTRIBUTE_TARGET",&gtk3_strings[51], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_INFO",&gtk3_strings[52], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_DOS_IS_MOUNTPOINT",&gtk3_strings[53], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_OWNER_USER_REAL",&gtk3_strings[54], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_NLINK",&gtk3_strings[55], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_READ",&gtk3_strings[56], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_N_COPIES",&gtk3_strings[57], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CURSOR_HANDLE",&gtk3_strings[58], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LIST_ROW",&gtk3_strings[59], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PAGE_RANGES",&gtk3_strings[60], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_UNMOUNT",&gtk3_strings[61], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_READONLY",&gtk3_strings[62], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_NOTEBOOK",&gtk3_strings[63], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_HORIZONTAL",&gtk3_strings[64], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_RESOLUTION_X",&gtk3_strings[65], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_DOS_REPARSE_POINT_TAG",&gtk3_strings[66], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BACKGROUND_IMAGE",&gtk3_strings[67], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_IDENTIFIER_KIND_UUID",&gtk3_strings[68], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_INODE",&gtk3_strings[69], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_LEVEL_BAR_OFFSET_LOW",&gtk3_strings[70], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LIST",&gtk3_strings[71], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_CATEGORIES",&gtk3_strings[72], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK",&gtk3_strings[73], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_START",&gtk3_strings[74], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_COLLATE",&gtk3_strings[75], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_PANE_SEPARATOR",&gtk3_strings[76], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC",&gtk3_strings[77], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_CREATED",&gtk3_strings[78], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CALENDAR",&gtk3_strings[79], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_PULSE",&gtk3_strings[80], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_IDENTIFIER_KIND_NFS_MOUNT",&gtk3_strings[81], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET",&gtk3_strings[82], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_FREE",&gtk3_strings[83], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_PROGRESSBAR",&gtk3_strings[84], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_WARNING",&gtk3_strings[85], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_START_STOP_TYPE",&gtk3_strings[86], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN",&gtk3_strings[87], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_PRIMARY_TOOLBAR",&gtk3_strings[88], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_LEVEL_BAR_OFFSET_FULL",&gtk3_strings[89], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_DUPLEX",&gtk3_strings[90], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_VERSION",&gtk3_strings[91], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_POPUP",&gtk3_strings[92], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_URI_RESERVED_CHARS_ALLOWED_IN_USERINFO",&gtk3_strings[93], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_TYPE_DIRECTORY",&gtk3_strings[94], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_OUTPUT_DIR",&gtk3_strings[95], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CSD",&gtk3_strings[96], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_REMOTE",&gtk3_strings[97], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_STOP",&gtk3_strings[98], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_READ_ONLY",&gtk3_strings[99], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_ATTRIBUTE_LABEL",&gtk3_strings[100], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT",&gtk3_strings[101], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_LINK_SUBMENU",&gtk3_strings[102], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_STARTUP_NOTIFY",&gtk3_strings[103], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MENUBAR",&gtk3_strings[104], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_EDIT_NAME",&gtk3_strings[105], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_VIEW",&gtk3_strings[106], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MENUITEM",&gtk3_strings[107], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_SYMBOLIC_ICON",&gtk3_strings[108], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_UNDERSHOOT",&gtk3_strings[109], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TRASH_DELETION_DATE",&gtk3_strings[110], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BORDER_WIDTH",&gtk3_strings[111], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_COMMENT",&gtk3_strings[112], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_STR_DELIMITERS",&gtk3_strings[113], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CONTEXT_MENU",&gtk3_strings[114], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LEVEL_BAR",&gtk3_strings[115], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_QUESTION",&gtk3_strings[116], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_WIN32_DRIVER_EXTRA",&gtk3_strings[117], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_FINISHINGS",&gtk3_strings[118], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_HAL_UDI",&gtk3_strings[119], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SIDEBAR",&gtk3_strings[120], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_IS_MOUNTPOINT",&gtk3_strings[121], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_CHANGED_USEC",&gtk3_strings[122], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SCROLLBAR",&gtk3_strings[123], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_MONITOR_EXTENSION_POINT_NAME",&gtk3_strings[124], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MESSAGE_DIALOG",&gtk3_strings[125], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_HEADER",&gtk3_strings[126], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_LEVEL_BAR_OFFSET_HIGH",&gtk3_strings[127], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LEFT",&gtk3_strings[128], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_REGION_COLUMN_HEADER",&gtk3_strings[129], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_PAPER",&gtk3_strings[130], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TITLEBAR",&gtk3_strings[131], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_MOUNT",&gtk3_strings[132], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_ORIENTATION",&gtk3_strings[133], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BORDER_RADIUS",&gtk3_strings[134], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_OVERSHOOT",&gtk3_strings[135], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_UNIX_DEVICE",&gtk3_strings[136], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_BLOCK_SIZE",&gtk3_strings[137], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_SELINUX_CONTEXT",&gtk3_strings[138], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_DEFAULT_SOURCE",&gtk3_strings[139], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_BLOCKS",&gtk3_strings[140], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN",&gtk3_strings[141], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VFS_EXTENSION_POINT_NAME",&gtk3_strings[142], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_REVERSE",&gtk3_strings[143], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_NAME",&gtk3_strings[144], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MONOSPACE",&gtk3_strings[145], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_NUMBER_UP_LAYOUT",&gtk3_strings[146], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_RENAME",&gtk3_strings[147], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_DOCK",&gtk3_strings[148], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_IS_VIRTUAL",&gtk3_strings[149], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_IMAGE",&gtk3_strings[150], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_RESOLUTION_Y",&gtk3_strings[151], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_THUMBNAIL_IS_VALID",&gtk3_strings[152], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_FAST_CONTENT_TYPE",&gtk3_strings[153], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_SIZE",&gtk3_strings[154], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_DBUS_ACTIVATABLE",&gtk3_strings[155], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SUGGESTED_ACTION",&gtk3_strings[156], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_DESTRUCTIVE_ACTION",&gtk3_strings[157], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BACKGROUND_COLOR",&gtk3_strings[158], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_REGION_COLUMN",&gtk3_strings[159], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_EXPANDER",&gtk3_strings[160], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_A3",&gtk3_strings[161], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_DELETE",&gtk3_strings[162], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_ACCESS_USEC",&gtk3_strings[163], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SLIDER",&gtk3_strings[164], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_PATH",&gtk3_strings[165], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_BUTTON",&gtk3_strings[166], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_URI_RESERVED_CHARS_GENERIC_DELIMITERS",&gtk3_strings[167], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_COLOR",&gtk3_strings[168], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_CHANGED",&gtk3_strings[169], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"PANGO_RENDER_TYPE_FT2",&gtk3_strings[170], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_RECENT_MODIFIED",&gtk3_strings[171], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_HIDDEN",&gtk3_strings[172], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_PREVIEW_ICON",&gtk3_strings[173], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CELL",&gtk3_strings[174], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_TYPE",&gtk3_strings[175], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_PADDING",&gtk3_strings[176], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_VERTICAL",&gtk3_strings[177], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_RUBBERBAND",&gtk3_strings[178], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_LINK_SECTION",&gtk3_strings[179], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_RIGHT",&gtk3_strings[180], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_ACTIONS",&gtk3_strings[181], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_NUMBER_UP",&gtk3_strings[182], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_ATTRIBUTE_ACTION",&gtk3_strings[183], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MARK",&gtk3_strings[184], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_ENTRY",&gtk3_strings[185], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_USE_COLOR",&gtk3_strings[186], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_ACCESS",&gtk3_strings[187], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_LEGAL",&gtk3_strings[188], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_SETTINGS_BACKEND_EXTENSION_POINT_NAME",&gtk3_strings[189], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_BORDER_COLOR",&gtk3_strings[190], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_WIN32_DRIVER_VERSION",&gtk3_strings[191], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SCROLLBARS_JUNCTION",&gtk3_strings[192], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TRASH_ORIG_PATH",&gtk3_strings[193], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_GID",&gtk3_strings[194], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TOOLBAR",&gtk3_strings[195], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_SIZE",&gtk3_strings[196], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_TYPE_LINK",&gtk3_strings[197], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_MENU",&gtk3_strings[198], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_TERMINAL",&gtk3_strings[199], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SCALE_HAS_MARKS_BELOW",&gtk3_strings[200], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_MODE",&gtk3_strings[201], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_DESCRIPTION",&gtk3_strings[202], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TROUGH",&gtk3_strings[203], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ID_FILE",&gtk3_strings[204], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_BOTTOM",&gtk3_strings[205], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_GVFS_BACKEND",&gtk3_strings[206], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_FRAME",&gtk3_strings[207], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_MENU_ATTRIBUTE_ICON",&gtk3_strings[208], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_REGION_ROW",&gtk3_strings[209], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_MIME_TYPE",&gtk3_strings[210], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_RDEV",&gtk3_strings[211], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_OUTPUT_BIN",&gtk3_strings[212], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_OWNER_USER",&gtk3_strings[213], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_SORT_ORDER",&gtk3_strings[214], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_MOUNTABLE_CAN_START_DEGRADED",&gtk3_strings[215], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PRINT_PAGES",&gtk3_strings[216], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_GENERIC_NAME",&gtk3_strings[217], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_LETTER",&gtk3_strings[218], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_GROUP",&gtk3_strings[219], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_EXECUTIVE",&gtk3_strings[220], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_MARGIN",&gtk3_strings[221], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_DOS_IS_SYSTEM",&gtk3_strings[222], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_HIGHLIGHT",&gtk3_strings[223], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TIME_MODIFIED",&gtk3_strings[224], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_URI_RESERVED_CHARS_ALLOWED_IN_PATH_ELEMENT",&gtk3_strings[225], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_STATUSBAR",&gtk3_strings[226], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PAGE_SET",&gtk3_strings[227], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TOOLTIP",&gtk3_strings[228], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_UNIX_UID",&gtk3_strings[229], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_PROPERTY_FONT",&gtk3_strings[230], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE",&gtk3_strings[231], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_USE_PREVIEW",&gtk3_strings[232], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_FILESYSTEM_TYPE",&gtk3_strings[233], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_SCALE",&gtk3_strings[234], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_DOS_IS_ARCHIVE",&gtk3_strings[235], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ID_FILESYSTEM",&gtk3_strings[236], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_TYPE",&gtk3_strings[237], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_DRIVE_IDENTIFIER_KIND_UNIX_DEVICE",&gtk3_strings[238], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_MEDIA_TYPE",&gtk3_strings[239], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_THUMBNAIL_PATH",&gtk3_strings[240], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_COMBOBOX_ENTRY",&gtk3_strings[241], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_DITHER",&gtk3_strings[242], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_NO_DISPLAY",&gtk3_strings[243], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_TRASH_ITEM_COUNT",&gtk3_strings[244], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TITLE",&gtk3_strings[245], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_URI_RESERVED_CHARS_SUBCOMPONENT_DELIMITERS",&gtk3_strings[246], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_STANDARD_COPY_NAME",&gtk3_strings[247], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_TYPE_APPLICATION",&gtk3_strings[248], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE",&gtk3_strings[249], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_OUTPUT_URI",&gtk3_strings[250], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_TRY_EXEC",&gtk3_strings[251], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_LINKED",&gtk3_strings[252], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_ACCELERATOR",&gtk3_strings[253], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_REGION_TAB",&gtk3_strings[254], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PAPER_NAME_A5",&gtk3_strings[255], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PAPER_WIDTH",&gtk3_strings[256], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_SEPARATOR",&gtk3_strings[257], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PRINTER",&gtk3_strings[258], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_FILE_ATTRIBUTE_ETAG_VALUE",&gtk3_strings[259], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_WIDE",&gtk3_strings[260], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_CHECK",&gtk3_strings[261], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_URI_RESERVED_CHARS_ALLOWED_IN_PATH",&gtk3_strings[262], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_DND",&gtk3_strings[263], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_TOUCH_SELECTION",&gtk3_strings[264], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_DEFAULT",&gtk3_strings[265], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_BACKGROUND",&gtk3_strings[266], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_EXEC",&gtk3_strings[267], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_QUALITY",&gtk3_strings[268], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_PRINT_SETTINGS_PAPER_FORMAT",&gtk3_strings[269], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_KEY_FILE_DESKTOP_KEY_ICON",&gtk3_strings[270], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"GTK_STYLE_CLASS_INSERTION_CURSOR",&gtk3_strings[271], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"G_VOLUME_IDENTIFIER_KIND_LABEL",&gtk3_strings[272], SLANG_STRING_TYPE,1),
   MAKE_VARIABLE((char*)"glib_micro_version",&glib_micro_version, SLANG_UINT_TYPE, 1),
   MAKE_VARIABLE((char*)"glib_minor_version",&glib_minor_version, SLANG_UINT_TYPE, 1),
   MAKE_VARIABLE((char*)"glib_major_version",&glib_major_version, SLANG_UINT_TYPE, 1),
   MAKE_VARIABLE((char*)"glib_binary_age",&glib_binary_age, SLANG_UINT_TYPE, 1),
   MAKE_VARIABLE((char*)"glib_interface_age",&glib_interface_age, SLANG_UINT_TYPE, 1),
   SLANG_END_INTRIN_VAR_TABLE
};	/* }}} */

